--> pralable
-- USE BD_Air_France;

-- immatriculation F-.... (lettres), N-..... (chiffres ou lettres)

ALTER TABLE T_vols_historique_vlh
      ADD  CONSTRAINT CK_immat_avi
           CHECK (vlh_immat_avion LIKE '[F]-[A-Z][A-Z][A-Z][A-Z]'
               OR vlh_immat_avion LIKE '[N][0-9][0-9][0-9][0-9][0-9]'
               OR vlh_immat_avion LIKE '[N][0-9][0-9][0-9][A-Z][A-Z]');


-- aroport de dpart diffrent de celui d'arrive

ALTER TABLE T_vols_historique_vlh
      ADD  CONSTRAINT CK_aer_dep_arr
           CHECK (NOT (aer_dep = aer_arr));


-- pas de vols du jour ou  une date ultrieure (seulement  partir de la veille)

ALTER TABLE T_vols_historique_vlh
      ADD  CONSTRAINT CK_vol_avant_jour
           CHECK (vlh_date_vol < CURRENT_TIMESTAMP+1);

-- vol dure plus de 30'

ALTER TABLE T_vols_historique_vlh
      ADD  CONSTRAINT CK_heure_vol_30_min
           CHECK (DATEADD(MI, 30, vlh_h_dep) <= vlh_h_arr);

-- tests

INSERT INTO T_vols_historique_vlh
 (vlh_num_vol,vlh_date_vol,vlh_h_dep,vlh_h_arr,vlh_immat_avion,aer_dep,aer_arr)
VALUES 
 ('US690','2012-04-10','11:30:00','14:00:00','N089EP','TLS','NYK');

INSERT INTO T_vols_historique_vlh
 (vlh_num_vol,vlh_date_vol,vlh_h_dep,vlh_h_arr,vlh_immat_avion,aer_dep,aer_arr)
VALUES 
 ('AF6140','2011-12-20','12:35:00','13:55:00','F-GHAZ','TLS','TLS');

INSERT INTO T_vols_historique_vlh
 (vlh_num_vol,vlh_date_vol,vlh_h_dep,vlh_h_arr,vlh_immat_avion,aer_dep,aer_arr)
VALUES 
 ('AF6140','2013-12-20','12:35:00','13:55:00','F-GHAZ','ORY','TLS');

INSERT INTO T_vols_historique_vlh
 (vlh_num_vol,vlh_date_vol,vlh_h_dep,vlh_h_arr,vlh_immat_avion,aer_dep,aer_arr)
VALUES 
 ('US690','2011-12-21','11:30:00','10:00:00','F-GHAZ','TLS','NYK');

INSERT INTO T_vols_historique_vlh
 (vlh_num_vol,vlh_date_vol,vlh_h_dep,vlh_h_arr,vlh_immat_avion,aer_dep,aer_arr)
VALUES 
 ('US690','2011-12-21','11:30:00','11:45:00','F-GHAZ','TLS','NYK');

INSERT INTO T_vols_historique_vlh
 (vlh_num_vol,vlh_date_vol,vlh_h_dep,vlh_h_arr,vlh_immat_avion,aer_dep,aer_arr)
VALUES 
 ('US690','2011-12-21','11:30:00','14:00:00','N089EP','TLS','NYK');

INSERT INTO T_vols_historique_vlh
 (vlh_num_vol,vlh_date_vol,vlh_h_dep,vlh_h_arr,vlh_immat_avion,aer_dep,aer_arr)
VALUES 
 ('AF6140','2012-03-20','12:35:00','13:55:00','F-GHAZ','ORY','TLS');
