--> pralable
-- USE BD_Air_France;

-- Restrictions 

CREATE TABLE T_pilote_pil
 (pil_brevet VARCHAR(6),pil_prenom VARCHAR(15),
  pil_nom VARCHAR(15), pil_hvol DECIMAL(7,2), pil_prime SMALLINT, cmp_compa VARCHAR(4),
  CONSTRAINT PK_pil PRIMARY KEY(pil_brevet));

INSERT INTO T_pilote_pil VALUES ('PL-1', 'Pierre','Filloux', 450,500, 'AF');
INSERT INTO T_pilote_pil VALUES ('PL-2', 'Christian','Sigaudes', 0,NULL, 'AF');
INSERT INTO T_pilote_pil VALUES ('PL-3', 'Pierre','Perez', 1000,90,'SING');
INSERT INTO T_pilote_pil VALUES ('PL-4', 'Romaric','Benech', 2450,500,'CAST');
INSERT INTO T_pilote_pil VALUES ('PL-5', 'Vincent','Gindre', 400,600,'SING');
INSERT INTO T_pilote_pil VALUES ('PL-6', 'Bruno','Duffau', NULL,0,'CAST');


SELECT pil_brevet, pil_nom AS "pil_prime 500"  
FROM   T_pilote_pil 
WHERE  pil_prime = 500;

SELECT pil_brevet, pil_nom "de Air-France" 
FROM   T_pilote_pil
WHERE  cmp_compa = 'AF';

SELECT pil_brevet, pil_nom, pil_prime  
FROM   T_pilote_pil
WHERE  pil_prime <= 400;

SELECT pil_brevet, pil_nom, pil_prime  
FROM   T_pilote_pil
WHERE  pil_prime <> 500;

SELECT pil_brevet, pil_nom, pil_prime  
FROM   T_pilote_pil
WHERE  NOT(pil_prime = 500);

SELECT pil_brevet, pil_nom, pil_prime  
FROM   T_pilote_pil
WHERE  pil_prime != 500;

-- oprateurs

SELECT pil_brevet, pil_nom, cmp_compa
FROM   T_pilote_pil
WHERE  (cmp_compa = 'SING' OR cmp_compa = 'AF' AND pil_hvol < 500);

SELECT pil_brevet, pil_nom, cmp_compa
FROM   T_pilote_pil
WHERE  ((cmp_compa = 'SING'  OR cmp_compa = 'AF') AND pil_hvol < 500);

-- oprateurs intgrs

SELECT pil_brevet, pil_nom, pil_hvol 
FROM   T_pilote_pil
WHERE  pil_hvol BETWEEN 400 AND 1000;


SELECT pil_brevet, pil_nom, cmp_compa 
FROM   T_pilote_pil
WHERE  cmp_compa IN ('CAST', 'SING');

SELECT pil_brevet, pil_nom, cmp_compa 
FROM   T_pilote_pil
WHERE  cmp_compa LIKE ('%A%');

SELECT pil_brevet, pil_nom, cmp_compa 
FROM   T_pilote_pil
WHERE  cmp_compa LIKE ('A_');

SELECT pil_brevet,pil_nom, pil_prime, pil_hvol 
FROM   T_pilote_pil
WHERE  pil_prime IS NULL
OR     pil_hvol  IS NULL;

SELECT pil_nom FROM T_pilote_pil WHERE pil_prime IS NOT NULL ;

SELECT pil_nom FROM T_pilote_pil WHERE NOT (pil_prime IS NULL) ;

-- Alias

SELECT cmp_compa AS c1, pil_prenom AS c2, pil_nom AS c3
FROM   T_pilote_pil
WHERE  c1 ='AF';

SELECT ap.cmp_compa, ap.pil_prenom, ap.pil_nom
FROM   T_pilote_pil ap
WHERE  ap.cmp_compa='AF'; 


SELECT ap.cmp_compa, ap.pil_prenom, ap.pil_nom
FROM   T_pilote_pil ap
WHERE  cmp_compa='AF'; 

DROP TABLE T_pilote_pil;
GO
