
-- 

USE BD_Air_France;

CREATE TABLE T_Pilote_pil
(pil_brevet VARCHAR(6),
 pil_nom    VARCHAR(20), pil_nbHVol DECIMAL(7,2), cmp_comp VARCHAR(4),
 CONSTRAINT pk_Pilote PRIMARY KEY(pil_brevet));
GO

INSERT INTO T_Pilote_pil VALUES ('PL-1', 'Giaconne', 2450, 'AF');
INSERT INTO T_Pilote_pil VALUES ('PL-2', 'Bardon', 900, 'AF');
INSERT INTO T_Pilote_pil VALUES ('PL-3', 'Mejers', 2500, 'SING');
INSERT INTO T_Pilote_pil VALUES ('PL-4', 'Lhospice', 5500, 'CAST');
INSERT INTO T_Pilote_pil VALUES ('PL-5', 'Calac', 5400, 'AF');
INSERT INTO T_Pilote_pil VALUES ('PL-6', 'Cogne', 2500, 'SING');
GO

-- 302, 7-18

CREATE PROCEDURE P_Experimente
  (@p1 VARCHAR(4), 
   @p2 VARCHAR(60)  OUTPUT, 
   @p3 DECIMAL(7,2) OUTPUT)
AS
BEGIN 
  DECLARE @v1 SMALLINT;
  IF (@p1 IS NULL)
      SELECT @v1=COUNT(*) FROM T_Pilote_pil
             WHERE pil_nbHVol = (SELECT MAX(pil_nbHVol) FROM T_Pilote_pil);
  ELSE
       SELECT @v1=COUNT(*) FROM T_Pilote_pil
              WHERE pil_nbHVol = (SELECT MAX(pil_nbHVol) 
                              FROM T_Pilote_pil WHERE cmp_comp = @p1)
              AND  cmp_comp = @p1;
IF (@V1 = 0)
   SET @p2 = 'Aucun pilote n''est le plus expriment';
ELSE
   IF @v1 > 1
      SET @p2 = 'Plusieurs pilotes sont plus expriments';
   ELSE
    BEGIN
      IF (@p1 IS NULL)
          SELECT  @p2=CONCAT(pil_nom,CONCAT('-',cmp_comp)),
                  @p3=pil_nbHVol
      FROM T_Pilote_pil WHERE pil_nbHVol = 
 (SELECT MAX(pil_nbHVol) FROM T_Pilote_pil);
	ELSE
          SELECT  @p2=pil_nom, @p3=pil_nbHVol
     FROM T_Pilote_pil WHERE pil_nbHVol = (SELECT MAX(pil_nbHVol) FROM T_Pilote_pil     WHERE cmp_comp = @p1)
           AND cmp_comp = @p1;
     END;
END;
GO

-- 303, 7-19

DECLARE @retour_nom    VARCHAR(60);
DECLARE @retour_heures DECIMAL(7,2);
EXEC P_Experimente 'AF', @retour_nom OUTPUT, 
                        @retour_heures OUTPUT;
PRINT @retour_nom ;
PRINT @retour_heures;

EXEC P_Experimente NULL, @retour_nom OUTPUT, 
                        @retour_heures OUTPUT;
PRINT @retour_nom ;
PRINT @retour_heures;

--

BEGIN
  DECLARE @retour_nom    VARCHAR(60);
  DECLARE @retour_heures DECIMAL(7,2);
  EXEC dbo.P_Experimente 'SING', @retour_nom OUTPUT, 
                        @retour_heures OUTPUT;
  PRINT @retour_nom;
END;

EXEC sp_recompile 'dbo.P_Experimente';
GO

DROP PROCEDURE P_Experimente;
GO

DROP TABLE T_Pilote_pil;
GO