
USE BD_Air_France;

IF OBJECT_ID ('dbo.T_Pilote_pil','U') IS NOT NULL
    DROP TABLE dbo.T_Pilote_pil;
GO

CREATE TABLE T_Pilote_pil
(pil_brevet VARCHAR(6), pil_nom    VARCHAR(20), 
 pil_salaire DECIMAL(7,2),pil_nbHVol DECIMAL(7,2), cmp_comp VARCHAR(4),
 CONSTRAINT pk_Pilote PRIMARY KEY(pil_brevet));
GO

INSERT INTO T_Pilote_pil VALUES ('PL-1', 'Giaconne', 5600,2450, 'AF');
INSERT INTO T_Pilote_pil VALUES ('PL-2', 'Bardon', 5000,900, 'AF');
INSERT INTO T_Pilote_pil VALUES ('PL-3', 'Mejers', 6090, 2500, 'SING');
INSERT INTO T_Pilote_pil VALUES ('PL-4', 'Lhospice', 7400,5500, 'CAST');
INSERT INTO T_Pilote_pil VALUES ('PL-5', 'Calac', 6700, 5400, 'AF');
INSERT INTO T_Pilote_pil VALUES ('PL-6', 'Cogne', 6080, 2500, 'SING');
GO

-- 351, 7-59

BEGIN 
 DECLARE @col1 VARCHAR(128) = 'pil_nom',
         @col2 VARCHAR(128) = 'pil_nbHvol',
         @col3 VARCHAR(128),
         @req  VARCHAR(MAX);
 SET @req = 'SELECT ';
 IF @col1 IS NOT NULL
    BEGIN
    SET @req = @req + @col1;
    IF @col2 IS NOT NULL
       BEGIN
       SET @req = @req + ','+ @col2;
       IF @col3 IS NOT NULL
          SET @req = @req + ','+ @col3;
       END;
   END;
 SET @req = @req + ' FROM T_Pilote_pil';
 EXECUTE(@req);
 PRINT(@req);
 EXECUTE('UPDATE T_Pilote_pil SET pil_salaire=pil_salaire*0.89');
END;
GO

-- 351, 7-60

BEGIN 
EXECUTE('
CREATE TABLE #T_aeroport_aer
 (aer_IATA   VARCHAR(3) PRIMARY KEY,
  aer_OACI   VARCHAR(6), aer_nom  VARCHAR(50))');
EXECUTE('INSERT INTO #T_aeroport_aer 
   VALUES (''BLO'',''LGFH'',''Ales'')');
END;
GO

-- 352, 7-61

BEGIN
DECLARE @instruction NVARCHAR(MAX),
        @parametres  NVARCHAR(200),
        @v1 DECIMAL(4,2) = 0.85,
        @v2 DECIMAL(7,2), 
        @v3 NVARCHAR(6) = 'PL-3';
SET @instruction = N'UPDATE T_Pilote_pil SET pil_salaire=pil_salaire*@p1,@p2=pil_salaire WHERE pil_brevet=@p3';
SET @parametres = N'@p1 DECIMAL(4,2),@p2 DECIMAL(7,2) OUTPUT,@p3 NVARCHAR(6)';
EXECUTE sp_executesql @instruction,@parametres, 
      @p1=@v1,@p2=@v2 OUTPUT,@p3= @v3; 
PRINT 'Avant diminution : '+CAST(@v2 AS VARCHAR(10));
END;
GO


DROP TABLE T_Pilote_pil;
GO