--> Pralable
/*
IF EXISTS(SELECT NULL FROM sys.databases WHERE name = 'DB_CRYPT')
BEGIN
   EXEC ('USE DB_CRYPT;
          ALTER DATABASE DB_CRYPT SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
          USE master;
          DROP DATABASE DB_CRYPT;');
END;

IF EXISTS(SELECT * FROM sys.server_principals WHERE name = 'CNX_FRED')
   EXEC ('DROP LOGIN CNX_FRED;');

*/
-- On cre une base de donnes
CREATE DATABASE DB_CRYPT
GO
-- On se place dans le contexte de cette nouvelle base
USE DB_CRYPT
GO
-- On cre une table des patients
CREATE TABLE dbo.T_PATIENT_PTT
(PTT_ID               INT IDENTITY PRIMARY KEY,
 PTT_NOM_CRYPTE       VARBINARY(256), 
 PTT_NUMSECU_CRYPTE   VARBINARY(128));
GO
-- On cre la cl symtrique
CREATE SYMMETRIC KEY KS_FRED WITH ALGORITHM = AES_256
   ENCRYPTION BY PASSWORD = 'Jacques Bonde 007 !';
GO
-- On ouvre la cl symtrique pour lutiliser
OPEN SYMMETRIC KEY KS_FRED 
   DECRYPTION BY PASSWORD = 'Jacques Bonde 007 !';
-- On insre une ligne avec des donnes cryptes dans la table
INSERT INTO dbo.T_PATIENT_PTT
VALUES (ENCRYPTBYKEY(KEY_GUID('KS_FRED'), 'Dupont'),
        ENCRYPTBYKEY(KEY_GUID('KS_FRED'), '1800675112337'));
-- On ferme la cl
CLOSE SYMMETRIC KEY KS_FRED;