USE master;
GO

CREATE DATABASE DB_SPORT
GO

USE DB_SPORT;
GO

CREATE TABLE dbo.T_SPORT_SPT
(
	SPT_ID int IDENTITY(1,1) NOT NULL PRIMARY KEY,
	SPT_LIBELLE varchar(32) NULL 
)
GO

CREATE TABLE dbo.T_ADHERENT_ADR
(
	ADR_ID int IDENTITY(1,1) NOT NULL PRIMARY KEY ,
	ADR_NOM char(32) NULL,
	ADR_PRENOM varchar(25) NULL,
	ADR_DATE_NAISSANCE datetime NULL,
	ADR_TEL_FIX char(20) NULL,
	ADR_TEL_MOBILE char(20) NULL,
	ADR_MAIL char(64) NULL,
	ADR_ADRESSE1 varchar(38) NULL,
	ADR_ADRESSE2 varchar(38) NULL,
	ADR_ADRESSE3 varchar(38) NULL,
	ADR_CP char(8) NULL,
	ADR_VILLE char(32) NULL,
	ADR_LOGIN char(32) NULL,
	ADR_PASS char(32) NULL,
	ADR_NUMSECU char(13) NULL,
	ADR_POINTS decimal(29, 9) NULL,
	ADR_DATE_ADHESION datetime NULL,
	ADR_CATEGORIE char(16) NULL,
	ADR_REDUCTION_PC float NULL,
	ADR_FONDATEUR bit NOT NULL DEFAULT 0
)
GO

--> modification si version > 2005
IF LEFT(@@VERSION, 25) > 'Microsoft SQL Server 2005'
   EXEC ('ALTER TABLE T_ADHERENT_ADR ALTER COLUMN ADR_DATE_NAISSANCE DATE; ALTER TABLE T_ADHERENT_ADR ALTER COLUMN ADR_DATE_ADHESION DATE;')
GO

CREATE TABLE dbo.T_PRATIQUE_PTQ
(
	ADR_ID int NOT NULL,
	SPT_ID int NOT NULL,
 CONSTRAINT PK_T_PRATIQUE_PTQ PRIMARY KEY (ADR_ID ASC, SPT_ID ASC)
)
GO

CHECKPOINT;
GO

CHECKPOINT;
GO

SET IDENTITY_INSERT dbo.T_SPORT_SPT ON;
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (1,'Aerobic sportive');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (2,'Arostation');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (3,'Aikido');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (4,'Alpinisme');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (5,'Apne');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (6,'Aqua gym');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (7,'Arts martiaux artistiques');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (8,'Athltisme');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (9,'Aviron');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (10,'Badminton');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (11,'Baseball');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (12,'Basket ball');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (13,'Beach volley');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (14,'Biathlon');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (15,'Billard');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (16,'BMX');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (17,'Boxe amricaine');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (18,'Boxe anglaise');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (19,'Boxe chinoise');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (20,'Boxe franaise');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (21,'Boxe thalandaise');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (22,'Cano kayak');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (23,'Canyonisme');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (24,'Capoeira');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (25,'Char  voile');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (26,'Course  pied');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (27,'Cyclisme sur piste');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (28,'Cyclisme sur route');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (29,'Cyclo-cross');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (30,'Deltaplane');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (31,'Equitation');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (32,'Escalade');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (33,'Escrime');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (34,'Fitness');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (35,'Football');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (36,'Football US');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (37,'Golf');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (38,'Gymnastique artistique');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (39,'Gymnastique douce');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (40,'Gymnastique rythmique');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (41,'Haltrophilie');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (42,'Handball');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (43,'Hockey sur glace');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (44,'Ju-Jitsu traditionnel');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (45,'Karat');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (46,'Karting');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (47,'Kick boxing');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (48,'Kite surf');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (49,'Krav maga');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (50,'Kung fu');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (51,'Luge');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (52,'Lutte grco-romaine');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (53,'Moto cross');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (54,'Moto vitesse');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (55,'Motoneige');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (56,'Musculation');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (57,'Nage avec palmes');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (58,'Natation');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (59,'Natation synchronise');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (60,'Parachutisme');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (61,'Parapente');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (62,'Patinage artistique');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (63,'Pche sous-marine');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (64,'Pelote basque');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (65,'Pentathlon');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (66,'Planche  voile');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (67,'Plonge');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (68,'Plongeon');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (69,'Rafting');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (70,'Randonne questre');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (71,'Randonne pdestre');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (72,'Raquette  neige');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (73,'Rugby  XIII');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (74,'Rugby  XV');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (75,'Skateboard');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (76,'Ski alpin');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (77,'Ski de fond');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (78,'Ski de randonne');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (79,'Ski de vitesse');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (80,'Ski nautique');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (81,'Snowboard');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (82,'Splologie');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (83,'Squash');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (84,'Surf');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (85,'Taekwondo');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (86,'Tennis');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (87,'Tennis de table');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (88,'Tir  l''arc');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (89,'Tir sportif');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (90,'Tir subaquatique');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (91,'Trampoline');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (92,'Triathlon');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (93,'ULM');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (94,'Voile');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (95,'Vol  voile');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (96,'Volley ball');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (97,'VTT');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (98,'Water polo');
INSERT INTO dbo.T_SPORT_SPT (SPT_ID,SPT_LIBELLE) VALUES (99,'Yoga');
SET IDENTITY_INSERT dbo.T_SPORT_SPT OFF;

CHECKPOINT;
GO

SET DATEFORMAT YMD;
GO

SET IDENTITY_INSERT dbo.T_ADHERENT_ADR ON;
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1,'CATHERINE','YVES','1930-02-24','02.47.10.44.66','06.10.07.30.18',NULL,'21 imp de l''aurore','','','14460','COLOMBELLES',NULL,NULL,'2300250643001',15.000000000,'1957-07-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2,'REVET','MARCEL','1934-07-17','02.80.29.15.70','06.13.93.63.02',NULL,'','','','14730','GIBERVILLE',NULL,NULL,'1340714406001',75.000000000,'1955-09-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3,'GOSSET','ANDRE','1930-05-09','02.10.58.92.37','06.21.37.29.23',NULL,'','','','14480','CREULLY',NULL,NULL,'2300514022001',178.000000000,'1956-07-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4,'RICHARD','Claude','1943-01-16','02.12.29.46.51','06.74.02.77.90',NULL,'10 PLACE DE L''HOTEL DE VILLE','','','14260','ROUCAMPS',NULL,NULL,'2430114275001',69.000000000,'1973-04-08','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5,'KAMALI','GENEVIEVE','1928-07-26','02.13.03.04.39','06.83.11.12.21',NULL,'20 av de la cite miniere','','','14270','MEZIDON CANON',NULL,NULL,'1280714437001',123.000000000,'1950-03-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6,'LEFRANCOIS','ARLETTE','1936-07-12','02.74.05.90.78',NULL,NULL,'','','','14000','CAEN',NULL,NULL,'1360714592001',146.000000000,'1963-07-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7,'LEMARCHAND','RENE','1939-10-23','02.76.01.64.95','06.15.91.69.48',NULL,'7 BD DU 11 NOVEMBRE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1391014654001',107.000000000,'1960-04-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8,'','FRANCOISE','1929-06-17','02.94.15.61.90','06.30.19.07.53',NULL,'','','','50360','PICAUVILLE',NULL,NULL,'2290650096001',37.000000000,'1952-05-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9,'BOIS','Bernard','1930-11-21','02.50.84.40.21','06.35.36.78.98',NULL,'','','','14430','DOZULE',NULL,NULL,'2301114752001',96.000000000,'1956-02-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (10,'BOIS','MARGUERITE','1938-02-09','02.66.95.40.44','06.57.27.29.13',NULL,'','','','61200','SARCEAUX',NULL,NULL,'2380227129001',52.000000000,'1961-12-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (11,'HUVIER','SANDRINE','1931-12-24','02.38.28.79.54','06.64.98.11.71',NULL,'','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1311214717001',367.000000000,'1953-07-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (12,'GUERIN','MICHEL','1946-01-31','02.33.61.04.21','06.24.08.16.24',NULL,'','','','14970','BENOUVILLE',NULL,NULL,'2460114424001',57.000000000,'1968-08-13','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (13,'VANRYCKEGHEM','ADRIENNE','1935-12-21','02.86.58.50.19','06.14.55.78.95',NULL,'','','','14840','DEMOUVILLE',NULL,NULL,'2351214569001',145.000000000,'1965-03-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (14,'HOUSSIN','YVETTE','1946-02-17','02.86.54.17.68','06.72.62.43.67',NULL,'25 RUE LOUIS ARRAGON','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2460250223001',439.000000000,'1969-11-02','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (15,'LEBOURGEOIS','MARIE-JEANNE','1936-02-05','02.45.35.55.64','06.75.92.30.96',NULL,'','','','14000','CAEN',NULL,NULL,'1360261071001',138.000000000,'1958-01-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (16,'CALLY','EUGENIE','1939-01-10',NULL,NULL,NULL,'29 RUE DE L4ESPERANCE','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1390122304001',107.000000000,'1964-11-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (17,'CARABEUF','ROLANDE','1930-11-12','02.75.82.69.76','06.22.45.09.95',NULL,'15 REU DES MOISSONEURS','','','14000','CAEN',NULL,NULL,'2301114738001',488.000000000,'1953-03-19','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (18,'GASNIER','PAUL','1959-01-30','02.73.21.83.76','06.27.62.17.79',NULL,'15 RUE DE LA CAVEE','','','14860','RANVILLE',NULL,NULL,'1590114675001',158.000000000,'1982-10-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (19,'AZE','Claude','1933-05-10','02.42.16.95.21','06.62.87.66.62',NULL,'','','','14190','SOIGNOLLES',NULL,NULL,'2330550594001',210.000000000,'1958-07-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (20,'JAVELAUD','MONIQUE','1940-01-27','02.76.66.34.89','06.77.39.26.26',NULL,'','','','14370','ARGENCES',NULL,NULL,'1400114432001',401.000000000,'1965-01-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (21,'LIVET','CATHERINE','1956-09-29','02.12.32.25.76','06.86.82.14.15',NULL,'','','','14000','CAEN',NULL,NULL,'1560914052001',646.000000000,'1981-09-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (22,'ANNE','JOEL','1937-01-18','02.27.99.91.81','06.97.31.09.15',NULL,'','','','14650','CARPIQUET',NULL,NULL,'1370161307001',505.000000000,'1964-08-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (23,'HERVIEU','ROGER','1930-12-03','02.11.88.84.93','06.35.09.28.42',NULL,'','','','14850','ESCOVILLE',NULL,NULL,'1301214201001',3416.000000000,'1959-06-22','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (24,'BARBIER','ANNICK','1932-07-29','02.10.26.31.42','06.86.73.57.20',NULL,'','','','14000','CAEN',NULL,NULL,'1320714537001',89.000000000,'1962-11-21','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (25,'BAZIN','ALAIN','1932-04-03','02.19.47.98.09','06.39.58.91.92',NULL,'','','','14370','GIBERVILLE',NULL,NULL,'1320453276001',186.000000000,'1954-07-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (26,'MERIEULT','EUGENE','1930-03-21','02.79.77.88.81','06.95.19.19.74',NULL,'8 RUE HAVIN','','','14000','CAEN',NULL,NULL,'2300353079001',1144.000000000,'1957-09-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (27,'BERARD','CLAUDIA','1938-04-19','02.15.31.79.34','06.22.48.66.55',NULL,'14 RUE PASTEUR','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2380414249001',153.000000000,'1962-05-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (28,'BERARD','ROGER','1933-10-22','02.76.28.74.21',NULL,NULL,'12 rue de lanteuil','','','14000','CAEN',NULL,NULL,'2331078504001',97.000000000,'1963-06-25','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (29,'DUPONT','CLAIRE','1958-05-15','02.69.98.74.19',NULL,NULL,'12 rue st barbe','','','14120','MONDEVILLE',NULL,NULL,'1580514749001',2445.000000000,'1980-08-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (30,'BRUNET','JEAN','1938-11-17','02.73.33.08.75','06.11.38.52.22',NULL,'zone industrielle du martray','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'2381114220001',248.000000000,'1961-03-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (31,'THUILLIETTE','PIERRE','1959-01-18',NULL,NULL,NULL,'','','','14740','LASSON',NULL,NULL,'2590153238001',38.000000000,'1980-08-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (32,'MANCEL','JACQUELINE','1943-04-15','02.90.01.38.94','06.65.23.39.87',NULL,'','','','14740','LASSON',NULL,NULL,'1430414336001',7.000000000,'1973-09-05','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (33,'LEMERAY','GERARD','1937-09-03','02.38.30.21.17','06.44.98.72.82',NULL,'102 rue de branville','','','14490','BALLEROY',NULL,NULL,'2370914347001',462.000000000,'1967-11-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (34,'GAUTIER','REGIS','1929-01-01','02.85.34.72.26','06.79.13.29.95',NULL,'22 bvd raymond poincare','','','14220','BARBERY',NULL,NULL,'2290114071001',191.000000000,'1959-03-13','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (35,'LEGELEUX','GERARD','1937-06-05','02.53.13.30.95','06.44.54.85.38',NULL,'38 avenue ste therese','','','14400','BAYEUX',NULL,NULL,'1370614039001',628.000000000,'1965-10-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (36,'ROUSSEL','CLAUDE','1923-08-12','02.45.80.39.03','06.50.45.39.94',NULL,'','','','14114','VER SUR MER',NULL,NULL,'1230850394001',42.000000000,'1951-02-02','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (37,'BISSON','JEAN','1949-02-09','02.71.48.88.82','06.92.23.27.55',NULL,'','','','14540','GRENTHEVILLE',NULL,NULL,'2490261321001',13.000000000,'1970-07-27','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (38,'BALLUAS','ROBERT','1940-08-02','02.57.42.05.40','06.48.54.34.76',NULL,'18 rue de stocklhome','','','14000','CAEN',NULL,NULL,'1400861102001',2974.000000000,'1964-06-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (39,'BARBIER','JEAN MARIE','1957-10-02','02.88.01.55.44','06.10.40.89.58',NULL,'','','','14680','CINTHEAUX',NULL,NULL,'2571014215001',767.000000000,'1979-03-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (40,'JAMES','SYLVIE','1933-12-20','02.19.49.15.02','06.30.47.21.46',NULL,'','','','14000','CAEN',NULL,NULL,'1331253043001',128.000000000,'1955-05-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (41,'LEPELTIER','SERGE','1933-08-31','02.29.49.36.43','06.65.58.85.48',NULL,'','','','14240','ST GERMAIN D''ECTOT',NULL,NULL,'1330814622001',12.000000000,'1954-09-19','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (42,'LEROSIER','NICOLLE','1932-02-09','02.34.83.53.46','06.63.95.26.55',NULL,'','','','14000','CAEN',NULL,NULL,'2320214372001',573.000000000,'1961-06-26','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (43,'LANOS','Christine','1934-10-15','02.52.42.83.51','06.36.53.77.83',NULL,'16 AVENUE DU 43 IEME REGT D ARTI','LLERIE','','14000','CAEN',NULL,NULL,'1341014651001',30.000000000,'1964-02-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (44,'LEREBOUR','MICHEL','1979-03-17','02.56.49.82.01','06.47.24.14.04',NULL,'2 rue meaise','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1790356152001',719.000000000,'2005-03-07','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (45,'MALASSENET','ARLETTE','1932-06-27','02.12.28.42.00','06.33.37.28.35',NULL,'','','','14370','CLEVILLE',NULL,NULL,'2320614735001',146.000000000,'1959-05-10','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (46,'LENEVEU','RENE',NULL,'02.34.86.08.56','06.11.89.41.74',NULL,'le mesnil touffray','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'',117.000000000,'2010-07-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (47,'BECQUET','MONIQUE',NULL,'02.28.55.51.47','06.55.10.80.34',NULL,'33 chemin de l''arguilly','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'',15.000000000,'2008-06-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (48,'BOUSQUET','GILLES',NULL,'02.52.85.48.57','06.23.78.17.09',NULL,'11 RUE DE LA PAIX','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'',160.000000000,'2012-01-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (49,'MADELAINE','JEAN',NULL,'02.78.31.38.77','06.94.94.40.59',NULL,'27 RUE DE LA CHENEVOTTE','','','14000','CAEN',NULL,NULL,'',675.000000000,'2008-02-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (50,'ANNE','JEAN',NULL,'02.20.85.82.74',NULL,NULL,'1 PLACE DES NOYERS','','','14000','CAEN',NULL,NULL,'',357.000000000,'2010-08-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (51,'DUCLOS','Michel',NULL,'02.78.32.00.09','06.33.35.13.70',NULL,'','','','14000','CAEN',NULL,NULL,'',914.000000000,'2011-08-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (52,'DURAND','GINETTE',NULL,'02.19.67.90.57','06.89.78.01.68',NULL,'','','','14540','SOLIERS',NULL,NULL,'',179.000000000,'2009-05-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (53,'GRANDMOUGIN','PATRICK',NULL,'02.19.64.71.85','06.11.46.76.99',NULL,'11 rue felici charles','','','14120','MONDEVILLE',NULL,NULL,'',9.000000000,'2008-10-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (54,'GUERIN','ROLAND FELIX MA',NULL,'02.65.15.82.29','06.54.67.34.13',NULL,'19 rue des genevriers','','','14000','CAEN',NULL,NULL,'',2.000000000,'2011-10-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (55,'LAURENT','ODETTE',NULL,'02.90.60.38.62','06.11.78.64.90',NULL,'16 RUE EMILE ZOLA','','','14000','CAEN',NULL,NULL,'',877.000000000,'2009-05-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (56,'GOUMAULT','JEANNINE',NULL,'02.88.27.03.63','06.69.35.95.66',NULL,'5 rue de sully','','','14780','LION SUR MER',NULL,NULL,'',320.000000000,'2010-12-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (57,'PEPIN','PATRICE',NULL,'02.58.20.01.85','06.52.72.03.96',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'',355.000000000,'2013-08-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (58,'MAIZERAY','HENRI',NULL,'02.64.46.87.71','06.19.34.39.45',NULL,'8 impasse reine matilde','','','14120','MONDEVILLE',NULL,NULL,'',3624.000000000,'2008-02-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (59,'HEUGUET','MAURICETTE',NULL,'02.90.61.48.52','06.20.18.05.29',NULL,'','','','61320','LALACELLE',NULL,NULL,'',16.000000000,'2013-03-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (60,'COSTALONGA','CECILE',NULL,'02.86.19.51.42','06.80.51.82.40',NULL,'4 RUE GUILBERT','','','14123','IFS',NULL,NULL,'',243.000000000,'2011-06-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (61,'COSTALONGA','JEAN',NULL,'02.92.26.34.96','06.57.76.17.69',NULL,'4 RUE DE VERDUN','','','14930','ETERVILLE',NULL,NULL,'',24.000000000,'2013-01-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (62,'THOMAS','LAURENCE',NULL,'02.18.82.63.13','06.69.53.66.32',NULL,'','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'',67.000000000,'2012-10-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (63,'DREYFUS','GEORGES',NULL,'02.90.70.34.20','06.38.20.14.87',NULL,'','','','14320','MAY SUR ORNE',NULL,NULL,'',445.000000000,'2011-12-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (64,'JOYAUX','NICOLE',NULL,'02.89.69.30.20','06.14.51.96.31',NULL,'','','','14000','CAEN',NULL,NULL,'',43.000000000,'2007-11-27','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (65,'MARIE','BERNARD',NULL,'02.80.07.31.20','06.58.13.44.94',NULL,'2 rue edouard manet','','','14000','CAEN',NULL,NULL,'',107.000000000,'2012-01-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (66,'BUNEL','FRANCOISE',NULL,'02.68.48.00.28','06.81.94.49.97',NULL,'HAMEAU DE BELLEFONTAINE','','','61800','ST CORNIER DES LANDES',NULL,NULL,'',171.000000000,'2009-11-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (67,'BRILLANT','PATRICIA',NULL,'02.29.32.79.81','06.34.47.56.59',NULL,'3 RUE SOULIER','','','50300','ST OVIN',NULL,NULL,'',22.000000000,'2010-07-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (68,'KOPYLA','PAULETTE',NULL,'02.42.37.90.32','06.28.77.19.63',NULL,'304 Haute Folie','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'',267.000000000,'2012-10-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (69,'AVRIL','GISELE',NULL,'02.73.49.63.36','06.17.85.67.69',NULL,'34 Rue Gaston Manneville','','','14610','VILLONS LES BUISSONS',NULL,NULL,'',1547.000000000,'2008-01-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (70,'FOUBERT','LOUIS','1962-05-28','02.28.19.69.67','06.29.09.49.71',NULL,'','','','14270','MEZIDON CANON',NULL,NULL,'16205610010',844.000000000,'1986-12-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (71,'HAVIN','GERARD','1982-01-22','02.84.01.98.74',NULL,NULL,'','','','50880','PONT HEBERT',NULL,NULL,'282017142200',31.000000000,'2003-04-21','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (72,'VIRGEL','ROGER','1981-05-01','02.70.86.70.44','06.60.89.91.47',NULL,'52 avenue Bayview Pointe-Claire','Qubec','','14260','BREMOY',NULL,NULL,'1810599000000',208.000000000,'2005-10-02','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (73,'LAUSSINE','DANIEL','1984-07-29','02.63.60.63.01','06.60.69.28.06',NULL,'11 rue guillaume trebutien','','','14540','BOURGUEBUS',NULL,NULL,'1840714118000',8.000000000,'2012-12-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (74,'POULIQUEN','GILBERT','1987-09-04','02.47.12.38.63','06.71.63.40.34',NULL,'','','','14370','BELLENGREVILLE',NULL,NULL,'1870961214000',25.000000000,'2012-12-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (75,'BASLEY','NATHALIE','1965-09-02','02.31.11.44.38','06.46.30.49.60',NULL,'','','','14000','CAEN',NULL,NULL,'2650914075001',177.000000000,'1995-12-04','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (76,'CASTEL','GEORGETTE','1940-06-10','02.39.24.34.63','06.64.04.25.20',NULL,'17 rue de la liberation','','','14000','CAEN',NULL,NULL,'1400651285001',2460.000000000,'1966-12-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (77,'PASQUET','MAURICETTE','1929-11-22','02.64.46.79.12','00 33 6.86.51.94.70',NULL,'Route de St Sylvain','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2291178038001',410.000000000,'1950-06-29','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (78,'TSIKLAURI','PAULETTE','1936-03-19','02.96.75.23.93','06.60.67.08.81',NULL,'','','','50160','ST AMAND',NULL,NULL,'1360314530001',106.000000000,'1957-07-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (79,'JEANNE','MARTINE','1946-10-29','02.40.57.43.16','06.27.71.47.42',NULL,'BELLOU','','','14000','CAEN',NULL,NULL,'1461014149001',19.000000000,'1974-09-17','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (80,'CHAUVIN','ANDRE','1937-07-01','02.10.94.93.78','06.77.88.20.46',NULL,'','','','14190','MAIZIERES',NULL,NULL,'1370714266001',190.000000000,'1958-07-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (81,'PILLIER','MICHELINE','1932-10-25','02.33.02.83.91','06.12.23.70.70',NULL,'33 bvd general vannier','','','14000','CAEN',NULL,NULL,'1321014013001',91.000000000,'1962-06-13','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (82,'PITANCE','BERNARD','1931-08-27','02.58.34.97.40','06.85.91.09.34',NULL,'','','','14000','CAEN',NULL,NULL,'1310814762001',8.000000000,'1952-06-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (83,'DODEMAN','JEAN CLAUDE','1939-06-26','02.10.40.75.49','06.48.38.36.81',NULL,'67 rue de bayeux','','','27210','FATOUVILLE GRESTAIN',NULL,NULL,'2390627422001',27.000000000,'1962-05-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (84,'JULIEN','CLAUDE','1967-02-05','02.12.04.70.63','06.49.13.26.79',NULL,'INSTITUT MEDICO PROFESSIONNEL','','','14610','EPRON',NULL,NULL,'1670214137001',131.000000000,'1994-02-26','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (85,'CHARBONNIER','CHARLES','1934-02-14','02.36.00.59.41','06.15.37.06.07',NULL,'','','','14840','DEMOUVILLE',NULL,NULL,'1340214392001',1533.000000000,'1955-02-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (86,'SIMON','MADELEINE','1939-09-17','02.11.12.57.10','06.49.46.69.50',NULL,'','','','14000','CAEN',NULL,NULL,'2390914657001',69.000000000,'1960-04-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (87,'NORMAND','DENIS','1928-12-14','02.10.98.17.44','06.88.08.47.03',NULL,'7 chemin des bruyres','','','14000','CAEN',NULL,NULL,'1281214572001',669.000000000,'1950-02-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (88,'MILOUX','CHRISTIAN',NULL,'02.14.23.99.69','06.71.90.91.73',NULL,'3 ROUTE D ARGENCE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1320214039001',648.000000000,'2008-03-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (89,'DUMONT','MARIE MADELEINE','1962-01-17','02.79.85.89.47','06.75.18.59.93',NULL,'hameaux de cavigny','','','14340','CAMBREMER',NULL,NULL,'2620114581001',40.000000000,'1983-11-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (90,'COURTIN','THERESE','1939-10-22','02.11.64.20.60','06.78.72.50.54',NULL,'la cour d''enfer','','','14000','CAEN',NULL,NULL,'1391078158001',130.000000000,'1963-08-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (91,'JOUAULT','PIERRE','1943-07-01','02.24.68.98.31','06.76.49.54.30',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1430750246001',89.000000000,'1968-07-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (92,'REQUIS','HERVE',NULL,'02.10.86.75.53','06.24.64.50.88',NULL,'','','','14220','DONNAY',NULL,NULL,'',1472.000000000,'2012-03-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (93,'LEMASSON','MADELEINE',NULL,'02.79.03.44.41','06.35.78.47.68',NULL,'','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'',121.000000000,'2010-04-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (94,'BISSON','LEA',NULL,'02.72.18.30.26','06.10.69.86.84',NULL,'','','','14000','CAEN',NULL,NULL,'',57.000000000,'2007-12-12','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (95,'PERROTTE','JEAN CLAUDE',NULL,'02.74.04.14.37',NULL,NULL,'95 BVD LEROY','','','14120','MONDEVILLE',NULL,NULL,'',800.000000000,'2013-07-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (96,'MELET','JEANNINE',NULL,'02.29.24.94.56','06.58.74.21.00',NULL,'33 RUE GAMBETTA','','','14000','CAEN',NULL,NULL,'',104.000000000,'2011-10-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (97,'FLEURY','RAYMOND',NULL,'02.40.64.43.40','06.45.77.27.88',NULL,'3 RUE SOULLIERS','','','14350','LE TOURNEUR',NULL,NULL,'',17.000000000,'2012-05-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (98,'COLOMBERT','ELIANE',NULL,'02.85.69.65.31','06.34.74.49.77',NULL,'','','','14000','CAEN',NULL,NULL,'',36.000000000,'2009-08-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (99,'MAECKE','CLAUDE',NULL,'02.99.74.18.63',NULL,NULL,'71 route d harcout','','','14540','SOLIERS',NULL,NULL,'',698.000000000,'2011-12-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (100,'ROULLIER','ELISABETH',NULL,'02.61.96.13.00','06.55.77.88.34',NULL,'','','','14840','DEMOUVILLE',NULL,NULL,'',349.000000000,'2013-08-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (101,'AMICHOT','DANIEL',NULL,'02.44.37.71.90','06.51.51.13.86',NULL,'le calvaire','','','14123','FLEURY SUR ORNE',NULL,NULL,'',6.000000000,'2008-03-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (102,'LEFAVRAIS','JACQUELINE',NULL,'02.75.66.59.35','06.66.70.92.55',NULL,'141 rue de falaise','','','14420','POTIGNY',NULL,NULL,'',884.000000000,'2013-01-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (103,'BELLAIR','EDITH',NULL,'02.38.01.40.33','06.35.24.06.16',NULL,'4 rue glenn miler','','','14320','MAY SUR ORNE',NULL,NULL,'',30.000000000,'2012-10-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (104,'FONNARD','GILLES',NULL,'02.83.36.03.11','06.23.74.07.52',NULL,'1 place de la liberte','','','50460','QUERQUEVILLE',NULL,NULL,'',692.000000000,'2010-12-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (105,'BOURDON','NADEGE',NULL,'02.87.46.95.33','06.46.06.93.80',NULL,'26 rue de l ancienne gare','','','27750','LA COUTURE BOUSSEY',NULL,NULL,'',747.000000000,'2012-09-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (106,'HAMEL','SUZANNE',NULL,'02.16.62.74.27',NULL,NULL,'','','','14000','CAEN',NULL,NULL,'',27.000000000,'2013-08-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (107,'MONFORT','Michel',NULL,'02.16.94.17.64','06.25.96.20.30',NULL,'4 RUE J JACQUES ROUSSEAU','','','14123','IFS',NULL,NULL,'',32.000000000,'2011-12-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (108,'VILLEROY','GEORGETTE',NULL,'02.62.81.33.66','06.11.38.06.89',NULL,'5 allee de dieldt','','','50580','DENNEVILLE',NULL,NULL,'',87.000000000,'2009-12-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (109,'COLLET','PATRICE',NULL,'02.55.88.15.45','06.20.90.80.55',NULL,'','','','14123','IFS',NULL,NULL,'',18.000000000,'2008-05-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (110,'JAMARD','Pierre',NULL,'02.81.57.51.54','06.18.72.18.77',NULL,'','','','61250','COLOMBIERS',NULL,NULL,'',508.000000000,'2013-09-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (111,'PHILIPPE','JACQUES',NULL,'02.70.66.02.48','06.11.15.02.59',NULL,'101 rue du chemin vert','','','14190','FIERVILLE BRAY',NULL,NULL,'',87.000000000,'2009-02-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (112,'LOREL','BERNARD',NULL,'02.12.10.61.04','06.26.94.74.42',NULL,'101 rue du chemin vert','','','14000','CAEN',NULL,NULL,'',159.000000000,'2009-02-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (113,'LAUNAY','MARIUS',NULL,'02.62.78.37.99','06.97.26.76.89',NULL,'24 rue des grands lacs','','','14120','MONDEVILLE',NULL,NULL,'',17.000000000,'2012-09-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (114,'HERVIEU','ROGER JACQUES',NULL,'02.10.26.05.31','06.11.67.98.48',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'',929.000000000,'2010-11-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (115,'MARGUERIE','DANIEL',NULL,'02.79.99.39.38','06.14.39.96.68',NULL,'19 RUE LE PETIT VICEL','','','61160','TRUN',NULL,NULL,'',4105.000000000,'2013-05-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (116,'D ANDREA','COLETTE',NULL,'02.80.78.98.60','06.22.37.51.61',NULL,'15 rue de la olaine','','','14190','FIERVILLE BRAY',NULL,NULL,'',4095.000000000,'2010-04-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (117,'CERE','JANINE',NULL,'02.38.80.51.10','06.32.94.76.90',NULL,'','','','14690','PONT D''OUILLY',NULL,NULL,'',438.000000000,'2012-01-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (118,'CAIRON','JEAN',NULL,'02.11.24.82.70','06.64.52.35.81',NULL,'','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'',106.000000000,'2013-07-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (119,'LAVILLE','GUY',NULL,'02.35.82.95.94','06.70.95.78.28',NULL,'','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'',1164.000000000,'2009-10-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (120,'ROLLAND','PAUL',NULL,'02.69.21.60.23','06.15.47.29.29',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'',150.000000000,'2010-06-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (121,'BUISARD','THERESE',NULL,'02.54.93.19.04','06.58.94.35.54',NULL,'10 IMP MARECHAL COURONNE','','','14700','FALAISE',NULL,NULL,'',36.000000000,'2013-06-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (122,'HENRY','CLAUDE',NULL,'02.45.41.58.03','06.11.69.32.56',NULL,'ferme de la mare / cour ste cath','erine de sienne','','14000','CAEN',NULL,NULL,'',57.000000000,'2013-09-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (123,'JALET','Solange',NULL,'02.11.48.52.16','06.41.85.35.53',NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'',42.000000000,'2009-12-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (124,'MARIE','roger',NULL,'02.88.44.18.28','06.15.57.98.04',NULL,'15 RUE ST GABRIEL','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'',59.000000000,'2009-09-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (125,'JEAN','JULES',NULL,'02.47.76.62.39','06.71.81.08.97',NULL,'10 RUE DU 11 NOVEMBRE','','','14860','RANVILLE',NULL,NULL,'',420.000000000,'2010-04-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (126,'GUERARD','HENRI',NULL,'02.48.41.20.43','06.90.04.55.47',NULL,'1 rue des sirets','','','14000','CAEN',NULL,NULL,'',106.000000000,'2011-01-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (127,'CAPELLO','ROBERT','1937-11-28','02.78.28.09.48','06.80.67.95.84',NULL,'14 ALLEE DU LOSION','','','14730','GIBERVILLE',NULL,NULL,'2371114015001',30.000000000,'1963-10-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (128,'BONNIVARD','SIMONE','1964-10-28','02.60.09.72.26','06.90.68.29.16',NULL,'','','','14840','DEMOUVILLE',NULL,NULL,'1641050129001',35.000000000,'1987-06-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (129,'MARHIC','LOUIS','1932-12-07','02.37.35.48.97','06.21.54.52.91',NULL,'','','','14123','IFS',NULL,NULL,'1321214290001',205.000000000,'1954-07-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (130,'LASTELLE','DENISE','1935-07-29','02.48.86.92.91','06.70.51.03.80',NULL,'','','','14000','CAEN',NULL,NULL,'1350714005001',525.000000000,'1956-09-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (131,'MURIEL','FRANCOISE','1930-01-11','02.49.73.61.65','06.13.18.94.37',NULL,'','','','14800','DEAUVILLE',NULL,NULL,'1300161222001',39.000000000,'1952-02-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (132,'JOUVIN','PIERRE','1934-08-09','02.60.76.60.31','06.37.32.39.50',NULL,'','','','14400','BAYEUX',NULL,NULL,'1340814700001',651.000000000,'1958-12-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (133,'PERRIER','GEORGES','1937-08-15','02.38.68.77.65','06.67.96.26.19',NULL,'','','','14940','SANNERVILLE',NULL,NULL,'1370814192001',3032.000000000,'1961-04-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (134,'LEVERRIER','DANIELE','1956-04-16','02.11.61.29.43','06.10.94.72.81',NULL,'16 RUE DE MORTAIN','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2560414640001',92.000000000,'1985-05-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (135,'LEDRU','JEAN','1937-02-05','02.81.51.05.83','06.31.83.52.93',NULL,'','','','14000','CAEN',NULL,NULL,'1370261344001',230.000000000,'1964-01-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (136,'SCELLES','COLETTE','1936-06-17','02.76.02.18.90','06.12.29.66.46',NULL,'','','','14670','TROARN',NULL,NULL,'2360614672001',747.000000000,'1958-02-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (137,'PERAUD','PIERRE','1965-04-14','02.33.35.41.28','06.48.20.73.35',NULL,'','','',NULL,NULL,NULL,NULL,'2650414651001',29.000000000,'1994-02-24','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (138,'SPRENGER','LEON','1936-01-30','02.56.47.49.58','06.91.97.79.87',NULL,'','','','14123','FLEURY SUR ORNE',NULL,NULL,'1360155500001',2825.000000000,'1958-02-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (139,'BLACHET','YVETTE',NULL,'02.79.37.65.64','06.31.10.75.41',NULL,'1 rue des sirets','','','14370','BILLY',NULL,NULL,'',19.000000000,'2008-03-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (140,'BENARD','JEANNINE',NULL,'02.78.02.31.14','06.11.41.27.88',NULL,'','','','14350','LE DESERT',NULL,NULL,'',222.000000000,'2012-12-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (141,'BUSNEL','DANIELLE',NULL,'02.40.52.25.06','06.73.68.94.58',NULL,'10023 RES LES BOIS DU TEMPLE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'',25.000000000,'2008-04-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (142,'BARTI','GERMAINE',NULL,'02.69.22.76.00','06.58.20.07.30',NULL,'14 rue ed herioz','','','14123','CORMELLES LE ROYAL',NULL,NULL,'',106.000000000,'2012-10-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (143,'CATHERINE','SUZANNE',NULL,'02.80.79.30.19','06.19.06.19.70',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'',1111.000000000,'2009-09-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (144,'DUFAY','VERONIQUE',NULL,'02.26.06.99.56','06.66.82.47.83',NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'',187.000000000,'2011-11-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (145,'WISS','JEAN CLAUDE',NULL,NULL,NULL,NULL,'2 rue de l''egalite','','','14970','BENOUVILLE',NULL,NULL,'',5327.000000000,'2012-01-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (146,'LAMOTTE','DIDIER',NULL,'02.40.44.85.59','06.40.37.61.07',NULL,'','','','14210','GIBERVILLE',NULL,NULL,'',66.000000000,'2009-06-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (147,'BRILLAUD','ANDRE',NULL,'02.42.51.15.42','06.26.21.04.66',NULL,'','','','14000','CAEN',NULL,NULL,'',10.000000000,'2013-04-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (148,'PANIZZON','PIERRE',NULL,'02.26.60.93.11','06.35.02.12.35',NULL,'3 allee j cartier','','','14123','IFS',NULL,NULL,'',6.000000000,'2009-09-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (149,'TERRY','Remi',NULL,'02.52.94.11.67','06.61.02.38.17',NULL,'13 rue des bergeronettes','','','14730','GIBERVILLE',NULL,NULL,'',1.000000000,'2008-10-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (150,'ADAM','PIERRE',NULL,'02.25.86.10.52','06.62.49.31.52',NULL,'','','','14270','OUEZY',NULL,NULL,'',109.000000000,'2009-12-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (151,'GALLOT','LUCIENNE',NULL,'02.59.98.79.90','06.11.01.75.90',NULL,'35 allee du coti','','','14000','CAEN',NULL,NULL,'',39.000000000,'2009-09-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (152,'LEMAROIS','JACQUES',NULL,'02.20.72.18.62','06.91.72.00.53',NULL,'','','','14630','CAGNY',NULL,NULL,'',957.000000000,'2009-03-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (153,'LECOEUR','PAULETTE',NULL,'02.22.90.45.67','06.32.94.56.09',NULL,'','','','14000','CAEN',NULL,NULL,'',1713.000000000,'2012-11-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (154,'JEHANNE','JANINE',NULL,'02.51.82.53.08','06.68.47.19.52',NULL,'','','','14670','TROARN',NULL,NULL,'',497.000000000,'2012-09-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (155,'ALBA','STEPHANE',NULL,'02.24.31.70.60','06.78.25.59.22',NULL,'','','','14330','LE MOLAY LITTRY',NULL,NULL,'',346.000000000,'2011-11-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (156,'LECOQ','PASCAL',NULL,'02.57.56.70.57','06.61.99.42.05',NULL,'','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'',282.000000000,'2009-03-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (157,'DESOUBEAUX','ROBERT',NULL,'02.21.71.01.46','06.78.79.11.63',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'',26.000000000,'2011-08-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (158,'FOULIARD','COLETTE',NULL,'02.54.06.68.91','06.83.24.99.76',NULL,'','','','61200','FONTENAI SUR ORNE',NULL,NULL,'',84.000000000,'2011-05-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (159,'ANGEL DIT HUGO','HELENE',NULL,'02.23.19.86.12','06.84.33.38.99',NULL,'','','','14000','CAEN',NULL,NULL,'',62.000000000,'2011-07-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (160,'DELAUNAY','GENEVIEVE',NULL,'02.60.48.66.98','06.10.64.35.99',NULL,'','','','14390','CABOURG',NULL,NULL,'',387.000000000,'2012-09-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (161,'EURY','NADINE',NULL,'02.49.75.19.81','06.25.76.08.10',NULL,'route de falaise','','','50750','STE SUZANNE SUR VIRE',NULL,NULL,'',1044.000000000,'2009-10-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (162,'DODEMAN','MARIE MADELEINE',NULL,'02.74.33.06.25',NULL,NULL,'2 impasse des charmes','','','14000','CAEN',NULL,NULL,'',168.000000000,'2009-05-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (163,'ISIDOR','FRANCOISE',NULL,'02.93.55.99.57','06.80.91.02.18',NULL,'29 rue robert bothereau','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'',30.000000000,'2011-05-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (164,'AUGUET','BEATRICE',NULL,'02.13.82.63.48','06.53.27.83.59',NULL,'1801 quaretier du bois','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'',59.000000000,'2010-09-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (165,'DESMYTER','Micheline',NULL,'02.45.23.34.06','06.81.40.18.65',NULL,'14 rue de la marne','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'',847.000000000,'2013-01-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (166,'MOUVILLE','HUGUETTE',NULL,'02.50.10.78.22','06.54.51.28.38',NULL,'','','','14000','CAEN',NULL,NULL,'',94.000000000,'2009-03-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (167,'MARIE','MARTINE',NULL,'02.11.69.30.43','06.19.92.95.30',NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'',32.000000000,'2008-06-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (168,'PIETRALUNGA','ANNIE',NULL,'02.45.84.22.97','06.85.33.44.42',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'',830.000000000,'2011-10-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (169,'LEBRUN','LUC',NULL,'02.41.47.51.88','06.11.50.51.32',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'',631.000000000,'2011-11-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (170,'HENRI','BERNADETTE',NULL,'02.27.94.32.44','06.82.37.29.12',NULL,'','','','14610','VILLONS LES BUISSONS',NULL,NULL,'',418.000000000,'2010-01-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (171,'QUONIAM','jean luc',NULL,'02.30.19.75.33','06.72.44.28.20',NULL,'','','',NULL,NULL,NULL,NULL,'',941.000000000,'2012-03-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (172,'LESIMPLE','MICHEL',NULL,'02.11.33.22.45','06.73.39.82.57',NULL,'','','','14650','CARPIQUET',NULL,NULL,'',54.000000000,'2008-02-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (173,'FEREY','ALAIN','1954-04-14','02.61.01.35.04','06.75.13.42.70',NULL,'5 RUE JULES FERRY','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'2540450614001',18.000000000,'1978-04-22','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (174,'FRANDEMICHE','SERGE','1933-10-02','02.10.48.44.34','06.80.96.01.47',NULL,'11 allee j racine','','','14000','CAEN',NULL,NULL,'1331014277001',2161.000000000,'1956-04-13','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (175,'DERIEN','J FRANCOI','1937-10-07','02.80.56.17.07','06.11.52.01.69',NULL,'','','','14000','CAEN',NULL,NULL,'2371014670001',441.000000000,'1959-05-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (176,'BLANCHARD','RAYMOND','1937-10-12','02.28.50.40.40','06.17.77.85.82',NULL,'38 rue des ecuyers','','','14120','MONDEVILLE',NULL,NULL,'1371014733001',909.000000000,'1967-05-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (177,'LEPY','XAVIER','1955-01-03','02.69.12.90.58','06.38.84.64.08',NULL,'','','','14240','CAHAGNES',NULL,NULL,'1550135355001',148.000000000,'1985-08-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (178,'','COLETTE','1962-05-19','02.19.59.19.00','06.50.66.79.56',NULL,'','','','14150','OUISTREHAM',NULL,NULL,'2620514170001',38.000000000,'1984-07-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (179,'','','1939-11-13','02.10.39.70.16','06.38.18.42.39',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1391114066001',38.000000000,'1968-11-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (180,'MARTY','DANIEL','1928-09-17','02.76.38.10.37','06.29.77.33.51',NULL,'10 rue louis pasteur','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1280935072001',341.000000000,'1952-05-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (181,'VIVIER','nathalie','1934-01-31','02.72.69.80.22','06.90.24.23.78',NULL,'','','','50100','CHERBOURG',NULL,NULL,'2340114595001',40.000000000,'1958-04-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (182,'PICARD','MICHEL','1943-05-14','02.94.21.34.50','06.51.88.08.49',NULL,'','','','50450','GAVRAY',NULL,NULL,'1430578158001',671.000000000,'1965-03-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (183,'AUMONT','AUGUSTE','1963-02-27','02.79.10.44.78','06.79.50.58.47',NULL,'21 RUE DES MIMOSAS','','','14123','IFS',NULL,NULL,'3630282121001',54.000000000,'1985-12-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (184,'HUE','Christelle','1937-12-30','02.63.67.49.95','06.50.15.31.16',NULL,'32 RUE EUGENE MAES','','','14123','FLEURY SUR ORNE',NULL,NULL,'1371214506001',2155.000000000,'1964-01-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (185,'LEHAIN','Lionel','1940-03-15','02.11.34.94.11','06.25.07.79.70',NULL,'RTE DE TESSY','','','14370','CHICHEBOVILLE',NULL,NULL,'1400361377001',238.000000000,'1969-04-18','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (186,'LE MARQUIS','CHARLES','1964-05-25','02.14.83.33.26','06.38.12.26.58',NULL,'','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1640514118001',167.000000000,'1994-04-02','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (187,'SZYMANSKI','MARGUERITE','1934-01-31','02.43.66.36.91','06.39.15.63.24',NULL,'74 quai vendeuvre','','','14780','LION SUR MER',NULL,NULL,'2340127164001',265.000000000,'1963-03-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (188,'LEGRAND','MARC','1931-05-02','02.15.53.94.14','06.87.02.84.19',NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1310514026001',87.000000000,'1954-01-09','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (189,'RIBET','DANIEL',NULL,'02.37.08.07.34','06.65.77.65.17',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2650750262001',650.000000000,'2010-10-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (190,'DUBOSQ','CYRILLE','1929-10-03','02.19.05.46.08','06.23.49.42.40',NULL,'120 rue emile zola 120 rue em','ile zola','','14950','ST PIERRE AZIF',NULL,NULL,'1291050498001',699.000000000,'1954-05-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (191,'HAVARD','herve','1935-01-16','02.18.96.74.85',NULL,NULL,'5 RUE DE LA HAIE VIGNE','','','14120','GIBERVILLE',NULL,NULL,'1350127036001',14.000000000,'1956-10-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (192,'PRECOURT','ROBERT','1933-02-01','02.17.80.85.90','06.35.73.51.77',NULL,'','','','14000','CAEN',NULL,NULL,'2330214688001',87.000000000,'1957-12-06','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (193,'CATHERINE','JEAN','1930-05-25','02.52.49.71.78','06.34.15.60.84',NULL,'','','','14630','CAGNY',NULL,NULL,'1300514037001',9.000000000,'1953-11-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (194,'SABINE','JEAN PIERRE','1965-11-20','02.26.84.34.73','06.11.69.22.01',NULL,'','','','14370','CLEVILLE',NULL,NULL,'2651114455001',54.000000000,'1995-10-25','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (195,'ROSSIGNOL','GUY','1948-02-20','02.15.67.13.18','06.27.96.87.90',NULL,'','','','14370','ARGENCES',NULL,NULL,'1480214547001',1151.000000000,'1972-09-02','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (196,'PONTES','BERNARD','1939-11-18','02.11.20.91.73','06.29.81.30.49',NULL,'','','','14370','ARGENCES',NULL,NULL,'2391161038001',659.000000000,'1968-11-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (197,'LEROY','GERARD',NULL,'02.95.51.76.84','06.51.17.25.69',NULL,'','','','14390','CABOURG',NULL,NULL,'2390114368001',24.000000000,'2011-11-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (198,'LUCAS','BERNARD','1929-05-26','02.32.45.09.54','06.11.47.63.97',NULL,'','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2290576594001',631.000000000,'1957-06-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (199,'LELIEVRE','JOSEPH','1984-07-11','02.47.97.62.95','06.12.33.47.51',NULL,'','','','14430','ANNEBAULT',NULL,NULL,'2840714039001',20.000000000,'2009-03-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (200,'POULLAIN','ROBERT','1928-03-07','02.32.17.82.59','06.82.06.63.89',NULL,'','','','14370','BELLENGREVILLE',NULL,NULL,'2280327021001',61.000000000,'1956-11-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (201,'DUVAL','VALERIE','1962-12-09','02.52.72.14.27','06.52.90.47.78',NULL,'','','','14700','ST PIERRE DU BU',NULL,NULL,'1621299122001',12.000000000,'1991-11-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (202,'PATELLI','CHRISTIANE','1937-12-11','02.34.53.83.31','06.65.94.41.56',NULL,'','','','14000','CAEN',NULL,NULL,'2371214485001',10.000000000,'1966-07-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (203,'ESNEYS','GENEVIEVE','1932-03-08','02.43.85.81.39','06.36.90.49.91',NULL,'','','','14730','GIBERVILLE',NULL,NULL,'1320314643001',2686.000000000,'1953-09-02','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (204,'GUYONNET','HELENE','1945-02-12','02.69.26.16.47','06.94.72.22.67',NULL,'','','','14840','DEMOUVILLE',NULL,NULL,'2450214290001',137.000000000,'1973-05-14','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (205,'LEPLANQUOIS','GENEVIEVE','1935-03-12','02.46.12.83.88','06.42.04.63.23',NULL,'','','','14250','FONTENAY LE PESNEL',NULL,NULL,'1350314629001',15.000000000,'1959-03-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (206,'LEROUGE','auguste','1940-04-16','02.80.03.25.59','06.28.76.93.76',NULL,'14 rue de la marne','','','76600','LE HAVRE',NULL,NULL,'1400461385001',38.000000000,'1964-08-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (207,'BURIN','GEORGES','1942-04-21','02.19.56.87.29','06.50.42.40.03',NULL,'8 rue marivaux','','','14000','CAEN',NULL,NULL,'1420478239001',3000.000000000,'1966-12-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (208,'AUGER','JULIEN','1941-01-24','02.12.23.37.02','06.35.06.31.10',NULL,'','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'2410114050001',1015.000000000,'1962-04-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (209,'BOUET','alain','1966-07-20','02.27.88.20.36','06.39.78.36.65',NULL,'','','','14210','STE HONORINE DU FAY',NULL,NULL,'2660714034001',1431.000000000,'1991-09-14','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (210,'METAYER','MARIE LOUISE','1969-07-29','02.99.29.74.84',NULL,NULL,'','','',NULL,NULL,NULL,NULL,'1690759183001',8.000000000,'1995-07-04','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (211,'MELINOU','JEAN','1959-12-28','02.11.47.01.19','06.37.98.82.01',NULL,'','','',NULL,NULL,NULL,NULL,'1591214344001',36.000000000,'1980-01-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (212,'SOUCY','ELISABETH','1934-07-09','02.30.94.05.95','06.13.08.14.43',NULL,'5 rue du temps perdu','','',NULL,NULL,NULL,NULL,'1340714538001',55.000000000,'1963-09-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (213,'SOCROUN','YVETTE','1934-08-28','02.47.35.84.74',NULL,NULL,'89 rue j chagford','','',NULL,NULL,NULL,NULL,'2340814354001',162.000000000,'1960-11-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (214,'ALEXANDRE','marcel','1977-08-10','02.12.94.07.53','06.87.56.68.58',NULL,'','','',NULL,NULL,NULL,NULL,'2770899322001',37.000000000,'1999-02-09','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (215,'LOUVEL','PIERRETTE','1929-01-29','02.73.76.49.19','06.14.35.50.80',NULL,'','','',NULL,NULL,NULL,NULL,'2290114659001',334.000000000,'1958-05-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (216,'CATILLON','JEANNINE','1958-01-18','02.57.18.47.78','06.22.73.45.87',NULL,'','','','14123','IFS',NULL,NULL,'2580114092001',70.000000000,'1988-05-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (217,'FONTAINE','ERIC','1935-12-18','02.21.29.88.27','06.71.89.45.42',NULL,'','','','14630','CAGNY',NULL,NULL,'2351214145001',798.000000000,'1958-07-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (218,'CARBONNE','THERESE','1945-01-04','02.32.29.25.34','06.13.41.71.47',NULL,'','','','14460','COLOMBELLES',NULL,NULL,'2450114118001',67.000000000,'1972-09-29','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (219,'SIMEON','RAYMONDE','1964-01-23','02.90.87.17.32','06.40.53.63.43',NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2640178370001',4.000000000,'1991-02-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (220,'DAUPHIN','ROGER','1937-04-05','02.29.73.31.55','06.64.03.26.58',NULL,'14 rue des carrelles','','','14000','CAEN',NULL,NULL,'2370414591001',74.000000000,'1960-03-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (221,'GERAULT','roland','1942-03-01','02.78.18.06.30','06.50.55.46.29',NULL,'72 RUE DES EPIVAS','','',NULL,NULL,NULL,NULL,'2420314675001',1447.000000000,'1964-03-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (222,'LEMORE','HENRIETTE','1961-03-29','02.60.33.80.58','06.56.96.95.68',NULL,'','','',NULL,NULL,NULL,NULL,'2610314542001',186.000000000,'1990-12-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (223,'POZNANSKI','LOUIS','1949-01-25','02.23.49.77.19','06.89.01.40.32',NULL,'21 rue des aulnes','','',NULL,NULL,NULL,NULL,'2490114338001',37.000000000,'1972-07-15','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (224,'BANDRAC','ROGER','1949-03-01','02.44.56.15.12','06.53.91.70.36',NULL,'30 RUE ALEXANDRE CHORON','','',NULL,NULL,NULL,NULL,'1490314499001',38.000000000,'1973-07-09','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (225,'LAUNAY','CLAUDE','1936-09-02','02.23.04.73.87','06.11.76.12.98',NULL,'40 bd leroy','','',NULL,NULL,NULL,NULL,'2360950083001',188.000000000,'1959-05-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (226,'PASNEL','DOMINIQUE','1952-01-16','02.10.62.95.00','06.10.30.16.54',NULL,'16 AV DU 43 EME REGIMENT D ARTIL','LERIE CHEZ MR SARDORI','',NULL,NULL,NULL,NULL,'1520102585001',17.000000000,'1978-04-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (227,'NEDELEC','claude','1937-10-18','02.29.58.69.59','06.61.25.52.73',NULL,'','','',NULL,NULL,NULL,NULL,'1371061303001',6.000000000,'1963-09-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (228,'DUPREY','MAURICE','1922-06-02','02.56.15.06.22','06.11.89.87.40',NULL,'','','','14220','BARBERY',NULL,NULL,'1220614491001',1207.000000000,'1951-01-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (229,'THOMASSE','Monique','1935-06-16','02.97.65.21.31','06.82.48.32.26',NULL,'','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2350614457001',26.000000000,'1957-10-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (230,'JOUSSELIN','MARGUERITE','1954-05-19','02.26.61.16.74',NULL,NULL,'','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1540514084001',2531.000000000,'1981-06-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (231,'PHILIPPAU','GILBERT','1966-03-04','02.48.21.87.15','06.72.98.52.48',NULL,'','','','14160','DIVES SUR MER',NULL,NULL,'2660314554001',886.000000000,'1988-09-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (232,'GILLE','MAURICE','1937-11-04','02.47.17.68.11','06.10.70.72.58',NULL,'126 rue brancion','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2371150054001',4027.000000000,'1961-05-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (233,'DUHOMME','LILIANE','1937-11-02','02.50.66.65.53','06.19.43.95.25',NULL,'12 bis reu de l eglise','','','14220','HAMARS',NULL,NULL,'1371114097001',35.000000000,'1961-06-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (234,'PELTIER','CLAUDE','1932-03-28','02.88.36.05.43','06.36.83.02.76',NULL,'901 rue du chemin vert','','','14210','AVENAY',NULL,NULL,'1320314227001',1408.000000000,'1961-09-15','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (235,'GRIEUX','MONIQUE','1937-07-13','02.99.04.15.38','06.55.38.58.62',NULL,'1 rue de la haie pature','','','14210','LA CAINE',NULL,NULL,'1370714291001',63.000000000,'1958-03-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (236,'FERDJALLAT','RENE','1932-09-26','02.10.82.16.77','06.36.92.49.46',NULL,'20 rue de lisbone','','','14210','TOURVILLE SUR ODON',NULL,NULL,'2320914282001',84.000000000,'1955-05-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (237,'VAUQUELIN','GERARD','1950-10-17','02.14.80.49.87','06.67.78.48.01',NULL,'55 rue des epivas','','','14850','HEROUVILLETTE',NULL,NULL,'2501014075001',174.000000000,'1971-06-19','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (238,'LANGE','SP','1939-10-16','02.48.65.37.57','06.78.42.41.20',NULL,'14 rue jean simon','','','14000','CAEN',NULL,NULL,'2391014171001',1704.000000000,'1962-08-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (239,'BARRIERE','PATRICIA','1934-11-08','02.77.72.00.42','06.33.03.50.87',NULL,'village de l''eglise','','','14630','FRENOUVILLE',NULL,NULL,'1341137101001',30.000000000,'1956-10-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (240,'GUILLEMETTE','BERNARD','1931-01-05','02.12.02.27.35','06.14.73.44.56',NULL,'POIX','','','14000','CAEN',NULL,NULL,'2310114370001',108.000000000,'1959-05-08','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (241,'MARTY','GENEVIEVE','1959-02-11','02.75.33.41.59','06.58.63.77.14',NULL,'25 rue des jonchets','','','14500','VIRE',NULL,NULL,'1590250376001',23.000000000,'1982-06-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (242,'LOPES DOS SANTOS','ANDREE','1961-01-12','02.89.68.09.31','06.44.40.43.56',NULL,'LE BOURG','','','14210','BARON SUR ODON',NULL,NULL,'2610114092001',1050.000000000,'1984-05-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (243,'LACROIX','ANNE MARIE','1961-04-01','02.53.90.85.39','06.72.17.91.10',NULL,'RESIDENCE LA ROSERAIE 28 RUE DU',' MANOIR','','14540','BOURGUEBUS',NULL,NULL,'1610414455001',121.000000000,'1983-12-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (244,'MOTEL','JEAN-PAUL','1935-06-23','02.50.69.95.50','06.11.38.60.66',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'2350614218001',27.000000000,'1957-07-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (245,'PAILLARD','PATRICK',NULL,'02.18.14.67.10','06.80.50.18.89',NULL,'15 AV DE NORMANDIE','','','14120','MONDEVILLE',NULL,NULL,'1340450397001',168.000000000,'2007-12-01','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (246,'RENARD','GILLES','1957-02-05','02.10.92.45.46','06.28.09.87.83',NULL,'5 rue chanoine levasseur','','','14120','MONDEVILLE',NULL,NULL,'1570214628001',35.000000000,'1978-02-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (247,'RUBELT','GISELE','1957-04-21','02.47.67.44.22','06.10.59.02.06',NULL,'CAO 4 rue Guilbert','','','14123','IFS',NULL,NULL,'1570499255001',2948.000000000,'1981-10-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (248,'LESAGE','CLAUDINE','1941-01-27','02.30.07.39.88','06.11.22.36.08',NULL,'80 rue de Rouen Cour des acacias','','','14000','CAEN',NULL,NULL,'2410114125001',57.000000000,'1970-07-24','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (249,'LECONTE','MAURICE',NULL,'02.74.63.18.43',NULL,NULL,'16 RUE DE L EGALITE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1460514721001',162.000000000,'2013-05-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (250,'POULAIN','EUGENE','1935-01-14','02.36.36.65.80','06.48.54.08.89',NULL,'','','','14370','BELLENGREVILLE',NULL,NULL,'1350114486001',210.000000000,'1961-07-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (251,'LAZARD','MARIE MADELEINE','1936-02-17','02.63.70.63.28','06.95.32.80.75',NULL,'22 rue guillaume le conquerant','','','14320','MAY SUR ORNE',NULL,NULL,'1360214114001',6.000000000,'1963-01-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (252,'COURTOIS','CHRISTIANE','1933-07-05','02.10.42.90.81','06.24.88.44.97',NULL,'','','','14000','CAEN',NULL,NULL,'1330714477001',174.000000000,'1954-10-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (253,'CHAPRON','JEANINE',NULL,'02.10.71.15.45','06.11.32.19.50',NULL,'','','','14610','BASLY',NULL,NULL,'1460414588001',878.000000000,'2011-12-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (254,'VILLEROY','ODETTE','1945-03-18','02.81.75.67.83','06.88.54.00.39',NULL,'','','','14860','RANVILLE',NULL,NULL,'1450314181001',6.000000000,'1969-10-31','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (255,'BOISNEL','MARIE CLAIRE','1932-06-12','02.24.61.64.73','06.12.31.40.00',NULL,'10 rue pasteur','','','14270','MEZIDON CANON',NULL,NULL,'1320614384001',295.000000000,'1956-01-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (256,'LEROULLIER','YVONNE','1967-12-19','02.33.85.59.48','06.12.18.07.51',NULL,'','','','14710','ECRAMMEVILLE',NULL,NULL,'2671261417001',5.000000000,'1994-03-01','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (257,'','XAVIER','1940-03-06','02.33.73.01.86','06.64.34.09.36',NULL,'12 route de belengreville','','','14470','COURSEULLES SUR MER',NULL,NULL,'2400314517001',4.000000000,'1968-05-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (258,'PEZERIL','NICOLE','1930-05-14','02.70.26.89.35','06.61.38.42.11',NULL,'24 VOIE DE BIERE','','','14480','CREULLY',NULL,NULL,'2300527641001',80.000000000,'1951-02-09','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (259,'JARRY','ODETTE','1941-01-16','02.71.82.93.06','06.79.33.65.68',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2410114553001',760.000000000,'1971-02-03','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (260,'FLOCH','THIERRY','1975-02-10','02.11.25.39.16','06.26.55.10.11',NULL,'','','','14190','URVILLE',NULL,NULL,'2750250031001',160.000000000,'1996-04-25','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (261,'LE NOEL','MARIE LEONIE','1968-03-17','02.97.04.49.34','06.79.82.64.05',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1680314589001',3219.000000000,'1991-10-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (262,'CHICHUA','DAVID','1958-02-21','02.92.18.46.03','06.31.69.00.02',NULL,'','','','14220','MUTRECY',NULL,NULL,'2580214114001',78.000000000,'1983-09-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (263,'NIARD','REJANE','1959-09-05','02.74.89.98.05',NULL,NULL,'(131 avenue de guynemer) SDF!!!!','!!!!!!','','14670','TROARN',NULL,NULL,'1590914075001',32.000000000,'1984-01-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (264,'LEMASSON','SERGE','1942-01-09','02.18.59.58.33','06.26.23.11.64',NULL,'','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1420114744001',762.000000000,'1967-08-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (265,'DUCHESNE','Andre',NULL,'02.61.69.50.34','06.25.03.27.60',NULL,'128 RUE DE LA DELIVRANDE','','','14111','LOUVIGNY',NULL,NULL,'2290778689001',145.000000000,'2008-08-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (266,'CHARPIOT','ANDRE','1928-09-09','02.77.78.63.41','06.72.67.15.66',NULL,'14 rue du stade','','','14000','CAEN',NULL,NULL,'2280914008001',63.000000000,'1950-02-24','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (267,'MARQUE','JOEL','1930-06-23','02.36.95.46.79','06.12.23.10.67',NULL,'4 RUE DE LA CHENEVOTTE','','','14400','BAYEUX',NULL,NULL,'2300614623001',22.000000000,'1955-01-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (268,'ANDRISIK','GENEVIEVE','1959-03-23','02.30.26.33.49','06.11.47.05.26',NULL,'HAMEAU DE LA HOGUE','','','14270','MEZIDON CANON',NULL,NULL,'1590314413001',8.000000000,'1989-12-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (269,'BAGDASARIAN','SIMONE','1967-04-22','02.80.35.75.23','06.69.81.58.84',NULL,'26 RUE DE LA RESISTANCE','','',NULL,NULL,NULL,NULL,'1670414668001',8.000000000,'1997-10-22','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (270,'LESIEUR','GUSTAVE','1934-07-17','02.30.27.12.28','06.54.96.96.13',NULL,'','','',NULL,NULL,NULL,NULL,'2340772044001',103.000000000,'1962-12-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (271,'BROSSARD','PIERRE','1933-07-09','02.55.54.32.26','06.12.23.51.24',NULL,'','','',NULL,NULL,NULL,NULL,'2330750494001',39.000000000,'1963-06-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (272,'ALBA','PAULETTE','1943-01-30','02.38.95.84.88','06.43.32.85.97',NULL,'','','','14000','CAEN',NULL,NULL,'1430114249001',1507.000000000,'1965-09-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (273,'LE ROUX','LILIANE','1932-03-06','02.58.72.90.15','06.12.31.17.18',NULL,'80 BD LEROY','','','14150','OUISTREHAM',NULL,NULL,'2320314437001',1327.000000000,'1961-09-30','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (274,'VINCENT','JEAN LOU','1932-03-04','02.97.10.62.15','06.62.28.83.33',NULL,'12 allee de l''alberta','','','14000','CAEN',NULL,NULL,'1320361482001',14.000000000,'1957-11-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (275,'MARIE','CAROLE',NULL,'02.10.17.57.08','06.65.55.87.07',NULL,'','','',NULL,NULL,NULL,NULL,'2390914266001',1053.000000000,'2007-12-31','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (276,'ROBERT','JEAN LOUIS','1955-02-21','02.10.14.66.14','06.63.82.94.77',NULL,'34 RUE DES SABLONNETTES','','','14250','TILLY SUR SEULLES',NULL,NULL,'1550214254001',3279.000000000,'1976-05-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (277,'DESLOGES','carole','1938-04-11','02.11.57.13.03','06.93.23.25.60',NULL,'19 b rue albert souboule','','','14100','LISIEUX',NULL,NULL,'1380450160001',23.000000000,'1961-02-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (278,'SUR','ANDREE','1929-09-05','02.58.59.00.95','06.55.66.05.50',NULL,'10 rue des jardins','','','50130','OCTEVILLE',NULL,NULL,'2290914594001',83.000000000,'1958-01-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (279,'PERRELLE','Jacqueline','1934-03-20','02.66.94.33.59','06.21.54.74.92',NULL,'','','','14730','GIBERVILLE',NULL,NULL,'1340314181001',33.000000000,'1958-04-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (280,'BRICET','JULIEN','1943-05-18','02.63.21.72.65','06.13.35.39.30',NULL,'','','','14123','IFS',NULL,NULL,'1430578158001',421.000000000,'1972-01-11','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (281,'GISZLER','CLAUDE','1939-07-14','02.34.39.58.32','06.77.96.30.83',NULL,'15 RUE DE LA FONTAINE','','','14730','GIBERVILLE',NULL,NULL,'2390714437001',36.000000000,'1965-06-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (282,'DEMESTRE','CLAUDE',NULL,'02.80.20.83.38','06.29.82.15.37',NULL,'','','','14000','CAEN',NULL,NULL,'1310686273001',20.000000000,'2012-09-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (283,'BEEUWSAERT','FRANCINE','1949-01-24','02.78.08.37.16','06.54.53.30.87',NULL,'','','','14123','IFS',NULL,NULL,'1490150503001',27.000000000,'1971-09-07','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (284,'RIVOGNAC','RENE','1938-11-23','02.11.11.59.99','06.61.05.22.31',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'2381114138001',69.000000000,'1963-02-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (285,'MORIN','VERONIQUE','1933-11-02','02.10.01.47.62','06.35.11.62.63',NULL,'172 rue caponiere','','','14123','IFS',NULL,NULL,'1331114226001',2704.000000000,'1957-01-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (286,'LEPELTIER','GUY','1929-07-08','02.11.81.39.41','06.19.87.99.26',NULL,'14 rue des verts pres','','','14430','CRESSEVEUILLE',NULL,NULL,'1290760353001',1231.000000000,'1959-02-19','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (287,'BARBANCHON','MICHELINE','1939-08-03','02.13.07.98.94','06.11.15.69.14',NULL,'20 rue ch peggy','','','50500','ST HILAIRE PETITVILLE',NULL,NULL,'2390814332001',731.000000000,'1968-07-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (288,'DESMONTS','CLAUDE','1960-03-25','02.90.54.62.29','06.72.46.17.08',NULL,'','','','14000','CAEN',NULL,NULL,'1600350371001',199.000000000,'1988-03-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (289,'MADELAINE','AGNES','1962-03-20','02.56.43.93.48','06.16.31.67.38',NULL,'','','','14430','DOZULE',NULL,NULL,'1620350365001',1848.000000000,'1983-08-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (290,'MALLET','GERARD','1962-05-08','02.12.18.01.69','06.29.70.88.85',NULL,'LE LONDE','','','14420','VILLERS CANIVET',NULL,NULL,'2620514278001',539.000000000,'1988-11-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (291,'TRESGOTS','Nicole','1933-03-01','02.57.81.06.33','06.59.96.14.29',NULL,'5 RUE DU LAVOIR','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1330314422001',114.000000000,'1963-10-29','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (292,'HAMARD','GENEVIEVE','1959-12-21','02.16.43.82.13','06.39.47.08.41',NULL,'','','','14110','CONDE SUR NOIREAU',NULL,NULL,'1591214531001',39.000000000,'1984-04-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (293,'BISSON','MARIE LOUISE','1934-12-30','02.24.48.66.38','06.11.67.75.45',NULL,'','','','14220','THURY HARCOURT',NULL,NULL,'1341214702001',23.000000000,'1957-02-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (294,'BISSON','OCTAVIE','1938-01-11','02.67.50.46.07','06.11.66.51.15',NULL,'','','','14123','IFS',NULL,NULL,'1380114207001',857.000000000,'1962-02-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (295,'MAURICE','PHILIPPE','1913-01-07','02.11.07.29.95','06.81.49.24.89',NULL,'','','','14123','FLEURY SUR ORNE',NULL,NULL,'1130133243001',36.000000000,'1934-04-12','GOLD',24,1);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (296,'MARIE','GERARD','1939-05-22','02.12.10.07.81','06.30.24.73.53',NULL,'903 QUARTIER DU VAL','','','14990','BERNIERES SUR MER',NULL,NULL,'1390550300001',82.000000000,'1962-09-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (297,'PASCAL','PHILIPPE','1964-03-19','02.25.74.64.72',NULL,NULL,'2 rue des marchands','','','14123','FLEURY SUR ORNE',NULL,NULL,'2640314134001',420.000000000,'1994-06-27','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (298,'L HOSTIS','PIERRE','1957-03-01','02.59.80.58.24','06.38.80.31.99',NULL,'','','','14400','ST VIGOR LE GRAND',NULL,NULL,'2570314454001',63.000000000,'1978-05-31','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (299,'GELINAUD','GERMAINE','1968-10-31','02.11.84.15.03','06.30.31.28.98',NULL,'6 RUE ALEXANDRE DRIA','','',NULL,NULL,NULL,NULL,'2681095063001',3233.000000000,'1990-11-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (300,'KOTOWSKI','ODETTE','1938-07-06','02.90.17.04.17','06.56.53.21.57',NULL,'16 rue juliot curie','','',NULL,NULL,NULL,NULL,'1380708497001',377.000000000,'1961-02-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (301,'','GEORGES','1937-06-07','02.33.00.22.58','06.44.47.26.56',NULL,'','','',NULL,NULL,NULL,NULL,'2370614025001',810.000000000,'1961-01-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (302,'DROUET','ARMAND','1932-08-26','02.30.45.45.57','06.18.97.05.76',NULL,'8 RUE DE LA TUILERIE','','','14123','IFS',NULL,NULL,'1320850504001',88.000000000,'1957-11-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (303,'LESIEUR','JANINE','1951-01-01','02.56.61.62.25','06.70.92.06.32',NULL,'la grande bruyere','','','14710','RUSSY',NULL,NULL,'2510161332001',92.000000000,'1978-01-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (304,'AUVRAY','BERNARD','1959-02-27','02.23.43.12.74',NULL,NULL,'','','','14000','CAEN',NULL,NULL,'2590214034001',2477.000000000,'1982-12-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (305,'LE COGUIC','Andre','1928-01-14','02.10.51.43.25','06.11.78.76.47',NULL,'60 place champlain','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2280114346001',189.000000000,'1958-09-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (306,'ROULET','PIERRE','1945-06-01','02.41.38.60.62','06.99.54.00.06',NULL,'20 rue du chateau d''eau','','','14160','DIVES SUR MER',NULL,NULL,'2450661505001',645.000000000,'1975-12-13','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (307,'LETELLIER','MICHEL','1935-10-05','02.81.14.39.31','06.38.78.49.66',NULL,'','','',NULL,NULL,NULL,NULL,'1351014138001',19.000000000,'1959-10-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (308,'CATHERINE','GISELE','1929-06-02','02.51.47.01.91','06.25.22.15.54',NULL,'4 IMPASSE DES POMMIERS','','',NULL,NULL,NULL,NULL,'1290614319001',358.000000000,'1950-03-30','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (309,'DREAN','LOUISE','1938-06-23','02.15.80.56.43','06.10.75.99.60',NULL,'CITE UNIVERSITAIRE LE BISEY BAT','NORD 2 CHAMBRE  229','',NULL,NULL,NULL,NULL,'1380650166001',1.000000000,'1968-12-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (310,'GODARD','LEON','1950-01-28','02.27.76.73.71','06.90.96.83.50',NULL,'18 RUE LECONTE','','','14000','CAEN',NULL,NULL,'1500114355001',236.000000000,'1975-11-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (311,'TABOUREL','BERNARD','1958-09-02','02.41.98.29.00','06.49.61.92.23',NULL,'8 RUE JULES VERNE','','',NULL,NULL,NULL,NULL,'1580914005001',37.000000000,'1979-07-31','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (312,'GOUVAZE','ANDRE','1970-03-13','02.26.34.44.44','06.47.19.38.22',NULL,'2 rue jean zay','','',NULL,NULL,NULL,NULL,'2700327050001',979.000000000,'1994-10-17','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (313,'MARESQ','OCTAVE','1935-01-26','02.14.10.09.45','06.69.18.04.75',NULL,'2 rue du clos st mathieu','','','14320','FONTENAY LE MARMION',NULL,NULL,'2350114678001',43.000000000,'1961-02-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (314,'VIGAN','MICHEL','1951-01-31','02.44.91.34.49','06.23.70.76.97',NULL,'24 RUE D''ARDENNES','','','14540','CONTEVILLE',NULL,NULL,'2510150564001',47.000000000,'1979-02-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (315,'MARIE','CATHERINE','1938-02-04','02.87.59.01.23','06.10.06.76.47',NULL,'2 rue henri davoisne','','',NULL,NULL,NULL,NULL,'2380214123001',716.000000000,'1962-05-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (316,'POISSON BAILLY','MARC','1966-10-27','02.19.92.19.35','06.32.56.56.60',NULL,'route de st pierre sur dives','','','14140','LIVAROT',NULL,NULL,'2661014145001',15.000000000,'1996-06-15','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (317,'GOST','FERNAND','1938-01-05','02.31.96.01.25','06.83.24.26.48',NULL,'6 RUE GUSTAVE FLAUBERT','','','14730','GIBERVILLE',NULL,NULL,'1380114332001',38.000000000,'1967-12-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (318,'JARLAUD','georges','1945-09-14','02.29.23.25.90','06.40.44.61.29',NULL,'6 rue Mesnil Vitey','','',NULL,NULL,NULL,NULL,'1450914749001',114.000000000,'1966-09-01','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (319,'GUILBERT','JOSIANE','1932-02-12','02.59.97.58.82','06.26.40.87.83',NULL,'17 SQUARE LOUIS DUBOSQ','','',NULL,NULL,NULL,NULL,'1320214520001',5220.000000000,'1959-03-13','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (320,'BROCHARD','ERIC','1937-07-26','02.10.54.41.95','06.23.22.66.79',NULL,'86 RUE DES LUTHIERS','','','14460','COLOMBELLES',NULL,NULL,'1370714291001',91.000000000,'1964-06-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (321,'LE GOFF','RAYMONDE','1941-01-19','02.57.78.07.72','06.66.61.39.11',NULL,'27 RUE PAUL CLAUDEL','','','14680','GOUVIX',NULL,NULL,'2410161186001',153.000000000,'1970-08-08','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (322,'DILASSER','LIONEL','1928-02-14','02.77.32.98.19','06.49.14.90.01',NULL,'','','','14540','POUSSY LA CAMPAGNE',NULL,NULL,'2280277178001',623.000000000,'1951-03-24','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (323,'LAMER','CLAUDE','1929-08-25','02.59.94.09.78','06.81.70.74.36',NULL,'','','','61380','SOLIGNY LA TRAPPE',NULL,NULL,'2290814470001',2538.000000000,'1953-12-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (324,'TISON','Remy','1958-07-17','02.26.54.70.74',NULL,NULL,'5 RESIDENCE  DES FONTAINES','','','14320','MAY SUR ORNE',NULL,NULL,'1580714581001',138.000000000,'1982-08-23','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (325,'TISON','DANIEL','1938-03-18','02.33.55.01.38','06.41.72.41.72',NULL,'9 RUE DU PAVILLON','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'1380359252001',1379.000000000,'1968-05-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (326,'WYTROWA','JEANNINE','1936-08-30','02.12.86.24.46','06.65.99.57.99',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'2360861339001',34.000000000,'1958-07-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (327,'LACROIX','JEANINNE','1931-05-11','02.35.41.55.80','06.26.24.56.47',NULL,'','','',NULL,NULL,NULL,NULL,'2310528285001',18.000000000,'1952-10-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (328,'ODIENNE','ANDRE','1961-03-30','02.65.65.80.01','06.10.41.49.75',NULL,'23 RUE J PREVERT','','','14000','CAEN',NULL,NULL,'1610314651001',30.000000000,'1982-02-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (329,'LE MAITRE','Jean pierre','1936-09-23','02.93.12.17.15','06.53.89.93.25',NULL,'','','','14240','CAUMONT L''EVENTE',NULL,NULL,'2360914229001',0.000000000,'1963-03-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (330,'AMAND','Jeannine','1958-04-06','02.26.57.78.78','06.55.04.13.70',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'2580414537001',492.000000000,'1983-09-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (331,'FASOLI','MARCEL','1917-02-01','02.78.49.77.99','06.18.52.18.31',NULL,'','','','14000','CAEN',NULL,NULL,'2170236101001',43.000000000,'1941-09-13','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (332,'JOUVE','MICHEL',NULL,'02.24.24.61.79','06.57.50.67.52',NULL,'19 residence le bois de la couli','niere','','50620','ST FROMOND',NULL,NULL,'1480314421001',42.000000000,'2012-10-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (333,'','SOLANGE','1935-08-01','02.18.85.27.28','06.11.76.82.84',NULL,'','','','61400','LA CHAPELLE MONTLIGEON',NULL,NULL,'1350861139001',186.000000000,'1960-03-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (334,'JOUANNE','ODETTE','1941-04-03','02.11.48.84.40','06.20.60.80.22',NULL,'20/1 RUE DES BLEUETS','','','14370','ARGENCES',NULL,NULL,'1410431069001',48.000000000,'1966-07-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (335,'LEPRAEL','MARCEL','1940-06-13','02.67.58.42.33','06.29.87.69.59',NULL,'20/1 RUE DES BLEUETS','','','14370','ARGENCES',NULL,NULL,'2400653127001',94.000000000,'1963-02-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (336,'LEHONGRE','MIREILLE','1939-10-13','02.94.66.76.91','06.10.22.43.89',NULL,'','','','50110','TOURLAVILLE',NULL,NULL,'1391050356001',182.000000000,'1965-05-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (337,'MARIE','BRIGITTE','1941-01-23','02.10.08.82.27','06.26.93.17.12',NULL,'5 rue de l abbaye','','','14123','FLEURY SUR ORNE',NULL,NULL,'1410150265001',37.000000000,'1963-06-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (338,'AMAURY','ABEL','1950-04-27','02.82.32.24.24','06.12.30.22.86',NULL,'19 rue du pere samson','','','14000','CAEN',NULL,NULL,'1500414356001',879.000000000,'1973-08-14','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (339,'BODY','YOLANDE','1942-05-30','02.36.19.63.91','06.14.66.00.05',NULL,'25 bis av pere charles de foucau','lt','','14000','CAEN',NULL,NULL,'1420578398001',66.000000000,'1966-06-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (340,'LEPETIT','BERNARD','1934-09-27','02.54.91.93.36','06.86.10.50.23',NULL,'42 rue du milieux','','','14123','IFS',NULL,NULL,'2340914247001',225.000000000,'1960-08-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (341,'BENOIST','GERARD','1934-07-27','02.14.67.90.43','06.54.91.40.07',NULL,'','','','14000','CAEN',NULL,NULL,'2340714659001',16.000000000,'1958-04-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (342,'PIVET','MONIQUE','1968-09-06','02.59.26.85.47','06.67.45.86.81',NULL,'1 E ROGER POULAIN','','',NULL,NULL,NULL,NULL,'1680927681001',895.000000000,'1993-03-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (343,'DUMAS','LIONEL','1937-06-03','02.22.55.90.46','06.74.10.91.44',NULL,'66 RUE DU MARAIS','','',NULL,NULL,NULL,NULL,'1370614497001',181.000000000,'1959-02-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (344,'DUMONT','CHRISTIANE','1954-04-17','02.65.87.95.95','06.69.10.25.24',NULL,'31 RUE DU MABREY','','','14000','CAEN',NULL,NULL,'1540461417001',33.000000000,'1977-11-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (345,'DUMONT','AUGUSTE','1932-08-04','02.51.99.39.64','06.30.29.49.91',NULL,'4 rue du boulhoullay','','','14000','CAEN',NULL,NULL,'1320814432001',258.000000000,'1955-05-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (346,'','JANINE','1936-06-05','02.43.66.38.66','06.10.33.27.77',NULL,'','','','14123','IFS',NULL,NULL,'1360662393001',105.000000000,'1960-01-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (347,'WISS','JEAN','1929-11-21','02.54.75.84.97','06.60.28.85.31',NULL,'48 RUE DU CANADA','','',NULL,NULL,NULL,NULL,'1291114735001',15.000000000,'1951-10-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (348,'CLEMENCE','CATHERINE','1932-03-22','02.38.99.83.32','06.64.35.22.89',NULL,'48 RUE DU CANADA','','','50760','ANNEVILLE EN SAIRE',NULL,NULL,'1320314076001',2550.000000000,'1962-05-21','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (349,'SUAZE','ALFRED','1932-11-04','02.80.77.33.83','06.42.10.37.80',NULL,'','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2321161402001',2.000000000,'1955-12-25','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (350,'MAURAND','olivier','1932-02-28','02.48.36.02.80','06.71.08.39.62',NULL,'','','',NULL,NULL,NULL,NULL,'2320261283001',71.000000000,'1962-09-21','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (351,'LEMONNIER','NICOLE','1934-10-17','02.94.57.47.33','06.17.75.95.42',NULL,'','','',NULL,NULL,NULL,NULL,'1341014431001',782.000000000,'1964-12-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (352,'GRENET','SYLVAIN','1941-01-28','02.24.63.45.36','06.95.52.66.89',NULL,'5 RUE DE LA QUERRIERE AU ROSSIGN','OL','',NULL,NULL,NULL,NULL,'1410114268001',1036.000000000,'1966-09-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (353,'RAVEAU','DANIEL','1966-06-13','02.67.16.39.95','06.37.65.18.07',NULL,'6 rue de martinville','','',NULL,NULL,NULL,NULL,'1660614046001',39.000000000,'1996-12-16','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (354,'CATHERINE','JACQUELINE','1928-04-15','02.72.94.22.22','06.10.30.64.10',NULL,'','','','14370','BELLENGREVILLE',NULL,NULL,'2280450523001',171.000000000,'1952-07-14','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (355,'PIERRE','ROBERT','1931-10-20','02.78.61.00.05','06.66.66.58.75',NULL,'','','','14740','ST MANVIEU NORREY',NULL,NULL,'1311014119001',164.000000000,'1952-10-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (356,'REBOURS','GABRIEL','1935-06-05','02.93.90.31.28','06.35.24.96.25',NULL,'','','','14360','TROUVILLE SUR MER',NULL,NULL,'2350650440001',92.000000000,'1957-11-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (357,'DUPONT','JACQUES','1929-04-27','02.36.39.90.63','06.33.69.53.09',NULL,'17 RUE DE L AUBEPINE','','','14000','CAEN',NULL,NULL,'1290414027001',1593.000000000,'1951-06-17','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (358,'BURIN','CELINE','1928-02-24','02.11.31.08.36','06.10.69.47.07',NULL,'','','','14320','FONTENAY LE MARMION',NULL,NULL,'1280214042001',91.000000000,'1953-04-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (359,'LECARDONNEL','Josiane','1920-01-15','02.10.14.86.31','06.93.58.72.72',NULL,'8 rue mac mahon','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1200114655001',11.000000000,'1943-10-20','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (360,'NEEL','Emile','1941-08-29','02.11.84.72.56','06.78.38.32.81',NULL,'5 RUE JACQUES PREVERT','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2410814733001',227.000000000,'1967-09-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (361,'LESEUR','ANNICK','1931-03-02','02.11.01.61.52','06.11.72.64.58',NULL,'','','',NULL,NULL,NULL,NULL,'2310314412001',1421.000000000,'1952-06-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (362,'COSTARD','MAURICETTE','1944-01-20','02.31.24.14.79','06.52.50.94.76',NULL,'','','','93390','CLICHY SOUS BOIS',NULL,NULL,'2440161081001',83.000000000,'1969-04-28','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (363,'CHANTEPIE','GINETTE','1930-02-08','02.75.07.86.28','06.55.79.64.26',NULL,'6 LE CLOS DE BULLY','','','14160','DIVES SUR MER',NULL,NULL,'2300229045001',484.000000000,'1953-11-16','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (364,'LEMARCHAND','ANDREE','1934-01-12','02.28.77.30.54','06.55.53.87.93',NULL,'','','',NULL,NULL,NULL,NULL,'2340150261001',805.000000000,'1960-07-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (365,'LALLEMAND','ALAIN','1964-01-28','02.32.84.51.39','06.10.68.94.99',NULL,'341 BD DE GRAVILLE','','',NULL,NULL,NULL,NULL,'2640161293001',152.000000000,'1990-10-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (366,'QUESNEL','ALINE','1937-08-11','02.29.45.38.80','06.11.01.90.09',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1370814724001',16.000000000,'1962-04-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (367,'DENIS','henri','1930-07-10','02.44.84.78.00','06.30.06.44.27',NULL,'7 impasse leo ferre','','','14190','OUILLY LE TESSON',NULL,NULL,'1300714047001',8.000000000,'1960-09-15','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (368,'ROBINE','LOUIS','1933-03-11','02.36.93.74.32',NULL,NULL,'','','',NULL,NULL,NULL,NULL,'1330314483001',562.000000000,'1957-08-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (369,'ROBINE','NATHALIE','1933-04-01','02.10.77.65.37','06.55.21.04.28',NULL,'20 ROUTE DE CAEN','','',NULL,NULL,NULL,NULL,'2330414069001',12.000000000,'1956-12-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (370,'ALEXANDRE','JACQUELINE','1957-03-14','02.31.98.11.22','06.45.44.54.62',NULL,'','','','14230','ISIGNY SUR MER',NULL,NULL,'1570314568001',91.000000000,'1981-02-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (371,'GABRIEL','THIERRY','1929-05-30','02.41.19.05.94','06.11.88.87.58',NULL,'','','','14670','TROARN',NULL,NULL,'1290514679001',422.000000000,'1951-09-29','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (372,'LEMENUEL','GERARD','1944-10-26','02.29.65.15.71','06.25.56.76.73',NULL,'2 Alle des Meliers','','','14120','MONDEVILLE',NULL,NULL,'2441014208001',163.000000000,'1970-01-09','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (373,'LE GOUPILLOT','BERNARD','1938-02-09','02.39.60.43.04','06.33.95.29.91',NULL,'2 ALLEE DES MELIERS chez mme Ge','lato','','14000','CAEN',NULL,NULL,'2380214610001',40.000000000,'1963-04-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (374,'MOINS','VALERIE','1968-09-29','02.72.18.82.59','06.83.87.92.28',NULL,'','','',NULL,NULL,NULL,NULL,'1680927681001',788.000000000,'1992-08-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (375,'MELIN','CHRISTIANE','1945-01-27','02.49.52.17.12','06.42.40.00.13',NULL,'','','','14540','BOURGUEBUS',NULL,NULL,'1450149342001',208.000000000,'1968-07-31','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (376,'FOSSEY','PAULETTE','1965-11-03','02.10.67.17.31','06.85.09.71.87',NULL,'','','',NULL,NULL,NULL,NULL,'2651114578001',77.000000000,'1986-10-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (377,'NICOLLE','GINETTE','1959-03-13','02.91.21.48.14','06.74.74.89.75',NULL,'11 place des bleuts','','','14000','CAEN',NULL,NULL,'2590350363001',5131.000000000,'1987-07-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (378,'VASNIER','ROGER','1933-02-23','02.60.54.48.31','06.44.74.80.84',NULL,'2 place andre schoeff','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1330214174001',647.000000000,'1963-07-11','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (379,'FREMONT','BRIGITTE','1932-11-28','02.12.25.98.19','06.56.93.57.18',NULL,'24 RUE DE L ANCIENNE GARE','','',NULL,NULL,NULL,NULL,'2321150025001',41.000000000,'1954-08-17','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (380,'SENTILLY','CHRISTINE','1964-08-05','02.21.91.29.37','06.20.10.68.04',NULL,'322 LES BELLES PORTES','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1640814430001',2325.000000000,'1989-01-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (381,'TOURNIERE','LUCIEN','1936-04-01','02.57.52.23.69','06.47.67.55.25',NULL,'50 route de gouvix','','','14370','VIMONT',NULL,NULL,'1360414327001',78.000000000,'1958-02-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (382,'HAMON','GENEVIEVE','1937-10-11','02.51.03.90.34','06.65.45.48.82',NULL,'LA LANDE','','','14270','VIEUX FUME',NULL,NULL,'2371086137001',38.000000000,'1964-03-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (383,'HEUZE','MARIE','1947-01-25','02.11.49.18.85','06.10.09.40.06',NULL,'4 MOISSY','','','14700','ST MARTIN DE MIEUX',NULL,NULL,'2470150289001',12.000000000,'1971-07-20','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (384,'LELOGEAIS','JEAN','1953-03-31','02.76.29.84.72','06.77.36.25.36',NULL,'2 RESIDENCE  DU BOCAGE','','',NULL,NULL,NULL,NULL,'1530314305001',3.000000000,'1982-03-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (385,'DUMONT','PIERRE','1952-03-27','02.51.11.93.23','06.94.34.83.95',NULL,'XXXXXXXXXXXXXXXXXXX','','',NULL,NULL,NULL,NULL,'1520314164001',1055.000000000,'1982-07-31','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (386,'RENEE','JEANNE','1934-01-28','02.70.76.26.35','06.28.17.85.86',NULL,'12 RUE DE LA GARENNE','','','75015','PARIS 15',NULL,NULL,'1340150559001',79.000000000,'1961-08-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (387,'GABRIEL','JEAN LOUIS','1940-10-01','02.37.63.34.31','06.31.25.86.27',NULL,'7-5 RUE DU BOIS','','','14940','TOUFFREVILLE',NULL,NULL,'2401014277001',15.000000000,'1965-05-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (388,'SEBERT','ETIENNE','1945-01-29','02.10.74.75.22',NULL,NULL,'CHEMIN DU MARAIS','','','14123','IFS',NULL,NULL,'1450114406001',8.000000000,'1974-05-15','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (389,'LEREVEREND','GHISLAINE','1938-02-13','02.41.45.48.55','06.11.10.53.89',NULL,'rue de picardie','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2380261076001',7.000000000,'1964-10-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (390,'DOUCHIN','JOELLE','1932-05-29','02.88.60.70.18','06.48.47.41.48',NULL,'21 RUE SAINT MARTIN','','','14120','MONDEVILLE',NULL,NULL,'1320514542001',953.000000000,'1954-03-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (391,'JEAN MARIE','JACKY','1938-03-28','02.40.20.70.43','06.67.66.52.54',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1380314472001',2317.000000000,'1968-07-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (392,'BOUTELOUP','ALCIDE','1988-02-05','02.93.41.83.42','06.78.00.09.83',NULL,'2 IMPASSE DES GLAIEULS','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1880299344001',450.000000000,'2010-02-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (393,'DESLOGES','pierre','1959-07-16','02.56.50.29.88','06.10.75.09.52',NULL,'6 RUE DE LA BRUYERE','','','50390','ST JACQUES DE NEHOU',NULL,NULL,'2590714157001',26.000000000,'1981-02-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (394,'BAYEUX','THERESE','1934-05-23','02.13.05.14.85','06.58.37.96.27',NULL,'35 RUE CHATEAU BRIAND','','','61380','STE CERONNE LES MORTAGNE',NULL,NULL,'1340514535001',50.000000000,'1957-07-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (395,'CORBET','MARIE THERESE','1920-04-06','02.47.50.17.18','06.11.55.42.61',NULL,'5 bis impasse du manoir','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2200432305001',168.000000000,'1947-07-12','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (396,'PEDELOUP','DAVID','1924-10-29','02.35.38.04.53','06.23.21.21.72',NULL,'13 rue des grandes patures','','','14270','CESNY AUX VIGNES OUEZY',NULL,NULL,'2241003310001',1025.000000000,'1950-03-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (397,'VICTOR','GEORGES','1941-01-27','02.70.89.27.94','06.61.59.47.30',NULL,'903 QUARTIER DU VAL','','','14360','TROUVILLE SUR MER',NULL,NULL,'2410150558001',2.000000000,'1962-10-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (398,'LEGRAND','CHRISTINE','1935-12-09','02.51.64.27.15','06.81.52.32.90',NULL,'3 2 ALLEE DES CAPUCINES','','',NULL,NULL,NULL,NULL,'1351250215001',97.000000000,'1957-07-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (399,'MARIE','GENEVIEVE','1955-06-05','02.91.41.80.52','06.83.46.06.87',NULL,'LA HOUSSAYE','','','14123','IFS',NULL,NULL,'1550614086001',87.000000000,'1984-02-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (400,'ROGUELIN','JEAN','1958-02-11','02.46.49.44.64','06.37.27.27.51',NULL,'le bourg','','','14670','TROARN',NULL,NULL,'1580214396001',77.000000000,'1979-04-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (401,'PEAN','CLAUDE','1938-04-27','02.28.29.40.43','06.11.96.63.47',NULL,'23 bis bvd leroy','','','14000','CAEN',NULL,NULL,'2380414012001',34.000000000,'1962-07-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (402,'RADIGUET','JACQUES','1958-02-26','02.11.76.33.17','06.66.08.75.10',NULL,'10- 2 avenue du rond point','','','14670','TROARN',NULL,NULL,'2580214331001',188.000000000,'1988-09-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (403,'MORISSET','ALBERT','1939-04-09','02.10.60.65.53','06.90.11.22.45',NULL,'chemin des bruyeres','','','14730','GIBERVILLE',NULL,NULL,'1390414342001',408.000000000,'1963-04-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (404,'GODEAU','ALAIN','1930-06-11','02.88.90.03.99','06.18.39.49.29',NULL,'4 rue des freres vigouroux','','',NULL,NULL,NULL,NULL,'1300650194001',6.000000000,'1953-05-02','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (405,'CAPELLO','EDDY','1938-09-05','02.12.67.59.79','06.16.10.42.46',NULL,'5 RUE DU BOIS','','','14370','VIMONT',NULL,NULL,'2380914158001',309.000000000,'1960-02-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (406,'LEQUESNE','JEANNINE','1956-05-10','02.41.85.55.78','06.83.49.92.66',NULL,'76 RUE DU PLESSIS TREVISE','','','14123','IFS',NULL,NULL,'1560561208001',862.000000000,'1977-08-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (407,'MAUNY','CHRISTIAN','1935-09-13','02.44.47.18.75','06.27.01.58.28',NULL,'22 RUE CAILLEMER','','','14123','IFS',NULL,NULL,'1350914046001',1018.000000000,'1958-06-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (408,'LEMONNIER','ARLETTE','1947-05-01','02.58.21.35.80','06.49.81.46.34',NULL,'RUE DE LA DIME','','',NULL,NULL,NULL,NULL,'1470578495001',1614.000000000,'1974-01-25','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (409,'HOREL','MARTHE','1929-08-31','02.12.10.55.00','06.90.73.16.38',NULL,'40 RUE DE L EGLISE','','',NULL,NULL,NULL,NULL,'2290850194001',17.000000000,'1951-09-27','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (410,'LETONDEUR','JOSETTE','1959-10-06','02.10.48.47.59','06.11.33.12.84',NULL,'89 RUE DU MARECHAL FOCH','','',NULL,NULL,NULL,NULL,'1591014517001',342.000000000,'1984-03-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (411,'HUET','claude','1940-07-30','02.19.61.15.30','06.32.33.68.22',NULL,'','','','14123','FLEURY SUR ORNE',NULL,NULL,'1400714083001',211.000000000,'1968-12-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (412,'DACHICOURT','THERESE','1933-02-21','02.62.28.69.88','06.34.39.70.03',NULL,'37 rue de normandie','','',NULL,NULL,NULL,NULL,'2330214329001',32.000000000,'1957-08-07','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (413,'PICARD','MARIE LOUISE','1950-01-13','02.85.89.59.46','06.47.27.10.86',NULL,'4 RUE DES MARCHES','','','14400','MONCEAUX EN BESSIN',NULL,NULL,'1500150185001',532.000000000,'1974-12-12','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (414,'MORIN','YVES','1934-11-08','02.12.08.43.76','06.27.72.72.18',NULL,'13 RUE GEORGES BRASSENS','','','14000','CAEN',NULL,NULL,'2341114625001',980.000000000,'1961-11-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (415,'VANNIER','tengiz','1936-11-15','02.40.13.19.89','06.38.83.04.65',NULL,'7 RUE DES CORDES','','','14111','LOUVIGNY',NULL,NULL,'2361114006001',157.000000000,'1963-04-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (416,'DUBREUIL','GINETTE','1967-04-09','02.64.62.26.00','06.99.51.21.25',NULL,'','','','14000','CAEN',NULL,NULL,'1670414537001',594.000000000,'1988-08-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (417,'MOUSSEL','JANINE','1961-01-22','02.21.71.54.50','06.56.19.51.14',NULL,'11 RUE JOSEPH DE  DELENTE','','','14670','TROARN',NULL,NULL,'2610114225001',4.000000000,'1982-06-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (418,'LANGLOIS','GUY','1933-05-30','02.18.63.68.07','06.11.77.61.33',NULL,'','','',NULL,NULL,NULL,NULL,'2330514071001',108.000000000,'1960-09-20','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (419,'DUVERLIE','','1937-05-28','02.12.12.38.61','06.70.81.48.77',NULL,'','','','14000','CAEN',NULL,NULL,'1370554067001',10.000000000,'1959-07-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (420,'CHARNY','roland','1940-05-25','02.89.02.42.22','06.13.99.83.72',NULL,'','','','14000','CAEN',NULL,NULL,'2400550312001',408.000000000,'1964-04-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (421,'RENARD','Raoul','1951-06-26',NULL,NULL,NULL,'133 RUE DES ACCACIAS','','',NULL,NULL,NULL,NULL,'2510614118001',10.000000000,'1976-02-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (422,'ADAM','Bernard','1928-06-20','02.11.72.81.76','06.18.79.59.37',NULL,'27 BD DU 13 JUIN','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2280614319001',99.000000000,'1955-09-17','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (423,'LEFAUCONNIER','Paul','1930-12-27','02.40.58.56.50','06.86.26.05.00',NULL,'16 rue antoine galland','','','14840','CUVERVILLE',NULL,NULL,'2301235022001',27.000000000,'1960-09-15','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (424,'ROUXELIN','FRANCOIS','1921-12-14','02.62.93.80.16','06.85.28.12.74',NULL,'2 RUE JACQUES BREL','','','14210','ESQUAY NOTRE DAME',NULL,NULL,'1211219090001',3.000000000,'1946-04-22','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (425,'DAUGUET','ADAM','1940-05-21','02.27.84.14.31','06.61.57.87.70',NULL,'30 rue de la republique','','',NULL,NULL,NULL,NULL,'1400510387001',515.000000000,'1969-08-14','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (426,'LECOUTURIER','MADELEINE','1939-09-18','02.53.53.00.26','06.52.46.13.00',NULL,'HAMEAU DE CAHIER','','',NULL,NULL,NULL,NULL,'2390961182001',196.000000000,'1962-05-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (427,'BESNIER','JOSIANE','1958-11-01','02.29.89.52.25','06.91.08.14.08',NULL,'la mare potier','','',NULL,NULL,NULL,NULL,'2581114118001',699.000000000,'1979-05-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (428,'LESAGE','GEORGES','1970-01-27','02.11.12.63.10','06.26.78.99.31',NULL,'HAMEAU DE NEUMER','','',NULL,NULL,NULL,NULL,'1700114020001',34.000000000,'1991-10-29','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (429,'RICHARD','DENISE','1940-11-20','02.11.63.56.60','06.88.80.82.08',NULL,'64 route de st pierre sur dives','','',NULL,NULL,NULL,NULL,'1401129083001',333.000000000,'1962-03-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (430,'MARC','GENEVIEVE','1940-10-03','02.66.00.39.77','06.75.68.90.22',NULL,'1 rue p semard','','',NULL,NULL,NULL,NULL,'2401014408001',332.000000000,'1965-04-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (431,'PRIOULT','COLETTE','1964-07-30','02.62.92.99.71','06.46.66.25.44',NULL,'3 rue des anamones','','',NULL,NULL,NULL,NULL,'1640714090001',15.000000000,'1993-01-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (432,'DUCHEMIN','YVETTE','1930-05-24','02.75.88.83.64','06.87.90.78.05',NULL,'lieu dit le mesnil gouffier','','','50000','ST LO',NULL,NULL,'1300514668001',54.000000000,'1960-08-30','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (433,'RIFFAUD','MARIE ANTOINETTE','1968-01-26','02.99.06.02.17','06.59.77.40.77',NULL,'11 rue camille blaisot','','','14123','FLEURY SUR ORNE',NULL,NULL,'2680114327001',26.000000000,'1993-02-08','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (434,'MESLIN','JEAN-JACQUES','1932-07-11','02.38.09.53.08','06.31.74.99.43',NULL,'87 rue de falaise','','','14000','CAEN',NULL,NULL,'1320714394001',646.000000000,'1957-02-01','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (435,'DESCHAMPS','MERABI','1945-01-17','02.63.75.94.03','06.48.53.12.67',NULL,'11 cite de la sucrerie','','','14320','MAY SUR ORNE',NULL,NULL,'2450114513001',4912.000000000,'1973-04-04','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (436,'ARDOIN','YVETTE','1928-02-12','02.65.24.67.89','06.39.02.65.22',NULL,'2 residence st gerbold rue forge','t','','14730','GIBERVILLE',NULL,NULL,'1280250416001',52.000000000,'1951-03-14','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (437,'GOUJON','Robert','1932-04-06','02.52.51.52.28','06.26.52.53.12',NULL,'la bourbe','','',NULL,NULL,NULL,NULL,'1320414257001',2373.000000000,'1962-04-08','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (438,'ALBA','REMI','1932-08-18','02.10.52.99.86','06.77.16.66.61',NULL,'20 RUE DES FRAISIERS','','',NULL,NULL,NULL,NULL,'2320861311001',40.000000000,'1958-07-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (439,'NICOLLE','GEORGETTE','1933-11-26','02.49.71.10.52','06.40.26.64.20',NULL,'301 QUARTIER DU VAL','','','14000','CAEN',NULL,NULL,'1331114099001',15.000000000,'1954-04-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (440,'CAR','ALAIN','1965-06-08','02.10.88.36.66','06.20.20.69.13',NULL,'11 rue de speyside balsaque','','','14000','CAEN',NULL,NULL,'1650672045001',747.000000000,'1986-05-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (441,'PATRIX','TENGIZ','1929-06-24','02.21.15.61.57','06.67.83.10.10',NULL,'route de la suisse normande','','','14000','CAEN',NULL,NULL,'1290614319001',727.000000000,'1950-03-28','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (442,'SAMOYEAU','andre','1932-04-16','02.41.10.09.10','06.77.50.94.70',NULL,'31 rue auguste lechesne','','',NULL,NULL,NULL,NULL,'1320461344001',1063.000000000,'1953-06-12','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (443,'CORDELET','ODILE','1938-07-26','02.32.35.98.62','06.91.00.48.57',NULL,'11 rue monseigneur adam','','',NULL,NULL,NULL,NULL,'1380714005001',17.000000000,'1965-10-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (444,'LEMARCHAND','','1936-02-23','02.98.88.80.89','06.72.95.36.70',NULL,'la chapelle','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1360214554001',66.000000000,'1962-07-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (445,'RONARC H','BERNARD','1957-02-09','02.96.14.77.10','06.11.47.66.75',NULL,'13 RUE PAUL THOMASSE','','',NULL,NULL,NULL,NULL,'1570217234001',396.000000000,'1980-08-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (446,'BOSCHER','BERNARD','1962-04-09','02.11.50.30.27','06.53.32.12.03',NULL,'24 allee du jeu de paume','','',NULL,NULL,NULL,NULL,'2620414133001',38.000000000,'1985-04-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (447,'BACON','CLAUDE','1929-03-17','02.48.18.01.24','06.29.65.90.40',NULL,'23 RUE TOURMALINE','','',NULL,NULL,NULL,NULL,'1290314345001',97.000000000,'1952-11-28','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (448,'LEMOISSON','CHRISTIAN','1943-01-20','02.50.76.70.32','06.10.66.13.11',NULL,'12 rue amiral courbet','','',NULL,NULL,NULL,NULL,'2430160494001',596.000000000,'1973-03-14','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (449,'LEMONNIER','CLAUDE','1966-08-28','02.25.64.04.34','06.94.31.81.04',NULL,'18 rue foch','','','14000','CAEN',NULL,NULL,'2660814323001',35.000000000,'1990-04-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (450,'BOULARD','MARIE-JOSEPHE','1932-11-13','02.99.12.83.52','06.67.92.62.42',NULL,'18 RUE DES FAUVETTES','','','14860','AMFREVILLE',NULL,NULL,'1321114341001',244.000000000,'1953-12-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (451,'HAMEL','DANIEL','1933-07-12','02.37.82.81.08','06.47.23.03.39',NULL,'2 4 imp du peintre','','',NULL,NULL,NULL,NULL,'2330761489001',658.000000000,'1957-09-18','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (452,'LE MASLE','JEAN','1940-02-28','02.11.72.52.69','06.98.81.97.21',NULL,'32 RUE DES ECOLES','','','14260','AUNAY SUR ODON',NULL,NULL,'1400214556001',95.000000000,'1961-07-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (453,'ROCANCOURT','','1935-12-26','02.31.30.59.94','06.23.35.52.29',NULL,'25 rte d''hacourt','','',NULL,NULL,NULL,NULL,'2351214592001',44.000000000,'1957-03-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (454,'BUISARD','','1928-04-13','02.79.08.54.06','06.83.17.01.93',NULL,'3 rue du lieu vautier','','',NULL,NULL,NULL,NULL,'1280450627001',33.000000000,'1952-03-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (455,'LEMOIGNE','ANDRE','1936-03-23','02.51.02.62.89','06.88.51.66.67',NULL,'les pedouzes','','',NULL,NULL,NULL,NULL,'2360327627001',1140.000000000,'1957-12-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (456,'RALLO','JEAN','1957-01-23','02.12.08.97.09','06.51.60.39.06',NULL,'53 RUE DE LA MARJOLAINE','','',NULL,NULL,NULL,NULL,'2570114714001',1734.000000000,'1981-04-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (457,'QUETIL','MICHEL','1937-06-01','02.78.49.18.00','06.85.03.34.42',NULL,'NORON LA POTRY','','',NULL,NULL,NULL,NULL,'1370676466001',40.000000000,'1959-05-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (458,'ENGUEHARD','ODILE','1940-05-26','02.42.07.22.41','06.30.30.97.40',NULL,'2AV G CLEMENCEAU','','','14000','CAEN',NULL,NULL,'1400514133001',107.000000000,'1964-03-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (459,'LEFEVRE','JEANNE','1961-06-28','02.26.92.93.77','06.39.60.72.06',NULL,'8 AV DU 43me RGT D ARTILLERIE','','',NULL,NULL,NULL,NULL,'1610614118001',191.000000000,'1990-02-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (460,'','GERARD','1937-08-16','02.90.08.67.45','06.68.11.40.63',NULL,'','','',NULL,NULL,NULL,NULL,'1370814726001',2600.000000000,'1958-06-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (461,'BARBE','ANDREE','1939-10-05','02.71.58.47.55','06.34.71.40.66',NULL,'11 RUE EMILI ZOLA','','','14370','CROISSANVILLE',NULL,NULL,'1391014162001',15.000000000,'1963-05-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (462,'DESCHAMP','GISELE','1954-10-09','02.21.01.20.28','06.68.00.16.70',NULL,'12 rue albert suel','','','14210','TOURVILLE SUR ODON',NULL,NULL,'1541014118001',878.000000000,'1983-06-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (463,'MATHISSART','SYLVIANE','1938-10-22',NULL,NULL,NULL,'6 RUE DU CLOS DE FRANCE','','',NULL,NULL,NULL,NULL,'1381014453001',11.000000000,'1962-11-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (464,'ROUSSELET','Andre','1935-10-16','02.11.07.66.98','06.99.40.59.88',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2351014098001',246.000000000,'1956-02-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (465,'DOUSSON','GERARD','1952-01-27','02.71.02.62.17','06.50.63.82.99',NULL,'','','',NULL,NULL,NULL,NULL,'1520150410001',274.000000000,'1976-01-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (466,'GUINNEBAULT','MADELEINE','1928-10-19','02.64.47.11.31','06.50.34.12.59',NULL,'17 RUE BERTHIER','','',NULL,NULL,NULL,NULL,'2281014074001',49.000000000,'1954-10-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (467,'POTIER','christophe','1939-05-28','02.22.39.94.73','06.33.89.71.71',NULL,'','','',NULL,NULL,NULL,NULL,'2390514493001',34.000000000,'1961-10-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (468,'BERRANGER','JEAN CLAUDE','1928-07-18','02.28.35.03.60','00 33 6.71.82.13.41',NULL,'70 RUE DE LA MER','','','14370','ARGENCES',NULL,NULL,'1280735271001',359.000000000,'1953-05-08','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (469,'BRANGER','FRANCOISE','1964-05-07','02.46.17.45.93','06.80.70.25.53',NULL,'1 RUE DES CHAMPS FLEURIS','','',NULL,NULL,NULL,NULL,'1640514087001',188.000000000,'1993-09-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (470,'LEMENAGER','HELENE',NULL,'02.41.50.82.52','06.39.25.51.55',NULL,'16 RUE EDMOND VILLEY DESMEZERETS','','',NULL,NULL,NULL,NULL,'2380614480001',159.000000000,'2012-10-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (471,'ALLAIN','LEONE','1937-06-26',NULL,NULL,NULL,'24 RUE DU CIVISME','','',NULL,NULL,NULL,NULL,'1370614311001',207.000000000,'1964-07-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (472,'LE LOGE','LEA','1934-08-15','02.81.83.13.93','06.76.47.73.71',NULL,'2 CITE DES CASTORS','','','14370','ARGENCES',NULL,NULL,'1340814629001',94.000000000,'1955-07-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (473,'LELOUTRE','DANIEL','1967-08-10','02.11.86.19.87','06.34.27.31.49',NULL,'13 rue de la grasse de dieu','','',NULL,NULL,NULL,NULL,'2670850464001',690.000000000,'1992-06-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (474,'FRANCOISE','JEAN',NULL,'02.30.40.74.15',NULL,NULL,'272 RUE DU VIEU PAITIS','','',NULL,NULL,NULL,NULL,'1580214543001',91.000000000,'2009-06-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (475,'VINCENT','MARIE JEANNE','1934-04-29','02.54.78.31.74',NULL,NULL,'84 place de l''eglise','','','14000','CAEN',NULL,NULL,'1340414063001',919.000000000,'1960-03-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (476,'DELARUE','ANDRE','1966-04-21','02.57.99.88.45','06.62.64.14.86',NULL,'hameau lahaye','','','14000','CAEN',NULL,NULL,'2660450563001',1312.000000000,'1996-11-02','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (477,'DEVAUX','FRANCOIS','1946-03-26','02.61.39.13.55','06.33.42.52.80',NULL,'11 BIS RUE CAMILLE PELLETAN','','','14380','PONT FARCY',NULL,NULL,'1460314057001',174.000000000,'1976-08-25','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (478,'FAHEIM','MONIQUE','1948-11-18','02.13.03.90.15','06.75.97.88.48',NULL,'19 rue armand marie','','','14123','IFS',NULL,NULL,'2481114092001',67.000000000,'1970-01-06','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (479,'BICORNE','TAHAR','1955-07-10','02.39.13.04.69','06.34.37.01.98',NULL,'8 bd impratrice eugnie','','',NULL,NULL,NULL,NULL,'1550778554001',13.000000000,'1979-01-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (480,'SYLVAND','JEANNINE','1943-07-29','02.11.66.42.54','06.10.81.90.40',NULL,'5 ALLEE DU ROC','','',NULL,NULL,NULL,NULL,'1430711183001',220.000000000,'1964-12-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (481,'RAGOT','CATHERINE','1938-12-28','02.63.49.94.02','06.38.79.73.21',NULL,'7 IMPASSE DES HIRONDELLES','','','14980','ROTS',NULL,NULL,'1381272298001',630.000000000,'1963-06-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (482,'LECORDIER','AIMEE','1939-09-28','02.61.28.30.13','06.24.97.97.33',NULL,'RESIDENCE ARC EN CIEL BAT B 19','','','14150','OUISTREHAM',NULL,NULL,'1390914240001',71.000000000,'1962-12-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (483,'LECOT','JEAN','1936-03-16','02.18.96.01.54','06.39.98.79.00',NULL,'7 RUE GEORGES MAUDOUIT','','',NULL,NULL,NULL,NULL,'2360314387001',888.000000000,'1959-05-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (484,'ACHIN','ANDRE','1936-12-09','02.47.79.40.37','06.71.18.01.73',NULL,'RESIDENCE TERREFOUR','','',NULL,NULL,NULL,NULL,'2361214392001',886.000000000,'1966-09-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (485,'LEROY','BRIGITTE','1927-04-05','02.10.90.96.11','06.87.48.95.47',NULL,'12 RUE GANDIE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1270487061001',320.000000000,'1948-03-14','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (486,'LITHARE','GASTON','1938-02-26','02.10.97.44.59','06.80.67.95.87',NULL,'11 RUE D ANJOU','','',NULL,NULL,NULL,NULL,'1380214433001',32.000000000,'1961-08-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (487,'CARRE','PIERRETTE','1938-12-17','02.12.08.98.41','06.20.75.30.69',NULL,'3 rue d''ober kochen','','',NULL,NULL,NULL,NULL,'2381250074001',38.000000000,'1968-09-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (488,'CONFLANT','RENE','1940-12-27','02.11.91.41.78','06.11.58.29.41',NULL,'7 bis rue rougeT de lisle','','',NULL,NULL,NULL,NULL,'1401214722001',64.000000000,'1963-11-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (489,'LEROUX','GINETTE','1962-02-06','02.22.41.60.89','06.11.39.56.22',NULL,'13 rue des roses','','','14100','BEUVILLERS',NULL,NULL,'1620250043001',108.000000000,'1991-06-16','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (490,'SAMSON','GILBERTE','1938-09-06','02.70.27.27.25','06.40.84.16.27',NULL,'6 RUE PASTEUR','','',NULL,NULL,NULL,NULL,'2380914489001',665.000000000,'1961-06-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (491,'SANSON','NELLY','1929-05-21','02.65.90.50.09','06.73.58.29.21',NULL,'7 RUE DU DR PLANTAIN','','','14730','GIBERVILLE',NULL,NULL,'2290550507001',38.000000000,'1954-06-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (492,'LUCAS','CLAUDE','1933-08-30','02.11.68.53.79','06.28.47.75.51',NULL,'19 BD RAYMOND POINCARE','','','14730','GIBERVILLE',NULL,NULL,'1330814274001',93.000000000,'1954-10-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (493,'TUBOEUF','GILBERT','1961-03-16','02.12.33.43.28','06.18.72.41.27',NULL,'481 RUE DU GABLE BLANC','','',NULL,NULL,NULL,NULL,'2610350422001',4512.000000000,'1986-02-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (494,'BELLIARD','LOUISE','1959-04-09','02.48.93.13.47','06.71.97.61.10',NULL,'1 RUE DES ORMES','','','27260','CORMEILLES',NULL,NULL,'2590414396001',1505.000000000,'1987-06-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (495,'VAN WYNSBERGHE','PAUL','1935-12-03','02.21.44.04.04','06.26.79.91.24',NULL,'LE PONT D''ILLEY','','','14000','CAEN',NULL,NULL,'1351214281001',580.000000000,'1960-07-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (496,'GOUBIN','MARCEL','1955-02-08','02.74.10.44.74',NULL,NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'2550214125001',67.000000000,'1983-01-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (497,'SAULNIER','MARIE CLAIRE','1932-03-15','02.94.59.93.70','06.17.63.00.05',NULL,'','','','14000','CAEN',NULL,NULL,'1320314098001',365.000000000,'1962-10-10','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (498,'BECQUET','BERNARD','1943-07-27','02.55.17.45.30','06.78.75.18.95',NULL,'27 RUE DES CANADIENS','','',NULL,NULL,NULL,NULL,'1430714214001',147.000000000,'1965-07-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (499,'LEDANOIS','DENISE','1940-09-07','02.49.83.44.80','06.43.17.18.10',NULL,'129 RESIDENCE DE PARIS, BD RAYMO','ND POINCARE','',NULL,NULL,NULL,NULL,'2400914229001',41.000000000,'1970-08-03','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (500,'ROBIN','FERNANDE','1945-01-09','02.61.55.67.27','06.66.68.06.55',NULL,'14 RUE DU CLOS DE BAS','','','76600','LE HAVRE',NULL,NULL,'1450161339001',305.000000000,'1968-10-04','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (501,'ROBIN','ROSE','1935-12-18','02.94.68.20.57','06.26.70.12.89',NULL,'5 rue louvet','','','14000','CAEN',NULL,NULL,'2351214193001',213.000000000,'1957-03-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (502,'BARBIER','JEANNINE','1939-08-18','02.49.65.39.58','06.64.71.31.49',NULL,'33 BLV RAYMOND POINCARE','','','14000','CAEN',NULL,NULL,'2390814427001',103.000000000,'1961-10-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (503,'TANQUEREL','DANIEL','1937-04-15','02.11.68.70.30','06.56.27.70.01',NULL,'8 RUE PIERRE MENOCHET','','','14770','ST JEAN LE BLANC',NULL,NULL,'1370414164001',22.000000000,'1960-07-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (504,'CHEMIN','HELENE','1935-11-12','02.36.80.08.24','06.34.41.66.51',NULL,'2 rue Andr Gide','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'2351114301001',800.000000000,'1962-11-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (505,'BARETTE','MAURICE','1931-03-27','02.41.78.96.56','06.59.38.27.00',NULL,'18 rue du blanc','','',NULL,NULL,NULL,NULL,'2310314251001',36.000000000,'1956-04-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (506,'SAUVAGE','LEONE','1931-11-10','02.36.72.02.50','06.32.61.51.67',NULL,'6 rue des carrieres','','','14110','CONDE SUR NOIREAU',NULL,NULL,'1311161096001',2192.000000000,'1957-09-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (507,'SAUVAGE','Michel','1934-11-03','02.10.34.15.45','06.91.41.75.50',NULL,'4 chemin des moires','','',NULL,NULL,NULL,NULL,'2341114042001',1395.000000000,'1957-03-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (508,'LECARPENTIER','CLAUDE','1941-02-18','02.11.62.61.10','06.59.30.84.04',NULL,'15 RUE DU DR THIBAUT DE LA FRESN','AYE','',NULL,NULL,NULL,NULL,'1410214409001',10.000000000,'1962-08-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (509,'LEBARBEY','ROGER','1940-06-17','02.65.97.61.10','06.55.68.25.11',NULL,'40 avenue albert 1er','','',NULL,NULL,NULL,NULL,'2400614197001',29.000000000,'1963-09-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (510,'BUQUET','SUZANNE','1969-11-21','02.14.54.66.90','06.43.05.84.74',NULL,'15 RUE PARABOLE DU CLOS','','',NULL,NULL,NULL,NULL,'2691114162001',847.000000000,'1991-12-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (511,'MOREL','SUZANNE','1933-10-14','02.75.38.73.86','06.11.91.48.37',NULL,'7 RUE CLOS DU PAVILLON','','',NULL,NULL,NULL,NULL,'1331014060001',734.000000000,'1955-08-01','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (512,'BULLIAN','Gilles',NULL,'02.96.05.11.17','06.54.72.61.17',NULL,'CLOS DU PAVILLON N.12','','',NULL,NULL,NULL,NULL,'2290514164001',50.000000000,'2009-03-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (513,'','jean louis','1938-04-24','02.18.03.76.59','06.22.10.88.28',NULL,'bretteville','','','14123','IFS',NULL,NULL,'2380414119001',766.000000000,'1964-03-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (514,'BOUCHARD','MICHEL','1936-06-05','02.27.03.32.87','06.74.05.05.28',NULL,'13 rue des mineurs','','',NULL,NULL,NULL,NULL,'1360650099001',7.000000000,'1957-07-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (515,'BELLANGER','HUBERT','1928-09-15','02.18.91.38.97','06.86.12.20.03',NULL,'9 PLACE PABLO NERUDA','','','14000','CAEN',NULL,NULL,'2280901153001',111.000000000,'1952-05-24','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (516,'CANTELOUP','JEANNE','1946-01-02','02.27.57.42.67','06.10.14.09.35',NULL,'2 rue jugan','','',NULL,NULL,NULL,NULL,'1460150130001',131.000000000,'1974-02-20','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (517,'DIVET','Christiane','1968-06-18','02.52.14.61.82','06.35.66.58.26',NULL,'223 IMPASSE DU VILLAGE','','',NULL,NULL,NULL,NULL,'1680661437001',700.000000000,'1996-02-28','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (518,'LE BATARD','ANDREE','1965-02-12','02.44.85.81.77','06.46.91.97.91',NULL,'30 RUE LA FRESNAIE','','','14120','MONDEVILLE',NULL,NULL,'1650214208001',484.000000000,'1986-04-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (519,'BLANCHET','JEAN LOUIS','1958-10-06','02.10.92.38.53','06.65.96.73.43',NULL,'11a rue de st aubin sur mer','','','14000','CAEN',NULL,NULL,'1581035238001',163.000000000,'1980-01-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (520,'HARDEL','ODETTE','1936-06-28','02.97.15.06.94','06.55.38.14.65',NULL,'17 RUE DU STADE','','',NULL,NULL,NULL,NULL,'1360614268001',1327.000000000,'1960-12-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (521,'GENTILETTI','Marie rose','1957-01-22','02.64.36.62.45','06.54.98.94.86',NULL,'607 LES BELLES PORTES','','',NULL,NULL,NULL,NULL,'1570187146001',38.000000000,'1979-09-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (522,'CARDONNEL','VALERIE','1950-01-11','02.79.00.81.06','06.84.88.23.88',NULL,'301 HAUTE FOLIE','','',NULL,NULL,NULL,NULL,'1500176390001',4291.000000000,'1975-05-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (523,'MIDY','FREDERIC','1930-04-07','02.57.53.17.65','06.71.60.11.33',NULL,'FERME DE LA PRAIRIE','','',NULL,NULL,NULL,NULL,'1300414118001',37.000000000,'1959-03-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (524,'GUILLERY','PIERRE','1932-11-10','02.66.68.25.07','06.11.55.50.77',NULL,'5 rue des fleurs','','',NULL,NULL,NULL,NULL,'1321161052001',36.000000000,'1962-02-09','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (525,'LENOBLE','MICHEL','1949-06-22','02.22.33.46.27','00 33 6.61.40.22.92',NULL,'','','',NULL,NULL,NULL,NULL,'1490614002001',581.000000000,'1978-02-12','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (526,'LETELLIER','MAXIMILIEN','1952-06-01','02.55.11.52.72','06.38.48.34.93',NULL,'32 RUE DU PONT DU COUDRAY','','',NULL,NULL,NULL,NULL,'1520699350001',98.000000000,'1976-03-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (527,'DANJOU','PIERRE','1930-02-10','02.10.44.25.49','06.89.09.79.79',NULL,'6 rue jean genest','','',NULL,NULL,NULL,NULL,'1300227138001',1469.000000000,'1952-08-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (528,'MARIE','JOSETTE',NULL,'02.25.50.33.51','06.11.44.83.41',NULL,'5 RUE DES ROSES','','',NULL,NULL,NULL,NULL,'1340514225001',3.000000000,'2008-01-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (529,'CRESTAUX','YVES','1969-10-03','02.15.28.08.27','06.54.68.90.24',NULL,'28 rue des chasses','','',NULL,NULL,NULL,NULL,'2691042187001',3016.000000000,'1991-08-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (530,'PROUX','MICHEL','1929-12-06','02.42.81.91.15','06.30.99.14.13',NULL,'4/3 alle des capucines','','',NULL,NULL,NULL,NULL,'2291214207001',201.000000000,'1955-12-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (531,'BOCAGE','COLETTE','1936-06-03','02.26.91.75.22','06.20.87.66.08',NULL,'12 RUE  DES SAUTS CABRI','','',NULL,NULL,NULL,NULL,'2360614174001',137.000000000,'1962-10-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (532,'LEGER','RAYMOND','1935-08-22','02.43.73.74.42',NULL,NULL,'3 RUE DE BERLIN','','',NULL,NULL,NULL,NULL,'2350814301001',1514.000000000,'1963-01-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (533,'CHALTON','EDITH','1929-10-01','02.15.60.24.99','06.68.25.65.43',NULL,'9 RUE DE L ESPERANCE','','',NULL,NULL,NULL,NULL,'2291050621001',498.000000000,'1952-01-20','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (534,'','Genevieve','1935-09-18','02.81.44.30.74',NULL,NULL,'26 ALLEES DES TISSERANDS','','','14000','CAEN',NULL,NULL,'1350950614001',89.000000000,'1956-02-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (535,'BARBE','MICHEL','1929-01-23','02.28.28.49.64','06.12.75.09.73',NULL,'4 RUE JEAN MOULIN','','','14123','IFS',NULL,NULL,'1290172142001',31.000000000,'1950-09-05','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (536,'','GISELE','1938-06-15','02.28.80.06.35','06.49.77.30.34',NULL,'3 RUE GANDHI','','',NULL,NULL,NULL,NULL,'1380650511001',52.000000000,'1967-07-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (537,'BOTCAZOU','NICOLE','1940-10-30','02.11.08.13.06','06.11.70.82.18',NULL,'9 rue gandhi','','',NULL,NULL,NULL,NULL,'1401027163001',166.000000000,'1963-11-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (538,'DELAUNAY','MARCELLE','1933-05-20','02.11.70.84.35','06.44.13.80.79',NULL,'11 RUE DU PARC','','',NULL,NULL,NULL,NULL,'1330514229001',99.000000000,'1960-10-19','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (539,'JEANNE','MARGUERITE','1936-06-26','02.11.96.79.13','06.74.30.96.30',NULL,'ROUTE DE LIVAROT','','','14000','CAEN',NULL,NULL,'2360614526001',872.000000000,'1961-06-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (540,'JUBAULT','PASCAL','1947-01-21','02.67.31.26.33','06.16.35.95.47',NULL,'35 RUE DU POMMIER GRIS','','',NULL,NULL,NULL,NULL,'1470114233001',386.000000000,'1971-07-25','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (541,'RIVIERE','NELLY','1943-04-30','02.26.70.22.89','06.24.42.17.49',NULL,'21 RUE BASSE','','','14000','CAEN',NULL,NULL,'1430414037001',26.000000000,'1966-04-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (542,'BOURSIN','GERARD','1940-06-19','02.99.52.88.70','06.46.00.40.48',NULL,'19 RUE JEAN JACQUES ROUSSEAU','','','14840','DEMOUVILLE',NULL,NULL,'1400614296001',15.000000000,'1966-10-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (543,'LEMENAGER','GEORGETTE','1946-03-22','02.40.63.90.80','06.37.20.68.19',NULL,'ROUTE DE TILLY SUR SEULLES','','',NULL,NULL,NULL,NULL,'1460350299001',31.000000000,'1970-01-08','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (544,'THOMAS','LOUIS','1928-02-14','02.34.70.80.78','06.85.51.20.19',NULL,'','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'2280250488001',736.000000000,'1953-01-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (545,'CALBRY','JEANNINE','1940-12-29','02.62.51.03.87','06.78.07.62.15',NULL,'1 rue de la coile','','','14000','CAEN',NULL,NULL,'2401214119001',237.000000000,'1962-09-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (546,'MESNIL','Angele','1943-01-11','02.65.28.39.69','06.20.83.81.24',NULL,'3 PLACE CLAUDE DE BUSSY','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1430114090001',982.000000000,'1968-04-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (547,'BINET','DENISE','1964-11-14','02.79.76.78.18','06.56.41.11.03',NULL,'40 RUE ERNEST RENAN','','','14000','CAEN',NULL,NULL,'1641199255001',19.000000000,'1986-03-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (548,'BINET','SUZANNE','1928-02-27','02.41.30.08.36','06.49.84.52.90',NULL,'57 rue du manoir','','',NULL,NULL,NULL,NULL,'2280214325001',62.000000000,'1951-02-12','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (549,'VOISVENEL','NELLY','1938-05-26','02.11.33.50.39','06.45.64.83.57',NULL,'CHEMIN DE LA CROIX MARIE','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2380550465001',145.000000000,'1962-10-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (550,'LEBRETHON','FLORENCE','1934-10-28','02.40.91.12.15','06.73.92.12.91',NULL,'LE BOURG','','',NULL,NULL,NULL,NULL,'1341014108001',102.000000000,'1962-02-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (551,'MICHEL','SABINE','1933-12-29','02.49.53.93.79','06.15.53.08.45',NULL,'1 le marronnier','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1331214664001',4771.000000000,'1955-03-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (552,'QUIDOR DIT PASQUET','JOEL','1954-07-22','02.79.03.52.55','06.10.64.25.86',NULL,'34 RUE DE LA MUANCE','','','14000','CAEN',NULL,NULL,'1540714189001',2914.000000000,'1977-04-24','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (553,'GUELLE','JOCELYNE','1931-09-26','02.27.97.55.12','06.74.88.05.55',NULL,'15 rue charles peggy','','',NULL,NULL,NULL,NULL,'1310961232001',178.000000000,'1957-04-22','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (554,'LATINI','HENRIETTE','1933-05-18','02.84.09.91.72','06.11.98.71.96',NULL,'roucamps','','',NULL,NULL,NULL,NULL,'2330514378001',86.000000000,'1954-11-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (555,'LITHARD','JEAN CLAUDE','1940-05-29','02.84.74.64.92',NULL,NULL,'19 RUE DU STADE','','',NULL,NULL,NULL,NULL,'2400527045001',15.000000000,'1970-03-14','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (556,'MESNIL','SERGE','1928-06-01','02.11.93.05.08','06.45.80.11.80',NULL,'23 RUE DE LA BIENFAISANCE','','',NULL,NULL,NULL,NULL,'2280614276001',105.000000000,'1956-01-13','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (557,'MORIN','DANIEL',NULL,'02.49.70.94.20','06.22.21.35.25',NULL,'6 RUE JULES FLAMBARD','','','14120','MONDEVILLE',NULL,NULL,'2410214038001',41.000000000,'2008-04-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (558,'DETRAIN','LYDIE','1932-03-22','02.11.28.02.91','06.85.75.67.20',NULL,'LE MOULIN DE FRESNAY','','',NULL,NULL,NULL,NULL,'2320350051001',192.000000000,'1961-07-09','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (559,'VEREL','FRANCOISE','1940-04-12','02.19.92.30.52','06.75.31.39.94',NULL,'6 RUE DE SAINT HILAIRE','','','14370','CHICHEBOVILLE',NULL,NULL,'1400414071001',375.000000000,'1962-11-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (560,'CAILLY','PAULETTE','1943-04-27','02.76.98.71.34','06.82.65.41.43',NULL,'7 rue des castors','','','14400','BAYEUX',NULL,NULL,'2430461039001',142.000000000,'1971-02-01','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (561,'VIVIEN','PATRICK','1932-01-12','02.95.89.40.65','06.12.61.74.01',NULL,'61 RUE LOUIS LE CHATELIER','','',NULL,NULL,NULL,NULL,'2320114499001',1498.000000000,'1957-12-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (562,'KOPER','MARIE LINE','1958-01-31','02.70.34.32.59','06.21.94.81.11',NULL,'9 RUE CHEMIN AUX BOEUFS','','',NULL,NULL,NULL,NULL,'1580153013001',90.000000000,'1979-05-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (563,'ANDRISIK','SERGE','1929-01-05','02.62.43.06.87','06.54.33.35.39',NULL,'3 IMPASSE DES BLEUETS','','',NULL,NULL,NULL,NULL,'2290114553001',18.000000000,'1959-09-08','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (564,'COCHARD','MARTIAL','1980-12-09','02.60.11.68.46','06.82.92.97.21',NULL,'3 RUE ST GILLES','','',NULL,NULL,NULL,NULL,'1801299255001',98.000000000,'2009-06-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (565,'GRARD','CHARLOTTE','1938-09-13','02.41.39.01.41','06.65.26.43.96',NULL,'53 RUE J VILAR','','','14000','CAEN',NULL,NULL,'2380972066001',266.000000000,'1962-07-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (566,'MANCHON','LUCIEN','1932-12-18','02.52.60.78.04','06.45.32.48.35',NULL,'8 RUE LEONARD GILLES','','',NULL,NULL,NULL,NULL,'1321214497001',59.000000000,'1956-09-08','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (567,'FESTOC','GERMAIN','1934-06-10','02.59.30.88.80','06.21.05.49.83',NULL,'HAMEAU VALETTE','','','14000','CAEN',NULL,NULL,'1340661303001',221.000000000,'1963-08-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (568,'WALKER','GUSTAVE','1938-01-19','02.83.00.57.32','06.71.71.28.67',NULL,'22 RUE ALFRED CASSIGNEUL','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1380114100001',38.000000000,'1959-06-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (569,'LOREL','JACQUELINE','1938-04-04','02.92.94.44.79','06.21.31.34.82',NULL,'5 RUE DES PRES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1380422162001',2.000000000,'1959-12-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (570,'ALIX','BERNARD','1936-10-05','02.47.09.11.67','06.34.03.57.41',NULL,'15 BD A BRIAND','','','14540','BOURGUEBUS',NULL,NULL,'2361014076001',929.000000000,'1961-02-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (571,'GERMOND','AIME','1945-01-25','02.50.11.57.97','00 33 6.75.92.94.53',NULL,'BATIMENT U RESIDENCE COLBERT','','','14630','FRENOUVILLE',NULL,NULL,'2450114549001',26.000000000,'1967-08-30','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (572,'BOISSEL','MARIANNE','1932-11-03','02.88.53.12.23','06.90.16.85.74',NULL,'68  ROUTE DE LA GUERINIERE','','',NULL,NULL,NULL,NULL,'1321114672001',366.000000000,'1958-02-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (573,'FONTAINE','lucien','1932-03-27','02.87.51.33.83','06.91.83.73.77',NULL,'24 RUE DE RONCEVAUX','','',NULL,NULL,NULL,NULL,'1320314468001',50.000000000,'1955-01-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (574,'FONTAINE','MARTIAL','1940-12-31','02.42.97.09.95','06.10.20.35.30',NULL,'6 RUE DU 8 MAI','','',NULL,NULL,NULL,NULL,'2401214118001',796.000000000,'1970-07-04','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (575,'LOREL','JULIEN','1953-01-22','02.38.83.87.12','06.11.46.90.25',NULL,'11 RUE DES PRIMEVERES','','','14000','CAEN',NULL,NULL,'2530114099001',982.000000000,'1975-05-21','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (576,'LENORAIS','BERNARD','1948-03-23','02.34.98.77.84','06.65.07.18.51',NULL,'1 RUE CLOS DU CAPRICE','','','14123','IFS',NULL,NULL,'1480314164001',163.000000000,'1973-02-22','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (577,'LEMARCHAND','THERESE','1962-02-14','02.10.82.41.09','06.81.46.59.31',NULL,'19 RUE MAURICE LAFON','','',NULL,NULL,NULL,NULL,'2620214213001',31.000000000,'1987-09-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (578,'LAUNAY','LOUIS','1938-05-03','02.42.06.81.09','06.56.18.46.81',NULL,'38 RUE SALVADOR ALLENDE','','',NULL,NULL,NULL,NULL,'1380561040001',218.000000000,'1961-01-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (579,'LECANU','STEPHANE','1936-04-28','02.10.80.03.54','06.13.10.65.80',NULL,'544 rue du chemin vert','','','14000','CAEN',NULL,NULL,'1360414657001',35.000000000,'1960-08-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (580,'LE ROUX','STEPHANE','1955-03-15','02.20.06.78.58','06.42.87.33.48',NULL,'1 rue des clematires','','','14860','RANVILLE',NULL,NULL,'2550314294001',1907.000000000,'1977-02-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (581,'LEROUX','BERNADETTE','1957-01-04','02.20.10.99.00','06.51.43.39.19',NULL,'1 rue claude debussy','','','14370','MOULT',NULL,NULL,'1570114530001',535.000000000,'1987-11-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (582,'MOREL','SERGE','1931-03-30','02.99.99.45.19','06.86.27.67.41',NULL,'RUE DES COMMERCES','','','50130','OCTEVILLE',NULL,NULL,'1310314291001',80.000000000,'1956-01-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (583,'PERREE','FREDERIC','1937-12-18','02.78.41.24.97','06.98.43.10.89',NULL,'','','','50680','AIREL',NULL,NULL,'1371214410001',90.000000000,'1966-09-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (584,'BILLANT','FREDERIC','1952-04-13','02.21.89.37.14','06.30.52.43.28',NULL,'1 rue des mesanges','','','14400','BAYEUX',NULL,NULL,'2520414170001',25.000000000,'1976-09-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (585,'LE PASTEUR','JEAN CLAUDE','1966-03-18','02.61.48.58.46','06.73.94.98.97',NULL,'Rue de Picardie','','','14000','CAEN',NULL,NULL,'1660314453001',1413.000000000,'1988-09-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (586,'','GUY','1936-12-30','02.67.49.02.39','06.74.98.24.51',NULL,'35 GRANDE RUE','','','14730','GIBERVILLE',NULL,NULL,'2361214400001',105.000000000,'1959-05-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (587,'GUILLOT','JACQUES','1923-08-10','02.11.77.77.05','06.12.22.94.95',NULL,'7 rue du lavoir','','','14000','CAEN',NULL,NULL,'1230850394001',16.000000000,'1953-12-31','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (588,'CONTENTIN','ELIANE','1928-03-07','02.56.72.32.52','06.35.16.59.26',NULL,'24 RUE GEORGES HARRISON','','','14840','DEMOUVILLE',NULL,NULL,'2280314282001',73.000000000,'1950-05-15','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (589,'VIEL','Sylvie','1952-02-13','02.50.48.27.91','06.55.89.39.94',NULL,'7 RUE DES PRIMEVERES','','','50740','CAROLLES',NULL,NULL,'1520214545001',2064.000000000,'1980-06-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (590,'HANOUET','CHRISTIANE','1950-10-19','02.58.76.38.46','06.69.72.72.32',NULL,'47 rue du port','','','14000','CAEN',NULL,NULL,'1501014018001',355.000000000,'1974-03-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (591,'LE GARGAM','HUBERT',NULL,'02.34.88.32.08','06.40.09.65.65',NULL,'27 rue des acacias','','','14000','CAEN',NULL,NULL,'1430214470001',94.000000000,'2012-05-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (592,'','AUGUSTE','1928-09-10','02.93.00.49.91','06.11.23.64.95',NULL,'3 av des clairieres','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2280922054001',49.000000000,'1952-01-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (593,'LAURENT','FRANCIS','1928-09-29','02.26.77.59.48','06.10.60.45.68',NULL,'10 RUE SULLY','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2280922054001',24.000000000,'1951-11-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (594,'CORDRAY','JEAN FRANCOIS','1952-01-30','02.60.66.59.53','06.24.35.86.97',NULL,'1 ALLEE DES JARDINS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1520114654001',986.000000000,'1973-07-01','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (595,'LIETOT','LOUIS','1935-04-12','02.55.55.33.58','06.56.57.18.58',NULL,'','','','50560','GEFFOSSES',NULL,NULL,'1350475116001',1338.000000000,'1959-01-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (596,'LAROSE','','1940-04-27','02.91.95.44.18','06.22.04.24.27',NULL,'1 allee louis edouard garrido','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1400436087001',77.000000000,'1967-09-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (597,'LEGRIX','ELISABETH','1937-03-16','02.66.68.55.70','06.69.01.39.32',NULL,'1 RUE DES HORTENSIAS','','',NULL,NULL,NULL,NULL,'1370314437001',154.000000000,'1963-08-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (598,'BROSSON','JEAN','1935-04-10','02.76.25.67.83','06.25.88.43.88',NULL,'2 CLOS DU MONASTERE','','',NULL,NULL,NULL,NULL,'1350414325001',4284.000000000,'1963-09-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (599,'LEPAISANT','MIREILLE',NULL,'02.65.84.17.31','06.46.44.56.24',NULL,'4 RUE PIERRE DE RONSARD','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2430114011001',31.000000000,'2012-02-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (600,'HOLLEY','',NULL,'02.72.15.79.12','06.94.68.07.24',NULL,'18 Bis Place du Marchand','','','14000','CAEN',NULL,NULL,'1520214090001',377.000000000,'2010-09-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (601,'LETELLIER','PATRICIA','1932-08-28','02.29.19.19.18','06.11.83.34.80',NULL,'TERCEI','','','14123','FLEURY SUR ORNE',NULL,NULL,'2320853159001',18.000000000,'1953-10-28','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (602,'HOUEIX','PAULETTE','1932-06-14','02.73.23.76.10','06.61.18.11.47',NULL,'5 rue louis lachenal','','','14630','FRENOUVILLE',NULL,NULL,'1320614106001',418.000000000,'1956-06-18','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (603,'LELANDAIS','THERESE',NULL,'02.81.21.56.83','06.80.79.89.75',NULL,'9 RUE MAURICE ARROT','','',NULL,NULL,NULL,NULL,'2310880706001',204.000000000,'2010-11-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (604,'DUVERNOIS','jean','1933-09-23','02.90.89.11.50','06.70.17.77.14',NULL,'CAREL ROUTE DE FALAISE','','','14320','MAY SUR ORNE',NULL,NULL,'1330914666001',91.000000000,'1956-07-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (605,'AUMONT','z','1964-01-30','02.57.08.47.47','06.82.80.24.50',NULL,'3 RUE DE L''EGLISE','','','14320','MAY SUR ORNE',NULL,NULL,'2640114290001',205.000000000,'1986-04-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (606,'VIGNOLLES','PIERRETTE','1931-06-17','02.34.22.63.41','06.42.45.40.99',NULL,'7 RUE HELENE BOUCHER','','',NULL,NULL,NULL,NULL,'1310614124001',51.000000000,'1954-10-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (607,'LATOUR','VALERIE','1958-01-28',NULL,NULL,NULL,'10 avenue de cabourg','','',NULL,NULL,NULL,NULL,'1580114668001',36.000000000,'1981-04-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (608,'BESNIER','GILBERTE','1961-01-13','02.24.81.00.62','06.10.14.19.26',NULL,'61 RUE VICTOR LEPINE','','',NULL,NULL,NULL,NULL,'2610150547001',2640.000000000,'1983-06-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (609,'LECOQ','ROLAND','1966-01-18','02.44.36.00.53','06.17.52.77.08',NULL,'LES TILLEUILS','','','14740','PUTOT EN BESSIN',NULL,NULL,'1660114246001',3048.000000000,'1987-06-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (610,'LECARPENTIER','GILBERT','1936-02-13','02.61.37.44.75','06.56.61.71.95',NULL,'11 RUE PAUL LANGEVIN','','','14680','GOUVIX',NULL,NULL,'1360214411001',413.000000000,'1957-12-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (611,'GASSON','ROGER','1938-07-20','02.11.89.16.43','06.38.48.37.77',NULL,'1 RUE MICHEL LASNE','','',NULL,NULL,NULL,NULL,'2380714364001',1333.000000000,'1968-10-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (612,'QUIQUEMELLE','TUBO','1937-02-05','02.57.01.48.42','06.75.67.73.21',NULL,'1 rue de troarn','','',NULL,NULL,NULL,NULL,'1370214565001',1535.000000000,'1964-08-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (613,'FAINE','RAYMOND','1929-07-23','02.46.99.85.73','06.10.72.33.55',NULL,'5 rue bulletieres','','',NULL,NULL,NULL,NULL,'1290714050001',41.000000000,'1959-08-04','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (614,'COADOU','THIERRY','1934-02-27','02.89.31.34.83','06.83.94.00.04',NULL,'7 route de bretagne','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1340214672001',101.000000000,'1955-10-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (615,'DESCHAMPS','CHRISTIANE',NULL,'02.76.29.25.48','06.43.91.65.10',NULL,'24 RUE MAURICE GENEVOIX','','',NULL,NULL,NULL,NULL,'2321253127001',114.000000000,'2009-09-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (616,'LEBEDEL','BRIGITTE','1933-06-19','02.83.27.61.82','06.70.82.87.95',NULL,'26 RUE DES DRAKKARS','','','14610','CAIRON',NULL,NULL,'2330614221001',468.000000000,'1959-02-10','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (617,'VALLEE','MAURICE','1933-08-20','02.29.41.96.80','06.73.24.18.09',NULL,'1 RUE EDMOND GOMBAUX','','','14320','FONTENAY LE MARMION',NULL,NULL,'1330850268001',28.000000000,'1963-09-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (618,'PICQUENARD','MARCEL','1953-03-29','02.87.85.40.99','06.12.21.37.50',NULL,'LE MESNIL AU GRAIN','','',NULL,NULL,NULL,NULL,'2530314247001',76.000000000,'1974-09-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (619,'DELBRAYELLE','LOUIS','1929-03-18',NULL,NULL,NULL,'8 RUE DE LA CHAUSSEE','','',NULL,NULL,NULL,NULL,'2290350160001',7.000000000,'1954-07-08','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (620,'ROCHER','MARCELLE','1929-12-24','02.10.81.34.17','06.35.18.80.41',NULL,'144 BD LEROY','','','14370','MOULT',NULL,NULL,'2291261287001',166.000000000,'1956-10-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (621,'MOCQUES','MARGUERITE','1970-03-05','02.11.80.90.36','06.46.66.17.15',NULL,'RUE DE GLATIGNY','','','14630','CAGNY',NULL,NULL,'1700399255001',2936.000000000,'1998-05-12','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (622,'PIQUOT','MADELEINE','1929-12-22','02.64.40.61.83','06.55.00.50.65',NULL,'24 BLD DE LA HAGUE','','','14000','CAEN',NULL,NULL,'2291214685001',103.000000000,'1953-09-16','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (623,'BEAUGEARD','CHANTAL','1939-08-03','02.54.36.32.04','06.39.77.58.80',NULL,'55 RUE DE LA PIGACIERE','','','53220','PONTMAIN',NULL,NULL,'1390814489001',174.000000000,'1962-09-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (624,'HEBERT','PIERRE GEORGES','1957-07-12','02.10.52.33.88','06.11.26.75.13',NULL,'LE PARC DAVOUST','','','14000','CAEN',NULL,NULL,'1570750138001',405.000000000,'1985-09-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (625,'ABED BAHTSOU','THERESE EUGENIE','1934-02-24','02.59.82.74.68',NULL,NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2340250261001',162.000000000,'1958-12-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (626,'MONTAJAULT','MARIE LOUI','1958-10-19','02.23.01.11.69','06.22.59.87.62',NULL,'22 bis rue du jardin','','','14800','TOUQUES',NULL,NULL,'1581014499001',13.000000000,'1984-09-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (627,'LECOQ','GISELE','1964-11-08','02.28.81.87.40','06.21.88.68.23',NULL,'7 rue des accacias','','','14220','BARBERY',NULL,NULL,'1641199255001',2182.000000000,'1988-08-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (628,'HEBERT','YVES','1938-03-01','02.25.38.83.27','06.85.48.62.51',NULL,'','','','14000','CAEN',NULL,NULL,'1380314517001',35.000000000,'1965-12-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (629,'LERICHE','JEAN CLAUDE','1930-12-30','02.48.35.95.52','06.58.71.44.07',NULL,'16 rue erik satie','','','14000','CAEN',NULL,NULL,'2301250080001',1365.000000000,'1953-12-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (630,'BETTE','JEAN CLAUDE','1969-07-13','02.50.63.76.72','06.91.66.80.38',NULL,'3 RUE DES MERISIERS','','','61100','FLERS',NULL,NULL,'1690714109001',207.000000000,'1990-12-14','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (631,'BLANCHERIE','NICOLLE','1944-05-15','02.88.60.45.70','06.22.48.91.65',NULL,'2 allee cl hamelin','','','14840','CUVERVILLE',NULL,NULL,'1440561304001',35.000000000,'1966-03-03','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (632,'SEILLIER','CHANTAL','1944-05-24','02.52.86.15.19','06.80.29.72.79',NULL,'1 rue a richard','','','14150','OUISTREHAM',NULL,NULL,'1440561304001',87.000000000,'1970-09-10','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (633,'JACQ','SERGE','1934-12-07','02.13.53.62.22','06.62.48.21.51',NULL,'18 rue barbeux','','','14320','MAY SUR ORNE',NULL,NULL,'1341277070001',97.000000000,'1955-02-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (634,'PASNEL','ANNE MARIE','1950-01-05','02.64.37.10.31','06.50.15.68.59',NULL,'LA SAUVEGARDE','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1500114173001',0.000000000,'1973-09-05','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (635,'LACROIX','NOEL','1945-06-12','02.17.31.89.15','00 33 6.58.24.74.14',NULL,'LA VALLEE','','','14630','FRENOUVILLE',NULL,NULL,'1450614404001',205.000000000,'1968-04-26','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (636,'RIVIERE','','1936-01-04','02.32.67.89.37','06.95.02.30.38',NULL,'33 RUE GEORGES GAILLARD','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2360150180001',89.000000000,'1959-03-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (637,'BACON','JEAN CLAUDE','1940-04-13','02.91.01.25.85','06.70.85.34.34',NULL,'15 rue du dr derrien','','','14000','CAEN',NULL,NULL,'1400414506001',402.000000000,'1964-06-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (638,'BACON','NATHALIE','1935-10-14','02.60.25.19.00','06.82.41.45.56',NULL,'27 RTE DE PERRIERS','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1351014368001',1287.000000000,'1963-04-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (639,'LECORDIER','ODETTE','1943-08-30','02.56.37.75.79','06.61.18.40.21',NULL,'2 RUE J GUESDES','','','14123','FLEURY SUR ORNE',NULL,NULL,'1430814298001',174.000000000,'1964-02-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (640,'GORIN','BERNARD','1940-09-07','02.60.10.63.18','06.50.91.82.48',NULL,'7 RUE DU CLOS ST GILLES','','','14250','AUDRIEU',NULL,NULL,'2400914439001',348.000000000,'1962-08-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (641,'LEDAIN','JEANNINE','1950-02-22','02.55.22.28.73','06.56.93.20.04',NULL,'LES ECOUVIARIES','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2500261444001',2.000000000,'1973-09-01','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (642,'CAILLON','HUGUETTE','1949-03-12','02.80.00.83.33','06.29.08.72.87',NULL,'13 RUE DU VIEUX PRESSOIR','','',NULL,NULL,NULL,NULL,'1490399134001',130.000000000,'1971-12-28','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (643,'TIRARD','BEATRICE','1945-01-12','02.11.92.74.26',NULL,NULL,'13 RUE  HARRY HAWKINS','','','50150','SOURDEVAL',NULL,NULL,'2450150597001',10.000000000,'1969-01-10','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (644,'BRIENS','MOISE','1934-05-14',NULL,NULL,NULL,'20 AVENUE LOUIS TOUSSAINT','','',NULL,NULL,NULL,NULL,'1340527367001',2783.000000000,'1955-08-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (645,'DEVAUX','JACQUES','1932-11-07','02.20.61.51.40','06.61.94.06.80',NULL,'22 RUE D''AMOZANE','','',NULL,NULL,NULL,NULL,'2321161070001',228.000000000,'1960-01-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (646,'PERRETTE','HUGUETTE','1935-07-06','02.12.01.44.38','06.70.51.19.00',NULL,'19 impasse des roses','','',NULL,NULL,NULL,NULL,'1350714659001',1165.000000000,'1958-01-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (647,'MELINOU','LUCIENNE','1931-04-18','02.59.40.70.15','06.98.47.43.17',NULL,'3 AVENUE D''HARCOURT','','',NULL,NULL,NULL,NULL,'1310414357001',10.000000000,'1960-10-27','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (648,'KARWECKI','RAYMONDE','1938-08-25','02.10.56.06.63','06.12.04.90.92',NULL,'2-4 rue de l''arbalete','','','14123','IFS',NULL,NULL,'1380814357001',191.000000000,'1966-04-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (649,'IVON','RAYMONDE','1964-01-15','02.71.27.06.59','00 33 6.66.26.14.25',NULL,'7 RUE DE LA CHARMILLE','','','14111','LOUVIGNY',NULL,NULL,'2640114437001',520.000000000,'1993-11-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (650,'PIGEON','ANNICK','1932-12-21','02.19.55.54.49','06.45.68.22.44',NULL,'11 rue georges clemenceau','','','14000','CAEN',NULL,NULL,'2321261093001',167.000000000,'1958-06-06','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (651,'QUERE','GASTON','1935-10-06','02.49.25.76.49','06.50.18.56.06',NULL,'36 RUE DE L''EGLISE','','',NULL,NULL,NULL,NULL,'2351014268001',830.000000000,'1964-01-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (652,'GAUTHIER','JEAN CLAUDE','1939-02-10','02.11.87.18.85','06.12.33.40.54',NULL,'272 RUE DU VIEU PAITIS','','',NULL,NULL,NULL,NULL,'1390250636001',85.000000000,'1960-01-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (653,'TEISSEDRE','PIERRE','1933-09-28','02.33.24.29.20','06.31.01.09.11',NULL,'10 IMPASSE DU 14 JUIN','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1330950066001',6.000000000,'1958-07-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (654,'PATRIX','JACQUELINE','1939-08-27','02.84.43.21.74',NULL,NULL,'141 BD DE FRANCE','','',NULL,NULL,NULL,NULL,'1390814100001',199.000000000,'1960-09-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (655,'LEU','MAURICE','1964-08-05','02.10.47.73.78','06.75.92.21.28',NULL,'4 RUE CAMILLE DEMOULIN','','',NULL,NULL,NULL,NULL,'2640814251001',312.000000000,'1994-10-13','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (656,'GUESNON','DENISE','1938-07-26',NULL,NULL,NULL,'10 RUE DE MOLIERE','','',NULL,NULL,NULL,NULL,'1380714217001',48.000000000,'1960-05-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (657,'LEGRAND','','1963-02-27','02.92.48.30.25','06.34.52.59.66',NULL,'CHEMIN DE LA CROIX AUX NOBLES','','','14000','CAEN',NULL,NULL,'2630214308001',76.000000000,'1987-04-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (658,'LETHIMONNIER OUDIN','CLAUDE','1932-07-19','02.11.69.10.01','06.63.74.22.72',NULL,'62 AVENUE DE LA MER','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1320714266001',770.000000000,'1958-05-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (659,'PISTIS','JOSEPH','1939-11-21','02.10.19.05.58','06.37.99.78.43',NULL,'23 RUE DU RUEL','','','14000','CAEN',NULL,NULL,'2391114241001',37.000000000,'1964-01-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (660,'LE THIMONNIER','JEAN','1933-10-18','02.77.06.33.24','06.79.29.88.81',NULL,'5 RUE OBLOND','','',NULL,NULL,NULL,NULL,'1331050214001',209.000000000,'1958-06-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (661,'MARCINKOWSKI','BERNARD','1967-04-26','02.77.10.87.81','06.89.54.39.96',NULL,'RUE DES SITELLES','','',NULL,NULL,NULL,NULL,'2670489460001',41.000000000,'1997-06-09','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (662,'LECHASLES','YVETTE','1940-02-24','02.89.09.62.86','06.61.29.28.25',NULL,'RES BEL AIR 22 RUE DU DR ROUX','','','14220','BOULON',NULL,NULL,'1400214437001',22.000000000,'1964-07-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (663,'VOISIN','CLAUDE','1940-01-03','02.10.66.49.93','06.12.01.02.46',NULL,'LE BOURG','','','14220','ESPINS',NULL,NULL,'2400114274001',1352.000000000,'1969-07-12','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (664,'ROSTAING','THERESE','1941-01-13','02.71.07.53.64','06.10.63.71.60',NULL,'LE BEL AIR','','',NULL,NULL,NULL,NULL,'2410114284001',86.000000000,'1965-01-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (665,'FEREY','MICHEL','1928-05-19','02.76.82.92.38','06.63.07.62.97',NULL,'LA PLANCHE A LA HOUSSE','','',NULL,NULL,NULL,NULL,'2280514659001',1753.000000000,'1952-10-30','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (666,'ANNE','ANDRE','1932-09-22','02.26.79.23.18','06.28.75.68.22',NULL,'48 rue des caillouins','','',NULL,NULL,NULL,NULL,'2320914060001',0.000000000,'1959-10-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (667,'ALIX','ALBERT','1938-12-30','02.11.71.86.23','06.44.95.52.63',NULL,'9 RUE DU CLOS NEUF','','',NULL,NULL,NULL,NULL,'2381250025001',2495.000000000,'1959-11-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (668,'GARNIER','NICOLE','1959-02-03','02.77.75.47.47','06.37.53.00.49',NULL,'6 av guy de maupassant','','',NULL,NULL,NULL,NULL,'2590214556001',32.000000000,'1982-04-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (669,'DUDOUET-MALASSIS','','1942-01-10','02.34.28.82.79','06.67.14.46.12',NULL,'51 rue du pont crion','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'1420117358001',123.000000000,'1970-06-08','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (670,'CHORON','DOMINIQUE','1930-08-06','02.81.15.29.49','06.35.84.16.36',NULL,'4 rue leon guigne','','',NULL,NULL,NULL,NULL,'1300883099001',333.000000000,'1960-10-01','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (671,'PATARD','LUCIEN','1967-04-21','02.74.53.95.54',NULL,NULL,'41 rue d''alencon','','','14780','LION SUR MER',NULL,NULL,'2670414356001',330.000000000,'1989-12-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (672,'DESMEULLES','PASCAL','1938-11-09','02.16.46.52.53','06.80.43.05.81',NULL,'6 AVENUE DU PRESIDENT COTY','','',NULL,NULL,NULL,NULL,'2381161316001',569.000000000,'1963-02-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (673,'OSMOND','DANIEL','1967-05-23','02.57.70.70.06','06.16.23.76.71',NULL,'8 rue du hennin','','',NULL,NULL,NULL,NULL,'1670514197001',42.000000000,'1997-11-23','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (674,'LEMIERE','GILLES','1945-01-29','02.51.55.26.75','06.53.41.00.81',NULL,'9 LE COUDRAY','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1450114140001',77.000000000,'1975-06-29','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (675,'','PIERRE','1933-08-23','02.19.31.23.49','06.43.97.42.90',NULL,'24 BIS ROUTE D''HARCOURT','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1330814335001',74.000000000,'1963-05-12','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (676,'CAPDEPON','RENE','1965-05-03','02.21.13.97.92','06.31.04.94.21',NULL,'4 RUE PIERRE DE RONSARD','','',NULL,NULL,NULL,NULL,'2650514166001',544.000000000,'1987-02-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (677,'LEFEVRE','MARCEL','1939-05-10','02.12.03.50.11','06.11.74.51.05',NULL,'2 RUE DE LA POUDRIERE','','',NULL,NULL,NULL,NULL,'2390550530001',38.000000000,'1965-01-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (678,'BERTAU','Alain','1935-01-01','02.30.78.67.66','06.13.34.55.58',NULL,'LA FONTAINE BALAN','','',NULL,NULL,NULL,NULL,'2350161017001',87.000000000,'1961-10-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (679,'AVICE','ANDRE','1935-09-04','02.36.57.38.15','06.77.95.76.97',NULL,'4 RUE DU SOIR','','','14610','THAON',NULL,NULL,'2350972155001',761.000000000,'1956-05-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (680,'NOWICKI','DANIELLE','1931-02-15','02.42.39.81.22','+ 33 6.68.51.39.67',NULL,'10 RUE DE MARIVAUX','','','14840','CUVERVILLE',NULL,NULL,'1310214111001',1373.000000000,'1958-01-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (681,'LIGERON','ANDRE','1935-11-30','02.33.52.90.73','06.82.87.60.55',NULL,'16 rue des renardieres','','','14000','CAEN',NULL,NULL,'2351114367001',178.000000000,'1956-10-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (682,'GUILLEMETTE','JOSEPH','1929-01-20','02.83.29.94.33','06.74.12.84.64',NULL,'LAUNAY','','','27470','SERQUIGNY',NULL,NULL,'2290163162001',621.000000000,'1959-04-14','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (683,'CARRE','daniel','1933-03-19','02.68.17.02.93','06.10.61.59.86',NULL,'6 CHEMIN DE GRUCHY','','',NULL,NULL,NULL,NULL,'1330314346001',33.000000000,'1954-05-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (684,'LENFANT','MARCEL','1930-02-18','02.85.38.42.05','06.10.65.08.06',NULL,'6 DOMAINE','','','50620','ST FROMOND',NULL,NULL,'1300250195001',2244.000000000,'1960-02-02','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (685,'MACHU','GHISLAINE','1940-03-08','02.15.18.71.23','06.11.57.27.38',NULL,'LA COUR DES MARETTES','','','14940','TOUFFREVILLE',NULL,NULL,'2400350592001',116.000000000,'1963-10-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (686,'VARDON','NADINE','1940-08-03','02.39.08.67.98','06.12.06.23.05',NULL,'9 bvd de la charite','','',NULL,NULL,NULL,NULL,'1400819134001',596.000000000,'1970-10-18','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (687,'FRIGOULT','MARIE JOSEPHE','1939-11-12','02.31.54.65.57','06.35.70.25.24',NULL,'9 RUE DU 18 JUIN','','','14000','CAEN',NULL,NULL,'1391114429001',82.000000000,'1960-06-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (688,'GRIMAULT','JEAN DOMINIQUE','1936-04-02','02.87.94.33.33','06.19.91.47.81',NULL,'1 RUE GEORGES CAZIN','','','14000','CAEN',NULL,NULL,'1360414107001',98.000000000,'1966-10-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (689,'PHILIPPE','ODILE','1933-07-27','02.74.79.01.23',NULL,NULL,'LE BAS DU VEY','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2330714453001',96.000000000,'1960-07-09','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (690,'','BERNARD','1931-06-13','02.10.32.03.70','06.54.61.60.22',NULL,'42 bd georges pompidou','','','14120','MONDEVILLE',NULL,NULL,'2310661424001',600.000000000,'1956-01-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (691,'FONNARD','LUCIENNE','1954-03-24','02.53.49.38.82','06.87.17.39.70',NULL,'4 RUE DES SOURCES','','','14930','MALTOT',NULL,NULL,'2540314057001',8.000000000,'1979-07-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (692,'LAHAYE','Agnes','1935-07-17','02.11.32.29.75','06.11.55.20.93',NULL,'97 RUE DES ACACIAS','','',NULL,NULL,NULL,NULL,'1350714568001',27.000000000,'1958-03-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (693,'VOYER','MARIE CLAUDE','1951-03-06','02.63.54.05.46','06.45.92.34.15',NULL,'16 RUE DES CANADIENS','','',NULL,NULL,NULL,NULL,'1510350234001',813.000000000,'1972-04-01','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (694,'GUERIN','DANIEL','1932-01-04','02.17.31.25.77','06.39.44.24.25',NULL,'6 RUE DU BEL AIR','','','14360','TROUVILLE SUR MER',NULL,NULL,'2320114408001',3.000000000,'1954-07-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (695,'FISCHER','DANIEL','1969-07-10','02.70.21.57.10','06.67.19.59.58',NULL,'8 RUE LEON BLUM','','',NULL,NULL,NULL,NULL,'1690714109001',408.000000000,'1990-07-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (696,'MORIN','','1937-01-30','02.11.72.72.64','06.47.01.87.75',NULL,'1 RUE ST ANDRE','','',NULL,NULL,NULL,NULL,'2370161192001',5058.000000000,'1958-07-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (697,'DENOYES','marguerite','1930-01-04','02.64.51.87.56','06.44.07.28.95',NULL,'CHEMIN DES MARAIS','','',NULL,NULL,NULL,NULL,'1300150214001',458.000000000,'1951-12-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (698,'COLLET','DOMINIQUE','1953-06-12','02.69.25.98.87','06.37.74.95.32',NULL,'13 RUE DE LA REPUBLIQUE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2530661291001',89.000000000,'1974-01-21','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (699,'DENIER','MARTHE','1929-10-18','02.34.28.16.31','06.60.90.58.85',NULL,'144 BD LEROY','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2291014408001',192.000000000,'1951-07-21','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (700,'SYRYN','VERONIQUE','1933-02-22','02.30.70.06.95','06.94.66.82.79',NULL,'34 rue de cormelles','','',NULL,NULL,NULL,NULL,'1330214348001',720.000000000,'1960-05-15','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (701,'DUCHEMIN','THERESE','1939-12-31','02.77.58.03.79','06.11.18.58.47',NULL,'28 rue georges clmenceau','','',NULL,NULL,NULL,NULL,'2391214500001',34.000000000,'1963-07-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (702,'RABASSE','JEAN','1959-01-07','02.87.37.83.21','06.70.62.98.15',NULL,'4 impasse des glantiers','','',NULL,NULL,NULL,NULL,'2590114311001',795.000000000,'1982-07-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (703,'MINERBE','BERNARD','1962-09-08','02.12.77.88.28','06.51.50.84.52',NULL,'LE MESNIL TOUFFRAY','','',NULL,NULL,NULL,NULL,'1620914319001',1838.000000000,'1986-02-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (704,'MURER','JEANNE','1929-01-24','02.22.13.99.95','06.49.31.11.93',NULL,'22 RUE DES MESANGES','','',NULL,NULL,NULL,NULL,'2290114408001',412.000000000,'1953-01-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (705,'LELANDAIS','JOSEPH','1929-01-09','02.12.72.48.61','06.12.40.44.78',NULL,'46 RUE DE L''EGLISE','','',NULL,NULL,NULL,NULL,'2290114634001',229.000000000,'1954-01-31','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (706,'LAMBERT','MARTINE','1935-04-13','02.15.13.57.72','06.80.89.92.19',NULL,'7 rue de villiers','','','14840','DEMOUVILLE',NULL,NULL,'1350415118001',31.000000000,'1965-03-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (707,'BARBE','DENISE','1931-01-04','02.12.67.00.66','06.24.59.80.76',NULL,'1 rue elsa triolet','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1310114126001',209.000000000,'1958-02-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (708,'DESCHAMPS','ROLAND','1937-12-29','02.71.16.19.40','06.76.58.85.95',NULL,'4-4 rue de l''arbalette','','',NULL,NULL,NULL,NULL,'2371214704001',83.000000000,'1963-01-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (709,'LEMAIRE','THERESE','1928-04-15','02.44.63.12.51','06.10.67.04.28',NULL,'19 bvd alsace lorraine','','','14123','IFS',NULL,NULL,'1280450182001',25.000000000,'1958-05-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (710,'LECHAT','YVETTE','1934-09-20',NULL,NULL,NULL,'7 RUE FRANCK REES','','','14700','FALAISE',NULL,NULL,'1340914540001',221.000000000,'1959-12-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (711,'JOSEPHINE','LILIANE','1935-12-08','02.53.06.32.93','06.68.94.52.69',NULL,'RESIDENCE LES TROTTEBEC APPT7','','','14000','CAEN',NULL,NULL,'1351214610001',84.000000000,'1958-01-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (712,'PELCOQ','DENISE',NULL,'02.24.24.47.49','06.65.90.71.34',NULL,'24 rue l lecornu','','','14000','CAEN',NULL,NULL,'1510114118001',8.000000000,'2012-12-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (713,'ROBERT','SIMONE','1929-08-02','02.44.02.76.93','06.55.87.63.44',NULL,'12.2 RUE DES MARGUERITES','','',NULL,NULL,NULL,NULL,'1290883124001',502.000000000,'1956-10-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (714,'AUZOU','EVELYNE','1932-11-17','02.74.41.02.81',NULL,NULL,'16 BIS PLACE ST MARTIN','','',NULL,NULL,NULL,NULL,'1321114479001',145.000000000,'1958-08-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (715,'GRENIER','CHRISTIANE','1936-07-14','02.44.07.47.55','06.40.50.46.17',NULL,'9 RUE DE BERNAY','','','14730','GIBERVILLE',NULL,NULL,'1360714047001',1172.000000000,'1957-07-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (716,'PORQUET','RENE','1935-01-04','02.50.27.30.34','06.82.56.88.25',NULL,'25 RUE DU DR BRANLY','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2350149002001',75.000000000,'1956-06-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (717,'LOREL','ALICE','1931-09-08','02.18.62.20.43','06.12.32.61.83',NULL,'37 RUEJEAN MERMOZ','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1310902071001',152.000000000,'1953-02-03','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (718,'MAUGER','BERNADETTE','1936-09-11','02.86.87.65.58','06.21.70.79.32',NULL,'171 RUE D AUGE','','','14120','MONDEVILLE',NULL,NULL,'1360914701001',57.000000000,'1959-05-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (719,'MARIE','JACQUELINE','1948-04-02','02.68.61.17.89','06.87.70.21.25',NULL,'4 ALLEE DES AUBEPINES','','','14310','VILLERS BOCAGE',NULL,NULL,'2480414213001',37.000000000,'1970-11-08','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (720,'JEHANNE','ELIANE','1936-05-20','02.89.59.68.11','06.37.80.41.91',NULL,'9 rue p de courbertin','','','14120','MONDEVILLE',NULL,NULL,'1360514651001',160.000000000,'1963-03-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (721,'GAUBERT','CHARLES','1937-01-12','02.22.05.46.44','06.71.49.78.08',NULL,'LA MADELEINE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2370114422001',598.000000000,'1962-06-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (722,'SOISMIER','PAULETTE','1931-11-16','02.82.48.68.08','06.50.76.42.09',NULL,'le val de cis','','','61100','FLERS',NULL,NULL,'2311150641001',1456.000000000,'1952-02-14','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (723,'ANNE','LEON','1937-11-20','02.91.57.15.12','06.55.76.42.23',NULL,'14 rue r le magnifique','','','14730','GIBERVILLE',NULL,NULL,'1371114469001',21.000000000,'1961-06-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (724,'MATHISSART','NELLY','1964-10-13','02.23.47.89.62','06.43.64.92.33',NULL,'3 BIS RUE DAMOZANNE','','','14000','CAEN',NULL,NULL,'2641050409001',73.000000000,'1985-10-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (725,'MARIE','RENE','1962-05-07','02.12.72.09.92','06.91.17.59.67',NULL,'14 rue de la cayriere','','','14000','CAEN',NULL,NULL,'2620514170001',3580.000000000,'1983-01-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (726,'BREANT','GISELE','1928-11-30','02.10.47.14.08','06.55.97.97.55',NULL,'LES PEDOUZES','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2281114039001',798.000000000,'1952-06-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (727,'LE BRIZAUT','DANIELLE','1930-10-12','02.84.41.73.22','06.74.74.80.05',NULL,'29 rue d argouge porte 400','','','14170','HIEVILLE',NULL,NULL,'2301014241001',41.000000000,'1953-05-27','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (728,'LE BATARD','MARTHE','1957-02-06','02.68.80.96.77','06.37.02.86.23',NULL,'56 rue des caillouins','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1570214367001',1330.000000000,'1979-06-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (729,'ARMAND','EMILE','1958-02-24','02.79.50.42.27','06.76.84.83.87',NULL,'16 RUE DU 15 JUIN','','','14000','CAEN',NULL,NULL,'2580214315001',150.000000000,'1980-05-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (730,'LEGIRET','BERNARD','1929-12-18','02.10.75.88.49','06.75.29.92.83',NULL,'LE BOURG LOPIN','','','14000','GIBERVILLE',NULL,NULL,'1291214236001',75.000000000,'1954-06-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (731,'HOUEIX','PIERRE','1939-02-16','02.37.32.67.15','06.11.08.58.12',NULL,'3 rue a dumas','','','14250','ELLON',NULL,NULL,'2390278600001',152.000000000,'1963-04-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (732,'PICHON','GINETTE','1955-01-13','02.38.88.36.92','06.72.34.13.24',NULL,'4 RUE LA HAUTE GUETTE','','','14670','TROARN',NULL,NULL,'2550114312001',72.000000000,'1976-05-21','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (733,'FRANCOISE','DOMINIQUE','1952-10-15','02.24.68.03.45','06.84.20.17.90',NULL,'ROUTE D AROMANCHE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2521014379001',24.000000000,'1977-02-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (734,'QUINTAINE','MICHELE','1931-02-12','02.34.61.88.47','06.95.48.19.91',NULL,'8 RUE PABLO PICASSO','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1310214337001',68.000000000,'1954-07-24','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (735,'LANGLINE','RAYMOND','1936-06-19','02.99.25.21.04','06.94.86.81.84',NULL,'3 CITE DES JARDINS','','','14310','VILLERS BOCAGE',NULL,NULL,'1360614087001',562.000000000,'1959-02-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (736,'LAMENDOUR','THERESE','1932-01-21','02.27.66.21.37','06.75.80.39.14',NULL,'1603 GRANDE DELLE','','','14000','CAEN',NULL,NULL,'1320114320001',939.000000000,'1960-12-26','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (737,'QUETEL','JEAN EDOUARD','1965-03-22','02.12.36.12.66','06.10.84.49.77',NULL,'clairtison','','','14460','COLOMBELLES',NULL,NULL,'1650314245001',479.000000000,'1988-09-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (738,'FABLET','CLAUDE','1934-10-05','02.77.29.34.77','06.89.42.68.75',NULL,'33 RUE PERE SANSONU','','','14220','BOULON',NULL,NULL,'1341014516001',17.000000000,'1958-09-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (739,'POUSSIER','JEAN PAUL','1929-05-26','02.48.61.41.31','06.74.94.19.01',NULL,'15 CHEMIN DES BOIS','','','14210','MISSY',NULL,NULL,'2290535291001',18.000000000,'1953-01-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (740,'LETOURNEUR','ROGER','1942-03-21','02.27.63.69.29','06.54.50.61.93',NULL,'68 RUE ARMAND MARIE','','','14350','BEAULIEU',NULL,NULL,'2420314336001',137.000000000,'1965-02-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (741,'MICHEL','DELPHIN','1934-12-29','02.60.41.25.13','06.75.77.56.96',NULL,'12 RUE MOZART','','','14220','OUFFIERES',NULL,NULL,'1341214335001',1851.000000000,'1961-11-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (742,'LACAILLE','CLAUDINE','1933-01-01','02.43.20.75.04','06.13.84.49.14',NULL,'12 AVENUE JACQUES PREVERT','','','14340','CREVECOEUR EN AUGE',NULL,NULL,'2330177126001',780.000000000,'1963-11-23','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (743,'TURGIS','GISELE','1943-02-24','02.11.49.02.27','06.83.29.14.82',NULL,'31 RUE DU PRESSOIR','','','14123','FLEURY SUR ORNE',NULL,NULL,'2430214682001',24.000000000,'1964-04-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (744,'DORNIER','EMILE','1948-01-30','02.11.79.33.48','06.15.31.45.03',NULL,'16 RUE DE BEAUVOIR','','','14111','LOUVIGNY',NULL,NULL,'2480114376001',118.000000000,'1975-04-03','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (745,'AMELINE','BERNARD','1930-04-03','02.71.76.23.84','06.58.76.64.99',NULL,'28 RUE VAL ES DUNE','','','61350','PASSAIS LA CONCEPTION',NULL,NULL,'2300414714001',261.000000000,'1953-02-09','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (746,'JAMES','Jacqueline','1960-10-16','02.80.30.37.12','06.79.99.55.05',NULL,'23 allee des poetes','','','14120','MONDEVILLE',NULL,NULL,'2601014112001',99.000000000,'1984-09-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (747,'CHOPIN','MAX','1951-02-22','02.49.88.14.70','06.11.72.14.08',NULL,'12 avenue Charles de Foucault','','','14000','CAEN',NULL,NULL,'1510214732001',115.000000000,'1975-01-31','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (748,'TOLLEMER','LINA','1953-01-29','02.17.12.66.03','06.82.06.42.17',NULL,'6 RUE DES TILLEULS','','','83460','LES ARCS',NULL,NULL,'2530172256001',1665.000000000,'1976-06-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (749,'MARIE','GISELE','1954-01-26','02.32.66.36.48','06.48.70.54.82',NULL,'58 GRANDE RUE','','','14120','MONDEVILLE',NULL,NULL,'1540114532001',176.000000000,'1984-08-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (750,'BAZEILLE','THIERRY','1967-02-26','02.31.68.17.53','06.50.20.48.68',NULL,'31 RUE DES FRERES BOUTROIS','','','77100','MEAUX',NULL,NULL,'1670214407001',114.000000000,'1991-12-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (751,'BENJENEC','ODETTE','1959-01-02','02.59.51.28.89','06.91.37.52.33',NULL,'49 RUE HECTOR BERLIOZ','','','14000','CAEN',NULL,NULL,'2590114258001',9.000000000,'1983-08-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (752,'TAFFIN','CLAUDINE','1925-01-19','02.61.11.94.38','06.11.92.08.02',NULL,'route de la folie','','','14123','IFS',NULL,NULL,'1250132029001',50.000000000,'1947-04-20','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (753,'VANOVERBEKE','PAUL','1939-08-19','02.43.09.53.52','06.28.34.40.92',NULL,'22 rue du 7 aout 1944','','','14160','DIVES SUR MER',NULL,NULL,'2390814736001',128.000000000,'1963-05-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (754,'BREHON','GABRIEL','1940-06-16','02.44.55.94.37','06.48.00.94.71',NULL,'13 RUE DU DR ROUX','','','14000','CAEN',NULL,NULL,'1400656036001',474.000000000,'1962-12-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (755,'MAUREY','MAURICE','1939-12-15','02.85.00.00.48','06.36.43.34.24',NULL,'8 ALLEE DE LA VARENDE','','','14800','TOUQUES',NULL,NULL,'2391214008001',26.000000000,'1965-08-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (756,'RICHARD','BERNADETTE','1929-11-06','02.10.53.75.22','06.10.09.23.93',NULL,'18 RUE DE LA DIVES','','','61200','ARGENTAN',NULL,NULL,'2291114698001',542.000000000,'1950-06-09','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (757,'ROLLAND','GERARD','1936-06-05','02.49.01.80.87','06.37.99.44.42',NULL,'129 BD RAYMOND POINCARE','','','14370','ARGENCES',NULL,NULL,'2360614649001',20.000000000,'1966-09-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (758,'MARIE','MONIQUE','1935-05-04','02.57.48.26.13','06.10.98.18.99',NULL,'82 RUE VICTOR LEPINE','','','14000','CAEN',NULL,NULL,'1350550475001',91.000000000,'1965-05-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (759,'ROGER','GILBERT','1951-01-06','02.71.68.34.82','06.11.95.34.18',NULL,'31 rue de formigny','','','14220','BOULON',NULL,NULL,'1510114009001',1532.000000000,'1976-12-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (760,'LEPAGE','ALEXIA','1929-05-30','02.69.55.05.10','06.34.75.64.45',NULL,'7 rue des ancien d''afn','','','50180','AGNEAUX',NULL,NULL,'2290514643001',2854.000000000,'1958-08-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (761,'TURBAN','BRIGITTE','1930-12-10','02.72.44.47.68','06.54.80.02.64',NULL,'1 RESIDENCE DES PINCONS','','','14490','CAHAGNOLLES',NULL,NULL,'1301214506001',13.000000000,'1952-01-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (762,'LEPETIT','MARIE','1929-04-04','02.31.91.28.93','06.89.61.62.01',NULL,'RUE BISSIERES','','','61230','ST EVROULT DE MONTFORT',NULL,NULL,'1290414733001',46.000000000,'1955-05-08','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (763,'DUPONT','JOCELYNE','1949-01-15','02.13.03.76.45','06.19.48.91.30',NULL,'7 rue du berry','','','14170','VENDEUVRE',NULL,NULL,'2490161152001',576.000000000,'1972-04-30','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (764,'JANET','MADELEINE','1950-03-31','02.86.29.73.42','06.41.23.46.59',NULL,'38 rue desmant','','','14190','ST SYLVAIN',NULL,NULL,'1500314113001',64.000000000,'1978-12-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (765,'CLATOT','HUBERT','1930-10-15','02.91.06.23.43','06.51.77.16.18',NULL,'16 rte de tilly','','','14610','ANISY',NULL,NULL,'1301014689001',1296.000000000,'1953-07-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (766,'ALLAIN','CHRISTOPHE','1930-08-25','02.84.89.36.67','06.65.93.16.89',NULL,'LONGCHAMPS','','','14123','FLEURY SUR ORNE',NULL,NULL,'1300814181001',61.000000000,'1952-01-19','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (767,'DELAQUAIZE','GILBERTE','1938-05-20','02.11.46.41.62','06.95.28.14.97',NULL,'10 RUE DES CHARDONNERETS','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1380561040001',91.000000000,'1968-11-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (768,'RAS','LUCIEN','1967-02-26','02.92.21.02.58','06.12.00.80.40',NULL,'7 rue porte millet les petites s','oeurs des pauvres','','14370','MOULT',NULL,NULL,'1670214407001',149.000000000,'1997-03-01','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (769,'DELASALLE','EMILE','1943-03-10','02.10.27.89.49','06.49.22.69.93',NULL,'13 RUE ARAGO','','','14670','TROARN',NULL,NULL,'1430361251001',26.000000000,'1973-03-17','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (770,'DELAITRE','DOMINIQUE','1936-01-28','02.79.18.67.78','06.38.05.17.17',NULL,'8 RUE GEORGES MAUDUIT','','','14490','BALLEROY',NULL,NULL,'1360114618001',199.000000000,'1964-12-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (771,'FESTOC','EUGENE','1933-12-09','02.47.94.28.12','06.65.58.98.24',NULL,'2 IMPASSE IRENE ET J.LOUIS CURIE','','','14380','ST SEVER CALVADOS',NULL,NULL,'2331214654001',35.000000000,'1957-01-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (772,'LANGLOIS','DANIELLE','1961-02-05','02.22.88.96.69','06.10.49.90.22',NULL,'10 rue leroy','','','14730','GIBERVILLE',NULL,NULL,'2610250354001',95.000000000,'1982-07-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (773,'CLEMENT','CLAUDE','1932-09-09','02.27.34.10.46','06.10.74.96.04',NULL,'ST MARDS DE BLACARVILLE','','','61100','FLERS',NULL,NULL,'1320914712001',14.000000000,'1962-05-26','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (774,'SILINE','ALI','1935-06-03','02.22.85.02.45','06.71.62.94.51',NULL,'2 rue du vercors','','','14000','CAEN',NULL,NULL,'1350614277001',46.000000000,'1959-04-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (775,'FLEURY','LOUIS','1932-01-06','02.71.47.09.29','06.88.38.89.10',NULL,'26 RUE GEORGES GAILLARD','','','14670','TROARN',NULL,NULL,'2320114133001',366.000000000,'1955-06-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (776,'ROBERT','bernard','1930-10-01','02.14.14.90.30','06.10.35.79.72',NULL,'26 RUE LEONARD GILLES','','','14000','CAEN',NULL,NULL,'2301014339001',91.000000000,'1951-02-18','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (777,'OSSEMONT','ROBERT','1935-10-18','02.66.63.37.03','06.20.06.74.55',NULL,'203 bis rue de falaise','','','14460','COLOMBELLES',NULL,NULL,'2351014590001',376.000000000,'1963-02-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (778,'BUSNOT','SIMONE','1935-10-11','02.40.21.40.80','06.30.01.08.52',NULL,'14 al  des poetes','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2351014590001',31.000000000,'1963-12-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (779,'EUDINE','ROGER','1940-12-09','02.20.46.25.84','06.70.31.63.80',NULL,'3 RUE DU NID DE CHIEN','','','14123','IFS',NULL,NULL,'2401278555001',2488.000000000,'1961-07-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (780,'BAUPIN','FELIX','1937-11-14','02.74.98.84.97',NULL,NULL,'3 RUE PASTEUR','','','50700','ST JOSEPH',NULL,NULL,'2371114045001',86.000000000,'1962-03-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (781,'PATERN','MARIE THERESE','1959-03-29','02.10.46.74.16',NULL,NULL,'CHEMIN DE L''HOPITAL','','','14610','BASLY',NULL,NULL,'1590314422001',1016.000000000,'1981-05-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (782,'FOSSEY','MICHEL','1932-03-20','02.65.91.81.75','06.35.86.49.80',NULL,'ROUTE DE MAIZIERES','','','14510','HOULGATE',NULL,NULL,'2320314201001',1715.000000000,'1953-05-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (783,'THEZARD','MICHEL','1940-05-15','02.30.60.68.26','06.40.40.84.35',NULL,'44 B RUE DE BAYEUX','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2400568250001',1014.000000000,'1963-10-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (784,'GUILBERT','BERNARD','1969-07-09','02.40.85.38.44','06.42.60.67.17',NULL,'RUE DU CLOS BAVENT','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2690780021001',92.000000000,'1992-01-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (785,'NOEL','MONIQUE','1966-02-10','02.76.59.30.58','06.56.76.20.92',NULL,'214 RUE D''AUGE','','','14710','RUBERCY',NULL,NULL,'1660214675001',414.000000000,'1995-01-05','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (786,'LORANT','DANIEL','1932-10-19','02.23.58.92.33','06.16.35.78.70',NULL,'5 RUE DU PETIT MARAIS','','','14850','HEROUVILLETTE',NULL,NULL,'1321014112001',30.000000000,'1956-06-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (787,'BRIONNE','JOSETTE','1938-12-04','02.11.34.54.03','06.16.11.64.00',NULL,'25 RUE DU GROS ORME','','','14170','L''OUDON',NULL,NULL,'1381214221001',35.000000000,'1959-05-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (788,'DRION','SIMONE','1936-06-03','02.27.44.60.00','06.62.95.13.87',NULL,'81 AVENUE JEAN JAURES','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1360614221001',27.000000000,'1959-09-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (789,'GRAS','THERESE','1933-01-25','02.58.55.07.83','06.11.34.37.02',NULL,'21 rue de persil','','','14120','MONDEVILLE',NULL,NULL,'2330114608001',32.000000000,'1955-11-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (790,'BERNIER','ISABELLE','1925-01-22','02.58.80.85.34','06.26.60.70.20',NULL,'1 CHEMIN DE ST AIGNAN','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1250132029001',216.000000000,'1946-05-23','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (791,'DEROUET','SIMONE','1939-10-06','02.86.88.58.61','06.65.44.17.48',NULL,'28 RUE DES TILLEULS','','','14880','HERMANVILLE SUR MER',NULL,NULL,'1391014667001',449.000000000,'1961-02-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (792,'DESLANDES','CLAUDE','1932-04-16','02.75.17.84.82','06.64.99.68.82',NULL,'5 RUE DES QUATRES VENTS','','','14270','MEZIDON CANON',NULL,NULL,'1320414436001',183.000000000,'1961-06-19','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (793,'DALIGAULT','GERARD','1940-10-30','02.11.12.90.82','06.56.38.57.61',NULL,'24 RUE VAN BEETHOVEN','','','14150','OUISTREHAM',NULL,NULL,'2401014730001',1294.000000000,'1961-03-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (794,'MOUCHEL','JEAN PIERRE','1924-01-11','02.77.11.65.25','06.20.66.57.72',NULL,'5 ROUTE DE LA HERSERIE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1240166090001',32.000000000,'1953-03-31','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (795,'LETALLEC','JEAN','1934-01-22','02.92.92.16.64','06.59.89.26.13',NULL,'80 RUE DE LA SEINE','','','14000','CAEN',NULL,NULL,'2340114026001',199.000000000,'1964-04-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (796,'TOUQUET','Michel','1956-08-31','02.87.03.16.18','06.90.94.99.00',NULL,'27 RUE DES CHANTERELLES','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1560814747001',89.000000000,'1978-03-19','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (797,'MARIE','LUCIEN','1937-08-10','02.63.39.52.04','06.15.80.04.66',NULL,'49 RESIDENCE DES CHARDONNERETS','','','14390','CABOURG',NULL,NULL,'1370814090001',3.000000000,'1959-12-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (798,'GASTON','JACKY','1939-10-28','02.87.39.66.78','06.11.57.18.95',NULL,'ALLEE DES FAUVETTES','','','14370','AIRAN',NULL,NULL,'1391014020001',1118.000000000,'1961-08-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (799,'DUPONT','MADELEINE','1928-08-25','02.26.08.41.29','06.65.72.81.38',NULL,'1685 RUE DE BRETTEVILLE','','','14111','LOUVIGNY',NULL,NULL,'1280814737001',1450.000000000,'1951-05-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (800,'LEBAILLY','SIMONE','1943-01-28','02.12.85.27.28','06.38.17.78.60',NULL,'2 impasse pierre lefevre','','','14350','LE BENY BOCAGE',NULL,NULL,'1430114618001',102.000000000,'1966-06-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (801,'LECOURT','SIMONE','1928-05-09','02.45.50.61.98','06.26.51.53.38',NULL,'16.3 grande rue','','','14000','CAEN',NULL,NULL,'2280514735001',205.000000000,'1954-08-17','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (802,'BERTRAND','YVES','1946-01-06','02.10.93.93.53','06.73.34.06.71',NULL,'8 rue du manoir','','','14620','DAMBLAINVILLE',NULL,NULL,'1460114736001',1.000000000,'1970-06-29','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (803,'FLAMBARD','LOUISE','1932-03-09','02.67.79.80.37','06.31.72.88.57',NULL,'','','','14700','ST MARTIN DE MIEUX',NULL,NULL,'2320314418001',600.000000000,'1959-10-11','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (804,'LAPORTE','MICHEL','1949-07-31','02.11.98.99.59','06.66.70.37.45',NULL,'98 AVENUE FOSCH','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1490714565001',157.000000000,'1972-11-12','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (805,'GESLIN','COLETTE','1938-10-02','02.41.34.65.41','06.10.33.64.70',NULL,'19 RUE DE L''OFFICIALITE','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2381050502001',4170.000000000,'1968-07-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (806,'RATTIER','YVES','1946-09-21','02.30.95.49.47','06.86.58.95.93',NULL,'LE CLOS COCHON','','','50550','ST VAAST LA HOUGUE',NULL,NULL,'2460921153001',223.000000000,'1967-05-18','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (807,'LAFFILARD','THERESE','1964-01-21','02.82.42.05.18','06.15.72.58.86',NULL,'le pavillon','','','50140','ROMAGNY',NULL,NULL,'2640160166001',49.000000000,'1988-09-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (808,'SALLIOT','COLETTE','1963-03-12','02.80.84.15.34','06.99.94.06.73',NULL,'20 RUE DES PERVENCHES','','','14370','MOULT',NULL,NULL,'1630314535001',41.000000000,'1984-04-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (809,'TREFEU','JOELLE','1954-01-31','02.39.63.92.51','06.61.71.17.43',NULL,'5 RUE DE L''ABBAYE','','','14000','CAEN',NULL,NULL,'2540114181001',3.000000000,'1981-02-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (810,'DESCLOS','RENEE','1933-07-06','02.55.63.00.67','06.50.62.25.10',NULL,'13 RUE DES PLATANES','','','14260','ROUCAMPS',NULL,NULL,'2330714173001',405.000000000,'1954-04-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (811,'MAUNY','HENRIETTE','1939-03-16','02.50.39.82.85','06.81.20.32.60',NULL,'23 RUE DES ROSIERS','','','14700','FALAISE',NULL,NULL,'1390314229001',40.000000000,'1963-08-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (812,'COTARD DUPARQUE','SERGE','1951-02-03','02.84.15.93.91','06.74.65.79.31',NULL,'17 RES ST JACQUES','','','14000','CAEN',NULL,NULL,'1510214712001',4720.000000000,'1976-04-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (813,'BOUTRY','MARC','1943-01-04','02.72.59.78.38','06.41.57.25.14',NULL,'356 RUE DE LA CHAPELLE','','','14530','LUC SUR MER',NULL,NULL,'1430102195001',165.000000000,'1965-12-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (814,'THOMASSE','HENRI','1958-04-23','02.85.67.35.00','06.27.89.26.03',NULL,'19 BD MARECHAL LYAUTEY','','','61210','NEUVY AU HOULME',NULL,NULL,'2580414327001',939.000000000,'1982-08-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (815,'PAGNON','ANDRE','1933-11-23','02.59.45.06.97','06.61.22.41.00',NULL,'25 rue salvador allende','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'2331114686001',127.000000000,'1958-07-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (816,'HASTAIN','alain','1936-05-19','02.81.21.77.09','06.37.57.85.77',NULL,'2 ALLEE DES ACACIAS','','','14320','FONTENAY LE MARMION',NULL,NULL,'2360550595001',1138.000000000,'1957-12-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (817,'DUVENT','SUZANNE','1957-02-22','02.47.31.88.62','06.26.64.57.02',NULL,'1312 RUE DU STADE','','','14000','CAEN',NULL,NULL,'1570250626001',362.000000000,'1981-02-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (818,'BENOIT','ANDRE','1969-12-03','02.53.50.77.93','00 33 6.25.82.22.18',NULL,'14 allee andre gides','','','14630','FRENOUVILLE',NULL,NULL,'2691214537001',34.000000000,'1993-12-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (819,'VASTEL','THIERRY','1949-06-25','02.14.36.02.99','06.19.34.48.51',NULL,'51 rue michel lasne','','','14540','ROCQUANCOURT',NULL,NULL,'1490614335001',237.000000000,'1974-05-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (820,'FRANCOIS','GERARD','1939-04-29','02.41.30.59.36','06.50.68.70.30',NULL,'3 rue du stade','','','14000','CAEN',NULL,NULL,'2390414247001',135.000000000,'1962-02-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (821,'LE NOEL','FLORENCE',NULL,'02.10.52.29.84','06.66.39.26.22',NULL,'2 chemin aux boeufs','','','14000','CAEN',NULL,NULL,'2631110420001',18.000000000,'2008-06-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (822,'DUCHEMIN','DENISE','1940-02-07','02.53.68.36.95','06.62.69.41.40',NULL,'1 rue bleriot','','','14120','MONDEVILLE',NULL,NULL,'2400250427001',175.000000000,'1965-11-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (823,'LAINE','Gaston','1937-07-22','02.38.67.77.49','06.27.13.93.17',NULL,'3 sente au coin','','','14630','CAGNY',NULL,NULL,'1370714708001',7.000000000,'1966-03-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (824,'GUILLOREAU','Jeannine','1944-03-26','02.88.41.92.38','06.11.21.89.56',NULL,'1 Frres des Vigouroux','','',NULL,NULL,NULL,NULL,'1440314037001',99.000000000,'1965-12-05','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (825,'DAVOULT','JOSIANE','1934-10-10','02.21.90.07.75','06.39.10.55.39',NULL,'7 RUE DES ACCACIAS','','','14850','ESCOVILLE',NULL,NULL,'2341014426001',187.000000000,'1957-11-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (826,'GRANDIERE','DOMINIQUE','1930-01-20','02.62.53.89.38','06.71.10.49.49',NULL,'37 bld des felibres','','','14000','CAEN',NULL,NULL,'2300150332001',617.000000000,'1958-03-04','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (827,'MOGIS','BERNARD','1930-05-28','02.50.81.05.83','06.84.00.70.34',NULL,'50 LE FRESNE','','','14370','ARGENCES',NULL,NULL,'1300514440001',5.000000000,'1954-02-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (828,'LE COHUE','SIMONE','1936-06-15','02.53.01.72.65','06.86.12.90.41',NULL,'23 ROUTE DU PONT DU COUDRAY','','','14160','DIVES SUR MER',NULL,NULL,'1360650149001',4003.000000000,'1957-08-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (829,'LAMBERT','MICHEL','1936-04-02','02.17.22.78.78','06.12.05.70.80',NULL,'30 RUE DE L EGLISE','','','14370','MOULT',NULL,NULL,'1360461263001',11.000000000,'1963-03-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (830,'LAMOTTE','YVETTE','1932-02-21','02.40.19.94.11','06.78.19.92.92',NULL,'235 RUE DE LA REPUBLIQUE','','','14860','AMFREVILLE',NULL,NULL,'1320214469001',223.000000000,'1957-09-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (831,'LEGRAND','THERESE','1937-05-17','02.54.06.79.30','06.35.33.36.21',NULL,'34 ROUTE DE CAEN','','','14270','MEZIDON CANON',NULL,NULL,'1370550074001',73.000000000,'1959-07-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (832,'MOTTIN','JEAN CLAUDE','1930-11-17','02.16.35.79.79','06.51.39.34.11',NULL,'12 RUE DE LA BARONNIE','','','14000','CAEN',NULL,NULL,'2301114698001',1128.000000000,'1953-06-13','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (833,'LEGIRET','RAYMOND','1938-04-17','02.56.26.66.60','06.10.12.49.09',NULL,'16 RUE ST EXUPERY','','','14190','CAUVICOURT',NULL,NULL,'2380414044001',941.000000000,'1960-07-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (834,'PLE','JOCELYNE','1969-12-31','02.16.80.25.24','06.56.27.69.20',NULL,'29 BOULEVARD RAYMOND POINCARE','','','14840','DEMOUVILLE',NULL,NULL,'1691292063001',104.000000000,'1990-05-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (835,'RICHARD','JEANNE','1936-08-05','02.11.88.80.40','06.95.58.87.84',NULL,'16 RUE  JEAN  GREMILLON','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1360814647001',49.000000000,'1957-08-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (836,'SAMSON','SYLVIE',NULL,'02.87.80.54.03','06.87.58.46.10',NULL,'7 rue alexandre','','','14120','MONDEVILLE',NULL,NULL,'2650414651001',1281.000000000,'2010-06-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (837,'LE NOEL','','1939-10-14','02.40.44.58.48','06.49.29.05.61',NULL,'11 AVENUE DU CHATEAU','','','50150','SOURDEVAL',NULL,NULL,'2391050226001',196.000000000,'1961-07-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (838,'PETITBOIS','DOMINIQUE','1936-03-31','02.43.85.66.63','06.63.97.31.01',NULL,'4 RUE GUILBERT','','','14220','ESSON',NULL,NULL,'1360314753001',58.000000000,'1957-09-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (839,'LANGRAND','','1936-12-20','02.40.54.49.10','06.47.97.23.10',NULL,'14 RUE DU CLOS DE LA MARE','','','14000','CAEN',NULL,NULL,'1361214271001',39.000000000,'1958-06-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (840,'POUTREL','DIDIER','1930-10-17','02.43.37.84.39','06.12.01.19.42',NULL,'la martelerie','','','14460','COLOMBELLES',NULL,NULL,'1301014221001',150.000000000,'1955-01-08','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (841,'BELLEE','FRANCOISE','1930-09-09','02.10.94.59.01','06.26.44.75.90',NULL,'120 RUE DU VILLAGE','','','14210','VACOGNES NEUILLY',NULL,NULL,'1300950117001',4542.000000000,'1958-03-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (842,'MAHEUT','HUBERT','1952-01-04','02.10.40.54.80','06.15.17.78.56',NULL,'LE CLOS JULIEN','','','14190','OUILLY LE TESSON',NULL,NULL,'1520114133001',80.000000000,'1975-07-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (843,'EUGENE','MARCEL','1986-07-13','02.10.26.16.19','06.15.47.23.53',NULL,'43 ROUTE DE BENEAUVILLE','','','14670','TROARN',NULL,NULL,'1860722123001',78.000000000,'2012-12-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (844,'COQUIN','MARCEL','1931-06-08','02.78.66.51.37','06.10.90.34.92',NULL,'18 RUE ST ANDRE  3 EME ETAGE POR','TE 27','','94500','CHAMPIGNY SUR MARNE',NULL,NULL,'2310614219001',77.000000000,'1961-06-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (845,'DESFEUX','EUGENIE','1950-01-25','02.33.88.70.35','06.59.15.60.13',NULL,'22 BIS RUE JOSEPH LEVILLY','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1500114752001',178.000000000,'1978-05-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (846,'EURY','CHRISTOPHE','1949-01-14','02.90.49.70.41','06.48.14.20.42',NULL,'26 rue l lecornu','','','14740','SECQUEVILLE EN BESSIN',NULL,NULL,'2490114225001',149.000000000,'1979-03-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (847,'BRAULT','MICHELLE','1949-01-18','02.85.64.83.49','06.77.60.97.06',NULL,'10 RUE GEORGES BRASSENS','','','14830','LANGRUNE SUR MER',NULL,NULL,'1490114747001',867.000000000,'1970-01-10','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (848,'LEFEBVRE','DIDIER',NULL,NULL,NULL,NULL,'3 impasse du home','','','14730','GIBERVILLE',NULL,NULL,'2391150601001',46.000000000,'2010-12-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (849,'CHEBANA','CLAUDE','1977-08-05','02.12.28.11.66','06.11.54.36.13',NULL,'9 ALLEE DES BOULOTS','','','14000','CAEN',NULL,NULL,'2770899322001',63.000000000,'2007-12-10','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (850,'TETI','HELENE','1937-02-05','02.68.89.98.29','06.83.63.79.69',NULL,'5 impasse de l''escalier','','','14840','DEMOUVILLE',NULL,NULL,'2370214300001',1272.000000000,'1959-08-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (851,'SICOT','BERNARD','1930-11-19','02.68.87.47.75','06.68.59.03.62',NULL,'6 rue de la paix','','','14630','CAGNY',NULL,NULL,'2301102401001',1059.000000000,'1951-12-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (852,'MULLOT','CHRISTIANE','1949-02-19','02.87.22.84.53','06.15.59.94.12',NULL,'ferme st nicolas','','','14610','EPRON',NULL,NULL,'1490250322001',132.000000000,'1971-08-14','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (853,'MULLOT','DANIEL','1933-08-30','02.53.52.00.98','06.12.57.57.76',NULL,'1402 quartier du bois','','','14880','HERMANVILLE SUR MER',NULL,NULL,'1330814675001',5.000000000,'1963-11-25','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (854,'ROMEUF','FERNANDE','1930-10-13','02.58.56.29.61','06.10.72.27.99',NULL,'52 RUE BELLEVUE','','','45200','AMILLY',NULL,NULL,'2301050013001',312.000000000,'1952-10-08','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (855,'PERIER','JACQUES','1937-10-19','02.85.81.99.76','06.97.07.93.10',NULL,'LA BERTHERIE','','','14250','LINGEVRES',NULL,NULL,'1371014557001',1186.000000000,'1959-08-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (856,'VINCENT','THIERRY','1966-02-05','02.54.75.43.30','06.42.34.02.33',NULL,'7 route de paris','','','50130','OCTEVILLE',NULL,NULL,'1660241070001',10.000000000,'1994-09-25','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (857,'OUZOUF','MONIQUE','1938-01-03','02.45.64.86.18','06.50.26.37.90',NULL,'5 AUTELS RUE DE LA FORGE','','','14000','CAEN',NULL,NULL,'2380114623001',18.000000000,'1960-04-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (858,'CHAMPS','MARIE-THERESE','1953-01-23','02.69.17.00.35','06.20.05.24.39',NULL,'2 IMPASSE PAUL ELIE GERMEZ','','','06000','NICE',NULL,NULL,'1530114497001',460.000000000,'1974-04-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (859,'FRANCOISE','REMI','1940-01-21','02.64.46.51.98','06.30.42.59.11',NULL,'1 chemin de coz-castel1','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2400114271001',5.000000000,'1970-03-18','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (860,'LOPES DOS SANTOS','SYLVIE','1963-05-23','02.55.97.26.43','06.30.47.36.97',NULL,'13 rue des coteaux','','','14210','ESQUAY NOTRE DAME',NULL,NULL,'2630514099001',146.000000000,'1984-02-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (861,'LAVILLE','SOLANGE','1981-12-31','02.47.66.60.78','06.98.14.70.58',NULL,'ru e des ecoles','','','14400','ST VIGOR LE GRAND',NULL,NULL,'1811299255001',537.000000000,'2011-07-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (862,'LEPAN','BERNARD','1953-06-13','02.96.68.42.62','06.48.33.29.41',NULL,'3 SQUARE LA VARONDE','','','14000','CAEN',NULL,NULL,'2530614651001',101.000000000,'1978-01-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (863,'ABRAHAM','CHRISTIANE','1968-08-13','02.30.71.97.43','06.64.55.57.99',NULL,'7 rue paul langevin','','','14850','HEROUVILLETTE',NULL,NULL,'2680814009001',5.000000000,'1991-11-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (864,'BENJDIR','ROGER','1931-07-23','02.99.54.59.38','06.52.07.21.98',NULL,'','','','14000','CAEN',NULL,NULL,'2310761074001',189.000000000,'1959-01-03','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (865,'LAMBERT','SIMONE','1933-02-08','02.47.64.20.91','06.10.28.49.42',NULL,'1 rue hector berlioz','','','14270','PERCY EN AUGE',NULL,NULL,'1330201265001',154.000000000,'1962-05-19','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (866,'POUCHIN','COLETTE','1933-02-17','02.11.57.58.20','06.74.30.75.39',NULL,'BRETTEVILLE LE RABET','','','14120','MONDEVILLE',NULL,NULL,'1330264445001',86.000000000,'1957-03-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (867,'GROSINI','PIERRE','1929-01-12','02.55.58.08.54','06.91.68.33.29',NULL,'22 REGIMENT DES MAISONS NEUVES','','','14000','CAEN',NULL,NULL,'1290161490001',109.000000000,'1952-02-16','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (868,'GOUEY','CLAUDE','1936-01-16','02.59.45.70.16','06.48.67.43.61',NULL,'30 BIS RUE DU MILIEU','','','14260','ST GEORGES D''AUNAY',NULL,NULL,'2360161505001',269.000000000,'1963-05-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (869,'EUGENE','BERNARD','1934-11-15','02.53.32.57.94','06.44.69.01.95',NULL,'30 rue de la montagne','','','61160','CHAMBOIS',NULL,NULL,'2341114224001',444.000000000,'1962-11-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (870,'BRION','ODETTE','1948-10-23','02.55.39.80.86','06.10.91.74.81',NULL,'36 rue eugenie','','','50270','BARNEVILLE CARTERET',NULL,NULL,'1481014178001',4726.000000000,'1972-12-29','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (871,'LETELLIER','MICHEL','1931-09-24','02.49.94.83.61','06.25.33.85.68',NULL,'5 avenue du 19 mars 1962','','','92700','COLOMBES',NULL,NULL,'1310914140001',1402.000000000,'1954-10-26','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (872,'LE MAGNEN','CLAUDETTE','1929-12-01','02.61.41.61.90','06.48.72.84.88',NULL,'168 QUARTIER DES BELLES PORTES','','','14000','CAEN',NULL,NULL,'2291214073001',62.000000000,'1951-05-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (873,'DERENEMESNIL','GENEVIEVE','1931-05-26','02.15.39.83.54','06.81.78.89.95',NULL,'1874 rte de bretteville','','','14730','GIBERVILLE',NULL,NULL,'1310514097001',119.000000000,'1952-11-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (874,'DERENEMESNIL','GERARD','1942-05-25','02.86.64.02.40','06.44.36.48.45',NULL,'29 bd raymond poincare','','','14160','BRUCOURT',NULL,NULL,'1420514665001',2940.000000000,'1965-11-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (875,'STETTLER','JOSETTE','1956-12-01','02.24.59.21.23','06.40.29.15.22',NULL,'LE BOURG','','','14220','FRESNEY LE VIEUX',NULL,NULL,'2561214657001',649.000000000,'1977-03-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (876,'TRICARD','JANE','1953-03-10','02.37.52.61.02','06.25.50.16.44',NULL,'3 RUE BERLIOZ','','','14240','CAUMONT L''EVENTE',NULL,NULL,'2530314119001',17.000000000,'1976-04-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (877,'CHOPIN','Jean louis','1957-01-14','02.36.89.28.47','06.17.39.15.98',NULL,'56 RUE DE L''ARQUETTE','','',NULL,NULL,NULL,NULL,'1570114407001',21.000000000,'1980-01-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (878,'ROUSSEL','LUCIENNE','1932-05-11','02.88.38.03.85','06.80.40.65.09',NULL,'cambridge 6 place wurzbourg n','2264','','14123','IFS',NULL,NULL,'1320572139001',78.000000000,'1962-12-07','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (879,'DESAUNAY','DENISE','1944-06-30','02.21.27.87.50','06.11.41.01.60',NULL,'9 RUE DE BRETAGNE','','','14210','AMAYE SUR ORNE',NULL,NULL,'1440650297001',117.000000000,'1971-04-21','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (880,'JOUAN','MARIE MARGUERIT','1962-09-26','02.69.01.61.13','06.63.91.19.38',NULL,'56 rue louis robillard cada sona','tra b 101','','14670','TROARN',NULL,NULL,'1620914328001',526.000000000,'1989-03-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (881,'GOUABAULT','MICHEL','1931-08-06','02.53.39.57.16','06.59.64.24.77',NULL,'19 RESIDENCE DU PARC','','','14730','GIBERVILLE',NULL,NULL,'2310814370001',12.000000000,'1960-05-04','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (882,'DETERVILLE','PIERRE','1936-08-26','02.11.95.88.56','06.29.07.25.65',NULL,'42 ROUTE DE PARIS','','','14540','BOURGUEBUS',NULL,NULL,'1360814990001',295.000000000,'1966-09-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (883,'DODOLIN','GEORGES','1927-10-07','02.77.17.64.27','06.73.25.42.58',NULL,'le lieu dit meheudin','','','50630','QUETTEHOU',NULL,NULL,'1271071279001',10.000000000,'1950-09-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (884,'DEMORTREUX','FRANCOISE','1931-04-08','02.37.99.99.02','06.10.32.84.80',NULL,'5 rue des perrees','','','14840','DEMOUVILLE',NULL,NULL,'1310427243001',506.000000000,'1952-05-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (885,'DEMORTREUX','CLAUDE','1931-01-02','02.38.71.63.31','06.56.56.43.27',NULL,'10 impasse des pommiers','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2310114221001',363.000000000,'1961-07-09','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (886,'GROSSET','CHRISTIAN','1940-07-13','02.56.24.78.50','06.28.17.75.05',NULL,'25 AVENUE PIERRE ET MARIE CURIE','','','14000','CAEN',NULL,NULL,'1400703071001',98.000000000,'1963-12-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (887,'BUTEL','YVETTE','1933-12-06','02.11.77.77.95','06.68.89.95.84',NULL,'LA RUFAUVIERE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1331214297001',28.000000000,'1954-02-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (888,'MAUBANT','JACQUELINE','1960-04-24','02.62.61.70.18','06.50.14.06.05',NULL,'35 RUE GEORGES POMPIDOU','','','14000','CAEN',NULL,NULL,'2600478670001',76.000000000,'1985-11-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (889,'LANOS','GILBERT','1936-02-14','02.70.77.50.28','06.74.25.70.51',NULL,'5 RUE DE LA MULLOISIERE','','','14000','CAEN',NULL,NULL,'1360245324001',197.000000000,'1962-06-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (890,'','JEAN','1954-04-12','02.11.90.46.86','06.81.00.21.89',NULL,'1 place de la liberte appt 14','','','14540','ROCQUANCOURT',NULL,NULL,'1540414530001',141.000000000,'1977-07-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (891,'PINEL','MICHEL','1939-01-06','02.47.51.89.58','06.62.84.98.41',NULL,'11 rue pasteur','','','14000','CAEN',NULL,NULL,'1390114646001',296.000000000,'1962-07-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (892,'MORAINE','SIMONE','1933-09-30','02.62.52.90.49','06.44.40.21.93',NULL,'168 RUE DE FALAISE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1330950446001',63.000000000,'1961-10-13','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (893,'SABINE','GEORGETTE','1931-09-11','02.71.74.22.96',NULL,NULL,'9 allee st marcouf','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2310914016001',2502.000000000,'1955-09-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (894,'DEPONT','YOLANDE','1946-03-11','02.16.87.32.34','06.10.80.72.33',NULL,'22 RUE DU PARC','','','14160','DIVES SUR MER',NULL,NULL,'1460314590001',76.000000000,'1968-02-04','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (895,'LETULLIER','ALBERT','1946-03-22','02.11.64.82.52','06.52.68.46.97',NULL,'3 PARVIS NOTRE DAME','','','14340','MANERBE',NULL,NULL,'1460314590001',418.000000000,'1968-02-28','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (896,'RATUSZNIK','CLAUDE','1940-05-03','02.74.70.22.04',NULL,NULL,'5 rue des anciens de l''afn','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2400527045001',707.000000000,'1962-01-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (897,'AILLET','MARCEL','1928-08-20','02.86.18.13.36','06.89.05.91.78',NULL,'22 rue pasteur','','','14123','IFS',NULL,NULL,'2280814182001',1717.000000000,'1956-08-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (898,'LEFEVRE','JANINE','1933-09-11','02.54.72.04.76','06.11.31.20.47',NULL,'2 chemine de caen','','','14120','MONDEVILLE',NULL,NULL,'2330914201001',5.000000000,'1960-09-09','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (899,'MESNIL','FABIENNE','1930-11-25','02.10.64.87.96','06.33.26.85.64',NULL,'515 rue du tour de ville','','','14840','CUVERVILLE',NULL,NULL,'2301114720001',240.000000000,'1951-04-23','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (900,'SOBOL','RAYMOND','1961-03-09','02.25.79.44.87','06.90.93.05.23',NULL,'34 RUE DE CHAMPAGNE','','','14430','DOUVILLE EN AUGE',NULL,NULL,'2610361135001',384.000000000,'1984-09-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (901,'DEMOOR','MAURICE','1966-01-27','02.19.83.65.75','06.91.04.10.51',NULL,'14 RUE DE LA HAIE BRETON','','','14270','MAGNY LE FREULE',NULL,NULL,'2660114057001',1166.000000000,'1991-08-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (902,'VIOLLET','ANNICK','1948-02-19','02.63.52.45.22','06.97.27.23.51',NULL,'','','','14800','TOUQUES',NULL,NULL,'2480250347001',362.000000000,'1976-12-28','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (903,'FRANC','ANDREE','1947-06-06','02.47.32.39.14','06.10.20.63.32',NULL,'15 rue du stade','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1470650129001',753.000000000,'1974-08-10','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (904,'LELONG','MICHELINE','1959-01-10','02.56.16.02.40','06.61.48.83.76',NULL,'LE MESNIL HERMIER','','','50500','CARENTAN',NULL,NULL,'2590114206001',21.000000000,'1984-07-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (905,'THIBOUT','BERNARD','1950-01-09','02.58.95.65.45','06.10.72.12.88',NULL,'12 rue gandhi','','','61200','ARGENTAN',NULL,NULL,'1500114746001',170.000000000,'1973-11-23','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (906,'LENEGRE','COLETTE','1959-02-13','02.59.99.04.28','06.41.86.41.69',NULL,'7 RUE DAMOZANNE','','','61570','ST LOYER DES CHAMPS',NULL,NULL,'2590214538001',93.000000000,'1983-03-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (907,'ROUSSEL','JEAN CLAUDE','1932-10-31','02.52.20.70.02','06.18.22.89.35',NULL,'15 rte de cabourg','','','14000','CAEN',NULL,NULL,'2321014409001',36.000000000,'1953-10-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (908,'COLETTI','WANDA','1928-03-28','02.62.27.33.70','06.21.39.57.91',NULL,'MAISONCELLES S/AJON','','','14000','CAEN',NULL,NULL,'2280350553001',76.000000000,'1951-08-14','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (909,'JOUENNE','Roger','1928-05-04','02.74.76.30.32',NULL,NULL,'12 RUE LECOMTE','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1280514220001',35.000000000,'1952-04-10','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (910,'FOUCHER','ROGER','1942-04-21','02.70.79.10.17','06.33.19.27.41',NULL,'2 rue du boulhoullay','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1420478239001',418.000000000,'1964-12-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (911,'ROGUE','JEANNE','1940-01-09','02.40.39.19.95','06.37.69.03.99',NULL,'8 rue j. catherine','','','14270','ERNES',NULL,NULL,'1400177280001',3.000000000,'1968-11-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (912,'HARTEL','PATRICK','1941-07-04','02.86.22.03.12','06.77.37.64.54',NULL,'10 rue louis braille','','','14370','AIRAN',NULL,NULL,'1410760219001',1098.000000000,'1965-10-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (913,'DUFEIL','YVETTE','1929-08-26','02.23.56.93.68','06.50.67.56.60',NULL,'76 AVENUE DE PARIS','','','61310','VILLEBADIN',NULL,NULL,'1290850515001',596.000000000,'1951-02-13','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (914,'BOULLIER','MADELEINE','1959-01-13','02.11.56.31.18','06.87.48.61.25',NULL,'8 RUE DU BERRY','','','14980','ROTS',NULL,NULL,'1590114719001',48.000000000,'1989-04-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (915,'CHAUVET','Jean pierre','1933-11-24','02.57.69.22.96','06.12.38.26.51',NULL,'1 RUE PIERRE LEPRESTRE','','','50160','GUILBERVILLE',NULL,NULL,'1331127169001',286.000000000,'1956-09-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (916,'ISABEL','FRANCOISE','1930-11-02','02.33.98.33.22','06.39.47.43.49',NULL,'27 RUE DU PONT CREON','','','14170','OUVILLE LA BIEN TOURNEE',NULL,NULL,'2301193710001',98.000000000,'1952-12-16','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (917,'HUE','GENEVIEVE','1956-05-02','02.47.24.98.63','06.63.69.52.78',NULL,'4 RUE DU STADE','','','14000','CAEN',NULL,NULL,'2560514049001',144.000000000,'1978-01-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (918,'EUDES','NICOLE','1940-06-24','02.58.78.95.25','06.13.35.63.58',NULL,'','','','14250','TILLY SUR SEULLES',NULL,NULL,'2400614228001',1394.000000000,'1969-06-08','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (919,'RIGOT','DOMINIQUE','1957-08-15','02.10.11.36.84','06.95.79.56.44',NULL,'RUE DES MESLIERS','','','14000','CAEN',NULL,NULL,'1570814502001',30.000000000,'1980-09-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (920,'DALISSON','LUCIEN','1938-01-29','02.76.90.18.13','06.65.91.44.68',NULL,'LA FERME DU BOURG','','','14190','OUILLY LE TESSON',NULL,NULL,'2380114060001',2068.000000000,'1962-10-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (921,'GODEFROY','JACKIE','1951-03-30','02.48.97.76.02','06.65.29.90.03',NULL,'CHEMIN DU DOUET NOLENT','','','14370','ARGENCES',NULL,NULL,'2510314176001',118.000000000,'1981-07-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (922,'LEBATARD','COLETTE','1959-01-23','02.83.06.43.26','06.26.91.82.05',NULL,'132 rue de poterie','','','83120','STE MAXIME',NULL,NULL,'1590114014001',104.000000000,'1981-03-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (923,'DESCHAMPS','PHILOMIN','1929-02-05','02.52.84.34.27','06.44.21.34.52',NULL,'LE BEAU TONNE','','','14370','ARGENCES',NULL,NULL,'1290261401001',833.000000000,'1952-01-17','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (924,'VANOVERBEKE','ODETTE','1928-10-02','02.11.62.86.04','06.69.59.76.42',NULL,'3 RUE DES PRIMEVERES','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2281014328001',354.000000000,'1949-03-26','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (925,'HEBERT','RAYMOND','1932-03-01','02.84.74.81.78',NULL,NULL,'7 rue du chateau d''eau','','','14000','CAEN',NULL,NULL,'1320314376001',269.000000000,'1953-12-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (926,'CHANTREUIL','Batrice','1930-12-17','02.44.80.46.49','06.94.42.56.93',NULL,'','','','14220','BOULON',NULL,NULL,'2301272220001',0.000000000,'1953-04-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (927,'LEMARQUAND','SIMONE','1965-02-21','02.83.69.42.90','06.36.93.79.37',NULL,'133 rue haute','','','14123','IFS',NULL,NULL,'1650214396001',167.000000000,'1991-02-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (928,'LEFEVRE','GEORGES','1969-04-23','02.61.47.39.89','06.55.04.77.71',NULL,'5 impasse des marniers','','','14940','SANNERVILLE',NULL,NULL,'1690437242001',5136.000000000,'1996-10-04','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (929,'COIGNEAUX','ARLETTE','1933-12-25','02.91.10.66.04','06.59.53.01.92',NULL,'17 rue paul eluard','','','14120','MONDEVILLE',NULL,NULL,'2331214200001',14.000000000,'1961-06-06','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (930,'BELMONTE','NATACHA','1936-02-16','02.70.84.80.35','06.23.28.50.93',NULL,'FONTAINE HALBOUT','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'1360261071001',388.000000000,'1957-07-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (931,'TESSIER','LUCIENNE','1968-12-01','02.11.90.86.37','06.41.47.99.98',NULL,'','','','14190','ESTREES LA CAMPAGNE',NULL,NULL,'1681214525001',1577.000000000,'1996-11-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (932,'GUILLARD','PASCAL','1968-12-20','02.64.84.08.20','06.51.72.03.81',NULL,'6 RUE DE LA MUTUALITE','','','14111','LOUVIGNY',NULL,NULL,'1681214525001',85.000000000,'1996-01-10','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (933,'MARIE','GERMAINE','1939-02-08','02.46.45.44.50','06.11.92.96.84',NULL,'7 route d ifs','','','14220','FRESNEY LE VIEUX',NULL,NULL,'1390214566001',106.000000000,'1963-01-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (934,'SIRAUT','PIERRE','1938-03-19','02.10.68.72.98','06.40.48.55.48',NULL,'2 RUE DES LILAS','','','14123','FLEURY SUR ORNE',NULL,NULL,'1380314157001',71.000000000,'1964-07-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (935,'GAIGNON','bernard','1932-09-07','02.16.12.34.72','06.64.34.88.22',NULL,'31 rue auguste lechesne','','','14860','BAVENT',NULL,NULL,'1320914449001',116.000000000,'1961-01-09','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (936,'ROBERT','','1937-12-21','02.78.10.92.71','06.82.93.80.06',NULL,'24 RUE BOULLEU','','','14700','FALAISE',NULL,NULL,'2371214485001',1045.000000000,'1960-07-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (937,'PRUNEAU','MARIE LAURENCE',NULL,'02.51.34.29.47','06.16.85.23.91',NULL,'2 rue de la liberation','','','14000','CAEN',NULL,NULL,'2660114386001',17.000000000,'2011-03-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (938,'LANCHAS','JEANINE','1937-12-18','02.77.29.05.18','06.37.35.64.05',NULL,'LE FEY','','','14160','DIVES SUR MER',NULL,NULL,'2371214211001',662.000000000,'1962-07-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (939,'RICHIER','Paulette','1951-02-08','02.15.81.87.36','06.58.19.91.28',NULL,'4 rue des ifs','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1510214499001',102.000000000,'1975-05-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (940,'CACHARD','Chantal','1934-04-19','02.53.61.00.88','06.23.31.45.91',NULL,'','','','14123','IFS',NULL,NULL,'1340414063001',259.000000000,'1962-11-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (941,'LORY','MARIETTE','1937-04-20','02.49.97.59.24','06.79.52.42.05',NULL,'909 Bd du Val','','','14000','CAEN',NULL,NULL,'1370414328001',25.000000000,'1958-08-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (942,'LAURENT','SYLVIE','1968-01-24','02.43.48.15.32','06.39.65.62.06',NULL,'14 rue ed herioz','','','14000','CAEN',NULL,NULL,'1680114384001',18.000000000,'1989-09-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (943,'FRANCOIS','ANDRE',NULL,'02.71.27.55.65','06.14.73.05.23',NULL,'10 RUE ALBERT BAYET','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2430314205001',1845.000000000,'2012-08-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (944,'BAUTMANS','PATRICIA','1961-05-07','02.53.99.48.61','06.35.80.06.31',NULL,'5 RUE LECHARTIER DE LA VARIGNIER','E','','14123','IFS',NULL,NULL,'1610572225001',46.000000000,'1988-12-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (945,'EURIN','RAYMOND','1933-02-01','02.23.54.83.26','06.31.29.25.90',NULL,'2 RUE DES VIKINGS','','','14123','FLEURY SUR ORNE',NULL,NULL,'1330214574001',554.000000000,'1961-11-22','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (946,'BEDEL','JANINE','1934-02-25','02.19.22.29.94','06.36.82.01.39',NULL,'9 RUE DES PETITES COUTURES','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'2340250288001',952.000000000,'1955-08-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (947,'DELACOUR','GERARD','1947-06-22','02.12.03.06.41','06.47.63.33.43',NULL,'residence les matine 10 avenue d','e paris','','14540','ROCQUANCOURT',NULL,NULL,'1470614339001',24.000000000,'1976-07-13','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (948,'GADY','ODETTE','1946-05-10','02.23.51.55.47','06.37.98.88.07',NULL,'9 RUE FRANCHE','','','14250','FONTENAY LE PESNEL',NULL,NULL,'2460536227001',169.000000000,'1970-07-02','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (949,'BOUZFOUR','LILIANE','1932-01-18','02.71.30.16.15','06.28.59.16.98',NULL,'10 rue pasteur','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1320114390001',1226.000000000,'1954-03-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (950,'BRIERE','THERESE','1938-11-21','02.45.67.53.12','06.21.65.80.14',NULL,'2 RUE AUGUSTE LECHESNE','','','14000','CAEN',NULL,NULL,'2381114714001',2217.000000000,'1961-07-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (951,'MARIE','JACQUES','1942-01-11','02.66.12.30.34','06.86.43.53.33',NULL,'74 RUE GENERAL DE GAULLE','','','14500','COULONCES',NULL,NULL,'1420114610001',180.000000000,'1965-03-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (952,'LECHEVALIER','JACQUES','1963-08-21','02.34.81.54.73','06.12.18.52.39',NULL,'29 RUE DE LA FOLIE','','','14370','VIMONT',NULL,NULL,'1630821460001',1644.000000000,'1989-02-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (953,'ROBERT','SERGE','1938-07-31','02.11.72.42.43','06.92.78.59.90',NULL,'7 RUE DES BOULEAUX','','','14190','FIERVILLE BRAY',NULL,NULL,'2380714218001',17.000000000,'1960-10-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (954,'LEBLANC','JEANINE','1935-07-21','02.52.70.01.84','06.52.65.88.11',NULL,'CHEMIN DU RIGOLET','','','14123','IFS',NULL,NULL,'2350750462001',202.000000000,'1958-06-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (955,'LEBENOIT','MARIE-CLAIRE','1935-05-14','02.38.57.58.45','06.88.62.58.31',NULL,'8 place pablo neruda','','','22730','TREGASTEL',NULL,NULL,'1350550281001',46.000000000,'1957-09-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (956,'TRANCHANT','SOLANGE','1940-07-16','02.34.02.29.11','06.95.55.44.92',NULL,'6 RUE DES SABLONS','','','14220','BARBERY',NULL,NULL,'1400772039001',80.000000000,'1970-08-23','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (957,'TRAVERS','YVETTE','1929-12-27','02.54.43.19.06','06.37.63.34.52',NULL,'21 RUE LEONARD GILLES','','','14111','LOUVIGNY',NULL,NULL,'2291214073001',1630.000000000,'1957-07-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (958,'GABRIEL','JANINE','1928-07-07','02.65.56.87.44','06.41.03.21.93',NULL,'GRANDE RUE','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'1280722143001',100.000000000,'1953-08-02','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (959,'RICHARD','RENEE','1959-03-23','02.10.06.65.41','06.24.84.11.73',NULL,'61 RUE DE FALAISE','','','14520','PORT EN BESSIN HUPPAIN',NULL,NULL,'2590361022001',102.000000000,'1989-12-29','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (960,'BRASIL','FRANCOISE','1929-11-06','02.85.02.70.37','06.50.20.43.02',NULL,'HAMEAU DE SOQUENCE','','','14730','GIBERVILLE',NULL,NULL,'2291114378001',155.000000000,'1952-11-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (961,'COLLET','DANIEL','1930-02-02','02.85.89.22.61','06.49.11.04.73',NULL,'9 BOULEVARD RICHEMOND','','','14460','COLOMBELLES',NULL,NULL,'1300272097001',9.000000000,'1957-05-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (962,'MARIE','NICOLE','1931-09-29','02.68.18.17.96','06.39.17.05.31',NULL,'6 avenue des chevaliers','','','14123','IFS',NULL,NULL,'2310914247001',1182.000000000,'1952-02-08','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (963,'FILOCHE','MICHEL','1939-03-05','02.26.58.08.44','06.48.83.61.78',NULL,'ROUTE DE BISSIERE','','','14340','CREVECOEUR EN AUGE',NULL,NULL,'2390314167001',130.000000000,'1969-12-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (964,'LEFEVRE','SUZANNE','1938-04-28','02.53.89.54.04','06.10.15.54.67',NULL,'8 rue des pres','','','50110','TOURLAVILLE',NULL,NULL,'2380461062001',48.000000000,'1962-10-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (965,'LEVANNIER','CHRISTIANE','1931-04-09','02.11.13.36.88','06.61.18.15.75',NULL,'ZA LE MARESQUIER','','','14000','CAEN',NULL,NULL,'2310435084001',80.000000000,'1954-03-08','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (966,'CARINI','JEANNINE','1930-09-29','02.12.08.27.80','06.65.14.44.74',NULL,'14 RUE LECONTE','','','14730','GIBERVILLE',NULL,NULL,'2300914326001',3626.000000000,'1952-12-27','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (967,'SIMEON','JACQUELINE','1950-05-15','02.99.68.34.10','06.81.81.19.39',NULL,'7 RUE JEAN MERMOZ','','','14000','CAEN',NULL,NULL,'2500514198001',26.000000000,'1979-03-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (968,'COLOMBE','MARC','1934-09-01','02.89.97.83.51','06.24.65.15.08',NULL,'7 rue roger bastion','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1340950544001',122.000000000,'1961-10-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (969,'SIMON','MARC','1932-07-11','02.97.52.14.49','06.55.46.86.21',NULL,'24 place du marche','','','14540','SOLIERS',NULL,NULL,'1320714416001',2640.000000000,'1955-05-20','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (970,'','NADINE','1956-03-20','02.72.98.35.51','06.59.15.03.06',NULL,'38 rue val es dunes','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2560314011001',156.000000000,'1984-04-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (971,'BREHAM','DENISE','1964-11-29','02.62.55.30.71','06.37.50.29.14',NULL,'la corniere','','','14000','CAEN',NULL,NULL,'1641199255001',34.000000000,'1987-08-30','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (972,'QUERTINMONT','GISELE','1968-01-24','02.41.77.35.96','06.47.60.02.23',NULL,'48 bd de la forbine','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1680153166001',38.000000000,'1992-01-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (973,'COISPEL','','1930-06-04','02.81.09.61.68','06.99.60.49.24',NULL,'3 rue saint sernin','','','14100','LISIEUX',NULL,NULL,'1300661397001',125.000000000,'1959-05-01','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (974,'DOINEL','CLAUDETTE','1966-01-11','02.17.32.28.53','06.83.50.98.66',NULL,'39 RUE DES ACCACIAS','','','14000','CAEN',NULL,NULL,'1660162557001',12.000000000,'1991-11-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (975,'MENARD','MARGUERITE','1939-09-26','02.33.37.62.47','06.10.27.43.17',NULL,'2 allee du general sismonds','','','14000','CAEN',NULL,NULL,'1390914261001',962.000000000,'1963-12-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (976,'PAVIE','FRANCOIS','1960-05-04','02.61.34.49.83','06.11.25.24.21',NULL,'','','','14370','CROISSANVILLE',NULL,NULL,'1600514482001',59.000000000,'1982-08-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (977,'CHETOUH','ERIC','1937-05-17','02.40.77.15.30','06.91.98.48.87',NULL,'LE BOURG','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1370550640001',11.000000000,'1958-08-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (978,'LACOUR','ISABELLE','1951-03-26','02.36.61.02.91','06.74.01.12.66',NULL,'3 RUE DES PLUVIERS','','','50500','CARENTAN',NULL,NULL,'1510361081001',23.000000000,'1974-07-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (979,'JENVRIN','MAURICE','1937-10-29','02.66.42.46.38','06.41.74.85.93',NULL,'5 CHEMIN DU MOULIN','','','14570','ST REMY',NULL,NULL,'1371061081001',1047.000000000,'1960-01-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (980,'HERICY','EDMONDE','1956-05-29','02.80.53.31.74',NULL,NULL,'LA FARCIERE','','','14130','ST GATIEN DES BOIS',NULL,NULL,'1560561208001',593.000000000,'1980-09-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (981,'BULTEY','PHILIPPE','1933-04-29','02.25.05.32.38','06.11.74.00.98',NULL,'79 RUE SAINT PATRICE','','','14370','ARGENCES',NULL,NULL,'1330414722001',156.000000000,'1954-05-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (982,'JAMES','GEORGES','1948-11-02','02.19.69.72.44','06.10.13.67.35',NULL,'8 BOULEVARD LONGUET','','','14500','VIRE',NULL,NULL,'1481128107001',20.000000000,'1972-06-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (983,'','MICHEL','1936-07-07','02.46.24.88.83','06.75.83.28.99',NULL,'11 RUE DES HOMMETS','','','14730','GIBERVILLE',NULL,NULL,'1360714120001',29.000000000,'1963-06-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (984,'BINET','GILLES','1955-04-08','02.82.14.95.31','06.95.56.13.36',NULL,'12 rue des sablonnettes','','','50300','LE VAL ST PERE',NULL,NULL,'2550427384001',160.000000000,'1979-06-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (985,'BOURREE','ROGER','1966-07-11','02.49.21.25.56','06.70.50.67.77',NULL,'14 rue du limousin','','','14960','MEUVAINES',NULL,NULL,'1660728390001',39.000000000,'1988-05-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (986,'JOUANNE','DANIELE','1959-01-05','02.88.52.49.89','06.75.98.09.32',NULL,'','','','14730','GIBERVILLE',NULL,NULL,'2590114057001',3553.000000000,'1986-02-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (987,'PESNELLE','CHRISTIAN','1939-06-29','02.12.27.32.76','06.33.81.72.37',NULL,'5 RUE LUCIE MANGEMATIN FOYER GOU','ESLARD','','14000','CAEN',NULL,NULL,'1390661197001',429.000000000,'1960-02-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (988,'ARZUR','CHARLES','1931-09-21','02.39.99.07.82','06.11.92.67.88',NULL,'8 RUE CORISANDE','','','14840','DEMOUVILLE',NULL,NULL,'1310914760001',350.000000000,'1955-09-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (989,'BONNET','ANDREE','1938-04-28','02.43.46.70.25','06.25.42.09.35',NULL,'LIEU DIT MONT ROTI','','','14000','CAEN',NULL,NULL,'2380461030001',3867.000000000,'1968-07-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (990,'GEFRAIN','THIERRY','1950-03-02','02.98.01.66.08','06.11.50.48.12',NULL,'QUARTIER DE L''EGLISE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1500314610001',856.000000000,'1975-06-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (991,'TOMBETTE','MAURICE','1929-01-09','02.53.58.61.81','06.14.56.36.23',NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2290149143001',33.000000000,'1950-07-02','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (992,'SAVARY','THERESE','1936-02-25','02.12.03.64.45','06.98.04.95.16',NULL,'RUE DU VAL DE QUESNAY','','','14123','IFS',NULL,NULL,'2360250609001',69.000000000,'1962-05-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (993,'FOUCHER','CHRISTIANE','1963-02-14','02.61.31.63.15','06.19.61.04.13',NULL,'7 RUE ANDRE PIERRE MARIE','','','14000','CAEN',NULL,NULL,'1630214057001',34.000000000,'1993-04-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (994,'RAULINE','MICHEL','1936-12-24','02.23.93.34.18','06.23.41.35.92',NULL,'109 bd general vasnier','','','61200','FLEURE',NULL,NULL,'2361214118001',525.000000000,'1965-08-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (995,'CULOT','GILBERT','1930-07-20','02.49.60.43.22','06.32.52.94.32',NULL,'la hogue','','','14123','IFS',NULL,NULL,'2300750002001',133.000000000,'1955-11-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (996,'BLOUET','ROGER','1964-03-14','02.10.95.61.96','06.11.33.82.52',NULL,'2-1 ALLEE SERPENTINE','','','14000','CAEN',NULL,NULL,'1640350545001',126.000000000,'1991-03-29','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (997,'JAGUIN','SUZANNE','1930-03-15','02.17.21.17.19','06.54.59.90.21',NULL,'LE PARC DAVOUST','','','14000','CAEN',NULL,NULL,'2300314137001',10.000000000,'1953-05-23','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (998,'','GERARD','1940-02-04','02.70.56.81.40','06.89.99.14.17',NULL,'36 rue du 07 aout 1944','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'2400214695001',36.000000000,'1970-08-28','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (999,'GERMOND','christophe','1957-03-27','02.12.09.89.85','06.38.26.66.58',NULL,'ROUTE DE FONTAINE HENRY','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1570361360001',8.000000000,'1978-11-21','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1000,'LEMAHIEU','ERIC','1982-01-26','02.21.73.37.48','06.11.60.13.88',NULL,'16 RUE DE L''EGLISE','','','14630','CAGNY',NULL,NULL,'2820199253001',127.000000000,'2004-05-19','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1001,'BAUCHER','NOELLE','1936-07-17','02.79.04.89.04','06.51.06.92.69',NULL,'7 RUE DE LA COOPERATIVE','','','14840','DEMOUVILLE',NULL,NULL,'1360735137001',503.000000000,'1957-11-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1002,'BARON','Michel','1964-06-08','02.12.04.16.76','06.39.52.34.82',NULL,'14 RUE DE BURON','','','14260','AUNAY SUR ODON',NULL,NULL,'1640675041001',198.000000000,'1987-07-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1003,'BEAUDRON','Michel','1939-05-05','02.64.86.08.95','06.12.08.70.06',NULL,'34 RUE DES TILLEULS','','','14460','COLOMBELLES',NULL,NULL,'2390550530001',1250.000000000,'1962-01-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1004,'FORTIN','CHRISTOPHE','1955-03-01','02.17.37.63.81','06.81.29.97.08',NULL,'7 rue de la vallee','','','14700','FALAISE',NULL,NULL,'2550361430001',15.000000000,'1983-11-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1005,'GROSOS','GUY','1940-03-28','02.39.07.24.65','06.34.90.23.41',NULL,'15 rue des bons enfants','','','14000','CAEN',NULL,NULL,'1400314060001',329.000000000,'1968-04-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1006,'DUBOC','WILLIAM','1935-05-15','02.46.59.26.42','06.62.65.12.15',NULL,'2 avenue de la concorde','','','14260','AUNAY SUR ODON',NULL,NULL,'1350514340001',56.000000000,'1958-07-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1007,'JOSEPH','SIMONE','1938-07-23','02.11.96.42.69','06.28.10.83.26',NULL,'5 RUE ROGER POULAIN','','','61200','ARGENTAN',NULL,NULL,'1380714349001',1910.000000000,'1962-02-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1008,'BOURGOIS','OLIVIER','1930-02-21','02.11.43.88.79','06.12.42.24.41',NULL,'11 ALLEE DE VARSOVIE','','','14000','CAEN',NULL,NULL,'2300261173001',844.000000000,'1953-12-18','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1009,'LE FRAPPER','DOMINIQUE','1936-06-26','02.48.71.43.79','06.55.95.69.33',NULL,'9 RUE DU TEMPS PERDU','','','14000','CAEN',NULL,NULL,'2360614116001',41.000000000,'1957-03-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1010,'MARIE','HERVE','1933-11-20','02.14.29.21.33','06.12.26.96.10',NULL,'21 RUE ST JEAN BAPTISTE','','','14740','STE CROIX GRAND TONNE',NULL,NULL,'2331114461001',172.000000000,'1956-08-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1011,'HUET','GERARD','1950-03-08','02.54.47.37.11','06.16.54.05.91',NULL,'24 ROUTE DE PARIS','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2500350262001',197.000000000,'1972-01-18','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1012,'BRAULT','GERARD','1933-05-22','02.83.99.15.52','06.71.83.82.94',NULL,'401 BD DU VAL','','','14000','CAEN',NULL,NULL,'2330514544001',1808.000000000,'1956-04-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1013,'OLIVE','eugene','1934-02-15','02.48.23.76.93','06.23.20.79.35',NULL,'15 RUE LEON JOUHAUX','','','14410','VASSY',NULL,NULL,'1340214714001',19.000000000,'1955-07-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1014,'LAGRAVE','BERNARD','1952-01-17','02.62.62.98.25','06.98.82.44.02',NULL,'18 porte millet','','','14570','LE VEY',NULL,NULL,'2520114195001',881.000000000,'1981-01-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1015,'LEMOIGNE','EMILIENNE','1939-05-02','02.12.10.84.11','06.83.68.41.94',NULL,'LE VAL D''OR APPT 21 18 RUE R.AI','NI','','14000','CAEN',NULL,NULL,'1390559580001',3443.000000000,'1962-11-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1016,'BALLIERE','lucie','1929-10-17','02.37.05.48.90','06.16.07.90.41',NULL,'rue des haies d''argence','','','14860','BAVENT',NULL,NULL,'2291021404001',63.000000000,'1954-05-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1017,'MAURICE','JEAN CLAUDE','1940-05-03','02.60.41.21.22','06.16.93.75.04',NULL,'residence de l''eglise bat b2 r1','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2400514304001',173.000000000,'1961-11-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1018,'ROUSSEL','MARIE JEANNE','1959-01-19','02.26.84.93.99','06.10.87.73.91',NULL,'9 rue jean le carpentier','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2590114271001',82.000000000,'1981-11-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1019,'KEDZIORA','EVELINE','1941-07-07',NULL,NULL,NULL,'10 RUE TESTE DE BUCH','','','14000','CAEN',NULL,NULL,'1410714499001',13.000000000,'1963-09-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1020,'BOISET','SYLVIE','1941-07-27','02.87.19.90.81','06.24.76.19.39',NULL,'34 RUE VICTOR HUGO','','','14270','MEZIDON CANON',NULL,NULL,'1410714499001',1666.000000000,'1965-12-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1021,'BEAUDOIN','MARIE-JEANNE','1938-12-18','02.21.21.98.57','06.30.71.39.13',NULL,'22 ROUTE DE GACE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2381250025001',34.000000000,'1961-06-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1022,'RATUSZNIK','MARIE','1938-12-12','02.82.25.95.75','06.35.15.67.72',NULL,'14 RUE PAUL LANGEVIN','','','14370','CLEVILLE',NULL,NULL,'2381250025001',478.000000000,'1961-11-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1023,'BEQUET','ANDREE','1955-05-23','02.33.21.64.00','06.99.18.92.89',NULL,'23 rue charles de foucault','','','14000','CAEN',NULL,NULL,'1550514548001',287.000000000,'1979-06-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1024,'MAISERAY','ARNAUD',NULL,'02.10.00.34.76','06.10.51.54.56',NULL,'48 ROUTE DE BENOUVILLE','','','14370','ARGENCES',NULL,NULL,'1520253199001',102.000000000,'2011-08-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1025,'CAPDEPON','CHANTAL','1967-07-04','02.29.70.09.24','06.50.73.08.99',NULL,'2 RUE DU PRESSOIR','','','50500','CARENTAN',NULL,NULL,'2670714107001',27.000000000,'1997-04-16','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1026,'DUBOURG','HENRIETTE','1932-08-19','02.21.09.11.62','06.20.01.69.51',NULL,'RESIDENCE HELITAS  33 RUE ST OUE','N','','14123','FLEURY SUR ORNE',NULL,NULL,'2320814140001',238.000000000,'1956-12-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1027,'MORICE','Gerard','1935-06-12','02.81.82.72.32','06.98.68.26.21',NULL,'15 RUE VICTOR HUGO','','','50320','LA LUCERNE D''OUTREMER',NULL,NULL,'1350614059001',408.000000000,'1958-12-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1028,'VAN WYNSBERGHE','SIMONE','1930-08-14','02.29.84.39.26','06.27.08.90.95',NULL,'101 impasse des cypres','','','61130','ST OUEN DE LA COUR',NULL,NULL,'2300850531001',105.000000000,'1953-04-08','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1029,'LANDAIS','JANINE','1961-01-31','02.64.18.85.73','06.10.51.14.57',NULL,'16 RUE DU PETIT PLAIN','','','14120','MONDEVILLE',NULL,NULL,'1610114109001',584.000000000,'1985-01-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1030,'GIRARD','PIERRE','1935-10-09','02.60.16.00.73','06.32.28.39.40',NULL,'CHEMINA DU BUISSON LIROSE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2351014266001',359.000000000,'1959-06-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1031,'TARRAGO','MARCEL','1933-12-19','02.36.05.37.49','06.35.64.10.91',NULL,'PLACE DE L''EGLISE','','','14190','FIERVILLE BRAY',NULL,NULL,'1331275018001',8.000000000,'1958-07-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1032,'BARBOTTE','MICHEL','1940-06-09','02.44.06.67.96','06.28.76.43.99',NULL,'811 quartier des belles portes','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1400650400001',38.000000000,'1961-11-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1033,'COTEL','HENRI','1956-08-13','02.10.29.44.49','06.72.96.59.37',NULL,'16 rue du puits picard','','','14270','CESNY AUX VIGNES OUEZY',NULL,NULL,'1560814747001',25.000000000,'1977-01-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1034,'BOUQUEREL','JEAN','1939-03-07','02.64.09.18.84','06.79.01.76.62',NULL,'6 rue alfred nobel','','','14000','CAEN',NULL,NULL,'2390361002001',493.000000000,'1969-01-14','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1035,'CARRE','CHRISTIAN','1939-07-17','02.70.84.20.15','06.15.46.45.74',NULL,'28 RUE DE L''ESPERANCE','','','14270','MEZIDON CANON',NULL,NULL,'1390714101001',3976.000000000,'1962-07-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1036,'LORIDAN','LILIANE','1948-03-31','02.67.31.67.94','06.10.76.49.39',NULL,'88 RUE CHAPRON','','','14000','CAEN',NULL,NULL,'2480314287001',588.000000000,'1970-12-11','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1037,'CASTEL','RAYMOND','1928-05-19','02.42.61.86.91','06.12.22.27.95',NULL,'38 RUE CALMETTE','','','14270','MEZIDON CANON',NULL,NULL,'2280514667001',1658.000000000,'1949-06-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1038,'LETELLIER','RAYMOND','1938-10-19','02.23.38.68.48','06.31.08.05.27',NULL,'887 rue du chemin vert','','','27330','LA BARRE EN OUCHE',NULL,NULL,'2381061237001',191.000000000,'1959-04-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1039,'','JACK','1926-02-18','02.10.13.15.90','06.11.83.38.76',NULL,'20 rue de caen','','','14160','DIVES SUR MER',NULL,NULL,'1260218082001',9.000000000,'1947-10-12','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1040,'LOPEZ','GERARD','1934-01-22','02.28.94.45.47','06.93.30.88.26',NULL,'1 blvd des ducs','','','14000','CAEN',NULL,NULL,'2340127613001',484.000000000,'1961-12-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1041,'BIDARD','Jeanne','1935-02-04','02.92.48.70.76','06.64.03.89.62',NULL,'50 RUE DE CUSSY','','','14000','CAEN',NULL,NULL,'2350214703001',200.000000000,'1961-10-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1042,'BRAULT','FATIMA','1938-08-27','02.18.68.85.44','06.14.12.28.58',NULL,'11 rue de l''esperance','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2380814370001',95.000000000,'1961-09-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1043,'BRAULT','JEANNE','1940-10-24','02.15.63.33.58','06.55.08.28.69',NULL,'28 RUE DE L''ANCIENNE GARE','','','14730','GIBERVILLE',NULL,NULL,'2401078430001',349.000000000,'1969-12-14','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1044,'MOULIN','THERESE','1965-03-04','02.75.00.54.32','06.52.87.67.04',NULL,'39 avenue robert schumann','','','14123','IFS',NULL,NULL,'1650314245001',1244.000000000,'1987-04-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1045,'LECOQ','ALBERT','1937-02-12','02.67.18.02.51','06.30.84.04.90',NULL,'la forge cambro','','','14540','GRENTHEVILLE',NULL,NULL,'1370214508001',2306.000000000,'1962-06-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1046,'ENAULT','HENRI','1938-09-05','02.36.78.80.40','06.87.38.17.24',NULL,'route de la gare','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2380914702001',93.000000000,'1962-05-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1047,'TILLARD','JANIQUE','1928-05-29','02.33.66.67.93','06.46.15.57.80',NULL,'56 av guynemer','','','14220','TOURNEBU',NULL,NULL,'1280550610001',189.000000000,'1955-05-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1048,'GUERIN','LEA','1939-06-20','02.12.27.36.64','06.16.29.65.70',NULL,'la moinerie','','','14000','CAEN',NULL,NULL,'1390614046001',70.000000000,'1968-04-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1049,'LE PERON','ROLAND','1942-09-04','02.84.50.43.99','06.81.58.40.51',NULL,'22 RUE DE LA GARE','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1420977089001',20.000000000,'1972-11-19','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1050,'BONNETOT','denis','1919-12-24','02.37.56.09.11','06.48.68.01.80',NULL,'6 ALLEE DU GENERAL SIMONDS','','','14000','CAEN',NULL,NULL,'1191214228001',303.000000000,'1940-04-24','PREMIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1051,'JEANNE','CHRISTIANE','1932-09-14','02.71.49.39.16','06.58.76.07.25',NULL,'3 RUE MARTIN LIEU DIT"LES PEDOUZ','ES"','','14370','MOULT',NULL,NULL,'1320914239001',0.000000000,'1953-02-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1052,'CHETOUH','YVETTE','1954-01-09','02.68.87.21.54','06.57.43.27.71',NULL,'29 AVENUE  CONSEIL','','','14400','BAYEUX',NULL,NULL,'2540150027001',90.000000000,'1984-02-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1053,'DALISSON','FERNAND','1939-04-18','02.11.10.55.47','06.37.10.62.88',NULL,'ROUTE DE ROUEN','','','14280','ST CONTEST',NULL,NULL,'2390461293001',1231.000000000,'1966-11-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1054,'CORDIER','HENRIETTE','1937-01-24','02.58.01.01.70','06.22.20.12.24',NULL,'3 RUE DES PRUNIERS','','','14220','THURY HARCOURT',NULL,NULL,'1370114488001',1055.000000000,'1960-01-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1055,'LEMONNIER','JACQUELINE','1929-04-19','02.38.42.40.18','06.80.42.80.62',NULL,'HAMEAU PLANCHE A LAHOUSSE','','','14540','BOURGUEBUS',NULL,NULL,'1290472386001',64.000000000,'1950-05-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1056,'LEPAS','JEAN PIERRE','1933-08-03','02.32.38.01.51','06.53.30.26.18',NULL,'4 RUE DE GENEVE','','','14120','MONDEVILLE',NULL,NULL,'2330814716001',188.000000000,'1956-03-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1057,'DEBAUDRE','HENRI','1953-05-09','02.87.26.89.84','06.60.93.22.68',NULL,'22 rue de verdin','','','14000','CAEN',NULL,NULL,'1530527035001',193.000000000,'1976-01-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1058,'BELLAUNAY','CHARLES','1932-01-25','02.39.78.53.48','06.55.90.79.82',NULL,'56 rue louis robillard','','','14270','CONDE SUR IFS',NULL,NULL,'2320114235001',3937.000000000,'1954-01-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1059,'HARANG','YVETTE','1937-05-03','02.35.75.34.07','06.51.02.61.58',NULL,'16 rue gujan mestras','','','50460','QUERQUEVILLE',NULL,NULL,'2370561375001',207.000000000,'1962-01-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1060,'LABBE','VIVIANE','1969-09-21','02.55.01.40.77','06.32.38.45.66',NULL,'4 rue camille drapeau','','','14000','CAEN',NULL,NULL,'2690914118001',138.000000000,'1993-11-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1061,'QUELARD','ARLETTE','1928-01-14','02.42.34.71.36','06.27.81.14.25',NULL,'la conarderie','','','61570','ALMENECHES',NULL,NULL,'1280121683001',14.000000000,'1953-12-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1062,'TOUVIOT','MYRIAM','1937-11-22','02.84.48.31.41','06.37.03.33.28',NULL,'IMPASSE DES 4 VENTS','','','14170','BERVILLE',NULL,NULL,'2371114120001',122.000000000,'1962-08-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1063,'CAREL','BEATRICE','1932-09-24','02.86.47.87.22','06.51.33.65.73',NULL,'le mesnil de bavent','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2320914062001',17.000000000,'1958-04-02','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1064,'LEBOSQUAIN','','1945-01-02','02.90.60.08.75','06.95.80.87.16',NULL,'2C CHEMIN DE CAEN','','','14370','ARGENCES',NULL,NULL,'2450114727001',643.000000000,'1968-06-26','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1065,'FORET','BERNARD','1940-07-25','02.14.61.35.30','06.56.35.20.08',NULL,'Le Bourg','','','61150','RANES',NULL,NULL,'1400714347001',341.000000000,'1962-01-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1066,'RICHARD','ROGER','1939-06-03','02.74.35.03.28',NULL,NULL,'10 RUE DU MUGUET','','','14123','IFS',NULL,NULL,'1390614712001',1072.000000000,'1961-12-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1067,'LEGRIX','VERONIQUE','1939-06-01','02.11.32.87.26','06.10.90.85.10',NULL,'9 BD DE L4ESPERANCE','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1390614712001',225.000000000,'1968-08-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1068,'GUESDON','Jean claude','1943-03-19','02.11.09.47.00','06.11.12.50.14',NULL,'','','','14460','COLOMBELLES',NULL,NULL,'2430314535001',168.000000000,'1964-08-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1069,'PICOT','RENEE','1957-11-30','02.70.17.79.86','06.56.28.53.94',NULL,'lieu dit le chau hauterive','','','14270','MEZIDON CANON',NULL,NULL,'2571114369001',30.000000000,'1987-02-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1070,'LEROY','','1938-12-28','02.46.63.55.87','06.11.71.92.10',NULL,'42 rue d harmanville','','','14000','CAEN',NULL,NULL,'1381214020001',350.000000000,'1967-09-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1071,'GRANGE','MARTHE','1957-02-26','02.31.61.68.61','06.59.21.42.07',NULL,'122 rue du 20 siecle','','','14260','JURQUES',NULL,NULL,'2570250038001',432.000000000,'1983-02-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1072,'GODEFROY','JULES','1965-01-24','02.89.30.69.52','06.61.86.71.46',NULL,'LE MESNIL','','','14220','HAMARS',NULL,NULL,'1650114118001',79.000000000,'1986-08-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1073,'SURIREY','THERESE','1957-03-20','02.28.96.34.22','06.10.17.60.43',NULL,'47 AVENUE PIERRE LAURENT','','','14123','IFS',NULL,NULL,'2570314257001',4818.000000000,'1979-04-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1074,'RIVOGNAC','JEAN PIERRE','1933-10-09','02.60.52.40.59','06.95.47.23.97',NULL,'62 RUE DE LISIEUX','','','14400','SUBLES',NULL,NULL,'2331053115001',38.000000000,'1955-08-07','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1075,'GOST','GILLES','1933-12-21','02.69.56.23.35','06.78.83.49.06',NULL,'36 RUE DE CONDE','','','14400','BAYEUX',NULL,NULL,'1331279068001',379.000000000,'1954-05-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1076,'SURIREY','YANKA','1968-01-14','02.88.67.79.22','06.12.23.19.40',NULL,'','','','14210','STE HONORINE DU FAY',NULL,NULL,'1680114384001',90.000000000,'1994-03-15','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1077,'ROSSIGNOL','VALERIE','1929-01-23','02.59.86.90.77','06.90.86.99.81',NULL,'22 RUE DU PARC','','','14111','LOUVIGNY',NULL,NULL,'2290114277001',194.000000000,'1953-08-15','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1078,'JOSEPH','MARIE JOSEPH','1925-12-31','02.95.34.36.70','06.81.42.18.64',NULL,'8 AVENUE MARECHAL KOENIG','','','14000','CAEN',NULL,NULL,'1251220199001',160.000000000,'1948-12-20','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1079,'DUTILLEUL','MADELEINE','1934-09-30','02.89.26.47.66','06.61.25.16.36',NULL,'LA COUTURE BOUREL','','','14000','CAEN',NULL,NULL,'1340914416001',983.000000000,'1958-12-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1080,'PIERRE','MADELEINE','1963-01-01','02.51.40.49.31','06.58.80.38.60',NULL,'2 IMPASSE DES VOSGES','','','14120','MONDEVILLE',NULL,NULL,'1630114225001',258.000000000,'1985-10-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1081,'CORVAISIER','JEAN-LOUIS','1938-05-19','02.46.46.54.41','06.11.39.76.77',NULL,'38 RUE LOUIS LEFEVRE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1380550488001',2047.000000000,'1960-06-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1082,'ANDRE','DENISE','1945-01-30','02.16.91.80.60','06.90.77.49.11',NULL,'5 RUE DE LA CARDONNIERE','','','14370','AIRAN',NULL,NULL,'2450176755001',2.000000000,'1973-09-19','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1083,'GUERIN','HUBERT','1936-03-06','02.21.64.92.82','06.28.49.98.23',NULL,'11 RUE DU POINT DU JOUR','','','27500','PONT AUDEMER',NULL,NULL,'1360361371001',585.000000000,'1957-02-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1084,'DECAEN','ROBERT','1948-01-03','02.58.30.21.22','06.33.31.77.17',NULL,'25 av de verdun','','','14123','IFS',NULL,NULL,'1480121013001',25.000000000,'1972-04-17','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1085,'POUPINEL','CLAUDE','1929-09-16','02.92.61.78.17','06.47.89.52.06',NULL,'15 RUE ARISTIDE BRIAND','','','14000','CAEN',NULL,NULL,'1290914327001',519.000000000,'1950-11-10','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1086,'LEMIERE','MONIQUE','1945-04-24','02.82.51.11.15','06.33.59.44.03',NULL,'11 RUE PIERRE CINGAL','','','14370','BELLENGREVILLE',NULL,NULL,'1450475048001',62.000000000,'1971-05-11','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1087,'LEFRANC','BRIGITTE','1931-12-08','02.77.82.80.61','06.65.01.16.88',NULL,'41 AV CONSEIL','','','14000','CAEN',NULL,NULL,'1311261331001',39.000000000,'1959-08-01','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1088,'SEEGER','SYLVIE','1930-11-02','02.54.08.62.02','06.88.46.56.43',NULL,'14 AV CONSEIL','','','14120','MONDEVILLE',NULL,NULL,'2301114704001',806.000000000,'1957-09-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1089,'MESNIL','JEAN-CLAUDE',NULL,'02.11.42.94.70','06.76.43.37.72',NULL,'10 AVENUE DOCT MAURICE COLLIN AP','PT 18','','14320','FONTENAY LE MARMION',NULL,NULL,'2650814305001',223.000000000,'2008-02-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1090,'HAREL','ANNICK','1965-09-29','02.54.64.69.78','06.10.76.39.50',NULL,'8 RUE DU DR RAYER','','','14850','ESCOVILLE',NULL,NULL,'2650914075001',9.000000000,'1991-10-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1091,'COURTIN','LEONCE','1938-02-03','02.52.55.92.73','06.40.86.89.94',NULL,'LA CORDERIE','','','14270','PERCY EN AUGE',NULL,NULL,'2380214275001',24.000000000,'1961-01-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1092,'LEMOINE','BERNARD','1955-03-23','02.11.70.93.63','06.11.05.21.33',NULL,'8 AVENUE MARECHAL KOENIG','','','14000','CAEN',NULL,NULL,'1550350072001',352.000000000,'1982-02-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1093,'LEMOINE','RENE','1919-12-08','02.24.48.01.77','06.10.53.58.01',NULL,'10 RUE DE SULLY','','','61200','ARGENTAN',NULL,NULL,'2191232196001',17.000000000,'1941-12-01','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1094,'ANQUETIL','RENE','1946-08-27','02.86.53.38.45','06.10.88.75.54',NULL,'9 c RUE CHAPRON','','','14220','MOULINES',NULL,NULL,'2460814248001',49.000000000,'1969-05-31','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1095,'LEMAROIS','ANDRE','1940-01-03','02.89.83.49.45','06.66.00.10.18',NULL,'6 RUE GEORGES SAND','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1400114434001',206.000000000,'1964-11-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1096,'BAZIRE','JEANNINE','1939-11-17','02.49.58.95.74',NULL,NULL,'62 RUE DE LA SEINE','','','14000','CAEN',NULL,NULL,'1391114420001',52.000000000,'1969-12-09','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1097,'FESTOC','GENEVIEVE','1936-07-15','02.11.13.15.75','06.44.27.35.05',NULL,'11 RUE DES FONTAINES FONTENAY LE',' PESNEL','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1360750024001',16.000000000,'1957-06-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1098,'CARBON','ODETTE','1942-06-27','02.65.69.41.36','06.84.00.84.54',NULL,'1 rue du bout roulant','','','14370','MERY CORBON',NULL,NULL,'2420614590001',75.000000000,'1971-11-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1099,'LEMOIGNE','ETIENNE','1935-10-05','02.64.18.90.78','06.47.88.17.72',NULL,'10 PLACE DE LA JUSTICE FOYER D','E LA GUERINIERE','','14000','CAEN',NULL,NULL,'1351014538001',296.000000000,'1959-12-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1100,'PERRELLE','EMMANUEL','1936-11-02','02.45.45.19.46','06.79.21.83.77',NULL,'6 RUE MICHEL JEAN','','','14000','CAEN',NULL,NULL,'2361176485001',288.000000000,'1959-06-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1101,'DROST','CHRISTOPHE','1935-11-19','02.30.91.41.70','06.78.22.59.70',NULL,'LE HAMEAU BOEUF','','','14000','CAEN',NULL,NULL,'1351161289001',42.000000000,'1961-01-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1102,'PERREE','GERARD','1961-03-10','02.10.74.80.12',NULL,NULL,'5 RUE DE MOUEN','','','14000','CAEN',NULL,NULL,'2610378419001',2012.000000000,'1983-12-31','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1103,'HAMELIN','MARTHE','1964-02-27','02.91.20.44.50','06.98.09.04.44',NULL,'40 RUE ALBERT CAMUS','','','14000','CAEN',NULL,NULL,'2640214186001',40.000000000,'1991-09-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1104,'PITEL','GEORGES','1954-01-02','02.22.62.83.37','06.50.22.07.20',NULL,'1 RUE DE COURSEULLES','','','14370','ARGENCES',NULL,NULL,'2540161314001',1275.000000000,'1975-03-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1105,'DEBAEREMAKER','MARIE LOUISE','1948-03-25','02.62.39.60.47','06.80.60.90.57',NULL,'7 RUE GASTON MONNERVILLE','','','14320','FONTENAY LE MARMION',NULL,NULL,'2480361480001',154.000000000,'1974-03-15','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1106,'BASTARD','THIERRY','1933-04-25','02.32.50.92.38','06.98.77.25.77',NULL,'30 RUE YVES BERNARD','','','50400','GRANVILLE',NULL,NULL,'1330450301001',470.000000000,'1958-06-08','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1107,'LAMOTTE','MICHELLE','1937-07-29','02.54.43.03.00','06.90.32.10.36',NULL,'5 rue charles coulomb','','','14000','CAEN',NULL,NULL,'1370750641001',205.000000000,'1963-06-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1108,'DUPLEX','IRENE','1929-01-19','02.17.72.97.96','06.10.56.32.67',NULL,'164 rue de falaise','','','14120','MONDEVILLE',NULL,NULL,'1290114750001',26.000000000,'1954-11-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1109,'TERRY','JACQUES','1941-03-02','02.84.77.45.64','06.90.52.70.68',NULL,'16 rue de verdun','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'2410314362001',11.000000000,'1963-08-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1110,'CHARDIN','MICHEL','1930-03-11','02.36.41.18.18','06.30.21.30.84',NULL,'COTE DE FIERVILLE','','','14880','HERMANVILLE SUR MER',NULL,NULL,'2300314057001',191.000000000,'1951-01-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1111,'HUE','CAROLE','1936-05-31','02.28.12.72.27','06.35.44.56.84',NULL,'48 RUE D''ALENCON','','','14000','CAEN',NULL,NULL,'1360514437001',604.000000000,'1957-10-31','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1112,'LE HELLEY','MARIE','1935-03-01','02.51.98.79.54','06.26.88.70.96',NULL,'29 RUE DE CHICHEBOVILLE','','','14150','OUISTREHAM',NULL,NULL,'1350361282001',56.000000000,'1956-06-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1113,'LAMORLETTE','CLAUDETTE','1949-01-28','02.27.57.41.19','06.48.86.95.33',NULL,'7 RUE DU QUEBEC','','',NULL,NULL,NULL,NULL,'2490114536001',342.000000000,'1974-02-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1114,'GUILLAUME','GABRIELLE','1941-06-10','02.30.31.64.38','06.80.00.05.10',NULL,'6 ALLEE DU CLOS DE LA PRAIRIE','','','14540','SOLIERS',NULL,NULL,'2410650121001',32.000000000,'1962-11-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1115,'THOREL','BRIGITTE','1955-01-21','02.15.02.55.02','06.22.75.27.48',NULL,'26 rue des aubiers','','','14310','EPINAY SUR ODON',NULL,NULL,'2550114679001',358.000000000,'1985-02-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1116,'CHAUVIN','GISELE','1934-06-16','02.61.83.85.63','06.61.37.30.54',NULL,'','','','14000','CAEN',NULL,NULL,'1340676594001',61.000000000,'1964-09-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1117,'EPINETTE','MARIE THERESE','1948-12-24','02.26.23.83.00','06.44.11.31.89',NULL,'4 RUE DANIEL TISON','','','14000','CAEN',NULL,NULL,'2481214013001',16.000000000,'1970-04-16','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1118,'FERGANT','MARIE CLAIRE','1937-09-09','02.97.24.31.16','06.58.35.82.82',NULL,'1 rue du muguet','','','14860','AMFREVILLE',NULL,NULL,'1370914749001',431.000000000,'1959-06-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1119,'BOULLAND','JEAN PIERRE','1940-12-25','02.66.50.67.14','06.67.13.88.76',NULL,'18 AVENUE DE VERDUN','','','14210','EVRECY',NULL,NULL,'2401214433001',24.000000000,'1967-09-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1120,'LABASTRIES','MONIQUE','1929-01-14','02.25.42.54.73','06.10.72.60.57',NULL,'27 RUE DE L''ARQUETTE','','','14370','ARGENCES',NULL,NULL,'1290161490001',737.000000000,'1956-02-18','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1121,'EL DJADID','JEAN','1928-05-23','02.90.67.59.06','06.59.85.93.08',NULL,'80 rue des roches','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'2280514413001',2090.000000000,'1951-09-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1122,'CARDIN','FRANCOISE','1930-05-29','02.48.59.91.32','06.77.76.68.95',NULL,'17 RUE DE LA DEMI LUNE','','','14400','BAYEUX',NULL,NULL,'1300514125001',1304.000000000,'1959-02-08','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1123,'BAYET','CLAUDE','1928-03-26','02.50.90.66.36','06.48.32.79.69',NULL,'13 rue jacque prevert','','','14000','CAEN',NULL,NULL,'2280314105001',38.000000000,'1949-04-03','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1124,'POTTIER','MARGUERITE','1929-09-09','02.65.24.66.32','06.35.77.88.23',NULL,'40 BIS ROUTE D''HARCOURT','','',NULL,NULL,NULL,NULL,'1290914658001',2.000000000,'1956-03-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1125,'ORIN','RENE','1930-10-05','02.56.30.03.63','06.49.32.27.99',NULL,'98 RUE DE BRANVILLE','','','14860','BAVENT',NULL,NULL,'2301014187001',348.000000000,'1953-05-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1126,'AUBIN','RENE','1950-01-12','02.65.38.28.22','06.45.20.86.96',NULL,'56 ALLEE DES POMMIERS DOMAINE DU',' HAUT BOIS','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'2500161166001',7.000000000,'1977-09-22','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1127,'DERENEMESNIL','JEAN','1937-02-10','02.59.53.02.70','06.38.18.42.88',NULL,'8-3 ALLEE DES CAMPANULES','','','14123','FLEURY SUR ORNE',NULL,NULL,'1370214763001',1723.000000000,'1958-08-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1128,'ROUGET','MICHEL','1961-09-05','02.74.45.05.61',NULL,NULL,'101 RUE DU CHEMIN VERT','','','14250','BROUAY',NULL,NULL,'1610937071001',129.000000000,'1984-09-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1129,'LECARDRONNEL','JACQUELINE','1938-12-17','02.11.95.32.59','06.96.46.55.12',NULL,'5 rue de la poste','','','14460','COLOMBELLES',NULL,NULL,'2381214513001',35.000000000,'1959-08-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1130,'PRIEUR','NELLY','1932-06-27','02.38.63.72.29','06.68.95.56.36',NULL,'14 rue marthe gibrat','','','14000','CAEN',NULL,NULL,'1320699397001',428.000000000,'1955-10-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1131,'LENORMAND','','1932-06-28','02.44.17.87.06','06.12.46.42.23',NULL,'5 CHEMIN DU MOULIN','','','14210','ESQUAY NOTRE DAME',NULL,NULL,'1320699397001',2412.000000000,'1953-11-30','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1132,'AMAND','MONIQUE','1969-07-13','02.87.91.86.48','06.20.74.20.76',NULL,'71 rue de bretagne','','','14840','DEMOUVILLE',NULL,NULL,'1690714109001',50.000000000,'1998-04-20','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1133,'CONNAULT','claude','1937-05-29','02.11.81.39.57','06.87.79.75.70',NULL,'154 BD LEROY','','','50480','STE MARIE DU MONT',NULL,NULL,'1370550405001',534.000000000,'1964-08-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1134,'LEREBOURG','JACQUES','1934-05-11','02.90.22.73.29','00 33 6.51.25.07.39',NULL,'38 rue eugenie','','','50260','BRICQUEBEC',NULL,NULL,'2340561177001',107.000000000,'1959-10-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1135,'THOMAS','edgar','1919-10-09','02.56.88.75.88','06.98.67.13.14',NULL,'ROUTE DE ST PIERRE S/ DIVES','','','14700','FALAISE',NULL,NULL,'1191061464001',424.000000000,'1943-07-06','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1136,'RICHARD','ELISABETH',NULL,'02.56.41.50.65','06.40.31.09.59',NULL,'11 RUE HOTEL AU BOSQ','','','14000','CAEN',NULL,NULL,'2450228263001',24.000000000,'2013-08-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1137,'JAMES','ANNICK','1936-08-24','02.12.69.82.77','06.32.91.53.92',NULL,'15 RUE DE BOURGOGNE','','','14920','MATHIEU',NULL,NULL,'1360829072001',85.000000000,'1962-03-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1138,'HUYGHE','JEANNINE','1939-10-09','02.48.74.68.70',NULL,NULL,'9 RUE DU DR PAUL ENOUF','','','14370','MOULT',NULL,NULL,'2391014417001',39.000000000,'1966-06-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1139,'LE NAOUR','stephane','1964-05-03','02.77.23.49.08','06.47.99.38.44',NULL,'3 RUE JEAN CABY','','','14400','BAYEUX',NULL,NULL,'2640514730001',343.000000000,'1990-03-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1140,'MAINCENT','SIMONE','1937-08-14','02.87.88.15.41','06.13.23.86.67',NULL,'131 av guynemer','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2370814505001',2278.000000000,'1966-02-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1141,'MESNIL','NICOLE','1931-05-31','02.15.67.10.64','06.41.11.34.07',NULL,'6 RUE CARDINAL LAVIGERIE','','','14210','EVRECY',NULL,NULL,'1310514525001',808.000000000,'1957-07-27','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1142,'CHARDIN','MADELY','1936-04-27','02.19.76.98.92','06.11.23.92.66',NULL,'27 RUE DE LA ROSERAIE','','','14150','OUISTREHAM',NULL,NULL,'1360414657001',104.000000000,'1966-05-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1143,'MOREL','JACQUELINE','1936-12-03','02.58.28.94.06','06.11.18.71.89',NULL,'48 BD RAYMOND POINCARE','','','50700','VALOGNES',NULL,NULL,'2361214319001',146.000000000,'1958-08-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1144,'AUBIN','MARTINE','1943-01-07','02.10.89.59.93','06.83.74.77.92',NULL,'16 CITE DES CASTORS','','','14540','CONTEVILLE',NULL,NULL,'1430114090001',383.000000000,'1964-07-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1145,'GUERET','JANINE','1929-01-14','02.12.15.58.36','06.11.51.17.50',NULL,'12 rue de la grace de dieu','','','14490','ST PAUL DU VERNAY',NULL,NULL,'2290114408001',232.000000000,'1952-06-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1146,'JEANNE','MAURICE','1937-08-04','02.49.43.67.46','06.45.02.75.07',NULL,'115 rue des acacias','','','14670','TROARN',NULL,NULL,'2370817306001',142.000000000,'1958-05-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1147,'ROYER','ROLAND','1940-07-26','02.12.33.22.94','06.76.02.36.88',NULL,'19 place des drakkars','','','14400','ST VIGOR LE GRAND',NULL,NULL,'2400717328001',39.000000000,'1963-04-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1148,'LEMANISSIER','GUY','1937-04-28','02.98.91.50.51','06.97.37.97.74',NULL,'40 RUE DU 16 AOUT 1944','','','14470','COURSEULLES SUR MER',NULL,NULL,'2370414711001',92.000000000,'1959-09-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1149,'VERHAEGHE','ROGER','1931-02-27','02.44.82.55.55','06.25.23.54.79',NULL,'CHEMIN DIT AUX MALADES','','','14000','CAEN',NULL,NULL,'2310250356001',105.000000000,'1953-02-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1150,'MAUCORPS','LILIANE','1948-01-23','02.90.37.30.71','06.10.03.99.02',NULL,'7 rue de la marre','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'1480114635001',1825.000000000,'1970-05-17','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1151,'NICOLLE','JEAN','1958-03-08','02.82.46.74.17',NULL,NULL,'RUE MAC MAHON','','','14750','ST AUBIN SUR MER',NULL,NULL,'1580350247001',38.000000000,'1986-07-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1152,'NICOLLE','BRIGITTE','1934-02-24','02.22.15.63.93','06.76.95.59.01',NULL,'7 RUE DE L EGLISE','','','14000','CAEN',NULL,NULL,'1340214044001',153.000000000,'1961-03-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1153,'VOISIN','JEANINE','1934-06-21','02.22.75.44.77','06.44.08.27.17',NULL,'14 avenue du 18 aout 1944','','','14123','FLEURY SUR ORNE',NULL,NULL,'1340614262001',30.000000000,'1961-06-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1154,'FERAY','THIERRY','1956-05-25','02.66.56.90.93','06.86.17.64.13',NULL,'101 rue de branville','','','14390','CABOURG',NULL,NULL,'1560561208001',104.000000000,'1981-11-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1155,'BLESTEL','PAUL','1936-03-15','02.73.20.85.37','06.44.75.93.98',NULL,'5 RUE VICTOR HUGO','','','14460','COLOMBELLES',NULL,NULL,'2360314437001',795.000000000,'1959-11-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1156,'CERE','FERNANDE','1945-07-31','02.25.72.78.66','06.61.90.10.36',NULL,'159 rue haute','','','14123','IFS',NULL,NULL,'1450714610001',1859.000000000,'1974-03-21','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1157,'GOUGEON','CATHERINE','1935-12-22',NULL,NULL,NULL,'24 rue spontini','','','14260','AUNAY SUR ODON',NULL,NULL,'2351214470001',868.000000000,'1960-03-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1158,'LECARDONNEL','JANIQUE','1932-06-09','02.11.20.08.22','06.39.32.30.88',NULL,'8 impasse des bleuet','','','14000','CAEN',NULL,NULL,'2320622256001',166.000000000,'1956-09-09','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1159,'JULIENNE','RAYMOND','1947-01-16','02.76.84.63.80','06.37.88.61.79',NULL,'22-8 grande rue','','','14120','MONDEVILLE',NULL,NULL,'1470172299001',2762.000000000,'1970-03-18','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1160,'CHABANNE','NICOLE','1937-06-25','02.14.15.93.87','06.91.25.03.02',NULL,'12 RUE DE LA ROUVRE','','','14630','CAGNY',NULL,NULL,'1370676466001',5274.000000000,'1964-01-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1161,'LEGRIX','SERGE','1929-07-02','02.19.69.00.67','06.10.21.23.03',NULL,'7 rue marie france','','','61150','ECOUCHE',NULL,NULL,'1290714581001',15.000000000,'1955-07-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1162,'LE BUAN','ISABELLE','1940-08-09','02.55.69.62.52','06.17.49.05.05',NULL,'1 route de Paris','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'2400814125001',655.000000000,'1970-11-20','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1163,'RECOURSE','MICHEL','1948-12-10','02.34.01.50.65','06.19.70.01.97',NULL,'69 RUE PASTEUR','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1481214306001',35.000000000,'1978-06-29','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1164,'GUICHARD','CLAUDIE','1953-04-10','02.11.17.28.42','06.43.57.35.97',NULL,'1 ROUTE DE CORDEY','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'1530414493001',181.000000000,'1977-10-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1165,'LE POAIZARD','JANINE','1933-04-05','02.60.41.96.40','06.57.00.35.77',NULL,'19 ROUTE DE LA GUERINIERE','','','14410','BERNIERES LE PATRY',NULL,NULL,'2330414118001',365.000000000,'1957-08-23','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1166,'TOUPIN','MARIE','1937-01-15','02.76.45.20.66','06.78.12.82.16',NULL,'19 rue paul claudel','','','14000','CAEN',NULL,NULL,'2370160260001',226.000000000,'1961-01-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1167,'PIERRE','THERESE','1938-03-01','02.41.55.58.70','06.64.69.55.51',NULL,'4 RUE DES BRUYERES','','','14570','ST REMY',NULL,NULL,'1380350483001',141.000000000,'1960-04-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1168,'CHATELLIER','FRANCK','1933-05-23','02.46.64.52.21','06.10.43.73.54',NULL,'8 RUE DES LONGS JOUHAUX','','','14000','CAEN',NULL,NULL,'1330527630001',38.000000000,'1954-12-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1169,'LAMULLE','LUCETTE','1955-05-01','02.11.69.80.05','06.71.41.55.48',NULL,'74 RUE BEAULUE','','','14120','MONDEVILLE',NULL,NULL,'1550514548001',299.000000000,'1981-06-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1170,'GAYET','DOMINIQUE','1931-01-19','02.10.88.80.81','06.44.68.30.10',NULL,'45 rue ernest renan','','','14000','CAEN',NULL,NULL,'2310150415001',454.000000000,'1957-02-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1171,'GUILLOREAU','ROGER','1930-08-08','02.76.51.58.43','06.76.54.19.35',NULL,'2 CITE DES JARDINS','','','14000','CAEN',NULL,NULL,'2300850526001',1.000000000,'1955-03-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1172,'QUIGNETTE','JANINE','1966-05-01','02.40.19.99.57','06.73.28.80.15',NULL,'2 BIS RUE DE FORT MIGNY','','','14620','BAROU EN AUGE',NULL,NULL,'2660576137001',51.000000000,'1993-08-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1173,'BASLEY','JEANINE','1939-04-19','02.67.71.21.26','06.35.35.99.75',NULL,'25 RUE MONGOLFIER','','','14670','JANVILLE',NULL,NULL,'2390450032001',389.000000000,'1963-01-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1174,'BOISSARD','MARTINE','1928-12-09','02.91.21.08.41','06.51.60.62.45',NULL,'rue de la liberation','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1281214251001',6.000000000,'1949-12-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1175,'LE COMTE','','1930-01-03','02.92.31.43.13','06.19.12.65.09',NULL,'14 RESIDENCE OLYMPA','','','14730','GIBERVILLE',NULL,NULL,'2300150436001',174.000000000,'1951-09-01','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1176,'LERENARD','MICHEL',NULL,'02.63.22.94.19','06.64.12.13.12',NULL,'','','','14220','MOULINES',NULL,NULL,'1914123780001',95.000000000,'2010-02-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1177,'RENOUF','GENEVIEVE','1935-01-19','02.67.86.36.83','06.58.27.60.05',NULL,'12 RUE DE LA RESISTANCE','','','14123','IFS',NULL,NULL,'1350114030001',756.000000000,'1957-07-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1178,'JAMARD','GILBERT','1951-01-27','02.25.56.19.31','06.38.93.82.38',NULL,'21 rue des mimosas','','','14000','CAEN',NULL,NULL,'2510150085001',911.000000000,'1979-08-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1179,'MACE','DANIEL','1932-11-26','02.10.35.49.24','06.23.23.40.68',NULL,'4 RUE XAVIER DANCELME','','','14400','BAYEUX',NULL,NULL,'2321129191001',41.000000000,'1961-08-31','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1180,'MONTIGNY','MARIE ROSE','1958-10-21','02.55.28.29.91','06.41.78.77.39',NULL,'19 imp des roses','','','14000','CAEN',NULL,NULL,'2581014149001',424.000000000,'1982-04-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1181,'DUMONT','STEPHANIE','1961-03-30','02.68.88.37.56','06.10.40.19.34',NULL,'RUE ERNEST RENAN   N.19','','','14270','MEZIDON CANON',NULL,NULL,'1610314435001',35.000000000,'1985-06-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1182,'MALLET','PAUL','1968-01-26','02.70.04.23.71','06.10.64.13.03',NULL,'1 IMPASSE REINE MATHILDE','','','14000','CAEN',NULL,NULL,'1680153166001',17.000000000,'1989-04-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1183,'AUBRY','PASCAL','1956-02-15','02.52.77.73.29','06.47.00.20.90',NULL,'13 RUE DE VERDUN','','','14280','ST CONTEST',NULL,NULL,'1560214341001',307.000000000,'1978-03-17','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1184,'ZIMMERMANN','GERARD','1956-01-27','02.47.38.66.96','06.11.93.93.51',NULL,'2 RUE DU CENTRE','','','14170','HIEVILLE',NULL,NULL,'1560133227001',70.000000000,'1980-08-31','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1185,'LENORMAND','YVETTE','1946-02-12','02.87.29.88.98','06.23.65.03.42',NULL,'17 RUE DE LA GUERINIERE','','','14670','ST PAIR',NULL,NULL,'2460214244001',380.000000000,'1969-10-28','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1186,'DURAND','MARIE','1936-06-03','02.50.98.09.02','06.68.06.10.59',NULL,'7 RUE EDOUARD VAILLANT','','','50310','LE HAM',NULL,NULL,'1360614123001',53.000000000,'1963-04-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1187,'OLIVIER','MARIE THERESE','1928-07-02','02.50.29.75.38','06.35.44.84.12',NULL,'26 ave de rouen','','','14370','CHICHEBOVILLE',NULL,NULL,'1280735065001',7.000000000,'1951-12-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1188,'FONTAINE','RENE','1933-06-21','02.12.34.40.00','06.69.27.07.80',NULL,'1 rue pierre le pretre','','','14000','CAEN',NULL,NULL,'1330614666001',177.000000000,'1960-10-14','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1189,'GODEAU','BERNARD',NULL,'02.59.95.36.58','06.50.53.37.47',NULL,'9 RUE JACQUES BREL','','','14860','BAVENT',NULL,NULL,'2350914165001',132.000000000,'2009-08-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1190,'BELLIARD','RAYMOND','1963-01-10','02.60.48.38.15','06.52.77.12.31',NULL,'34 BD FONTAINE COUVERTE','','','14120','MONDEVILLE',NULL,NULL,'1630114327001',549.000000000,'1990-02-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1191,'LELIEVRE','CZESLAW','1964-11-10','02.85.51.01.24','06.44.78.40.08',NULL,'2 IMPASSE DES ECOLES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1641114118001',49.000000000,'1990-07-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1192,'RENEE','RENE','1929-11-18','02.65.50.57.69','06.72.62.61.80',NULL,'18 RUE ARISTIDE HIMBAUT','','','14370','CANTELOUP',NULL,NULL,'1291114757001',84.000000000,'1950-10-12','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1193,'LECONTE','NELLY','1929-10-25','02.46.03.38.33','06.62.41.54.23',NULL,'30 ROUTE DE PARIS','','','14370','MOULT',NULL,NULL,'1291014665001',29.000000000,'1954-03-06','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1194,'LEDENTU','RACHEL','1929-10-06','02.47.23.06.21','06.74.89.27.24',NULL,'160 COUR NORMANDE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1291014665001',132.000000000,'1950-03-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1195,'CARABY','vadim','1938-05-15','02.46.49.28.28','06.41.84.85.81',NULL,'15 rue pasteur','','','14460','COLOMBELLES',NULL,NULL,'1380514713001',200.000000000,'1959-07-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1196,'','J GEORGES','1928-11-06','02.11.18.47.68','06.66.68.97.74',NULL,'2 RUE DU MONT DU SAULE','','','14000','CAEN',NULL,NULL,'1281114310001',2385.000000000,'1952-05-29','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1197,'REVEL','LAETITIA','1931-05-23','02.56.27.83.41','06.60.24.53.17',NULL,'15 rue des mesanges','','','14100','LISIEUX',NULL,NULL,'2310514377001',1795.000000000,'1953-03-31','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1198,'NEAUD','BRUNO','1915-03-01','02.54.89.10.73','06.17.14.15.55',NULL,'Z1 ROUTE DE CAEN','','','14270','CONDE SUR IFS',NULL,NULL,'2150303294001',80.000000000,'1941-07-25','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1199,'LE PREVOST DE LA MOISSONIERE','MICHEL','1946-05-31','02.26.57.00.47','06.40.27.61.44',NULL,'38 RUE ST MICHEL','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1460514550001',589.000000000,'1973-03-16','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1200,'CHAMBET','ROLAND','1956-03-30','02.18.23.30.99','06.31.17.75.06',NULL,'21 RUE DU FOUR A CHAUX','','','14460','COLOMBELLES',NULL,NULL,'2560314119001',57.000000000,'1979-03-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1201,'HOUEL','YVES','1955-01-17','02.15.35.53.66','06.11.03.22.11',NULL,'','','','14320','MAY SUR ORNE',NULL,NULL,'2550161269001',36.000000000,'1979-06-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1202,'GERVAIS','JEAN CLAUDE','1963-11-06','02.49.02.60.89','06.38.98.11.86',NULL,'19 rue du stade','','','14460','COLOMBELLES',NULL,NULL,'2631114118001',82.000000000,'1992-12-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1203,'ROUSSEL','MARCELLE','1951-06-05','02.10.34.48.79','06.57.77.15.29',NULL,'','','','61240','NONANT LE PIN',NULL,NULL,'2510614118001',114.000000000,'1976-06-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1204,'HOUSSIN','YVES','1927-10-07','02.85.10.24.28','06.19.85.88.55',NULL,'24 pl du marche','','','14120','MONDEVILLE',NULL,NULL,'2271039320001',197.000000000,'1952-12-06','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1205,'BERTOLI','PATRICIA','1963-03-06','02.43.20.15.83','06.22.09.54.03',NULL,'11 RUE DU PETIT SEMILLON','','','14000','CAEN',NULL,NULL,'1630314507001',30.000000000,'1992-03-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1206,'VIVIEN','MAURICE','1939-08-26','02.92.97.45.35','06.72.84.92.34',NULL,'','','','14320','MAY SUR ORNE',NULL,NULL,'1390878314001',181.000000000,'1961-04-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1207,'DELAHAYE','CHRISTOPHE','1965-10-13','02.12.17.79.45','06.10.37.59.05',NULL,'1110RUE DU BOIS','','','14123','IFS',NULL,NULL,'2651014761001',823.000000000,'1993-10-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1208,'ANDRE','SYLVIE','1939-11-03','02.57.15.08.68','06.12.04.05.34',NULL,'5 RUE DES EQUIPES D URGENCES','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2391114370001',57.000000000,'1962-10-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1209,'COBBAERT','BERNADETTE','1930-05-03','02.52.81.47.99','06.31.30.82.54',NULL,'16 RUE AUX PIERROTS','','','14980','ROTS',NULL,NULL,'1300514033001',725.000000000,'1956-04-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1210,'RUEL','GISELE','1929-09-26','02.74.69.04.47',NULL,NULL,'25 ALLEE GUILLAUME LE CONQUERANT','','','14370','BELLENGREVILLE',NULL,NULL,'2290914588001',541.000000000,'1953-05-03','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1211,'KLAINE','PIERRE','1940-08-08','02.26.49.97.57','06.37.86.17.81',NULL,'8 RUE DU DAUPHINE','','','14320','MAY SUR ORNE',NULL,NULL,'2400814673001',288.000000000,'1966-06-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1212,'LEVRARD','FERNAND','1931-11-23','02.30.56.66.91','06.38.80.59.98',NULL,'13 RUE DE VERDUN','','','14140','LE MESNIL DURAND',NULL,NULL,'2311114044001',93.000000000,'1956-06-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1213,'TALVAST','BERNARD','1935-03-14','02.38.88.57.76','06.26.24.64.78',NULL,'153 RUE DE BEAULUE','','','14000','CAEN',NULL,NULL,'2350314478001',27.000000000,'1957-05-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1214,'SONNET','CATHERINE','1949-04-13','02.56.09.51.21','06.60.51.24.08',NULL,'3 SQUARE ANDRE GID','','','14270','ECAJEUL',NULL,NULL,'2490414757001',25.000000000,'1970-01-22','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1215,'MARIE','JACKY','1956-01-13','02.41.18.65.78','06.10.38.20.70',NULL,'22 RUE A BRIAND','','','14000','CAEN',NULL,NULL,'1560114088001',303.000000000,'1979-03-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1216,'LESNIK','ROGER','1943-05-28','02.16.50.22.87','06.79.40.14.00',NULL,'9 rue porte millet','','','14000','CAEN',NULL,NULL,'2430527614001',2804.000000000,'1973-05-30','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1217,'ALLO','FERNANDE','1931-08-08','02.39.25.11.05','06.67.64.31.99',NULL,'14 rue du val','','','14270','MAGNY LE FREULE',NULL,NULL,'1310814024001',4.000000000,'1952-12-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1218,'LECUIROT','JACQUES','1932-12-12','02.28.07.01.95','06.49.88.45.80',NULL,'LA ROCHE FONTAINE','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'2321214659001',3631.000000000,'1954-10-14','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1219,'DUBOIS','EVELINE','1933-05-11','02.70.86.09.43','06.69.45.93.62',NULL,'15 route de la gurinire','','','14150','OUISTREHAM',NULL,NULL,'2330527118001',3845.000000000,'1958-06-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1220,'BARBEY','YOLANDE','1936-11-17','02.59.94.00.12','06.90.56.61.43',NULL,'10 BD NICOLAS ORESNE','','','14370','ARGENCES',NULL,NULL,'2361161306001',118.000000000,'1961-08-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1221,'FRANCISOT','JEAN CLAUDE','1929-03-20','02.41.26.50.96','06.22.84.07.09',NULL,'route de rouen','','','14120','MONDEVILLE',NULL,NULL,'1290314636001',548.000000000,'1953-09-03','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1222,'HUSSEINOVA','PAUL','1931-12-25','02.11.82.66.71','06.82.60.06.05',NULL,'65 RUE DU GAL DE GAULLE','','','61200','ARGENTAN',NULL,NULL,'2311250266001',1371.000000000,'1952-03-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1223,'MARIE','GISELE','1954-01-16','02.52.81.18.46','06.53.94.46.89',NULL,'9 RUE CHAPRON','','','14190','ST SYLVAIN',NULL,NULL,'2540114219001',11.000000000,'1981-09-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1224,'GUILLON','JOSETTE','1930-12-25','02.89.27.68.55','06.25.67.01.23',NULL,'9 RUE GANDHI','','','14850','ESCOVILLE',NULL,NULL,'2301278531001',1092.000000000,'1953-05-07','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1225,'ALLAIN','ANDRE','1940-02-27','02.10.29.28.47','06.61.21.09.65',NULL,'ROUTE DE CAMPIGNY','','','14530','LUC SUR MER',NULL,NULL,'2400214005001',106.000000000,'1963-03-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1226,'LECARDONNEL','EMILIENNE','1934-09-07','02.72.01.91.69','06.37.79.73.20',NULL,'RUE DU GENERAL DE GAULLE','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1340914438001',70.000000000,'1955-01-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1227,'WOJCIK','DENISE','1944-03-26','02.17.06.17.46','06.39.59.85.16',NULL,'108 RUE DE FALAISE','','','14570','ST REMY',NULL,NULL,'1440314383001',107.000000000,'1968-09-09','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1228,'GRANDMOUGIN','CHANTAL','1935-12-03','02.43.88.49.02','06.26.54.49.49',NULL,'14 ROUTE DES LACS','','','14000','CAEN',NULL,NULL,'1351214216001',106.000000000,'1957-05-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1229,'DERRIEN','RAYMOND','1940-01-11','02.45.60.09.51','06.60.85.58.67',NULL,'','','','14670','TROARN',NULL,NULL,'1400114438001',34.000000000,'1970-10-25','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1230,'FEREY','ANNETTE','1943-01-07','02.61.33.96.49','06.28.39.85.52',NULL,'10 RUE DES SPORTS','','','14000','CAEN',NULL,NULL,'1430150178001',206.000000000,'1967-10-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1231,'LUNEL','JULIETTE','1957-01-27','02.85.17.09.17','06.57.62.22.51',NULL,'6 RUE DR ZAJEWSKI','','','14570','ST REMY',NULL,NULL,'1570114407001',40.000000000,'1979-07-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1232,'CLEMENT','SIMONE','1939-03-19','02.53.89.03.38','06.10.19.49.70',NULL,'7 BIS BD DE LA LIBERATION','','','14123','IFS',NULL,NULL,'2390314316001',567.000000000,'1962-07-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1233,'HINGAND','JEANINE','1928-01-02','02.10.49.57.71','06.60.62.47.88',NULL,'20 RUE DE LA MOINERIE','','','14210','AMAYE SUR ORNE',NULL,NULL,'2280114274001',172.000000000,'1950-10-10','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1234,'HARTEL','JACQUELINE','1934-05-31','02.33.31.69.05','06.12.28.03.55',NULL,'3 RUE SIKORSKI','','','14120','MONDEVILLE',NULL,NULL,'2340514400001',98.000000000,'1957-05-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1235,'HOULETTE','GERARD','1935-11-03','02.53.30.28.10','06.78.23.56.34',NULL,'1 RUE DE LA LUSERNE','','','14630','EMIEVILLE',NULL,NULL,'1351114558001',518.000000000,'1958-11-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1236,'BAROCHE','GISELE','1928-12-12','02.85.56.25.77','06.11.57.75.26',NULL,'8 IMPASSE DU VILLAGE','','','14220','ACQUEVILLE',NULL,NULL,'2281214537001',194.000000000,'1957-09-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1237,'MOREL','GENEVIEVE','1949-03-09','02.92.40.77.32','06.26.63.79.61',NULL,'13 RUE FORMIGNY','','','14120','MONDEVILLE',NULL,NULL,'2490350620001',3.000000000,'1971-10-03','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1238,'ANGOT','raymond','1939-03-22','02.16.61.31.16','06.11.53.81.34',NULL,'LA VALETTE','','','14000','CAEN',NULL,NULL,'1390314629001',95.000000000,'1966-09-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1239,'','YVETTE','1939-03-03','02.96.79.61.54','06.16.04.67.05',NULL,'LIEU DIT"LE DOMAINE"','','','50300','AVRANCHES',NULL,NULL,'1390314629001',97.000000000,'1966-12-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1240,'LECONTE','MAURICE','1964-12-29','02.33.12.13.81','06.53.21.02.33',NULL,'RUE RABELAIS','','','14540','BOURGUEBUS',NULL,NULL,'2641214145001',254.000000000,'1993-08-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1241,'PONTAIS','DENISE','1937-07-10','02.56.90.47.90','06.92.16.24.57',NULL,'','','','14380','LANDELLES ET COUPIGNY',NULL,NULL,'2370714204001',205.000000000,'1966-10-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1242,'LABEY','ELISE','1935-02-02','02.32.46.83.32','06.70.67.52.68',NULL,'75 rue eustache restoux','','','13011','MARSEILLE 11',NULL,NULL,'2350214379001',3510.000000000,'1965-04-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1243,'DUDOUIT','LOUIS','1963-12-13','02.31.58.92.55','06.58.08.96.60',NULL,'5 RUE KALIGRENKO','','','14540','BOURGUEBUS',NULL,NULL,'1631299253001',550.000000000,'1993-03-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1244,'POMIKAL','CLAUDE','1933-02-26','02.39.37.08.92','06.88.44.02.78',NULL,'6 RUE DE LA CLE DES CHAMPS','','','27530','EZY SUR EURE',NULL,NULL,'2330249202001',56.000000000,'1957-02-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1245,'BRIDOT','ROZELINE','1933-06-11','02.75.85.27.58','06.60.02.24.82',NULL,'5 RUE AUGUSTE LANGLOIS','','','14123','IFS',NULL,NULL,'2330661477001',123.000000000,'1956-11-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1246,'LANGLOIS','JACQUES','1939-11-13','02.24.90.55.30','06.50.61.20.81',NULL,'9 RUE MOZART','','','14490','CASTILLON',NULL,NULL,'1391122204001',413.000000000,'1966-01-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1247,'LEPETIT','FRANCOISE','1962-01-03','02.46.21.45.05','06.47.77.12.38',NULL,'CHEMIN DE LA CROIX AUX NOBLES','','','14430','BEUVRON EN AUGE',NULL,NULL,'1620114020001',663.000000000,'1988-05-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1248,'RAULINE','ANDRE','1962-12-27','02.37.42.69.59','06.42.32.89.60',NULL,'','','','14780','LION SUR MER',NULL,NULL,'2621214690001',691.000000000,'1984-07-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1249,'CASTEL','MONIQUE','1934-10-13','02.53.33.95.60','06.87.40.89.08',NULL,'2 PLACE GENDARMERIE MOBILE','','','14630','FRENOUVILLE',NULL,NULL,'1341014482001',15.000000000,'1958-05-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1250,'LEREBOURG','CZESLAW','1929-01-16','02.17.52.89.87','06.64.54.36.05',NULL,'18 rue saint andre','','','61370','ECHAUFFOUR',NULL,NULL,'2290114622001',326.000000000,'1951-06-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1251,'PRECOURT','RENE','1956-02-26','02.45.32.73.09','06.42.19.76.71',NULL,'LA VACQUERIE','','','14400','BAYEUX',NULL,NULL,'1560214114001',193.000000000,'1977-04-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1252,'PESNEL','YVETTE','1933-05-10','02.11.36.90.21','06.50.98.42.96',NULL,'5 rue jean philippe rameau','','','14210','CHEUX',NULL,NULL,'1330527119001',105.000000000,'1954-04-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1253,'LAMY','JEAN','1959-02-14','02.88.77.84.92','06.79.63.64.16',NULL,'15 RUE DE BRETAGNE','','','14000','CAEN',NULL,NULL,'1590227513001',410.000000000,'1982-08-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1254,'TROHEL','MARCEL','1934-10-05','02.93.67.48.52','06.83.17.57.10',NULL,'4 rue du  pere jules','','','14000','CAEN',NULL,NULL,'2341014424001',1592.000000000,'1960-12-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1255,'TRAVIGNET','CHARLES','1938-08-21','02.11.33.68.37','06.84.64.79.02',NULL,'IMPASSE ROGER SALENGRO','','','14123','IFS',NULL,NULL,'2380850149001',270.000000000,'1962-10-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1256,'DESCHIENS','MARC','1937-02-15','02.10.55.95.54','06.95.68.55.40',NULL,'LA GARDERIE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1370214271001',27.000000000,'1966-10-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1257,'ANDRE','MARGUERITE','1935-03-05','02.39.71.30.46','06.76.42.50.75',NULL,'10 RUE DE LA VALLEE','','','14000','CAEN',NULL,NULL,'2350376620001',68.000000000,'1956-04-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1258,'CHANCOIGNE','SIMONE','1924-12-11','02.17.62.60.81','06.70.06.53.99',NULL,'RUE DE LA SARRIETTE','','','14240','CAHAGNES',NULL,NULL,'2241277013001',829.000000000,'1947-04-14','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1259,'BOUVIER','LOUIS','1940-03-24','02.30.97.41.29','06.78.52.55.28',NULL,'11 rue du tour de ville','','','14290','MEULLES',NULL,NULL,'2400314206001',34.000000000,'1967-03-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1260,'DELMAS','GERARD','1968-01-06','02.64.94.68.51','06.64.81.81.21',NULL,'13 LE BOURG DE CRENNES','','','14330','LE MOLAY LITTRY',NULL,NULL,'1680153166001',780.000000000,'1992-06-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1261,'HETET','YVES','1930-06-21','02.53.91.37.03','06.23.40.78.86',NULL,'26 rue georges gaillard','','','14220','HAMARS',NULL,NULL,'1300661397001',1404.000000000,'1952-03-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1262,'MOREAU','THIERRY','1955-01-09','02.23.86.55.72','06.49.00.19.77',NULL,'1 RUE DU DOCTEUR LECHARPENTIER','','','14130','BONNEVILLE LA LOUVET',NULL,NULL,'1550150221001',86.000000000,'1981-05-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1263,'LAIR','SYLVIANNE','1940-02-24','02.41.21.58.82','06.65.24.45.82',NULL,'1 rue des pervenches','','','50700','VALOGNES',NULL,NULL,'2400214112001',66.000000000,'1962-11-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1264,'PARIS','JEANINE','1942-12-07','02.58.64.45.14','06.79.93.70.72',NULL,'26 RUE DANIEL DANJON','','','14270','BIEVILLE QUETIEVILLE',NULL,NULL,'1421297202001',61.000000000,'1969-03-14','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1265,'HEBERT','HUBERT','1936-01-26','02.18.17.46.04','06.50.85.65.04',NULL,'','','','14670','TROARN',NULL,NULL,'2360114181001',3011.000000000,'1959-07-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1266,'MARIE','CHARLES','1932-02-17','02.29.60.07.40','06.52.40.36.17',NULL,'8 RUE DU CHATEL','','','61500','SEES',NULL,NULL,'1320222118001',196.000000000,'1962-11-18','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1267,'FOUQUES','FRANCIS','1956-06-15','02.10.15.76.62','06.57.42.53.94',NULL,'18 LE PETIT PLAIN','','','14000','CAEN',NULL,NULL,'1560614145001',366.000000000,'1982-10-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1268,'GUESNON','LIONEL','1938-04-02','02.24.87.40.53','06.68.48.49.22',NULL,'13 RUE ST EXUPERY','','','14000','CAEN',NULL,NULL,'1380414520001',105.000000000,'1967-07-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1269,'LEBARBIER','MICHEL','1932-04-24','02.11.82.37.34','06.81.56.76.46',NULL,'17 RUE LEBAUDY','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2320414170001',186.000000000,'1961-10-20','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1270,'BARBANCHON','LOUIS','1936-05-22','02.61.04.86.64','06.96.87.38.52',NULL,'8 rue st loup','','','14000','CAEN',NULL,NULL,'1360561073001',157.000000000,'1960-12-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1271,'NEDELEC','ANDREE','1938-07-13','02.11.65.00.46','06.58.94.89.65',NULL,'12 ALLEE DES OFEVRES','','','14370','MOULT',NULL,NULL,'1380714482001',2.000000000,'1959-12-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1272,'BLOND','GABRIELLE','1937-01-09','02.11.89.24.43','06.10.67.07.60',NULL,'8 RUE DE L EGALITE','','','14000','CAEN',NULL,NULL,'1370114103001',2.000000000,'1962-04-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1273,'CAILLON','YOLANDE','1921-04-30','02.53.32.70.85','06.78.73.53.48',NULL,'5 LONGUE DU THEATRE','','','14320','FONTENAY LE MARMION',NULL,NULL,'2210414739001',1923.000000000,'1946-10-28','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1274,'MARIE','COLETTE','1956-12-06','02.64.28.10.40','06.61.32.40.14',NULL,'25 RUE DES CORMORANS','','','14270','MEZIDON CANON',NULL,NULL,'2561214314001',529.000000000,'1979-02-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1275,'ALLIX','BERNARD','1936-10-12','02.90.37.78.51','06.50.37.70.25',NULL,'3 ROUTE D''ARGENTAN','','','14210','LE LOCHEUR',NULL,NULL,'2361014715001',966.000000000,'1961-06-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1276,'DELANNEE','ROLAND','1929-12-05','02.74.07.40.24',NULL,NULL,'LIEU DIT AUBIGNY','','','14240','CAUMONT L''EVENTE',NULL,NULL,'2291214552001',4372.000000000,'1951-10-31','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1277,'GALLOT','ALBERT','1955-04-30','02.36.27.64.74',NULL,NULL,'13 rue des canadiens','','','14860','BAVENT',NULL,NULL,'2550461354001',42.000000000,'1976-02-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1278,'VIVIEN','JACQUELINE','1942-12-20','02.89.74.98.77',NULL,NULL,'6 RUE CHRESTIEN DE TROYES','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1421297202001',102.000000000,'1966-01-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1279,'KROB','MAURICE','1940-10-02','02.36.78.75.87','06.74.72.45.40',NULL,'13 RUE DES PINSONS','','','14540','POUSSY LA CAMPAGNE',NULL,NULL,'1401050523001',40.000000000,'1968-01-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1280,'DROST','MICHEL','1936-10-31','02.11.73.82.89','06.40.91.43.45',NULL,'','','','14670','TROARN',NULL,NULL,'1361014390001',81.000000000,'1965-09-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1281,'HINGAND','JEAN','1958-01-29','02.18.61.28.51','06.58.51.05.51',NULL,'CHEMIN DE LINFIRMERIE','','','14000','CAEN',NULL,NULL,'2580176390001',348.000000000,'1984-07-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1282,'CAILLON','CHRISTIANE','1935-02-06','02.28.70.94.60','06.71.03.54.28',NULL,'3 IMP BARRASSINS','','',NULL,NULL,NULL,NULL,'1350276021001',69.000000000,'1965-10-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1283,'HUBERT','JACQUES','1930-11-19','02.33.35.95.48','06.89.76.28.66',NULL,'16 RUE FRANCOIS MANSARD','','','61250','HAUTERIVE',NULL,NULL,'2301114160001',36.000000000,'1952-11-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1284,'CAPRON','GISELE','1935-05-12','02.46.80.66.12','06.68.40.48.11',NULL,'12 RUE EMILE ORY','','','14170','HIEVILLE',NULL,NULL,'1350514345001',40.000000000,'1958-01-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1285,'MALLET','GEORGES','1932-05-13','02.87.53.58.17','06.70.26.41.50',NULL,'LOTISSEMENT DES TILLEULS','','','14730','GIBERVILLE',NULL,NULL,'2320561145001',3.000000000,'1962-03-02','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1286,'MITAINE','KLEBER','1937-05-17','02.40.21.00.04','06.36.43.63.57',NULL,'13 RUE DES CHARMILLES','','','14220','TOURNEBU',NULL,NULL,'1370514712001',63.000000000,'1963-12-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1287,'GODDERIDGE','GERARD','1928-05-23','02.26.02.64.60','06.99.17.24.39',NULL,'','','','14000','CAEN',NULL,NULL,'2280514525001',1109.000000000,'1951-09-24','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1288,'MAUGER','GERARD','1934-03-22',NULL,NULL,NULL,'120 JACQUES GEROULT','','','14370','CHICHEBOVILLE',NULL,NULL,'1340350509001',1884.000000000,'1964-09-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1289,'DESLANDES','ODETTE','1959-10-18','02.52.54.56.28','06.91.78.96.59',NULL,'4 ROUTE D''HARCOURT','','','61120','VIMOUTIERS',NULL,NULL,'2591014116001',4.000000000,'1980-11-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1290,'BUDOC','SIMONE','1948-02-04','02.33.45.89.10','06.57.82.59.29',NULL,'81 RUE DE BRETAGNE','','','14000','CAEN',NULL,NULL,'2480214416001',52.000000000,'1972-06-20','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1291,'PHILIPPE','DANIEL','1930-05-28','02.83.83.60.23','06.44.10.69.85',NULL,'3/2 AVENUE DU POINT DU JOUR','','','14120','MONDEVILLE',NULL,NULL,'1300514024001',14.000000000,'1960-10-12','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1292,'JENVRIN','eric','1932-09-04','02.35.59.18.70','06.12.05.95.98',NULL,'2 RUE EUGENE BOUDIN','','','14220','BOULON',NULL,NULL,'2320961166001',621.000000000,'1953-10-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1293,'LEROY','CHRISTIANE','1939-01-22','02.62.59.12.61','06.10.01.74.81',NULL,'10 rue st vincent de paul','','','14860','BAVENT',NULL,NULL,'2390161179001',97.000000000,'1968-07-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1294,'PECQUET','HENRI','1938-11-14','02.80.17.48.18','06.75.63.51.10',NULL,'1 rue de l eglise','','','14940','SANNERVILLE',NULL,NULL,'1381114408001',50.000000000,'1960-07-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1295,'CARABY','DANIEL','1929-01-19','02.85.86.97.95','06.82.30.58.05',NULL,'222 RUE CAPONIERE','','','14270','BIEVILLE QUETIEVILLE',NULL,NULL,'1290114750001',434.000000000,'1957-01-28','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1296,'MARIE','NATHALIE','1939-07-12','02.26.83.28.57','06.11.42.02.05',NULL,'11 RUE ERNEST RENAN','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1390776219001',212.000000000,'1960-07-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1297,'PONTES','JOSSELINE','1930-06-12','02.72.18.90.16','06.37.83.59.93',NULL,'25 RUE DU MOULIN A VOIDE','','','14000','CAEN',NULL,NULL,'1300650378001',18.000000000,'1957-07-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1298,'OZANNE','MARIE DANIELLE','1929-02-27','02.87.74.06.41',NULL,NULL,'4 ROUTE D''ECOUVER','','','14000','CAEN',NULL,NULL,'1290214373001',481.000000000,'1953-03-20','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1299,'MARIE','GILBERT','1939-03-11','02.79.05.30.74',NULL,NULL,'29 RUE DAMOZANE','','','14320','FONTENAY LE MARMION',NULL,NULL,'1390350263001',43.000000000,'1961-03-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1300,'LEMASLE','MONIQUE','1933-03-04','02.89.62.39.59','06.68.48.91.52',NULL,'2 rue guy de maupassant','','','14120','MONDEVILLE',NULL,NULL,'2330314577001',613.000000000,'1955-07-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1301,'ZIMMERMANN','BERNADETTE','1963-01-07','02.30.94.41.17','06.12.07.39.11',NULL,'27 RUE D IFS','','','14400','BAYEUX',NULL,NULL,'2630114287001',28.000000000,'1988-10-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1302,'LEREVEREND','CLAUDE','1939-12-21','02.11.77.85.49','06.28.13.13.45',NULL,'52 BIS ROUTE DE PARIS','','','14160','DIVES SUR MER',NULL,NULL,'1391250356001',780.000000000,'1966-08-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1303,'BOUCHARD','YVETTE','1935-04-23','02.72.32.24.47','06.87.02.14.87',NULL,'20 RUE JACQUES BREL','','','14120','MONDEVILLE',NULL,NULL,'2350414117001',22.000000000,'1964-12-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1304,'CLEMENT','YVETTE','1932-05-20','02.41.22.28.87','06.60.36.38.76',NULL,'4 RUE DE LA COMMUNE','','','14000','CAEN',NULL,NULL,'2320514251001',72.000000000,'1960-10-04','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1305,'HAMELIN','JEAN JACQUES','1930-10-27','02.61.05.72.51','06.55.00.98.42',NULL,'5 RUE DES MOULINS','','','14490','LE TRONQUAY',NULL,NULL,'1301014318001',2991.000000000,'1956-07-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1306,'HUET','RENEE','1930-11-29','02.43.14.78.07','06.11.69.77.53',NULL,'4 ALLEE DU BUCQUET','','','14350','LE BENY BOCAGE',NULL,NULL,'1301161167001',99.000000000,'1956-01-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1307,'GERMAIN','RENEE','1941-03-01','02.33.32.20.33','06.83.31.61.21',NULL,'19 RUE DES FRESNETS','','','14000','CAEN',NULL,NULL,'2410314669001',39.000000000,'1965-06-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1308,'HENRION','ROGER','1961-01-04','02.54.12.56.72','06.13.79.48.34',NULL,'CHEMIN DES PRES','','','15270','CHAMPS SUR TARENTAINE MARCHAL',NULL,NULL,'2610114738001',17.000000000,'1991-01-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1309,'LOSTANLEN','Jean Pierre','1944-02-09','02.15.86.63.09','06.50.57.21.74',NULL,'9 rue de la chardonnrette','','',NULL,NULL,NULL,NULL,'1440227332001',766.000000000,'1973-12-19','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1310,'VAUCLAIR','JEANNINE','1950-07-22','02.27.70.51.09','06.12.01.38.36',NULL,'6 RUE PAUL LANGEVIN','','','14460','COLOMBELLES',NULL,NULL,'2500750398001',242.000000000,'1975-06-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1311,'','JEAN','1950-04-14','02.39.22.59.36','06.77.31.01.23',NULL,'31 residence la chapelle','','','14430','HOTOT EN AUGE',NULL,NULL,'2500414538001',23.000000000,'1974-10-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1312,'FORTIN','Nathalie','1959-04-30','02.33.45.53.90','06.11.31.77.48',NULL,'17 RUE DES CERISIERS','','','14000','CAEN',NULL,NULL,'1590414018001',67.000000000,'1987-01-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1313,'LEPLEY','ROGER','1938-02-05','02.53.30.03.12','06.74.97.88.15',NULL,'5 RUE FARADAY','','','14000','CAEN',NULL,NULL,'2380250111001',290.000000000,'1961-06-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1314,'HARDY','EMILE','1938-11-09','02.15.39.79.96','06.59.94.11.35',NULL,'67 ROUTE DE PARIS','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1381114629001',186.000000000,'1965-11-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1315,'HARDY','RAYMONDE','1949-05-16','02.37.82.53.18','06.39.68.08.98',NULL,'VILLAGE LES HOULLES','','','14000','CAEN',NULL,NULL,'1490514432001',398.000000000,'1977-01-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1316,'SANDEAU','NATHALIE','1968-01-19','02.28.11.14.91','06.46.07.69.57',NULL,'4/3 alle des capucines','','','14970','ST AUBIN D''ARQUENAY',NULL,NULL,'2680114327001',515.000000000,'1989-01-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1317,'BOUSQUET','JOEL','1964-03-13','02.62.70.83.87','06.97.29.95.93',NULL,'16 route du puit','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2640314158001',37.000000000,'1986-04-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1318,'PAWLENKO','SOTHEAVY','1928-08-30','02.81.24.27.35','06.67.18.15.47',NULL,'RUE MALHERBE','','','14260','MONTAMY',NULL,NULL,'2280878127001',83.000000000,'1950-07-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1319,'CHAMPION','GERARD','1932-03-09','02.83.04.89.76','06.39.09.17.11',NULL,'7 RUE SAINT PAIX','','','14190','OUILLY LE TESSON',NULL,NULL,'2320350507001',19.000000000,'1955-03-07','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1320,'VIGET','CATHERINE','1960-04-20','02.94.03.56.97','06.15.77.90.74',NULL,'52 RUE BELLE VU','','',NULL,NULL,NULL,NULL,'2600461408001',356.000000000,'1981-08-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1321,'PECHER','BRUNO','1934-03-21','02.11.76.08.94','06.45.36.35.34',NULL,'5 allee des pains gris','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2340314301001',42.000000000,'1959-04-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1322,'LAIDET','PIERRE','1953-04-01','02.81.74.31.46',NULL,NULL,'4 rue Jean Moulin','','','14630','FRENOUVILLE',NULL,NULL,'1530461166001',40.000000000,'1980-03-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1323,'LE BUAN','MARIA','1930-09-02','02.83.46.05.19','06.27.43.02.29',NULL,'2 COUR TURQUETIL','','','14390','CABOURG',NULL,NULL,'2300950391001',810.000000000,'1953-12-16','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1324,'BUSNOT','ANDREE','1939-07-16','02.10.14.38.84','06.29.95.60.43',NULL,'56 av guynemer','','','14000','CAEN',NULL,NULL,'2390714411001',41.000000000,'1963-08-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1325,'MOULIN','JOCELYNE','1937-11-23','02.89.01.96.12','06.32.16.49.88',NULL,'8 rue du lieu vautier','','','14220','CROISILLES',NULL,NULL,'1371114480001',55.000000000,'1967-01-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1326,'REHE','LUCIEN','1928-10-27','02.71.25.85.57','06.22.32.51.79',NULL,'LA BUTTE ROSSIGNOL','','','14220','GRIMBOSQ',NULL,NULL,'1281059075001',251.000000000,'1949-09-30','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1327,'LESELLIER','MICHEL','1964-03-11','02.41.23.39.58','06.55.81.73.98',NULL,'42AV LEON BLOUM','','','14000','CAEN',NULL,NULL,'2640361376001',27.000000000,'1989-06-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1328,'TAUPIN','JACQUELINE','1931-02-21','02.86.21.49.93','06.68.83.19.41',NULL,'13 RUE DE BRETAGNE','','','14190','URVILLE',NULL,NULL,'2310250087001',3.000000000,'1956-11-17','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1329,'LANGLOIS','ROGER','1938-11-30','02.78.43.69.10','06.37.19.11.14',NULL,'11 RUE DE L ABBAYE','','','14630','CAGNY',NULL,NULL,'1381114207001',2.000000000,'1960-07-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1330,'MERLE','MARIE JEANNE','1961-04-17','02.68.73.26.55','06.14.22.62.21',NULL,'45 rue de bretteville','','','14123','IFS',NULL,NULL,'1610414675001',2628.000000000,'1982-11-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1331,'MALINE','ANDRE','1929-04-09','02.35.89.62.59','06.11.46.80.33',NULL,'2 RUE DE LA PAIX','','','14370','AIRAN',NULL,NULL,'2290461221001',187.000000000,'1951-09-10','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1332,'L HOSTIS','JEAN CLAUDE','1945-06-09','02.64.11.40.45','06.40.30.56.16',NULL,'8 RUE HAUTE FEUILLE','','','14400','BAYEUX',NULL,NULL,'2450614576001',108.000000000,'1970-12-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1333,'PINCON','MARCELLE','1935-11-04','02.87.21.02.29','06.39.16.05.20',NULL,'11 CHEMIN DU BREUIL','','','14130','SURVILLE',NULL,NULL,'1351114564001',32.000000000,'1964-05-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1334,'PEUDECOEUR','DANIEL','1939-10-18','02.87.62.82.19','06.11.58.47.59',NULL,'16 HAMEAU DE NEUF MER','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2391035360001',1417.000000000,'1968-06-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1335,'HAMEL','CLAUDE','1935-12-21','02.61.88.86.93','06.29.61.09.81',NULL,'2 RUE DE LA  PAGNOLEE','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'2351214014001',371.000000000,'1956-04-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1336,'FERREIRA','','1949-01-19','02.34.66.25.38','06.17.60.34.91',NULL,'2 RUE JEANZAY','','','14190','ST SYLVAIN',NULL,NULL,'2490114037001',54.000000000,'1970-02-25','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1337,'LAHAYE','ERIC',NULL,'02.39.00.24.02','06.58.52.11.53',NULL,'21 RUE DE STOCKLOM','','','14500','ST GERMAIN DE TALLEVENDE',NULL,NULL,'1410114662001',264.000000000,'2009-05-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1338,'FLOTTE','GENEVIEVE','1938-07-26','02.45.46.06.16','06.55.99.41.11',NULL,'3 RUE DU MARECHAL JOFFRE','','','14670','TROARN',NULL,NULL,'1380750491001',47.000000000,'1961-08-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1339,'PAGNY','EDMOND','1937-06-16','02.98.45.16.87','06.60.76.14.49',NULL,'34 RUE ANATOLE FRANCE','','','14000','CAEN',NULL,NULL,'1370650095001',666.000000000,'1959-10-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1340,'DOCQUIER','BERNARD','1933-12-13','02.68.08.02.86','06.10.11.65.78',NULL,'17 rte de barbery','','','14120','MONDEVILLE',NULL,NULL,'1331214727001',66.000000000,'1955-12-25','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1341,'STAEL','CLAUDE','1936-08-27','02.45.61.92.98','06.11.57.61.73',NULL,'237 RUE GODET','','','14123','IFS',NULL,NULL,'1360814205001',17.000000000,'1957-10-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1342,'ROUSSELLE','JACQUELINE','1928-05-11','02.88.36.03.20','06.76.04.57.03',NULL,'CHEMIN DE CHAMBRAY','','','14000','CAEN',NULL,NULL,'1280514220001',363.000000000,'1951-10-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1343,'PIERRE DESIRE','RENE','1938-12-31','02.12.33.82.12','06.11.33.94.67',NULL,' 5 rue lemaitre','','','14250','TILLY SUR SEULLES',NULL,NULL,'2381214166001',88.000000000,'1962-08-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1344,'PIERRE DESIRE','DANIEL','1929-08-12','02.38.26.51.76','06.97.99.66.73',NULL,'3 ROUTE DE FOUR','','','14940','TOUFFREVILLE',NULL,NULL,'2290859604001',401.000000000,'1950-09-28','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1345,'MARGUERITE','DELPHINE','1938-10-16','02.10.63.28.23','06.86.79.37.17',NULL,'1 rue de l europe','','','14000','CAEN',NULL,NULL,'1381050083001',64.000000000,'1966-11-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1346,'TIREL','RAYMOND','1966-01-03','02.58.37.44.55','06.96.82.80.90',NULL,'25 boulevard de l''esperance','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'1660150615001',103.000000000,'1987-11-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1347,'TIREL','MADELEINE','1965-08-29','02.42.32.12.81','06.90.88.97.24',NULL,'FERME DU LOGIS','','','14690','PIERREFITTE EN CINGLAIS',NULL,NULL,'1650814033001',42.000000000,'1993-03-29','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1348,'RUAULT','LUCIENNE','1939-09-04','02.26.32.27.63','06.74.14.12.03',NULL,'48 bvd raymond poincare','','','14740','ST MANVIEU NORREY',NULL,NULL,'1390914283001',48.000000000,'1968-06-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1349,'RUAUX','DANIEL','1930-08-26',NULL,NULL,NULL,'3 PLACE ROTTENDORF','','','14730','GIBERVILLE',NULL,NULL,'2300849233001',427.000000000,'1951-01-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1350,'FISCHER','GILBERT','1937-06-05','02.87.86.94.34','06.52.45.48.15',NULL,'6 allee des vignons','','','14480','VILLIERS LE SEC',NULL,NULL,'1370614282001',152.000000000,'1961-03-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1351,'DEPARDIEU','HYACINTHE','1933-02-08','02.85.16.52.77','06.75.66.03.01',NULL,'35 RUE DU VAL D''ODON','','','14530','LUC SUR MER',NULL,NULL,'2330250292001',223.000000000,'1963-04-29','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1352,'JOUANNEAU','MAURICE','1949-05-20','02.70.35.16.07','06.19.70.04.07',NULL,'65 route de coleville','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1490561478001',1183.000000000,'1972-03-01','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1353,'CHARLES','FRANCOISE','1956-05-16','02.90.74.28.78',NULL,NULL,'88 ROUTE D IFS','','','14220','THURY HARCOURT',NULL,NULL,'1560514720001',655.000000000,'1985-06-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1354,'JEHANNE','MONIQUE','1935-02-27','02.11.95.17.99','06.58.91.87.11',NULL,'17 RUE GENERAL DE GAULLE','','',NULL,NULL,NULL,NULL,'2350214488001',68.000000000,'1958-10-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1355,'KACZMAREK','JEAN-LOUIS','1931-05-12',NULL,NULL,NULL,'28 rue des quesnots','','','14123','IFS',NULL,NULL,'1310514309001',48.000000000,'1952-04-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1356,'TAUPIN','JEANNINE','1945-08-27','02.10.96.31.42','06.68.23.84.26',NULL,'15 RUE SIRE DE CREULLY','','','14220','THURY HARCOURT',NULL,NULL,'1450814099001',121.000000000,'1974-04-12','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1357,'BAZIN','NORBERT','1936-01-03','02.45.51.29.45','06.28.70.26.19',NULL,'7 RUE JEAN PHILIPPE RAMEAU','','','14220','THURY HARCOURT',NULL,NULL,'1360114113001',105.000000000,'1959-02-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1358,'HAMONIAUX','LOUIS','1951-02-25','02.60.25.02.25','06.60.00.05.72',NULL,'4 RUE COUCOU','','','14000','CAEN',NULL,NULL,'2510250486001',692.000000000,'1973-12-04','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1359,'HAMEL','PIERRE','1968-04-06','02.75.68.00.56','06.43.28.89.16',NULL,'1 RUE HAMEAU PAISIBLE','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2680414118001',21.000000000,'1995-06-13','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1360,'LE GOVIC','PAUL','1951-02-16','02.87.89.40.36','06.87.57.40.62',NULL,'AVENUE DES GABIONS','','','14370','MERY CORBON',NULL,NULL,'2510250486001',461.000000000,'1977-09-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1361,'PELLOUIN','JEAN','1931-08-22','02.10.51.66.64','06.24.41.46.33',NULL,'LA TOURETTE','','','14000','CAEN',NULL,NULL,'1310861006001',29.000000000,'1956-03-14','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1362,'ELISABETH','VITAL','1968-06-01','02.27.34.34.06','06.58.30.21.57',NULL,'4 PLACE GAL LECLERC','','','14000','CAEN',NULL,NULL,'1680614005001',189.000000000,'1991-05-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1363,'BELLOU','EDMOND','1955-03-06','02.26.68.11.93','06.84.51.79.36',NULL,'15 RUE LAPLACE','','','14620','MORTEAUX COULIBOEUF',NULL,NULL,'1550314483001',2576.000000000,'1985-09-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1364,'VIOLLET','GILBERT','1940-04-20','02.69.45.18.98','06.15.68.64.67',NULL,'2 rue paul langevin','','','50880','PONT HEBERT',NULL,NULL,'2400461054001',223.000000000,'1970-07-29','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1365,'JOUSSET','EMILE','1940-03-24','02.89.89.01.67','06.19.94.68.41',NULL,'1 rue de l''ile de france','','','14000','CAEN',NULL,NULL,'2400314181001',1399.000000000,'1962-11-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1366,'WAGNER','SOLANGE','1931-11-07','02.80.48.25.44','00 33 6.76.61.18.60',NULL,'15 RUE DU MARE','','','14190','ST SYLVAIN',NULL,NULL,'2311114709001',95.000000000,'1955-04-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1367,'ROBERT','ANDRE','1969-07-24','02.17.70.39.06','06.49.30.69.47',NULL,'23 ALLEE DE BRUXELLE','','','14310','VILLERS BOCAGE',NULL,NULL,'1690759183001',19.000000000,'1994-10-28','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1368,'BONNEAU','DANIEL','1928-10-07','02.52.31.68.98','06.79.36.73.81',NULL,'7 ALLEE DES FAUVETTES','','','14000','CAEN',NULL,NULL,'2281014328001',2809.000000000,'1958-02-01','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1369,'PRIN','JACQUES','1939-02-04','02.96.55.35.63','06.44.53.45.10',NULL,'31 CHEMIN DU HAMEL','','','14000','CAEN',NULL,NULL,'2390214346001',6.000000000,'1963-07-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1370,'DEBAIZE','BERNADETTE','1929-08-03','02.10.23.90.51','06.18.04.18.50',NULL,'11LE MONT D UROU','','','14117','ARROMANCHES LES BAINS',NULL,NULL,'1290850492001',380.000000000,'1952-12-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1371,'GUILLOT','claude','1957-08-17','02.37.33.83.07','06.54.15.39.07',NULL,'95 route de rouen','','','14270','MEZIDON CANON',NULL,NULL,'1570814430001',184.000000000,'1985-10-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1372,'JOHN','DENISE','1960-01-01','02.58.37.24.87','06.58.59.14.76',NULL,'23 ALBERT GODARD','','','14123','IFS',NULL,NULL,'1600114581001',721.000000000,'1989-03-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1373,'HEBERT','ROBERT','1934-05-15','02.64.59.36.08','06.47.01.93.27',NULL,'10 rue du pere joseph','','','14123','IFS',NULL,NULL,'1340561410001',23.000000000,'1955-10-31','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1374,'VAUVARIN','YVETTE','1939-09-11','02.84.37.24.75','06.88.83.13.09',NULL,'26 rue vaudieres','','','14340','LA HOUBLONNIERE',NULL,NULL,'2390945225001',135.000000000,'1965-03-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1375,'LELIEVRE','JULIEN','1930-12-28','02.11.82.48.09','06.10.76.68.97',NULL,'57 rue louis lechatelier','','','14460','COLOMBELLES',NULL,NULL,'1301214229001',42.000000000,'1956-02-23','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1376,'QUETEL','ANNE MARIE','1937-02-20','02.32.67.57.85','06.45.72.31.21',NULL,'21 RUE DU HAMEAU FOULON','','','14370','ARGENCES',NULL,NULL,'1370250149001',41.000000000,'1967-01-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1377,'GUILLOT','THERESE','1932-08-18','02.58.02.90.94','06.66.66.48.52',NULL,'43 RUE DES ACACIAS','','','14270','QUETIEVILLE',NULL,NULL,'2320814372001',1431.000000000,'1953-02-02','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1378,'HUBERT','FRANCOIS','1963-01-24','02.46.80.38.45','06.10.76.41.52',NULL,'62 ROUTE DE PARIS','','','14400','ARGANCHY',NULL,NULL,'1630114355001',1086.000000000,'1986-11-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1379,'THOMAS','ROGER','1935-05-06','02.13.67.01.48','06.53.21.85.86',NULL,'19 rue des penses','','',NULL,NULL,NULL,NULL,'1350550483001',627.000000000,'1956-11-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1380,'LELAIDIER','M THERESE','1937-11-28','02.77.27.20.77','06.34.86.62.52',NULL,'15 rue de stockholm','','','14190','ESTREES LA CAMPAGNE',NULL,NULL,'2371114120001',4114.000000000,'1958-02-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1381,'DERRIEN','CORINNE','1935-05-02','02.12.10.07.27','06.73.68.97.75',NULL,'2 rue therese de la varde','','','14121','SALLENELLES',NULL,NULL,'2350514434001',38.000000000,'1958-10-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1382,'ALLIX','CLAUDE','1945-02-11','02.11.93.17.97','06.46.87.55.20',NULL,'14 RUE PAUL LANGEVIN','','','14000','CAEN',NULL,NULL,'1450276279001',103.000000000,'1972-02-24','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1383,'SONNET','LUCIENNE','1932-05-01','02.10.58.42.95','06.12.19.40.74',NULL,'2260 route de coutances','','','14540','BOURGUEBUS',NULL,NULL,'1320514034001',100.000000000,'1958-09-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1384,'COTTRAIT','MAURICETTE','1933-09-25','02.72.56.51.94','06.86.20.33.50',NULL,'LOTISSEMENT LES COTEAUX','','','14000','CAEN',NULL,NULL,'1330961101001',14.000000000,'1959-10-06','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1385,'GUILLEMET','NATAVAN','1959-03-07','02.52.93.67.56','06.11.55.87.51',NULL,'18 RUE DES PRES','','','75116','PARIS',NULL,NULL,'2590314509001',186.000000000,'1982-08-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1386,'DETAIS','ODETTE','1963-02-13','02.72.00.57.53','06.19.77.92.56',NULL,'55 RUE PARC DU CHATEAU','','','14850','HEROUVILLETTE',NULL,NULL,'2630214714001',311.000000000,'1992-08-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1387,'MASSOT','MADELEINE','1937-04-18','02.37.99.52.02','06.20.59.00.16',NULL,'15 QUAI DE LA LONDE','','','14120','MONDEVILLE',NULL,NULL,'1370461469001',1037.000000000,'1963-11-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1388,'DUFOUR','VINCENT','1956-06-24','02.49.98.05.74',NULL,NULL,'8 RUE GEORGES MAUDUIT','','','14000','CAEN',NULL,NULL,'2560614404001',104.000000000,'1979-02-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1389,'DUVAL','MICHEL','1939-03-07','02.60.52.02.85','06.10.77.42.51',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'1390314745001',105.000000000,'1962-01-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1390,'PETITJOUAN','YEZRY','1960-02-20','02.32.53.49.10','06.77.89.71.70',NULL,'4 RUE DU 11 NOVEMBRE','','','14370','MOULT',NULL,NULL,'2600214245001',300.000000000,'1986-09-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1391,'FLEURY','ERIC','1938-08-07','02.11.86.46.81','06.10.13.75.86',NULL,'12 RUE DES GRANDES MURAILLES','','','14730','GIBERVILLE',NULL,NULL,'1380814211001',919.000000000,'1968-08-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1392,'LANDEAU','MADELEINE','1958-10-22','02.57.71.36.33','06.78.56.37.86',NULL,'7 RUE RENE VALOGNES CHEZ MME B','ICHARD M.T','','14700','FOURNEAUX LE VAL',NULL,NULL,'2581051598001',700.000000000,'1983-06-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1393,'VINGTROIS','DANIEL','1931-08-01','02.22.96.51.60','06.88.22.75.98',NULL,'15 RUE DE LA TESTE DE BUCH','','','14000','CAEN',NULL,NULL,'2310861093001',19.000000000,'1960-07-03','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1394,'GUINCESTRE','ODETTE','1933-06-08','02.30.42.94.72','06.72.93.10.64',NULL,'10 RUE DE LA REPUBLIQUE','','','14123','IFS',NULL,NULL,'2330614463001',1525.000000000,'1955-06-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1395,'RAULT','ELISABETH','1947-02-17','02.92.20.54.96','06.67.77.79.95',NULL,'3 RUE DE L''AVIATION','','','14670','TROARN',NULL,NULL,'2470250491001',39.000000000,'1969-01-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1396,'CREMA','MAURICE','1964-01-25','02.64.01.67.01','06.14.88.79.01',NULL,'5/3 ALLEE DES CHEVREFEUILLES','','','14460','COLOMBELLES',NULL,NULL,'1640114734001',88.000000000,'1994-07-29','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1397,'WETZSTEIN','CHRISTIANE','1948-04-23','02.12.67.40.52','06.16.67.00.54',NULL,'3 RUE CHARLOTTE CORDAY','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2480414444001',931.000000000,'1971-08-19','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1398,'BEAUGEARD','MARIE THERESE','1965-05-30','02.17.44.06.77','06.48.68.57.79',NULL,'28 RUE ALFRED DE MUSSET','','','14120','MONDEVILLE',NULL,NULL,'1650514119001',12.000000000,'1990-01-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1399,'HEBERT','PHILIPPE','1933-08-11','02.21.30.33.72','06.44.20.82.25',NULL,'1 3 allee du romarin','','','14940','SANNERVILLE',NULL,NULL,'1330814685001',36.000000000,'1957-01-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1400,'GUERET','YVETTE','1928-03-20','02.57.43.01.84','06.25.49.59.41',NULL,'21 RUE PIERRE DE COUBERTIN','','','61570','ALMENECHES',NULL,NULL,'2280314724001',745.000000000,'1958-10-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1401,'VALENTE','','1937-08-31','02.59.45.40.84','06.36.94.85.16',NULL,'25 rue henri philippe','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1370814351001',130.000000000,'1967-05-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1402,'MARGUERITE','MODESTO','1969-07-02','02.84.35.79.46','06.71.12.75.95',NULL,'6 ALLEE DU FELIER','','','14480','LANTHEUIL',NULL,NULL,'1690714109001',44.000000000,'1992-02-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1403,'SIMEON','RACHELLE','1932-09-28','02.83.29.09.80','06.67.07.20.96',NULL,'5 PLACE GEORGES CLEMENCEAU','','','14150','OUISTREHAM',NULL,NULL,'2320925493001',1919.000000000,'1959-12-31','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1404,'LAFOSSE','JEAN PIERRE','1930-01-21','02.87.38.58.11','06.74.14.64.69',NULL,'78 RUE ST ANNE','','','14000','CAEN',NULL,NULL,'1300114241001',1089.000000000,'1959-09-22','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1405,'','JEAN PIERRE','1939-12-04','02.38.63.67.08','06.59.90.78.61',NULL,'32 BIS AVENUE DE LA PAIX','','','14960','ASNELLES',NULL,NULL,'1391214212001',163.000000000,'1965-10-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1406,'HIE','gerard','1933-06-07','02.66.64.38.73','06.13.80.20.00',NULL,'41 AVEBUE ROBERT SCHUMAN','','','14670','TROARN',NULL,NULL,'2330661078001',2518.000000000,'1954-03-08','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1407,'REBACZ','DIDIER','1940-06-05','02.35.77.37.27','06.72.05.04.16',NULL,'4 ALLEE ALFRED JARRY','','','50120','EQUEURDREVILLE HAINNEVILLE',NULL,NULL,'2400662024001',10.000000000,'1964-01-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1408,'BIREE','SIMONE','1936-04-21','02.73.89.10.52','06.70.11.15.85',NULL,'75 rue eustache restoux','','','14370','BELLENGREVILLE',NULL,NULL,'1360414456001',612.000000000,'1960-06-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1409,'ALBRECHT','ANDREE','1966-01-24','02.11.40.22.29','06.11.69.48.34',NULL,'6 AVENUE DU 19 MARS 1962','','','14370','MOULT',NULL,NULL,'1660162557001',1.000000000,'1989-03-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1410,'MORIN','MARIE','1935-04-29','02.40.44.04.66','06.63.50.18.07',NULL,'27 RUE FROIDE','','','14730','GIBERVILLE',NULL,NULL,'1350414027001',357.000000000,'1956-01-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1411,'LEMOINE','SANDRINE','1945-01-01','02.10.07.55.03','06.71.72.20.73',NULL,'7 RUE DES LILAS','','','14000','CAEN',NULL,NULL,'2450176312001',1026.000000000,'1975-07-06','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1412,'DESGUET','MARGUERITE',NULL,'02.31.67.69.60','06.90.88.72.03',NULL,'36 RUE DE CHAMPAGNE','','','14270','MEZIDON CANON',NULL,NULL,'2400922034001',56.000000000,'2010-05-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1413,'DUVAL','GEORGETTE','1930-03-10','02.89.69.74.04',NULL,NULL,'9 RUE DE LA PETITE LONDE','','','14000','CAEN',NULL,NULL,'2300314692001',210.000000000,'1956-01-11','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1414,'ROUSSEAU','MICHEL','1932-03-19','02.89.80.82.85','06.28.76.03.56',NULL,'10 RUE BEAU SEJOUR','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1320314146001',9.000000000,'1958-12-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1415,'GESTIN','DANIEL','1938-07-21','02.10.77.67.05','06.52.34.91.36',NULL,'LE LONDAIN','','','14630','CAGNY',NULL,NULL,'1380750491001',208.000000000,'1962-11-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1416,'GAUTIER','','1963-11-23','02.99.64.13.87','06.39.82.66.84',NULL,'17 RUE GENERAL DE GAULLE','','','14160','DIVES SUR MER',NULL,NULL,'2631114118001',205.000000000,'1984-07-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1417,'CHEMIN','THERESE','1938-10-11','02.56.75.59.83','06.62.02.36.00',NULL,'6 RUE DE L''ILE DE FRANCE','','','14120','MONDEVILLE',NULL,NULL,'1381050062001',1197.000000000,'1961-03-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1418,'LAMOTTE','CHRISTIAN','1956-02-13','02.51.37.35.46','06.19.43.64.33',NULL,'40 RUE DE LA FRENAYE','','','50160','TORIGNI SUR VIRE',NULL,NULL,'2560214247001',3.000000000,'1977-09-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1419,'GABRIEL','LIONEL','1928-03-14','02.10.03.08.20','06.58.61.60.70',NULL,'8 PLACE DE LA PETITE BRUYERE','','','14000','CAEN',NULL,NULL,'1280314548001',685.000000000,'1956-08-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1420,'LEMAITRE','BERNARD','1939-01-11','02.84.02.87.99','06.14.21.32.11',NULL,'196 RUE DE LA DIME','','','14100','LISIEUX',NULL,NULL,'2390114128001',242.000000000,'1963-10-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1421,'PIQUET','ANNIC','1939-09-06','02.60.63.62.17','06.79.35.09.64',NULL,'3 RUE DE COLOMBELLES','','','14000','CAEN',NULL,NULL,'1390914283001',3755.000000000,'1962-02-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1422,'MEZERETTE','SOPHIE','1933-11-30','02.12.23.98.64','06.61.21.92.93',NULL,'route de la bagotiere','','','14400','BAYEUX',NULL,NULL,'2331114038001',170.000000000,'1963-01-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1423,'BOUGAULT','RAYMONDE','1936-09-22','02.25.75.19.22','06.68.80.42.05',NULL,'LE MESNIL','','','14460','COLOMBELLES',NULL,NULL,'2360914480001',39.000000000,'1962-09-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1424,'BINET','MICHEL','1944-06-19','02.53.66.63.05','06.67.96.37.90',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'2440614196001',39.000000000,'1965-10-27','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1425,'GRANDRIE','JEAN LUC','1937-01-09','02.59.61.71.85','06.18.90.88.77',NULL,'7 rue des chasses','','','14360','TROUVILLE SUR MER',NULL,NULL,'1370114164001',2597.000000000,'1959-02-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1426,'DUCHEMIN','GERARD','1937-01-28','02.10.18.98.37','06.76.07.61.37',NULL,'18 GRANDE RUE','','','14280','ST CONTEST',NULL,NULL,'1370114164001',1344.000000000,'1959-09-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1427,'NOYER','GERARD','1939-11-18','02.88.75.56.60','06.11.92.39.93',NULL,'6 BIS RUE DES ROCHES','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1391189287001',36.000000000,'1960-09-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1428,'TURBAN','GENEVIEVE','1937-05-21','02.10.20.14.32','06.12.09.87.17',NULL,'20 rue anatole france','','','14700','AUBIGNY',NULL,NULL,'2370550099001',1916.000000000,'1958-05-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1429,'REMY','SOLANGE','1953-05-22','02.62.47.04.58','06.71.26.96.80',NULL,'9 RUE RICHARD LENOIR','','','14123','FLEURY SUR ORNE',NULL,NULL,'2530527523001',24.000000000,'1975-05-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1430,'LE DUC','MICHEL','1943-03-01','02.21.26.66.07','06.10.58.04.37',NULL,'4 rue p langevin','','','14000','CAEN',NULL,NULL,'1430327364001',766.000000000,'1964-03-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1431,'SALERNE','MICHELINE','1938-01-08','02.69.53.34.58','06.32.26.72.14',NULL,'8-3 ALLEE DES CAMPANULES','','','14000','CAEN',NULL,NULL,'2380114327001',30.000000000,'1966-10-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1432,'ADAMCIK','FERNAND','1934-02-23','02.82.67.33.04','06.72.03.17.67',NULL,'16 RUE DES SURETS','','','14120','MONDEVILLE',NULL,NULL,'1340214651001',48.000000000,'1963-06-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1433,'CASSIGNEUL','MARIE NOELLE','1942-01-23','02.29.07.48.81','06.72.39.61.14',NULL,'1 CHEMIN DES CALYMENES','','','14370','ARGENCES',NULL,NULL,'2420150038001',19.000000000,'1965-07-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1434,'PITOIS','CLAUDIA','1928-09-18','02.40.15.19.63','06.25.59.20.42',NULL,'RESIDENCE ALBATROS BD BOIVIN CH','AMPEAUX','','14320','FONTENAY LE MARMION',NULL,NULL,'1280914669001',2.000000000,'1953-11-12','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1435,'MADELINE','GERARD','1933-05-15',NULL,NULL,NULL,'7 RUE STE PAIX PORTE B','','','14123','FLEURY SUR ORNE',NULL,NULL,'2330514134001',429.000000000,'1954-10-11','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1436,'LEGRAND','PATRICK','1929-06-26','02.97.65.63.41','06.22.21.37.83',NULL,'15 rue v lepine','','','14000','CAEN',NULL,NULL,'1290650559001',78.000000000,'1959-05-29','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1437,'LEBRUN','JACQUELINE','1929-06-24','02.12.29.96.72','06.92.01.37.53',NULL,'rue du parc','','','14800','TOUQUES',NULL,NULL,'1290650559001',130.000000000,'1952-01-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1438,'SAVARY','SOPHIE','1948-03-10','02.56.15.07.29','06.16.57.76.52',NULL,'8 RUE DES CARMES','','','14730','GIBERVILLE',NULL,NULL,'1480314729001',27.000000000,'1978-08-11','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1439,'QUESLIER','RAYMONDE','1937-11-28','02.12.12.86.56','06.70.14.37.65',NULL,'2 ET 4 AVENUE DE PARIS','','','14000','CAEN',NULL,NULL,'1371150577001',37.000000000,'1965-01-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1440,'CORBIN','ROGER','1935-01-07','02.77.41.81.89','06.71.45.88.65',NULL,'2 RUE BOUTROIS','','','14210','STE HONORINE DU FAY',NULL,NULL,'2350114208001',141.000000000,'1959-07-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1441,'LASSEUR','MICHEL','1958-02-20','02.23.67.04.73','06.56.19.83.89',NULL,'8,rue saint norbert','','','14670','BURES SUR DIVES',NULL,NULL,'2580214315001',253.000000000,'1983-07-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1442,'DRION','JOCELYNE','1936-05-14','02.11.34.53.77','06.11.03.27.88',NULL,'8,rue saint norbert','','','14630','FRENOUVILLE',NULL,NULL,'1360514437001',376.000000000,'1960-09-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1443,'RAVIDAT','BRUNO','1960-03-17','02.39.00.17.51','06.51.93.04.32',NULL,'9 bd de l esperance','','','14000','CAEN',NULL,NULL,'2600314478001',333.000000000,'1989-01-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1444,'LANDAIS','PHILIPPE','1960-03-01','02.22.20.18.89','06.12.34.80.32',NULL,'2-1 ALLEE SERPENTINE','','','14730','GIBERVILLE',NULL,NULL,'2600314274001',792.000000000,'1987-06-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1445,'DERAINE','SOLANGE','1934-10-13','02.51.68.89.82','06.45.49.72.19',NULL,'22 RUE D ARMOR','','','14700','FALAISE',NULL,NULL,'2341014708001',53.000000000,'1956-02-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1446,'NICOLLE','JEAN',NULL,'02.79.53.65.44','06.83.16.36.75',NULL,'13 RUE DE GOURNAY','','','14190','URVILLE',NULL,NULL,'2320561489001',123.000000000,'2008-03-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1447,'MARIE','JACQUELINE',NULL,'02.81.03.39.75','06.30.42.24.22',NULL,'38 BIS ROUTE D''HARCOURT','','','14120','MONDEVILLE',NULL,NULL,'2401253201001',37.000000000,'2011-03-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1448,'GROSSE','MAURICE','1943-02-04','02.10.13.75.77','06.16.46.86.78',NULL,'21 RUE DES MARRONNIERS','','','14990','BERNIERES SUR MER',NULL,NULL,'1430214717001',17.000000000,'1966-04-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1449,'BREANT','ROGER','1940-12-13','02.98.30.05.52','06.10.57.36.97',NULL,'7 rue notre dame des champs','','','14540','GRENTHEVILLE',NULL,NULL,'2401250007001',2443.000000000,'1966-05-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1450,'SANGALLI','GILBERT','1927-03-15','02.67.42.50.95','06.73.14.23.91',NULL,'133 RUE HAUTE','','','14120','MONDEVILLE',NULL,NULL,'2270397103001',4000.000000000,'1951-07-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1451,'LETENNEUR','CHANTAL','1937-07-14','02.39.42.82.31','06.62.73.58.34',NULL,'6 RUE DES JONQUILLES','','','14000','CAEN',NULL,NULL,'2370714516001',43.000000000,'1961-05-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1452,'DE FERRIERE LE VAYER','ROGER','1957-01-26','02.35.25.90.73','06.77.33.75.90',NULL,'74 rue ernest ronand','','','14630','CAGNY',NULL,NULL,'2570114034001',798.000000000,'1986-03-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1453,'N''GUENOR','ROGER','1944-12-10','02.93.24.05.86','06.49.95.41.23',NULL,'9 rue paul samson','','','14123','FLEURY SUR ORNE',NULL,NULL,'2441214237001',29.000000000,'1968-04-22','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1454,'BARBE','EMILE','1931-03-16','02.11.92.28.87','06.66.99.88.48',NULL,'41 RUE AUGUSTE LECHESNE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1310376254001',89.000000000,'1952-08-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1455,'ROUAULT DE COLIGNY','REMY','1934-05-24','02.92.82.09.55','06.62.36.83.66',NULL,'21 bis rue reg de maisonneuve','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1340514073001',258.000000000,'1958-12-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1456,'LE DUC','GENEVIEVE','1931-12-29','02.12.59.57.01','06.39.82.13.35',NULL,'1102 haute folie','','','14190','OUILLY LE TESSON',NULL,NULL,'1311227333001',951.000000000,'1961-05-05','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1457,'LECONTE','JOELLE','1929-09-09','02.29.43.62.86','06.20.82.58.63',NULL,'98 rue de branville bat c','','','14670','TROARN',NULL,NULL,'1290914658001',10.000000000,'1951-10-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1458,'ROUSSEL','ROBERT','1940-04-14','02.88.06.41.81','06.91.97.03.71',NULL,'4 rue soulie','','','14860','BAVENT',NULL,NULL,'2400450235001',184.000000000,'1970-08-21','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1459,'CHEMIN','ERIC','1942-01-30','02.31.55.39.99','06.97.90.07.29',NULL,'9 RUE DE LA HACHE RESIDENCE LES','DELICES','','14610','CAIRON',NULL,NULL,'1420114130001',27.000000000,'1967-12-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1460,'DARTY','GILBERT','1958-01-26','02.32.06.65.36','06.51.84.48.91',NULL,'RESIDENCE DE L''EGLISE BAT B2','','','14940','TOUFFREVILLE',NULL,NULL,'2580114196001',311.000000000,'1979-06-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1461,'LEVAVASSEUR','LYDIE','1935-12-09','02.58.66.43.09','06.29.64.12.11',NULL,'53 RUE SAINT ANDRE','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2351276034001',57.000000000,'1960-06-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1462,'','ANNETTE','1966-02-04','02.31.48.66.33','06.40.27.75.50',NULL,'18 RUE ST ANDRE APPT 27','','','14000','CAEN',NULL,NULL,'1660277331001',1319.000000000,'1990-10-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1463,'LAHAYE','JEANNINE',NULL,'02.66.70.80.43','06.39.03.88.36',NULL,'43 RUE C BLAISOT','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1280414529001',2071.000000000,'2010-06-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1464,'BRIDET','FATIMA','1935-04-09','02.67.92.76.65','06.67.53.65.71',NULL,'25 RUE DE LA FONTAINE','','','14670','JANVILLE',NULL,NULL,'2350461466001',24.000000000,'1959-08-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1465,'CHOUQUARD','YVES','1939-10-26','02.42.28.45.78','06.56.08.97.55',NULL,'12 RUE PAUL DE COUBERTIN','','','95320','ST LEU LA FORET',NULL,NULL,'2391014127001',282.000000000,'1965-10-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1466,'FRAPPIER','DIDIER','1928-05-10','02.63.41.93.82','06.62.59.59.08',NULL,'','','','14160','DIVES SUR MER',NULL,NULL,'1280514220001',12.000000000,'1955-11-02','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1467,'JOUAN','JEANNE','1939-10-08','02.80.74.53.63',NULL,NULL,'19 ROUTE DE TINCHEBRAY','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1391050370001',15.000000000,'1966-08-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1468,'SOYER','GEORGES','1946-03-20','02.58.01.30.25','06.50.14.39.68',NULL,'LOYSEL','','','14460','COLOMBELLES',NULL,NULL,'1460350299001',6.000000000,'1972-07-15','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1469,'FIANT','PIERRETTE','1960-07-21','02.23.97.38.45','06.48.15.59.85',NULL,'4 ALLEE DES FAUSETTES','','','27210','CONTEVILLE',NULL,NULL,'1600714246001',742.000000000,'1988-12-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1470,'BUNEL','JACQUELINE','1927-08-14','02.90.91.86.20','06.23.65.38.60',NULL,'4 RUE DE LA DIVE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2270814008001',642.000000000,'1955-04-11','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1471,'VAUVRECY','MICHEL','1939-02-06','02.51.25.47.43','06.26.78.32.60',NULL,'27 RUE BOUILLON','','','14400','ST MARTIN DES ENTREES',NULL,NULL,'2390214628001',14.000000000,'1961-12-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1472,'AUMOND','EVELINE','1941-05-23','02.65.83.63.12','06.85.00.89.05',NULL,'36 RUE CLEMENCEAU','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1410514134001',930.000000000,'1965-04-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1473,'TURQUET','EMILE','1932-10-10','02.82.93.67.76','06.67.47.99.26',NULL,'75 rue eustache restoux','','','61200','ARGENTAN',NULL,NULL,'1321014479001',208.000000000,'1959-05-22','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1474,'BECQUET','CLAUDE','1959-07-08','02.37.31.48.95','06.48.04.66.63',NULL,'5 rue kalinigrenko','','','14000','CAEN',NULL,NULL,'1590714114001',470.000000000,'1980-12-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1475,'HARIVEL','JEAN','1962-01-16','02.71.23.98.16','06.25.91.73.71',NULL,'1 rue des ecoles','','','14190','ST SYLVAIN',NULL,NULL,'1620114168001',138.000000000,'1983-08-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1476,'HENRY','FRANCOISE','1967-05-24','02.65.95.32.53','06.27.31.27.29',NULL,'43 quai de juillet','','','14670','TROARN',NULL,NULL,'2670514158001',187.000000000,'1990-07-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1477,'CHERUETTE','MAURICE','1928-08-24','02.75.68.58.79','06.39.44.13.72',NULL,'60 rue des accacias','','','14000','CAEN',NULL,NULL,'2280878127001',555.000000000,'1951-02-22','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1478,'CALBRY','ANNE-MARIE','1943-06-27','02.58.57.13.89','06.30.45.41.32',NULL,'23 route de paris','','',NULL,NULL,NULL,NULL,'1430614218001',68.000000000,'1964-06-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1479,'LECLERC','CLAUDINE','1939-08-22','02.65.87.20.35','06.70.87.93.08',NULL,'98 rue bronville','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1390814734001',2802.000000000,'1968-01-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1480,'PERREAU','ROLANDE','1931-08-08','02.50.75.25.80','06.11.85.18.32',NULL,'9 rue gabrielle renou','','','14000','CAEN',NULL,NULL,'2310814437001',342.000000000,'1956-04-02','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1481,'','SOPHIE','1932-11-27','02.12.06.39.05','06.34.11.91.45',NULL,'7 RUE DU STADE','','','14000','CAEN',NULL,NULL,'2321114074001',37.000000000,'1960-02-12','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1482,'ROYER','','1953-03-13','02.21.71.24.91','06.11.23.70.84',NULL,'69 ROUTE NATIONALE','','','50460','TONNEVILLE',NULL,NULL,'2530362071001',2983.000000000,'1975-06-24','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1483,'HAMEL','YVES','1963-12-22','02.63.69.64.71','06.70.87.79.43',NULL,'2 RUE DE SECQUEVILLE','','','14000','CAEN',NULL,NULL,'1631299253001',0.000000000,'1985-04-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1484,'BESNIER','PAUL','1939-06-20','02.50.60.80.67','06.53.36.26.12',NULL,'26 CLOS ST MARTIN','','',NULL,NULL,NULL,NULL,'1390627469001',395.000000000,'1963-01-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1485,'CAGET','CATHERINE','1929-10-18','02.85.87.74.99',NULL,NULL,'LE BOURG','','','14270','MEZIDON CANON',NULL,NULL,'1291002071001',346.000000000,'1954-09-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1486,'LEROUX','RAYMOND','1967-01-14','02.26.19.82.01','06.10.42.66.19',NULL,'16 rue du sentier','','','14840','DEMOUVILLE',NULL,NULL,'2670175022001',32.000000000,'1988-12-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1487,'MALASSIGNE','COLETTE','1940-05-06','02.83.18.93.65','06.77.37.08.91',NULL,'5 rue jean baptiste jaillet','','','14480','LANTHEUIL',NULL,NULL,'1400514501001',21.000000000,'1961-12-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1488,'LELIEVRE','MARIE THERESE','1969-10-02','02.73.67.58.89','06.13.21.80.86',NULL,'LE BOURG','','','14320','FONTENAY LE MARMION',NULL,NULL,'2691042187001',155.000000000,'1994-09-27','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1489,'LEMONNIER','JEAN PAUL','1943-03-14','02.39.36.39.77','06.16.38.26.14',NULL,'3 RUE LENOTRE','','','14670','TROARN',NULL,NULL,'2430341273001',11.000000000,'1973-10-11','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1490,'GURY','NICOLE','1929-12-09','02.81.48.03.48','06.95.49.85.77',NULL,'','','','61570','ALMENECHES',NULL,NULL,'2291214268001',63.000000000,'1957-12-30','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1491,'POREY','AHMED','1929-12-08','02.11.58.76.15','06.43.45.91.66',NULL,'73 BIS RUE DU TOUR DE VILLE','','','14123','IFS',NULL,NULL,'2291214268001',319.000000000,'1955-07-18','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1492,'BEDIER','LAURENCE','1947-02-23','02.76.55.93.69','06.10.01.77.71',NULL,'20 RUE ROBERT LE MAGNIFIQUE','','','14420','POTIGNY',NULL,NULL,'1470214623001',52.000000000,'1974-01-16','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1493,'POUSSIN','LILIANE','1928-03-07','02.38.53.20.07','06.10.44.40.22',NULL,'5 RUE ALBERT CAMUS','','','14000','CAEN',NULL,NULL,'2280314747001',32.000000000,'1955-03-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1494,'GUILLOTIN','HUGUETTE','1960-02-12','02.27.59.76.77','06.82.10.25.06',NULL,'9 RUE DES DUNES','','','14670','TROARN',NULL,NULL,'1600214667001',142.000000000,'1986-02-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1495,'QUIQUEMELLE','JACK','1928-10-05','02.47.62.43.91','06.78.69.46.89',NULL,'54 RUE DE BREST','','','14000','CAEN',NULL,NULL,'1281014316001',3070.000000000,'1949-11-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1496,'QUENTIN','JACQUELINE','1938-09-17','02.75.68.06.41','06.68.15.92.58',NULL,'17 rue des tilleuls','','','14270','MEZIDON CANON',NULL,NULL,'1380914717001',1885.000000000,'1960-04-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1497,'COUTANCE','ROBERT','1948-01-29','02.10.96.31.70','06.11.83.07.34',NULL,'55 route d''ifs','','','14370','MOULT',NULL,NULL,'2480114234001',193.000000000,'1969-09-19','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1498,'SUZANNE','MICHEL','1959-01-06','02.29.84.67.78','06.32.32.17.45',NULL,'42 RUE DU CHANT DES OISEAUX','','','14400','BAYEUX',NULL,NULL,'2590114258001',52.000000000,'1981-11-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1499,'GUERIN','NICOLE','1963-04-03','02.89.94.82.97','06.12.04.29.71',NULL,'32 RUE DE BRUXELLES','','','14630','CAGNY',NULL,NULL,'2630414257001',24.000000000,'1993-09-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1500,'LOREL','THERESE','1928-01-10','02.47.11.41.15','06.85.23.01.88',NULL,'12 CHEMIN DES POISSONNIERS','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1280178360001',388.000000000,'1949-06-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1501,'EVRARD','JEAN','1963-05-03','02.69.02.75.54','06.16.16.68.85',NULL,'2 rue des balcons','','','14730','GIBERVILLE',NULL,NULL,'1630508480001',1006.000000000,'1992-04-08','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1502,'NIRO','JACQUELINE','1964-05-18','02.58.76.74.38',NULL,NULL,'3 RUE ALBERT BAYET','','','14000','CAEN',NULL,NULL,'2640550181001',69.000000000,'1994-07-05','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1503,'BOURLIER','PAULETTE','1936-06-27','02.54.20.30.82','06.25.02.10.17',NULL,'HAMEAU DE JACOB MESNIL','','','14840','DEMOUVILLE',NULL,NULL,'2360653230001',192.000000000,'1960-08-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1504,'MARION','PIERRE','1945-06-03','02.63.41.12.91','06.48.51.78.93',NULL,'7 IMPASSE DES PENSEES','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'2450661505001',64.000000000,'1969-11-26','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1505,'BRETONNIER','jacques','1929-01-06','02.71.66.82.03','06.16.71.73.45',NULL,'LE BOURG','','','14123','IFS',NULL,NULL,'1290127006001',753.000000000,'1951-11-26','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1506,'PERRIN','MICHEL','1930-06-25','02.28.24.42.86','06.51.28.88.01',NULL,'145 RESIDENCE DES TAMARIS','','','50460','QUERQUEVILLE',NULL,NULL,'1300614602001',42.000000000,'1954-05-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1507,'ROSIER','YVES','1933-03-24','02.23.70.64.90','06.14.67.19.19',NULL,'ROUTE D''ORBEC','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1330314716001',228.000000000,'1962-11-21','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1508,'HEURTEBISE','GUY','1962-02-10','02.75.69.05.29','06.35.09.21.80',NULL,'801 QUARTIER DU VAL','','','14400','BAYEUX',NULL,NULL,'2620214248001',4164.000000000,'1988-08-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1509,'GUERARD','SOLANGE','1960-02-25','02.63.67.60.87','06.79.98.67.71',NULL,'LOT LES BELEMNITES','','','14123','IFS',NULL,NULL,'1600272323001',29.000000000,'1986-05-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1510,'DANJOU','RICHARD','1932-04-01','02.11.77.02.74',NULL,NULL,'64 RUE DE CONDE','','','14000','CAEN',NULL,NULL,'1320450170001',402.000000000,'1955-05-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1511,'GAUDIN','armelle','1934-02-17','02.47.64.60.51','06.81.18.41.38',NULL,'19 rue du bois','','','14120','MONDEVILLE',NULL,NULL,'2340261094001',5.000000000,'1958-10-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1512,'TORCHIO','charles','1944-04-20','02.33.75.70.14','06.33.45.12.94',NULL,'1 RUE VILAINE','','','61160','MONTABARD',NULL,NULL,'1440431457001',537.000000000,'1974-07-16','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1513,'GAYET','Joseph','1935-10-24','02.64.08.21.00','06.16.78.11.77',NULL,'6 RUE DU PETIT BONHEUR','','','14000','CAEN',NULL,NULL,'2351014157001',961.000000000,'1962-10-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1514,'EVRARD','JACQUELINE','1942-04-26','02.12.03.70.87','06.80.69.69.50',NULL,'les epinettes','','','14100','LISIEUX',NULL,NULL,'2420462702001',60.000000000,'1965-07-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1515,'MARTIN','YVETTE','1937-10-13','02.98.81.38.06','06.68.56.96.02',NULL,'5 VILLAGE LA ROCQUE','','','14000','CAEN',NULL,NULL,'2371014408001',315.000000000,'1967-01-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1516,'HARACHE','GEORGETTE','1939-01-10','02.32.97.99.56','06.79.24.38.68',NULL,'8 RUE DR BOUTROIS','','','50580','ST REMY DES LANDES',NULL,NULL,'1390114452001',102.000000000,'1963-12-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1517,'BUNEL','BERNARD','1932-06-20','02.11.71.85.80','06.31.94.39.41',NULL,'8 RUE DU DR BOUTROIS','','','14380','LANDELLES ET COUPIGNY',NULL,NULL,'2320614118001',7.000000000,'1962-07-02','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1518,'HUCHET','REMI','1934-10-19','02.26.93.43.18','06.92.08.22.35',NULL,'14 BIS RUE DE BRAS','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1341035025001',1496.000000000,'1956-01-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1519,'LEQUESNE','PIERRE','1934-08-22','02.38.03.14.73','06.31.81.19.69',NULL,'12 rue marechal foch','','',NULL,NULL,NULL,NULL,'2340850110001',133.000000000,'1958-03-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1520,'LOPEZ','','1936-08-18','02.95.98.06.21','06.63.72.99.38',NULL,'','','','14000','CAEN',NULL,NULL,'2360814100001',557.000000000,'1960-07-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1521,'ASSELINE','MARTINE','1937-01-05','02.30.83.77.97','06.86.42.89.48',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1370114733001',257.000000000,'1960-05-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1522,'BOULENT','SERGE','1936-12-09','02.35.92.13.26','06.20.41.54.57',NULL,'11 RESIDENCE JEAN RACINE','','','14540','SOLIERS',NULL,NULL,'1361214221001',37.000000000,'1958-06-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1523,'GRANGERE','DIDIER','1934-08-05','02.83.64.59.44','06.10.66.44.54',NULL,'LIEU DIT"RATPRUNE"','','','14530','LUC SUR MER',NULL,NULL,'2340814301001',24.000000000,'1955-02-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1524,'HEBERT','DANIELLE','1944-05-14','02.17.71.72.05','06.50.41.73.06',NULL,'ouffieres','','','14370','MOULT',NULL,NULL,'1440577311001',23.000000000,'1966-02-05','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1525,'QUEUDEVILLE LE BOEUF','MADELEINE','1937-05-23','02.10.32.24.23','06.88.98.25.07',NULL,'17 allee laperouse','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2370514720001',299.000000000,'1963-09-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1526,'ENAULT','JULES','1944-03-02','02.27.61.51.19','06.55.38.47.69',NULL,'3 RUE DES MINEURS','','','61500','CHAILLOUE',NULL,NULL,'1440314063001',164.000000000,'1965-10-29','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1527,'HELIE','HENRI','1945-03-27','02.12.30.63.50','06.50.65.58.62',NULL,'18 rue hinbaut','','','61200','ARGENTAN',NULL,NULL,'2450314172001',167.000000000,'1973-08-25','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1528,'JAMME','GEORGES','1932-08-16','02.10.79.08.69','06.11.25.96.10',NULL,'7 PLACE CLAUDE DEBUSSY','','','14000','CAEN',NULL,NULL,'1320886120001',39.000000000,'1956-08-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1529,'JACQUELINE','GASTON','1936-02-22','02.42.14.59.45','06.18.52.15.28',NULL,'1 RUE DES JONQUILLES','','','14240','CAUMONT L''EVENTE',NULL,NULL,'1360214114001',704.000000000,'1959-08-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1530,'LESOMPTIER','EVELYNE','1942-01-06','02.42.15.81.71','06.55.11.09.68',NULL,'11 RUE DU 8 JUIN','','','61200','UROU ET CRENNES',NULL,NULL,'2420114266001',1930.000000000,'1967-05-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1531,'GARNIER','FRANCOIS','1950-10-09',NULL,NULL,NULL,'15 RUE DU CLOS NEUF','','','14000','CAEN',NULL,NULL,'1501014018001',18.000000000,'1978-06-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1532,'LUNEL','MARIE-THERESE','1930-11-10','02.90.03.05.94','06.28.59.46.14',NULL,'2 rue du rservoire','','','14600','HONFLEUR',NULL,NULL,'2301114012001',2.000000000,'1958-04-06','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1533,'BERTRAND','CLAUDE','1940-05-11','02.19.24.76.70','06.81.51.67.57',NULL,'25 CHEMIN DES VIGNES','','','14370','MOULT',NULL,NULL,'2400514603001',329.000000000,'1963-10-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1534,'PERRIN','VIVIANE','1965-01-26','02.82.34.26.01','06.27.88.38.11',NULL,'5 rue eustache pilon','','','14330','LE MOLAY LITTRY',NULL,NULL,'1650114471001',297.000000000,'1989-10-16','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1535,'LEMAINE','YVETTE','1949-01-31','02.71.41.77.63','06.10.50.89.22',NULL,'9 RUE DES COSTILS','','','14120','MONDEVILLE',NULL,NULL,'2490114060001',303.000000000,'1977-10-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1536,'GOUWY','JEAN MARIE','1942-04-02','02.69.99.41.76','06.82.69.67.32',NULL,'2 BIS RUE PRESSENCE','','','14000','CAEN',NULL,NULL,'2420427074001',162.000000000,'1965-08-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1537,'CARIOT','GERARD','1931-09-13','02.11.41.10.33','06.27.31.35.91',NULL,'le chateau','','','14370','MOULT',NULL,NULL,'1310914370001',1550.000000000,'1953-12-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1538,'LAVENU','JEAN CLAUDE','1936-02-02','02.15.84.06.21','06.30.45.69.99',NULL,'7 RUE DU ROND POINT','','','14210','MAIZET',NULL,NULL,'1360214103001',88.000000000,'1958-10-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1539,'ROUSSELET','LUCIENNE','1969-10-02','02.10.26.37.35','06.25.70.91.30',NULL,'29 RUE EMILE MOUGINS','','','61410','COUTERNE',NULL,NULL,'2691014566001',2643.000000000,'1992-01-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1540,'PIQUOT','JACQUELINE','1954-01-22','02.99.16.20.79','06.55.86.51.00',NULL,'LA GROSDAIE','','','14370','BELLENGREVILLE',NULL,NULL,'2540161314001',731.000000000,'1984-06-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1541,'BESSELIEVRE','MIREILLE','1936-01-13','02.81.28.80.82','06.10.08.30.46',NULL,'8 RUE DU PIN','','','14540','SOLIERS',NULL,NULL,'2360149038001',1957.000000000,'1966-11-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1542,'LECLERC','JEAN-LOUIS','1940-01-06','02.49.67.69.97','06.81.35.26.21',NULL,'62 ROUTE DE GOUVIX','','','14000','CAEN',NULL,NULL,'2400161431001',66.000000000,'1968-06-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1543,'LEPOITTEVIN','JEAN LOUIS','1959-04-26','02.75.57.27.97','06.14.12.77.82',NULL,'15 rue marie curie','','','14540','SOLIERS',NULL,NULL,'2590414396001',21.000000000,'1982-06-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1544,'DUFOUR','ELISE','1934-04-11','02.95.15.42.92','06.11.30.60.73',NULL,'18 rue nicolas copernic','','',NULL,NULL,NULL,NULL,'2340414510001',54.000000000,'1962-06-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1545,'DUCLOS','YVONNE','1939-09-22','02.41.86.20.36','06.59.60.00.83',NULL,'LE HAMEL','','','14540','GRENTHEVILLE',NULL,NULL,'2390914543001',131.000000000,'1962-06-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1546,'DUCLOS','DIDIER','1952-04-09','02.96.03.91.72','06.72.83.52.81',NULL,'1 RUE DE L''OCEAN','','','14670','TROARN',NULL,NULL,'2520461474001',61.000000000,'1982-04-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1547,'FLEURENCE','MAURICETTE','1939-05-21','02.60.76.77.64','06.68.38.59.72',NULL,'8 RUE COLOMBELLES','','','14000','CAEN',NULL,NULL,'1390514411001',1818.000000000,'1962-04-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1548,'BAJARD','MADELEINE','1918-02-16','02.34.65.06.46','06.74.14.55.77',NULL,'53 rue du conte','','','14730','GIBERVILLE',NULL,NULL,'1180273085001',61.000000000,'1940-06-01','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1549,'MARIENNE','BERNARD','1930-08-17','02.41.19.02.32','06.90.31.19.57',NULL,'5 RUE DES EQUIPES D''URGENCE','','','14340','ST LOUP DE FRIBOIS',NULL,NULL,'2300850406001',9.000000000,'1958-02-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1550,'BUNEL','RAYMOND','1931-10-30','02.11.61.05.80','06.15.38.04.88',NULL,'47 RUE ALFRED DE MUSSET','','','14000','CAEN',NULL,NULL,'2311061349001',368.000000000,'1960-04-12','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1551,'ZIMMERMANN','LUCETTE','1939-10-09','02.52.92.91.22','06.58.70.35.02',NULL,'6 RUE BOUAKE','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2391014150001',1047.000000000,'1961-01-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1552,'LEPETIT','ANNIE GHISLAINE','1956-04-21','02.29.30.52.48','06.25.26.02.86',NULL,'AVENUE DE LA PLAGE','','','14130','BLANGY LE CHATEAU',NULL,NULL,'2560414640001',65.000000000,'1980-07-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1553,'POULAIN','GEORGES','1929-09-10','02.30.45.87.49','06.94.06.27.16',NULL,'29 RUE DU FOURCHI','','','14460','COLOMBELLES',NULL,NULL,'1290961472001',35.000000000,'1951-03-22','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1554,'BRUNET','ALAIN',NULL,'02.60.98.92.91','06.17.34.35.00',NULL,'24 RUE DU CERISIER','','','14220','FRESNEY LE VIEUX',NULL,NULL,'2400950181001',383.000000000,'2011-06-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1555,'BEROT','ANTOINE','1936-08-08','02.11.18.72.44','06.95.35.80.52',NULL,'','','','14370','ARGENCES',NULL,NULL,'1360850052001',326.000000000,'1957-12-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1556,'ACHER','MICHEL','1938-07-01','02.77.25.76.42','06.34.06.82.60',NULL,'chemin du basfond','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'2380714271001',49.000000000,'1961-10-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1557,'MARIE','MICHELLE','1932-03-02','02.68.00.11.20','06.12.02.75.66',NULL,'91 AV CHARLEMAGNE','','','14230','ISIGNY SUR MER',NULL,NULL,'1320314140001',13.000000000,'1961-09-24','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1558,'MARIE','CHRISTIANE','1939-05-01','02.47.73.47.52','06.29.73.06.86',NULL,'15 RUE APOLLON 11','','','14111','LOUVIGNY',NULL,NULL,'1390514302001',1793.000000000,'1962-12-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1559,'DOGUET','RAYMONDE','1938-02-11','02.52.60.57.69','06.53.20.83.37',NULL,'31 RUE DE LA GARE','','','61400','ST LANGIS LES MORTAGNE',NULL,NULL,'2380214121001',28.000000000,'1967-09-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1560,'AUVRAY','GINETTE','1930-11-06','02.98.25.08.87','06.36.48.35.95',NULL,'','','','14740','LASSON',NULL,NULL,'1301161167001',853.000000000,'1954-05-06','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1561,'MICHEL','ANDRE','1936-03-04','02.18.43.42.57','06.52.37.74.99',NULL,'38 rue principale','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1360314666001',647.000000000,'1961-10-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1562,'NEUVILLE','DANIEL','1935-02-26','02.15.73.79.64','06.39.09.99.81',NULL,'7 RUE DE L''AVENIR','','','14400','BAYEUX',NULL,NULL,'1350214659001',402.000000000,'1960-06-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1563,'MARIE','GAEL','1935-12-28','02.10.43.63.91','06.22.60.15.40',NULL,'ferme du lieu d agneau','','','14000','CAEN',NULL,NULL,'2351214298001',61.000000000,'1961-02-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1564,'MORISSET','MARTIAL','1929-06-14','02.63.85.58.54','06.30.91.09.44',NULL,'LIEU ST GERMAIN','','','14000','CAEN',NULL,NULL,'2290614677001',3346.000000000,'1950-10-13','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1565,'MADELINE','RENE','1935-11-22','02.18.53.20.91','06.83.55.33.08',NULL,'5 RUE DAMOZANNE','','','14111','LOUVIGNY',NULL,NULL,'2351114005001',277.000000000,'1960-06-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1566,'VIVIEN','JACQUES','1962-05-05','02.26.15.94.25','06.70.50.06.10',NULL,'6 rue du luxembourg','','','14000','CAEN',NULL,NULL,'2620527192001',1374.000000000,'1992-01-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1567,'LETOUZEY','','1938-03-09','02.84.11.22.17','06.12.38.18.24',NULL,'5 rue des marches','','','61570','MORTREE',NULL,NULL,'1380350356001',34.000000000,'1967-01-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1568,'PERRINE','NICOLAS','1962-01-18','02.34.36.47.72','06.71.29.91.60',NULL,'86 bis rue de brancille','','','14240','CAHAGNES',NULL,NULL,'1620114692001',510.000000000,'1992-05-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1569,'DUBREUIL','BERNARD','1934-01-16','02.88.01.79.59','06.28.62.39.12',NULL,'48 rue du paty','','','14540','SOLIERS',NULL,NULL,'1340114449001',211.000000000,'1955-12-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1570,'LEJEUNE','CLAUDINE','1935-10-22','02.31.85.28.42','06.45.63.26.25',NULL,'60 rue des acassias','','','14000','CAEN',NULL,NULL,'2351014570001',177.000000000,'1958-02-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1571,'LORAULT','CLAUDINE','1938-11-30','02.61.06.37.04','06.52.39.58.71',NULL,'3 RUE DU 9 JUILLET','','','14111','LOUVIGNY',NULL,NULL,'1381114321001',23.000000000,'1961-07-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1572,'HEBERT','ODETTE','1940-07-10','02.10.13.95.59','06.84.25.68.63',NULL,'place de la mairie','','',NULL,NULL,NULL,NULL,'1400714076001',37.000000000,'1966-04-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1573,'GROULT','CATHERINE','1931-06-24','02.44.73.02.43','06.11.55.03.63',NULL,'','','','14670','ST PAIR',NULL,NULL,'1310676754001',1239.000000000,'1961-03-04','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1574,'LALISSE','JEANNINE','1930-07-08','02.20.77.18.66','06.13.60.20.19',NULL,'12RUE GEORGES FRANCOIS','','','14210','AMAYE SUR ORNE',NULL,NULL,'2300714158001',75.000000000,'1952-01-22','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1575,'DODEMAN','NICOLE','1966-06-16','02.60.59.39.95','06.71.25.43.62',NULL,'4 de la dive','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1660614288001',818.000000000,'1996-11-06','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1576,'HUGUET','JEAN','1942-01-25','02.26.82.43.85','06.12.02.59.09',NULL,'6 Chemin du Home','','','14370','MOULT',NULL,NULL,'2420114063001',50.000000000,'1963-02-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1577,'CHESNE','ALINE','1932-09-26','02.50.73.79.41','06.26.21.04.94',NULL,'12 RUE DE VASSY','','','14740','ST MANVIEU NORREY',NULL,NULL,'1320936046001',2967.000000000,'1955-08-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1578,'RICHER','GILBERT','1959-01-15','02.81.62.91.13','06.67.90.65.44',NULL,'16 RUE LOUIS LACHENAL','','','14860','BAVENT',NULL,NULL,'1590127367001',43.000000000,'1980-08-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1579,'VAN LAEYS','DENIS','1961-04-10','02.16.86.76.25','06.10.20.29.98',NULL,'LA CATHIOLE RD 513','','','14150','OUISTREHAM',NULL,NULL,'1610414145001',13.000000000,'1987-08-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1580,'LEPLANQUOIS','Marie francoise','1937-09-14','02.52.43.32.05','06.29.09.72.22',NULL,'26 RUE DANIEL DANJON','','','14630','CAGNY',NULL,NULL,'1370914268001',136.000000000,'1965-02-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1581,'HAREL','ANDRE','1933-04-26','02.97.76.16.16','06.12.12.60.23',NULL,'7 RUE DU CALVAIRE','','','14700','FALAISE',NULL,NULL,'1330450257001',1521.000000000,'1956-06-24','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1582,'REVERT','THERESE','1932-08-30','02.15.58.72.56','06.25.82.75.25',NULL,'43 rue de lisbonne','','','14630','CAGNY',NULL,NULL,'1320886120001',632.000000000,'1957-07-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1583,'BEN MERZOUG','PATRICIA','1937-12-15','02.73.41.12.72','06.83.87.71.74',NULL,'2 rue marechal joffre','','','14460','COLOMBELLES',NULL,NULL,'1371214506001',27.000000000,'1966-01-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1584,'BEN MERZOUG','NATHALIE','1934-08-29','02.51.46.34.47','06.19.46.41.76',NULL,'44 rue maurice fouques','','','14370','MOULT',NULL,NULL,'2340814677001',589.000000000,'1957-11-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1585,'ALEXANDRE','MARGUERITE','1936-03-28','02.55.08.87.07','06.56.94.58.48',NULL,'44 rue maurice fouques','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2360350583001',64.000000000,'1958-08-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1586,'MAUGER','MARCEL','1969-11-07','02.61.30.94.38','06.34.14.13.36',NULL,'','','','14790','VERSON',NULL,NULL,'1691199256001',458.000000000,'1993-12-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1587,'','ROGER','1947-01-08','02.29.89.78.98','06.44.51.19.64',NULL,'216 RUE DU CHEMIN VERT','','','14940','SANNERVILLE',NULL,NULL,'1470175114001',3349.000000000,'1970-09-11','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1588,'RENIER','HENRIETTE','1976-06-05','02.30.37.17.40','06.33.62.25.59',NULL,'8 RUE DU CALVAIRE','','','14111','LOUVIGNY',NULL,NULL,'2760699238001',42.000000000,'1999-02-19','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1589,'ACHARD','JEAN CLAUD','1960-05-31','02.77.87.54.88','06.63.60.72.44',NULL,'rue juno residence la chenaie','','','14400','BAYEUX',NULL,NULL,'1600599352001',12.000000000,'1981-05-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1590,'CASTEL','PASCAL','1937-07-10','02.12.06.51.03','06.43.98.73.65',NULL,'3 RUE LEO DELIBES','','','14130','PONT L''EVEQUE',NULL,NULL,'1370714325001',57.000000000,'1958-02-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1591,'GUIBOUT','REGINE','1928-09-30','02.65.16.35.85','06.89.64.33.26',NULL,'5 RUE DU LUCET','','','14123','FLEURY SUR ORNE',NULL,NULL,'1280927485001',2.000000000,'1950-05-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1592,'LE GUERN','MARCEL','1928-09-21','02.63.01.63.08','06.71.07.54.95',NULL,'LE BOURG','','',NULL,NULL,NULL,NULL,'1280914409001',1.000000000,'1949-05-26','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1593,'LE ROUZES','STEPHANIE','1938-04-19','02.39.73.98.01','06.75.22.40.14',NULL,'7 ALLEE WINNIPEG','','','14370','BELLENGREVILLE',NULL,NULL,'1380414348001',84.000000000,'1959-04-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1594,'SONNET','Therese','1913-04-15','02.60.21.40.05','06.91.56.47.78',NULL,'1 allee louis edouard garrido','','',NULL,NULL,NULL,NULL,'2130465025001',41.000000000,'1943-09-08','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1595,'VALLEREND','JEAN PIERRE','1938-07-22','02.83.13.60.19','06.79.00.23.06',NULL,'29 RUE DU PARC','','','50300','AVRANCHES',NULL,NULL,'1380750570001',3457.000000000,'1964-07-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1596,'CUSSY','GERARD','1959-02-09','02.63.40.03.92','06.81.69.39.96',NULL,'53 bd de retel','','',NULL,NULL,NULL,NULL,'1590214544001',2385.000000000,'1988-06-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1597,'LETONDEUR','FERNANDE','1936-07-25','02.73.45.68.18','06.98.47.27.87',NULL,'111 RUE DES RELIGIEUSES','','','14540','SOLIERS',NULL,NULL,'1360714437001',29.000000000,'1960-04-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1598,'BISSON','MAURICE','1931-03-04','02.35.09.73.44','06.56.53.12.40',NULL,'21 rue de la cavee','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2310314760001',539.000000000,'1952-02-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1599,'LETELLIER','FRANCINE','1935-06-21','02.32.08.80.67','06.82.39.26.85',NULL,'hameau du puis','','','14123','IFS',NULL,NULL,'2350614218001',506.000000000,'1960-01-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1600,'DEMONT','MICHEL','1934-02-10','02.38.61.26.91','06.78.09.36.02',NULL,'CHEMIN DU MANOIR','','','14730','GIBERVILLE',NULL,NULL,'1340214553001',233.000000000,'1962-09-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1601,'DESETABLE','THIERRY','1962-01-10','02.67.15.52.03','06.58.02.43.41',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'1620114020001',22.000000000,'1983-02-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1602,'SAMSON','GUY','1934-05-16','02.67.32.23.66','06.51.51.81.71',NULL,'fromentel','','','14000','CAEN',NULL,NULL,'2340514508001',139.000000000,'1956-10-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1603,'','HUGUETTE','1940-12-08','02.19.09.96.92','06.69.67.96.07',NULL,'16 ruest andre','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1401214456001',68.000000000,'1965-03-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1604,'BRIZARD','DENISE','1939-04-11','02.77.15.68.79','06.29.33.07.36',NULL,'2 BIS RUE DE PRESSENCE','','','14000','CAEN',NULL,NULL,'1390450198001',68.000000000,'1962-12-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1605,'LEBRETON','SUZANNE','1967-04-15','02.17.65.29.72','06.68.68.59.82',NULL,'3 rue de la plaine','','','14120','MONDEVILLE',NULL,NULL,'2670414356001',51.000000000,'1992-06-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1606,'PILON','CHARLOTTE',NULL,'02.73.50.37.62','06.55.14.45.63',NULL,'6 village lallemand','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2390550554001',743.000000000,'2009-09-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1607,'LEPRAT','HELENE','1940-09-30','02.88.90.44.85','06.79.28.01.33',NULL,'15 ROUTE DE CAMBRAI','','','61570','MORTREE',NULL,NULL,'2400914117001',15.000000000,'1963-09-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1608,'DENOUETTE','JEAN-FRANCOIS','1930-11-05','02.83.84.59.13','06.23.24.26.47',NULL,'16 CHEMIN DU SOL ROC','','','14000','CAEN',NULL,NULL,'1301161387001',69.000000000,'1952-08-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1609,'DENOUETTE','MADELEINE','1939-07-02','02.57.58.79.37','06.52.81.98.56',NULL,'2 BIS DE LA COOPERATIVE','','','14540','ROCQUANCOURT',NULL,NULL,'2390714566001',38.000000000,'1960-02-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1610,'LETURCQ','LILIANE','1940-09-10','02.85.18.15.55','06.19.68.96.89',NULL,'3 RUE DES LAURIERS','','','14430','GOUSTRANVILLE',NULL,NULL,'1400914391001',3742.000000000,'1963-11-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1611,'FLOCH','FRANCINE','1938-08-12','02.48.11.33.14','06.30.22.99.28',NULL,'20 RUE LUCIEN MANGEMATIN','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1380814357001',161.000000000,'1968-09-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1612,'HIS','HENRIETTE','1936-02-12','02.11.00.26.99','06.34.71.54.95',NULL,'2 RESIDENCE DU CHARDONNERET','','','50680','ST CLAIR SUR L''ELLE',NULL,NULL,'2360214606001',295.000000000,'1966-02-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1613,'BROSSARD','BERNARD','1937-02-10','02.87.86.02.67','06.76.81.16.31',NULL,'LA HOUARDIERE','','','14100','LISIEUX',NULL,NULL,'1370227251001',28.000000000,'1960-09-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1614,'HENRY','LUCIEN','1920-07-27','02.42.53.39.24','06.70.39.12.53',NULL,'la pilliere','','','14190','URVILLE',NULL,NULL,'1200744184001',96.000000000,'1943-10-02','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1615,'THOMAS','BERNARD','1935-09-20','02.83.04.00.76','06.24.10.69.49',NULL,'75 RUE DU CENTRE','','','14330','LE MOLAY LITTRY',NULL,NULL,'1350914119001',1883.000000000,'1963-09-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1616,'DELILLE','MARIE','1942-06-21','02.81.07.11.77','06.68.97.30.18',NULL,'le pillieres','','','14640','VILLERS SUR MER',NULL,NULL,'1420614458001',28.000000000,'1971-06-03','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1617,'PONTES','ANDREE','1931-02-03','02.14.66.19.96','06.50.91.67.88',NULL,'12 rue arsene richard','','','50250','LITHAIRE',NULL,NULL,'1310214734001',772.000000000,'1960-01-28','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1618,'DURAND','CHARLOTTE','1928-04-24','02.48.15.68.21','06.58.34.91.26',NULL,'19 rue goujarde','','','61100','FLERS',NULL,NULL,'1280461370001',87.000000000,'1952-01-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1619,'SONNET','SOLANGE','1935-05-11','02.45.08.67.82','06.57.20.36.49',NULL,'3 res du beau site','','','14000','CAEN',NULL,NULL,'1350553183001',39.000000000,'1964-02-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1620,'FOUQUES','MAURICE','1949-02-07','02.71.07.90.74',NULL,NULL,'154 rue de falaise','','','14000','CAEN',NULL,NULL,'1490214530001',41.000000000,'1974-11-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1621,'MADELEINE','HENRIETTE','1932-05-27','02.32.62.35.46','06.48.28.79.86',NULL,'14 RUE FRANCOIS MITTERRAND','','','14123','IFS',NULL,NULL,'1320514509001',34.000000000,'1956-04-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1622,'FAINS','SYLVIE','1934-06-06','02.80.00.84.02','06.64.09.00.07',NULL,'HAMEAU DES ORMES','','','14000','CAEN',NULL,NULL,'2340614197001',102.000000000,'1957-11-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1623,'SUARD','GISELE','1935-09-02','02.61.74.40.88',NULL,NULL,'2 RUE DES AUNES','','','14630','CAGNY',NULL,NULL,'1350950377001',162.000000000,'1956-04-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1624,'THOMAS','GUY','1949-01-28','02.59.84.03.91','06.86.67.77.64',NULL,'coupigny','','','14310','MONTS EN BESSIN',NULL,NULL,'2490144200001',4944.000000000,'1975-04-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1625,'ACHARD DE LELUARDIERE','THIERRY','1967-04-19','02.94.27.83.00','06.38.63.51.54',NULL,'3 ALL2E DES POETES','','','14120','MONDEVILLE',NULL,NULL,'2670414356001',313.000000000,'1990-07-14','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1626,'DEVIC','DENIS','1965-06-21','02.51.05.19.80','06.72.81.48.51',NULL,'1 rue des hameaux','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'1650614044001',72.000000000,'1988-03-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1627,'MARVIN','LUCIENNE','1982-03-03','02.44.19.15.72','06.98.92.32.11',NULL,'8 rue alfred nobel','','','14150','OUISTREHAM',NULL,NULL,'2820399234001',21.000000000,'2010-03-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1628,'GUERIN','didier','1944-03-25','02.12.25.99.02','06.42.31.19.48',NULL,'86 bis rue basse','','','14000','CAEN',NULL,NULL,'1440314150001',363.000000000,'1973-03-01','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1629,'HECTOR','FERNAND','1964-02-27','02.90.07.17.19','06.78.92.43.93',NULL,'LA CORBELLIERE','','','14000','CAEN',NULL,NULL,'2640214658001',177.000000000,'1994-03-21','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1630,'MOREL','ANDRE','1959-09-03','02.91.17.02.33','06.20.51.13.53',NULL,'8 IMPASSE DU MANOIR LE HAUT MESN','IL','','14860','RANVILLE',NULL,NULL,'1590914075001',282.000000000,'1980-06-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1631,'MORIN','MARGUERITE','1935-01-29','02.89.26.19.13','06.20.00.15.89',NULL,'7 ALLEE WINIPEG','','','14160','DIVES SUR MER',NULL,NULL,'1350114319001',732.000000000,'1957-07-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1632,'LIBOIS','MARY','1929-04-14','02.40.90.62.02','06.44.58.62.74',NULL,'LA RENARDIERE','','','14123','IFS',NULL,NULL,'2290450202001',865.000000000,'1952-05-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1633,'GOUBERT','ROGER','1961-03-27','02.61.88.32.99','06.81.31.89.13',NULL,'8 RUE DES CHARMILLES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1610314308001',2753.000000000,'1984-04-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1634,'VALLEE','YOLANDE','1952-02-05','02.60.28.27.17','06.78.41.86.60',NULL,'11 RUE DE BRETTEVILLE','','','61700','DOMFRONT',NULL,NULL,'1520214090001',1305.000000000,'1978-11-26','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1635,'SIMON','BERNARD','1932-02-02','02.58.47.14.89','06.55.03.65.72',NULL,'15 PLACE DE LA DEMIE LUNE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1320214325001',377.000000000,'1954-11-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1636,'BOUTELOUP','GUY','1934-01-27','02.30.60.87.52','06.92.00.02.45',NULL,'LA RUE D''AVE','','','14540','SOLIERS',NULL,NULL,'2340129184001',72.000000000,'1955-04-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1637,'MICLOT','JACQUELINE','1967-11-12','02.75.33.89.40','06.40.14.32.29',NULL,'7 RUE DU BISSONNET','','','14220','GRIMBOSQ',NULL,NULL,'2671114118001',30.000000000,'1990-02-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1638,'LAVENANT','DENIS','1934-09-30','02.83.39.30.26','06.63.93.89.40',NULL,'25 rue du blanc','','','14210','PREAUX BOCAGE',NULL,NULL,'2340914315001',93.000000000,'1958-07-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1639,'GOST','OLIVIER','1930-12-03','02.55.61.31.76','06.52.02.57.98',NULL,'37 RUE PASTEUR','','','14330','TOURNIERES',NULL,NULL,'1301214166001',205.000000000,'1960-10-01','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1640,'SAMSON','PAULETTE','1959-02-13','02.31.17.50.41','06.78.25.94.96',NULL,'','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1590214581001',122.000000000,'1981-11-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1641,'MERIENNE','ROLANDE','1932-02-12','02.82.83.36.54','06.26.13.54.63',NULL,'route nationale','','','14120','MONDEVILLE',NULL,NULL,'1320214039001',50.000000000,'1955-07-23','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1642,'MAISERET','MARIE THERESE','1935-01-09','02.83.31.58.91','06.41.06.40.76',NULL,'33 RUE D''AUTHIE','','','14120','MONDEVILLE',NULL,NULL,'1350114659001',63.000000000,'1959-05-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1643,'BENOIT','GINETTE','1929-07-12','02.62.08.22.78','06.41.66.46.98',NULL,'96 BD LYAUTEY','','','14120','MONDEVILLE',NULL,NULL,'2290714266001',41.000000000,'1951-11-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1644,'ANNE','FRANCIS','1935-12-09','02.47.42.91.97','06.42.61.96.92',NULL,'22 RUE DE LA GARE','','','14000','CAEN',NULL,NULL,'2351214506001',88.000000000,'1958-06-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1645,'GODDERIDGE','hubert','1941-02-09','02.96.85.18.82','06.58.32.63.78',NULL,'4 RUE RAYMOND COSSON','','','14000','CAEN',NULL,NULL,'1410227080001',421.000000000,'1971-05-23','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1646,'BATON','GENEVIEVE','1954-01-05','02.98.51.62.28','06.78.68.73.00',NULL,'ANCIEN PRESBYSTERE','','','14370','MOULT',NULL,NULL,'1540161278001',92.000000000,'1978-05-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1647,'BENOITS','pascal','1961-09-20','02.47.48.13.16','06.11.00.47.23',NULL,'CHEMIN DU VEY','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1610937071001',83.000000000,'1985-08-30','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1648,'CHARLES','DONATIENNE','1936-11-18','02.11.87.12.34','06.23.76.46.20',NULL,'13 AVENUE DE NORMANDIE','','','14370','ARGENCES',NULL,NULL,'2361150438001',14.000000000,'1959-04-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1649,'AILLET','ALBERT','1940-09-09','02.26.66.77.36','06.48.79.88.03',NULL,'5 impa fr cassard','','','32100','CONDOM',NULL,NULL,'1400950234001',1034.000000000,'1962-07-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1650,'LEVAVASSEUR','','1932-07-18','02.39.86.69.06','06.73.38.01.29',NULL,'GARE DE CROUAY','','','14220','FRESNEY LE VIEUX',NULL,NULL,'1320750581001',97.000000000,'1955-07-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1651,'DONNE','BERNARD','1933-09-27','02.82.22.31.89','06.60.71.26.51',NULL,'LE BOURG','','','14220','BOULON',NULL,NULL,'1330914266001',591.000000000,'1956-04-17','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1652,'DELIVET','JACQUELINE','1932-11-29','02.41.87.62.30','06.43.98.50.70',NULL,'27 RUE DE L''ARQUETTE','','','14100','GLOS',NULL,NULL,'2321150301001',545.000000000,'1960-09-08','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1653,'HODIN','LOUIS','1930-09-18','02.16.86.52.62','06.16.03.96.61',NULL,'13 CLOS DU PAVILLON','','','14270','CESNY AUX VIGNES OUEZY',NULL,NULL,'1300914498001',1304.000000000,'1957-12-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1654,'MOREL','VALERIE','1940-02-07','02.28.66.94.90','06.85.54.83.59',NULL,'26 rue des talbotieres','','','14540','GRENTHEVILLE',NULL,NULL,'1400250173001',19.000000000,'1970-02-20','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1655,'LARVOR','ETIENNE',NULL,'02.65.77.03.91','06.20.75.49.79',NULL,'13 village de l''eglise','','','14540','ROCQUANCOURT',NULL,NULL,'2800629232001',216.000000000,'2007-12-30','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1656,'ALEXANDRE','ARLETTE','1932-10-15','02.74.91.83.98',NULL,NULL,'8 AVENUE MARC DU GARREAU','','','14000','CAEN',NULL,NULL,'1321035095001',3645.000000000,'1953-02-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1657,'FOUCHARD','HENRIETTE','1943-02-19','02.74.47.89.21',NULL,NULL,'CHEMIN DE LA TONNELLE','','','61160','MONT ORMEL',NULL,NULL,'2430261459001',41.000000000,'1965-02-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1658,'HARANG','GUY','1930-08-30','02.67.37.63.31','06.66.16.17.40',NULL,'','','','14000','CAEN',NULL,NULL,'2300814497001',21.000000000,'1951-04-05','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1659,'JUMEL','MICHEL','1943-01-09','02.23.22.84.37','06.79.25.16.26',NULL,'7 rue Edmond Raphal','','','14670','TROARN',NULL,NULL,'1430150032001',42.000000000,'1973-06-05','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1660,'BEAUBIGNY','JEAN-CLAUDE','1935-11-22','02.52.22.94.25','06.17.63.79.01',NULL,'1 RUE DES MESANGES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1351161289001',80.000000000,'1960-03-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1661,'PARIS','RAYMOND','1969-05-16','02.87.53.65.26','06.48.37.26.73',NULL,'CHEMIN DE LA CROIX THOY','','','14210','TOURVILLE SUR ODON',NULL,NULL,'2690514271001',684.000000000,'1996-07-29','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1662,'HARDY','WILLY','1960-01-24','02.84.11.55.73','06.63.72.82.39',NULL,'hameau la haye','','','14370','ARGENCES',NULL,NULL,'2600114520001',183.000000000,'1987-10-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1663,'LETALLEC','JACQUES','1967-04-15','02.57.07.98.06','06.15.55.06.58',NULL,'13 RUE VICTOR HUGO','','','14120','MONDEVILLE',NULL,NULL,'2670414356001',16.000000000,'1991-09-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1664,'DENIS','DANIEL','1930-10-20','02.80.11.63.37','06.19.77.18.08',NULL,'2 RUE THE DEVONSHIRE RT','','','14120','MONDEVILLE',NULL,NULL,'2301061070001',1337.000000000,'1954-07-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1665,'LUCAS','YVON','1949-01-04','02.11.51.94.40','06.28.64.16.41',NULL,'','','','14130','BLANGY LE CHATEAU',NULL,NULL,'1490150540001',173.000000000,'1970-10-21','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1666,'GAUDRY','NICOLE','1947-01-21','02.49.20.37.12','06.73.44.91.87',NULL,'9 CHEMIN DE GARRAINE','','','14123','IFS',NULL,NULL,'1470127335001',1701.000000000,'1970-05-25','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1667,'POREY','ODETTE','1927-11-30','02.10.30.97.28','06.65.49.31.59',NULL,'64 BOULEVARD LEROY','','','14000','CAEN',NULL,NULL,'1271133446001',23.000000000,'1948-09-15','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1668,'BOURGES','daniel','1936-02-13','02.52.70.72.43','06.14.72.77.34',NULL,'2 RUE DES PENSEES','','','14370','BELLENGREVILLE',NULL,NULL,'2360214566001',58.000000000,'1966-06-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1669,'DALLIER','SOTHEAVY','1930-01-17','02.10.79.63.96','06.89.53.83.13',NULL,'25 RUE DU COTENTIN','','','14000','CAEN',NULL,NULL,'1300180352001',25.000000000,'1952-01-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1670,'LEMOIGNE','JOELLE','1935-09-23','02.32.01.18.22','06.47.25.03.24',NULL,'14 ALLEE DES ARTS','','','14790','VERSON',NULL,NULL,'2350914055001',338.000000000,'1956-12-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1671,'FILOCHE','THERESE','1936-12-03','02.67.94.43.85','06.82.62.42.13',NULL,'LE BOULAY','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2361250224001',185.000000000,'1965-06-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1672,'MALABOEUF-CARRE','ANNETTE','1946-01-24','02.86.33.54.00','06.18.68.88.85',NULL,'12 avenue de la liberation','','','14370','MOULT',NULL,NULL,'1460114158001',1996.000000000,'1974-04-01','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1673,'COCHEREL','MADELEINE','1933-01-30','02.57.10.14.17','06.10.38.40.56',NULL,'50 AVENUE GUYNEMER','','','14000','CAEN',NULL,NULL,'1330161168001',65.000000000,'1958-02-20','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1674,'RAULT','GHISLAINE','1933-02-08','02.71.40.63.95','06.82.51.91.63',NULL,'LIEU DIT AUBIGNY','','','14460','COLOMBELLES',NULL,NULL,'2330214432001',38.000000000,'1960-10-27','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1675,'MICHEL','MICHEL','1965-01-25','02.11.21.22.11','06.85.58.44.99',NULL,'3 rue louis robillard','','','14370','BELLENGREVILLE',NULL,NULL,'2650114005001',24.000000000,'1986-01-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1676,'VALLETTE','FRANCIS',NULL,'02.11.30.93.79','06.34.99.60.04',NULL,'62 avenue charlotte corday','','','14123','FLEURY SUR ORNE',NULL,NULL,'1310214301001',98.000000000,'2013-03-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1677,'KUEZMEROWIEZ','JEAN FRANCOIS','1928-09-07','02.86.49.53.31','06.10.46.29.17',NULL,'19 RUE FROIDE','','','50180','AGNEAUX',NULL,NULL,'2280914092001',1360.000000000,'1954-02-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1678,'BISSON','EDOUARD','1952-03-04','02.64.96.89.63','06.10.46.76.46',NULL,'18 BD ALSACE LORRAINE','','','14310','PARFOURU SUR ODON',NULL,NULL,'2520330235001',51.000000000,'1981-12-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1679,'LANGLINAY','PAULETTE','1932-10-26','02.85.90.65.88','06.24.72.54.23',NULL,'709 BLD DU GRAND PARC','','','14000','CAEN',NULL,NULL,'2321014581001',3748.000000000,'1954-05-31','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1680,'COTTRAIT','THIERRY','1965-04-07','02.78.19.56.91','06.28.36.53.92',NULL,'14 PLACE SAINT ANNE','','','14630','CAGNY',NULL,NULL,'2650414651001',763.000000000,'1987-12-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1681,'QUESNOT','MARIE',NULL,'02.70.97.75.63','06.62.74.19.00',NULL,'9 bd de l esperance','','','14970','BENOUVILLE',NULL,NULL,'1360214301001',20.000000000,'2012-12-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1682,'RIBAUD','VICTOR','1928-02-14','02.91.54.37.32','06.26.24.96.03',NULL,'LE DESERTIF','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2280261069001',2588.000000000,'1952-01-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1683,'PETIT','JEANNE','1949-05-15','02.77.47.05.75','06.26.99.03.79',NULL,'16 RESIDENCE ST JACQUES','','','50190','GORGES',NULL,NULL,'1490561478001',486.000000000,'1971-08-10','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1684,'FORET','MAURICE','1949-05-04','02.85.86.58.16','06.63.46.81.26',NULL,'4 RUE DES CHEVREFEUILLES','','','14390','CABOURG',NULL,NULL,'1490561478001',4.000000000,'1974-08-12','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1685,'CHEMIN','ODETTE','1936-09-25','02.27.95.64.55','06.61.43.36.31',NULL,'171 RUE D''AUGE','','','14000','CAEN',NULL,NULL,'1360914098001',185.000000000,'1959-07-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1686,'LE BIGOT','THERESE','1959-11-26','02.11.00.21.83','06.32.08.24.17',NULL,'65 rue des roches','','','14123','IFS',NULL,NULL,'1591114729001',80.000000000,'1982-03-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1687,'GAZENGEL','JEANNINE','1932-05-20','02.78.57.77.22','06.98.32.29.24',NULL,'2 RUE DE LA MUANCE','','','14000','CAEN',NULL,NULL,'2320550052001',347.000000000,'1956-07-06','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1688,'LEFLAMBE','LAETITIA',NULL,'02.59.36.22.10','06.69.43.24.11',NULL,'6 RUE DE LA CLE DES CHAMPS','','','14123','FLEURY SUR ORNE',NULL,NULL,'2340114369001',75.000000000,'2009-08-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1689,'DUVAL','MARYLINE','1931-07-27','02.74.61.65.60',NULL,NULL,'11 RUE DU 11 NOVEMBRE','','','14000','CAEN',NULL,NULL,'2310714548001',125.000000000,'1956-11-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1690,'VAUTIER','JEAN','1969-11-29','02.48.43.69.04','06.11.04.65.37',NULL,'99 RUE DE LA DELIVRANDE','','','14320','FONTENAY LE MARMION',NULL,NULL,'2691114162001',466.000000000,'1992-07-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1691,'VARIN','DANIEL','1938-02-24','02.17.85.33.73','06.87.76.32.26',NULL,'10 PARVIS DE NOTRE DAME','','','14000','CAEN',NULL,NULL,'2380265059001',810.000000000,'1966-10-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1692,'NEEL','NOEL','1933-04-18','02.36.99.67.11','06.24.68.67.41',NULL,'LA MOISSONNIERE','','','14670','TROARN',NULL,NULL,'2330450406001',116.000000000,'1963-06-26','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1693,'KERIMOV','YVONNE','1933-03-31','02.20.08.13.83','06.29.46.93.31',NULL,'15 impasse du peintre','','','14940','SANNERVILLE',NULL,NULL,'1330314305001',2.000000000,'1957-01-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1694,'PINEAU','THERESE','1930-02-09','02.57.78.13.71','06.91.24.46.73',NULL,'13 AVENUE DE NORMANDIE','','','14400','NONANT',NULL,NULL,'1300214186001',126.000000000,'1958-07-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1695,'BOUSSELET','JACQUES','1929-11-16','02.71.71.50.05','06.54.81.52.32',NULL,'6 CHEMIN DU PETIT PARC','','','50880','PONT HEBERT',NULL,NULL,'2291114740001',236.000000000,'1951-10-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1696,'LECONTE','DEMBA','1946-01-12','02.46.86.34.23','06.10.40.37.53',NULL,'4 rue jean francois millet','','','14270','MEZIDON CANON',NULL,NULL,'1460114375001',75.000000000,'1969-03-21','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1697,'GUALBERT','DOMINIQUE','1934-07-01','02.48.76.53.37','06.77.86.15.67',NULL,'5 RUE D''ANJOU','','','14260','ST GEORGES D''AUNAY',NULL,NULL,'1340714619001',6.000000000,'1958-03-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1698,'DELAMOTTE','PATRICE','1936-07-12','02.13.17.08.79','06.65.68.24.31',NULL,'4 RUE DE LA COURTE DELLE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1360714430001',104.000000000,'1960-05-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1699,'BOUFFAY','PAULETTE','1932-11-03','02.19.11.69.78','06.62.84.43.48',NULL,'CAPAR MESNIL','','','14460','COLOMBELLES',NULL,NULL,'2321178551001',21.000000000,'1956-01-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1700,'BALOCHE','JEANNE','1938-02-27','02.58.02.66.67','06.13.98.10.16',NULL,'6 ALLEE DES VIGNONS','','','61470','LE BOSC RENOULT',NULL,NULL,'2380214446001',1634.000000000,'1967-12-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1701,'ROCQUANCOURT','serge','1931-02-13','02.13.52.87.10','06.10.27.71.67',NULL,'38 avenue de la republique','','','14600','LA RIVIERE ST SAUVEUR',NULL,NULL,'2310237132001',335.000000000,'1955-06-18','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1702,'FRANCOIS','BERNARD','1939-03-23','02.80.85.69.05','06.67.89.05.33',NULL,'17. rue des rosiers, batG escali','er11','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1390314066001',2069.000000000,'1960-12-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1703,'GRATIA','LILIANE','1939-03-03','02.10.96.25.33','06.12.89.75.59',NULL,'19 RUE GEORGES AUGUSTE','','','14730','GIBERVILLE',NULL,NULL,'1390314066001',228.000000000,'1966-03-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1704,'BRISSARD','THERESE','1930-02-22','02.38.72.63.06','06.11.78.72.76',NULL,'23 RUE DES ORAILLES','','','14370','ARGENCES',NULL,NULL,'2300214461001',204.000000000,'1958-05-31','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1705,'LAIGNEL','','1928-11-27','02.21.02.27.86','06.11.65.65.55',NULL,'20. route de bayeux','','','14110','ST GERMAIN DU CRIOULT',NULL,NULL,'2281114570001',183.000000000,'1952-05-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1706,'DESMONTS','YVETTE','1959-03-06','02.12.89.34.37','00 33 6.57.99.68.71',NULL,'20. rue vallee d''auge','','','50580','DENNEVILLE',NULL,NULL,'1590350111001',106.000000000,'1980-11-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1707,'AHMED','ROGER','1936-03-19','02.49.63.27.61','06.71.72.72.49',NULL,'LE BOURG','','','14840','DEMOUVILLE',NULL,NULL,'2360314610001',85.000000000,'1960-10-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1708,'MARIE','GERARD','1950-03-02','02.15.69.34.52','06.36.95.90.04',NULL,'21 RUE DE BRUXELLES','','','14730','GIBERVILLE',NULL,NULL,'2500314029001',275.000000000,'1976-12-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1709,'LETHAN','ROLANDE','1934-03-27','02.86.40.88.73','06.84.96.64.03',NULL,'1 RUE VICTOR HUGO','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1340314048001',21.000000000,'1964-09-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1710,'WALCZAK','YVES','1966-12-24','02.67.75.59.80','06.89.03.15.54',NULL,'10 RUE DES ALOUETTES','','','14320','MAY SUR ORNE',NULL,NULL,'2661214523001',1251.000000000,'1987-02-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1711,'CARABY','ROGER','1928-01-13','02.90.41.00.91','06.11.61.98.37',NULL,'','','','14840','DEMOUVILLE',NULL,NULL,'1280149150001',2722.000000000,'1949-05-08','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1712,'DOINARD','GASTON','1932-03-08','02.33.43.50.20','06.26.07.58.82',NULL,'','','','14150','OUISTREHAM',NULL,NULL,'1320314133001',75.000000000,'1959-02-15','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1713,'DRIEU','ANDRE','1966-03-07','02.74.25.95.04',NULL,NULL,'31 RUE DU CLOS VOISIN','','','14000','CAEN',NULL,NULL,'2660362119001',45.000000000,'1991-10-14','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1714,'SANTIER','GUY','1938-06-25','02.57.44.06.84','06.87.24.81.21',NULL,'7 RUE CAMILLE GUERIN','','','14160','DIVES SUR MER',NULL,NULL,'2380678233001',33.000000000,'1960-01-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1715,'LOUIS','ALICE','1930-05-07','02.48.86.96.51','06.28.76.07.92',NULL,'37 RUE JEAN MERMOZ','','','14540','CONTEVILLE',NULL,NULL,'2300514652001',105.000000000,'1955-01-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1716,'TACCHI','JACQUELINE','1929-07-20','02.52.06.30.05','06.11.40.05.67',NULL,'5 RUE CHRESTIEN DE TROYES','','','14000','CAEN',NULL,NULL,'1290714098001',561.000000000,'1952-05-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1717,'JEANNE','EMILE','1928-12-31','02.31.52.61.77','06.47.48.82.29',NULL,'','','','14380','MESNIL CLINCHAMPS',NULL,NULL,'2281214456001',1686.000000000,'1953-08-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1718,'RUAULT','SIMONE','1935-11-25','02.76.07.91.91','06.72.27.77.40',NULL,'907 quartier du grand parc','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1351191506001',76.000000000,'1959-02-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1719,'VERHAEGHE','CHRISTIANE','1961-01-11','02.12.07.71.08','06.77.82.08.65',NULL,'1 rue fred scamaroni','','','50680','CERISY LA FORET',NULL,NULL,'2610114125001',118.000000000,'1984-10-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1720,'RADIGUET','PAULETTE','1937-07-01','02.72.24.81.91','06.30.52.43.47',NULL,'','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'2370714066001',187.000000000,'1959-04-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1721,'LEMARIE','MADELAINE','1939-10-03','02.30.82.33.14','06.12.28.87.78',NULL,'HAMEAU BONNEVAL','','','50660','LINGREVILLE',NULL,NULL,'2391014282001',3.000000000,'1963-11-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1722,'LOREL','SYLVIE','1938-12-14','02.41.18.06.85','06.32.29.54.89',NULL,'route de corniche chemin du sema','phore','','29270','CARHAIX PLOUGUER',NULL,NULL,'1381228294001',453.000000000,'1964-02-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1723,'LEMAITRE','JACQUELINE','1939-10-18','02.57.41.39.31','06.63.54.58.49',NULL,'LE BOIS','','','14850','ESCOVILLE',NULL,NULL,'2391014171001',9.000000000,'1963-07-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1724,'SZWAJA','COLETTE','1965-05-20','02.82.46.26.22','06.83.42.64.78',NULL,'4 RUE DES HAUTS JARDIN','','','14000','CAEN',NULL,NULL,'1650514556001',79.000000000,'1995-08-03','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1725,'GAIGNON','FRANCOISE','1959-01-16','02.11.81.67.81','06.10.38.97.41',NULL,'10 RUE DE SULLY','','','61250','DAMIGNY',NULL,NULL,'1590114176001',4123.000000000,'1981-06-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1726,'ANSELMETTI','ALICE','1936-09-16','02.67.55.71.19','06.41.02.15.45',NULL,'30 rue du seau du loup','','','14123','FLEURY SUR ORNE',NULL,NULL,'2360914407001',68.000000000,'1959-11-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1727,'ZIELINSKI','CHARLOTTE','1937-07-10','02.80.42.78.04','06.71.15.81.43',NULL,'6 chemin la couture','','','14630','CAGNY',NULL,NULL,'1370727030001',571.000000000,'1965-01-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1728,'HARE','DANIEL','1935-10-26','02.31.54.01.70','06.58.32.64.26',NULL,'14 RUE DOMREMY','','','14790','VERSON',NULL,NULL,'2351014657001',26.000000000,'1959-12-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1729,'SCELLES','JULIEN','1935-10-20',NULL,NULL,NULL,'21 RUE JEAN PHILIPPE RAMEAU','','','14270','MEZIDON CANON',NULL,NULL,'2351014657001',737.000000000,'1956-02-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1730,'SALLE','JEAN','1931-01-04','02.68.50.15.90','06.70.88.27.19',NULL,'12 RUE DE L''ECUREUIL','','','14370','AIRAN',NULL,NULL,'1310114027001',336.000000000,'1958-05-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1731,'LEGORGEU','NATHALIE','1928-04-07','02.99.98.76.58','06.10.31.21.83',NULL,'','','','14111','LOUVIGNY',NULL,NULL,'2280414245001',94.000000000,'1950-07-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1732,'CAPRAIS','BERNARD','1935-05-21','02.19.41.58.27','06.69.41.26.88',NULL,'302 la ramee','','','14850','ESCOVILLE',NULL,NULL,'2350514004001',96.000000000,'1961-02-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1733,'LE CLERC','MARIE','1929-09-02','02.65.73.75.57','06.23.03.96.41',NULL,'RUE DES AGRIONS','','','14620','DAMBLAINVILLE',NULL,NULL,'1290914658001',36.000000000,'1950-05-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1734,'BLOTTIERE','MARIE','1937-07-02','02.52.27.87.05','06.22.11.59.82',NULL,'28 RUE DE PROVENCE','','','14860','RANVILLE',NULL,NULL,'1370722353001',495.000000000,'1967-06-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1735,'QUESNEL','/','1930-10-21',NULL,NULL,NULL,'9 ROUTE DE PERIERS','','','14000','CAEN',NULL,NULL,'2301050395001',25.000000000,'1954-01-19','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1736,'MARIE','THERESE','1966-01-11','02.10.78.55.56','06.59.23.37.27',NULL,'1 RUE DES PETITES MARETTES','','','14000','CAEN',NULL,NULL,'1660114341001',471.000000000,'1996-10-20','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1737,'RENOUF','THERESE','1930-05-11','02.11.45.72.29','06.34.69.76.52',NULL,'','','','14000','CAEN',NULL,NULL,'2300576060001',214.000000000,'1952-09-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1738,'DUVAL','YVONNE','1933-05-25','02.53.09.43.07','06.79.16.96.67',NULL,'3 rue henri barbusse','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'1330514598001',98.000000000,'1963-09-08','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1739,'NICOLLE','MIREILLE','1933-02-11','02.90.96.17.44','06.23.86.75.91',NULL,'27 CITE DE CAUDET','','','14123','FLEURY SUR ORNE',NULL,NULL,'2330214594001',15.000000000,'1956-12-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1740,'CRENN','JEANNINE','1930-04-20','02.79.59.73.28','06.98.75.85.97',NULL,'','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1300414251001',2125.000000000,'1957-12-31','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1741,'LEMARIE','JEAN','1929-05-02','02.92.54.15.78','06.47.02.15.22',NULL,'37 AVENUE DE COURSEULLES','','','14123','IFS',NULL,NULL,'1290514556001',14.000000000,'1950-09-10','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1742,'MAHEUT','FRANCOISE','1935-07-01','02.69.98.66.76','06.11.75.16.83',NULL,'2 RUE DU  POITOU','','','14670','JANVILLE',NULL,NULL,'1350714167001',181.000000000,'1957-03-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1743,'CHESNEL','JOELLE','1933-09-26','02.55.46.25.04','06.27.54.05.01',NULL,'15 RUE GEORGES CLEMENCEAU','','','14450','GRANDCAMP MAISY',NULL,NULL,'1330950269001',137.000000000,'1960-09-25','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1744,'THIRON','GEORGETTE',NULL,'02.42.69.49.20','06.12.14.64.41',NULL,'LES RABUSQUETS','','','14000','CAEN',NULL,NULL,'1281214181001',53.000000000,'2013-08-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1745,'SIMON','NADINE','1928-01-09','02.77.30.00.02','06.53.12.70.67',NULL,'LE PIED DU BOIS','','','14630','FRENOUVILLE',NULL,NULL,'1280114342001',280.000000000,'1951-08-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1746,'MORAINE','','1966-01-14','02.38.22.76.49','06.52.28.47.00',NULL,'19 RUE DE SAINTONGE','','',NULL,NULL,NULL,NULL,'1660114246001',128.000000000,'1996-02-18','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1747,'GERVAIS','MONIQUE','1955-01-03','02.84.03.99.82','06.44.93.89.06',NULL,'2 AVENUE DU VAL','','',NULL,NULL,NULL,NULL,'2550114686001',20.000000000,'1980-07-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1748,'LATOUR','BEATRICE',NULL,'02.66.51.98.79','06.38.12.87.07',NULL,'1 RUE DE LA FRENEE','','','14000','CAEN',NULL,NULL,'1600114057001',3778.000000000,'2009-08-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1749,'CARABY','MARTINE','1939-04-22','02.24.83.01.57','06.10.38.76.45',NULL,'21 RUE PIERRE DE COUBERTIN','','','61310','SURVIE',NULL,NULL,'1390414047001',39.000000000,'1960-08-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1750,'BORDIER','ADRIENNE','1957-01-25','02.88.71.05.64','06.98.57.88.94',NULL,'ROUTE DE MAIZIERES','','','14220','THURY HARCOURT',NULL,NULL,'2570114396001',183.000000000,'1984-02-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1751,'PELLIER','JEAN MARIE','1933-08-28','02.54.14.06.34','06.44.23.42.14',NULL,'1 SENTE DE LA CRESSONIERE','','','14000','CAEN',NULL,NULL,'2330853036001',588.000000000,'1954-06-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1752,'MOGES','CLAUDE','1935-11-20','02.43.58.83.23','06.69.24.57.73',NULL,'19 RUE DU CLOS NORMAND','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'1351114006001',129.000000000,'1959-05-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1753,'GRIMAULT','JEAN','1945-07-30','02.19.40.74.24',NULL,NULL,'10 RUE DU CHEMIN BERNARD','','','14460','COLOMBELLES',NULL,NULL,'1450714483001',24.000000000,'1975-10-24','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1754,'VAILLANT','ALICE','1932-05-26','02.62.18.35.60','00 33 6.64.14.43.42',NULL,'17 RUE DE L4ABBATIALE','','','14123','IFS',NULL,NULL,'1320550538001',33.000000000,'1956-04-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1755,'VOISIN','HENRIETTE','1935-03-04','02.16.96.48.39','06.35.13.27.00',NULL,'5 RUE DU BOIS','','','14670','TROARN',NULL,NULL,'1350314046001',200.000000000,'1959-07-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1756,'BLOT','JACQUES','1932-03-09','02.20.56.51.25','06.43.40.52.87',NULL,'1 rue st andre','','','14123','IFS',NULL,NULL,'1320327207001',10.000000000,'1955-03-27','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1757,'','BERNADETTE','1940-02-26','02.93.43.61.14','06.95.54.97.51',NULL,'1-2 ALLEE DU PRIEURE','','','14570','ST REMY',NULL,NULL,'1400214076001',257.000000000,'1961-05-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1758,'LECOMTE','ANDRE','1937-05-19','02.10.17.87.65','06.85.48.51.20',NULL,'115 LE RUQUET','','','14980','ROTS',NULL,NULL,'1370514338001',147.000000000,'1965-08-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1759,'CAILLOT','BERNARD','1969-09-17','02.78.49.87.10','06.12.26.57.03',NULL,'5 RUE DU STADE','','','14670','TROARN',NULL,NULL,'2690914118001',32.000000000,'1992-09-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1760,'LEROSIER','ROGER','1929-05-29','02.72.32.21.51','06.25.59.20.49',NULL,'12 RUE DU 19 MARS 1962','','','14120','MONDEVILLE',NULL,NULL,'1290514556001',950.000000000,'1950-02-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1761,'LEBECQ','CHRISTIAN','1938-02-17','02.15.79.61.89','06.28.05.11.98',NULL,'21 RUE DU MANOIR','','','14320','MAY SUR ORNE',NULL,NULL,'1380248123001',8.000000000,'1961-03-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1762,'STEPIEN','PIERRE','1933-10-02','02.96.77.61.08','06.16.89.76.17',NULL,'8 chemin duvivier','','','14000','CAEN',NULL,NULL,'1331014130001',38.000000000,'1959-09-10','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1763,'MARIE','MARIE THERESE','1939-10-11','02.81.12.96.06','06.85.61.21.25',NULL,'LE BOURG','','','14123','FLEURY SUR ORNE',NULL,NULL,'1391027112001',34.000000000,'1962-12-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1764,'LEFEVRE','PATRICIA','1928-04-19','02.10.14.78.69','06.64.60.24.32',NULL,'19 PLACE VERDUN','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2280414675001',195.000000000,'1949-07-30','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1765,'BILLARD','CHANTAL','1962-01-28','02.23.15.14.87','06.88.03.66.66',NULL,'7 RUE STE PAIX PORTE B','','','14000','CAEN',NULL,NULL,'2620114333001',193.000000000,'1989-06-16','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1766,'CANCIAN','JACQUELINE','1940-02-11','02.24.78.27.71','06.65.31.99.21',NULL,'3 RUE LES RIFFARDS','','','14000','CAEN',NULL,NULL,'1400214556001',3.000000000,'1967-08-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1767,'JEANBRUN','FRANCOIS','1962-01-03','02.74.96.97.56',NULL,NULL,'ROUTE DE STE HONORINE DU FAY','','','14000','CAEN',NULL,NULL,'1620114020001',1472.000000000,'1986-02-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1768,'VIBERT','GEORGES','1935-05-10','02.95.60.04.27','06.60.63.30.88',NULL,'22 BD RAYMOND POINCARE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1350514129001',53.000000000,'1958-07-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1769,'BAUDOUIN','MADELEINE','1960-01-23','02.27.20.89.88','06.64.23.28.05',NULL,'5 AVENUE  SAINTE THERESE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2600114191001',718.000000000,'1982-07-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1770,'LETIRAND','marcel','1952-01-24','02.35.11.18.92','06.42.07.26.01',NULL,'','','','14000','CAEN',NULL,NULL,'2520114675001',371.000000000,'1980-09-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1771,'DOUCHY','GILBERT','1930-09-04','02.12.26.95.02','06.83.45.96.79',NULL,'9 RUE ALEXIS DE TOCQUEVILLE','','','14120','MONDEVILLE',NULL,NULL,'2300914699001',3954.000000000,'1955-05-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1772,'TAVERNEY','NICOLLE',NULL,'02.12.13.62.42','06.48.19.61.46',NULL,'84 ABBE LECORNU','','','14220','ST LAURENT DE CONDEL',NULL,NULL,'2472099337001',83.000000000,'2010-05-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1773,'GERME','YVONNE','1963-03-15','02.23.06.73.24','06.48.92.11.98',NULL,'9 rue juno','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'2630399253001',47.000000000,'1991-08-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1774,'ANNE','NELLY','1940-01-27','02.12.85.20.45','06.14.41.29.61',NULL,'2 RUE DU CLOS CARRE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2400114458001',84.000000000,'1964-11-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1775,'BOUET','JEANNINE','1936-06-21','02.28.43.35.03','06.81.88.11.85',NULL,'15 cote du val','','','14000','CAEN',NULL,NULL,'2360650610001',20.000000000,'1964-08-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1776,'DELASALLES','EDITH','1946-01-01','02.24.13.75.59','06.97.27.58.24',NULL,'9 PLACE DE MARILLAC','','','14120','MONDEVILLE',NULL,NULL,'1460150323001',10.000000000,'1968-08-04','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1777,'DESHAMAUTS','FRANCOIS-MICHEL','1940-10-02','02.73.51.82.80','06.51.21.31.95',NULL,'11 AVENUE DU CALVADOS','','','14240','ST GERMAIN D''ECTOT',NULL,NULL,'1401014370001',34.000000000,'1964-11-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1778,'GODEY','LUCIENNE','1947-01-26','02.60.40.76.42','06.52.08.42.01',NULL,'LE BOURG','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1470114246001',0.000000000,'1968-08-03','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1779,'COLLINET','AIME','1966-03-30','02.70.18.01.07','06.36.35.03.93',NULL,'LOTISSEMENT COMMUNAL LA VIOLIER','E','','14840','DEMOUVILLE',NULL,NULL,'1660314453001',139.000000000,'1996-10-27','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1780,'TURBOUST','MICHELLE','1934-03-27','02.11.86.76.66','06.38.74.50.01',NULL,'10 chemin du val','','','14270','MEZIDON CANON',NULL,NULL,'2340322224001',162.000000000,'1955-06-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1781,'','GENEVIEVE','1939-11-06','02.80.42.76.79','06.45.24.48.60',NULL,'882 CHEMIN DU VAL','','','14320','MAY SUR ORNE',NULL,NULL,'1391114123001',151.000000000,'1963-01-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1782,'JOUBERT','remy','1935-08-27','02.81.32.39.00','06.60.55.34.35',NULL,'','','','14540','ROCQUANCOURT',NULL,NULL,'2350814352001',460.000000000,'1962-04-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1783,'RICHER','JANINE','1956-01-10','02.76.48.84.22','06.62.48.43.22',NULL,'3 LES AIGUILLERES','','','14000','CAEN',NULL,NULL,'2560150626001',36.000000000,'1983-11-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1784,'HALLIEN','HENRI',NULL,'02.16.42.69.05','06.89.68.26.75',NULL,'2 BIS RUE DE CABOURG','','','14120','MONDEVILLE',NULL,NULL,'1320122105001',64.000000000,'2010-08-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1785,'SOYER','MARCEL',NULL,'02.39.56.65.17','06.96.80.35.22',NULL,'','','','14000','CAEN',NULL,NULL,'2360850231001',266.000000000,'2012-04-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1786,'THOMASSE','BERNARD','1928-06-12','02.27.01.59.29','06.59.24.60.32',NULL,'','','','50120','EQUEURDREVILLE HAINNEVILLE',NULL,NULL,'2280614126001',1469.000000000,'1951-06-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1787,'BIDOT','JACQUES','1965-05-30','02.91.87.14.35','06.53.17.35.86',NULL,'7 rue alfonse et leonard  gilles','','','14120','MONDEVILLE',NULL,NULL,'1650514410001',40.000000000,'1991-11-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1788,'','JANINE','1928-12-18','02.35.72.43.26','06.42.04.96.47',NULL,'23 RUE EMMANUEL','','','14270','OUEZY',NULL,NULL,'1281214666001',164.000000000,'1953-01-23','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1789,'COLIN','DENISE','1956-12-18','02.30.57.52.13','06.21.41.59.50',NULL,'3 BIS RUE DE LA LIBERATI0N','','','14370','ARGENCES',NULL,NULL,'2561214314001',23.000000000,'1979-08-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1790,'LEMARCHAND','GILBERT',NULL,'02.94.41.14.84','06.10.86.77.35',NULL,'13 place de la mairie','','','14740','PUTOT EN BESSIN',NULL,NULL,'1320361331001',385.000000000,'2009-09-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1791,'LAVILLE','JEAN','1938-10-20','02.71.88.81.80','06.75.57.12.63',NULL,'','','','14400','ST VIGOR LE GRAND',NULL,NULL,'1381050500001',192.000000000,'1963-01-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1792,'CHOUQUARD','ISABELLE','1966-08-29','02.16.52.86.51','06.33.92.56.40',NULL,'LE MESNIL TOUFFRAY','','','14770','LASSY',NULL,NULL,'2660814651001',173.000000000,'1989-02-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1793,'LEMATTE','IRENE','1952-01-22','02.52.91.66.99','06.15.34.55.74',NULL,'','','','14000','CAEN',NULL,NULL,'1520114402001',966.000000000,'1982-02-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1794,'ANGOT','LOUIS','1932-11-19','02.22.91.53.14','06.62.36.92.20',NULL,'1 rue Marcel Pelluet','','','50500','BREVANDS',NULL,NULL,'2321114271001',638.000000000,'1957-05-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1795,'LEDENTU','RENE','1939-07-08','02.22.01.88.41','06.10.05.36.53',NULL,'22 RUE DES TILLEULS','','','14800','DEAUVILLE',NULL,NULL,'2390756054001',46.000000000,'1965-10-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1796,'RUGALE','PAUL','1961-03-15','02.10.41.35.61','06.83.58.74.05',NULL,'3 RUE DU 8 MAI','','','14370','AIRAN',NULL,NULL,'1610314435001',21.000000000,'1983-07-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1797,'DUBOIS','MADELEINE','1961-03-24','02.38.02.26.70','06.11.00.43.97',NULL,'3 rue saint sernin','','','14120','MONDEVILLE',NULL,NULL,'1610314529001',206.000000000,'1990-04-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1798,'LECANU','RENE-PIERRE','1961-11-09','02.46.66.86.93','06.27.19.51.94',NULL,'','','','14540','GRENTHEVILLE',NULL,NULL,'1611114581001',4691.000000000,'1989-08-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1799,'MARIE','MONIQUE','1931-11-25','02.73.65.40.67','06.11.19.45.61',NULL,'85 RUE DE FALAISE','','','14000','CAEN',NULL,NULL,'2311161140001',46.000000000,'1961-03-30','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1800,'LAMY','JEAN','1928-01-20','02.43.01.33.84','06.11.20.30.59',NULL,'35 RUE GAMBETTA','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'2280114084001',56.000000000,'1953-04-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1801,'LETOURNEUR','ANDRE','1940-06-28','02.24.53.96.36','06.96.18.60.20',NULL,'5 RUE EUGENIE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1400650165001',5.000000000,'1967-01-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1802,'GUICHET','GEORGETTE','1965-02-14','02.12.27.27.90','06.41.88.13.05',NULL,'657 GRANDE RUE','','','14860','BAVENT',NULL,NULL,'1650214341001',1761.000000000,'1986-04-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1803,'OLIVEAU','DOMINIQUE','1929-09-10','02.50.61.31.36','06.60.33.98.86',NULL,'8 CHEMIN ST GEORGES','','','14630','CAGNY',NULL,NULL,'2290961170001',98.000000000,'1953-12-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1804,'MICHEL','DENISE','1944-06-15','02.46.60.05.52','06.74.60.27.62',NULL,'3 RUE DU PLAIN DU ROY','','','61100','LA CHAPELLE AU MOINE',NULL,NULL,'1440661226001',688.000000000,'1974-02-14','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1805,'RENOUF','DENISE','1975-02-18','02.11.65.93.37','06.77.17.97.10',NULL,'14 RUE DU LAVOIR','','','14123','IFS',NULL,NULL,'2750250031001',1574.000000000,'1998-08-26','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1806,'CATHERINE','paul','1946-01-21','02.17.30.13.21','06.55.04.31.13',NULL,'6 IMP MATIGNON','','','14123','IFS',NULL,NULL,'2460114461001',456.000000000,'1976-08-21','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1807,'KOMPAORE','THIERRY','1945-02-15','02.10.13.20.29','06.11.47.79.42',NULL,'1 rue des erables','','','14930','ETERVILLE',NULL,NULL,'1450231137001',1227.000000000,'1969-09-26','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1808,'FRIANT','JEAN','1939-03-18','02.41.59.83.56','06.20.76.85.96',NULL,'4 RUE DE STOCKHOLM','','','14120','MONDEVILLE',NULL,NULL,'2390314341001',94.000000000,'1961-05-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1809,'BRUNET','PIERRE','1931-10-09','02.93.22.65.73','06.34.72.62.96',NULL,'33 RUE DES PAVILLONS','','','14000','CAEN',NULL,NULL,'2311014020001',157.000000000,'1956-04-29','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1810,'LONGPRE','GILLES','1934-03-05','02.15.22.25.44','06.57.24.76.35',NULL,'15 rue bellevue','','','14460','COLOMBELLES',NULL,NULL,'1340314653001',19.000000000,'1964-01-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1811,'QUESNEL','GINETTE','1940-05-07','02.85.29.83.74',NULL,NULL,'27 RUE GALANTE','','','14120','MONDEVILLE',NULL,NULL,'2400514506001',15.000000000,'1965-08-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1812,'LESAGE','JOSEPH','1956-05-24','02.87.77.76.88','06.81.66.57.67',NULL,'325 RUE DE FALAISE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2560514560001',118.000000000,'1978-08-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1813,'BLONDEL','SIMONE','1936-04-05','02.10.66.36.31','06.25.32.66.21',NULL,'1 RUE GEORGES CAZIN','','','14123','IFS',NULL,NULL,'1360414543001',479.000000000,'1966-06-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1814,'LEMAIRE','MARCEL','1937-01-16','02.11.29.86.13','06.12.43.32.42',NULL,'75 RUE BRANVILLE','','','14570','ST LAMBERT',NULL,NULL,'1370114164001',45.000000000,'1959-11-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1815,'FESTOC','PAULETTE','1938-07-29','02.16.35.75.78','06.24.23.34.71',NULL,'25 rue leclerc','','','14880','HERMANVILLE SUR MER',NULL,NULL,'1380714695001',1022.000000000,'1964-11-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1816,'QUINQUENEL','THERESE','1947-01-31','02.53.86.33.20','06.56.75.50.98',NULL,'LE MONTMIREL','','','27270','LA CHAPELLE GAUTHIER',NULL,NULL,'1470161177001',83.000000000,'1971-11-29','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1817,'ADAM','RAYMONDE','1930-01-11','02.30.82.35.61','06.43.78.97.43',NULL,'11 rue de l''europe','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1300114301001',1493.000000000,'1952-02-10','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1818,'LAIR','SOLANGE','1936-03-28','02.49.19.77.55','06.10.18.97.54',NULL,'Pillou','','','14320','MAY SUR ORNE',NULL,NULL,'2360314304001',59.000000000,'1966-06-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1819,'LE MARQUAND','RAYMONDE','1970-03-06','02.41.80.98.84','06.61.11.03.31',NULL,'43 rue des roches','','','14220','THURY HARCOURT',NULL,NULL,'1700314118001',1271.000000000,'1999-11-11','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1820,'FERAY','MARYLINE','1963-01-15','02.38.37.60.94','06.57.89.88.95',NULL,'14. rue richard lenoir','','','14670','TROARN',NULL,NULL,'2630114062001',212.000000000,'1990-10-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1821,'LEFEVRE','PHILIPPE','1939-10-04','02.42.48.16.36','06.74.72.42.23',NULL,'11 rue de rochechoire','','','14190','ST SYLVAIN',NULL,NULL,'1391014277001',92.000000000,'1961-12-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1822,'HERAULT','CHRISTINE','1946-02-27',NULL,NULL,NULL,'7 RUE ANTOINE GALLAND','','','14150','OUISTREHAM',NULL,NULL,'1460214438001',92.000000000,'1976-07-27','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1823,'BEN JENEC','ERIC','1950-02-14','02.69.52.63.99','06.98.48.25.27',NULL,'1 RUE BASSE','','','61240','LE MERLERAULT',NULL,NULL,'2500250054001',11.000000000,'1975-11-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1824,'GUERIN','XAVIER','1936-04-19','02.12.25.32.82','06.10.22.66.27',NULL,'6 RUE DE LA PAIX','','','50340','HEAUVILLE',NULL,NULL,'2360414475001',620.000000000,'1957-09-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1825,'WAJDA','JOELLE','1931-09-30','02.72.51.63.89','06.64.59.54.40',NULL,'10 allee g bizet','','','14450','GRANDCAMP MAISY',NULL,NULL,'2310914579001',169.000000000,'1956-05-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1826,'BRIDON','GERARD','1937-04-19','02.98.46.36.76','06.71.16.54.65',NULL,'5 rue du raquet','','','14220','CROISILLES',NULL,NULL,'1370461344001',199.000000000,'1967-09-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1827,'HARIVEL','REMY','1942-03-30','02.72.30.55.06','06.58.29.81.79',NULL,'61 RUE DE LA FONTENELLE','','','14730','GIBERVILLE',NULL,NULL,'1420314309001',4985.000000000,'1972-07-17','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1828,'CASTEL','CHRISTOPHE','1934-12-08','02.33.88.39.82','06.34.28.33.86',NULL,'2 ALLEE DE LA MARE','','','14220','CROISILLES',NULL,NULL,'2341261040001',3.000000000,'1956-03-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1829,'HUET','ROGER','1935-02-03','02.49.34.08.45','06.93.93.41.94',NULL,'','','','14270','MEZIDON CANON',NULL,NULL,'2350214271001',4.000000000,'1956-01-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1830,'HALLEY','DOMINIQUE','1934-11-07','02.48.57.25.30','06.83.43.62.56',NULL,'29 RUE DAMOZANNE','','','14370','AIRAN',NULL,NULL,'2341114281001',26.000000000,'1959-06-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1831,'THOMASSE','JACQUES','1930-05-15','02.10.15.56.37','06.90.20.69.61',NULL,'ALLEE DU PORTIQUE LE MONT ST LE','GER','','14570','CLECY',NULL,NULL,'2300576060001',35.000000000,'1960-08-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1832,'PICAN','RENEE','1932-01-24','02.59.50.42.22','06.45.09.28.78',NULL,'36 RUE DE LA HAIE','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1320122105001',58.000000000,'1959-01-15','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1833,'','FRANCOISE','1931-02-16','02.30.58.69.06','06.38.61.82.95',NULL,'55 RUE DE CAEN','','','14123','FLEURY SUR ORNE',NULL,NULL,'2310250356001',290.000000000,'1953-09-13','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1834,'ORY','RENE','1956-01-06','02.65.02.83.80','06.47.13.41.50',NULL,'6 RUE DE LION','','','14490','CAMPIGNY',NULL,NULL,'2560114610001',850.000000000,'1982-08-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1835,'MAILLAR','PHILIPPE','1936-09-27','02.73.07.35.53','06.57.56.48.81',NULL,'8 RUE DES LABOUREURS','','','14123','FLEURY SUR ORNE',NULL,NULL,'1360914431001',180.000000000,'1958-09-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1836,'MARIE','YVONNE','1930-03-24','02.89.57.46.94','06.10.87.16.38',NULL,'4 IMPASSE DES BLEUETS','','','14730','GIBERVILLE',NULL,NULL,'2300350148001',771.000000000,'1959-10-08','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1837,'MALLET','francoise','1933-02-12','02.84.63.94.78','06.34.72.97.62',NULL,'17 RUE LUCIEN MANGEMATIN','','','14710','ST LAURENT SUR MER',NULL,NULL,'1330214655001',82.000000000,'1955-04-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1838,'JEANNE','EDITH','1950-02-06','02.29.13.06.16','06.10.37.15.09',NULL,'38 rue de l''esprance','','','14230','ISIGNY SUR MER',NULL,NULL,'2500214275001',79.000000000,'1976-04-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1839,'MORISSET','GUY','1935-07-21','02.10.45.86.04','06.68.01.95.09',NULL,'le fey','','','14540','SOLIERS',NULL,NULL,'1350714566001',177.000000000,'1965-12-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1840,'GUIGNANS','CHARLES','1929-10-05','02.32.74.67.72',NULL,NULL,'5 rue de la garenne','','','14190','ST SYLVAIN',NULL,NULL,'2291014458001',2121.000000000,'1958-09-07','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1841,'CLANCHE','YVONNE','1937-05-06','02.21.54.16.25','06.11.23.73.27',NULL,'6 RUE BOUTROIS','','','14000','CAEN',NULL,NULL,'2370514251001',762.000000000,'1962-10-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1842,'CHAPRON','ANNE MARIE','1949-08-09','02.62.88.77.46','06.11.57.49.87',NULL,'86 route d''harcourt','','','14000','CAEN',NULL,NULL,'1490814089001',126.000000000,'1971-05-29','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1843,'BLERY','HUBERT','1982-03-06','02.56.27.18.77','06.19.00.13.81',NULL,'29 ROUTE DE COURSEULLES','','','14000','CAEN',NULL,NULL,'2820399234001',1687.000000000,'2004-05-03','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1844,'DAVID','LOUIS','1918-03-18','02.37.93.39.67','06.46.43.55.42',NULL,'MAISON DE RETRAITE  88 ROUTE DE','ROUEN','','14150','OUISTREHAM',NULL,NULL,'2180371148001',26.000000000,'1940-09-09','PREMIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1845,'VANDON','JEANINE','1939-04-21','02.10.65.99.42','06.83.81.16.94',NULL,'2 RUE GOUJARDE','','','14000','CAEN',NULL,NULL,'1390414521001',317.000000000,'1963-07-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1846,'VAIDIS','ROBERT','1958-02-26','02.83.06.09.16','06.23.48.61.14',NULL,'','','','14000','CAEN',NULL,NULL,'1580214245001',371.000000000,'1985-05-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1847,'GORAL','RENEE','1946-01-03','02.11.86.03.36','06.58.42.60.51',NULL,'3 RUE DES ECOLIERS','','','14320','FONTENAY LE MARMION',NULL,NULL,'2460114183001',37.000000000,'1967-04-30','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1848,'VAUDREVILLE','CLAUDE','1968-09-28','02.33.49.61.44','06.59.15.87.84',NULL,'NEUVILLETTE','','','14390','PETIVILLE',NULL,NULL,'2680950619001',1012.000000000,'1996-04-25','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1849,'DERVILLERS','SOLANGE','1929-12-31','02.30.35.48.53','06.10.00.46.22',NULL,'4 RUE DU ROCHER','','','14000','CAEN',NULL,NULL,'2291214167001',9.000000000,'1952-09-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1850,'VALLY','ELISABETH','1933-12-19','02.91.12.48.60','06.82.25.76.37',NULL,'41 ave du 6 juin','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1331272255001',306.000000000,'1955-02-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1851,'MAINIER','MICHEL','1940-07-23','02.68.67.14.25','06.33.56.70.12',NULL,'6 RUE CARDINAL LAVIGERIE','','','14000','CAEN',NULL,NULL,'1400752083001',44.000000000,'1964-11-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1852,'BENARD','LAURENCE','1956-08-30','02.61.45.62.47','06.74.34.93.93',NULL,'29 RUE EMILE MOUGINS','','','14000','CAEN',NULL,NULL,'2560872082001',44.000000000,'1985-04-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1853,'BRIARD','NOELLE','1958-11-03','02.78.25.39.46','06.81.04.49.32',NULL,'3 chemin du long bois','','','14000','CAEN',NULL,NULL,'1581114112001',1663.000000000,'1987-11-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1854,'BELLAMY','JEAN YVES','1955-03-08','02.79.37.78.67','06.18.35.75.26',NULL,'11 RUE DU POITOU','','','14000','CAEN',NULL,NULL,'1550314524001',139.000000000,'1985-01-30','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1855,'MELINOU','BERNARD','1961-04-20','02.54.29.89.32','06.11.58.07.12',NULL,'cao 4 rue guilbert','','','14640','AUBERVILLE',NULL,NULL,'1610414675001',776.000000000,'1991-03-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1856,'LANTRAIN','dominique',NULL,'02.29.62.42.39','06.12.12.51.13',NULL,'10 rue les bleuets','','','14000','CAEN',NULL,NULL,'2430214349001',1250.000000000,'2008-05-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1857,'APERRY','GEORGES','1937-11-18','02.10.61.45.95','06.18.03.69.67',NULL,'HAMEAU LES MARCHANDS','','','14730','GIBERVILLE',NULL,NULL,'1371114743001',75.000000000,'1961-01-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1858,'DELIVET','PHILIPPE','1929-06-24','02.38.94.38.30','06.72.96.70.12',NULL,'17 RUE DE L ABCIALE','','','14120','MONDEVILLE',NULL,NULL,'2290614554001',86.000000000,'1951-12-23','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1859,'LEMESLE','PATRICK','1929-03-16','02.77.65.12.75','06.55.05.84.27',NULL,'MAISON BOCAINE','','','14120','MONDEVILLE',NULL,NULL,'1290314670001',1194.000000000,'1951-08-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1860,'LE FEIVRE','JEAN-CHRISTOPHE','1940-09-10','02.37.41.11.80','06.31.79.51.35',NULL,'55 RESIDENCE ST JEAN','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1400914654001',163.000000000,'1963-10-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1861,'CHAUMERON','GINETTE','1955-01-28','02.73.95.19.71','06.68.12.03.00',NULL,'','','','14000','CAEN',NULL,NULL,'1550150435001',43.000000000,'1985-12-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1862,'LECHOISNE','PAUL','1932-05-25','02.10.46.15.96','06.44.32.50.61',NULL,'10 rue maurice moutare','','','61200','ARGENTAN',NULL,NULL,'1320576627001',1133.000000000,'1961-02-20','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1863,'RENOUF','DENISE','1954-01-08','02.52.42.27.80','06.13.65.66.43',NULL,'17 RUE DES GERANIUMS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2540114552001',1011.000000000,'1981-03-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1864,'DEZIER','JANINE','1954-01-10','02.77.71.40.43','06.14.28.91.53',NULL,'residence les bruyeres','','','14540','SOLIERS',NULL,NULL,'2540114552001',21.000000000,'1984-02-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1865,'MANCHON DESRIVIERES','JEAN','1937-04-30','02.54.34.96.31','06.32.62.51.29',NULL,'3 IMPASSE DES CHARMES','','','14110','PONTECOULANT',NULL,NULL,'2370437076001',197.000000000,'1959-03-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1866,'MOREL','GERARD','1955-03-26','02.43.03.99.74',NULL,NULL,'33 chemin de l''arguilly','','','14270','MAGNY LE FREULE',NULL,NULL,'2550314294001',141.000000000,'1982-11-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1867,'KERIMOV','CLAUDINE','1935-07-23','02.27.80.53.18','06.15.67.22.83',NULL,'5 RUE JEAN DE LA VARENDE','','','14000','CAEN',NULL,NULL,'2350714680001',31.000000000,'1963-03-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1868,'','MARIE THERESE','1961-01-03','02.70.55.99.83','06.51.15.21.96',NULL,'8 RUE DU MARECHAL DE LATTRE DE T','ASSIGNY','','14000','CAEN',NULL,NULL,'2610150547001',64.000000000,'1991-03-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1869,'THOMAS','JACQUELINE','1937-10-28','02.83.07.26.92','06.10.22.81.14',NULL,'RUE DE PICARDIE','','','14860','RANVILLE',NULL,NULL,'1371014562001',522.000000000,'1959-07-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1870,'POTTIER','GUSTAVE','1968-02-23','02.87.61.90.66','06.55.63.66.76',NULL,'FOYER DES PERSONNES AGEES DE LA','FOLIE COUVRECHEF','','61100','ST GEORGES DES GROSEILLERS',NULL,NULL,'2680214114001',1409.000000000,'1991-05-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1871,'POTTIER','PIERRE','1932-07-02','02.41.91.08.94','06.88.95.57.58',NULL,'11 RUE DU TOUR DE TERRE','','','14670','TROARN',NULL,NULL,'1320714394001',38.000000000,'1962-11-27','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1872,'MASSERON','FERNANDE','1949-12-26','02.44.58.74.20',NULL,NULL,'553 chemin du val','','','14000','CAEN',NULL,NULL,'1491214094001',812.000000000,'1971-05-24','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1873,'LENOEL','JEAN','1935-04-13','02.67.95.14.10','06.45.74.86.76',NULL,'4 RUE FLEURIE','','','50700','VALOGNES',NULL,NULL,'2350461466001',8.000000000,'1959-12-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1874,'LENOEL','DELPHINE','1939-01-26','02.40.02.13.55','06.16.07.96.96',NULL,'FOYER HENRI DUNANT','','','14190','CAUVICOURT',NULL,NULL,'1390150224001',99.000000000,'1961-04-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1875,'DIGEON','SIMONE','1936-12-25','02.38.41.30.71','06.11.00.04.05',NULL,'','','','14260','BONNEMAISON',NULL,NULL,'2361214173001',352.000000000,'1960-08-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1876,'NOTAMY','BERNADETTE','1941-05-18','02.11.23.45.01','06.85.07.33.25',NULL,'L AIGLERIE','','','14640','AUBERVILLE',NULL,NULL,'1410514538001',431.000000000,'1965-10-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1877,'PHILIPPOT','CLAUDE','1962-03-20','02.10.28.48.25','06.24.18.41.50',NULL,'','','','61300','ST SYMPHORIEN DES BRUYERES',NULL,NULL,'1620361122001',3.000000000,'1983-05-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1878,'GAUSSEN','ERNESTINE','1961-03-16','02.66.90.21.29','06.16.64.87.84',NULL,'','','','61210','LA FRESNAYE AU SAUVAGE',NULL,NULL,'1610314435001',40.000000000,'1985-03-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1879,'LAIDET','LOUISE','1934-12-30','02.17.29.41.35','06.11.68.72.27',NULL,'26 Les Marettes','','','14320','MAY SUR ORNE',NULL,NULL,'2341250371001',37.000000000,'1959-05-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1880,'VIGAN','gaetan','1929-04-25','02.59.12.01.38','06.20.51.20.27',NULL,'8 PLACE GARDIN','','','14270','MEZIDON CANON',NULL,NULL,'2290414289001',307.000000000,'1952-02-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1881,'BEAUGAS','GAETAN','1930-11-05','02.82.61.65.87','06.22.52.16.58',NULL,'3 rue saint cernin','','','14370','ARGENCES',NULL,NULL,'2301114720001',1977.000000000,'1957-09-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1882,'DEFRANCE','JEANNINE','1941-01-15','02.37.69.33.75','06.68.80.56.11',NULL,'3 RUE DES VERGERS','','','50620','LE DEZERT',NULL,NULL,'2410114050001',36.000000000,'1963-09-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1883,'REVEL','EMILE','1933-03-21','02.38.42.82.54','06.44.18.29.25',NULL,'2 AVENUE DES AULNAIES','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2330327179001',446.000000000,'1956-07-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1884,'PODEVIN','JACQUELINE','1936-03-24','02.61.79.10.29','06.16.13.60.16',NULL,'lieu dit le menil gouffier','','','50530','CHAMPEAUX',NULL,NULL,'1360314020001',58.000000000,'1963-12-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1885,'HEBERT','LOUIS','1933-12-31','02.88.65.50.89','06.99.04.10.70',NULL,'VOIE PANORAMIQUE','','','14460','COLOMBELLES',NULL,NULL,'2331214166001',3597.000000000,'1955-06-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1886,'VIVIER','EUGENE-CYRILLE','1933-10-04','02.78.96.68.19','06.94.43.17.14',NULL,'','','','14000','CAEN',NULL,NULL,'2331014274001',791.000000000,'1955-12-31','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1887,'ROUSSEL','LUCIEN','1939-02-11','02.76.93.59.91','06.49.96.50.59',NULL,'203 bis rue de falaise','','','14460','COLOMBELLES',NULL,NULL,'2390280100001',1657.000000000,'1960-04-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1888,'BOLLENGIER','marie christine','1938-03-27','02.46.66.07.90','06.59.05.29.50',NULL,'26 rue de la rpublique','','','61200','ARGENTAN',NULL,NULL,'1380314719001',11.000000000,'1960-02-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1889,'LEPLEY','SOLANGE','1942-03-31','02.27.53.42.67','06.68.49.29.96',NULL,'27 RUE DE L''ARQUETTE','','','27270','CHAMBLAC',NULL,NULL,'1420350295001',7.000000000,'1970-12-25','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1890,'BARBIER','DENISE','1933-09-07','02.61.79.44.55','06.11.66.23.80',NULL,'610 quartier des belles portes','','','14500','VAUDRY',NULL,NULL,'2330950577001',191.000000000,'1958-12-19','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1891,'DUVAL','REINE','1936-03-17','02.10.88.65.25','06.71.77.49.55',NULL,'3 rue a dumas','','','50100','CHERBOURG',NULL,NULL,'1360314121001',0.000000000,'1965-05-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1892,'FERAY','GERARD','1940-02-13','02.50.17.96.90','06.76.41.69.68',NULL,'12 RUE EUGENE BOUDIN','','','14540','HUBERT FOLIE',NULL,NULL,'2400228087001',432.000000000,'1970-02-03','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1893,'FOUCHARD','ROLAND','1934-07-04','02.25.79.33.51','06.39.99.54.29',NULL,'46 RUE DE BAYEUX','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2340761219001',202.000000000,'1956-09-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1894,'DALIGAULT','ROBERT','1931-05-18','02.41.94.96.08','06.59.46.61.65',NULL,'4 RUE MARECHAL FOCH','','','50100','CHERBOURG',NULL,NULL,'1310561032001',102.000000000,'1957-03-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1895,'CAMBRON','MONIQUE','1934-04-23','02.37.17.81.48','06.66.26.05.01',NULL,'7 RUE ST JEAN BAPTISTE','','','14700','FALAISE',NULL,NULL,'2340414437001',172.000000000,'1960-10-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1896,'HELAINE','PASCAL','1930-04-02','02.89.93.54.51','06.77.94.14.20',NULL,'HAMEAU LECTOT','','','14000','CAEN',NULL,NULL,'1300414639001',115.000000000,'1959-07-07','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1897,'CATHERINE','FLORENCE','1943-02-22','02.44.57.18.07','06.23.33.78.63',NULL,'2 rue du marais','','','14120','MONDEVILLE',NULL,NULL,'1430214367001',54.000000000,'1972-03-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1898,'LEFOULON','ARSENE',NULL,'02.96.96.21.90','06.75.81.82.85',NULL,'','','','14320','FONTENAY LE MARMION',NULL,NULL,'1350214516001',201.000000000,'2013-07-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1899,'FRANOISE','SERGE','1952-02-18','02.11.70.09.20','06.75.17.96.22',NULL,'25 CHEMIN DE BENEAUVILLE','','','14000','CAEN',NULL,NULL,'2520214166001',95.000000000,'1982-03-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1900,'GUILLARD','CLAUDE','1934-02-01','02.85.96.16.68','06.12.17.44.75',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1340250105001',346.000000000,'1959-11-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1901,'GUERIN','ANDREE','1939-01-20','02.27.29.08.06','06.73.75.79.02',NULL,'23 CHEMIN DE LA CROIX DE FER','','','14000','CAEN',NULL,NULL,'2390114081001',8.000000000,'1968-07-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1902,'DECARITE','YVETTE','1938-03-16','02.31.95.26.43','06.85.90.88.27',NULL,'19 RUE DU PONT JALLON','','','14000','CAEN',NULL,NULL,'2380314289001',191.000000000,'1962-02-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1903,'BIETRY','YANNICK','1929-04-28','02.70.79.85.87','06.54.94.66.85',NULL,'20 AVENUE DE LA CITE MINIERE','','','76200','DIEPPE',NULL,NULL,'2290461057001',1062.000000000,'1958-03-11','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1904,'PESQUEREL','ARLETTE','1957-08-02','02.37.69.70.86','06.12.62.79.10',NULL,'LA FONTAINE','','','14540','ROCQUANCOURT',NULL,NULL,'2570814366001',1163.000000000,'1980-09-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1905,'CID','MONIQUE','1937-07-13','02.35.26.73.57','06.82.08.22.36',NULL,'55 RUE DE LA COHUE','','','14220','ST LAURENT DE CONDEL',NULL,NULL,'1370778331001',262.000000000,'1959-05-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1906,'MICHEL','ELIANE','1928-03-19','02.51.33.36.58','06.63.87.45.66',NULL,'','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2280350318001',105.000000000,'1951-03-31','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1907,'MAUGER','CHRISTIANE','1933-05-11','02.48.66.40.18','06.68.46.29.28',NULL,'1 ALLEE DES PINCONS','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1330514112001',34.000000000,'1959-09-23','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1908,'FONTAINE','GHISLAINE','1929-04-29','02.61.55.70.66','06.32.83.05.71',NULL,'1 RUE DE L''ORMELET','','','14000','CAEN',NULL,NULL,'2290461197001',206.000000000,'1957-08-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1909,'LIBOIS','ROBERT','1963-02-09','02.65.97.10.21','06.36.91.28.75',NULL,'7 rue de la vierge','','','14120','MONDEVILLE',NULL,NULL,'2630214990001',4167.000000000,'1987-12-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1910,'DOLLEY','GINETTE','1935-06-07','02.70.65.64.84','06.69.68.94.04',NULL,'11 RUE DU PLAIN DU ROY','','','14370','MOULT',NULL,NULL,'2350661028001',363.000000000,'1960-03-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1911,'LASSEUR','JEAN','1976-06-27','02.59.91.85.83','06.30.29.78.65',NULL,'157 rue haute','','','14540','SOLIERS',NULL,NULL,'2760699238001',602.000000000,'1997-02-20','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1912,'LEGRAS','MAURICETTE','1966-12-29','02.23.14.39.83','06.47.80.92.81',NULL,'4 HAMEAU DE BRAY','','','14260','AUNAY SUR ODON',NULL,NULL,'2661214294001',23.000000000,'1992-08-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1913,'LUST','FLORENCE','1936-04-11','02.37.52.16.49','06.82.40.65.25',NULL,'24  av des clairieres','','','14000','CAEN',NULL,NULL,'1360457596001',8.000000000,'1966-10-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1914,'RUEL','JANINE',NULL,'02.96.39.98.10','06.87.95.76.46',NULL,'25 rue de l''avenir','','','14000','CAEN',NULL,NULL,'1610361283001',4780.000000000,'2010-04-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1915,'ROSEN','','1919-04-02','02.10.60.19.91','06.51.96.02.55',NULL,'FOYER ALBERT 1ER 21 AVENUE ALBE','RT 1ER','','14220','LES MOUTIERS EN CINGLAIS',NULL,NULL,'1190450502001',420.000000000,'1946-07-19','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1916,'VIARD','JACQUES','1932-09-19','02.14.82.72.96','06.77.76.11.71',NULL,'14 AVENUE GEORGES LANDRY','','','14059','CAEN',NULL,NULL,'2320949019001',29.000000000,'1954-08-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1917,'LEMAITRE','VIVIANE','1937-01-06','02.68.21.62.23','06.19.89.16.21',NULL,'1 RUE DU PRIEURE','','','14150','OUISTREHAM',NULL,NULL,'2370114451001',110.000000000,'1964-01-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1918,'BAZIN','JACQUELINE','1932-07-16','02.35.00.25.15','06.37.45.96.68',NULL,'','','','14123','IFS',NULL,NULL,'2320714610001',201.000000000,'1953-10-10','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1919,'LE METAYER','GUSTAVE','1977-06-20','02.10.25.69.36','06.84.02.89.58',NULL,'1 RUE BIENFAISANCE','','','50800','BOISYVON',NULL,NULL,'2770699302001',223.000000000,'1999-03-23','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1920,'LEMAITRE','PATRICIA','1939-12-29','02.91.22.49.05','06.86.90.83.11',NULL,'D37 ROUTE DE TROARN','','','14370','ARGENCES',NULL,NULL,'1391214455001',339.000000000,'1963-09-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1921,'LE BLOND','MARIE JOSEPHE','1935-06-07','02.75.16.09.35','06.11.22.61.48',NULL,'12 rue gandhi','','','14480','CREULLY',NULL,NULL,'2350614229001',1075.000000000,'1958-05-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1922,'BERLIN','GENEVIEVE','1937-07-08','02.79.27.76.43','06.11.29.04.96',NULL,'30 RUE LAUNETTE','','','14000','CAEN',NULL,NULL,'1370714404001',100.000000000,'1961-06-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1923,'GEHENNE','CHRISTOPHE','1940-03-17','02.30.43.58.00','06.10.12.07.81',NULL,'16 IMPASSE POMONE','','','14700','VIGNATS',NULL,NULL,'1400314672001',27.000000000,'1962-07-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1924,'SUPRUN','YVES','1936-11-25','02.12.79.48.56','06.86.16.58.99',NULL,'434 ROUTE DE LANGRUNE','','','14470','COURSEULLES SUR MER',NULL,NULL,'2361127040001',433.000000000,'1958-04-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1925,'COLIBOEUF','THERESE','1962-03-07','02.10.52.85.55','06.21.98.88.39',NULL,'16 RUE DE LA POMME','','','14000','CAEN',NULL,NULL,'1620314628001',375.000000000,'1986-03-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1926,'DELAMARE','JULIETTE','1963-01-30','02.61.20.32.23','06.78.22.56.28',NULL,'159 RTE DE LION','','','14123','FLEURY SUR ORNE',NULL,NULL,'1630114327001',91.000000000,'1989-07-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1927,'LEVERRIER','FLORENCE','1930-12-17','02.97.83.63.40','06.55.69.14.22',NULL,'27 RUE DE BOURGOGNE','','','14220','ST LAURENT DE CONDEL',NULL,NULL,'2301250580001',37.000000000,'1952-04-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1928,'ESNOULT','BERNARD','1950-06-19','02.11.36.11.45','06.71.76.92.96',NULL,'50 route de gouvix','','','14220','ST LAURENT DE CONDEL',NULL,NULL,'2500614255001',57.000000000,'1978-02-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1929,'SUSANNE-BEBIN','RENE','1938-05-26','02.24.67.45.34','06.62.30.12.45',NULL,'2 CENTRE DE LA BERGERE','','','14000','CAEN',NULL,NULL,'2380585257001',92.000000000,'1960-11-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1930,'LE MAITRE','ANGELE','1930-03-04','02.20.93.12.41','06.73.57.91.87',NULL,'51A RUE VICTOR LEPINE','','','14000','CAEN',NULL,NULL,'2300390010001',14.000000000,'1960-05-25','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1931,'JACQUES','JEAN','1957-03-25',NULL,NULL,NULL,'RUE DE L EGLISE','','','14000','GIBERVILLE',NULL,NULL,'1570314328001',19.000000000,'1981-08-23','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1932,'SALLOT','REGINE','1959-11-27','02.28.19.56.65','06.34.66.34.96',NULL,'42 RUE DE L''EGLISE','','','14000','CAEN',NULL,NULL,'1591114729001',3644.000000000,'1980-01-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1933,'MERLE','MICHEL','1938-07-18','02.80.03.65.75','06.88.90.65.13',NULL,'LES HAUTS VENTS','','','61430','ATHIS DE L''ORNE',NULL,NULL,'1380714140001',29.000000000,'1959-03-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1934,'SKIBA','THERESE','1935-05-05','02.46.51.55.60','06.87.93.34.20',NULL,'53 RUE JEAN VILAR','','','14190','CAUVICOURT',NULL,NULL,'1350561461001',65.000000000,'1956-09-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1935,'DAIGREMONT','IRENE','1931-01-24','02.24.10.05.37','06.35.37.72.52',NULL,'24 RUE DES MONTS','','','72520','LAIGNE EN BELIN',NULL,NULL,'2310114196001',395.000000000,'1961-11-21','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1936,'BELIN','MICHEL','1935-09-15',NULL,NULL,NULL,'','','','14000','CAEN',NULL,NULL,'1350950082001',375.000000000,'1962-07-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1937,'CLEMENCE','SUZANNE','1930-04-05','02.45.92.41.00','06.43.62.75.09',NULL,'1 rue dcardinal lavigerie','','','14000','CAEN',NULL,NULL,'1300414181001',1066.000000000,'1951-09-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1938,'VAUTIER','CYRILLE','1928-04-26','02.76.44.04.02','06.91.11.67.92',NULL,'4 route de saint clair','','','14230','ISIGNY SUR MER',NULL,NULL,'2280441279001',1976.000000000,'1951-03-15','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1939,'PESNELLE','JEAN','1961-07-30','02.88.22.50.31','06.98.00.69.30',NULL,'','','','50310','QUINEVILLE',NULL,NULL,'2610714661001',145.000000000,'1987-06-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1940,'LOISEL','MARCEL','1940-03-03','02.29.78.96.89','06.46.28.54.69',NULL,'LE BOURG','','','14800','TOUQUES',NULL,NULL,'1400314488001',351.000000000,'1962-11-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1941,'DESRUES','JACQUELINE','1940-12-09','02.65.47.68.27','06.19.59.34.33',NULL,'"LE SAUBENARD"','','','50700','VALOGNES',NULL,NULL,'1401214469001',172.000000000,'1969-11-23','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1942,'LANGLAIS','JOEL','1934-06-16','02.76.39.42.06','06.10.67.69.34',NULL,'VILLAGE D''INGY','','','14220','CROISILLES',NULL,NULL,'1340656198001',92.000000000,'1958-03-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1943,'LECLERC','GERARD','1945-02-24','02.20.97.22.53','06.52.28.75.65',NULL,'res palissis  rue monseigneur ad','am','','14940','TOUFFREVILLE',NULL,NULL,'1450250369001',3503.000000000,'1967-07-09','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1944,'MONROTY','JEAN','1962-01-11','02.21.92.41.61','06.34.90.72.84',NULL,'11 rue des pavillon','','','14000','CAEN',NULL,NULL,'2620161049001',20.000000000,'1985-02-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1945,'GAUTIER','LOUISE','1933-05-06','02.49.88.93.33','06.11.49.39.79',NULL,'2 RUE DU VAL','','','61230','GACE',NULL,NULL,'2330550161001',142.000000000,'1955-11-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1946,'CHARTRAIN','BERNARD','1930-08-30','02.35.60.29.36','06.17.37.72.20',NULL,'80 AVENUE DE ROUEN','','','14630','CAGNY',NULL,NULL,'2300814338001',48.000000000,'1953-11-14','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1947,'VILFEU','DOMINIQUE','1929-05-18','02.93.00.62.01','06.66.61.49.57',NULL,'7 RUE DES CAPUCINES','','','14710','LOUVIERES',NULL,NULL,'2290518187001',446.000000000,'1956-09-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1948,'LANGLAIS','SERGE','1930-02-01','02.16.07.59.70','06.14.15.89.65',NULL,'RUE DE LIROSE','','','14610','ANISY',NULL,NULL,'1300214564001',48.000000000,'1958-07-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1949,'LAUNAY','CHANTAL','1945-03-24',NULL,NULL,NULL,'4 venelle aux morices','','','14123','IFS',NULL,NULL,'1450314316001',12.000000000,'1966-08-21','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1950,'MARIE','','1928-02-26','02.74.24.52.02',NULL,NULL,'61 ROUTE DE PORT EN BESSIN BP 6','0000','','14270','OUEZY',NULL,NULL,'1280214530001',1358.000000000,'1958-05-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1951,'BROUT','CHRISTIANE','1940-02-11','02.44.98.84.58','06.41.97.74.90',NULL,'11 IMPASSE DES CYCLAMENS','','','14330','LE BREUIL EN BESSIN',NULL,NULL,'1400244116001',6.000000000,'1967-03-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1952,'FALET','BRIGITTE','1937-04-20','02.27.04.15.56','06.14.15.17.45',NULL,'4 RUE GUSTAVE FLAUBERT','','','14000','CAEN',NULL,NULL,'1370414020001',94.000000000,'1961-12-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1953,'MILANI','VITAL','1933-03-14','02.33.67.43.25','00 33 6.80.83.16.33',NULL,'9 RUE ROMAINE','','','14400','BAYEUX',NULL,NULL,'1330314200001',747.000000000,'1959-07-06','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1954,'LETELLIER','GENEVIEVE','1936-08-11','02.34.71.76.68','06.82.25.22.90',NULL,'27 RUE CAILLEMER','','','14250','CRISTOT',NULL,NULL,'1360814360001',46.000000000,'1960-07-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1955,'LETELLIER','CHRYSTELLE','1939-08-13','02.37.51.91.29','06.19.91.39.60',NULL,'21 RUE DE LA POMMERAIE','','','14000','CAEN',NULL,NULL,'2390814120001',3936.000000000,'1969-03-05','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1956,'VAUGEOIS','MONIQUE','1934-09-15','02.86.97.93.59','06.11.42.88.90',NULL,'LE MESNIL','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1340914318001',136.000000000,'1958-11-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1957,'CARVILLE','LOUIS','1964-07-19','02.11.82.27.22','06.67.93.31.06',NULL,'7 RUE BOBIGNY','','','14000','CAEN',NULL,NULL,'2640721361001',1157.000000000,'1988-03-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1958,'NIARD','ODILE','1945-05-29','02.11.86.63.18','06.57.66.28.55',NULL,'11 YVONNE GUEGAN','','','50340','BRICQUEBOSQ',NULL,NULL,'1450556256001',588.000000000,'1966-09-03','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1959,'ADAM','RENE','1934-07-05','02.87.94.21.61','06.55.57.89.89',NULL,'11 RUE DE BRETAGNE','','','14540','GRENTHEVILLE',NULL,NULL,'2340714323001',48.000000000,'1958-12-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1960,'DILYS','NELLY','1930-08-11','02.10.21.72.44','06.82.89.74.66',NULL,'VIRCOQ','','','14340','VALSEME',NULL,NULL,'2300814393001',430.000000000,'1958-07-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1961,'','JEANNE','1930-06-17','02.60.82.65.15','06.46.98.84.48',NULL,'14 BD CHURCHILL','','','14700','VIGNATS',NULL,NULL,'1300614027001',12.000000000,'1957-12-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1962,'MARIE','ilqar','1954-01-16','02.66.52.21.41','06.11.81.09.79',NULL,'HAMEAU COURTEILLES','','','14630','FRENOUVILLE',NULL,NULL,'1540161278001',11.000000000,'1977-06-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1963,'JEANNETTE','FELIX','1942-01-09','02.10.70.34.36','06.33.19.66.05',NULL,'FERME DU LOGIS','','','14210','TOURVILLE SUR ODON',NULL,NULL,'1420114744001',836.000000000,'1964-02-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1964,'TALHI','MADELEINE','1936-05-21','02.22.28.31.76','06.17.41.75.11',NULL,'30 route d''harcourt','','','14400','BAYEUX',NULL,NULL,'1360514651001',1.000000000,'1957-01-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1965,'LEGRAS','DANY','1929-07-23','02.43.04.27.26','06.11.70.22.07',NULL,'17 RUE CH BEAUDELAIRE','','',NULL,NULL,NULL,NULL,'1290714121001',383.000000000,'1958-02-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1966,'','CLAUDINE','1932-10-16','02.10.62.17.55','06.59.94.17.34',NULL,'37 BIS RUE DE BRAS','','','14190','ESTREES LA CAMPAGNE',NULL,NULL,'1321014109001',17.000000000,'1961-06-04','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1967,'GRUZA','JACQUELINE','1938-03-29','02.66.26.12.00','06.18.84.37.69',NULL,'11 rue du bissonnet','','','14000','CAEN',NULL,NULL,'1380314157001',461.000000000,'1959-06-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1968,'VATRES','CHRISTIANE','1932-07-23','02.99.29.82.90','06.99.25.21.83',NULL,'289 TOURDERIE','','','14000','CAEN',NULL,NULL,'2320714612001',136.000000000,'1958-09-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1969,'LETERRIER','SYLVIE','1938-04-22','02.21.98.87.12','06.11.53.11.84',NULL,'39 RUE DE LA DELIVRANDE','','','14000','CAEN',NULL,NULL,'2380461407001',397.000000000,'1962-05-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1970,'LEVALLOIS','ROLANDE','1928-08-27','02.82.07.52.16','06.78.89.44.91',NULL,'','','',NULL,NULL,NULL,NULL,'1280872380001',264.000000000,'1952-05-19','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1971,'SAGE','ALEXANDRE','1929-02-23','02.90.36.84.19','06.78.89.20.51',NULL,'RESIDENCE DE LA BERGERIE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2290214708001',168.000000000,'1950-01-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1972,'GUERIN','CHANTAL','1943-02-27','02.89.99.10.69','06.59.96.86.09',NULL,'23 paul eloire','','','14630','FRENOUVILLE',NULL,NULL,'2430214356001',4775.000000000,'1965-06-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1973,'SUPIZET','MICHEL','1939-11-09','02.65.65.82.34','06.14.49.35.45',NULL,'64 rue de la marne','','',NULL,NULL,NULL,NULL,'2391114712001',41.000000000,'1960-03-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1974,'LENGRONNE','MICHEL','1934-10-23','02.68.82.21.11','06.43.51.88.25',NULL,'16 AVENUE DU 43 E REGIMENT D''ART','ILLERIE','','14330','SAONNET',NULL,NULL,'2341061236001',735.000000000,'1960-11-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1975,'BONNEL','NADINE','1967-10-19','02.42.71.73.94','06.80.91.36.04',NULL,'10 rue du poitou','','','14510','HOULGATE',NULL,NULL,'2671014290001',172.000000000,'1992-10-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1976,'LEPOITTEVIN','JULES','1940-12-12','02.99.85.71.69','06.11.03.29.19',NULL,'2 IMPASSE DES GLAIEULS','','','14410','VIESSOIX',NULL,NULL,'2401253201001',2359.000000000,'1969-06-08','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1977,'PERI','MARIE LAURE','1953-03-19','02.39.16.13.87','06.42.92.52.30',NULL,'30 BD ALSACE LORRAINE','','','14000','CAEN',NULL,NULL,'2530314119001',39.000000000,'1974-09-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1978,'MEUDIC','','1928-01-23','02.27.80.15.33','06.49.33.05.03',NULL,'46 BIS RUE DE LA SEINE','','','50210','ST DENIS LE VETU',NULL,NULL,'2280172154001',1094.000000000,'1949-12-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1979,'VARIN','GENEVIEVE','1938-09-25','02.51.48.98.37','06.18.87.14.66',NULL,'2 rue france choubert','','','14480','LE FRESNE CAMILLY',NULL,NULL,'1380914090001',14.000000000,'1962-01-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1980,'VARIN','ARMELLE','1933-02-11','02.17.02.02.55','06.66.80.10.41',NULL,'18 RUE ALBERT 1ER','','','14000','CAEN',NULL,NULL,'1330214364001',327.000000000,'1955-07-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1981,'ROQUET','MAURICE','1956-12-30','02.60.37.06.08','06.36.27.60.33',NULL,'','','','14240','CAHAGNES',NULL,NULL,'2561214657001',352.000000000,'1977-09-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1982,'MARIE','GEORGETTE','1938-09-05','02.60.44.89.43','06.10.74.71.00',NULL,'3 rue de la perquette','','','14000','CAEN',NULL,NULL,'1380914372001',91.000000000,'1966-12-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1983,'','CLAUDE','1936-07-29','02.51.00.30.72','06.16.71.02.87',NULL,'16 rue henri barbusse','','','14000','CAEN',NULL,NULL,'1360750325001',67.000000000,'1957-09-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1984,'LECHEVALLIER','CLAUDE','1954-03-26','02.30.76.70.31','06.49.34.26.47',NULL,'1 RUE DU NID DU CHIEN','','','14980','ROTS',NULL,NULL,'1540350505001',59.000000000,'1976-07-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1985,'MOSSLER','HELENE','1945-10-24','02.52.37.34.08','06.44.54.55.27',NULL,'IMPASSE LA MARTINIERE','','','14123','IFS',NULL,NULL,'1451097221001',304.000000000,'1970-08-31','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1986,'SPINGA','JEANNINE','1931-08-21','02.96.00.28.78','06.39.29.95.30',NULL,'9 rue d isigny chez mme CUDINE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2310814020001',6.000000000,'1953-03-10','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1987,'TRIOLET','MARCELLE','1962-03-23','02.67.78.43.39','06.84.77.78.76',NULL,'19 imp des roses','','','14500','VIRE',NULL,NULL,'1620361122001',31.000000000,'1986-05-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1988,'HUREL','PASCAL','1939-03-27','02.77.97.65.00','06.10.45.35.73',NULL,'9 RUE ROGER DUPONT','','','14000','CAEN',NULL,NULL,'2390314186001',186.000000000,'1963-06-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1989,'LESAVOUREUX','FERNAND',NULL,'02.60.30.87.69','06.85.48.00.26',NULL,'13 LOTISSEMENT DE LA MOTTE','','','14160','GRANGUES',NULL,NULL,'1340622094001',358.000000000,'2007-11-19','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1990,'LEPAGE','BERNARD','1938-08-27','02.83.97.38.17','06.48.38.94.61',NULL,'2 RUE DU PANORAMA','','','14670','ST OUEN DU MESNIL OGER',NULL,NULL,'2380814117001',264.000000000,'1961-08-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1991,'ECHE','PIERRE','1929-03-09','02.11.26.63.96','06.44.46.67.56',NULL,'lieu dit lalonde rd 33','','','61700','AVRILLY',NULL,NULL,'1290310206001',818.000000000,'1955-09-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1992,'SEBIRE','ODETTE','1931-05-10','02.43.41.57.81','06.28.85.72.89',NULL,'4 BIS RUE DU DR PAUL ENOUF','','','14320','FONTENAY LE MARMION',NULL,NULL,'2310522128001',142.000000000,'1960-05-21','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1993,'BOUET','CLAUDE','1939-04-02','02.35.32.66.45','06.80.24.07.94',NULL,'56 rue armand marie','','','14123','IFS',NULL,NULL,'2390414388001',15.000000000,'1963-02-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1994,'JUMEL','CLAUDE','1932-02-24','02.13.13.74.95',NULL,NULL,'62 C ROUTE DE BRETAGNE','','','14210','NEUILLY LE MALHERBE',NULL,NULL,'1320261295001',100.000000000,'1960-04-20','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1995,'MAUPILIER','CHANTAL','1934-12-30','02.94.36.36.16','06.12.00.70.15',NULL,'1 RUE DE BAYEUX','','','14490','BALLEROY',NULL,NULL,'2341214535001',384.000000000,'1956-12-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1996,'POZNANSKI','fabien','1937-04-28','02.43.34.83.24','06.25.02.71.24',NULL,'4 RUE DU PRESIDENT COTY','','','14670','TROARN',NULL,NULL,'1370414066001',106.000000000,'1966-06-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1997,'LANGEVIN','Jean louis','1937-10-26','02.50.32.89.24','06.79.51.47.59',NULL,'3 PLACE DU CLOS DES OUISEAUX','','',NULL,NULL,NULL,NULL,'1371014628001',23.000000000,'1965-12-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1998,'MAUBERT','MICHELINE','1938-01-14','02.58.98.28.75','06.50.19.12.65',NULL,'3 rue roger bastion','','',NULL,NULL,NULL,NULL,'1380161232001',197.000000000,'1960-10-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (1999,'CHASSERIEAU','VERONIQUE',NULL,'02.37.44.10.14','06.62.34.40.58',NULL,'rue du stade','','','14000','CAEN',NULL,NULL,'1430460516001',38.000000000,'2009-11-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2000,'GOUDAL','JEAN','1936-10-15','02.24.03.51.18','06.96.48.28.70',NULL,'4 cite des jardins','','','14610','BASLY',NULL,NULL,'2361077464001',110.000000000,'1958-07-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2001,'COUDRAY','SYLVIE','1939-11-05','02.12.07.85.68','06.27.31.32.27',NULL,'6 rue du luxembourg','','','14850','HEROUVILLETTE',NULL,NULL,'2391178066001',79.000000000,'1962-11-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2002,'VILAIN','GEORGETTE','1932-06-29','02.51.86.96.21','06.74.86.04.56',NULL,'CHEMIN DU CHAMP BRETON','','','14170','LIEURY',NULL,NULL,'1320653157001',170.000000000,'1962-12-11','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2003,'ESNEYS','DENIS','1985-05-20','02.24.67.27.24','06.58.80.91.73',NULL,'5 RUE DE L''EURE','','','14840','CUVERVILLE',NULL,NULL,'1850599336001',11.000000000,'2012-02-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2004,'FLEURY','PAULETTE','1968-01-22','02.83.28.24.30','06.11.45.84.07',NULL,'15 RUE DE VERDUN','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1680153166001',99.000000000,'1989-03-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2005,'ANNE','ANDRE','1940-11-21','02.19.20.29.76','00 33 6.32.52.11.44',NULL,'','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1401114196001',328.000000000,'1967-01-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2006,'TOUTAIN','ISABELLE','1934-10-13','02.91.07.23.50','06.41.39.17.18',NULL,'34 AVENUE DE L''HIPPODROME','','','14270','LE MESNIL MAUGER',NULL,NULL,'2341014515001',1179.000000000,'1961-02-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2007,'POREY','RENE','1939-08-30','02.94.79.02.16','06.36.08.41.69',NULL,'5/8 CITE DE ROCHES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2390814163001',78.000000000,'1968-03-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2008,'DAUMESNIL','JEANINE','1938-02-07','02.57.37.32.24','06.67.08.82.26',NULL,'27 RUE DU PONT CREON','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1380214483001',33.000000000,'1968-09-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2009,'BOREL','ANDRE','1935-04-23','02.64.90.26.52','06.43.32.08.71',NULL,'163 RUE DE LA BASSE RIVE','','','14000','CAEN',NULL,NULL,'1350461389001',581.000000000,'1956-06-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2010,'QUERE','ALBERT','1941-03-01','02.33.44.77.53','06.25.45.58.37',NULL,'163 RUE DE LA BASSE RIVE','','','14000','CAEN',NULL,NULL,'2410351391001',73.000000000,'1969-06-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2011,'CHAPPERON','EDOUARD','1940-03-29','02.10.51.29.69','06.11.57.90.18',NULL,'11 RUE DU CHATEAU D''EAU','','','14123','IFS',NULL,NULL,'2400350390001',8.000000000,'1964-01-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2012,'GODEFROY','DANIEL','1938-05-16','02.81.00.51.32','06.85.65.00.76',NULL,'5 RUE MARGUERITE DURAS','','','14980','ROTS',NULL,NULL,'1380560653001',41.000000000,'1960-09-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2013,'ERROT','MAURICE','1930-01-14','02.61.13.12.09','06.53.95.01.04',NULL,'le lion d or','','','61200','ARGENTAN',NULL,NULL,'2300114168001',29.000000000,'1951-03-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2014,'BARBEY','MADELEINE','1936-08-23','02.32.27.69.55','06.10.59.04.82',NULL,'23 rue de la bienfaisance','','','14690','PIERREFITTE EN CINGLAIS',NULL,NULL,'1360814597001',2250.000000000,'1961-09-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2015,'RIBOT','COLETTE','1939-05-01','02.20.13.52.53','06.50.69.61.03',NULL,'9 RUE DU 11 NOVEMBRE','','','14120','MONDEVILLE',NULL,NULL,'1390514171001',406.000000000,'1962-11-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2016,'VIVIEN','JOSIANE','1948-01-02','02.47.46.64.39','06.24.83.17.97',NULL,'9 RUE PORTE MILLET','','','14120','MONDEVILLE',NULL,NULL,'2480114589001',68.000000000,'1969-11-22','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2017,'RIBARD','CHRISTIAN','1947-01-21','02.61.56.01.80','06.88.50.92.60',NULL,'57 RUE DE BEAULIEU','','','14370','ARGENCES',NULL,NULL,'1470135260001',10.000000000,'1968-07-30','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2018,'HARDY','MICHEL','1933-02-17','02.11.71.15.73','06.79.45.41.43',NULL,'19 RUE PIERRE CURIE','','','14670','TROARN',NULL,NULL,'1330214336001',61.000000000,'1961-06-07','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2019,'LEBAILLY','ALAIN','1931-10-09','02.93.83.86.13','06.87.58.97.32',NULL,'campagnol','','','14370','AIRAN',NULL,NULL,'2311014216001',134.000000000,'1952-10-24','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2020,'GUERARD','KATIA','1934-09-16','02.14.40.73.39','06.39.74.14.26',NULL,'23 ALLEE DES ORFEVRES','','',NULL,NULL,NULL,NULL,'1340961252001',312.000000000,'1956-04-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2021,'GAUCHARD','CHRISTIAN','1928-01-09','02.18.87.47.23','06.36.07.86.16',NULL,'14 rue des maronniers','','','61200','SEVIGNY',NULL,NULL,'1280114396001',8.000000000,'1951-07-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2022,'LEPETIT','ALBERT','1931-02-18','02.89.55.71.48','06.10.95.48.13',NULL,'4 2 rue des marguerites','','','14000','CAEN',NULL,NULL,'2310250356001',59.000000000,'1959-03-19','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2023,'PICOT','ANDREE','1943-01-20','02.27.12.19.01','06.11.79.44.56',NULL,'62 RUE DU MARAIS','','','14410','BURCY',NULL,NULL,'1430114618001',1188.000000000,'1964-08-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2024,'JOHN','PIERRE','1970-03-10','02.26.22.82.35','06.91.08.44.33',NULL,'le bourg','','',NULL,NULL,NULL,NULL,'2700380570001',939.000000000,'1992-09-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2025,'CAMBRON','ROLAND','1943-01-10','02.30.36.61.61','06.63.21.58.35',NULL,'1 RUE VOLTAIRE','','','14670','JANVILLE',NULL,NULL,'1430114335001',367.000000000,'1973-07-11','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2026,'LE ROY','JACQUELINE','1944-02-11','02.28.53.85.55','06.84.06.31.45',NULL,'7 RUE STE PAIX PORTE B','','','14400','ST MARTIN DES ENTREES',NULL,NULL,'2440212264001',82.000000000,'1969-09-04','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2027,'LAFON','BERNARD','1944-02-01','02.27.07.63.82','06.10.66.51.24',NULL,'22 RUE PRE SAINT MARTIN','','','14123','IFS',NULL,NULL,'2440212264001',35.000000000,'1967-06-01','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2028,'GUILLON','CLAUDE','1957-01-05','02.35.22.77.51','06.20.30.41.20',NULL,'2 RUE DES CHASSES','','','50360','PICAUVILLE',NULL,NULL,'1570114695001',649.000000000,'1982-01-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2029,'FORTIER','NATHALIE','1932-09-17','02.34.02.92.27','06.11.65.16.49',NULL,'12 RUE DU STADE','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'2320914023001',3.000000000,'1954-07-14','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2030,'ROULLEAUX','GEORGETTE','1932-09-07','02.83.82.03.64','06.84.57.39.26',NULL,'12 AVENUE DE LA CONCORDE','','','14310','TRACY BOCAGE',NULL,NULL,'2320914023001',2289.000000000,'1957-05-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2031,'LESAULNIER','MAURICE','1929-05-15','02.45.11.39.29','06.43.87.78.51',NULL,'17 PLACE VOLTAIRE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2290553100001',58.000000000,'1958-07-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2032,'SEBERT','LOUISE','1939-02-03','02.45.98.03.56','06.77.05.62.61',NULL,'36 RUE ALEXANDRE','','','14700','FALAISE',NULL,NULL,'2390214122001',40.000000000,'1963-07-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2033,'LEROUVILLOIS','MADELEINE','1936-09-12','02.70.90.26.39','06.61.40.80.35',NULL,'15 rue de la crte','','',NULL,NULL,NULL,NULL,'2360950289001',380.000000000,'1964-08-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2034,'BLIN','ANTHONY','1935-08-15','02.23.50.41.72','06.61.96.49.82',NULL,'','','','14000','CAEN',NULL,NULL,'1350841099001',149.000000000,'1959-05-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2035,'RICHARD','CLAUDE','1936-06-19','02.31.47.06.19','06.10.15.58.42',NULL,'fissy','','','14123','IFS',NULL,NULL,'2360661218001',991.000000000,'1958-10-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2036,'QUONIAM','DANIEL','1939-07-26','02.54.97.38.09','06.11.10.89.89',NULL,'25 RUE DES CORPS MORANTS','','','14700','FALAISE',NULL,NULL,'1390714258001',27.000000000,'1965-04-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2037,'QUONIAM','JOCELYNE','1957-02-20','02.10.57.45.35','06.20.63.17.40',NULL,'','','','14370','ARGENCES',NULL,NULL,'1570214520001',813.000000000,'1985-11-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2038,'HOST','MYRIAM','1954-07-08','02.10.28.55.52','06.10.01.94.76',NULL,'3 RUE DE FALAISE','','','14630','EMIEVILLE',NULL,NULL,'1540714188001',5.000000000,'1977-05-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2039,'AZE','GINO','1961-04-10','02.43.04.90.08','06.47.61.93.92',NULL,'6 RUE DE VAUX','','','14270','MEZIDON CANON',NULL,NULL,'1610414454001',24.000000000,'1985-07-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2040,'GONIDEC','THERESE','1946-05-26','02.14.59.65.73','06.33.51.28.27',NULL,'85 AVENUE DE LA PLAGE','','','14260','ONDEFONTAINE',NULL,NULL,'2460514146001',1112.000000000,'1971-08-22','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2041,'PLET','ALEXANDRE','1962-01-11','02.65.46.60.10','06.76.39.49.45',NULL,'19 RUE DE L''ECUREUIL','','','61300','L''AIGLE',NULL,NULL,'2620114221001',305.000000000,'1990-12-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2042,'PALIN','GERALDINE','1936-01-08','02.18.79.02.82','06.64.22.60.64',NULL,'579 ROUTE DU BANC','','','14000','CAEN',NULL,NULL,'2360161069001',91.000000000,'1957-06-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2043,'PATRICE','Brigitte','1937-08-25','02.10.64.11.94','06.74.27.11.68',NULL,'16 rte de tilly','','','50340','LES PIEUX',NULL,NULL,'2370814221001',88.000000000,'1961-09-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2044,'DESLOGES','claude','1937-12-30','02.79.13.39.97','06.28.18.34.64',NULL,'17 ALLEE LAPEROUZE','','','14210','AVENAY',NULL,NULL,'1371214288001',711.000000000,'1967-04-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2045,'GUERIN','CHRISTOPHE','1955-01-26','02.37.05.75.80','06.88.14.29.69',NULL,'2 rue de l''ile de france','','','14000','CAEN',NULL,NULL,'1550114365001',141.000000000,'1984-02-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2046,'LEMERCIER','ALAIN','1938-04-28','02.46.75.06.30','06.28.01.32.52',NULL,'3 rue de londres','','','14000','CAEN',NULL,NULL,'2380450033001',79.000000000,'1961-11-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2047,'LEVAVASSEUR','ARLETTE','1941-01-08','02.69.42.89.67','06.82.60.82.69',NULL,'36 RUE DE L''EPARGNE','','',NULL,NULL,NULL,NULL,'1410114075001',2237.000000000,'1971-08-30','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2048,'LOYAUX','stephane','1961-04-15','02.11.64.81.80','06.49.11.45.73',NULL,'70 RUE DU GENERAL DE GAULLE','','','14400','BAYEUX',NULL,NULL,'1610414483001',78.000000000,'1991-12-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2049,'TERRY','IRENE','1939-03-22','02.12.07.63.79','06.52.93.38.85',NULL,'chez m Baiga 9 RUE ALBERT DE MUN','','','61100','FLERS',NULL,NULL,'2390361006001',152.000000000,'1968-03-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2050,'JANVIER','CLEMENCE','1932-03-27','02.83.31.71.31','06.72.85.34.36',NULL,'9 route de devant','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2320350051001',399.000000000,'1962-10-13','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2051,'GRUYER','JOEL','1955-02-10','02.12.33.21.30','06.91.39.88.32',NULL,'2 rue a nobell','','','14370','ARGENCES',NULL,NULL,'2550214349001',597.000000000,'1977-07-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2052,'LE CANN','MICHELINE','1934-07-26','02.47.80.57.78','06.88.84.17.38',NULL,'7 CITE DE LA CHAPELLE','','','14860','BAVENT',NULL,NULL,'2340714340001',843.000000000,'1956-12-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2053,'BEQUET','ODETTE','1931-12-17','02.72.38.82.60','06.42.62.18.25',NULL,'3 BOULEVARD DU MAINE','','','14000','CAEN',NULL,NULL,'2311261418001',42.000000000,'1955-08-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2054,'GEERTS','GERARD','1959-01-30','02.75.60.20.42','06.87.53.61.85',NULL,'4 ROUTE DE CAEN','','','14610','THAON',NULL,NULL,'1590114046001',1180.000000000,'1986-11-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2055,'DENIZE','MUGUETTE','1937-06-12','02.89.84.30.48','06.82.87.18.74',NULL,'101 AVENUE GENERAL LECLERC','','','14123','IFS',NULL,NULL,'1370614515001',313.000000000,'1965-06-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2056,'SIMON','PIERRE','1935-07-10','02.60.51.98.66','06.67.09.01.37',NULL,'36 RUE GUILLAUUME LE CONQUERANT','','','14480','CREULLY',NULL,NULL,'1350750484001',9.000000000,'1960-02-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2057,'MAUGER','JEANNE','1928-12-03','02.56.32.28.44','06.44.59.90.05',NULL,'LE NOUVEAU MONDE','','','14310','VILLERS BOCAGE',NULL,NULL,'1281203314001',647.000000000,'1955-09-24','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2058,'SALLES','HELENE','1937-11-15','02.39.67.63.94','06.26.87.24.90',NULL,'39 AVENUE DES 2 EGLISES','','','14370','CANTELOUP',NULL,NULL,'2371114011001',315.000000000,'1958-12-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2059,'LOREL','SUZANNE','1957-06-04','02.79.93.71.21','06.44.75.26.86',NULL,'CHEMIN DU FRICHE LE DESERT','','','14240','ORBOIS',NULL,NULL,'1570627155001',3657.000000000,'1987-12-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2060,'GILBERT','CLAUDE','1968-02-21','02.10.52.36.45','06.59.18.38.45',NULL,'28 rue m utrillo','','','14370','ARGENCES',NULL,NULL,'2680214057001',72.000000000,'1996-04-25','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2061,'ARMAND','Jules','1933-02-02','02.50.16.36.05','06.35.44.87.47',NULL,'1 rue des marches','','',NULL,NULL,NULL,NULL,'1330214127001',175.000000000,'1960-03-10','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2062,'GIARD','HUBERT','1936-04-26','02.65.49.07.22','06.11.91.74.95',NULL,'1 rue chagford','','','14370','VIMONT',NULL,NULL,'1360445080001',57.000000000,'1960-05-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2063,'BERTHEAUME','LOUISE','1938-03-12','02.46.45.63.45','06.10.02.97.84',NULL,'11 RUE DES REHAUTS','','',NULL,NULL,NULL,NULL,'1380314041001',16.000000000,'1962-03-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2064,'HUE','RENE','1929-08-07','02.78.63.22.14','06.10.52.57.06',NULL,'23 RUE DU VILLAGE','','','14100','LISIEUX',NULL,NULL,'2290814743001',196.000000000,'1952-06-23','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2065,'LEMIERE','PAULETTE','1928-03-12','02.93.41.09.11','06.66.81.85.72',NULL,'32 ROUTE DE ROUEN','','','14790','VERSON',NULL,NULL,'2280350427001',464.000000000,'1956-03-14','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2066,'SIGNORET','JEAN','1965-01-31','02.10.15.19.44','00 33 6.34.84.76.35',NULL,'','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'1650114060001',10.000000000,'1992-04-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2067,'MONTECOT','THERESE','1953-09-20','02.70.56.56.09','06.39.57.60.59',NULL,'LE MESNIL FREMENTAL','','','14460','COLOMBELLES',NULL,NULL,'1530914430001',188.000000000,'1976-07-12','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2068,'MOREL','FRANCIS','1950-03-01','02.33.30.47.91','06.43.61.20.38',NULL,'','','','14310','LANDES SUR AJON',NULL,NULL,'2500314319001',597.000000000,'1977-03-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2069,'ESCOLIVET','SUZANNE','1957-01-25',NULL,NULL,NULL,'2 ET 4 AVENUE DE PARIS','','','14220','GRIMBOSQ',NULL,NULL,'1570114695001',16.000000000,'1983-08-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2070,'MENOYOT','GEORGES','1958-04-27','02.25.22.73.83','06.81.34.51.95',NULL,'','','','14150','OUISTREHAM',NULL,NULL,'2580414589001',2686.000000000,'1985-05-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2071,'ROLLOT','JEAN PAUL','1930-05-24','02.38.38.26.03','06.82.74.25.48',NULL,'17 BOULEVARD DE L''AVIATION','','','14630','FRENOUVILLE',NULL,NULL,'1300514037001',121.000000000,'1953-06-29','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2072,'DUBOIS','SARAH','1930-03-21','02.30.97.19.41','06.67.35.03.21',NULL,'25 AVENUE EDITH DE BEAUMONT','','',NULL,NULL,NULL,NULL,'1300361376001',259.000000000,'1960-10-13','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2073,'PROST','MARIE THERESE','1929-01-03','02.75.42.85.74',NULL,NULL,'chemin des villiers','','','14350','ST MARTIN DES BESACES',NULL,NULL,'2290114375001',125.000000000,'1951-05-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2074,'PITON','MICHEL','1941-01-28','02.83.38.51.32','06.44.85.33.59',NULL,'46 RUE DE LA LIBERATION','','','14170','VAUDELOGES',NULL,NULL,'1410161101001',491.000000000,'1965-02-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2075,'HEBERT','','1935-12-14','02.11.55.55.58','06.42.74.96.46',NULL,'43 RUE MONSEIGNEUR ADAM','','','50470','LA GLACERIE',NULL,NULL,'2351214760001',397.000000000,'1961-06-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2076,'POREE','COLETTE','1960-02-03',NULL,NULL,NULL,'86 RUE DU SAPIN','','','14000','CAEN',NULL,NULL,'2600214190001',123.000000000,'1987-08-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2077,'BECQUET','RAYMONDE','1929-08-12','02.79.23.86.98','06.33.91.81.16',NULL,'20 avenue de l''hippodrome','','','14000','CAEN',NULL,NULL,'1290814546001',11.000000000,'1955-12-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2078,'LEMIEUX','MARCEL','1964-09-30','02.48.90.91.53','06.79.77.12.22',NULL,'19 BD DE RETHEL','','','14460','COLOMBELLES',NULL,NULL,'2640975009001',6.000000000,'1988-02-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2079,'BASSET','VIVIANE','1940-12-12','02.62.98.06.17','06.24.54.06.81',NULL,'15 PLACE DEMI LUNE','','','14670','BURES SUR DIVES',NULL,NULL,'2401207066001',691.000000000,'1962-08-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2080,'AUDOUARD','CLAUDE','1953-02-15','02.58.65.98.40','06.46.26.42.20',NULL,'CHEMIN DES BONNEMENTS','','','14123','IFS',NULL,NULL,'1530214274001',1266.000000000,'1976-11-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2081,'CATHERINE','FRANCOISE','1939-02-10','02.20.01.12.12','06.32.45.20.59',NULL,'chemin du basfond','','','14000','CAEN',NULL,NULL,'1390250558001',3.000000000,'1966-07-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2082,'FALISE','','1965-05-10','02.12.13.51.19','06.11.00.76.59',NULL,'61. rue de bretagne','','','14730','GIBERVILLE',NULL,NULL,'1650514119001',147.000000000,'1986-11-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2083,'LECESNE','GERARD',NULL,'02.97.28.58.32','06.75.30.36.82',NULL,'26 rue du dr bougault','','','50820','COUVILLE',NULL,NULL,'1310103314001',25.000000000,'2009-06-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2084,'GRIMAUX','YVES','1955-01-20','02.43.01.30.38','06.63.75.63.18',NULL,'7 rue de sude','','','14700','FALAISE',NULL,NULL,'1550114119001',76.000000000,'1977-02-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2085,'LAUNEY','MAURICE','1933-03-06','02.84.13.38.10','06.54.98.41.30',NULL,'12 RUE DU MOULIN A TAN','','','14250','LINGEVRES',NULL,NULL,'1330314176001',14.000000000,'1959-01-07','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2086,'GUINAUDEAU','GUY','1929-08-11','02.53.77.06.48','06.31.99.08.98',NULL,'3 RUE SAINT SERNIN','','','14700','FALAISE',NULL,NULL,'1290814117001',25.000000000,'1955-04-06','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2087,'VICTOIRE','JEANINE','1944-02-12','02.53.06.52.54','06.61.63.95.00',NULL,'12 rue trainerie','','','14960','ASNELLES',NULL,NULL,'1440276091001',4.000000000,'1969-11-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2088,'DUREL','ODILE','1944-03-31','02.46.54.23.40','06.59.38.06.33',NULL,'224 rue des colombes','','',NULL,NULL,NULL,NULL,'1440361103001',3.000000000,'1967-11-23','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2089,'MONTOYA-ALAYA','THERESE','1947-01-05','02.15.42.13.08','06.97.65.20.11',NULL,'9 RUE BERNARD ZAJEWSKI','','','14740','LASSON',NULL,NULL,'2470114411001',8.000000000,'1969-10-24','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2090,'HUREL','ROGER','1931-08-22','02.46.42.56.32','06.13.43.34.71',NULL,'1 RESIDENCE ST GERBOLD','','','92100','BOULOGNE BILLANCOURT',NULL,NULL,'1310814489001',63.000000000,'1959-05-02','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2091,'SCELLES','MARTINE','1932-11-04','02.22.25.38.89','06.36.37.31.46',NULL,'','','','14000','CAEN',NULL,NULL,'1321114206001',570.000000000,'1961-09-24','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2092,'JOHN','MARIE JACQUELIN','1932-07-03','02.10.91.37.90','00 33 6.33.31.32.46',NULL,'','','','14880','HERMANVILLE SUR MER',NULL,NULL,'2320750064001',102.000000000,'1961-04-19','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2093,'MERCIER','annick','1952-01-11','02.12.14.37.74',NULL,NULL,'21. RUE ALBERT GIROUX','','','27500','PONT AUDEMER',NULL,NULL,'1520114301001',693.000000000,'1975-07-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2094,'PALIWODA','CLAUDE','1934-11-12','02.11.85.70.09','06.40.38.54.90',NULL,'les perires','','','14860','BAVENT',NULL,NULL,'2341114268001',134.000000000,'1957-01-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2095,'PECATTE','ANDRE','1934-11-01','02.26.77.44.80','06.69.02.64.61',NULL,'9 rue chemin aux boeufs','','','14740','MARTRAGNY',NULL,NULL,'2341114268001',122.000000000,'1958-04-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2096,'BARRE','REMI','1937-12-18','02.74.31.84.20',NULL,NULL,'11 rue de beauvais','','','14000','CAEN',NULL,NULL,'1371254054001',32.000000000,'1959-11-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2097,'DOUCERAIN','BERNARD','1960-01-07','02.95.06.52.67','06.51.96.69.19',NULL,'7 RUE DU LAVOIR','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1600114557001',6.000000000,'1981-11-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2098,'FLAGUAIS','MICHEL','1929-06-29','02.43.63.47.35','06.11.07.53.68',NULL,'19 RUE VICTOR VENDE LA PIERRE H','EUZE','','14000','CAEN',NULL,NULL,'1290614208001',97.000000000,'1952-01-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2099,'GENDRON','SIMONE','1938-04-10','02.12.08.73.78','06.92.52.72.84',NULL,'24 av albert 1er','','','14800','DEAUVILLE',NULL,NULL,'1380414221001',25.000000000,'1959-06-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2100,'','FRANCOIS','1955-06-05','02.11.89.01.52','06.56.03.14.34',NULL,'RUE DU PARC','','','14000','CAEN',NULL,NULL,'1550614316001',168.000000000,'1979-01-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2101,'DUMAINE','THERESE','1951-07-15','02.79.59.25.89','06.34.89.54.42',NULL,'16 RUE DU 8 MAI','','','14780','LION SUR MER',NULL,NULL,'2510714734001',78.000000000,'1976-08-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2102,'SOUPLY','HELENE','1930-05-22','02.49.38.79.25','06.49.94.71.46',NULL,'ROUTE D''ARGENCES','','','14000','CAEN',NULL,NULL,'1300550316001',41.000000000,'1959-08-23','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2103,'LECOUTOUR','EUGENE','1934-12-27','02.57.20.87.91','06.15.26.05.93',NULL,'9 impasse des marettes','','','14310','LONGVILLERS',NULL,NULL,'2341214042001',84.000000000,'1955-02-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2104,'GOSSELIN','JEAN-CLAUDE','1950-01-20','02.35.35.63.94','06.63.84.00.08',NULL,'','','',NULL,NULL,NULL,NULL,'1500114320001',3.000000000,'1972-04-04','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2105,'DERIVIERE','BERNARD','1934-06-10','02.11.88.41.31','06.46.93.02.69',NULL,'4 ALLEE ALFRED JARRY','','',NULL,NULL,NULL,NULL,'2340650498001',267.000000000,'1962-08-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2106,'HAMELIN','THERESE',NULL,'02.41.02.49.79','06.97.42.27.52',NULL,'26 AVENUE DU CALVADOS','','','14370','CLEVILLE',NULL,NULL,'2360214434001',622.000000000,'2012-10-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2107,'HAMELIN','JACQUELINE','1965-06-18','02.74.38.60.41',NULL,NULL,'RES LE PARC DU MENILERAN BT A 2','AV HASTING','','14000','CAEN',NULL,NULL,'1650614319001',744.000000000,'1987-11-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2108,'SIMON','ALEXANDRE','1965-06-15','02.61.02.75.00','06.40.58.15.85',NULL,'COTE DE FIERVILLE','','','14540','BOURGUEBUS',NULL,NULL,'1650614319001',1682.000000000,'1991-03-31','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2109,'LABBE','PIERRE','1940-05-19','02.15.06.67.78','06.86.90.83.51',NULL,'3 RUE GANDHI','','','14850','HEROUVILLETTE',NULL,NULL,'2400514470001',2861.000000000,'1970-06-18','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2110,'GUILLOU','PIERRE','1937-05-29','02.72.34.15.73','06.46.29.88.83',NULL,'47 chemin de fleury','','','14390','CABOURG',NULL,NULL,'1370550046001',102.000000000,'1958-01-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2111,'GOURAND','BERNARD','1933-07-22','02.20.26.87.54','06.85.76.84.68',NULL,'chateau st gilles','','','61350','PASSAIS LA CONCEPTION',NULL,NULL,'2330714027001',26.000000000,'1956-10-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2112,'RENIER','PHILIPPE','1944-02-03','02.47.57.86.53','06.88.06.72.08',NULL,'4 rue  briere','','','14920','MATHIEU',NULL,NULL,'2440214592001',551.000000000,'1965-03-15','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2113,'SANSON','EVELYNE','1968-11-06','02.56.48.75.95','06.12.29.64.76',NULL,'21 RUE BIGANOS','','','14000','CAEN',NULL,NULL,'2681150014001',19.000000000,'1996-04-11','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2114,'TRICARD','BERNARD','1930-04-30','02.73.15.99.39','06.67.52.42.41',NULL,'CHEMIN DE COLOMBY','','','14630','CAGNY',NULL,NULL,'2300414076001',251.000000000,'1958-07-27','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2115,'VINGTROIS','ELIANE','1935-05-19','02.11.98.90.76','06.44.33.12.53',NULL,'4 rue mortemer','','','50680','MOON SUR ELLE',NULL,NULL,'2350514044001',197.000000000,'1956-02-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2116,'PELCHAT','BERNARD','1939-06-16','02.92.98.12.80','06.16.96.25.50',NULL,'','','','14000','CAEN',NULL,NULL,'1390661341001',3661.000000000,'1963-12-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2117,'RENEE','PATRICK','1930-01-16','02.88.62.34.69','06.55.34.20.23',NULL,'7 rue des pins','','','14120','MONDEVILLE',NULL,NULL,'1300114332001',372.000000000,'1953-07-26','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2118,'RIVIERE','CLAUDETTE','1943-01-17','02.80.13.67.70','06.50.20.36.74',NULL,'4 RUE DE L''EGALITE','','','14000','CAEN',NULL,NULL,'1430114459001',183.000000000,'1973-12-24','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2119,'MARIE','JEAN','1937-01-09','02.89.66.84.73','06.43.08.28.91',NULL,'7 RUE LEONARD GILLES','','','14000','CAEN',NULL,NULL,'2370161447001',810.000000000,'1959-01-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2120,'MORIN','MARIETTE','1935-08-11','02.20.23.69.64','06.13.88.20.43',NULL,'','','','14000','CAEN',NULL,NULL,'1350861486001',425.000000000,'1963-02-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2121,'LOMTATIDZE','LOUISE','1940-05-08','02.42.82.92.67','06.30.11.85.47',NULL,'3 RESIDENCE DE LA CHAPELLE','','','14120','MONDEVILLE',NULL,NULL,'2400514268001',368.000000000,'1962-09-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2122,'LEBRUN','JEAN','1928-09-14','02.11.13.89.05','06.46.27.60.74',NULL,'1 RUE DES GRANDES PATURES','','','14400','GUERON',NULL,NULL,'2280914668001',83.000000000,'1951-05-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2123,'ROCQUANCOURT','Jacqueline','1943-03-20','02.25.36.99.46','06.10.12.44.42',NULL,'10 rue de l avenir','','','14540','ROCQUANCOURT',NULL,NULL,'2430361357001',133.000000000,'1967-07-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2124,'CHEVALIER','CLAUDE','1934-03-12','02.18.57.97.94','06.31.36.63.10',NULL,'9 rue de la plaine','','','61570','BOISSEI LA LANDE',NULL,NULL,'2340314759001',25.000000000,'1955-03-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2125,'LEMAITRE','PIERRE','1935-06-20','02.87.82.00.06','00 33 6.92.58.55.07',NULL,'63 rue clos du pavillon','','','14120','MONDEVILLE',NULL,NULL,'2350624115001',1422.000000000,'1960-02-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2126,'LEMENUEL','THERESE','1964-03-01','02.35.13.47.96','06.27.02.90.66',NULL,'40 avenue albert premier','','','61100','FLERS',NULL,NULL,'2640314046001',99.000000000,'1985-06-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2127,'BREUX','ALAIN','1949-03-12','02.10.83.95.28','06.72.44.79.69',NULL,'16 rues des rames','','','75009','PARIS',NULL,NULL,'1490314703001',117.000000000,'1971-03-02','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2128,'GUESDON','LOUIS','1965-04-15','02.23.70.98.90','06.71.16.97.14',NULL,'centre de personnes agees du chu','53 bvd de la charite','','14000','CAEN',NULL,NULL,'2650414651001',590.000000000,'1988-06-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2129,'BLOSSIER','BERTRAND','1963-02-08','02.63.08.97.90','06.49.29.43.39',NULL,'7 RUE MAURICE GENEVOIX','','','14000','CAEN',NULL,NULL,'1630214654001',39.000000000,'1986-10-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2130,'LEGRAND','GILBERT','1931-03-04','02.55.85.35.29','06.29.33.10.02',NULL,'2 ROUTE DE TOURNAY','','','14540','ROCQUANCOURT',NULL,NULL,'1310350417001',378.000000000,'1957-02-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2131,'BOUET','didier','1961-01-11','02.94.84.00.46','06.20.84.76.71',NULL,'39 BOULEVARD BELLEVUE','','','14123','IFS',NULL,NULL,'2610114092001',33.000000000,'1983-05-23','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2132,'LANGEVIN','SYLVAIN','1961-01-11','02.21.42.59.78','06.52.51.60.07',NULL,'4 VILLAGE POMMENAUQUE','','','14120','MONDEVILLE',NULL,NULL,'2610114092001',1384.000000000,'1988-07-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2133,'COLLARD','JEAN','1936-12-29','02.28.37.36.46','06.71.20.24.70',NULL,'rue des anmones','','','50700','SAUSSEMESNIL',NULL,NULL,'2361214705001',159.000000000,'1961-03-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2134,'DELESTRE','MADELEINE','1965-01-23','02.11.44.29.94','06.74.01.87.31',NULL,'34 rue des mesanges','','','14260','AUNAY SUR ODON',NULL,NULL,'2650114338001',102.000000000,'1988-09-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2135,'BOMPAIN','DANIELLE','1930-04-23','02.32.72.37.65','06.45.22.90.31',NULL,'1 rue hector berlioz','','','14123','IFS',NULL,NULL,'1300414251001',473.000000000,'1958-03-14','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2136,'DENISE','MARCEL','1952-06-18','02.82.97.64.18','06.82.88.34.22',NULL,'24 RUE DE COURVAUDON','','','14610','THAON',NULL,NULL,'2520614406001',146.000000000,'1976-05-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2137,'DUPONT','GERARD','1939-06-22','02.12.13.78.88','06.24.47.99.94',NULL,'28 rue victor chautard','','','61160','CHAMBOIS',NULL,NULL,'2390614341001',26.000000000,'1965-08-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2138,'AUBERT','Michel','1952-01-24','02.12.01.59.47','06.25.53.71.10',NULL,'LE CHATEAU','','','14730','GIBERVILLE',NULL,NULL,'2520127037001',82.000000000,'1977-06-28','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2139,'BIZET','ALEXANDRE','1933-12-15','02.12.93.19.16','06.62.17.94.89',NULL,'36 RUE DU DORCET','','','14190','FIERVILLE BRAY',NULL,NULL,'2331214080001',260.000000000,'1956-08-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2140,'HALLARD','GERARD',NULL,'02.84.79.69.02','06.10.64.90.13',NULL,'2 route de chambois','','','14420','USSY',NULL,NULL,'1390114583001',372.000000000,'2009-02-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2141,'LECHIPEY','CLEMENCE','1955-01-21','02.34.61.06.08','06.46.05.48.71',NULL,'RUE ROBERT LEFEVRE','','','14400','BAYEUX',NULL,NULL,'2550185078001',9.000000000,'1982-11-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2142,'LETELLIER','YOLANDE','1929-09-07','02.10.06.53.18','06.63.62.91.67',NULL,'25 RUE DE CAMBRAI','','','14520','PORT EN BESSIN HUPPAIN',NULL,NULL,'1290914656001',490.000000000,'1959-12-03','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2143,'LETELLIER','DEBORAH','1937-03-17','02.42.15.59.47','06.92.79.75.96',NULL,'34 RUE DU GENERAL LECLERC','','','14700','FALAISE',NULL,NULL,'2370314757001',22.000000000,'1960-07-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2144,'PARIS','LILIANE','1939-07-31','02.47.58.29.47','06.10.76.45.28',NULL,'19 RUE DES FLEURS','','','14670','TROARN',NULL,NULL,'2390714327001',45.000000000,'1962-03-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2145,'ALVAREZ','LOUIS','1964-05-08','02.89.58.16.95','06.61.73.99.39',NULL,'12 AV DU 43 EME REGIMENT D''ARTIL','LERIE','','14320','FONTENAY LE MARMION',NULL,NULL,'2640514109001',346.000000000,'1988-02-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2146,'GILLES','EMMANUEL','1928-01-15','02.77.37.16.44','06.87.58.41.97',NULL,'LA BERGERIE','','','14000','CAEN',NULL,NULL,'2280161365001',131.000000000,'1958-01-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2147,'GENEST','ISABELLE','1937-04-08','02.10.66.20.17','06.30.66.64.81',NULL,'HAMEAU GIOT','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2370414678001',31.000000000,'1960-02-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2148,'FAVENNEC','GILBERT','1934-09-24','02.29.41.15.50','06.12.66.69.80',NULL,'FERME"LIEU DIT  LA CAMPAGNE"','','','14730','GIBERVILLE',NULL,NULL,'2340950494001',135.000000000,'1958-04-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2149,'MASSELIN','ERNEST','1940-02-05','02.10.41.61.41','06.42.25.41.63',NULL,'85 RUE DE FALAISE','','','14480','VILLIERS LE SEC',NULL,NULL,'1400214554001',125.000000000,'1970-05-02','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2150,'LEBRETON','Ghislain','1961-04-13','02.55.73.81.01','06.25.46.48.51',NULL,'la hogue','','','14123','IFS',NULL,NULL,'2610414610001',131.000000000,'1987-04-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2151,'DESCLOS','JEAN','1969-11-21','02.27.23.41.73','06.11.81.26.80',NULL,'106 RUE BRANVILLE','','','14000','CAEN',NULL,NULL,'1691199256001',75.000000000,'1999-01-13','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2152,'DUREL','GISELE','1929-10-28','02.48.43.42.93','06.25.27.66.03',NULL,'','','','14370','MOULT',NULL,NULL,'2291027170001',35.000000000,'1958-01-07','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2153,'LAHOUGUE','LOUISE','1949-01-06','02.89.52.87.00','06.12.31.11.16',NULL,'6/1 RUE DU RUISSEAU','','','14630','FRENOUVILLE',NULL,NULL,'2490178646001',27.000000000,'1971-08-21','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2154,'SEREE','SYLVIE',NULL,'02.36.51.55.59','06.19.27.12.76',NULL,'7 rue du chateau d eau','','',NULL,NULL,NULL,NULL,'1640914364001',0.000000000,'2009-01-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2155,'DUPONT','BERNARD','1935-09-18','02.51.32.91.54','06.57.91.84.68',NULL,'8 RUE FRED SCAMARONI','','','14370','BELLENGREVILLE',NULL,NULL,'2350914078001',233.000000000,'1958-10-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2156,'MARY','PIERRE','1935-04-24','02.69.26.38.77','06.49.21.23.84',NULL,'11 RUE DE L''ETANG','','','14123','FLEURY SUR ORNE',NULL,NULL,'1350476325001',30.000000000,'1959-06-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2157,'WION','MAURICE','1939-09-08','02.90.98.86.24','06.79.81.00.74',NULL,'28 RUE DE VERDUN','','','14400','BLAY',NULL,NULL,'2390914596001',87.000000000,'1962-02-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2158,'LEMASSON','SIMONE',NULL,'02.79.32.85.50','06.89.94.30.48',NULL,'14 rue des sablans','','','14310','MONTS EN BESSIN',NULL,NULL,'1590114213001',1010.000000000,'2010-03-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2159,'RAGOT POYET','ROBERT','1968-03-06','02.77.86.38.42','06.52.52.44.97',NULL,'le mont cauvin','','','14000','CAEN',NULL,NULL,'1680314657001',1140.000000000,'1991-01-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2160,'GUERIN','PASCALE','1937-08-24','02.35.50.77.69','06.29.65.89.83',NULL,'3 RUE DES AULMES','','','14320','FONTENAY LE MARMION',NULL,NULL,'1370814096001',248.000000000,'1959-08-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2161,'GUERIN','daniel','1931-11-16','02.36.01.59.43','06.73.83.11.32',NULL,'154 BOULEVARD LEROY','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2311114280001',12.000000000,'1958-11-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2162,'CACHARD','FRANCOISE','1935-01-16','02.11.43.05.22','06.14.33.87.19',NULL,'66 RUE DE LA GUERINIERE','','','14000','CAEN',NULL,NULL,'1350114288001',614.000000000,'1964-01-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2163,'TARRAL','DENISE','1964-11-16','02.40.54.97.12','06.61.18.52.01',NULL,'3 rue du chateau d''eau','','','14000','CAEN',NULL,NULL,'1641114118001',599.000000000,'1988-07-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2164,'HOUSSIN','DANIEL','1937-06-26','02.48.62.20.56','06.96.04.31.40',NULL,'882 CHEMIN DU VAL','','','14940','SANNERVILLE',NULL,NULL,'1370661314001',36.000000000,'1960-10-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2165,'HOUSSIN','ANNICK',NULL,'02.16.11.42.90','06.66.34.87.64',NULL,'9 RUE DES COTEAUX','','','14190','ST SYLVAIN',NULL,NULL,'2510989157001',302.000000000,'2010-06-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2166,'LEDUC','PAULETTE','1967-09-14','02.67.16.76.07','06.95.00.97.58',NULL,'22 RUE DES GENOTTES','','','14406','BAYEUX CEDEX',NULL,NULL,'1670914734001',2526.000000000,'1991-08-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2167,'LEROY','NADINE','1933-12-10','02.69.30.91.42','06.17.77.26.16',NULL,'33 BIS RUE DE LA REPUBLIQUE','','','14123','IFS',NULL,NULL,'2331214223001',548.000000000,'1959-03-26','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2168,'OUDART','JEAN CLAUDE','1962-05-13','02.63.10.13.25','06.29.10.39.50',NULL,'40 RUE VICTOR HUGO','','','14370','ARGENCES',NULL,NULL,'2620514278001',96.000000000,'1983-07-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2169,'DEGUY','FERNANDE','1963-01-05','02.50.24.35.53','06.73.43.57.71',NULL,'1 place de la libert','','','14260','CAMPANDRE VALCONGRAIN',NULL,NULL,'1630161069001',46.000000000,'1984-07-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2170,'LEFRANCOIS','THERESE','1968-12-20','02.88.55.72.52','06.67.16.24.26',NULL,'hameau de benouville','','','14400','BAYEUX',NULL,NULL,'1681261001001',158.000000000,'1990-01-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2171,'CORDIER','JACQUELINE','1948-02-03','02.37.33.06.24','06.56.63.53.84',NULL,'14 rue georges gailliard','','',NULL,NULL,NULL,NULL,'2480250154001',1417.000000000,'1969-12-11','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2172,'GODARD','MONIQUE','1933-01-03','02.23.72.21.84','06.11.48.02.27',NULL,'40 AVENUE ALFRED PIAT','','','14117','ARROMANCHES LES BAINS',NULL,NULL,'1330172111001',24.000000000,'1963-12-01','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2173,'DUREL','GRATIEN','1940-03-02','02.30.50.85.83','06.35.27.89.87',NULL,'','','','14123','IFS',NULL,NULL,'2400314042001',26.000000000,'1969-02-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2174,'FROMENT','GISELE','1936-07-15','02.98.96.92.88','06.42.66.11.18',NULL,'1 PLACE DES POMMIERS','','','14270','MEZIDON CANON',NULL,NULL,'2360750465001',39.000000000,'1965-02-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2175,'BALLIGAND','MICHEL','1932-01-18','02.81.89.00.08','06.34.53.66.71',NULL,'4 RUE DU VIVIER','','','14630','CAGNY',NULL,NULL,'1320114672001',1338.000000000,'1956-02-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2176,'LE GOVIC','SIMONE','1945-02-07','02.72.60.33.44','06.41.05.09.24',NULL,'5IMPASSE DES MARONNIERS','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1450214184001',814.000000000,'1970-09-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2177,'DUVAL','PIERRE','1938-02-26','02.11.97.68.30','06.51.86.91.28',NULL,'19 RUE JULES VERNE','','','14370','ARGENCES',NULL,NULL,'2380250198001',755.000000000,'1965-07-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2178,'MAILLARD','MAURICE','1934-10-07','02.67.97.64.64','06.85.88.62.54',NULL,'30 BIS RUE DU MILIEU','','','14530','LUC SUR MER',NULL,NULL,'2341053149001',356.000000000,'1959-12-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2179,'BELLEE','MONIQUE','1932-12-12','02.10.35.77.25','06.43.82.08.40',NULL,'2 RUE DE LA MULOISIERE','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'2321214139001',38.000000000,'1953-11-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2180,'PEUZET','PAULETTE','1940-05-04','02.51.01.31.73','06.86.90.21.39',NULL,'55 RUE DE CAEN','','','14000','CAEN',NULL,NULL,'1400550080001',305.000000000,'1961-02-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2181,'GOURAND','ANDREE','1938-05-29','02.74.75.36.24',NULL,NULL,'12 avenue Charles de Foucault','','','14000','CAEN',NULL,NULL,'1380514719001',176.000000000,'1968-11-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2182,'RETOUX','MARCEL','1938-09-03','02.89.00.29.63','06.72.67.36.19',NULL,'18 rue des merovingiens','','','14123','IFS',NULL,NULL,'2380935332001',7.000000000,'1968-12-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2183,'TROUILLARD','CLAUDE','1934-09-27','02.52.15.04.40','06.20.07.63.94',NULL,'22 ROUTE DU BUISSON','','','14480','LANTHEUIL',NULL,NULL,'1340961252001',20.000000000,'1957-02-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2184,'','JEAN','1980-06-20','02.61.85.26.10','06.27.57.57.80',NULL,'16 BIS RUE DU 8 MAI 1945','','','14000','CAEN',NULL,NULL,'2800629232001',1343.000000000,'2005-05-09','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2185,'HEUDRON','PIERRE','1939-02-03','02.11.79.29.42','06.28.92.35.91',NULL,'','','',NULL,NULL,NULL,NULL,'2390272124001',1872.000000000,'1962-05-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2186,'ROUSSEAU','RAYMONDE','1929-01-21','02.31.77.35.77','06.89.30.75.82',NULL,'LE BOURG','','',NULL,NULL,NULL,NULL,'2290150415001',55.000000000,'1955-06-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2187,'LECELLIER','HUBERT','1966-02-24','02.26.87.99.57','06.19.86.34.68',NULL,'2 AVENUE MAURICE COLLIN','','','14640','VILLERS SUR MER',NULL,NULL,'1660278440001',160.000000000,'1988-03-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2188,'LEVARD','MICHEL','1969-09-02','02.50.67.38.27','06.10.58.69.06',NULL,'1 RUE DU COMMANDANT CHARCOT','','','14730','GIBERVILLE',NULL,NULL,'2690914118001',106.000000000,'1994-09-19','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2189,'LEVRARD','PASCALE','1940-01-19','02.18.61.80.52','06.35.37.57.10',NULL,'12 RUE DES BLEUETS','','','14000','CAEN',NULL,NULL,'1400114438001',709.000000000,'1963-09-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2190,'LEZE','ROGER','1966-09-01','02.72.95.97.36','06.80.91.57.06',NULL,'22 avenue lon labb','','','14000','CAEN',NULL,NULL,'1660914524001',211.000000000,'1990-01-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2191,'SURIRAY','ANDREE','1958-01-20','02.99.50.51.65','06.15.54.53.48',NULL,'la crete','','','14123','IFS',NULL,NULL,'2580114092001',410.000000000,'1981-05-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2192,'BAZEILLE','PIERRE','1938-07-30','02.10.89.58.45','06.20.02.60.90',NULL,'27 CITE DE CAUDET','','','14123','IFS',NULL,NULL,'1380750378001',24.000000000,'1960-09-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2193,'JANET','JOSETTE','1954-05-14','02.89.31.93.42','06.24.43.17.17',NULL,'7 BIS RESIDENCE PASTEUR','','','14120','MONDEVILLE',NULL,NULL,'1540514719001',90.000000000,'1984-03-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2194,'REMOND','GASTON','1950-02-05','02.26.90.21.57','06.34.45.09.95',NULL,'6 place norge','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2500214275001',91.000000000,'1979-11-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2195,'LHOMME','GEORGES','1932-05-14','02.11.50.64.94','06.53.95.56.86',NULL,'18 ALLEE DU BOSPHORE','','','14610','ANISY',NULL,NULL,'1320514240001',91.000000000,'1960-02-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2196,'MARIE','JEAN','1950-03-16','02.11.44.16.55','06.12.29.82.81',NULL,'2, rue du Rochemer','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2500350089001',47.000000000,'1971-03-31','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2197,'TILLARD','THERESE','1939-07-06','02.51.65.36.95','06.26.09.90.40',NULL,'La fresnaie','','',NULL,NULL,NULL,NULL,'1390714258001',765.000000000,'1960-05-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2198,'PREVELLE','NICOLE','1964-10-16','02.87.63.00.45','06.72.04.28.90',NULL,'CRECY','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1641014118001',328.000000000,'1993-09-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2199,'VIRY','ALAIN','1933-02-24','02.22.59.24.63','06.58.63.55.55',NULL,'ROUTE DE MOUTIER HUBERT','','','14000','CAEN',NULL,NULL,'2330214137001',206.000000000,'1957-01-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2200,'TOUCHARD','CLAUDE','1929-10-21','02.16.74.31.86',NULL,NULL,'14 RUE DE LA POMMERAIE','','','14270','VIEUX FUME',NULL,NULL,'1291014245001',849.000000000,'1956-03-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2201,'CUSSY','CLAUDE','1929-04-25','02.69.32.89.49','06.28.71.85.97',NULL,'446 BRUYERE DE CALVILLE','','','14270','MEZIDON CANON',NULL,NULL,'1290414125001',42.000000000,'1953-02-05','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2202,'DECLEE','JEANNE','1940-08-07','02.86.92.78.08','06.99.34.12.58',NULL,'8 avenue jeanne d''arc','','','14370','BILLY',NULL,NULL,'2400869382001',43.000000000,'1961-03-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2203,'THIEBAUT','JEAN PIERRE',NULL,'02.24.53.80.59','06.84.87.66.91',NULL,'','','','50270','LES MOITIERS D''ALLONNE',NULL,NULL,'2370914486001',19.000000000,'2008-01-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2204,'LEFRANCOIS','JEAN BAPTISTE','1933-09-28','02.11.97.81.79','06.47.69.25.64',NULL,'21 AVENUE TONISVORST','','','14540','SOLIERS',NULL,NULL,'1330953199001',2853.000000000,'1954-10-15','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2205,'PERIER','JACQUELINE','1935-12-21','02.13.05.55.53','06.22.04.59.14',NULL,'RUE LES LILAS  81 RUE D''HEROUVIL','LE','',NULL,NULL,NULL,NULL,'1351214621001',818.000000000,'1959-10-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2206,'LAVAGEN','FRANCIS','1963-01-27','02.99.45.40.81','06.87.88.42.74',NULL,'5 rue j jaures','','','14220','BARBERY',NULL,NULL,'2630114038001',8.000000000,'1990-04-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2207,'GUERIN','JULES','1966-01-24','02.34.77.32.99','06.78.94.54.35',NULL,'7 IMPASSE DE LA TOUR','','',NULL,NULL,NULL,NULL,'2660150415001',21.000000000,'1989-05-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2208,'GUERIN','EMILE','1947-01-04','02.10.56.99.52','06.36.60.52.73',NULL,'5 chemin des coteaux','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1470114461001',2157.000000000,'1970-03-25','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2209,'CHAPON','PIERRE','1935-12-11','02.53.07.18.65','06.11.33.05.88',NULL,'102 RUE DE L EGLISE','','','14210','ESQUAY NOTRE DAME',NULL,NULL,'1351253008001',41.000000000,'1956-09-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2210,'DUMONT','BERNARD','1966-06-15','02.52.27.56.96','06.18.05.51.67',NULL,'4 allee alfred jarry','','','14680','GOUVIX',NULL,NULL,'1660614046001',1573.000000000,'1990-02-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2211,'MOUCHEL','DOMINIQUE','1934-07-12','02.42.17.23.94','06.64.16.17.11',NULL,'5 imp degas','','','14540','BOURGUEBUS',NULL,NULL,'2340714672001',867.000000000,'1956-03-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2212,'FLEURY','CATHERINE','1929-07-29','02.38.18.39.34','06.56.16.95.76',NULL,'3 BIS ROUTE DE VILLER','','',NULL,NULL,NULL,NULL,'1290714015001',61.000000000,'1959-08-29','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2213,'FLEURY','ROLAND','1950-01-13','02.11.29.77.08','06.83.88.66.33',NULL,'64 rue de falaise','','','14000','CAEN',NULL,NULL,'2500114123001',7.000000000,'1974-02-19','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2214,'LELIEVRE','MONIQUE','1961-01-24','02.10.86.37.05','06.26.39.40.59',NULL,'7 rue de la vierge','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2610114495001',177.000000000,'1990-05-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2215,'ETIENNE','NADJA','1932-11-17','02.16.50.52.99','06.38.02.14.15',NULL,'19 RUE ABBE RICHARD','','','14310','VILLERS BOCAGE',NULL,NULL,'1321114377001',34.000000000,'1954-11-01','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2216,'MANGEANT','ROGER','1934-07-27','02.35.29.02.66','06.51.00.28.76',NULL,'LE CHESNAY ROUTE DE L AIGLE','','','14730','GIBERVILLE',NULL,NULL,'2340761307001',72.000000000,'1958-10-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2217,'BARBOTTE','ANDRE','1939-05-18','02.77.22.96.99','06.77.95.11.27',NULL,'8 RUE DE L''UNION','','','14790','VERSON',NULL,NULL,'2390550236001',187.000000000,'1966-07-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2218,'LECHASLES','CHRISTIAN','1940-10-08','02.34.95.53.00','06.43.66.99.12',NULL,'7 RUE DES PINCONS','','',NULL,NULL,NULL,NULL,'1401050435001',48.000000000,'1967-08-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2219,'JEANNE','ANDRE','1939-08-06','02.53.24.16.65','06.99.87.82.61',NULL,'47 RUE DU 4 JUILLET 1944','','','14000','CAEN',NULL,NULL,'2390814251001',277.000000000,'1965-12-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2220,'GALLET','PAUL','1965-02-19','02.29.65.14.46','06.46.03.20.71',NULL,'8 RUE DU PALAIS DE JUSTICE','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'1650214208001',116.000000000,'1987-07-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2221,'LAMARRE','MARIE CLAUDE','1970-03-10','02.52.45.68.62','06.46.38.04.15',NULL,'174 ROUTE DE BRETAGNE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1700314763001',5.000000000,'2000-11-18','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2222,'JEANNE','CLAUDE','1939-09-10','02.41.07.79.51','06.27.71.61.90',NULL,'5 IMPASSE DES BARONNIERS','','','14750','ST AUBIN SUR MER',NULL,NULL,'1390953143001',44.000000000,'1969-10-29','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2223,'MARGUILLIER','JEAN CLAUDE',NULL,'02.35.54.62.19','06.62.22.54.98',NULL,'','','','14140','LIVAROT',NULL,NULL,'2410161186001',728.000000000,'2010-02-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2224,'BERNADA','JEAN CLAUDE','1935-08-30','02.72.90.53.49','06.80.90.02.47',NULL,'2 rue des aubepines RESIDENCE L','E RONCERAY','','14150','OUISTREHAM',NULL,NULL,'2350814044001',91.000000000,'1956-12-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2225,'AMAURY','JEAN LUC','1959-10-29','02.55.37.28.92','06.87.67.26.17',NULL,'77 RUE DU CHEMIN VERT','','','14000','CAEN',NULL,NULL,'2591014463001',187.000000000,'1981-08-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2226,'LECARPENTIER','SYLVIE','1942-01-18','02.10.18.48.72','06.16.76.73.87',NULL,'24 RUE DU BOIS DE CLAQUET','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1420150487001',499.000000000,'1963-06-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2227,'HEMERY','','1934-06-07','02.11.56.59.13','06.86.45.09.51',NULL,'65 rue monseigneur adam','','','14190','ST SYLVAIN',NULL,NULL,'1340650319001',1269.000000000,'1956-10-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2228,'GERARD','eugene','1939-08-10','02.51.31.69.24','06.90.77.24.29',NULL,'9 RUE DU LAVOIR','','','14000','CAEN',NULL,NULL,'2390850554001',13.000000000,'1960-07-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2229,'FRANCOIS','FRANCINE','1942-04-11','02.50.62.43.72','06.58.59.87.73',NULL,'2 PLACE DES GENETS','','','50160','TORIGNI SUR VIRE',NULL,NULL,'1420414486001',49.000000000,'1963-08-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2230,'ROSSIGNOL','JEAN-PIERRE',NULL,'02.47.05.18.98','06.80.60.77.59',NULL,'12 rue d hulsinki','','','14630','CAGNY',NULL,NULL,'2370714657001',170.000000000,'2013-04-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2231,'MAGNIEN','MARIUS','1957-03-31','02.69.84.59.31','06.66.04.16.82',NULL,'13 PROMENADE DU FORT','','',NULL,NULL,NULL,NULL,'1570314328001',3513.000000000,'1984-02-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2232,'AUVRAY','PAULETTE','1938-04-07','02.11.70.65.84','06.94.57.76.53',NULL,'','','','14000','CAEN',NULL,NULL,'2380414758001',91.000000000,'1960-01-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2233,'DAVID','JACQUES','1938-09-18','02.87.90.60.05','06.10.34.37.17',NULL,'98 rue des roches','','',NULL,NULL,NULL,NULL,'1380950031001',899.000000000,'1961-05-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2234,'BACHELOT','NOELLE','1946-04-29','02.78.93.67.21','06.89.27.39.41',NULL,'','','','14000','CAEN',NULL,NULL,'1460408481001',36.000000000,'1974-01-07','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2235,'QUESNOT','annick','1928-04-20','02.50.83.09.29','06.71.11.49.50',NULL,'9 ALLEE DES PAINS GRIS','','','14680','CINTHEAUX',NULL,NULL,'1280461370001',258.000000000,'1951-07-02','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2236,'MORIN','YVETTE','1931-09-09','02.44.75.36.97','06.10.43.77.94',NULL,'LA BRIQUETERIE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2310914676001',420.000000000,'1961-03-04','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2237,'EMILE','DANY','1968-01-20','02.23.07.32.23','06.46.64.19.16',NULL,'EPINAY S/ ODON','','','14120','MONDEVILLE',NULL,NULL,'2680114437001',9.000000000,'1989-02-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2238,'MORIN','MARIE ROSE','1938-09-20','02.35.06.36.38','06.10.66.13.46',NULL,'RUE PIERRE ARTHUS','','','14620','FOURCHES',NULL,NULL,'2380914364001',189.000000000,'1960-01-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2239,'TROUVE','PIERRE','1937-09-04','02.11.03.43.84','06.31.26.33.70',NULL,'29 RUE CHAUSSEE','','','50120','EQUEURDREVILLE HAINNEVILLE',NULL,NULL,'1370950045001',37.000000000,'1965-11-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2240,'TROUVE','DANIEL','1950-02-27','02.80.94.69.58','06.37.84.07.13',NULL,'','','','14460','COLOMBELLES',NULL,NULL,'2500214010001',427.000000000,'1972-03-21','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2241,'','REMY','1940-08-26','02.35.90.43.38','06.83.55.38.31',NULL,'15 PLACE DE LA RESISTANCE','','','14123','IFS',NULL,NULL,'1400814211001',113.000000000,'1969-02-08','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2242,'MARIE','ERIC','1963-04-07','02.22.63.22.66','06.11.10.85.38',NULL,'3 rue gabriel dupont','','','61440','ST ANDRE DE MESSEI',NULL,NULL,'2630414712001',2845.000000000,'1985-07-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2243,'LE BUGLE','JEANNINE','1933-07-02','02.17.28.04.81','06.64.15.35.54',NULL,'','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2330750054001',1.000000000,'1960-07-18','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2244,'SAILLENFEST','JEAN PIERRE','1963-12-08','02.34.91.39.20','06.19.53.59.92',NULL,'14 RUE DE LA MARNE','','','14490','BALLEROY',NULL,NULL,'1631299253001',320.000000000,'1986-02-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2245,'TANQUEREL','ANDREE','1938-01-09','02.94.72.74.52',NULL,NULL,'8 RUE LEONARD GILLES','','','61160','MONT ORMEL',NULL,NULL,'1380153215001',185.000000000,'1968-07-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2246,'SUZANNE','MARIE HELENE','1939-04-29','02.89.84.07.37','06.29.97.67.00',NULL,'28 RUE DE L''ANCIENNE GARE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2390414200001',32.000000000,'1968-03-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2247,'CORBEAU','CAMILLE','1936-07-09','02.56.92.24.47','06.38.53.85.88',NULL,'9 4 CITEE DES ROCHES','','','14700','FALAISE',NULL,NULL,'1360714190001',461.000000000,'1960-10-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2248,'CRENEL','MICHEL','1931-04-01','02.34.55.49.45','06.14.14.44.21',NULL,'8 RUE DES CAPUCINES','','','14210','LE LOCHEUR',NULL,NULL,'1310414622001',7.000000000,'1953-02-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2249,'CORDIER','MADELEINE',NULL,'02.44.32.77.88','06.47.53.97.58',NULL,'4 RUE  DU HAUT SEVER','','','14000','CAEN',NULL,NULL,'1351076019001',1237.000000000,'2011-09-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2250,'VASSE','MICHEL','1931-08-03','02.38.21.64.37','06.85.32.34.54',NULL,'98 rue branville bat c','','','14730','GIBERVILLE',NULL,NULL,'1310814411001',280.000000000,'1955-05-09','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2251,'DESJOUIS','JEAN','1935-02-09','02.50.85.58.58','06.72.33.10.88',NULL,'20 RUE DE LA MOINERIE','','','14000','CAEN',NULL,NULL,'2350214271001',27.000000000,'1956-06-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2252,'DONGE','Janine','1949-06-05','02.19.86.00.73','06.21.14.70.61',NULL,'3 RUE DES HAUTS VENTS','','','14000','CAEN',NULL,NULL,'1490614002001',43.000000000,'1979-09-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2253,'HOUGUET','RACHEL','1939-04-27','02.20.46.19.99','06.45.85.90.40',NULL,'1 RUE DES FOURS','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1390450404001',132.000000000,'1963-06-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2254,'','DANIEL','1968-01-04','02.40.77.50.58','06.48.88.66.20',NULL,'LE HAM','','','14320','LAIZE LA VILLE',NULL,NULL,'1680114245001',1524.000000000,'1993-11-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2255,'SABINE','DANIEL','1931-04-15','02.99.86.85.69','06.85.88.27.01',NULL,'22 RUE PASTEUR','','','14250','TESSEL',NULL,NULL,'1310414751001',183.000000000,'1955-04-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2256,'DUCREUX','HERVE','1967-05-29','02.33.47.63.30','06.86.83.15.37',NULL,'9 rue des pins','','','14000','CAEN',NULL,NULL,'1670550252001',200.000000000,'1996-12-24','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2257,'MARIE','MONIQUE','1968-06-22','02.33.99.73.74',NULL,NULL,'','','','14130','ST GATIEN DES BOIS',NULL,NULL,'1680614005001',10.000000000,'1989-04-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2258,'ANJOU','SYLVIE','1934-05-17','02.76.02.64.13','06.67.89.28.09',NULL,'4 RUE DU PRESIDENT COTY','','','14120','MONDEVILLE',NULL,NULL,'2340514145001',75.000000000,'1956-01-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2259,'VERHAEGUE','ILQAR','1955-07-04','02.26.47.68.33','06.10.46.08.77',NULL,'98 rue branville bat c','','','14440','CRESSERONS',NULL,NULL,'2550714313001',97.000000000,'1977-09-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2260,'HEUDE','','1934-02-17','02.48.90.94.92','06.65.87.50.76',NULL,'16 RUE DE LA REFORME','','','14440','CRESSERONS',NULL,NULL,'1340214090001',290.000000000,'1960-04-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2261,'PROVOST','JEANNE','1959-05-03','02.23.23.54.81','06.12.13.41.63',NULL,'15 AVENUE COMMANDANT KIEFFER','','','14840','CUVERVILLE',NULL,NULL,'1590578576001',1577.000000000,'1980-01-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2262,'DECAN','DANIEL',NULL,'02.74.42.84.89',NULL,NULL,'7 RUE DE CABOURG','','','14111','LOUVIGNY',NULL,NULL,'2390661168001',500.000000000,'2012-02-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2263,'ARIBAUT','DANIEL','1958-07-23','02.67.61.15.67','06.59.97.53.64',NULL,'1 RUE GEORGES SICOT RESIDENCE E','DENVERT','','14460','COLOMBELLES',NULL,NULL,'2580714118001',21.000000000,'1986-08-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2264,'EPHIMOFF','MICHELINE','1934-05-01','02.11.13.69.55','06.13.69.25.16',NULL,'1 LOTISSEMENT  LES BIGNETTES','','','14320','FONTENAY LE MARMION',NULL,NULL,'2340514327001',7.000000000,'1956-10-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2265,'HERBERT','LEONE','1933-03-02','02.47.83.59.84','06.54.31.56.43',NULL,'26. rue d arromanches','','','14260','MONTAMY',NULL,NULL,'1330361278001',98.000000000,'1954-08-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2266,'GROULT','LEONNE','1935-03-25','02.58.40.13.85','06.71.21.51.49',NULL,'HAMEAU LE PUANT','','','14730','GIBERVILLE',NULL,NULL,'1350314617001',650.000000000,'1956-08-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2267,'FOUQUET','PIERRE','1949-01-28','02.11.97.98.81','06.14.41.03.74',NULL,'5 RUE PASTEUR','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2490114218001',41.000000000,'1972-06-15','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2268,'MARIE','NICOLE','1934-09-27','02.79.68.53.44','06.35.62.79.34',NULL,'','','','14123','FLEURY SUR ORNE',NULL,NULL,'2340914109001',624.000000000,'1955-07-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2269,'BILLARD','PAULETTE','1912-07-08','02.35.25.25.53','06.10.29.05.43',NULL,'','','','14000','CAEN',NULL,NULL,'1120750423001',13.000000000,'1938-01-18','GOLD',24,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2270,'PISLARD','Marcel','1963-06-01','02.29.36.94.38','06.69.83.45.70',NULL,'15 RUE DE BROCELIANDE','','','14600','LA RIVIERE ST SAUVEUR',NULL,NULL,'2630614208001',297.000000000,'1990-12-29','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2271,'THOMAS','CECILE','1956-01-15','02.29.03.34.78','06.30.22.09.75',NULL,'4 RUE DES PRIMEVERES','','','14400','BAYEUX',NULL,NULL,'2560114149001',190.000000000,'1977-01-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2272,'HEDOU','YVETTE','1938-01-30','02.23.38.48.17','06.83.14.83.29',NULL,'138 AVENUE HENRY CHERON','','','14000','CAEN',NULL,NULL,'1380114319001',5.000000000,'1968-08-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2273,'MARIE','NICOLE','1969-07-22','02.75.26.07.18','06.73.13.16.96',NULL,'1201 QUARTIER DU BOIS','','','14123','IFS',NULL,NULL,'1690714109001',41.000000000,'1995-03-28','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2274,'VILLEDIEU','YVETTE','1945-03-01','02.60.67.46.91','06.38.53.93.35',NULL,'31 route de paris','','','14120','MONDEVILLE',NULL,NULL,'1450314181001',100.000000000,'1968-01-20','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2275,'LEBUNETEL','MONIQUE','1933-06-13','02.17.42.10.51','06.72.00.84.30',NULL,'18 route des quatres puits','','','14000','CAEN',NULL,NULL,'2330650483001',345.000000000,'1963-02-26','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2276,'PETIT','ELIANE','1966-07-06','02.24.77.30.01','06.51.52.10.36',NULL,'13 rue carpoilier','','','14360','TROUVILLE SUR MER',NULL,NULL,'1660714493001',88.000000000,'1988-06-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2277,'COURSIER','JEANINE','1939-03-16','02.15.38.08.02','06.37.48.43.33',NULL,'LE MOULIN','','','14000','CAEN',NULL,NULL,'2390355543001',3208.000000000,'1961-08-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2278,'MARGUERITE','ALBERT','1928-08-03','02.21.80.50.46','06.25.35.69.52',NULL,'19 BD MARECHAL LYAUTEY','','','14000','CAEN',NULL,NULL,'2280814635001',1903.000000000,'1953-02-05','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2279,'VAVASSEUR','DENISE','1954-01-05','02.80.37.04.14','06.10.59.37.79',NULL,'LA FERME DES CERISIERS','','','14000','CAEN',NULL,NULL,'1540127413001',19.000000000,'1979-08-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2280,'DESHAYES','ANITA','1946-04-27','02.10.51.84.10','06.10.03.28.05',NULL,'30 RUE DES FRERES WILKIN','','','50360','PICAUVILLE',NULL,NULL,'2460414760001',1663.000000000,'1971-03-24','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2281,'DESHAYES','guy','1933-11-20','02.65.57.27.15','06.40.09.75.26',NULL,'21 AVENUE DE THIES','','','50150','SOURDEVAL',NULL,NULL,'2331114150001',38.000000000,'1962-09-01','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2282,'LECONTE','MARY','1936-11-19','02.11.99.18.74',NULL,NULL,'1 chemin de l arbre favee','','','14310','VILLERS BOCAGE',NULL,NULL,'1361114139001',73.000000000,'1963-10-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2283,'DORNIOL','MAURICE','1932-10-19','02.82.59.37.16','06.35.05.62.31',NULL,'17 RUE DU PORT','','','14390','PETIVILLE',NULL,NULL,'1321050275001',84.000000000,'1960-10-04','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2284,'LEMARECHAL','DANIEL','1937-02-24','02.49.89.50.91','06.13.65.95.00',NULL,'14 RUE DU PETIT PARC','','','14400','CONDE SUR SEULLES',NULL,NULL,'1370227547001',57.000000000,'1964-03-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2285,'JULIEN','RENEE','1931-04-04','02.65.42.12.04','06.57.31.06.43',NULL,'1034 Quartier des Belles Portes','','','14190','ST SYLVAIN',NULL,NULL,'2310472239001',277.000000000,'1954-09-24','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2286,'TERRY','MICHELE','1929-10-17',NULL,NULL,NULL,'22 RUE JEAN LECOUTURIER','','','14000','CAEN',NULL,NULL,'1291014556001',135.000000000,'1959-11-05','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2287,'LEPETIT','CLAUDE','1938-09-21','02.11.04.78.84','06.37.62.90.50',NULL,'12 AVENUE DE L''EPINAY','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1380914475001',27.000000000,'1964-03-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2288,'BIHEL','DANIEL','1955-01-10','02.29.61.97.52','06.98.42.83.39',NULL,'4 RUE DES ECOLES','','','14330','STE MARGUERITE D''ELLE',NULL,NULL,'2550150166001',806.000000000,'1982-06-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2289,'GOMOND','JACQUELINE','1962-04-24','02.14.85.50.95','06.10.16.60.55',NULL,'65 CHEMIN DU VAL','','','14940','SANNERVILLE',NULL,NULL,'1620478107001',98.000000000,'1990-05-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2290,'PIROU','JACQUELINE','1939-03-12','02.69.80.41.33','06.10.11.77.01',NULL,'11 rue urbain lefrancois','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1390314066001',1.000000000,'1968-04-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2291,'FESTOC','GINETTE','1931-02-16','02.10.56.33.67','06.32.89.67.03',NULL,'50 RUE DU MILIEU','','','14000','CAEN',NULL,NULL,'2310214557001',118.000000000,'1953-06-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2292,'TISON','YVES','1935-04-29','02.39.28.95.05','06.90.06.47.47',NULL,'5 RUE JEAN MOULIN','','','14210','CHEUX',NULL,NULL,'1350476325001',168.000000000,'1962-12-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2293,'POREY','JEAN','1934-02-25','02.40.72.62.46','06.10.57.45.34',NULL,'','','','14100','ST MARTIN DE MAILLOC',NULL,NULL,'2340214388001',1.000000000,'1956-06-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2294,'DUFOUR','MICHEL','1933-08-22','02.17.87.59.16','06.30.52.01.73',NULL,'9 RUE ROGER BASTION','','','14000','CAEN',NULL,NULL,'2330814669001',38.000000000,'1957-05-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2295,'VERITE','HENRIETTE','1940-12-29','02.97.03.46.65','06.10.51.96.80',NULL,'2 bis rue des jardins','','','14670','TROARN',NULL,NULL,'2401278208001',1644.000000000,'1964-04-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2296,'CHEVREUIL','BERNARD','1963-05-29','02.91.37.33.18','06.48.71.12.04',NULL,'22 RUE DU MANOIR','','','14630','FRENOUVILLE',NULL,NULL,'1630572141001',194.000000000,'1990-06-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2297,'GAUTIER','MONIQUE','1932-12-23','02.33.17.41.20','06.70.63.48.88',NULL,'5 RUE DE L''ANGELUS','','','14370','ARGENCES',NULL,NULL,'1321214678001',12.000000000,'1953-03-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2298,'MANSOURI','DANIEL','1950-01-10','02.11.95.37.51','06.10.83.37.85',NULL,'1 bis rue du marais','','',NULL,NULL,NULL,NULL,'2500156073001',24.000000000,'1976-11-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2299,'CORDIER','CAROLE','1934-03-01','02.52.79.25.54','06.27.08.95.48',NULL,'7 RUE JACQUES NOURRY','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2340314693001',846.000000000,'1964-02-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2300,'BELLENGER','RENE','1956-12-21','02.89.17.63.35','06.10.37.27.12',NULL,'1 RUE DE SAVOIE','','','14210','STE HONORINE DU FAY',NULL,NULL,'2561214657001',3686.000000000,'1981-08-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2301,'THOMASSE','JEAN MARC','1929-07-12','02.89.76.42.84','06.39.43.87.59',NULL,'1 rue roger dechambre','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'1290714714001',25.000000000,'1955-12-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2302,'MARGERIE','ANDRE','1930-03-27','02.35.96.21.10','06.15.76.85.92',NULL,'7 RUE JEAN ADIGARD DES GAUTRIS','','','14860','BAVENT',NULL,NULL,'2300390010001',19.000000000,'1956-12-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2303,'DELASALLES','DANIEL','1930-05-11','02.99.09.41.63','06.11.90.94.45',NULL,'35 RUE GAMBETTA','','','14670','JANVILLE',NULL,NULL,'1300514221001',339.000000000,'1960-03-09','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2304,'DAIGREMONT','','1937-02-01','02.28.19.44.32','06.89.61.30.45',NULL,'25 rue vandecandelaere','','','14740','LASSON',NULL,NULL,'2370250435001',215.000000000,'1963-10-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2305,'HODIESNE','DANIEL','1960-01-28','02.48.75.50.91','06.10.05.51.58',NULL,'3 RUE DE LA MARJOLAINE','','','14123','IFS',NULL,NULL,'2600150504001',293.000000000,'1988-03-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2306,'SUARD','JEAN CLAUDE','1934-05-16','02.42.36.71.16','06.37.14.44.09',NULL,'22 BIS RUE JOSEPH LEVILLY','','','14800','DEAUVILLE',NULL,NULL,'2340550098001',20.000000000,'1959-04-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2307,'SUARD','MAURICE','1937-07-31','02.22.23.98.31','06.37.44.68.80',NULL,'11 RUE DES DENTELLIERES','','','14000','CAEN',NULL,NULL,'1370714266001',126.000000000,'1958-04-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2308,'PASQUET','PIERRE','1947-03-17','02.24.11.37.70','06.57.29.93.13',NULL,' 8 IMPASSE DES DAINS LES ORCHIDE','ES','','14430','DOZULE',NULL,NULL,'1470314009001',16.000000000,'1977-03-12','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2309,'','MAURICE','1956-01-25','02.10.27.92.43','06.45.26.32.56',NULL,'LA GRURIE','','','14480','COULOMBS',NULL,NULL,'2560114623001',23.000000000,'1980-06-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2310,'PITEL','LUCIEN','1958-07-05','02.58.14.50.53','06.26.16.07.98',NULL,'1 rue abbe boudier','','',NULL,NULL,NULL,NULL,'2580714263001',509.000000000,'1982-03-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2311,'HENRIETTE','CHANTAL','1932-11-15','02.20.82.08.93','06.22.06.99.92',NULL,'13 rue de ros','','','14000','CAEN',NULL,NULL,'1321114672001',1.000000000,'1953-05-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2312,'LEROUVILLOIS','JANINE','1962-01-09','02.42.82.45.15','06.77.72.15.96',NULL,'LE BOURG','','','14940','TOUFFREVILLE',NULL,NULL,'2620114221001',849.000000000,'1983-11-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2313,'BURET','MONIQUE','1932-02-23','02.51.13.72.82','06.53.46.51.97',NULL,'2 ALLEE DES MESANGES LES BREOL','ES','','14000','CAEN',NULL,NULL,'2320235314001',57.000000000,'1959-06-19','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2314,'MECHIN','PAULINE','1966-11-21','02.61.88.59.79','06.12.06.01.30',NULL,'8 RUE JULES GUESDE','','','14480','CREULLY',NULL,NULL,'2661114376001',986.000000000,'1995-04-18','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2315,'CHAUVEAU','JOSELYNE','1978-06-20','02.19.84.14.48','06.64.44.40.35',NULL,'ALLEE DU VIEUX COLOMBIER','','','14000','CAEN',NULL,NULL,'2780699249001',215.000000000,'2005-05-23','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2316,'HUET','CORINNE','1937-10-26','02.88.41.69.84','06.89.84.56.98',NULL,'la bruyere','','','14120','MONDEVILLE',NULL,NULL,'1371050225001',190.000000000,'1965-05-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2317,'BARBE','JEANNE','1939-05-29','02.23.29.61.85','06.52.02.08.09',NULL,'33 rue emile bouguns','','','14000','CAEN',NULL,NULL,'2390514341001',820.000000000,'1968-10-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2318,'MARTIGNY','EMMANUELLE','1954-01-08','02.73.64.01.02','06.30.40.95.00',NULL,'42 AVENUE DU MONT ST MICHEL','','','14990','BERNIERES SUR MER',NULL,NULL,'1540170439001',540.000000000,'1984-11-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2319,'TOUTAIN','MARCEL','1938-12-12','02.57.36.17.48','06.73.86.49.28',NULL,'30 AVENUE DES MARRONNIERS','','','14990','BERNIERES SUR MER',NULL,NULL,'1381250592001',177.000000000,'1959-11-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2320,'FOULIARD','YVES','1928-03-20','02.13.00.38.50','06.26.17.65.59',NULL,'22 RUE NICOLAS COPERNIC','','','14000','CAEN',NULL,NULL,'1280361116001',719.000000000,'1956-03-22','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2321,'GAUMERD','ANDRE','1947-08-14','02.32.00.39.72','06.67.64.95.84',NULL,'7 RUE GUSTAVE FLAUBERT','','','14370','MOULT',NULL,NULL,'1470814657001',420.000000000,'1974-11-27','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2322,'EUDELINE','BERNARD','1931-08-06','02.11.56.97.37','06.29.90.49.80',NULL,'RUE DE LA MER','','','14370','MERY CORBON',NULL,NULL,'1310861505001',171.000000000,'1956-03-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2323,'KERIMOV','NATHALIE','1932-10-28','02.16.40.02.96','06.46.18.98.27',NULL,'HAMEAU LE MESNIL ROGER','','','14000','CAEN',NULL,NULL,'2321014662001',793.000000000,'1956-05-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2324,'ROMEA','DOMINIQUE','1940-03-26','02.29.00.70.00','06.16.23.43.41',NULL,'42 rue de luc','','','14630','FRENOUVILLE',NULL,NULL,'2400314722001',1.000000000,'1969-04-27','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2325,'BACON','DANIEL','1951-05-29','02.44.60.45.24','06.51.37.41.42',NULL,'12 RUE LOUIS BALLIERE','','','14000','CAEN',NULL,NULL,'2510514248001',313.000000000,'1976-03-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2326,'DECAN','JEAN LOUIS','1936-07-11','02.39.07.85.24','06.90.95.70.75',NULL,'5 VALLEE BOQUET','','','14000','CAEN',NULL,NULL,'1360714525001',62.000000000,'1964-12-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2327,'HAMEL','JULES','1934-09-01','02.69.34.65.08','06.85.18.36.00',NULL,'4 RUE LOUIS ARAGON','','','14120','MONDEVILLE',NULL,NULL,'1340914164001',1405.000000000,'1958-10-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2328,'MARIE','ANNICK','1959-01-09','02.52.62.42.66','06.84.73.61.45',NULL,'35 rue aristide briand','','','14500','VIRE',NULL,NULL,'1590114590001',52.000000000,'1983-04-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2329,'GAUTIER','DANIEL','1974-06-30','02.77.83.85.78','06.73.88.06.35',NULL,'la nouette de bas','','','14150','OUISTREHAM',NULL,NULL,'2740614118001',1851.000000000,'2002-04-14','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2330,'DESHAYES','RAYMONDE','1940-08-07','02.66.41.90.68','06.60.31.91.09',NULL,'22 rue du berry','','','14390','CABOURG',NULL,NULL,'2400849229001',45.000000000,'1965-03-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2331,'POISSON','YVETTE',NULL,'02.44.23.17.28','06.54.35.04.42',NULL,'FOYER HENRI DUNANT 15 RUE GUILL','AUME TREBUTIEN','','14450','GRANDCAMP MAISY',NULL,NULL,'1310614332001',503.000000000,'2009-11-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2332,'GERVAIS','PAUL','1964-01-18','02.22.25.51.48','06.29.61.38.87',NULL,'COMMES ESCLURES','','','14000','CAEN',NULL,NULL,'2640161478001',1022.000000000,'1992-06-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2333,'PANEL','ROGER','1950-01-22','02.70.47.34.19','06.44.73.84.87',NULL,'20 RUE DU 8 MAI','','','14490','BALLEROY',NULL,NULL,'2500150355001',11.000000000,'1974-04-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2334,'OZANNE','BERNARD','1936-03-09','02.10.59.06.41','06.27.08.13.60',NULL,'12 RUE LOUIS ROBILLARD','','','14000','CAEN',NULL,NULL,'2360350239001',35.000000000,'1966-10-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2335,'BABILONI','JOSIANE','1928-03-31','02.52.05.20.94','06.51.66.50.71',NULL,'1 RUE DES MENUYERES','','','14000','CAEN',NULL,NULL,'1280314327001',292.000000000,'1954-08-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2336,'DUMONT','ANDRE','1954-03-17','02.10.81.11.99','06.69.98.06.88',NULL,'16 bis rue de l''epinette','','','14000','CAEN',NULL,NULL,'2540350493001',84.000000000,'1977-10-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2337,'LEROSSIGNOL','SYLVIE','1937-12-23','02.65.53.39.10','06.88.42.61.28',NULL,'','','','14000','CAEN',NULL,NULL,'2371214067001',1220.000000000,'1961-08-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2338,'LECELLIER','BERNARD','1941-01-28','02.87.31.30.26','06.85.27.47.95',NULL,'3/3 rue des champs fleuris','','','14790','VERSON',NULL,NULL,'1410114513001',309.000000000,'1968-11-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2339,'COMBA','ANDREE','1956-01-15','02.28.88.57.79','06.16.21.98.13',NULL,'','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1560114301001',41.000000000,'1982-02-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2340,'','JEANNE','1970-03-02','02.43.63.53.18','06.18.37.57.05',NULL,'','','','14320','MAY SUR ORNE',NULL,NULL,'2700327050001',1240.000000000,'1993-10-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2341,'ROUSSELET','CHRISTIANE','1937-11-28','02.81.04.13.01','06.23.37.94.67',NULL,'50 CHEMIN DE LA FOSSE MERBOIS','','','14000','CAEN',NULL,NULL,'2371114221001',22.000000000,'1962-01-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2342,'LEFRANCOIS','','1943-03-02','02.10.33.18.21','06.35.82.45.81',NULL,'LE CERISIER DU NORD','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1430314212001',2.000000000,'1968-07-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2343,'TILLAUT','MARCEL EUGENE','1931-01-25','02.46.18.00.69','06.82.68.62.06',NULL,'8 RUE FELIX BOUFFAY','','','14000','CAEN',NULL,NULL,'2310176709001',359.000000000,'1960-03-08','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2344,'VAUVARIN','JEANNINE','1931-10-08','02.54.33.56.53','06.48.56.29.46',NULL,'12 RUE DU BEL AIR','','','14220','THURY HARCOURT',NULL,NULL,'2311050121001',103.000000000,'1953-11-04','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2345,'HELD','FERNANDE','1968-01-25','02.75.27.51.46','06.27.78.27.69',NULL,'30 RUE DU MANOIR','','','14220','CULEY LE PATRY',NULL,NULL,'1680114365001',508.000000000,'1989-07-29','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2346,'MELINOU','DANIEL','1939-01-19','03.35.47.84.89','06.28.05.54.96',NULL,'5 RUE DES HAIES VIVES','','','71260','LUGNY',NULL,NULL,'1390114007001',3444.000000000,'1968-03-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2347,'THETIOT','','1939-03-05','02.78.77.71.13','06.87.50.59.65',NULL,'18 rue albert bayet','','','14000','CAEN',NULL,NULL,'1390350147001',26.000000000,'1969-03-27','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2348,'LIARD','CLAUDINE','1954-02-17','02.69.84.98.99','06.56.87.70.71',NULL,'1 RUE JEAN MERMOZ','','','14220','CULEY LE PATRY',NULL,NULL,'2540261308001',1.000000000,'1984-06-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2349,'BINOIST','ANNE MARIE','1960-04-08','02.18.55.36.75','06.12.80.41.68',NULL,'9 SQUARE MARCEL PAGNOL','','','14000','CAEN',NULL,NULL,'2600461051001',4782.000000000,'1990-03-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2350,'MORAND','MARTINE','1938-08-15','02.87.11.08.46','06.35.18.14.40',NULL,'RUE HENRI BRUNET','','','14740','MARTRAGNY',NULL,NULL,'1380814225001',429.000000000,'1960-10-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2351,'BERTHELOT','JULIEN','1929-09-17','02.64.35.24.84','06.41.37.98.46',NULL,'21 BIS PERE CHARLES DE FOUCAULT','','','14150','OUISTREHAM',NULL,NULL,'2290914126001',31.000000000,'1952-02-20','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2352,'MARTIN','JEANINE','1929-07-31','02.66.17.93.20','06.55.03.87.05',NULL,'1 TER CHEMIN DU LONG BOIS','','','14000','CAEN',NULL,NULL,'2290714376001',841.000000000,'1950-05-24','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2353,'JOYEUX','GISELE','1942-11-07','02.45.75.15.81','06.44.31.74.47',NULL,'15 rue de la crte','','','14860','BAVENT',NULL,NULL,'2421177214001',1322.000000000,'1968-10-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2354,'AUBRY','BERNARD','1931-05-23','02.10.12.75.95','06.11.81.63.99',NULL,'17 rue de la bruyre','','','14260','AUNAY SUR ODON',NULL,NULL,'1310514040001',710.000000000,'1952-01-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2355,'CERE','LAURENCE','1933-12-27','02.94.21.50.68','06.12.57.48.26',NULL,'6 rue du valle','','','14370','BELLENGREVILLE',NULL,NULL,'1331214664001',116.000000000,'1954-09-29','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2356,'QUETRON','MARY','1934-11-16','02.13.10.21.85','06.11.63.41.20',NULL,'7 COTE DU MESNIL','','','50860','SOULLES',NULL,NULL,'1341178650001',1874.000000000,'1955-04-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2357,'MIDOU','RENE','1987-11-12','02.11.83.83.36','06.86.58.91.69',NULL,'4 RUE DU JURA','','','14930','MALTOT',NULL,NULL,'1871198818001',17.000000000,'2012-07-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2358,'MONNIER','FRANCOIS','1936-01-28','02.69.95.02.30','06.11.03.82.99',NULL,'87  C2 RUE DE FALAISE','','','61200','UROU ET CRENNES',NULL,NULL,'1360114410001',184.000000000,'1966-08-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2359,'LELIEVRE','JOSEPH','1929-03-31','02.11.41.74.65',NULL,NULL,'24 RUE DU BOCAGE','','','14400','BAYEUX',NULL,NULL,'2290350305001',115.000000000,'1952-05-04','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2360,'MAUDEMAIN','Suzanne','1933-07-28','02.55.11.81.37','06.10.04.54.29',NULL,'LE ROND POMMIER','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2330714245001',70.000000000,'1961-08-24','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2361,'MASSON','JACQUES',NULL,'02.54.10.91.84','06.12.84.13.54',NULL,'10 ROUTE DE VILLIERS LE SEC','','','14420','POTIGNY',NULL,NULL,'8014181600001',29.000000000,'2008-02-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2362,'DUFOUR','JACQUELINE','1934-07-22','02.64.67.58.31','06.30.36.34.12',NULL,'8 RUE MANGEMATIN','','','14850','HEROUVILLETTE',NULL,NULL,'2340780058001',58.000000000,'1958-07-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2363,'LELIEVRE','YVETTE','1936-10-31','02.38.93.87.28','06.10.93.79.85',NULL,'10 rue de sully','','','14000','CAEN',NULL,NULL,'1361014005001',1713.000000000,'1963-07-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2364,'FREMONT','','1964-02-21','02.89.37.63.07','06.87.29.22.48',NULL,'61 BD GENERAL VANIER','','','14260','ONDEFONTAINE',NULL,NULL,'1640261217001',30.000000000,'1992-08-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2365,'DAUMESNIL','HENRI','1979-05-20','02.28.90.24.35','06.68.21.96.38',NULL,'41 AVENUE DU 6 JUIN','','','50270','SORTOSVILLE EN BEAUMONT',NULL,NULL,'2790529105001',719.000000000,'2008-10-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2366,'CARON','ROBERT','1938-02-02','02.62.59.91.05','06.11.46.02.96',NULL,'2 rue edmond boca','','','14310','ST LOUET SUR SEULLES',NULL,NULL,'1380214038001',939.000000000,'1959-12-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2367,'PATRICE','MARIE LOUISE','1930-09-16','02.59.66.75.77','06.39.73.70.17',NULL,'4 RUE DU LAVOIR','','','14150','OUISTREHAM',NULL,NULL,'2300914461001',10.000000000,'1952-04-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2368,'JEAN','YVETTE','1935-08-08','02.34.76.67.10','06.45.97.21.35',NULL,'35 rue pierre de couvertin','','','61430','ATHIS DE L''ORNE',NULL,NULL,'1350850582001',17.000000000,'1956-11-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2369,'PETIT','MONIQUE','1936-03-30','02.74.12.82.93',NULL,NULL,'12 RUE DE ROTS','','','61120','VIMOUTIERS',NULL,NULL,'2360314100001',1679.000000000,'1960-09-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2370,'MESNIL','alain',NULL,'02.99.45.00.43','06.62.49.50.57',NULL,'VILLAGE MITRECAMP','','','14120','MONDEVILLE',NULL,NULL,'2320414287001',128.000000000,'2010-12-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2371,'LANGLAIS','CLAUDINE','1936-06-02','02.85.28.94.21','06.75.64.50.65',NULL,'42 rue du chemin vert','','','14340','CAMBREMER',NULL,NULL,'2360614543001',16.000000000,'1957-01-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2372,'DROULIN','PATRICK','1932-11-23','02.36.78.67.49','06.43.24.54.04',NULL,'15 bis de chicheboville','','','66100','PERPIGNAN',NULL,NULL,'1321150394001',49.000000000,'1962-12-15','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2373,'DROULIN','ALAIN','1934-02-26','02.11.54.50.00','06.78.71.73.65',NULL,'LA CHAUSSE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1340214168001',662.000000000,'1957-04-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2374,'ZIMOLONG','GHISLAINE','1965-02-23','02.27.54.10.04','06.43.88.77.93',NULL,'30 AVENUE DES DIABLOTINS RESIDEN','CE HORTENSIAS','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1650214163001',15.000000000,'1994-03-25','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2375,'ROBINE','YVONNE','1940-04-23','02.44.75.26.63','06.20.19.94.29',NULL,'37 RUE PIERRE BROSSOLETTE','','','61200','ARGENTAN',NULL,NULL,'2400450192001',1687.000000000,'1961-03-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2376,'BOSSUYT','CYPRIENNE','1931-11-10','02.50.35.82.63','06.10.75.84.90',NULL,'36 RUE DE VERDUN','','','14170','GRISY',NULL,NULL,'1311161150001',262.000000000,'1959-06-03','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2377,'LAMBALLAIS','JEAN LOUIS','1938-06-16','02.32.30.55.51','06.17.06.31.31',NULL,'35 rue de falaise','','','27300','MENNEVAL',NULL,NULL,'2380614207001',20.000000000,'1960-11-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2378,'LEMARCHAND','CLAUDE','1955-01-16','02.86.86.21.44','06.84.99.78.64',NULL,'1 ALLEE DE L''EUROPE','','',NULL,NULL,NULL,NULL,'1550150292001',1684.000000000,'1977-10-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2379,'LEMARCHAND','CHRISTIANE','1931-10-07','02.73.54.66.06','06.59.35.29.23',NULL,'213 RUE DE LA PLAINE','','','14000','CAEN',NULL,NULL,'2311050036001',1023.000000000,'1954-12-03','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2380,'CATEL','BERNARD','1937-10-12','02.78.97.51.22','06.72.07.07.47',NULL,'1 PLACE DES NOYERS','','',NULL,'GIBERVILLE',NULL,NULL,'1371050494001',402.000000000,'1959-12-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2381,'MARIE','JEAN PIERRE','1980-12-18','02.72.86.78.07','06.29.53.58.02',NULL,'20 RUE DU BEL AIR','','','61500','SEES',NULL,NULL,'1801299215001',8.000000000,'2005-09-14','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2382,'HEMERY','RAYMONDE','1966-07-26','02.31.90.92.36','06.84.04.54.59',NULL,'1 RUE PIERRE CURIE APP B13','','','14270','MEZIDON CANON',NULL,NULL,'1660714325001',22.000000000,'1988-10-05','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2383,'BISSIERE','GUSTAVE','1940-06-13','02.23.10.00.99','06.30.54.23.70',NULL,'3 RUE DU ROND POINT','','','14000','CAEN',NULL,NULL,'2400614235001',40.000000000,'1968-06-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2384,'DOINARD','ALAIN','1948-03-07','02.89.93.88.15','06.84.10.11.11',NULL,'67 ROUTE DE PARIS','','','14470','COURSEULLES SUR MER',NULL,NULL,'2480361472001',57.000000000,'1969-01-22','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2385,'CAPET','MARTINE','1939-09-23','02.30.06.60.65','06.77.81.04.50',NULL,'7 RUE DU MARAIS','','','14400','BAYEUX',NULL,NULL,'2390914309001',7.000000000,'1962-05-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2386,'BRENAC','CLAUDINE',NULL,'02.48.68.03.66','06.28.48.09.84',NULL,'8 RUE DE LA REPUBLIQUE','','','14000','CAEN',NULL,NULL,'2650814305001',28.000000000,'2009-07-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2387,'NOEL','XAVIER','1952-01-24','02.11.37.21.76','06.95.83.91.00',NULL,'5 rue des erables1','','','50000','ST LO',NULL,NULL,'2520114678001',598.000000000,'1976-07-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2388,'ANSELIN','PATRICIA','1942-03-21','02.87.79.00.41','06.90.84.69.48',NULL,'5 rue lon blum','','','14730','GIBERVILLE',NULL,NULL,'2420361002001',78.000000000,'1965-06-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2389,'LECLUZE','JACQUELINE','1947-04-16','02.12.62.06.62','06.75.13.67.16',NULL,'17 rue du bout au mesnil','','','14000','CAEN',NULL,NULL,'1470414349001',36.000000000,'1968-12-23','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2390,'LETEMPLIER','CAROLINE','1957-01-05','02.88.57.82.84','06.52.15.24.59',NULL,'43 ROUTE DE CAEN','','',NULL,'GIBERVILLE',NULL,NULL,'2570114456001',35.000000000,'1987-08-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2391,'DUCOUDRAY','JEANINE','1932-03-05','02.22.57.10.98','06.21.31.38.01',NULL,'les lhelpiquets','','',NULL,NULL,NULL,NULL,'2320314585001',151.000000000,'1955-12-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2392,'DE BROU','CLAUDE','1955-01-24','02.98.03.58.74',NULL,NULL,'14 RUE DE LA LIBERATION','','','61200','ARGENTAN',NULL,NULL,'2550114188001',2378.000000000,'1985-11-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2393,'REGIELI','PIERRE',NULL,'02.39.05.11.22','06.12.13.66.68',NULL,'3 rue de la vigne a la dame','','','61150','RANES',NULL,NULL,'1400561314001',39.000000000,'2009-11-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2394,'CHAPRON','CLAUDE','1936-03-29','02.25.61.10.97','06.61.56.17.61',NULL,'8 boulevard des allies','','','14630','FRENOUVILLE',NULL,NULL,'1360314309001',2861.000000000,'1964-12-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2395,'ENOUF','RENE','1954-10-11','02.10.41.34.05','06.17.45.55.18',NULL,'50 rue de bretagne','','','14810','GONNEVILLE EN AUGE',NULL,NULL,'1541014118001',279.000000000,'1979-03-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2396,'BOUILLERE','MICHEL','1937-04-09','02.75.38.84.81','06.46.52.14.87',NULL,'21 RUE LE CLOS','','','14210','TOURVILLE SUR ODON',NULL,NULL,'1370414667001',40.000000000,'1959-02-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2397,'BERARD','BERNARD','1956-05-24','02.34.14.47.72','06.15.91.72.74',NULL,'9, route de Merville','','','14000','CAEN',NULL,NULL,'1560514042001',1412.000000000,'1979-11-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2398,'CROCQUEVIEILLE','ANNE','1937-05-29','02.25.14.21.63','06.12.19.03.82',NULL,'3 rue des freres lumieres','','','14000','CAEN',NULL,NULL,'2370514015001',401.000000000,'1959-09-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2399,'MELINOU','GERARD','1944-06-06','02.41.97.87.66','06.87.56.84.64',NULL,'LE CLOS DES CIGOGNES','','','14540','SOLIERS',NULL,NULL,'1440675058001',26.000000000,'1969-02-01','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2400,'ANQUETIL','MONIQUE','1928-11-29','02.86.09.73.96','06.51.08.26.31',NULL,'HAUT LAURENT','','','50000','ST LO',NULL,NULL,'2281114141001',241.000000000,'1955-03-02','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2401,'LANNUZEL','DANIEL','1934-06-15','02.49.56.71.37','06.68.90.69.02',NULL,'13 la longue rue','','','14670','ST PAIR',NULL,NULL,'2340614361001',290.000000000,'1955-01-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2402,'MOTIN','CLAUDE','1928-06-23','02.52.43.44.93','06.52.92.19.24',NULL,'12 rue pierre et marie curie','','','14320','MAY SUR ORNE',NULL,NULL,'1280689387001',93.000000000,'1950-04-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2403,'CACHARD','RAYMOND','1939-03-15','02.11.75.22.83','06.22.95.08.16',NULL,'9 rue du val fleurie','','','14220','ST LAURENT DE CONDEL',NULL,NULL,'2390350370001',104.000000000,'1965-01-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2404,'VARIN','ARLETTE','1929-12-29','02.64.85.24.50','06.43.21.49.25',NULL,'4 bld liyaute','','','14190','ST SYLVAIN',NULL,NULL,'2291214684001',71.000000000,'1954-03-14','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2405,'LAUNAY','BERNADETTE','1944-03-28','02.65.47.72.54','06.10.75.01.95',NULL,'24 RUE AUGUSTE LECHESNE','','','14840','DEMOUVILLE',NULL,NULL,'1440314256001',1329.000000000,'1967-04-13','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2406,'VERGNE','LOUIS','1935-02-03','02.88.89.60.53','06.23.72.15.43',NULL,'LE PLESSIX','','','14123','IFS',NULL,NULL,'2350214593001',172.000000000,'1963-10-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2407,'VERGNE','LUCETTE','1935-12-07','02.54.79.63.90','06.43.94.71.24',NULL,'5 rue du 11 novembre','','','14370','ARGENCES',NULL,NULL,'1351214610001',4624.000000000,'1957-10-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2408,'PAGNY','GENEVIEVE','1928-03-29','02.57.73.98.02','06.10.12.81.59',NULL,'1109 QUARTIER DU GRAND PARC','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1280314379001',396.000000000,'1954-05-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2409,'LEFEVRE','JACQUELINE','1944-01-01','02.47.76.57.44','06.46.66.29.26',NULL,'11 RUE CAUDE','','','14000','CAEN',NULL,NULL,'2440150342001',315.000000000,'1965-07-15','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2410,'HOLDRY','RAYMOND','1956-05-01','02.29.34.81.24','06.13.36.66.23',NULL,'Le bourg','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1560561208001',88.000000000,'1982-01-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2411,'MARIE','MARIE SOPHIE','1928-11-18','02.20.67.65.43','06.30.85.28.64',NULL,'19 IMPASSE DES ROSES','','','14000','GIBERVILLE',NULL,NULL,'1281156079001',35.000000000,'1956-03-01','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2412,'CAMUS','JEANNE','1940-09-06','02.94.55.55.37','06.15.16.27.78',NULL,'102 RTE DE CABOURG LE MESNIL','','','14460','COLOMBELLES',NULL,NULL,'1400929075001',38.000000000,'1961-06-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2413,'MARIE','PIERRE','1928-11-15','02.51.68.45.52','06.76.88.63.95',NULL,'LE MANOIR','','','14210','NOYERS BOCAGE',NULL,NULL,'1281114486001',507.000000000,'1949-09-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2414,'MARIE','MICHEL','1963-02-05','02.48.10.74.19',NULL,NULL,'','','','14260','AUNAY SUR ODON',NULL,NULL,'1630214554001',295.000000000,'1992-12-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2415,'FONTAINE','PAUL','1962-10-24','02.28.93.83.30','06.77.75.97.90',NULL,'13 rue des grandes patures','','','50500','CARENTAN',NULL,NULL,'1621014211001',1170.000000000,'1988-03-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2416,'ESNOUF','MAURICE','1935-01-04','02.11.33.21.48','06.98.75.62.58',NULL,'LES CABLES','','','14000','CAEN',NULL,NULL,'1350114452001',102.000000000,'1956-01-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2417,'POULLAVEC','BERNARD','1929-05-10','02.51.82.07.57','06.93.66.70.39',NULL,'16 residence BELLEVUE','','','14680','GOUVIX',NULL,NULL,'2290514128001',31.000000000,'1952-07-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2418,'GELINAUD','CLAUDE','1950-01-19','02.88.65.93.88','06.94.15.70.99',NULL,'le bourg totes','','','14430','HOTOT EN AUGE',NULL,NULL,'1500114482001',463.000000000,'1971-04-04','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2419,'DELENTE','HUBERT','1933-06-18','02.11.46.45.50','06.78.68.32.31',NULL,'31 AVENUE GAMBETTA','','','14123','FLEURY SUR ORNE',NULL,NULL,'1330614042001',36.000000000,'1959-05-04','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2420,'CANU','PHILIPPE','1958-10-15','02.42.43.77.88','06.36.69.13.07',NULL,'7 RUE DE LIROSE','','','14860','RANVILLE',NULL,NULL,'1581035238001',847.000000000,'1985-12-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2421,'LEPAON','JEANNE','1930-01-17','02.99.17.74.78',NULL,NULL,'19 rue goujarde','','',NULL,NULL,NULL,NULL,'2300178143001',171.000000000,'1960-06-22','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2422,'GAUCHARD','CHARLES','1958-01-20','02.64.21.18.53','06.54.41.26.24',NULL,'17 rue de cormelles','','','14940','SANNERVILLE',NULL,NULL,'2580114513001',48.000000000,'1982-08-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2423,'BRICET','MARLENE','1963-12-03','02.12.61.75.02','06.47.27.18.50',NULL,'LE VIEUX BOIS','','','14000','CAEN',NULL,NULL,'1631299253001',30.000000000,'1991-03-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2424,'LEO','MARIE JOSEE','1954-01-25','02.44.50.39.07','06.85.86.34.05',NULL,'1 RUE DE LA GARENNE','','','14650','CARPIQUET',NULL,NULL,'1540161278001',68.000000000,'1977-02-19','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2425,'DECATHEAUGRUE','EMMANUEL','1929-10-26','02.25.51.01.72','06.89.23.47.84',NULL,'8 rue de tageret','','','14150','OUISTREHAM',NULL,NULL,'2291014076001',2.000000000,'1959-12-14','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2426,'MANOURY','LUCIEN','1939-12-30','02.74.86.85.83',NULL,NULL,'10 RUE PIERRE MARIVAUX','','','14400','BAYEUX',NULL,NULL,'1391250267001',34.000000000,'1962-10-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2427,'POVOLNY','ROGER','1966-04-19','02.26.96.55.73','06.68.38.84.02',NULL,'99 RUE DE LA DELIVRANDE','','','14370','MERY CORBON',NULL,NULL,'2660414752001',5.000000000,'1991-12-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2428,'SAVARY','LEONE','1936-05-12','02.88.05.06.88','06.68.14.40.85',NULL,'6 RUE CATHERINE DE MEDICIS','','','14940','SANNERVILLE',NULL,NULL,'1360514659001',106.000000000,'1959-05-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2429,'GRUJARD','BERNARD','1963-02-22','02.51.60.58.95','06.27.00.36.59',NULL,'11 IMPASSE MARCEL FOUBERT','','','14120','MONDEVILLE',NULL,NULL,'2630214619001',96.000000000,'1987-01-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2430,'BAUDRY','BERNARD','1936-10-23','02.52.32.98.52','06.36.78.56.42',NULL,'36  ROUTE DE BRETTEVILLE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2361050412001',167.000000000,'1960-08-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2431,'MAISONNIER','JULIETTE','1959-08-23','02.51.17.92.09','06.10.19.41.01',NULL,'22 place georges pompidou','','','14000','CAEN',NULL,NULL,'1590814749001',590.000000000,'1982-02-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2432,'TERRY','LOUISE','1939-09-30','02.64.20.08.17','06.99.28.79.81',NULL,'75 rue eustache restout','','','14370','MOULT',NULL,NULL,'2390914163001',634.000000000,'1968-04-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2433,'LEBOURGEOIS','francois','1934-11-15','02.77.54.95.53','06.11.57.88.57',NULL,'6 ALLEE MARCEL CACHIN','','','14960','MEUVAINES',NULL,NULL,'1341114628001',49.000000000,'1955-12-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2434,'VARIN','ALAIN','1959-01-21','02.14.74.76.63',NULL,NULL,'5 RUE DES CLOSETS','','','14000','CAEN',NULL,NULL,'1590127367001',20.000000000,'1985-06-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2435,'LE COURCY','RAYMOND','1929-08-20','02.11.11.10.37','06.32.65.14.88',NULL,'12 CHEMIN DES LONGUES RAYES','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1290850190001',297.000000000,'1956-08-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2436,'MERIEULT','CORINNE','1935-05-02','02.80.64.08.55','06.46.48.19.59',NULL,'15 RUE DE STOCKHOLM','','','14123','FLEURY SUR ORNE',NULL,NULL,'1350550542001',1536.000000000,'1959-06-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2437,'LAURENS','JEAN','1928-01-12','02.57.94.15.06','06.58.01.09.73',NULL,'19 RUE FLEMING','','','14370','CLEVILLE',NULL,NULL,'1280114342001',20.000000000,'1949-04-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2438,'FOUBERT','BERNARD','1940-12-01','02.77.70.57.96','06.68.29.50.70',NULL,'11 RUE PAUL LANGEVIN','','','14123','IFS',NULL,NULL,'1401249127001',3915.000000000,'1963-09-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2439,'THEVENIAUD','MARCEL','1953-01-12','02.25.32.84.21','06.43.59.71.82',NULL,'RUE AUX GRAINS','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1530114287001',37.000000000,'1976-07-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2440,'MAUGER','YVETTE','1963-10-12','02.89.24.59.04','06.25.24.13.75',NULL,'47 rue val des dunes','','','14240','CAUMONT L''EVENTE',NULL,NULL,'2631014007001',171.000000000,'1992-11-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2441,'LOREL','COLETTE','1938-11-30','02.19.93.98.80','06.68.87.81.52',NULL,'48 PLACE DE LA GARE','','','14000','CAEN',NULL,NULL,'1381114207001',35.000000000,'1966-11-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2442,'COTTIER','COLETTE','1934-12-11','02.34.28.92.34','06.30.26.44.02',NULL,'CHEMIN DU VAL COLLET','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'2341214651001',1007.000000000,'1959-07-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2443,'POIER','RAYMONDE','1978-09-17','02.15.83.61.54','06.54.37.65.16',NULL,'2 CHEMIN DU MAREYAGE','','','14250','AUDRIEU',NULL,NULL,'2780999336001',145.000000000,'2004-09-28','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2444,'HIBLOT','JACQUELINE','1932-08-15','02.19.00.32.38','06.40.70.62.84',NULL,'LIEU DIT LE LAUNEY','','','27270','LA CHAPELLE GAUTHIER',NULL,NULL,'1320814516001',627.000000000,'1955-10-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2445,'DEBEAUPTE','JACQUELINE','1935-05-04','02.82.37.16.82','06.41.67.08.71',NULL,'6. RUE DES COURTILS','','','14470','COURSEULLES SUR MER',NULL,NULL,'1350514651001',187.000000000,'1958-04-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2446,'GODEFROY','EUGENE','1949-01-12','02.81.28.49.38','06.32.86.88.98',NULL,'15 rue leon briand','','','14111','LOUVIGNY',NULL,NULL,'1490150172001',8.000000000,'1972-11-28','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2447,'BOURELLE','FRANCOISE','1935-04-29',NULL,NULL,NULL,'Mesnil Roger','','','14650','CARPIQUET',NULL,NULL,'1350414712001',24.000000000,'1965-04-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2448,'BIGNON','PATRICK','1933-09-02','02.36.84.86.25','06.27.79.57.78',NULL,'','','','61700','DOMFRONT',NULL,NULL,'1330914117001',179.000000000,'1956-07-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2449,'BOUDANT','JEAN CLAUDE','1969-11-27','02.71.77.05.36','06.61.34.52.41',NULL,'21 rue pierre curie','','','14000','CAEN',NULL,NULL,'2691114499001',31.000000000,'1999-02-28','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2450,'LE COGUIC','BLANCHE',NULL,'02.11.44.12.87','06.18.69.83.83',NULL,'28. RUE PASTEUR','','','14610','COLOMBY SUR THAON',NULL,NULL,'1500161387001',563.000000000,'2012-08-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2451,'VERMES','MICHELE',NULL,'02.13.28.77.48','06.38.57.60.42',NULL,'Lecarel','','','14850','HEROUVILLETTE',NULL,NULL,'1300378333001',2190.000000000,'2012-10-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2452,'JEAN','THERESE','1939-02-07','02.11.82.26.62','06.66.58.80.79',NULL,'28 Village St Pierre','','','14370','BELLENGREVILLE',NULL,NULL,'2390250176001',17.000000000,'1961-12-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2453,'VIVIER','PAULETTE','1939-08-19','02.80.89.09.15','06.39.31.91.95',NULL,'3 CLOS DES CIGOGNES','','','14400','ETREHAM',NULL,NULL,'1390814489001',179.000000000,'1960-11-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2454,'GIRARD','RENE','1959-06-21','02.10.70.19.14','06.32.70.33.84',NULL,'2 RUE DU STADE','','','14123','IFS',NULL,NULL,'2590614128001',206.000000000,'1987-07-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2455,'HUE','FERNAND','1951-04-08','02.18.91.97.11','06.32.72.46.01',NULL,'44 rue de l''eglise','','','14000','CAEN',NULL,NULL,'1510414587001',348.000000000,'1973-02-27','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2456,'MOUCHEL','JEANNINE','1938-10-25','02.41.23.60.23','06.11.42.34.25',NULL,'9 RUE DU BERRY','','','14000','CAEN',NULL,NULL,'2381061258001',32.000000000,'1964-07-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2457,'HERVIEU','EVELYNE','1940-03-28','02.90.99.40.12','06.11.55.05.72',NULL,'43 rue de lisbonne','','','14000','CAEN',NULL,NULL,'2400361355001',745.000000000,'1961-02-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2458,'BASLEY','MARIE','1937-07-05','02.50.26.42.88','06.84.06.44.58',NULL,'19 LA PETITE RUE','','','14123','IFS',NULL,NULL,'1370750230001',10.000000000,'1959-07-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2459,'RENOU','LUCIEN','1935-01-25','02.55.27.19.39','06.75.92.17.06',NULL,'3 imp des ormes','','','14320','FONTENAY LE MARMION',NULL,NULL,'2350161460001',9.000000000,'1962-03-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2460,'MAURICE','BERNARD','1935-06-23',NULL,NULL,NULL,'rue de la justice','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2350614714001',283.000000000,'1962-04-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2461,'DECROIX','CASSIA','1938-04-09','02.43.26.20.38','06.75.28.74.95',NULL,'6 RUE DE LA MAIRIE','','','14460','COLOMBELLES',NULL,NULL,'2380414738001',629.000000000,'1959-06-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2462,'BEURIOT','PIERRE','1936-08-11','02.70.07.61.52','06.54.43.68.47',NULL,'RES BEL AIR 22 RUE DU DR ROUX','','','14270','MEZIDON CANON',NULL,NULL,'1360814277001',40.000000000,'1958-09-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2463,'GEERTS','DENISE','1928-07-15','02.45.46.50.21','06.47.72.56.21',NULL,'4 rue du stade','','','14000',NULL,NULL,NULL,'2280714379001',121.000000000,'1951-11-04','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2464,'PLANTIS','Bernard','1960-01-12','02.23.07.84.14','06.26.73.72.68',NULL,'29 RUE DAMOZANNE','','','14860','RANVILLE',NULL,NULL,'2600150060001',1007.000000000,'1984-06-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2465,'GAZENGEL','ROGER','1932-02-27','02.73.84.35.96','06.85.98.81.76',NULL,'LE BOURG','','','14420','USSY',NULL,NULL,'2320214132001',4664.000000000,'1953-10-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2466,'MURIS','BRIGITTE','1966-07-12','02.10.20.84.45','06.34.79.10.29',NULL,'3 rue j levilly','','','14310','VILLERS BOCAGE',NULL,NULL,'1660714325001',114.000000000,'1996-05-07','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2467,'RIBET','PIERRE','1934-06-12','02.43.39.93.57','06.11.15.39.79',NULL,'10 rue des Quesnots','','','14480','BAZENVILLE',NULL,NULL,'2340614090001',33.000000000,'1957-01-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2468,'LAGRAVE','GERARD','1936-12-07','02.17.18.14.69','06.12.06.81.08',NULL,'109 quartier des belles portes','','','14500','VIRE',NULL,NULL,'1361278371001',84.000000000,'1966-10-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2469,'GODEY','JOEL','1936-11-03','02.67.33.02.65','06.68.31.21.65',NULL,'19 CHEMIN DU VOIE','','',NULL,NULL,NULL,NULL,'1361114406001',153.000000000,'1959-07-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2470,'DUROCHER','SERGE','1938-01-25','02.65.70.34.02','06.10.41.90.90',NULL,'9 RUE DE LA FERRIERE','','','14000','CAEN',NULL,NULL,'1380127218001',760.000000000,'1963-05-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2471,'COLLETTE','ANDREE','1960-07-07','02.12.05.20.99','06.98.34.73.40',NULL,'grande rue','','','14000','CAEN',NULL,NULL,'1600714396001',416.000000000,'1984-01-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2472,'ALIX','ARLETTE','1936-02-21','02.64.86.22.54','06.55.53.02.73',NULL,'IMPASSE FOCH','','','14430','PUTOT EN AUGE',NULL,NULL,'1360250581001',80.000000000,'1963-10-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2473,'CHEVALIER','NATHALIE','1955-01-17','02.84.96.36.81','06.99.01.55.39',NULL,'4 ROUTE DU MARAIS','','','14940','TOUFFREVILLE',NULL,NULL,'2550114431001',17.000000000,'1982-09-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2474,'WAJDA','FRANCOISE','1956-06-03','02.81.47.50.51','06.10.72.35.04',NULL,'119 rue du centre','','','14123','IFS',NULL,NULL,'1560614291001',94.000000000,'1984-01-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2475,'BENOIS','JOSEPH FERNAND','1932-07-01','02.24.05.07.84','06.82.42.64.52',NULL,'','','','14430','DOZULE',NULL,NULL,'1320714554001',322.000000000,'1958-05-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2476,'PEUDRU','LILIANE','1932-12-16','02.88.11.56.79','06.88.36.33.70',NULL,'15 RUE DU RUEL','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1321261045001',14.000000000,'1958-09-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2477,'MORAINE','DAVID','1930-06-02','02.13.76.24.06','06.54.56.80.19',NULL,'2 CHEMIN DU CLOS','','','14100','LISIEUX',NULL,NULL,'1300650480001',19.000000000,'1953-07-13','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2478,'BERTHIER','HENRIETTE','1942-11-01','02.68.06.06.25','06.10.91.53.03',NULL,'1 IMPASSE DES OISEAUX','','','14540','BOURGUEBUS',NULL,NULL,'1421114529001',471.000000000,'1972-02-09','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2479,'CAPELLE','HENRI','1935-12-02','02.93.37.99.46','06.64.00.18.12',NULL,'18 RUE VICTOR HUGO','','','14500','VAUDRY',NULL,NULL,'2351214367001',39.000000000,'1958-10-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2480,'DESLOGES','REINE','1934-09-26','02.54.87.93.57','06.67.42.42.69',NULL,'les charmilles 3 rue de l eglise','','','14370','MOULT',NULL,NULL,'2340914140001',165.000000000,'1959-09-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2481,'LECHIPEY','ERIC','1940-11-05','02.23.45.72.94','06.36.59.82.63',NULL,'6 ALLEE DE BERNE','','','14000','CAEN',NULL,NULL,'2401150159001',83.000000000,'1967-08-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2482,'FOURRE','ERIC','1931-04-27','02.40.36.69.89','06.93.91.95.16',NULL,'1 rue denis diderot','','','14390','CABOURG',NULL,NULL,'2310414556001',739.000000000,'1957-05-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2483,'LANGELLIER','LEONE','1932-04-07','02.21.33.03.88','06.72.06.79.47',NULL,'7 CLOS CHARMANT','','',NULL,NULL,NULL,NULL,'1320450512001',1292.000000000,'1957-06-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2484,'PALLUD','RAYMOND','1940-04-01','02.89.24.10.07','06.11.67.49.35',NULL,'12 RUE CARDINAL DU PERRON','','','14480','CREULLY',NULL,NULL,'2400450162001',3166.000000000,'1964-07-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2485,'SUARD','SOPHIE','1939-11-26','02.18.40.93.68','06.40.84.61.11',NULL,'LIEU DIT ORVAL','','','14780','LION SUR MER',NULL,NULL,'1391176216001',380.000000000,'1967-04-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2486,'CHAUVET','BERNARD','1929-05-23','02.28.68.20.61','06.42.07.52.65',NULL,'8 PLACE PASTEUR','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2290550417001',151.000000000,'1953-09-02','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2487,'SYLVAND','BERNARD','1922-05-20','02.44.26.01.74',NULL,NULL,'CARREFOUR BABELUCHE','','','14400','ST VIGOR LE GRAND',NULL,NULL,'1220514118001',81.000000000,'1952-10-14','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2488,'LECOQ','DANIEL','1936-10-04','02.11.95.08.31','06.81.80.50.17',NULL,'16 RUE D ARGENTAN','','','14000','CAEN',NULL,NULL,'1361014187001',17.000000000,'1959-04-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2489,'FEUGUERAY','THERESE','1933-09-09','02.35.96.27.69','06.18.20.76.80',NULL,'1 RUE DE ERGALANCIERS','','','14570','ST REMY',NULL,NULL,'2330914258001',13.000000000,'1959-09-04','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2490,'LELONGE','FRANCOIS','1940-09-16','02.24.36.30.31','06.16.46.53.60',NULL,'7 RUE LA COQUERIE','','','14123','IFS',NULL,NULL,'2400914651001',25.000000000,'1964-05-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2491,'DUPONT','GINETTE','1934-01-28','02.89.13.22.03','06.83.05.71.34',NULL,'9 rue st eloi','','','14000','CAEN',NULL,NULL,'2340114629001',8.000000000,'1958-08-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2492,'DUVAL','MICHEL','1931-04-03','02.14.68.69.33','06.66.61.59.01',NULL,'7 BIS RUE PASTEUR','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1310414279001',172.000000000,'1960-07-23','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2493,'SORNIN','CLAUDE','1933-02-24','02.50.99.64.66','06.86.70.92.13',NULL,'21 rue pierre curie','','','61100','LA LANDE PATRY',NULL,NULL,'1330214413001',139.000000000,'1955-05-17','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2494,'LANDRY','DANIEL','1932-09-07','02.46.73.82.75','06.83.25.42.85',NULL,'11 RUE YVONNE GUEGAN','','','14310','VILLERS BOCAGE',NULL,NULL,'1320950250001',1316.000000000,'1953-05-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2495,'DELAHAYE','FLORENCE','1937-11-14','02.67.23.22.53','06.26.90.89.71',NULL,'13 RUE DE LA REPUBLIQUE','','','14270','CONDE SUR IFS',NULL,NULL,'1371114325001',302.000000000,'1967-03-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2496,'MARIE','XAVIER','1935-06-03','02.27.91.79.92','06.30.38.53.71',NULL,'43 AVENUE JEAN VILAR','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1350614364001',969.000000000,'1964-05-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2497,'DESCHAMPS','MONIQUE','1940-12-10','02.10.81.26.85','06.88.62.50.38',NULL,'ROUTE DE CAEN','','',NULL,NULL,NULL,NULL,'1401250338001',256.000000000,'1961-08-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2498,'ELART','VALERIE','1947-01-24','02.62.96.03.88','06.88.76.88.38',NULL,'12 RUE DE LA GROSSE TOUR','','','14123','IFS',NULL,NULL,'1470114233001',48.000000000,'1973-12-07','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2499,'DETAIS','COLETTE','1932-06-30','02.57.09.17.40','06.11.15.37.39',NULL,'49 RUE SALVADOR MAXIME','','','14000','CAEN',NULL,NULL,'2320622258001',1716.000000000,'1953-03-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2500,'CHEVALIER','JEAN','1931-06-20','02.14.40.64.45','06.68.91.37.96',NULL,'57 RUE LOUIS ARAGON','','','14700','FALAISE',NULL,NULL,'2310614341001',24.000000000,'1955-04-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2501,'DUBOIS','Jean','1935-10-24','02.87.84.77.32','06.15.03.28.17',NULL,'57 rue luois aragon','','','14210','MAIZET',NULL,NULL,'1351049249001',43.000000000,'1961-11-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2502,'VALLERIE','DANIEL','1936-07-09','02.84.56.33.99','06.41.62.36.83',NULL,'60 bvd de rethel','','','14000','CAEN',NULL,NULL,'1360772248001',186.000000000,'1960-08-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2503,'MAUDUIT','MICHELLE','1940-06-21','02.89.33.85.51','06.93.05.96.11',NULL,'49 place andre desnouettes','','','14000','CAEN',NULL,NULL,'1400614342001',43.000000000,'1962-10-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2504,'LOUIS','ANDRE','1947-01-30','02.48.01.56.65','06.83.44.40.46',NULL,'','','','14370','ARGENCES',NULL,NULL,'1470114233001',88.000000000,'1969-12-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2505,'FOUILLARD','ANDRE','1928-05-27','02.10.85.99.69','06.72.82.65.55',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1280514273001',143.000000000,'1950-10-01','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2506,'LOUISE','JEAN','1939-09-26','02.71.27.24.86','06.52.56.01.98',NULL,'quartier de l eglise','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1390927431001',208.000000000,'1961-05-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2507,'GILLETTE','JACQUES','1932-01-31','02.86.79.67.94','06.44.00.62.40',NULL,'25 BOULEVARD DE L''ESPERANCE','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'2320114372001',1894.000000000,'1960-04-11','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2508,'SALINSKI','CLAUDE','1939-08-11','02.64.71.71.17','06.56.64.27.15',NULL,'','','','14000','CAEN',NULL,NULL,'1390814391001',2319.000000000,'1966-07-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2509,'LE VIEL','EVELYNE','1929-08-22','02.64.38.44.76','06.11.07.50.35',NULL,'22 RUE PASTEUR','','','14190','URVILLE',NULL,NULL,'1290850358001',327.000000000,'1953-11-20','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2510,'PREVEL','ANDRE',NULL,'02.72.30.37.87','06.41.76.91.87',NULL,'25 RUE DU GROS ORME','','','50180','AGNEAUX',NULL,NULL,'2581250432001',11.000000000,'2008-10-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2511,'ANDRE','MAURICE','1938-11-12','02.50.73.20.34','06.84.41.75.04',NULL,'17 RUE DE BENOUVILLE','','','14740','LASSON',NULL,NULL,'1381114597001',116.000000000,'1960-06-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2512,'LE GUAY','MICHEL','1938-11-03','02.55.49.82.12','06.22.28.20.01',NULL,'21 RUE PASTEUR','','','14670','JANVILLE',NULL,NULL,'1381114597001',54.000000000,'1967-03-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2513,'ROLLAND','ANDREE','1958-02-13','02.89.44.27.95','06.89.16.92.70',NULL,'','','',NULL,NULL,NULL,NULL,'2580214368001',161.000000000,'1985-04-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2514,'LE LIGNE','JEANINE','1933-02-16','02.25.64.34.37','06.70.18.68.99',NULL,'9 ALLEE DES AVELINES','','','14730','GIBERVILLE',NULL,NULL,'1330214679001',196.000000000,'1958-09-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2515,'BOUCHER','JEANINE','1945-01-02','02.11.07.81.71','06.79.42.13.25',NULL,'3 IMPASSE DE LA MOISSON','','',NULL,NULL,NULL,NULL,'2450114612001',185.000000000,'1966-12-21','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2516,'BARRASSIN','','1937-07-01','02.84.46.23.55','06.73.95.62.19',NULL,'25 rue henry mathis','','',NULL,NULL,NULL,NULL,'2370714352001',1951.000000000,'1958-12-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2517,'VAILLANT','JULIETTE','1939-01-21','02.12.23.41.95','06.11.22.16.26',NULL,'26 RUE DE LAUSANNE','','','14000','CAEN',NULL,NULL,'2390150230001',41.000000000,'1960-09-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2518,'SERAFIN','','1964-01-29','02.36.88.48.39','06.58.04.90.76',NULL,'513 quartier du bois','','','14650','CARPIQUET',NULL,NULL,'2640114437001',34.000000000,'1989-07-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2519,'FERRUT','JACQUES','1930-01-29','02.43.22.72.05','06.54.86.48.08',NULL,'7 rue du chateau d eau','','','61200','ARGENTAN',NULL,NULL,'1300114084001',373.000000000,'1959-05-27','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2520,'LECOMTE','JACQUELINE','1967-09-06','02.40.88.14.49','06.51.52.14.55',NULL,'11 RUE DES CHANOINES','','','14000','CAEN',NULL,NULL,'1670914734001',335.000000000,'1991-03-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2521,'BESNARD','EUGENE-CYRILLE','1930-08-02','02.58.70.62.41','06.57.62.17.00',NULL,'9 RUE DU LAVOIR','','','14700','FALAISE',NULL,NULL,'1300814685001',4.000000000,'1958-03-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2522,'RIOT','MICHEL','1949-01-14','02.86.99.40.48','06.30.91.34.34',NULL,'RUE DE LIROZE','','','92100','BOULOGNE BILLANCOURT',NULL,NULL,'1490114372001',861.000000000,'1971-10-24','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2523,'COSNARD','PASCAL','1942-09-26','02.14.01.14.96','06.43.01.09.69',NULL,'12/14 RUE SAINT GABRIEL','','','14540','BOURGUEBUS',NULL,NULL,'1420977089001',4164.000000000,'1963-11-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2524,'LEMENICIER','HELOISE','1958-04-28','02.12.09.14.06','06.57.76.88.09',NULL,'47 BIS RUE DE LA FAUTELAYE','','','14670','TROARN',NULL,NULL,'1580461028001',68.000000000,'1985-06-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2525,'LEBOUCHER','CHANTAL','1937-01-08','02.12.21.50.86','06.90.06.98.08',NULL,'2 CITE DE BAULTS','','','14860','BAVENT',NULL,NULL,'1370133194001',66.000000000,'1958-04-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2526,'MOUTIER','ANNABELLE','1942-01-31','02.24.79.31.47','06.10.26.23.74',NULL,'11 RUE DU PARC','','','14540','SOLIERS',NULL,NULL,'1420114543001',191.000000000,'1964-08-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2527,'HALLEY','KARINE','1935-08-21','02.20.61.34.32','06.28.54.39.66',NULL,'RESIDENCE GUY TRAVERS 22 RUE VOL','TAIRE','','14630','CAGNY',NULL,NULL,'1350861302001',2663.000000000,'1965-02-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2528,'ARNOULD','MICHEL','1933-10-23','02.80.72.76.73','06.11.41.49.36',NULL,'66 rue des epivas','','','14420','VILLERS CANIVET',NULL,NULL,'1331050502001',64.000000000,'1956-01-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2529,'PASQUIER','Jacqueline','1935-10-13','02.74.71.85.20',NULL,NULL,'2 rue des fleurs','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1351076019001',82.000000000,'1960-02-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2530,'MARTINEZ','SUZANNE','1959-01-23','02.57.20.32.28','06.89.32.28.96',NULL,'35 RUE GEORGES POMPIDOU','','','14000','CAEN',NULL,NULL,'2590150321001',109.000000000,'1985-03-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2531,'HOUSSAYE','THERESE','1931-10-05','02.96.12.71.94','06.86.57.27.52',NULL,'10 rue st vincent de paul','','','14310','LANDES SUR AJON',NULL,NULL,'2311014434001',10.000000000,'1954-04-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2532,'LEFORT','ABEL',NULL,'02.74.20.79.89',NULL,NULL,'28 RUE DE LA SEULLES','','','14910','BLONVILLE SUR MER',NULL,NULL,'2381014707001',200.000000000,'2010-01-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2533,'PRINGAULT','JACQUES','1937-12-12','02.87.28.63.44','06.39.71.68.24',NULL,'1 rue louis lachenal','','','14123','FLEURY SUR ORNE',NULL,NULL,'2371214046001',1131.000000000,'1958-09-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2534,'COER','nelly','1959-10-20','02.11.32.14.79','06.44.51.30.17',NULL,'chemin des communes','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2591050067001',749.000000000,'1983-01-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2535,'','MARIE LOUISE','1934-11-14','02.47.71.60.47','06.18.50.58.54',NULL,'12 rue des longs champs','','','14540','SOLIERS',NULL,NULL,'1341114329001',538.000000000,'1962-04-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2536,'LEMASSON','MICHELINE','1960-01-09','02.78.82.51.83','06.33.01.03.78',NULL,'19 rue armand marie','','','14220','LES MOUTIERS EN CINGLAIS',NULL,NULL,'1600114027001',23.000000000,'1984-11-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2537,'LE BERRE','LOUIS','1960-01-06','02.58.48.18.52','06.53.39.45.52',NULL,'35 AVENUE GEORGES GUYNEMER','','','14210','STE HONORINE DU FAY',NULL,NULL,'1600114027001',41.000000000,'1989-08-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2538,'MOREL','LYDIE','1959-04-01','02.19.29.05.77','06.23.73.44.27',NULL,'26bis avenue georges pompidou','','','14000','CAEN',NULL,NULL,'1590450561001',29.000000000,'1988-10-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2539,'MESSEAN','MARC','1960-01-28','02.62.77.72.69','06.75.65.18.65',NULL,'12 RUE HAIE BRETON','','','14120','MONDEVILLE',NULL,NULL,'2600114354001',33.000000000,'1984-03-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2540,'PATRICE','JANINE','1934-10-31','02.10.06.99.21','06.82.37.26.83',NULL,'10 RUE DES CASTELLERIES','','','14000','CAEN',NULL,NULL,'1341014714001',389.000000000,'1961-08-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2541,'NICOLLE','HELENE','1934-10-15','02.17.54.29.78','06.43.84.47.11',NULL,'13 RUE DU BESSIN','','','14860','BAVENT',NULL,NULL,'1341014714001',549.000000000,'1962-11-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2542,'PARMENT','PATRICIA','1944-02-15','02.11.53.38.78','06.10.33.06.70',NULL,'22 RUE JULES FERY','','','14320','MAY SUR ORNE',NULL,NULL,'2440266210001',90.000000000,'1972-04-15','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2543,'','BERNARD','1937-08-30','02.45.00.10.96','06.49.23.20.35',NULL,'120 rue du chateau','','','14120','MONDEVILLE',NULL,NULL,'1370814047001',20.000000000,'1961-08-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2544,'LLOZE','YVES','1935-03-11','02.12.09.19.57','06.47.47.09.36',NULL,'2 PLACE DES GENETS','','','14000','CAEN',NULL,NULL,'1350337123001',109.000000000,'1961-05-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2545,'BEE','MICHELLE','1938-02-13','02.69.27.50.35','06.29.37.51.97',NULL,'645 RUE DU BOCAGE','','',NULL,NULL,NULL,NULL,'2380214123001',413.000000000,'1966-09-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2546,'LA LONDES','ROGER','1930-01-21','02.11.86.55.63','06.71.93.58.23',NULL,'5 RUE VICTOR HUGO','','','14120','MONDEVILLE',NULL,NULL,'1300114663001',1950.000000000,'1958-01-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2547,'BINET','MARIE JOSEPHE','1948-01-05','02.15.71.15.08','06.55.23.58.61',NULL,'5 RUE DU MOULIN LA TOUR','','',NULL,NULL,NULL,NULL,'2480150105001',169.000000000,'1971-03-19','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2548,'LONCLE','MARIE FRANCOISE','1940-07-21','02.32.85.97.06','06.50.39.55.20',NULL,'8 RUE GUILLAUME DU PARC','','','61490','ST CLAIR DE HALOUZE',NULL,NULL,'1400714390001',94.000000000,'1961-08-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2549,'BELLISSENT','MONIQUE','1943-01-07','02.11.15.78.65','06.32.36.00.40',NULL,'8 RUE DE GRAAL','','','14123','IFS',NULL,NULL,'2430114543001',3.000000000,'1968-05-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2550,'LEPELTIER','JEAN CLAUDE',NULL,'02.35.33.12.31','06.85.13.60.98',NULL,'27 RUE NEUVE ST JEAN','','','14000','CAEN',NULL,NULL,'2301250415001',888.000000000,'2009-10-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2551,'POLIDOR','NATHALIE','1936-10-06','02.63.41.19.10','06.43.11.51.11',NULL,'','','','14520','COMMES',NULL,NULL,'1361014341001',11.000000000,'1957-04-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2552,'GALLOT','GERARD','1933-07-14','02.54.71.89.18','06.69.45.47.40',NULL,'1014 bel porte','','','14630','FRENOUVILLE',NULL,NULL,'1330714357001',727.000000000,'1956-01-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2553,'GODIER','ALBERT',NULL,'02.90.02.19.20','06.10.25.62.89',NULL,'120 RUE DES LILAS','','','14000','CAEN',NULL,NULL,'1321085135001',3711.000000000,'2009-08-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2554,'DILASSER','joseph','1951-03-17','02.69.59.12.07','06.31.82.79.20',NULL,'1 clos duperthuis','','','50000','ST LO',NULL,NULL,'2510314176001',39.000000000,'1981-04-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2555,'YONNET','GERMAIN','1931-05-05','02.19.73.64.09','06.18.61.93.52',NULL,'20 RUE DES BELGES','','','14470','COURSEULLES SUR MER',NULL,NULL,'1310558103001',217.000000000,'1952-06-20','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2556,'LEBATARD','JEAN LOUIS','1930-03-05','02.10.99.65.56','00 33 6.39.22.49.88',NULL,'LE VIVEROT','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2300314355001',67.000000000,'1951-08-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2557,'BERNIER','THERESE','1969-04-23','02.59.88.12.41','06.65.91.48.50',NULL,'LE GRANDE BRUYERE','','','50250','ST SYMPHORIEN LE VALOIS',NULL,NULL,'2690414407001',10.000000000,'1991-07-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2558,'LEPELTIER','ROSELINE','1938-11-04','02.61.06.99.22','06.48.32.11.83',NULL,'65 rue du 20eme siecle','','','14730','GIBERVILLE',NULL,NULL,'2381160647001',45.000000000,'1961-06-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2559,'LEPELTIER','GHISLAINE','1939-05-30','02.66.01.50.73','06.11.35.80.91',NULL,'78 RUE DES CAILLOINS','','',NULL,NULL,NULL,NULL,'1390514740001',205.000000000,'1961-03-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2560,'CHALLANDE','STEPHANE','1946-01-24','02.68.89.97.37','06.57.14.75.61',NULL,'7 RUE DE BIR HAKERM','','','14370','AIRAN',NULL,NULL,'2460114005001',123.000000000,'1976-04-06','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2561,'CASTEL','ROGER','1939-12-17','02.10.93.80.97','06.35.11.46.66',NULL,'26 avenue de l''Europe','','','14500','VAUDRY',NULL,NULL,'1391250267001',995.000000000,'1962-11-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2562,'PIWTORAK','LUCIENNE','1943-01-02','02.10.31.06.57','06.11.99.48.35',NULL,'122 RUE DES DIX ACRES','','','14610','FONTAINE HENRY',NULL,NULL,'2430114310001',100.000000000,'1970-12-23','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2563,'DUPUIS','JOCELYNE','1941-04-12','02.17.73.34.58','06.68.50.45.90',NULL,'PLACE ALFRED THOMAS','','','14280','ST CONTEST',NULL,NULL,'2410414396001',906.000000000,'1962-01-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2564,'DUBUS','','1941-04-16','02.93.18.28.83','06.88.21.95.37',NULL,'LA BELLE EPINE','','','14220','ACQUEVILLE',NULL,NULL,'2410414396001',32.000000000,'1971-01-29','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2565,'DURAND','CHRISTIANE','1939-09-01','02.18.26.77.34','06.30.38.08.85',NULL,'CHEMIN DU MARAIS','','','14730','GIBERVILLE',NULL,NULL,'1390950523001',885.000000000,'1960-08-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2566,'HARDY','BERNADETTE',NULL,'02.40.25.44.45','06.28.77.46.19',NULL,'12 RUE DE L''EGLISE','','',NULL,NULL,NULL,NULL,'2390861434001',78.000000000,'2009-06-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2567,'LEGUEDOIS','CLAUDE','1935-06-12','02.54.83.31.97','06.47.55.73.94',NULL,'12 RUE DES FOSSETTES','','','14000','CAEN',NULL,NULL,'1350614444001',1723.000000000,'1961-04-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2568,'GUESDON','JEANNINE','1939-10-14','02.38.23.57.35','06.33.31.27.51',NULL,'3 AVENUE SAINTE THERESE','','','14540','BOURGUEBUS',NULL,NULL,'1391077512001',181.000000000,'1966-09-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2569,'JEAN','CLAUDE','1933-09-01','02.30.73.57.20','06.53.59.43.23',NULL,'','','','14000','CAEN',NULL,NULL,'1330914268001',304.000000000,'1954-12-18','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2570,'LEVALLOIS','CLAUDE','1938-02-16','02.41.83.28.56','06.83.46.68.08',NULL,'6 RUE DES PLATANES','','',NULL,NULL,NULL,NULL,'2380214190001',414.000000000,'1959-05-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2571,'LOPES DOS SANTOS','MARIE THERESE','1937-05-06','02.70.97.92.82','06.38.35.36.07',NULL,'46 rue de la cachette','','','14120','MONDEVILLE',NULL,NULL,'2370514114001',196.000000000,'1967-09-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2572,'BIABAUD','NORBERT','1939-06-18','02.20.51.29.04','06.68.60.35.58',NULL,'47 RUE DE LA LIBERTE','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'2390627016001',17.000000000,'1963-08-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2573,'THIBOUST','CLAUDINE','1928-07-30','02.74.16.00.59',NULL,NULL,'93 BIS RUE ST PATRICE','','','14630','FRENOUVILLE',NULL,NULL,'1280714320001',41.000000000,'1952-01-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2574,'TIREL','HUGUETTE','1937-01-27','02.10.59.70.05','06.81.02.59.57',NULL,'','','','14670','TROARN',NULL,NULL,'1370114268001',728.000000000,'1964-05-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2575,'FIANT','CLAUDINE','1930-10-28','02.33.49.36.23','06.34.46.43.11',NULL,'RESIDENCE AMPHITRITE','','','14730','GIBERVILLE',NULL,NULL,'1301050394001',241.000000000,'1960-09-27','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2576,'GAVREL','CORINNE','1943-03-08','02.24.63.45.06','06.10.03.27.07',NULL,'4 TER ROUTE D''HARCOURT','','',NULL,NULL,NULL,NULL,'1430361251001',1633.000000000,'1965-02-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2577,'SANTIN','ANDRE','1937-09-18','02.30.50.67.46','06.97.82.31.78',NULL,'ECAJEUL','','','14000','CAEN',NULL,NULL,'1370978392001',79.000000000,'1967-11-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2578,'DESCHAMPS','GERARD','1937-05-25','02.73.30.68.91','06.10.65.46.37',NULL,'13 RUE DE LOMGCHAMPS UROU ET CRE','NNES','','14850','ESCOVILLE',NULL,NULL,'2370514566001',5.000000000,'1967-06-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2579,'DESCHAMPS','JEAN','1934-02-02','02.23.41.92.02','06.11.25.12.24',NULL,'22 route de laize','','','14210','EVRECY',NULL,NULL,'1340250504001',16.000000000,'1957-09-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2580,'GUILLEMETTE','DANIEL','1956-03-04','02.83.04.03.68','06.33.92.34.64',NULL,'7 rue clos joli','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2560314213001',373.000000000,'1977-11-19','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2581,'LEMARIE','RENE','1934-02-07','02.72.51.59.83','06.98.78.96.14',NULL,'18 allee des pins','','','14000','CAEN',NULL,NULL,'1340214282001',2817.000000000,'1964-05-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2582,'MONTIGNY','LUCIEN','1930-03-18','02.63.41.62.30','06.78.00.82.99',NULL,'4 RUE DES SORBIERS','','','14670','BURES SUR DIVES',NULL,NULL,'1300378333001',59.000000000,'1954-08-12','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2583,'GERVAIS','JACQUES',NULL,'02.81.49.38.93','06.11.07.34.29',NULL,'9 RUE DES CHANOINES','','','14470','COURSEULLES SUR MER',NULL,NULL,'1460376239001',33.000000000,'2009-09-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2584,'AUDE','MARTINE','1929-04-10','02.10.65.31.38','06.57.69.82.77',NULL,'6 RUE MONTCALM','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2290414011001',2338.000000000,'1959-06-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2585,'LETOUX','MARC','1952-01-29','02.88.51.19.06','06.40.63.38.93',NULL,'4 rue de biganos','','','50410','PERCY',NULL,NULL,'2520162117001',987.000000000,'1981-05-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2586,'LEBLOND','','1933-07-02','02.74.75.47.99',NULL,NULL,'3 rue du 13 juin','','','50460','QUERQUEVILLE',NULL,NULL,'1330714185001',106.000000000,'1955-08-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2587,'DUBOIS','JACQUES','1959-01-26','02.60.16.67.87','06.62.43.62.05',NULL,'2 RUE DU 8 MAI','','','14470','REVIERS',NULL,NULL,'1590114164001',1245.000000000,'1987-07-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2588,'LEREBOURG','SIMONE','1937-03-29','02.47.17.59.55','06.49.18.02.28',NULL,'LA VALLEE','','','14123','IFS',NULL,NULL,'2370314697001',3.000000000,'1962-01-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2589,'JOBARD','ERIC','1928-09-22','02.97.74.23.62',NULL,NULL,'163 RUE DE LA BASSE RIVE','','','14123','IFS',NULL,NULL,'2280914246001',169.000000000,'1953-10-18','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2590,'BRESSON','JACQUES','1952-03-29','02.72.30.85.63','06.96.75.62.80',NULL,'72 RUE DESIRE LE HOC','','','14000','CAEN',NULL,NULL,'2520314034001',458.000000000,'1975-03-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2591,'ANGOT','sylviane','1920-01-09','02.62.87.79.56','06.26.92.16.01',NULL,'14 RUE DES SABLONNETTES','','','14000','CAEN',NULL,NULL,'1200114697001',30.000000000,'1950-07-10','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2592,'YVELIN','ALAIN','1935-10-01','02.66.70.33.34','06.13.02.40.37',NULL,'PLACE DE LA RESISTANCE N/2','','','14830','LANGRUNE SUR MER',NULL,NULL,'2351014397001',128.000000000,'1957-02-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2593,'HUNAULT','EMILE','1936-06-21','02.10.53.66.41','06.45.12.81.63',NULL,'18 ALLEEE DE L''ALBERTA','','','14500','VIRE',NULL,NULL,'1360650149001',43.000000000,'1957-10-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2594,'PANNIER','COLETTE','1936-06-15','02.90.13.49.61','06.10.56.04.35',NULL,'68 RUE DE BEL AIR','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1360650149001',10.000000000,'1957-07-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2595,'DUVAL','GINETTE','1935-05-22','02.23.67.95.46','06.48.05.09.09',NULL,'7 RUE DES MANIOLIAS','','','93160','NOISY LE GRAND',NULL,NULL,'2350514509001',118.000000000,'1962-02-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2596,'CHAUVIN','MAURICE','1928-05-23','02.31.37.67.13','06.60.92.98.14',NULL,'38 RUE ALBERT CAMUS','','','14000','CAEN',NULL,NULL,'2280514140001',30.000000000,'1950-08-24','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2597,'LEPARQUIER','JEANNINE','1968-01-31','02.88.79.81.36','06.41.49.28.36',NULL,'LIEU DIT FONTAINE BOUILLANTE','','','14160','DIVES SUR MER',NULL,NULL,'1680150218001',553.000000000,'1995-10-21','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2598,'VERIE','PIERRE','1937-09-11','02.66.71.80.32','06.59.59.93.00',NULL,'les enclos','','','14470','COURSEULLES SUR MER',NULL,NULL,'2370914582001',180.000000000,'1966-01-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2599,'TREHARD','Auguste','1965-02-13','02.43.54.10.68','06.69.44.07.29',NULL,'25 RUE DES ECOLES','','','14940','TOUFFREVILLE',NULL,NULL,'2650214354001',3612.000000000,'1988-04-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2600,'THOMAS','CHRISTIANE','1931-05-22','02.62.56.26.28','06.18.99.10.94',NULL,'10 RUE DES TILLEULS','','','14460','COLOMBELLES',NULL,NULL,'2310514324001',968.000000000,'1952-09-03','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2601,'LITHARE','FRANCIS','1963-10-04','02.76.09.62.58','06.14.27.89.60',NULL,'10 CLOS DE LA HUTERNE','','','61300','L''AIGLE',NULL,NULL,'2631078579001',1135.000000000,'1992-09-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2602,'DESRAME','PIERRE','1937-11-27','02.86.65.62.56','06.10.29.41.80',NULL,'18 AV PERE CHARLES DE FOUCAULT','','','61370','ECHAUFFOUR',NULL,NULL,'1371161093001',7.000000000,'1960-06-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2603,'THARSILE','MONIQUE','1932-09-19','02.73.30.45.23','06.91.24.47.03',NULL,'7 RUE SAINTE PAIX','','','14370','ARGENCES',NULL,NULL,'1320961431001',1295.000000000,'1957-09-29','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2604,'GROULT','SIMONE','1930-03-03','02.57.88.97.55','06.11.79.12.33',NULL,'ROUTE D''ARGENCES','','','14370','ARGENCES',NULL,NULL,'1300314679001',203.000000000,'1954-12-25','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2605,'DUBOSCLARD','JEAN','1936-09-09','02.36.98.33.26','06.79.96.23.88',NULL,'LIEU DIT "BORDEAU"','','','14710','VIERVILLE SUR MER',NULL,NULL,'1360951541001',322.000000000,'1960-07-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2606,'LEROUVILLOIS','ANDREE','1937-06-08','02.70.60.47.52','06.17.69.85.01',NULL,'LA VACQUERIE','','',NULL,NULL,NULL,NULL,'2370602543001',62.000000000,'1960-01-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2607,'RIBET','JEAN FRANCOIS','1949-03-18','02.32.90.25.73','06.96.77.42.98',NULL,'13 place de la mairie','','','14000','CAEN',NULL,NULL,'1490350556001',40.000000000,'1979-05-31','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2608,'VANDAELE','','1929-05-26','02.34.16.01.34','06.68.91.71.98',NULL,'12 rue notre dame des champs','','','14540','BOURGUEBUS',NULL,NULL,'2290514628001',23.000000000,'1953-04-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2609,'DE LA CHARLERIE','MARIE THERESE','1964-11-26','02.31.34.64.32','06.70.44.87.62',NULL,'12 rue guy mollet','','','14370','MERY CORBON',NULL,NULL,'2641114675001',22.000000000,'1994-02-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2610,'MAHOUY','YVETTE','1949-03-14','02.79.14.59.28','06.10.06.81.67',NULL,'30 rue le bois preau','','','14120','MONDEVILLE',NULL,NULL,'2490314760001',3372.000000000,'1974-02-22','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2611,'SOREL','SOLANGE','1933-12-05','02.11.20.28.61','06.54.06.72.85',NULL,'37 RUE DE CAUVIGNY','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1331214173001',76.000000000,'1962-05-11','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2612,'CATOIS','ANDREE','1966-09-16','02.22.07.21.66','06.83.39.01.32',NULL,'15 RUE EMMANUEL CHABRIER','','','14630','CAGNY',NULL,NULL,'1660914074001',45.000000000,'1992-06-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2613,'CHESNEL','FRANCOISE','1950-01-07','02.30.58.33.50','06.69.92.68.07',NULL,'3 rue jean jacques rousseau','','','14150','OUISTREHAM',NULL,NULL,'2500150402001',1207.000000000,'1978-02-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2614,'GIARD','BERNADETTE','1939-08-29','02.69.08.11.36','06.52.64.92.35',NULL,'4 rue paul langevin','','','61100','FLERS',NULL,NULL,'2390850071001',19.000000000,'1960-01-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2615,'MARIE','MIREILLE','1937-04-17','02.49.09.71.92','06.59.40.24.25',NULL,'RUE LES MARGUERIE','','','50250','LA HAYE DU PUITS',NULL,NULL,'2370414724001',299.000000000,'1965-04-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2616,'MARIE','JACQUELINE',NULL,'02.80.70.66.63','06.52.89.12.33',NULL,'7 AVENUE MARECHAL FOCH','','','14000','CAEN',NULL,NULL,'1540114745001',201.000000000,'2013-04-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2617,'SALEM','ALAIN','1954-04-17','02.78.91.56.37','06.36.08.28.09',NULL,'25 RUE DES CORMORANS','','','14000','CAEN',NULL,NULL,'1540476650001',28.000000000,'1978-03-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2618,'HAURAY','FRANCOISE','1967-02-16','02.64.45.81.46','06.44.97.79.55',NULL,'9 rue de la chardonnrette','','','14730','GIBERVILLE',NULL,NULL,'2670214596001',237.000000000,'1997-02-24','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2619,'FERRAND','SOLANGE',NULL,'02.82.24.00.83','06.29.56.91.74',NULL,'14 rue centrale','','','61150','LOUCE',NULL,NULL,'1331214403001',131.000000000,'2008-03-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2620,'BEURON','PATRICIA','1931-11-05','02.11.63.25.80','06.10.96.70.54',NULL,'4 impasse des glantiers','','','14320','FONTENAY LE MARMION',NULL,NULL,'2311114294001',110.000000000,'1961-08-12','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2621,'JACQUES','CLAUDINE','1932-04-25','02.10.01.87.73','06.56.07.17.38',NULL,'16 RUE DES CHAMPS BAILLY','','','14700','FALAISE',NULL,NULL,'1320414436001',11.000000000,'1954-04-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2622,'DECAEN','JACQUES','1937-05-02','02.24.48.32.57','06.39.18.30.26',NULL,'17 ROUTE DE LA GUERINIERE','','','14120','MONDEVILLE',NULL,NULL,'2370514126001',2164.000000000,'1961-11-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2623,'MADELAINE','ETIENNE','1938-05-12','02.37.68.22.51','06.81.35.14.45',NULL,'1 LOT LES BIGNETTES','','','14111','LOUVIGNY',NULL,NULL,'1380550381001',24.000000000,'1960-02-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2624,'RONCALLI','MICHEL','1934-11-06','02.21.64.80.29','06.32.80.23.71',NULL,'2 RUE DES BRUYERES','','','14000','CAEN',NULL,NULL,'1341150301001',5.000000000,'1958-04-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2625,'FRAY','PAUL','1939-02-02','02.86.43.38.56','06.11.20.04.87',NULL,'17 CHEMIN SAINT JULIEN','','','14530','LUC SUR MER',NULL,NULL,'1390250082001',797.000000000,'1969-06-20','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2626,'LEMIERE','JEAN','1930-04-03','02.66.90.70.78','06.40.68.48.02',NULL,'18 RUE ALBERT BAYET','','','61310','LE PIN AU HARAS',NULL,NULL,'2300414266001',978.000000000,'1958-08-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2627,'SICOT','RICHARD','1948-02-23','02.10.88.86.83','06.10.29.80.68',NULL,'LA BRECHE AUX OIES','','','14620','CROCY',NULL,NULL,'2480214344001',2.000000000,'1971-04-28','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2628,'JOUANNE','SUZANNE','1948-01-27','02.53.63.40.58','06.55.79.27.15',NULL,'22 RUE DES CANADIENS','','','14140','LES MOUTIERS HUBERT',NULL,NULL,'1480114556001',114.000000000,'1972-07-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2629,'LEROUX','JEAN','1935-04-09','02.47.97.02.29','06.17.58.83.90',NULL,'6 JULES FERRY','','','14110','CONDE SUR NOIREAU',NULL,NULL,'1350439013001',909.000000000,'1957-02-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2630,'DELMOTTE','AUGUSTE','1929-06-21','02.85.74.18.76',NULL,NULL,'3 AVENUE DES ECOLES','','','14700','FALAISE',NULL,NULL,'1290660426001',376.000000000,'1951-08-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2631,'MOTTE','MARIE FRANCOISE','1944-02-15','02.58.89.68.16','06.15.02.62.05',NULL,'13 RUE ALBERT CAMUS','','','14000','CAEN',NULL,NULL,'2440214565001',198.000000000,'1967-11-08','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2632,'MENANT','LEON','1935-08-21','02.79.79.04.30','06.44.45.21.15',NULL,'45 RUE OMAHA','','','14000','CAEN',NULL,NULL,'2350814186001',330.000000000,'1960-01-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2633,'MONHUREL','daniel','1919-10-03','02.82.86.18.86','06.98.53.09.86',NULL,'DEPARTEMENTALE 163 ROUTE DE LISI','EUX','','61320','ROUPERROUX',NULL,NULL,'1191014657001',43.000000000,'1947-07-17','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2634,'LEBRETON','GISELE','1932-10-29','02.29.13.34.58','06.51.91.48.64',NULL,'8 rue des pres','','','14000','CAEN',NULL,NULL,'2321050619001',97.000000000,'1957-09-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2635,'DORTEE','DENISE','1931-01-01','02.28.51.43.86','06.81.71.72.73',NULL,'18 RUE MAURICE FOUQUES','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2310114588001',49.000000000,'1959-11-04','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2636,'RUFFIN','JACKY','1940-06-15','02.24.06.27.06','06.47.88.74.43',NULL,'14 LA FORGETTE','','','14250','FONTENAY LE PESNEL',NULL,NULL,'2400650236001',22.000000000,'1968-02-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2637,'DEGUY','OLIVIER','1939-08-23','02.44.76.40.47','06.49.62.49.00',NULL,'18 rue saint andre porte 27','','','14420','USSY',NULL,NULL,'1390814432001',126.000000000,'1966-07-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2638,'GARNIER','STEPHAN','1960-10-01','02.24.25.39.74',NULL,NULL,'2 BIS RUE EMILE ZOLA RESIDENCE',' NORMANDIA','','14670','TROARN',NULL,NULL,'2601099131001',12.000000000,'1984-01-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2639,'RIBOT','GERARD','1930-09-26','02.61.43.87.50','06.46.22.99.09',NULL,'16 RUE GEORGES BRASSENS','','','14860','BREVILLE LES MONTS',NULL,NULL,'2300950572001',5123.000000000,'1951-12-22','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2640,'LEMOINE','JEANNINE','1930-10-08','02.31.35.95.31','06.74.61.68.58',NULL,'RUE PAUL JAMES','','','50700','URVILLE',NULL,NULL,'1301050437001',283.000000000,'1951-09-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2641,'MATHON','FRANCIS','1939-07-08','02.78.29.32.76','06.52.09.02.76',NULL,'ROUTE DE CAEN','','',NULL,NULL,NULL,NULL,'1390750426001',981.000000000,'1963-02-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2642,'VARIN','ANDRE','1936-09-02','02.29.98.21.75','06.28.27.19.58',NULL,'le bourg','','','14840','DEMOUVILLE',NULL,NULL,'1360985227001',32.000000000,'1961-11-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2643,'SAMSON','RAOUL',NULL,'02.10.14.16.02','06.72.01.11.78',NULL,'PLACE DE LA GARE','','','14330','STE MARGUERITE D''ELLE',NULL,NULL,'1321014711001',170.000000000,'2010-05-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2644,'LEROUILLY','LOUIS','1947-03-26','02.10.85.18.20','06.89.82.09.00',NULL,'40 RUE EMILE ZOLA','','','14670','BURES SUR DIVES',NULL,NULL,'2470314071001',8.000000000,'1969-06-11','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2645,'COUM','AMBROISE MICHEL','1952-04-22','02.11.92.87.20','06.99.07.25.09',NULL,'12 CHEMIN DU CLOS DE SALLES','','','14220','THURY HARCOURT',NULL,NULL,'2520414030001',1639.000000000,'1982-01-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2646,'COEURDOUX','BERNADETTE','1937-02-15','02.68.55.67.35','06.12.02.04.17',NULL,'152 BD LEROY','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1370227243001',795.000000000,'1967-10-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2647,'VERDONCK','MARC','1968-03-28','02.76.89.82.26','06.91.58.00.81',NULL,'','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2680314120001',5.000000000,'1996-05-03','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2648,'LEVEQUE','JACQUELINE','1977-06-22','02.27.41.67.84','06.45.31.47.49',NULL,'24 TER BOULEVARD JOFFRE','','','14860','BAVENT',NULL,NULL,'2770699302001',9.000000000,'2002-02-10','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2649,'DUTERTRE','NATHALIE','1934-05-27','02.98.31.96.67','06.74.52.68.51',NULL,'5 places des jeunes','','','14123','IFS',NULL,NULL,'1340561129001',36.000000000,'1955-04-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2650,'VASLIN','BERNARD','1937-11-11','02.35.43.12.47','06.89.79.29.75',NULL,'13 RESIDENCE LES POMMIERS','','','14470','COURSEULLES SUR MER',NULL,NULL,'2371114266001',354.000000000,'1964-09-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2651,'LECONTE','MARIE-CHRISTIN','1933-02-15','02.10.46.06.61','06.46.21.68.14',NULL,'214 rue d''auge','','','61350','PASSAIS LA CONCEPTION',NULL,NULL,'1330214364001',29.000000000,'1963-01-11','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2652,'LECROQ','MADELEINE',NULL,'02.84.57.34.98','00 33 6.55.91.85.09',NULL,'327 les belle portes','','','14370','BELLENGREVILLE',NULL,NULL,'1330214364001',1507.000000000,'2009-11-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2653,'DESCLOS','DENISE','1932-06-29','02.50.12.51.96','06.10.26.98.72',NULL,'70 rue charles gide','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2320614382001',292.000000000,'1962-08-17','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2654,'LEDEMENEY','FRANCOISE','1935-06-26','02.39.31.73.75','00 33 6.47.33.92.42',NULL,'16 RUE DU PARC','','','14840','CUVERVILLE',NULL,NULL,'2350614581001',66.000000000,'1956-11-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2655,'MABIRE','JEAN MARIE','1936-11-23','02.69.32.93.78','06.28.26.13.84',NULL,'8 rue du vales us dune','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1361114406001',214.000000000,'1958-03-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2656,'RABAN','CLAUDE','1965-02-04','02.51.86.66.92','06.10.24.63.09',NULL,'16 LE BOURG','','','14120','MONDEVILLE',NULL,NULL,'1650214163001',99.000000000,'1991-09-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2657,'LELIEVRE','MADELEINE','1937-05-29','02.87.77.30.31','06.34.19.23.90',NULL,'9 ALLEE DES REBLOTS','','','14120','MONDEVILLE',NULL,NULL,'2370514384001',41.000000000,'1960-02-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2658,'BANDRAC','ANDREE','1951-12-19','02.46.31.09.53','06.11.91.77.93',NULL,'chez madame Lanvoise les houx','','','14310','VILLERS BOCAGE',NULL,NULL,'2511250534001',103.000000000,'1980-07-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2659,'BOLL','DANIEL','1955-03-29','02.41.09.84.93','06.44.67.82.90',NULL,'10 CHEMIN DU FORT','','','14000','CAEN',NULL,NULL,'2550350302001',6.000000000,'1984-02-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2660,'MILLIERE','RAYMOND','1938-06-15','02.56.71.70.27','06.16.17.86.86',NULL,'3 rue de charpentier des champs','','','14000','CAEN',NULL,NULL,'1380650511001',61.000000000,'1960-01-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2661,'LE THIMONNIER','MARTINE','1935-12-01','02.20.07.73.23','06.69.95.00.00',NULL,'6 RUE DE L''OLIFANT','','',NULL,NULL,NULL,NULL,'2351227116001',135.000000000,'1965-05-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2662,'CASTEL','DANIEL','1934-03-31','02.10.38.07.56','06.10.74.80.13',NULL,'15 RUE DU POMMIER GRIS','','','14000','CAEN',NULL,NULL,'1340314145001',469.000000000,'1955-05-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2663,'VIMONT','DANIEL','1935-09-15','02.12.04.05.08','06.25.83.14.92',NULL,'139 chemin de blamont','','','14111','LOUVIGNY',NULL,NULL,'2350914637001',27.000000000,'1965-04-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2664,'MOTIN','MICHEL','1933-06-18','02.46.99.86.59','06.40.87.34.25',NULL,'3 rue morin ruffier','','','14000','CAEN',NULL,NULL,'2330650463001',176.000000000,'1963-03-21','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2665,'VISSE','PIERRE','1949-01-15','02.36.86.24.51','06.73.92.68.35',NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2490135063001',1164.000000000,'1975-09-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2666,'RICHARD','GISELE','1939-02-22','02.68.00.91.93','06.90.07.93.20',NULL,'23 RUE DE LA BIENFAISANCE','','','14370','MOULT',NULL,NULL,'2390250236001',77.000000000,'1960-06-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2667,'BLONDEL','MADELY','1952-06-03','02.10.14.95.89','06.40.90.00.98',NULL,'28 RUE DE LA DEFENSE PASSIVE','','','14370','CROISSANVILLE',NULL,NULL,'2520614406001',819.000000000,'1973-07-15','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2668,'ONFRAY','GINETTE','1939-04-23','02.97.76.37.45','06.53.23.51.21',NULL,'7 RUE DES BRUYERE','','','14210','AMAYE SUR ORNE',NULL,NULL,'2390450042001',4126.000000000,'1969-01-10','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2669,'HEUTTE','EUGENIE','1937-05-14','02.12.92.45.07','06.73.59.90.96',NULL,'56 AVENUE GUILLAUME LE CONQUERAN','T','','61200','AUNOU LE FAUCON',NULL,NULL,'2370550099001',550.000000000,'1961-01-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2670,'JUTANT','BERNARD','1928-02-15','02.82.63.87.08','06.47.33.90.23',NULL,'28 RUE DE CONDE','','','14000','CAEN',NULL,NULL,'1280214515001',107.000000000,'1955-06-28','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2671,'LECOMTE','NICOLE','1939-03-22','02.88.80.25.08','06.57.41.59.15',NULL,'8 AVENUE JOEL MINICI','','','14310','TOURNAY SUR ODON',NULL,NULL,'2390350053001',8.000000000,'1962-03-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2672,'HUET','MARIE THERESE','1963-01-02','02.78.30.44.03','06.47.26.31.01',NULL,'LES FAINS','','','14460','COLOMBELLES',NULL,NULL,'2630114036001',79.000000000,'1989-01-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2673,'LETABAREUX','MARIE CLAIRE','1938-02-08','02.26.56.51.69','06.54.49.25.20',NULL,'2 RUE DU STADE','','','14000','CAEN',NULL,NULL,'1380214469001',287.000000000,'1961-07-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2674,'PLUMERAND','COLETTE','1977-06-16','02.99.87.69.90','06.47.26.96.31',NULL,'LE BOURG','','','14810','GONNEVILLE EN AUGE',NULL,NULL,'2770699302001',2.000000000,'2006-05-09','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2675,'POTTIER','JULIETTE','1933-04-24','02.11.56.23.30','06.85.19.48.15',NULL,'28 ROUTE D HARCOURT','','','14210','ESQUAY NOTRE DAME',NULL,NULL,'2330414505001',243.000000000,'1961-04-24','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2676,'ROUVRAIS','daniel','1939-06-30','02.75.56.53.16','06.47.23.22.24',NULL,'48 RUE CHARLEMAGNE','','','14730','GIBERVILLE',NULL,NULL,'2390614643001',150.000000000,'1960-08-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2677,'LAMOUREUX','MONIQUE','1947-03-07','02.53.79.25.96','06.59.24.31.26',NULL,'15 CITE DES CLOS','','','14610','CAIRON',NULL,NULL,'2470314249001',38.000000000,'1972-04-18','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2678,'','GUY','1969-03-13','02.35.82.17.93','06.32.08.10.30',NULL,'24 marechal joffre','','','14240','LIVRY',NULL,NULL,'1690361063001',311.000000000,'1990-12-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2679,'BEQUET','PAUL','1939-08-15','02.49.79.89.58','06.10.98.84.98',NULL,'ROUTE DE CREULLY','','','14000','CAEN',NULL,NULL,'2390814181001',224.000000000,'1963-01-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2680,'HELIE','PAUL','1964-07-06','02.18.04.61.78','06.82.57.25.17',NULL,'20 ALLEE DES VERGEES','','','14370','BELLENGREVILLE',NULL,NULL,'1640714331001',36.000000000,'1986-01-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2681,'PIOLAIN','GINETTE','1945-03-03','02.85.42.94.18','06.14.96.79.55',NULL,'la longue forge','','','14350','STE MARIE LAUMONT',NULL,NULL,'1450314181001',697.000000000,'1970-07-19','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2682,'MOREL','HENRI','1950-03-21','02.70.05.70.38','06.42.42.94.13',NULL,'3 rue paul langevin','','','14390','CABOURG',NULL,NULL,'2500314364001',194.000000000,'1971-03-23','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2683,'DELAHAYE','CLAUDETTE','1930-04-23','02.15.87.66.70','06.10.34.98.61',NULL,'7 RUE MARGERIE','','','14460','COLOMBELLES',NULL,NULL,'2300414392001',17.000000000,'1953-08-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2684,'POTTIER','MARGUERITE','1929-03-15','02.63.14.54.27','06.77.80.87.47',NULL,'16 RUE MAURICE DENIS','','','14430','DOZULE',NULL,NULL,'2290361376001',72.000000000,'1952-07-02','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2685,'LEFEVRE','ANDREE','1945-06-27','02.62.81.05.61','06.32.17.07.40',NULL,'RESIDENCE ROBERT GAUTIER 21 BD','DU 30 JUIN 1944','','14000','CAEN',NULL,NULL,'1450614448001',299.000000000,'1975-02-13','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2686,'LUCAS','RAYMOND','1940-05-10','02.57.26.41.81','06.61.14.61.87',NULL,'20 RUE LEQUINDRE','','','14860','RANVILLE',NULL,NULL,'1400514654001',54.000000000,'1961-05-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2687,'KARWECKI','RAYMOND','1948-09-29','02.57.38.31.67','06.30.44.55.00',NULL,'12 avenue de la concorde','','','27210','MARTAINVILLE',NULL,NULL,'2480914607001',10.000000000,'1978-03-19','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2688,'LE BLANC','SONIA','1933-09-12','02.17.10.26.67','06.51.46.47.57',NULL,'24 ALLEE DES POETES','','','14190','OUILLY LE TESSON',NULL,NULL,'1330914236001',320.000000000,'1960-07-08','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2689,'DULORD','GEORGETTE','1940-10-15','02.10.28.90.56','06.85.56.16.95',NULL,'142 bis residence normandy rue d','e bayeux','','14000','CAEN',NULL,NULL,'1401014333001',37.000000000,'1961-08-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2690,'MARIE','ARLETTE','1914-07-04','02.33.26.09.81','06.20.70.77.42',NULL,'6 rue armand leveel','','','14000','CAEN',NULL,NULL,'2140750227001',209.000000000,'1936-06-24','GOLD',24,1);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2691,'GEGAT','THERESE','1933-03-14','02.23.49.89.59','06.44.82.06.05',NULL,'11 RUE DU POITOU','','','14480','BANVILLE',NULL,NULL,'1330314046001',2873.000000000,'1955-05-14','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2692,'CAHAGNE','CLAUDINE','1929-04-25','02.64.96.11.25','06.61.96.83.83',NULL,'1 RUE DE BRETAGNE','','','14210','BARON SUR ODON',NULL,NULL,'1290414543001',50.000000000,'1953-06-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2693,'BISSON','EVELINE','1967-03-13','02.99.96.91.44','06.26.38.81.55',NULL,'15 RUE D''ANGLETERRE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2670314221001',15.000000000,'1990-08-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2694,'VICTOIRE','JOSETTE','1969-12-11','02.11.79.52.61','06.17.66.45.95',NULL,'5 RUE MARY TAVY','','','14190','ST SYLVAIN',NULL,NULL,'1691292063001',36.000000000,'1996-05-16','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2695,'RICAUD','nathalie','1957-01-03','02.26.39.04.15','06.96.92.87.54',NULL,'11 IMPASSE DE L''ORANGERAIE','','','14610','THAON',NULL,NULL,'2570114610001',457.000000000,'1980-12-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2696,'HILAIRET','JACQUES','1938-12-30','02.31.24.55.61','06.37.96.22.23',NULL,'20 RUE DU CHEMIN VERT','','','14780','LION SUR MER',NULL,NULL,'1381214581001',54.000000000,'1961-08-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2697,'MAROT','MARCEL','1940-04-16','02.11.50.87.78','06.45.97.57.12',NULL,'23 rue du village','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1400414071001',1396.000000000,'1962-08-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2698,'LAURENT','BERNARD','1962-01-27','02.18.18.43.96','06.60.50.26.38',NULL,'1 PLACE DE LA MAIRIE','','','14270','MEZIDON CANON',NULL,NULL,'2620114221001',1433.000000000,'1985-09-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2699,'PLATEAU','DOMINIQUE','1931-06-12','02.27.49.52.79','06.76.81.40.87',NULL,'le pon neuf','','','14930','ETERVILLE',NULL,NULL,'2310614469001',42.000000000,'1954-09-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2700,'OLIVE','PATRICK','1965-04-01','02.33.01.46.85','06.12.07.46.52',NULL,'5 rue de sandford','','','14100','ST DESIR',NULL,NULL,'2650414704001',115.000000000,'1992-07-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2701,'CHAPPEY','DANIEL','1940-02-19','02.63.66.16.66','06.10.13.58.58',NULL,'13 chemin de caen','','','50480','AMFREVILLE',NULL,NULL,'2400224481001',31.000000000,'1968-03-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2702,'FONTAINE','LUCIENNE','1938-03-23','02.65.96.65.58','06.49.88.80.36',NULL,'25 grande rue','','','14730','GIBERVILLE',NULL,NULL,'1380314133001',69.000000000,'1963-07-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2703,'BORDONNET','claude','1940-04-13','02.79.76.09.21','06.50.06.86.79',NULL,'2 LE MESNIL','','','14940','SANNERVILLE',NULL,NULL,'1400414714001',409.000000000,'1961-08-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2704,'MARIE','YVONNE','1932-09-22','02.38.33.58.66','06.69.74.72.26',NULL,'7 RUE SAINT ELOI','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2320950216001',1254.000000000,'1953-04-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2705,'GADY','IGAR','1936-10-01','02.44.49.77.62','06.90.66.09.76',NULL,'6 rue d ''auge','','','14123','IFS',NULL,NULL,'1361014020001',270.000000000,'1964-04-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2706,'D''ANDREA','SUZANNE','1936-06-13','02.43.95.07.29','06.11.51.64.92',NULL,'164 RUE DU SIEUR DE BRAS','','','14540','GRENTHEVILLE',NULL,NULL,'1360627522001',681.000000000,'1959-07-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2707,'ROBERT','RAYMONDE','1929-12-04','02.10.05.77.41','06.96.81.58.10',NULL,'1 rue jean philippe rameau','','','14860','BREVILLE LES MONTS',NULL,NULL,'1291214160001',16.000000000,'1951-12-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2708,'LEGALLET','ANNABELLE','1985-06-14','02.66.67.63.01','06.12.20.36.97',NULL,'12 rue marie curry','','','14730','GIBERVILLE',NULL,NULL,'2850699406001',64.000000000,'2008-11-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2709,'LETOURNEUR','MADELEINE','1956-01-30','02.23.60.24.72','06.56.85.30.79',NULL,'6 AVENUE DU CANADA','','','14670','ST SAMSON',NULL,NULL,'1560135186001',90.000000000,'1980-03-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2710,'BREUIL','SIMONNE','1935-10-03','02.98.66.03.33','06.31.51.26.93',NULL,'25 RUE DE L''EGLISE','','','14310','PARFOURU SUR ODON',NULL,NULL,'2351014494001',187.000000000,'1956-10-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2711,'THERESE','GISELE','1943-05-27','02.18.69.76.01','06.17.70.23.71',NULL,'20 RUE LA BATAILLE','','','50860','LE MESNIL OPAC',NULL,NULL,'1430514323001',21.000000000,'1968-07-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2712,'YON','CLAUDE','1964-05-23','02.84.13.02.42','06.66.84.65.70',NULL,'HAMEAU PERIGNY','','','14123','IFS',NULL,NULL,'1640514087001',72.000000000,'1986-02-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2713,'SALLE','Andre','1952-03-21','02.33.57.35.06','06.55.04.00.90',NULL,'LA BARBELIERE','','','14220','CROISILLES',NULL,NULL,'2520314021001',10.000000000,'1974-10-21','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2714,'KREJPOWICZ','Emile','1968-08-29','02.33.05.24.43','06.40.49.09.56',NULL,'56 RUE DES CALLOUINS','','','14840','CUVERVILLE',NULL,NULL,'2680814009001',1726.000000000,'1991-10-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2715,'VERHAEGHE','JEAN','1934-04-24','02.95.25.66.73','06.71.40.38.26',NULL,'2 RUE DU COLOMBIER ST HILAIRE PE','TITVILLE','','14150','OUISTREHAM',NULL,NULL,'2340414304001',189.000000000,'1956-12-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2716,'MARIE','MARTINE','1932-08-10','02.92.46.11.84','06.10.20.33.46',NULL,'961 chemin du val','','','14460','COLOMBELLES',NULL,NULL,'1320850616001',712.000000000,'1953-04-16','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2717,'CALBRY','CHRISTINE','1932-08-29','02.24.97.00.68','06.11.40.20.40',NULL,'6 RUE DES DEPORTES','','','14460','COLOMBELLES',NULL,NULL,'1320850616001',232.000000000,'1955-09-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2718,'CAUBRIERE','THERESE','1958-08-12','02.45.41.09.35','06.68.37.35.79',NULL,'6 RUE DES TILLEULS','','','14000','CAEN',NULL,NULL,'1580814340001',40.000000000,'1981-05-23','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2719,'TISON','PAULETTE','1933-11-02','02.21.23.10.54','06.39.51.33.31',NULL,'1 rue cravas','','','50000','ST LO',NULL,NULL,'2331114101001',9.000000000,'1958-04-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2720,'LEBOURGEOIS','HENRI','1929-11-04','02.84.65.27.10','06.98.96.47.38',NULL,'56 rue des caillouins','','',NULL,NULL,NULL,NULL,'1291114365001',1835.000000000,'1953-12-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2721,'LAHAYE','JACQUES','1929-11-25','02.18.71.51.66','06.10.64.94.01',NULL,'22 RUE DE CORBEILLE','','','14620','BAROU EN AUGE',NULL,NULL,'1291114365001',173.000000000,'1953-05-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2722,'DELAIN','DANIELLE','1937-06-05','02.46.44.02.15','06.73.85.23.54',NULL,'9 RUE DE L''AMIRAL COURBET','','','14710','LA FOLIE',NULL,NULL,'1370614204001',57.000000000,'1964-03-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2723,'LAMY','JEAN','1930-04-26','02.20.44.51.71','06.10.99.98.33',NULL,'7 rue de l egalite','','','14000','CAEN',NULL,NULL,'1300427425001',84.000000000,'1954-06-24','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2724,'DUPONT','REINE','1931-11-18','02.24.18.35.19','06.31.20.65.79',NULL,'32 CHEMIN DE LA CROIX VAUTIER','','','14220','MARTAINVILLE',NULL,NULL,'1311155043001',111.000000000,'1961-11-02','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2725,'LERDU','ANNICK','1962-01-14','02.31.41.02.69','06.31.99.60.19',NULL,'29 LA DUNE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2620150377001',118.000000000,'1989-08-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2726,'FOUBERT','MARC','1929-01-12','02.89.40.62.30','06.76.97.51.39',NULL,'RUE DU MOUTTIER','','','14000','CAEN',NULL,NULL,'1290114149001',3569.000000000,'1959-05-08','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2727,'MARIE','JACQUES','1933-03-25','02.22.76.95.00','06.15.64.48.34',NULL,'7 CHEMIN DE LA HAIE MORIN','','','14240','CAUMONT L''EVENTE',NULL,NULL,'1330314580001',51.000000000,'1954-01-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2728,'SIMONNET','MARIE','1946-05-02','02.68.41.85.69','06.28.83.17.73',NULL,'4 RUE DES LILAS','','','14170','L''OUDON',NULL,NULL,'1460514721001',619.000000000,'1968-10-04','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2729,'LE COHUE','MAURICE','1957-04-07','02.92.74.93.66',NULL,NULL,'19 route d ''esquay','','','61160','FEL',NULL,NULL,'1570461037001',6.000000000,'1986-11-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2730,'SOBOL','JEAN','1966-03-31','02.11.34.06.25','06.53.89.37.45',NULL,'chemin de l hopital','','','14940','SANNERVILLE',NULL,NULL,'1660302326001',1027.000000000,'1989-11-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2731,'SINEUX','ANDREE','1930-08-30','02.72.38.93.55','06.78.31.48.79',NULL,'3 RUE ROGER BASTION','','','14370','AIRAN',NULL,NULL,'2300814008001',1.000000000,'1955-06-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2732,'DUCLOS','FERNAND','1937-02-18','02.20.29.82.18','06.12.07.74.27',NULL,'LA COUTURE DES CHESNES','','','14000','CAEN',NULL,NULL,'1370214266001',11.000000000,'1967-04-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2733,'PATRY','BERNARD',NULL,'02.18.09.26.80','06.42.03.83.34',NULL,'13 place de la mairie','','','14270','LE MESNIL MAUGER',NULL,NULL,'2520214074001',35.000000000,'2008-11-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2734,'FOUQUEREL','CLAUDE','1944-05-10','02.21.77.35.12','06.43.51.47.28',NULL,'14 rue de la marne','','','14730','GIBERVILLE',NULL,NULL,'2440514758001',18.000000000,'1971-10-12','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2735,'LEGRAND','SYLVIE','1966-01-11','02.40.10.38.28','06.69.47.78.25',NULL,'1 RUE ROGER POULIN APPT R2','','','14540','SOLIERS',NULL,NULL,'1660150615001',106.000000000,'1989-11-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2736,'LEMONNIER','ERIC','1930-09-28','02.31.92.83.87','06.43.95.38.36',NULL,'15 RUE LE FERRAGE','','','14123','IFS',NULL,NULL,'1300956149001',1407.000000000,'1955-08-24','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2737,'BLONDEAU','MAURICE','1934-06-21','02.81.57.23.63','06.85.83.38.82',NULL,'15 RUE LE FERRAGE','','','14120','MONDEVILLE',NULL,NULL,'1340635108001',2320.000000000,'1956-06-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2738,'TANQUEREL','LIONEL','1933-05-13','02.35.85.66.52','06.50.65.75.20',NULL,'19 RUE DE L''EGLISE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2330561427001',18.000000000,'1954-02-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2739,'DUBOSCLARD','MARGUERITE','1967-04-05','02.10.26.68.68','06.49.25.68.89',NULL,'70 RUE DES EPIVAS','','','14220','ST MARTIN DE SALLEN',NULL,NULL,'2670414356001',514.000000000,'1992-06-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2740,'BABILOTTE','FRANCOIS','1961-02-02','02.43.55.45.02','06.83.04.88.52',NULL,'13 RUE DU PETIT CLOS','','','14830','LANGRUNE SUR MER',NULL,NULL,'1610261474001',292.000000000,'1991-12-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2741,'CHAUVEAU','PIERRETTE','1928-12-30','02.58.67.98.38','06.52.49.92.25',NULL,'6 RUE DU PRESSOIR','','','14840','CUVERVILLE',NULL,NULL,'1281202018001',11.000000000,'1952-06-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2742,'KROB','OLIVIER','1944-10-31','02.25.44.86.81','06.39.67.07.34',NULL,'1 RUE DE VAUCELLES','','','14610','CAMBES EN PLAINE',NULL,NULL,'1441076427001',208.000000000,'1965-12-20','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2743,'PELCERF','OLIVIER','1937-12-01','02.14.26.40.89','06.16.16.55.24',NULL,'6 RUE PASTEUR','','','14123','IFS',NULL,NULL,'1371250615001',1250.000000000,'1962-03-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2744,'SALAGNAC','BERNARD','1944-03-17','02.66.87.94.08','06.79.81.24.15',NULL,'10 BIS RUE BELLANDIERE','','','14270','MEZIDON CANON',NULL,NULL,'2440314118001',723.000000000,'1973-09-26','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2745,'EUSTACE','EVELYNE','1949-01-19','02.11.28.52.93','06.34.21.07.71',NULL,'1 rue leopold trebutien','','','14320','MAY SUR ORNE',NULL,NULL,'1490114747001',74.000000000,'1972-01-12','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2746,'BOURGOIN','RENE','1930-06-30','02.98.35.69.46','06.51.94.68.96',NULL,'4 PLACE DU PARC','','','14123','FLEURY SUR ORNE',NULL,NULL,'2300661431001',90.000000000,'1959-06-01','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2747,'LE CANU','FRANCOISE','1937-09-08','02.42.29.20.74',NULL,NULL,'8 BOULEVARD ALSACE LORRAINE','','','14400','MAISONS',NULL,NULL,'2370961464001',16.000000000,'1959-12-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2748,'CODEMO','ROBERT','1928-04-08','02.45.75.15.81','06.99.90.06.63',NULL,'5 ALLEE DES 4 SAISONS','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2280414685001',73.000000000,'1952-02-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2749,'LEDUC','PAUL','1933-11-14','02.27.11.23.49','06.10.25.49.45',NULL,'4 RUE CAMILLE DRAPEAU','','','14670','ST SAMSON',NULL,NULL,'2331114369001',6.000000000,'1954-02-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2750,'MONROTY','paul','1932-03-23','02.74.33.13.41',NULL,NULL,'','','','14370','BELLENGREVILLE',NULL,NULL,'1320314146001',944.000000000,'1956-03-19','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2751,'GUESDON','JACQUELINE','1930-03-20','02.45.83.39.52','06.80.32.35.65',NULL,'13 rue de l''abbaye','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1300314145001',454.000000000,'1957-02-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2752,'PICARD','PASCAL',NULL,'02.18.26.41.91','06.27.03.57.33',NULL,'25 RESIDENCE DES MAUVIS','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'2380314098001',22.000000000,'2011-06-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2753,'NIARD','SUZANNE','1961-02-07','02.92.14.38.69','06.50.74.59.99',NULL,'23bis pere charles de foucault','','','14120','MONDEVILLE',NULL,NULL,'2610227654001',6.000000000,'1987-05-05','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2754,'SZYMANSKI','JACQUES','1935-12-29','02.98.76.92.21','06.44.65.52.24',NULL,'12 RUE DE LA MAIRIE','','','61200','OCCAGNES',NULL,NULL,'2351214732001',712.000000000,'1956-05-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2755,'LHERMENIER','BERNARD','1945-01-25','02.46.04.29.33','06.10.41.75.62',NULL,'11 RUE ELIANE','','','14210','AMAYE SUR ORNE',NULL,NULL,'1450118098001',5034.000000000,'1971-12-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2756,'GICQUEL','BERNARD','1933-01-28','02.83.75.18.72','06.78.56.54.56',NULL,'VALLEE D''OIGNE','','','14220','BARBERY',NULL,NULL,'1330114579001',426.000000000,'1956-05-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2757,'BOUDANT','PAULETTE','1981-09-16','02.48.44.05.92','06.44.49.54.42',NULL,'34 ALLEE DU GRAND BARACHOIS','','','14320','FONTENAY LE MARMION',NULL,NULL,'2810999416001',149.000000000,'2005-03-10','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2758,'LETONDEUR','ODETTE',NULL,'02.43.65.05.32','06.72.14.76.20',NULL,'22 RUE GEORGES BRASSENS','','','14000','CAEN',NULL,NULL,'1350114517001',797.000000000,'2012-11-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2759,'LEGALLAIS','MONIQUE','1928-03-10','02.10.75.81.38','06.51.37.46.73',NULL,'5 bd de l''esperance','','','14540','SOLIERS',NULL,NULL,'2280314747001',42.000000000,'1958-01-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2760,'CARPENTIER','NELLY','1933-10-13','02.91.94.44.52','06.10.91.49.45',NULL,'48 rue v lepine','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'2331014153001',969.000000000,'1955-08-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2761,'GERMAIN','RENEE',NULL,'02.48.18.94.92','06.72.74.78.27',NULL,'ROUTE DE BOULON  LE BOURG','','','14120','MONDEVILLE',NULL,NULL,'1620114020001',630.000000000,'2009-03-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2762,'RIBET','MICHEL','1962-01-15','02.33.36.53.80','00 33 6.60.30.53.92',NULL,'7 BIS RUE PORTE MILLET','','','14270','MEZIDON CANON',NULL,NULL,'1620114020001',25.000000000,'1985-06-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2763,'CLANCHE','ALBERT','1928-08-19','02.56.86.51.99','06.73.02.94.92',NULL,'73 RUE GERICAULT','','','14000','CAEN',NULL,NULL,'2280814125001',189.000000000,'1955-09-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2764,'LEFEVRE','SERGE','1936-12-02','02.54.72.22.27','06.61.95.46.01',NULL,'305 QUARTIER GRANDE DELLE','','','50000','ST LO',NULL,NULL,'1361214207001',72.000000000,'1961-06-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2765,'ABED BAHTSOU','SIMONE','1966-04-18','02.52.54.17.86','06.27.98.50.93',NULL,'4 RUE DES MARRONNIERS','','','14240','SEPT VENTS',NULL,NULL,'2660414003001',361.000000000,'1992-10-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2766,'YVER','GENEVIEVE','1935-07-05','02.25.95.88.12','06.42.23.50.66',NULL,'','','','14370','BELLENGREVILLE',NULL,NULL,'1350777373001',111.000000000,'1959-05-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2767,'BOUCHARD','CHRISTOPHE','1935-07-17','02.11.82.07.61','06.50.86.86.97',NULL,'123 BD LEROY','','','14490','LE TRONQUAY',NULL,NULL,'1350777373001',12.000000000,'1959-10-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2768,'LESSELINE','JACQUES','1928-01-03','02.53.43.86.39','06.69.19.37.21',NULL,'CHEMIN TUILE','','','61600','LA FERTE MACE',NULL,NULL,'1280150147001',88.000000000,'1956-06-29','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2769,'ONFRAY','MARINO','1932-01-25','02.86.40.35.58','06.50.59.37.80',NULL,'12 RUE DU PARC','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2320150157001',562.000000000,'1959-01-14','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2770,'ROULAND','Robert','1930-02-21','02.65.67.14.75','06.10.45.78.32',NULL,'12 RUE DE L''ANCIENNE GARE','','','50500','BREVANDS',NULL,NULL,'1300214431001',409.000000000,'1951-12-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2771,'PASQUET','PAUL','1934-02-05','02.44.96.18.88','06.90.87.97.34',NULL,'LES MOULINS','','','14190','URVILLE',NULL,NULL,'2340214323001',189.000000000,'1957-07-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2772,'AUMONT','PIERRE','1955-05-04','02.48.03.41.23','06.87.53.39.98',NULL,'31 RUE CHATEAUBRIAND','','','14120','MONDEVILLE',NULL,NULL,'1550514548001',258.000000000,'1983-07-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2773,'GAUGIN','MIREILLE','1940-07-15','02.77.42.16.20','06.40.54.76.30',NULL,'12 BOULEVARD POMPIDOU','','','14320','MAY SUR ORNE',NULL,NULL,'1400714384001',42.000000000,'1962-11-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2774,'FRANCOISE','JULES','1938-05-01','02.53.56.23.01','06.21.42.99.80',NULL,'7 RUE DU DR TROLLEY','','','14460','COLOMBELLES',NULL,NULL,'1380514331001',1241.000000000,'1966-06-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2775,'BOULLANGER','MAURICE','1968-02-17','02.23.23.92.86','06.40.76.19.05',NULL,'11 RUE DU BAC DU PORT','','','14540','ROCQUANCOURT',NULL,NULL,'2680214057001',97.000000000,'1991-11-16','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2776,'CHESNEL','JEAN','1938-02-04','02.23.55.90.35','06.12.65.95.50',NULL,'38 RUE EUGENE MAES','','','14000','CAEN',NULL,NULL,'2380227129001',59.000000000,'1960-02-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2777,'PERRIER','','1948-02-19','02.11.75.76.44','06.78.13.76.75',NULL,'9 RUE DU BOIS','','','50250','PRETOT STE SUZANNE',NULL,NULL,'2480214538001',23.000000000,'1971-03-24','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2778,'DYVRANDE','VALERIE','1940-10-28','02.21.37.89.46','06.61.49.10.61',NULL,'9 RUE DU LABRADOR','','','14150','OUISTREHAM',NULL,NULL,'2401014686001',89.000000000,'1970-05-15','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2779,'DUMONT','YVES','1943-08-14','02.61.16.64.51','06.39.04.00.66',NULL,'40 RUE PONT AUDEMER','','','14000','CAEN',NULL,NULL,'1430866217001',429.000000000,'1966-03-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2780,'DESRETTES','GUY','1940-11-17','02.66.09.57.22','06.84.16.83.49',NULL,'19 RUE D ATHENES','','','14860','RANVILLE',NULL,NULL,'2401150046001',313.000000000,'1961-02-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2781,'MOTTIN','MARCEL','1929-09-17','02.52.32.67.24','06.61.89.05.50',NULL,'8 RUE DU STEDE','','','14120','MONDEVILLE',NULL,NULL,'2290914588001',125.000000000,'1956-05-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2782,'RENAUT','MICHEL','1966-06-05','02.68.03.15.66','06.83.52.68.41',NULL,'28 RUE DES TILLEULS','','','14630','CAGNY',NULL,NULL,'2660675073001',417.000000000,'1991-08-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2783,'REHE','ROLANDE','1937-12-29','02.58.55.93.23','06.71.58.16.90',NULL,'22  BIS RUE ARISTIDE BRIAND','','','14000','CAEN',NULL,NULL,'1371214076001',3460.000000000,'1961-11-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2784,'MAGOARIEC','PAULETTE','1934-03-26','02.81.86.72.47','06.10.05.47.37',NULL,'23 BD SCHUMAN','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1340350635001',3933.000000000,'1960-01-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2785,'TOSTAIN','JANINE','1931-02-19','02.73.20.45.27','06.10.19.63.68',NULL,'46 RUE ARISTIDE BRIAND','','','14220','ST MARTIN DE SALLEN',NULL,NULL,'2310214552001',53.000000000,'1955-04-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2786,'BREARD','ROGER','1928-02-09','02.57.53.81.90','06.35.43.94.38',NULL,'3 rue d etavaux','','','14480','BAZENVILLE',NULL,NULL,'1280214059001',309.000000000,'1958-10-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2787,'LEBEL','MICHEL','1930-09-11','02.11.89.67.48','06.43.60.49.53',NULL,'10 RUE VAL ES DUNES','','','14460','COLOMBELLES',NULL,NULL,'2300950624001',14.000000000,'1958-05-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2788,'CARABY','MARIE CLAIRE','1931-04-20','02.79.65.40.65','06.27.68.93.11',NULL,'1 RUE DE LA  DEMI LUNE','','','14000','CAEN',NULL,NULL,'2310414010001',39.000000000,'1955-08-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2789,'DUREL','ALAIN','1919-12-25','02.11.82.95.38','06.10.16.04.25',NULL,'5 rue des courtils','','','14000','CAEN',NULL,NULL,'1191214731001',38.000000000,'1941-01-11','PLATINIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2790,'LABBEY','Pierre','1936-06-05','02.91.06.14.52','06.73.30.23.03',NULL,'11 RUE DE LA REPUBLIQUE','','','14000','CAEN',NULL,NULL,'1360614425001',427.000000000,'1957-12-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2791,'MARTIN','Louis','1930-07-25','02.82.25.93.21','06.17.87.70.78',NULL,'9 RUE COMMANDANT LE COUTOUR','','','14000','CAEN',NULL,NULL,'1300780579001',24.000000000,'1957-04-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2792,'SCHMIECHEN','ARMAND','1940-01-03','02.67.00.26.37','00 33 6.84.17.53.42',NULL,'16 RUE DE L''ECOLE','','','14740','PUTOT EN BESSIN',NULL,NULL,'2400150077001',21.000000000,'1963-10-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2793,'BERTOLI','CHRISTIANE','1938-08-06','02.11.26.68.81','06.71.05.41.85',NULL,'6 RUE DES FRERES LEPAULE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1380814730001',2547.000000000,'1960-01-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2794,'RETOUT','GINETTE','1932-02-23','02.83.25.87.30','06.10.72.27.97',NULL,'32 rue du coudray','','','14000','CAEN',NULL,NULL,'2320214730001',893.000000000,'1960-11-24','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2795,'GILBERT','ROLANDE','1953-02-19','02.66.67.81.15','06.56.79.20.18',NULL,'2 bis chemin aux boeufs','','',NULL,NULL,NULL,NULL,'1530214062001',1042.000000000,'1974-01-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2796,'AUBRY','GISELE',NULL,'02.13.01.65.10','06.81.40.84.79',NULL,'RUE PETIT COULIBOEUF','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'1530214062001',86.000000000,'2009-10-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2797,'DAIGNEAU','roger','1940-07-27','02.51.85.54.43','06.53.00.96.67',NULL,'39 RUE PASTEUR','','','14610','CAIRON',NULL,NULL,'2400750213001',38.000000000,'1965-03-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2798,'HAYE','ROLANDE','1937-02-21','02.68.88.31.95','06.16.08.44.13',NULL,'8 RUE MICHEL ANGIER','','','14730','GIBERVILLE',NULL,NULL,'1370227251001',13.000000000,'1959-11-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2799,'CACHARD','x','1955-06-05','02.36.48.07.81','06.55.53.74.29',NULL,'21 RUE DES PRES','','','14400','BAYEUX',NULL,NULL,'2550614118001',206.000000000,'1976-03-24','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2800,'MARIE','RAYMONDE','1939-02-07','02.28.65.25.15','06.11.82.40.76',NULL,'ROUTE DE MAIZIERES','','',NULL,NULL,NULL,NULL,'2390214225001',200.000000000,'1969-07-28','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2801,'AUBIN','MICHEL','1963-02-06','02.11.49.27.33','06.12.28.35.33',NULL,'75 rue d auge','','','14150','OUISTREHAM',NULL,NULL,'2630260537001',7.000000000,'1989-02-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2802,'FARCY','DOMINIQUE','1966-08-29','02.53.89.78.05','06.63.86.70.61',NULL,'LA COUTURE BOIREL','','','14123','FLEURY SUR ORNE',NULL,NULL,'2660814495001',56.000000000,'1987-04-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2803,'LAINE','Guy','1931-03-29','02.79.95.91.75','06.16.93.90.06',NULL,'48 rue du tour de ville','','','14270','LE MESNIL MAUGER',NULL,NULL,'1310314471001',23.000000000,'1959-12-06','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2804,'SAUTERAUD','MARIA CAROLINE','1947-02-12','02.62.91.89.92','06.20.22.28.26',NULL,'54 RUE DU BOUT DU HAUT','','','61200','ARGENTAN',NULL,NULL,'1470214666001',18.000000000,'1969-11-14','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2805,'BOUYOL','Madeleine','1931-02-07','02.11.40.12.71','06.64.82.16.42',NULL,'7 RUE DES CHATAIGNIERS','','','14320','FONTENAY LE MARMION',NULL,NULL,'1310214118001',1077.000000000,'1954-10-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2806,'LEPELTIER','GISELE','1936-01-18','02.32.54.09.58','06.56.06.31.20',NULL,'18 rue de cingal','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1360155500001',669.000000000,'1958-08-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2807,'LENOBLE','YVETTE','1938-11-23','02.12.17.68.62','06.45.64.50.06',NULL,'2 rue res de la chaudiere','','','56400','PLUNERET',NULL,NULL,'1381150021001',425.000000000,'1959-10-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2808,'MANSON','JEAN FRANCOIS','1935-12-09','02.11.51.95.57','06.45.59.98.62',NULL,'14 ALLEE DES POETES','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1351260236001',1201.000000000,'1958-01-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2809,'BOUFFAY','Denis','1950-04-11','02.48.41.84.95','06.24.75.47.71',NULL,'154 ROUTE D''HARCOURT','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'1500414242001',38.000000000,'1971-08-26','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2810,'LOMBARD','VINCENT','1939-09-06','02.80.75.46.82','06.30.41.67.03',NULL,'42 RUE DU 20 E SIECLE','','','14400','BAYEUX',NULL,NULL,'2390914523001',25.000000000,'1962-08-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2811,'REBULET','MONIQUE',NULL,'02.90.65.86.85','06.47.80.84.18',NULL,'3 RUE LEBAUDY','','','14860','BAVENT',NULL,NULL,'1310414622001',150.000000000,'2009-02-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2812,'MADELAINE','XAVIER','1940-06-03','02.37.57.70.46','06.10.09.83.20',NULL,'LE DOUET BARON','','','14940','SANNERVILLE',NULL,NULL,'1400614201001',841.000000000,'1962-01-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2813,'LEMAITRE','claudia','1960-03-15','02.12.07.95.15','06.49.17.65.74',NULL,'11 RUE DE L ABBAYE','','','14000','CAEN',NULL,NULL,'1600314538001',2063.000000000,'1989-04-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2814,'LEMARIE','MARCEL','1940-12-08','02.12.22.26.79','06.60.52.65.84',NULL,'41 rue aristide briand','','','50880','PONT HEBERT',NULL,NULL,'2401214417001',586.000000000,'1965-01-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2815,'LANGLAIS','BERNARD','1956-02-21','02.80.87.06.74',NULL,NULL,'LA BOIS NORMANDE','','','50500','CARENTAN',NULL,NULL,'2560214290001',88.000000000,'1986-02-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2816,'LANGLOIS','MONIQUE','1968-08-01','02.36.16.87.87','06.40.84.59.37',NULL,'RESIDENCE COLBERT 1ER ETAGE  N1','2','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2680814658001',256.000000000,'1990-09-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2817,'ROULLAND','CAROLE','1979-01-23','02.48.53.65.59','06.82.75.10.21',NULL,'','','','14730','GIBERVILLE',NULL,NULL,'2790198739001',179.000000000,'2007-01-23','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2818,'BRETEL','PIERRE','1947-02-15','02.47.41.85.11','06.50.73.26.61',NULL,'326 RUE JACQUES CARTIER BOIS MA','RCEL','','14123','CORMELLES LE ROYAL',NULL,NULL,'1470214535001',39.000000000,'1968-06-22','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2819,'LEMERRE','rene','1938-09-24','02.47.72.33.67','06.65.95.79.57',NULL,'25 BOULEVARD DE L''ESPERANCE','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2380950397001',27.000000000,'1968-06-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2820,'MARLIAC','COLETTE','1934-11-18','02.43.71.40.14','06.32.22.45.03',NULL,'LES GUERRES','','','14000','CAEN',NULL,NULL,'2341114703001',176.000000000,'1955-06-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2821,'FORT','MIREILLE','1939-07-24','02.75.29.43.33','06.62.70.42.78',NULL,'12 RUE DE ROME','','','14000','CAEN',NULL,NULL,'2390753275001',986.000000000,'1960-11-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2822,'LEMONNIER','BERNARD','1940-02-09','02.46.28.92.33','06.35.90.72.25',NULL,'7 RESIDENCE DES SOURCES','','','14000','CAEN',NULL,NULL,'1400214758001',1791.000000000,'1968-10-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2823,'PAYNEL','ANDREE','1944-05-01','02.91.12.27.56','06.78.20.71.90',NULL,'10 rue de l hudson','','','14220','ST MARTIN DE SALLEN',NULL,NULL,'2440561060001',54.000000000,'1966-06-30','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2824,'BENJENEC','JULES','1929-12-01','02.11.91.30.30','06.62.54.59.80',NULL,'27 RUE MARIE HAREL','','','14210','MAISONCELLES SUR AJON',NULL,NULL,'1291214654001',29.000000000,'1954-07-12','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2825,'TANQUERAY','MICHEL','1935-09-21','02.56.86.51.07','06.66.01.54.49',NULL,'20 RUE DU SOLEIL LEVANT','','','50210','CERISY LA SALLE',NULL,NULL,'1350950211001',52.000000000,'1958-10-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2826,'POSTEL','BERNARD','1937-12-14','02.86.46.61.50','06.64.10.60.81',NULL,'2 IMPASSE DU VALTRU','','','14860','BAVENT',NULL,NULL,'2371261375001',213.000000000,'1960-05-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2827,'CHARLES','CHARLES','1936-08-20','02.31.56.99.05','06.41.53.47.61',NULL,'34 rue des mesanges','','','14000','CAEN',NULL,NULL,'1360827035001',865.000000000,'1963-07-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2828,'DELPOSEN','JEAN','1939-10-12','02.11.80.66.85','06.89.22.89.90',NULL,'1 rue du beton vibr','','','14120','MONDEVILLE',NULL,NULL,'1391014266001',237.000000000,'1967-07-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2829,'BISSON','MICHELLE','1930-01-08',NULL,NULL,NULL,'1 RUE DU LUCET','','','14310','VILLERS BOCAGE',NULL,NULL,'1300114552001',3221.000000000,'1951-03-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2830,'LEROUX','BERNADETTE','1940-10-27','02.80.67.73.91','06.12.05.50.72',NULL,'39 RUE JEAN VILAR','','','14540','BOURGUEBUS',NULL,NULL,'2401050149001',229.000000000,'1970-11-09','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2831,'DECOUFLEY','BERNARD','1939-01-17','02.66.79.67.39','06.87.76.37.67',NULL,'les fours a chaud','','','14000','CAEN',NULL,NULL,'2390127425001',1105.000000000,'1960-08-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2832,'LAMOUREUX','BERNARD','1939-01-18','02.91.25.95.00','06.11.71.84.82',NULL,'16 RUE HAUTE','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'2390127425001',204.000000000,'1964-01-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2833,'CARUEL','ANDRE','1930-08-24','02.86.34.41.86','06.47.29.21.53',NULL,'5 RUE BICOQUET','','','14400','LONGUES SUR MER',NULL,NULL,'2300814338001',3.000000000,'1953-03-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2834,'PARIS','MADELEINE','1946-01-09','02.59.94.72.05','06.30.45.44.51',NULL,'','','','14140','LISORES',NULL,NULL,'2460114424001',398.000000000,'1973-12-05','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2835,'DE BADEREAU DE ST MARTIN','JOCELYNE','1950-01-09','02.47.70.24.98','06.13.78.18.12',NULL,'21 RUE DE ROUEN','','','14370','ARGENCES',NULL,NULL,'2500114278001',144.000000000,'1974-02-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2836,'DEMORIEUX','MICHEL','1935-08-26','02.82.46.64.77','06.53.71.84.20',NULL,'3 SQUARE DES MESANGES','','','14650','CARPIQUET',NULL,NULL,'1350850094001',26.000000000,'1960-04-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2837,'GOULEY','DANIEL',NULL,'02.27.02.08.38','06.11.06.20.40',NULL,'4 RUE DE LA CHAUSSE','','','14220','ST MARTIN DE SALLEN',NULL,NULL,'2510214263001',40.000000000,'2011-04-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2838,'BLANCHEMAIN','ANDRE','1963-06-26','02.99.88.67.81','06.23.67.61.28',NULL,'9 AVENUE ALBERT FEVRIER','','',NULL,NULL,NULL,NULL,'1630676260001',497.000000000,'1987-09-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2839,'BELLAMY','MARIE','1933-11-11','02.14.25.19.89','06.57.76.34.82',NULL,'51 RUE DU GENERAL LECLERC','','','14000','CAEN',NULL,NULL,'1331114689001',1866.000000000,'1957-06-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2840,'SEIGNEURIE','COLETTE',NULL,'02.34.99.63.42','06.98.03.58.36',NULL,'5 RUE DES CANADIENS','','','14190','FIERVILLE BRAY',NULL,NULL,'2630414712001',415.000000000,'2009-10-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2841,'DELAITRE','Andre','1940-09-18','02.95.25.39.40','06.92.33.47.07',NULL,'22 rue des chanterelles','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2400914123001',129.000000000,'1963-12-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2842,'HEBERT','MICHEL','1952-01-14','02.20.48.80.79','06.28.96.26.49',NULL,'','','','14000','CAEN',NULL,NULL,'2520150401001',119.000000000,'1981-05-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2843,'MORDANT','BRIGITTE','1939-03-29','02.98.57.58.30','06.12.34.70.88',NULL,'les maisons barrees','','','14530','LUC SUR MER',NULL,NULL,'1390350486001',17.000000000,'1965-07-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2844,'LESERGENT','GILBERT','1961-05-29','02.30.93.31.43','06.35.45.61.85',NULL,'14 RUE HIPPOLYTE MONIN','','','14000','CAEN',NULL,NULL,'2610514335001',116.000000000,'1985-07-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2845,'RIVOGNAC','AGNES','1937-11-03','02.30.57.46.54','06.98.90.50.44',NULL,'24 RUE DU CLOS DU PAVILLON','','','14150','OUISTREHAM',NULL,NULL,'1371150364001',214.000000000,'1959-07-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2846,'RENARD','NELLY','1936-08-29','02.72.22.12.33','06.12.04.24.34',NULL,'','','','50890','CONDE SUR VIRE',NULL,NULL,'2360814467001',55.000000000,'1963-10-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2847,'FLAMBARD','MARIE THERESE','1931-12-17','02.14.62.27.46','06.26.59.00.83',NULL,'les roquettes','','','14210','CHEUX',NULL,NULL,'2311214209001',849.000000000,'1953-12-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2848,'MORISSEAU','DOMINIQUE','1962-01-05','02.71.52.69.52','06.82.55.99.67',NULL,'6 RUE DU VIQUET','','','14320','MAY SUR ORNE',NULL,NULL,'2620114221001',5.000000000,'1987-05-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2849,'PESCHET','YVONNE','1937-11-18','02.22.35.60.45','06.23.31.64.94',NULL,'16 CLOS LARIGAUDERIE','','','14970','BENOUVILLE',NULL,NULL,'1371188163001',567.000000000,'1959-04-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2850,'LEBREC','MICHEL','1937-12-13','02.47.57.57.29','06.39.28.58.29',NULL,'52 route d ifs','','','14320','MAY SUR ORNE',NULL,NULL,'1371214263001',1541.000000000,'1961-01-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2851,'MESNAGE','MICHEL','1940-02-09','02.54.52.29.03','06.41.29.52.84',NULL,'1 rue des clematites','','','14210','CHEUX',NULL,NULL,'2400261470001',37.000000000,'1963-03-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2852,'GILLARD','MAURICETTE','1934-10-11','02.41.48.55.08','06.12.16.24.56',NULL,'5 rue du calvaire','','','50250','LA HAYE DU PUITS',NULL,NULL,'1341014651001',3597.000000000,'1958-10-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2853,'JAMES','CLAUDE','1938-11-11','02.64.03.66.33','06.60.00.43.31',NULL,'1 ROUTE DE PORT EN BESSIN','','','14790','VERSON',NULL,NULL,'2381114577001',214.000000000,'1967-04-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2854,'PELCAT','MARIE THERESE','1933-03-12','02.39.46.53.00','06.66.58.11.20',NULL,'11 rue du dorset','','','14000','CAEN',NULL,NULL,'1330314580001',72.000000000,'1954-07-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2855,'HALLEY','MARIE GENEVIEVE','1934-09-24','02.83.07.81.47','06.12.11.03.62',NULL,'504 QUARTIER DU VAL','','','14250','DUCY STE MARGUERITE',NULL,NULL,'1340914349001',348.000000000,'1955-03-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2856,'LEBRETON','JACKY','1959-04-23','02.64.56.30.52','06.14.33.36.40',NULL,'30 RUE BOIS PREEAU','','','14860','BAVENT',NULL,NULL,'2590414396001',1489.000000000,'1983-02-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2857,'CAUMEIL','MONIQUE','1933-03-16','02.63.34.61.39','06.22.49.85.53',NULL,'5 RUE PAUL MATHIEU','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1330361123001',9.000000000,'1954-12-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2858,'DECROIX','NELLY','1931-06-06','02.31.27.26.05','06.40.27.76.06',NULL,'les goderelles','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1310614164001',51.000000000,'1958-09-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2859,'SERVAIN','DANIEL','1944-05-22',NULL,NULL,NULL,'14 rue pierre mendes france','','','14114','VER SUR MER',NULL,NULL,'1440514477001',99.000000000,'1965-08-30','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2860,'LAURAIN','MONIQUE','1948-01-13',NULL,NULL,NULL,'LA BULLETIERE','','','14190','FONTAINE LE PIN',NULL,NULL,'1480114437001',1345.000000000,'1970-04-16','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2861,'RENOUF','FLEURINE','1934-01-16','02.47.17.18.46','06.33.31.87.20',NULL,'17 RUE DE LA DUITERIE','','','14190','FIERVILLE BRAY',NULL,NULL,'2340114630001',20.000000000,'1955-01-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2862,'GUILLAUME','marie-claude','1934-01-15','02.60.31.26.36','06.49.88.73.13',NULL,'LA GOUTELLE','','','14240','LA VACQUERIE',NULL,NULL,'2340114630001',11.000000000,'1960-01-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2863,'LEVALLOIS','JEAN MARC','1957-03-11','02.46.81.25.32','06.78.68.04.08',NULL,'HAMEAU DES TRAVERS','','','14540','SOLIERS',NULL,NULL,'1570314135001',357.000000000,'1979-10-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2864,'AUBERTIN','GERALD','1962-02-11','02.57.53.12.22','06.54.02.10.31',NULL,'RUE DE LA FOUDRIERE','','','14123','IFS',NULL,NULL,'2620214213001',68.000000000,'1985-04-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2865,'LEROMAIN','DESIRE','1928-10-03','02.32.15.27.03','06.41.14.00.45',NULL,'11 rue albert de mun','','','14460','COLOMBELLES',NULL,NULL,'2281053271001',365.000000000,'1953-06-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2866,'PERRIER','GERMAINE','1930-10-30','02.42.50.63.46','06.11.97.15.49',NULL,'7 rue des champs','','','14123','FLEURY SUR ORNE',NULL,NULL,'2301050110001',19.000000000,'1957-12-20','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2867,'ANNE','Michel','1938-09-13','02.36.14.64.86','06.64.51.68.43',NULL,'546 RUE DU CHEMIN VERT RESIDE','NCE LE BOSQUET','','14170','ESCURES SUR FAVIERES',NULL,NULL,'2380914489001',42.000000000,'1960-10-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2868,'SIMONNET','DANIEL','1936-10-15','02.74.70.95.37',NULL,NULL,'7 rue du 11 novembre','','','61200','ARGENTAN',NULL,NULL,'2361014760001',55.000000000,'1961-05-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2869,'GATELLIER','YVES','1948-05-09','02.80.64.49.50','06.46.87.64.44',NULL,'1 RUE BEAUREGARD','','','14000','CAEN',NULL,NULL,'2480514657001',1918.000000000,'1969-03-19','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2870,'DURAND','ROLAND','1948-07-23','02.71.13.06.60','06.72.46.38.27',NULL,'RUE BOURDON','','','14400','BAYEUX',NULL,NULL,'1480714449001',625.000000000,'1973-09-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2871,'GUIONIE','MICHEL','1954-01-27','02.49.13.51.28','06.28.35.91.96',NULL,'','','','14150','OUISTREHAM',NULL,NULL,'2540114654001',1446.000000000,'1979-12-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2872,'DELANGLE','MARIE THERESE','1937-03-12','02.70.47.05.75','06.36.99.71.64',NULL,'14 RUE DE SWIMBRIDGE','','','14270','BIEVILLE QUETIEVILLE',NULL,NULL,'1370314437001',39.000000000,'1958-12-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2873,'ZAJEWSKI','GASTON','1938-11-14','02.11.66.24.20','06.22.41.60.51',NULL,'9 RUE DE LA PLAINE','','','14160','BRUCOURT',NULL,NULL,'2381114100001',190.000000000,'1965-01-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2874,'DADDA','EUGENE CYRILLE','1935-01-14','02.69.10.16.38','06.60.59.66.77',NULL,'45 RUE DE L''ARQUETTE','','','14370','ARGENCES',NULL,NULL,'1350114538001',95.000000000,'1956-07-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2875,'BRUNET','GEORGETTE','1955-01-06','02.39.21.41.61','06.43.79.73.63',NULL,'5 PLACE DU THEATRE','','','14000','CAEN',NULL,NULL,'2550161145001',3897.000000000,'1979-07-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2876,'AVONDE','BERNADETTE','1940-05-01','02.82.96.05.01','06.57.97.36.07',NULL,'10 rue de suede','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1400514355001',107.000000000,'1965-04-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2877,'DEBAIZE','FRANCOISE','1940-05-15','02.89.06.50.41','06.75.84.82.74',NULL,'20 RUE MALASSIS','','','14370','ARGENCES',NULL,NULL,'1400514355001',425.000000000,'1969-08-05','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2878,'LEROY','GUY','1967-02-10','02.31.40.88.57','06.67.11.38.46',NULL,'6 RUE DES CAPUCINES','','','14630','FRENOUVILLE',NULL,NULL,'1670277108001',66.000000000,'1991-08-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2879,'HAVIN','MICHELINE','1935-05-21','02.51.69.82.09','06.12.27.96.56',NULL,'15 RUE DES ROUGES GORGES','','',NULL,NULL,NULL,NULL,'1350514158001',35.000000000,'1962-12-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2880,'CAPELLO','gerard','1935-04-17','02.58.89.72.30','06.11.29.17.83',NULL,'5 ALLEE DU RONCHERET','','','14000','CAEN',NULL,NULL,'2350414117001',336.000000000,'1956-06-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2881,'LESELLIER','GILBERT','1927-03-07','02.11.17.50.86','06.53.88.68.14',NULL,'17 rue de la bruyre','','','14000','CAEN',NULL,NULL,'2270397103001',7.000000000,'1950-05-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2882,'LEBLOND','JACQUES','1936-11-15','02.57.40.16.34','06.30.73.01.02',NULL,'4 rue de la haie vigne','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'2361127590001',246.000000000,'1964-01-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2883,'VERRIER','LAURENCE','1937-03-16','02.58.77.06.48','06.17.44.66.33',NULL,'96 BD LYAUTEY','','','14150','OUISTREHAM',NULL,NULL,'2370314034001',95.000000000,'1961-07-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2884,'PETIT','RENEE','1956-02-13','02.38.69.17.02','06.55.78.25.05',NULL,'CHEMIN DE LA CHASSE LE BOUFFAY','','','14570','ST REMY',NULL,NULL,'1560214140001',554.000000000,'1979-06-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2885,'RIVIERE','RAYMOND','1949-01-21','02.88.69.91.44','06.55.90.50.13',NULL,'11 RUE DU LIMOUSIN','','','14370','BELLENGREVILLE',NULL,NULL,'2490114471001',329.000000000,'1970-01-14','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2886,'HETTIER','DENISE','1940-01-23','02.84.77.75.77','06.37.29.22.64',NULL,'6 RUE DES PRES DE L''ODON','','','14310','MONTS EN BESSIN',NULL,NULL,'2400114207001',1348.000000000,'1966-12-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2887,'PREMPAIN','JEAN','1939-05-16','02.29.80.29.43','06.10.23.11.51',NULL,'rue le nuisement','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2390588116001',33.000000000,'1962-08-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2888,'CALBRIS','MICHEL','1950-01-09','02.11.05.31.16','06.70.78.27.84',NULL,'13 RUE DE ROSEE','','','14350','ETOUVY',NULL,NULL,'2500150423001',1687.000000000,'1974-08-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2889,'MARIE','PAULETTE','1934-10-02','02.11.27.61.52','06.10.16.01.23',NULL,'8 BOULEVARD ALSACE LORRAINE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1341014385001',27.000000000,'1958-02-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2890,'MATHON','JEAN CLAUDE','1940-12-13','02.36.18.52.72','06.37.09.40.75',NULL,'21 rue des rouges gorges','','','14000','CAEN',NULL,NULL,'1401214168001',589.000000000,'1965-11-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2891,'LEGRAS','PAUL','1955-01-09','02.20.45.44.97','06.32.71.04.93',NULL,'22 rue voltaire','','','14000','CAEN',NULL,NULL,'2550161145001',294.000000000,'1978-08-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2892,'HEINZE','MARTINE','1953-01-23','02.78.92.49.97','06.36.25.84.49',NULL,'24 RUE COTIS CAPEL','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1530183023001',78.000000000,'1980-07-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2893,'KOULIKOVSKI','GINETTE','1933-04-24','02.19.44.99.29','06.17.97.70.98',NULL,'88 ROUTE DE CABOURG','','','14210','NOYERS BOCAGE',NULL,NULL,'1330414057001',128.000000000,'1962-07-01','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2894,'DUFAILLY','RAYMONDE','1933-04-27','02.94.48.27.65','06.84.46.96.46',NULL,'3 RUE PABLO PICASSO','','','14680','GOUVIX',NULL,NULL,'1330414057001',52.000000000,'1956-10-27','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2895,'LE METAYER','Yvette','1932-04-25','02.73.41.42.23','06.60.93.34.92',NULL,'HAMEAU DE CAREL','','','14570','CLECY',NULL,NULL,'2320414693001',425.000000000,'1956-07-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2896,'LE BARBIER','GEORGETTE','1958-12-16','02.26.74.16.31',NULL,NULL,'5 RUE MADELEINE','','','14990','BERNIERES SUR MER',NULL,NULL,'1581214241001',1.000000000,'1982-01-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2897,'OTHON','MONIQUE','1931-03-13','02.41.70.89.45','06.23.61.60.16',NULL,'5 RUE DES CANADIENS','','','14800','DEAUVILLE',NULL,NULL,'1310314229001',11.000000000,'1958-09-09','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2898,'BARDET','ANDRE','1962-10-08','02.11.68.78.52','06.65.69.65.60',NULL,'LES 4 ROUTES','','','14123','IFS',NULL,NULL,'2621014149001',3330.000000000,'1984-06-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2899,'GRANDET','MIREILLE','1956-05-21','02.25.69.43.29','06.30.38.16.12',NULL,'ROUTE DE BAYEUX LE NOUET','','','14000','CAEN',NULL,NULL,'1560561208001',646.000000000,'1977-06-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2900,'LEON','NICOLE','1937-01-25','02.79.72.91.36','06.50.97.82.13',NULL,'','','','14123','IFS',NULL,NULL,'1370114593001',2747.000000000,'1958-07-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2901,'CHEDOT','RENEE','1939-11-09','02.10.72.85.03','06.20.17.68.68',NULL,'3 RUE DES PRIMEVERES','','','50470','LA GLACERIE',NULL,NULL,'2391114297001',142.000000000,'1966-01-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2902,'JENVRIN','MAUD','1933-01-12','02.16.79.36.77','06.73.91.58.52',NULL,'8 RUE DE L''ABBE PORTE','','','14540','GRENTHEVILLE',NULL,NULL,'2330176101001',54.000000000,'1962-10-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2903,'JENVRIN','ROGER','1950-01-05','02.39.72.57.14','06.80.07.47.84',NULL,'LE PAVILLON','','','14730','GIBERVILLE',NULL,NULL,'1500114496001',11.000000000,'1975-06-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2904,'BISSON','Roger','1928-05-11','02.83.56.15.60','06.46.20.54.37',NULL,'1 RUE JOSEPH LEVILLY','','','14123','IFS',NULL,NULL,'2280514482001',73.000000000,'1955-07-23','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2905,'HOREL','THIERRY','1945-02-22','02.88.67.45.40','06.13.75.26.54',NULL,'7 RUE DES PRIMEVERES','','','14123','IFS',NULL,NULL,'2450261364001',635.000000000,'1974-11-09','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2906,'POSTEL','MARIE JOSEE','1964-01-10','02.73.62.06.85','06.10.67.79.66',NULL,'17 RUE GEISELBHCH','','','14220','THURY HARCOURT',NULL,NULL,'2640161478001',85.000000000,'1992-07-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2907,'AUVE','JEANNE','1933-06-27','02.20.86.14.46','06.29.21.03.02',NULL,'','','','14000','CAEN',NULL,NULL,'1330614271001',1155.000000000,'1959-05-24','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2908,'DECAEN','DENISE','1934-10-15','02.61.08.49.19','06.15.70.00.19',NULL,'4 RUE PAUL ALLENE','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1341014211001',87.000000000,'1962-06-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2909,'MOREL','FRANCINE','1957-02-04','02.22.30.53.48','06.82.75.30.71',NULL,'8 RUE HENRI ROSEL','','','14630','CAGNY',NULL,NULL,'2570214173001',7.000000000,'1986-10-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2910,'JOURDAN','EMILIENNE','1937-05-03','02.39.86.50.85','06.11.11.50.66',NULL,'10 RUE DES CHARRONS','','','14730','GIBERVILLE',NULL,NULL,'2370514039001',79.000000000,'1967-03-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2911,'LANGLOIS','BERNARD','1935-03-27','02.10.10.63.76','06.30.87.74.00',NULL,'12  RUE FITZ HAIMON','','','14220','CROISILLES',NULL,NULL,'1350328402001',27.000000000,'1963-04-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2912,'LE METAYER','ALAIN','1938-05-31','02.39.77.34.42','06.20.32.72.24',NULL,'12 ROUTE DU HAMEAU DE BIGARD','','','14370','ARGENCES',NULL,NULL,'1380514196001',138.000000000,'1961-01-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2913,'LENOEL','MONIQUE','1928-10-10','02.48.90.05.40','06.30.01.48.21',NULL,'66 RUE DE LA GUERINIERE','','','14000','CAEN',NULL,NULL,'1281072221001',73.000000000,'1954-09-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2914,'TRIPPIER','YVES','1930-03-28','02.31.73.55.05','06.33.76.31.70',NULL,'7 RUE CLOS DU PAVILLON','','',NULL,NULL,NULL,NULL,'2300314221001',102.000000000,'1955-05-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2915,'ROULANT','JEAN MARIE','1949-01-31','02.82.70.48.66','06.11.11.67.13',NULL,'10 RUE EMILE MOUGINS','','','14670','TROARN',NULL,NULL,'2490114509001',706.000000000,'1970-10-24','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2916,'EURY','JANINE','1939-06-10','02.59.23.52.11','06.70.29.85.62',NULL,'ROUTE DE CAMPIGNY','','','14280','ST CONTEST',NULL,NULL,'2390627422001',21.000000000,'1963-06-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2917,'MOREL','JACQUES','1946-01-22','02.79.96.02.53','06.10.95.79.84',NULL,'6 RUE JEAN DE LA FONTAINE','','','14000','CAEN',NULL,NULL,'1460161119001',33.000000000,'1967-08-09','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2918,'MANCEL','','1942-05-17','02.85.02.86.70','06.85.80.07.59',NULL,'5 RUE DE LA CHARRIERE','','','14610','FONTAINE HENRY',NULL,NULL,'1420514665001',40.000000000,'1964-05-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2919,'CAPDEPON','ALAIN','1940-03-18','02.81.26.95.66','06.14.90.34.00',NULL,'14 rue brillere','','','14170','PERRIERES',NULL,NULL,'1400370526001',586.000000000,'1966-03-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2920,'LERICHE','ALEXANDER','1933-02-19','02.24.31.74.29',NULL,NULL,'2 RUE DE LA MADELEINE','','','14400','BAYEUX',NULL,NULL,'1330261007001',60.000000000,'1961-08-17','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2921,'LEPERCHOIS','Auguste','1931-12-21','02.10.30.41.52','06.61.71.17.31',NULL,'1 rue neuve','','','14120','MONDEVILLE',NULL,NULL,'1311214114001',4070.000000000,'1952-03-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2922,'MARTIN','EMILE','1960-02-10','02.66.30.55.62','06.79.79.27.35',NULL,'33 AVENUE COTI','','','14310','MONTS EN BESSIN',NULL,NULL,'1600214477001',114.000000000,'1985-09-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2923,'DELAMARRE','ODETTE','1938-04-27','02.49.82.63.41','06.23.10.13.49',NULL,'1 rue du chateau d''eau','','','14540','SOLIERS',NULL,NULL,'2380414758001',32.000000000,'1966-02-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2924,'COLLETTE','MONIQUE',NULL,'02.38.06.48.72','06.43.47.97.05',NULL,'','','','14370','CHICHEBOVILLE',NULL,NULL,'1341014482001',1334.000000000,'2011-03-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2925,'CARINI','RAYMONDE','1939-04-16','02.33.50.32.43','06.43.52.77.95',NULL,'1 rue Pierre Curry','','','14120','MONDEVILLE',NULL,NULL,'1390414452001',398.000000000,'1964-09-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2926,'BRUYERE','MARIE ANTOINETTE','1941-06-11','02.17.67.93.47','06.89.39.88.64',NULL,'25 RUE SAINT ANDRE','','',NULL,NULL,NULL,NULL,'2410650121001',1060.000000000,'1970-02-09','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2927,'MOITIE','ELISE','1940-02-18','02.95.91.00.72','06.79.30.53.53',NULL,'RESIDENCE LAURELIE 2 RUE DU HAUT',' DES JARDINS','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2400214271001',2.000000000,'1969-05-31','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2928,'MARC','JEAN PIERRE','1940-02-07','02.58.58.14.71','06.11.66.31.62',NULL,'5 rue traverciere','','','14840','CUVERVILLE',NULL,NULL,'2400214271001',87.000000000,'1966-03-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2929,'FLAMBARD','DANIEL','1958-02-01','02.31.19.86.31','06.23.52.25.94',NULL,'11 RUE DU 13 06 1944','','','14320','MAY SUR ORNE',NULL,NULL,'2580214315001',3254.000000000,'1987-05-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2930,'DANET','MAURICE','1956-02-03','02.22.39.28.90','06.44.23.26.04',NULL,'10 rue paul samson','','','14840','DEMOUVILLE',NULL,NULL,'1560214140001',68.000000000,'1977-01-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2931,'DUVAL','HUBERT','1963-02-12','02.22.51.65.74',NULL,NULL,'','','','14000','CAEN',NULL,NULL,'2630214408001',162.000000000,'1992-06-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2932,'MARY','PIERRE','1936-03-03','02.10.11.53.66','06.23.60.92.28',NULL,'6/1 RUE DU RUISSEAU','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2360314119001',41.000000000,'1965-01-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2933,'ROBBES','ANDRE',NULL,'02.67.63.69.77','06.11.47.78.17',NULL,'33 RUE LARCHER','','','93700','DRANCY',NULL,NULL,'2370714204001',172.000000000,'2012-11-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2934,'THIEBAUT','GUY','1951-02-27','02.89.44.24.94','06.58.10.58.83',NULL,'2 RUE DE LA BRUYERE','','','14930','ETERVILLE',NULL,NULL,'2510214200001',54.000000000,'1979-04-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2935,'CHATELLIER','M THERESE','1961-03-25','02.78.23.34.89','06.68.75.43.58',NULL,'3 RUE BOIS','','','14370','BELLENGREVILLE',NULL,NULL,'1610314499001',413.000000000,'1991-12-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2936,'LAURENT','ALBERT','1935-09-20','02.65.72.59.63','06.80.58.52.95',NULL,'3 rue paul langevin','','','14370','CROISSANVILLE',NULL,NULL,'1350978646001',22.000000000,'1956-12-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2937,'PAUVRET','ANTOINETTE','1943-02-03','02.38.96.47.11','06.85.90.64.45',NULL,'1 IMPASSE DE CUSSY','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2430214597001',951.000000000,'1969-02-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2938,'LANGLOIS','ANDRE','1939-04-22','02.87.54.03.08','06.99.24.18.72',NULL,'1543 RUE DE BRETTEVILLE','','','61500','BOITRON',NULL,NULL,'2390414142001',713.000000000,'1962-04-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2939,'LEMAROIS','MARCELLE','1943-09-29','02.82.37.74.38',NULL,NULL,'1 rue caillemer hameau d''etavau','x','','14470','COURSEULLES SUR MER',NULL,NULL,'1430934081001',18.000000000,'1966-03-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2940,'SIMON','SYLVETTE','1931-10-02','02.37.20.30.88','06.34.98.65.91',NULL,'ROUTE DE MEZIERES','','','14120','MONDEVILLE',NULL,NULL,'1311014166001',494.000000000,'1954-07-29','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2941,'HERTEMENT','JEAN FRANC','1934-03-30','02.29.73.00.08','06.46.07.81.59',NULL,'77 RUE EUSTACHE RISTOUT BP 41050','','','14920','MATHIEU',NULL,NULL,'1340378146001',1479.000000000,'1958-06-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2942,'BREYNE','JACQUELINE','1937-12-18','02.11.60.93.61','06.61.44.80.53',NULL,'','','','14000','CAEN',NULL,NULL,'2371253113001',10.000000000,'1962-04-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2943,'BOSSARD','PIERRE','1942-02-21','02.88.17.95.35','06.70.60.70.77',NULL,'7 BIS ROUTE DE BRETAGNE','','',NULL,NULL,NULL,NULL,'1420250048001',130.000000000,'1964-12-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2944,'HUVE','MADELEINE','1939-04-24','02.11.61.83.13','06.40.95.36.20',NULL,'1 bld de rethel','','','14310','VILLERS BOCAGE',NULL,NULL,'2390414732001',1015.000000000,'1962-07-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2945,'FOURE','ISABELLE','1964-06-29','02.65.55.50.28','06.10.05.67.71',NULL,'LE FOSSE NEUF','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2640614079001',2634.000000000,'1987-11-05','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2946,'THOUROUDE','YVONNE','1934-02-27','02.32.01.80.38','06.49.34.76.66',NULL,'115 RUE DU PARC','','','14270','MEZIDON CANON',NULL,NULL,'2340214703001',212.000000000,'1956-08-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2947,'SCELLES','MARIE','1934-08-17','02.84.67.83.63','06.22.01.45.67',NULL,'4 IMPASSE DES VIOLETTES','','','50100','CHERBOURG OCTEVILLE CEDEX',NULL,NULL,'2340814266001',142.000000000,'1964-07-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2948,'GRANVAL','NICOLE',NULL,'02.33.10.53.30','06.59.31.28.69',NULL,'route de tilly','','','14270','MEZIDON CANON',NULL,NULL,'2310814397001',184.000000000,'2013-02-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2949,'CHARDIN','YVETTE','1930-09-21','02.67.94.27.18','06.92.31.92.84',NULL,'17 RUE W. CHURCHILL','','','14000','CAEN',NULL,NULL,'1300914628001',150.000000000,'1954-10-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2950,'VETILLARD','DANIEL','1938-12-05','02.79.56.71.86','06.40.57.08.36',NULL,'LE COLOMBIER','','','14370','BELLENGREVILLE',NULL,NULL,'1381214221001',290.000000000,'1963-07-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2951,'LANGEVIN','BERNARD','1940-04-24','02.10.96.37.28','06.69.08.60.69',NULL,'26 RUE CONDORCET','','','14370','ARGENCES',NULL,NULL,'2400450084001',1154.000000000,'1969-10-10','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2952,'LANGEVIN','GUY','1956-05-04','02.64.94.20.94','06.65.90.11.01',NULL,'9  RUE DES HAUTS VENTS','','','14370','ARGENCES',NULL,NULL,'1560561208001',47.000000000,'1979-12-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2953,'LEROY','JEAN PIERRE','1932-05-09','02.86.78.77.38','06.15.73.29.76',NULL,'4 RUE DU SQUARE','','','14123','IFS',NULL,NULL,'1320550115001',20.000000000,'1958-01-27','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2954,'GASNIER','GERMAINE','1939-01-27','02.98.82.02.32','06.11.49.23.40',NULL,'1 RUE DU PETIT MARAIS','','','14000','CAEN',NULL,NULL,'1390199424001',615.000000000,'1961-05-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2955,'DE LA CELLE','PHILIPPE','1935-10-01','02.73.95.77.67','06.82.31.99.67',NULL,'CHEMIN DE LA CROIX AUX NOBLES','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2351014382001',361.000000000,'1965-05-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2956,'PILLET','ANDRE','1958-08-21','02.34.15.83.21','06.80.49.82.63',NULL,'1 impasse du berry','','','14000','CAEN',NULL,NULL,'1580814340001',3.000000000,'1981-03-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2957,'HARTEL','MICHEL','1933-10-23','02.55.63.06.50','06.65.06.20.49',NULL,'22 BOULEVARD RAYMOND POINCARE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2331014593001',29.000000000,'1954-05-09','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2958,'LEMOUTON','HENRI','1930-12-11','02.78.52.10.43','06.99.95.01.05',NULL,'7 rue lecorbusier les jardins du',' val','','14370','ARGENCES',NULL,NULL,'1301250342001',3017.000000000,'1951-07-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2959,'GUILBERT','LEON','1921-12-14','02.85.72.72.56','00 33 6.39.94.07.82',NULL,'8 rue de la valee','','','14400','ESQUAY SUR SEULLES',NULL,NULL,'1211219090001',749.000000000,'1948-06-16','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2960,'COSSON','JULIETTE','1930-10-27','02.74.63.02.87',NULL,NULL,'14 RUE DU CLOS VENET','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1301076648001',89.000000000,'1952-04-01','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2961,'PRIOULT','ROBERT','1939-06-29','02.15.67.33.05','06.19.68.92.33',NULL,'RUE LA COUR','','','14000','CAEN',NULL,NULL,'1390614314001',520.000000000,'1961-08-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2962,'ALIX','GUY','1933-12-27','02.80.88.01.12','06.33.07.36.38',NULL,'18 AVENUE DE VERSAILLES','','','14000','CAEN',NULL,NULL,'2331244208001',51.000000000,'1959-06-28','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2963,'BUFFARD','Francoise','1937-08-18','02.83.30.84.45','06.71.71.64.11',NULL,'46 rte d''ifs','','','14670','ST PAIR',NULL,NULL,'2370850593001',8.000000000,'1967-09-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2964,'MOUCHEL','JEANNE','1933-04-14',NULL,NULL,NULL,'1 rue jean de la bruyre','','','61200','UROU ET CRENNES',NULL,NULL,'1330444015001',2428.000000000,'1961-04-16','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2965,'DELALANDE','DANIEL','1933-07-19','02.11.20.01.25','06.66.18.97.16',NULL,'3 rue saint cernin','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2330714167001',386.000000000,'1960-12-19','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2966,'SUBIRY','BERNADETTE','1932-10-20','02.62.39.81.05','06.65.81.83.13',NULL,'RABOTTE','','','14830','LANGRUNE SUR MER',NULL,NULL,'1321014171001',2.000000000,'1961-06-21','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2967,'AUFFRAY','HENRI','1934-09-03','02.78.94.25.79','06.70.20.22.86',NULL,'40 AVE PASTEUR','','','14220','ESPINS',NULL,NULL,'2340916199001',2858.000000000,'1959-08-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2968,'GRANDSIRE','RENE','1958-01-29','02.15.57.43.11','06.76.93.70.84',NULL,'LE CLOS DU MOINE','','','14250','AUDRIEU',NULL,NULL,'1580114668001',37.000000000,'1987-10-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2969,'VARIN','Claude','1958-01-22','02.47.31.24.42','06.11.69.85.65',NULL,'13 RUE DES PAVILLONS','','','14730','GIBERVILLE',NULL,NULL,'1580114668001',16.000000000,'1980-03-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2970,'BEAUVAIS','Jeanine','1930-10-30','02.58.43.71.56','06.44.03.68.91',NULL,'7 rue albert de mun','','','14210','NOYERS BOCAGE',NULL,NULL,'1301014746001',271.000000000,'1953-04-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2971,'LECHEVALLIER','CATHERINE','1928-01-27','02.99.78.54.49','06.56.01.50.82',NULL,'41 RUE LOUIS PASTEUR','','','14210','STE HONORINE DU FAY',NULL,NULL,'2280122028001',32.000000000,'1956-07-24','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2972,'BOUILLET','MARIE THERESE','1928-10-22','02.56.64.89.22','06.64.11.74.57',NULL,'43 LA QUIESCE','','','14000','CAEN',NULL,NULL,'2281014339001',43.000000000,'1954-11-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2973,'GOUBIN','YVETTE','1943-04-28','02.54.66.22.47','06.29.32.39.92',NULL,'2 RUE DE LA HALLE AU BLE','','','14000','CAEN',NULL,NULL,'1430461276001',193.000000000,'1964-05-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2974,'ERNULT','MADELEINE','1967-04-14','02.53.68.58.37','06.15.86.82.02',NULL,'30 RUE AUX BOUETS','','',NULL,NULL,NULL,NULL,'2670414356001',17.000000000,'1989-01-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2975,'CERVANTES','IRENE','1943-02-03','02.61.85.81.26','06.50.86.43.12',NULL,'CHAISONCELLES','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1430214717001',363.000000000,'1969-11-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2976,'LEMERRE','ROGER','1928-09-27','02.63.37.02.41','06.69.65.25.66',NULL,'42 RUE ST PIERRE','','','50000','ST LO',NULL,NULL,'1280914140001',4.000000000,'1956-04-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2977,'MARIE','MICHEL','1940-06-03','02.83.84.02.35','06.90.07.20.09',NULL,'1 RUE DU DOCTEUR LECHARPENTIER','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1400661137001',68.000000000,'1968-05-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2978,'MERCIER','Veronique','1934-12-05','02.10.45.20.40','06.19.84.55.09',NULL,'RUE DES BUCARDES','','','14150','OUISTREHAM',NULL,NULL,'1341227238001',89.000000000,'1962-08-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2979,'GUIHAIRE','MICHELLE','1932-09-22','02.10.07.11.20','06.84.33.82.04',NULL,'6 RUE ABBE BOSSARD','','','50160','BIEVILLE',NULL,NULL,'1320914658001',6.000000000,'1955-12-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2980,'FAFIN','ASTRIDE','1935-11-30','02.32.58.02.06','06.41.41.65.23',NULL,'17 RUE DES PRIMEVERES','','','14940','TOUFFREVILLE',NULL,NULL,'2351150196001',236.000000000,'1958-08-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2981,'HUREL','GUY','1962-06-13','02.10.17.63.96','06.55.38.07.01',NULL,'38 RUE CLOS DU PAVILLON','','','14220','FRESNEY LE VIEUX',NULL,NULL,'2620614113001',257.000000000,'1989-11-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2982,'TRUFAULT','NICOLE','1960-11-29','02.11.23.58.40','06.37.61.67.76',NULL,'LE LIEU DIT "LES FORGES DE CLERM','ONT"','','14123','CORMELLES LE ROYAL',NULL,NULL,'2601170582001',140.000000000,'1983-07-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2983,'DUMERGER','ANDREE','1965-05-21','02.34.55.46.40','06.60.39.02.30',NULL,'3 rue jean villard','','','61200','ARGENTAN',NULL,NULL,'1650514118001',1522.000000000,'1994-01-31','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2984,'BLONDEAU','ROLAND','1939-06-22','02.87.74.58.72',NULL,NULL,'21 rue des mimosas','','','14370','MERY CORBON',NULL,NULL,'2390661297001',56.000000000,'1968-07-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2985,'HEBERT','ODILE','1967-04-06','02.37.39.89.42','06.88.13.07.71',NULL,'1 RUE DU FOUR A CHAUD','','','14730','GIBERVILLE',NULL,NULL,'2670414356001',403.000000000,'1992-04-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2986,'PATIN','JACQUELINE','1928-05-15','02.73.25.62.96','06.36.64.53.46',NULL,'','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'2280514137001',18.000000000,'1951-02-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2987,'CARABY','GEORGES','1932-10-04','02.90.37.60.21','06.11.16.50.04',NULL,'17 ALLEE LAPEROUSE','','','14000','CAEN',NULL,NULL,'1321014112001',1307.000000000,'1959-09-10','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2988,'ABEL','DIDIER','1930-04-24','02.90.61.26.94','06.52.84.36.62',NULL,'2 CHEMIN AUX BOEUFS','','','50000','ST LO',NULL,NULL,'1300414288001',30.000000000,'1954-11-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2989,'PALAIS','MARCEL','1953-05-30','02.47.12.59.97','06.26.03.99.94',NULL,'11 RUE HENRI PHILIPPE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1530514539001',457.000000000,'1980-04-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2990,'PALAIS','JACQUES','1936-04-16','02.30.75.56.96','06.76.41.00.46',NULL,'13 RUE LUCIEN NELLE','','','14120','MONDEVILLE',NULL,NULL,'2360488251001',1852.000000000,'1957-08-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2991,'PERRY','PHILIPPE','1932-09-20','02.53.44.26.61','06.17.95.81.58',NULL,'','','',NULL,NULL,NULL,NULL,'2320925493001',56.000000000,'1957-02-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2992,'TAPIN','MARIE THERESE','1969-07-24','02.27.97.87.24','06.38.06.17.67',NULL,'ROUTE D''ISIGNY','','','14000','CAEN',NULL,NULL,'1690714109001',1539.000000000,'1990-01-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2993,'PACARY','MICHEL','1937-09-09','02.31.34.23.82','06.10.61.49.00',NULL,'11 HAMEAU DE RANCHEVILLE','','','14570','ST LAMBERT',NULL,NULL,'1370914371001',15.000000000,'1959-01-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2994,'VILLARD','PAUL','1930-08-31','02.11.19.56.90','06.24.13.14.33',NULL,'123 RUE CAPONIERE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1300878066001',131.000000000,'1959-01-15','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2995,'MILANI','JEAN','1931-03-19','02.59.85.50.94','06.97.88.32.77',NULL,'15 RUE JEAN QUEDEC','','','14670','TROARN',NULL,NULL,'1310355582001',69.000000000,'1955-10-31','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2996,'JOUANNE','MICHEL','1941-06-11','02.10.19.19.69','06.43.75.23.21',NULL,'18 RUE ALBERT 1ER','','','14260','JURQUES',NULL,NULL,'1410650642001',8.000000000,'1967-09-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2997,'PANNIER','JANINE','1940-04-11','02.35.71.27.90','06.80.57.38.71',NULL,'3 AVENNUE CHARLOTTE CORDEY','','','14000','CAEN',NULL,NULL,'1400414714001',114.000000000,'1961-09-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2998,'HOMMET','PAULETTE','1935-06-21','02.74.21.58.15',NULL,NULL,'4 RUE DE L''ECUILLER','','','14000','CAEN',NULL,NULL,'2350614537001',83.000000000,'1959-01-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (2999,'GUALBERT','MICHEL','1928-12-31','02.63.21.19.60','06.37.19.32.15',NULL,'9 rue des rames','','','14110','CONDE SUR NOIREAU',NULL,NULL,'1281250161001',41.000000000,'1952-11-16','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3000,'DELISLE','MARIE-THERESE','1940-12-28','02.63.06.49.58','06.58.83.91.19',NULL,'15 BIS RUE de chicheboville','','','14610','BASLY',NULL,NULL,'1401214383001',364.000000000,'1963-10-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3001,'POULLAIN','Christiane','1939-06-29','02.49.37.56.26','06.35.06.91.64',NULL,'3 impasse du home','','','14490','CASTILLON',NULL,NULL,'1390614046001',13.000000000,'1962-10-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3002,'PEZET DE CORVAL','FRANCOISE','1948-07-26','02.53.64.51.05','06.52.16.60.89',NULL,'1 rue du haut d aulny','','','14380','COURSON',NULL,NULL,'1480714064001',893.000000000,'1972-02-14','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3003,'LALEMAN','MARIE-THERESE','1935-07-21','02.10.47.27.08','06.42.87.55.50',NULL,'13 RUE JACQUES PREVERT','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1350714191001',459.000000000,'1957-01-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3004,'LEGRIX','MONIQUE','1930-10-02','02.73.01.43.51','06.89.74.29.61',NULL,'25 rue salvador allende','','','14420','POTIGNY',NULL,NULL,'1301072334001',27.000000000,'1952-02-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3005,'GASNIER','ALBERT','1930-01-19','02.11.98.97.39','06.35.94.76.39',NULL,'10 rue st vincent de paul','','','61240','NONANT LE PIN',NULL,NULL,'1300114176001',103.000000000,'1953-05-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3006,'AUBEY','OLIVIER','1968-01-20','02.11.63.04.71','06.53.96.12.56',NULL,'327 LES BELLES PORTES','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1680153166001',206.000000000,'1991-11-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3007,'GUERIN','CLAUDE','1957-01-21','02.22.08.07.11','06.59.27.61.07',NULL,'2 CHEMIN DES MOOUSSETTES','','','14840','DEMOUVILLE',NULL,NULL,'1570114225001',9.000000000,'1987-02-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3008,'SENECHAL','Alberte','1956-01-28','02.69.50.61.88','06.10.16.60.26',NULL,'55 ROUTE D''HARCOURT','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1560161459001',101.000000000,'1983-01-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3009,'MARIE','MARIE BERTHE','1931-06-11','02.49.16.86.24','06.15.47.82.32',NULL,'la maison blanche','','','14123','FLEURY SUR ORNE',NULL,NULL,'2310614205001',169.000000000,'1952-04-01','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3010,'AUDES','DOMINIQUE','1933-10-23','02.27.10.92.20','06.10.78.53.09',NULL,'2 rue des balcons','','','61200','OCCAGNES',NULL,NULL,'1331014488001',849.000000000,'1958-06-20','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3011,'GILART-GATIUS','JANINE','1934-04-13','02.89.22.31.13','06.79.59.67.07',NULL,'3 RUE DU PERE ROBERT','','','14190','URVILLE',NULL,NULL,'2340414157001',16.000000000,'1964-02-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3012,'COSTALONGA','XAVIER','1963-12-19','02.93.53.18.17','06.58.55.47.43',NULL,'LA JAUNIERE','','','14000','CAEN',NULL,NULL,'1631299253001',8.000000000,'1990-07-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3013,'HEBERT','bernard','1936-09-10','02.20.35.65.31','06.68.00.72.99',NULL,'6 rue du Mont ecamu','','','14123','IFS',NULL,NULL,'2360914549001',431.000000000,'1957-05-31','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3014,'DOIX','JEAN','1940-12-19','02.57.85.69.29','06.91.97.48.80',NULL,'6-2 rue des balcons','','','14120','MONDEVILLE',NULL,NULL,'2401250197001',738.000000000,'1966-10-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3015,'PRUNIER LEBASTARD','CHARLOTTE','1968-08-14','02.21.69.01.38','06.11.09.32.77',NULL,'1 route de caumont','','','14730','GIBERVILLE',NULL,NULL,'2680814658001',110.000000000,'1989-09-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3016,'CHARDRON','PAULETTE','1933-08-09','02.37.54.89.69','06.91.77.42.54',NULL,'21 RUE DU PONT DU COUDRAY','','','14000','CAEN',NULL,NULL,'2330814437001',4540.000000000,'1958-02-21','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3017,'BOURGEOT','JEANNE','1931-10-31','02.72.61.11.73','06.32.64.21.30',NULL,'6 rue froide','','','14480','LE FRESNE CAMILLY',NULL,NULL,'2311014454001',351.000000000,'1958-02-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3018,'DECAN','CAMILLE','1938-08-31','02.14.25.66.18','06.91.00.04.67',NULL,'LES PEDOUZES','','','14110','CONDE SUR NOIREAU',NULL,NULL,'2380814160001',4.000000000,'1964-01-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3019,'LAUMONIER','FRANCOISE','1930-06-25','02.19.43.40.17','06.22.07.45.49',NULL,'11 RUE D ORLEANS','','','14120','MONDEVILLE',NULL,NULL,'1300650546001',32.000000000,'1957-05-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3020,'MARIE','THERESE','1942-04-30','02.87.75.48.99','06.72.87.81.99',NULL,'7 RUE FLANDRE DUNKERQUE','','','14120','MONDEVILLE',NULL,NULL,'1420450492001',389.000000000,'1964-10-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3021,'MARIE','MARCEL','1945-02-08','02.94.08.14.99','06.19.35.90.29',NULL,'20 ROUTE DE COURSEULLES','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'2450261086001',2431.000000000,'1967-07-18','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3022,'MONTIGNY','BERNARD','1931-04-08','02.31.80.21.97','06.45.04.88.64',NULL,'10 RUE DE SUEDE','','','14520','STE HONORINE DES PERTES',NULL,NULL,'1310414357001',0.000000000,'1956-03-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3023,'VENTE','MARYVONNE','1943-01-12','02.85.87.65.43','06.74.36.67.97',NULL,'maison de retraite de troarn','','','14510','GONNEVILLE SUR MER',NULL,NULL,'1430114664001',16.000000000,'1966-04-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3024,'COURTONNE','HUGUETTE','1934-04-15','02.37.26.53.12','06.16.74.02.81',NULL,'4 RUE CALMETTE','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'2340414543001',772.000000000,'1958-03-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3025,'NICOLE','PATRICIA','1929-05-01','02.91.28.16.46','06.10.75.16.99',NULL,'LE POT','','','14120','MONDEVILLE',NULL,NULL,'2290514271001',227.000000000,'1959-05-21','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3026,'HOUSSIN','HENRIETTE','1956-05-23','02.96.90.19.83','06.90.64.63.25',NULL,'24 AVENUE DU SOLEIL','','','50760','ANNEVILLE EN SAIRE',NULL,NULL,'1560550010001',154.000000000,'1981-01-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3027,'FOUQUES','PAULETTE','1935-03-02','02.77.88.11.42','06.73.10.26.74',NULL,'15 ROUTE DE LA GUERINIERE','','','14000','CAEN',NULL,NULL,'1350314348001',27.000000000,'1962-08-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3028,'GROSINI','MICHEL','1937-08-14','02.10.73.30.83','06.52.11.73.31',NULL,'135 RUE D''EPRON','','','14120','MONDEVILLE',NULL,NULL,'1370814167001',88.000000000,'1965-06-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3029,'LECHANGEUR','MICHEL','1929-06-19','02.36.72.76.32','06.72.00.87.07',NULL,'6 IMPASSE DES BLEUETS','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1290614164001',741.000000000,'1953-04-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3030,'ROZIER','XAVIER','1935-03-14','02.69.86.44.16','06.57.90.87.51',NULL,'79 RUE DE BRETAGNE','','','14420','SOUMONT ST QUENTIN',NULL,NULL,'2350328111001',411.000000000,'1963-02-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3031,'LEMOINE','SUZANNE','1959-01-08','02.10.09.51.97','06.84.13.32.71',NULL,'13 RUE DE BOURGOGNE','','','14700','AUBIGNY',NULL,NULL,'1590127367001',625.000000000,'1989-12-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3032,'DANSE','CHARLES','1953-04-06','02.65.70.41.82','06.96.43.42.81',NULL,'233 rue de falaise','','','14220','CULEY LE PATRY',NULL,NULL,'1530414248001',34.000000000,'1976-07-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3033,'MULLOIS','MICHELINE','1929-07-27','02.89.34.41.72','06.25.96.70.59',NULL,'','','','14620','MORTEAUX COULIBOEUF',NULL,NULL,'1290750389001',31.000000000,'1956-11-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3034,'MONGODIN','AUGUSTE','1930-06-06','02.32.71.87.87','06.16.02.98.27',NULL,'chemin des bruyeres','','','14270','MEZIDON CANON',NULL,NULL,'2300614318001',66.000000000,'1951-01-07','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3035,'LEMERCIER','JANINE','1928-09-15','02.24.76.77.20','06.38.41.24.02',NULL,'57  ROUTE D''HARCOURT','','','14930','VIEUX',NULL,NULL,'1280961367001',225.000000000,'1949-10-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3036,'LEFRANT','DENISE','1942-01-05','02.29.99.04.19','06.84.74.68.56',NULL,'25 AV DE VERDUN','','','14123','FLEURY SUR ORNE',NULL,NULL,'1420177281001',2828.000000000,'1964-05-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3037,'MERIEULT','FATIMA',NULL,'02.11.31.26.10','06.59.89.47.90',NULL,'36 AVENUE GEORGES CLEMENCEAU','','','14000','CAEN',NULL,NULL,'2340950145001',33.000000000,'2008-10-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3038,'MENARD','Jean','1939-12-23','02.25.05.61.15','06.51.29.42.71',NULL,'17 RUE DU BERRY','','','14370','CANTELOUP',NULL,NULL,'1391250028001',254.000000000,'1961-11-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3039,'DOCHE','LUCIEN','1945-04-04','02.50.49.01.84','06.41.64.51.23',NULL,'22 RUE DU SIEUR DE BRAS','','','14540','SOLIERS',NULL,NULL,'1450475048001',63.000000000,'1975-08-02','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3040,'ALLIO','Jeannine','1938-05-01','02.91.58.55.15','06.65.42.23.45',NULL,'11 RUE DES BARENTINS','','','14000','CAEN',NULL,NULL,'1380561040001',1032.000000000,'1968-06-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3041,'GOSSET','Gilbert','1961-01-12','02.10.11.01.20','06.89.08.15.46',NULL,'8 AVENUE MARC DUGARREAUX','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2610114221001',3.000000000,'1984-07-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3042,'QUERUEL','marie','1961-05-15','02.46.16.14.32','06.46.54.94.11',NULL,'rue du vieux chateau','','','50430','LESSAY',NULL,NULL,'1610554408001',102.000000000,'1986-01-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3043,'SALLES','Marie Josephe','1931-09-26','02.28.37.76.42','06.36.99.12.53',NULL,'14 RUE DE LA GARE','','','50430','LESSAY',NULL,NULL,'1310961287001',1166.000000000,'1960-10-29','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3044,'MALINE','JANINE','1952-01-04','02.93.05.09.69','06.19.64.54.86',NULL,'LA HARDRONNIERE','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'1520114410001',82.000000000,'1982-10-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3045,'BRIAND','Denise',NULL,'02.31.81.27.19','06.99.04.45.96',NULL,'98 BIS  ROUTE DE FALAISE','','',NULL,NULL,NULL,NULL,'1360314219001',272.000000000,'2008-08-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3046,'CRUCHON','MICHELINE','1939-04-07','02.68.77.27.77','06.10.03.86.05',NULL,'3 RUE ARISTIDE BRIAND','','','14210','STE HONORINE DU FAY',NULL,NULL,'2390475036001',26.000000000,'1966-10-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3047,'LEMARECHAL','Jeanne','1938-05-08','02.73.42.81.00','06.37.20.79.30',NULL,'RUE LEON GUIGNE','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1380514416001',457.000000000,'1968-05-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3048,'MULLOIS','CLAUDE','1934-11-09','02.94.06.49.06','06.65.17.00.65',NULL,'59 ROUTE DE PARIS','','','14280','AUTHIE',NULL,NULL,'1341114211001',54.000000000,'1956-09-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3049,'LEPAILLEUR','sylvain','1940-01-18','02.10.67.37.52','06.52.66.76.92',NULL,'37 RUE EUGENIE','','','14920','MATHIEU',NULL,NULL,'1400114530001',18.000000000,'1968-10-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3050,'DIVERT','COLETTE','1930-11-07','02.10.49.44.76','06.32.85.57.25',NULL,'15 ALLEE DES JONQUILLES','','','14510','HOULGATE',NULL,NULL,'1301114119001',79.000000000,'1951-06-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3051,'LARSONNEUR','CHANTAL','1961-03-27','02.88.22.50.07','06.61.92.96.14',NULL,'10 RUE ALBERT BAYET','','','14121','SALLENELLES',NULL,NULL,'2610314182001',74.000000000,'1983-01-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3052,'POULARD','JEAN','1940-10-08','02.63.25.86.31','06.10.19.88.96',NULL,'57 RUE ARMAND MARIE','','','14370','BELLENGREVILLE',NULL,NULL,'1401014396001',402.000000000,'1961-05-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3053,'PIEDVACHE','','1961-01-08','02.78.76.66.52','06.78.76.82.12',NULL,'41 AVENUE FOCH','','','14123','IFS',NULL,NULL,'2610114623001',4.000000000,'1990-05-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3054,'BROTIN','MARIE CLAIRE','1922-07-19','02.41.01.17.66','06.10.14.08.37',NULL,'20 RUE DE L''ENGANNERIE','','','14111','LOUVIGNY',NULL,NULL,'1220714366001',31.000000000,'1944-11-29','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3055,'PARIS','Yvette','1933-09-05','02.37.67.95.41','06.84.84.33.31',NULL,'5 rue marcel palluet','','','14270','MEZIDON CANON',NULL,NULL,'1330961307001',974.000000000,'1961-12-29','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3056,'MOMPLE','BERNARD','1933-09-06','02.12.04.05.68','06.75.22.15.17',NULL,'15 impasse du peintre','','','14210','TROIS MONTS',NULL,NULL,'1330961307001',16.000000000,'1963-12-12','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3057,'SAUVEGRAIN','GUY','1939-10-24','02.21.57.86.08','06.62.52.10.56',NULL,'27 RUE  DE LA CAVEE','','','14370','ARGENCES',NULL,NULL,'2391014076001',197.000000000,'1961-03-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3058,'RICHARD','GUY','1962-06-28','02.21.95.90.37','06.70.13.83.63',NULL,'2 IMPASSE DE L ORANGERAIE','','','14000','CAEN',NULL,NULL,'1620614587001',72.000000000,'1988-10-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3059,'LEBOURGEOIS','AUGUSTE','1928-02-20','02.47.55.11.07','06.81.59.10.05',NULL,'7 RUE DE L AVIATION','','','14000','CAEN',NULL,NULL,'2280214145001',128.000000000,'1951-04-05','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3060,'BARBENCHON','ROLANDE','1936-04-09','02.22.13.16.79','06.15.08.41.38',NULL,'ROUTE DE BALLEROY','','','50690','MARTINVAST',NULL,NULL,'1360435032001',752.000000000,'1958-10-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3061,'KRA','Marcel','1932-12-06','02.76.54.44.94','06.11.85.65.21',NULL,'27 rue du stade','','','14000','CAEN',NULL,NULL,'1321214164001',7.000000000,'1954-12-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3062,'RIQUET','SUZANNE','1932-12-23','02.50.54.42.08','06.61.89.14.57',NULL,'15 venelle auchan argence','','','14490','CASTILLON',NULL,NULL,'1321214164001',16.000000000,'1955-04-13','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3063,'GASNIER','MARIE','1938-03-30','02.51.00.51.75','06.11.25.33.53',NULL,'3 rue de tourville','','','14520','PORT EN BESSIN HUPPAIN',NULL,NULL,'2380314109001',134.000000000,'1960-03-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3064,'LEPETIT','CLAUDE','1931-03-12','02.13.61.28.02','06.42.94.11.62',NULL,'21 RUE PIERRE CINGAL','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2310314716001',5.000000000,'1959-11-20','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3065,'HEMERY','GAETAN','1934-12-02','02.11.61.77.22','06.36.08.33.62',NULL,'9 RUE LIEUTENANT DE ST LOUVENT','','','14000','CAEN',NULL,NULL,'2341214651001',345.000000000,'1960-12-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3066,'BAUMEL','YVONNE','1963-04-14','02.22.94.94.26','06.71.14.39.55',NULL,'40 BD MARECHAL LIAUTTEY','','','14000','CAEN',NULL,NULL,'2630414712001',172.000000000,'1987-03-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3067,'GICQUEL','Henriette','1965-06-29','02.11.63.13.66','06.10.79.72.70',NULL,'20 BIS CHEMIN VILLENEUVE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1650614092001',20.000000000,'1995-08-01','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3068,'BARBOTTE','VADIM','1969-05-05','02.39.10.86.47','06.11.85.79.56',NULL,'39 rue des acacias','','','14220','FRESNEY LE VIEUX',NULL,NULL,'1690514319001',1373.000000000,'1995-07-02','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3069,'SEBIRE','Andr','1939-08-02','02.75.61.75.02','06.46.31.44.16',NULL,'quartier eglise','','','14630','CAGNY',NULL,NULL,'2390835211001',894.000000000,'1960-04-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3070,'MAUNY','Yves','1964-05-08','02.87.45.20.99','06.62.45.89.26',NULL,'18 impasse de l''orangeraie','','','14240','CAUMONT L''EVENTE',NULL,NULL,'1640514087001',38.000000000,'1989-04-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3071,'DAVID','Marius','1968-01-27','02.47.84.18.55','06.14.47.06.50',NULL,'9 RUE DE L AVENIR','','','14370','ARGENCES',NULL,NULL,'2680114327001',13.000000000,'1993-02-16','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3072,'BAZILE','Jean','1945-07-06','02.48.17.08.97','06.76.23.97.87',NULL,'6 RUE DES PEUPLIERS','','','14700','FALAISE',NULL,NULL,'1450714308001',112.000000000,'1966-09-24','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3073,'LEBOURGEOIS','Henri','1933-05-20','02.10.32.92.68','06.10.03.51.75',NULL,'RUE TARDIF','','','14190','SOIGNOLLES',NULL,NULL,'1330550394001',195.000000000,'1957-05-31','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3074,'ANQUETIL','Bernard','1938-01-25','02.33.79.08.88','06.14.28.02.35',NULL,'2 rue des fauvettes','','','14550','GIBERVILLE',NULL,NULL,'2380114221001',2316.000000000,'1959-07-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3075,'PREVERT','DENISE','1964-01-17','02.95.90.26.75','06.42.42.00.53',NULL,'76 RUE DE LA GUERINIERE','','','61160','NEAUPHE SUR DIVE',NULL,NULL,'2640114437001',333.000000000,'1986-12-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3076,'ALEXANDRE','CHARLES','1937-05-12','02.78.71.50.24','06.46.38.27.50',NULL,'30 RUE DU CLOS DU HAMEL','','','50000','ST LO',NULL,NULL,'1370514516001',101.000000000,'1963-12-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3077,'LEMOINE','Madeleine','1935-05-20','02.39.36.22.13','06.70.45.97.11',NULL,'8 IMPASSE CHATAIGNERAIE','','','14000','CAEN',NULL,NULL,'1350578551001',669.000000000,'1961-05-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3078,'DESTIGNY','Pierre','1929-11-09','02.81.89.42.66','00 33 6.86.55.09.21',NULL,'66 rue du val distrait','','','14400','COTTUN',NULL,NULL,'2291114427001',1831.000000000,'1959-06-14','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3079,'LEVEAUFRE','MURIELLE','1939-12-15','02.11.58.35.74',NULL,NULL,'11 res l oree d hasting','','','14120','MONDEVILLE',NULL,NULL,'2391214699001',23.000000000,'1960-10-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3080,'LAFONTAINE','Chantal','1936-12-16','02.75.60.44.59','06.67.49.50.01',NULL,'23 rue pasteur','','','14310','GIBERVILLE',NULL,NULL,'1361214628001',1004.000000000,'1957-06-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3081,'ABADIE','ermano','1938-04-17','02.73.17.48.25','06.78.55.64.65',NULL,'53 rue de la marne','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2380490068001',1043.000000000,'1964-10-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3082,'COLACE','Pierre','1937-07-18','02.69.69.38.22','06.64.15.30.44',NULL,'grande rue','','','14320','FONTENAY LE MARMION',NULL,NULL,'2370714197001',3241.000000000,'1958-06-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3083,'ALVAREZ','Paulette','1943-06-24','02.28.91.03.23','06.22.24.78.21',NULL,'6 RUE SALVATOR A.N.D','','','14670','TROARN',NULL,NULL,'1430614248001',24.000000000,'1968-12-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3084,'LAMIDEY','Claudine','1951-08-06','02.23.02.18.25','06.65.76.33.95',NULL,'28 RUE JEAN FLEURY','','',NULL,'GIBERVILLE',NULL,NULL,'1510850028001',49.000000000,'1975-06-28','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3085,'HAREL','Jacqueline','1959-01-31','02.77.23.04.19','06.23.71.74.01',NULL,'RUE CAUBRIERE','','','14260','JURQUES',NULL,NULL,'2590114258001',403.000000000,'1984-07-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3086,'SOULAT','Louis','1929-12-20','02.43.03.04.13','06.98.97.29.13',NULL,'29 route du cimetiere','','','14460','COLOMBELLES',NULL,NULL,'1291236035001',0.000000000,'1953-12-11','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3087,'HUE','Grard','1964-01-01','02.48.98.42.97','06.10.46.89.30',NULL,'9 RUE DES ECOLES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2640172138001',717.000000000,'1985-06-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3088,'GUERARD','Jacky','1931-06-24','02.46.32.84.84','06.29.74.97.92',NULL,'2 RUE BAD NEUSTADT','','',NULL,'GIBERVILLE',NULL,NULL,'2310614579001',82.000000000,'1953-02-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3089,'GOSSET','Adolphe','1948-02-12','02.67.33.48.86','06.10.43.17.44',NULL,'LA CHESNAYE','','','14490','NORON LA POTERIE',NULL,NULL,'2480214587001',38.000000000,'1969-08-26','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3090,'LACOUR','HENRI','1934-07-09','02.54.51.19.48','06.32.42.39.20',NULL,'10 rue st vincent de paul','','','14440','BENY SUR MER',NULL,NULL,'1340776260001',39.000000000,'1963-11-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3091,'KURANDY','HUGUETTE','1934-08-16','02.12.23.73.74',NULL,NULL,'13 RUE GUSTAVE FLAUBERT','','','14510','HOULGATE',NULL,NULL,'2340814543001',773.000000000,'1955-04-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3092,'PELTIER','YVONNE','1935-08-02','02.42.84.03.53','06.68.46.24.52',NULL,'3 rue de verrieres','','','14000','CAEN',NULL,NULL,'1350814173001',79.000000000,'1958-09-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3093,'PIGEON','JEAN','1940-02-14','02.36.92.20.99','06.10.77.02.69',NULL,'chemin de l''eglise','','','50500','CARENTAN',NULL,NULL,'1400276563001',105.000000000,'1964-10-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3094,'CHENEL','MARIE','1956-01-18','02.35.01.23.34','06.69.26.95.24',NULL,'8 RUE ALFRED NOBEL','','','14123','IFS',NULL,NULL,'2560114020001',380.000000000,'1985-07-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3095,'CRESTEY','JEAN MARIE','1961-05-10','02.56.40.64.94','06.93.60.37.10',NULL,'18 rue pierre semard','','','61200','GIBERVILLE',NULL,NULL,'2610514329001',429.000000000,'1990-06-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3096,'DEVAUX','GERARD','1932-06-15','02.58.46.21.35','06.12.15.81.38',NULL,'5 bis rue de maltot','','','14540','SOLIERS',NULL,NULL,'2320614341001',132.000000000,'1960-09-01','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3097,'BOCQUET','MICHEL','1936-09-26','02.75.52.02.45','06.88.20.94.51',NULL,'12 RUE DE LA COOPERATIVE','','','27230','BOURNAINVILLE',NULL,NULL,'2360979104001',2229.000000000,'1959-05-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3098,'MASSELIN','Jacques','1934-08-10','02.27.97.53.22','06.51.88.68.37',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1340814100001',76.000000000,'1963-10-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3099,'DELAFONTAINE','Bernard','1932-08-12','02.42.54.96.50','06.13.68.45.02',NULL,'59 av de la redoute','','','27230','THIBERVILLE',NULL,NULL,'1320872173001',133.000000000,'1958-08-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3100,'GUILLAUME','Adeline','1932-11-18','02.82.00.74.43',NULL,NULL,'5 BOULEVARD DES VIOLETTES','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'2321176400001',357.000000000,'1956-05-03','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3101,'LEBEL','MONIQUE','1934-05-11','02.23.53.06.29','06.71.89.89.25',NULL,'8 RUE DES ECOSSAIS','','','14460','COLOMBELLES',NULL,NULL,'1340578536001',556.000000000,'1955-04-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3102,'LAIDET','Michle','1942-02-25','02.64.07.02.24','06.90.15.89.23',NULL,'2 RUE PASTEUR','','','14980','ROTS',NULL,NULL,'2420227167001',189.000000000,'1963-01-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3103,'SOLAIS','Nelly','1944-03-16','02.40.70.41.60','06.26.74.99.60',NULL,'48 rue de cormelles','','','50480','ST GERMAIN DE VARREVILLE',NULL,NULL,'2440314118001',1824.000000000,'1970-10-03','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3104,'PUPIN','Paulette','1968-04-26','02.13.73.35.25','06.66.55.36.94',NULL,'65 RUE C BLAISOT','','','14240','ANCTOVILLE',NULL,NULL,'1680414537001',105.000000000,'1992-07-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3105,'ROUPNEL','GERARD','1937-03-17','02.94.18.87.19','06.37.63.75.43',NULL,'7 RUE DU PLAN DU ROY','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1370361198001',194.000000000,'1958-03-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3106,'BOUSQUET','MAURICETTE','1951-02-17',NULL,NULL,NULL,'7 rue des anciens d''afn','','','14123','FLEURY SUR ORNE',NULL,NULL,'1510214670001',102.000000000,'1973-05-30','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3107,'PICARD','RAYMONDE','1934-11-12','02.81.35.74.79',NULL,NULL,'20 RUE DES ANEMONES','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2341114610001',176.000000000,'1955-01-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3108,'DUPARD','EDITH','1932-05-09','02.75.75.42.75','00 33 6.37.16.27.62',NULL,'2 rue des ecossais','','','61310','LA COCHERE',NULL,NULL,'2320550338001',622.000000000,'1955-10-31','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3109,'ALESSI','MADELEINE','1951-01-28','02.90.76.98.95','06.20.35.05.76',NULL,'le bourg','','','14540','SOLIERS',NULL,NULL,'1510114747001',1.000000000,'1978-01-24','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3110,'SAMAIN','ANDRE','1961-02-07','02.74.85.19.42',NULL,NULL,'93 RUE ESNERT MANCHON','','','27230','THIBERVILLE',NULL,NULL,'2610214461001',126.000000000,'1984-04-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3111,'ROBERGE','Simone',NULL,'02.74.52.58.30',NULL,NULL,'','','','14210','BOUGY',NULL,NULL,'2330814309001',517.000000000,'2011-12-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3112,'LAIDET','Charles','1956-03-13','02.12.58.42.60','06.57.08.40.06',NULL,'10 PLACE DE LA JUSTICE','','','50490','LA RONDE HAYE',NULL,NULL,'2560353013001',27.000000000,'1977-10-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3113,'PAYEN','Madeleine',NULL,'02.13.65.88.10','06.28.09.67.61',NULL,'39 RUE DE L''ARQUETTE','','','50810','ST PIERRE DE SEMILLY',NULL,NULL,'1670914734001',772.000000000,'2011-03-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3114,'BAUDOUIN','Pierre','1963-11-01','02.84.31.66.31','06.59.77.75.48',NULL,'9 allee st marcouf','','','14570','ST REMY',NULL,NULL,'1631178401001',122.000000000,'1986-02-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3115,'BELLIARD','EUPHROSINE','1931-12-10','02.30.45.41.93','06.10.95.33.84',NULL,'92 RUE VLADIMIR MARTEL','','','14000','CAEN',NULL,NULL,'1311250087001',60.000000000,'1952-11-08','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3116,'FICET','JANINE','1932-09-02','02.11.07.05.55','06.10.80.99.77',NULL,'8 RUE DES GERANIUMS','','','14540','GRENTHEVILLE',NULL,NULL,'2320914592001',1952.000000000,'1959-01-14','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3117,'LEROUVILLOIS','SERGE','1933-01-09','02.40.78.78.42','06.23.09.51.82',NULL,'18 RUE DE LA DIVES','','','14123','IFS',NULL,NULL,'1330161361001',54.000000000,'1961-12-13','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3118,'DENIS','ROLANDE','1940-12-24','02.26.58.41.67','06.37.67.62.88',NULL,'5 K RUE MARGUERITE DURAS','','','14270','MEZIDON CANON',NULL,NULL,'1401214660001',89.000000000,'1961-06-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3119,'COLOMES','MARCEL','1937-11-21','02.52.27.33.55','06.77.69.34.18',NULL,'LE BUQUET','','','50500','CARENTAN',NULL,NULL,'1371114649001',42.000000000,'1959-09-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3120,'LEFRANCOIS','Arlette','1933-05-30','02.40.39.34.60','06.33.15.85.85',NULL,'40 avenue albert 1er','','','14000','CAEN',NULL,NULL,'1330514614001',626.000000000,'1960-04-20','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3121,'LE SECQ','GUY','1933-04-20','02.53.85.72.23','06.50.51.65.81',NULL,'6 RUE VAL DES DUNES','','','14670','TROARN',NULL,NULL,'1330414691001',8.000000000,'1955-05-09','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3122,'GUELLE','GENEVIEVE','1968-08-22','02.53.55.13.33','06.56.78.05.74',NULL,'22 rue du chateau','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2680814009001',611.000000000,'1997-08-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3123,'WIDEROWSKI','ANDRE','1938-08-27','02.82.31.94.38','06.18.11.00.09',NULL,'26 rue d ifs','','','27260','CORMEILLES',NULL,NULL,'1380829268001',164.000000000,'1960-09-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3124,'BISSON','Jeanine','1928-11-26','02.79.84.70.16','06.76.80.37.76',NULL,'98 RUE DU SAPIN','','','14123','IFS',NULL,NULL,'1281161346001',283.000000000,'1950-04-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3125,'BARON','GUY','1913-09-10','02.54.76.41.09','06.17.38.55.01',NULL,'7 IMPASSE DES PENSEES','','','27230','THIBERVILLE',NULL,NULL,'1130959202001',40.000000000,'1940-04-13','PREMIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3126,'BOUSSARD','Bernard',NULL,'02.84.49.23.00','06.96.14.74.47',NULL,'3 rue du lanquedoc','','','14210','ESQUAY NOTRE DAME',NULL,NULL,'1360914311001',116.000000000,'2011-03-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3127,'MARIE','ALPHONSE','1933-05-22','02.24.86.39.39','06.68.68.02.07',NULL,'21 RUE BASSE','','','14490','LE TRONQUAY',NULL,NULL,'2330514138001',39.000000000,'1956-10-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3128,'MEDELAINE','CELINE','1937-06-05','02.33.32.31.69','06.88.24.64.35',NULL,'17 AVENUE DES TULIPES','','','14730','GIBERVILLE',NULL,NULL,'1370614118001',3387.000000000,'1961-05-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3129,'LAVILLE','CLAUDE','1950-01-27','02.25.68.50.66','06.22.86.95.49',NULL,'7 RUE ANDRE PIERRE MARIE','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1500114746001',262.000000000,'1980-07-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3130,'ROBERGE','GUY','1944-08-03','02.45.48.29.35','06.10.20.68.20',NULL,'2 RUE DE LA LIBERATION','','','14120','MONDEVILLE',NULL,NULL,'1440881284001',155.000000000,'1966-04-16','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3131,'MASSON','Michel','1986-06-30','02.41.87.23.54','06.21.65.86.81',NULL,'100 RUE DE LA CHAUSSEE','','','14120','MONDEVILLE',NULL,NULL,'1860699223001',6.000000000,'2010-02-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3132,'PATRY','Yves','1944-01-01','02.34.48.09.84','06.89.16.74.70',NULL,'2 RUE DES FRENES','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1440114301001',2727.000000000,'1974-01-29','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3133,'COER','Juliette','1932-06-07','02.68.54.98.89','06.29.52.98.00',NULL,'5 rue rimbaud','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1320614990001',808.000000000,'1955-08-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3134,'PELTIER','MAURICE','1929-11-11','02.90.43.61.89','06.62.52.88.66',NULL,'645 RUE DU BOCAGE','','','14540','ROCQUANCOURT',NULL,NULL,'2291150443001',32.000000000,'1957-04-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3135,'MONTIGNY','Jean Marc','1938-09-24','02.21.41.19.77','06.39.63.61.75',NULL,'18 rue hinbaut','','',NULL,NULL,NULL,NULL,'2380914364001',2377.000000000,'1965-12-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3136,'TERRY','Sylvette','1934-07-18','02.71.08.89.75','06.89.64.18.14',NULL,'11 RUE DES DRAKKARS','','','14320','MAY SUR ORNE',NULL,NULL,'2340714167001',328.000000000,'1961-07-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3137,'DELSAUX','THERESE','1921-12-21','02.35.97.37.94','06.19.64.66.39',NULL,'21 impasse du chene','','','14150','OUISTREHAM',NULL,NULL,'1211219090001',13.000000000,'1950-04-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3138,'BREARD','Jean marie','1940-01-08','02.55.07.05.55','06.36.36.14.40',NULL,'23 RUE DE LA BIENFAISANCE','','','14710','MANDEVILLE EN BESSIN',NULL,NULL,'2400114180001',132.000000000,'1962-11-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3139,'GOUVILLE','FREDERIC','1936-10-10','02.79.53.09.29','06.80.36.60.45',NULL,'28 avenue de normandie','','','14120','MONDEVILLE',NULL,NULL,'1361050342001',14.000000000,'1960-03-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3140,'CARDINE','EVELYNE','1932-12-26','02.55.38.94.45','06.68.98.11.31',NULL,'12 rue jean jaures','','','14380','ST SEVER CALVADOS',NULL,NULL,'2321255245001',303.000000000,'1961-07-24','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3141,'CARDINE','JEAN-LOUIS','1939-11-08','02.12.25.10.54','06.60.12.32.41',NULL,'10 RUE DU BICENTENAIRE','','','61300','L''AIGLE',NULL,NULL,'2391114027001',60.000000000,'1964-01-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3142,'LAMOTTE','SYLVIE','1936-05-12','02.69.95.95.60','06.23.81.01.40',NULL,'','','','14220','THURY HARCOURT',NULL,NULL,'2360514502001',100.000000000,'1958-11-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3143,'COSTALONGA','JEAN CLAUDE','1939-01-17','02.56.18.95.73','06.69.15.56.60',NULL,'13 rue maurice fouques','','','50270','BARNEVILLE CARTERET',NULL,NULL,'1390114452001',250.000000000,'1961-09-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3144,'PASCAL','GENEVIEVE','1939-01-15','02.61.28.04.34','06.26.09.93.07',NULL,'5 BD DES VIOLETTES','','','14000','CAEN',NULL,NULL,'1390114452001',158.000000000,'1964-01-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3145,'COTEL','robert','1960-09-07','02.41.37.03.45','06.50.43.52.44',NULL,'28 AVENUE STE THERESE','','','14120','MONDEVILLE',NULL,NULL,'2600914011001',157.000000000,'1984-11-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3146,'BOUILLARD','MAURICE','1935-10-27','02.63.72.95.97','06.38.61.77.72',NULL,'12 RUE DU CALVAIRE','','','14000','CAEN',NULL,NULL,'2351014413001',137.000000000,'1957-09-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3147,'GOURDELIER','MICHELLE','1936-10-05','02.11.94.26.63','06.10.89.21.70',NULL,'7 rue roger bastion','','','50440','VASTEVILLE',NULL,NULL,'2361061145001',86.000000000,'1960-04-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3148,'BALUTA','Gabrielle','1934-07-17','02.95.07.26.42','06.30.27.01.90',NULL,'62 ROUTE DE GOUVIX','','','14123','FLEURY SUR ORNE',NULL,NULL,'2340714211001',83.000000000,'1957-06-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3149,'GALLI','GENEVIEVE','1936-08-24','02.17.70.08.45','06.60.84.02.79',NULL,'23 rue pierre curry','','','14920','MATHIEU',NULL,NULL,'2360814100001',15.000000000,'1961-01-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3150,'ETIENNE','Ginette','1946-03-20','02.10.52.19.08','06.95.12.34.03',NULL,'23 rue pierre cury','','','14730','GIBERVILLE',NULL,NULL,'1460314327001',507.000000000,'1973-09-09','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3151,'ENGUEHARD','GEORGINA','1940-12-07','02.90.43.01.35','06.10.62.30.72',NULL,'6 RUE CARDINAL LAVIGERIE','','','14930','VIEUX',NULL,NULL,'1401275045001',272.000000000,'1967-03-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3152,'LEMOIGNE','LEON','1930-01-26','02.47.08.86.03','06.68.11.92.51',NULL,'5.1 rue des marguerittes','','','14320','MAY SUR ORNE',NULL,NULL,'1300114673001',80.000000000,'1958-02-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3153,'BERTRAND','Monique','1958-02-05','02.11.32.55.24','06.63.96.06.34',NULL,'16 Bis Rue de l''Egise','','',NULL,NULL,NULL,NULL,'1580250240001',89.000000000,'1986-06-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3154,'DECOUDRE','Madeleine','1932-01-20','02.14.14.65.70','06.13.29.90.38',NULL,'19 RUE PIERRE CURIE','','','14120','MONDEVILLE',NULL,NULL,'1320114602001',2419.000000000,'1961-08-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3155,'VASSEUR','EDOUARD','1932-12-07','02.46.18.69.92','06.86.11.99.42',NULL,'','','','14400','BAYEUX',NULL,NULL,'1321214702001',311.000000000,'1956-09-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3156,'POREE','Michel','1934-02-19','02.57.19.44.53','06.10.12.95.18',NULL,'LA CHAPELLE','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1340214365001',194.000000000,'1958-03-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3157,'MAUGER','Martine','1948-01-05','02.85.31.37.59','06.11.88.37.31',NULL,'15 rue arago','','','14730','GIBERVILLE',NULL,NULL,'2480114256001',176.000000000,'1970-04-05','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3158,'MAUGER','Jeanne','1939-09-28','02.88.81.53.23','06.22.91.48.50',NULL,'RUE DE HOULLEGATTE','','','14120','MONDEVILLE',NULL,NULL,'1390914356001',9.000000000,'1964-09-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3159,'LEBOURGEOIS','mauricette','1949-03-01','02.57.04.46.86','06.33.69.26.10',NULL,'8 RUE VAL ES DUNES','','','14000','CAEN',NULL,NULL,'2490353173001',292.000000000,'1970-11-15','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3160,'JACQ','CLAUDETTE','1933-05-07','02.44.18.36.31','06.19.80.68.61',NULL,'12 RUE DE LA GARE','','','14123','IFS',NULL,NULL,'1330550494001',220.000000000,'1954-01-12','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3161,'DUBOSQ','JEAN PIERRE','1921-11-19','02.80.54.48.28','06.86.91.31.75',NULL,'1 RUE DES  MESANGES','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2211183003001',3352.000000000,'1946-06-08','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3162,'THOMAS','Martine','1931-04-18','02.41.52.62.99','06.47.68.37.48',NULL,'12 RUE PASTEUR','','','14000','CAEN',NULL,NULL,'1310414622001',1677.000000000,'1954-04-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3163,'BARBEY','LOUIS','1928-11-01','02.11.22.15.99','06.38.78.38.81',NULL,'23 RUE PREBENDE','','','27260','CORMEILLES',NULL,NULL,'2281114346001',5.000000000,'1950-11-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3164,'AVRAIN','Fernande','1934-12-01','02.15.70.24.34','06.86.72.35.63',NULL,'401 QUARTIER LEVAL','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2341214211001',583.000000000,'1962-01-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3165,'LAUNAY','Marie claire','1939-01-27','02.12.29.96.83','06.20.74.70.65',NULL,'401 QUARTIER LEVAL','','','14840','DEMOUVILLE',NULL,NULL,'2390150542001',282.000000000,'1966-06-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3166,'LEGENTIL','LEONCE','1938-06-27','02.64.08.67.43','06.78.10.80.95',NULL,'rue neuve','','','50180','AGNEAUX',NULL,NULL,'1380614662001',78.000000000,'1959-03-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3167,'DJEMA','JEAN','1932-11-01','02.12.03.04.80','06.10.93.72.68',NULL,'11 rue Moliere chemin vert','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2321114049001',33.000000000,'1954-04-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3168,'MONHUREL','MARCELINE','1930-03-16','02.89.37.72.39','06.66.63.15.35',NULL,'14 RUE DOMREMY','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1300314512001',980.000000000,'1958-03-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3169,'LEQUILLLEUC','Monique','1935-05-11','02.53.36.54.56','06.46.34.97.85',NULL,'2 RUE DU  POITOU','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1350514129001',27.000000000,'1956-06-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3170,'LEGUEDOIS','Ren','1935-05-22','02.86.16.00.45','06.71.70.09.82',NULL,'IMPASSE FOUCHARD BP 299','','','14000','CAEN',NULL,NULL,'1350514287001',416.000000000,'1965-06-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3171,'SAVEY','Michel','1955-01-23','02.80.40.01.29','06.16.69.04.73',NULL,'2 rue jean jacques rousseau','','','14000','CAEN',NULL,NULL,'2550135228001',602.000000000,'1985-12-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3172,'MARIE','Claude','1940-05-11','02.46.04.44.95','06.18.91.11.15',NULL,'5.1 rue des marguerittes','','','14520','COMMES',NULL,NULL,'2400569162001',1043.000000000,'1967-04-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3173,'FREMONT','Didier','1954-05-31','02.31.35.66.92','06.11.34.96.13',NULL,'la paneliere','','','14123','IFS',NULL,NULL,'1540514614001',90.000000000,'1978-03-28','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3174,'GALLET','DENISE','1932-04-07','02.91.61.93.14','06.24.56.52.34',NULL,'5 RUE DES PERREES','','','14260','AUNAY SUR ODON',NULL,NULL,'2320414084001',4215.000000000,'1957-08-16','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3175,'LEBRETON','GUY','1934-11-23','02.81.92.06.97','06.11.16.86.62',NULL,'31 RUE AUGUSTE LECHESNE','','','61160','BAILLEUL',NULL,NULL,'1341114090001',110.000000000,'1960-01-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3176,'LEBOUCHER','MARTINE','1930-07-07','02.20.12.30.13','06.26.69.13.26',NULL,'24 RUE DES SPORTS','','','14000','CAEN',NULL,NULL,'1300714240001',53.000000000,'1955-03-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3177,'SIMONNEAU','CHARLES','1932-09-13','02.49.15.69.04','06.10.26.28.63',NULL,'122 RUE DES DIX ACRES','','','14123','IFS',NULL,NULL,'2320914562001',58.000000000,'1953-12-11','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3178,'LEMARCHAND','CAROLE','1939-07-29','02.12.25.86.47','06.63.03.06.73',NULL,'4 ALLEE DES CHEVREFEUILLES','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1390722310001',179.000000000,'1966-03-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3179,'GIMBORD','CLAUDE','1934-03-17','02.28.11.97.26','06.43.73.84.55',NULL,'18 QUAI DE CALIGNY RESIDENCE B','RIQUEVILLE','','14500','VIRE',NULL,NULL,'1340314377001',1797.000000000,'1956-12-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3180,'SAINT-MARTIN','ALBERTINE','1935-07-09','02.11.37.80.31','06.75.15.55.52',NULL,'clairtison','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1350750473001',342.000000000,'1956-01-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3181,'FAVA','Christian','1939-11-15','02.25.78.38.95','06.36.22.43.34',NULL,'36 BOULEVARD JACQUES DUCLOS','','','61200','UROU ET CRENNES',NULL,NULL,'1391114515001',26.000000000,'1964-04-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3182,'MIECAZE','Nadine','1938-10-31','02.43.19.44.98','06.14.71.39.31',NULL,'1 RUE DES MILLEPERTUIS','','','14160','DIVES SUR MER',NULL,NULL,'2381061237001',5.000000000,'1960-09-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3183,'CHAUVEAU','YVETTE','1936-07-02','02.45.03.32.68','06.84.03.11.69',NULL,'1 RUE ALBERT SUEL','','','14930','ETERVILLE',NULL,NULL,'2360714124001',24.000000000,'1959-09-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3184,'GILLARD','NORBERT','1948-01-05','02.67.22.22.56','06.44.07.74.10',NULL,'','','','14123','IFS',NULL,NULL,'2480114589001',64.000000000,'1969-10-24','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3185,'DUBOURG DESGRANGES','RENE','1932-08-12','02.66.63.74.88',NULL,NULL,'15 RUE DU CHATEUA D EAU','','','14620','MORTEAUX COULIBOEUF',NULL,NULL,'2320814117001',370.000000000,'1960-09-19','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3186,'BAYARD','NICOLE','1956-02-26','02.77.59.95.52','06.58.26.86.91',NULL,'1 RUE DU FOCQ','','','14730','GIBERVILLE',NULL,NULL,'1560214341001',176.000000000,'1977-04-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3187,'CERVERO','Lucien','1938-10-28','02.55.66.85.94','06.68.79.71.03',NULL,'62 RUE DU MARAIS','','','14000','CAEN',NULL,NULL,'2381014310001',34.000000000,'1965-11-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3188,'AUBENEAU','GERARD','1953-09-24','02.29.83.18.56','06.11.56.33.24',NULL,'31 RUE DES VAUDES','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1530914430001',4.000000000,'1975-11-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3189,'KOZIK','JACQUES','1930-04-08','02.93.65.16.97','06.30.43.16.98',NULL,'14 RUE DE LA GARE','','','14190','FIERVILLE BRAY',NULL,NULL,'2300472331001',66.000000000,'1960-08-10','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3190,'SOUTIF','GEORGES','1948-01-13','02.74.80.26.79',NULL,NULL,'4 AVENUE DE LA VOIX AU COQ','','','14000','CAEN',NULL,NULL,'1480161006001',617.000000000,'1969-07-05','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3191,'SIMON','MARIE JEANNE','1958-02-21','02.10.20.55.80','06.79.22.66.11',NULL,'LE QUERON','','','61570','ALMENECHES',NULL,NULL,'1580214008001',38.000000000,'1980-11-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3192,'ASSELOT','Simone','1939-12-28','02.32.34.38.14','06.56.37.03.35',NULL,'LA MINIERE','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1391214200001',181.000000000,'1960-06-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3193,'LEMONGRE','Marc','1957-02-06','02.19.06.16.67','06.79.68.78.05',NULL,'35 RUE DU MANOIR','','','14480','BANVILLE',NULL,NULL,'2570272138001',0.000000000,'1983-03-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3194,'BOUFFAY','JEAN YVES','1936-12-18','02.85.62.03.81','06.83.77.40.77',NULL,'17 res uranus','','','14500','VIRE',NULL,NULL,'2361214051001',23.000000000,'1960-10-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3195,'STONINA','BERNARD','1934-01-21','02.47.28.00.25','06.69.94.20.70',NULL,'3 av d''harcourt','','','14220','FRESNEY LE VIEUX',NULL,NULL,'2340114327001',39.000000000,'1963-10-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3196,'LAMACHE','Annick','1928-04-01','02.36.17.53.63','06.23.77.44.90',NULL,'LE MESNIL','','','14120','MONDEVILLE',NULL,NULL,'2280429286001',701.000000000,'1951-06-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3197,'HARANG','Mauricette','1942-04-27','02.94.03.96.30','06.11.76.72.48',NULL,'9 rue du dauphin','','','14120','MONDEVILLE',NULL,NULL,'1420478239001',2667.000000000,'1972-09-09','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3198,'','Jean Charles','1935-01-14','02.68.90.27.29','06.33.42.35.72',NULL,'23 RUE PREBENDE','','','14730','GIBERVILLE',NULL,NULL,'1350114556001',1337.000000000,'1961-12-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3199,'FALET','PIERRE','1966-04-28','02.49.82.63.19','06.96.00.49.97',NULL,'ROUTE D''ARGENCES','','','50120','EQUEURDREVILLE HAINNEVILLE',NULL,NULL,'2660441022001',428.000000000,'1994-08-09','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3200,'ROUTIER','Gerard','1935-04-13','02.20.68.67.12','06.10.99.45.21',NULL,'','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2350414383001',351.000000000,'1956-10-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3201,'HELLOUIN','Germain','1934-03-04','02.70.60.03.13','06.80.59.01.10',NULL,'5 route de soliers','','','14730','GIBERVILLE',NULL,NULL,'2340350497001',326.000000000,'1955-04-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3202,'DUCHESNE','Jeanine','1934-06-26','02.33.93.11.42','06.48.07.74.58',NULL,'4 CHEMIN AUX BOEUFS RESIDENCES',' DES JARDINS D''IFS','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2340614167001',65.000000000,'1958-12-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3203,'ROCHER','bernard','1928-03-02','02.36.10.44.77','06.26.05.72.90',NULL,'65 av charlemagne','','','14850','ESCOVILLE',NULL,NULL,'2280314644001',15.000000000,'1949-09-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3204,'VARDON','Christiane','1940-04-21','02.55.56.41.64','06.30.53.97.45',NULL,'45 RUE DE L ORATOIRE','','','14650','CARPIQUET',NULL,NULL,'2400427283001',34.000000000,'1962-12-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3205,'FAVENNEC','CASSIA','1930-08-27','02.48.51.63.33','06.28.46.14.11',NULL,'27 rue des charmies','','','14140','ST JULIEN LE FAUCON',NULL,NULL,'1300814561001',62.000000000,'1951-11-19','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3206,'VAUGOUDE','JOCELYNE','1930-05-18','02.57.01.85.58','06.31.20.65.43',NULL,'18 rue st andre','','','14710','MANDEVILLE EN BESSIN',NULL,NULL,'2300514450001',629.000000000,'1954-06-02','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3207,'LERICHE','MARIE ODILE','1935-07-27','02.19.52.87.63','06.24.47.91.73',NULL,'4 Rue Paul Longeouain','','',NULL,NULL,NULL,NULL,'2350761328001',98.000000000,'1958-01-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3208,'RIDEL','CLAUDE','1929-08-13','02.16.93.55.24','06.16.42.24.55',NULL,'3 CHEMIN FUNGERE','','','14670','TROARN',NULL,NULL,'2290850359001',88.000000000,'1954-12-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3209,'SANSON','Arlette','1970-02-20','02.20.81.84.04','06.87.36.44.89',NULL,'70 ROUTE DE LA GUERINIERE','','','14780','LION SUR MER',NULL,NULL,'2700214558001',8.000000000,'2000-06-26','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3210,'VIGNAL','KLEBER','1933-10-30','02.44.74.44.46',NULL,NULL,'5 RUE ALBERT EINSTEIN','','','14250','VENDES',NULL,NULL,'1331091134001',242.000000000,'1954-03-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3211,'MARIE','BERNADETTE','1935-09-05','02.11.56.59.02','06.26.00.98.08',NULL,'1 CITE DES CALVAIRES','','','14123','IFS',NULL,NULL,'2350914245001',1048.000000000,'1959-11-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3212,'LEVAVASSEUR','Eliane','1935-08-28','02.11.17.57.07','06.56.74.82.84',NULL,'5 AVENUE DU COLONEL DAWSON','','','61160','TRUN',NULL,NULL,'1350850483001',593.000000000,'1963-03-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3213,'DOUSSON','GASTON','1930-01-08','02.69.40.58.29','06.95.17.04.65',NULL,'8 RUE JULES FERY','','','14530','LUC SUR MER',NULL,NULL,'1300114224001',336.000000000,'1957-05-16','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3214,'LOUVEL','Andre','1931-02-12','02.30.58.43.59','06.96.86.53.95',NULL,'105 rue de mauvais ville','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'1310250134001',24.000000000,'1955-03-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3215,'LETIEN','Andree','1935-10-31','02.55.72.30.72','06.90.90.45.85',NULL,'35 rue guillain','','','14840','DEMOUVILLE',NULL,NULL,'2351014382001',161.000000000,'1959-09-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3216,'DEPAS','Maurice','1935-03-10','02.68.37.34.93','06.66.03.92.31',NULL,'LE BOURG','','','61800','CHANU',NULL,NULL,'1350314387001',29.000000000,'1956-09-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3217,'LAULIER','ALEXIA','1937-08-27','02.80.17.26.88','06.81.60.05.76',NULL,'90 RUE SAINT MARTIN','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'1370814397001',32.000000000,'1967-07-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3218,'DELHOMMEAU','ANNY','1963-01-14','02.10.95.06.46','06.30.74.22.05',NULL,'29 rue de 6 juin','','','14000','CAEN',NULL,NULL,'2630180410001',98.000000000,'1993-05-08','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3219,'BLANDIN','ALAIN','1938-06-09','02.81.46.94.47','06.72.86.53.52',NULL,'14 AVENUE GEORGES POMPIDOU','','','14000','CAEN',NULL,NULL,'2380661260001',5100.000000000,'1964-02-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3220,'SAMSON','MICHELINE','1940-01-16','02.24.90.29.62','06.19.66.74.18',NULL,'4 rue traversiere','','','14540','BOURGUEBUS',NULL,NULL,'1400161385001',3165.000000000,'1961-02-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3221,'AUBIN','ALMA','1929-07-13','02.37.38.59.90','06.14.05.38.11',NULL,'LE VEY','','','61310','LE BOURG ST LEONARD',NULL,NULL,'2290714301001',25.000000000,'1950-11-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3222,'GUESDON','Thierry','1938-01-30','02.87.22.17.93','06.49.85.51.40',NULL,'31 RUE D''ORLEAN','','','92400','COURBEVOIE',NULL,NULL,'1380114592001',194.000000000,'1965-12-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3223,'MASSEL','YVETTE','1930-01-29','02.42.94.08.83','06.23.34.21.81',NULL,'','','','14480','LE FRESNE CAMILLY',NULL,NULL,'1300114084001',279.000000000,'1951-05-20','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3224,'DURAND','SYLVIE','1934-06-08','02.34.49.65.42','06.79.46.66.60',NULL,'7 rue paul langevin','','','14850','HEROUVILLETTE',NULL,NULL,'1340650491001',794.000000000,'1958-07-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3225,'MACE','ODETTE','1935-08-27','02.76.19.05.28','06.35.69.15.20',NULL,'22 rue du milieu','','','14940','SANNERVILLE',NULL,NULL,'1350814173001',3.000000000,'1958-06-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3226,'MADELAINE','AIME','1931-08-18','02.40.34.07.81','06.44.13.87.79',NULL,'18 RUE FOCH','','','14730','GIBERVILLE',NULL,NULL,'2310814268001',64.000000000,'1958-08-07','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3227,'SUARD','HUGUETTE','1938-01-19','02.77.77.04.81','06.10.65.98.04',NULL,'315 rue marechal montgomery','','','14400','LONGUES SUR MER',NULL,NULL,'1380114319001',116.000000000,'1963-07-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3228,'TIENNOT','Claudine','1939-05-26','02.11.24.00.28','06.84.48.56.96',NULL,'7 RUE DU PLAN DU ROY','','','14930','MALTOT',NULL,NULL,'2390514309001',192.000000000,'1960-05-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3229,'BOUSQUET','MONIQUE','1930-03-20','02.51.06.73.86','06.77.12.75.34',NULL,'4 rue andre lebastard','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2300314019001',0.000000000,'1952-06-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3230,'GODIER','ELISABETH','1931-01-25','02.87.99.80.13','06.66.82.43.53',NULL,'3 rue saint cernin','','','14840','DEMOUVILLE',NULL,NULL,'2310156167001',1964.000000000,'1954-04-05','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3231,'MIRAKIAN','HELENE','1954-02-17','02.51.97.85.27','06.31.14.11.54',NULL,'611 bd de la haute folie','','','14210','EVRECY',NULL,NULL,'2540214355001',94.000000000,'1984-07-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3232,'CASSAND','BERNADETTE','1956-02-07','02.97.57.40.78','00 33 6.99.11.11.42',NULL,'21 CHEMIN DE VILLENEUVE','','','14400','SOMMERVIEU',NULL,NULL,'1560214341001',4.000000000,'1978-01-24','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3233,'MILLET','JEAN','1939-03-16','02.11.81.87.75','06.87.68.34.43',NULL,'6 rue de la paix','','','14190','ST SYLVAIN',NULL,NULL,'1390314708001',34.000000000,'1961-12-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3234,'HELIE','MARCEL','1962-07-05','02.47.73.13.78','06.97.04.02.81',NULL,'9 PLACE DE LA PREVOYANCE','','','14990','BERNIERES SUR MER',NULL,NULL,'2620714542001',340.000000000,'1985-12-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3235,'MAUDUIT','CLAUDE','1945-04-09','02.97.65.87.10','06.18.51.20.58',NULL,'10 RUE CAMILLE BLAISOT','','','14750','ST AUBIN SUR MER',NULL,NULL,'2450450262001',281.000000000,'1966-03-03','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3236,'RAMOS','Michel','1928-10-19','02.26.22.18.09','06.18.19.96.19',NULL,'4 CHEMIN DE LA MASSE','','','14540','GRENTHEVILLE',NULL,NULL,'2281014553001',29.000000000,'1955-12-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3237,'LEBOUCHER','ROLAND','1928-03-10','02.68.87.78.14','06.69.56.39.33',NULL,'8 RUE CHARLOTTE CORDAY','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1280327467001',778.000000000,'1950-08-13','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3238,'LEBOUCHER','CHANTAL','1934-01-12','02.36.74.49.51',NULL,NULL,'155 RUE ANDRE DUPONT','','','14430','BEUVRON EN AUGE',NULL,NULL,'2340175012001',102.000000000,'1955-02-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3239,'LEPELLETIER','EUGENE','1932-08-01','02.64.61.49.61','06.68.51.06.88',NULL,'1 AVENUE GEORGES POMPIDOU','','','14123','IFS',NULL,NULL,'2320814142001',27.000000000,'1956-12-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3240,'LEVALLOIS','SOTHEAVY','1932-12-15','02.20.25.29.90','06.77.16.39.95',NULL,'11 rue du docteur roux','','','14000','CAEN',NULL,NULL,'1321214006001',110.000000000,'1958-11-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3241,'LEQUILLEUC','SOTHEAVY','1949-05-13','02.34.60.00.66','06.70.07.00.14',NULL,'3 rue saint cernin','','','14123','FLEURY SUR ORNE',NULL,NULL,'2490550097001',263.000000000,'1973-11-12','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3242,'FIANT','ALBERT','1932-07-05','02.95.67.22.31','06.47.55.91.87',NULL,'1 RUE ROMAIN ROLLAND','','','14240','PARFOURU L''ECLIN',NULL,NULL,'1320714317001',60.000000000,'1962-09-22','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3243,'LECLEAC H','JOSETTE','1949-02-16','02.10.92.70.00','06.10.13.29.87',NULL,'1 PLACE FOCH','','','14123','FLEURY SUR ORNE',NULL,NULL,'2490239110001',380.000000000,'1974-09-17','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3244,'ACHARD','CLAUDE','1918-10-19','02.11.64.71.09','06.70.41.07.56',NULL,'38 rue saint martin des bois','','','14000','CAEN',NULL,NULL,'1181061400001',12.000000000,'1940-08-19','PLATINIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3245,'MOREL','Fernand','1963-01-13','02.30.61.18.68','06.46.38.58.06',NULL,'75 RUE EUSTACHE RESTOU','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1630114327001',759.000000000,'1985-05-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3246,'LEBAS','NICOLE','1940-02-06','02.71.69.37.39','06.68.47.52.65',NULL,'18 rue albert demun','','','14790','MOUEN',NULL,NULL,'2400214005001',205.000000000,'1965-11-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3247,'RAMOCINSKI','RENE','1938-04-16','02.83.96.25.68','06.44.96.92.20',NULL,'22 RUE DES CANADIENS','','','14000','CAEN',NULL,NULL,'2380427170001',608.000000000,'1959-08-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3248,'LHOMME','DANIEL','1939-12-20','02.41.41.24.66','06.45.58.72.70',NULL,'3 rsidence des chardonnerets','','','14270','MAGNY LE FREULE',NULL,NULL,'2391250366001',3135.000000000,'1967-01-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3249,'MOISSON','ALAIN',NULL,'02.40.92.87.51','06.17.04.83.15',NULL,'19 av de normandie','','','14460','COLOMBELLES',NULL,NULL,'1590514455001',2836.000000000,'2012-08-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3250,'GALLET','JEAN','1936-09-30','02.77.54.71.42','06.71.84.20.39',NULL,'154  rue saint jean','','','14000','CAEN',NULL,NULL,'2360914589001',354.000000000,'1958-12-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3251,'GRAVEY','PASCAL','1932-03-14','02.77.82.39.03','06.85.42.29.16',NULL,'13 place de la marie','','','14370','ARGENCES',NULL,NULL,'1320363377001',36.000000000,'1953-01-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3252,'BUDOC','HELENE ANTOINET','1928-02-24','02.46.95.97.75','06.71.01.06.22',NULL,'30 rue de savoie','','','14430','DOZULE',NULL,NULL,'1280260492001',15.000000000,'1958-02-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3253,'LEPERLIER','SYLVIE','1935-04-13','02.41.85.34.63','06.90.85.49.99',NULL,'11 RUE EUGENIE','','','14120','MONDEVILLE',NULL,NULL,'1350461283001',22.000000000,'1963-11-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3254,'LENGRONNE','JEAN','1934-11-06','02.57.94.24.21','06.84.87.30.25',NULL,'2 rue des fauvettes','','','14150','OUISTREHAM',NULL,NULL,'2341114281001',65.000000000,'1955-05-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3255,'ANDRES','Marie annick','1932-03-29','02.30.74.89.76',NULL,NULL,'19 RUE CAMILLE BLAIZOT','','','14320','LAIZE LA VILLE',NULL,NULL,'2320314442001',477.000000000,'1959-12-13','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3256,'LE CORRE','JANINE','1932-05-25','02.62.41.97.44','06.47.59.77.73',NULL,'7 RUE JEAN MICHEL','','','14190','ST SYLVAIN',NULL,NULL,'2320562114001',619.000000000,'1954-05-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3257,'LEMEUNIER','BRUNO','1937-08-12','02.15.37.73.19','06.83.57.85.50',NULL,'18 RUE FOCH','','','14370','MOULT',NULL,NULL,'2370889232001',27.000000000,'1967-09-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3258,'HERVOUIN','JACQUES','1946-07-30','02.63.97.12.87','06.75.97.56.68',NULL,'1 RES ST GERBOL','','','14360','TROUVILLE SUR MER',NULL,NULL,'2460714491001',144.000000000,'1968-08-28','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3259,'JACQUES','JEAN PAUL','1938-09-28','02.35.82.49.12','06.37.23.08.73',NULL,'4 RUE DU GALION','','','27230','THIBERVILLE',NULL,NULL,'2380914516001',31.000000000,'1959-09-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3260,'ST JORE','Gerard','1930-08-16','02.40.31.30.18','06.45.85.65.01',NULL,'19 RUE VAL ES DUNES','','','14400','ST VIGOR LE GRAND',NULL,NULL,'1300850558001',119.000000000,'1960-10-11','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3261,'ANTOINE','EMILE','1937-06-03','02.34.69.56.67','06.10.45.00.50',NULL,'8 RUE DU LAVOIR','','','14160','PERIERS EN AUGE',NULL,NULL,'1370614204001',50.000000000,'1966-10-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3262,'LELIEVRE','EMILE','1938-04-14','02.19.49.57.61','06.57.87.65.94',NULL,'9 RUE CAPONIERE','','','14000','CAEN',NULL,NULL,'2380414341001',663.000000000,'1961-03-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3263,'FRANCOIS','YVES','1933-10-08','02.97.77.90.62','06.30.94.31.19',NULL,'LA PILLIERE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1331049161001',605.000000000,'1961-11-30','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3264,'RENAULT','MICHELINE','1935-06-01','02.29.60.58.21','06.84.93.63.62',NULL,'34 RUE LOUIS PASTEUR','','','14930','ETERVILLE',NULL,NULL,'1350614009001',1168.000000000,'1960-03-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3265,'MARMION','Gerard','1935-07-06','02.33.72.99.83','06.90.23.07.23',NULL,'41 RUE DU PONT CREON','','','14460','COLOMBELLES',NULL,NULL,'1350714098001',85.000000000,'1960-10-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3266,'','MADELEINE','1950-02-18','02.43.50.60.48','06.89.65.31.07',NULL,'LA PLANCHE','','',NULL,NULL,NULL,NULL,'1500214379001',3372.000000000,'1977-12-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3267,'DUVAL','MADELEINE','1929-01-15','02.33.52.52.11','06.20.33.85.88',NULL,'12 RUE PASTEUR','','','14150','OUISTREHAM',NULL,NULL,'1290114339001',902.000000000,'1954-05-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3268,'HOUSSAYE','CLAUDE','1931-10-18','02.89.04.08.80','06.71.29.60.87',NULL,'144 BOULEVARD LEROY','','','14123','IFS',NULL,NULL,'2311076456001',1419.000000000,'1954-08-08','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3269,'RATERO MARTIN','YVETTE',NULL,'02.45.62.32.48','06.72.55.64.01',NULL,'26 RUE LEONARD GILLES','','','14210','EVRECY',NULL,NULL,'1290314240001',356.000000000,'2010-04-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3270,'BUREL','EUPHROSINE','1944-03-21','02.61.89.47.29','06.69.00.28.60',NULL,'4 rue de la riviere','','','14670','TROARN',NULL,NULL,'2440327208001',292.000000000,'1967-07-29','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3271,'MARIE','THERESE','1932-01-16','02.28.47.87.74',NULL,NULL,'RUE DE L''EGLISE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2320114133001',36.000000000,'1954-07-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3272,'PETITPAS','YVES','1959-02-07','02.19.43.01.85','06.10.08.40.43',NULL,'29 RUE DU GENERAL REVEL','','','14420','USSY',NULL,NULL,'2590214034001',29.000000000,'1980-08-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3273,'LEVALLOIS','Albert','1945-02-06','02.18.92.97.09','06.11.95.15.64',NULL,'18  rue st andre','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2450214143001',174.000000000,'1975-04-27','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3274,'MADELAINE','ROGER','1929-03-10','02.11.77.27.37','06.11.15.42.97',NULL,'4 ALLEE LA VOISIER','','','14000','CAEN',NULL,NULL,'2290314431001',19.000000000,'1955-04-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3275,'VANDEWIELE GIBOT','THERESE','1929-08-24','02.85.59.36.45','06.31.02.26.83',NULL,'10 RUE BOUTEVILLE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1290814274001',336.000000000,'1953-05-06','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3276,'LECUYER','ROBERT','1929-08-26','02.16.59.94.45','06.16.50.82.71',NULL,'8 boulevard de rotel','','','14111','LOUVIGNY',NULL,NULL,'1290814274001',1342.000000000,'1955-08-19','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3277,'TERRY','MARCEL','1930-10-12','02.16.07.77.95','06.49.27.36.52',NULL,'C22','','','14123','IFS',NULL,NULL,'1301037239001',1010.000000000,'1953-01-10','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3278,'JOUEN','denise','1934-02-16','02.12.50.81.86','06.40.98.97.17',NULL,'11 rue de poitou','','','14000','CAEN',NULL,NULL,'2340214109001',463.000000000,'1964-04-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3279,'BESNEHARD','JACQUES','1937-02-08','02.87.39.08.11','06.42.33.38.80',NULL,'HAMEAU LES IFS','','','14000','CAEN',NULL,NULL,'1370299121001',126.000000000,'1961-01-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3280,'','CLAUDE','1939-04-25','02.18.92.51.66','06.58.62.20.18',NULL,'12 01 grandelle','','','14400','MOSLES',NULL,NULL,'2390414255001',95.000000000,'1962-10-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3281,'CHARLES','MARTINE','1931-10-08','02.31.34.33.83','06.91.49.13.40',NULL,'24 RUE PASTEUR','','','14190','FIERVILLE BRAY',NULL,NULL,'2311057177001',1667.000000000,'1952-08-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3282,'BAAZIZ','JEANNE','1944-01-13','02.59.38.90.70','06.89.72.45.85',NULL,'maison de retraitealienor d''aqui','taine 47 rue aristide briand  b','p209','14020','CAEN CEDEX',NULL,NULL,'1440188124001',98.000000000,'1974-06-12','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3283,'LETELLIER','MAX','1944-02-17','02.13.32.64.78','06.69.03.62.04',NULL,'39 alle des troennes','','','27260','LA CHAPELLE BAYVEL',NULL,NULL,'2440250140001',426.000000000,'1970-09-17','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3284,'TOSTAIN','ERIC','1935-12-02','02.69.18.52.46','06.62.33.75.07',NULL,'LA RESQUERIE','','','14210','NOYERS BOCAGE',NULL,NULL,'1351214218001',54.000000000,'1958-12-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3285,'GOST','MARGUERITE','1931-01-30','02.11.71.54.02','06.23.42.36.98',NULL,'2 IMPASSE DU CHIRONNE','','','14000','CAEN',NULL,NULL,'2310114274001',85.000000000,'1956-03-31','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3286,'JEANNE','CHARLOTTE','1961-01-19','02.74.36.74.84',NULL,NULL,'ROUTE DE LA TUILERIE LA COUR ST',' JEAN','','61170','BURES',NULL,NULL,'2610114167001',33.000000000,'1983-01-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3287,'LEBRETON','ANDRE','1939-04-18','02.75.21.11.29','06.50.28.51.76',NULL,'','','','14970','BENOUVILLE',NULL,NULL,'2390461206001',1192.000000000,'1962-02-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3288,'VERITE','CATHERINE','1934-04-13',NULL,NULL,NULL,'5 ROUTE DE ST ANDRE','','','14610','CAIRON',NULL,NULL,'2340414109001',170.000000000,'1960-11-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3289,'SOISNARD','SUZANNE','1928-12-28','02.74.92.76.56',NULL,NULL,'20 rue joyeuse','','','14400','MONCEAUX EN BESSIN',NULL,NULL,'2281214456001',2013.000000000,'1950-07-29','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3290,'THEVENIAUD','Andr','1929-10-12','02.15.05.46.95','06.89.73.49.29',NULL,'11 rue victor hugo','','','14360','TROUVILLE SUR MER',NULL,NULL,'2291014408001',821.000000000,'1950-08-18','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3291,'FRAVAL','SIGRID','1961-03-01','02.55.42.31.11','06.68.80.89.84',NULL,'88 RUE CHAPRON','','','14310','TOURNAY SUR ODON',NULL,NULL,'1610361283001',44.000000000,'1987-02-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3292,'BRICET','Marie louise','1940-01-23','02.66.35.36.86','06.24.30.53.94',NULL,'','','','61200','ARGENTAN',NULL,NULL,'1400127135001',73.000000000,'1969-02-01','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3293,'POREY','JOCELYNE','1932-06-09','02.11.12.25.69','06.40.74.40.24',NULL,'18 RUE ST ANDRE  3 EME ETAGE POR','TE 27','','14210','GRAINVILLE SUR ODON',NULL,NULL,'1320627076001',42.000000000,'1953-06-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3294,'MARIE','JEAN','1959-07-17','02.11.75.04.02','06.80.97.03.84',NULL,'9 rue du sieur de bras','','','14670','TROARN',NULL,NULL,'1590714567001',36.000000000,'1989-08-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3295,'LENGRONNE','annabelle','1930-04-30','02.57.77.39.91','06.96.85.04.28',NULL,'8 ALLEE DES PINS','','','14270','MEZIDON CANON',NULL,NULL,'2300427442001',260.000000000,'1951-11-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3296,'PENNEC','MICHEL','1970-01-13','02.19.57.57.94','06.89.93.47.34',NULL,'38 BOULEVARD MARECHAL LYAUTEY','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1700114076001',106.000000000,'1999-06-07','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3297,'POIRIER','MAURICE','1932-08-06','02.84.47.57.08','06.14.81.39.59',NULL,'5 BIS ROUTE DE MALTOT','','','14123','IFS',NULL,NULL,'1320814384001',370.000000000,'1954-05-14','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3298,'LAVILLE','MAURICE','1936-06-02','02.35.15.41.37','06.10.70.10.02',NULL,'23 RUE DU PONT CREON','','','14000','CAEN',NULL,NULL,'1360661351001',779.000000000,'1958-05-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3299,'DESCHAMPS','BRIGITTE','1936-08-15','02.12.02.33.46','06.10.47.28.03',NULL,'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX','XXXXXXXXXXXXXXXXXXXXXXXXXXXXX','',NULL,NULL,NULL,NULL,'1360814164001',35.000000000,'1958-03-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3300,'NOGENT','Marcel','1929-05-02','02.11.81.93.46','06.28.02.58.67',NULL,'43 AVENUE DU 6 JUIN','','','14000','CAEN',NULL,NULL,'1290514349001',60.000000000,'1952-01-31','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3301,'LEGOFF','Auguste','1935-12-21','02.42.25.51.25','06.72.42.48.24',NULL,'6 avenue du 19 mars 1962','','','50890','CONDE SUR VIRE',NULL,NULL,'2351214475001',40.000000000,'1962-04-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3302,'POISSON','PIERRE','1937-08-12','02.10.28.56.96','06.53.93.63.06',NULL,'22 RUE JACQUES BREL','','','14000','CAEN',NULL,NULL,'1370861298001',452.000000000,'1960-10-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3303,'LEMOINE','HERVE','1935-01-13','02.39.98.54.45','06.51.84.50.79',NULL,'36 av de paris','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1350114319001',55.000000000,'1965-02-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3304,'NOJAC','Simone','1948-07-30','02.70.63.88.47','06.19.39.01.60',NULL,'22 RUE DU GENERAL LECLERC','','','14630','CAGNY',NULL,NULL,'1480714449001',771.000000000,'1971-04-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3305,'LEROY','ETIENNE','1939-03-09','02.79.05.73.89','06.92.77.31.17',NULL,'12 RUE DU PLEIN SOLEIL','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1390314739001',244.000000000,'1969-03-24','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3306,'MARY','JEAN CLAUDE','1953-06-14','02.49.69.46.05','06.84.62.44.17',NULL,'19 ALLEE DES ISLES','','','14250','VENDES',NULL,NULL,'2530627229001',3317.000000000,'1975-06-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3307,'DELAHAYE','MONIQUE','1936-04-22','02.10.69.82.17','06.48.95.04.35',NULL,'7 b rue ste paix','','','14290','ORBEC',NULL,NULL,'2360414477001',2.000000000,'1962-02-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3308,'MASSON','JANINE','1937-11-24','02.47.33.09.21','06.16.77.27.70',NULL,'6 B CHEMIN DU BAS DES JARDINS','','','14840','CUVERVILLE',NULL,NULL,'1371150364001',61.000000000,'1958-01-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3309,'BRANELLEC','ODETTE','1962-09-11','02.33.79.37.37','06.63.66.81.17',NULL,'','','','14730','GIBERVILLE',NULL,NULL,'1620950453001',92.000000000,'1983-04-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3310,'','YVES','1939-05-22','02.83.55.63.58','06.85.99.11.79',NULL,'10 RUE DU PARC','','','14000','CAEN',NULL,NULL,'1390550300001',175.000000000,'1961-04-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3311,'AUSSANT','PAULE','1955-02-16','02.17.15.88.29','06.82.25.61.32',NULL,'60 BD LYAUTEY','','','14210','PREAUX BOCAGE',NULL,NULL,'2550261159001',856.000000000,'1982-03-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3312,'BAZIN','MAURICE','1936-10-02','02.50.76.20.30','06.48.97.55.75',NULL,'4 rue Jean Moulin','','','14123','IFS',NULL,NULL,'2361014551001',139.000000000,'1958-03-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3313,'GUESDON','yves','1939-10-16','02.74.47.37.29',NULL,NULL,'LIEU DIT "LA HOGUE"','','','14980','ROTS',NULL,NULL,'2391035360001',20.000000000,'1960-02-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3314,'DESHAYES','MARC','1933-05-06','02.49.52.26.96','06.76.32.16.01',NULL,'clairtison','','','14840','CUVERVILLE',NULL,NULL,'2330514213001',2.000000000,'1961-07-30','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3315,'PAYSANT','RAYMOND','1949-01-07','02.53.98.00.60','06.11.86.64.01',NULL,'LA FORGE','','','14000','CAEN',NULL,NULL,'1490114505001',166.000000000,'1975-04-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3316,'LEPAPE','ANDRE','1968-11-04','02.40.89.11.98','06.10.99.26.74',NULL,'61 j  rte de bretagne','','','14123','IFS',NULL,NULL,'1681191577001',45.000000000,'1997-07-27','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3317,'LEBRASSEUR','Armelle','1962-01-25','02.65.52.44.82','06.52.28.89.71',NULL,'5 RUE DE LA FOSSE MERBOIS','','','14000','CAEN',NULL,NULL,'2620150377001',36.000000000,'1987-02-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3318,'NICOLLE','PIERRE','1961-10-27','02.11.50.30.79','06.51.58.42.29',NULL,'19 rue de la BIENFAISANCE','','','14570','ST REMY',NULL,NULL,'1611053081001',383.000000000,'1986-01-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3319,'PICANT','JEAN LOUIS','1959-11-03','02.23.71.73.79','06.10.85.55.24',NULL,'9 rue denis diderot','','','27270','ST JEAN DU THENNEY',NULL,NULL,'2591114414001',33.000000000,'1982-11-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3320,'JOSEPH','LOUIS','1935-10-01','02.10.77.78.07','06.11.28.77.22',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1351014118001',378.000000000,'1958-02-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3321,'PRUNIER','ROGER','1930-01-31','02.27.81.80.49','06.79.09.97.77',NULL,'10 allee georges bizet','','','14123','IFS',NULL,NULL,'2300114341001',20.000000000,'1951-08-15','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3322,'CARABY','CATHERINE','1939-09-20','02.86.17.10.97','06.63.69.27.44',NULL,'VILLAGE VILLODON','','','14000','CAEN',NULL,NULL,'1390914515001',962.000000000,'1965-10-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3323,'MARIE','Andre paul','1933-07-12','02.27.96.95.80','06.34.99.46.28',NULL,'11 ALLEE DE JOBOURG','','','14730','GIBERVILLE',NULL,NULL,'1330714294001',23.000000000,'1957-06-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3324,'GIROUARD','MARCEL','1931-04-29','02.22.84.63.49','06.56.58.81.30',NULL,'34 rue de la butte aux loups','','','14000','CAEN',NULL,NULL,'2310414488001',105.000000000,'1956-12-02','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3325,'MARAINE','PIERRE','1946-01-10','02.11.58.83.83','06.61.06.83.23',NULL,'1 RUE JULES GUESDE','','','14860','BAVENT',NULL,NULL,'1460129196001',2763.000000000,'1973-01-28','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3326,'LEGENDRE','Bernard','1960-01-29','02.45.42.96.72','06.88.14.96.74',NULL,'15 rue Estienne d''Orves','','','14000','CAEN',NULL,NULL,'1600127467001',82.000000000,'1989-01-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3327,'GOUMEAUX','CLAUDE','1937-08-11','02.12.18.33.89','06.18.44.48.67',NULL,'CHEMIN DES PERELLES','','','14860','BAVENT',NULL,NULL,'2370827077001',205.000000000,'1958-06-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3328,'GRARD','ROBERT','1932-05-15','02.74.07.71.79',NULL,NULL,'10 ROUTE D'' HARCOURT','','','27300','PLAINVILLE',NULL,NULL,'2320541243001',1154.000000000,'1961-01-25','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3329,'GAMBART','ANTOINETTE','1947-01-07','02.77.58.88.71','06.55.87.73.87',NULL,'11 RUE DES MILLEHARTS','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2470114694001',23.000000000,'1977-07-09','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3330,'LAURENT','ROGER','1936-12-13','02.91.03.58.83','06.31.86.30.82',NULL,'20 rue de l''ancienne eglise','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2361214173001',127.000000000,'1966-12-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3331,'LECOQ','Vronique','1934-07-28','02.18.80.83.36','06.10.31.13.36',NULL,'22 rue albert camus','','','14940','SANNERVILLE',NULL,NULL,'2340714160001',8.000000000,'1958-11-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3332,'LAVILLE','ERNEST','1934-01-27','02.65.38.77.65','06.38.51.27.13',NULL,'9 RUE GUSTAVE FLAMBERT','','','14480','CREULLY',NULL,NULL,'1340114138001',219.000000000,'1956-04-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3333,'FAVA','CLAUDE','1955-03-01','02.67.12.93.80','06.75.19.74.54',NULL,'IMPASSE D HORIVAL','','','27550','NASSANDRES',NULL,NULL,'1550350040001',947.000000000,'1981-12-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3334,'IMHOF','MARIE LOUISE','1936-08-22','02.77.71.00.63','06.23.24.46.97',NULL,'LE MESNIL NOBLE','','','14000','CAEN',NULL,NULL,'2360850129001',95.000000000,'1962-10-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3335,'LEDENTU','DANIEL','1930-11-05','02.33.22.19.23','06.82.29.60.40',NULL,'7 impasse de l egalite','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1301114090001',1087.000000000,'1951-06-14','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3336,'PACARY','DANIEL','1958-02-01','02.11.83.97.58','06.51.55.89.47',NULL,'11 rue de bourgogne','','','14460','COLOMBELLES',NULL,NULL,'1580214268001',25.000000000,'1987-02-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3337,'LETENNEUR','JOCELYNE','1932-07-21','02.11.03.59.08','06.28.30.79.91',NULL,'8 saint au moine','','','14630','CAGNY',NULL,NULL,'1320714040001',22.000000000,'1955-11-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3338,'BLESTEL','EUGENE','1955-01-23','02.55.95.87.75','06.72.85.12.09',NULL,'6 rue de colombelles','','','14000','CAEN',NULL,NULL,'1550114491001',47.000000000,'1979-11-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3339,'CATHERINE','SYLVIE','1946-03-21','02.46.38.89.23','06.57.06.96.69',NULL,'7 RUE HENRI PHILIPPE','','','14114','VER SUR MER',NULL,NULL,'2460314507001',657.000000000,'1972-10-03','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3340,'LERICHE','SIMONE','1954-03-12','02.61.03.29.47','06.29.81.10.99',NULL,'32 rue des canadiens','','','14120','MONDEVILLE',NULL,NULL,'2540314212001',359.000000000,'1983-08-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3341,'LECOUTE','LUCIENNE','1937-04-14','02.10.55.10.86','06.13.04.49.41',NULL,'120 rue du chateau d''eaux','','','14000','CAEN',NULL,NULL,'1370414752001',1085.000000000,'1960-12-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3342,'VILLAIN','ANDRE','1939-08-12','02.38.95.57.30','06.61.31.47.04',NULL,'7 IMPASSE DES MURIERS','','','14530','LUC SUR MER',NULL,NULL,'1390814342001',132.000000000,'1961-11-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3343,'MABIRE','MICHELE','1945-02-14','02.10.89.70.08','06.71.00.43.22',NULL,'13 RUE FERNAND LEGER','','','50440','VASTEVILLE',NULL,NULL,'2450261364001',1.000000000,'1967-05-03','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3344,'LETESSE','Bernadette','1937-04-21','02.42.50.39.38','06.61.40.71.42',NULL,'15 rue jean jacques rousseau','','','50310','VAUDREVILLE',NULL,NULL,'2370427218001',2398.000000000,'1961-03-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3345,'GERVAIS','HUBERT','1930-06-18','02.11.58.07.25','06.80.02.81.05',NULL,'3 rue charlotte corday','','','14370','CROISSANVILLE',NULL,NULL,'1300614025001',255.000000000,'1957-07-24','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3346,'LEROSSIGNOL','ROLANDE','1938-10-08','02.10.51.23.37','06.32.43.92.65',NULL,'13 place voltaire','','','14730','GIBERVILLE',NULL,NULL,'1381014690001',102.000000000,'1966-07-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3347,'PICHONNIER','PALMYRE','1956-01-09','02.50.32.36.20','06.45.32.68.81',NULL,'2 rue des pavillons','','','14700','FALAISE',NULL,NULL,'1560114166001',10.000000000,'1978-11-12','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3348,'HAIRY','Juliette','1930-06-08','02.16.37.93.45','06.20.88.80.45',NULL,'54 RUE DE LA SEINE','','','14420','USSY',NULL,NULL,'1300614543001',90.000000000,'1955-09-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3349,'LEMARCHAND','Aubert','1929-04-09','02.61.38.67.25','06.23.73.59.54',NULL,'1 ALLEE DES FOUGERES   CIDEX J35','','','14000','CAEN',NULL,NULL,'1290414655001',897.000000000,'1950-02-06','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3350,'MURAT','Jean','1933-06-16','02.83.60.59.83','06.64.20.49.59',NULL,'1 CHEMIN DU PRESBYTERE','','','14370','ARGENCES',NULL,NULL,'2330614246001',7.000000000,'1963-08-23','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3351,'SILLIERE','Michel','1937-03-04','02.34.24.66.39','06.12.20.50.17',NULL,'','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2370314215001',129.000000000,'1958-10-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3352,'HERSENT','ROLAND','1943-07-21','02.72.68.43.36','06.11.57.34.56',NULL,'28 route de Lieury','','','14000','CAEN',NULL,NULL,'2430714554001',39.000000000,'1964-01-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3353,'LONGUET','RENEE','1933-12-03','02.31.38.14.24','06.74.50.83.52',NULL,'17 BIS RUE JEANNE D''ARC','','','14630','FRENOUVILLE',NULL,NULL,'1331214297001',32.000000000,'1957-08-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3354,'BINET','GILBERT','1933-05-21','02.10.40.49.61','06.33.51.24.74',NULL,'3 rue morin ruffier','','','14990','BERNIERES SUR MER',NULL,NULL,'2330514129001',1375.000000000,'1954-11-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3355,'STREBEL','MAURICE','1931-07-28','02.99.34.80.11','06.73.26.86.82',NULL,'4 ALLEE CHARLES TOUPE','','','14860','BAVENT',NULL,NULL,'2310702795001',181.000000000,'1960-11-28','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3356,'BOUILLY','JOSIANE','1937-03-07','02.16.53.23.80','06.80.87.20.92',NULL,'4 RUE MOUSSARD','','','14730','GIBERVILLE',NULL,NULL,'2370314456001',1.000000000,'1965-07-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3357,'BELLAIR','GINETTE','1961-06-17','02.82.39.60.88','06.88.04.60.14',NULL,'15 RUE DES CANADIENS','','','14000','CAEN',NULL,NULL,'2610614306001',180.000000000,'1987-01-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3358,'DESVAGES','HELENE','1936-10-11','02.60.59.55.30','06.96.06.24.71',NULL,'ROUTE DU BEAU MOULIN "HAMEAU LA','CAUVINEE"','','14000','CAEN',NULL,NULL,'2361027591001',1961.000000000,'1958-07-31','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3359,'LEBOSQ','DANIEL','1936-06-21','02.13.28.12.53','06.22.22.45.65',NULL,'5 ROUTE DE TIMCHEBRAY','','','14000','CAEN',NULL,NULL,'2360661086001',37.000000000,'1964-09-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3360,'FAVRIS','MARCEL','1963-06-13','02.84.76.23.92','06.83.39.07.35',NULL,'10104 bvd belles portes','','','14123','FLEURY SUR ORNE',NULL,NULL,'2630614090001',828.000000000,'1985-11-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3361,'DEROY','Gaston','1929-12-15','02.10.68.88.73','06.59.76.42.66',NULL,'','','','50440','GREVILLE HAGUE',NULL,NULL,'2291214514001',29.000000000,'1951-04-20','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3362,'BARREY','ALAIN','1934-05-13','02.99.06.47.34','06.22.27.16.09',NULL,'20 rue de l''etang','','','50200','COUTANCES',NULL,NULL,'2340514006001',39.000000000,'1960-07-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3363,'AMAURY','ANNICK','1951-01-12',NULL,NULL,NULL,'HAMEAU DE MORIERE','','','14000','CAEN',NULL,NULL,'2510114538001',1248.000000000,'1980-09-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3364,'WYKA','RENEE','1939-05-05','02.43.26.59.52','06.58.47.82.35',NULL,'12 rue franklin','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2390514515001',1730.000000000,'1969-06-28','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3365,'LE COHUE','GUY','1931-08-01','02.35.80.86.10','06.69.98.83.43',NULL,'12 rue franklin','','','14059','CAEN',NULL,NULL,'1310814257001',324.000000000,'1956-10-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3366,'PUSTELNIKA','LOUIS','1928-11-20','02.83.28.77.44','06.59.45.91.97',NULL,'23 RUE BARBEUX','','','14190','CAUVICOURT',NULL,NULL,'1281161346001',920.000000000,'1950-11-16','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3367,'LEPELTIER','CLAUDE','1931-11-28','02.11.86.38.52','06.63.06.40.53',NULL,'8 rue denis diderot','','','14730','GIBERVILLE',NULL,NULL,'1311114602001',1257.000000000,'1955-05-17','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3368,'MARY','CLAUDE','1935-09-27','02.28.22.73.85','06.81.04.87.43',NULL,'8 RUE DES EPICIERS','','','14000','CAEN',NULL,NULL,'1350950298001',84.000000000,'1957-06-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3369,'CAPELLO','PIERRE','1931-04-20','02.73.41.21.14','06.57.27.41.64',NULL,'RUE DES CERISIERS','','','14250','TILLY SUR SEULLES',NULL,NULL,'2310450046001',19.000000000,'1956-12-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3370,'BROQUET','SUZANNE','1929-04-13','02.82.44.36.66','06.70.61.69.25',NULL,'29 rue du stade','','','14540','BOURGUEBUS',NULL,NULL,'1290414704001',290.000000000,'1955-01-16','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3371,'TANQUEREL','GILLES','1936-03-14','02.10.68.02.33','06.84.07.08.04',NULL,'29 rue du stade','','','14370','ARGENCES',NULL,NULL,'2360314437001',11.000000000,'1966-09-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3372,'DENIS','M THERESE','1934-02-21','02.73.70.52.43','06.57.62.32.87',NULL,'17 RUE HENRI BARBUSSE','','','14000','CAEN',NULL,NULL,'2340250433001',96.000000000,'1963-02-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3373,'ROUSSELLE','DANIELLE','1934-10-09','02.42.28.63.91','06.98.04.45.81',NULL,'7 rte de verson','','','14370','MOULT',NULL,NULL,'1341014325001',23.000000000,'1959-03-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3374,'MAISERET','MAXIME','1965-06-18','02.80.99.30.30','06.26.81.95.72',NULL,'16 RUE HAUTE','','','14000','CAEN',NULL,NULL,'1650614319001',679.000000000,'1987-07-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3375,'ANGER','JOSETTE','1931-11-01','02.65.42.88.23','06.75.72.62.01',NULL,'grande rue','','','14000','CAEN',NULL,NULL,'2311114370001',16.000000000,'1952-07-31','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3376,'JOBARD','Andre','1935-12-18','02.86.87.24.16','06.95.08.66.52',NULL,'2 ALLEE DU ROUGE GORGES','','',NULL,'GIBERVILLE',NULL,NULL,'2351214653001',20.000000000,'1957-11-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3377,'NIO','THERESE','1933-06-30','02.69.07.43.23','06.86.89.23.64',NULL,'28 rue de l''esperance','','','14000','CAEN',NULL,NULL,'1330614171001',1069.000000000,'1957-02-20','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3378,'ALIPBAEV','MYRIAM','1962-05-16','02.36.33.96.22','06.22.94.10.18',NULL,'LE BOURG','','','14123','IFS',NULL,NULL,'1620514416001',149.000000000,'1988-07-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3379,'ROBINE','MARIE AGNES','1922-09-30','02.16.19.99.91','06.23.58.93.37',NULL,'6 allee du general simonds','','','14630','CAGNY',NULL,NULL,'1220967324001',29.000000000,'1945-02-12','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3380,'LE HELLAYE','REGIS','1966-07-15','02.52.88.58.21','06.57.58.77.73',NULL,'1 IMPASSE DES MELEZES','','','14000','CAEN',NULL,NULL,'1660761490001',468.000000000,'1989-04-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3381,'GUERIN','CHRISTIAN','1970-01-15','02.77.02.70.34','06.32.44.75.17',NULL,'le desertif','','',NULL,NULL,NULL,NULL,'1700114076001',1027.000000000,'1999-09-15','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3382,'LECOQ','ADRIENNE','1939-07-07','02.81.51.08.51','06.69.47.27.44',NULL,'9 bvd de l''esperance','','','14710','COLOMBIERES',NULL,NULL,'2390761044001',736.000000000,'1964-09-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3383,'SOUCHON','JEAN','1933-07-31','02.77.79.65.22','06.81.44.28.96',NULL,'14 rue nicolas copernic','','','14860','BAVENT',NULL,NULL,'1330714312001',996.000000000,'1955-09-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3384,'VANOVERBEKE','JEAN','1937-12-26','02.73.76.89.63','06.87.92.33.65',NULL,'residence des personnes ages ru','e des acacias','','14000','CAEN',NULL,NULL,'1371250564001',75.000000000,'1961-08-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3385,'LEROY','Bernadette','1929-09-05','02.49.03.25.87','06.53.46.05.11',NULL,'25 RUE VICTOR LEPINE','','','14270','MEZIDON CANON',NULL,NULL,'1290914174001',152.000000000,'1954-03-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3386,'LECOEUR','THERESE','1937-02-14','02.37.96.35.78','06.70.96.50.60',NULL,'3/1 RUE DES BALCONS','','','14630','FRENOUVILLE',NULL,NULL,'1370276643001',70.000000000,'1967-07-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3387,'CHABOCHE','ANDRE-PAUL','1950-07-29','02.48.13.51.42','06.11.60.33.03',NULL,'2 rue des balcons','','','14000','CAEN',NULL,NULL,'2500761273001',14.000000000,'1974-02-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3388,'RIVIERE','GERARD','1937-04-20','02.65.56.64.65','06.43.98.61.50',NULL,'1 rue des carmes','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2370414238001',458.000000000,'1961-02-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3389,'HOUEL','MARIE JANINE',NULL,'02.18.33.33.99','06.85.97.53.58',NULL,'','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1451050129001',30.000000000,'2010-05-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3390,'CROS','MICHEL','1950-01-30','02.90.35.38.78','06.13.76.73.74',NULL,'5 GRANDE RUE','','','14370','GIBERVILLE',NULL,NULL,'2500150435001',308.000000000,'1980-05-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3391,'HEBERT MADELAINE','ROGER','1956-02-20','02.68.67.07.15','06.15.45.16.70',NULL,'13 route de bretagne','','','14123','IFS',NULL,NULL,'2560250361001',30.000000000,'1981-08-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3392,'','PAULETTE','1940-05-03','02.79.85.54.57','06.10.92.44.72',NULL,'ferme d''ailly','','','95130','FRANCONVILLE',NULL,NULL,'2400518091001',85.000000000,'1965-03-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3393,'','CHRISTIAN',NULL,'02.72.16.82.07','06.76.58.60.88',NULL,'6 impasse des myosotis','','','14320','FONTENAY LE MARMION',NULL,NULL,'2301150339001',4073.000000000,'2012-08-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3394,'LEMONNIER','ROBERT','1930-01-11','02.19.80.47.55','06.14.55.43.92',NULL,'13 rue jacques prevert','','','14220','THURY HARCOURT',NULL,NULL,'2300128046001',24.000000000,'1952-04-27','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3395,'MAUPOU','pierrette','1933-10-08','02.25.64.01.99','06.22.87.49.44',NULL,'3 chemin du moulin','','','14000','CAEN',NULL,NULL,'1331027252001',514.000000000,'1954-08-29','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3396,'LANGEVIN','Camille','1932-05-26','02.30.86.40.09','06.44.22.95.85',NULL,'83 AVENUE JEAN JAURES','','','14490','BALLEROY',NULL,NULL,'2320561477001',10.000000000,'1955-02-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3397,'BAZEILLE','Simone','1936-01-28','02.64.26.73.27','06.27.09.14.48',NULL,'Chez Mme Belcombe 9 rue de la Cr','ete St Jean','','14123','IFS',NULL,NULL,'1360114353001',31.000000000,'1959-11-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3398,'GUERIN','BERNARD','1932-02-06','02.71.18.43.23','06.55.87.51.88',NULL,'9 IMPASSE LE VALTRU','','','14123','IFS',NULL,NULL,'1320214552001',32.000000000,'1960-10-03','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3399,'DEMORIEUX','jean','1933-07-09','02.10.49.95.91','06.62.42.00.50',NULL,'9 RUE DE BURON','','','14000','GIBERVILLE',NULL,NULL,'1330714076001',313.000000000,'1956-06-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3400,'FLEURY','JEAN','1974-01-17','02.10.79.63.91','06.87.06.00.25',NULL,'16 RUE LORD LOVAT','','','14390','CABOURG',NULL,NULL,'2740199239001',550.000000000,'1997-06-29','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3401,'NOEL','CZESSIAWA','1933-11-26','02.31.74.47.40',NULL,NULL,'','','','14121','SALLENELLES',NULL,NULL,'1331114627001',2358.000000000,'1960-05-10','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3402,'','DANIEL','1948-03-05','02.83.12.36.51','06.76.74.58.27',NULL,'15 RUE DES POMMIERS','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'1480350317001',113.000000000,'1974-07-02','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3403,'HAMEL','DOMINIQUE','1930-07-09','02.44.45.25.39','06.97.38.41.18',NULL,'115 RUE MALIFE','','','61100','FLERS',NULL,NULL,'1300750030001',23.000000000,'1951-07-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3404,'LE FRANCOIS','JEAN MICHEL','1942-03-13','02.86.68.78.57','06.34.89.08.66',NULL,'13 ALLEE DE LA FOSSE A GARENNE','','','14270','GIBERVILLE',NULL,NULL,'2420314112001',4059.000000000,'1969-07-05','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3405,'QUETEL','PHILIPPE','1944-01-28','02.22.05.04.43','06.23.04.20.48',NULL,'LE PETIT CHATEAU','','','14630','FRENOUVILLE',NULL,NULL,'2440114689001',11.000000000,'1971-06-18','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3406,'LORIN','Yolande','1945-03-09','02.51.90.14.88','06.11.01.97.55',NULL,'7 rue albert de mun','','','14000','CAEN',NULL,NULL,'2450350307001',448.000000000,'1967-06-10','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3407,'VIARD','ODETTE','1933-03-13','02.28.86.03.93','06.90.49.26.33',NULL,'1 CHEMIN DU PUIT','','','14120','MONDEVILLE',NULL,NULL,'2330314221001',24.000000000,'1963-02-05','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3408,'BOUET','CECILE','1935-07-27','02.59.67.60.36','06.56.86.10.66',NULL,'10 RUE DES CHARRONS','','','14860','BAVENT',NULL,NULL,'1350714410001',209.000000000,'1957-01-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3409,'DECAUMONT','SUZANNE','1935-09-18','02.11.30.07.93','06.15.13.48.56',NULL,'4 rue de la dml','','','14210','VACOGNES NEUILLY',NULL,NULL,'1350950614001',209.000000000,'1958-12-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3410,'LE MEULAIS','BERNARD','1931-10-20','02.59.42.39.54','06.33.26.76.52',NULL,'LIEU DIT" LE BRULE"','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2311014434001',21.000000000,'1954-11-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3411,'DESHAYES','YVONNE','1939-04-15','02.72.91.64.58','06.18.93.43.11',NULL,'pl de la poste','','','14000','CAEN',NULL,NULL,'2390414606001',41.000000000,'1966-10-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3412,'JABOT','YVONNE','1968-04-16','02.36.25.97.46','06.82.45.70.33',NULL,'23 route de cormeille','','','14400','BAYEUX',NULL,NULL,'2680414118001',78.000000000,'1995-07-19','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3413,'COULANGE','MICHEL','1935-12-19','02.46.94.38.95','06.11.67.17.59',NULL,'7 RUE STE PAIX','','','14123','IFS',NULL,NULL,'1351214320001',37.000000000,'1959-01-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3414,'LEGRAS','THERESE','1929-03-08','02.81.16.61.38','06.15.67.97.26',NULL,'55 ROUTE D IFS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1290350076001',57.000000000,'1951-02-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3415,'LANFRANC DE PANTHOU','PAULETTE','1933-04-30','02.95.73.30.26','06.80.08.61.31',NULL,'22 RUE DU PARC','','','14840','DEMOUVILLE',NULL,NULL,'2330450438001',323.000000000,'1958-04-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3416,'MERLE','EDMOND','1929-02-11','02.75.09.34.75','06.92.32.09.13',NULL,'3 RUE ROGER DECHAMBRE','','','14540','GRENTHEVILLE',NULL,NULL,'1290261436001',122.000000000,'1952-06-22','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3417,'','ALAIN','1950-01-24','02.30.51.84.06','06.89.51.51.56',NULL,'51 rue de la ronde couture','','','14740','SECQUEVILLE EN BESSIN',NULL,NULL,'2500150226001',1535.000000000,'1975-01-22','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3418,'HAMELIN','MARIE','1952-04-19','02.85.37.99.31','06.50.18.81.91',NULL,'L HERMITAGE','','','14630','CAGNY',NULL,NULL,'2520414257001',70.000000000,'1973-02-12','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3419,'HAMELIN','CLAUDE','1938-06-20','02.68.86.44.95','06.11.87.31.97',NULL,'1 RUE HENRI LEFEVRE','','','61600','MAGNY LE DESERT',NULL,NULL,'2380614211001',768.000000000,'1966-06-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3420,'AMELINE','GUY','1932-09-09','02.58.79.78.41','06.24.10.97.28',NULL,'LE HAMEAU BERTHEAUME','','','14000','CAEN',NULL,NULL,'2320914046001',2773.000000000,'1953-07-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3421,'HUET','guy','1935-08-07','02.13.08.15.18','06.11.51.78.98',NULL,'37 LES MARTINS','','','14123','IFS',NULL,NULL,'2350814552001',819.000000000,'1959-07-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3422,'LEHAIN','GUY','1929-02-02','02.38.78.99.30','06.65.02.98.26',NULL,'12 RUE DE VIRE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2290250546001',28.000000000,'1950-02-21','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3423,'DOUCERAIN','michel','1949-03-03','02.26.40.49.99','06.18.88.84.84',NULL,'PILLET WILL','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1490314294001',596.000000000,'1977-09-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3424,'LEROULLEY','MADELEINE','1957-06-27','02.34.83.96.75','06.71.75.65.90',NULL,'28 rue des quesnots','','','14670','TROARN',NULL,NULL,'2570614074001',6.000000000,'1978-04-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3425,'PIRE','COLETTE','1931-01-12','02.13.93.94.97','06.82.57.03.04',NULL,'107 BD GAL VANNIER','','','14120','MONDEVILLE',NULL,NULL,'2310114476001',155.000000000,'1958-07-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3426,'CHALLES','SUZANNE','1929-08-21','02.84.82.37.22','06.70.73.39.41',NULL,'20 RUE DES CORMORANS','','','14200','GIBERVILLE',NULL,NULL,'2290814118001',135.000000000,'1956-06-28','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3427,'GIBERT','GASTON','1951-01-31','02.74.50.37.02',NULL,NULL,'18 RUE DE VERRIERE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2510114661001',759.000000000,'1973-01-19','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3428,'CANONNE','ALAIN','1941-01-31','02.95.80.65.94','06.44.13.79.35',NULL,'23 ROUTE DE PARIS','','','14700','VERSAINVILLE',NULL,NULL,'1410114662001',33.000000000,'1964-04-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3429,'LAMY','GERARD','1932-07-31','02.85.51.58.98','06.97.02.59.19',NULL,'20 GRANDE RUE','','','14000','CAEN',NULL,NULL,'1320750384001',148.000000000,'1954-07-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3430,'VASNIER','PAULETTE','1929-05-01','02.94.08.02.90','06.29.81.18.48',NULL,'1 rue des tilleuls','','','14000','CAEN',NULL,NULL,'2290514312001',169.000000000,'1950-01-05','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3431,'DUFOUR','FREDERIC','1939-08-24','02.47.23.43.64','06.35.83.52.31',NULL,'2 RUE DE L''ILE DE FRANCE','','','14123','IFS',NULL,NULL,'2390814258001',1.000000000,'1964-11-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3432,'DUFOUR','PATRICIA','1939-06-03','02.62.68.09.52','06.24.81.24.95',NULL,'14 RUE MORIN RUFFIER','','','61100','FLERS',NULL,NULL,'1390614305001',868.000000000,'1961-11-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3433,'EUDELINE','Bernard','1962-11-21','02.65.41.71.49','06.34.30.74.37',NULL,'29 RUE DES COTEAUX','','','14000','CAEN',NULL,NULL,'1621114158001',32.000000000,'1983-04-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3434,'VALLEE','GISELE','1941-04-28','02.45.04.45.35','06.98.04.44.46',NULL,'chemin des croix','','','14730','GIBERVILLE',NULL,NULL,'1410414321001',682.000000000,'1964-03-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3435,'VALLEE','JEANNE','1956-05-05','02.85.31.19.71','06.26.59.45.68',NULL,'saint ouen du mesnil auger','','','14220','CURCY SUR ORNE',NULL,NULL,'1560550568001',211.000000000,'1985-07-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3436,'BASLY','JEAN','1939-02-27','02.49.19.75.86','06.65.46.51.54',NULL,'39 RUE DE LA PILLARDIERE','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'2390261194001',35.000000000,'1962-06-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3437,'MORIN','FRANCOIS','1938-05-14','02.10.93.96.23','06.48.07.96.95',NULL,'6 RUE GEORGES CLEMENCEAU','','','14000','CAEN',NULL,NULL,'1380560653001',714.000000000,'1964-04-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3438,'VIVIEN','CATHERINE','1958-03-14','02.85.21.85.23','06.64.02.65.04',NULL,'7 route de lile de france','','','50570','MARIGNY',NULL,NULL,'2580314050001',75.000000000,'1980-03-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3439,'LHOMME','NATHALIE','1939-08-07','02.26.69.35.72','06.35.86.16.22',NULL,'33 rue clos du pavillon','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1390814734001',2373.000000000,'1965-03-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3440,'BEAUFILS','JEANNE','1962-02-27','02.10.01.81.99','06.18.00.85.57',NULL,'19 rue eugenie','','','14120','MONDEVILLE',NULL,NULL,'2620214213001',399.000000000,'1983-06-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3441,'LEFORT','ELIANE','1940-03-15','02.29.69.53.59','06.82.86.02.76',NULL,'14 RUE DU COURSIN','','','14210','EVRECY',NULL,NULL,'1400350236001',116.000000000,'1962-05-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3442,'MAURICE','GHISLAINE','1933-10-12','02.40.78.58.19','06.60.84.16.43',NULL,'8 allee de laperoirse','','','14540','POUSSY LA CAMPAGNE',NULL,NULL,'1331014271001',7.000000000,'1954-06-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3443,'D ANDREA','YVETTE','1931-11-20','02.84.11.21.13','06.22.26.52.64',NULL,'6 RUE DE LA PLACE','','',NULL,NULL,NULL,NULL,'1311114066001',370.000000000,'1954-05-23','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3444,'GAILLARD','sebastien','1931-10-27','02.57.38.54.73','06.13.11.87.02',NULL,'19 LE BOURG','','','14540','GRENTHEVILLE',NULL,NULL,'1311061446001',768.000000000,'1952-01-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3445,'CANDELE','THERESE','1931-10-25','02.90.50.99.60','06.73.38.83.36',NULL,'2 rue du calvaire','','','14123','IFS',NULL,NULL,'2311014216001',268.000000000,'1960-10-10','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3446,'JACQUES','JEAN','1943-01-14','02.85.70.02.78','06.11.13.84.72',NULL,'21 RUE CAMILLE BLAIZOt','','','14000','CAEN',NULL,NULL,'1430161232001',56.000000000,'1964-05-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3447,'ASSELINE','RAYMONDE','1938-03-30','02.56.67.93.72','06.85.32.15.39',NULL,'4 RUE DE LA ROUVRE','','','14000','CAEN',NULL,NULL,'2380314513001',183.000000000,'1968-09-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3448,'LEBRETHON','MARIE THERESE','1981-09-17','02.55.10.27.77','06.97.51.43.40',NULL,'3 IMPASSE ALBERT CAMUS','','','14840','DEMOUVILLE',NULL,NULL,'2810999416001',80.000000000,'2009-03-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3449,'GRAFFET','GERARD','1969-11-08','02.28.78.91.91','06.99.17.07.62',NULL,'115 chemin aux boeufs','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1691199256001',37.000000000,'1995-02-26','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3450,'','michel','1933-06-19','02.77.94.84.13','06.31.81.84.09',NULL,'6 rue lucien mangematin','','','14710','LA FOLIE',NULL,NULL,'1330661361001',3814.000000000,'1958-02-12','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3451,'MABIRE','MICHELINE','1928-01-06','02.68.84.00.11','06.46.88.53.90',NULL,'3 impasse du home','','','14730','GIBERVILLE',NULL,NULL,'1280180218001',4968.000000000,'1954-11-27','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3452,'CONTENTIN','ANDRE','1919-10-30','02.74.29.69.25',NULL,NULL,'3 ALLEE DES POETES','','','14540','ROCQUANCOURT',NULL,NULL,'1191014008001',37.000000000,'1944-02-19','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3453,'QUESNEL','JEAN','1932-03-21','02.90.20.66.63','06.17.89.35.85',NULL,'6 IMPASSE DES MARGUERITTES','','','14370','ARGENCES',NULL,NULL,'1320314579001',38.000000000,'1960-05-31','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3454,'GORDIEN','GINETTE','1924-09-09','02.11.57.07.65','06.24.39.90.99',NULL,'23 RUE DE LA LIBERATION','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1240995501001',901.000000000,'1949-02-11','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3455,'GORDIEN','REGINE','1940-02-25','02.11.80.93.88','06.18.88.41.62',NULL,'1 RUE CARDINAL LAVIGERIE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1400250469001',53.000000000,'1967-07-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3456,'HEBERT','REGINE','1931-04-16','02.88.87.28.38','06.66.73.10.59',NULL,'14 alle des potes','','','14000','CAEN',NULL,NULL,'2310414292001',49.000000000,'1960-08-26','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3457,'FIANT','CLAUDE','1933-09-22','02.85.40.42.65','06.48.88.92.54',NULL,'14-9 RUE DU BOIS','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1330914391001',6.000000000,'1963-09-30','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3458,'HUARD','ANNE MARIE','1927-07-08','02.26.63.63.30','06.88.86.60.37',NULL,'4 rue du manoir','','','14500','VAUDRY',NULL,NULL,'2270724297001',941.000000000,'1956-08-11','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3459,'EUDINE','JACQUELINE','1940-11-25','02.12.83.09.32','06.21.31.54.35',NULL,'1 rue de le liberation','','','14220','BOULON',NULL,NULL,'1401150039001',37.000000000,'1968-12-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3460,'FRARY','OLIVIER','1964-03-10','02.64.91.78.79','06.83.76.05.17',NULL,'12 AVENUE DE LA CONCORDE','','','14000','CAEN',NULL,NULL,'2640314003001',218.000000000,'1988-04-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3461,'FREIDOZ','MICHEL','1954-04-02','02.55.69.75.97','06.34.06.06.05',NULL,'33 route de trouville','','','14460','COLOMBELLES',NULL,NULL,'2540414617001',34.000000000,'1984-07-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3462,'LEMARCHAND','ANDRE','1928-06-24','02.71.64.02.51','06.71.03.43.34',NULL,'23 RUE MAURICE LEGAL','','','14000','CAEN',NULL,NULL,'1280614177001',35.000000000,'1954-06-17','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3463,'TANQUEREL','CHARLES','1939-08-02','02.34.14.39.53','06.38.16.72.44',NULL,'55 RUE DE CAEN','','','14190','FIERVILLE BRAY',NULL,NULL,'1390814195001',30.000000000,'1963-12-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3464,'LESACHEY','YVES','1933-11-19','02.74.16.99.14',NULL,NULL,'ROUTE DE CAEN','','','14123','FLEURY SUR ORNE',NULL,NULL,'2331114369001',14.000000000,'1962-12-23','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3465,'COURTAI','SIMONE','1933-11-30','02.10.07.43.22','06.83.77.36.05',NULL,'13 RUE DE LA CHARITE','','','61200','ARGENTAN',NULL,NULL,'1331161069001',1016.000000000,'1957-09-16','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3466,'BEAUNEZ','SIMONE','1933-11-06','02.80.81.51.91','06.61.56.72.25',NULL,'38 BV LIAUTEY','','','14170','JORT',NULL,NULL,'2331114335001',16.000000000,'1963-01-08','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3467,'BELLOTEAU','CHRISTIAN','1934-09-06','02.16.85.22.08','06.57.14.79.59',NULL,'10 IMPASSE JACQUARD','','','14700','LA HOGUETTE',NULL,NULL,'1340914481001',9.000000000,'1955-04-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3468,'LE SECQ','ETIENNE','1961-03-05','02.50.08.14.58','06.74.22.89.86',NULL,'','','','61200','ARGENTAN',NULL,NULL,'2610378419001',593.000000000,'1990-10-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3469,'MELINOU','ALAIN','1940-04-28','02.94.85.64.56','06.63.86.40.32',NULL,'11 rue st jean baptiste','','','14940','SANNERVILLE',NULL,NULL,'2400482166001',14.000000000,'1962-07-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3470,'GUIBERT','PAULETTE','1966-09-20','02.10.15.22.13','06.64.09.11.97',NULL,'5 RUE DU BUISSON','','','14500','VIRE',NULL,NULL,'1660914074001',61.000000000,'1995-04-26','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3471,'HALLEY','BRUNO','1930-07-08','02.40.05.00.63','06.95.48.70.40',NULL,'5 rue claude chappe','','','14730','GIBERVILLE',NULL,NULL,'2300737122001',366.000000000,'1955-07-30','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3472,'NOEL','CLAUDE','1929-07-18','02.88.04.09.78','06.26.95.12.34',NULL,'52 RUE DE LA LIBERTE','','','14570','CLECY',NULL,NULL,'2290788486001',814.000000000,'1950-07-19','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3473,'TRIOLET','ANDREE','1957-02-16','02.37.22.76.43','06.19.41.30.09',NULL,'CRPA FOYER HECTOR BERLIOZ','','','14000','CAEN',NULL,NULL,'1570214087001',2951.000000000,'1987-08-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3474,'','ALPHONSINE','1964-05-17','02.45.58.11.79','06.33.81.84.17',NULL,'154 ROUTE D''HARCOURT','','',NULL,NULL,NULL,NULL,'2640514006001',212.000000000,'1991-07-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3475,'HEMERY','ANDREE','1966-01-28','02.97.05.06.67','06.17.48.42.87',NULL,'27 avenue du passous','','','14000','CAEN',NULL,NULL,'2660114327001',246.000000000,'1993-01-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3476,'BOURGUIGNON','CECILE','1935-05-14','02.25.65.77.36','06.11.25.51.49',NULL,'20 rue de la liberation','','','14500','VAUDRY',NULL,NULL,'1350514345001',451.000000000,'1959-03-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3477,'LE FEIVRE','GINETTE','1937-10-12','02.10.62.94.07','06.19.28.72.22',NULL,'4 RUE DU PERRET','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1371014628001',2365.000000000,'1958-01-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3478,'AUGER','MARC','1928-06-12','02.35.67.27.13','06.59.38.54.13',NULL,'CHEMIN DE L''EPINAY APT 23 BAT E3','4 DOMAINE DU VERT COTEAU','',NULL,NULL,NULL,NULL,'1280614092001',1.000000000,'1953-05-14','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3479,'DEGRENNE','','1947-02-17','02.43.35.06.32','06.81.81.75.68',NULL,'4 RUE DE FONTENELLE','','','14670','TROARN',NULL,NULL,'1470260614001',314.000000000,'1977-05-29','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3480,'DEGRENNE','LOUISE','1957-02-23','02.54.31.73.02','06.47.43.82.25',NULL,'14 AVENUE PASTEUR','','','14540','BOURGUEBUS',NULL,NULL,'2570214266001',4200.000000000,'1980-01-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3481,'FOLLAIN','NICOLE','1930-10-02','02.63.02.85.39','06.11.83.50.65',NULL,'37 RUE CHATEAUBRIAND','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2301014481001',10.000000000,'1955-04-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3482,'DENIEL','GUY','1934-08-16','02.84.52.47.55','06.63.66.40.60',NULL,'6 AVENUE DU 19 MARS 1962','','','14980','ROTS',NULL,NULL,'2340814749001',6.000000000,'1963-10-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3483,'LEDRU','LOUIS MARIE','1940-01-24','02.34.46.60.39','06.77.05.43.28',NULL,'3 RUE DE SWING BUDGE','','','14370','MOULT',NULL,NULL,'1400114206001',143.000000000,'1966-06-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3484,'LEBON','DIDIER','1931-01-03','02.67.57.11.47','06.43.37.65.61',NULL,'11 impasse du chateau','','','14370','MOULT',NULL,NULL,'1310114251001',1009.000000000,'1959-12-06','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3485,'RAUYER','JANINE','1934-03-01','02.10.03.43.80','06.45.26.56.06',NULL,'530 rue de la mare','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1340314484001',1354.000000000,'1963-11-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3486,'GOUMEAUX','FRANCOISE','1932-01-09','02.31.48.77.59','06.77.66.08.16',NULL,'8 RUE DU PERRON','','','50760','GATTEVILLE LE PHARE',NULL,NULL,'1320172313001',254.000000000,'1962-01-17','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3487,'LEMARIE','DENISE','1935-07-19','02.55.49.97.64','06.41.27.27.18',NULL,'23 AVENUE CHARLEMAGNE','','','14790','VERSON',NULL,NULL,'1350723193001',357.000000000,'1957-09-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3488,'MALLET','REMI','1954-02-09','02.62.22.63.47','06.18.77.14.97',NULL,'20 avenue de l hypodrome','','','50000','ST LO',NULL,NULL,'2540261347001',93.000000000,'1977-06-22','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3489,'PROUX','NOELLE',NULL,'02.46.96.29.50','06.15.14.90.97',NULL,'LIVRY','','','14500','VIRE',NULL,NULL,'1300661273001',159.000000000,'2009-11-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3490,'AUMONT','DENIS','1982-03-27','02.34.26.75.51','06.98.89.18.96',NULL,'CHEMIN DE LA CROIX DU PORT','','','14000','CAEN',NULL,NULL,'2820399234001',362.000000000,'2003-09-23','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3491,'RIVIERE','DANIELLE',NULL,'02.17.99.86.87','06.88.90.25.94',NULL,'16 RUE DE LAIZE LE VAL','','','14540','BOURGUEBUS',NULL,NULL,'2820399234001',19.000000000,'2013-03-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3492,'','MAURICE','1940-02-24','02.23.32.24.88','06.26.61.26.33',NULL,'LE CHAMPS FLEURI','','','14270','MEZIDON CANON',NULL,NULL,'1400214206001',202.000000000,'1962-04-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3493,'JALET','RENEE','1932-05-02','02.10.25.31.47','06.84.63.80.15',NULL,'9 RUE DU MANOIR ST JEAN','','','14000','CAEN',NULL,NULL,'2320514251001',165.000000000,'1957-07-31','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3494,'BROUT','MARIE','1928-10-17','02.88.31.59.39','06.62.14.62.01',NULL,'6 SQUARE ANATOLE FRANCE','','','14210','ESQUAY NOTRE DAME',NULL,NULL,'2281014277001',0.000000000,'1955-06-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3495,'DUREL','Gerard','1938-05-30','02.28.49.15.75','06.74.26.33.69',NULL,'26 RUE D''EDHIMBOURG','','','14260','ONDEFONTAINE',NULL,NULL,'2380550562001',23.000000000,'1967-12-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3496,'CHRETIEN','YVETTE','1936-10-26','02.72.49.12.55','06.84.50.61.12',NULL,'11 rue de la poudrieres','','','14000','CAEN',NULL,NULL,'1361014675001',1732.000000000,'1963-03-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3497,'DUGREE','GERARD','1931-01-11','02.82.97.00.44','06.35.82.74.47',NULL,'6 rue des liberateur','','',NULL,NULL,NULL,NULL,'2310161218001',476.000000000,'1957-09-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3498,'COUPRY','SYLVIE','1934-12-31','02.55.22.27.56','06.21.05.13.69',NULL,'RUE DE CHEDEVILLE','','','14000','CAEN',NULL,NULL,'1341250480001',5.000000000,'1958-05-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3499,'BINET','GILBERT','1933-12-12','02.51.85.81.01','06.41.46.04.04',NULL,'rue de la justice','','','14000','CAEN',NULL,NULL,'2331214235001',2.000000000,'1959-09-02','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3500,'NOBLET','NATHALIE','1935-04-18','02.12.06.82.72','06.81.30.66.77',NULL,'22 PASSAGE ESCOVILLE','','','14000','CAEN',NULL,NULL,'1350450356001',224.000000000,'1956-03-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3501,'CHALLANDE','Andre','1930-08-02','02.53.42.65.74',NULL,NULL,'LE BOURG','','','61200','ARGENTAN',NULL,NULL,'2300850268001',48.000000000,'1954-10-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3502,'LEPETIT','CHRISTIAN','1932-01-27','02.11.15.87.68','06.16.80.38.76',NULL,'19 RUE DES COTEAUX','','','14123','IFS',NULL,NULL,'2320114094001',1392.000000000,'1958-10-31','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3503,'LEBRUN','MAURICE','1937-02-03','02.84.60.08.84','06.67.76.27.40',NULL,'18 RUE DES PATRIOTES','','','14370','MERY CORBON',NULL,NULL,'1370216366001',26.000000000,'1958-05-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3504,'PASQUET','YVAN','1930-08-07','02.13.91.16.08','06.47.28.54.04',NULL,'branville','','','14370','MOULT',NULL,NULL,'2300814483001',114.000000000,'1952-04-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3505,'LEDRU','PASCAL','1933-11-23','02.40.53.51.36','06.69.00.07.46',NULL,'7 RUE DR. LEGENDE','','','14310','VILLY BOCAGE',NULL,NULL,'1331150248001',313.000000000,'1957-09-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3506,'LORFEUVRE','ROLAND','1939-08-21','02.89.93.71.99','06.17.31.59.93',NULL,'1 rue d athene','','','14000','CAEN',NULL,NULL,'2390814301001',44.000000000,'1964-04-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3507,'HARIEL','GILBERT','1931-12-26','02.91.10.71.98','06.24.91.62.48',NULL,'','','','14540','BOURGUEBUS',NULL,NULL,'1311227333001',218.000000000,'1953-07-31','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3508,'FEHN','JEAN','1931-03-21','02.60.11.62.92','06.69.07.37.82',NULL,'9 RUE DE LA CLE DES CHAMPS','','','14000','CAEN',NULL,NULL,'1310350180001',106.000000000,'1955-03-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3509,'BERTRAND','PAULETTE','1959-03-13','02.10.05.76.25','06.79.14.97.86',NULL,'5 RUE DES MOULINS','','','14000','CAEN',NULL,NULL,'2590361211001',1866.000000000,'1986-05-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3510,'ABRAHAM','RENE','1939-12-04','02.39.26.90.52','06.32.96.92.89',NULL,'7 RUE DE L''ECUREUIL','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1391235078001',1071.000000000,'1962-04-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3511,'LAURENT','JEANNE','1933-11-29','02.44.48.70.88','06.31.54.80.13',NULL,'5 RUE DE LA RIVIERE','','','14000','CAEN',NULL,NULL,'1331114174001',38.000000000,'1956-07-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3512,'LE BARON','GEORGES','1940-03-12',NULL,NULL,NULL,'5 RUE DES BRUYERES','','','14150','OUISTREHAM',NULL,NULL,'1400361440001',17.000000000,'1964-10-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3513,'LECLUSE','VERONIQUE',NULL,'02.85.40.58.67','06.10.21.57.73',NULL,'1 RUE ST HILAIRE','','','14000','CAEN',NULL,NULL,'1280550083001',172.000000000,'2009-02-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3514,'ANGOT','MIREILLE','1960-02-09','02.70.16.05.77','06.79.43.54.74',NULL,'1 RUE ST HILAIRE','','','14540','SOLIERS',NULL,NULL,'1600214390001',823.000000000,'1985-05-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3515,'DELIVET','YVETTE','1930-04-07','02.11.86.56.40','06.46.78.49.88',NULL,'5 rue du clos duhamel','','','14123','IFS',NULL,NULL,'2300435103001',2038.000000000,'1952-07-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3516,'GUENIER','CYPRIENNE','1975-01-08','02.98.90.47.36','06.44.40.90.94',NULL,'34 RUE TOUR MALINE','','','14000','CAEN',NULL,NULL,'2750135238001',19.000000000,'1999-04-08','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3517,'LERAY','SOLANGE','1956-03-02','02.81.92.78.92','06.21.04.89.24',NULL,'9 rue des pins','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1560376159001',42.000000000,'1986-10-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3518,'HUMEL','HENRIETTE','1968-11-26','02.97.44.33.66','06.44.75.83.62',NULL,'5 rue boutrois','','','14120','MONDEVILLE',NULL,NULL,'2681114655001',38.000000000,'1992-04-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3519,'BOULLAND','THERESE','1928-03-31','02.37.43.83.13','06.11.28.22.36',NULL,'8 RUE EMILE LEBRUN','','','14480','CULLY',NULL,NULL,'2280314623001',1604.000000000,'1949-04-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3520,'LESAGE','SOLANGE','1964-02-23','02.11.52.12.31','06.59.55.17.28',NULL,'13 RUE PASTEUR','','','14630','FRENOUVILLE',NULL,NULL,'1640214438001',310.000000000,'1987-11-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3521,'LEMOINE','JACQUES','1950-05-08','02.11.11.24.76','06.73.40.75.76',NULL,'9 BOULEVARD DU 13 JUIN','','','14000','CAEN',NULL,NULL,'1500514532001',133.000000000,'1978-07-21','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3522,'RIVIERE','YVES','1944-05-30','02.12.30.43.25','06.10.98.33.62',NULL,'hameau de jacob mesnil','','','14780','LION SUR MER',NULL,NULL,'1440514339001',162.000000000,'1966-06-01','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3523,'RIVIERE','MARYVONNE','1938-09-03','02.31.35.50.46','06.96.22.48.82',NULL,'37 RUE DU CHEMINET','','','14370','BELLENGREVILLE',NULL,NULL,'1380914625001',73.000000000,'1960-05-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3524,'DESMORTREUX','BORIS','1931-02-14','02.38.34.65.26','06.52.25.48.29',NULL,'2 RUE JULIEN FACHE','','','14370','BELLENGREVILLE',NULL,NULL,'2310214719001',42.000000000,'1954-08-17','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3525,'HUET','GISELE','1930-08-11','02.99.02.18.76','06.84.77.24.35',NULL,'1 rue roger poulin','','','14114','VER SUR MER',NULL,NULL,'2300850268001',283.000000000,'1954-10-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3526,'HAMELIN','NICOLE','1930-03-10','02.32.72.56.85','06.27.18.32.62',NULL,'15 RUE ARISTIDE BRIAND','','','14540','BOURGUEBUS',NULL,NULL,'2300314627001',19.000000000,'1954-03-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3527,'FONTAINE','JOSIANE','1940-09-11','02.10.37.84.69','06.21.96.70.80',NULL,'9 boulevard de la charit','','','14210','STE HONORINE DU FAY',NULL,NULL,'1400985293001',40.000000000,'1962-12-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3528,'HAMONIAUX','MICHEL','1931-08-26','02.40.42.94.80','06.63.98.10.42',NULL,'26 RUE DES CASTORS','','','14000','CAEN',NULL,NULL,'1310850393001',58.000000000,'1959-01-04','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3529,'BRICET','ROGER','1935-10-04','02.45.87.38.78','06.45.68.53.30',NULL,'7 RESIDENCE SAINTE PAIX','','','14123','IFS',NULL,NULL,'1351050577001',34.000000000,'1956-03-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3530,'DOUSSON','JEAN CLAUDE','1931-02-12','02.10.79.51.89','06.43.28.14.83',NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2310214283001',109.000000000,'1959-05-10','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3531,'FOLLIET','JEAN CLAUDE','1931-07-24','02.40.24.71.61','06.11.59.35.99',NULL,'32 route de baron','','','14000','CAEN',NULL,NULL,'1310750359001',757.000000000,'1953-10-03','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3532,'LENOGUE','COLETTE','1928-05-19','02.56.11.31.85','06.10.11.16.68',NULL,'LES 3 MONTEAUX "LIEU DIT"','','','27230','DRUCOURT',NULL,NULL,'1280558149001',91.000000000,'1949-01-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3533,'LEQUESNE','SERGE','1931-04-25','02.38.14.92.91','06.87.10.64.66',NULL,'5 bvd de l''esperance','','','14123','IFS',NULL,NULL,'2310414292001',26.000000000,'1961-01-02','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3534,'VALIN','ALLAIN',NULL,'02.81.30.02.16','06.11.81.40.15',NULL,'12 RUE DES MESANGES','','','14210','MAIZET',NULL,NULL,'1680614005001',1740.000000000,'2011-12-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3535,'DELASSALLES','GINETTE','1934-06-13','02.39.87.63.03','06.37.63.42.69',NULL,'19 AVENUE DU 6 JUIN','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1340614181001',587.000000000,'1964-04-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3536,'CASTEL','GISELE','1952-01-05','02.65.75.86.85','06.39.44.87.17',NULL,'2 RUE DE MALFILATRE  MAISON DE R','ETRAITE ST JEAN','','14730','GIBERVILLE',NULL,NULL,'2520114271001',1144.000000000,'1980-03-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3537,'DEVILLE','CLAUDE','1940-09-12','02.23.94.88.44','06.29.89.40.83',NULL,'32 rue bellevue','','','61200','ARGENTAN',NULL,NULL,'2400914439001',129.000000000,'1962-01-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3538,'SEFRIN','PASCAL','1932-04-26','02.26.50.50.18','06.24.29.91.10',NULL,'13 rue saint exupery','','','61240','LE MERLERAULT',NULL,NULL,'2320414452001',5269.000000000,'1956-07-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3539,'LEBEDEL','FREDERIC','1943-05-12','02.22.66.71.65','06.41.02.40.40',NULL,'5 rue de la liberation','','','14840','DEMOUVILLE',NULL,NULL,'1430578158001',2.000000000,'1971-12-11','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3540,'LEMETAYER','GEORGES','1932-11-28','02.65.70.79.81','06.64.33.33.17',NULL,'3 avenue du Point du Jour','','','14540','BOURGUEBUS',NULL,NULL,'2321150467001',251.000000000,'1960-07-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3541,'GEORGES','RENE','1930-04-16','02.43.87.82.55','06.11.90.46.46',NULL,'110 BD  MARECHAL LYAUTEY','','','14210','CHEUX',NULL,NULL,'1300414200001',11.000000000,'1960-09-24','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3542,'CALBRY','YVES','1967-09-05','02.12.00.41.28','06.85.37.33.13',NULL,'10 rue des Quesnots','','','14460','COLOMBELLES',NULL,NULL,'1670914734001',4179.000000000,'1996-07-09','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3543,'PRENVEILLE','YVES','1940-10-08','02.59.88.46.60','06.10.65.53.26',NULL,'11 rue pasteur','','','14700','FALAISE',NULL,NULL,'2401076551001',44.000000000,'1964-11-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3544,'DUGARDIN','JACQUELINE','1934-08-01','02.25.09.82.54','06.45.36.79.70',NULL,'LA VARDIERE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2340836035001',25.000000000,'1957-11-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3545,'CHICHUA','PIERRE','1943-01-02','02.63.46.24.53','06.62.90.58.87',NULL,'19 RUE DE SAINTONGE','','','14123','IFS',NULL,NULL,'2430114039001',249.000000000,'1968-05-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3546,'TANQUEREL','VINCENT','1932-11-26','02.76.14.43.52','06.85.37.56.58',NULL,'5 RUE DU PETIT VALLON','','','14123','FLEURY SUR ORNE',NULL,NULL,'2321114283001',200.000000000,'1961-06-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3547,'DOS ANJOS','HELENE','1939-10-13','02.87.50.12.82','06.45.57.04.03',NULL,'7 RUE PAUL CREPON','','','14000','CAEN',NULL,NULL,'2391080732001',28.000000000,'1967-10-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3548,'CORNET','SUZANNE','1935-08-14','02.28.71.60.66','06.87.24.55.72',NULL,'24 RUE DE BEAUVOIR','','','14730','GIBERVILLE',NULL,NULL,'1350814355001',30.000000000,'1957-01-31','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3549,'GARDIE','RAYMOND','1936-08-18','02.63.23.56.37','06.81.03.04.71',NULL,'LE MOULIN DE LA VALLEE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2360861346001',1388.000000000,'1962-02-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3550,'','RAYMONDE','1929-01-01','02.67.32.65.44','06.50.36.42.90',NULL,'LA VARDIERE','','','14120','MONDEVILLE',NULL,NULL,'2290150295001',382.000000000,'1953-01-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3551,'MOREAU','RAYMOND','1919-12-22','02.75.36.03.75','06.48.58.13.32',NULL,'4 SQUARE JOHN KENNEDY','','',NULL,NULL,NULL,NULL,'1191214731001',26.000000000,'1948-12-15','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3552,'DELALANDE','JEANNINE','1940-03-23','02.15.10.04.89','06.24.09.06.96',NULL,'COUR HOULETTE','','','14310','VILLY BOCAGE',NULL,NULL,'1400314408001',80.000000000,'1968-12-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3553,'RIQUIER','Alphonse','1949-01-21','02.14.70.00.77','06.76.00.49.24',NULL,'2 rue d''Helsinski','','','14000','CAEN',NULL,NULL,'2490150307001',2283.000000000,'1973-08-24','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3554,'LE BUGLE','SOLANGE','1929-01-12','02.31.70.37.84','06.29.06.05.70',NULL,'19 AVENUE JEAN JAURES','','','50120','EQUEURDREVILLE HAINNEVILLE',NULL,NULL,'2290114749001',57.000000000,'1959-01-03','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3555,'FREMONT','PATRICIA','1936-10-06','02.35.70.36.67','06.57.56.53.11',NULL,'LIEU DIT LES DOUETS','','','14370','BELLENGREVILLE',NULL,NULL,'2361014551001',168.000000000,'1961-04-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3556,'FREMONT','MICHEL','1939-02-09','02.52.30.83.93','06.72.85.90.07',NULL,'2 rue victor hugo','','','14630','CAGNY',NULL,NULL,'2390245107001',18.000000000,'1966-06-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3557,'LEMOIGNE','YVES','1937-10-03','02.64.03.21.01','06.59.01.31.57',NULL,'350 RUE DE LUBECKE','','','14000','CAEN',NULL,NULL,'1371050494001',11.000000000,'1967-01-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3558,'LEGRAND','DANIEL','1949-01-19','02.45.33.89.38','06.64.72.48.14',NULL,'QUARTIER DE L''EGLISE','','','14540','ROCQUANCOURT',NULL,NULL,'2490150307001',25.000000000,'1971-03-05','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3559,'MARIE','MARIE THERESE','1939-01-23','02.74.72.01.93',NULL,NULL,'HAMEAU ST ANDRE','','','14210','EVRECY',NULL,NULL,'1390114072001',38.000000000,'1960-12-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3560,'BOUQUEY','ARLETTE','1934-11-02','02.10.80.50.36','06.81.00.10.67',NULL,'6 allee de la tour des gens d ar','mes','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1341114431001',198.000000000,'1963-04-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3561,'CAVELIER','DANIEL','1962-01-09','02.33.25.94.05','06.35.24.44.31',NULL,'40 rue du clos du pavillon','','','14380','SEPT FRERES',NULL,NULL,'1620114020001',38.000000000,'1986-01-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3562,'BAZIRE','DIDIER','1935-03-24','02.64.07.07.45','06.45.49.11.85',NULL,'ETAVAUX','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'2350350048001',171.000000000,'1960-05-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3563,'BOIVERT','MARIE CLAIRE','1931-01-26','02.27.52.39.59','06.11.03.38.13',NULL,'19 HAMEAU CHEF DE RUE','','','14510','GONNEVILLE SUR MER',NULL,NULL,'2310114266001',164.000000000,'1953-06-05','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3564,'SALLES','PATRICK','1943-10-05','02.10.96.47.59','06.97.68.05.22',NULL,'17 RUE CONSTANT FORGET','','','14220','TOURNEBU',NULL,NULL,'1431014519001',109.000000000,'1967-05-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3565,'PARISY','ROBERT','1957-08-17','02.53.78.40.40','06.49.27.54.44',NULL,'64 AVENUE GUYNEMER','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2570850084001',3467.000000000,'1986-06-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3566,'GEMY','GEORGETTE','1928-09-20','02.63.76.01.30','06.34.01.56.26',NULL,'17 RUE DE SAVOIE','','','14000','CAEN',NULL,NULL,'2280922054001',51.000000000,'1949-08-30','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3567,'LHERMENIER','ODETTE','1936-04-11','02.37.36.83.00','06.95.76.18.12',NULL,'3 RUE DU STADE','','','14730','GIBERVILLE',NULL,NULL,'1360450308001',2847.000000000,'1959-09-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3568,'KERIMOV','ALAIN','1962-02-04','02.31.45.54.81','06.60.22.09.31',NULL,'22 BIS RUE JOSEPH  LEVILLY','','','14120','MONDEVILLE',NULL,NULL,'2620214530001',17.000000000,'1984-07-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3569,'LEFEVRE','YVETTE','1938-12-19','02.55.60.35.69','06.28.60.39.03',NULL,'2 allee du breuil','','','14400','AGY',NULL,NULL,'2381214374001',5.000000000,'1962-09-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3570,'BREHIN','ROBERT','1959-03-02','02.89.04.18.59','06.12.13.95.14',NULL,'27 RUE DU BLANC  RESIDENCE DRAP','VERT','','14000','CAEN',NULL,NULL,'2590350466001',1378.000000000,'1987-08-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3571,'LOUVEL','JOSYANE','1938-02-12','02.40.62.25.97','06.89.04.70.81',NULL,'1 rue du moulin','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1380214020001',3.000000000,'1965-06-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3572,'DYVRANDE','JEAN','1968-08-30','02.35.87.01.30','06.68.71.27.28',NULL,'14 RUE DES CASTORS','','','14860','AMFREVILLE',NULL,NULL,'2680814658001',202.000000000,'1991-03-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3573,'FEHN','MADELEINE','1946-09-20','02.33.80.32.21','06.67.82.72.12',NULL,'RUE PASTEUR','','','14000','CAEN',NULL,NULL,'1460914052001',100.000000000,'1967-07-25','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3574,'MAURILLE','GERARD','1929-04-12','02.20.91.58.73','06.57.88.32.81',NULL,'1 AVENUE FOCH','','','14930','ETERVILLE',NULL,NULL,'1290414670001',24.000000000,'1952-01-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3575,'LEVIEILS','MONIQUE','1929-04-21','02.49.89.35.13','06.65.45.72.50',NULL,'CHEMIN DU FORT BASSEVILLE ECAJEU','L','','14000','CAEN',NULL,NULL,'1290414670001',705.000000000,'1959-11-23','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3576,'GUESNON','DENISE','1933-09-07',NULL,NULL,NULL,'HAMEAU DE RUBERCY','','','50100','CHERBOURG',NULL,NULL,'1330914266001',61.000000000,'1961-11-20','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3577,'BIDEL','MARTINE','1930-03-10','02.49.44.95.79','06.83.46.01.94',NULL,'village les bruyeres','','','14220','TOURNEBU',NULL,NULL,'2300314590001',283.000000000,'1953-09-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3578,'DUMEZ','CLAUDE','1954-04-25','02.31.65.25.68','06.16.67.40.00',NULL,'16 ALLEE DE MORSALINE','','','14220','TOURNEBU',NULL,NULL,'1540414583001',36.000000000,'1975-01-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3579,'GUELLE','JANICK','1929-06-18','02.76.49.26.75','06.10.43.80.09',NULL,'21 rue de l avenir','','','14700','CORDEY',NULL,NULL,'1290650110001',18.000000000,'1956-08-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3580,'CREVEU','MICHEL','1930-08-10','02.32.52.60.73','06.37.02.24.46',NULL,'7 rue  du pere sanson','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1300850468001',27.000000000,'1960-10-04','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3581,'DESCARTES','FREDERIC','1963-01-09','02.50.15.17.82','06.19.68.93.10',NULL,'48 RUE DE CORMELLES','','','14470','COURSEULLES SUR MER',NULL,NULL,'2630114062001',38.000000000,'1993-08-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3582,'MARIE','MARTINE','1929-01-24','02.60.87.03.63','06.26.04.59.88',NULL,'11 rue felix leclerc','','','14000','CAEN',NULL,NULL,'1290127006001',162.000000000,'1951-05-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3583,'HUET','CATHERINE','1956-08-28','02.60.92.11.12','06.70.89.99.83',NULL,'7 bis rue porte millet entree a','','','14000','CAEN',NULL,NULL,'2560872082001',24.000000000,'1979-11-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3584,'LENOGUE','CATHERINE','1938-12-13','02.48.54.86.00','06.57.69.38.15',NULL,'LES MOULINS','','','14000','CAEN',NULL,NULL,'2381268242001',152.000000000,'1963-03-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3585,'LEDEZERT','JEANINE','1934-01-04','02.25.09.21.14','06.50.41.08.18',NULL,'2 IMPASSE DES ACCACIAS','','','14210','BARON SUR ODON',NULL,NULL,'1340114368001',86.000000000,'1960-07-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3586,'PIERRE','PIERRETTE','1936-02-23','02.67.32.78.42','06.96.60.92.01',NULL,'3 CHEMIN DE COLLEVILLE','','','14000','CAEN',NULL,NULL,'2360214341001',355.000000000,'1960-09-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3587,'LEPLEY','LILIANE','1930-06-28','02.65.62.26.47','06.12.27.56.00',NULL,'8 residence olympia','','','14000','CAEN',NULL,NULL,'1300614145001',315.000000000,'1951-06-14','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3588,'HEUZE','MONIQUE','1952-01-19','02.21.61.06.10','06.35.18.58.80',NULL,'LOTISSEMENT PERLYMELE   "LE HOM"','','','14460','COLOMBELLES',NULL,NULL,'2520161084001',2153.000000000,'1975-12-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3589,'FERAY','CLAUDINE','1939-07-02','02.77.82.94.74',NULL,NULL,'3 RUE AUX BOUETS','','','14150','OUISTREHAM',NULL,NULL,'2390714677001',33.000000000,'1963-09-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3590,'JARDIN','DANIEL','1928-04-05','02.10.03.27.84','06.44.14.35.27',NULL,'2 CHEMIN DES MARAIS DU BOURG','','','77380','COMBS LA VILLE',NULL,NULL,'1280414462001',354.000000000,'1953-08-06','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3591,'GIBASSIER','BERNARD','1931-08-13','02.51.20.74.18',NULL,NULL,'7 RUE DE LA HOGUE','','','14190','ST SYLVAIN',NULL,NULL,'1310814418001',2884.000000000,'1953-06-01','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3592,'JOMAT','CHANTAL','1931-03-22','02.15.84.52.74',NULL,NULL,'28 rue du champs versan','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1310327288001',100.000000000,'1953-07-20','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3593,'CORDIER','MAURICE','1934-05-13','02.29.60.56.49','06.94.76.42.32',NULL,'10 RUE DU MAJOR STYFFE','','','14220','THURY HARCOURT',NULL,NULL,'2340535016001',22.000000000,'1959-05-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3594,'VERRIER','LILIANE','1965-02-04','02.10.26.86.51','06.34.18.36.90',NULL,'','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'1650214123001',147.000000000,'1986-12-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3595,'PERON','YVES','1959-04-25','02.70.70.53.46','06.32.70.58.44',NULL,'5 RUE DES AUCRAIS','','','14730','GIBERVILLE',NULL,NULL,'2590414491001',365.000000000,'1985-08-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3596,'GAUBERT','BERNARD','1930-07-06','02.10.02.75.16','06.94.54.44.02',NULL,'10 RUE GEORGES BIZET','','','14000','CAEN',NULL,NULL,'1300714654001',173.000000000,'1954-10-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3597,'DAIGREMONT','SIMONE','1928-12-28','02.96.97.41.48','06.34.99.18.27',NULL,'LA BLANCHETIERE','','','14480','CREULLY',NULL,NULL,'1281214666001',706.000000000,'1949-04-29','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3598,'BONNET','MICHELLE','1937-08-18','02.84.27.62.83','06.40.12.77.95',NULL,'25 BD DE RETHEL','','','14210','MONTIGNY',NULL,NULL,'2370814430001',163.000000000,'1961-07-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3599,'LEGOFF','CLAUDIA','1968-08-14','02.11.28.38.24','06.41.12.69.21',NULL,'2 /4 RUE DE LA RENAISSANCE','','','14840','GIBERVILLE',NULL,NULL,'1680861292001',23.000000000,'1991-09-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3600,'GUILLOUET','PATRICIA','1968-08-06','02.28.30.23.11','06.89.67.79.46',NULL,'13 RUE DES CANADIENS','','','14000','CAEN',NULL,NULL,'1680861292001',50.000000000,'1998-10-19','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3601,'CATHERINE','ANTOINETTE','1961-02-23','02.81.26.92.27','06.32.89.48.89',NULL,'LE PONT ROCH','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2610261071001',311.000000000,'1989-09-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3602,'CHAUVIN','CLAIRE','1929-12-22','02.33.27.70.82','06.66.46.06.09',NULL,'route de cauchere','','','14840','CUVERVILLE',NULL,NULL,'1291214628001',105.000000000,'1958-09-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3603,'LETURCQ','HENRY',NULL,'02.45.08.03.20','06.83.89.52.36',NULL,'6 RUE CONDE','','','14630','CAGNY',NULL,NULL,'2531259454001',15.000000000,'2013-06-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3604,'MAUPAS','CLAUDE',NULL,'02.37.39.87.29','06.72.80.32.58',NULL,'4 RUE DE L''EGALITE','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2291014020001',842.000000000,'2013-08-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3605,'GUERIN','PATRICIA','1936-09-06','02.70.43.98.44','06.44.23.58.93',NULL,'le bourg','','','14670','JANVILLE',NULL,NULL,'2360914030001',185.000000000,'1961-04-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3606,'LEPELTIER','ANDREE','1939-08-08','02.92.61.62.13','06.16.10.51.05',NULL,'','','','14630','CAGNY',NULL,NULL,'1390814342001',58.000000000,'1969-07-23','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3607,'LHONNEUR','THIERRY','1952-07-27','02.14.47.81.77','06.53.17.43.93',NULL,'8 rue du hamet','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2520750398001',43.000000000,'1976-06-24','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3608,'MOTTE','MICHEL','1932-11-10','02.12.41.54.24','06.18.23.44.03',NULL,'rue de dunkerque','','','14270','MEZIDON CANON',NULL,NULL,'2321127499001',341.000000000,'1953-01-20','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3609,'LESELLIER','Monique','1938-07-08','02.65.41.20.88','06.12.22.59.19',NULL,'6 RUE DES POMMIERS','','','14270','MEZIDON CANON',NULL,NULL,'1380714087001',36.000000000,'1963-02-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3610,'LIARD','MICHEL','1930-01-17','02.69.06.47.64','06.86.76.93.74',NULL,'83 AVENUE JEAN JAURES','','','14000','CAEN',NULL,NULL,'1300114311001',1522.000000000,'1960-12-01','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3611,'COGNEC','JACKY','1940-01-22','02.64.26.53.45','06.50.09.47.48',NULL,'34 RUE DU CANADA','','','14730','GIBERVILLE',NULL,NULL,'1400114006001',1040.000000000,'1962-01-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3612,'BIGNON','JEAN CLAUDE','1940-01-01','02.86.32.48.81','06.26.02.92.44',NULL,'5 IMPASSE DE LA GRONDE','','','14700','FALAISE',NULL,NULL,'1400114006001',107.000000000,'1963-09-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3613,'CHEVALIER','VIVIANE','1940-01-28','02.81.99.59.41','06.19.76.99.39',NULL,'4 RUE DES SORBIERS','','','14000','CAEN',NULL,NULL,'1400150294001',22.000000000,'1962-06-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3614,'LEPEIGNE','CLAUDE','1928-09-04','02.88.48.62.25','06.89.62.17.93',NULL,'8 rue st marc','','','14540','SOLIERS',NULL,NULL,'2280922054001',283.000000000,'1958-07-17','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3615,'BUISSON','RAYMOND','1957-03-21','02.44.55.74.14',NULL,NULL,'43 RUE C BLAISOT','','','14540','SOLIERS',NULL,NULL,'1570314134001',309.000000000,'1980-05-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3616,'LAVIEILLE','YVES','1933-02-12','02.26.89.17.80','06.99.92.91.46',NULL,'rue alfred rossel residence du','port','','14123','FLEURY SUR ORNE',NULL,NULL,'2330214432001',56.000000000,'1956-11-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3617,'BRUYERE','ANDREE','1936-12-15','02.11.42.29.97','06.10.11.12.47',NULL,'6 ALLEE DE LA FERME','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2361222094001',11.000000000,'1961-05-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3618,'BUHOURT','YVONNE','1940-05-02','02.32.98.69.46','06.81.10.52.44',NULL,'57 RUE LOUIS ARAGON','','','14370','ARGENCES',NULL,NULL,'1400561098001',145.000000000,'1961-04-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3619,'LANGEVIN','MICHELE','1939-11-28','02.70.87.50.18','06.11.80.22.92',NULL,'12 CHEMIN DES POISSONNIERS','','','14190','FIERVILLE BRAY',NULL,NULL,'2391172136001',177.000000000,'1960-09-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3620,'TRUBLARD','ANNIE','1937-12-20','02.48.20.95.43','06.83.03.74.06',NULL,'18 RUE DU CLOS DU PAVILLON','','','14000','CAEN',NULL,NULL,'1371214209001',292.000000000,'1959-08-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3621,'LEROY','BRUNO','1935-06-08','02.50.25.71.46','06.69.38.11.15',NULL,'4 RUE GAMBETTA','','','14320','FONTENAY LE MARMION',NULL,NULL,'2350614689001',915.000000000,'1959-11-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3622,'CARABEUF','','1936-11-07','02.35.19.93.26','06.25.88.78.04',NULL,'13 LOTISSEMENT DES POMMIERS','','','14710','TREVIERES',NULL,NULL,'2361114123001',81.000000000,'1957-02-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3623,'LECOMTE','GINETTE','1954-01-04','02.76.32.73.25','06.82.91.38.44',NULL,'3 RUE DES SERPELETS','','','14400','BAYEUX',NULL,NULL,'2540161314001',39.000000000,'1981-12-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3624,'DEVIN','ROGER','1930-07-30','02.56.03.21.33','06.41.92.47.21',NULL,'51 F RUE VICTOR LEPINE','','','14000','CAEN',NULL,NULL,'1300714162001',186.000000000,'1955-06-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3625,'LECHIPEY','CLAUDE','1923-09-22','02.60.69.59.38','06.54.76.49.72',NULL,'359 RUE DE LA MARE','','','14320','FONTENAY LE MARMION',NULL,NULL,'2230965075001',2910.000000000,'1947-02-11','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3626,'LECLERC','JOSEPH','1929-12-24','02.58.57.52.65','06.12.08.68.04',NULL,'214 rue d''Auge','','','14540','TILLY LA CAMPAGNE',NULL,NULL,'1291214637001',810.000000000,'1953-06-18','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3627,'RAULT','ALAIN','1937-01-08','02.88.06.85.77','06.68.60.43.79',NULL,'50 rue des epivas','','','14190','ST SYLVAIN',NULL,NULL,'1370114200001',285.000000000,'1958-01-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3628,'TIRELLE','ODETTE','1952-06-27','02.47.32.49.69','06.49.82.20.12',NULL,'33 RUE PASTEUR','','','14480','TIERCEVILLE',NULL,NULL,'2520661280001',66.000000000,'1975-05-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3629,'TOUTAIN','SUZANNE','1964-03-24','02.12.26.66.31','06.45.94.62.59',NULL,'5 residence de la prairie','','','14123','IFS',NULL,NULL,'2640314488001',285.000000000,'1988-11-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3630,'GESLIN','JACQUELINE','1956-08-25','02.25.58.59.11','06.18.56.64.09',NULL,'7 imp du chant de l alouette','','','14540','SOLIERS',NULL,NULL,'1560814546001',970.000000000,'1980-05-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3631,'FLEURY','GASTON','1959-08-09','02.98.46.54.30','06.81.92.58.04',NULL,'30rue pasteur','','','14160','GRANGUES',NULL,NULL,'1590814249001',33.000000000,'1985-02-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3632,'LEPORTIER','SIMONE','1941-01-23','02.33.58.27.76','06.93.43.71.38',NULL,'21 BD DU 30/06/44 RESIDENCE GAU','TIER','','14000','CAEN',NULL,NULL,'2410114146001',67.000000000,'1962-11-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3633,'RIVIERE','MICHEL','1940-01-25','02.82.58.70.73','06.37.07.88.77',NULL,'29 rue marechal gallieni','','','14370','ARGENCES',NULL,NULL,'1400114206001',752.000000000,'1963-01-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3634,'KASPRZAK','YVES','1932-05-12','02.10.34.17.66','06.51.59.58.49',NULL,'37 avenue de rouen','','','14670','TROARN',NULL,NULL,'1320550550001',74.000000000,'1958-08-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3635,'','ROLAND','1937-07-19','02.22.68.74.75',NULL,NULL,'22 AVENUE DE LA CONCORDE','','','14000','CAEN',NULL,NULL,'2370714547001',334.000000000,'1958-05-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3636,'LEGOUPIL','FERNAND','1931-10-31','02.40.14.67.74',NULL,NULL,'2 RUE LEDOUX','','','14120','MONDEVILLE',NULL,NULL,'2311014144001',198.000000000,'1952-01-15','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3637,'HEBERT','Suzanne',NULL,'02.90.25.40.71','06.24.69.80.28',NULL,'12 rue lucien boussoutrot','','','14460','COLOMBELLES',NULL,NULL,'1280214150001',3.000000000,'2010-09-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3638,'NOEL','MICHELINE','1949-04-11','02.22.86.57.81','06.30.75.73.43',NULL,'3 rue amiral courbet','','','14390','PETIVILLE',NULL,NULL,'1490414248001',1364.000000000,'1975-03-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3639,'COURTEILLE','GILBERTE','1938-08-03','02.45.97.10.95','06.55.00.86.47',NULL,'11 AVENUE DES CANADIENS','','','61470','AVERNES ST GOURGON',NULL,NULL,'2380814221001',106.000000000,'1960-05-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3640,'MARIE','ROLANDE','1948-02-02','02.98.21.58.57','06.51.24.18.55',NULL,'107 bd general vanier','','','14111','LOUVIGNY',NULL,NULL,'1480214099001',1047.000000000,'1971-10-20','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3641,'CHEVAUCHERIE','KARINE','1931-09-12','02.16.39.36.88','06.90.00.05.76',NULL,'30 RUE ST PATRICE','','','14220','FRESNEY LE VIEUX',NULL,NULL,'1310961354001',75.000000000,'1956-04-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3642,'DALLIER','RAYMOND','1934-03-30','02.87.82.03.25','06.87.00.25.32',NULL,'1 RUE VERTE','','','14170','BERNIERES D''AILLY',NULL,NULL,'2340314325001',149.000000000,'1964-02-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3643,'PAYSANT','MARIANE','1957-03-27','02.85.65.82.77','00 33 6.10.22.92.22',NULL,'3 rue des peupliers','','','14470','COURSEULLES SUR MER',NULL,NULL,'1570350356001',42.000000000,'1986-07-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3644,'MICHEL','PATRICIA','1928-03-13','02.75.44.18.90','06.14.04.41.10',NULL,'5 BOULEVARD DES VIOLETTES','','','14320','LAIZE LA VILLE',NULL,NULL,'1280314509001',97.000000000,'1951-07-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3645,'MILLON','HENRIETTE','1939-11-20','02.52.64.80.95','06.95.70.34.27',NULL,'14 rue de la bonne vierge','','','14000','CAEN',NULL,NULL,'1391114115001',45.000000000,'1960-05-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3646,'FRANCOIS','andre','1932-03-09','02.11.29.27.67','06.11.12.33.84',NULL,'101 AVENUE DE LA PLAGE','','','14220','CROISILLES',NULL,NULL,'1320314408001',65.000000000,'1955-08-03','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3647,'LAURENT','GERARD','1933-08-01','02.81.79.41.07','06.21.43.92.58',NULL,'14 RUE MESAISE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2330814409001',136.000000000,'1955-03-20','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3648,'VANDAELE','JANINE','1930-11-25','02.64.21.52.74',NULL,NULL,'9 rue des gables','','','14000','CAEN',NULL,NULL,'1301114628001',2284.000000000,'1954-09-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3649,'HAMEL','ALEXIA','1933-12-23','02.26.56.93.70','00 33 6.21.20.10.82',NULL,'32 rue des hogues','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'2331214166001',10.000000000,'1957-12-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3650,'LEMONNIER','ALPHONSE','1937-12-30','02.26.36.28.90','06.21.55.35.92',NULL,'20 rue St Gilles','','','14940','SANNERVILLE',NULL,NULL,'2371214609001',50.000000000,'1964-07-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3651,'DUPONT','ANDRE','1946-01-29','02.98.58.85.73','06.86.35.20.28',NULL,'3 rue Gandhi','','','14000','CAEN',NULL,NULL,'1460114486001',182.000000000,'1971-05-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3652,'MULOT','REMY',NULL,'02.87.97.03.63','06.49.70.92.88',NULL,'11 RUE DES HAUTVENTS','','','14114','VER SUR MER',NULL,NULL,'1390672186001',537.000000000,'2009-03-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3653,'VERMURGHEN','GILLES','1963-06-30','02.33.29.44.88','06.11.29.21.65',NULL,'','','','27450','ST MARTIN ST FIRMIN',NULL,NULL,'1630614521001',672.000000000,'1986-10-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3654,'LEHERICY','NADINE','1962-01-25','02.28.06.25.16','06.13.81.69.81',NULL,'24 Rsidence du Parc','','','14000','CAEN',NULL,NULL,'2620114044001',4357.000000000,'1987-10-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3655,'LAVILLE','CLAIRE','1938-11-17','02.91.54.66.94','06.71.74.29.57',NULL,'38 rue Maurice Fouques','','','14670','BURES SUR DIVES',NULL,NULL,'2381150546001',1149.000000000,'1965-10-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3656,'JEANNE','VERONIQUE','1943-01-19','02.29.11.51.84','06.73.85.64.65',NULL,'20 RUE AUGUSTE LECHESNE','','','14940','SANNERVILLE',NULL,NULL,'2430150229001',7.000000000,'1966-04-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3657,'HERAUVILLE','SYLVIE','1938-06-22','02.10.63.34.14','06.39.80.45.43',NULL,'LE VIEUX PRESBYTERE','','','14470','GRAYE SUR MER',NULL,NULL,'2380614324001',3260.000000000,'1967-08-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3658,'BAZIRE','KYANDYK','1930-03-11','02.50.70.90.39','06.71.55.64.50',NULL,'RESIDENCE DU PARC APPT 28','','','61560','ST AUBIN DE COURTERAIE',NULL,NULL,'1300314353001',94.000000000,'1951-10-12','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3659,'LEBRETHON','JEAN','1934-06-09','02.32.74.00.22',NULL,NULL,'14 RUE DU 8 MAI 1845','','','14123','IFS',NULL,NULL,'1340614340001',18.000000000,'1955-01-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3660,'BREYNE','MARGUERITE','1969-01-25','02.36.60.63.10','06.60.68.21.13',NULL,'22 rue circulaire','','','14840','DEMOUVILLE',NULL,NULL,'1690114333001',72.000000000,'1997-01-23','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3661,'BREYNE','MARLENE','1935-03-04','02.12.16.00.30','06.42.50.79.48',NULL,'75 rue bouteille','','','61120','VIMOUTIERS',NULL,NULL,'2350361404001',616.000000000,'1963-02-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3662,'LAMOTTE','LEON','1937-02-05','02.82.51.46.58','06.42.16.75.08',NULL,'2 RUE DES TILLEULS','','','14220','THURY HARCOURT',NULL,NULL,'2370214066001',89.000000000,'1966-12-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3663,'SIMON','JOEL','1933-08-16','02.11.29.26.78','06.41.92.67.89',NULL,'8 RUE DE PROVENCE','','','14370','MERY CORBON',NULL,NULL,'1330814394001',347.000000000,'1954-05-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3664,'AUBERT','GERARD','1933-08-10','02.11.67.23.87','06.97.99.38.09',NULL,'32 RUE CAMILLE BLAIZOT','','','14570','ST LAMBERT',NULL,NULL,'2330814515001',39.000000000,'1955-10-27','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3665,'LINAY','FERNAND','1940-04-21','02.43.08.88.53','06.13.82.35.40',NULL,'9 RUE DES HAUTS VENTS','','','14400','ST VIGOR LE GRAND',NULL,NULL,'1400478338001',62.000000000,'1969-12-26','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3666,'LA MARTA BLASCO','XAVIER','1929-09-25',NULL,NULL,NULL,'Rue du Grand Champ','','','14340','ST LOUP DE FRIBOIS',NULL,NULL,'2290914160001',1251.000000000,'1952-12-30','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3667,'SAID','CLAUDE','1936-04-30','02.53.53.27.97','06.10.74.49.87',NULL,'7 impasse de l''humeliere','','','14120','MONDEVILLE',NULL,NULL,'1360414370001',2996.000000000,'1957-08-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3668,'HUARD','CLAIRE','1938-09-12','02.57.78.39.21','06.20.19.78.52',NULL,'Rsidence La Bruyre Appt32 20','rue Edouard Vaillant','','14120','MONDEVILLE',NULL,NULL,'2380914489001',647.000000000,'1961-01-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3669,'LEMERCIER','MARIE JOSEPHE','1965-01-06','02.28.65.06.80','06.82.21.53.17',NULL,'5 rue Gustave Flaubert','','','61200','SEVIGNY',NULL,NULL,'2650114174001',28.000000000,'1995-07-24','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3670,'PICAN','JOEL',NULL,'02.63.29.80.88','00 33 6.71.41.14.22',NULL,'66 BD ALSACE LORRAINE','','','14730','GIBERVILLE',NULL,NULL,'1670214137001',75.000000000,'2013-07-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3671,'DELHOMMEAU','JACQUELINE','1932-04-04','02.10.23.18.94','06.12.08.20.70',NULL,'75 RUE DU CENTRE','','','14540','GRENTHEVILLE',NULL,NULL,'2320414452001',12.000000000,'1956-04-13','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3672,'LABBE','ERIC','1934-09-23','02.46.70.53.39','06.41.60.21.07',NULL,'rue georges landry','','','14000','CAEN',NULL,NULL,'1340935319001',1230.000000000,'1956-08-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3673,'LOISEL','CHRISTIANE','1951-05-19','02.11.28.48.98','06.67.18.52.74',NULL,'34 ALBERT CAMUS','','','14000','CAEN',NULL,NULL,'2510514308001',11.000000000,'1981-07-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3674,'THOREL','GABRIELLE','1938-01-24','02.73.67.94.70','06.33.39.35.31',NULL,'Le Taret','','','14320','FONTENAY LE MARMION',NULL,NULL,'2380150148001',781.000000000,'1964-08-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3675,'BEAUGAS','Daniel','1930-12-25','02.35.59.68.57','06.12.00.10.53',NULL,'11 rue des fontaines','','','14000','CAEN',NULL,NULL,'1301214347001',588.000000000,'1953-04-23','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3676,'LECHEVALLIER','JOELLE','1948-01-26','03.67.73.94.50','06.89.69.58.26',NULL,'17 rue f faure','','','08000','CHARLEVILLE MEZIERES',NULL,NULL,'1480114556001',66.000000000,'1971-02-17','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3677,'MARIE','JEANINE','1928-01-03','02.89.75.35.21','06.29.26.17.81',NULL,'7 Chemin du Prieur','','','61100','MONTILLY SUR NOIREAU',NULL,NULL,'2280114029001',18.000000000,'1954-04-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3678,'MARIE','JACQUES','1937-05-03','02.90.24.07.58','06.12.90.64.26',NULL,'LA COUR','','','14270','MEZIDON CANON',NULL,NULL,'1370514602001',183.000000000,'1958-06-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3679,'DESPORTES','CLAUDINE','1936-08-06','02.25.50.72.70','06.68.28.51.43',NULL,'1103 les belles portes','','','14260','ONDEFONTAINE',NULL,NULL,'1360814660001',1098.000000000,'1960-06-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3680,'RENAUD','MICHEL','1942-11-07','02.76.09.07.21','06.91.09.49.50',NULL,'','','','50470','LA GLACERIE',NULL,NULL,'1421114529001',1452.000000000,'1971-11-20','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3681,'CRUCHON','CLAUDINE','1956-04-11','02.21.73.20.07','06.32.20.99.91',NULL,'10 rue Constant Forget','','','14350','LA GRAVERIE',NULL,NULL,'1560414112001',157.000000000,'1984-02-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3682,'GUESDON','CHANTAL','1931-11-09','02.72.88.12.93','06.10.90.65.52',NULL,'17 rue Jacques Prvert','','','14520','PORT EN BESSIN HUPPAIN',NULL,NULL,'1311161275001',510.000000000,'1954-11-13','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3683,'BAROCHE','','1929-06-28','02.61.42.28.78','06.74.83.29.19',NULL,'10 rue de la Fontaine','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'2290602825001',134.000000000,'1958-02-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3684,'DEVIQUE','','1936-05-21','02.84.82.72.21','06.37.93.11.86',NULL,'6.1 CITE DES ROCHES','','','14000','CAEN',NULL,NULL,'2360514071001',2.000000000,'1962-07-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3685,'BUSSY','MARIE-CLAUDE','1948-02-21','02.14.21.23.77','06.88.26.16.21',NULL,'14 RUE DE L''AVENIR','','','14840','CUVERVILLE',NULL,NULL,'2480214728001',20.000000000,'1977-08-27','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3686,'POINTU','ALEXANDRINE','1931-08-14','02.16.01.99.00','06.35.88.56.20',NULL,'39 BIS RUE PASTEUR','','','14000','CAEN',NULL,NULL,'1310814065001',1608.000000000,'1956-08-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3687,'JEANNETTE','LIONEL','1932-01-30','02.24.71.99.97','06.69.71.26.35',NULL,'20 RUE LEONARD GILLES','','','14123','FLEURY SUR ORNE',NULL,NULL,'1320150469001',92.000000000,'1961-07-09','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3688,'MAIGNAN','SUZANNE','1930-11-16','02.23.11.73.69','06.10.82.60.09',NULL,'37 RUE DU TOUR DE VILLE','','','14630','CAGNY',NULL,NULL,'1301114396001',2.000000000,'1955-01-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3689,'FESTOC','GENEVIEVE','1956-04-20','02.39.71.83.67','06.11.44.80.26',NULL,'230 CHEMIN DE FLEURY','','','14000','CAEN',NULL,NULL,'1560414740001',1199.000000000,'1978-03-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3690,'GOGUET','','1930-01-30','02.52.03.23.06','06.12.79.67.45',NULL,'1 RUE ROMAIN ROLLAND','','','50310','MONTEBOURG',NULL,NULL,'2300114273001',85.000000000,'1951-11-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3691,'ALLO','CHRISTIAN',NULL,'02.14.67.13.84','06.17.12.79.50',NULL,'117 RUE D''AUTHIE','','','61200','ARGENTAN',NULL,NULL,'1200314181001',5.000000000,'2009-04-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3692,'LE BIGOT','BERNADETTE','1940-06-29','02.97.75.48.24','06.65.73.85.55',NULL,'50 RUE ALEXIS DE TOCQUEVILLE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1400650165001',253.000000000,'1968-11-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3693,'FARIN','DENIS','1936-08-03','02.43.01.21.59','06.73.29.05.63',NULL,'11 rue Louis Lachenal','','','14000','CAEN',NULL,NULL,'2360850129001',90.000000000,'1959-08-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3694,'LIEGARD','GUY','1937-04-02','02.15.73.45.21','06.50.84.32.73',NULL,'9 RUE DES ECOLES','','','14810','GONNEVILLE EN AUGE',NULL,NULL,'2370414763001',86.000000000,'1961-02-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3695,'CORDIER','HERVE','1937-11-15','02.81.42.43.68','06.27.33.36.62',NULL,'10 rue du clos carre','','','14430','DOUVILLE EN AUGE',NULL,NULL,'2371150151001',91.000000000,'1961-10-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3696,'BARBE','CHRISTIAN','1938-07-12','02.57.81.91.46','06.11.74.56.15',NULL,'1 LE MARRONNIER','','','14540','SOLIERS',NULL,NULL,'1380714233001',640.000000000,'1960-10-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3697,'SEGONDS','SERGE','1940-06-14','02.26.05.91.69','06.34.74.81.28',NULL,'12 rue des Canadiens','','','14000','CAEN',NULL,NULL,'2400650260001',16.000000000,'1963-05-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3698,'PRIGENT','CHARLES','1931-06-07','02.52.60.13.28','06.10.21.25.76',NULL,'5 rue Gustave Flaubert','','','14730','GIBERVILLE',NULL,NULL,'1310650256001',64.000000000,'1957-02-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3699,'DETERVILLE','MAURICE','1932-09-13','02.17.94.20.83','06.61.61.53.41',NULL,'ferme de l''glise','','','14540','BOURGUEBUS',NULL,NULL,'1320961431001',187.000000000,'1953-05-21','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3700,'GAUCHE','TORNIKE','1923-05-06','02.31.28.75.06','06.64.36.60.65',NULL,'1 route des Tourelles','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2230506159001',17.000000000,'1945-12-27','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3701,'','LOUISE','1966-01-22','02.54.53.05.08','06.95.90.18.81',NULL,'13 rue de stokhlom','','','14000','CAEN',NULL,NULL,'2660114535001',11.000000000,'1989-09-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3702,'POIRIER','Jean','1935-05-13','02.11.27.48.94','06.13.17.50.44',NULL,'26 RUE DU DR CHARCOT','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2350514017001',156.000000000,'1958-01-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3703,'GAREL','YVES','1967-07-12','02.52.02.47.01','06.33.30.23.54',NULL,'505 route de canteloup','','','50250','ST JORES',NULL,NULL,'1670714470001',3304.000000000,'1990-04-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3704,'FAMECHON','JEAN-LOUIS','1932-10-30','02.25.90.37.87','06.40.34.78.28',NULL,'35 rue Aristide Briand','','','14730','GIBERVILLE',NULL,NULL,'2321014503001',22.000000000,'1957-09-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3705,'DAGAIN','','1929-04-05','02.64.76.64.21','06.77.81.62.43',NULL,'29 rue st exupery','','','14120','MONDEVILLE',NULL,NULL,'1290460700001',1942.000000000,'1953-08-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3706,'CATHERINE','MONIQUE','1929-11-23','02.93.45.58.00','06.19.30.08.03',NULL,'25 rue de la haie ligne','','','14000','CAEN',NULL,NULL,'2291178312001',1586.000000000,'1955-09-12','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3707,'LAGOUDE','PASCAL',NULL,'02.65.56.60.40','06.12.04.82.82',NULL,'22 avenue de la concorde','','','14120','MONDEVILLE',NULL,NULL,'2320214603001',702.000000000,'2008-09-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3708,'HENRIETTE','MADELEINE','1962-03-19','02.11.05.07.88','06.50.19.89.86',NULL,'19 bd de rethel','','','14000','CAEN',NULL,NULL,'2620314274001',166.000000000,'1985-07-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3709,'GUILLOT','MARIE-CHRISTIN','1962-03-01','02.66.39.58.49','00 33 6.40.05.95.12',NULL,'4 la belle etoile','','','14220','PLACY',NULL,NULL,'2620314274001',2.000000000,'1983-10-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3710,'SIMON','ISABELLE','1933-01-09','02.46.32.45.68','06.47.82.98.31',NULL,'LE REGENCY 15 RUE DR TILLaUX','','','14850','HEROUVILLETTE',NULL,NULL,'2330114292001',840.000000000,'1955-03-07','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3711,'SIMON','ISABELLE','1936-04-03','02.12.19.43.29','00 33 6.35.73.79.32',NULL,'129 rue de l''glise','','','14970','ST AUBIN D''ARQUENAY',NULL,NULL,'2360427065001',179.000000000,'1958-09-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3712,'SKRZYPACZ','SYLVIE','1938-12-09','02.49.12.16.86','06.59.20.97.64',NULL,'59 RUE MARTINVILLE','','','14000','CAEN',NULL,NULL,'2381214060001',3017.000000000,'1963-04-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3713,'BAZIN','JEAN PIERRE','1940-12-30','02.71.92.16.97','06.77.61.31.20',NULL,'99 RUE ANDRE MALRAUX','','','14210','STE HONORINE DU FAY',NULL,NULL,'2401261002001',20.000000000,'1961-02-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3714,'TUKALO','BERNARD','1935-04-05','02.71.54.74.76',NULL,NULL,'la bruyre','','','14840','DEMOUVILLE',NULL,NULL,'2350414271001',88.000000000,'1956-02-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3715,'DUMOUCHEL','ANDREE','1938-04-22','02.94.37.03.13','06.56.38.14.73',NULL,'NEUMER','','','14270','MEZIDON CANON',NULL,NULL,'1380414471001',400.000000000,'1962-04-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3716,'LECHAPTOIS','NATHALIE','1931-06-23','02.11.42.76.85','06.84.50.07.08',NULL,'38 BD LYAUTEY','','',NULL,NULL,NULL,NULL,'1310614236001',3.000000000,'1954-06-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3717,'BISSON','JACQUES','1931-12-18','02.56.10.07.41','06.86.08.70.90',NULL,'6 ALLEE DES TILLEUILS','','','14123','IFS',NULL,NULL,'1311214589001',63.000000000,'1954-01-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3718,'NOVO','JEAN','1968-11-03','02.86.54.79.75','06.17.35.82.35',NULL,'15 rue pillet will','','','14310','TOURNAY SUR ODON',NULL,NULL,'2681114119001',1112.000000000,'1992-07-14','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3719,'GROSMESNIL','','1928-02-14','02.75.90.77.63','06.68.60.31.35',NULL,'','','','14000','CAEN',NULL,NULL,'1280214150001',21.000000000,'1955-11-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3720,'ARIBAUT','ANTOINETTE','1930-12-12','02.83.25.32.32','06.54.51.14.22',NULL,'3 Chemin du Buisson','','','61100','FLERS',NULL,NULL,'1301214666001',193.000000000,'1958-07-11','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3721,'MERY','Therese','1931-10-26','02.35.12.98.00','06.11.47.56.14',NULL,'3 rue caillemer','','','14270','MEZIDON CANON',NULL,NULL,'1311076260001',33.000000000,'1956-12-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3722,'DEBONS','EMILIENNE','1931-07-30','02.60.45.80.90','06.20.75.24.71',NULL,'7 rue Lonard Gill','','','61000','ALENCON',NULL,NULL,'1310714100001',61.000000000,'1952-10-31','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3723,'DE CEUNYNCK','JEAN',NULL,'02.15.21.41.07','06.91.97.80.27',NULL,'325 RUE DE FALAISE BP1254','','','14000','CAEN',NULL,NULL,'1430150501001',770.000000000,'2012-07-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3724,'DIEUDONNE','Josselyne','1932-10-17','02.76.23.65.96','06.79.61.36.54',NULL,'7 rue Paul Verlaine','','','14460','COLOMBELLES',NULL,NULL,'1321014112001',1230.000000000,'1957-12-24','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3725,'BOUTELOUP','Marthe','1940-09-08','02.22.85.03.37','06.98.78.82.16',NULL,'7 rue du Commandant Charcot','','','14123','IFS',NULL,NULL,'2400914182001',23.000000000,'1965-07-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3726,'RICHARD','CLAUDE','1940-02-10','02.84.10.67.63','06.32.00.23.88',NULL,'9 rue du Bissonnet','','','14120','MONDEVILLE',NULL,NULL,'1400233478001',2367.000000000,'1968-06-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3727,'CHAMPEL','JEAN','1930-04-15','02.90.27.37.17','06.96.15.38.01',NULL,'12 rue de l''Eglise','','','14510','HOULGATE',NULL,NULL,'1300414301001',14.000000000,'1960-10-07','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3728,'NIARD','HUGUETTE','1931-06-10','02.80.45.31.48','06.42.58.91.23',NULL,'7 avenue de Normandie','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2310614733001',43.000000000,'1954-11-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3729,'COLIN','','1955-04-05','02.39.58.73.86','06.67.94.12.33',NULL,'Ferme de la Grande Bergerie','','','14000','CAEN',NULL,NULL,'2550414477001',320.000000000,'1980-03-23','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3730,'BISSON','MARCEL','1952-01-14','02.11.11.81.98','06.13.97.83.07',NULL,'39 AVENUE DU MARECHAL','','','14120','MONDEVILLE',NULL,NULL,'2520114119001',153.000000000,'1973-09-28','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3731,'LOUIS','SIMONE','1936-07-24','02.18.40.73.79','06.65.59.13.05',NULL,'12 RUE DU MARECHAL FOCH','','','14730','GIBERVILLE',NULL,NULL,'1360714099001',1304.000000000,'1957-01-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3732,'MARGUERIE','PAULETTE','1938-05-22','02.82.48.07.02','06.95.91.34.44',NULL,'12 rue Neuve','','','14940','SANNERVILLE',NULL,NULL,'2380514347001',136.000000000,'1968-04-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3733,'CAILLET','JEAN CLAUDE','1936-11-18','02.69.87.02.75','06.58.32.03.71',NULL,'73 AVENUE CHARLOTTE CORDAY','','','14690','PONT D''OUILLY',NULL,NULL,'2361114251001',9.000000000,'1964-10-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3734,'MARIE','MOISE','1963-04-28','02.68.53.62.91','06.21.48.48.33',NULL,'18 allee des poetes','','','14000','CAEN',NULL,NULL,'1630414493001',6.000000000,'1993-03-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3735,'FURDYNA','JACQUES','1940-06-15','02.11.68.23.85','06.12.25.23.31',NULL,'6 rue neuve st jean','','','14000','CAEN',NULL,NULL,'1400614327001',63.000000000,'1962-01-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3736,'BOUTROIS','MARGUERITE','1928-03-24','02.15.37.03.04','06.46.37.66.13',NULL,'5 rue Lornard de Vinci','','','14120','MONDEVILLE',NULL,NULL,'1280315190001',38.000000000,'1957-07-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3737,'QUETIL','CHRISTIANE','1936-03-20','02.31.77.76.59','06.79.64.32.74',NULL,'9 rue georges le francois','','','14440','CRESSERONS',NULL,NULL,'1360314457001',39.000000000,'1957-02-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3738,'RODRIGUES','JACQUES','1943-05-07','02.49.05.75.99','06.69.18.32.05',NULL,'5 rue marcel pelluet','','','14220','CROISILLES',NULL,NULL,'1430578158001',507.000000000,'1965-01-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3739,'LE BON','JANINE','1938-03-14','02.38.59.48.87','06.73.96.59.51',NULL,'15 rue Estienne d''Orves','','','14730','GIBERVILLE',NULL,NULL,'2380349259001',20.000000000,'1961-05-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3740,'LECOUTOUR','MARTINE','1933-10-02','02.82.62.77.40','06.83.02.57.84',NULL,'29 rue de Clinchamps','','','14000','CAEN',NULL,NULL,'2331050597001',231.000000000,'1960-12-30','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3741,'HERVIEU','DESIRE',NULL,'02.29.66.27.95','06.72.95.68.19',NULL,'14 Sente du Vivier','','','14000','CAEN',NULL,NULL,'1300314309001',4311.000000000,'2011-04-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3742,'HERVIEU','BERTRAND','1934-06-14','02.32.29.50.07','06.46.16.92.00',NULL,'1 route de bayeux','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2340614366001',59.000000000,'1958-06-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3743,'ARDILLON','NICOLE','1932-12-11','02.54.23.40.02','06.21.90.54.68',NULL,'87 rue d''Hrouville','','','14320','FONTENAY LE MARMION',NULL,NULL,'2321214444001',1501.000000000,'1956-06-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3744,'MARIE','JACKY','1934-04-11','02.14.12.39.37','06.89.37.31.47',NULL,'3 impasse du coin','','','14000','CAEN',NULL,NULL,'2340450298001',433.000000000,'1959-11-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3745,'LE BORDAIS','SIMONE','1938-02-24','02.89.89.62.52','06.57.14.51.07',NULL,'LE BOURG','','','14610','EPRON',NULL,NULL,'1380250172001',566.000000000,'1966-07-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3746,'NICOLLE','MICHELLE','1938-01-22','02.85.07.29.81','06.20.98.07.53',NULL,'','','','14610','FONTAINE HENRY',NULL,NULL,'1380114197001',103.000000000,'1968-09-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3747,'FOSSARD','MADELEINE','1938-08-14','02.50.83.17.77','06.78.19.82.28',NULL,'23 RUE DU BESSIN','','',NULL,NULL,NULL,NULL,'1380814533001',35.000000000,'1960-07-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3748,'LECLOUAREC','CLAUDE','1936-09-10','02.98.56.29.00','06.20.88.05.92',NULL,'','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1360914057001',87.000000000,'1958-12-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3749,'BONVICINI','','1936-02-06','02.89.18.40.27','06.41.35.96.86',NULL,'19 ROUTE DE LA GUERINIERE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2360250378001',3592.000000000,'1963-03-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3750,'FOUQUEREL','HENRI','1948-01-02','02.85.96.37.15','06.33.26.64.87',NULL,'25 rue montgolfier','','','14630','FRENOUVILLE',NULL,NULL,'1480114168001',407.000000000,'1978-04-09','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3751,'RODRIGUEZ MEDALLO','FREDERIC','1943-03-28','02.12.29.23.37','06.17.50.09.50',NULL,'36 rue de la plaine','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1430314212001',970.000000000,'1970-05-07','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3752,'GUERIN','ALAIN','1939-06-19','02.12.05.20.32','06.66.01.50.89',NULL,'2 PLACE PASTEUR','','','14400','BAYEUX',NULL,NULL,'2390614183001',128.000000000,'1965-12-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3753,'GILLET','YANNICK','1934-02-17','02.72.13.15.69','06.11.38.72.67',NULL,'58 rue du tour de ville','','','14540','SOLIERS',NULL,NULL,'2340214323001',8.000000000,'1963-08-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3754,'DORNIOL','DANIELLE','1940-09-26','02.30.67.26.52','06.90.94.00.15',NULL,'15 RUE MONSEIGNEUR ADAM','','','14150','OUISTREHAM',NULL,NULL,'2400914552001',8.000000000,'1970-10-26','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3755,'DELANGE','YVETTE','1958-01-11','02.56.94.75.52','06.80.84.20.54',NULL,'4 RUE ST EXUPERRY','','','14000','CAEN',NULL,NULL,'2580114723001',423.000000000,'1982-01-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3756,'NORMAND','MADELEINE','1940-08-31','02.11.69.36.91','06.79.99.89.31',NULL,'16 RUE CAMILLE DRAPEAU','','','14123','FLEURY SUR ORNE',NULL,NULL,'1400861447001',89.000000000,'1966-10-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3757,'LACROIX','Maryvonne','1938-09-05','02.95.22.92.72','06.26.05.29.32',NULL,'24 RUE DU GENERAL LECLERC','','','14210','STE HONORINE DU FAY',NULL,NULL,'1380914720001',1689.000000000,'1965-06-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3758,'LECHEVALLIER','JOSETTE','1961-12-27','02.29.79.35.74',NULL,NULL,'LES FOSSES','','','14730','GIBERVILLE',NULL,NULL,'1611261171001',47.000000000,'1983-07-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3759,'DEVIGNE','GUY','1934-10-27','02.99.66.66.66','06.80.53.31.47',NULL,'16 RUE DES ARTS','','','14123','IFS',NULL,NULL,'2341014726001',452.000000000,'1960-09-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3760,'BISSON','JOSEPH','1960-01-19','02.60.54.50.42','06.35.31.16.84',NULL,'St Eloi','','','14400','SOMMERVIEU',NULL,NULL,'2600150464001',49.000000000,'1990-06-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3761,'THOMAS','RAYMONDE','1943-01-21','02.89.75.31.20','06.10.60.05.27',NULL,'5 rue de Sude','','','14220','BARBERY',NULL,NULL,'1430161075001',14.000000000,'1967-07-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3762,'LECERF','CYRILLE','1970-03-06','02.49.43.32.95','06.62.49.03.37',NULL,'13 RUE PAUL ALLENE','','','14000','CAEN',NULL,NULL,'2700327050001',278.000000000,'1991-02-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3763,'FLEURY','LUCIENNE','1938-02-05','02.46.78.15.18','06.51.77.74.96',NULL,'7 CHEMIN DU MOULIN HUE','','','50820','BRIX',NULL,NULL,'1380214738001',32.000000000,'1964-10-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3764,'BECQUET','JEAN','1963-10-31','02.10.19.87.40','06.10.83.37.25',NULL,'33 RUE JEAN MERMOZ','','','14320','FONTENAY LE MARMION',NULL,NULL,'1631014215001',35.000000000,'1993-04-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3765,'GUERIN','MICHEL','1938-06-12','02.37.40.26.23','06.77.66.75.12',NULL,'LE CLOS CHOISNEL','','','14000','CAEN',NULL,NULL,'1380650577001',294.000000000,'1968-08-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3766,'GUERIN','CLAUDE','1921-01-02','02.24.78.62.51','06.88.18.51.70',NULL,'7 RESIDENCE STE PAIX','','','14430','BRANVILLE',NULL,NULL,'1210114554001',17.000000000,'1944-06-13','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3767,'HARANT','Michel','1956-01-16','02.13.89.15.96','06.82.35.94.90',NULL,'30 rue d''Esglandes','','','14700','FALAISE',NULL,NULL,'1560114264001',11.000000000,'1984-04-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3768,'LEPELTIER','RENE','1929-06-14','02.59.95.59.29','06.99.42.20.97',NULL,'11 RUE PIERRE BROCELETTE','','','14123','IFS',NULL,NULL,'1290614658001',116.000000000,'1954-07-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3769,'AUMONT','JEANNINE','1953-03-14','02.81.97.86.26','06.71.17.27.73',NULL,'19 PLACE VERDUN','','',NULL,NULL,NULL,NULL,'1530314283001',18.000000000,'1974-06-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3770,'BRIERE','MIREILLE','1935-03-03','02.14.31.78.42','06.47.38.11.81',NULL,'17 rue des Eglantiers','','','14320','FONTENAY LE MARMION',NULL,NULL,'1350314079001',3015.000000000,'1957-04-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3771,'DELANGE','GEORGES','1953-05-05','02.31.11.34.89','06.32.59.61.40',NULL,'60 RUE DU BOUT DE BAS','','','14540','HUBERT FOLIE',NULL,NULL,'2530514519001',121.000000000,'1976-09-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3772,'TAUPIN','SIMONE','1932-09-27','02.79.19.56.22','06.39.52.32.62',NULL,'Le Juget','','','14270','MEZIDON CANON',NULL,NULL,'1320916157001',1730.000000000,'1954-03-02','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3773,'PERICHON','JACQUES PAUL','1938-02-25','02.85.62.84.44','06.51.35.16.73',NULL,'85 BD ANDRE DE TOLL','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'2380214068001',812.000000000,'1966-10-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3774,'CAPITAINE','PIERRE','1938-10-28','02.22.06.04.63','06.87.36.56.33',NULL,'31 rue de la Vire','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'1381061288001',98.000000000,'1962-11-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3775,'ACCARD','SUZANNE','1931-07-25','02.74.47.82.67',NULL,NULL,'13 RUE FRED SCAMARONI','','','14000','CAEN',NULL,NULL,'1310714551001',319.000000000,'1956-04-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3776,'LEU','MICHEL','1938-04-28','02.45.01.51.37','06.20.97.60.95',NULL,'96 AVENUE DE ROUEN BAT B APPT 1','8 RDC','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1380450416001',75.000000000,'1963-06-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3777,'GUERIN','BATAGOZA','1930-07-17','02.81.21.37.51','06.30.10.78.81',NULL,'LIEU DIT LE BOURG NEUF','','',NULL,NULL,NULL,NULL,'2300714437001',46.000000000,'1955-02-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3778,'LENNUYEUX','ROBERT',NULL,'02.35.32.37.34','06.24.03.79.79',NULL,'LA RAIRIE','','','14210','AMAYE SUR ORNE',NULL,NULL,'1361261197001',89.000000000,'2011-08-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3779,'BOUET','JACQUELINE','1957-03-10','02.27.55.26.70','06.71.98.41.43',NULL,'10 Impasse Tellier','','','14600','HONFLEUR',NULL,NULL,'1570361332001',34.000000000,'1985-09-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3780,'LEFLOCH','ODILE','1968-09-12','02.66.91.45.01','06.11.34.64.62',NULL,'272 rue du Vieux Paitis','','','14730','GIBERVILLE',NULL,NULL,'1680914390001',162.000000000,'1998-01-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3781,'MESNIL','GERARD','1930-08-16','02.74.59.69.49',NULL,NULL,'ROUTE DE MEZIERES','','','14730','GIBERVILLE',NULL,NULL,'1300814424001',2842.000000000,'1959-03-19','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3782,'TILLARD','ARLETTE','1936-07-05','02.33.45.75.00','06.34.12.17.51',NULL,'24 RUE DE TIERCEVILLE','','','14000','CAEN',NULL,NULL,'1360735112001',84.000000000,'1957-10-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3783,'DOUCHET','MICHEL','1935-01-23','02.11.76.36.82','06.11.92.73.88',NULL,'rue de la justice','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1350199358001',624.000000000,'1956-01-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3784,'DESLOGES','ODILE','1935-01-12','02.10.03.43.55','06.48.66.48.08',NULL,'26 rue des Msanges','','','14120','MONDEVILLE',NULL,NULL,'1350199358001',408.000000000,'1963-12-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3785,'GODARD','MARCEL','1934-06-13','02.10.05.45.28','06.46.58.20.77',NULL,'16 rue des genets','','','14570','ST LAMBERT',NULL,NULL,'2340614384001',318.000000000,'1956-11-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3786,'BUISSON','JEANNE','1944-03-07','02.77.34.07.81','06.60.04.82.83',NULL,'4 RUE LAENNEC','','','14000','CAEN',NULL,NULL,'2440327208001',31.000000000,'1974-07-16','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3787,'LEBIGOT','JEANNINE','1984-07-08','02.96.05.66.04','06.61.26.85.89',NULL,'13-2 GRANDE RUE','','','14540','BOURGUEBUS',NULL,NULL,'1840799255001',365.000000000,'2008-03-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3788,'LOISON','GISELE','1959-05-04','02.76.86.14.15','06.55.22.68.46',NULL,'7 CHEMIN DU MOULIN HUE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2590514638001',57.000000000,'1986-08-30','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3789,'LERAISNIER','JOEL','1959-01-06','02.67.22.94.70','06.56.79.37.55',NULL,'52 RUE DU COMMERCE','','','14270','MEZIDON CANON',NULL,NULL,'2590114443001',77.000000000,'1986-02-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3790,'CHERBONNEL','GENEVIEVE','1965-11-20','02.29.07.88.95','06.11.90.37.05',NULL,'2 IMPASSE DU BERRY','','','14000','CAEN',NULL,NULL,'2651114191001',218.000000000,'1987-08-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3791,'VERHAEGHE','FRANCOISE','1955-02-10','02.27.87.30.24','06.10.35.22.10',NULL,' 801 QUARTIER DU VAL','','','14320','FONTENAY LE MARMION',NULL,NULL,'1550214254001',527.000000000,'1979-08-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3792,'LANTRAIN','BRUNO','1969-06-22','02.99.07.29.69','06.28.31.00.51',NULL,'27 rue des perrelles','','','14000','CAEN',NULL,NULL,'1690678401001',115.000000000,'1999-11-28','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3793,'LE JAMTEL','ANDRE','1945-05-26','02.82.33.29.43','06.44.36.13.05',NULL,'200 RUE DES BALCONS','','',NULL,NULL,NULL,NULL,'1450514183001',30.000000000,'1969-03-29','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3794,'BOUTELOUP','ISABELLE','1945-05-29','02.41.55.75.80','06.26.19.43.53',NULL,'17 RUE DES PETITES RUES','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'1450514183001',412.000000000,'1969-09-25','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3795,'FESTOC','RAYMOND','1940-07-25','02.31.90.64.31','06.86.82.07.13',NULL,'10 RUE DU JURA','','','14210','TROIS MONTS',NULL,NULL,'2400772054001',1852.000000000,'1961-09-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3796,'PARMENT','PASCALE','1959-01-02','02.68.19.53.83','06.99.45.61.53',NULL,'39 avenue du marechal','','','14000','CAEN',NULL,NULL,'1590150220001',1309.000000000,'1981-12-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3797,'NOEL','MICHEL','1942-03-09','02.60.60.87.40','06.85.07.74.67',NULL,'19 rue goujarde','','','14610','EPRON',NULL,NULL,'1420314072001',41.000000000,'1963-12-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3798,'RYDER','','1951-01-24','02.28.73.57.94','00 33 6.93.11.58.72',NULL,'4 RUE DU PRONET','','','14000','CAEN',NULL,NULL,'2510114157001',45.000000000,'1972-04-06','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3799,'TRIPPIER','ROGER','1938-09-13','02.88.69.35.49','06.84.86.58.65',NULL,'36 RUE DE LA HAYE','','','14000','CAEN',NULL,NULL,'2380979307001',746.000000000,'1960-11-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3800,'LEVILLY','ISABELLE','1934-06-26','02.74.88.48.92',NULL,NULL,'15 RUE VICTOR HUGO','','','14000','CAEN',NULL,NULL,'1340614133001',1358.000000000,'1959-08-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3801,'PIGEON','ELIANE','1934-12-04','02.75.64.15.88','06.10.96.78.99',NULL,'IMPASSE RASPAIL','','','14000','CAEN',NULL,NULL,'2341214638001',612.000000000,'1957-02-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3802,'MENARD','Patrice','1954-01-27','02.61.78.81.89','06.17.34.79.86',NULL,'17 ALLEE LAPEROUSE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1540114659001',107.000000000,'1976-03-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3803,'LANGLOIS','CHRISTOPHE','1964-01-14','02.82.40.95.40','06.30.86.26.54',NULL,'28 RUE DES FRERES COLLIN','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1640114456001',16.000000000,'1986-04-05','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3804,'JEANNE','BERNARD','1966-07-23','02.85.07.85.29','06.85.48.94.02',NULL,'2 RUE DES CANADIENS','','','14860','BAVENT',NULL,NULL,'2660714034001',11.000000000,'1996-11-02','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3805,'SEVESTRE','IRENE','1943-01-02','02.27.51.97.73','06.76.63.92.12',NULL,'24 ALLEE DES POETES','','','14400','BAYEUX',NULL,NULL,'1430150393001',129.000000000,'1967-12-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3806,'MARIE','PIERRE','1933-02-15','02.81.77.92.56','06.52.61.73.90',NULL,'7 impasse de l''humeliere','','','14710','LA FOLIE',NULL,NULL,'1330261466001',181.000000000,'1958-06-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3807,'BERTHE','ROLANDE','1938-06-14','02.60.92.60.25','06.72.58.54.00',NULL,'12 CHEMIN DE BEAUREGARD','','','14250','JUAYE MONDAYE',NULL,NULL,'2380650281001',127.000000000,'1959-04-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3808,'JUMEL','MICHEL','1932-01-09','02.77.26.43.70','06.67.89.09.20',NULL,'19 rue de la hague','','','14000','CAEN',NULL,NULL,'2320127305001',382.000000000,'1956-07-19','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3809,'RENCUREL','PIERRE','1937-01-12','02.10.36.22.91','06.70.20.27.92',NULL,'20 avenue du point du jour','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1370114005001',216.000000000,'1961-03-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3810,'PERRIN','CLAUDE','1932-02-28','02.25.71.69.68','06.42.21.15.55',NULL,'CHEMIN DU VEY','','','14630','CAGNY',NULL,NULL,'1320214257001',205.000000000,'1953-05-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3811,'VAUVRECY','FRANCE','1931-04-05','02.31.34.55.32','06.51.98.95.32',NULL,'24 CITE MON TOIT','','','14120','MONDEVILLE',NULL,NULL,'1310461147001',16.000000000,'1952-01-15','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3812,'VISSE','JANINE','1934-01-26','02.58.12.38.42','06.66.79.96.10',NULL,'','','','14540','HUBERT FOLIE',NULL,NULL,'2340114752001',32.000000000,'1964-08-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3813,'VAUVARIN','ROLAND','1968-09-06','02.11.78.46.39','06.43.21.53.15',NULL,'101 rue d''Hrouville','','','14123','IFS',NULL,NULL,'1680914390001',39.000000000,'1992-07-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3814,'MICHEL','LOUIS','1963-04-19','02.72.78.42.31','06.96.34.73.90',NULL,'98 rue Basse','','','14630','FRENOUVILLE',NULL,NULL,'2630414257001',35.000000000,'1984-10-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3815,'DUCHATELLE','','1932-08-11','02.13.79.27.58','06.24.47.29.58',NULL,'26 rue de l''Eglise','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1320814246001',564.000000000,'1960-09-08','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3816,'DENIS','YVONNE','1929-12-03','02.85.31.86.65','06.88.26.29.82',NULL,'6 abb Aynard','','','01960','PERONNAS',NULL,NULL,'2291276114001',31.000000000,'1959-01-06','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3817,'CHATELAIN','THERESE',NULL,NULL,NULL,NULL,'11 rue de Mzidon','','','14670','TROARN',NULL,NULL,'2301250267001',1046.000000000,'2012-01-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3818,'THOMAS','ELISABETH','1933-05-07','02.23.09.97.87','06.15.23.87.83',NULL,'11 ALLEE DE COPENHAGUE','','','14210','EVRECY',NULL,NULL,'1330514614001',3609.000000000,'1955-07-31','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3819,'PETIT','ROBERT','1966-02-01','02.99.72.69.53','06.11.43.38.91',NULL,'7 RUE GUSTAVE FLAUBERT','','','14860','RANVILLE',NULL,NULL,'1660241070001',1287.000000000,'1987-09-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3820,'LEHENAFF','ANNICK','1963-06-20','02.88.56.93.95','06.25.42.20.36',NULL,'1 RUE DE PROVENCE','','','14123','IFS',NULL,NULL,'2630614090001',419.000000000,'1991-02-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3821,'LANGLOIS','ISABELLE','1967-04-16','02.76.83.27.84','06.40.88.25.88',NULL,'19 RUE DU PONT JALON','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2670414356001',27.000000000,'1992-04-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3822,'LEROY','BERNARD','1935-04-27','02.22.09.48.64','06.47.34.86.60',NULL,'9 ALLEE ST MARCOUF LE CHEMIN V','ERT','','14000','CAEN',NULL,NULL,'2350414751001',257.000000000,'1957-09-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3823,'POTEL','ISABELLE','1935-10-20','02.58.16.97.26','06.90.41.19.12',NULL,'rue de bretteville','','','14270','LE MESNIL MAUGER',NULL,NULL,'2351014133001',20.000000000,'1956-11-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3824,'AUBREE','PHILIPPE','1934-07-19','02.62.96.04.20','06.45.02.33.76',NULL,'27 RUE CAILLEMER','','','14400','TOUR EN BESSIN',NULL,NULL,'2340727169001',12.000000000,'1956-04-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3825,'LEROY','ROLAND','1955-08-14','02.77.08.12.19','06.79.36.75.45',NULL,'LA FLAMBARDIERE','','','14240','CAHAGNES',NULL,NULL,'2550814169001',1446.000000000,'1984-04-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3826,'GOURNAY','MARCEL','1940-03-16','02.11.74.17.32',NULL,NULL,'17 rue gustave flaubert','','','14000','CAEN',NULL,NULL,'1400314664001',106.000000000,'1963-11-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3827,'CHAUVIN','RAYMONDE','1947-01-16','02.70.91.32.55','06.21.61.00.81',NULL,'5 rue de la fosse  terre','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2470114619001',21.000000000,'1975-07-24','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3828,'LE MEUR','VICTOR','1951-08-20','02.69.66.71.68','06.16.37.62.17',NULL,'9 RUE KINDSBACH','','','14000','CAEN',NULL,NULL,'1510850028001',4249.000000000,'1978-02-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3829,'FOUQUES','CLAUDIA','1968-09-17','02.93.61.48.06','06.64.04.90.46',NULL,'2 rue Cardinal Lavigerie','','','14000','CAEN',NULL,NULL,'1680914390001',104.000000000,'1998-08-15','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3830,'COBBAERT','GILLES','1953-02-21','02.32.78.69.25','06.63.08.48.71',NULL,'75 RUE BRANVILLE','','','14123','IFS',NULL,NULL,'2530280755001',130.000000000,'1980-06-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3831,'AUBRY','NICOLE','1945-05-12','02.47.87.67.56','06.88.19.53.94',NULL,'8 RUE JULES FERRY','','','14220','OUFFIERES',NULL,NULL,'2450514554001',130.000000000,'1974-01-06','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3832,'CHASSARD','FERNAND','1967-04-21','02.74.24.62.06',NULL,NULL,'14 rue d''anjou','','','14000','CAEN',NULL,NULL,'2670414356001',64.000000000,'1991-04-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3833,'FLAMBARD','Rolande','1930-10-22','02.48.62.37.03','06.11.22.77.08',NULL,'4 IMPASSE DU CHEMIN VERT','','','14540','HUBERT FOLIE',NULL,NULL,'1301014514001',3.000000000,'1955-06-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3834,'CONTI','MARTINE','1933-07-31','02.11.55.52.80','06.17.39.08.53',NULL,'13 AVENUE DU PARC','','','14520','PORT EN BESSIN HUPPAIN',NULL,NULL,'1330714521001',28.000000000,'1963-12-10','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3835,'ANCQUETIL','Michel','1955-02-16','02.62.47.44.99','06.26.12.02.35',NULL,'10 rue verdiere','','',NULL,NULL,NULL,NULL,'1550214254001',619.000000000,'1976-02-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3836,'CHARPENTIER','CHRISTIANE',NULL,'02.24.15.36.92','06.28.34.62.95',NULL,'24RUE DU STADE','','','14650','CARPIQUET',NULL,NULL,'2700114327001',470.000000000,'2013-05-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3837,'LAURENT','JACQUELINE','1934-04-10','02.18.54.76.07','06.30.00.44.07',NULL,'248 AVENUE JEAN JAURES','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2340414181001',101.000000000,'1963-10-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3838,'LAURENT','CORINNE','1930-06-13','02.62.68.07.65','06.55.61.05.33',NULL,'19 rue Circulaire','','','14120','MONDEVILLE',NULL,NULL,'2300650433001',593.000000000,'1952-11-12','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3839,'PICOT','COLETTE','1934-01-13','02.14.67.93.53','06.12.24.97.31',NULL,'20 rue Jules Ferry','','','14630','FRENOUVILLE',NULL,NULL,'1340114138001',472.000000000,'1957-12-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3840,'GACHET','MIREILLE','1969-09-11','02.14.73.27.20','06.95.61.46.82',NULL,'13 rue des Geraniums','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2690914118001',223.000000000,'1992-04-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3841,'DULORD','Jacques','1929-09-21','02.22.75.83.13','06.42.88.73.45',NULL,'7 rue des pres','','','14190','MAIZIERES',NULL,NULL,'1290950059001',3435.000000000,'1953-04-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3842,'COUE','JACQUELINE','1939-08-17','02.25.47.76.77','06.42.13.22.27',NULL,'16 rue saint andre','','','14270','CONDE SUR IFS',NULL,NULL,'2390827221001',704.000000000,'1967-12-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3843,'VANNIER','MONIQUE','1937-12-31','02.49.15.30.08','06.11.97.44.30',NULL,'LA PCOTERIE','','','14190','CAUVICOURT',NULL,NULL,'1371214263001',78.000000000,'1960-04-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3844,'ROLLAND','GILBERT','1935-12-01','02.89.99.38.93','06.90.78.32.42',NULL,'LE NOUVEAU MONDE','','','14120','MONDEVILLE',NULL,NULL,'1351214523001',84.000000000,'1956-07-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3845,'MAGLOIRE','BERNARD','1936-04-18','02.11.47.88.36','06.12.07.82.33',NULL,'4 cite des jardins','','','50850','GER',NULL,NULL,'2360488251001',376.000000000,'1966-01-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3846,'TERRY','ilqar','1938-03-06','02.73.58.57.59','06.55.85.01.59',NULL,'2 rue paul allaine','','','14000','CAEN',NULL,NULL,'2380322225001',169.000000000,'1964-08-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3847,'VERZELE','REGIS','1968-01-14','02.63.71.90.60','06.42.18.63.75',NULL,'LE CAMPOINT','','','14460','COLOMBELLES',NULL,NULL,'2680114327001',35.000000000,'1991-07-29','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3848,'CHEVALIER','VALENTIN','1962-01-09','02.14.43.87.83','06.13.46.54.46',NULL,'LE CAMPOINT','','','14540','ROCQUANCOURT',NULL,NULL,'2620114221001',149.000000000,'1987-04-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3849,'FERTE','Gabriel','1929-09-29','02.39.86.70.86','06.24.36.34.85',NULL,'29 RUE PASTEUR','','','14400','ST LOUP HORS',NULL,NULL,'2290914204001',42.000000000,'1953-08-28','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3850,'LEMERCIER','CHRISTIANE','1951-03-08','02.86.76.69.98','06.19.41.93.35',NULL,'20 RUE ERNEST RENAN','','','14710','TREVIERES',NULL,NULL,'1510341243001',474.000000000,'1976-06-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3851,'VILLEDIEU','LUCIENNE','1932-04-28','02.12.93.65.77','06.59.42.55.95',NULL,'LES FOURNEAUX','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2320414170001',5.000000000,'1956-05-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3852,'DELACOUR','MARIELLE','1930-11-30','02.96.21.38.72','06.18.06.43.52',NULL,'144 rue haute','','','14000','CAEN',NULL,NULL,'2301128408001',138.000000000,'1952-03-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3853,'THOREL','MADELAINE','1961-01-31','02.61.89.89.01','00 33 6.33.42.94.20',NULL,'9 ROUTE D AUVERS','','','14270','MEZIDON CANON',NULL,NULL,'1610114666001',20.000000000,'1984-05-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3854,'RENARD','FRANCIS','1934-06-11','02.93.02.27.72','06.20.17.18.16',NULL,'48 bvd raymond poincare','','','14710','MANDEVILLE EN BESSIN',NULL,NULL,'1340650139001',73.000000000,'1959-12-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3855,'LEPONT','Mauricette','1942-03-19','02.48.13.10.93','06.35.36.60.32',NULL,'9 IMPASSE DES MARETTES','','','14370','CANTELOUP',NULL,NULL,'1420314072001',274.000000000,'1966-04-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3856,'CHEVALIER','Mauricette','1940-05-30','02.74.96.11.69',NULL,NULL,'','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2400550164001',98.000000000,'1969-01-24','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3857,'TOQUET','JEAN','1957-01-31','02.51.38.46.17','06.59.51.22.37',NULL,'46 avenue de la cigogne','','','14000','CAEN',NULL,NULL,'1570114187001',5121.000000000,'1983-08-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3858,'RICHARD','MICHEL','1930-12-10','02.43.41.18.40','06.33.26.44.34',NULL,'70 RUE DE L''EGLISE','','','14730','GIBERVILLE',NULL,NULL,'1301214490001',215.000000000,'1955-05-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3859,'COURTOIS','michel','1931-07-16','02.30.24.31.27','06.31.76.13.77',NULL,'2 rue de rome','','','14123','IFS',NULL,NULL,'2310714308001',1706.000000000,'1960-06-26','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3860,'WILHOFF','CAROLE','1929-11-08','02.44.33.65.09','06.15.24.13.10',NULL,'4 rue st lanbert','','','14123','FLEURY SUR ORNE',NULL,NULL,'2291114127001',183.000000000,'1952-06-01','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3861,'FOLLIOT','YVETTE','1934-10-06','02.83.07.49.43','06.14.09.15.56',NULL,'11 rue de la fraternite','','','50230','AGON COUTAINVILLE',NULL,NULL,'2341014554001',991.000000000,'1955-09-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3862,'TETI','YVES','1959-03-09','02.39.10.70.15','06.13.73.96.39',NULL,'6 chemin du home','','','61120','VIMOUTIERS',NULL,NULL,'2590350363001',107.000000000,'1980-01-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3863,'LAMOTTE','MARIE CLAIRE','1947-03-14','02.30.67.36.59','06.76.56.51.24',NULL,'11 rue urbain lefrancois','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'2470314211001',29.000000000,'1970-06-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3864,'MARC','ODILE','1951-03-23','02.85.19.57.92','06.87.99.22.62',NULL,'6 ALLEE DES TILLEULS','','','14800','TOUQUES',NULL,NULL,'1510314396001',2511.000000000,'1973-04-30','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3865,'BRIARD','DANIEL','1930-11-10','02.20.88.12.65','06.44.95.59.14',NULL,'3 RUE PROGRES SOCIAL','','','14150','OUISTREHAM',NULL,NULL,'1301154339001',391.000000000,'1958-08-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3866,'LAGNIEL','CHRISTIANE','1963-04-07','02.94.84.60.44','06.19.45.04.31',NULL,'6 RUE DE LITTRY','','','61160','OMMOY',NULL,NULL,'2630414257001',47.000000000,'1986-06-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3867,'OLIVIER','MARCEL','1939-07-15','02.12.57.48.06','06.86.86.74.38',NULL,'8 RUE JULES LOUIS RAME','','',NULL,NULL,NULL,NULL,'2390761139001',196.000000000,'1961-03-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3868,'LE LOSTEC','RENE','1960-01-12','02.28.56.86.10','06.64.77.10.95',NULL,'LES LANDES','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1600114251001',69.000000000,'1987-05-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3869,'HENRI','JACQUELINE','1939-06-25','02.80.32.70.88','06.10.65.98.27',NULL,'LA CHAPELLE GAUTHIER','','','14520','PORT EN BESSIN HUPPAIN',NULL,NULL,'1390614060001',21.000000000,'1963-11-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3870,'PAYSANT','PIERRE','1939-03-15','02.58.61.10.86','06.73.84.00.79',NULL,'la boulaye','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2390314712001',336.000000000,'1965-05-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3871,'BOURLIER','CLAUDE','1937-03-03','02.40.60.28.29','06.49.28.56.07',NULL,'1 RUE DU CHEMIN VERT','','','14270','MEZIDON CANON',NULL,NULL,'1370314682001',859.000000000,'1960-06-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3872,'VIAU','MAURICE','1951-09-24','02.18.86.66.24','06.11.91.86.88',NULL,'','','','14320','MAY SUR ORNE',NULL,NULL,'1510961249001',526.000000000,'1976-11-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3873,'LEROUGE','GINETTE','1940-07-10','02.63.87.64.54','06.45.90.98.46',NULL,'15 bis bvd r poincarre','','','14120','MONDEVILLE',NULL,NULL,'1400714026001',205.000000000,'1964-01-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3874,'MACE','FRANCOIS','1956-01-03','02.26.65.63.31','06.53.46.44.11',NULL,'13 RUE DE LA MER','','','14150','OUISTREHAM',NULL,NULL,'2560128105001',1283.000000000,'1985-01-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3875,'PROVOST','ROGER','1937-07-09','02.29.55.55.12','06.47.58.92.54',NULL,'909 QUARTIER DU  VAL','','','14260','AUNAY SUR ODON',NULL,NULL,'1370714291001',298.000000000,'1959-12-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3876,'MORICE','LOIC','1932-09-19','02.12.16.52.27','06.35.75.81.59',NULL,'56 ROUTE DU FRESNE','','','14120','MONDEVILLE',NULL,NULL,'1320961212001',879.000000000,'1954-05-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3877,'CYRILLE','MAUD','1930-11-04','02.77.53.16.68','06.11.23.15.49',NULL,'136 BOULEVARD RAYMOND POINCARE','','','50760','BARFLEUR',NULL,NULL,'1301114090001',20.000000000,'1953-11-23','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3878,'CHALOT','YVETTE','1931-01-27','02.12.23.11.64','06.80.82.54.73',NULL,'1 RUE ABBE BRUNNIN','','','14780','LION SUR MER',NULL,NULL,'2310114690001',191.000000000,'1954-12-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3879,'LAISNEY','KARINE','1931-04-11','02.45.11.55.87','00 33 6.88.68.79.02',NULL,'LA CROIX','','','14460','COLOMBELLES',NULL,NULL,'2310414643001',83.000000000,'1953-05-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3880,'SAINT-REQUIER','JACQUES','1932-06-06','02.19.46.70.77','06.80.62.89.21',NULL,'11 BD DE L ESPERANCE','','','14000','CAEN',NULL,NULL,'2320661181001',243.000000000,'1961-07-11','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3881,'FESTE','LILIANE','1962-12-17','02.21.44.57.15','06.62.84.09.56',NULL,'Tour de Balleroy Appt21','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2621214114001',28.000000000,'1984-05-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3882,'LEMONNIER','PIERRE','1968-04-12','02.24.81.07.18','06.17.03.10.91',NULL,'Hameau du Beffeux','','','14700','FALAISE',NULL,NULL,'1680476561001',77.000000000,'1998-01-20','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3883,'CHANTREUIL','ALAIN','1935-08-20','02.93.85.44.81','06.25.60.88.82',NULL,'20 rue auguste lechesne','','','14120','MONDEVILLE',NULL,NULL,'2350814309001',396.000000000,'1960-12-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3884,'POREY','BERNARD','1935-08-01','02.52.61.10.62','06.76.04.34.83',NULL,'','','','14000','CAEN',NULL,NULL,'2350814324001',47.000000000,'1965-11-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3885,'POEZEVARA','PAULETTE','1934-06-15','02.99.75.79.88','06.41.23.43.46',NULL,'HAMEAU DE COUPIGNY','','','14123','IFS',NULL,NULL,'2340614198001',356.000000000,'1956-11-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3886,'PHILIPPE','SOLANGE','1930-05-28','02.11.18.40.57','06.10.06.51.28',NULL,'396 CHEMIN DE LA PLAUBERIE','','','14120','MONDEVILLE',NULL,NULL,'1300514033001',1704.000000000,'1951-06-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3887,'LAUNAY','JACQUES','1934-09-13','02.43.64.07.25','06.19.68.64.16',NULL,'1 BD BELLEVUE','','','14220','THURY HARCOURT',NULL,NULL,'2340914158001',274.000000000,'1956-11-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3888,'COTTEBRUNE','BERNADETTE','1940-06-01','02.53.51.82.53','06.62.44.43.35',NULL,'24 RUE GENERAL LECLERC','','','14000','CAEN',NULL,NULL,'1400614327001',191.000000000,'1961-04-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3889,'DUPUY','YVONNE','1951-02-18','02.11.32.01.08','06.90.09.67.12',NULL,'15 DOMAINE DU VAUDON','','','14000','CAEN',NULL,NULL,'1510214356001',19.000000000,'1981-06-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3890,'LEFEVRE','ALAIN','1932-08-09','02.44.93.87.59','06.81.75.04.75',NULL,'7 ALLEE DE VIENNE','','','14000','CAEN',NULL,NULL,'1320814181001',257.000000000,'1957-03-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3891,'FIANT','YVON','1938-10-15','02.12.39.95.16','06.11.19.98.56',NULL,'75 rue d''auge','','','14000','CAEN',NULL,NULL,'1381014120001',0.000000000,'1960-09-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3892,'GAUTIER','GISELE','1935-09-23','02.74.47.73.44',NULL,NULL,'10 RUE DE LA VERDIERE','','','14120','MONDEVILLE',NULL,NULL,'2350950482001',693.000000000,'1963-04-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3893,'RAQUILLET','GILBERT','1932-08-26','02.92.74.27.41',NULL,NULL,'1 rue du clos raiven','','','14100','LISIEUX',NULL,NULL,'2320850358001',1937.000000000,'1954-09-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3894,'BUQUET','FERNAND','1951-02-21','02.27.35.02.25','06.97.71.89.98',NULL,'10 rue de la Libration','','','14740','ST MANVIEU NORREY',NULL,NULL,'2510214263001',1015.000000000,'1979-12-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3895,'TEGADZE','DANIELLE','1931-06-13','02.34.53.82.40','06.78.34.18.81',NULL,'3 place du jura','','','14000','CAEN',NULL,NULL,'2310602543001',1843.000000000,'1952-06-02','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3896,'BESSELIEVRE','Gisele','1931-12-24','02.22.39.69.14','06.56.66.37.27',NULL,'1 RESIDANCE MEROUVELLE','','','14000','CAEN',NULL,NULL,'1311214321001',34.000000000,'1953-12-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3897,'FOUILLET','MONIQUE','1934-12-07','02.68.16.18.28','06.19.51.47.30',NULL,'LA CORBETIERE','','','14240','CAUMONT L''EVENTE',NULL,NULL,'2341214640001',171.000000000,'1957-07-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3898,'LORILLU','MICHEL','1933-09-28','02.46.69.18.03','06.77.58.83.73',NULL,'85 RUE DE FALAISE','','','14210','AMAYE SUR ORNE',NULL,NULL,'1330950017001',33.000000000,'1959-11-21','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3899,'SOUPLY','MARIE THERESE','1948-04-06','02.10.94.04.87','06.12.04.49.48',NULL,'85 RUE DE FALAISE','','','14320','FONTENAY LE MARMION',NULL,NULL,'2480414163001',220.000000000,'1971-03-07','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3900,'LEMARCHAND','LUCIEN','1929-04-02','02.26.59.55.83','06.12.79.70.49',NULL,'13 rue du sieur de bras','','','14350','STE MARIE LAUMONT',NULL,NULL,'1290414670001',1061.000000000,'1952-07-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3901,'SANSON','hubert','1929-12-04','02.65.48.48.91','06.41.94.40.35',NULL,'21 RUE JEAN PHILIPPE RAMEAU','','','14920','MATHIEU',NULL,NULL,'2291250556001',24.000000000,'1951-09-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3902,'DUBOIS','YVETTE','1955-03-17','02.56.93.48.41','06.86.11.86.44',NULL,'11 PLACE DES COSMONAUTES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1550314482001',71.000000000,'1984-11-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3903,'NORGEOT','fabien','1932-11-09','02.19.90.53.79','06.11.80.75.98',NULL,'30 bis rue du milieu','','','14540','SOLIERS',NULL,NULL,'1321161267001',113.000000000,'1958-12-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3904,'ANGOT','ANNE MARIE','1940-12-05','02.38.27.82.10','06.21.53.57.75',NULL,'30 RUE LA BAILLEE','','','14370','AIRAN',NULL,NULL,'2401214118001',39.000000000,'1962-08-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3905,'SPECHT','NICOLE','1932-06-12','02.78.48.30.11','00 33 6.56.87.22.92',NULL,'LA VALLEE','','','14000','CAEN',NULL,NULL,'1320661297001',678.000000000,'1962-06-05','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3906,'BOURREAU','DANIEL','1929-08-26','02.30.86.02.67','06.30.79.36.05',NULL,'1 rue du Jardin Cleri','','','50460','URVILLE NACQUEVILLE',NULL,NULL,'2290849211001',277.000000000,'1951-07-20','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3907,'SOUCHON','alain','1939-03-04','02.50.68.88.49','06.53.48.23.84',NULL,'12 rue d esglandes','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1390314623001',14.000000000,'1969-03-08','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3908,'STEPHAN','HERVE','1964-01-26','02.76.13.11.12','06.65.70.59.73',NULL,'LA COUR D''O','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'2640161293001',24.000000000,'1991-05-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3909,'RINGUENET','ANDRE',NULL,'02.95.24.81.19','06.61.62.84.33',NULL,'HAMEAU RUPIERRE','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'2381014294001',46.000000000,'2008-12-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3910,'LECONTE','ROGER','1929-11-06','02.24.47.43.25','06.10.12.63.95',NULL,'PTITES SOEURS DES PAUVRES  7 RUE',' PORT MILLET','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2291114740001',2641.000000000,'1956-10-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3911,'DEMORGE','GILBERTE','1929-03-22','02.13.38.12.56','06.15.86.35.51',NULL,'LOTISSEMENT DU CHAMPS DE FOIRE','','','14320','MAY SUR ORNE',NULL,NULL,'2290361376001',28.000000000,'1952-02-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3912,'GDOWSKI','','1929-10-04','02.10.50.69.34','06.60.00.27.42',NULL,'9 rue des mares de l''horloge','','','14860','RANVILLE',NULL,NULL,'2291060142001',111.000000000,'1954-05-30','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3913,'LEBLANC','PATRICIA','1943-01-06','02.10.13.52.63','06.10.67.74.75',NULL,'103 bvd du gd parc','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2430161194001',854.000000000,'1972-03-12','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3914,'GANCEL','MARIE THERESE','1941-01-13','02.57.99.86.43','06.71.45.21.53',NULL,'1 rue des Peupliers','','','50410','PERCY',NULL,NULL,'2410114635001',521.000000000,'1964-10-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3915,'LEROY','JANINE','1929-03-02','02.91.77.32.71','06.97.41.68.97',NULL,'18 RUE ST MARTIN','','','14120','MONDEVILLE',NULL,NULL,'2290350474001',73.000000000,'1956-01-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3916,'MAUDUIT','GUY','1929-08-27','02.48.19.33.31','06.89.90.35.28',NULL,'LE BOIS THOUROUDE','','','14310','VILLERS BOCAGE',NULL,NULL,'1290814180001',595.000000000,'1959-09-26','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3917,'POGU','JEANNE','1946-03-14','02.54.58.90.86','06.10.83.79.08',NULL,'21 RUE DES COTEAUX','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1460314241001',13.000000000,'1975-02-22','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3918,'ANCELLIN','GERARD','1929-09-06','02.57.44.20.46','06.53.30.48.58',NULL,'13 IMP DES CYCLAMENS','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1290961287001',96.000000000,'1955-08-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3919,'DUMONT','HENRIETTE','1962-03-24','02.98.43.33.49','06.76.74.76.87',NULL,'10 RUE DES ERABLES','','','50180','AGNEAUX',NULL,NULL,'2620314556001',30.000000000,'1984-07-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3920,'HOUSSIN','JACQUES','1957-04-16','02.18.31.57.56','06.96.95.65.42',NULL,'FOYER DES ACACIAS','','','14123','IFS',NULL,NULL,'2570414008001',417.000000000,'1982-05-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3921,'CHEVALIER','BERNADETTE','1939-10-26','02.20.23.09.09','06.33.27.89.95',NULL,'33 ROUTE D''AUNAY','','','14123','IFS',NULL,NULL,'2391035360001',35.000000000,'1963-04-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3922,'QUESNEE','LUCETTE','1926-05-19','02.53.46.83.45','06.53.00.49.69',NULL,'5.AVENUE LEONARD GILLES','','','14150','OUISTREHAM',NULL,NULL,'1260563091001',44.000000000,'1955-09-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3923,'SEKOWSKI','BERNADETTE','1940-10-18','02.60.45.71.00','06.99.76.28.41',NULL,'60 AVENUE GENERAL LECLERC','','','14860','AMFREVILLE',NULL,NULL,'1401014383001',17.000000000,'1963-08-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3924,'WITTWER','JACQUELINE','1936-08-15','02.57.25.88.05','06.28.69.20.97',NULL,'','','','14930','VIEUX',NULL,NULL,'2360814467001',64.000000000,'1957-11-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3925,'SABINE','MYLENE','1961-03-05','02.34.01.79.98','06.87.91.88.40',NULL,'9.4 CITE DES ROCHES','','','14230','ISIGNY SUR MER',NULL,NULL,'2610378419001',132.000000000,'1984-12-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3926,'GALOPIN','DANIEL','1933-05-07','02.11.24.01.79','06.46.12.61.78',NULL,'1 IMPASSE DE CUSSY','','','14670','TROARN',NULL,NULL,'1330561237001',1075.000000000,'1955-05-15','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3927,'LEFEVRE','ELIANE','1930-12-26','02.65.17.47.46','06.51.56.11.53',NULL,'9 RUE DES PETITES CHASSES','','','14000','CAEN',NULL,NULL,'1301214040001',1010.000000000,'1953-07-26','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3928,'CHOPIN','JACQUELINE','1933-09-11','02.74.55.73.31',NULL,NULL,'15 RUE VICTOR HUGO','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1330914332001',76.000000000,'1963-04-05','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3929,'COTTINEAU','CAROLE','1967-04-23','02.68.86.94.72','06.91.42.39.68',NULL,'2 RUE DES PRIMEVERES','','','14220','LES MOUTIERS EN CINGLAIS',NULL,NULL,'1670414537001',35.000000000,'1989-04-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3930,'PAISNEL','Louis','1958-01-21','02.84.37.74.91',NULL,NULL,'8 RESIDENCE DES MAUVIS','','','14120','MONDEVILLE',NULL,NULL,'2580114092001',28.000000000,'1981-06-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3931,'PIET','CHRISTIANE','1960-04-24','02.40.86.66.05','06.44.32.86.61',NULL,'1 PLACE DE LA MAISONNETTE','','','14460','COLOMBELLES',NULL,NULL,'2600414051001',6.000000000,'1990-08-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3932,'TILLARD','ODETTE','1962-07-27','02.10.06.96.69','06.12.27.34.99',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'2620714542001',84.000000000,'1987-05-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3933,'BERLAIMONT','pascal','1961-01-31','02.68.59.49.82','06.78.12.96.07',NULL,'36 RUE DU GENERAL LECLERC','','','50260','LE VALDECIE',NULL,NULL,'2610114221001',3525.000000000,'1989-08-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3934,'HARDY','JULES','1957-11-12','02.63.13.36.47','06.80.44.22.75',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1571199256001',843.000000000,'1985-03-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3935,'LEBAS','JANINE','1962-06-24','02.24.57.76.43','06.71.06.06.42',NULL,'ROUTE DE BAROU','','','14430','DOZULE',NULL,NULL,'1620614587001',164.000000000,'1985-08-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3936,'PECQUET','PIERRE','1935-07-04','02.86.30.38.90','06.10.73.88.30',NULL,'RTE DE BAROU','','','14730','GIBERVILLE',NULL,NULL,'2350714406001',164.000000000,'1956-05-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3937,'VIEL','RENE','1962-01-11','02.70.46.99.66','06.98.83.95.25',NULL,'CLOS BOUGRAN','','','14160','DIVES SUR MER',NULL,NULL,'1620114020001',27.000000000,'1984-11-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3938,'LOIROT','CLAUDE','1967-01-06','02.55.28.15.13','06.88.88.54.49',NULL,'9 RUE CAMILLE BLAISOT','','','14000','CAEN',NULL,NULL,'1670114762001',597.000000000,'1989-01-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3939,'CHASSERIEAU','GUY','1936-08-13','02.61.08.68.48','06.67.43.94.03',NULL,'1802 QUARTIER DU BOIS','','','14000','CAEN',NULL,NULL,'1360850150001',77.000000000,'1962-06-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3940,'ARMAND','MONIQUE','1930-10-28','02.12.05.36.31','06.75.82.55.26',NULL,'909 QUARTIER DU  VAL','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'2301014705001',221.000000000,'1959-12-08','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3941,'ROUSSEL','LOUISE','1937-05-26','02.28.95.90.60','06.67.74.69.59',NULL,'Les Lots','','','14320','MAY SUR ORNE',NULL,NULL,'2370514251001',29.000000000,'1961-12-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3942,' BRION','ROBERT','1954-02-02','02.11.99.80.77','06.48.92.09.05',NULL,'2 rue  paul vaillant couturier','','','14860','BAVENT',NULL,NULL,'1540261353001',189.000000000,'1976-11-12','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3943,'VAULTIER','SIMONE','1933-06-06','02.11.66.63.78','06.30.50.61.11',NULL,'5 pl jeanne d''arc','','','14270','MEZIDON CANON',NULL,NULL,'2330650463001',7.000000000,'1959-07-02','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3944,'LEMOIGNE','PATRICIA','1935-08-13','02.27.57.38.01','06.22.10.39.02',NULL,'23 rue du dr laennec','','','14000','CAEN',NULL,NULL,'1350814437001',3354.000000000,'1959-04-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3945,'SIMON','JACQUELINE','1946-01-30','02.72.75.43.95','06.13.90.69.17',NULL,'1 place de la republique','','','14250','AUDRIEU',NULL,NULL,'2460150173001',70.000000000,'1968-12-12','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3946,'MURZOT','JACKY','1928-06-13','02.14.01.95.09','06.36.64.20.39',NULL,'2 rue des fauvettes','','','14320','FONTENAY LE MARMION',NULL,NULL,'1280614338001',15.000000000,'1950-01-14','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3947,'LE GARREC','ANDRE','1930-08-27','02.36.55.86.88','06.66.54.42.22',NULL,'96 AVENUE DE ROUEN','','','14120','MONDEVILLE',NULL,NULL,'2300855505001',36.000000000,'1955-01-02','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3948,'JOURDAIN','ISABELLE','1930-03-20','02.30.80.19.99','06.43.16.62.17',NULL,'23 RUE D''ARGENCES','','','14530','LUC SUR MER',NULL,NULL,'1300314512001',405.000000000,'1952-12-20','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3949,'CUDORGE','GENEVIEVE','1937-06-15','02.46.15.01.36','06.55.10.81.48',NULL,'17 quai de la londe','','','14370','BILLY',NULL,NULL,'1370614311001',675.000000000,'1967-09-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3950,'GASTEBOIS','FERNAND','1969-07-06','02.90.79.25.41','06.45.38.84.37',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1690714109001',90.000000000,'1993-01-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3951,'COTELLE','SYLVIE','1945-01-23','02.11.29.94.79','06.95.48.96.02',NULL,'FERME DE LA FERTE','','','14540','ROCQUANCOURT',NULL,NULL,'2450114157001',117.000000000,'1973-11-17','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3952,'LEBEL','CHRISTIANE','1929-01-21','02.49.69.27.32','06.21.21.83.70',NULL,'4 rue du val herel','','','14730','GIBERVILLE',NULL,NULL,'2290114663001',1442.000000000,'1959-12-26','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3953,'THOMASSE','lionel','1956-07-08','02.77.70.66.66','06.40.34.26.88',NULL,'2 RUE SAINT VINCENT DE PAUL','','','14120','MONDEVILLE',NULL,NULL,'1560714197001',22.000000000,'1986-09-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3954,'DORNIOL','HYACINTHE','1934-07-10','02.34.38.09.93','06.88.45.32.79',NULL,'8 RUE JEAN JAURES','','','14150','OUISTREHAM',NULL,NULL,'2340714363001',207.000000000,'1962-04-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3955,'PLAINE','JEANNINE','1939-08-01','02.39.78.42.54','06.14.39.71.08',NULL,'3 ROUTE DE VARAVILLE','','','14123','IFS',NULL,NULL,'2390872256001',171.000000000,'1964-12-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3956,'COULANGE','Hubert','1932-11-22','02.33.84.82.75','06.63.73.86.01',NULL,'1 rue du canada','','','14270','MEZIDON CANON',NULL,NULL,'1321114712001',817.000000000,'1960-05-01','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3957,'JEANNE','GILBERT','1953-01-17','02.38.50.79.10','06.46.01.61.45',NULL,'24 RUE DES MARCHES','','','14000','CAEN',NULL,NULL,'1530150559001',46.000000000,'1975-10-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3958,'LETELLIER','JEANNINE','1934-09-16','02.80.99.48.88','06.55.59.82.68',NULL,'15 RUE ROGER DUPONT','','','14400','BAYEUX',NULL,NULL,'2340927035001',2.000000000,'1957-11-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3959,'DELAMARE','ANDRE','1953-02-18','02.44.84.97.76','06.55.50.38.66',NULL,'25 BD DE RETHEL','','','14000','CAEN',NULL,NULL,'1530214568001',7.000000000,'1978-07-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3960,'FLEURY','RAYMOND','1940-03-12','02.11.76.17.49','06.82.47.12.45',NULL,'6 RUE DE LA DIVES','','','14730','GIBERVILLE',NULL,NULL,'1400314672001',874.000000000,'1961-08-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3961,'ROZIER','DENISE','1933-02-19','02.13.14.39.28','06.88.79.07.27',NULL,'23 RUE DES MARES','','','14370','CROISSANVILLE',NULL,NULL,'1330250529001',1199.000000000,'1963-03-09','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3962,'BRUGGEMAN','claude','1959-06-17','02.79.27.09.93','06.90.42.95.13',NULL,'6 RUE DU JURA','','','50140','ROMAGNY',NULL,NULL,'1590650635001',486.000000000,'1985-09-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3963,'TRIGER','Martine','1949-04-17','02.88.47.11.06','06.24.15.10.06',NULL,'23 BD GAL VANIER','','','14740','ST MANVIEU NORREY',NULL,NULL,'1490414526001',201.000000000,'1974-06-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3964,'GUILLOUET','HUGUETTE','1932-08-19','02.89.12.32.99','06.78.43.82.23',NULL,'37 RUE D AUVERGNE','','','14000','CAEN',NULL,NULL,'1320850509001',98.000000000,'1957-06-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3965,'RAYMOND','Gerard','1930-12-06','02.10.96.18.51','06.19.10.40.60',NULL,'18 avenue de versaille','','','14710','LOUVIERES',NULL,NULL,'1301214163001',1410.000000000,'1960-11-03','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3966,'HERBLINE','Helene','1930-06-28','02.52.41.47.88','06.11.97.22.23',NULL,'96 RUE DU PRESIDENT WILLSON','','','14000','CAEN',NULL,NULL,'1300650546001',103.000000000,'1953-05-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3967,'BERTIN','charles','1938-06-02','02.97.23.53.60','06.47.74.15.44',NULL,'maison de retraite normandie','','','14000','CAEN',NULL,NULL,'2380614246001',26.000000000,'1962-06-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3968,'CHAMARET','JEAN','1928-07-21','02.20.31.08.12','06.60.57.89.54',NULL,'12 RUE ALBERT BAYET','','','14120','MONDEVILLE',NULL,NULL,'2280761352001',100.000000000,'1950-03-31','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3969,'DELASALLE','GINETTE','1933-10-28','02.82.08.10.34','06.82.75.29.09',NULL,'17 RUE DE LA VIGNE A LA DAME','','','14470','COURSEULLES SUR MER',NULL,NULL,'1331014137001',758.000000000,'1961-06-20','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3970,'','PASCAL',NULL,'02.27.36.30.41','06.70.58.21.52',NULL,'61 rue pasteur','','','14260','AUNAY SUR ODON',NULL,NULL,'1280414164001',192.000000000,'2009-08-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3971,'GUESNE','EDITH','1934-12-29','02.10.71.28.45','06.29.49.11.23',NULL,'35 RUE DE CREMEL','','','14123','IFS',NULL,NULL,'2341250371001',2696.000000000,'1963-08-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3972,'KOWARSKY','YVAN','1935-05-28','02.70.71.86.93','06.65.07.93.20',NULL,'LE BOURG','','','50760','STE GENEVIEVE',NULL,NULL,'1350514345001',148.000000000,'1960-03-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3973,'GROUD','CHRISTOPHE','1932-02-18','02.84.13.12.42','06.30.26.35.88',NULL,'10 PLACE DE LA DEMI LUNE','','','61120','VIMOUTIERS',NULL,NULL,'1320214191001',4146.000000000,'1953-09-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3974,'LATOUR','CHRISTOPHE','1929-04-20','02.60.18.25.91','06.55.78.72.41',NULL,'57 RUE D''HARMONVILLE','','','14630','FRENOUVILLE',NULL,NULL,'2290414116001',62.000000000,'1958-03-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3975,'DELAVAUX','THIERRY','1932-08-09','02.11.83.99.41','06.68.26.44.71',NULL,'9 RUE DE LA RENAISSANCE','','','14650','CARPIQUET',NULL,NULL,'2320814294001',76.000000000,'1953-04-07','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3976,'VICTOIRE','JEAN','1947-07-04','02.57.82.86.87','06.84.39.62.12',NULL,'1 RUE DES ECOLES','','','14000','CAEN',NULL,NULL,'1470761313001',275.000000000,'1974-01-22','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3977,'JOLIVET','ERNESTINE',NULL,'02.12.33.24.67','06.64.09.05.96',NULL,'PERCY EN AUGE','','','14120','MONDEVILLE',NULL,NULL,'1320914712001',41.000000000,'2008-10-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3978,'LEFEVRE','Alain','1928-02-02','02.93.08.86.08','06.96.19.04.00',NULL,'6 RUE JEAN FRANCOIS LEMANISSIER','','','14000','CAEN',NULL,NULL,'1280214059001',399.000000000,'1950-03-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3979,'GUILBERT','NOEL','1931-03-20','02.80.29.59.38','06.41.81.61.06',NULL,'residence des personnes agees','','','14220','MARTAINVILLE',NULL,NULL,'1310314111001',156.000000000,'1952-06-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3980,'PHILIPPE','MONIQUE','1931-07-26','02.24.23.78.47','06.81.62.47.79',NULL,'11 RUE D AUBUSSON','','','14120','MONDEVILLE',NULL,NULL,'2310714526001',127.000000000,'1952-03-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3981,'LEMONNIER','GEORGES','1932-12-03','02.61.08.39.33','06.81.71.51.49',NULL,'26 RUE DANIEL DANJON','','','61430','CAHAN',NULL,NULL,'2321250580001',158.000000000,'1961-04-30','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3982,'BOUCHER','RAYMONDE','1965-05-18','02.80.45.18.47','06.13.87.13.15',NULL,'LA PARENTERIE','','','14670','JANVILLE',NULL,NULL,'2650514546001',920.000000000,'1995-09-01','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3983,'VANDERMEERSCH','PASCALE','1931-05-26','02.43.27.66.12','06.35.24.17.75',NULL,'LE HAUT DE SAINT BENIN','','','14310','EPINAY SUR ODON',NULL,NULL,'2310550111001',827.000000000,'1956-01-12','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3984,'BRETON MIESES','ELIANE','1928-06-15','02.57.11.45.47','06.27.09.85.30',NULL,'58 RUE DES ROSIERS','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1280629050001',159.000000000,'1958-05-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3985,'BERTRAND','FERNANDE','1939-03-29','02.21.16.15.98','06.90.70.33.28',NULL,'22 RUE DE LA MARE','','','14000','CAEN',NULL,NULL,'1390361252001',88.000000000,'1961-08-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3986,'DESVAGES','JACQUELINE','1932-03-10',NULL,NULL,NULL,'11/22 RUE D''EPRON','','','14000','CAEN',NULL,NULL,'2320314738001',83.000000000,'1962-07-17','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3987,'BATON','CHRISTINE','1944-06-06','02.24.23.84.53','06.65.63.92.30',NULL,'15 RUE DES COTTAGES','','','14000','CAEN',NULL,NULL,'2440661478001',127.000000000,'1974-07-26','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3988,'TILLARD','MICHEL','1939-09-03','02.26.15.26.47','06.66.67.00.26',NULL,'272 RUE DU VIEU PAITISSE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1390927028001',105.000000000,'1966-01-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3989,'SERANDOUR','MARIE YVONNE','1934-12-21','02.10.48.08.40','06.83.42.81.57',NULL,'24 alle des peupliers','','','61000','ALENCON',NULL,NULL,'2341214409001',32.000000000,'1964-08-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3990,'TURQUET','AUGUSTIN','1953-01-12','02.83.76.57.56','06.33.49.99.23',NULL,'41 RUE DES DRAKKARS','','','14670','TROARN',NULL,NULL,'2530150388001',2613.000000000,'1975-01-12','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3991,'GERVAIS','SIMONE','1931-08-29','02.86.47.64.65','06.40.29.98.51',NULL,'20 RUE DE L EGLISE','','','14980','ROTS',NULL,NULL,'1310850492001',794.000000000,'1953-07-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3992,'BOURDAIS','ROGER','1932-06-24','02.11.43.97.28','06.28.90.45.29',NULL,'47 RUE DU POINT DE VU','','','14480','TIERCEVILLE',NULL,NULL,'1320614136001',74.000000000,'1955-09-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3993,'CALBRY','FRANCIS',NULL,'02.52.44.78.41','06.63.25.97.16',NULL,'6 RUE DE LA LIBERTE','','','14000','CAEN',NULL,NULL,'2370261414001',208.000000000,'2009-10-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3994,'BOULEY','MARIE PIERRE','1945-06-16','02.20.37.55.75','06.25.47.26.65',NULL,'RES FOYER LOGEMENT LES ROUGES GO','RGES APPT 62 14 RUE JACQUES PREV','ERT','14980','ROTS',NULL,NULL,'1450614682001',44.000000000,'1974-01-05','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3995,'PASQUIER','CHRYSTELLE','1932-05-21','02.65.48.78.09','06.19.75.01.67',NULL,'12 route du haras','','','14260','JURQUES',NULL,NULL,'2320514045001',1866.000000000,'1957-12-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3996,'LETOURNEUR','DOMINIQUE','1934-09-13','02.40.74.93.60',NULL,NULL,'59 avenue pierre laurent','','','14190','FIERVILLE BRAY',NULL,NULL,'2340914246001',125.000000000,'1955-12-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3997,'HEMERY','PHILIPPE','1938-12-17','02.55.74.26.67',NULL,NULL,'86 avenue de rouen','','','14210','CHEUX',NULL,NULL,'2381261355001',779.000000000,'1962-09-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3998,'MONSALLIER','CLAUDE','1942-01-22','02.11.13.50.79','06.10.95.16.59',NULL,'10 impasse lemeray','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1420114144001',48.000000000,'1965-09-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (3999,'ARNOULT','DOMINIQUE','1967-02-05','02.39.20.11.14','06.91.37.90.51',NULL,'17 RUE PASTEUR MARTIN LUTHER KIN','G','','14000','CAEN',NULL,NULL,'2670214596001',202.000000000,'1988-10-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4000,'MARTEL','ALAIN',NULL,'02.54.30.60.66','06.53.13.63.72',NULL,'9 RUE JACQUES PREVERT','','','14000','CAEN',NULL,NULL,'1310714271001',31.000000000,'2012-10-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4001,'WALTER','LUCIENNE',NULL,'02.43.54.88.56','06.35.22.67.50',NULL,'214 rue d''auge','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1660214675001',43.000000000,'2010-04-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4002,'JANSON','JEAN','1948-02-10','02.16.92.45.47','06.11.12.71.99',NULL,'LA VILLETTE','','','14370','BELLENGREVILLE',NULL,NULL,'1480261089001',1405.000000000,'1973-05-19','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4003,'LEBAUDY','DANIEL','1955-11-29','02.34.51.22.85','06.20.02.27.56',NULL,'18 RUE ALBERT 1ER','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1551114276001',27.000000000,'1980-05-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4004,'CAIRON','MICHEL',NULL,'02.76.85.83.52','06.75.01.83.69',NULL,'res du parc','','','14600','GENNEVILLE',NULL,NULL,'1291014556001',514.000000000,'2009-04-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4005,'ZEMMOURI','SYLVIE',NULL,'02.10.80.27.15','06.80.14.32.81',NULL,'6 allee des vignons','','','14120','MONDEVILLE',NULL,NULL,'2380514583001',182.000000000,'2012-06-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4006,'BOUILLON','GILBERT','1936-10-31','02.10.15.11.18','06.49.99.67.08',NULL,'1 rue sieur du vivier ST ROMPHA','IRE','','14000','CAEN',NULL,NULL,'1361014390001',7.000000000,'1959-06-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4007,'CAUCHON','Marie madeleine','1929-10-09','02.72.72.84.69','06.23.07.33.32',NULL,'68 RUE DE LA SEINE','','','14123','IFS',NULL,NULL,'1291014556001',32.000000000,'1955-08-24','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4008,'LEGAILLARD','MICHEL','1930-01-16','02.10.01.18.01','06.52.98.40.24',NULL,'16 RESIDENCE DES POMMIERS','','','14000','CAEN',NULL,NULL,'1300114062001',185.000000000,'1956-08-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4009,'GENEVIEVE','ANDREE','1930-01-17','02.90.26.32.00','06.19.86.12.91',NULL,'8 rue georges  bandzwolek','','','50760','REVILLE',NULL,NULL,'1300114062001',1233.000000000,'1960-11-24','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4010,'FLAUSS','MIREILLE','1937-04-22','02.69.27.64.33','06.53.27.05.61',NULL,'52 RUE DE LA FOURNIERE','','','14460','COLOMBELLES',NULL,NULL,'2370414195001',149.000000000,'1967-10-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4011,'DAUMESNIL','CORINNE','1965-02-04','02.39.52.39.54','06.53.13.61.68',NULL,'25 rue henri baptiste','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1650214208001',456.000000000,'1988-06-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4012,'PACCINI','THERESE','1932-06-09','02.72.98.54.45','06.75.80.16.75',NULL,'3 IMPASSE DES ALPES','','','50310','LESTRE',NULL,NULL,'2320614351001',1180.000000000,'1955-09-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4013,'FERAY','ANDRE','1937-12-03','02.11.17.33.29','06.66.65.59.58',NULL,'14 impasse des tournesols','','','14000','CAEN',NULL,NULL,'1371214335001',10.000000000,'1966-07-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4014,'LEGRAND','Gilles','1938-05-28','02.78.22.26.90','06.48.58.23.44',NULL,'3bv de reutel','','','50200','MONTHUCHON',NULL,NULL,'1380527179001',110.000000000,'1962-05-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4015,'RAULT','JEAN PIERRE','1936-08-14','02.73.60.01.12','06.40.88.35.12',NULL,'16 rue henri cheron','','','14000','CAEN',NULL,NULL,'1360814328001',1047.000000000,'1962-06-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4016,'GODIN','MONIQUE','1936-03-10','02.40.43.82.20','06.90.00.03.72',NULL,'4 RUE DES BUISSONS','','','50880','PONT HEBERT',NULL,NULL,'1360314516001',12.000000000,'1958-12-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4017,'DELALANDE','PIERRE-JACQUES','1928-10-27','02.39.68.01.73','06.41.26.63.14',NULL,'13 rue e vaillant','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2281076343001',39.000000000,'1955-09-21','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4018,'SURIRAY','COLETTE','1957-07-17','02.87.29.75.89','06.92.59.84.97',NULL,'RUE DES FRERES CHAPPE','','','14000','CAEN',NULL,NULL,'1570778571001',239.000000000,'1984-08-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4019,'PIOFFET','ROGER','1940-05-18','02.45.02.90.78','06.10.06.19.00',NULL,'1 place de la liberte appt 14','','','61140','BAGNOLES DE L''ORNE',NULL,NULL,'2400514137001',41.000000000,'1967-06-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4020,'MADELAINE','Nicole','1943-03-23','02.69.30.20.63','06.11.66.55.08',NULL,'4 RUE DES VAUDES','','','14700','VERSAINVILLE',NULL,NULL,'2430314200001',278.000000000,'1964-08-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4021,'CASTILLE','RENE','1933-02-02','02.14.91.88.84','06.18.24.82.40',NULL,'24 RUE DES LILAS','','','14740','ROSEL',NULL,NULL,'1330261466001',32.000000000,'1956-07-16','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4022,'DUVELLEROY','EUGENE','1956-05-10','02.49.96.92.57','06.22.24.44.84',NULL,'4 RUE JUNO','','','50880','PONT HEBERT',NULL,NULL,'1560561208001',58.000000000,'1980-01-31','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4023,'MARIE','CLAUDINE',NULL,'02.80.17.79.91','06.12.33.57.44',NULL,'14 RUE DU CLOS DE BAS','','','14210','NOYERS BOCAGE',NULL,NULL,'1650314423001',103.000000000,'2009-03-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4024,'FRANCOIS','LUCIEN','1946-03-08','02.47.54.63.81','06.60.17.49.12',NULL,'9 rue pasteur','','','14670','ST PIERRE DU JONQUET',NULL,NULL,'1460314003001',71.000000000,'1969-11-21','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4025,'NICOLLE','ROBERT','1931-02-09','02.10.88.59.47','06.36.77.86.20',NULL,'CHEMIN DU CHAMP BRETON','','','14000','CAEN',NULL,NULL,'1310214100001',2613.000000000,'1952-05-20','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4026,'NEEL','JEANNE','1937-10-26','02.66.33.11.19','06.43.17.60.50',NULL,'10 RUE DU BICENTENAIRE','','','27260','ST PIERRE DE CORMEILLES',NULL,NULL,'2371014137001',394.000000000,'1958-09-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4027,'GASNIER','BENOIST','1929-05-29','02.59.26.89.91','06.78.19.38.98',NULL,'7 RUE DE L''EGLISE','','','14111','LOUVIGNY',NULL,NULL,'2290514046001',38.000000000,'1950-09-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4028,'MARIE','CHRISTIANE','1932-11-06','02.11.13.00.22','06.97.89.15.30',NULL,'11 RUE DU PARC','','','14000','CAEN',NULL,NULL,'2321114747001',394.000000000,'1953-07-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4029,'VAUGEOIS','MAURICE','1967-02-04','02.14.39.68.93','06.52.77.63.10',NULL,'17 rue des douits','','','14370','ARGENCES',NULL,NULL,'2670299314001',1253.000000000,'1995-05-01','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4030,'JEANNE','RENEE','1928-12-01','02.83.78.39.96','06.10.37.00.43',NULL,'6 rue jacque brel','','','14460','COLOMBELLES',NULL,NULL,'1281214470001',1216.000000000,'1950-03-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4031,'BAGOT','FRANCOISE','1935-10-23','02.66.89.37.19','06.10.79.87.98',NULL,'23 rue  de la cle des champs','','','61300','L''AIGLE',NULL,NULL,'2351014452001',2242.000000000,'1957-09-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4032,'CORDON','MICHEL','1930-05-22','02.60.90.53.71','06.76.85.47.76',NULL,'11 impasse des quatre vents','','','14000','CAEN',NULL,NULL,'2300514450001',81.000000000,'1955-01-25','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4033,'LEGEARD','BERNADETTE','1939-05-15','02.90.76.72.23','06.51.61.07.07',NULL,'13 rue alfred harel','','','27120','JOUY SUR EURE',NULL,NULL,'1390580814001',30.000000000,'1963-07-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4034,'DROULIN','GEORGETTE','1929-07-22','02.12.52.35.72','06.10.34.06.41',NULL,'17 residence des mauvis','','','61160','TOURNAI SUR DIVE',NULL,NULL,'2290714444001',70.000000000,'1951-01-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4035,'DUDOUET','DENIS','1940-12-04','02.10.64.28.17','06.86.46.11.20',NULL,'30 avenue de la liberte','','','14000','CAEN',NULL,NULL,'1401214168001',268.000000000,'1962-04-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4036,'FEREY','THIERRY','1933-07-06','02.26.02.91.48','06.99.47.34.40',NULL,'8 RUE ALBERT BAYET','','','14000','CAEN',NULL,NULL,'1330761027001',83.000000000,'1954-05-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4037,'LEFEVRE','ROGER','1934-08-13','02.77.52.07.79','06.59.58.56.26',NULL,'35 rue de l''eolienne','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2340814659001',692.000000000,'1961-06-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4038,'VICTOR','JEAN','1936-03-29','02.36.89.95.56','06.79.16.37.64',NULL,'46 RUE DU MANOIR','','','14000','CAEN',NULL,NULL,'1360314516001',176.000000000,'1965-06-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4039,'LE CORRE','SIMONE','1983-05-20','02.68.29.85.84','06.26.21.21.58',NULL,'4 ALLEE DU SERPOLET','','','14620','MORTEAUX COULIBOEUF',NULL,NULL,'2830599242001',763.000000000,'2007-07-05','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4040,'ADELINE','GISELE','1932-09-15','02.44.69.51.22','06.20.03.26.23',NULL,'la poterie','','','14380','MESNIL CLINCHAMPS',NULL,NULL,'1320914100001',124.000000000,'1957-11-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4041,'FOURNIER','ANNICK','1955-06-24','02.54.97.24.98','06.94.95.61.57',NULL,'1 RUE DE LA FONTAINE','','','50100','CHERBOURG',NULL,NULL,'2550650575001',32.000000000,'1977-06-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4042,'PEZERIL','ALICE','1932-10-07','02.73.49.53.62','06.65.26.79.98',NULL,'19 rue de falaise','','','14880','HERMANVILLE SUR MER',NULL,NULL,'2321061474001',60.000000000,'1962-10-11','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4043,'GUILLOT','MICHEL','1929-10-24','02.31.25.94.05','06.61.51.45.23',NULL,'23 ROUTE DE CORMELLES','','','14190','FIERVILLE BRAY',NULL,NULL,'1291014665001',323.000000000,'1953-12-31','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4044,'LEPIONNIER','GINETTE','1935-07-07','02.14.64.75.49','06.52.29.22.57',NULL,'59 IMPASSE LES COUTURES','','','14480','CREULLY',NULL,NULL,'2350714637001',71.000000000,'1961-06-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4045,'DAVIGNON','GINETTE','1948-06-19','02.38.58.09.87','06.94.45.80.23',NULL,'cidex 10 les ecoles','','','14220','BARBERY',NULL,NULL,'1480661027001',418.000000000,'1970-10-19','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4046,'DUBOURG','COLETTE','1935-12-14','02.82.15.96.50','06.90.94.46.35',NULL,'cidex 10 les ecoles','','','14000','CAEN',NULL,NULL,'2351214193001',31.000000000,'1960-04-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4047,'MILOCHE','DANIEL','1939-04-02','02.15.50.12.07','06.25.47.16.65',NULL,'30 JARDIN DE COURSEULLES','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1390414488001',2588.000000000,'1960-05-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4048,'ANDRE','ANNICK','1937-12-25','02.11.08.88.28','06.26.45.72.57',NULL,'3 rue de la plaine','','','14190','CAUVICOURT',NULL,NULL,'1371214163001',3856.000000000,'1959-07-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4049,'ALVAREZ','CAROLE','1933-01-04','02.31.05.60.18','06.30.70.42.08',NULL,'11 RUE GEORGES BRASSENS','','','14420','POTIGNY',NULL,NULL,'2330114195001',1.000000000,'1961-08-04','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4050,'TANSKI','DANIEL','1937-12-16','03.11.96.57.33','06.50.66.98.01',NULL,'3 RUE DU DOCTEUR LALLIER','','','80430','BEAUCAMPS LE VIEUX',NULL,NULL,'2371214738001',368.000000000,'1967-12-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4051,'DURAND','JOEL',NULL,'02.46.82.15.34','06.26.46.27.32',NULL,'103 rue de la corderie','','','14540','SOLIERS',NULL,NULL,'1320544218001',10.000000000,'2008-04-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4052,'LETOUZE','Michel','1951-01-02','02.55.47.28.01','06.38.90.60.15',NULL,'7 RUE DU MAJEUR STYFFE','','','61200','ARGENTAN',NULL,NULL,'1510114078001',77.000000000,'1981-06-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4053,'MENOYOT','MONIQUE','1929-10-04','02.77.50.74.47',NULL,NULL,'104 RUE DE LA HEVE','','','14120','MONDEVILLE',NULL,NULL,'1291014665001',407.000000000,'1955-03-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4054,'TANQUEREL','BERNARD','1933-05-07','02.26.00.90.97','06.86.04.76.81',NULL,'347 AVENUE DES DUNES','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'1330514668001',72.000000000,'1958-04-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4055,'HELLO','ANDRE','1930-10-04','02.12.16.70.61','06.33.62.24.81',NULL,'HAMEAU FERTREL','','','14220','GRIMBOSQ',NULL,NULL,'1301037239001',268.000000000,'1952-02-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4056,'LELIEVRE','GERARD','1935-12-09','02.23.82.00.22','06.90.17.44.61',NULL,'60 av de paris','','','50740','CAROLLES',NULL,NULL,'1351214690001',822.000000000,'1962-01-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4057,'MICHEL','RAYMOND','1934-06-27','02.45.66.00.47','06.82.98.69.73',NULL,'18 RUE DE LA DIVES','','','14270','MEZIDON CANON',NULL,NULL,'2340614591001',31.000000000,'1959-03-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4058,'POCHET','RAYMOND','1952-04-16','02.28.25.41.07','06.29.38.51.08',NULL,'18 RUE DE CHAMPAGNE','','','14000','CAEN',NULL,NULL,'2520414257001',66.000000000,'1973-06-22','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4059,'AUBIN','YVONNE','1970-01-14','02.65.15.96.30','06.50.69.26.69',NULL,'19 rue j j rousseau','','','14123','IFS',NULL,NULL,'1700114020001',677.000000000,'1995-06-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4060,'CARRE','FRANCIS','1931-01-27','02.70.87.33.59','06.74.32.55.45',NULL,'2 RUE DE ROUEN','','','14120','MONDEVILLE',NULL,NULL,'2310117449001',5066.000000000,'1953-05-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4061,'THOMAS','NICOLE','1967-02-07','02.88.27.96.42','06.97.72.27.94',NULL,'3 RUE ALEXANDRE','','','14120','MONDEVILLE',NULL,NULL,'2670261016001',42.000000000,'1988-11-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4062,'FOLL','MARCEL','1958-02-17','02.30.53.64.96','06.18.10.11.06',NULL,'37 RUE PIERRE GRINGOIRE','','','14270','MEZIDON CANON',NULL,NULL,'2580214249001',130.000000000,'1986-12-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4063,'SOPHIE','Sophie','1963-02-01','02.47.13.40.12','06.56.86.90.15',NULL,'35 RUE DES CANADIENS','','','14000','CAEN',NULL,NULL,'1630214386001',1249.000000000,'1986-07-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4064,'DJIHIL','ALAIN','1963-05-11',NULL,NULL,NULL,'6 PLACE JEAN ROSTAND','','','14000','CAEN',NULL,NULL,'1630508480001',35.000000000,'1990-12-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4065,'TERRE','RENEE','1931-05-08','02.27.29.38.88','06.15.67.80.80',NULL,'9 RUE GANDHI','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1310572228001',416.000000000,'1954-06-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4066,'MARTIN','GABRIELLE','1932-05-01','02.10.81.09.59','06.98.57.29.92',NULL,'15 RUE DU MUGUET','','','14370','VIMONT',NULL,NULL,'1320514237001',384.000000000,'1959-05-24','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4067,'FLACHS','ODETTE','1953-08-27','02.73.62.74.19',NULL,NULL,'6 URE DES PEUPLIERS','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1530814103001',376.000000000,'1974-06-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4068,'NICCO','BERNARD','1931-04-21','02.45.49.95.25','06.67.41.51.62',NULL,'4 RUE DES CLEMATITES','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2310414556001',118.000000000,'1961-08-06','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4069,'LEGOUX','ALICE','1928-11-27','02.61.27.72.19','06.31.21.68.28',NULL,'5 RUE PASTEUR','','','61160','MONTABARD',NULL,NULL,'2281114407001',1259.000000000,'1952-12-20','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4070,'ROSE','SIMONE','1956-01-06','02.89.60.36.98','06.90.43.71.71',NULL,'CAP HORN 7 PLACE DE LA DEMI LUNE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1560114039001',1072.000000000,'1981-04-23','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4071,'GOURAND','FRANCOISE','1937-10-31','02.70.28.34.83','06.42.37.83.32',NULL,'6 RUE DES CAPUCINES','','','14310','VILLERS BOCAGE',NULL,NULL,'2371061399001',2543.000000000,'1964-10-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4072,'PARIS','JANINE',NULL,'02.47.46.33.97','06.61.38.20.57',NULL,'34 BIS AVENUE ALEXANDRE DELAVERG','NE','','14730','GIBERVILLE',NULL,NULL,'2370314068001',59.000000000,'2012-03-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4073,'LECHANGEUR','PATRICE','1935-12-17','02.10.38.33.91','06.71.45.27.10',NULL,'VILLAGE LE MERCERIE','','','50480','STE MARIE DU MONT',NULL,NULL,'2351214275001',37.000000000,'1961-05-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4074,'LEFRANCOIS','BOGUMIL','1930-11-30','02.22.78.42.91','06.48.50.03.95',NULL,'LE HAMEAU BERTHEAUME','','','61200','ARGENTAN',NULL,NULL,'1301161167001',367.000000000,'1955-07-24','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4075,'MESNIL','','1953-03-15','02.69.29.90.71','06.57.98.21.52',NULL,'1 RUE DU CHATEAU D''EAU','','','50120','EQUEURDREVILLE HAINNEVILLE',NULL,NULL,'2530314119001',198.000000000,'1976-08-19','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4076,'','BERNARD','1935-05-25','02.82.80.45.89','06.82.14.58.24',NULL,'le bourg','','','14860','BAVENT',NULL,NULL,'2350561071001',96.000000000,'1957-07-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4077,'FROMENT','CHRISTIAN','1943-09-21','02.44.45.60.13','06.75.91.87.77',NULL,'18 rue robert bothereau','','','14220','CULEY LE PATRY',NULL,NULL,'1430978397001',75.000000000,'1969-11-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4078,'LE MEULAIS','JANINE','1962-03-11','02.34.71.63.81','06.70.81.43.42',NULL,'13 RUE ALBERT CAMUS','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2620314305001',97.000000000,'1990-04-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4079,'PERRIN','THERESE','1947-02-24','02.36.08.74.86',NULL,NULL,'11 IMPASSE DE L''ORANGERAIE','','','14400','RYES',NULL,NULL,'1470214145001',14.000000000,'1975-05-27','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4080,'HERBINIERE','MADELEINE','1940-03-13','02.51.88.81.22','06.29.69.12.99',NULL,'61 BOULEVARD DE RETHEL','','','14000','CAEN',NULL,NULL,'2400361283001',511.000000000,'1965-07-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4081,'LAMOTTE','JEAN CLAUDE','1952-01-26','02.32.20.52.59','06.90.48.93.38',NULL,'44 rue de la marne','','','14320','FONTENAY LE MARMION',NULL,NULL,'2520114200001',332.000000000,'1975-12-28','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4082,'MATHIEU','MARIE JOSEPHE',NULL,'02.46.75.19.27','06.62.68.38.40',NULL,'','','','50740','CAROLLES',NULL,NULL,'1400176046001',112.000000000,'2013-04-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4083,'YONNET','ETIENNE','1930-08-14','02.59.03.33.54','06.51.18.45.96',NULL,'9 AVENUE DES COURLIS','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'2300814483001',95.000000000,'1959-07-15','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4084,'LECARDRONNEL','Ghislaine','1935-02-04','02.11.14.09.30','06.52.36.09.36',NULL,'33 rue des Ecordires','','','14000','CAEN',NULL,NULL,'1350277316001',0.000000000,'1957-02-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4085,'BOTTON','THIERRY','1930-05-31','02.16.66.11.74',NULL,NULL,'RESIDENCE LES JARDINS D''IFS 1874',' RUE DE BRETTEVILLE','','14730','GIBERVILLE',NULL,NULL,'1300550330001',2779.000000000,'1956-08-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4086,'HERBERT','EDITH','1935-02-26','02.48.85.94.37','06.36.99.83.84',NULL,'2 VENELLE DE L''EGLISE','','','14220','GRIMBOSQ',NULL,NULL,'1350261352001',24.000000000,'1957-01-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4087,'LE GOVIC','LUCIENNE','1934-12-11','02.10.15.04.60','06.29.59.28.88',NULL,'LIEU DIT QUAYNE','','','50110','TOURLAVILLE',NULL,NULL,'2341214493001',13.000000000,'1958-07-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4088,'LEQUEST','Xavier','1950-07-07','02.57.12.37.09','06.16.22.53.80',NULL,'LIEU DIT"LES LANDES"','','','14230','ST GERMAIN DU PERT',NULL,NULL,'2500761273001',179.000000000,'1974-11-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4089,'FOUET','EVELYNE','1936-12-29','02.29.51.10.78','06.22.35.42.76',NULL,'5 imp albert camus','','','14000','GIBERVILLE',NULL,NULL,'1361214103001',3307.000000000,'1960-03-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4090,'MASSON','RAYMOND','1931-10-12','02.67.46.42.86','06.77.82.76.14',NULL,'4 rue de stocholm','','','14000','CAEN',NULL,NULL,'1311014166001',35.000000000,'1960-06-20','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4091,'LEBASTARD','MARYVONNE','1931-10-13','02.45.13.51.04','06.49.91.43.83',NULL,'2 impasse reine mathilde','','','14370','CHICHEBOVILLE',NULL,NULL,'1311014166001',38.000000000,'1959-01-19','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4092,'GANCEL','PIERRE','1937-05-01','02.24.28.38.11','06.82.54.34.48',NULL,'161 rue d auge','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2370514157001',393.000000000,'1958-06-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4093,'AMELINE','GERARD','1932-08-14','02.13.65.39.34','06.75.54.31.96',NULL,'37 RUE FRANKLIN','','','14370','AIRAN',NULL,NULL,'2320850345001',10.000000000,'1956-06-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4094,'TRIBEHOU','MICHEL','1969-04-01','02.52.99.93.05','06.54.50.40.29',NULL,'1 rue d athene','','','14123','IFS',NULL,NULL,'2690414133001',1597.000000000,'1992-12-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4095,'AUBIN','GUY','1936-09-16','02.39.64.29.15','06.83.81.54.46',NULL,'29 RUE DE LA FOLIE','','','14370','ARGENCES',NULL,NULL,'1360950591001',1409.000000000,'1961-01-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4096,'LEMOIGNE','MARYVONNE','1952-06-09','02.20.17.53.77','06.38.89.65.82',NULL,'4 RUE DU PERRET','','','14220','THURY HARCOURT',NULL,NULL,'2520614683001',91.000000000,'1977-11-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4097,'AUFFRAY','MARIE LINE','1966-12-07','02.86.30.80.45','06.11.69.68.43',NULL,'3 RUE ST SERNIN','','','14790','GIBERVILLE',NULL,NULL,'2661214757001',999.000000000,'1991-02-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4098,'ROUAULT DE COLIGNY','JEAN-JACQU','1937-02-21','02.59.08.21.64','06.78.58.81.42',NULL,'12 rue de la pommerais','','','14000','CAEN',NULL,NULL,'1370250498001',97.000000000,'1958-05-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4099,'BARBANCHON','PATRICK','1981-12-06','02.75.64.81.53','06.63.97.98.37',NULL,'8 RUE DU CAPITAINE POINLANE','','','50390','ORGLANDES',NULL,NULL,'1811299255001',21.000000000,'2006-03-12','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4100,'DUHAMEL','JEANNE','1939-02-19','02.32.80.79.72','06.21.68.41.58',NULL,'4 PLACE KOENIG','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2390214099001',355.000000000,'1963-01-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4101,'BALINSKI','jeanne','1929-06-12','02.94.92.21.16','06.63.45.77.46',NULL,'LE DOMAINE','','','14530','LUC SUR MER',NULL,NULL,'1290614320001',43.000000000,'1951-08-18','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4102,'CHAPRON','BRUNO','1928-08-21','02.75.51.14.59','06.11.43.87.20',NULL,'hameau marcel voieno 4','','','14370','ARGENCES',NULL,NULL,'1280814409001',64.000000000,'1956-01-06','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4103,'MORISSET','MICHEL',NULL,'02.67.23.91.93','06.10.81.08.81',NULL,'5 RUE LEON JOUHAUX','','','14270','MEZIDON CANON',NULL,NULL,'1570150106001',409.000000000,'2008-10-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4104,'LEHONGRE','JACQUELINE','1937-06-16','02.13.43.56.38','06.10.40.12.66',NULL,'15 RUE PASTEUR','','','14123','IFS',NULL,NULL,'1370614204001',2141.000000000,'1958-03-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4105,'COULANGE','FRANCOISE','1935-10-09','02.54.10.88.76','06.86.08.08.03',NULL,'15 ALLEE DE LA FERME','','','14000','CAEN',NULL,NULL,'2351014162001',146.000000000,'1959-12-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4106,'LELIEVRE','ODETTE','1960-02-19','02.29.55.21.07','06.10.59.81.68',NULL,'22 RUE DES LILAS','','','14000','CAEN',NULL,NULL,'1600214390001',33.000000000,'1990-04-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4107,'DAIREAUX','JACKY','1913-12-02','02.79.22.91.97','06.16.89.27.41',NULL,'','','','14000','CAEN',NULL,NULL,'2131247038001',16.000000000,'1937-01-14','GOLD',24,1);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4108,'VILLETTE','jacky','1963-02-21','02.28.72.07.11','06.39.91.55.86',NULL,'4 RUE DES PRES HAYS','','','50340','LES PIEUX',NULL,NULL,'2630214408001',551.000000000,'1986-03-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4109,'LEMANCEL','JEANNE','1961-01-09','02.12.19.78.03','06.12.13.40.81',NULL,'12 RUE LION MEZIERES','','','14000','CAEN',NULL,NULL,'2610161222001',782.000000000,'1986-04-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4110,'LEFEVRE','DANIEL','1961-01-16','02.87.84.68.38','06.16.05.52.45',NULL,'1 RUE GUILBERT','','','14123','IFS',NULL,NULL,'2610161222001',276.000000000,'1982-09-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4111,'RENE','CHRISTIAN','1961-02-25','02.16.36.08.83','06.21.07.75.46',NULL,'3 impasse yvon henri','','','14680','GIBERVILLE',NULL,NULL,'2610214430001',23.000000000,'1987-04-30','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4112,'DUVAL','BERNARD','1957-01-17','02.49.36.22.31','06.11.06.70.41',NULL,'26 rue des vaudes','','','14400','BAYEUX',NULL,NULL,'1570150260001',41.000000000,'1979-01-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4113,'GAUTIER','MICHEL','1929-07-21','02.80.29.96.02','06.11.63.89.67',NULL,'la gueriniere appt 24 rue sully','','','14270','MEZIDON CANON',NULL,NULL,'2290714057001',58.000000000,'1951-11-02','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4114,'ALEXANDRE','YVONNE','1968-05-16','02.73.75.32.72','06.90.30.86.03',NULL,'LE VICEL','','','14420','POTIGNY',NULL,NULL,'2680593057001',387.000000000,'1998-10-20','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4115,'MERIEL','SOLANGE','1937-03-21','02.56.96.66.62','06.93.01.63.12',NULL,'10 RUE GEORGES BIZET','','','14120','GIBERVILLE',NULL,NULL,'2370327398001',233.000000000,'1967-09-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4116,'HELAINE','MARCEL','1933-04-30','02.19.65.04.54','06.68.12.74.42',NULL,'11 RUE DE L''EUROPE','','','50500','CARENTAN',NULL,NULL,'2330414078001',182.000000000,'1955-09-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4117,'CAUSIER','JACQUELINE','1937-04-26','02.77.79.00.98','06.11.66.22.92',NULL,'ROUTE DE LA BELLE EPINE','','','14000','CAEN',NULL,NULL,'1370414328001',353.000000000,'1963-01-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4118,'BRIERE','JACQUES','1929-02-16','02.66.40.87.14','06.49.99.29.60',NULL,'25 RUE ROYAL HAMPSHIRE REGIMENT','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2290214758001',4301.000000000,'1953-02-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4119,'MIKOLAJCZAK','RENE','1929-02-18','02.29.15.76.14','06.81.63.67.44',NULL,'l''acre','','','14170','GIBERVILLE',NULL,NULL,'2290214758001',51.000000000,'1954-09-08','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4120,'LEMIERE','JEANNINE','1931-03-20','02.56.73.92.96','06.58.64.60.79',NULL,'226 rue d auge','','','14390','CABOURG',NULL,NULL,'1310314025001',192.000000000,'1961-05-26','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4121,'GOSSELIN','DANIEL','1940-09-23','02.57.39.32.17','06.68.65.64.59',NULL,'LE CLOS DOGUET','','','14123','IFS',NULL,NULL,'1400972374001',396.000000000,'1962-03-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4122,'LEPELLETIER','MADELAINE','1940-09-09','02.20.33.25.24','06.70.66.37.72',NULL,'FOYER RESIDENCE   1 RUE DES ACAC','IAS','','14540','ROCQUANCOURT',NULL,NULL,'1400972374001',187.000000000,'1966-09-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4123,'CLOUET','Elise','1965-05-03','02.22.96.63.80','06.31.71.14.60',NULL,'LES PALLIERES','','','14210','AMAYE SUR ORNE',NULL,NULL,'2650514014001',1643.000000000,'1987-11-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4124,'RAULT','MARIE THERESE','1939-06-23','02.26.07.77.31','06.98.79.42.84',NULL,'3 PRET DE LA MOTTE','','','14730','GIBERVILLE',NULL,NULL,'2390614643001',48.000000000,'1966-01-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4125,'AUBIN','JACQUELINE','1938-03-08','02.32.27.24.14','06.19.65.17.74',NULL,'4 RUE DU SQUARE','','','14860','RANVILLE',NULL,NULL,'1380314719001',75.000000000,'1963-02-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4126,'TANQUEREL','GUY','1966-07-21','02.36.89.05.75','06.39.16.50.85',NULL,'24 rue van bethoven','','','14123','IFS',NULL,NULL,'2660714034001',15.000000000,'1993-04-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4127,'MICHEL','JOCELYNE',NULL,'02.78.43.49.10','06.16.17.87.39',NULL,'LA FORGE','','','14540','HUBERT FOLIE',NULL,NULL,'2350250114001',30.000000000,'2012-03-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4128,'DOIX','MARIE LOUISE','1940-12-22','02.62.17.05.58','06.50.84.01.76',NULL,'','','','14460','COLOMBELLES',NULL,NULL,'1401214660001',69.000000000,'1964-10-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4129,'LEDUC','','1932-11-16','02.10.61.74.44',NULL,NULL,'32 CHEMIN DE LA CROIX VAUTIER','','','14000','CAEN',NULL,NULL,'2321176400001',18.000000000,'1953-02-27','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4130,'SANCHEZ ACUNA','JEANNINE','1929-10-28','02.38.44.78.19','06.96.12.95.15',NULL,'LA COUR DU BOSQ','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'2291014408001',111.000000000,'1954-10-18','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4131,'ANNE','ROLANDE','1940-12-19','02.91.45.19.65','00 33 6.53.46.73.92',NULL,'RUE LA GESNIERE','','','14270','MEZIDON CANON',NULL,NULL,'2401227251001',1457.000000000,'1966-07-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4132,'QUONIAM','MARCEL','1941-01-02','02.80.19.85.29','06.44.77.36.31',NULL,'4 SENTE DES JARDINS','','','14860','RANVILLE',NULL,NULL,'2410102422001',92.000000000,'1963-03-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4133,'GROULT','ANNICK','1937-05-26','02.47.69.00.00','06.10.88.54.94',NULL,'RUE DE LISIEUX','','','14220','CAUMONT SUR ORNE',NULL,NULL,'2370514126001',42.000000000,'1966-04-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4134,'CALLOUET','MADELAINE','1929-01-25','02.99.19.64.19','06.72.61.71.49',NULL,'','','','14100','LISIEUX',NULL,NULL,'1290114508001',974.000000000,'1952-05-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4135,'JACQUELINE','MICHEL','1928-12-12','02.58.30.31.86','06.83.93.76.79',NULL,'37 RUE EUGENIE','','','61000','ST GERMAIN DU CORBEIS',NULL,NULL,'1281214020001',347.000000000,'1954-03-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4136,'CHATOJAN','Claude','1944-03-02','02.81.69.95.02','00 33 6.45.89.14.42',NULL,'2 ALLEE DES ROSSIGNOLS','','','14123','IFS',NULL,NULL,'2440314331001',167.000000000,'1968-07-11','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4137,'GOSSELIN','ROLAND','1937-09-17','02.80.77.86.01','06.44.94.03.20',NULL,'','','','61300','L''AIGLE',NULL,NULL,'2370972108001',101.000000000,'1959-08-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4138,'MARIE','MARIE','1936-06-02','02.17.41.52.55','06.14.07.73.32',NULL,'4 BIS RUE ERICK SATIE','','','14700','MARTIGNY SUR L''ANTE',NULL,NULL,'2360650159001',103.000000000,'1962-05-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4139,'THOMASSE','Jacqueline','1935-11-19','02.89.76.54.53','06.76.64.27.01',NULL,'4 RUE DE LA HAIE VIGNE','','','14000','CAEN',NULL,NULL,'1351114128001',5.000000000,'1960-03-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4140,'HOLE','ANDRE','1938-02-19','02.88.94.60.71','06.54.71.62.43',NULL,'4 RUE JACQUES BREL','','','14000','CAEN',NULL,NULL,'2380214119001',94.000000000,'1960-05-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4141,'LE NAGARD','MARILYNE','1932-12-30','02.18.61.66.42','06.43.80.78.29',NULL,'rue de bretteville','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1321214339001',15.000000000,'1955-09-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4142,'AUDONNET','ANDREE','1965-02-01','02.56.49.42.60','06.14.50.87.60',NULL,'7-3 CITE DU CALVAIRE','','','14120','MONDEVILLE',NULL,NULL,'1650214163001',2685.000000000,'1992-09-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4143,'CEMON','MICHEL','1938-09-11','02.98.85.96.70','06.87.48.55.70',NULL,'6 GRANDE RUE','','','14400','BAYEUX',NULL,NULL,'2380914240001',215.000000000,'1962-06-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4144,'VANNESTE','HUGUETTE','1955-03-26','02.67.81.51.08','06.54.40.76.72',NULL,'1 ALLEE DES POETES','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1550314461001',507.000000000,'1980-05-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4145,'SEBERT','LUCIENNE','1946-02-24','02.46.17.31.58','06.63.18.28.20',NULL,'13 RUE MARCEL PELUET','','','14000','CAEN',NULL,NULL,'1460245032001',411.000000000,'1973-09-20','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4146,'LEMARINIER','MARGUERITE','1935-02-21','02.45.52.71.75','06.46.39.03.90',NULL,'18 RUE DES CAPUCINES','','',NULL,NULL,NULL,NULL,'1350261054001',68.000000000,'1956-12-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4147,'GAYDIER','MIREILLE','1949-01-23','02.15.88.98.27','06.61.55.35.15',NULL,'2 ALLEE DES SAULES','','','14370','AIRAN',NULL,NULL,'2490114213001',2936.000000000,'1979-09-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4148,'TILLAUT','MARIE JOSE','1933-12-13','02.73.32.65.90','06.12.11.08.97',NULL,'HAMEAU DE JACOB MESNIL','','','14790','MOUEN',NULL,NULL,'2331227127001',719.000000000,'1959-11-21','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4149,'JAMES','MARIE LAURE','1934-06-11','02.16.77.93.26','06.11.92.08.04',NULL,'65 RUE DE FORMIGNY','','','14260','AUNAY SUR ODON',NULL,NULL,'1340661093001',108.000000000,'1956-06-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4150,'BAUMY','chantal','1931-04-05','02.67.60.05.54','06.69.77.40.02',NULL,'6 RUE JEAN FRANCOIS LEMANISSIER','','','14860','RANVILLE',NULL,NULL,'2310414100001',360.000000000,'1955-10-12','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4151,'BELLIARD','fernand',NULL,'02.11.43.71.87','06.38.52.87.51',NULL,'LES 3 PONTS','','','50200','COUTANCES',NULL,NULL,'2350350041001',794.000000000,'2013-08-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4152,'VIGOT','CYRILLE','1965-01-08','02.24.65.34.44','06.32.33.58.74',NULL,'2 rue du monument','','','14120','MONDEVILLE',NULL,NULL,'1650114715001',48.000000000,'1995-02-20','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4153,'RUELLAND','PATRICK','1935-03-18','02.11.46.79.56','06.10.83.62.66',NULL,'LES CARREAUX','','','14000','CAEN',NULL,NULL,'1350314166001',1.000000000,'1956-11-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4154,'BOREL','GINETTE','1943-02-18','02.43.17.74.91',NULL,NULL,'RUE DE SEVES','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2430214163001',42.000000000,'1970-06-27','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4155,'ACHER','BERNARD','1930-08-08','02.20.25.64.43','06.57.91.13.12',NULL,'LE HUTREL','','','14220','ESPINS',NULL,NULL,'1300861192001',104.000000000,'1954-01-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4156,'PLASSAIS','CARLOS','1930-07-29','02.79.02.33.18','06.31.54.21.82',NULL,'8 RUE DU 11 NOVEMBRE','','','14190','MAIZIERES',NULL,NULL,'1300759247001',24.000000000,'1952-05-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4157,'MARIE','BERNARD','1929-11-16','02.13.31.40.84','06.18.91.49.92',NULL,'HAMEAU NEMERS','','','14830','LANGRUNE SUR MER',NULL,NULL,'2291161252001',26.000000000,'1950-04-13','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4158,'CHASTANG','DENIS','1938-10-05','02.68.23.37.13','06.62.74.03.34',NULL,'47 A RUE LEON CONTENT','','','14700','FALAISE',NULL,NULL,'1381014133001',131.000000000,'1963-10-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4159,'BISSON','Raymond','1940-10-06','02.82.06.80.37','06.31.87.32.63',NULL,'26 PLACE DE LA LOMBARDERIE','','','14123','IFS',NULL,NULL,'1401014383001',1.000000000,'1970-04-20','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4160,'DESDOMAINES','HELENE','1956-08-02','02.95.24.45.23','06.27.97.92.75',NULL,'6 av de la divette res saint mic','hel','','27000','GIBERVILLE',NULL,NULL,'1560814747001',964.000000000,'1985-11-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4161,'DAVENNE','ARMAND','1966-06-20','02.37.35.04.14','06.49.47.94.75',NULL,'61 RUE BELLEVUE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2660675073001',241.000000000,'1988-03-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4162,'JACQ','VALERIE','1935-04-26','02.70.17.90.40','06.55.24.75.90',NULL,'42 RUE BOSNY','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2350450518001',42.000000000,'1958-07-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4163,'GESNOUIN','aline','1958-12-16','02.25.45.72.34','06.29.25.94.85',NULL,'4 RUE DE BRETAGNE','','','14650','CARPIQUET',NULL,NULL,'2581250432001',3740.000000000,'1980-03-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4164,'HANICOT','BERNARD','1938-06-18','02.25.07.49.73','06.37.76.25.31',NULL,'6 RUE DE RONCEVAUX','','','14350','STE MARIE LAUMONT',NULL,NULL,'1380614527001',77.000000000,'1961-01-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4165,'LEBAILLY','SARAH','1928-06-18','02.11.69.04.51','06.49.40.74.41',NULL,'52 RUE GEORGES CLEMENCEAU','','','14370','ARGENCES',NULL,NULL,'2280661260001',336.000000000,'1957-04-24','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4166,'LEBAILLY','JEANNE','1928-06-16','02.90.32.08.27','06.76.52.92.92',NULL,'1 rue roger poulin','','','14120','MONDEVILLE',NULL,NULL,'2280661260001',68.000000000,'1951-03-12','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4167,'PESARD','ARMAND','1935-12-02','02.71.29.74.66',NULL,NULL,'5 avenue de normandie','','','14460','COLOMBELLES',NULL,NULL,'2351250106001',40.000000000,'1957-01-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4168,'MOUSSAY','FREDERIC','1937-02-24','02.46.47.26.09','06.84.29.77.62',NULL,'3/1 AVENUE DES ECOLES','','','50310','GIBERVILLE',NULL,NULL,'2370214488001',28.000000000,'1961-03-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4169,'SUARD','CLAIRE','1970-01-05','02.59.96.72.77','06.18.56.38.28',NULL,'11 RUE H BRUNET','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'1700114020001',221.000000000,'1993-11-16','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4170,'DELISLE','JACQUELINE','1933-07-16','02.46.61.51.91','06.80.04.65.98',NULL,'LE BOURG','','','14123','IFS',NULL,NULL,'2330702146001',26.000000000,'1954-02-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4171,'LAUNAY','MARIE LINE','1956-03-04','02.66.01.14.79','06.62.29.79.83',NULL,'2 4 rue de l arbalete','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2560314754001',37.000000000,'1981-05-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4172,'LETHOREL','ROGER','1968-04-08','02.21.84.20.98','06.22.87.52.83',NULL,'15 allee du haut du parc','','','14400','SOMMERVIEU',NULL,NULL,'1680476561001',659.000000000,'1995-06-06','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4173,'GOUIN','DAVID','1936-10-30','02.10.42.55.01','06.65.86.09.57',NULL,'','','','14420','POTIGNY',NULL,NULL,'1361014675001',1279.000000000,'1966-05-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4174,'BLANCHARD','JEAN','1960-01-15','02.36.46.79.42','06.61.10.46.83',NULL,'22 RUE DE LA VALLEE','','','14370','ARGENCES',NULL,NULL,'2600114747001',87.000000000,'1984-09-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4175,'BRUNET','PAULETTE','1935-01-14','02.11.83.76.64','06.43.27.03.99',NULL,'564 RUE DE LA MARE','','','14123','IFS',NULL,NULL,'1350114030001',276.000000000,'1958-05-31','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4176,'BRINDEJONC','MARIE THERESE','1960-02-26','02.34.12.08.54','06.25.19.16.69',NULL,'HAMEAU GRUCHY','','','61120','VIMOUTIERS',NULL,NULL,'2600214382001',269.000000000,'1983-08-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4177,'BERNARD','ROBERT','1939-10-20','02.10.45.10.49','06.74.73.18.62',NULL,'25 RUE THE ROYAL HAMPSHIRE REGIM','ENT','','14370','AIRAN',NULL,NULL,'1391014117001',42.000000000,'1960-07-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4178,'MONTIGNY','HUBERT','1962-02-05','02.23.66.18.96','06.41.28.15.79',NULL,'FOYER LE VAL DES MOULINS 8 RUE D','ES MOULINS','','14190','OUILLY LE TESSON',NULL,NULL,'2620214213001',50.000000000,'1990-06-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4179,'ROUSSEAU','JEAN CLAUDE','1935-04-11','02.32.01.38.72','06.70.96.26.78',NULL,'18 RUE DU PONT CEL','','','14120','MONDEVILLE',NULL,NULL,'1350415118001',456.000000000,'1956-07-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4180,'GROULT','jacques','1929-11-26','02.65.28.46.56','06.71.67.35.31',NULL,'11 impasse du chateau','','','14240','LA LANDE SUR DROME',NULL,NULL,'2291114369001',139.000000000,'1956-08-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4181,'COUTANCE','claude','1959-12-15','02.48.37.87.96','06.37.23.18.72',NULL,'3 RUE ROGER DECHAMBRE','','','14790','VERSON',NULL,NULL,'1591214344001',2.000000000,'1987-08-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4182,'TOUDIC','Louis','1933-09-11','02.46.10.64.33','06.67.45.57.44',NULL,'7 rue de sully','','','14310','LANDES SUR AJON',NULL,NULL,'1330914566001',642.000000000,'1957-06-07','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4183,'DEROIN','PATRICIA','1937-01-17','02.96.80.47.96','06.46.46.93.14',NULL,'8 rue denis diderot','','','14620','MORTEAUX COULIBOEUF',NULL,NULL,'2370161169001',32.000000000,'1958-10-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4184,'MADEIRA  PORTELA','GUY','1956-06-22','02.12.69.63.64','06.10.85.24.49',NULL,'12 RUE DU DOS DE LA POULE','','','14620','MORTEAUX COULIBOEUF',NULL,NULL,'1560614291001',50.000000000,'1980-02-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4185,'SKIBA','GUY','1933-01-19','02.24.24.41.90','06.11.17.94.11',NULL,'17 allee laperouse','','','14420','VILLERS CANIVET',NULL,NULL,'1330114156001',81.000000000,'1957-04-20','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4186,'WATROBA','BERNARD','1937-09-08','02.31.58.22.76','06.78.96.75.87',NULL,'35 RUE DE SUEDE','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2370961137001',862.000000000,'1962-02-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4187,'PROFFIT','MICHEL','1964-07-25','02.92.44.68.86','06.32.07.63.68',NULL,'7 RUE DU TEMPS PERDU','','','50420','GIBERVILLE',NULL,NULL,'1640714335001',10.000000000,'1989-01-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4188,'GUELLE','ROGER','1940-01-06','02.15.72.35.97','06.89.59.84.86',NULL,'7 rue des Capucines','','','14260','ONDEFONTAINE',NULL,NULL,'1400128421001',211.000000000,'1961-05-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4189,'VANDAMME','LUCIEN','1980-12-21','02.64.79.02.37','06.16.85.48.06',NULL,'la hogue','','','14540','ROCQUANCOURT',NULL,NULL,'1801299255001',11.000000000,'2006-10-23','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4190,'CHESNEL','RAYMONDE','1934-08-15','02.10.34.59.60','06.73.31.57.15',NULL,'7 rue des freres lumieres','','','14170','BERNIERES D''AILLY',NULL,NULL,'1340850567001',271.000000000,'1957-10-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4191,'MARTIN','THIERRY','1957-01-08','02.33.48.75.85','06.45.39.45.73',NULL,'37 avenue gerard philippe','','','14460','COLOMBELLES',NULL,NULL,'1570114133001',87.000000000,'1983-07-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4192,'COURTIN','ODETTE','1930-01-15','02.76.25.80.74',NULL,NULL,'route de lisieux','','','14730','GIBERVILLE',NULL,NULL,'2300114527001',48.000000000,'1956-05-30','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4193,'LANGLOIS','RAYMONDE','1931-08-09','02.71.53.81.14','06.33.54.38.27',NULL,'4 rue des canadiens','','','14730','GIBERVILLE',NULL,NULL,'2310814493001',37.000000000,'1952-04-26','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4194,'ZUIANI','PIERRE','1928-07-24','02.46.18.32.47','06.56.85.21.20',NULL,'7 PLACE DU CLOS','','','14000','CAEN',NULL,NULL,'2280714647001',170.000000000,'1952-06-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4195,'LAMBERTON','THERESE','1947-02-25','02.23.33.68.71','06.93.71.46.39',NULL,'20 RUE DU BOIS DES TRENTAINES','LE ROCREUIL','','14000','CAEN',NULL,NULL,'1470235309001',214.000000000,'1973-12-12','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4196,'CHEENNE','JEAN PIERRE','1966-11-12','02.36.40.16.55','06.69.76.36.97',NULL,'5 impasse de l''escalier','','','14000','CAEN',NULL,NULL,'2661114376001',50.000000000,'1991-03-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4197,'THIBAUT','JEAN CLAUDE','1929-12-18','02.57.33.97.40','06.39.00.88.56',NULL,'','','','14430','HOTOT EN AUGE',NULL,NULL,'1291214565001',122.000000000,'1950-04-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4198,'FOSSARD','albert','1963-02-03','02.11.49.77.17','06.65.42.22.11',NULL,'4 RUE DE DOMREMY','','','14400','VAUCELLES',NULL,NULL,'2630214045001',25.000000000,'1985-07-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4199,'LIBOIS','patrick','1933-11-08','02.17.29.99.19','06.21.53.69.96',NULL,'19 RUE DU MARRONNIER','','','14500','VIRE',NULL,NULL,'2331150117001',1354.000000000,'1954-08-18','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4200,'HOUDELIER','MICHEL','1956-07-26','02.99.61.08.86','06.78.83.99.73',NULL,'8 RUE D AUGE','','','14000','GIBERVILLE',NULL,NULL,'1560714197001',376.000000000,'1979-05-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4201,'GOUEFFIC','TADEUCH','1969-05-02','02.79.18.65.57','06.80.76.41.12',NULL,'7 RUE DES FRESNES','','','14160','DIVES SUR MER',NULL,NULL,'2690514271001',9.000000000,'1994-03-09','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4202,'ROCHAS','NOELLA','1926-07-29','02.10.15.38.02','06.67.64.11.59',NULL,'14 RUE ALBERT BAYET','','','14810','GONNEVILLE EN AUGE',NULL,NULL,'2260719176001',384.000000000,'1953-07-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4203,'CHARDIN','MARCEL','1934-04-11','02.11.44.95.21','06.11.87.22.76',NULL,'','','','14320','MAY SUR ORNE',NULL,NULL,'1340444051001',89.000000000,'1958-10-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4204,'MISZCZAK','ANDREE','1965-05-31','02.85.44.64.19','06.15.79.56.09',NULL,'28 RUE PIERRE MENDES FRANCE','','','14120','MONDEVILLE',NULL,NULL,'2650576591001',1.000000000,'1989-03-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4205,'FOUBERT','PIERRE','1938-12-31','02.52.74.13.33',NULL,NULL,'10 RUE DE ROUGEMONT','','','14370','ARGENCES',NULL,NULL,'2381214291001',2279.000000000,'1968-05-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4206,'MISZCZAK','roger','1965-05-07','02.84.27.21.12','06.44.53.14.20',NULL,'36 RUE DU STADE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1650514205001',35.000000000,'1986-06-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4207,'PROFFIT','MARTHE','1938-02-15','02.30.40.54.80','06.82.82.11.77',NULL,'11 RUE DES PEUPLIERS','','','14000','CAEN',NULL,NULL,'1380214738001',575.000000000,'1959-06-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4208,'BELLENGER','JEANNINE','1962-06-08','02.48.82.88.29','06.23.31.34.79',NULL,'1 RUE DES TILLEULS','','','14670','TROARN',NULL,NULL,'2620614394001',23.000000000,'1985-03-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4209,'GUYOT','JEAN','1962-06-25','02.51.44.78.91','06.52.85.96.57',NULL,'3 RUE P CURIE','','','14740','SECQUEVILLE EN BESSIN',NULL,NULL,'2620614394001',171.000000000,'1992-09-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4210,'SEBERT','GISELE','1965-04-20','02.31.09.82.80','06.50.76.18.94',NULL,'LA VALLEE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1650414655001',212.000000000,'1988-02-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4211,'HAIZE','ALAIN','1935-01-04','02.10.10.92.52','06.17.85.89.38',NULL,'8 RUE DES TALLIS','','','14240','STE HONORINE DE DUCY',NULL,NULL,'1350114534001',14.000000000,'1956-10-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4212,'EHRMANN','PAULETTE','1932-02-24','02.61.18.25.42','06.44.15.59.05',NULL,'1 RUE DU COTENTIN','','','14000','CAEN',NULL,NULL,'1320214191001',1136.000000000,'1955-04-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4213,'LE LOGE','Florence','1929-10-13','02.11.83.20.81','06.11.79.53.93',NULL,'1248 BD DE LA PAIX','','','14000','CAEN',NULL,NULL,'2291014410001',28.000000000,'1953-01-11','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4214,'MOTEL','Graldine','1934-06-27','02.44.55.13.38','06.41.58.09.77',NULL,'13 RUE FERNAND LEGER','','','14450','GRANDCAMP MAISY',NULL,NULL,'1340622094001',789.000000000,'1955-07-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4215,'COQUIN','NICOLE','1968-01-28','02.57.96.33.95','06.90.15.77.20',NULL,'7 RUE DE VERDUN','','','14000','CAEN',NULL,NULL,'2680114327001',253.000000000,'1989-02-14','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4216,'BONNETOT','ANDRE','1960-05-01','02.52.40.34.92','06.84.87.76.12',NULL,'21 RUE PAUL CLAUDEL','','','14000','CAEN',NULL,NULL,'1600514482001',1151.000000000,'1981-04-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4217,'KREMER','SYLVIE','1936-08-10','02.32.69.86.95','06.81.16.00.82',NULL,'9 RUE DE LA LIBERATION','','','14270','MEZIDON CANON',NULL,NULL,'2360875050001',13.000000000,'1960-12-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4218,'CARESMEL','JEAN','1934-05-02','02.31.50.54.50','06.51.12.02.84',NULL,'3 RUE SAINT SERNIN','','','14123','IFS',NULL,NULL,'1340549159001',2586.000000000,'1957-05-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4219,'ERAMBOURG','BERNARD','1935-06-16','02.32.08.72.88','06.11.15.90.76',NULL,'2 RUE DES MARCHES','','','14123','GIBERVILLE',NULL,NULL,'2350650246001',7.000000000,'1965-05-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4220,'MOTEL','ANNICK','1951-09-23','02.58.18.82.14','06.17.98.06.12',NULL,'LA HAUTINIERE','','','14630','CAGNY',NULL,NULL,'2510914198001',147.000000000,'1975-12-21','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4221,'FONTAINE','JEAN CLAUDE','1934-09-16','02.43.05.09.79','06.85.75.84.82',NULL,'2-4 rue de l''arbalete','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'1340914164001',824.000000000,'1959-01-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4222,'JALLAIS','ANDRE','1928-09-24','02.95.31.60.25','06.10.32.31.87',NULL,'LE MAIZERET','','','14940','SANNERVILLE',NULL,NULL,'2280914382001',12.000000000,'1958-04-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4223,'MARIE','JACQUELINE','1953-03-26','02.79.81.84.05','06.35.66.47.40',NULL,'9 RUE DE L EGLISE','','','50130','OCTEVILLE',NULL,NULL,'2530350614001',18.000000000,'1976-04-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4224,'LEPOULTIER','JANINE','1951-03-12','02.11.28.00.68','06.11.24.62.27',NULL,'LE LIEU DIT 50 LA VETINIERE','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'1510314098001',1068.000000000,'1975-08-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4225,'LEEUWERCK','DOMINIQUE','1931-10-06','02.51.99.31.18','06.90.40.61.71',NULL,'1 RES ST GERBOL 13 RUE CONSTANT','FORGET','','92300','LEVALLOIS PERRET',NULL,NULL,'2311014739001',1193.000000000,'1961-10-07','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4226,'MESNIL','THERESE','1939-10-02','02.13.99.97.14','06.10.27.30.10',NULL,'120, rue de l'' eglise','','','14220','CROISILLES',NULL,NULL,'1391014277001',44.000000000,'1963-08-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4227,'LECOMTE','GERARD','1928-09-09','02.47.49.38.21','06.73.18.60.96',NULL,'5,rue vincent mutelli','','','14120','MONDEVILLE',NULL,NULL,'1280914603001',77.000000000,'1951-07-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4228,'TRIHOLLET','JEAN','1940-07-22','02.68.81.48.03','06.19.82.66.34',NULL,'le haut boscque','','','14940','SANNERVILLE',NULL,NULL,'2400776183001',149.000000000,'1962-03-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4229,'BOUDET','JEAN-LOUIS','1965-02-18','02.75.70.15.37','06.35.70.66.81',NULL,'3 IMPASSE DE L''ABBE DURAND','','','14730','GIBERVILLE',NULL,NULL,'1650214341001',30.000000000,'1989-06-08','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4230,'LAVACHE','ANDRE','1931-01-03','02.85.90.20.41','06.56.71.09.24',NULL,'26 AVENUE DU CALVADOS','','','14400','GIBERVILLE',NULL,NULL,'2310114277001',136.000000000,'1952-12-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4231,'SZWEC','JEANNINE','1934-10-19','02.12.32.41.80','06.41.41.18.09',NULL,'6 Chemin du Heaume','','','14260','ONDEFONTAINE',NULL,NULL,'1341014092001',12.000000000,'1955-12-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4232,'COLLET','','1960-01-23','02.14.70.02.09','06.16.90.95.17',NULL,'42 rue du marais','','','14370','ARGENCES',NULL,NULL,'1600114241001',1549.000000000,'1989-10-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4233,'MARTY','PHILIPPE','1960-01-20','02.41.61.37.31','06.62.93.72.10',NULL,'37 AV DE ROUEN','','','14170','HIEVILLE',NULL,NULL,'1600114241001',1081.000000000,'1990-02-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4234,'BONIN','GERARD','1968-01-28','02.24.87.92.68','06.62.10.27.35',NULL,'6 RUE DE LA LIB2RATION','','','14940','GIBERVILLE',NULL,NULL,'1680161508001',1603.000000000,'1992-04-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4235,'PHILIPPE','Georges','1919-11-23','02.10.18.49.53','06.11.58.58.96',NULL,'la huanniere','','','14730','GIBERVILLE',NULL,NULL,'1191171153001',289.000000000,'1940-02-04','PREMIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4236,'LANOS','MARIE THERESE','1937-12-04','02.65.05.63.39','06.50.20.95.38',NULL,'11 RUE DU POINT DU JOUR','','','14270','PERCY EN AUGE',NULL,NULL,'2371214241001',73.000000000,'1967-09-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4237,'PAVY','Louis','1948-02-24','02.11.90.89.09','06.26.11.54.02',NULL,'','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1480261089001',2312.000000000,'1978-09-07','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4238,'CUQUEMELLE','JACQUES','1938-11-04','02.82.82.79.07','06.54.49.71.69',NULL,'13 IMPASSE DES CASTORS','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2381161488001',943.000000000,'1962-06-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4239,'GARNIER','ALFRED','1964-01-07','02.19.16.97.42','06.64.97.69.71',NULL,'27 rue de la liberation','','','14370','MERY CORBON',NULL,NULL,'2640161093001',184.000000000,'1989-10-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4240,'LECARDONNEL','camille','1935-03-28','02.42.67.25.54','06.43.53.73.37',NULL,'','','','14880','HERMANVILLE SUR MER',NULL,NULL,'1350370525001',325.000000000,'1957-08-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4241,'MACE','Emile','1948-01-16','02.88.91.09.24','06.79.40.49.25',NULL,'8 allee georges bizet','','','14123','FLEURY SUR ORNE',NULL,NULL,'2480114719001',14.000000000,'1969-03-11','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4242,'DEBLED','BRIGITTE','1929-04-21','02.32.16.86.54','06.67.87.80.28',NULL,'BAT A RESIDENCE LES TILLEULS 1','RUE EMILE NICOL','','14700','FALAISE',NULL,NULL,'1290414382001',627.000000000,'1954-09-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4243,'TILLARD','MARIE FRANCOISE','1931-05-22','02.75.82.81.38','06.49.13.13.16',NULL,'8 LA CONTERIE','','','14680','GOUVIX',NULL,NULL,'2310514737001',22.000000000,'1959-07-28','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4244,'DE VILLELE','RENEE','1929-09-19','02.54.57.55.30','06.10.87.16.14',NULL,'3 RUE DES PORTES','','','14100','LISIEUX',NULL,NULL,'1290914658001',26.000000000,'1952-11-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4245,'BOUCHARD','COLETTE','1958-01-02','02.34.31.47.42','06.95.56.04.82',NULL,'120 AVENUE DE QUAKENBRUCK','','','14730','GIBERVILLE',NULL,NULL,'1580114117001',193.000000000,'1987-09-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4246,'MARIE','HENRI','1951-03-20','02.11.32.65.57','06.62.86.52.04',NULL,'8 ALLEE DE LA CAMPAGNE','','','50180','AGNEAUX',NULL,NULL,'2510314502001',129.000000000,'1979-01-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4247,'MAHAUT','GISELE','1968-01-27','02.12.35.76.10','06.39.87.37.82',NULL,'9 PLACE PAUL QUELLEC','','','50480','STE MERE EGLISE',NULL,NULL,'2680114437001',4.000000000,'1998-05-31','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4248,'POISSON','ANNIE','1953-02-15','02.86.70.61.31','06.17.06.22.93',NULL,'25 RUE DES CORMORANS','','','14123','IFS',NULL,NULL,'2530214251001',23.000000000,'1974-12-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4249,'BLANCHE','CLAUDE','1933-12-22','02.68.73.68.02','06.78.65.20.84',NULL,'34 RUE DE CHEDEVILLE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1331214118001',652.000000000,'1955-03-06','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4250,'BEAUSSIRE','CLAUDE','1929-06-04','02.49.02.48.23','06.27.25.72.65',NULL,'1 RUE DU CHEMIN VERT LA SOUDIE','RE','','14000','CAEN',NULL,NULL,'2290614117001',1857.000000000,'1953-11-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4251,'BIDGRAIN','Daniel','1935-10-26','02.10.22.63.53','06.74.09.97.08',NULL,'3 rue de verrieres','','','14310','EPINAY SUR ODON',NULL,NULL,'2351014656001',1025.000000000,'1963-06-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4252,'VILLEROY','ren','1954-02-08','02.63.21.77.02','06.15.24.44.41',NULL,'908 RUE DU CHEMIN VERT','','','14370','CROISSANVILLE',NULL,NULL,'1540214637001',41.000000000,'1984-02-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4253,'MARIE','SERGE','1929-01-31','02.11.77.85.93','06.81.54.02.70',NULL,'1 IMPASSE DES MELEZES','','','14940','SANNERVILLE',NULL,NULL,'1290114339001',32.000000000,'1959-11-22','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4254,'COUDRAY','JOSEPH LOUIS','1963-12-14','02.65.82.32.34','06.36.35.95.32',NULL,'7 RUE DE PROVENCE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1631299253001',71.000000000,'1985-10-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4255,'MAHIER','SYLVIE','1969-04-08','02.81.35.92.27','06.19.33.87.94',NULL,'3 allee des poetes','','','14570','CLECY',NULL,NULL,'1690494038001',3249.000000000,'1998-10-29','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4256,'ROLLE','COLETTE','1929-01-17','02.89.83.89.45','06.13.83.99.08',NULL,'10 RUE ST VINCENT DE PAUL','','','14570','CLECY',NULL,NULL,'1290114479001',1739.000000000,'1957-10-30','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4257,'BRAULT','MARCEL','1933-02-23','02.49.97.50.61','06.79.67.06.56',NULL,'159 RUE DE BAYEUX','','','14270','MEZIDON CANON',NULL,NULL,'1330261505001',514.000000000,'1957-10-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4258,'DELAMARD','ELIANE','1957-05-22','02.89.33.15.81','06.24.95.11.24',NULL,'11 QUAI DU BIEF','','','14220','THURY HARCOURT',NULL,NULL,'2570514509001',25.000000000,'1978-11-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4259,'JOURDAIN','ANDRE','1958-02-18','02.10.12.18.02','06.66.29.74.74',NULL,'ROUTE NATIONALE 175','','','14000','CAEN',NULL,NULL,'2580214249001',34.000000000,'1983-07-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4260,'LEHERON','CLAUDE','1940-11-23','02.29.59.40.46','06.81.42.33.91',NULL,'LE DOS LAVE','','','14860','BAVENT',NULL,NULL,'2401114072001',60.000000000,'1961-11-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4261,'LEFRANCOIS','VIOLETTE','1928-06-12','02.30.08.29.80','06.83.23.27.21',NULL,'4 RUE DE STOKHOLM','','','14230','ISIGNY SUR MER',NULL,NULL,'2280614567001',31.000000000,'1953-11-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4262,'DELARUE','Janine','1929-05-06','02.13.05.02.55','06.10.02.18.30',NULL,'57 RUE DES ACACIAS','','','14370','MOULT',NULL,NULL,'1290514236001',46.000000000,'1952-10-24','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4263,'CHARTIER','CLAUDE','1933-07-08','02.15.63.60.15','06.73.19.99.65',NULL,'8 route de paris','','','50160','LE PERRON',NULL,NULL,'1330714134001',1355.000000000,'1961-09-01','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4264,'AILLET','PIERRE','1940-07-31','02.24.49.19.78','06.86.72.54.60',NULL,'15 place lucas ludon','','','27270','BROGLIE',NULL,NULL,'2400714287001',250.000000000,'1962-02-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4265,'FRANCOISE','EMMANUEL',NULL,'02.86.52.59.19','06.18.51.31.03',NULL,'manoir de venoix route de cabour','g','','14700','BONNOEIL',NULL,NULL,'1280714392001',130.000000000,'2013-01-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4266,'VANDAELE','DENIS','1943-05-29','02.15.67.68.40','06.57.69.72.89',NULL,'CHEMIN DU MILIEU','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'1430561054001',160.000000000,'1964-01-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4267,'AUST','MARIE CLAUDE','1931-06-22','02.38.42.26.80','06.63.38.04.86',NULL,'6 RUE DU MANOIR','','',NULL,NULL,NULL,NULL,'1310628422001',640.000000000,'1952-10-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4268,'GERMAIN','JACQUELINE','1944-01-02','02.82.69.14.39','06.21.60.40.85',NULL,'6 rue des charrons','','','14000','CAEN',NULL,NULL,'2440114213001',929.000000000,'1970-12-02','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4269,'SALAUN','RICHARD','1955-01-05','02.11.30.66.44','06.63.21.55.81',NULL,'CHAEMIN DES HAUTES VIGNES','','','50500','BREVANDS',NULL,NULL,'1550114654001',185.000000000,'1979-03-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4270,'PORET','Jean','1953-08-12','02.25.18.43.91','06.93.95.94.40',NULL,'9 RUE DE PICARDIE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1530814424001',531.000000000,'1977-09-24','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4271,'BIGNON','JEAN','1961-03-16','02.83.86.52.92','06.66.18.67.38',NULL,'13 PETITE RUE','','','14370','ARGENCES',NULL,NULL,'1610350288001',8.000000000,'1986-08-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4272,'MARY','MICHELINE','1946-01-05','02.91.74.44.64',NULL,NULL,'2 /4 RUE DE LA RENAISSANCE','','','14000','CAEN',NULL,NULL,'2460114137001',123.000000000,'1976-04-18','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4273,'GRENIER','JEAN CLAUDE','1940-02-02','02.71.69.40.39','06.94.36.04.33',NULL,'HAIMON LE DENTU','','','14860','RANVILLE',NULL,NULL,'2400237113001',6.000000000,'1965-01-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4274,'GLINEL','Monique','1979-01-02','02.19.60.46.04','06.59.36.12.70',NULL,'5 RUE J.J. ROUSSEAU','','','61150','GOULET',NULL,NULL,'2790198739001',10.000000000,'2001-11-06','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4275,'FOREST','MICHEL','1927-05-02','02.57.58.36.65','06.88.02.61.20',NULL,'64 RUE DE FALAISE','','','14000','CAEN',NULL,NULL,'1270589370001',1208.000000000,'1955-08-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4276,'DEBONS','Serge','1940-07-25','02.56.18.63.88','06.98.88.92.80',NULL,'40 rue e varlain','','','14570','LA VILLETTE',NULL,NULL,'1400714669001',30.000000000,'1962-10-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4277,'DEBREGEAS','CHRISTIAN','1928-11-10','02.25.31.60.42','06.49.79.70.74',NULL,'le pissot','','','14630','FRENOUVILLE',NULL,NULL,'1281114625001',438.000000000,'1957-04-16','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4278,'MANSON','JEAN','1950-03-16','02.11.20.28.31','06.11.40.99.83',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1500314006001',3061.000000000,'1977-05-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4279,'ROUSSELLE','HUGUETTE','1965-08-06','02.15.07.40.80','06.42.94.62.01',NULL,'LIEU DIT CROQUEMAIN','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2650814305001',284.000000000,'1994-02-24','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4280,'SPREUTELS','JACQUELINE','1932-10-02','02.72.33.02.58','06.81.65.10.75',NULL,'place de la mairie','','','50750','CANISY',NULL,NULL,'1321085120001',81.000000000,'1962-06-30','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4281,'AUGER','','1944-01-21','02.94.20.86.73','06.72.70.36.40',NULL,'4 RUE BIGANOS','','','14000','CAEN',NULL,NULL,'2440150139001',157.000000000,'1972-03-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4282,'QUEUDRUE','GERARD','1935-07-31','02.56.50.07.68','06.36.44.84.84',NULL,'','','','14840','DEMOUVILLE',NULL,NULL,'1350714098001',76.000000000,'1957-02-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4283,'LE DUC','GILBERTE','1939-06-25','02.49.74.07.04',NULL,NULL,'11 rue Jacques Cartier','','','14460','COLOMBELLES',NULL,NULL,'2390661324001',33.000000000,'1962-11-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4284,'AUMONT','JEAN CLAUD','1937-02-17','02.16.97.82.17','06.72.54.46.77',NULL,'4 RUE DE LA DIMES','','','61100','FLERS',NULL,NULL,'2370214310001',573.000000000,'1960-01-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4285,'LECAM','Solange','1964-08-26','02.11.74.40.41',NULL,NULL,'3 RUE PASTEUR','','','14320','MAY SUR ORNE',NULL,NULL,'2640814074001',356.000000000,'1993-05-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4286,'MOULIN','THERESE','1947-01-17','02.12.25.18.26','06.80.60.02.77',NULL,'2 IMPASSE DES POMMIERS','','','14123','IFS',NULL,NULL,'2470150289001',84.000000000,'1971-09-17','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4287,'LUCAS','julien','1936-03-09','02.11.36.30.95','06.20.67.95.34',NULL,'28 RUE DU PARC','','','14840','CUVERVILLE',NULL,NULL,'1360350433001',131.000000000,'1965-07-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4288,'THOMAS','FRANCOISE','1958-04-21','02.67.60.99.33','06.10.33.08.25',NULL,'8 PLACE NOTRE DAME DU VOEU','','','14000','CAEN',NULL,NULL,'1580414226001',52.000000000,'1986-12-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4289,'FANTINO','GERARD','1940-02-12',NULL,NULL,NULL,'20/03 RUE DES BLEUETS','','','14210','EVRECY',NULL,NULL,'1400214019001',17.000000000,'1963-09-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4290,'FLAIS','THERESE','1937-04-27','02.13.03.28.41','06.59.55.37.58',NULL,'1 avenue du 19 mars 1962','','','14610','VILLONS LES BUISSONS',NULL,NULL,'2370414301001',838.000000000,'1961-02-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4291,'COEURET','BERNARD','1937-04-28','02.88.84.55.06','06.62.34.00.51',NULL,'2 RUE DE L''EGLISE','','','14210','EVRECY',NULL,NULL,'2370414711001',83.000000000,'1961-03-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4292,'BRASSY','MARCEL','1956-07-03','02.51.82.23.39','06.25.38.69.71',NULL,'701 BOULEVARD DES BELLES PORTES','','','14540','SOLIERS',NULL,NULL,'2560714183001',729.000000000,'1979-08-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4293,'BARBIER','HENRIETTE','1928-11-25','02.41.46.00.91','06.11.08.80.15',NULL,'5 rue des anciens afn','','','14123','IFS',NULL,NULL,'2281114602001',78.000000000,'1949-07-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4294,'YON','LEON','1931-04-01','02.16.98.79.47','06.89.89.44.30',NULL,'5 RUE LE CARRELET','','','14670','TROARN',NULL,NULL,'1310414328001',2056.000000000,'1961-07-25','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4295,'JUIN','GILBERT','1950-03-19','02.66.33.57.44','06.49.09.28.71',NULL,'ferme de l eglise','','','14310','VILLERS BOCAGE',NULL,NULL,'2500350075001',245.000000000,'1975-06-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4296,'MARTINE','CLAUDE','1932-07-23','02.24.11.86.99','06.90.33.50.21',NULL,'98 route d''harcourt','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2320775061001',191.000000000,'1956-07-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4297,'JACQUETTE','Paulette','1949-04-17','02.36.27.24.77','06.50.23.18.66',NULL,'2 rue de l''avenir','','','14390','VARAVILLE',NULL,NULL,'2490414542001',24.000000000,'1975-11-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4298,'LEPETIT','NADINE','1929-10-09','02.10.62.77.41','06.93.60.32.40',NULL,'2 RUE BAD NEUSTADT','','','14310','EPINAY SUR ODON',NULL,NULL,'2291014461001',531.000000000,'1959-03-21','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4299,'SOBOL','BERNARD','1964-12-27','02.36.36.38.79','06.21.10.33.91',NULL,'48 boulevard raymond point carre','','','14120','MONDEVILLE',NULL,NULL,'2641236088001',93.000000000,'1985-05-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4300,'RIVIERE','CHANTAL','1938-01-03','02.13.71.49.53','06.22.80.28.13',NULL,'17 AVENUE LYAUTEY','','','14000','CAEN',NULL,NULL,'1380150319001',91.000000000,'1959-09-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4301,'FAUCONNET','RAYMOND','1940-09-19','02.68.52.47.03','06.87.38.14.78',NULL,'4 rue roland spitzer','','','14190','OUILLY LE TESSON',NULL,NULL,'2400950090001',3734.000000000,'1965-06-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4302,'RICHARD','EVELYNE','1936-04-08','02.17.43.67.35','06.76.21.07.36',NULL,'23 RUE DU RUEL','','','14120','MONDEVILLE',NULL,NULL,'2360414566001',139.000000000,'1961-12-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4303,'SALERNE','DENISE','1962-02-16','02.10.39.86.72','06.13.34.72.83',NULL,'57 rue du manoir','','','14670','TROARN',NULL,NULL,'2620214213001',555.000000000,'1984-07-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4304,'MARIE','MARCEL','1939-03-30','02.63.91.70.20','06.99.77.48.48',NULL,'4 IMPASSE DES EGLANTIERS','','','14000','CAEN',NULL,NULL,'1390314364001',102.000000000,'1965-06-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4305,'DEBREGEAS','FRANCOISE','1935-05-01','02.82.52.78.58','06.57.30.74.71',NULL,'26 rue ampere','','','14210','CHEUX',NULL,NULL,'2350561294001',280.000000000,'1959-12-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4306,'GUERIN','THIERRY','1936-11-27','02.94.89.61.38','06.88.24.21.22',NULL,'25 ROUTE DE TROUVILLE','','','14400','VAUX SUR AURE',NULL,NULL,'2361114160001',46.000000000,'1963-07-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4307,'MAUDUIT','SERGE','1959-01-08','02.99.32.13.22','06.86.22.43.26',NULL,'24 ROUTE DE PARIS','','','14400','VAUX SUR AURE',NULL,NULL,'2590161237001',31.000000000,'1989-11-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4308,'HAY','ERIC','1937-06-07','02.12.09.63.12','06.54.02.39.42',NULL,'22 RUE HERBLINE','','','14470','COURSEULLES SUR MER',NULL,NULL,'1370614311001',191.000000000,'1967-05-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4309,'MICHEL','MICHEL','1944-02-02','02.18.18.69.57','06.42.49.05.38',NULL,'122 chemin de l eglise','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2440272174001',26.000000000,'1970-01-16','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4310,'','THERESE','1965-06-01','02.10.16.26.09','06.10.73.93.10',NULL,'17 rue du chateau','','','14540','GRENTHEVILLE',NULL,NULL,'2650614408001',256.000000000,'1989-08-08','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4311,'PERREE','GEORGES','1951-07-29','02.55.07.04.10','06.14.63.09.93',NULL,'10 AVENUE DES FONTAINES','','','27300','BERNAY',NULL,NULL,'1510714673001',212.000000000,'1976-01-28','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4312,'GUIBET','BERNARD','1959-01-04','02.26.35.84.98','06.28.57.95.78',NULL,'29 IMPASSE DE L''ORANGERAIE','','','14990','BERNIERES SUR MER',NULL,NULL,'1590114637001',874.000000000,'1983-07-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4313,'LEMOIGNE','CLAUDE','1939-06-23','02.44.69.20.55','06.65.43.46.10',NULL,'LE DOUET BEROT','','','14190','MAIZIERES',NULL,NULL,'1390614258001',1775.000000000,'1962-04-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4314,'POINTE','MICHEL','1940-12-26','02.12.34.07.19','06.59.16.48.57',NULL,'44 rue maurice fouques','','','14150','OUISTREHAM',NULL,NULL,'2401261002001',210.000000000,'1969-11-28','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4315,'POINTE','MICHEL','1933-08-11','02.70.08.77.15','06.10.68.82.57',NULL,'23 RUE DU PAVILLON','','','14160','DIVES SUR MER',NULL,NULL,'1330814761001',267.000000000,'1956-06-13','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4316,'KOUBA','FRANCOIS','1932-04-30','02.23.05.28.02','06.33.32.52.27',NULL,'LES 3 MONTEAUX "LIEU DIT"','','','14240','SEPT VENTS',NULL,NULL,'1320414035001',787.000000000,'1953-01-24','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4317,'ASSELINE','HUBERT','1968-03-23','02.45.23.15.33','06.10.17.87.74',NULL,'IMPASSE DU VILLAGE','','','14000','CAEN',NULL,NULL,'1680314657001',205.000000000,'1989-04-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4318,'LECORDIER','MICHEL','1940-11-28','02.33.23.87.60','06.19.02.14.83',NULL,'23 RUE DE LA MARE','','','14370','MERY CORBON',NULL,NULL,'1401114702001',1348.000000000,'1967-08-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4319,'DUBOSQ','JEANNE','1940-11-28','02.42.77.83.37','06.83.40.52.68',NULL,'30 RUE AMPERE','','','14000','CAEN',NULL,NULL,'1401114702001',408.000000000,'1963-08-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4320,'PAVY','MARIE LOUISE','1953-01-21','02.81.31.83.38','06.54.56.37.53',NULL,'178 rue d auge','','','14000','CAEN',NULL,NULL,'2530114543001',425.000000000,'1978-02-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4321,'BUQUET','Louis','1963-05-04','02.17.14.05.81','06.19.39.27.92',NULL,'16 RUE AUX BOUETS','','','14670','TROARN',NULL,NULL,'1630514072001',3442.000000000,'1992-10-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4322,'TALVAST','MICHEL','1954-02-26','02.11.38.31.83','06.83.22.85.90',NULL,'RESIDENCE EMPHYTRITE PLACE ALFRE','D THOMAS','','14170','EPANEY',NULL,NULL,'2540250338001',81.000000000,'1978-10-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4323,'WENDERBERG','JEANNINE-YVONN','1932-03-03','02.87.77.96.42','06.41.78.02.02',NULL,'7 RESIDENCE STE PAIX','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'1320361189001',438.000000000,'1961-08-17','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4324,'FLEURENT','BERNARD','1948-04-16','02.20.91.27.01','06.42.82.96.40',NULL,'MORCHESNE','','','14970','BENOUVILLE',NULL,NULL,'2480414360001',301.000000000,'1971-12-21','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4325,'HEYMANS','GISELE','1962-03-06','02.62.41.28.68','06.43.33.73.27',NULL,'6 IMPASSE ALBERT DENIS','','','14123','IFS',NULL,NULL,'1620361122001',171.000000000,'1992-09-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4326,'PESCHARD','alain','1949-01-14','02.82.04.30.16','06.10.91.14.15',NULL,'34 COULANDON','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2490178153001',845.000000000,'1974-01-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4327,'','FRANCOISE',NULL,'02.11.18.85.64','06.85.75.80.95',NULL,'8 RUE PASTEUR','','','14240','CAHAGNES',NULL,NULL,'2420124579001',20.000000000,'2008-06-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4328,'GUIGUEN','GERARD','1929-09-16','02.58.01.85.15','06.30.54.44.18',NULL,'12 rue lucien boussoutrot','','','14240','ORBOIS',NULL,NULL,'1290976575001',15.000000000,'1954-05-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4329,'BOULIER','BERNARD','1951-01-09','02.36.77.76.60','06.86.02.93.90',NULL,'10 RUE DU VAL RICHER','','','14120','MONDEVILLE',NULL,NULL,'2510114651001',889.000000000,'1974-01-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4330,'PLEINTEL','lucien','1940-11-07','02.88.38.31.44','06.90.94.99.39',NULL,'24 RUE PASTEUR','','','14000','CAEN',NULL,NULL,'1401114702001',66.000000000,'1964-09-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4331,'PILON','MONIQUE','1953-01-08','02.81.04.40.77','06.32.27.29.76',NULL,'','','','14370','BELLENGREVILLE',NULL,NULL,'2530114020001',21.000000000,'1975-08-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4332,'JOUBERT','RAYMONDE','1940-05-04','02.44.76.98.14','06.66.08.99.67',NULL,'42RUE DU MILIEU','','','14000','CAEN',NULL,NULL,'1400514287001',2783.000000000,'1961-06-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4333,'','PATRICIA','1934-10-20','02.11.45.35.54','06.82.88.98.95',NULL,'4 RUE DU PUITS','','','14270','MEZIDON CANON',NULL,NULL,'1341014118001',259.000000000,'1964-01-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4334,'DALLET','JACQUELINE','1933-03-29','02.55.58.22.14','06.19.08.94.30',NULL,'2 RUE JACQUES BREL','','','14123','IFS',NULL,NULL,'1330314305001',456.000000000,'1956-01-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4335,'DALLET','JEANNE','1930-08-05','02.50.29.27.74',NULL,NULL,'4 RUE RAOUL TESSON','','','14280','ST CONTEST',NULL,NULL,'1300814325001',1867.000000000,'1957-04-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4336,'BULLERYAL','Louis','1951-03-09','02.67.64.39.93','06.34.66.27.40',NULL,'2 RUE DES VALETTES','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'2510314287001',90.000000000,'1972-02-09','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4337,'LEPOULTIER','MARIE-ROSE','1929-03-02','02.31.11.89.01','06.88.63.01.42',NULL,'','','','14540','HUBERT FOLIE',NULL,NULL,'2290314384001',5.000000000,'1950-05-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4338,'SANSON','Marcelle','1930-11-29','02.45.16.44.56','06.76.49.80.08',NULL,'1 RUE DES BRUYERES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1301161387001',49.000000000,'1958-01-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4339,'VOEGELE','GERARD','1937-08-15','02.44.50.56.67','06.97.61.93.48',NULL,'12 chemin du beau site','','','14630','FRENOUVILLE',NULL,NULL,'2370814129001',35.000000000,'1964-08-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4340,'WUILLEME','RAYMOND','1917-03-06','02.95.09.06.07','06.97.18.56.02',NULL,'7 RUE DE L EGLISE','','','14000','CAEN',NULL,NULL,'1170314389001',252.000000000,'1940-12-31','PREMIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4341,'MOREL','SUZANNE','1938-06-20','02.68.48.74.89',NULL,NULL,'174 ROUTE DE BRETAGNE','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1380650642001',46.000000000,'1965-06-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4342,'MAINNEMARD','CLAUDE','1930-05-23','02.71.06.03.47','06.96.22.09.38',NULL,'2 rue le clos du pavillon','','','50430','ST GERMAIN SUR AY',NULL,NULL,'2300561303001',1107.000000000,'1953-04-20','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4343,'TAHIER','MADELEINE','1939-07-18','02.78.47.99.48','06.53.76.15.22',NULL,'LE BOURG','','','14123','IFS',NULL,NULL,'1390714443001',13.000000000,'1967-07-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4344,'DIBEL','DANIEL','1957-01-19','02.46.75.08.87','06.86.60.75.23',NULL,'23 AV DE L EUROPE','','','14000','CAEN',NULL,NULL,'2570114455001',103.000000000,'1985-06-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4345,'BUSNEL','JACQUES','1969-12-15','02.44.14.22.17','06.45.98.26.89',NULL,'1 RUE DE LA GRANDE MARE','','','14540','BOURGUEBUS',NULL,NULL,'2691214537001',661.000000000,'1991-11-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4346,'OSSEMONT','Mauricette','1946-07-19','02.50.72.44.21','06.27.69.71.57',NULL,'17 ROUTE DE LA FRESNAIE','','','14120','MONDEVILLE',NULL,NULL,'1460728085001',24.000000000,'1967-12-21','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4347,'LECOUTURIER','JEAN CLAUDE','1955-02-06','02.12.28.68.97','06.48.44.66.07',NULL,'HOTEL LE FLORIANE 30 RUE DE L AV','ENIR','','14740','LASSON',NULL,NULL,'1550214688001',1093.000000000,'1983-03-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4348,'ROBINE','JACQUELINE','1933-07-14','02.36.22.00.78','06.42.19.25.03',NULL,'18 RUE ALBERT LEPEE','','','14320','MAY SUR ORNE',NULL,NULL,'2330714100001',86.000000000,'1957-08-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4349,'MARIE','HELENA','1933-07-06','02.10.33.76.37','06.11.93.27.52',NULL,'les clos meheudin','','','14380','LANDELLES ET COUPIGNY',NULL,NULL,'2330714100001',30.000000000,'1958-12-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4350,'ALVES CONDE','GERMAINE','1965-03-08','02.86.05.28.75','06.56.35.39.83',NULL,'LE JARDIN DE LA TOURELLE','','','14250','BUCEELS',NULL,NULL,'1650314100001',667.000000000,'1994-02-15','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4351,'TOURNEAU','YVONNE','1934-06-09','02.43.24.42.35','06.85.00.80.23',NULL,'11 RUE DU MOULIN','','','14460','COLOMBELLES',NULL,NULL,'1340614559001',1167.000000000,'1963-05-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4352,'TAHIER','THERESE','1954-11-03','02.48.87.14.73','06.11.31.58.74',NULL,'','','','14123','FLEURY SUR ORNE',NULL,NULL,'2541161433001',940.000000000,'1975-06-19','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4353,'LECARPENTIER','HERVE','1934-05-03','02.27.95.16.94','06.57.46.17.41',NULL,'15 IMPASSE DES VALENTIN HAUY','','','14780','LION SUR MER',NULL,NULL,'2340514397001',82.000000000,'1957-06-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4354,'BOUVET','MARIE CLAUDE','1955-03-28','02.10.13.55.84','06.72.22.93.61',NULL,'HAMEAU RUPIERRE','','','14210','NOYERS BOCAGE',NULL,NULL,'2550361109001',210.000000000,'1976-03-12','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4355,'LEMONNIER','JEANNE','1940-10-06','02.89.85.62.90','06.64.05.46.35',NULL,'1 PLACE DE LA LIBERTE','','',NULL,NULL,NULL,NULL,'1401014119001',483.000000000,'1967-02-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4356,'FRIESS','GUY','1970-03-21','02.38.89.09.77','06.37.31.09.39',NULL,'16 Bis Rue de l''Eglise','','','14790','VERSON',NULL,NULL,'1700350237001',920.000000000,'1998-12-06','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4357,'BELLENGER','Michel','1938-05-04','02.30.62.19.16','06.87.21.70.69',NULL,'','','','14290','ORBEC',NULL,NULL,'2380553237001',1.000000000,'1963-03-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4358,'PHILIPPE','Patricia','1949-01-31','02.87.95.53.09','06.16.10.87.54',NULL,'191 RUE HENRI VENIARD','','','14000','CAEN',NULL,NULL,'1490114372001',7.000000000,'1970-04-30','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4359,'LECHEVALIER','JEANINE',NULL,'02.13.70.22.70','06.32.79.26.70',NULL,'10 RUE AUGUSTE LECHESNE','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1401214726001',202.000000000,'2011-10-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4360,'VILLE','PIERRE','1932-11-07','02.37.70.53.78','06.11.02.10.52',NULL,'203 RUE DE VERDUN','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1321114712001',356.000000000,'1962-08-11','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4361,'HOYET','PATRICIA','1932-12-13','02.29.14.38.92','06.76.16.31.26',NULL,'10 rue ab boulier','','','14000','CAEN',NULL,NULL,'1321249334001',286.000000000,'1961-06-05','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4362,'GOYER','Yves','1938-09-21','02.37.60.95.90','06.74.73.79.47',NULL,'2 RUE PIERRE CORNEILLE','','','14000','CAEN',NULL,NULL,'2380950109001',195.000000000,'1965-06-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4363,'GOSSELIN','SYLVAIN','1928-11-18','02.94.30.26.86','06.92.51.98.14',NULL,'16 IMPASSE PASCAL','','','14000','CAEN',NULL,NULL,'1281184087001',37.000000000,'1951-12-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4364,'GABRIEL','ALAIN','1939-07-11','02.90.67.49.02','06.37.27.38.04',NULL,'17 RUE DU MUGUET','','','14410','VASSY',NULL,NULL,'2390714577001',28.000000000,'1966-05-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4365,'SIMONIN','CHARLES','1928-01-20','02.11.47.48.43','06.40.83.55.33',NULL,'9 RUE PIERRE FRANCOIS DELAUNAY','','','14940','SANNERVILLE',NULL,NULL,'1280114396001',416.000000000,'1957-08-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4366,'FROMENT','Paulette','1933-03-26','02.71.13.73.63','06.34.45.52.25',NULL,'5 allee des pains gris','','','14400','GUERON',NULL,NULL,'2330314550001',89.000000000,'1963-07-22','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4367,'LOISON','Gilberte','1931-03-07','02.30.04.23.93','06.79.42.56.14',NULL,'la chenaie rue juno','','','14960','ASNELLES',NULL,NULL,'1310314229001',508.000000000,'1954-11-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4368,'CHARLES','Paulette','1937-03-07','02.83.20.94.18','06.41.48.34.68',NULL,'la chenaie rue juno','','','14220','GRIMBOSQ',NULL,NULL,'1370314437001',1100.000000000,'1960-04-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4369,'LEMORE','MARIE LOUISE','1931-09-15','02.57.54.05.27','06.28.74.89.33',NULL,'10 pl du dr german','','','14000','CAEN',NULL,NULL,'2310914085001',82.000000000,'1957-04-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4370,'LEMASSON','PIERRE','1950-01-11','02.12.02.24.50','06.47.38.73.88',NULL,'','','','14240','LIVRY',NULL,NULL,'1500114581001',1628.000000000,'1977-12-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4371,'BESSIRARD','MONIQUE','1929-06-24','02.70.26.53.02','06.55.76.86.59',NULL,'18 rue boulevard louis barthou','','','14670','TROARN',NULL,NULL,'2290614480001',172.000000000,'1954-01-07','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4372,'SAINT CLAIR','LOUIS','1931-12-14','02.62.93.45.33','06.31.52.59.54',NULL,'5 rue de la delle du renard','','','14380','LE MESNIL ROBERT',NULL,NULL,'2311214628001',25.000000000,'1961-03-08','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4373,'CORDON','ADOLPHE','1935-11-08','02.36.29.94.37','06.78.95.89.92',NULL,'1 impasse du berry','','','14370','ARGENCES',NULL,NULL,'2351114035001',3.000000000,'1961-09-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4374,'PICQUE','Roland','1952-01-05','02.45.06.34.45','06.85.87.08.68',NULL,'12 AV DU 43 EME REGIMENT D''ARTIL','LERIE','','14370','ARGENCES',NULL,NULL,'2520150546001',83.000000000,'1982-09-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4375,'RENOUARD','JACQUES','1955-01-01','02.12.31.52.73','06.87.50.41.69',NULL,'ROUTE DE GLATIGNY','','','14000','CAEN',NULL,NULL,'2550114241001',354.000000000,'1985-02-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4376,'MARIE','GILBERT','1939-02-08','02.68.64.79.94','06.49.48.39.15',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2390214046001',86.000000000,'1963-03-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4377,'ALMIRE','Lucien','1946-06-12','02.11.27.39.93','06.88.06.31.98',NULL,'LES PEDOUZES','','','14630','CAGNY',NULL,NULL,'1460614010001',131.000000000,'1973-06-13','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4378,'PERRETTE','GENEVIEVE','1954-02-15','02.48.54.05.91','06.23.55.26.51',NULL,'35 rue du centre','','','14000','CAEN',NULL,NULL,'1540214121001',390.000000000,'1976-09-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4379,'BRAULT','LUCIEN','1968-09-06','02.69.67.09.91','06.25.18.98.30',NULL,'31 RUE CAMILLE BLAIZOT','','','14860','BAVENT',NULL,NULL,'1680961197001',3438.000000000,'1995-11-23','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4380,'BRESSON','Pierrette','1965-11-08','02.71.85.21.71','06.22.21.13.15',NULL,'LE BOURG','','','14130','COUDRAY RABUT',NULL,NULL,'1651114743001',402.000000000,'1987-12-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4381,'DOUDNIK','Marthe','1946-04-10','02.28.72.78.70','06.20.21.19.04',NULL,'3 RUE DES LILAS','','','14150','OUISTREHAM',NULL,NULL,'2460414170001',510.000000000,'1969-09-30','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4382,'NOURRIS','RAYMOND','1950-01-25','02.19.72.85.81','06.14.68.37.76',NULL,'5 RUE GEORGES .LACOUR','','','14530','LUC SUR MER',NULL,NULL,'1500161449001',394.000000000,'1972-05-17','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4383,'CONRAUD','SYLVIE','1968-02-01','02.11.90.56.54','06.14.49.08.42',NULL,'4 BIS RUE DU VIQUET','','','14000','CAEN',NULL,NULL,'1680214174001',74.000000000,'1992-05-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4384,'LEMOINE','Simonne','1937-02-02','02.11.30.48.39','06.82.32.50.98',NULL,'22 TER RUE DE LA LIBERATION','','','14270','MEZIDON CANON',NULL,NULL,'1370261181001',75.000000000,'1959-10-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4385,'FLAMBARD','alphonsine','1968-01-23','02.55.27.39.92','06.66.48.75.44',NULL,'19 rue d''athnes','','','14150','OUISTREHAM',NULL,NULL,'1680153166001',333.000000000,'1993-02-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4386,'CAUCHON','ANDREE','1941-12-23','02.44.88.34.48','06.84.45.90.40',NULL,'12 RUE HENRI BARBUSSE','','','14540','ROCQUANCOURT',NULL,NULL,'1411212034001',1082.000000000,'1969-07-05','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4387,'LARCHER','GEORGES','1936-05-17','02.59.41.37.71','06.61.65.53.33',NULL,'6 rue alfred nobel','','','14000','CAEN',NULL,NULL,'2360549066001',23.000000000,'1964-12-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4388,'ROBINE-LANGLOIS','SYLVIE','1961-03-14','02.41.31.28.93','06.39.04.37.48',NULL,'9 rue gandhi','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1610314435001',39.000000000,'1982-12-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4389,'DUMESNIL','PATRICE','1961-02-08','02.14.53.24.74',NULL,NULL,'8 RUE DE LA POMME D''OR','','','14310','EPINAY SUR ODON',NULL,NULL,'2610261071001',1897.000000000,'1984-02-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4390,'BARBIER','MADELEINE','1939-02-18','02.19.29.42.49','06.40.31.60.72',NULL,'branville','','',NULL,NULL,NULL,NULL,'2390214166001',222.000000000,'1963-12-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4391,'ROUSIER','lionel','1958-02-05','02.48.30.19.92','06.36.80.11.03',NULL,'144 BOULEVARD LEROY','','','14980','ROTS',NULL,NULL,'1580214063001',17.000000000,'1980-10-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4392,'WULLENS','DANIELLE','1940-02-20','02.41.47.05.73','06.42.32.56.74',NULL,'3 rue du stade','','','61160','COUDEHARD',NULL,NULL,'2400214100001',52.000000000,'1970-01-23','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4393,'TOLLEMER','THERESE','1935-07-23','02.10.89.72.08','06.62.92.33.71',NULL,'13 RUE LAFAYETTE','','','14500','ROULLOURS',NULL,NULL,'2350714009001',407.000000000,'1961-08-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4394,'GARNOT','Monique','1940-11-13','02.78.18.01.00','06.84.14.18.36',NULL,'4 RUE DU 9 JUILLET','','','14680','GOUVIX',NULL,NULL,'1401161042001',716.000000000,'1969-04-13','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4395,'DOCAGNE','MICHEL','1950-01-31','02.12.09.86.04','06.37.42.36.22',NULL,'6 RUE JEAN DE LA FONTAINE','','','14170','OLENDON',NULL,NULL,'2500128395001',195.000000000,'1972-06-24','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4396,'HEBERT','MAURICETTE','1933-11-30','02.11.47.80.30','06.82.52.29.57',NULL,'6 rue du clos neuf','','','14770','ST VIGOR DES MEZERETS',NULL,NULL,'2331114752001',635.000000000,'1957-12-19','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4397,'DUBOS','SUZANNE','1928-12-02','02.73.31.83.87','06.38.61.76.02',NULL,'45 AVENUE DU 6 JUIN','','','14000','CAEN',NULL,NULL,'1281214431001',43.000000000,'1951-04-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4398,'ROUSSEL','ROGER','1934-05-01','02.13.69.13.70','06.46.54.20.88',NULL,'3 AVENUE  MADELAINE DE SEGUR','','','14000','CAEN',NULL,NULL,'1340514709001',136.000000000,'1964-01-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4399,'CHEVALLIER','GASTON','1936-03-07','02.11.68.19.61','06.46.80.75.38',NULL,'9 RUE DE ROHAN CHABOT','','','14170','GRISY',NULL,NULL,'1360314297001',2.000000000,'1963-05-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4400,'GRAVEY','Louis','1931-09-02','02.30.43.65.61','06.32.16.04.69',NULL,'RUE DE L''EGLISE','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'2310914605001',1042.000000000,'1955-11-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4401,'BOUCHER','GILBERT','1936-03-31','02.47.32.20.26','06.48.06.02.74',NULL,'8 RUE DU BOURG','','','14000','CAEN',NULL,NULL,'2360314353001',104.000000000,'1966-10-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4402,'MADELAINE','SERGE','1954-01-08','02.10.64.99.01','06.16.33.36.71',NULL,'21 rue de rouen','','','14370','ARGENCES',NULL,NULL,'1540114074001',34.000000000,'1977-09-22','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4403,'LECARPENTIER','PATRICIA','1958-06-17','02.65.65.14.41','06.29.89.13.99',NULL,'5 RUE DU PARC','','','14740','SECQUEVILLE EN BESSIN',NULL,NULL,'2580614454001',742.000000000,'1981-08-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4404,'WENSING','MARIE THERESE','1933-06-21','02.89.34.81.17','06.88.38.66.32',NULL,'3 rue paul langevin','','','14460','COLOMBELLES',NULL,NULL,'2330614129001',209.000000000,'1963-07-23','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4405,'JAUTEE','JACQUELINE','1945-01-30','02.87.33.96.17','06.92.64.42.80',NULL,'2 IMPASSE DU POIDS DU ROI','','','14270','MEZIDON CANON',NULL,NULL,'1450114071001',304.000000000,'1966-07-26','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4406,'CALDIN','PIERRE','1950-04-17','02.11.27.81.84','06.95.42.60.81',NULL,'39 rue robert bothereau','','','14540','GRENTHEVILLE',NULL,NULL,'2500414084001',43.000000000,'1972-05-01','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4407,'DION','MARTINE','1936-08-03','02.76.30.67.26','06.79.27.77.40',NULL,'53 RUE DE LA MARNE','','','14000','CAEN',NULL,NULL,'1360814485001',700.000000000,'1957-06-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4408,'BASTARD','CLAUDINE','1940-03-09','02.12.27.28.60','06.77.27.24.92',NULL,'25 rue de caen','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2400314160001',5108.000000000,'1966-09-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4409,'COMMUN','ELIANE','1954-02-06','02.72.06.76.72','06.13.49.84.12',NULL,'','','','14320','FONTENAY LE MARMION',NULL,NULL,'1540223055001',10.000000000,'1976-09-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4410,'LESELLIER','JACQUELINE','1934-09-01','02.83.49.99.79','06.84.09.61.99',NULL,'18 rue saint andre porte 27','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1340914412001',132.000000000,'1963-04-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4411,'LESELLIER','EDOUARD','1942-01-24','02.76.15.91.18','06.42.12.14.96',NULL,'RUE DE CHEUX','','','14740','STE CROIX GRAND TONNE',NULL,NULL,'2420150583001',218.000000000,'1967-03-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4412,'MOUSSET','MICHELE','1935-06-09','02.11.00.07.46','06.52.50.17.15',NULL,'20 CLOS ST MARTIN','','','14540','ROCQUANCOURT',NULL,NULL,'1350614271001',98.000000000,'1958-10-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4413,'BOURGOGNE','RENEE','1931-12-15','02.59.41.76.19','06.12.33.91.66',NULL,'15 RESIDENCE ST JACQUES','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1311214225001',108.000000000,'1961-10-22','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4414,'DESLOGES','COLETTE','1929-06-17','02.38.80.87.63','06.70.09.39.98',NULL,'52 rue d ifs','','','14570','ST REMY',NULL,NULL,'2290650111001',50.000000000,'1950-02-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4415,'MENNECHEZ','RENEE','1932-06-18','02.59.96.31.85','06.11.62.32.19',NULL,'25 rue du moulin a voide','','','14390','CABOURG',NULL,NULL,'2320614516001',77.000000000,'1955-01-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4416,'MARESQ','JEAN YVES','1935-12-27','02.91.29.61.75','06.15.49.43.98',NULL,'3 rue du l anguedoc','','','14000','CAEN',NULL,NULL,'1351250087001',3978.000000000,'1961-08-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4417,'CHOISY','ADOLPHE','1969-10-30','02.81.53.63.00','06.19.47.06.51',NULL,'9 ROUTE DE CONDE','','','14110','CONDE SUR NOIREAU',NULL,NULL,'2691042187001',497.000000000,'1995-11-16','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4418,'FRILLEY','LEOPOLD','1959-02-24','02.96.83.13.54','06.12.29.99.43',NULL,'RUE DU MOUTIER','','','14123','IFS',NULL,NULL,'2590214556001',51.000000000,'1980-02-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4419,'JEAN','Danielle',NULL,'02.93.24.15.02','06.35.48.98.96',NULL,'2 rue de l''avenir','','','14400','BAYEUX',NULL,NULL,'1381014695001',120.000000000,'2010-04-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4420,'BAUMEL','ANDRE','1933-12-28','02.79.49.40.86','06.49.03.68.56',NULL,'RUE LE JARDIN','','','14000','CAEN',NULL,NULL,'2331214096001',1249.000000000,'1957-06-21','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4421,'ALLIOT','Ren',NULL,'02.23.59.68.53','06.13.60.48.97',NULL,'12 RUE DES PAVILLONS','','','14210','NOYERS BOCAGE',NULL,NULL,'1300514440001',1.000000000,'2008-07-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4422,'PLASSAIS','Patrice','1929-09-08','02.42.27.98.05','06.30.80.17.99',NULL,'6 ROUTE DE L''ANGLE','','','14710','LOUVIERES',NULL,NULL,'1290914712001',413.000000000,'1951-05-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4423,'LENEVEU','COLETTE','1940-06-10','02.48.87.41.94','06.31.16.85.48',NULL,'4 RUE CHANOINE RENOUF','','','14123','FLEURY SUR ORNE',NULL,NULL,'1400675114001',42.000000000,'1961-05-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4424,'HENNEBERT','XAVIER','1930-02-07','02.18.43.16.18','06.13.25.66.89',NULL,'34 RUE DU CHEMIN VERT','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2300205079001',254.000000000,'1956-08-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4425,'LEFAUCHEUR','Aline','1954-03-27','02.27.88.67.23','06.10.55.77.97',NULL,'25 QUAI DE LA LONDE','','','14700','FALAISE',NULL,NULL,'2540314266001',337.000000000,'1980-08-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4426,'GUILLOIS','FLORENCE','1960-01-16','02.34.46.80.61','06.16.83.08.86',NULL,'7 bis rue porte millet','','','14670','TROARN',NULL,NULL,'1600129024001',55.000000000,'1986-04-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4427,'THEPAUT','JOEL','1940-01-27','02.10.87.36.70','06.78.19.04.67',NULL,'1 BIS RUE DE LA PAIX','','','14610','ANISY',NULL,NULL,'2400150077001',412.000000000,'1969-10-17','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4428,'HERARD','JEAN','1928-12-05','02.15.50.58.05','06.29.90.58.51',NULL,'20 CLOS DU PAVILLON','','','14000','CAEN',NULL,NULL,'2281250182001',146.000000000,'1952-07-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4429,'AMIOT','DANIEL','1929-08-27','02.83.43.34.61','06.55.42.64.11',NULL,'4 ALLEE DES CHEVREFEUILLE','','','14460','COLOMBELLES',NULL,NULL,'1290850552001',9.000000000,'1951-03-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4430,'BICHUT','DOMINIQUE','1964-08-18','02.58.26.74.32',NULL,NULL,'9 rue des tieuls','','','14120','MONDEVILLE',NULL,NULL,'1640814118001',187.000000000,'1988-11-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4431,'BOULOT','DANIEL','1929-11-23','02.73.31.92.50','06.11.58.12.44',NULL,'LE RUYE','','','14630','CAGNY',NULL,NULL,'1291114735001',774.000000000,'1959-09-28','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4432,'LECHAPELAIS','JEANNE','1942-09-03','02.87.67.04.75','06.27.24.29.52',NULL,'1 avenue du 19 mars 1962','','','14630','EMIEVILLE',NULL,NULL,'1420914650001',53.000000000,'1971-01-21','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4433,'HELD','BERNARD','1935-03-10','02.52.45.55.95','06.64.25.06.65',NULL,'FOYER ROBERT M 68 RUE EUSTACHE R','ESTOUX','','14120','MONDEVILLE',NULL,NULL,'2350314228001',708.000000000,'1958-03-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4434,'CHAPUIS','JEAN MARIE','1945-08-26','02.15.36.59.99','06.52.73.51.74',NULL,'HAMEAU LE BEFFEUX','','','61160','GUEPREI',NULL,NULL,'2450814343001',6.000000000,'1968-06-22','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4435,'LEBOULANGER','ROGER','1949-02-18','02.86.07.84.04','06.66.39.30.58',NULL,'17 VILLAGE DE L''EGLISE','','','14630','CAGNY',NULL,NULL,'2490214587001',280.000000000,'1978-04-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4436,'DUCHESNE','JEANNINE','1931-07-31','02.11.83.86.32','06.46.25.09.07',NULL,'','','','14000','CAEN',NULL,NULL,'2310714754001',69.000000000,'1955-03-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4437,'MONTCUIT','PIERRE','1935-09-11','02.11.95.43.59','06.47.16.65.27',NULL,'44 rue maurice fouques','','','14540','GRENTHEVILLE',NULL,NULL,'1350914271001',1871.000000000,'1961-05-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4438,'YVER','BERNARD','1935-09-23','02.46.42.03.92','06.54.85.54.15',NULL,'','','','14220','BOULON',NULL,NULL,'2350914493001',624.000000000,'1956-10-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4439,'GUILLEMIN','Rene','1956-08-14','02.21.20.49.32','06.15.89.39.84',NULL,'2 rue alexandre lelannier','','','14000','CAEN',NULL,NULL,'1560814747001',3788.000000000,'1979-11-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4440,'SCUSSEL','SIGRID','1970-01-16','02.74.10.50.00',NULL,NULL,'LA BOCQUETIERE','','','14310','VILLERS BOCAGE',NULL,NULL,'2700114623001',210.000000000,'1996-10-23','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4441,'BOCCHINI','JEAN','1928-03-11','02.49.24.86.38','06.79.91.86.74',NULL,'LA BOCQUETIERE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2280322164001',13.000000000,'1956-07-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4442,'ANDRE','J FRANCOIS','1948-06-22','02.96.54.93.74',NULL,NULL,'12 RUE LA MARE AUX ANGOTS','','','14123','IFS',NULL,NULL,'1480614088001',4.000000000,'1976-12-01','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4443,'AUBER','PIERRE','1966-07-05','02.53.01.53.42','06.35.64.40.51',NULL,'8 RUE AUGUSTE LECHESNE','','','14460','COLOMBELLES',NULL,NULL,'1660714666001',172.000000000,'1993-12-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4444,'LETIRAND','ROGER','1955-08-06','02.41.70.84.70','06.10.15.75.89',NULL,'178 rue d auge','','','14000','CAEN',NULL,NULL,'2550814712001',525.000000000,'1981-10-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4445,'PEZERIL','MADELEINE','1935-08-24','02.86.09.84.17','06.43.58.14.33',NULL,'620 rue de la mare','','','14210','TROIS MONTS',NULL,NULL,'2350814103001',603.000000000,'1957-12-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4446,'LOIR','CHRISTIAN','1969-11-08','02.85.29.60.67','06.85.95.83.17',NULL,'6 ALLEE VASCO DE GAMA','','','14120','MONDEVILLE',NULL,NULL,'2691150611001',4.000000000,'1992-07-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4447,'LANGLOIS','ALAIN','1935-02-15','02.10.12.32.77','06.41.18.56.06',NULL,'1 ALLEE DES POETES','','','78410','AUBERGENVILLE',NULL,NULL,'1350214123001',12.000000000,'1961-07-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4448,'LECHEVALLIER','david','1963-06-10','02.80.50.84.17','06.80.27.83.36',NULL,'359 RUE DE LA MARE','','',NULL,NULL,NULL,NULL,'1630699255001',12.000000000,'1987-08-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4449,'LECHEVALLIER','JEAN PIERRE','1931-08-13','02.43.84.31.14','06.45.23.26.49',NULL,'4 RUE DE BULLY','','','14840','DEMOUVILLE',NULL,NULL,'1310814489001',10.000000000,'1955-01-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4450,'CANCIAN','GISELE','1938-11-05','02.11.23.25.19','06.31.80.14.56',NULL,'5 PLACE GEORGES CLEMENCEAU','','','14123','IFS',NULL,NULL,'2381114622001',96.000000000,'1959-08-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4451,'BEREZIAK','MONIQUE','1952-05-30','02.10.97.52.64','06.63.96.28.42',NULL,'5 IMPASSE DES OEILLETS','','','50440','GREVILLE HAGUE',NULL,NULL,'2520514640001',1.000000000,'1974-11-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4452,'FRANCOIS','FRANCINE','1930-07-16','02.57.27.14.96','06.37.05.63.64',NULL,'60 rue st jacques','','','14960','ASNELLES',NULL,NULL,'1300780579001',270.000000000,'1954-02-14','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4453,'CHANDON','JACQUELINE','1936-12-02','02.66.33.11.07','06.10.46.65.83',NULL,'','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1361214047001',42.000000000,'1966-02-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4454,'MOLVEAUX','PATRICE','1946-01-26','02.51.40.31.85','06.87.72.42.90',NULL,'61 RUE DE FALAISE','','','14110','CONDE SUR NOIREAU',NULL,NULL,'1460150127001',1079.000000000,'1969-01-19','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4455,'MICHEL','pascal','1934-03-22','02.92.37.34.59','06.65.90.85.21',NULL,'LE BOULAY','','','14000','CAEN',NULL,NULL,'2340314030001',38.000000000,'1958-05-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4456,'CONTZLER','PIERRE','1930-09-27','02.73.78.82.10','06.65.62.31.41',NULL,'3 RUE DU LONG ACRE','','','14000','CAEN',NULL,NULL,'1300950499001',25.000000000,'1952-08-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4457,'LANOE','DENIS','1957-08-30','02.71.09.48.22','06.56.83.92.63',NULL,'93 RUE CAPONIERE SERVICE BERNADE','TTE II','','14190','ST SYLVAIN',NULL,NULL,'2570814366001',20.000000000,'1978-03-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4458,'LOUET','SYLVIANE','1953-01-25','02.17.37.32.00','06.42.02.87.64',NULL,'15 RUE DE BELLEVUE','','','14370','AIRAN',NULL,NULL,'1530114106001',10.000000000,'1975-10-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4459,'CHAPLAIN','JANINE','1929-07-13','02.27.92.30.12','06.61.58.51.20',NULL,'11 rue du stade','','','14000','CAEN',NULL,NULL,'2290743073001',1369.000000000,'1958-12-01','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4460,'LESOUEF','YVES','1935-12-01','02.66.89.42.36','06.73.98.87.58',NULL,'FERIERE DU VAL','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2351214275001',45.000000000,'1962-11-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4461,'HENRY','YVETTE','1932-07-18','02.97.81.03.36','06.51.66.42.92',NULL,'2 LONGUE VUE DES MUSICIENS','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2320714353001',153.000000000,'1962-08-10','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4462,'BEAUPLET','LIONEL','1937-01-18','02.11.77.00.80','06.35.20.59.50',NULL,'7 BIS RUE PORTE MILLET','','','14940','SANNERVILLE',NULL,NULL,'1370161298001',1527.000000000,'1958-05-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4463,'LEGRAND','MARIE LOUISE','1933-11-09','02.47.84.69.76','06.15.09.81.08',NULL,'11 CHEMIN DE L''AVONDE','','','14730','GIBERVILLE',NULL,NULL,'2331114746001',12.000000000,'1962-04-12','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4464,'BEAUDOUIN','ROBERT','1930-09-23','02.26.92.93.35','06.11.40.55.07',NULL,'GRANDE RUE','','','14000','CAEN',NULL,NULL,'2300914103001',158.000000000,'1951-01-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4465,'MANCEL','COLETTE','1944-01-17','02.31.87.28.19','06.28.07.72.39',NULL,'RUE GUY MAUPASSANT','','','50180','AGNEAUX',NULL,NULL,'2440114629001',2988.000000000,'1965-06-17','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4466,'AUMONT','MADELEINE','1934-08-12','02.66.93.74.90',NULL,NULL,'50 AV DE L EUROPE','','','14540','SOLIERS',NULL,NULL,'2340814046001',1444.000000000,'1958-01-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4467,'HEUDRON','STEPHANE','1928-08-29','02.11.67.39.03','06.24.82.75.03',NULL,'6  RUE  GUILLAUME','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1280814462001',46.000000000,'1950-04-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4468,'CAPELLI','ROGER','1945-01-15','02.10.84.77.70','06.36.33.55.73',NULL,'ROUTE DEPARTEMENTALE','','','14510','HOULGATE',NULL,NULL,'1450114092001',33.000000000,'1967-08-21','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4469,'SAINT JAMES','ROLANDE','1932-03-23','02.83.98.63.33','06.72.41.66.59',NULL,'3 IMPASSE DES ALPES','','','14610','THAON',NULL,NULL,'2320376466001',18.000000000,'1954-05-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4470,'TISON','MARTINE','1940-05-05','02.79.59.45.19','06.22.10.44.72',NULL,'7 RUE INSTOW','','',NULL,NULL,NULL,NULL,'1400514628001',228.000000000,'1961-03-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4471,'GAMBLIN','MARIE ROSE','1938-09-29','02.21.31.88.97','06.11.09.81.79',NULL,'28 ROUTE DE CAUMONT','','','14120',NULL,NULL,NULL,'1380914336001',788.000000000,'1961-11-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4472,'KANDELAKI','ALAIN','1940-05-31','02.72.00.59.47','06.32.07.90.00',NULL,'LE ROCHER ROUSSIN','','','27210','ST PIERRE DU VAL',NULL,NULL,'2400514254001',1072.000000000,'1963-12-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4473,'WYKA','ROBERT','1947-06-22','02.25.40.28.19','06.44.07.28.33',NULL,'9 rue de l avenir','','','14120','MONDEVILLE',NULL,NULL,'1470614405001',437.000000000,'1971-04-01','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4474,'LAULIER','DANIEL','1961-02-06','02.21.56.02.83','06.53.66.67.63',NULL,'42 rue du marais','','','14000','CAEN',NULL,NULL,'2610214366001',8.000000000,'1982-11-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4475,'CHARUEL','SERGE','1965-09-13','02.53.25.85.80','06.33.05.59.70',NULL,'7 RUE VOLTAIRE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2650950494001',92.000000000,'1995-05-04','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4476,'PESQUEREL','Marie antoinette','1963-06-10','02.10.17.64.91','06.89.70.91.18',NULL,'5 RUE DE L''ANGELUS','','','14730','GIBERVILLE',NULL,NULL,'2630614208001',83.000000000,'1985-09-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4477,'VIGAN','MICHEL','1933-07-08','02.46.41.57.81','06.61.84.19.81',NULL,'3 allee des poetes','','','14000','CAEN',NULL,NULL,'2330714465001',464.000000000,'1956-10-17','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4478,'GUILLOTIN','DANIEL','1944-01-04','02.45.00.41.60','06.18.36.18.40',NULL,'9 RUE MOZART','','','14123','IFS',NULL,NULL,'1440150252001',82.000000000,'1970-08-11','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4479,'JEANNE','JOSIANE','1965-08-19','02.23.47.53.63','06.76.80.32.80',NULL,'RD 579','','','14320','FONTENAY LE MARMION',NULL,NULL,'2650814305001',203.000000000,'1994-01-07','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4480,'MOSQUERON','GUY','1932-09-25','02.53.61.68.55','06.22.77.80.19',NULL,'9 RUE ROBERT CHABOT','','','14540','BOURGUEBUS',NULL,NULL,'1320914658001',434.000000000,'1957-06-01','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4481,'BAUDRON','Gisele','1934-08-13','02.23.32.91.28','06.71.78.20.53',NULL,'11 RUE BOUT MENARD','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1340814341001',40.000000000,'1957-05-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4482,'LEPLANQUOIS','PAULETTE','1947-02-03','02.89.14.25.79','06.19.61.82.75',NULL,'CHEMIN DU PETIT LIEU','','','14350','LA FERRIERE HARANG',NULL,NULL,'2470250128001',70.000000000,'1971-02-16','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4483,'GURY','CATHERINE','1944-03-23','02.82.51.47.95','06.31.19.54.19',NULL,'6 rue pasteur','','','14460','COLOMBELLES',NULL,NULL,'1440314740001',10.000000000,'1970-01-31','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4484,'BASSINET','michel','1936-06-02','02.56.51.34.33','06.33.65.86.44',NULL,'29 BD POINTCARRE','','','14940','SANNERVILLE',NULL,NULL,'1360653130001',2469.000000000,'1965-04-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4485,'OLARD','OLIVIER','1939-01-24','02.32.16.44.10','06.20.53.96.66',NULL,'6 cite des castors','','','14000','CAEN',NULL,NULL,'1390150512001',2826.000000000,'1967-02-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4486,'BRUNET','SYLVIE','1938-01-07','02.76.44.82.94','06.27.60.04.95',NULL,'16 rue de la clef des champs','','','50760','BARFLEUR',NULL,NULL,'2380101288001',103.000000000,'1960-11-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4487,'PERON','ALAIN','1950-02-25','02.28.30.14.69','06.42.62.85.57',NULL,'35 rue edouard vaillant','','','14120','MONDEVILLE',NULL,NULL,'2500214590001',536.000000000,'1975-06-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4488,'VARIN','Vronique',NULL,'02.10.59.57.20','06.53.52.67.12',NULL,'route de lorguichon','','','14000','CAEN',NULL,NULL,'2520178313001',601.000000000,'2013-05-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4489,'MAHIET','CHANTAL','1940-07-17','02.11.82.68.79','06.53.09.23.39',NULL,'175 RUE D''AUGE','','','14400','SOMMERVIEU',NULL,NULL,'1400714384001',40.000000000,'1961-02-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4490,'VACHON','jean','1939-04-20','02.69.58.48.87','06.44.31.00.57',NULL,'72 AVENUE CHARLES DE GAULLE','','','27170','BEAUMONT LE ROGER',NULL,NULL,'1390414129001',142.000000000,'1963-12-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4491,'AUBIN','andre','1948-02-15','02.88.70.03.57','06.79.12.40.98',NULL,'6 rue de l aubepine','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1480250560001',43.000000000,'1969-11-25','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4492,'COSNARD','Mireille','1932-03-14','02.79.63.90.85','06.64.31.16.34',NULL,'13 bis rue du marais','','','14123','IFS',NULL,NULL,'1320314146001',80.000000000,'1957-06-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4493,'SALLEY','Maurice','1938-02-25','02.66.11.56.72','06.21.38.67.90',NULL,'20 rue saint gilles','','','14540','SOLIERS',NULL,NULL,'1380214483001',21.000000000,'1960-12-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4494,'LEZE','JACQUES','1929-11-23','02.77.99.69.93','06.47.92.81.12',NULL,'13 place de la mairie','','','14123','IFS',NULL,NULL,'1291114334001',112.000000000,'1950-11-08','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4495,'LANGELEY','Roger','1967-05-27','02.83.85.36.82','06.35.73.56.10',NULL,'4 rue du moulin a voide','','','14120','MONDEVILLE',NULL,NULL,'2670514383001',2511.000000000,'1992-09-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4496,'GELHAY','jeannine','1937-08-20','02.93.35.05.56','06.80.35.21.24',NULL,'9 place des cevennes','','','14000','CAEN',NULL,NULL,'2370817306001',32.000000000,'1967-04-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4497,'ALEXANDRE','SERGE','1930-12-07','02.40.59.27.22','06.51.33.89.65',NULL,'RUE DE VAL AU SIOU LES BRUYERES','','','14000','CAEN',NULL,NULL,'1301214666001',178.000000000,'1959-09-11','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4498,'LEBAILLY','jeannine','1934-12-18','02.22.09.15.63','06.10.79.13.06',NULL,'62 BIS BOULEVARD MARECHAL LYAUTE','Y','','50450','GAVRAY',NULL,NULL,'2341214543001',845.000000000,'1955-08-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4499,'JACQUELINE','jean luc','1934-01-29','02.77.91.56.41','06.45.69.16.17',NULL,'3 RUE DU LONG ACRE','','','14130','ST BENOIT D''HEBERTOT',NULL,NULL,'1340114409001',520.000000000,'1956-09-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4500,'CHENARD','ROGER','1960-05-08','02.41.03.65.71','06.29.09.13.20',NULL,'9 PLACE REINE MATHILDE','','','61230','MARDILLY',NULL,NULL,'1600514458001',54.000000000,'1982-07-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4501,'','BERNARD','1933-11-24','02.12.13.49.71','06.12.02.52.44',NULL,'17 RUE HAMPSHIRE','','','14940','SANNERVILLE',NULL,NULL,'1331150597001',444.000000000,'1954-07-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4502,'AUSSANT','YVES','1939-09-09','02.10.58.58.25','06.12.10.07.05',NULL,'3 RUE DE L EGLISE','','','61210','STE HONORINE LA GUILLAUME',NULL,NULL,'1390950404001',94.000000000,'1969-07-30','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4503,'DOULE','dany','1928-08-21','02.42.40.76.31','06.45.43.64.98',NULL,'27 rue jean mermoz','','','14123','IFS',NULL,NULL,'1280814172001',2382.000000000,'1952-10-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4504,'CATHERINE','Jeannine','1959-04-17','02.44.30.88.01','06.41.93.36.64',NULL,'64 RUE DES ECORDIERES','','','14430','DOZULE',NULL,NULL,'2590414396001',14.000000000,'1988-04-30','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4505,'PIERRE','PIERRE','1928-01-18','02.10.03.57.01','06.12.33.53.47',NULL,'8 CHEMIN DU BOUT NEUF','','','50680','ST GEORGES D''ELLE',NULL,NULL,'2280122028001',831.000000000,'1954-09-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4506,'DONDEL','EMMANUEL','1930-11-06','02.65.57.86.60','06.95.43.68.58',NULL,'7 RUE STE PAIX PORTE B','','','14210','CHEUX',NULL,NULL,'2301150318001',139.000000000,'1951-01-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4507,'LE VILLAIN','CLAUDE','1940-07-04','02.70.66.42.44','06.44.21.55.04',NULL,'CHEMIN DE L''EGLISE','','','61000','ALENCON',NULL,NULL,'2400761199001',14.000000000,'1965-10-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4508,'','ELIANE','1935-12-13','02.64.60.83.79','06.75.86.83.58',NULL,'LA BRUYERE','','','14970','BENOUVILLE',NULL,NULL,'1351250641001',4161.000000000,'1958-06-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4509,'LECOCQ','ODILE','1936-09-25','02.61.00.22.00','06.53.47.35.07',NULL,'3 rue joseph levilly','','','14670','TROARN',NULL,NULL,'2360914229001',50.000000000,'1964-06-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4510,'FAUCON','marc','1942-05-22','02.19.83.15.66','06.11.92.54.67',NULL,'LES GUESROULT','','','14860','RANVILLE',NULL,NULL,'1420514355001',703.000000000,'1966-07-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4511,'DURAND','GUY','1968-04-23','02.62.25.34.80','06.12.11.57.60',NULL,'3 RUE MATHIEU  LANES','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2680414281001',888.000000000,'1998-01-27','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4512,'LEMIERE','MARCEL','1941-11-03','02.50.73.75.60','06.98.88.15.36',NULL,'rue des rosiers','','','14630','FRENOUVILLE',NULL,NULL,'2411114526001',152.000000000,'1963-07-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4513,'DUPONT','yannick','1936-01-31','02.83.58.90.50','06.56.35.07.21',NULL,'75 rue eustache restoux','','','14123','IFS',NULL,NULL,'2360114197001',24.000000000,'1966-02-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4514,'MARIE','Gilberte','1935-08-10','02.37.61.69.62','06.54.35.49.71',NULL,'2 AVENUE DE CHUDLEIGH','','','14123','FLEURY SUR ORNE',NULL,NULL,'2350814720001',60.000000000,'1960-11-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4515,'BOSQUAIN','JANINE','1933-09-18','02.84.78.88.95','06.92.63.16.54',NULL,'23 RUE DES DRAKKARS','','','14000','CAEN',NULL,NULL,'1330914003001',441.000000000,'1957-06-29','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4516,'','Henri','1941-01-08','02.25.52.84.81','06.83.78.41.15',NULL,'CHEMIN DE LA HAIE MASSIER','','','14540','SOLIERS',NULL,NULL,'2410114188001',58.000000000,'1968-06-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4517,'LECOCQ','Michele','1936-08-03','02.92.26.51.20','06.66.71.09.75',NULL,'CHEMIN DE LA TRIGALE','','','14940','SANNERVILLE',NULL,NULL,'1360814508001',20.000000000,'1957-02-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4518,'BASSAQUE','Jacques','1932-02-24','02.23.15.29.50','06.78.91.10.16',NULL,'LE BOURG','','','14220','FRESNEY LE VIEUX',NULL,NULL,'1320261006001',20.000000000,'1959-11-18','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4519,'SIMON','ROGER','1930-08-07','02.83.28.39.44','06.96.92.38.91',NULL,'LA CHARTIERE','','','61200','OCCAGNES',NULL,NULL,'1300814613001',36.000000000,'1955-10-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4520,'MASSIEU','YVES','1932-08-21','02.54.38.17.04','06.25.40.28.45',NULL,'52 ROUTE DE PARIS','','','14460','COLOMBELLES',NULL,NULL,'2320875015001',150.000000000,'1960-12-20','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4521,'ANNE','CLAUDE','1939-04-30','02.12.05.94.89','06.10.40.90.47',NULL,'22 RUE HENRY BRUNET','','','14480','CREULLY',NULL,NULL,'1390414076001',850.000000000,'1969-08-21','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4522,'LEPESTEUR','GISELE','1945-02-09','02.78.26.54.26','06.82.92.58.16',NULL,'76 RUE DE LA GUERINIERE','','','14000','CAEN',NULL,NULL,'2450214075001',714.000000000,'1969-09-03','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4523,'LEPESTEUR','pierre','1935-02-13','02.88.25.03.30','06.82.98.91.86',NULL,'26 RUE DU CLOS HERBERT','','','14000','CAEN',NULL,NULL,'1350261315001',19.000000000,'1965-12-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4524,'LHOMMET','Emilienne','1935-02-14','02.89.01.15.71','06.45.73.76.99',NULL,'62 RUE DE LA CHAPELLE','','','14690','PONT D''OUILLY',NULL,NULL,'1350261315001',988.000000000,'1961-05-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4525,'HAMEL','Roger','1932-02-01','02.84.32.73.51','06.73.66.03.47',NULL,'605 QUARTIER DU VAL','','','14120','MONDEVILLE',NULL,NULL,'2320214237001',221.000000000,'1959-03-28','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4526,'LAVACHE','Jean claude','1936-10-30','02.84.97.25.10','06.15.67.80.64',NULL,'2 rue des acacias','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2361014712001',83.000000000,'1958-10-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4527,'HALLEY','Paulette','1930-08-29','02.46.65.48.16','06.12.06.14.31',NULL,'mary tavy','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2300814670001',82.000000000,'1952-04-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4528,'VALLEE','ROGER','1964-03-12','02.76.36.37.66','06.72.65.27.40',NULL,'3 bis rue victor lepinne','','','14280','ST CONTEST',NULL,NULL,'2640314739001',79.000000000,'1993-07-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4529,'FLEURY','robert','1960-05-22','02.58.37.57.89','06.11.89.23.74',NULL,'24 AVENUE  DU 18 AOUT 1944','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2600545244001',386.000000000,'1983-02-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4530,'SAUVAGE','MAURICE','1961-02-06','02.68.08.15.63','06.90.22.53.68',NULL,'la neuville','','','14000','CAEN',NULL,NULL,'2610214150001',87.000000000,'1984-01-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4531,'DOUBLET','Michel','1955-02-18','02.63.59.58.96','06.17.16.93.44',NULL,'10 RUE VALLEUIL RESIDENCE CLAIR',' SOLEIL','','14112','BIEVILLE BEUVILLE',NULL,NULL,'2550214673001',463.000000000,'1980-01-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4532,'RECOURSE','louis','1944-01-19','02.40.85.05.51','06.25.95.70.37',NULL,'6 rue auguste le chene','','','14240','FEUGUEROLLES SUR SEULLES',NULL,NULL,'1440114637001',491.000000000,'1974-04-18','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4533,'GUILLOT','ANDRE','1953-01-31','02.47.17.96.77','06.10.46.12.43',NULL,'14 rue des tilleuls','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1530114670001',178.000000000,'1979-03-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4534,'JORE','mathieu','1964-07-01','02.92.68.56.30','06.56.67.69.11',NULL,'20 RUE AUX PIERROTS','','','14220','DONNAY',NULL,NULL,'1640714331001',58.000000000,'1985-06-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4535,'LANGLOIS','Jean Claude','1929-11-22','02.84.56.58.52','06.54.17.99.59',NULL,'2 RUE DE LA DIVES','','','50190','ST GERMAIN SUR SEVES',NULL,NULL,'2291172171001',314.000000000,'1950-01-21','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4536,'GOURDIN','GERARD','1938-05-09','02.76.10.02.46','06.49.55.09.47',NULL,'12 rue guitry','','','50630','MORSALINES',NULL,NULL,'1380514648001',849.000000000,'1967-12-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4537,'LAMOTTE','Yvanne','1978-12-24','02.11.13.22.77','06.11.03.73.27',NULL,'4 TER ROUTE D''HARCOURT','','','14630','FRENOUVILLE',NULL,NULL,'1781299408001',950.000000000,'2002-07-28','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4538,'ESNAUD','adolphe','1931-11-09','02.27.54.76.75','06.42.09.88.20',NULL,'5 RUE THERESE DE LA VARDE','','','14220','OUFFIERES',NULL,NULL,'1311114106001',3.000000000,'1954-07-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4539,'FOUQUES','FABIENNE','1932-02-24','02.39.37.24.87','06.77.40.19.63',NULL,'403 LE VAL','','','50100','CHERBOURG OCTEVILLE CEDEX',NULL,NULL,'1320214236001',326.000000000,'1956-03-20','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4540,'LECOUTURIER','JEAN','1932-05-13','02.36.45.67.07','06.25.70.93.03',NULL,'1102 haute folie','','','14860','ROBEHOMME',NULL,NULL,'1320514240001',11.000000000,'1953-06-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4541,'HALLOT','Jacqueline','1934-03-17','02.38.94.02.78','06.41.46.60.83',NULL,'6 route de paris','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1340314551001',2170.000000000,'1963-06-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4542,'HALOT','PIERRE','1962-09-20','02.66.10.82.96','06.33.78.52.24',NULL,'172 BIS RUE PASTEUR','','','14000','CAEN',NULL,NULL,'2620914353001',212.000000000,'1992-05-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4543,'BARATTE','Suzanne','1959-01-30','02.95.36.95.66','06.21.09.18.02',NULL,'36 BOULEVARD JACQUES DUCLOS','','','14750','ST AUBIN SUR MER',NULL,NULL,'1590114213001',1037.000000000,'1989-04-14','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4544,'GRANGE','ANTOINETTE','1939-07-15','02.77.74.87.97',NULL,NULL,'21 RUE DE LA VALLEE DE L''AY','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1390750190001',71.000000000,'1962-10-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4545,'FLEURY','ELISABETH','1939-07-12','02.81.91.07.24','06.56.85.69.20',NULL,'21 RUE DE LA VALLEE DE L''AY','','','14120','MONDEVILLE',NULL,NULL,'1390753114001',233.000000000,'1967-05-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4546,'CHOISY','EUGENIE','1964-11-17','02.53.70.50.10','06.28.80.62.99',NULL,'4 RUE DES CHARDONNERETS','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'1641114118001',75.000000000,'1991-03-08','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4547,'HAREL','PIERRE','1934-01-09','02.74.44.37.31',NULL,NULL,'CAREL','','','14270','QUETIEVILLE',NULL,NULL,'1340150099001',6.000000000,'1964-10-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4548,'DOUBLET','JOEL','1932-01-15','02.70.61.46.37','06.83.12.86.25',NULL,'LA BORDERIE','','','14730','GIBERVILLE',NULL,NULL,'2320149204001',12.000000000,'1955-07-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4549,'MALFILATRE','ANNICK','1932-11-16','02.13.06.93.31','06.59.90.63.23',NULL,'39 RUE LOUIS ARAGON','','','14000','CAEN',NULL,NULL,'1321114209001',38.000000000,'1957-08-27','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4550,'LECORDIER','Alain','1961-03-22','02.47.75.39.62','06.10.43.08.81',NULL,'12 rue des jardins','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1610314499001',1193.000000000,'1990-12-14','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4551,'GERMOND','HUBERT','1937-01-24','02.49.55.00.27','06.95.03.12.17',NULL,'4 sente au coin','','','50480','STE MERE EGLISE',NULL,NULL,'1370153189001',87.000000000,'1967-11-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4552,'MACE','ROGER','1939-03-12','02.69.88.12.41','06.41.19.71.43',NULL,'12 rue des treize acres','','','14620','LE MARAIS LA CHAPELLE',NULL,NULL,'2390314666001',93.000000000,'1968-10-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4553,'MENARD','SUZANNE','1942-04-09','02.84.05.56.72','06.40.20.48.65',NULL,'2 RUE DES FINLANDAIS','','','14120','MONDEVILLE',NULL,NULL,'1420427129001',1433.000000000,'1967-08-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4554,'LE LIVEC','NICOLE','1935-12-14','02.30.69.16.43','06.25.96.12.85',NULL,'2 IMPASSE JEAN MACE','','','14670','ST OUEN DU MESNIL OGER',NULL,NULL,'1351276558001',848.000000000,'1959-12-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4555,'LE VIVIER','GERARD','1962-02-01','02.63.58.65.96','06.68.09.33.22',NULL,'1 allleee  du basilic','','','14000','CAEN',NULL,NULL,'1620250548001',239.000000000,'1987-01-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4556,'AUMONT','RAYMOND','1938-01-10','02.95.42.15.16','06.89.91.93.22',NULL,'5 RUE DU 19 MARS 1962','','','14370','MOULT',NULL,NULL,'1380114061001',646.000000000,'1962-01-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4557,'AWAD AHMED','CLODILE','1968-11-20','02.89.30.38.65','06.62.33.42.42',NULL,'5 IMPASSE DE L''ESCALIER','','','14150','OUISTREHAM',NULL,NULL,'1681114305001',184.000000000,'1993-01-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4558,'QUERNET','GILLES','1933-06-11','02.27.07.87.95','06.28.15.07.55',NULL,'7 RUE APOLLO II','','','14370','CLEVILLE',NULL,NULL,'2330650364001',74.000000000,'1961-04-28','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4559,'HUET','JEAN','1939-02-13','02.87.97.27.66','06.45.18.15.81',NULL,'8 RUE DES GRES','','','14740','STE CROIX GRAND TONNE',NULL,NULL,'2390214013001',16.000000000,'1966-10-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4560,'DERENEMESNIL','Odette','1929-03-16','02.38.48.66.78','06.99.65.23.59',NULL,'3 rue de l ancienne gare','','','14000','CAEN',NULL,NULL,'1290314192001',1452.000000000,'1950-10-06','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4561,'ELISABETH','Lionel','1956-02-09','02.71.06.79.84','06.37.19.67.02',NULL,'20 GRANDE RUE','','','61120','VIMOUTIERS',NULL,NULL,'2560214290001',21.000000000,'1985-04-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4562,'LEPROVOST','Hlne','1931-07-19','02.29.39.55.67','06.72.98.59.61',NULL,'27 RUE DES AMICALES','','','14630','FRENOUVILLE',NULL,NULL,'1310714119001',38.000000000,'1955-07-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4563,'JOURDAN','bernard','1940-03-25','02.90.01.52.84','06.54.76.78.64',NULL,'6 RUE DES ERABLES','','','14370','AIRAN',NULL,NULL,'2400314554001',218.000000000,'1961-08-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4564,'JEANNE','Janine','1939-08-23','02.62.80.13.58','06.88.97.47.57',NULL,'7 RUE JEAN JACQUES ROUSSEAU','','','14840','CUVERVILLE',NULL,NULL,'2390827024001',760.000000000,'1960-11-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4565,'L HOPITAL BURDIN','Andre','1935-11-08','02.21.03.02.10','06.82.92.63.41',NULL,'LE CALVAIRE','','','14630','CAGNY',NULL,NULL,'1351150235001',272.000000000,'1959-09-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4566,'LE CORRE','COLETTE','1939-03-22','02.77.32.36.15','06.21.11.08.79',NULL,'64 BD  DUNOIS','','','14000','CAEN',NULL,NULL,'2390364057001',84.000000000,'1960-12-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4567,'RAULD','Hlne','1952-01-06','02.67.50.40.66','06.10.69.83.78',NULL,'42 RUE D A. L''ORFEVRE','','','14730','GIBERVILLE',NULL,NULL,'1520150410001',27.000000000,'1978-10-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4568,'LEHOC','Marcelle','1964-06-22','02.68.42.40.84','06.11.89.85.36',NULL,'67 le bas de cleville','','','14000','CAEN',NULL,NULL,'1640614525001',33.000000000,'1986-08-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4569,'BOULIER','THIERRY','1935-02-26','02.24.71.84.15','06.54.46.23.99',NULL,'31 RUE ARMAND MARIE','','','14000','CAEN',NULL,NULL,'1350214659001',168.000000000,'1957-12-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4570,'BOUHANS','FRANCOIS','1962-01-08','02.43.43.67.17','06.62.87.64.73',NULL,'20 avenue du 6 juin','','','14730','GIBERVILLE',NULL,NULL,'2620114221001',285.000000000,'1989-12-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4571,'GENEST','RAYMONDE','1930-11-17','02.16.07.97.61','06.35.23.99.05',NULL,'65 rue du xx siecle','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1301122220001',693.000000000,'1960-02-08','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4572,'MARIE','NADINE','1938-05-09','02.77.88.96.79','06.16.10.31.98',NULL,'LES FORGETTES','','','14000','CAEN',NULL,NULL,'1380514118001',203.000000000,'1965-11-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4573,'LEROUX','BERNARD','1929-02-19','02.81.26.85.82','06.10.57.45.90',NULL,'32 rue saint ouen','','','14460','COLOMBELLES',NULL,NULL,'1290261401001',519.000000000,'1952-08-12','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4574,'BRAULT','MARIE HENRIETTE','1936-10-02','02.23.40.54.36','06.39.96.79.47',NULL,'LES ECHELLERIES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1361050083001',88.000000000,'1959-04-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4575,'LAURENT','JACQUELINE','1930-11-29','02.31.24.60.78','06.19.11.68.42',NULL,'32 RUE DES PLATANES','','','14000','CAEN',NULL,NULL,'1301154339001',173.000000000,'1957-07-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4576,'DUBOIS','Pierre','1942-01-09','02.14.61.10.11','06.99.54.81.80',NULL,'56 rue louis robillard','','','14540','BOURGUEBUS',NULL,NULL,'1420114554001',1128.000000000,'1966-04-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4577,'HUE','allain','1934-05-14','02.37.74.20.57',NULL,NULL,'26 rue saint didace','','','14000','CAEN',NULL,NULL,'2340514207001',3650.000000000,'1959-01-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4578,'JAMES','CECILE','1963-04-18','02.83.14.58.59','06.23.27.83.53',NULL,'7 rue capitaine kalinigrenko','','','28300','LEVES',NULL,NULL,'1630414294001',250.000000000,'1987-10-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4579,'LECAUDEY','Denis','1925-03-09','02.11.53.06.56','06.18.48.69.82',NULL,'11 RUE DU BOUT QUESDON','','','14510','GONNEVILLE SUR MER',NULL,NULL,'2250336171001',123.000000000,'1948-05-27','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4580,'LE ROY','JEAN CLAUDE','1935-02-21','02.82.56.61.83','06.64.75.36.45',NULL,'24 rue maurice fouque','','','14540','SOLIERS',NULL,NULL,'2350272205001',69.000000000,'1965-07-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4581,'GOUBIN','DENISE','1931-12-09','02.32.48.95.60','06.47.63.12.59',NULL,'LA CHAPELLE NOIRE MARE','','','14150','OUISTREHAM',NULL,NULL,'1311214614001',149.000000000,'1953-09-22','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4582,'CHASLES','RAYMONDE','1934-05-16','02.27.12.31.11','06.60.08.65.25',NULL,'5 RUE MORAN LE BESQUE','','','14930','ETERVILLE',NULL,NULL,'2340550029001',3994.000000000,'1961-09-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4583,'GOUDEAU','HUBERT','1928-01-08','02.48.26.90.00','06.37.34.46.49',NULL,'1 rue louis lachenal','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'1280177123001',42.000000000,'1951-10-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4584,'BAUMY','GISELE','1928-07-04','02.55.22.21.65','06.99.58.30.92',NULL,'18 av jean vilard','','','14840','DEMOUVILLE',NULL,NULL,'1280714100001',114.000000000,'1958-10-16','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4585,'POUJADE','CATHERINE',NULL,'02.24.57.05.45','06.12.26.76.54',NULL,'LES FIEFFES','','','14150','OUISTREHAM',NULL,NULL,'1290914562001',92.000000000,'2012-07-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4586,'LECOMTE','GERARD','1935-06-17','02.96.24.30.73','06.74.86.18.45',NULL,'12 CHEMIN DU BAS MANOIR','','','14000','CAEN',NULL,NULL,'2350614190001',15.000000000,'1956-12-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4587,'BLAISOT','MICHEL','1937-02-19','02.81.44.33.55','06.22.07.55.31',NULL,'2 chemin d''angoville','','','14700','NORON L''ABBAYE',NULL,NULL,'1370250379001',525.000000000,'1960-09-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4588,'LEROUVILLOIS','DOMINIQUE','1934-10-15','02.11.75.13.74',NULL,NULL,'rue des jardins','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'2341061485001',73.000000000,'1958-10-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4589,'TIRARD','GERARD','1964-01-10','02.43.43.29.10','06.52.44.15.23',NULL,'2 RUE DU CHATEAU','','','61200','ARGENTAN',NULL,NULL,'1640114738001',428.000000000,'1985-02-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4590,'CHASLE','JEAN PIERRE','1968-03-03','02.67.89.39.00','06.24.62.00.33',NULL,'23 RUE PAUL TOUTAIN','','','14540','ROCQUANCOURT',NULL,NULL,'2680314287001',1326.000000000,'1990-09-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4591,'FILMONT','BERNADETTE','1934-04-07','02.58.28.10.92','06.67.56.27.25',NULL,'7 place auguste duval','','','14120','MONDEVILLE',NULL,NULL,'1340461278001',19.000000000,'1961-04-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4592,'ROULANT','Edith','1935-12-03','02.48.06.28.39','06.77.43.22.22',NULL,'10 rue des moulins','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1351214458001',451.000000000,'1959-08-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4593,'TOUVIOT','SYLVIANE','1922-01-08','02.67.39.82.41','06.20.71.34.24',NULL,'le carrelet','','','14730','GIBERVILLE',NULL,NULL,'1220129150001',177.000000000,'1952-10-14','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4594,'LADAMNE','ROBERT','1930-12-09','02.25.49.82.38','06.64.85.63.06',NULL,'13 RUE DE FECAMP','','',NULL,NULL,NULL,NULL,'2301214407001',8.000000000,'1951-07-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4595,'THERESE','SYLVIANE','1928-09-27','02.18.69.09.97','06.43.70.38.30',NULL,'17 RUE LE DES','','','14000','CAEN',NULL,NULL,'2280914754001',382.000000000,'1958-10-09','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4596,'LECOMTE','CLAUDE','1959-02-05','02.79.32.70.69','06.34.07.20.68',NULL,'23 AVENUE ALBERT PREMIER','','','50200','COUTANCES',NULL,NULL,'2590214538001',197.000000000,'1987-06-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4597,'FOUQUES','YVELINE','1936-11-09','02.56.13.93.71','06.11.42.42.83',NULL,'14 avenue landry','','','14370','ARGENCES',NULL,NULL,'2361127040001',41.000000000,'1962-10-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4598,'MARIE','JEAN','1930-05-30','02.40.26.04.33','06.70.63.28.19',NULL,'5 RUE DES ORMES','','','14220','THURY HARCOURT',NULL,NULL,'2300514383001',2246.000000000,'1956-06-29','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4599,'VERGY','Yves','1930-06-05','02.11.43.60.70','06.29.37.96.42',NULL,'3 RUE DES MESANGES','','','14480','LANTHEUIL',NULL,NULL,'1300614703001',290.000000000,'1954-07-29','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4600,'SEBERT','LOUISE','1957-01-12','02.12.00.50.09','06.12.54.14.10',NULL,'159 rue haute','','','14250','BROUAY',NULL,NULL,'1570114271001',4149.000000000,'1985-12-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4601,'JEANNE','CHRISTIANE','1938-04-22','02.94.13.16.28','06.57.23.31.34',NULL,'5 rue d''aviron','','','50700','ST JOSEPH',NULL,NULL,'2380414090001',19.000000000,'1961-04-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4602,'KERIMOV','RENE','1961-08-13','02.27.56.00.73','06.17.33.10.55',NULL,'5 rue de l ecuyer','','','14610','CAMBES EN PLAINE',NULL,NULL,'1610814067001',1189.000000000,'1988-09-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4603,'CANONNE','',NULL,'02.62.47.01.25','06.66.42.03.65',NULL,'23 rue maurice lafont','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2460114424001',40.000000000,'2008-01-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4604,'GUILLEUX','ARLETTE','1936-02-12','02.40.10.33.76','06.23.44.05.82',NULL,'23 rue maurice lafont','','','61150','ECOUCHE',NULL,NULL,'2360214118001',89.000000000,'1961-12-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4605,'BINET','FRANCOISE','1936-06-17','02.63.76.51.77','06.18.02.47.53',NULL,'1050 rue de la republique','','','14000','CAEN',NULL,NULL,'1360650446001',339.000000000,'1963-03-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4606,'VALLEE','THERESE','1964-07-02','02.48.92.08.52','06.63.69.49.31',NULL,'31 le clos','','','14450','GRANDCAMP MAISY',NULL,NULL,'1640714331001',237.000000000,'1992-08-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4607,'HUARD','MAURICE','1949-01-13','02.79.54.85.87','06.63.88.97.24',NULL,'8 RUE D AUGE','','','14000','CAEN',NULL,NULL,'1490114188001',1862.000000000,'1979-10-31','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4608,'LEGOUIX','CHANTAL','1940-07-14','02.41.62.26.57','06.43.99.93.39',NULL,'30 route d''harcourt','','','14840','DEMOUVILLE',NULL,NULL,'1400714309001',129.000000000,'1961-06-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4609,'VASSEUR','Gerard','1962-12-29','02.10.04.84.94','06.12.11.22.70',NULL,'9 RUE ABBE BOISNE','','','14120','MONDEVILLE',NULL,NULL,'2621214461001',223.000000000,'1986-08-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4610,'DELACOUR','VADIM','1934-12-07','02.22.53.70.14','06.70.47.40.99',NULL,'61 RUE DU CHATEAU D''EAU','','',NULL,NULL,NULL,NULL,'1341214207001',162.000000000,'1957-01-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4611,'CLANET','MICHEL','1930-09-27','02.61.35.20.14','06.71.93.49.35',NULL,'lieu dit le menil gouffier','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'2300950087001',264.000000000,'1953-03-12','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4612,'COQUIN','Bernadette','1929-06-26','02.68.21.77.91','06.56.31.46.42',NULL,'10 RUE DE L''AVENIR','','','14000','CAEN',NULL,NULL,'1290614319001',44.000000000,'1953-04-01','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4613,'MAUREY','LOUIS','1929-03-01','02.53.44.99.86','06.17.81.75.52',NULL,'LE BOURG','','','14740','STE CROIX GRAND TONNE',NULL,NULL,'1290314636001',481.000000000,'1950-03-04','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4614,'GALLIER','thierry','1938-09-29','02.81.29.73.96','06.52.23.30.46',NULL,'4 RUE DU RIUSSEAU','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2380961312001',42.000000000,'1961-07-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4615,'GODARD','GILBERT','1933-02-27','02.22.80.03.23','06.47.59.35.03',NULL,'9 ALLEE DE DIELETTE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2330278563001',888.000000000,'1963-09-11','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4616,'MADELAINE','Raymond','1917-02-22','02.99.41.93.09','06.39.50.25.93',NULL,'49 rue paul sanson','','','14140','STE MARGUERITE DE VIETTE',NULL,NULL,'2170236101001',85.000000000,'1939-04-29','PREMIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4617,'CHAMPBERTAULD','JACQUES','1934-02-25','02.51.39.01.11','06.84.21.26.29',NULL,'6 rue des rougemont','','','14120','MONDEVILLE',NULL,NULL,'1340214553001',2503.000000000,'1955-03-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4618,'MOREL','ODETTE','1931-07-23','02.79.47.72.35','06.73.54.73.79',NULL,'LES 4 CHAMPS ST LO D''OURVILLE','','','50790','BRUCHEVILLE',NULL,NULL,'2310714666001',38.000000000,'1960-12-15','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4619,'RAS','Marcelle','1934-08-01','02.93.11.49.80','06.99.37.20.85',NULL,'9 rue dr yvonnet','','','14370','CLEVILLE',NULL,NULL,'2340814057001',2.000000000,'1958-12-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4620,'CHAPUIS','NICOLE',NULL,'02.78.12.28.65','06.64.20.08.59',NULL,'3 rue jean marot','','','14000','CAEN',NULL,NULL,'1581214280001',210.000000000,'2012-11-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4621,'LEROSIER','NICOLE','1928-01-02','02.53.99.61.21','06.71.59.79.80',NULL,'16 rues des rames','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'2280172154001',17.000000000,'1950-07-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4622,'PHILIPPE','JEAN','1955-03-28','02.30.22.90.06','06.77.31.55.22',NULL,'le tremblais','','','61200','ARGENTAN',NULL,NULL,'1550314753001',5.000000000,'1978-03-28','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4623,'MARIE','CHRISTIANE','1929-09-30','02.11.92.04.27','06.22.05.20.07',NULL,'152 rte de valmont','','','14260','BONNEMAISON',NULL,NULL,'1290914174001',101.000000000,'1957-04-30','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4624,'FOSSEY','jean luc','1938-04-19','02.10.07.10.50','06.38.63.45.03',NULL,'2 rue j prevert','','','14670','TROARN',NULL,NULL,'1380414471001',198.000000000,'1968-11-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4625,'LEFFRAY','ludovic','1938-03-23','02.36.17.72.61','06.58.15.50.79',NULL,'RUE GUJAN MESTRAS','','','14000','CAEN',NULL,NULL,'1380314517001',139.000000000,'1963-04-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4626,'VANDENBERGHE','ELISE','1935-06-12','02.65.46.00.86','06.37.53.27.15',NULL,'64 ROUTE DE BRETAGNE','','','14860','RANVILLE',NULL,NULL,'2350614266001',102.000000000,'1957-03-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4627,'DAMBRINE','DANIEL','1962-11-28','02.52.33.28.44','06.85.83.52.10',NULL,'26 rue d'' helsinski','','','14000','CAEN',NULL,NULL,'1621114158001',41.000000000,'1983-02-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4628,'CHEVALIER','gilbert','1966-03-26','02.18.89.54.32','06.71.82.05.95',NULL,'','','','14000','CAEN',NULL,NULL,'1660302326001',1276.000000000,'1987-02-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4629,'BARBIER','JACQUELINE','1931-05-18','02.10.80.12.16','06.70.48.53.77',NULL,'14 RUE DE LA HAYE BRETON','','','14540','ROCQUANCOURT',NULL,NULL,'1310514020001',26.000000000,'1953-03-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4630,'RICHIDE','MICHEL','1931-01-01','02.95.83.86.67','06.97.52.27.98',NULL,'78 av jean jaures','','','61430','ATHIS DE L''ORNE',NULL,NULL,'1310103314001',266.000000000,'1953-03-12','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4631,'LEMOIGNE','MARYSE','1930-08-15','02.40.71.05.20','06.86.67.96.22',NULL,'4 RUE DES PLEIN CHAMPS','','','14670','TROARN',NULL,NULL,'2300861020001',997.000000000,'1956-12-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4632,'AUDE','DANY','1929-09-20','02.70.82.25.96','06.73.61.45.64',NULL,'40 rue e varlain','','',NULL,NULL,NULL,NULL,'1290914100001',74.000000000,'1954-05-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4633,'BANCE','SANDRINE','1949-05-20','02.87.63.53.29','06.38.75.13.10',NULL,'7 BOULEVARD VICTOR HUGO','','','14790','VERSON',NULL,NULL,'1490514595001',33.000000000,'1978-05-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4634,'LEBAS','SERGE','1933-02-04','02.33.06.64.91','06.50.90.94.44',NULL,'9 ALLEE WINNIPEG','','','14000','CAEN',NULL,NULL,'2330214438001',474.000000000,'1954-03-01','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4635,'GERVELAS','carole','1938-09-29','02.17.72.42.71','06.73.39.95.74',NULL,'8 RUE AUX PIERROTS','','','14990','BERNIERES SUR MER',NULL,NULL,'1380961114001',419.000000000,'1960-02-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4636,'LEBAS','CHRISTIANE','1959-02-06','02.37.03.71.66','06.82.57.21.12',NULL,'LE BOURG','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2590214034001',3054.000000000,'1981-03-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4637,'FROUX','JACQUELINE','1947-01-13','02.51.70.77.22','06.65.67.60.66',NULL,'18 rue de la rousseliere','','','14310','VILLERS BOCAGE',NULL,NULL,'1470161177001',6.000000000,'1971-10-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4638,'COLLET','NADINE','1966-12-20','02.39.00.17.63','06.18.86.86.01',NULL,'106 rue de geole','','','14000','CAEN',NULL,NULL,'1661222278001',80.000000000,'1994-11-23','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4639,'SIGNORET','JANINE','1953-02-26','02.62.41.05.10','06.61.92.26.63',NULL,'23 RUE DES TAILLEURS DE PIERRE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1530214477001',22.000000000,'1974-02-16','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4640,'VASLIN','','1937-02-06','02.59.78.68.75','06.71.83.70.28',NULL,'28 rue pasteur','','','14400','BAYEUX',NULL,NULL,'1370214266001',5208.000000000,'1959-07-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4641,'ROHEE','JACQUELINE','1931-08-20','02.77.67.45.35','06.72.14.83.53',NULL,'18 RUE LEON BLUM','','','14860','RANVILLE',NULL,NULL,'2310814663001',1460.000000000,'1952-05-19','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4642,'ROUILLARD','MICHEL','1936-08-18','02.21.76.81.06','06.25.12.86.06',NULL,'45 RUE DE L''ORATOIRE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2360814341001',796.000000000,'1961-08-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4643,'LEDRU','DANIEL','1928-10-22','02.24.74.99.80',NULL,NULL,'3 RUE ARISTIDE BRIAND','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2281014047001',42.000000000,'1955-11-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4644,'GOYER','MAURICE','1938-12-03','02.89.35.07.57','06.51.10.07.72',NULL,'3 rue des capucines','','','14700','FALAISE',NULL,NULL,'2381214374001',103.000000000,'1959-02-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4645,'GOYER','CAROLINE','1928-08-07','02.55.92.08.32','06.87.92.98.35',NULL,'22 RUE BAMPTON','','',NULL,NULL,NULL,NULL,'1280814462001',52.000000000,'1954-05-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4646,'MARTIN','','1930-05-16','02.10.91.44.76','06.35.58.84.42',NULL,'22 BD GEORGES POMPIDOU RESIDENCE',' ARENA','','14000','CAEN',NULL,NULL,'2300508483001',2422.000000000,'1951-01-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4647,'SOURD','JEAN CLAUDE','1933-08-11','02.16.22.34.15','06.10.61.21.19',NULL,'7 rue hallais','','','14280','ST CONTEST',NULL,NULL,'1330850523001',125.000000000,'1957-06-10','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4648,'LELIEVRE','JEAN CLAUDE','1930-06-02','02.40.06.04.69','06.13.14.32.62',NULL,'RUE BERNARD SEBERT','','','14123','IFS',NULL,NULL,'1300614543001',715.000000000,'1958-01-18','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4649,'GABRIEL','CLAUDE','1951-06-13','02.79.72.39.86','06.32.38.86.68',NULL,'7 RUE DE LA PLAINE','','','14120','MONDEVILLE',NULL,NULL,'1510661444001',26.000000000,'1980-02-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4650,'','CLAUDE','1960-01-05','02.62.13.51.08','06.15.54.72.14',NULL,'20 RUE PIERRE GRINGOIRE','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1600114488001',84.000000000,'1990-02-14','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4651,'BOUTELOUP','MICHEL','1935-06-01','02.65.37.85.96','06.12.54.66.58',NULL,'SENTE DES VAUX','','',NULL,NULL,NULL,NULL,'1350614276001',17.000000000,'1965-06-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4652,'MARTY','JACQUES','1949-01-23','02.10.80.02.07','06.55.74.32.92',NULL,'4 rue paul langevin','','','61120','CROUTTES',NULL,NULL,'2490114543001',23.000000000,'1970-01-14','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4653,'SURDIVE','JEAN','1949-04-07','02.37.92.14.09','06.68.34.25.93',NULL,'66 ROUTE DE SAINT LO','','','14110','PONTECOULANT',NULL,NULL,'2490414114001',374.000000000,'1972-05-17','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4654,'LEMIERE','Michelle','1932-10-14','02.80.82.44.72','06.14.29.27.29',NULL,'LA HOULLIERE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1321014112001',1216.000000000,'1957-10-22','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4655,'MOULIN','ANDRE','1938-09-23','02.86.45.22.63','06.10.91.18.23',NULL,'9 RUE DES GABLES','','',NULL,NULL,NULL,NULL,'1380953113001',316.000000000,'1962-10-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4656,'BURET','JACQUELINE','1929-11-21','02.31.05.59.54','06.10.74.72.00',NULL,'38 RUE FROIDE','','','14120','MONDEVILLE',NULL,NULL,'2291150602001',89.000000000,'1952-12-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4657,'VERDONCK','JEAN MARC','1949-02-26','02.59.63.62.93','06.67.41.07.53',NULL,'1 RUE LAPFORD','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1490250422001',40.000000000,'1977-02-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4658,'CHEVILLOT','THERESE','1930-11-24','02.11.03.68.36','06.68.00.33.06',NULL,'LA VARDIERE','','','14120','MONDEVILLE',NULL,NULL,'2301150550001',213.000000000,'1952-07-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4659,'CARIOU','LOUISE','1937-01-12','02.42.53.92.47','06.24.90.49.39',NULL,'30 RUE DE LA MONTAGNE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2370114282001',154.000000000,'1958-10-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4660,'LABBE','THERESE','1935-08-31','02.17.03.91.60','06.59.97.62.38',NULL,'SAINT ELOI','','','14430','PUTOT EN AUGE',NULL,NULL,'1350850032001',124.000000000,'1956-08-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4661,'GEORGES','NELLY','1928-06-05','02.23.98.07.49','06.77.04.84.62',NULL,'10 rue  gustave flaubert','','','50100','CHERBOURG',NULL,NULL,'2280614616001',24.000000000,'1953-12-18','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4662,'HARDY','CHRISTIANE','1929-06-21','02.67.50.33.73','06.95.68.24.28',NULL,'','','','14730','GIBERVILLE',NULL,NULL,'1290614319001',294.000000000,'1951-10-14','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4663,'PAUPY','RENE','1930-12-02','02.77.71.09.66','06.55.61.03.19',NULL,'1 RUE DE LA FRATERNITE','','','14730','GIBERVILLE',NULL,NULL,'2301258125001',27.000000000,'1960-02-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4664,'THOMASSE','DANIEL','1958-07-23','02.13.27.51.25','06.87.26.02.54',NULL,'7 RUE DE LA HAUTE CROIX','','','14540','HUBERT FOLIE',NULL,NULL,'2580778104001',294.000000000,'1979-04-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4665,'HAMONIAUX','JEAN','1938-08-01','02.12.44.10.75','06.10.95.17.05',NULL,'26 BIS RUE DE LA MARNE','','','14120','MONDEVILLE',NULL,NULL,'2380836200001',222.000000000,'1964-06-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4666,'BROCHART','GEORGES','1935-08-04','02.64.08.46.68','06.10.00.35.67',NULL,'37 bis rue aristide briand','','','14700','FALAISE',NULL,NULL,'2350814237001',94.000000000,'1957-06-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4667,'LEPLEUX','HENRI','1961-04-15','02.95.20.96.12','06.66.36.49.50',NULL,' village du puit','','','14460','COLOMBELLES',NULL,NULL,'1610414454001',693.000000000,'1991-06-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4668,'MARIE','GUY','1966-04-26','02.88.91.04.48','06.68.00.10.06',NULL,'LE HAMEAU DE MONCEL','','','14000','CAEN',NULL,NULL,'2660441022001',6.000000000,'1990-02-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4669,'PELLIER','MICHEL','1954-08-03','02.54.14.19.65','06.93.06.10.85',NULL,'472 avenue des francais','','','14540','BOURGUEBUS',NULL,NULL,'2540814483001',3102.000000000,'1976-06-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4670,'GAUTIER','PHILIPPE','1933-03-21','02.35.27.27.14','06.86.06.79.44',NULL,'9 TER RUE FELIX BOUFFAY','','','14170','EPANEY',NULL,NULL,'2330314558001',251.000000000,'1958-07-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4671,'MOTTAY','JANINE','1935-01-28','02.48.90.69.65','06.46.46.45.21',NULL,'LE MESNIL AUGRAIN','','','14000','CAEN',NULL,NULL,'2350114581001',188.000000000,'1957-09-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4672,'PALIS','EUGENE','1930-08-02','02.42.23.95.26','06.89.56.01.21',NULL,'2 avenue jean villard','','','14740','LE MESNIL PATRY',NULL,NULL,'1300814294001',22.000000000,'1957-04-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4673,'GITTON','JEANNINE','1944-02-03','02.33.22.14.28','06.44.01.34.55',NULL,'16 RUE PASTEUR','','','14400','ST VIGOR LE GRAND',NULL,NULL,'2440250010001',23.000000000,'1965-04-02','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4674,'PICHOU','VALERIE','1941-01-20','02.13.06.07.10','06.12.21.88.05',NULL,'40 RUE DE ROSEL','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2410150615001',573.000000000,'1963-05-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4675,'MACHU','ANDRE','1940-07-02','02.72.90.18.89','06.39.49.80.70',NULL,'100 RUE D''AUGE','','','14000','CAEN',NULL,NULL,'2400772054001',1204.000000000,'1970-07-28','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4676,'BRIONNE','GERARD','1929-11-06','02.98.25.09.50','06.10.02.96.33',NULL,'15 RUE DE LA  REPUBLIQUE','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2291114488001',289.000000000,'1952-01-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4677,'LECACHEUR','YVES','1946-02-21','02.49.70.29.98','06.18.36.61.98',NULL,'LES AULNAYS','','','14123','IFS',NULL,NULL,'1460214062001',100.000000000,'1974-02-24','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4678,'PERRELLE','ALAIN','1930-06-13','02.14.36.57.20','06.35.48.49.37',NULL,'37 RUE JEAN MERMOZ','','','14570','ST REMY',NULL,NULL,'1300614543001',5.000000000,'1952-05-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4679,'MAUBANT','JEANNINE','1936-08-05','02.74.91.20.44',NULL,NULL,'38 rue val des dunes','','','14240','ANCTOVILLE',NULL,NULL,'1360814239001',22.000000000,'1960-05-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4680,'LEGRAS','PHILIPPE','1930-04-02','02.13.40.47.87','06.26.81.88.06',NULL,'25 rue du moulin a voide','','','61160','TRUN',NULL,NULL,'1300414410001',252.000000000,'1958-12-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4681,'DOIX','VALERIE','1962-02-01','02.39.51.36.94','06.96.22.44.87',NULL,'14/2 rue du 6 juin','','','61450','LE CHATELLIER',NULL,NULL,'2620214530001',27.000000000,'1992-01-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4682,'GERVAIS','ANDRE','1937-06-22','02.43.35.63.01','06.87.94.34.56',NULL,'10 RUE HELENE KELLER','','','61450','LE CHATELLIER',NULL,NULL,'1370614204001',65.000000000,'1967-05-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4683,'MARHIC','JEAN','1952-02-22','02.87.00.18.23','06.57.98.50.34',NULL,'ferme d''angouville','','','50620','CAVIGNY',NULL,NULL,'1520227664001',275.000000000,'1973-02-16','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4684,'JOURDAIN','REGINE','1939-10-14','02.34.99.09.32','06.67.78.69.14',NULL,'17 rue des quatres saisons','','','14000','CAEN',NULL,NULL,'1391050445001',30.000000000,'1963-03-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4685,'','MARIE MADELEINE','1937-06-17','02.34.12.58.62','06.24.43.31.13',NULL,'49 rue de l ancienne gare','','','14000','CAEN',NULL,NULL,'1370650023001',214.000000000,'1962-04-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4686,'LHERMENIER','SABINE','1944-03-23','02.92.16.50.35','06.10.63.01.13',NULL,'ROUTE DE VENDES','','','14123','IFS',NULL,NULL,'2440314218001',1049.000000000,'1969-09-05','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4687,'','PAUL','1965-03-08','02.43.98.01.89','06.12.25.95.92',NULL,'1 RUE JEAN BAPTISTE LULLY','','','14370','CROISSANVILLE',NULL,NULL,'1650314316001',34.000000000,'1988-07-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4688,'DESLANDES','DENISE','1954-02-01','02.29.17.92.67','06.11.89.32.93',NULL,'26 RUE H SMITH','','','14120','MONDEVILLE',NULL,NULL,'1540214007001',94.000000000,'1977-06-22','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4689,'MOUCHEL','JEAN CLAUDE','1980-12-24','02.71.59.90.71','06.53.56.32.96',NULL,'42 RUE DE LA GARE','','','14123','IFS',NULL,NULL,'1801299255001',153.000000000,'2001-04-22','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4690,'MARIE','JEAN PIERRE','1950-01-01','02.90.41.19.54','06.76.23.70.54',NULL,'17 rue du bout au mesnil','','','14210','AMAYE SUR ORNE',NULL,NULL,'1500150118001',621.000000000,'1974-09-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4691,'LENOBLE','JEAN JACQ','1944-03-28','02.39.73.95.67','06.56.84.79.59',NULL,'14 RUE ALBERT 1ER','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2440314200001',23.000000000,'1967-10-09','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4692,'HEUZE','MARTINE','1937-06-26','02.88.51.10.55','06.35.75.03.71',NULL,'LES MASURES','','','14730','GIBERVILLE',NULL,NULL,'2370614233001',1072.000000000,'1959-02-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4693,'DUVAL','AURELIE','1930-05-21','02.32.22.55.96','06.30.19.20.37',NULL,'1 RUE DU PETIT MARAIS','','','14160','DIVES SUR MER',NULL,NULL,'2300514738001',2493.000000000,'1958-10-12','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4694,'MARIE','CLAUDE','1944-01-11','02.18.24.64.66','06.39.68.73.38',NULL,'LA COUARDE','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'1440150425001',21.000000000,'1967-10-29','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4695,'LAURENS','JEAN CLAUDE','1937-11-26','02.94.34.91.90','06.11.46.30.76',NULL,'','','','14730','GIBERVILLE',NULL,NULL,'1371150160001',341.000000000,'1959-03-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4696,'LECOUSTEY','JANINE','1945-02-26','02.71.88.17.54','06.83.45.76.75',NULL,'18 rue des vaudes','','','14400','BLAY',NULL,NULL,'1450214278001',87.000000000,'1968-04-05','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4697,'LEGUELINEL','Paul','1939-02-27','02.13.28.96.49','06.84.56.61.68',NULL,'26 rue des vaudes','','','14120','MONDEVILLE',NULL,NULL,'1390214197001',328.000000000,'1961-07-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4698,'BRETEAU','ARMANDE','1934-11-07','02.49.24.08.73','06.54.91.10.16',NULL,'grande rue','','','14150','OUISTREHAM',NULL,NULL,'1341114211001',1606.000000000,'1956-10-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4699,'LIGER','JEANINE','1939-01-03','02.10.59.80.53','06.54.94.83.95',NULL,'rue de la gare','','','14210','TROIS MONTS',NULL,NULL,'1390120288001',15.000000000,'1963-06-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4700,'LEDUC','Annick','1965-02-25','02.79.78.02.54','06.80.69.64.97',NULL,'rue du domaine clos des cigognes','','','14540','GRENTHEVILLE',NULL,NULL,'1650214163001',360.000000000,'1987-09-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4701,'MAUGER','ROBERT','1935-05-02','02.10.60.69.25','06.65.46.29.94',NULL,'le carrelet','','','14210','AVENAY',NULL,NULL,'1350586075001',131.000000000,'1965-09-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4702,'GRUAU','GEORGES','1930-10-08','02.88.86.18.14','06.40.66.55.46',NULL,'le carrelet','','','14000','CAEN',NULL,NULL,'2301014080001',71.000000000,'1955-05-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4703,'PERNET','JEANNINE','1932-09-14','02.30.33.25.49','06.11.65.58.50',NULL,'rue du bois de grim','','','14000','CAEN',NULL,NULL,'2320914254001',19.000000000,'1957-02-12','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4704,'PETIARD','CHRISTIANE','1962-06-16','02.65.38.27.23','06.74.34.30.88',NULL,'4 RUE CLOS DU CAREL','','','14000','CAEN',NULL,NULL,'1620623050001',667.000000000,'1985-10-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4705,'PHILIPPE','MICHEL','1960-02-16','02.10.64.81.52','06.12.57.04.03',NULL,'LES MERISIERS','','','61500','AUNOU SUR ORNE',NULL,NULL,'1600214390001',33.000000000,'1989-03-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4706,'LECORNU','SYLVIE','1935-05-10','02.18.47.88.74',NULL,NULL,'14 rue de la RTF','','','14840','CUVERVILLE',NULL,NULL,'1350514158001',1114.000000000,'1963-03-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4707,'FAROLET','JACQUELINE','1923-10-11','02.29.70.21.14','06.68.89.52.12',NULL,'08 avenue jeanne d arc','','','14000','CAEN',NULL,NULL,'1231037111001',214.000000000,'1950-09-04','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4708,'HARAN','DENIS','1951-04-13','02.12.13.38.72','06.50.12.44.44',NULL,'07 RUE D.A.F.N bat 3 porte 11','','','14000','CAEN',NULL,NULL,'2510414034001',791.000000000,'1974-12-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4709,'LEZE','CLAUDINE','1930-06-07','02.10.26.05.16','06.32.15.98.42',NULL,'45 RUE DES DUNES','','','14370','MERY CORBON',NULL,NULL,'2300635353001',498.000000000,'1951-12-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4710,'VIBERT','MARYLINE','1934-09-28','02.66.36.64.80','06.66.63.75.22',NULL,'7 RUE DU TEMPS PERDU','','','14770','DANVOU LA FERRIERE',NULL,NULL,'1340914675001',404.000000000,'1957-12-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4711,'LAIR','MARYLINE','1935-09-09','02.53.73.50.80','06.45.84.41.72',NULL,'6 RUE DE LA PILARDIERE','','','14111','LOUVIGNY',NULL,NULL,'2350975007001',193.000000000,'1965-12-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4712,'GAINCHE','ROGER','1956-07-01','02.17.86.25.52','06.80.03.76.71',NULL,'41 BOULEVARD MARECHAL JOFFRE','','','14000','CAEN',NULL,NULL,'1560714197001',735.000000000,'1983-03-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4713,'LEMONNIER','AUGUSTE','1943-01-27','02.67.20.27.67','06.11.92.93.85',NULL,'5 ROUTE DE TINCHEBRAY','','','14610','CAMBES EN PLAINE',NULL,NULL,'2430114739001',146.000000000,'1970-12-11','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4714,'PALISSARD','MARIE-LINE','1936-12-03','02.80.64.53.76','06.23.09.87.93',NULL,'812 RUE DU TOUR DE VILLE','','','14220','BARBERY',NULL,NULL,'1361214215001',71.000000000,'1959-05-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4715,'PAGNY','CHRISTIAN','1953-06-10','02.11.61.59.81','06.25.29.93.58',NULL,'20 RUE ROUGEMONT','','','14270','MEZIDON CANON',NULL,NULL,'2530661503001',4281.000000000,'1976-06-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4716,'LETELLIER','CHRISTIAN','1929-01-14',NULL,NULL,NULL,'8 RUE CLOS DU PAVILLON','','','14120','MONDEVILLE',NULL,NULL,'2290114587001',101.000000000,'1950-03-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4717,'DESTORS','ANNE MARIE','1969-07-28','02.22.07.34.89','00 33 6.87.20.29.42',NULL,'10 rue du temps perdu','','','14370','BELLENGREVILLE',NULL,NULL,'1690759183001',36.000000000,'1997-10-31','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4718,'MESNIL','SIMONE','1936-02-02','02.39.21.55.41','06.92.25.45.12',NULL,'','','','14190','FIERVILLE BRAY',NULL,NULL,'1360250261001',338.000000000,'1966-11-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4719,'ANGER','ALICE','1930-01-11','02.83.33.38.74',NULL,NULL,'18, rue louis armand','','','14123','IFS',NULL,NULL,'2300114217001',1058.000000000,'1956-05-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4720,'MADEC','MARIE','1936-02-17','02.70.35.18.88','06.48.96.87.78',NULL,'87 rue de falaise','','',NULL,NULL,NULL,NULL,'2360261421001',84.000000000,'1965-09-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4721,'BREUILLY','ENIO','1936-02-22','02.67.48.60.94','06.23.82.19.10',NULL,'CAUDERUE','','','14510','HOULGATE',NULL,NULL,'2360261421001',41.000000000,'1962-08-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4722,'COSNE','JANINE','1968-02-26','02.62.08.44.70','06.24.82.95.08',NULL,'hameau debussy','','','14500','ST GERMAIN DE TALLEVENDE',NULL,NULL,'1680214410001',215.000000000,'1996-06-26','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4723,'JULIEN','YVETTE','1928-04-02','02.59.37.19.04','06.79.65.36.60',NULL,'route de la jalousie','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1280461211001',6.000000000,'1958-08-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4724,'TRICARD','DANIEL',NULL,'02.40.89.66.87','06.93.39.93.00',NULL,'10 RUE CHAPRON','','','14000','CAEN',NULL,NULL,'1390914092001',18.000000000,'2007-11-13','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4725,'LEMENAGER','NADINE','1948-01-06','02.70.46.06.32','06.47.18.76.42',NULL,'LE BOURG','','','14270','MEZIDON CANON',NULL,NULL,'1480114112001',267.000000000,'1976-01-10','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4726,'LAIR','ANDRE','1934-03-28','02.21.41.66.51','06.32.31.02.22',NULL,'15 rue du Pommier Gris','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2340350431001',1461.000000000,'1962-02-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4727,'LAIR','LUCIENNE','1933-02-14','02.84.89.06.58','06.13.65.61.63',NULL,'2bis rue emile zola','','','14120','MONDEVILLE',NULL,NULL,'1330214464001',4407.000000000,'1955-10-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4728,'LAIR','DANIEL','1929-12-26','02.52.43.27.36','06.62.01.72.10',NULL,'9 RUE DE LA FROMAGERIE','','','14370','MOULT',NULL,NULL,'1291214289001',139.000000000,'1954-03-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4729,'LAURENT','DANIEL','1953-07-12','02.25.48.80.69','06.58.24.03.83',NULL,'4 RUE PAUL LANGEVIN','','','14130','FIERVILLE LES PARCS',NULL,NULL,'2530714525001',6.000000000,'1982-02-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4730,'BOUVET','BRIGITTE','1933-04-21','02.19.34.54.06','06.46.00.31.38',NULL,'10 rue c blaizot','','','14860','RANVILLE',NULL,NULL,'1330414691001',567.000000000,'1962-08-03','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4731,'MOULIN','NICOLLE','1937-10-09','02.11.70.83.22','06.56.69.47.21',NULL,'8 RUE LEON GUIGNE','','','14480','LE FRESNE CAMILLY',NULL,NULL,'2371035180001',681.000000000,'1961-12-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4732,'LEVERRIER','LIONEL','1936-07-06','02.24.63.88.28','06.11.05.42.79',NULL,'28 LE BOURG','','','14100','ST DESIR',NULL,NULL,'2360714356001',327.000000000,'1963-11-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4733,'MARIE','FRANCIS','1963-06-03','02.52.70.66.82','06.20.12.74.68',NULL,'LA FOLLETIERE','','','14730','GIBERVILLE',NULL,NULL,'2630614090001',6.000000000,'1986-06-05','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4734,'TAUPIN','LUCIEN','1927-01-19','02.42.68.74.93',NULL,NULL,'7 bis rue rougeT de lisle','','','14320','MAY SUR ORNE',NULL,NULL,'1270124229001',182.000000000,'1951-11-02','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4735,'BIOU','CLAUDE','1933-12-01','02.67.33.47.75','06.47.41.81.29',NULL,'L AIGLERIE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1331214468001',311.000000000,'1961-12-26','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4736,'','JOSETTE','1937-05-19','02.46.45.55.40','06.12.10.72.23',NULL,'16 RUE DES ECOLES','','','50580','ST LO D''OURVILLE',NULL,NULL,'2370514469001',83.000000000,'1965-12-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4737,'LEREBOURG','MICHEL','1937-09-06','02.60.22.88.83','06.22.52.57.69',NULL,'2 IMPASSE DU MUGUET','','','14860','BAVENT',NULL,NULL,'2370914081001',185.000000000,'1960-10-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4738,'JACQUET','CHRISTIANE','1928-06-28','02.66.15.70.62','06.80.63.08.19',NULL,'11 rue guillaume trebutien','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2280614206001',2793.000000000,'1950-04-22','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4739,'EGRET','IRENA','1929-08-29','02.18.05.18.70','06.10.50.51.50',NULL,'2 RUE DU LEUTENANT LOUIS RENOUF','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'2290850230001',442.000000000,'1953-09-01','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4740,'LHOMME','SIMONNE','1930-04-25','02.33.37.42.21','06.55.01.61.96',NULL,'9 RUE DU MARAIS','','',NULL,NULL,NULL,NULL,'2300414266001',355.000000000,'1955-03-31','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4741,'HUARD','SIMONNE','1962-06-28','02.61.72.27.37','06.44.58.02.26',NULL,'RUE DES POMMIERS','','','14000','CAEN',NULL,NULL,'1620614591001',155.000000000,'1992-10-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4742,'ALCIDE','RACHID','1940-11-17','02.88.05.94.63','06.98.80.70.48',NULL,'22 RUE DE LA REPUBLIQUE','','','14670','ST PIERRE DU JONQUET',NULL,NULL,'2401150297001',49.000000000,'1962-07-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4743,'BALLAVENNE','JEAN','1938-10-02','02.42.70.76.79','06.56.82.74.37',NULL,'LA PLANCHE ES VACHES','','','14000','CAEN',NULL,NULL,'2381014637001',1517.000000000,'1960-12-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4744,'LALLEMAND','MARIA','1936-06-05','02.80.99.86.00','06.47.46.68.35',NULL,'12 rue de la tourelle','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1360614338001',93.000000000,'1959-02-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4745,'HERVIEU','JANINE','1929-03-22','02.39.66.67.60','06.79.34.31.39',NULL,'1170 BD DE LA PAIX','','',NULL,NULL,NULL,NULL,'1290362698001',581.000000000,'1951-01-09','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4746,'HERVIEU','GUY','1964-01-17','02.67.02.66.28','06.11.88.70.34',NULL,'LE DOUET  BARON','','','61100','ST GEORGES DES GROSEILLERS',NULL,NULL,'2640114015001',732.000000000,'1989-12-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4747,'DELAHAYE','NICOLE','1954-01-04','02.22.90.19.42','06.63.70.43.98',NULL,'7 ALLEE DE VIENNE','','','14000','CAEN',NULL,NULL,'1540161278001',8.000000000,'1975-12-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4748,'GEFFROY-LEMOINE','SYLVIE','1963-01-27','02.49.79.56.02','06.82.41.06.67',NULL,'140 CHEMIN DU BUREL','','','14630','CAGNY',NULL,NULL,'1630114327001',64.000000000,'1987-06-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4749,'FRANCOISE','gilles','1954-08-17','02.11.75.63.33','06.10.43.06.34',NULL,'933 BD DES BELLES PORTES','','','14540','SOLIERS',NULL,NULL,'2540814118001',72.000000000,'1975-03-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4750,'HINGAND','CLAUDINE','1953-01-31','02.75.95.59.53','06.99.62.55.59',NULL,'9 RUE DES CANADIENS','','','14270','MEZIDON CANON',NULL,NULL,'1530114481001',1264.000000000,'1977-09-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4751,'SAUDAIN','MONIQUE','1966-03-25','02.34.97.40.62','06.10.32.95.53',NULL,'LOTISSEMENT LE FRIEGE','','','14540','ROCQUANCOURT',NULL,NULL,'2660314554001',3.000000000,'1989-09-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4752,'HAYS','EMILE','1947-01-15','02.34.22.35.38','06.54.06.70.95',NULL,'4 RUE DE L''ECUYER','','','14000','CAEN',NULL,NULL,'2470161403001',857.000000000,'1976-09-23','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4753,'LENFANT MARIE','MARCEL',NULL,'02.42.70.04.05','06.34.22.12.11',NULL,'4 rue de la pomme d or','','','14390','CABOURG',NULL,NULL,'1280514159001',99.000000000,'2010-07-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4754,'DESJARDINS','BERNARD','1934-06-02','02.42.84.06.85','06.89.93.97.15',NULL,'4 RUE DES BRUYERES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1340699122001',66.000000000,'1960-04-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4755,'LAMY','JEAN CLAUDE','1929-07-27','02.71.83.84.97','06.62.15.18.73',NULL,'15 impasse du peintre','','','14370','ARGENCES',NULL,NULL,'2290714251001',44.000000000,'1955-06-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4756,'VIRAY','FABRICE','1928-02-15','02.12.10.31.56','06.24.89.23.53',NULL,'33 rue emile mougins','','','14670','TROARN',NULL,NULL,'1280214588001',1507.000000000,'1951-06-29','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4757,'LEVERRIER','GINETTE','1939-06-30','02.90.77.38.57','06.57.11.05.03',NULL,'44 RUE DE FALAISE','','','14540','SOLIERS',NULL,NULL,'1390680042001',39.000000000,'1964-01-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4758,'GAILLARD','BRIGITTE','1934-06-23','02.77.02.30.25','06.17.25.35.88',NULL,'14 RUE JULES MICHELET','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1340635108001',817.000000000,'1964-10-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4759,'LOISELET','FRANCOISE','1951-02-18','02.51.53.59.12','06.37.83.54.04',NULL,'41 RUE AUGUSTE LECHESNE','','','14123','IFS',NULL,NULL,'2510214408001',6.000000000,'1974-05-12','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4760,'MOREL','IRENE','1953-05-08','02.12.09.07.31','06.11.50.52.20',NULL,'24 RUE DU STADE','','','61120','ORVILLE',NULL,NULL,'1530514539001',1054.000000000,'1975-08-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4761,'LEMONNIER','JOSETTE','1951-02-06','02.25.83.10.03','06.68.87.21.17',NULL,'1 CHEMIN DE BALLEROY','','','14000','CAEN',NULL,NULL,'2510214408001',3506.000000000,'1974-07-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4762,'VALLEE','JACQUES','1952-01-08','02.33.06.92.67','06.28.32.48.39',NULL,'22 RUE VICTOR HUGO','','','14840','CUVERVILLE',NULL,NULL,'1520102585001',65.000000000,'1974-02-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4763,'KRA','LEON','1934-09-15','02.40.22.96.16','06.48.56.84.28',NULL,'LE BOURG BEAUQUEY','','','14700','FALAISE',NULL,NULL,'1340914349001',909.000000000,'1955-12-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4764,'BAGDASARIAN','YVETTE','1934-02-15','02.83.28.20.82','06.31.24.50.37',NULL,'10 RUE DES CALENDRIERS','','','14170','BRETTEVILLE SUR DIVES',NULL,NULL,'1340214089001',56.000000000,'1962-10-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4765,'BAGDASARIAN','ALEXANDRE','1939-01-26','02.59.60.55.53','06.14.97.65.87',NULL,'18 quai des allies','','','14250','ELLON',NULL,NULL,'1390114739001',319.000000000,'1968-04-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4766,'MARTIGNY','PATRICIA','1930-10-17','02.12.21.63.73','06.93.01.89.81',NULL,'31 rue jeles ferry','','','14370','MOULT',NULL,NULL,'1301014078001',42.000000000,'1952-01-15','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4767,'BARBIER','BERNARD','1928-06-21','02.27.96.76.18','06.77.98.88.10',NULL,'75 rue des epivas','','','14730','GIBERVILLE',NULL,NULL,'2280653147001',612.000000000,'1950-12-30','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4768,'LETOURNEL','MARIE CLAUDE','1925-12-12','02.22.34.56.94','06.44.85.40.39',NULL,'18 route de falaise','','','14120','MONDEVILLE',NULL,NULL,'1251220199001',16.000000000,'1946-02-11','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4769,'HAMEL','PIERRE','1939-08-29','02.78.37.16.48','06.42.30.72.61',NULL,'brocottes','','','61470','LE BOSC RENOULT',NULL,NULL,'2390814736001',2264.000000000,'1965-12-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4770,'SUARD','GEORGES','1930-08-07','02.40.41.58.40','06.30.01.39.90',NULL,'14 RUE DU BOUT MACON','','','14123','IFS',NULL,NULL,'2300849233001',206.000000000,'1955-06-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4771,'CHARLES','FRANCOIS','1940-12-20','02.19.76.58.63','06.36.96.10.54',NULL,'','','','14700','AUBIGNY',NULL,NULL,'1401214456001',79.000000000,'1962-09-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4772,'BONNEAU','ALAIN','1937-01-25','02.55.27.86.50','06.98.27.26.79',NULL,'LA BOULAIE','','','14510','GONNEVILLE SUR MER',NULL,NULL,'2370157597001',38.000000000,'1961-04-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4773,'','MARCEL','1930-12-25','02.32.32.89.79','06.10.62.92.18',NULL,'CHEZ MADAME RAULAY LA PETITE MO','RTREE','','14220','DONNAY',NULL,NULL,'1301222093001',20.000000000,'1951-08-04','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4774,'CRAMPON','EVELYNE','1940-11-18',NULL,NULL,NULL,'43 RUE DE LA GARE','','','61310','EXMES',NULL,NULL,'1401114344001',200.000000000,'1970-09-07','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4775,'CASTEL','CHRISTINE','1941-11-30','02.14.74.18.60',NULL,NULL,'LE HAMEAU DES CHAMPS','','','14630','CAGNY',NULL,NULL,'1411117306001',91.000000000,'1963-11-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4776,'DEVILLIERS','MARIE THERESE','1938-02-03','02.56.57.90.27','06.42.28.96.34',NULL,'42 rue de l''''eglise','','','14280','AUTHIE',NULL,NULL,'1380250142001',84.000000000,'1960-08-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4777,'GUITTON','PHILIPPE','1952-01-07','02.36.62.81.03','06.59.58.42.32',NULL,'6 RUE DE LA DELIVRANDE','','','14000','CAEN',NULL,NULL,'1520135241001',332.000000000,'1980-12-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4778,'PECH','GENEVIEVE','1928-07-04','02.57.13.92.97','06.63.51.80.19',NULL,'12/2 RUE DES MARGUERITES','','','14670','TROARN',NULL,NULL,'2280714012001',103.000000000,'1949-01-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4779,'GOUPILLOT','MONIQUE','1931-08-17','02.49.73.58.56','06.84.82.35.47',NULL,'LIEU DIT "LE PAVILLON"','','','14700','FALAISE',NULL,NULL,'2310861093001',32.000000000,'1952-11-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4780,'PASQUIER','MAURICE','1961-05-28','02.10.96.56.21','06.81.84.16.92',NULL,'30 RUE DU CHATAIGNIER','','','14370','ARGENCES',NULL,NULL,'1610514392001',178.000000000,'1988-01-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4781,'RUETTE','ROBERT','1937-06-01','02.14.24.59.73','06.37.30.27.30',NULL,'6 RUE DE LA HAIE BRETON','','','14000','CAEN',NULL,NULL,'2370650265001',615.000000000,'1958-11-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4782,'BARBIER','FRANCOISE','1959-01-06','02.84.07.17.49','06.25.99.57.00',NULL,'LA CROIX','','','14210','AMAYE SUR ORNE',NULL,NULL,'1590114176001',164.000000000,'1989-05-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4783,'LENOEL','ROLAND','1929-04-30','02.72.75.23.08','06.61.44.52.67',NULL,'1 CHEMIN DES RACINES','','','14000','CAEN',NULL,NULL,'1290414160001',8.000000000,'1950-07-24','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4784,'ROGER','RENEE','1975-01-11','02.78.69.55.56','06.71.64.47.25',NULL,'4 allee alfred jarry','','','14000','CAEN',NULL,NULL,'2750135238001',2799.000000000,'2005-08-04','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4785,'JOURDAIN','PAUL','1940-11-26',NULL,NULL,NULL,'29 RUE PASTEUR','','','14000','CAEN',NULL,NULL,'1401114196001',191.000000000,'1965-11-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4786,'LENOEL','JEAN','1933-12-22','02.88.55.77.31','06.23.79.82.03',NULL,'75 GRANDE RUE','','','14430','BRANVILLE',NULL,NULL,'2331214166001',103.000000000,'1963-02-06','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4787,'MAURY','PASCAL','1930-09-05','02.45.98.33.26','06.44.25.36.97',NULL,'','','','14000','CAEN',NULL,NULL,'1300976183001',29.000000000,'1959-11-09','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4788,'LEBAS','JEAN-PIERRE','1932-03-13','02.22.03.70.41','06.41.41.86.92',NULL,'23 RUE DES CANADIENS','','','14320','MAY SUR ORNE',NULL,NULL,'2320314143001',2495.000000000,'1953-02-11','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4789,'BREVILLE','PASCALE','1939-02-19','02.39.45.48.90','06.11.67.37.40',NULL,'3 RUE DES JARDINS','','','27000','EVREUX',NULL,NULL,'2390214404001',12.000000000,'1967-12-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4790,'PASQUARELLI','MICHELE','1936-11-22','02.33.43.13.43','06.51.55.20.74',NULL,'LE BOURG','','','14540','SOLIERS',NULL,NULL,'2361176485001',172.000000000,'1966-10-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4791,'LEBOUCHER','YANNICK','1938-08-21','02.83.35.43.65','06.75.31.70.92',NULL,'10 IMPASSE DU CLOS CHAUMONT','','','14730','GIBERVILLE',NULL,NULL,'1380814533001',86.000000000,'1967-05-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4792,'VIN','SIMONE','1934-12-12','02.70.50.83.71','06.10.67.73.52',NULL,'28 RUE DES 13 ACRES','','','14540','SOLIERS',NULL,NULL,'2341214100001',23.000000000,'1960-08-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4793,'LANGLOIS','MAURICETTE','1935-08-13','02.34.30.75.91','06.81.68.33.20',NULL,'37 RUE EDOUARD VAILLANT','','','14000','CAEN',NULL,NULL,'2350814335001',17.000000000,'1962-12-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4794,'CORBIN','MIREILLE','1932-06-08','02.57.48.60.88','06.10.69.95.85',NULL,'5 rue du clos du caprice','','','14000','CAEN',NULL,NULL,'1320650058001',1707.000000000,'1958-04-24','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4795,'BOUZAIANE','MAURICETTE','1919-11-21','02.99.80.14.73','06.68.27.22.80',NULL,'1 RUE DES FOSSES','','','14860','RANVILLE',NULL,NULL,'1191145252001',759.000000000,'1948-10-17','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4796,'FLEURY','ROGER','1913-02-06','02.90.40.76.86','06.41.02.72.39',NULL,'LE LIEU DE LA PIERRE','','','14230','OSMANVILLE',NULL,NULL,'1130214597001',949.000000000,'1934-02-17','GOLD',24,1);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4797,'DELAMARRE','BERNARD','1961-08-12','02.98.27.11.56','06.11.54.60.10',NULL,'5 RUE FOCH','','','14680','GOUVIX',NULL,NULL,'1610861198001',1307.000000000,'1991-11-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4798,'LESAGE','FRANCOIS','1941-01-22','02.31.39.70.23','06.36.28.24.94',NULL,'4 chemin de la cave','','','14670','TROARN',NULL,NULL,'1410127445001',18.000000000,'1962-02-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4799,'BAZIN','GEORGES','1934-08-21','02.34.18.50.75','06.74.04.57.08',NULL,'8 rue de la mairie','','','14000','CAEN',NULL,NULL,'2340814167001',42.000000000,'1961-12-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4800,'COSTARD','JEAN','1930-01-19','02.66.54.35.20','06.11.08.65.43',NULL,'15 RUE DU FOUR A CHAUX','','','14000','CAEN',NULL,NULL,'1300114446001',147.000000000,'1958-06-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4801,'LEU','ANNIE','1949-02-27','02.41.72.12.32','06.11.07.37.82',NULL,'20 RUE CHARLOTTE CORDAY','','','14123','IFS',NULL,NULL,'2490250524001',42.000000000,'1973-11-05','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4802,'BOUCHER','SOLANGE','1935-01-16','02.74.90.92.23',NULL,NULL,'118 GRAND PARC','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1350150400001',414.000000000,'1960-04-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4803,'BIGOT','MARIE THERESE','1943-02-19','02.56.22.19.90','06.35.98.72.08',NULL,'LA PETITE LANDE CHEMIN DU HERY','','','14370','ARGENCES',NULL,NULL,'1430214581001',125.000000000,'1965-03-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4804,'ROBERT','CLAUDE','1929-07-26','02.38.49.77.07','06.65.22.57.75',NULL,'13 RUE MAURICE SOURIAU','','','14370','MERY CORBON',NULL,NULL,'2290735111001',60.000000000,'1952-12-20','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4805,'LECONTE','MICHEL','1929-09-30','02.80.84.85.82','06.98.89.66.74',NULL,'46 rue de baron','','','14000','CAEN',NULL,NULL,'1290928185001',93.000000000,'1952-01-29','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4806,'D HONDT','PATRICIA','1933-12-31','02.95.39.50.20','06.46.73.99.92',NULL,'4 RESIDENCE DU PARC','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'1331214712001',20.000000000,'1957-10-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4807,'DOSSIER','ODETTE','1934-02-05','02.17.46.75.29','06.10.28.60.19',NULL,'14 RUE DE LA CANARDIERE','','','14220','ESSON',NULL,NULL,'1340214675001',490.000000000,'1963-04-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4808,'HOLLER','COLETTE','1938-09-17','02.78.39.35.92','06.32.58.16.07',NULL,'le mesnil grain','','','14120','MONDEVILLE',NULL,NULL,'1380914603001',9.000000000,'1963-12-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4809,'MALAS','MICHEL','1933-03-24','02.20.03.90.30','06.29.84.27.98',NULL,'9/2 avenue de la falaise','','','14000','CAEN',NULL,NULL,'1330314588001',325.000000000,'1957-09-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4810,'YVERT','SOLANGE','1940-07-16','02.13.23.36.86','06.53.41.41.41',NULL,'22 RUE PAUL EDOURD','','','14160','DIVES SUR MER',NULL,NULL,'1400714396001',31.000000000,'1970-04-12','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4811,'MARIE','MARIE THERESE','1941-07-15','02.35.14.99.62','06.81.58.24.84',NULL,'21 impasse du chene','','','14840','DEMOUVILLE',NULL,NULL,'1410797223001',16.000000000,'1964-10-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4812,'NAVARRE','BRIGITTE','1939-03-25','02.56.22.80.45','06.70.88.75.65',NULL,'832 quartier de la haute folie','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1390361157001',179.000000000,'1963-09-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4813,'VERITE','FRANCK','1935-05-06','02.51.37.84.08','06.61.61.47.34',NULL,'CHEMIN DE L EGLISE','','','61240','LE MERLERAULT',NULL,NULL,'1350550019001',27.000000000,'1957-07-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4814,'DELALANDE','MARCEL','1963-08-30','02.19.31.46.98','06.57.08.41.62',NULL,'20 rue auguste lechesne','','','14123','FLEURY SUR ORNE',NULL,NULL,'2630814100001',1068.000000000,'1992-03-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4815,'HEBERT','MICHELINE','1936-07-23','02.11.60.83.85','06.96.38.33.00',NULL,'CHEF DE RUE','','','14370','BELLENGREVILLE',NULL,NULL,'1360714213001',362.000000000,'1962-02-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4816,'','GERARD','1966-06-26','02.34.05.11.28','06.22.34.00.00',NULL,'11 RESIDENCE GUSTAVE FLAUBERT','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2660650502001',456.000000000,'1990-01-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4817,'LEFEVRE','HELENE','1945-01-26','02.35.65.80.81','06.21.07.80.98',NULL,'17 rue des jardins','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2450176755001',12.000000000,'1967-05-18','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4818,'HOMMET','HENRIETTE','1929-02-27','02.11.75.70.54','06.82.61.48.36',NULL,'1 RUE CLOS JOLI','','','14570','ST LAMBERT',NULL,NULL,'1290261196001',308.000000000,'1951-04-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4819,'GALLOT','ROGER','1937-12-26','02.86.32.84.07','06.76.47.89.50',NULL,'le beau tonay','','','14850','HEROUVILLETTE',NULL,NULL,'1371214506001',32.000000000,'1964-04-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4820,'BOMMET','JEAN PIERRE','1954-03-16','02.57.94.45.59','06.20.48.66.08',NULL,'1 RUE DES ACACIAS','','','50890','CONDE SUR VIRE',NULL,NULL,'1540314587001',396.000000000,'1976-07-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4821,'CHENEVARIN','EMMANUEL','1935-06-15','02.79.87.24.82','06.11.62.78.47',NULL,'36 RUE JEAN JAURES','','','14190','ST SYLVAIN',NULL,NULL,'2350614138001',200.000000000,'1963-09-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4822,'HUREL','DANIELLE','1958-04-27','02.89.65.74.01',NULL,NULL,'40 avenue de la mer residence l','es dunes','','14000','CAEN',NULL,NULL,'1580461022001',58.000000000,'1980-10-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4823,'CATHRINE','','1956-02-17','02.96.65.15.69','06.57.01.91.44',NULL,'9 RUE DU BOULHOULLAY','','','14000','CAEN',NULL,NULL,'2560214755001',32.000000000,'1977-07-12','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4824,'DEBLED','ANGELE',NULL,'02.94.34.65.59','06.47.28.16.60',NULL,'9 RUE DE L''ILE DE FRANCE','','','14370','MERY CORBON',NULL,NULL,'2320714650001',61.000000000,'2012-05-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4825,'DROST','CLAUDE','1949-01-15','02.10.30.24.77','06.59.20.43.11',NULL,'RUE TARDIFF','','','14123','FLEURY SUR ORNE',NULL,NULL,'1490176716001',365.000000000,'1974-05-24','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4826,'ROGER','MARIE THERESE','1928-06-12','02.34.69.57.63','06.41.80.65.80',NULL,'63 avenue de paris','','','61100','FLERS',NULL,NULL,'2280614562001',58.000000000,'1957-11-30','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4827,'BATTIER','MADELEINE','1943-01-23','02.65.73.21.63','06.10.44.19.88',NULL,'13 place du 18 juillet','','','14470','COURSEULLES SUR MER',NULL,NULL,'1430161232001',187.000000000,'1964-07-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4828,'LAVIE','serge','1929-12-24','02.71.39.01.31','06.10.30.13.57',NULL,'1 RUE DES CAPUCINES','','',NULL,NULL,NULL,NULL,'2291250412001',1526.000000000,'1959-02-17','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4829,'PROFIT','FLORENCE','1933-09-23','02.90.97.32.18','06.13.45.41.62',NULL,'SAINT MAURICE EN COTENTIN','','','14250','HOTTOT LES BAGUES',NULL,NULL,'1330914278001',540.000000000,'1963-12-23','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4830,'FONTAINE','FLORENCE','1936-05-13','02.98.96.60.05','06.10.28.63.45',NULL,'5 rue du maine','','','14000','CAEN',NULL,NULL,'2360551108001',2575.000000000,'1961-04-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4831,'ANDRE','JEAN','1933-10-07','02.87.16.55.25','06.70.17.66.29',NULL,'16 rue des canadiens','','','50000','ST LO',NULL,NULL,'2331014133001',17.000000000,'1961-11-30','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4832,'RONDELEUX','NICOLE','1936-07-22','02.91.90.96.06','06.13.66.10.77',NULL,'la recussonniere','','','14370','CLEVILLE',NULL,NULL,'2360714100001',64.000000000,'1957-09-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4833,'LAGRAVE','MICHELLE','1963-08-03','02.75.27.32.94','06.65.52.54.15',NULL,'4 avenelles au maurice','','','14000','CAEN',NULL,NULL,'1630821460001',143.000000000,'1986-07-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4834,'LAULIER','JEAN MARC','1966-08-21','02.54.29.11.56','06.98.30.83.53',NULL,'10 rue st vincent de paul','','','14000','CAEN',NULL,NULL,'1660814119001',90.000000000,'1987-11-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4835,'CAIRON','MARIE-CLAIRE','1932-09-21','02.27.71.53.21','06.25.10.30.47',NULL,'35 rue des marches','','','14220','GIBERVILLE',NULL,NULL,'2320914253001',36.000000000,'1957-03-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4836,'BINOT','LEON','1955-01-19','02.83.46.78.69','06.74.53.79.13',NULL,'8 RESIDENCE OLYMPIA BD DETOLLE','','','14350','CARVILLE',NULL,NULL,'2550114195001',815.000000000,'1983-11-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4837,'FLECHARD','LUCIEN','1930-08-17','02.11.81.00.44','06.10.69.04.78',NULL,'26 RUE DANIEL DANJOU','','','14000','CAEN',NULL,NULL,'1300814659001',127.000000000,'1956-06-24','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4838,'MENESES','CHARLOTTE','1931-03-06','02.15.25.80.98','06.10.51.35.89',NULL,'LE HOUGUET','','','14430','GERROTS',NULL,NULL,'2310337186001',17.000000000,'1952-12-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4839,'AUBRY','JACQUELINE','1950-02-24','02.49.51.11.81','06.19.07.59.10',NULL,'127 BD RAYMOND POINCARE','','','14470','COURSEULLES SUR MER',NULL,NULL,'2500250054001',95.000000000,'1974-07-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4840,'GRIGY','ALLIETTE','1931-05-13','02.90.33.56.61','06.70.05.28.82',NULL,'31 AVENUE DU MOULIN','','','14000','CAEN',NULL,NULL,'1310550231001',973.000000000,'1952-09-11','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4841,'AVENEAU','PATRICK','1949-07-09','02.77.54.03.26','06.80.53.17.52',NULL,'135 RUE DES RUAUX','','','50700','VALOGNES',NULL,NULL,'1490714466001',26.000000000,'1978-04-16','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4842,'JAUSSAUD','ADRIENNE','1931-07-17',NULL,NULL,NULL,'2 RUE DES CHARMILLES','','','14120','MONDEVILLE',NULL,NULL,'2310714648001',117.000000000,'1958-03-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4843,'JAUSSAUD','LILIANE',NULL,'02.32.14.97.42','06.33.65.75.70',NULL,'22 PLACE PIERRE BOUCHARD','','','14123','IFS',NULL,NULL,'1360976596001',110.000000000,'2008-03-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4844,'LETOREY','STEPHANE','1940-12-09','02.55.55.76.47','06.69.02.95.02',NULL,'3 PLACE DES FONTAINES','','','14120','MONDEVILLE',NULL,NULL,'1401253019001',111.000000000,'1968-12-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4845,'SOISMIER','LILIANE','1936-01-12','02.47.84.88.38','06.10.51.18.58',NULL,'154 BD LEROY','','','14100','ST GERMAIN DE LIVET',NULL,NULL,'2360114171001',60.000000000,'1960-08-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4846,'MACHIN','armelle','1940-08-15','02.40.88.05.67','06.10.22.27.20',NULL,'la heuzerie','','','14270','MEZIDON CANON',NULL,NULL,'2400815119001',105.000000000,'1962-06-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4847,'MOTTAY','DENISE','1952-02-12','02.69.51.70.28','06.75.81.83.01',NULL,'14 rue robert houdin','','','14000','CAEN',NULL,NULL,'1520214268001',8.000000000,'1979-07-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4848,'RIVIERE','GUY','1966-10-12','02.97.26.32.04','06.84.15.69.65',NULL,'10 rue de l''eglise','','','14117','ARROMANCHES LES BAINS',NULL,NULL,'2661014145001',52.000000000,'1989-10-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4849,'AUMOND','JEANNINE','1951-10-14','02.45.25.74.89',NULL,NULL,'52 rue des caillouins','','','14220','BOULON',NULL,NULL,'2511014432001',162.000000000,'1972-07-15','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4850,'MATERN','MICHEL','1940-04-13','02.94.15.13.27','06.10.79.71.48',NULL,'21 impasse  du chene','','','14540','GRENTHEVILLE',NULL,NULL,'2400450210001',193.000000000,'1966-06-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4851,'COURAGEUX','PAUL','1929-08-22',NULL,NULL,NULL,'LE MAIZERET','','','14000','CAEN',NULL,NULL,'1290814722001',322.000000000,'1953-04-03','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4852,'KERIMOV','OLIVIER','1954-01-26','02.11.36.51.37','06.30.00.79.86',NULL,'14 RUE DU BOURGUEDON','','','14123','FLEURY SUR ORNE',NULL,NULL,'2540150472001',85.000000000,'1975-09-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4853,'GUERIN','SYLVIANE','1943-02-11','02.83.98.20.17','06.49.04.18.76',NULL,'20 RUE DE LA CHARTE','','','14920','MATHIEU',NULL,NULL,'1430214717001',2069.000000000,'1973-10-12','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4854,'TSINTSADZE','MARIE-THERESE','1969-11-22','02.27.78.72.85','06.88.65.20.71',NULL,'','','','14160','DIVES SUR MER',NULL,NULL,'1691199256001',129.000000000,'1993-11-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4855,'DECHAUFOUR','THERESE','1939-10-01','02.12.95.06.36','06.34.74.45.11',NULL,'la blanche lande','','','61350','PASSAIS LA CONCEPTION',NULL,NULL,'1391014117001',336.000000000,'1967-01-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4856,'GODEFROY','ALBERT','1929-04-29','02.65.98.42.20','06.10.80.88.84',NULL,'7 rue des accacias','','','14350','LA GRAVERIE',NULL,NULL,'2290414659001',24.000000000,'1952-05-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4857,'LELIEVRE','DOMINIQUE','1929-08-14','02.64.65.11.39','06.44.54.99.41',NULL,'3 RUE DES LAURIERS','','','14310','MAISONCELLES PELVEY',NULL,NULL,'1290814137001',188.000000000,'1957-12-16','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4858,'LECHEVALIER','SUZANNE',NULL,'02.47.77.99.24','06.10.58.98.34',NULL,'14 rue des mariniers','','','50250','VINDEFONTAINE',NULL,NULL,'1600114557001',750.000000000,'2012-09-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4859,'GASTEBLED','JANINE','1934-09-02','02.12.28.45.82','06.13.01.88.38',NULL,'50 RUE DE LA DUCHE','','','14000','CAEN',NULL,NULL,'1340914666001',7.000000000,'1963-09-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4860,'GABOYER','DOMINIQUE','1939-05-03','02.34.71.04.11','06.15.82.28.68',NULL,'4 RUE DANIEL TISON','','','14000','CAEN',NULL,NULL,'1390514762001',280.000000000,'1969-07-23','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4861,'PAYOT','TERESA','1941-05-12','02.84.74.29.61',NULL,NULL,'5 IMPASSE DES BARONNIERS','','','14430','DOZULE',NULL,NULL,'2410514653001',41.000000000,'1965-07-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4862,'GUESDON','DENISE','1935-12-21','02.27.67.49.09','06.69.23.77.91',NULL,'10 RUE DES FRERES BOUDROIS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1351214320001',867.000000000,'1957-07-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4863,'MARSAULT','JEAN','1935-05-07','02.31.13.68.54','06.10.93.95.92',NULL,'','','','14630','FRENOUVILLE',NULL,NULL,'1350578226001',95.000000000,'1960-07-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4864,'SOULARD','IRMA','1935-08-26','02.93.28.04.95','06.57.44.05.11',NULL,'26 allee des peupliers','','','14670','JANVILLE',NULL,NULL,'2350850196001',2155.000000000,'1956-07-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4865,'OUF','SAMI','1935-03-02','02.96.26.74.15',NULL,NULL,'6 chemin des marettes','','','27000','EVREUX',NULL,NULL,'2350314463001',752.000000000,'1960-01-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4866,'PEIGNEY','JEAN JACQUES','1937-03-26','02.35.08.47.16','06.10.03.26.70',NULL,'13 ROUTE DU ROBILLARD ','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1370314437001',208.000000000,'1965-05-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4867,'PAGNY','JACQUELINE','1959-01-10','02.91.45.45.69','06.61.75.77.22',NULL,'7 RUE CLOS DU PAVILLON','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1590127367001',20.000000000,'1986-05-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4868,'GUYOT','MAURICE','1936-10-28','02.73.82.43.19','06.82.82.12.04',NULL,'5 RUE DE LA PAIX','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2361014715001',20.000000000,'1960-12-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4869,'BOUET','ALBERT','1933-11-19','02.11.34.90.14','06.35.00.65.82',NULL,'crocy','','','14000','CAEN',NULL,NULL,'2331114656001',61.000000000,'1955-01-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4870,'JARDIN','ERNEST','1932-09-03','02.41.80.34.30','06.31.54.87.38',NULL,'1 la landel','','','14000','CAEN',NULL,NULL,'2320914310001',151.000000000,'1957-03-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4871,'DESSOUDE','GISELE','1928-04-29','02.86.70.23.61','06.40.16.69.78',NULL,'1 rue neuve','','','14630','FRENOUVILLE',NULL,NULL,'2280414271001',7.000000000,'1958-04-23','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4872,'GOINGUENET','LUC','1942-03-08','02.69.76.78.33','06.19.94.81.72',NULL,'2 RUE DES CIGOGNES LES PEDOUZES','','','14000','CAEN',NULL,NULL,'2420314589001',716.000000000,'1966-11-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4873,'CYRVAN','GILBERT','1955-01-22','02.27.35.57.86','06.76.17.36.77',NULL,'106 RUE BRANVILLE','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'2550114221001',257.000000000,'1976-11-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4874,'MARTIN','MARGUERITE','1937-08-14','02.65.98.11.79','06.16.08.31.20',NULL,'LA FORMIERE','','','14220','BARBERY',NULL,NULL,'1370814598001',62.000000000,'1958-08-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4875,'LEFLOCH','MARIE-THERESE','1931-01-26','02.10.09.75.49','06.50.07.84.52',NULL,'22 avenue de la concorde','','','76400','FECAMP',NULL,NULL,'2310114678001',1390.000000000,'1961-02-25','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4876,'LEFLOCH','ODETTE','1952-01-14','02.86.16.77.59','00 33 6.81.13.21.52',NULL,'8 rue jules ferry','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1520102585001',3732.000000000,'1975-01-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4877,'LECHARTIER','PIERRE','1969-03-01','02.23.43.08.21','06.37.38.62.14',NULL,'le bourg','','','14320','FONTENAY LE MARMION',NULL,NULL,'1690314525001',27.000000000,'1990-10-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4878,'GOYER','MARCEL','1933-02-01','02.21.45.71.01','06.34.18.13.90',NULL,'45 RUE DUHAMEL','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2330214277001',77.000000000,'1956-07-19','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4879,'SERVAGER','CHRISTIAN','1937-11-06','02.13.07.15.64','06.55.69.74.00',NULL,'26 rue de l''eglise','','','14120','MONDEVILLE',NULL,NULL,'1371161459001',207.000000000,'1966-09-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4880,'LECLERC','GERMAINE','1941-02-19','02.79.53.50.74',NULL,NULL,'25 avenue de verdun','','',NULL,NULL,NULL,NULL,'1410214607001',273.000000000,'1966-04-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4881,'DESETABLE','ERIC','1935-08-29','02.21.99.51.89','06.24.00.61.57',NULL,'27 rue de troarn','','','14150','OUISTREHAM',NULL,NULL,'2350861150001',203.000000000,'1963-06-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4882,'ANAYA','REGINE','1952-03-04','02.77.62.84.85','06.28.15.60.24',NULL,'22 rte de creully','','','14270','MEZIDON CANON',NULL,NULL,'1520350416001',37.000000000,'1982-03-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4883,'JEANNE','JEAN-PAUL','1965-01-18','02.46.41.70.84','06.73.84.15.53',NULL,'11 RUE DE VERDUN','','','14670','TROARN',NULL,NULL,'2650185301001',153.000000000,'1991-01-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4884,'MONTMORENCY','MAURICE','1946-01-16','02.84.70.87.88','06.27.66.73.31',NULL,'7 rue de suede','','','14120','MONDEVILLE',NULL,NULL,'1460150036001',69.000000000,'1969-04-29','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4885,'HERVE','BERNADETTE','1969-08-07','02.85.70.83.49','06.74.36.01.89',NULL,'3 rue de l egalite','','','61200','ARGENTAN',NULL,NULL,'2690892036001',46.000000000,'1993-07-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4886,'BEAUFILS','NICOLE','1934-11-25','02.68.02.20.46','06.45.93.26.05',NULL,'2 RESIDENCE DU CHAMP DE L ORMEAU','','','14610','ANISY',NULL,NULL,'1341114464001',345.000000000,'1955-10-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4887,'BEAUFILS','ODETTE','1944-01-31','02.12.09.77.12','06.22.51.33.36',NULL,'3 rue des benedictins','','','14730','GIBERVILLE',NULL,NULL,'1440114143001',70.000000000,'1968-11-20','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4888,'LEMOINE','ELISABETH','1966-07-17','02.93.75.33.29','06.70.30.40.46',NULL,'7 rue porte millet','','','14940','SANNERVILLE',NULL,NULL,'1660714325001',140.000000000,'1996-11-10','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4889,'URIEN','JOSETTE','1936-09-24','02.72.23.24.14','06.63.01.00.34',NULL,'7 rue des anciens d''afn','','','14970','BENOUVILLE',NULL,NULL,'2360986078001',9.000000000,'1963-10-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4890,'ALLIOUX','PAUL','1939-08-12','02.34.93.88.94','06.43.49.39.22',NULL,'11-04 BELLES PORTES','','','14920','MATHIEU',NULL,NULL,'1390856203001',408.000000000,'1963-01-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4891,'CHALES','FREDDY','1929-03-26','02.10.23.74.43',NULL,NULL,'49 ROUTE  DE  PIGNOCHET','','','14000','CAEN',NULL,NULL,'1290305110001',12.000000000,'1959-04-10','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4892,'THOMAS','MARIE','1928-12-27','02.83.10.94.00','06.37.61.59.36',NULL,'','','','14160','PERIERS EN AUGE',NULL,NULL,'1281214666001',77.000000000,'1951-05-22','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4893,'CORBALAN','BERNARD','1939-04-03','02.12.00.97.69','06.65.94.10.97',NULL,'23 rue  du stade','','','14700','ST PIERRE DU BU',NULL,NULL,'2390450042001',265.000000000,'1969-11-12','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4894,'CHANDON','MARTHE','1938-02-13','02.74.85.27.27',NULL,NULL,'11 RUE D ANJOU','','','14860','BAVENT',NULL,NULL,'2380214585001',24.000000000,'1960-08-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4895,'DALIGAULT','CHANTAL','1936-07-20','02.90.66.67.75','06.23.08.68.38',NULL,'60 RUE DU XX EME SIECLE','','','61310','ST PIERRE LA RIVIERE',NULL,NULL,'1360714331001',32.000000000,'1959-01-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4896,'DELAQUAIZE','JEAN CLAUDE','1932-08-03','02.10.30.60.05','06.40.61.32.11',NULL,'16 RUE HENRI BARBUSSE','','','31000','TOULOUSE',NULL,NULL,'1320814482001',347.000000000,'1956-10-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4897,'GROUET','GISELE','1933-11-01','02.73.77.86.45','06.71.95.03.76',NULL,'le bourg','','','14320','FONTENAY LE MARMION',NULL,NULL,'1331162764001',34.000000000,'1958-01-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4898,'SIGNORET','REMY','1950-05-02','02.70.89.95.86','06.14.37.92.10',NULL,'306 haute folie','','','14000','CAEN',NULL,NULL,'1500514529001',94.000000000,'1975-05-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4899,'GRZYWA','armelle','1932-01-08','02.37.57.10.65','06.34.06.92.05',NULL,'','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'1320124094001',4221.000000000,'1953-03-03','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4900,'','MARCELLINE','1932-01-14','02.44.83.73.64','06.38.51.87.12',NULL,'3 RUE SENTE AU COIN','','','14330','LE MOLAY LITTRY',NULL,NULL,'1320124094001',389.000000000,'1962-06-20','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4901,'FERET','COLETTE','1933-07-15','02.51.74.42.62',NULL,NULL,'7 rue de la forge','','','50810','LA BARRE DE SEMILLY',NULL,NULL,'1330708415001',3154.000000000,'1958-10-17','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4902,'DE VALLEE','THIERRY','1934-01-10','02.10.80.54.65','06.55.04.10.36',NULL,'LOTISSEMENT DU CHAMPS DE FOIRE','','','14123','IFS',NULL,NULL,'2340114254001',561.000000000,'1955-09-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4903,'LAMORLETTE','VERONIQUE','1928-04-17','02.82.23.23.45','06.67.06.60.16',NULL,'6 AVENUE MARCEL CACHIN ALLEE D','','','14270','MEZIDON CANON',NULL,NULL,'1280414529001',33.000000000,'1957-12-08','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4904,'BRICET','ILQAR','1935-04-11','02.88.36.56.71','06.76.86.01.38',NULL,'9 4 CITEE DES ROCHES','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1350414066001',5.000000000,'1961-11-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4905,'STAEL','MARIELLE',NULL,'02.47.78.49.84','06.10.94.93.88',NULL,'12 rue principale','','',NULL,NULL,NULL,NULL,'1620614587001',348.000000000,'2010-07-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4906,'LESELLIER','ANNIE','1950-01-24','02.45.98.17.60','06.30.85.79.43',NULL,'12 rue du petit bonheur','','','14190','CAUVICOURT',NULL,NULL,'1500114530001',709.000000000,'1972-05-25','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4907,'GUILLEMETTE','FRANCOISE','1958-06-26','02.78.78.25.61','06.96.89.92.52',NULL,'4 RUE DE GRAINVILLE','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'2580614328001',106.000000000,'1982-11-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4908,'CHOPIN','CLAUDE','1933-09-01','02.13.37.92.71','06.91.00.70.28',NULL,'25 boulevard de l''esperance','','','61150','GOULET',NULL,NULL,'2330951242001',172.000000000,'1962-12-25','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4909,'DELAFOSSE','MARIE-CLAIRE','1952-01-26','02.88.92.80.41','06.89.35.14.80',NULL,'86 AVENUE DE ROUEN','','','14123','IFS',NULL,NULL,'1520135241001',17.000000000,'1979-11-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4910,'LEFEBVRE','ANDREE','1929-05-29','02.51.06.80.83','06.75.37.93.17',NULL,'3 CITE DES FORGES','','','14000','CAEN',NULL,NULL,'2290550238001',335.000000000,'1951-01-02','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4911,'SANSON','EDOUARD','1935-11-13','02.10.79.36.39','06.71.48.95.84',NULL,'17 BD DE RETHEL','','','14270','MEZIDON CANON',NULL,NULL,'2351150025001',147.000000000,'1964-11-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4912,'QUESNEY','LOUISE',NULL,'02.76.70.79.19','06.44.81.18.58',NULL,'138 BD LYAUTEY','','','14123','IFS',NULL,NULL,'2330214207001',2.000000000,'2008-04-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4913,'LESENECAL','MARIE-JOSEPH','1938-02-10','02.85.93.63.43','06.32.99.07.65',NULL,'98 A1 RUE DE BRANVILLE','','','14210','EVRECY',NULL,NULL,'2380214268001',493.000000000,'1961-02-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4914,'VERRIERE','BERNARD','1934-09-06','02.10.59.60.39','06.48.56.64.00',NULL,'9 RUE DE NORMANDIE','','','14430','CRICQUEVILLE EN AUGE',NULL,NULL,'1340914349001',1203.000000000,'1962-11-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4915,'MARIE','BERNARD','1936-03-27','02.82.98.36.46','06.55.09.00.81',NULL,'LE PONT DE VIE','','','14310','VILLERS BOCAGE',NULL,NULL,'1360350328001',97.000000000,'1960-09-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4916,'BANKOWSKI','GERARD','1947-03-14','02.10.39.21.13','06.11.39.66.18',NULL,'ROBERT SCHUMAN','','','14000','CAEN',NULL,NULL,'1470314009001',58.000000000,'1971-04-06','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4917,'CRESPIN','MARIE-MADELEIN','1932-02-12','02.94.67.30.92','06.74.44.02.09',NULL,'1 allee louis aragon','','','50570','MARIGNY',NULL,NULL,'1320214409001',878.000000000,'1954-05-13','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4918,'GESBERT','THIERRY','1958-01-30','02.48.83.00.03','06.26.27.58.79',NULL,'maison de retraite normandie','','','50420','DOMJEAN',NULL,NULL,'2580114444001',91.000000000,'1980-10-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4919,'BAYEUL','PIERRE','1936-04-28','02.29.29.95.00','06.10.94.05.28',NULL,'11 RUE DES ECUREUILS','','','14930','VIEUX',NULL,NULL,'1360414248001',41.000000000,'1965-08-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4920,'HOUEIX','MICHEL','1934-11-17','02.12.64.10.54','06.11.05.54.21',NULL,'19 LE PRE SAINT MARTIN','','','14980','ROTS',NULL,NULL,'2341114076001',402.000000000,'1961-12-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4921,'HOUEIX','GERARD','1959-01-01','02.60.35.83.28','06.74.03.78.09',NULL,'le clos st lo','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'1590114090001',2767.000000000,'1986-02-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4922,'BREHON','OLIVIER','1929-12-14','02.53.47.84.16','06.98.11.80.93',NULL,'53 rue wladimir martrel','','','14570','ST LAMBERT',NULL,NULL,'2291214692001',1831.000000000,'1956-12-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4923,'DAUGE','MARTINE','1915-05-17','02.13.16.16.35','06.10.47.67.32',NULL,'6 PLACE DU PARC','','','14840','DEMOUVILLE',NULL,NULL,'2150503293001',212.000000000,'1945-05-13','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4924,'TORAILLE','ADRIENNE','1932-12-03','02.49.84.44.14','06.84.34.92.07',NULL,'7 RUE JEANNE D''ARC','','','50760','REVILLE',NULL,NULL,'2321214623001',95.000000000,'1959-08-26','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4925,'SENINCK','MAURICE','1958-02-26','02.40.55.63.47','06.39.13.60.80',NULL,'6 RUE DE L''ESPERANCE','','','50120','EQUEURDREVILLE HAINNEVILLE',NULL,NULL,'2580214315001',215.000000000,'1986-03-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4926,'ALLIX','STEPHANE','1949-02-08','02.42.40.11.38','06.13.64.99.52',NULL,'7 rue des accacias','','','14250','ELLON',NULL,NULL,'2490214753001',75.000000000,'1976-01-22','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4927,'GICQUEL','PIERRE','1930-03-31','02.30.95.13.25','06.18.56.87.84',NULL,'53 RUE MAURICE FOUQUES','','','14730','GIBERVILLE',NULL,NULL,'1300350222001',1096.000000000,'1953-05-30','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4928,'MARTIN','','1961-10-31','02.59.33.37.10','06.76.72.50.47',NULL,'2 RUE DES BRUYERES','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1611053081001',461.000000000,'1986-06-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4929,'LECOMTE','MADELEINE','1936-02-19','02.11.67.32.86','06.56.55.87.16',NULL,'LE HAMEAU DE SOQUENCE','','','14630','CAGNY',NULL,NULL,'2360214561001',183.000000000,'1963-12-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4930,'DAVY','JOCELYNE','1931-01-20','02.14.49.98.57','06.62.51.94.69',NULL,'20 RUE VICTOR CHAUTARD','','','14750','ST AUBIN SUR MER',NULL,NULL,'1310161227001',448.000000000,'1952-02-02','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4931,'QUEUDRUE','maurice','1932-03-04','02.10.90.71.74',NULL,NULL,'28 rue du village st pierre','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2320314537001',0.000000000,'1955-09-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4932,'RENAULT','MARGUERITE','1937-01-26','02.12.86.43.60','06.17.46.39.46',NULL,'62 bis bd lyautey RESIDENCE LA','BRUYERE','','50190','LA FEUILLIE',NULL,NULL,'2370114379001',50.000000000,'1963-07-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4933,'MESLAY','PIERRE','1950-02-19','02.59.72.32.33','06.71.20.60.41',NULL,'37 angelerie impasse voltaire','','','50190','LA FEUILLIE',NULL,NULL,'2500214026001',13.000000000,'1975-12-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4934,'TRAVERST','SOLANGE','1928-04-21','02.21.58.75.86','06.11.86.71.21',NULL,'43 BIS RUE DE LISBONNE','','','14940','SANNERVILLE',NULL,NULL,'2280414716001',14.000000000,'1958-12-04','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4935,'DELARUE','','1931-09-15','02.82.80.96.01','06.90.83.46.68',NULL,'60 rue eugene boudin','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1310914026001',854.000000000,'1959-08-05','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4936,'BOULLAND','CLAUDE','1957-03-16','02.35.60.17.21','06.72.65.51.69',NULL,'15 RUE FERDINAND BUISSON','','','14260','ST PIERRE DU FRESNE',NULL,NULL,'1570314281001',57.000000000,'1981-02-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4937,'GODEFROY','JOSIANE','1953-01-27','02.83.77.18.12','06.67.54.79.29',NULL,'','','','14460','COLOMBELLES',NULL,NULL,'2530114278001',3.000000000,'1982-03-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4938,'SUSANNE','FERNANDE','1952-01-22','02.28.91.39.67','06.33.67.59.27',NULL,'15 rue ARAGO','','','14570','CLECY',NULL,NULL,'1520150615001',119.000000000,'1980-11-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4939,'MARY','JEAN','1932-06-19','02.64.72.92.71','06.12.65.34.32',NULL,'83 rue mint st michel','','','14980','ROTS',NULL,NULL,'1320627499001',609.000000000,'1955-11-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4940,'RATEL','LILIANE','1938-01-31','02.10.21.11.97','06.30.31.19.10',NULL,'564 RUE DE LA MARE','','','14000','CAEN',NULL,NULL,'1380114028001',308.000000000,'1962-06-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4941,'ANGER','THERESE',NULL,'02.32.68.85.73','06.64.99.63.91',NULL,'7 RUE PASTEUR LUTHER KING','','','14540','ROCQUANCOURT',NULL,NULL,'1620150550001',124.000000000,'2013-08-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4942,'MARIE','ANTOINE','1936-10-06','02.53.61.10.53','06.23.81.65.56',NULL,'121 LA POMERAIE','','','50820','BRIX',NULL,NULL,'1361050605001',821.000000000,'1959-08-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4943,'DEBRIS','Emilien','1950-01-24','02.16.03.01.62','06.35.00.22.40',NULL,'3 IMPASSE AU COIN','','','14000','CAEN',NULL,NULL,'1500114417001',9.000000000,'1980-11-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4944,'CARDON','RAYMOND','1940-04-23','02.12.25.57.48','06.95.97.10.81',NULL,'1 la cour','','','14540','BOURGUEBUS',NULL,NULL,'2400414400001',202.000000000,'1961-05-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4945,'','MARIE CLAUDE','1949-01-28','02.81.44.16.45','06.52.01.13.40',NULL,'3 RUE DU STADE','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1490114729001',3632.000000000,'1976-09-28','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4946,'JEANNE','EMILIEN','1969-07-15','02.12.03.01.23','06.94.80.58.03',NULL,'2 rue p vaillant couturier','','','14460','COLOMBELLES',NULL,NULL,'2690780021001',31.000000000,'1994-09-07','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4947,'DESRAME','DENISE','1930-08-20','02.91.59.79.09','06.75.26.29.85',NULL,'5 RUE DES VIOLETTES','','','14000','CAEN',NULL,NULL,'1300861480001',1848.000000000,'1959-11-14','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4948,'GUINAUDEAU','BERNARD','1931-08-26','02.50.71.28.36','06.11.31.39.42',NULL,'11 RUE DUE MARECHAL LECLERC','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'1310859319001',71.000000000,'1953-08-01','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4949,'JOURDAN','JEAN-PIERRE','1961-02-23','02.15.91.20.63','06.88.78.02.41',NULL,'7 RUE DU STADE','','','14540','SOLIERS',NULL,NULL,'2610214287001',258.000000000,'1988-10-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4950,'BINET','ODILE','1940-02-14','02.11.46.89.96','06.91.50.40.64',NULL,'HAMEAU D''ESCURES','','','14670','TROARN',NULL,NULL,'2400214701001',321.000000000,'1970-12-07','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4951,'MIREY','CLAUDE','1956-01-29','02.44.31.04.88','06.63.72.60.82',NULL,'36 rue eustache ristou','','','14250','JUVIGNY SUR SEULLES',NULL,NULL,'2560146223001',29.000000000,'1981-02-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4952,'BLAISE','ALEXANDRE','1966-06-24','02.65.02.07.10','06.11.06.57.74',NULL,'19 rue jean pierre fierdehaiche','','','14120','MONDEVILLE',NULL,NULL,'1660614046001',81.000000000,'1991-09-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4953,'BASILE','GUY','1936-12-16','02.79.28.39.60','06.93.79.18.51',NULL,'rue  de la mairie','','','14000','CAEN',NULL,NULL,'2361250423001',299.000000000,'1958-08-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4954,'WAGNER','GINETTE','1943-03-20','02.48.21.98.97','06.62.38.84.48',NULL,'56 rue louis robillard','','','14000','CAEN',NULL,NULL,'1430327364001',57.000000000,'1967-05-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4955,'LE ROY','MARYLINE','1939-04-12','02.73.91.30.77','06.75.58.44.72',NULL,'12 RUE DE NORTHAM','','','14930','ETERVILLE',NULL,NULL,'1390414229001',232.000000000,'1961-09-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4956,'PASTRIGNANI','RENEE','1928-09-29','02.43.46.26.59','06.31.78.61.61',NULL,'14 RUE DE CHAMPAGNE','','','14630','FRENOUVILLE',NULL,NULL,'1280914711001',48.000000000,'1957-06-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4957,'BONIN','GUY','1966-04-14','02.72.64.37.27','06.86.96.30.21',NULL,'22 RUE DU BAC','','','14770','CAUVILLE',NULL,NULL,'2660441022001',28.000000000,'1996-08-03','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4958,'HUVIER','CONSTANT','1968-09-26','02.10.51.73.39','06.92.10.17.73',NULL,'13 avenue sainte therese','','','14270','MEZIDON CANON',NULL,NULL,'1680914390001',46.000000000,'1997-06-03','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4959,'LETURCQ','BRIGITTE','1939-12-01','02.12.29.09.35','06.71.30.66.09',NULL,'13 BOULEVARD DE RETHEL','','','14370','MERY CORBON',NULL,NULL,'1391214535001',2190.000000000,'1966-06-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4960,'GALLET','GERMAINE','1931-10-29','02.57.23.65.67','06.21.08.65.16',NULL,'26 RUE JEAN ROMAIN','','','14000','CAEN',NULL,NULL,'2311014163001',365.000000000,'1961-03-09','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4961,'PICHONNIER','BERNARD','1933-08-06','02.35.84.92.49','06.44.32.14.90',NULL,'RESIDENCE LES CARAVELLES RUE D','E NORMANDIE  BAT.D','','14000','CAEN',NULL,NULL,'1330814685001',291.000000000,'1957-04-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4962,'DELARUE','REINE','1950-01-16','02.51.81.06.64','06.11.98.25.89',NULL,'ST SYMPHORIEN','','','14320','FONTENAY LE MARMION',NULL,NULL,'2500150020001',176.000000000,'1972-09-03','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4963,'AUGER','CHANTAL','1938-12-15','02.31.98.58.00','06.54.76.61.20',NULL,'1 IMPASSE DES DAHLIAS','','','14270','MEZIDON CANON',NULL,NULL,'2381214133001',270.000000000,'1965-04-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4964,'DAUTRICHE','JACQUES','1940-04-24','02.11.87.28.19','06.46.28.59.36',NULL,'1 IMPASSE DU MAL FERRAND','','','14120','MONDEVILLE',NULL,NULL,'1400414467001',976.000000000,'1963-01-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4965,'PIROU','','1927-01-31','02.34.68.46.33','06.11.20.29.30',NULL,'12 RUE DU PETIT PLAIN','','','14123','FLEURY SUR ORNE',NULL,NULL,'1270124229001',428.000000000,'1948-12-30','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4966,'THEUNYNCK','SYLVIE','1932-06-11','02.25.61.17.41','06.61.74.85.65',NULL,'1450 ROUTE DE BRETTEVILLE','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'2320614554001',799.000000000,'1953-06-29','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4967,'VIC','JEAN BAPTISTE','1967-04-28','02.11.11.47.35','06.54.56.15.06',NULL,'LE PARADIS','','','61230','GACE',NULL,NULL,'1670414537001',33.000000000,'1991-09-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4968,'LEFEVRE','MARCEL','1934-07-22','02.69.12.45.69','06.61.77.29.42',NULL,'ROUTE NATIONALE','','','14320','MAY SUR ORNE',NULL,NULL,'1340714020001',924.000000000,'1961-11-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4969,'TILLON','BERNARD','1936-12-01','02.81.94.98.18','06.87.95.83.16',NULL,'54 RUE DES CAILLOUINS','','','14240','LIVRY',NULL,NULL,'1361214271001',31.000000000,'1965-10-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4970,'DUFRESNE','DANIEL','1939-05-20','02.56.08.98.95','06.24.88.82.68',NULL,'SAON','','','14670','ST OUEN DU MESNIL OGER',NULL,NULL,'1390514383001',292.000000000,'1969-06-14','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4971,'MONSTERLEET','HENRI','1933-12-01','02.41.29.93.76','06.95.63.57.13',NULL,'25 AVENUE DE LA DUCHESSE GONNOR','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2331250014001',84.000000000,'1955-10-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4972,'ANNE','JOSEPH','1933-06-21','02.13.66.20.38','06.58.63.10.28',NULL,'27 RUE ALBERT CAMUS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1330614211001',643.000000000,'1955-03-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4973,'MERCET','GILBERTE','1930-07-01','02.15.88.05.37','06.52.98.77.84',NULL,'8 SENTE AUX MOINES','','','14190','FIERVILLE BRAY',NULL,NULL,'2300703181001',7.000000000,'1958-07-07','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4974,'AUDOUX','YVES','1930-06-11','02.67.25.34.51','06.48.18.55.64',NULL,'13 RUE DE LA PISCINE','','','14370','MERY CORBON',NULL,NULL,'2300614118001',153.000000000,'1953-03-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4975,'LELIEVRE','JEAN','1947-01-06','02.26.41.42.11','06.42.39.54.31',NULL,'3 rue paul langevin','','','14670','ST SAMSON',NULL,NULL,'2470114124001',405.000000000,'1969-09-30','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4976,'DAMECOURT','GUY','1929-08-19','02.45.40.33.53','06.11.43.15.71',NULL,'108 BOULEVARD DES BELLES PORTES','','','14210','NOYERS BOCAGE',NULL,NULL,'1290814327001',28.000000000,'1953-07-04','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4977,'MAHEUT','JACQUES','1930-05-06','02.59.82.33.41','06.52.52.64.30',NULL,'8 RUE DE LA FLEURIERE','','','14210','NOYERS BOCAGE',NULL,NULL,'1300538122001',217.000000000,'1952-12-21','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4978,'PORQUET','LILIANE','1931-11-29','02.44.26.18.84','06.10.30.32.99',NULL,'3 RUELLE BINET','','','14220','GRIMBOSQ',NULL,NULL,'2311114703001',1787.000000000,'1957-01-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4979,'PONCHON','JOCELYNE','1929-04-26','02.13.83.89.96','06.67.88.28.68',NULL,'RUE LEON GUIGNE','','','14123','IFS',NULL,NULL,'2290414402001',602.000000000,'1954-01-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4980,'DUBOIS','GERARD','1955-05-19','02.12.25.72.82','06.22.26.45.26',NULL,'21 CHEMIN D ALLEMAGNE','','','14230','LES OUBEAUX',NULL,NULL,'2550527064001',81.000000000,'1976-12-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4981,'LEMAIGRE DEMESNIL','GERARD','1950-03-30','02.40.22.69.81','06.50.01.22.51',NULL,'LE VIRNIER','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1500361511001',1101.000000000,'1978-07-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4982,'BRIOUZE','jean','1970-03-04','02.60.19.05.42','06.81.75.92.07',NULL,'8 IMPASSE DU BEARN','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'1700314344001',100.000000000,'1998-07-19','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4983,'BAZIN','DANIEL','1956-06-14','02.21.16.13.20','06.42.78.19.87',NULL,'12 rue franklin','','','14850','ESCOVILLE',NULL,NULL,'2560650081001',1041.000000000,'1979-03-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4984,'DUCHEMIN','ROLAND','1934-11-30','02.90.30.50.34','06.10.41.07.91',NULL,'8 rue henri hanburen','','','14210','EVRECY',NULL,NULL,'1341114584001',17.000000000,'1959-05-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4985,'MARIE','SOLANGE','1933-01-25','02.64.78.03.40','06.16.16.34.42',NULL,'1 impasse des fresne','','','14000','CAEN',NULL,NULL,'1330160601001',24.000000000,'1958-10-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4986,'DESFONTAINES','CATHERINE','1939-10-23','02.62.32.94.12','06.11.81.00.76',NULL,'6 RUE VICTOR HUGO','','','14150','OUISTREHAM',NULL,NULL,'2391014287001',147.000000000,'1962-11-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4987,'POSTIL','CHRISTIAN','1940-09-18','02.48.39.33.58','06.48.97.90.80',NULL,'les moutiers en cinglais','','','14370','AIRAN',NULL,NULL,'2400961486001',34.000000000,'1967-08-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4988,'FINEL','ALAIN','1962-10-21','02.49.32.41.43','06.79.73.12.29',NULL,'21 rue des salines','','','14210','NOYERS BOCAGE',NULL,NULL,'2621014149001',1258.000000000,'1992-02-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4989,'PINEAU','GEORGETTE','1935-04-16','02.18.45.19.58','06.70.66.55.11',NULL,'67 AVENUE CHARLEMAGNE','','','14370','ARGENCES',NULL,NULL,'1350490102001',139.000000000,'1962-10-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4990,'LUCAS','ERIC','1951-04-13','02.69.06.59.61','06.68.43.82.55',NULL,'47 AVENUE DE LA BRIGADE PIRON','','','14540','GRENTHEVILLE',NULL,NULL,'2510414034001',81.000000000,'1980-10-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4991,'SEGMANE','GILBERT',NULL,'02.19.93.13.95','06.12.16.59.93',NULL,'2 RUE SAINTE OPPORTUNE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1440353173001',1452.000000000,'2009-09-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4992,'MARIE','JEAN PAUL','1963-01-20','02.71.13.32.61','06.90.80.31.83',NULL,'app 233 res la bruyere 20 rue ed','ouard vaillant','','14123','CORMELLES LE ROYAL',NULL,NULL,'1630114643001',990.000000000,'1989-08-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4993,'RIEGLER','MARTIAL','1936-07-09','02.77.93.26.29','06.79.39.45.36',NULL,'1 RUE ST ANDRE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2360750030001',32.000000000,'1959-09-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4994,'HEBERT','JACQUELINE','1935-04-15','02.84.78.67.83','06.64.15.53.53',NULL,'2 RUE DU CLOS LEROY','','','14540','POUSSY LA CAMPAGNE',NULL,NULL,'2350414592001',921.000000000,'1956-07-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4995,'BOUTAMINE','BRIGITTE','1940-09-13','02.43.47.84.56','06.71.22.95.66',NULL,'13 RUE LUCIEN NELLE VENOIX','','','14270','MEZIDON CANON',NULL,NULL,'2400914312001',396.000000000,'1963-08-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4996,'DUBREUIL','SIGRID','1934-09-19','02.16.07.98.59','06.10.13.87.00',NULL,'70 RUE ARMAND MARIE','','','14000','CAEN',NULL,NULL,'2340914538001',53.000000000,'1957-12-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4997,'DUBREUIL','EDOUARD','1931-04-02','02.11.19.83.62','06.54.75.89.17',NULL,'70 RUE ARMAND MARIE','','','14250','FONTENAY LE PESNEL',NULL,NULL,'1310414167001',1814.000000000,'1957-10-18','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4998,'FERRON','SABINE','1937-03-03','02.62.74.70.67',NULL,NULL,'12 RUE PIERRE CURIE','','','14400','ST MARTIN DES ENTREES',NULL,NULL,'2370324185001',1394.000000000,'1959-06-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (4999,'MULAC','CLAUDE','1933-08-03','02.54.44.16.42','06.84.31.18.42',NULL,'LE LIOUX','','','14700','AUBIGNY',NULL,NULL,'2330814689001',2.000000000,'1960-10-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5000,'FARCY','','1947-08-04','02.22.09.89.44','06.81.69.75.93',NULL,'1 RUE VAL ES DUNE','','','14120','MONDEVILLE',NULL,NULL,'1470814657001',418.000000000,'1970-06-06','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5001,'TRUPOT','MICHEL','1963-09-10','02.43.37.74.49',NULL,NULL,'9 RUE DE L ETANG','','','14260','BANNEVILLE SUR AJON',NULL,NULL,'2630914142001',165.000000000,'1985-06-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5002,'LEBLATIER','','1929-02-09','02.97.51.29.58','06.86.06.43.04',NULL,'13/5 RUE DU BOIS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1290214462001',57.000000000,'1953-11-24','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5003,'GIBOT','NICOLE','1935-10-08','02.44.27.02.78','06.19.05.35.21',NULL,'3 PASSAGE DES JACOBINS','','','14120','MONDEVILLE',NULL,NULL,'2351050522001',19.000000000,'1959-02-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5004,'LETOT','GERMAINE','1928-04-08','02.78.49.25.79','06.11.69.83.91',NULL,'35 AVENUE SAINT PIERRE ET MIQUEL','ON','','14400','MONCEAUX EN BESSIN',NULL,NULL,'2280414271001',213.000000000,'1954-10-17','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5005,'RIGAULT','LUCIEN','1952-05-10','02.96.48.89.00','06.76.06.24.83',NULL,'2 RUE DE LA TOSTAINERIE DE BAS','','','14320','FONTENAY LE MARMION',NULL,NULL,'1520514118001',1137.000000000,'1979-10-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5006,'LAMIDEY','JACKIE','1937-05-12','02.10.96.63.71','06.72.87.69.57',NULL,'17 ROUTE DE CAEN','','','50260','BRICQUEBEC',NULL,NULL,'1370550136001',44.000000000,'1959-09-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5007,'MARIE','FRANCOIS','1925-06-21','02.35.85.01.77','06.80.53.88.20',NULL,'7 AVENUE JEAN CATHERINE','','','14630','FRENOUVILLE',NULL,NULL,'2250658010001',197.000000000,'1952-10-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5008,'AIDART','MARIE-MADELEINE','1940-05-23','02.70.70.13.54','06.51.75.48.26',NULL,'14 rue pont d''etain','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2400514076001',44.000000000,'1966-07-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5009,'MOREL','PHILIPPE','1931-05-04','02.10.71.25.91','00 33 6.41.39.84.52',NULL,'chemin du capelier','','','14240','CAUMONT L''EVENTE',NULL,NULL,'1310541165001',43.000000000,'1958-08-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5010,'LALANDE','MAURICE','1938-12-08','02.55.04.47.56','06.51.45.13.13',NULL,'RESIDENCE LES LILAS','','','14123','IFS',NULL,NULL,'1381214020001',310.000000000,'1961-04-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5011,'ATTALAH','ANDRE','1962-03-31','02.31.28.58.76','06.18.94.75.33',NULL,'3 CHEMIN DU MARAIS','','','14840','DEMOUVILLE',NULL,NULL,'2620314675001',24.000000000,'1988-09-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5012,'MARIE','MARGUERITE','1933-10-10','02.44.93.27.61','06.25.33.82.28',NULL,'9 boulevard de la charit','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'2331062317001',766.000000000,'1956-04-22','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5013,'LACOUR','CHARLES','1937-01-29','02.57.39.53.12','06.61.04.24.18',NULL,'1 RUE DES GRANDES PATURES','','','50510','CERENCES',NULL,NULL,'2370141089001',197.000000000,'1967-11-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5014,'VASSE','RENE','1954-04-25','02.20.56.15.67','06.73.71.55.55',NULL,'4 passagejacques feuillebois','','','14000','CAEN',NULL,NULL,'2540414373001',2212.000000000,'1975-02-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5015,'SEVESTRE','BERNARD','1933-01-02','02.79.22.49.31','06.60.94.52.22',NULL,'4 AVENUE GUSTAVE V','','','14280','AUTHIE',NULL,NULL,'2330161445001',1515.000000000,'1961-05-03','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5016,'GUILLAUMET','JEAN YVES','1958-10-07','02.87.85.55.99','06.67.42.85.75',NULL,'17 RUE DU BERRY','','','14123','FLEURY SUR ORNE',NULL,NULL,'1581035238001',1579.000000000,'1981-01-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5017,'MARIE','JANINE','1929-10-10','02.77.14.47.07','06.29.22.28.11',NULL,'9 rue st exupery','','','14270','MEZIDON CANON',NULL,NULL,'2291014271001',114.000000000,'1953-10-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5018,'GERARD','THERESE','1933-11-04','02.67.29.22.45','06.48.81.03.71',NULL,'7 rue de la cavee','','','14000','CAEN',NULL,NULL,'1331161153001',355.000000000,'1958-04-24','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5019,'LEFLOCH','PIERRE','1935-08-18','02.77.15.40.54','06.14.38.43.16',NULL,'178 rue de falaise','','','14123','IFS',NULL,NULL,'1350814182001',597.000000000,'1959-01-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5020,'COLLET','MARCELLE','1964-09-01','02.71.47.11.10','06.37.34.85.82',NULL,'5 place jeanne d''arc','','','14000','CAEN',NULL,NULL,'1640914364001',422.000000000,'1989-04-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5021,'GUILPIN','HERVE','1969-01-28','02.77.81.04.21','06.76.67.44.70',NULL,'10 rue du pain perdu','','','14310','VILLERS BOCAGE',NULL,NULL,'2690193070001',27.000000000,'1992-10-29','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5022,'LEVILLAIN','YVES','1953-02-12','02.47.14.89.09','06.29.46.03.39',NULL,'14 RUE DE LA GARE','','','14111','LOUVIGNY',NULL,NULL,'2530250504001',181.000000000,'1977-07-26','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5023,'CALBRIS','ANDRE','1961-01-19','02.29.31.97.09','06.14.93.65.23',NULL,'1 rue du vert pres','','','14000','CAEN',NULL,NULL,'2610150276001',35.000000000,'1991-05-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5024,'BRIARD','BERTRAND','1934-09-23','02.56.76.65.89','06.20.27.91.07',NULL,'6 allee du general simonds','','','14940','SANNERVILLE',NULL,NULL,'2340927425001',53.000000000,'1959-11-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5025,'DAVID','FRANCOISE','1939-01-19','02.53.03.66.98','06.57.75.08.70',NULL,'1 rue pre clair','','','14980','ROTS',NULL,NULL,'2390114181001',136.000000000,'1960-10-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5026,'BECQUET','MIREILLE','1946-05-12','02.44.49.48.43','06.33.73.75.70',NULL,'24 RUE LEON LECORNU','','','14120','MONDEVILLE',NULL,NULL,'1460514747001',707.000000000,'1975-11-15','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5027,'FOSSE','AGNES','1930-04-15','02.10.43.24.05','06.11.37.84.81',NULL,'4 rue andre lebastard','','','14260','AUNAY SUR ODON',NULL,NULL,'1300414453001',848.000000000,'1956-11-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5028,'BROSSAS','GILLES','1929-05-09','02.35.77.99.45','06.10.17.33.62',NULL,'7 RUE DE CAMBRAI','','','14190','FIERVILLE BRAY',NULL,NULL,'2290514096001',205.000000000,'1956-10-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5029,'MARIE','MAUD','1958-02-27','02.50.82.68.27','06.88.63.88.19',NULL,'MAUPAS','','','14470','COURSEULLES SUR MER',NULL,NULL,'1580299255001',7.000000000,'1988-06-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5030,'LEPOIL','CHRISTIAN','1957-04-10','02.59.11.10.62','06.37.70.46.91',NULL,'17 rue des frres WILKING','','','14270','MEZIDON CANON',NULL,NULL,'2570414008001',90.000000000,'1986-02-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5031,'LEBOUVIER','FRANCIS','1936-06-24','02.30.88.46.62','06.20.58.65.70',NULL,'13 RUE DE LA GARENNE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1360614164001',1225.000000000,'1958-08-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5032,'CORBET','MICHEL','1939-07-19','02.37.10.16.52','06.16.87.91.17',NULL,'3 RUE LENOTRE','','','61210','PUTANGES PONT ECREPIN',NULL,NULL,'2390750129001',63.000000000,'1963-03-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5033,'LEMERRE-SIBONI','FRANCOIS','1935-08-25','02.65.21.56.92','06.39.30.50.70',NULL,'6 RUE GEORGE SAND','','','14430','DOZULE',NULL,NULL,'1350814124001',33.000000000,'1963-03-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5034,'SERAFIN','FRANCOIS','1933-10-20','02.10.30.57.42','06.26.13.87.63',NULL,'7 rue Edmond Raphal','','','14610','ANGUERNY',NULL,NULL,'1331061462001',129.000000000,'1963-09-21','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5035,'HALLEY','PASCAL','1937-12-14','02.81.71.95.88','06.24.66.27.94',NULL,'26 Les Marettes','','','14310','ST LOUET SUR SEULLES',NULL,NULL,'1371214288001',3057.000000000,'1966-09-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5036,'LEREBOURG','ADRIENNE','1948-01-06','02.34.87.63.15','00 33 6.72.04.86.22',NULL,'22 rue des Frres Boutrois','','','14700','BONNOEIL',NULL,NULL,'1480161283001',1.000000000,'1971-07-08','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5037,'MARIE','MICHEL','1957-02-27','02.22.85.96.61','06.58.87.18.77',NULL,'12 RUE DE LA DIME','','','61570','MORTREE',NULL,NULL,'1570214138001',883.000000000,'1985-11-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5038,'PITON','MONIQUE','1950-01-09','02.74.77.04.32',NULL,NULL,'1 rue de noyon','','','14330','LE MOLAY LITTRY',NULL,NULL,'2500114685001',600.000000000,'1978-03-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5039,'DUCOUDRAY','PASCALE','1965-04-18','02.87.53.76.48','06.10.49.94.43',NULL,'6 RUE GEORGES SEND','','','14860','BAVENT',NULL,NULL,'2650414651001',6.000000000,'1988-08-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5040,'MESLIN','YVETTE','1946-05-23',NULL,NULL,NULL,'53 RUE DE LA REPUBLIQUE','','','14730','GIBERVILLE',NULL,NULL,'2460514146001',252.000000000,'1968-07-30','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5041,'HEMERY','CLAUDE','1933-06-13','02.10.12.58.72','06.31.90.07.44',NULL,'3 rue de la cit libere','','','14370','CANTELOUP',NULL,NULL,'1330614437001',6.000000000,'1956-08-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5042,'GOSSELIN','ALAIN','1932-08-17',NULL,NULL,NULL,'92  rue st martin  res st nicola','s','','14123','FLEURY SUR ORNE',NULL,NULL,'1320877365001',11.000000000,'1955-08-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5043,'LEVAXELAIRE','CLEMENCE','1944-02-09','02.82.69.28.96','06.55.64.44.54',NULL,'1 rue de la fosse poirier','','','61200','ARGENTAN',NULL,NULL,'2440260360001',113.000000000,'1966-02-01','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5044,'TRIPPIER','MAURICE','1933-12-11','02.51.13.49.25','06.83.23.24.32',NULL,'13 rue des peruquettes','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2331227127001',320.000000000,'1961-12-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5045,'QUEDRU','JEAN','1934-02-17','02.23.31.58.57','06.48.18.02.67',NULL,'3 rue du vignoble','','','14670','TROARN',NULL,NULL,'2340250013001',178.000000000,'1958-06-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5046,'LEFOULON','GISELE-MARIE','1934-10-20','02.46.35.36.94','06.11.03.85.95',NULL,'10 impasse prigord','','','14000','CAEN',NULL,NULL,'1341061443001',2304.000000000,'1957-04-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5047,'LAMI','VALERIE','1932-03-09','02.69.30.46.17','06.78.42.61.64',NULL,'LA CLEMENDIERE','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'1320314077001',784.000000000,'1954-02-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5048,'LENGRONNE','ANDREE','1955-05-08','02.49.61.43.31','06.24.73.74.44',NULL,'93 ROUTE NATIONALE','','','14370','BILLY',NULL,NULL,'1550514568001',58.000000000,'1982-02-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5049,'GERVELAS','YVONNE','1930-05-15','02.41.71.43.79','06.74.94.00.06',NULL,'LA MAGNANERIE','','','14210','TOURVILLE SUR ODON',NULL,NULL,'1300551075001',1063.000000000,'1953-10-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5050,'NORMAND','DENISE','1945-01-13','02.87.57.18.02','06.67.86.95.61',NULL,'2 RUE DR MAURICE COLLIN','','','14000','CAEN',NULL,NULL,'1450150160001',148.000000000,'1975-04-23','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5051,'DEMELIN','SYLVIE','1934-01-04','02.18.96.19.49','06.11.14.61.84',NULL,'6 RUE PASTEUR','','','14270','MEZIDON CANON',NULL,NULL,'1340114056001',41.000000000,'1963-05-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5052,'HUBERT','GEORGES','1938-07-29','02.97.19.41.63','06.59.75.41.78',NULL,'1490 ROUTE DE BRETAGNE','','','14260','BONNEMAISON',NULL,NULL,'1380714389001',144.000000000,'1965-06-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5053,'','YOLANDE','1938-03-21','02.80.13.32.87','06.34.19.30.16',NULL,'8 ALLEE LAPERUSE','','','14220','ST OMER',NULL,NULL,'1380314157001',28.000000000,'1959-01-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5054,'DESBOIS','RAYMONDE','1946-02-06','02.11.70.81.83','06.70.09.86.00',NULL,'rte de st cursin','','','14990','BERNIERES SUR MER',NULL,NULL,'1460214649001',1839.000000000,'1968-03-07','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5055,'CORBIN','YOLANDE','1966-03-14','02.46.44.95.03','06.99.40.57.59',NULL,'27 rue des msanges','','','14370','BELLENGREVILLE',NULL,NULL,'1660302326001',356.000000000,'1989-11-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5056,'MEAR','ALAIN','1937-06-15','02.26.88.08.85','06.45.53.02.46',NULL,'10-1 rue des balcons','','','14260','AUNAY SUR ODON',NULL,NULL,'2370614353001',32.000000000,'1960-10-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5057,'HOSE','JOEL','1930-11-09','02.87.00.48.72','06.54.56.25.28',NULL,'10 chemin de la haie morin','','','14123','IFS',NULL,NULL,'1301114100001',168.000000000,'1958-01-27','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5058,'GUELLE','ARIELLE','1938-01-08','02.65.38.88.19','06.51.53.44.24',NULL,'2 RUE DES BARENTINS','','','14123','FLEURY SUR ORNE',NULL,NULL,'2380114060001',100.000000000,'1959-09-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5059,'ANDRE','ARIELLE','1968-08-29','02.85.45.90.43','06.16.88.07.06',NULL,'42 RUE ARISTIDE BRIAND','','','14000','CAEN',NULL,NULL,'2680814009001',3.000000000,'1997-12-06','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5060,'MARIE','SUZANNE','1937-11-15','02.76.21.67.38','06.38.96.71.24',NULL,'10 rue des anciens d''afn','','','14840','CUVERVILLE',NULL,NULL,'2371114098001',2396.000000000,'1959-08-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5061,'LESAGE','MARIE JEANNE','1962-02-13','02.10.27.16.63','06.19.53.46.56',NULL,'6 rue de Matignon','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2620250180001',34.000000000,'1990-02-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5062,'LEVOYER','PIERRE','1964-01-29','02.99.08.28.07','06.11.82.33.19',NULL,'13 ALLEE DES FLEURS','','','14100','LE MESNIL EUDES',NULL,NULL,'1640114734001',46.000000000,'1993-07-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5063,'MONNET','CLAUDE','1936-01-30','02.34.10.31.48','06.21.79.21.03',NULL,'3 rue de la Hague','','','14000','CAEN',NULL,NULL,'1360114690001',26.000000000,'1959-02-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5064,'LEGROS','MADELEINE','1929-05-23','02.72.10.42.82','06.88.78.83.22',NULL,'HAMEAU MARTINBEAU','','','14860','BAVENT',NULL,NULL,'2290561054001',184.000000000,'1952-08-02','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5065,'LECAMPION','TUBO','1929-06-12','02.54.79.45.48','06.79.39.24.31',NULL,'7 avenue pere charles de foucaul','T','','14000','CAEN',NULL,NULL,'1290614113001',113.000000000,'1952-10-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5066,'DUBOURG','TUBO','1939-09-10','02.10.42.21.41','06.83.97.48.04',NULL,'5 rue albert camus','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'2390956185001',828.000000000,'1962-12-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5067,'HOUSSIN','PATRICK','1939-01-16','02.80.33.94.74',NULL,NULL,'5 RUE DE TROARN','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2390114157001',113.000000000,'1962-06-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5068,'DOMINJOUD','VALERIE','1936-04-27','02.11.99.22.65','06.57.82.59.14',NULL,'hameau la haye','','','14270','BIEVILLE QUETIEVILLE',NULL,NULL,'1360450054001',755.000000000,'1959-05-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5069,'LE BARBEY','CHANTAL','1949-05-03','02.55.60.39.63','06.13.87.64.51',NULL,'15 chemin du lavoir le bourg ou','ezy','','14670','TROARN',NULL,NULL,'1490561478001',34.000000000,'1970-09-04','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5070,'AUMONT','THERESE','1963-08-02','02.75.26.04.81','06.19.01.65.60',NULL,'Le square John Kennedy','','','14120','MONDEVILLE',NULL,NULL,'1630814022001',592.000000000,'1985-07-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5071,'TOUTAIN','MONIQUE','1952-06-24','02.58.25.08.11','06.63.07.15.94',NULL,'29 RUE BAS','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2520614040001',755.000000000,'1976-09-16','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5072,'LEBRETHON','JOSETTE','1935-08-04','02.12.20.18.58','06.70.54.60.42',NULL,'11impasse du bout du haut','','','14630','FRENOUVILLE',NULL,NULL,'1350850032001',61.000000000,'1965-11-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5073,'ANNE','BEATRICE','1928-02-22','02.89.05.38.59','06.96.58.35.23',NULL,'21 RESIDENCE DU PARC','','','61200','ARGENTAN',NULL,NULL,'2280250220001',1119.000000000,'1949-02-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5074,'LEFLOCH','','1933-01-27','02.68.05.04.97','06.42.92.37.34',NULL,'5 Place du Millnaire','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1330114007001',43.000000000,'1956-04-19','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5075,'MAHAMAD','SERGE','1940-07-02','02.62.94.83.68','06.83.80.35.36',NULL,'6 rue Breney','','','14630','CAGNY',NULL,NULL,'2400750213001',851.000000000,'1963-07-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5076,'PINCON','LOUISE','1928-01-26','02.96.78.75.62','06.38.47.91.90',NULL,'29 rue saint exupery','','','14630','CAGNY',NULL,NULL,'2280114173001',194.000000000,'1955-01-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5077,'LONGPRE','ROLANDE','1933-07-24','02.63.57.69.18','06.42.59.74.74',NULL,'','','','14000','CAEN',NULL,NULL,'2330750201001',30.000000000,'1960-08-30','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5078,'BURET','FREDERIC','1941-04-22','02.31.27.62.26','06.63.04.29.52',NULL,'6 avenue de la Haie Hue','','','50270','ST MAURICE EN COTENTIN',NULL,NULL,'2410499121001',56.000000000,'1964-10-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5079,'FONTAINE','DENIS','1941-04-29','02.44.51.78.60','06.11.52.27.68',NULL,'16 ALLEE DU CLOS DE LA PRAIRIE','','','14123','IFS',NULL,NULL,'2410499121001',167.000000000,'1962-11-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5080,'PIGNOLET','JEAN',NULL,NULL,NULL,NULL,'2814 rue Romain Rolland','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1330114432001',256.000000000,'2009-09-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5081,'AMET','MARTINE','1944-01-31','02.88.58.36.21','06.26.97.33.93',NULL,'Hameau Le Beffeux','','','14240','CAHAGNES',NULL,NULL,'2440150147001',19.000000000,'1974-12-01','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5082,'HEBERT','BERNADETTE','1936-04-27','02.35.28.83.17','06.68.65.45.26',NULL,'18 GRANDE RUE','','','14190','ST SYLVAIN',NULL,NULL,'2360414713001',963.000000000,'1960-11-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5083,'MADELINE','THIERRY','1967-09-18','02.53.04.37.08','06.11.22.79.80',NULL,'36 ROUTE DE PARIS','','','14000','CAEN',NULL,NULL,'1670914734001',1522.000000000,'1995-05-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5084,'LEBOURGEOIS','SERGE','1946-10-23','02.99.14.24.97','06.82.67.27.81',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2461014087001',81.000000000,'1967-05-23','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5085,'DREUX','ANNICK','1930-06-28','02.16.43.28.31','06.13.39.60.05',NULL,'6 IMPASSE DES ABEILLES','','','14000','CAEN',NULL,NULL,'1300661212001',275.000000000,'1951-11-04','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5086,'GUILLAUMET','CHARLOTTE','1930-06-13','02.44.98.72.06','06.68.94.09.38',NULL,'9 RUE DU DR PAUL ENOUF','','','14000','CAEN',NULL,NULL,'1300614239001',33.000000000,'1951-06-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5087,'FOUCHAUX','MARTINE','1939-03-26','02.22.20.67.10','06.21.33.13.43',NULL,'1 RUE FEDERMEYER SELLIER','','','50760','REVILLE',NULL,NULL,'2390314090001',30.000000000,'1963-06-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5088,'SEKOWSKI','Andre','1946-01-03','02.77.79.28.70','06.10.44.41.59',NULL,'7 RUE MAURICE GENEVOIX','','','14000','CAEN',NULL,NULL,'2460114183001',125.000000000,'1970-05-06','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5089,'DORENLOT','JOEL','1937-03-16','02.83.29.09.57','06.62.16.43.88',NULL,'4 rue des sources','','','14990','BERNIERES SUR MER',NULL,NULL,'2370328417001',210.000000000,'1964-09-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5090,'PELTIER','CLAUDE','1960-06-17','02.29.11.05.86','06.49.87.06.32',NULL,'st pierre des ifs','','','14210','CHEUX',NULL,NULL,'1600614761001',91.000000000,'1984-10-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5091,'JOYEUX','CLAUDE','1934-11-25','02.13.84.23.96','06.17.84.62.72',NULL,'54 RUE MAURICE FOUQUES','','','61450','LA FERRIERE AUX ETANGS',NULL,NULL,'1341114225001',211.000000000,'1960-10-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5092,'VAUVERT','victor','1942-09-30','02.27.44.90.18','06.44.62.73.23',NULL,'5 route de chasseneuil','','','14920','MATHIEU',NULL,NULL,'2420927168001',1967.000000000,'1970-03-23','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5093,'LEFEVRE','LINDA','1936-01-25','02.73.09.06.09','06.12.01.43.75',NULL,'hameau rupirre','','','14220','CULEY LE PATRY',NULL,NULL,'1360150121001',157.000000000,'1959-01-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5094,'AMELINE','ADRIEN','1968-12-07','02.68.56.29.37','06.37.03.81.75',NULL,'11 rue moliere','','','14610','EPRON',NULL,NULL,'2681214666001',153.000000000,'1997-04-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5095,'LECLUZE','JEANNETTE','1932-11-14','02.81.03.05.58','06.49.59.77.11',NULL,'3 RUE DE LA PECHERIE','','','14000','CAEN',NULL,NULL,'2321114141001',392.000000000,'1958-11-02','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5096,'LEBAS','ANDRE','1954-01-12','02.28.97.72.10','06.60.03.33.85',NULL,'7 hameau des  champs','','','14000','CAEN',NULL,NULL,'1540114030001',1337.000000000,'1978-07-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5097,'LEGELEUX','THIERRY','1936-02-16','02.62.31.34.82','06.52.00.05.04',NULL,'30 RUE DE BROCELIANDE VENOIX','','','14150','OUISTREHAM',NULL,NULL,'2360289309001',3.000000000,'1965-11-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5098,'MAGUET','MONIQUE','1968-03-27','02.51.78.43.51','06.28.59.12.71',NULL,'10 RUE DE LA GARE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2680350502001',47.000000000,'1998-08-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5099,'LIARD','LUCETTE','1968-03-23','02.11.68.55.95','06.10.79.23.29',NULL,'18 RUE LA TRINGALE','','','14210','EVRECY',NULL,NULL,'2680350502001',36.000000000,'1994-09-29','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5100,'DUMONT','HUBERT','1935-11-05','02.98.22.23.91','06.93.81.26.78',NULL,'8 RUE D4AUGE','','','14150','OUISTREHAM',NULL,NULL,'1351114073001',823.000000000,'1958-05-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5101,'BAILLUET','GILBERTE',NULL,'02.71.84.78.68','06.51.82.40.55',NULL,'10 RUE DE LA GARE','','','14500','VAUDRY',NULL,NULL,'1390650107001',24.000000000,'2009-07-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5102,'MARIE','JEAN','1969-12-18','02.12.34.06.31','06.11.52.31.02',NULL,'14 RUE DU VAL','','','14880','HERMANVILLE SUR MER',NULL,NULL,'2691214537001',62.000000000,'1998-04-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5103,'AUBE','MICHEL','1941-01-11','02.46.07.18.02','06.20.25.29.31',NULL,'10 RUE D''HERMANVILLE','','','14540','HUBERT FOLIE',NULL,NULL,'2410114146001',802.000000000,'1963-08-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5104,'LERAISNIER','GINETTE','1940-03-31','02.11.80.58.33','06.38.18.89.58',NULL,'4 rue Elie Beaumont','','','14000','CAEN',NULL,NULL,'2400314727001',5145.000000000,'1964-12-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5105,'LERAISNIER','pascal','1964-01-23','02.19.28.74.86',NULL,NULL,'RUE CREUSE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1640114277001',414.000000000,'1993-06-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5106,'DELENTE','JACQUES','1949-03-11','02.67.47.31.51','06.51.06.87.75',NULL,'14 ROUTE DE BAYEUX','','','14000','CAEN',NULL,NULL,'2490314525001',1272.000000000,'1970-02-03','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5107,'CORDELLIER','','1963-01-02','02.46.44.96.70','00 33 6.74.81.92.92',NULL,'3 Le Mesnil','','','50720','BARENTON',NULL,NULL,'2630114062001',25.000000000,'1987-08-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5108,'DELASALLE','MICHEL','1939-05-19','02.65.22.55.58','06.10.71.43.87',NULL,'5 rue de la tourellle','','','14000','CAEN',NULL,NULL,'2390527629001',89.000000000,'1961-12-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5109,'PICHONNIER','GUY','1928-07-16','02.12.24.88.35','06.57.91.94.45',NULL,'1 RUE CLAUDE DEBUSSY','','','14740','ST MANVIEU NORREY',NULL,NULL,'1280714437001',280.000000000,'1955-09-17','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5110,'CLEMENT','THIERRY','1929-09-12','02.64.22.70.05','06.10.37.19.97',NULL,'17 RUE JACQUES PREVERT','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2290955154001',246.000000000,'1951-01-12','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5111,'HUARD','ROGER','1932-12-15','02.60.72.39.79','06.30.53.27.71',NULL,'38 ROUTE DES HAMEAUX','','','14840','CUVERVILLE',NULL,NULL,'1321253019001',1130.000000000,'1955-03-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5112,'OZANNE','GABRIEL','1932-02-01','02.76.89.52.25','06.70.56.71.13',NULL,'19 RUE DU TOUR DE VILLE','','','14940','SANNERVILLE',NULL,NULL,'1320214489001',37.000000000,'1956-12-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5113,'VERRIER','GENEVIEVE','1968-01-10','02.41.30.67.39','06.10.79.11.04',NULL,'13 CHEMIN AUX BOEUFS','','','14123','IFS',NULL,NULL,'1680162413001',37.000000000,'1998-03-17','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5114,'VAUQUELIN','RAYMOND','1944-03-18','02.83.14.04.42','06.38.37.77.36',NULL,'611 bd de la haute folie','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2440350485001',98.000000000,'1974-12-20','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5115,'HEMERY','JACQUELINE','1932-04-28','02.66.53.94.71','06.88.27.52.11',NULL,'325 RUE DE FALAISE BP1254','','','14220','CROISILLES',NULL,NULL,'2320453106001',50.000000000,'1953-05-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5116,'BOSSU','CLAUDE','1963-02-06','02.12.17.05.32','06.80.54.55.75',NULL,'60 RUE ST JACQUES','','','50820','BRIX',NULL,NULL,'2630214990001',71.000000000,'1988-09-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5117,'VERITE','Philippe','1942-08-02','02.11.66.99.22','06.28.33.15.68',NULL,'21 RUE DU 18 JUILLET','','','14370','ARGENCES',NULL,NULL,'1420814139001',471.000000000,'1971-03-09','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5118,'LEFEBVRE','GILBERTE','1960-02-16','02.26.45.14.92','06.19.18.99.06',NULL,'49 AVENUE FOCH','','','14000','CAEN',NULL,NULL,'1600214397001',166.000000000,'1983-08-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5119,'CHEFDOR','JEANINE','1933-06-21','02.48.21.60.63','06.83.46.95.16',NULL,'21 RUE LE CLOS','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2330614520001',14.000000000,'1960-02-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5120,'PERAZZI','MARTINE','1932-09-07','02.25.93.36.80','06.19.19.94.24',NULL,'2 CHEMIN DE LA BRUYERE ST LEONAR','D','','50100','CHERBOURG',NULL,NULL,'2320914288001',326.000000000,'1958-12-25','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5121,'MONCLER','GHISLAINE','1922-01-10','02.26.89.94.91','06.35.25.27.83',NULL,'5 RUE DU BERRY','','','14000','CAEN',NULL,NULL,'1220129150001',74.000000000,'1944-08-17','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5122,'GROUSSET','ROBERT','1933-07-04','02.47.66.98.96','06.72.78.46.57',NULL,'2 RUE SAN SALVADOR','','','14310','LONGVILLERS',NULL,NULL,'1330714336001',359.000000000,'1956-04-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5123,'MARIE','YVETTE','1941-01-12','02.79.49.03.28','06.10.37.89.92',NULL,'2 ROUTE DE MEZIDON','','','14850','HEROUVILLETTE',NULL,NULL,'2410127065001',22.000000000,'1971-08-30','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5124,'WAGNER','ELISE','1933-11-20','02.69.23.65.64','06.63.28.54.30',NULL,'3 rue des coles','','','14370','ARGENCES',NULL,NULL,'1331161153001',301.000000000,'1955-09-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5125,'BOUCHER','ROGER','1967-08-13','02.10.99.01.93','06.84.79.51.74',NULL,'1 RUE DES POMMIERS','','','14370','MOULT',NULL,NULL,'1670875113001',181.000000000,'1990-12-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5126,'','MICHEL','1937-05-18','02.49.84.72.89','06.32.61.20.02',NULL,'14 rue du mont','','','14000','CAEN',NULL,NULL,'1370550092001',589.000000000,'1962-09-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5127,'MAHAUT','JEANNINE','1928-11-09','02.69.79.51.89','00 33 6.54.60.02.62',NULL,'7 RUE VOLTAIRE','','','50570','HAUTEVILLE LA GUICHARD',NULL,NULL,'2281114143001',140.000000000,'1953-11-09','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5128,'LE GARGAM','DENISE','1940-06-19','02.15.49.73.95','06.71.14.45.73',NULL,'6 RUE DE LA PLAINE','','','14000','CAEN',NULL,NULL,'2400614504001',66.000000000,'1961-01-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5129,'ALLEAUME','ODILE','1930-09-08','02.20.91.71.83','06.73.34.96.91',NULL,'24 rue leon lecornu','','','14270','MEZIDON CANON',NULL,NULL,'2300978532001',3800.000000000,'1951-09-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5130,'VERITE','CECILE','1934-09-07','02.81.23.87.41','06.50.26.64.09',NULL,'4 ave rene rolland','','','14540','POUSSY LA CAMPAGNE',NULL,NULL,'1340914378001',1824.000000000,'1955-08-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5131,'MORIN','JOSIANE','1931-01-02','02.11.87.79.03','06.10.18.84.79',NULL,'5 rue de la liberation','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1310150197001',261.000000000,'1954-11-09','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5132,'RICHOMME','roger','1966-02-06','02.63.19.52.42','06.67.39.06.31',NULL,'26 AVENUE DE LA LIBERTE','','','14370','CHICHEBOVILLE',NULL,NULL,'1660214182001',64.000000000,'1994-05-11','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5133,'DESCHAMPS','JEAN','1948-01-24','02.30.56.35.99','06.94.05.16.53',NULL,'5 RUE DE GAMBOSVILLE','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1480114549001',3754.000000000,'1973-06-26','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5134,'ETIENNE','MADELEINE','1935-07-10','02.72.50.61.80','06.35.52.13.71',NULL,'FOYER RESIDENCE RUE DES ACCACI','AS','','14390','CABOURG',NULL,NULL,'1350714566001',565.000000000,'1960-08-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5135,'HUGUET','JACQUES','1941-01-15','02.15.47.83.12','06.74.96.36.92',NULL,'3 RUE DU MUGUET','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2410185215001',727.000000000,'1971-03-29','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5136,'JOURDAN','THERESE','1936-01-26','02.11.28.53.73','06.17.76.45.91',NULL,'44 ROUTE DE GOUVIX','','','50750','ST SAMSON DE BONFOSSE',NULL,NULL,'1360150436001',20.000000000,'1965-09-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5137,'LAMOUREUX','THERESE','1936-01-07','02.89.12.49.51','06.93.88.41.63',NULL,'307 quartier du val','','','14000','CAEN',NULL,NULL,'1360150436001',430.000000000,'1966-07-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5138,'LIARD','HUGUETTE','1952-02-04','02.64.01.34.30','06.30.34.03.38',NULL,'13 RUE DES SEMAILLES','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2520214024001',242.000000000,'1975-09-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5139,'LEBEL','YVONNE','1946-01-16','02.77.94.14.12','06.17.32.93.83',NULL,'2 IMPASSE DES CORVETTES','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2460114046001',78.000000000,'1968-04-18','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5140,'BOURDON','GEORGES','1956-07-17','02.11.68.53.37','06.41.43.13.89',NULL,'LE FRESNE','','','50700','ST JOSEPH',NULL,NULL,'1560714197001',392.000000000,'1979-05-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5141,'LEFEVRE','JEAN CLAUDE','1942-04-16','02.47.70.95.75','06.19.71.59.49',NULL,'4 RUE DU PERRET','','','14290','LA FOLLETIERE ABENON',NULL,NULL,'1420453149001',32.000000000,'1964-03-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5142,'GODEFROY','JEAN','1948-02-24','02.21.16.86.63','06.64.41.42.08',NULL,'14 rue de la marne','','','14120','MONDEVILLE',NULL,NULL,'2480261203001',100.000000000,'1970-05-08','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5143,'FESSARD','FRANCOISE','1963-02-15','02.34.25.59.85','06.90.93.90.15',NULL,'9 RUE DE LA CLE DES CHAMPS','','','50000','ST LO',NULL,NULL,'2630214045001',29.000000000,'1986-04-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5144,'MARGUERITE','GISELE','1943-11-14','02.40.00.02.53','06.16.40.74.06',NULL,'7 RUE DU REVEREND PERE JULES','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1431178099001',40.000000000,'1971-09-07','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5145,'VEILLARD','Jacqueline','1958-01-25','02.95.33.82.22','06.45.30.96.65',NULL,'5 RUE URBAIN LEFRANCOIS','','','14540','SOLIERS',NULL,NULL,'2580160661001',375.000000000,'1979-10-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5146,'VEILLARD','MONIQUE','1938-12-29','02.69.77.99.89','06.12.21.04.46',NULL,'7 RUE PAUL BERT','','','14590','FUMICHON',NULL,NULL,'2381218103001',53.000000000,'1959-10-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5147,'LALEMAN','MICHEL','1932-06-17','02.10.19.29.05','06.10.81.27.70',NULL,'LE LOGIS DE LA PERRIERE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1320661268001',20.000000000,'1956-08-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5148,'LEDANOIS','ALBERT','1947-05-18','02.79.09.06.92','06.11.79.07.82',NULL,'40 avenue conseil','','','14000','CAEN',NULL,NULL,'1470550192001',1012.000000000,'1969-02-12','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5149,'CHATEL','FRANCOIS','1939-07-14','02.93.16.17.06','06.12.16.54.63',NULL,'37 boulevard leroy','','','14850','ESCOVILLE',NULL,NULL,'1390750079001',2454.000000000,'1964-01-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5150,'HEUDIER','MICHEL','1947-04-19','02.66.18.81.82','06.50.76.60.27',NULL,'11 rue c blaizot','','','14000','CAEN',NULL,NULL,'1470414477001',237.000000000,'1972-03-13','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5151,'','MADELEINE','1967-06-26','02.77.53.29.27','06.58.00.71.09',NULL,'','','','14460','COLOMBELLES',NULL,NULL,'1670650581001',1058.000000000,'1997-04-08','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5152,'LE  BOUCHER','ODILE','1958-05-13','02.79.26.08.56','06.55.73.42.76',NULL,'2 RUE SANSON','','','14000','CAEN',NULL,NULL,'2580514207001',1854.000000000,'1980-05-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5153,'JOHN','MARIE','1959-04-09','02.68.92.97.41','06.15.93.25.19',NULL,'lieu dit "les Legers"','','','14000','CAEN',NULL,NULL,'2590414166001',11.000000000,'1980-04-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5154,'HENRY','MARIE','1963-10-16','02.87.50.16.17','06.55.15.43.79',NULL,'4 rue mortemer','','','14370','ARGENCES',NULL,NULL,'1631050009001',83.000000000,'1987-05-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5155,'HUBERT','jean','1934-04-06','02.22.34.56.10','06.13.03.38.60',NULL,'18 RUE JEAN MERMOZ','','','14610','CAIRON',NULL,NULL,'2340414763001',324.000000000,'1961-03-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5156,'LECHIPPEY','CLAUDE','1944-05-31','02.75.48.83.20','06.85.86.91.07',NULL,'13 RUE DES CERISIERS','','','61570','BOUCE',NULL,NULL,'1440514339001',26.000000000,'1974-12-30','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5157,'DUVIEU','SUZANNE','1928-11-16','02.53.18.44.52','06.20.67.92.68',NULL,'48 RUE JEAN PAUL MARAT','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1281114436001',121.000000000,'1951-05-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5158,'GOSSELIN','THERESE','1951-01-25','02.91.54.18.15','06.35.62.58.63',NULL,'6 RUE HENRI DUNANT','','','14000','CAEN',NULL,NULL,'2510114183001',53.000000000,'1974-06-21','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5159,'MARION','ANDREE','1939-07-24','02.82.31.75.75','06.16.54.43.78',NULL,'29 RUE DES CORDELIERS','','','50600','ST HILAIRE DU HARCOUET',NULL,NULL,'2390761207001',211.000000000,'1963-08-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5160,'LETELLIER','THERESE','1940-08-17','02.82.17.56.14','06.68.25.44.74',NULL,'58 ROUTE D''HARCOURT RES LES COT','EAUX','','14370','ARGENCES',NULL,NULL,'2400814689001',342.000000000,'1964-07-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5161,'AUMONT','ELIANE','1953-08-16','02.69.75.60.56','06.58.13.06.74',NULL,'30 RUE DU BOISPREAU','','','14000','CAEN',NULL,NULL,'2530814393001',673.000000000,'1982-03-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5162,'DUGUE','EDOUARD','1938-03-27','02.65.52.39.00','06.10.05.80.91',NULL,'L''CHALIER','','','14000','CAEN',NULL,NULL,'2380353061001',238.000000000,'1960-01-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5163,'MAUGER','ILQAR',NULL,'02.26.61.03.93','06.18.48.84.80',NULL,'8 rue des maronniers','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1540814748001',185.000000000,'2007-12-13','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5164,'LE BLANC','JEAN','1936-06-12','02.77.40.41.99','06.67.36.77.61',NULL,'41 rue nicolas oresme','','','50530','ST JEAN LE THOMAS',NULL,NULL,'1360614409001',33.000000000,'1959-10-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5165,'LECOURTOIS','IRINE','1932-03-24','02.57.43.38.82','06.12.22.50.68',NULL,'4 cite des jardins','','','14620','BAROU EN AUGE',NULL,NULL,'2320314234001',151.000000000,'1955-08-28','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5166,'MASSON','GERARD','1952-06-02','02.50.95.28.22','06.69.92.40.13',NULL,'4 rue de la haie vigne','','','50810','ST JEAN DES BAISANTS',NULL,NULL,'1520699350001',609.000000000,'1974-08-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5167,'MAILLET','YVETTE','1930-08-11','02.49.17.48.07','06.78.05.93.64',NULL,'LES ILES','','','14123','IFS',NULL,NULL,'2300849233001',5.000000000,'1954-03-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5168,'BREHAM','CHANTAL','1961-01-01','02.10.66.91.53','06.61.88.12.43',NULL,'36 RUE DU CAMP FERME','','','14220','FRESNEY LE VIEUX',NULL,NULL,'2610114738001',2120.000000000,'1989-05-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5169,'DESTIGNY','PHILIPPE','1938-05-15','02.22.19.49.05','06.37.14.79.02',NULL,'205 AVENUE JEAN JAURES','','','14160','DIVES SUR MER',NULL,NULL,'1380514717001',49.000000000,'1967-01-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5170,'DESPOIS','CLAUDE','1940-08-15','02.57.35.52.76','06.71.47.93.92',NULL,'10 RUE DE LA GRENOUILLERE','','','14240','ST GERMAIN D''ECTOT',NULL,NULL,'2400814281001',24.000000000,'1961-10-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5171,'BIREE','THIERRY','1959-02-22','02.13.47.29.41','06.24.89.48.03',NULL,'4 rue de la pyramide','','','14440','CRESSERONS',NULL,NULL,'1590214115001',9.000000000,'1981-11-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5172,'MOREL','PIERRETTE','1938-02-24','02.17.52.33.75','06.36.24.35.58',NULL,'5 rue des bruyeres','','','14730','GIBERVILLE',NULL,NULL,'2380214378001',75.000000000,'1960-02-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5173,'VAN DOORNE','','1928-06-07','02.58.52.21.64','06.95.09.88.35',NULL,'882 CHEMIN DU VAL','','','14350','DAMPIERRE',NULL,NULL,'2280676591001',277.000000000,'1952-01-21','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5174,'LAMY','MICHEL','1931-03-03','02.10.48.24.72','06.57.54.67.60',NULL,'2 rue  du capitaine foucher','','','61100','ST GEORGES DES GROSEILLERS',NULL,NULL,'1310376254001',765.000000000,'1957-11-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5175,'KUKIELZACK','ANNICK','1935-04-09','02.67.52.89.06','06.10.57.80.43',NULL,'133 RUE DE BRANVILLE','','','14150','OUISTREHAM',NULL,NULL,'1350490102001',1131.000000000,'1958-05-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5176,'THORIS','HENRI','1932-12-19','02.19.38.16.31','06.91.27.68.56',NULL,'21 rue biganos','','','14700','MARTIGNY SUR L''ANTE',NULL,NULL,'2321214722001',13.000000000,'1955-12-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5177,'MARIE','MARIE MADELEINE','1930-05-01','02.40.47.70.82','06.13.85.09.79',NULL,'2 3 allee chevrefeuille','','','14000','CAEN',NULL,NULL,'1300514666001',0.000000000,'1960-07-28','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5178,'CHEVALIER','NICOLE','1940-03-19','02.27.11.53.97','06.86.90.42.22',NULL,'12 AVENUE DU PARC','','','14120','MONDEVILLE',NULL,NULL,'2400356152001',60.000000000,'1968-12-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5179,'','NICOLE','1963-01-15','02.34.77.90.69','06.57.10.02.49',NULL,'2 rue de la pecherie','','','14220','CROISILLES',NULL,NULL,'1630114355001',1.000000000,'1985-05-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5180,'','daniel','1964-01-05','02.74.16.44.28',NULL,NULL,'27 av marechal koeing','','','14120','MONDEVILLE',NULL,NULL,'2640114015001',604.000000000,'1991-09-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5181,'LEVEQUE','JACQUES','1929-04-28','02.85.01.00.57','06.44.07.35.70',NULL,'RUE DU POIRIER','','','14880','HERMANVILLE SUR MER',NULL,NULL,'2290414156001',42.000000000,'1953-09-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5182,'FOSSARD','JACQUES','1959-08-26','02.64.90.01.25','06.13.30.76.64',NULL,'52 bd Alsace Lorraine','','','14220','DONNAY',NULL,NULL,'2590814710001',5.000000000,'1982-01-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5183,'HEBERT','lionel','1967-02-20','02.31.20.48.25','06.69.45.46.09',NULL,'leffart','','','14460','COLOMBELLES',NULL,NULL,'1670277108001',8.000000000,'1995-05-18','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5184,'LACOUR','YVETTE','1928-05-16','02.37.99.33.29','06.46.21.56.48',NULL,'','','','14730','GIBERVILLE',NULL,NULL,'2280514629001',147.000000000,'1951-07-12','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5185,'GALLIER','MONIQUE','1935-03-17','02.19.03.15.58','06.62.22.39.75',NULL,'21 RUE DES ECOLES','','','61200','SARCEAUX',NULL,NULL,'1350314348001',1818.000000000,'1957-03-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5186,'GASCOIN','MARIE','1966-10-02','02.57.18.97.32','06.84.41.23.20',NULL,'6 RUE DE DEMOUVILLE','','','14370','BELLENGREVILLE',NULL,NULL,'2661014145001',96.000000000,'1988-03-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5187,'LAPLANCHE','MARIE PAULE','1933-06-03','02.37.53.67.48','06.10.01.80.55',NULL,'6 RUE MAURICE LAFON','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2330661399001',2367.000000000,'1956-03-06','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5188,'VABRE','CLAUDE','1928-11-06','02.57.14.43.62','06.72.71.96.62',NULL,'6 RUE CARDINAL LAVIGERIE','','','14610','CAMBES EN PLAINE',NULL,NULL,'1281114431001',28.000000000,'1955-05-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5189,'PILET','JACQUELINE','1968-08-22','02.12.24.33.02','06.76.20.29.60',NULL,'1 RUE CAMILLE BLAIZOT','','','14370','ARGENCES',NULL,NULL,'1680814328001',11.000000000,'1997-04-07','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5190,'','SIMONE','1952-01-25','02.45.57.70.02','06.75.98.76.35',NULL,'34 RUE DES CASTORS','','','14120','MONDEVILLE',NULL,NULL,'1520114669001',288.000000000,'1975-01-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5191,'SEBERT','ALBERT','1966-12-14','02.10.08.57.36','06.32.33.72.75',NULL,'9 RUE DES CAILLOUINS','','','14170','PERRIERES',NULL,NULL,'2661214114001',1042.000000000,'1994-02-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5192,'PUREN','ALBERT',NULL,'02.72.01.10.97','06.67.89.04.00',NULL,'LA NEUVILLE','','','14270','ECAJEUL',NULL,NULL,'2371050215001',758.000000000,'2011-05-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5193,'LEFFRAY','HUBERT','1948-01-18','02.43.97.99.73','06.11.81.87.33',NULL,'LE BOURG','','','14370','BELLENGREVILLE',NULL,NULL,'2480114700001',126.000000000,'1977-11-11','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5194,'MAGUET','ROSELYNE','1932-11-29','02.44.84.36.81','06.42.78.05.65',NULL,'','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1321114479001',627.000000000,'1960-09-06','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5195,'GINGAT','CLAUDE',NULL,'02.78.56.52.41','06.63.34.40.83',NULL,'L''AIGLERIE','','','14000','CAEN',NULL,NULL,'2301185262001',185.000000000,'2009-10-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5196,'GODARD','MADELEINE',NULL,'02.77.85.13.21','06.59.08.51.41',NULL,'residence laurelie bat a appt 8','','','53100','MAYENNE',NULL,NULL,'1300527609001',5.000000000,'2009-05-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5197,'TOSTAIN','ROGER','1955-03-05','02.77.38.26.55','06.11.29.38.25',NULL,'34 rue albert camus','','','14120','MONDEVILLE',NULL,NULL,'2550314002001',36.000000000,'1978-09-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5198,'RENAUDINEAU','ALAIN','1940-07-16','02.81.73.05.36','06.69.35.97.71',NULL,'64 AVENUE GUYNEMER','','','14000','CAEN',NULL,NULL,'1400772039001',3311.000000000,'1961-02-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5199,'TUNCAY','FRANCIS','1933-12-05','02.17.22.80.54','06.81.98.02.62',NULL,'13 allee de copenahague','','','61200','ARGENTAN',NULL,NULL,'1331250311001',72.000000000,'1956-12-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5200,'MAUGER','CHRISTIAN','1949-05-29','02.37.93.19.28','06.89.22.96.20',NULL,'13 av de caen','','','14400','CROUAY',NULL,NULL,'2490514693001',1389.000000000,'1970-06-22','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5201,'MOREL','JANINE','1931-01-31','02.14.37.49.65','06.29.84.06.81',NULL,'rue albert mahieu','','','14000','CAEN',NULL,NULL,'2310114600001',285.000000000,'1961-05-28','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5202,'HESNARD','GASTON',NULL,'02.36.37.28.81','06.43.78.97.22',NULL,'15 chemin du bois d'' alencon','','','61100','FLERS',NULL,NULL,'1380714005001',484.000000000,'2013-04-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5203,'LEGOUBE','MARIE','1937-01-15','02.25.47.43.93','06.43.05.73.17',NULL,'7 rue alfonse et leonard  gilles','','','14510','HOULGATE',NULL,NULL,'1370150453001',805.000000000,'1964-11-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5204,'GUYOT','COLETTE','1937-12-16','02.12.11.82.15','06.89.17.08.75',NULL,'RUE DESERT','','','27270','FERRIERES ST HILAIRE',NULL,NULL,'2371214349001',24.000000000,'1961-11-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5205,'DANIEL','DONATIEN','1948-08-31','02.11.52.10.45','06.47.90.18.65',NULL,'7 IMPASSE DES ECOSSAIS','','','14470','COURSEULLES SUR MER',NULL,NULL,'2480814494001',47.000000000,'1969-01-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5206,'FOUQUES','NICOLE','1942-01-14','02.18.68.44.94','06.25.57.69.68',NULL,'62 RUE DE LA CHAPELLE','','','14540','SOLIERS',NULL,NULL,'1420114610001',1457.000000000,'1963-03-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5207,'JOB','GERARD','1942-01-09','02.52.85.35.97','06.88.52.84.15',NULL,'5 RUE DU BERRY','','','14860','BAVENT',NULL,NULL,'1420114610001',38.000000000,'1967-08-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5208,'GIRARD','BERNARD','1965-08-19','02.37.11.33.97','06.87.47.57.53',NULL,'3 rue camille saint saens','','','14123','IFS',NULL,NULL,'2650814305001',35.000000000,'1990-11-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5209,'BRIARD','THERESE','1959-10-28','02.11.88.99.56','06.49.52.85.81',NULL,'57 RUE DU MANOIR','','','50290','LONGUEVILLE',NULL,NULL,'1591014030001',21.000000000,'1981-08-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5210,'BOUET','EDITH','1929-08-15','02.43.99.66.72','06.60.48.22.75',NULL,'8 avenue du 43 eme regiment d''ar','tillerie','','14700','ST PIERRE CANIVET',NULL,NULL,'1290850433001',180.000000000,'1954-04-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5211,'DUCHESNEY','ARLETTE','1949-05-22','02.11.39.00.11','06.50.51.53.30',NULL,'13 RUE DE VERDUN','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1490514432001',185.000000000,'1974-01-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5212,'CALLU','BERNARD','1937-09-13','02.67.52.95.58','06.44.37.00.72',NULL,'11 LE PLANITRE','','','14330','SAON',NULL,NULL,'1370961108001',56.000000000,'1962-03-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5213,'NEELZ','SYLVIE','1935-04-30','02.73.41.56.82','06.13.02.59.52',NULL,'LE MESNIL','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1350450412001',839.000000000,'1957-06-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5214,'MARIE','SYLVIE','1929-11-30','02.37.45.95.08','06.65.32.57.18',NULL,'la cour','','','14730','GIBERVILLE',NULL,NULL,'1291114092001',39.000000000,'1958-05-08','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5215,'GERVAISE','DENISE',NULL,NULL,NULL,NULL,'2 BIS RUE DES CHARMILLES','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2330168034001',21.000000000,'2013-01-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5216,'HOUGUET','ELIANE','1929-01-07','02.71.95.19.78','06.49.82.49.15',NULL,'3 PLACE CHARLES DELANGLE','','','14000','CAEN',NULL,NULL,'2290114375001',17.000000000,'1956-02-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5217,'HEMERY','JEAN','1938-05-21','02.43.47.44.45','06.76.99.14.78',NULL,'8 allee laprouse','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1380560653001',110.000000000,'1968-10-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5218,'LE MONNIER','JEAN','1962-01-16','02.19.43.26.65','06.84.25.59.15',NULL,'7 av de verdun','','','14000','CAEN',NULL,NULL,'1620114205001',94.000000000,'1984-02-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5219,'BISSON','YVONNE','1959-04-27','02.64.01.19.17','06.54.29.29.90',NULL,'14 ALLEE DES POETES','','','14000','CAEN',NULL,NULL,'2590414396001',1814.000000000,'1988-11-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5220,'LANGLOIS','HUGUETTE','1934-06-13','02.34.67.72.21','06.44.20.54.97',NULL,'17 RUE DE L''EGLISE','','','36200','TENDU',NULL,NULL,'1340622094001',3845.000000000,'1964-12-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5221,'HARIVEL','COLETTE','1978-09-13','02.49.94.48.18','06.50.94.12.08',NULL,'foyer residence rue des acacias','','','14670','ST PIERRE DU JONQUET',NULL,NULL,'2780929151001',375.000000000,'2008-07-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5222,'MENARD','SYLVIE','1938-07-25','02.12.28.69.20','06.10.49.08.60',NULL,'3 RUE FER A CHEVAL','','','14000','CAEN',NULL,NULL,'1380714397001',414.000000000,'1961-04-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5223,'DAUVERGNE','','1940-08-31','02.12.20.95.83','06.33.51.55.84',NULL,'40 RUE DU BOUT GUESDON','','','14370','ARGENCES',NULL,NULL,'2400814301001',214.000000000,'1963-11-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5224,'LAPRUNE','JACQUES','1932-10-27','02.70.17.40.00','06.31.46.18.96',NULL,'4 RUE LABBE','','','14930','VIEUX',NULL,NULL,'1321061102001',44.000000000,'1953-10-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5225,'SALAUN','claude','1928-09-16','02.28.66.85.15','06.12.94.07.96',NULL,'94 rue du tour de ville','','','14120','MONDEVILLE',NULL,NULL,'1280914603001',2270.000000000,'1957-09-13','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5226,'LEROMAIN','MICHEL','1937-06-17','02.32.79.99.84','06.57.14.28.76',NULL,'168 RUE DE BAYEUX','','','14120','MONDEVILLE',NULL,NULL,'1370614098001',90.000000000,'1963-09-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5227,'COURVAL','LUCIEN','1931-06-08','02.65.07.77.87','06.35.09.71.17',NULL,'2 RESIDENCE SAINT GERBOLD RUE CO','NSTANT FORGET','','14700','FALAISE',NULL,NULL,'1310614716001',19.000000000,'1953-01-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5228,'VENISE','MICHELINE','1933-10-15','02.11.42.37.71','06.25.43.56.37',NULL,'LE MESNIL','','','14930','ETERVILLE',NULL,NULL,'2331014322001',55.000000000,'1959-11-13','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5229,'CLEREMBEAUX','MAURICE','1951-06-13','02.93.05.75.63','06.74.50.97.81',NULL,'13 RUE DE STOCKHOLM','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2510614056001',705.000000000,'1977-03-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5230,'TECHER','MARGUERITE','1931-11-30','02.80.89.76.44','06.16.10.43.61',NULL,'LIEU DIT SAINT QUENTIN','','','14123','IFS',NULL,NULL,'1311114655001',298.000000000,'1959-04-26','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5231,'LEFRANCOIS','JEANNINE','1931-11-13','02.25.22.60.51','06.92.96.59.94',NULL,'26 RUE DU CHEMINET','','','14370','ARGENCES',NULL,NULL,'1311114655001',29.000000000,'1958-12-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5232,'GASNIER','JEAN-CLAUDE','1937-04-10','02.76.23.84.38','06.88.89.03.57',NULL,'','','','14123','IFS',NULL,NULL,'1370414458001',17.000000000,'1960-07-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5233,'CLEMENCE','DENISE','1940-02-14','02.40.93.93.25','06.63.51.03.38',NULL,'2 RUE AUGUSTE NICOLAS','','','14270','MEZIDON CANON',NULL,NULL,'1400214076001',7.000000000,'1962-04-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5234,'DORNIOL','BERNARD','1936-12-12','02.11.11.73.69','06.31.20.34.98',NULL,'15 RUE ST OMER','','','14790','VERSON',NULL,NULL,'1361214103001',27.000000000,'1963-07-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5235,'ANNE','ALBERT','1935-10-05','02.33.00.16.13','06.78.25.12.36',NULL,'3 RUE DES JACINTHES','','','14210','AMAYE SUR ORNE',NULL,NULL,'2351050625001',203.000000000,'1956-01-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5236,'MABIRE','ARMELLE','1963-10-28','02.39.10.44.08','06.10.71.63.79',NULL,'18 ALLEE DU JEU DE PAUME','','','61790','ST PIERRE DU REGARD',NULL,NULL,'2631014652001',1332.000000000,'1986-11-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5237,'MOULIN','NELLY','1962-04-13','02.55.48.50.88','06.10.19.41.70',NULL,'16 RUE D''ISIGNY','','','14220','LES MOUTIERS EN CINGLAIS',NULL,NULL,'1620414080001',20.000000000,'1986-11-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5238,'EVEN','GUY','1954-01-24','02.99.01.85.16','06.60.72.48.71',NULL,'27 rue des charmilles','','','50550','ST VAAST LA HOUGUE',NULL,NULL,'1540114345001',133.000000000,'1978-08-12','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5239,'LENORMAND','CLOTHILDE','1940-05-31','02.77.77.52.33','06.11.93.36.17',NULL,'4 ALLEE DES LAVANDES','','','14000','CAEN',NULL,NULL,'2400550312001',256.000000000,'1961-06-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5240,'LENORMAND','JEAN','1961-09-26','02.50.60.89.28','06.84.31.42.85',NULL,'7 HAMEAU DES CHAMPS','','','14640','VILLERS SUR MER',NULL,NULL,'1610937071001',293.000000000,'1983-08-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5241,'PAULMIER','JACQUES','1957-03-20','02.89.33.67.86','06.37.97.77.18',NULL,'5 BOULEVARD DE L ESPERANCE','','','14540','GRENTHEVILLE',NULL,NULL,'1570361332001',42.000000000,'1982-02-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5242,'','ARMELLE','1935-02-16','02.43.41.42.89','06.62.96.32.08',NULL,'17 RUE MARECHAL FOCH','','','14540','SOLIERS',NULL,NULL,'2350233020001',69.000000000,'1959-01-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5243,'','PATRICIA','1930-07-02','02.35.71.56.11','06.52.36.63.27',NULL,'RUE GEORGES LANDRY','','','14000','CAEN',NULL,NULL,'2300750209001',225.000000000,'1952-08-20','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5244,'STEINMETZ','DANIEL','1934-01-17','02.53.16.58.40','06.92.95.02.69',NULL,'34 avenue st therese','','','14220','TOURNEBU',NULL,NULL,'1340114205001',2121.000000000,'1956-03-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5245,'COPILLIE','GERMAIN','1940-02-18','02.30.57.59.31','06.32.55.16.38',NULL,'103 BIS RUE DE L''EGLISE LA MALA','DRERIE','','14123','FLEURY SUR ORNE',NULL,NULL,'2400214236001',70.000000000,'1963-09-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5246,'SIMON','BERNARD','1983-06-26','02.96.16.66.71','06.95.78.38.02',NULL,'ROUTE DE CANON','','','14650','CARPIQUET',NULL,NULL,'1830699248001',80.000000000,'2006-02-07','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5247,'LEROUGE','JEANNINE','1954-04-02','02.16.37.85.65','06.36.55.31.07',NULL,'3 RUE ARISTIDE BRIAND','','','14170','BERVILLE',NULL,NULL,'1540414553001',925.000000000,'1976-07-26','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5248,'LEGUAY','ELISABETH','1935-12-10','02.61.22.41.71','06.19.78.51.86',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2351214133001',60.000000000,'1958-04-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5249,'GENISSON','ROGER','1954-01-05','02.10.96.66.77','06.57.75.35.19',NULL,'5 rue des marches','','','14460','COLOMBELLES',NULL,NULL,'1540114281001',2831.000000000,'1982-11-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5250,'LAHAYE','JEAN','1930-04-03','02.11.75.89.42','06.62.78.77.67',NULL,'11 RUE LOUIS LACHENAL','','','14620','CROCY',NULL,NULL,'1300414288001',387.000000000,'1957-06-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5251,'CRUCHON','MONIQUE','1940-01-29','02.27.57.06.41','06.34.08.79.37',NULL,'7 RUE DE LA FORGE','','','50690','HARDINVAST',NULL,NULL,'1400150409001',14.000000000,'1970-03-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5252,'LAMOTTE','JEAN MARIE','1932-02-11','02.11.58.14.84','06.27.62.39.92',NULL,'','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2320214614001',1288.000000000,'1954-03-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5253,'VERITE','NICOLE','1928-10-01','02.61.17.24.28','06.87.32.53.65',NULL,'40 rue g peri','','','14520','PORT EN BESSIN HUPPAIN',NULL,NULL,'2281014402001',785.000000000,'1955-10-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5254,'CUEFF','RENEE','1930-10-03','02.81.38.61.14','06.52.73.49.51',NULL,'38 rue de la pierre','','','50000','RAMPAN',NULL,NULL,'1301014723001',105.000000000,'1951-08-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5255,'LEPLAY','GERARD','1934-03-28','02.74.39.32.15',NULL,NULL,'4 AVENUE DU PARC','','','14780','LION SUR MER',NULL,NULL,'2340350486001',420.000000000,'1956-10-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5256,'TIROT','CLAUDE','1930-12-14','02.10.28.85.54','06.11.07.14.71',NULL,'','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1301214221001',104.000000000,'1960-08-18','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5257,'CHAPET','HELENE','1940-02-09','02.49.38.68.10','06.35.23.81.44',NULL,'2 RUE DES LILAS','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'1400261412001',63.000000000,'1966-03-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5258,'HALLUIN','DENISE','1930-01-31','02.62.48.63.02','06.79.22.48.56',NULL,'20 RUE MICHEL CABIEU','','','14000','CAEN',NULL,NULL,'1300114679001',106.000000000,'1956-08-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5259,'DESMAISONS','MONIQUE','1949-04-17','02.12.09.75.41','06.61.34.91.89',NULL,'41 rue pasteur appart 51','','','14540','SOLIERS',NULL,NULL,'2490414380001',146.000000000,'1972-04-17','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5260,'LECAPELAIN','YVETTE','1928-09-10','02.78.92.73.24','06.40.53.61.00',NULL,'4 rte de chatellerault','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2280914650001',96.000000000,'1958-09-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5261,'RAULT','CHANTAL','1933-06-12','02.10.12.66.74',NULL,NULL,'14 rue du ruet','','','14123','IFS',NULL,NULL,'2330614277001',22.000000000,'1959-03-07','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5262,'ROUPSARD','LOUIS','1937-04-25','02.61.91.70.94','06.84.86.32.08',NULL,'5, alle Claude Debussy','','','92700','COLOMBES',NULL,NULL,'2370450412001',177.000000000,'1961-09-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5263,'DOLLEY','EDITH','1967-02-16','02.90.68.94.33','06.35.19.04.48',NULL,'10 ROUTE DE TAILLEVILLE','','','61500','BELFONDS',NULL,NULL,'1670277108001',1794.000000000,'1994-12-29','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5264,'HIBLOT','claudine',NULL,'02.18.99.54.73','06.14.17.65.30',NULL,'76 RUE DE LA SEINE','','','14400','BAYEUX',NULL,NULL,'1381250592001',178.000000000,'2012-06-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5265,'BOUCHE','DANIEL','1944-08-26','02.31.43.03.53','06.11.02.60.44',NULL,'13 LE BOURG NEUF','','','14000','CAEN',NULL,NULL,'1440861505001',822.000000000,'1971-09-28','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5266,'LEVEZIEL','GASTON','1931-04-02','02.65.95.91.43','06.89.11.24.49',NULL,'4 RUE DE LA CAVEE','','','14120','MONDEVILLE',NULL,NULL,'1310461053001',7.000000000,'1955-05-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5267,'TERRIER','PIERRE','1948-02-19','02.40.97.59.68','06.10.48.85.86',NULL,'2 BIS RUE DU BAS VERSON','','','14270','MAGNY LE FREULE',NULL,NULL,'2480261320001',2959.000000000,'1972-11-06','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5268,'LEMONNIER','JEANNINE','1940-07-13','02.56.31.30.18','06.51.46.27.74',NULL,'LA MEHEUDIERE','','','14310','VILLERS BOCAGE',NULL,NULL,'2400750332001',142.000000000,'1966-03-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5269,'','JULIETTE','1939-09-11','02.23.26.90.67','06.22.51.20.15',NULL,'225 IMPASSE DU DOMAINE','','','14250','AUDRIEU',NULL,NULL,'1390976572001',17.000000000,'1969-12-10','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5270,'BARBEDETTE','CLAUDINE','1936-12-28','02.55.05.53.29','06.52.28.33.55',NULL,'12 RUE EMILE ORY','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'1361214527001',1033.000000000,'1959-04-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5271,'HORTENSE','MARIE FRANCE','1928-06-21','02.94.31.74.14',NULL,NULL,'14 rue du clos fleurie','','','14270','PERCY EN AUGE',NULL,NULL,'1280646015001',270.000000000,'1954-03-28','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5272,'LEBLOND','JEAN YVES','1932-05-09','02.70.97.46.16','06.69.73.18.46',NULL,'47 ROUTE DE CAUMONT','','','14000','CAEN',NULL,NULL,'2320514011001',52.000000000,'1953-02-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5273,'FOSSEY','ISABELLE','1939-08-30','02.37.95.32.42','06.67.36.75.41',NULL,'77 rue des roches','','','14840','DEMOUVILLE',NULL,NULL,'1390850186001',37.000000000,'1962-11-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5274,'LEGENTIL','FREDERIC','1938-05-24','02.97.00.79.71','06.26.53.40.93',NULL,'9 AVENUE DE NORMANDIE','','','14840','CUVERVILLE',NULL,NULL,'1380550046001',190.000000000,'1962-11-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5275,'HATTENVILLE','CLAUDE','1932-04-02','02.47.43.04.10','06.94.08.35.60',NULL,'20 bld georges pompidou','','','14110','CONDE SUR NOIREAU',NULL,NULL,'1320414226001',79.000000000,'1953-03-10','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5276,'DREUX','ROBERT','1955-07-22','02.31.36.27.59','06.12.27.77.55',NULL,'','','','14123','IFS',NULL,NULL,'1550714118001',92.000000000,'1978-05-16','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5277,'MARY','claude','1929-02-20','02.20.66.18.26','06.66.67.58.35',NULL,'21 RUE DE LA LIBERATION','','','14400','ST VIGOR LE GRAND',NULL,NULL,'2290214695001',86.000000000,'1952-06-30','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5278,'ANNE','PHILIPPE','1931-10-24','02.54.81.39.42','06.31.11.08.78',NULL,'58 rue anatole france','','','14650','CARPIQUET',NULL,NULL,'2311014144001',3020.000000000,'1952-11-16','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5279,'DENIS','JEANINE','1935-09-19','02.12.12.06.71','06.56.57.40.13',NULL,'14 RUE EMILE NICOL','','','14000','CAEN',NULL,NULL,'1350914119001',21.000000000,'1958-06-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5280,'PORTENART','ODILE','1937-01-09','02.18.81.88.44','06.60.67.00.22',NULL,'47 rue de la liberte','','','14310','VILLERS BOCAGE',NULL,NULL,'2370114489001',988.000000000,'1959-10-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5281,'MONROCQ','JULES','1959-01-04','02.32.29.38.87','06.14.40.04.55',NULL,'3 rue du calvaire','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1590114277001',13.000000000,'1989-02-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5282,'LECACHEUR','MADELEINE','1953-02-23','02.11.79.50.04','06.18.06.58.47',NULL,'115 RUE D AUGE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1530261262001',1894.000000000,'1977-06-17','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5283,'LENORMAND','VIRGINIE','1963-01-22','02.51.34.95.32','06.33.44.70.37',NULL,'','','','50250','HOUTTEVILLE',NULL,NULL,'2630114062001',153.000000000,'1985-01-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5284,'DRODE','ALAIN','1936-10-15','02.71.07.14.92','06.25.64.94.01',NULL,'15 RUE MEZERETTE','','','14980','ROTS',NULL,NULL,'2361014158001',99.000000000,'1958-10-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5285,'HOLLER','GUY','1931-05-15','02.59.56.59.52','06.63.76.16.19',NULL,'','','','14680','CINTHEAUX',NULL,NULL,'2310514181001',851.000000000,'1953-05-26','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5286,'BERNADA','CLAUDE','1963-08-27','02.34.21.57.07','06.52.31.24.73',NULL,'RUE DU MESNIL PATRY','','','27260','ST PIERRE DE CORMEILLES',NULL,NULL,'1630821460001',184.000000000,'1992-03-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5287,'TOLLEMER','MARIE','1970-01-18','02.11.40.36.72','06.99.16.63.66',NULL,'9 rue alexis de tocqueville','','','14160','DIVES SUR MER',NULL,NULL,'2700114074001',1349.000000000,'1991-08-14','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5288,'LHOMME','MARIE CLAUDE','1963-12-04','02.11.18.65.04','06.48.50.79.90',NULL,'10 IMPASSE ALBERT DENIS','','','14120','MONDEVILLE',NULL,NULL,'1631299253001',39.000000000,'1989-04-16','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5289,'BOULAND','SIMONE','1965-05-06','02.10.30.05.25','06.12.94.52.32',NULL,'8 rue denis diderot','','','14220','MUTRECY',NULL,NULL,'2650514546001',63.000000000,'1988-12-05','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5290,'MONGODIN','DANIEL','1931-08-19','02.21.47.00.23','06.12.07.18.43',NULL,'21 RUE DES CASTORS','','','14150','OUISTREHAM',NULL,NULL,'2310827355001',1020.000000000,'1953-08-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5291,'ROBILLARD','JACQUES','1954-03-11','02.83.70.29.35','06.49.25.27.25',NULL,'20 bis rue des monts','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'2540314161001',657.000000000,'1976-04-17','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5292,'SALLE','LILIANE','1936-01-09','02.47.73.24.71','06.79.98.72.57',NULL,'RESIDENCE LES CARAVELLES','','','14000','CAEN',NULL,NULL,'1360150343001',89.000000000,'1960-10-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5293,'PIEL','MICHEL','1966-07-14','02.82.83.29.09','06.95.40.52.85',NULL,'4 RUE DE LA PYRAMIDE','','','14000','CAEN',NULL,NULL,'2660714034001',21.000000000,'1991-06-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5294,'ALFRED','MARGUERITE','1930-12-17','02.57.07.78.88','06.55.42.63.84',NULL,'rue du 11 novembre 1918','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'2301214607001',19.000000000,'1955-02-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5295,'HAMEL','JULIEN','1939-02-27','02.66.91.92.89','06.27.12.15.08',NULL,'5 RUE DES ROSIERS','','','14000','CAEN',NULL,NULL,'1390214599001',27.000000000,'1963-05-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5296,'LE METAYER','BERNARD','1932-07-07','02.42.47.17.09','06.69.89.27.13',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'2320714990001',93.000000000,'1960-09-09','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5297,'FAUTRAD','EMILE','1936-06-05','02.27.25.86.05','06.92.64.38.16',NULL,'19 rue andre gide','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2360614341001',18.000000000,'1959-10-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5298,'DUCHEMIN','JEAN PIERRE','1967-02-26','02.41.43.74.02',NULL,NULL,'19 IMPASSE DES ROSES','','','14123','IFS',NULL,NULL,'2670214596001',12.000000000,'1991-05-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5299,'PEPIN','ISABELLE','1938-12-24','02.11.01.54.21','06.39.98.87.64',NULL,'21 BIS PERE CHARLES DE FOUCAULT','','','50120','EQUEURDREVILLE HAINNEVILLE',NULL,NULL,'2381214505001',699.000000000,'1960-10-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5300,'LEPAGE','PAULETTE','1935-10-01','02.71.65.19.36','06.55.93.14.67',NULL,'17  RUE PIERRE CURIE','','','14460','COLOMBELLES',NULL,NULL,'1351014602001',70.000000000,'1963-11-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5301,'GEORGES','RICHARD','1934-03-17','02.85.60.95.55','06.88.64.67.74',NULL,'5 rue de la demi lune','','','14000','CAEN',NULL,NULL,'1340314349001',879.000000000,'1959-01-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5302,'DELAUNAY','DENISE','1933-11-25','02.72.53.80.78','00 33 6.73.10.91.32',NULL,'43 AVENUE DE PARIS','','','14970','BENOUVILLE',NULL,NULL,'2331114480001',342.000000000,'1956-06-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5303,'DUVAL','MARIE',NULL,'02.66.31.53.52','06.13.86.89.88',NULL,'24 AVENUE  DU 18 AOUT 1944','','','50310','MONTEBOURG',NULL,NULL,'1320122105001',36.000000000,'2013-02-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5304,'GUILBERT','MARIE LOUISE','1932-10-25','02.53.15.66.97','06.52.07.43.19',NULL,'BELLE CROIX','','','14840','CUVERVILLE',NULL,NULL,'1321014482001',169.000000000,'1955-08-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5305,'LESAGE','ETIENNE','1938-09-16','02.15.22.29.27','06.32.56.70.06',NULL,'LE PETIT BERON','','','14123','IFS',NULL,NULL,'2380914628001',413.000000000,'1966-07-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5306,'CORBET','GISELE','1965-05-15','02.35.51.50.88','06.10.10.40.94',NULL,'7 allee marcel pagnol','','','61270','AUBE',NULL,NULL,'2650514038001',489.000000000,'1986-09-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5307,'THIEBOT','RAYMOND','1937-08-06','02.96.83.80.44','06.26.59.42.55',NULL,'','','','14670','TROARN',NULL,NULL,'1370814229001',4673.000000000,'1959-03-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5308,'PORET','JULES','1939-12-15','02.86.89.32.29','06.71.02.95.61',NULL,'LE MARQUIS','','','14540','SOLIERS',NULL,NULL,'1391214256001',103.000000000,'1961-11-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5309,'LEDRU','','1931-11-29','02.14.33.06.66','06.23.57.36.64',NULL,'le tilleul chemin des carrieres','','','14123','IFS',NULL,NULL,'1311114271001',27.000000000,'1954-07-16','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5310,'PLASSAIS','CHRISTIAN','1955-03-05','02.69.93.87.41','06.97.03.89.17',NULL,'14 rue des jardins','','','14700','LEFFARD',NULL,NULL,'1550314103001',235.000000000,'1978-02-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5311,'CHENU','GERARD','1950-03-21','02.74.49.72.49',NULL,NULL,'74 rue basse','','',NULL,NULL,NULL,NULL,'2500314149001',14.000000000,'1971-03-08','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5312,'VAULTIER','MARCEL','1928-03-31','02.32.45.91.83','06.94.23.15.40',NULL,'1 RUE DE SECQUEVILLE','','','14000','CAEN',NULL,NULL,'2280361447001',84.000000000,'1956-06-27','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5313,'WENSING','SARAH','1957-01-16','02.57.16.72.47','06.81.92.32.83',NULL,'1 ROUTE DE LA GRANGE AUX LAPINS','','','61230','GACE',NULL,NULL,'2570161167001',4025.000000000,'1985-07-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5314,'HERVIEU','DOMINIQUE','1920-03-07','02.25.60.87.49','06.47.64.35.46',NULL,'LA PETITE BICHOTTE','','','14610','CAIRON',NULL,NULL,'1200372225001',35.000000000,'1945-06-18','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5315,'DOUBLET','GEORGES','1935-07-23','02.97.15.81.49','06.68.75.14.48',NULL,'39 CHEMIN DES OMBRAGES','','','14790','VERSON',NULL,NULL,'1350714248001',149.000000000,'1962-08-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5316,'FOUCHER','JACQUELINE','1936-03-09','02.89.72.13.36','06.81.68.03.58',NULL,'8 RUE DE  LA CAVEE','','','50200','COURCY',NULL,NULL,'1360359121001',93.000000000,'1966-03-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5317,'RICHARD','NADINE','1935-01-18','02.67.57.15.23','06.76.62.41.80',NULL,'5 rue des freres boutrois','','','14000','CAEN',NULL,NULL,'2350150148001',376.000000000,'1958-09-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5318,'ROGER','ADRIEN',NULL,'02.56.82.56.86','06.17.82.74.20',NULL,'4 rue andre lebastard','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1290150111001',17.000000000,'2013-01-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5319,'FOSSARD','GEORGETTE','1929-01-15','02.50.22.10.53','06.62.24.70.46',NULL,'87 CHEMIN DE LA GROSSERIE','','','61120','VIMOUTIERS',NULL,NULL,'1290150111001',52.000000000,'1950-12-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5320,'LEPETIT','JEAN-PAUL','1936-06-17','03.84.47.25.11','06.43.22.67.23',NULL,'','','','60590','TRIE CHATEAU',NULL,NULL,'2360614451001',2367.000000000,'1957-08-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5321,'RAME','GHISLAINE','1931-03-03','02.42.43.29.05','06.88.26.03.94',NULL,'29 RUE STE MARIE','','','14117','MANVIEUX',NULL,NULL,'2310314140001',1495.000000000,'1955-03-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5322,'LEGALLET','ANDRE','1935-02-13','02.47.33.37.59','06.74.59.75.55',NULL,'32 rue du Pavillon','','','14000','CAEN',NULL,NULL,'2350214543001',190.000000000,'1959-01-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5323,'LABOURASSE','JOEL','1955-05-11','02.78.67.69.17','06.27.88.84.12',NULL,'24 RUE DU GENERAL LECLERC','','','14940','SANNERVILLE',NULL,NULL,'2550571130001',23.000000000,'1978-12-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5324,'LEMARQUAND','EDMOND','1928-09-06','02.47.36.41.69','06.12.41.66.52',NULL,'4 RUE DU CHANT DE L'' ALOUETTE','','','14790','MOUEN',NULL,NULL,'1280927069001',348.000000000,'1955-11-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5325,'DUVAL','ANDREE','1946-01-10','02.38.92.39.67','06.48.56.89.66',NULL,'','','','14000','CAEN',NULL,NULL,'2460118019001',300.000000000,'1967-08-06','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5326,'GAUCHER','JEAN LOUIS','1934-03-17','02.38.42.40.65','06.90.12.04.25',NULL,'16 RUE DES TILLEULS','','','14220','HAMARS',NULL,NULL,'2340350497001',40.000000000,'1964-12-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5327,'BOULLAND','RAYMOND','1940-05-04','02.22.07.65.42','06.31.89.29.42',NULL,'527 RUE DE LA MARE','','','14000','CAEN',NULL,NULL,'2400514171001',817.000000000,'1965-01-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5328,'DEMEAUTIS','YANN','1949-02-24','02.31.15.46.62','06.65.86.46.49',NULL,'4 AV DE LA MARNE','','','14120','MONDEVILLE',NULL,NULL,'1490214050001',129.000000000,'1973-01-19','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5329,'MENARD','GERARD','1970-01-02','02.62.04.58.83','06.40.84.24.50',NULL,'5 RUE DELA PLATE PIERRE','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1700114020001',37.000000000,'1994-01-29','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5330,'DUCHEMIN','JEAN MARC','1966-12-26','02.42.51.75.10','06.74.32.51.10',NULL,'','','','14840','DEMOUVILLE',NULL,NULL,'2661214538001',909.000000000,'1991-04-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5331,'HUET','FRANCOIS','1966-12-05','02.10.93.26.17','06.36.69.67.30',NULL,'RUE JACQUES PREVERT','','','50550','ST VAAST LA HOUGUE',NULL,NULL,'2661214538001',129.000000000,'1991-07-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5332,'DESCRETTES','LUCIEN','1946-10-29','02.69.71.22.01','06.11.00.29.46',NULL,'6 RUE DU BOUT GUESDON','','','14123','IFS',NULL,NULL,'2461037261001',43.000000000,'1970-12-01','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5333,'DESLANDES','JEANINE','1939-09-04','02.87.14.27.36','06.28.65.78.19',NULL,'7 RUE DE LA HOGUE','','','14150','OUISTREHAM',NULL,NULL,'2390950215001',25.000000000,'1961-05-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5334,'DESLANDES','','1936-01-15','02.17.55.17.16','06.70.78.91.00',NULL,'le bihet','','','14670','JANVILLE',NULL,NULL,'1360114582001',633.000000000,'1966-03-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5335,'ROLLAND','ODETTE','1934-06-18','02.33.01.13.95','06.21.85.18.60',NULL,'992 route du coupe gorge','','','14980','ROTS',NULL,NULL,'1340650394001',653.000000000,'1958-06-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5336,'LEGRAND','GERARD','1946-06-06','02.79.58.76.67','06.49.18.41.87',NULL,'8 chemin du mont potin','','','14210','TOURVILLE SUR ODON',NULL,NULL,'1460614125001',4438.000000000,'1968-07-28','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5337,'REGNAULT','GILBERT','1952-02-26','02.97.89.84.54','06.81.23.57.33',NULL,'','','','14370','MERY CORBON',NULL,NULL,'2520250196001',160.000000000,'1980-03-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5338,'CAPRAIS','CLAUDIA','1934-06-01','02.37.71.13.12','06.49.28.30.34',NULL,'16 rue du puits picard','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1340650394001',1896.000000000,'1964-12-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5339,'MARIE','NATHALIE','1937-12-06','02.29.09.19.72','06.50.31.93.37',NULL,'LA TREMBLEE','','','14123','IFS',NULL,NULL,'2371253119001',1701.000000000,'1961-02-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5340,'GENET','PIERRE','1935-04-08','02.19.78.61.25','06.76.30.31.62',NULL,'9 rue des bulletieres','','','14940','SANNERVILLE',NULL,NULL,'1350450001001',109.000000000,'1962-10-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5341,'COSNARD','DENISE','1942-08-31','02.40.01.08.47','06.86.89.18.90',NULL,'','','','14540','ROCQUANCOURT',NULL,NULL,'1420814544001',689.000000000,'1965-07-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5342,'VAUDRY','BERNADETTE','1958-03-07','02.10.72.32.36','06.80.79.13.75',NULL,'HLM LES ANTILOPES APPT 1230 10',' AVENUE DES MARECHAUX','','14520','PORT EN BESSIN HUPPAIN',NULL,NULL,'2580314121001',6.000000000,'1988-03-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5343,'BEAUMONT','GUY','1930-06-17','02.24.46.79.17','06.54.78.39.44',NULL,'21, rue Bernard Zajewski','','','14000','CAEN',NULL,NULL,'1300614464001',383.000000000,'1952-09-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5344,'BRICON','JEANNINE','1939-03-12','02.20.43.68.83','06.45.12.09.66',NULL,'11 rue paul langevin','','','14120','MONDEVILLE',NULL,NULL,'1390397109001',3.000000000,'1963-08-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5345,'PORET','CONSTANT','1961-03-23','02.65.72.60.57','06.85.08.45.29',NULL,'3 RUE DE LA CLAIRAUDERIE','','','61200','MOULINS SUR ORNE',NULL,NULL,'1610314435001',21.000000000,'1989-05-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5346,'JOUENNE','ANNA','1937-07-28','02.64.39.82.88','06.21.64.30.27',NULL,'4 RUE RAYMOND COSSON','','','14000','CAEN',NULL,NULL,'2370714535001',626.000000000,'1962-10-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5347,'LEGUEDE','JOELLE','1965-03-28','02.41.51.78.77','06.47.37.02.93',NULL,'1185 ROUTE DE LA VALLEE','','','14120','MONDEVILLE',NULL,NULL,'2650314643001',2.000000000,'1989-05-08','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5348,'DUGARDIN','PIERRE','1939-03-09','02.39.49.39.92','06.55.57.20.37',NULL,'7 rue auguste briand','','','14123','IFS',NULL,NULL,'2390314354001',510.000000000,'1966-10-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5349,'RENAUDINEAU','MAURICETTE','1930-12-26','02.66.55.88.52','06.33.45.97.94',NULL,'le pont au roux','','','14370','CLEVILLE',NULL,NULL,'2301235022001',120.000000000,'1956-11-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5350,'NKOUKA-LOUHOUAMOU','PATRICIA','1966-02-08','02.82.34.52.53','06.60.76.08.09',NULL,'89 ROUTE DES RIVIERES','','','14650','CARPIQUET',NULL,NULL,'1660214675001',393.000000000,'1988-04-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5351,'CHENU','michel','1956-01-20','02.11.40.48.80','06.48.16.99.22',NULL,'89 ROUTE DES RIVIERES','','','14000','CAEN',NULL,NULL,'1560150622001',11.000000000,'1978-03-19','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5352,'PITREL','JOSETTE','1930-08-27','02.11.78.96.14','06.79.17.52.40',NULL,'3 RUE DES FORGES','','','14270','MEZIDON CANON',NULL,NULL,'1300814761001',137.000000000,'1954-06-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5353,'ROSSIGNOL','ANDRE','1966-04-13','02.14.87.85.28','06.43.10.47.69',NULL,'5 RUE GUY DE MAUPASSANT','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2660441022001',16.000000000,'1995-12-11','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5354,'BELLIN','BERNARD','1940-03-17','02.90.69.09.88','06.22.46.10.83',NULL,'5 RUE VERTES PRAIRIES','','','14120','MONDEVILLE',NULL,NULL,'2400350552001',39.000000000,'1963-03-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5355,'FOUCHARD','PASCALE','1966-02-13','02.43.23.54.26','06.86.80.49.50',NULL,'rue de la justice','','','14630','CAGNY',NULL,NULL,'1660277331001',104.000000000,'1993-12-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5356,'RENIER','SERGE','1939-02-09','02.56.11.09.15','06.44.62.45.63',NULL,'','','','14350','ST PIERRE TARENTAINE',NULL,NULL,'1390214422001',57.000000000,'1964-06-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5357,'LEBRET','','1936-09-20','02.11.81.61.04','06.88.78.34.79',NULL,'18 RUE DE LA REPUBLIQUE','','','14630','CAGNY',NULL,NULL,'2360914119001',268.000000000,'1960-03-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5358,'PETIT','JEAN LOUIS','1963-04-03','02.96.38.31.24','06.10.32.49.11',NULL,'25 RUE DU BUISSON','','','14000','CAEN',NULL,NULL,'1630414294001',26.000000000,'1984-05-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5359,'DERAINE','YVETTE','1950-02-25','02.30.24.44.69','06.13.75.70.35',NULL,'','','','14630','CAGNY',NULL,NULL,'2500214458001',59.000000000,'1971-06-22','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5360,'KREMER','JEANNINE','1940-07-04','02.45.67.09.56','06.17.30.17.11',NULL,'','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'2400772204001',169.000000000,'1964-06-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5361,'QUENOT','LUDOVIC','1934-11-15','02.33.09.75.18','06.89.72.38.93',NULL,'10 RUE LA VIEILLE CHAISE DIEU','','','14000','CAEN',NULL,NULL,'1341178201001',137.000000000,'1957-04-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5362,'CHERUETTE','DENISE','1932-12-19','02.97.72.19.61','06.88.31.69.39',NULL,'37 RUE DE L''ESGLANDES','','','14650','CARPIQUET',NULL,NULL,'2321250426001',264.000000000,'1956-10-23','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5363,'CUSSY','MARIE-MADELEIN','1942-03-21','02.48.09.67.88','06.73.93.45.62',NULL,'159 rue haute','','','14120','MONDEVILLE',NULL,NULL,'1420380388001',19.000000000,'1967-02-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5364,'VIGNERON','JACQUES','1932-05-30','02.48.34.15.59','06.35.38.21.13',NULL,'1 TER RUE DU FRESNETS','','','61200','ARGENTAN',NULL,NULL,'1320514034001',162.000000000,'1961-06-14','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5365,'DELACOUR','MICHEL','1955-04-18','02.85.13.07.57','06.68.12.15.20',NULL,'','','','14270','MEZIDON CANON',NULL,NULL,'1550450373001',1994.000000000,'1979-10-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5366,'SANDEAU','YVONNE','1962-09-21','02.34.77.61.18','06.38.60.66.13',NULL,'3 RUE DU BAILLIAGE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1620914328001',103.000000000,'1987-06-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5367,'CLOUET','IRENE','1935-01-13','02.17.50.68.52','06.11.80.86.30',NULL,'65. AVENUE CHARLEMAGNE','','','14250','AUDRIEU',NULL,NULL,'2350114208001',18.000000000,'1958-05-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5368,'BAZILLE','','1958-01-30','02.76.70.10.88','06.49.49.07.71',NULL,'RUE DU PETIT MAISY 1 RES DU PHAR','E','','14000','CAEN',NULL,NULL,'2580114290001',193.000000000,'1988-01-05','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5369,'NEUVILLE','YVETTE','1962-02-26','02.12.14.29.04','06.90.12.76.12',NULL,'28 RUE DU 8 MAI','','','14000','CAEN',NULL,NULL,'2620214530001',481.000000000,'1984-09-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5370,'LAVERGNE','ALBERTE','1936-02-11','02.63.20.23.33','06.65.43.40.86',NULL,'33 RUE D''ANJOU','','','14000','CAEN',NULL,NULL,'1360250190001',291.000000000,'1965-01-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5371,'DUFOUR','paul','1964-01-13','02.56.08.66.87','06.90.65.25.52',NULL,'LE LIEU POULAIN','','','14270','MEZIDON CANON',NULL,NULL,'2640160166001',4.000000000,'1988-07-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5372,'HAUVEL','ADRIENNE','1960-05-05','02.62.01.50.36','06.88.83.07.68',NULL,'29 RUE DE BEAUVOIR','','','61140','JUVIGNY SOUS ANDAINE',NULL,NULL,'1600514458001',410.000000000,'1989-11-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5373,'LAMANTHE','DANIEL','1962-01-01','02.85.83.52.37','06.56.02.39.88',NULL,'ROUTE D ARGENCES','','','14540','BOURGUEBUS',NULL,NULL,'1620114020001',89.000000000,'1983-06-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5374,'LETELLIER','JACQUES','1935-01-29','02.77.49.96.73','06.63.18.55.29',NULL,'8 RUE D HELSINKY','','','14670','TROARN',NULL,NULL,'1350114339001',56.000000000,'1963-01-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5375,'GOUJU','AIMEE','1956-05-09','02.32.78.46.43','06.23.95.20.66',NULL,'11 Place Jeanne d''Arc','','','14730','GIBERVILLE',NULL,NULL,'1560561208001',228.000000000,'1979-08-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5376,'BOUDARD','MARIE FRANCE','1956-06-25','02.47.70.42.88','06.57.04.11.77',NULL,'15 BD  BERTRAND','','','14000','CAEN',NULL,NULL,'2560614404001',52.000000000,'1978-10-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5377,'FREIDOZ','YVONNE','1932-06-12','02.84.07.40.39','06.39.92.34.56',NULL,'les quesnouardiers','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2320614341001',152.000000000,'1961-04-26','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5378,'LERENARD','ROGER','1928-03-10','02.38.43.47.71','06.87.78.53.20',NULL,'les quesnouardiers','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2280314535001',96.000000000,'1949-03-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5379,'SEPCHAT','FRANCOISE','1933-05-03','02.46.33.15.68','06.91.30.15.29',NULL,'10 bis rue eugene figeac','','','14540','TILLY LA CAMPAGNE',NULL,NULL,'2330514129001',1013.000000000,'1963-04-27','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5380,'GERVAISE','HENRI','1931-12-24','02.56.38.01.38','06.31.35.37.79',NULL,'LE HAMEAU POURRI','','','14150','OUISTREHAM',NULL,NULL,'2311289117001',130.000000000,'1961-10-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5381,'DEVIN','EMMANUEL','1934-04-30','02.22.70.57.62','06.61.68.61.61',NULL,'11 rue de bourgogne','','','14540','GRENTHEVILLE',NULL,NULL,'2340471061001',19.000000000,'1956-08-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5382,'HAMARD','JEAN','1960-05-04','02.74.29.14.52',NULL,NULL,'1 RUE DES GLENGARRIANS','','','14670','TROARN',NULL,NULL,'2600514209001',350.000000000,'1989-11-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5383,'PLEY','PAULETTE','1955-01-06','02.82.27.81.25','06.32.73.38.81',NULL,'21 RUE DES SALINES','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'2550114170001',2.000000000,'1983-03-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5384,'DEWULF','MARIE HELENE','1933-12-08','02.45.41.24.91','06.23.99.20.69',NULL,'17 RUE DE L''EGLISE','','','14960','ASNELLES',NULL,NULL,'1331214331001',16.000000000,'1963-01-06','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5385,'DAVID','CHRISTIANE','1933-09-07','02.43.65.14.40','06.38.64.95.07',NULL,'ROUTE DU COMMERCE','','','14370','CROISSANVILLE',NULL,NULL,'2330914542001',60.000000000,'1957-12-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5386,'DAVID','HUGUETTE','1936-08-02','02.26.36.11.59','06.28.69.86.48',NULL,'58 rue anatole france','','','14340','CREVECOEUR EN AUGE',NULL,NULL,'2360814100001',82.000000000,'1966-10-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5387,'IMERLICHVILI','ANDRE','1931-04-12','02.21.39.47.92','06.10.16.94.06',NULL,'chemin d''assemont','','','14840','CUVERVILLE',NULL,NULL,'1310414164001',34.000000000,'1952-08-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5388,'QUESNEL','CHANTAL','1939-11-28','02.81.57.15.09','06.11.23.41.85',NULL,'25 RUE GUY DE MAUPASSANT','','','14840','DEMOUVILLE',NULL,NULL,'1391114684001',91.000000000,'1964-06-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5389,'HAMEL','CLAUDE','1938-03-04','02.21.97.29.81','06.11.10.73.52',NULL,'1874 ROUTE DE BRETTEVILLE','','','14120','MONDEVILLE',NULL,NULL,'2380345284001',915.000000000,'1962-02-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5390,'BROUT','JEAN LOUIS','1934-07-13','02.10.53.31.78','06.92.84.34.99',NULL,'LES PATIS','','','14840','DEMOUVILLE',NULL,NULL,'2340714070001',210.000000000,'1956-01-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5391,'LAMY','HENRIETTE','1956-02-10','02.23.14.70.93','06.85.58.21.60',NULL,'325 rue de falaise','','','14000','CAEN',NULL,NULL,'2560250564001',72.000000000,'1979-06-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5392,'MABIRE','TADEUCH','1970-01-08','02.40.14.70.80','06.79.09.78.42',NULL,'RUE AUX JUIFS','','','14540','GRENTHEVILLE',NULL,NULL,'2700114258001',28.000000000,'1994-01-28','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5393,'MARIE','EDOUARD','1930-10-10','02.31.99.64.33','06.98.49.39.98',NULL,'94 RUE DE FALAISE','','','14320','FONTENAY LE MARMION',NULL,NULL,'2301014366001',35.000000000,'1953-08-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5394,'DUCELLIER','SIMONE','1954-01-08','02.89.00.75.41','06.86.82.50.82',NULL,'RUE LES MESLINIERES','','','61100','LA LANDE PATRY',NULL,NULL,'1540150056001',3269.000000000,'1977-09-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5395,'LEMIERE','NELLY','1940-12-07','02.14.73.89.63','06.66.90.72.77',NULL,'25  AVENUE JEAN MONNET N/1 RESI','DENCE W.CHURCHILL','','14310','ST LOUET SUR SEULLES',NULL,NULL,'2401214654001',759.000000000,'1963-07-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5396,'DELAVAUX','MICHEL','1940-12-20','02.58.52.78.43','06.82.14.58.63',NULL,'20 RUE EUGENE MAES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2401214654001',2396.000000000,'1963-04-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5397,'BONNET','MICHEL','1940-09-18','02.75.05.36.37','06.89.34.46.36',NULL,'33 AVENUE ROBERT SCHUMAN','','','14940','SANNERVILLE',NULL,NULL,'1400914654001',590.000000000,'1962-10-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5398,'PRIGENT','MICHEL','1934-08-23','02.61.38.39.70','06.44.00.12.42',NULL,'21 RUE DES COTEAUX','','','14840','DEMOUVILLE',NULL,NULL,'1340814011001',69.000000000,'1960-12-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5399,'LENOEL','FRANCOISE','1929-09-01','02.36.69.16.00','06.19.77.31.63',NULL,'HAMEAU DE LA CORDERIE','','','14120','MONDEVILLE',NULL,NULL,'2290914623001',9.000000000,'1951-05-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5400,'RICHARD','ROLAND','1944-04-04','02.63.93.97.41','06.10.15.24.96',NULL,'27 rue d''ifs','','','14000','CAEN',NULL,NULL,'2440414156001',77.000000000,'1971-10-04','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5401,'HOUEIX','JACQUES','1935-09-18','02.10.77.06.29','06.81.56.36.09',NULL,'24 RUE DOYEN MORIERE','','','14500','VIRE',NULL,NULL,'2350914389001',966.000000000,'1958-09-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5402,'GOUDIER','MARIE','1929-01-26','02.84.16.39.82','06.25.15.16.48',NULL,'1 RUE DU LOGIS','','','14630','CAGNY',NULL,NULL,'1290114538001',82.000000000,'1959-07-10','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5403,'ROMET','CLAUDE','1929-12-05','02.10.72.14.33','06.45.13.22.91',NULL,'2 ALLEE DES  FRESNES','','','14000','CAEN',NULL,NULL,'1291214712001',44.000000000,'1954-12-18','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5404,'COUDRET','NICOLAS','1932-01-24','02.73.30.18.86','06.63.39.14.41',NULL,'2 AVENUE PIERRE MARIE CURIE','','','14123','IFS',NULL,NULL,'1320114392001',333.000000000,'1954-04-08','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5405,'DOREY','YVETTE','1961-01-25','02.23.37.91.60','06.16.41.01.89',NULL,'53. route d harcourt','','','14000','CAEN',NULL,NULL,'2610114623001',962.000000000,'1986-04-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5406,'BARBIER','SALLAH','1930-10-27','02.10.63.67.12','06.10.90.19.44',NULL,'11 CHEMIN DES CLOS','','','14000','CAEN',NULL,NULL,'2301038234001',1467.000000000,'1960-03-12','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5407,'GALLOT','HELENE','1933-05-16','02.49.56.15.65','06.49.74.21.42',NULL,'10 RESIDENCE DE LA CHAPELLE','','','14730','GIBERVILLE',NULL,NULL,'2330556175001',4.000000000,'1961-05-13','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5408,'GRAFFET','HELENE','1968-02-11','02.11.75.56.94','06.62.10.02.49',NULL,'11 RUE DE BRETAGNE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1680250166001',801.000000000,'1989-06-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5409,'VIEL','MARIN','1957-04-15','02.18.66.66.65','06.35.28.35.95',NULL,'5 rue montcalm','','','14230','VOUILLY',NULL,NULL,'2570414548001',64.000000000,'1980-01-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5410,'SONNET','MADELEINE','1950-01-06','02.63.22.32.44','06.79.18.87.69',NULL,'5 RUE DU CARRELET','','','14460','COLOMBELLES',NULL,NULL,'1500114752001',105.000000000,'1971-04-02','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5411,'BOTREAU','MAURICE','1935-02-25','02.17.78.43.73','06.11.33.41.71',NULL,'64 CHEMIN DES BOUTTIERES','','','14000','CAEN',NULL,NULL,'1350214256001',119.000000000,'1962-02-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5412,'LANOS','SIMONE','1939-07-07','02.62.72.75.75','06.81.71.96.93',NULL,'47 RUE DES TEINTURIERS','','','14000','CAEN',NULL,NULL,'1390761248001',948.000000000,'1969-07-30','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5413,'DUPY','NICOLE','1944-08-29','02.18.99.59.99','06.64.41.03.95',NULL,'11 rue emile zola','','','14123','IFS',NULL,NULL,'1440861505001',16.000000000,'1968-02-22','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5414,'MARTIN','EVELYNE','1944-08-26','02.87.70.51.85','06.10.71.33.87',NULL,'9 CHEMIN DE LA DELLE','','','14630','FRENOUVILLE',NULL,NULL,'1440861505001',1.000000000,'1973-11-19','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5415,'QUESNEL','MICHEL','1961-09-17','02.63.90.30.04','06.22.32.20.02',NULL,'138 AVENUE HENRI CHERON','','','14370','CLEVILLE',NULL,NULL,'1610950389001',543.000000000,'1983-11-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5416,'PAYOUX','SOLANGE','1929-05-02','02.24.71.25.54','06.77.96.45.00',NULL,'LA GEMMIERE','','','14000','CAEN',NULL,NULL,'2290514164001',58.000000000,'1950-07-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5417,'HOMMAIS','ROGER','1941-02-20','02.80.88.66.51','06.96.89.41.98',NULL,'23 RUE DE LA MONDRIERE APPT/299 ','RESIDENCE LEONARD GILLES','','14280','ST CONTEST',NULL,NULL,'1410250048001',34.000000000,'1970-02-09','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5418,'PRETI','ANDRE','1954-01-19','02.59.60.12.58','06.63.98.90.53',NULL,'2 RUE DE GRUCHY','','','14270','MEZIDON CANON',NULL,NULL,'1540114568001',674.000000000,'1975-11-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5419,'BOUTELOUP','GISELE','1938-12-15','02.47.27.14.22','06.23.93.21.80',NULL,'HAMEAU D''ENGRANVILLE','','','78990','ELANCOURT',NULL,NULL,'1381214738001',19.000000000,'1968-02-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5420,'QUESNEL','FLORENCE','1962-03-04','02.63.56.13.63','06.60.41.61.01',NULL,'22 RUE DES CARRIERES','','','14460','COLOMBELLES',NULL,NULL,'1620361122001',192.000000000,'1983-10-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5421,'QUESNEL','DONAT','1959-04-08','02.43.43.33.35','06.22.35.79.40',NULL,'1 RUE DE LA JOUBERIE','','','14850','ESCOVILLE',NULL,NULL,'2590414251001',36.000000000,'1989-06-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5422,'HUBERT','PIERRETTE','1957-07-23','02.71.65.16.22','06.55.68.55.60',NULL,'2 impasse beaudelaire','','','14123','IFS',NULL,NULL,'1570778571001',5.000000000,'1984-07-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5423,'LEMARINIER','JEAN','1933-02-18','02.36.12.07.94','06.45.38.54.51',NULL,'8 chemin duvivier','','','14000','CAEN',NULL,NULL,'1330214592001',1149.000000000,'1955-04-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5424,'GUILPIN','MARTINE','1953-02-24','02.83.38.23.73','06.45.04.54.54',NULL,'4 ALLEE DES LAVANDES','','','14000','CAEN',NULL,NULL,'2530214476001',77.000000000,'1981-10-31','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5425,'LHERMITE','',NULL,'02.84.65.41.36','06.63.67.84.47',NULL,'8 RUE DU PERE ROBERT','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1401014628001',12.000000000,'2011-11-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5426,'BOUGUERRA','JOEL','1936-12-15','02.59.31.09.73','06.37.19.28.34',NULL,'6 RUE PASTEUR','','','14120','MONDEVILLE',NULL,NULL,'2361208449001',17.000000000,'1959-02-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5427,'MICHEL','RENEE','1935-11-06','02.16.75.62.91','06.12.13.80.83',NULL,'10 route de rouen','','','14630','CAGNY',NULL,NULL,'2351114312001',78.000000000,'1956-09-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5428,'RAULT','SUZANNE','1935-11-07','02.71.11.94.87','06.95.66.30.12',NULL,'12 avenue de la liberation','','','14370','ARGENCES',NULL,NULL,'2351114312001',1555.000000000,'1958-05-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5429,'RAMSPACHER','SOLANGE','1969-10-18','02.72.64.02.11','06.13.60.55.30',NULL,'33 chemin des coteaux','','','14220','ST LAURENT DE CONDEL',NULL,NULL,'1691014344001',17.000000000,'1999-10-09','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5430,'GOVRICH','JEANNINE','1934-01-14','02.20.41.42.47','06.12.07.54.05',NULL,'RUE LA PILLIERE','','','14880','HERMANVILLE SUR MER',NULL,NULL,'1340114056001',416.000000000,'1955-08-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5431,'RENEE','JACQUES','1934-11-04','02.21.14.15.57','06.60.56.77.38',NULL,'25 rue des coteaux','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'2341114625001',26.000000000,'1962-12-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5432,'MARIE','MARY','1938-08-01','02.18.05.72.57','06.10.09.89.89',NULL,'4 ALLEE LAVOISIER','','','14340','CREVECOEUR EN AUGE',NULL,NULL,'2380879268001',333.000000000,'1966-05-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5433,'ANDRISIK','JACQUES','1940-02-18','02.31.19.34.49','06.16.17.06.45',NULL,'1 rue claude debussy','','','14840','CUVERVILLE',NULL,NULL,'1400214554001',141.000000000,'1970-08-27','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5434,'LEMAHIEU','MONIQUE','1954-02-08','02.10.95.21.28','06.72.36.56.70',NULL,'2 RUE ROSE HAREL','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2540214118001',1367.000000000,'1975-10-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5435,'DOUSSON','MADELEINE','1940-07-19','02.94.87.75.55','06.12.36.21.07',NULL,'2 RUE MARCEL FLEURY','','','14000','CAEN',NULL,NULL,'1400714384001',15.000000000,'1968-11-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5436,'JEANNE','LUCIENNE','1933-06-17','02.52.40.03.69','06.79.42.42.76',NULL,'9 rue geiseleach','','','14370','VIMONT',NULL,NULL,'2330614101001',125.000000000,'1959-05-15','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5437,'LIEGEARD','JACQUELINE','1935-01-15','02.67.46.83.99','06.48.71.88.42',NULL,'1 rue  de sandford','','','14320','FONTENAY LE MARMION',NULL,NULL,'2350114632001',31.000000000,'1961-03-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5438,'BONNEAU','ANDRE','1935-04-13','02.44.80.37.86','06.66.06.08.12',NULL,'15 rue jacques cartier','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1350414121001',13.000000000,'1965-11-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5439,'FAISANT','YVETTE','1935-04-29','02.47.75.57.83','06.38.59.51.29',NULL,' 2 RUE ELIANE','','','14400','NONANT',NULL,NULL,'1350414121001',710.000000000,'1962-12-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5440,'FEREY','ANDRE','1932-06-28','02.66.64.83.18','06.76.29.87.96',NULL,'1 RUE DU MARAIS','','','61220','LIGNOU',NULL,NULL,'1320627499001',1011.000000000,'1958-12-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5441,'CERON','CLAIRE','1949-08-17','02.11.98.70.46','00 33 6.17.33.40.42',NULL,'7 rue jean mermoz','','','14430','CRESSEVEUILLE',NULL,NULL,'1490814089001',41.000000000,'1971-04-25','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5442,'BAZIN','THERESE','1930-07-10','02.93.90.83.55','06.97.32.34.29',NULL,'20 AVENUE DE L''HYPPODROME','','','14310','LONGVILLERS',NULL,NULL,'1300756091001',164.000000000,'1953-07-24','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5443,'TOUTAIN','MARIE','1935-10-26','02.82.48.03.38','06.41.30.18.32',NULL,'6 RUE DES ACACIAS','','','14920','MATHIEU',NULL,NULL,'2351014213001',26.000000000,'1963-12-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5444,'REBOURS','GINETTE','1932-03-18','02.85.76.65.11','06.53.74.11.83',NULL,'21 route de cabourg','','','14730','GIBERVILLE',NULL,NULL,'1320314551001',23.000000000,'1962-03-20','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5445,'FASOLI','ANDRE','1945-10-03','02.11.96.64.22','06.62.49.33.17',NULL,'25 ALLEE GUILLAUME LE CONQUERANT','','','14000','CAEN',NULL,NULL,'1451092415001',13.000000000,'1972-08-24','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5446,'LEBRETON','MADELEINE','1942-04-17','02.82.19.34.36','06.35.93.29.67',NULL,'12 ROUTE DE LA LANDE D''AIROU','','','14123','IFS',NULL,NULL,'1420453149001',789.000000000,'1968-12-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5447,'VASSELIN','HUGUETTE','1931-12-21','02.10.10.42.13','06.76.55.73.19',NULL,'2 BIS RUE DE CABOURG','','','14830','LANGRUNE SUR MER',NULL,NULL,'1311214257001',898.000000000,'1954-10-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5448,'FRANCOIS','JEAN-CLAUDE','1940-02-07',NULL,NULL,NULL,'4/2 ROUTE DE TRAVERSIERE','','','14860','BAVENT',NULL,NULL,'1400253147001',2.000000000,'1967-01-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5449,'QUENAULT','GINETTE','1937-12-15','02.22.69.78.86','06.70.17.77.60',NULL,'61 RUE DU GENERAL DE GAULLE','','','14220','CURCY SUR ORNE',NULL,NULL,'2371214609001',20.000000000,'1963-05-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5450,'RENAULT','JEAN CLAUDE',NULL,'02.76.79.28.55','06.82.19.81.15',NULL,'87 RUE PIERRE CORNEILLE','','','14000','CAEN',NULL,NULL,'2820199253001',228.000000000,'2011-09-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5451,'MARSAULT','BERNARD','1982-01-25','02.11.22.38.06','06.73.80.86.69',NULL,'18 RUE DU CLOS BOUILLON','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'2820199253001',2331.000000000,'2012-05-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5452,'RUIZ RODRIGUEZ','DENISE','1957-01-14','02.67.45.93.67','06.15.35.71.41',NULL,'10 rue jean guttemberg','','','14850','ESCOVILLE',NULL,NULL,'1570114225001',3480.000000000,'1978-12-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5453,'BUNEL','PIERRE','1969-07-02','02.85.20.78.78','06.39.23.94.71',NULL,'5 IMPASSE DES ALPES','','','14250','LINGEVRES',NULL,NULL,'2690780021001',2860.000000000,'1991-03-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5454,'AVOINE','MAURICE','1954-08-08','02.67.21.52.59','06.11.55.32.68',NULL,'1 ALLEE DES PINCONS','','','14270','MEZIDON CANON',NULL,NULL,'2540814494001',188.000000000,'1975-05-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5455,'GERBE','MARINETTE','1935-12-31','02.10.77.06.57','06.83.75.95.76',NULL,'la cour bauval','','','14400','ST VIGOR LE GRAND',NULL,NULL,'2351261206001',379.000000000,'1960-01-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5456,'SYLVAND','ZENON','1939-09-09','02.30.86.97.57','06.82.05.95.58',NULL,'38 rue de l''eglise','','','14000','CAEN',NULL,NULL,'2390961182001',806.000000000,'1962-06-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5457,'LEHUBY','jean marc','1932-07-01','02.49.76.76.62','06.61.64.47.16',NULL,'','','','14113','VILLERVILLE',NULL,NULL,'2320753132001',893.000000000,'1954-08-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5458,'AVOINE','CLAUDE','1968-02-08','02.65.49.57.06','06.47.88.32.19',NULL,'5 RUE DES ANCIENS D''AFN','','','14120','MONDEVILLE',NULL,NULL,'2680214092001',72.000000000,'1998-11-30','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5459,'AUBRIS','PIERRE','1935-03-13','02.23.65.11.42','06.12.12.63.52',NULL,'12 rue du marechal leclerc','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'1350361282001',15.000000000,'1961-10-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5460,'LEMARCHAND','DENISE','1934-01-25','02.19.42.32.12','06.60.59.29.96',NULL,'4 IMPASSE DES CERISIERS','','','14800','DEAUVILLE',NULL,NULL,'1340114167001',946.000000000,'1959-08-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5461,'LOISON','SIMONE','1936-07-10','02.11.08.73.00','06.42.06.55.57',NULL,'16 RUE E.SATIE','','','27300','BERNAY',NULL,NULL,'1360714123001',40.000000000,'1959-03-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5462,'BARBANCHON','LOUIS','1932-12-10',NULL,NULL,NULL,'LE SUELLE','','','14000','CAEN',NULL,NULL,'2321235299001',44.000000000,'1958-12-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5463,'MAUGER','ARLETTE','1940-04-28','02.52.46.98.47','06.46.74.79.56',NULL,'95 AV DE ROUEN','','','50440','DIGULLEVILLE',NULL,NULL,'2400414485001',197.000000000,'1961-06-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5464,'ENAULT','ANDRE','1930-06-23','02.17.46.19.09','06.93.55.51.66',NULL,'ROUTE DE L''EGLISE','','','14270','MEZIDON CANON',NULL,NULL,'1300627051001',101.000000000,'1953-08-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5465,'PRUNEAU','FERNAND','1939-04-11','02.61.34.37.38','06.25.95.67.40',NULL,'7 RUE DES CHASSES','','','14123','IFS',NULL,NULL,'2390461494001',171.000000000,'1965-06-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5466,'LEBRETHON','DENISE','1934-03-29','02.64.53.44.61','06.98.04.69.68',NULL,'7 RUE DES CHASSES','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1340376146001',58.000000000,'1959-06-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5467,'BRUNET','BRIGITTE','1932-08-13','02.20.63.03.01','06.66.31.63.97',NULL,'4 RUE PAUL LANGEVIN','','','14123','IFS',NULL,NULL,'1320850504001',25.000000000,'1954-10-15','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5468,'LAVACHE','SIMONE','1929-09-18','02.85.08.89.75','06.10.13.72.09',NULL,'1 CHEMIN DES FEUGRETTES','','','14840','CUVERVILLE',NULL,NULL,'2290950384001',97.000000000,'1955-07-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5469,'FLAMBARD','HENRIETTE','1956-02-14','02.48.96.61.82','06.17.64.92.99',NULL,'LA LAITERIE','','','14000','CAEN',NULL,NULL,'2560214710001',114.000000000,'1982-07-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5470,'LESENECHAL','',NULL,'02.53.00.64.20','06.25.79.34.70',NULL,'COUPIGNY','','','14370','MOULT',NULL,NULL,'2380250635001',412.000000000,'2011-10-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5471,'CUQUEMELLE','AUGUSTINE','1931-08-07','02.61.34.52.15','06.91.39.67.24',NULL,'38 RUE DE CREULLY','','','14111','LOUVIGNY',NULL,NULL,'1310814101001',43.000000000,'1956-03-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5472,'CHESNEL','CHRISTIAN','1963-11-06','02.25.90.07.23','06.60.09.72.19',NULL,'RESIDENCE DU STEDE BAT/LES COLIB','RIS  122 RUE CARNOT','','50560','ANNEVILLE SUR MER',NULL,NULL,'2631114118001',2394.000000000,'1986-01-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5473,'BOSSUYT','CLAUDE','1963-11-22','02.33.46.46.92','06.11.10.27.76',NULL,'7 RUE DE LA HOGUE','','','14220','CULEY LE PATRY',NULL,NULL,'2631114118001',1421.000000000,'1987-06-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5474,'YVER','CLAUDE','1941-03-19','02.10.69.78.31','06.88.85.21.33',NULL,'8 allee jean philippe rameau','','','14370','ARGENCES',NULL,NULL,'2410314669001',2106.000000000,'1971-03-30','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5475,'GONIDEC','FLORENCE',NULL,'02.30.06.01.79','06.87.94.18.40',NULL,'PLACE DES CANADIENS','','','14120','MONDEVILLE',NULL,NULL,'1320614493001',429.000000000,'2009-12-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5476,'SUARD','JEAN CLAUDE','1931-12-20','02.12.20.60.53','06.10.12.20.73',NULL,'le tremblais','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1311228340001',5.000000000,'1961-09-19','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5477,'POREY','JOSIANE','1934-12-09','02.52.51.04.63','06.65.57.83.21',NULL,'15 rue de la bergerie','','','14000','CAEN',NULL,NULL,'1341227601001',25.000000000,'1955-02-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5478,'LEBEURRIER','GEORGES','1937-04-14','02.18.69.80.39','06.61.43.43.64',NULL,'6 allee l pergaug','','','14000','CAEN',NULL,NULL,'1370461344001',454.000000000,'1958-11-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5479,'GUERIN','','1931-10-23','02.10.03.56.43','06.21.97.85.36',NULL,'23 bis avenue charles de foucaul','t','','14220','TOURNEBU',NULL,NULL,'2311076456001',11.000000000,'1960-05-24','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5480,'ROCHER','thierry','1929-01-08','02.60.21.92.47','06.18.93.54.99',NULL,'71 rue j jaures','','','14460','COLOMBELLES',NULL,NULL,'1290114067001',0.000000000,'1953-07-13','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5481,'BLAIS','MICHEL','1932-05-05','02.96.97.61.85','06.11.42.32.45',NULL,'','','','14600','GONNEVILLE SUR HONFLEUR',NULL,NULL,'2320514011001',3913.000000000,'1962-06-09','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5482,'HIMONT','PIERRE','1940-05-21',NULL,NULL,NULL,'20 av du soleil','','','14000','CAEN',NULL,NULL,'2400522282001',4.000000000,'1966-06-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5483,'LEFEVRE','CLAUDINE','1939-05-15','02.81.50.41.51','06.12.21.12.42',NULL,'38 le castellot avenue de las il','les','','14370','CANTELOUP',NULL,NULL,'1390514383001',27.000000000,'1969-09-02','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5484,'LESAGE','MICHEL','1937-06-09','02.52.20.42.95','06.26.77.89.94',NULL,'4 IMPASSE DES BLEUETS','','','14000','CAEN',NULL,NULL,'2370614707001',138.000000000,'1962-03-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5485,'TISON','NICOLE','1932-11-17','02.54.13.20.97','06.31.43.30.73',NULL,'10 rue du val richer','','','50660','ORVAL',NULL,NULL,'1321161052001',359.000000000,'1953-04-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5486,'BOLL','GEORGES','1932-06-01','02.80.97.80.68','06.10.00.40.56',NULL,'10 RUE HELENE BOSCHER','','','14800','TOUQUES',NULL,NULL,'1320650332001',1138.000000000,'1953-02-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5487,'GROUD','ANDREE','1958-01-15','02.11.59.63.45','06.18.04.15.51',NULL,'LOGEMENT 3 25 RUE PIERRE RENAU','DEL','','14150','OUISTREHAM',NULL,NULL,'2580114628001',85.000000000,'1980-05-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5488,'PLANQUETTE','ANNE-MARIE','1933-06-20','02.51.73.99.07','06.63.57.26.22',NULL,'72 RUE DU CENTRE','','','14000','CAEN',NULL,NULL,'1330614309001',526.000000000,'1962-09-06','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5489,'GUEROUARD','NADINE','1934-03-27','02.75.86.25.43','06.79.78.18.64',NULL,'6 RUE DU DR ROUX','','','14840','DEMOUVILLE',NULL,NULL,'1340314700001',293.000000000,'1961-05-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5490,'BEAUGEARD','JEANNE','1930-10-13','02.67.49.51.09','06.36.63.72.99',NULL,'2 CLOS DU MONASTERE','','','14610','EPRON',NULL,NULL,'2301014224001',347.000000000,'1954-12-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5491,'SZYMANSKI','JEAN PAUL','1930-09-24','02.13.07.81.64','06.13.05.10.31',NULL,'9 rue des bretons','','','14190','ST SYLVAIN',NULL,NULL,'2300914038001',2176.000000000,'1959-04-25','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5492,'CASAS','JANINE','1958-02-21','02.11.05.89.13','06.14.65.18.67',NULL,'53 RUE DU MOULIN A VOIDE','','','14630','FRENOUVILLE',NULL,NULL,'2580214114001',44.000000000,'1988-06-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5493,'LECOUTURIER','MARIE THERESE','1952-01-20','02.56.61.69.75','06.23.27.12.34',NULL,'CHEMIN DES VILLIERS','','','14460','COLOMBELLES',NULL,NULL,'1520114245001',108.000000000,'1977-12-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5494,'DECHAUFOUR','JOEL','1963-01-04','02.31.36.18.06','06.55.08.89.35',NULL,'20 RUE CHARLES  MERAUVEL','','','50410','PERCY',NULL,NULL,'1630114734001',55.000000000,'1993-10-16','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5495,'TABUTEAU','JACK','1930-12-17','02.44.38.56.44','06.69.46.59.14',NULL,'51 RUE DES CARRIERES','','','14100','LISIEUX',NULL,NULL,'1301214490001',282.000000000,'1951-12-03','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5496,'BEHUE','RENE','1937-10-15','02.65.49.05.88','06.61.72.98.30',NULL,'1 BD BELLEVUE','','','14000','CAEN',NULL,NULL,'1371050372001',140.000000000,'1959-07-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5497,'MARGERIE','CHANTAL','1942-03-01','02.34.14.24.84','06.34.67.49.87',NULL,'10 rue de la pomme d''or','','','14000','CAEN',NULL,NULL,'2420314068001',2796.000000000,'1966-05-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5498,'KARASIEWICZ','MICHELINE','1960-02-21','02.45.26.65.68','06.41.91.70.91',NULL,'13 place de l hotel de ville col','lombelles','','14700','VIGNATS',NULL,NULL,'1600214390001',45.000000000,'1984-06-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5499,'FORTIN','YVON','1968-06-22','02.90.13.97.76','06.37.92.63.89',NULL,'2 RUE DES PONTS','','','14980','ROTS',NULL,NULL,'1680614005001',1332.000000000,'1989-07-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5500,'GRUEL','YVES','1964-01-30','02.22.12.24.94','06.10.61.48.62',NULL,'','','','50480','RAVENOVILLE',NULL,NULL,'2640114437001',460.000000000,'1986-03-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5501,'FARCY','COLETTE','1958-10-12','02.12.13.89.08','06.10.33.07.86',NULL,'route de manerbe','','','14630','FRENOUVILLE',NULL,NULL,'1581014443001',7.000000000,'1983-07-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5502,'VIEL','albert','1936-08-23','02.85.27.54.40','06.59.15.13.11',NULL,'2 rue Andr Gide','','','14120','MONDEVILLE',NULL,NULL,'1360814660001',428.000000000,'1964-12-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5503,'BIDAULT','CHRISTIAN','1967-05-19','02.29.43.53.64','06.11.27.20.64',NULL,'3 RUE LE NOTRE','','','14320','FONTENAY LE MARMION',NULL,NULL,'1670514197001',5.000000000,'1989-04-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5504,'JOUAN','MARCELLINE','1920-03-22','02.39.19.74.04',NULL,NULL,'LE CHENE SEC VILLAGE PERTHEVILL','E NERS','','14220','ST LAURENT DE CONDEL',NULL,NULL,'1200376093001',22.000000000,'1941-11-07','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5505,'JUMEL','CHRISTIANE','1936-10-20','02.15.65.45.46','06.49.84.13.85',NULL,'IMPASSE DES JARDINS','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1361014398001',329.000000000,'1965-02-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5506,'GIBERT','REMY','1931-07-09','02.10.70.90.04','06.78.85.52.21',NULL,'19 rue du bois de lilles','','','14123','IFS',NULL,NULL,'2310714288001',68.000000000,'1954-05-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5507,'CAZZARINI','FERNAND','1939-08-21','02.30.44.93.66','06.84.71.94.54',NULL,'2 impasse marlaud','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1390814432001',8.000000000,'1962-01-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5508,'HOUYVET','JEAN MARIE','1940-11-24','02.30.55.40.27','06.77.61.90.54',NULL,'5 ROUTE DU VIGOUREUX','','','14000','CAEN',NULL,NULL,'2401114114001',794.000000000,'1965-03-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5509,'LETALLEC','DENISE','1937-07-23','02.24.43.44.87','06.24.19.27.66',NULL,'1 rue roger dechambre','','','14160','DIVES SUR MER',NULL,NULL,'1370714271001',569.000000000,'1961-12-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5510,'MOUTARD','NOUR NEMA','1964-10-15','02.14.49.64.41','06.90.51.95.02',NULL,'15 rue des rosiers','','','14190','ST SYLVAIN',NULL,NULL,'1641014254001',1471.000000000,'1989-06-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5511,'DELAUNE','GISELE','1932-10-13','02.81.23.89.87','06.73.92.95.65',NULL,'2 ET 4 AVENUE DE PARIS','','','14930','VIEUX',NULL,NULL,'1321014246001',109.000000000,'1956-08-17','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5512,'BLOT','BERNARD','1943-07-14','02.16.21.83.33','06.12.17.48.34',NULL,'1 RUE DE LA FONTAINE','','','14000','CAEN',NULL,NULL,'1430761197001',1.000000000,'1965-11-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5513,'MABIRE','DANIEL','1958-01-13','02.86.20.90.07','06.49.91.33.78',NULL,'2 BD DES VIOLETTES','','','14113','VILLERVILLE',NULL,NULL,'2580114628001',32.000000000,'1984-05-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5514,'GALLIENNE','PIERRE','1966-06-29','02.18.94.78.01','06.21.30.86.76',NULL,'7 RUE PORTE MILLET LES PETITES S','OEUR DES PAUVRES','','14160','DIVES SUR MER',NULL,NULL,'2660614194001',8.000000000,'1987-09-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5515,'TISON','PIERRE','1928-08-18','02.78.11.97.52','06.82.80.69.27',NULL,'RUE LOUISE MICHEL','','','14000','CAEN',NULL,NULL,'1280862652001',235.000000000,'1957-07-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5516,'EUDET','MARIELAURE','1934-12-15','02.29.90.50.79','06.12.03.80.99',NULL,'5 RUE DE FONTAINE','','','14000','CAEN',NULL,NULL,'1341227238001',184.000000000,'1957-06-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5517,'BADIE','FRANCOISE','1935-11-13','02.23.18.72.48','06.88.20.09.10',NULL,'157 RUE BASSE','','','14370','BISSIERES',NULL,NULL,'1351114749001',212.000000000,'1962-02-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5518,'BROUTE','ANDRE','1938-07-06','02.11.66.40.54','06.11.09.96.31',NULL,'4 route de giberville','','','14123','IFS',NULL,NULL,'2380714262001',69.000000000,'1960-12-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5519,'NADIRADZE','patrice','1962-01-15','02.21.63.60.48','06.65.43.49.23',NULL,' rue denis diderot1','','',NULL,NULL,NULL,NULL,'2620114288001',4.000000000,'1988-03-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5520,'COME','PAULETTE','1938-05-23',NULL,NULL,NULL,'14-03 RUE DU BOIS  LE PLATEAU','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1380514355001',244.000000000,'1959-01-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5521,'BONHOMME','LILIANE','1943-02-18','02.33.07.64.16','06.66.40.68.55',NULL,'5 ROUTE DE CREULLY','','','14000','CAEN',NULL,NULL,'1430202182001',21.000000000,'1968-11-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5522,'TINARD','NICOLE','1936-09-07','02.10.05.52.03','06.54.11.67.97',NULL,'LA DOUBLERIE','','','14680','CINTHEAUX',NULL,NULL,'2360914100001',484.000000000,'1963-05-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5523,'BAAZIZ','GERMAIN','1948-07-07','02.12.28.67.66','06.43.84.81.58',NULL,'RESIDENCE MATINES 29 RUE RICHAR','D LENOIR','',NULL,NULL,NULL,NULL,'1480714093001',757.000000000,'1972-07-25','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5524,'HOMMET','ROLAND','1932-05-14','02.68.46.60.75','06.43.43.29.72',NULL,'12 RUE DUMONT D''URVILLE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2320533243001',36.000000000,'1957-03-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5525,'BRICE','THRSE','1936-10-09','02.11.89.90.63','06.24.99.36.40',NULL,'DRUBEC','','','14650','CARPIQUET',NULL,NULL,'2361014310001',308.000000000,'1961-01-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5526,'BARTHELAT','CLAUDINE','1931-01-23','02.31.33.92.06','06.26.01.90.91',NULL,'LA MOTTE','','','50480','STE MERE EGLISE',NULL,NULL,'1310114100001',196.000000000,'1956-04-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5527,'LEGAILLARD','GERARD','1942-06-14','02.75.28.32.68','06.64.47.97.11',NULL,'26 RUE  D'' ARROMANCHES','','','14670','TROARN',NULL,NULL,'2420650054001',13.000000000,'1965-11-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5528,'DESERABLE','MUGUETTE','1943-02-06','02.90.17.22.56','06.68.33.04.84',NULL,'10 BOUT BASSET','','','14670','TROARN',NULL,NULL,'1430214155001',91.000000000,'1966-12-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5529,'CHENEVARIN','JOSIANE','1936-10-09','02.12.04.43.35','06.60.38.52.88',NULL,'12 RUE DU BLANC','','','50000','ST LO',NULL,NULL,'2361050021001',299.000000000,'1963-05-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5530,'LEMOINE','BERNARD','1948-01-09','02.89.36.23.69','06.35.46.29.17',NULL,'15 PLACE DE LA DEMI LUNE BAT/','A','','14370','MOULT',NULL,NULL,'2480150193001',832.000000000,'1971-12-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5531,'POUSSET','MARIE THERESE','1958-05-25','02.82.66.09.34','06.66.02.36.16',NULL,'205 RUE SAINT JEAN','','','14540','HUBERT FOLIE',NULL,NULL,'2580514071001',8.000000000,'1981-09-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5532,'LALANDE','SOLANGE','1940-09-13','02.15.49.47.02','06.72.04.76.45',NULL,'4 RUE HENRI 1ER BEAUCLAIR','','','14650','CARPIQUET',NULL,NULL,'1400914278001',114.000000000,'1961-06-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5533,'LEGOUBIN','J-MICHEL','1957-04-11','02.66.12.53.96','06.89.08.47.57',NULL,'LA VICTOIRE','','','14120','MONDEVILLE',NULL,NULL,'2570414166001',120.000000000,'1987-05-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5534,'LECHAT','ODETTE','1966-02-04','02.18.68.04.00','06.11.28.81.81',NULL,'6 RUE DES CARRIERES','','','14123','IFS',NULL,NULL,'1660214675001',25.000000000,'1988-05-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5535,'PIAT','MARIE FRAN','1936-10-13','02.35.02.02.68','06.41.59.52.61',NULL,'LIEU DE VERVEND','','','14000','CAEN',NULL,NULL,'1361014566001',14.000000000,'1958-04-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5536,'HOUEIX','JEAN','1936-09-14','02.12.06.56.63','06.39.79.23.43',NULL,'22 RUE DE BEAUVOIR','','','14123','FLEURY SUR ORNE',NULL,NULL,'2360961463001',78.000000000,'1963-07-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5537,'HUGUET','GISELE','1948-10-22','02.22.99.55.66','06.37.84.71.52',NULL,'HAMEAU DE SAINT  CLAIR','','','14123','FLEURY SUR ORNE',NULL,NULL,'2481014118001',311.000000000,'1974-01-18','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5538,'DEBAIZE','MICHEL','1931-02-17','02.47.23.56.87','06.71.32.09.42',NULL,'1 rue Cardinal Lavigerie grace d','e Dieu','','61170','ST AGNAN SUR SARTHE',NULL,NULL,'1310256075001',690.000000000,'1956-02-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5539,'GUILLEMETTE','PHILIPE',NULL,'02.78.07.16.96','06.63.44.67.17',NULL,'D 48','','','14280','AUTHIE',NULL,NULL,'1631299253001',3116.000000000,'2013-05-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5540,'NIO','CLAUDE','1955-01-24','02.37.97.73.47','06.49.48.57.58',NULL,'13/1 RUE CENTRAL PROLONGE','','','14000','CAEN',NULL,NULL,'1550150292001',382.000000000,'1976-05-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5541,'NICOLLE','yolande','1954-01-20','02.28.87.39.56','06.50.76.03.68',NULL,'1549 rue de bretteville','','','14940','SANNERVILLE',NULL,NULL,'2540199255001',84.000000000,'1980-06-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5542,'MARIE','GERARD','1937-06-09','02.85.62.11.71','06.86.68.67.25',NULL,'81 AVENUE JEAN JAURES','','','14000','CAEN',NULL,NULL,'1370614170001',223.000000000,'1960-09-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5543,'HEBERT','SOLANGE','1934-09-21','02.14.18.48.46','06.75.68.40.43',NULL,'7 rue Edmond Raphal','','','14110','CONDE SUR NOIREAU',NULL,NULL,'2340914209001',3228.000000000,'1961-11-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5544,'LOYAUX','MICHELLE','1955-08-10','02.19.17.92.68','06.92.50.89.77',NULL,'rue des agrions hameau de bussy','','','14700','FALAISE',NULL,NULL,'2550814123001',29.000000000,'1977-12-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5545,'ROUSSEL','SYLVIE','1935-04-18','02.10.98.44.92','06.14.90.24.07',NULL,'5 RUE JEAN JAURES','','','14000','CAEN',NULL,NULL,'2350414727001',86.000000000,'1958-01-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5546,'JOSEPHINE','','1978-03-14','02.85.41.07.00','06.10.38.93.88',NULL,'2 rue cardina lavigerie','','',NULL,NULL,NULL,NULL,'2780375120001',7.000000000,'2002-04-02','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5547,'HAMEL','','1940-10-21','02.93.53.21.99','06.89.55.20.38',NULL,'1 rue henry cauchet','','','61200','ARGENTAN',NULL,NULL,'1401014538001',90.000000000,'1963-01-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5548,'KROB','GINETTE','1931-05-25','02.52.72.92.08','06.25.77.32.61',NULL,'8 rue du calvaire','','',NULL,NULL,NULL,NULL,'1310586193001',1101.000000000,'1955-03-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5549,'BOUTETTE','PIERRE','1936-01-11','02.34.93.54.75','06.11.73.69.60',NULL,'18 GD RUE','','','14740','ST MANVIEU NORREY',NULL,NULL,'1360114612001',13.000000000,'1962-12-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5550,'FORTIN','MICHEL','1932-11-02','02.10.91.35.70','06.46.98.37.50',NULL,'23 rue de bonn appt r2','','','14400','BAYEUX',NULL,NULL,'2321114093001',10.000000000,'1961-02-22','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5551,'CARPENTIER','NADINE','1936-08-30','02.18.48.88.03','06.48.03.78.82',NULL,'13  place de la mairie app18','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'2360861339001',347.000000000,'1958-06-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5552,'LE SOMPTIER','FRANCOISE','1933-08-13','02.27.38.91.04','06.60.34.79.30',NULL,'17 RUE DU MUGUET','','','14730','GIBERVILLE',NULL,NULL,'2330814101001',79.000000000,'1963-10-12','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5553,'DUPUIS','claude',NULL,'02.70.27.93.55','06.20.52.35.43',NULL,'4 rue laplace','','','14860','RANVILLE',NULL,NULL,'1380514076001',143.000000000,'2012-12-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5554,'FOYER','CHARLOTTE','1930-10-08','02.90.92.41.43','06.98.33.60.92',NULL,'7 bis venel cauvet','','','14860','RANVILLE',NULL,NULL,'1301014221001',16.000000000,'1951-02-18','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5555,'JEANNE','FERNAND',NULL,'02.26.69.58.38','06.96.67.17.56',NULL,'7 rue robert letellier','','','14510','HOULGATE',NULL,NULL,'2431114031001',27.000000000,'2012-08-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5556,'DESETABLE','ALINE','1931-07-13','02.37.40.41.68','06.71.26.50.41',NULL,'9 rue gandhi','','','14460','COLOMBELLES',NULL,NULL,'1310714439001',164.000000000,'1954-11-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5557,'MONDET','NICOLE','1934-01-06','02.64.42.04.52','06.83.31.14.34',NULL,'25 LIEU DIT"LE COUDRAY"','','','14630','FRENOUVILLE',NULL,NULL,'2340150110001',42.000000000,'1957-06-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5558,'BARSZCZ','JEAN','1930-06-15','02.31.18.86.53','06.41.99.68.74',NULL,'23 ROUTE DE ROBILLARD','','','14111','LOUVIGNY',NULL,NULL,'1300614132001',55.000000000,'1954-01-08','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5559,'MERIOTTE','GEORGES','1939-09-23','02.25.59.99.71','06.64.61.78.16',NULL,'10 rue des champs st martin','','','14220','GRIMBOSQ',NULL,NULL,'1390914311001',265.000000000,'1963-08-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5560,'CHEVALIER','EDOUARD',NULL,'02.82.08.56.95','06.81.86.06.53',NULL,'6 RUE DES BOULEAUX','','','14000','CAEN',NULL,NULL,'2540214697001',250.000000000,'2010-12-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5561,'THOMAS','philippe','1937-07-28','02.16.34.55.07','06.77.03.89.72',NULL,'','','','14730','GIBERVILLE',NULL,NULL,'1370714449001',34.000000000,'1959-06-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5562,'SANCHEZ ACUNA','','1928-02-14','02.26.67.61.00','06.75.48.30.33',NULL,'27 PLACE DU MARECHAL LECLERC','','','50400','GRANVILLE',NULL,NULL,'2280214479001',1.000000000,'1950-04-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5563,'DURAND','EDITH','1936-09-04','02.98.69.87.91','06.93.03.00.80',NULL,'LE LIEU DIT"LA ROUTE"','','',NULL,NULL,NULL,NULL,'1360914061001',34.000000000,'1966-05-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5564,'DURAND','LUCIENNE','1932-12-31','02.25.30.07.26','06.62.89.07.29',NULL,'15 route de la gueriniere app 14','','','50630','QUETTEHOU',NULL,NULL,'2321214275001',455.000000000,'1954-07-23','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5565,'BACHELOT','JEANNE','1945-06-23','02.98.27.70.17','06.73.85.19.99',NULL,'25 RUE HENRI BRUNET','','','14150','OUISTREHAM',NULL,NULL,'1450614324001',276.000000000,'1967-10-19','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5566,'LETONNELIER','REMY','1965-06-07','02.31.89.47.19','06.10.63.79.90',NULL,'12 rue de la fontaine','','','14120','MONDEVILLE',NULL,NULL,'1650614044001',2331.000000000,'1990-01-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5567,'POIRIER','ALAIN','1919-09-13','02.36.86.18.32','06.75.94.60.71',NULL,'26. rue du petit bonheur','','','14123','FLEURY SUR ORNE',NULL,NULL,'1190914119001',344.000000000,'1946-09-21','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5568,'GAILLARD','JEANNE','1935-07-18','02.99.39.07.17','06.93.37.26.92',NULL,'27. rue urbain cardon','','',NULL,NULL,NULL,NULL,'2350714011001',3677.000000000,'1962-08-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5569,'LEU','CLAUDE','1934-01-16','02.11.29.92.00','06.11.19.08.06',NULL,'19 LE BOURG','','','14850','ESCOVILLE',NULL,NULL,'1340177478001',9.000000000,'1958-06-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5570,'TOUTAIN','CLAUDE',NULL,'02.32.51.77.05','06.50.60.34.45',NULL,'5 RUE DE LA CONCORDE','','','14123','IFS',NULL,NULL,'1390114452001',314.000000000,'2008-10-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5571,'DRIEU','MICHELE','1962-10-25','02.24.08.00.31','06.81.36.38.24',NULL,'13 RUE DU 11 NOVEMBRE','','','14150','OUISTREHAM',NULL,NULL,'1621075117001',210.000000000,'1988-04-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5572,'JEANNE','ANNICK','1934-10-14','02.73.42.85.39','06.30.61.40.07',NULL,'12 RUE MOZART','','','14000','CAEN',NULL,NULL,'1341014118001',254.000000000,'1960-12-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5573,'LEGENDRE','JEANNE','1959-01-06','02.87.55.79.96','06.67.53.89.39',NULL,'','','',NULL,NULL,NULL,NULL,'1590114090001',39.000000000,'1986-07-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5574,'PERRETTE','claude','1930-04-03','02.11.11.97.44','06.11.20.39.07',NULL,'chemin de la tallerie','','','14320','FONTENAY LE MARMION',NULL,NULL,'1300414659001',32.000000000,'1953-11-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5575,'PICHON','JEAN PAUL','1945-01-15','02.44.96.59.27','06.91.17.18.85',NULL,'13 RUE DES PREMONTRES','','','14123','IFS',NULL,NULL,'1450118098001',341.000000000,'1973-08-20','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5576,'GAUCHARD','SUZANNE','1937-12-15','02.11.50.62.56','06.37.86.56.97',NULL,'12 RUE CAMILLE BLAISOT','','','14670','TROARN',NULL,NULL,'2371277157001',788.000000000,'1961-01-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5577,'','MAURICETTE','1966-02-23','02.44.30.54.54','06.59.03.58.33',NULL,'12 IMPASSE DU PEINTRE','','','14460','COLOMBELLES',NULL,NULL,'1660214657001',44.000000000,'1996-09-10','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5578,'SABINE','DANIEL','1938-02-09','02.19.04.55.11','06.47.14.86.25',NULL,'1 IMPASSE DE CUSSY','','','61300','L''AIGLE',NULL,NULL,'2380214328001',6.000000000,'1968-06-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5579,'BERNIER','DANIEL','1935-08-20','02.30.93.11.91','06.70.41.51.87',NULL,'','','','50400','GRANVILLE',NULL,NULL,'1350861110001',256.000000000,'1962-10-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5580,'LAIGUEDE','veronique','1943-01-15','02.57.29.21.46','06.24.38.01.81',NULL,'101 rue du chemin vert','','','14400','ST LOUP HORS',NULL,NULL,'1430114618001',328.000000000,'1973-05-13','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5581,'LEMARCHAND','MICHEL','1950-01-15','02.97.02.95.39','06.28.39.23.46',NULL,'LE BOURG','','','14850','HEROUVILLETTE',NULL,NULL,'1500161387001',29.000000000,'1972-02-26','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5582,'LECARPENTIER','FRANCOIS','1944-12-17','02.66.89.34.11','06.13.57.70.18',NULL,'ROUTE DE ST PIERRE S/DIVES','','','50100','CHERBOURG',NULL,NULL,'2441214237001',80.000000000,'1966-12-03','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5583,'FONS','CHARLOTTE','1929-01-06','02.12.92.08.96','06.44.00.15.45',NULL,'20 RUE DES PETITS FOSSES','','','14860','BAVENT',NULL,NULL,'2290114329001',133.000000000,'1953-05-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5584,'LE MERCIER','SERGE','1929-04-25','02.90.19.26.82','06.10.00.32.40',NULL,'17 BOULEVARD DE RETHEL','','','14350','BENY BOCAGE',NULL,NULL,'1290472386001',39.000000000,'1956-06-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5585,'BOURGUAIS','MARTINE','1931-07-18','02.11.52.68.77','06.33.96.03.58',NULL,'5 chemin du commandant de touche','t','','14340','LE PRE D''AUGE',NULL,NULL,'2310750640001',248.000000000,'1953-10-11','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5586,'LETELLIER','JOSETTE','1939-06-24','02.10.92.77.11','06.83.97.17.73',NULL,'6 AVENUE DU PARC','','','14400','RYES',NULL,NULL,'1390663040001',1984.000000000,'1960-02-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5587,'GRARD','REGINE','1929-08-02','02.76.28.38.93','06.50.77.25.20',NULL,'4 RUE DENNEVILLE','','','14620','LES MOUTIERS EN AUGE',NULL,NULL,'1290875045001',26.000000000,'1956-09-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5588,'VIVIER','MARIE-CLAIRE','1968-01-29','02.55.44.60.58','06.58.62.78.09',NULL,'5 chemin du commandant de touche','t','','14000','CAEN',NULL,NULL,'2680114327001',940.000000000,'1990-08-16','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5589,'JAMES','BERNARD','1970-03-15','02.20.95.70.11','06.64.03.14.64',NULL,'6 RUE DE LA MUTUALITe','','','61500','LE CERCUEIL',NULL,NULL,'2700380570001',2464.000000000,'1992-01-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5590,'MARY DIT CORDIER','ANDRE','1932-09-18','02.37.61.08.28','06.58.98.46.64',NULL,'31 RUE CLAUDE CHAPPE','','','14840','DEMOUVILLE',NULL,NULL,'1320914302001',1304.000000000,'1956-01-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5591,'HUBERT','PIERRE','1930-02-22','02.10.89.70.88','06.60.67.44.23',NULL,'LE FOU COUPE','','',NULL,NULL,NULL,NULL,'2300214506001',33.000000000,'1953-12-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5592,'ROUPIE','HENRI','1931-12-07','02.62.91.12.45','06.73.54.58.18',NULL,'3 RUE DU CHATEAU D''EAU','','','14800','DEAUVILLE',NULL,NULL,'2311261343001',206.000000000,'1959-09-10','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5593,'CARRE','RACHEL','1937-09-12','02.71.17.75.40','06.40.90.62.49',NULL,'17 RUE DU BOIS PERROTTE','','','14730','GIBERVILLE',NULL,NULL,'1370959230001',1838.000000000,'1966-02-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5594,'BOURRIENNE','JACQUELINE','1931-10-01','02.12.32.04.83','06.71.34.33.98',NULL,'11 LOTISSEMENT DU MANOIR','','','14120','MONDEVILLE',NULL,NULL,'2311014371001',77.000000000,'1952-01-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5595,'HERBLINE','NICOLLE','1935-10-16','02.77.91.45.53','06.53.77.13.54',NULL,'4 ALLEE ALFRED JARRY','','','50620','ST JEAN DE DAYE',NULL,NULL,'1351014384001',62.000000000,'1957-02-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5596,'PHILIPPE','CLAUDE','1932-07-17','02.76.52.34.10','06.47.50.59.44',NULL,'12 rue des coteaux','','','14460','COLOMBELLES',NULL,NULL,'2320714599001',95.000000000,'1955-01-05','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5597,'DAVID','therese','1952-01-23','02.55.40.70.06','06.48.33.40.16',NULL,'17 RUE DE BOURGOGNE','','','14600','LA RIVIERE ST SAUVEUR',NULL,NULL,'2520114736001',1225.000000000,'1976-01-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5598,'DEVASSY','MARIE-JEANNE',NULL,'02.26.18.11.63','06.64.18.30.31',NULL,'22 rue du berry','','','14710','TREVIERES',NULL,NULL,'2580372284001',154.000000000,'2010-06-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5599,'HERAUD','MARCELLE','1932-11-26','02.17.65.62.07','06.18.75.39.45',NULL,'7 RUE GUSTAVE FLAUBERT','','','14000','CAEN',NULL,NULL,'1321114695001',23.000000000,'1960-12-01','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5600,'LEFRANCOIS','GERARD','1934-04-21','02.34.40.28.72','06.57.89.94.43',NULL,'1 place de la liberte','','','14000','CAEN',NULL,NULL,'1340450389001',1.000000000,'1958-06-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5601,'VERGER','michel','1931-03-13','02.60.82.57.35','06.85.31.76.60',NULL,'7 rue des anciens d''afn','','','14120','MONDEVILLE',NULL,NULL,'2310314140001',66.000000000,'1956-06-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5602,'MORIN','BERNARD','1938-10-18','02.30.87.84.43','06.72.38.30.86',NULL,'5 rue de langelus','','','14480','LE FRESNE CAMILLY',NULL,NULL,'2381014666001',78.000000000,'1962-07-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5603,'NORMAND','ISABELLE','1930-07-31','02.22.61.10.76','06.54.87.89.35',NULL,'21 ALLEE DES CHARMES','','','14670','TROARN',NULL,NULL,'2300778210001',408.000000000,'1952-05-02','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5604,'GARNIER','FRANCOISE','1956-01-03','02.29.71.33.01','06.60.96.50.79',NULL,'11 RUE ROYALE','','','14730','GIBERVILLE',NULL,NULL,'2560114610001',197.000000000,'1983-09-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5605,'LEBRETON','FABIEN','1961-01-10','02.10.59.45.35','06.91.86.44.56',NULL,'8 rue bruyere','','','14123','IFS',NULL,NULL,'1610133209001',649.000000000,'1982-08-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5606,'TRIPON','RENE','1950-01-26','02.26.89.26.73','06.45.60.10.69',NULL,'39  RUE DE LA BUTTE AUX LOUPS','','','14630','FRENOUVILLE',NULL,NULL,'1500114225001',24.000000000,'1973-04-18','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5607,'MESLIN','FERNAND','1934-01-26','02.50.54.36.72','06.11.99.32.10',NULL,'1416 rue de l aquilon','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1340114124001',378.000000000,'1955-07-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5608,'CHAMPION','BERNADETTE','1928-02-23','02.73.23.51.50','06.40.25.55.21',NULL,'LE BOURG  RUE PRINCIPALE','','',NULL,NULL,NULL,NULL,'2280214118001',97.000000000,'1951-04-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5609,'LEDOLLEY','JEANNINE','1931-04-06','02.65.35.58.96','06.26.25.84.71',NULL,'8 rue de la motte','','',NULL,NULL,NULL,NULL,'2310414474001',28.000000000,'1954-02-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5610,'GAUQUELIN','ODETTE','1969-03-21','02.96.43.27.19','00 33 6.49.63.11.22',NULL,'11 AVENUE DES CHEVALIERS','','','27580','CHAISE DIEU DU THEIL',NULL,NULL,'1690314525001',1184.000000000,'1993-07-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5611,'POTEL','DANIELLE','1938-08-04','02.59.41.11.31','06.10.25.02.36',NULL,'RESIDENCE PLEIN CIEL  25 BD RICH','EMOND','','50880','PONT HEBERT',NULL,NULL,'2380814243001',41.000000000,'1959-01-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5612,'AUVRAY','JEAN','1931-07-06','02.74.15.63.02',NULL,NULL,'3 RESIDENCE MADAME DE SEGURE','','','14670','JANVILLE',NULL,NULL,'2310750587001',527.000000000,'1954-08-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5613,'DUPONT','MICHEL','1938-07-13','02.10.16.22.30','06.91.76.80.06',NULL,'19 RUE FROIDE','','','14850','ESCOVILLE',NULL,NULL,'1380714657001',51.000000000,'1967-04-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5614,'SUARD','JACQUES','1941-01-05','02.89.12.79.27','06.34.59.34.64',NULL,'hameau rupirre','','','14460','COLOMBELLES',NULL,NULL,'2410177226001',628.000000000,'1966-09-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5615,'GRENET','CHRISTIANE',NULL,'02.27.29.90.10','06.85.23.23.96',NULL,'19 rue goujarde','','','14170','JORT',NULL,NULL,'1680414422001',154.000000000,'2011-01-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5616,'HUARD','MARIE-THERESE','1950-01-13','02.31.62.38.26','06.97.57.04.42',NULL,'','','',NULL,NULL,NULL,NULL,'1500150147001',319.000000000,'1971-12-17','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5617,'VALLEE','GUY','1934-09-17','02.22.36.76.95','06.47.70.81.17',NULL,'11 rue du calendrier','','','14100','OUILLY LE VICOMTE',NULL,NULL,'2340927130001',42.000000000,'1956-04-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5618,'LEROUGE','Francis lissette','1936-06-11','02.62.42.95.19','06.73.47.82.97',NULL,'13 RUE ALBERT CAMUS','','','14730','GIBERVILLE',NULL,NULL,'1360650446001',107.000000000,'1957-07-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5619,'COQ','DENIS','1934-02-24','02.65.06.27.39','06.53.97.28.05',NULL,'2 ALLEE DU GENERAL SISMONDS','','','14000','CAEN',NULL,NULL,'1340214338001',53.000000000,'1962-02-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5620,'COURVAL','Francoise','1928-04-22','02.82.50.89.54','06.32.91.75.80',NULL,'36 RUE EDOUARD VAILLANT','','','14700','PERTHEVILLE NERS',NULL,NULL,'2280414727001',144.000000000,'1958-03-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5621,'ALFRED','ESTHER','1934-08-22','02.11.08.73.59','06.40.95.99.69',NULL,'5 RUE ALBERT FRILLEY','','','14260','AUNAY SUR ODON',NULL,NULL,'2340814114001',260.000000000,'1956-08-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5622,'STEPHAN','BERNARD','1931-08-21','02.79.14.90.75','06.52.48.51.47',NULL,'31 RUE DU GENERAL LECLERC','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'1310814173001',126.000000000,'1955-02-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5623,'LEBRUN','GUY','1928-12-17','02.29.75.70.79','06.20.83.72.02',NULL,'15 ROUTE DE LA GUERINIERE','','','14120','MONDEVILLE',NULL,NULL,'1281214020001',33.000000000,'1954-03-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5624,'BOUSSELET','FRANCOISE','1948-07-04','02.20.10.70.74',NULL,NULL,'8 impasse des victimes civils','','','14420','USSY',NULL,NULL,'1480714093001',1317.000000000,'1972-03-21','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5625,'NORMAND','MICHEL','1944-03-11','02.58.40.69.43','06.13.70.27.98',NULL,'1 RUE DE LA HAUTE ECARDE','','',NULL,NULL,NULL,NULL,'1440314037001',270.000000000,'1968-08-28','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5626,'DESSOUDE','ERIC','1932-09-09','02.49.01.20.42','06.63.70.99.69',NULL,'8 imp des bleuets','','','14000','CAEN',NULL,NULL,'2320914465001',3668.000000000,'1956-01-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5627,'LE HIR','GUY','1951-01-05','02.66.21.73.20','06.45.52.04.76',NULL,'41 ave du 6 juin','','','14000','CAEN',NULL,NULL,'2510114209001',19.000000000,'1976-08-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5628,'LAMOTTE','PHILIBERT','1928-05-23','02.81.25.72.60','06.92.28.08.99',NULL,'HAMEAU DE JOUETTE','','','14450','GRANDCAMP MAISY',NULL,NULL,'1280514220001',617.000000000,'1958-11-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5629,'ONFRAY','MICHEL','1929-12-14','02.59.59.14.68','06.75.89.33.30',NULL,'','','','14700','FALAISE',NULL,NULL,'2291214685001',55.000000000,'1958-02-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5630,'MARIE','RENE','1938-04-23','02.37.89.60.33','06.64.33.92.35',NULL,'19 rue val es dunes','','','14123','IFS',NULL,NULL,'2380427170001',357.000000000,'1959-03-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5631,'DESLANDES','LYDIE','1936-09-04','02.50.35.92.32','06.43.16.46.48',NULL,'19 avenue pere charles de foucau','ld res le pres','','14400','NONANT',NULL,NULL,'1360985227001',50.000000000,'1961-11-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5632,'BAUDAIN','SYLVIANE','1931-08-31','02.82.44.91.78','06.10.64.09.21',NULL,'LE BOURG BEAUQUEY','','','14220','THURY HARCOURT',NULL,NULL,'2310814157001',881.000000000,'1953-05-14','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5633,'ALLAIRE','michel','1940-09-13','02.77.54.76.23','06.63.16.07.82',NULL,'','','','14670','ST PAIR',NULL,NULL,'1400914346001',33.000000000,'1970-01-20','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5634,'TOURET','RENEE','1952-01-13','02.46.25.16.46','06.18.25.11.56',NULL,'2 ALLEE DU GENERAL SIMON','','','14120','MONDEVILLE',NULL,NULL,'1520114290001',112.000000000,'1977-08-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5635,'THOMASSE','JEAN PIERRE','1917-09-17','02.51.41.47.26','06.34.20.56.52',NULL,'18 rue st andre','','','14310','VILLERS BOCAGE',NULL,NULL,'2170942139001',602.000000000,'1941-12-14','PLATINIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5636,'LECOQ','claude','1947-01-08','02.55.32.22.46','06.84.61.95.84',NULL,'9 PLACE DE MARILLAC','','','14000','CAEN',NULL,NULL,'2470127196001',101.000000000,'1969-07-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5637,'DUPOUVOIR','YVES','1928-06-06','02.63.26.23.13','06.61.24.77.03',NULL,'34 RUE LOUIS PASTEUR','','','50140','ROMAGNY',NULL,NULL,'2280614254001',103.000000000,'1950-10-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5638,'GUILLOT','MICHEL','1929-09-01','02.26.67.71.61','06.53.42.67.18',NULL,'5 RUE MAJOR FULTON','','','50140','ROMAGNY',NULL,NULL,'1290914063001',100.000000000,'1953-01-01','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5639,'LEGALLOIS','JACQUELINE','1935-06-24','02.24.63.92.94','06.52.59.18.35',NULL,'25 rue montgolfier','','','14320','MAY SUR ORNE',NULL,NULL,'2350614030001',5.000000000,'1961-09-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5640,'TOMAS','PATRICIA','1939-06-23','02.69.20.81.33','06.54.80.92.41',NULL,'19 place du 18 juillet','','','14630','CAGNY',NULL,NULL,'1390650507001',279.000000000,'1964-02-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5641,'MARIE','HERVE','1934-12-28','02.10.94.68.55','06.29.67.49.62',NULL,'36 RUE DU CENTRE','','',NULL,NULL,NULL,NULL,'1341277070001',2.000000000,'1963-01-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5642,'LECOQ','JACQUES','1934-02-01','02.59.05.45.60','06.37.31.73.34',NULL,'8 ALLEE DU BOIS','','','14540','BOURGUEBUS',NULL,NULL,'2340214388001',162.000000000,'1957-04-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5643,'DERSOIR','PASCAL','1928-03-01','02.65.49.39.36','06.27.58.92.65',NULL,'RESIDENCE CHEVERNY   13 BIS RUE','DU DR MICHEL','','14000','CAEN',NULL,NULL,'2280350039001',1746.000000000,'1958-11-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5644,'LECLERC','JANINE','1936-02-13','02.87.03.34.51','06.62.36.79.33',NULL,'5 RUE DU CHAPEAU','','','14123','FLEURY SUR ORNE',NULL,NULL,'2360214039001',1658.000000000,'1962-05-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5645,'BIHEL','SIMONE','1940-09-03','02.21.04.43.13','06.11.58.37.39',NULL,'38 RUE NATIONALE','','','86140','SCORBE CLAIRVAUX',NULL,NULL,'2400914406001',121.000000000,'1966-06-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5646,'GDOWSKI','BERNARD','1948-03-07','02.94.34.52.63','06.35.45.33.40',NULL,'8 rue du village','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'2480314019001',152.000000000,'1969-12-14','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5647,'PORET','NICOLE','1931-08-27','02.79.08.81.14','06.33.21.91.68',NULL,'544 rue du chemin vert','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'1310850033001',29.000000000,'1954-08-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5648,'GISZLER','CYRILLE','1937-01-05','02.25.16.63.90','06.12.16.92.65',NULL,'14 rue des jardins','','','14830','LANGRUNE SUR MER',NULL,NULL,'2370114422001',59.000000000,'1961-02-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5649,'LANGEVIN','MARCEL','1956-02-13','02.36.81.56.30','06.75.26.58.59',NULL,'18 av pere ch de foucault','','','14000','CAEN',NULL,NULL,'2560214118001',37.000000000,'1986-04-30','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5650,'BAZILE','MICHELE','1948-06-10','02.25.25.37.09','06.58.52.10.37',NULL,'1 route de secny aux vignes','','','50820','COUVILLE',NULL,NULL,'1480614274001',268.000000000,'1971-06-14','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5651,'STEINMETZ','MAURICE','1929-03-09','02.82.82.10.39','06.36.21.96.39',NULL,'MONTCHAMP LE BOURG','','','14210','ESQUAY NOTRE DAME',NULL,NULL,'1290314390001',27.000000000,'1959-04-28','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5652,'DESMEZIERES','BERNARD','1928-07-21','02.79.08.02.34','06.68.40.86.40',NULL,'9 RUE DE LA MONTAGNE','','','14790','VERSON',NULL,NULL,'1280776672001',83.000000000,'1949-07-05','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5653,'MELANIE','BERNARD','1937-06-12','02.16.69.80.70','06.12.31.17.76',NULL,'140 RUE BRANVILLE','','','14570','T_ADHERENGIBERVILLET_ADR',NULL,NULL,'2370650111001',31.000000000,'1959-06-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5654,'RATERO-MARTIN','PIERRETTE','1936-04-03','02.10.94.98.63','06.98.29.83.69',NULL,'23 RUE ANATOLE FRANCE','','','50320','GIBERVILLE',NULL,NULL,'2360450548001',699.000000000,'1961-07-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5655,'THIERRY','ERIC','1933-01-06','02.24.27.32.56','06.56.62.64.02',NULL,'3 RUE DU GENERAL LECLERC','','','14123','IFS',NULL,NULL,'1330114182001',102.000000000,'1957-12-04','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5656,'FRANCOIS','YVONNE',NULL,'02.81.80.62.60','06.74.98.97.38',NULL,'65 RUE DES ROCHES','','','14370','ARGENCES',NULL,NULL,'1390814394001',372.000000000,'2008-11-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5657,'CIVIAKALA','LUCETTE','1926-09-26','02.53.06.48.25','06.34.29.16.68',NULL,'12 route d harcourt','','','14400','CUSSY',NULL,NULL,'2260914478001',13.000000000,'1950-09-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5658,'LAUVRIERE','HELENE','1933-05-10','02.63.39.06.41','06.11.35.72.81',NULL,'13 BOULEVARD D''ALSACE LORRAINE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1330514628001',3134.000000000,'1956-07-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5659,'DEBSKA','EDITH','1943-07-02','02.33.34.74.58',NULL,NULL,'702 QUARTIER DE LA HAUTE FOLIE','','','14000','CAEN',NULL,NULL,'1430761197001',20.000000000,'1969-10-01','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5660,'CARDON','JEAN','1942-01-13','02.89.78.02.91','06.77.24.40.48',NULL,'14 rue du general de gaulle','','','14220','THURY HARCOURT',NULL,NULL,'1420114130001',370.000000000,'1963-07-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5661,'PELLIER','GENEVIEVE','1942-03-11','02.19.66.86.31','06.10.11.37.62',NULL,'5 rrue de sully','','','14430','GOUSTRANVILLE',NULL,NULL,'2420314295001',856.000000000,'1965-10-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5662,'PAGNY','JACQUELINE','1938-04-05','02.39.45.29.53','06.64.91.87.28',NULL,'10 RUE DU SIX JUIN','','','14000','CAEN',NULL,NULL,'1380414257001',1682.000000000,'1963-07-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5663,'VILLALBA','LUCIENNE','1967-05-04','02.75.39.70.29','06.17.54.34.24',NULL,'13 PLACE DE LA MAIRIE APPT 18','','','14130','COQUAINVILLIERS',NULL,NULL,'1670561342001',722.000000000,'1997-12-11','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5664,'KOPYLA','AUGUSTE','1938-07-18','02.36.64.01.71','06.26.67.11.52',NULL,'20 rue le quindre','','','14120','MONDEVILLE',NULL,NULL,'1380714200001',57.000000000,'1962-11-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5665,'CRUCHON','MARCEL','1962-01-03','02.77.19.73.69','06.90.82.33.02',NULL,'37 avenue jean vilar','','','14123','IFS',NULL,NULL,'2620114044001',899.000000000,'1990-07-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5666,'MARIE','SYLVAIN','1944-06-17','02.67.51.06.89','06.75.55.33.49',NULL,'3 CHEMIN DU COLOMBIER','','','14270','MEZIDON CANON',NULL,NULL,'1440660175001',21.000000000,'1974-06-04','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5667,'LEMONNIER','CATHERINE','1939-09-23','02.47.67.18.16','06.10.28.96.26',NULL,'3 RUE D''ALSACE','','','14630','FRENOUVILLE',NULL,NULL,'2390914657001',166.000000000,'1966-11-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5668,'DESSEAUX','PIERRE','1930-07-23','02.80.57.83.20','06.55.64.42.85',NULL,'32 RUE DE LA HAIE AUX FEVES','','','14400','ST MARTIN DES ENTREES',NULL,NULL,'2300714720001',838.000000000,'1960-11-14','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5669,'LAINE','CAROL','1931-05-24','02.42.96.88.13','06.84.61.08.54',NULL,'1 rue de l egalite','','','14000','CAEN',NULL,NULL,'1310561367001',16.000000000,'1955-02-07','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5670,'ANNE','THERESE','1930-01-03','02.66.30.16.74',NULL,NULL,'8 PLACE DU COMMERCE','','',NULL,NULL,NULL,NULL,'1300161297001',836.000000000,'1955-05-25','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5671,'LECARPENTIER','MIREILLE','1943-01-23','02.49.18.67.63','06.38.94.77.42',NULL,'LE HAUT DE VILLERS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1430114058001',35.000000000,'1972-04-29','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5672,'MAROT','MONIQUE','1963-01-24','02.70.59.46.94','06.18.15.55.76',NULL,'75 rue d''auge','','','14120','MONDEVILLE',NULL,NULL,'1630114593001',65.000000000,'1984-04-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5673,'HERVE','ANNICK','1936-11-17','02.28.41.74.62',NULL,NULL,'61 RUE DE LA FONTENELLE','','','14430','DOZULE',NULL,NULL,'2361114428001',181.000000000,'1961-01-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5674,'MISTRAL','ANDREE','1942-01-19','02.41.85.64.85','06.57.15.43.15',NULL,'135 rue des accacias','','','14730','GIBERVILLE',NULL,NULL,'2420114538001',71.000000000,'1968-09-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5675,'MALGRAIN','ANDREE','1943-01-25','02.17.30.42.79','06.78.83.18.60',NULL,'6 rue francois mitterand','','','14740','LASSON',NULL,NULL,'1430150480001',158.000000000,'1969-01-21','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5676,'GANIVET','JEAN','1955-01-27','02.37.98.41.20','06.45.09.66.05',NULL,'FOSSE','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'1550161278001',74.000000000,'1980-07-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5677,'GUALBERT','GERARD','1929-11-27','02.10.99.03.43','06.16.44.95.09',NULL,'19 rue de la teste de buche','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2291114008001',346.000000000,'1950-11-06','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5678,'BARBE','GILBERT','1949-01-28','02.56.81.88.60','06.41.12.03.59',NULL,'2 rue jules ferry','','','14930','VIEUX',NULL,NULL,'1490114562001',1421.000000000,'1972-12-20','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5679,'RENOUX','PIERRE','1942-10-05','02.15.46.87.37','06.90.96.36.45',NULL,'3 RUE DE COURSEULLES','','','14270','MEZIDON CANON',NULL,NULL,'2421014641001',91.000000000,'1963-04-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5680,'ROISNET','LUCETTE','1942-10-14','02.10.26.89.00','06.18.62.13.45',NULL,'4 LA BRUYERE FLEURIE','','','14260','AUNAY SUR ODON',NULL,NULL,'2421014641001',52.000000000,'1972-05-03','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5681,'COUSSEAU','BERNARD','1928-09-04','02.91.18.11.37','06.98.77.36.21',NULL,'3 RUE DE TILLY','','','14000','CAEN',NULL,NULL,'1280953258001',1309.000000000,'1952-04-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5682,'LIEGEARD','MONIQUE','1930-03-11','02.44.64.75.47','06.80.30.93.32',NULL,'9 RUE JACQUES BREL','','','14210','NOYERS BOCAGE',NULL,NULL,'2300314221001',5.000000000,'1952-12-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5683,'MELINOU','LOUISE','1933-07-22','02.36.20.39.71','06.79.28.14.16',NULL,'96 BD MARECHAL LYAUTEY','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1330714454001',15.000000000,'1962-08-05','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5684,'POUDOU','HENRI','1930-07-15','02.10.00.97.31','06.15.21.75.76',NULL,'3 RUE DES LANDES','','','14000','CAEN',NULL,NULL,'2300714735001',2099.000000000,'1959-09-13','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5685,'RONDEAU','YVES','1961-02-16','02.12.61.97.97','06.12.98.37.81',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'2610214114001',99.000000000,'1983-12-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5686,'QUIRIE','YOLANDE','1939-12-05','02.10.54.04.92','06.81.02.29.20',NULL,'1 ROUTE DE CESNY AUX VIGNES','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'2391278496001',16.000000000,'1962-01-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5687,'LEVEQUE','CLAUDE','1934-04-30','02.11.08.78.68','06.76.94.61.07',NULL,'3 RUE SAINT MANVIEU','','','14000','CAEN',NULL,NULL,'1340414604001',167.000000000,'1962-05-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5688,'PERROTTE','MADELEINE','1931-07-12','02.11.32.89.35','06.79.70.56.15',NULL,'1 ALLEE DES JARDINS','','','14570','ST REMY',NULL,NULL,'2310714217001',40.000000000,'1958-06-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5689,'GRENET','JEAN','1934-11-18','02.15.22.84.26','06.81.45.94.71',NULL,'8 RUE ROYALE','','','14500','VIRE',NULL,NULL,'1341114667001',11.000000000,'1961-10-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5690,'ASSIER','GABRIELLE','1928-08-06','02.38.62.06.93','06.14.70.88.79',NULL,'6 rue de l''avenir','','','14730','GIBERVILLE',NULL,NULL,'1280814172001',249.000000000,'1952-09-19','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5691,'HAMEL','JACQUELINE','1957-02-02','02.43.38.37.92','06.86.16.22.74',NULL,'19 rue d athenes','','','14670','TROARN',NULL,NULL,'1570261171001',854.000000000,'1980-11-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5692,'GOULHOT','SYLVIE','1978-06-11','02.13.45.46.71','06.34.78.13.57',NULL,'LE BIOT','','','14000','CAEN',NULL,NULL,'2780699249001',44.000000000,'1999-04-03','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5693,'LEMAROIS','MARIE THERESE','1933-11-09','02.39.77.83.86','06.55.36.68.94',NULL,'7/2 grande rue','','','14120','MONDEVILLE',NULL,NULL,'2331114542001',1.000000000,'1955-04-17','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5694,'JORET','GUY','1936-10-15','02.86.57.92.49','06.43.99.26.71',NULL,'4 RUE DU PONT ROUGE','','','14370','ARGENCES',NULL,NULL,'1361014201001',890.000000000,'1957-04-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5695,'GENEST','MICHEL','1930-05-18','02.37.35.12.99','06.90.58.58.82',NULL,'LE NEUBOURG','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2300560033001',1830.000000000,'1951-04-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5696,'DORTEE','PIERRETTE','1938-07-09','02.58.38.24.89','06.28.37.52.05',NULL,'4 RUE DU PRESIDENT COTY','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2380750133001',97.000000000,'1960-10-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5697,'FERAY','Brigitte','1938-07-26','02.36.92.16.93','06.43.96.89.91',NULL,'7 RUE DU LAVOIR OUEZY','','','50630','CRASVILLE',NULL,NULL,'2380750133001',98.000000000,'1959-02-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5698,'SEBERT','MARIE ROSE','1934-02-14','02.22.33.16.35','06.85.50.95.23',NULL,'LE BOURG','','','14570','CLECY',NULL,NULL,'1340214541001',418.000000000,'1960-05-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5699,'SUZANNE','GEORGETTE','1934-10-10','02.15.08.15.24','06.39.64.05.11',NULL,'3 RUE DES CHAMPS','','','14100','LISIEUX',NULL,NULL,'2341014033001',39.000000000,'1961-03-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5700,'BAISADOULI','EDITH','1930-04-14','02.26.88.47.03','06.94.89.54.77',NULL,'2 rue paul de la lande','','',NULL,NULL,NULL,NULL,'1300461073001',284.000000000,'1957-07-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5701,'GRANDMOUGIN','CLEMENCE','1931-11-28','02.11.50.06.02','06.35.15.27.26',NULL,'hameau de la ville','','','14350','ETOUVY',NULL,NULL,'1311114507001',17.000000000,'1956-03-23','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5702,'CAUVET','ANNE MARIE','1950-05-06','02.28.98.73.55','06.99.12.00.68',NULL,'3 RUE DE VERDUN','','','14700','ST PIERRE CANIVET',NULL,NULL,'1500514529001',34.000000000,'1977-12-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5703,'GAYET','ANNIE','1950-05-13','02.38.03.88.49','06.80.70.87.23',NULL,'6 ter rue froide','','','14540','SOLIERS',NULL,NULL,'1500514529001',40.000000000,'1971-03-25','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5704,'LEDANOIS','GERARD','1937-03-20','02.37.04.23.41','06.23.21.78.15',NULL,'46 RUE GEORGES BRASSENS','','','14000','CAEN',NULL,NULL,'1370314504001',1845.000000000,'1959-09-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5705,'MANCEAU','JEAN PIERRE','1928-01-06','02.77.84.51.56','06.27.54.44.61',NULL,'34 RUE LEBLANC HARDEL','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1280114319001',640.000000000,'1949-03-13','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5706,'LITHARD','REMI','1970-01-18','02.99.74.17.84',NULL,NULL,'2 RUE DU DOMAINE','','','50890','CONDE SUR VIRE',NULL,NULL,'2700114623001',98.000000000,'2000-11-03','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5707,'LEU','EMILIEN','1936-12-26','02.11.69.00.60','06.26.27.01.86',NULL,'','','','14860','BAVENT',NULL,NULL,'2361227613001',874.000000000,'1958-07-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5708,'MERCIER','RAYMOND','1933-02-27','02.33.09.71.55','06.33.92.51.33',NULL,'65 RUE ST ANDRE','','','14840','DEMOUVILLE',NULL,NULL,'2330214421001',72.000000000,'1960-09-06','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5709,'DORAPHE','SYLVIE','1932-10-23','02.66.45.42.56','06.46.04.37.14',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1321014048001',43.000000000,'1955-11-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5710,'TIRARD','SYLVIE','1933-11-21','02.17.42.81.64','06.88.25.03.21',NULL,'HAMEAU LANGLOIS','','','14000','CAEN',NULL,NULL,'2331114257001',11.000000000,'1958-01-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5711,'AMAND','PHILIPPE','1938-04-13','02.85.66.12.54','06.67.09.16.68',NULL,'15 CHEMIN DU BOIS D''ALENCON','','','14370','BILLY',NULL,NULL,'1380414629001',25.000000000,'1959-07-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5712,'RAGOIN','THERESE','1951-01-03','02.11.83.66.70','06.85.07.64.46',NULL,'14 RUE FRED SCANARONI','','','14120','MONDEVILLE',NULL,NULL,'2510114314001',1286.000000000,'1981-11-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5713,'BELLENGER','FERNAND','1931-03-13','02.83.90.52.35','06.12.89.61.96',NULL,'12 RUE JULES FERRY','','','14000','CAEN',NULL,NULL,'2310350002001',5285.000000000,'1959-11-23','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5714,'MARIE','MARCEL','1929-10-07','02.52.70.26.41','06.15.43.46.94',NULL,'3 allee des louanges d amour','','','14000','CAEN',NULL,NULL,'2291014372001',45.000000000,'1952-04-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5715,'CHARLES','GEORGES','1934-11-13','02.70.14.44.95','06.23.66.64.77',NULL,'16 rue du puit picard','','','14123','IFS',NULL,NULL,'1341150393001',55.000000000,'1955-08-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5716,'ANNE','ANNICK','1929-09-24','02.75.35.50.81','06.79.87.17.76',NULL,'24 RUE DU STADE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1290950598001',42.000000000,'1957-04-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5717,'GINGAT','ALBAN','1936-01-22','02.30.94.20.08','06.84.77.91.56',NULL,'2-2 rue de l''arbalete','','','14140','ST GEORGES EN AUGE',NULL,NULL,'2360114689001',14.000000000,'1961-01-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5718,'CORPET','NICOLE','1962-12-15','02.12.76.92.40','06.89.84.91.02',NULL,'15 CHEMIN DES BOIS','','','14730','GIBERVILLE',NULL,NULL,'1621299122001',103.000000000,'1986-04-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5719,'GROSCOL','ISABELLE','1967-09-08',NULL,NULL,NULL,'30 RUE ERNEST RENAN','','',NULL,NULL,NULL,NULL,'1670914734001',82.000000000,'1994-01-07','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5720,'DELAMARE','MICHEL','1943-01-20','02.87.76.51.35','06.87.75.28.26',NULL,'lieu dit la hogue','','','14000','CAEN',NULL,NULL,'1430114592001',805.000000000,'1966-08-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5721,'BACHELLIER','BERNARD','1932-01-04','02.58.06.07.83','06.23.71.84.04',NULL,'','','','14120','GIBERVILLE',NULL,NULL,'1320114461001',140.000000000,'1955-10-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5722,'SAVARY','SUZANNE','1931-04-11','02.90.38.06.06','06.45.93.91.50',NULL,'4/2 RUE DU STADE','','','50890','CONDE SUR VIRE',NULL,NULL,'2310414542001',55.000000000,'1952-12-10','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5723,'DEMARAIS','MAURICE',NULL,'02.49.74.55.80',NULL,NULL,'ROUTE DE LITTRY','','','14270','MEZIDON CANON',NULL,NULL,'1341114377001',26.000000000,'2009-01-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5724,'BEURON','MARIE THERESE','1932-09-30','02.71.13.54.40','06.10.48.67.82',NULL,'1603 GRANDE DELLE','','','50250','GERVILLE LA FORET',NULL,NULL,'2320914209001',189.000000000,'1953-04-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5725,'AUGE','GEORGES','1966-06-23','02.11.62.53.19','06.25.39.38.45',NULL,'6 rue alfred nobel','','','50270','BARNEVILLE CARTERET',NULL,NULL,'2660675073001',381.000000000,'1993-03-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5726,'DELAQUAIZE','SYLVIE','1958-05-12','02.11.13.45.67','06.34.65.97.88',NULL,'13 RUE DES FONTAINES','','','50270','BARNEVILLE CARTERET',NULL,NULL,'1580514749001',381.000000000,'1982-02-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5727,'FONTAINE','CHRISTIANE','1940-06-11','02.83.78.66.14','06.12.97.82.36',NULL,'','','','14210','MISSY',NULL,NULL,'2400614494001',930.000000000,'1969-09-04','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5728,'FOUQUEREL','MICHEL','1936-06-29','02.12.26.22.15','06.12.18.75.00',NULL,'8 ALLEE LA PERoUSE','','','14730','GIBERVILLE',NULL,NULL,'1360653130001',105.000000000,'1960-12-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5729,'CLEREL','JOSEPH','1930-08-18','02.38.85.67.68','06.71.39.64.95',NULL,'2 rue louis savard','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1300814341001',1566.000000000,'1956-06-01','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5730,'BAILLEUX','JACKY','1959-06-12','02.14.70.23.96','06.94.56.41.97',NULL,'7 RUE DES BOUVREUIL','','','14220','BARBERY',NULL,NULL,'2590614128001',356.000000000,'1986-11-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5731,'MORIN','ALEXIS','1961-10-30','02.49.36.74.92',NULL,NULL,'PIERRE SEMARD','','',NULL,NULL,NULL,NULL,'1611014353001',6.000000000,'1985-05-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5732,'GUILLOTIN','HENRI','1938-01-22','02.67.45.53.14','06.28.33.40.02',NULL,'41 RUE DE CORNOUAILLES','','','61160','TRUN',NULL,NULL,'1380114319001',104.000000000,'1963-01-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5733,'LOIR','ALPHONSE','1947-06-21','02.16.11.72.83','06.24.22.12.43',NULL,'19 RUE CAMP ROMAIN','','','14710','TREVIERES',NULL,NULL,'1470610020001',267.000000000,'1969-05-21','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5734,'DELAVAUX','THERESE','1941-01-12','02.65.73.41.58','06.40.16.10.96',NULL,'3 RUE ST GILLES','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2410114211001',43.000000000,'1968-06-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5735,'MOTTIER','ANDRE','1939-11-08','02.55.79.27.67','06.61.47.72.39',NULL,'7 rue du 19 mars','','','14390','CABOURG',NULL,NULL,'2391150183001',37.000000000,'1969-05-09','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5736,'MICHEL','SIMONE','1965-06-02','02.78.12.29.68','06.44.16.79.40',NULL,'96 RUE D''HEROUVILLE','','','61300','L''AIGLE',NULL,NULL,'1650614044001',33.000000000,'1986-10-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5737,'RADULPHE','SYLVIE','1941-05-31','02.70.39.12.27','06.25.49.23.30',NULL,'LE CLOS DOGUET','','','14840','DEMOUVILLE',NULL,NULL,'1410514072001',5.000000000,'1965-01-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5738,'JACQUELINE','CHRISTIANE','1934-12-26','02.16.70.53.74',NULL,NULL,'6 RUE DU DOCTEUR LEPELLETIER','','','14260','AUNAY SUR ODON',NULL,NULL,'1341214627001',1665.000000000,'1960-05-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5739,'LEMARCHAND','THEREZE','1953-01-31','02.66.04.50.67','06.52.48.75.86',NULL,'10 LE HOME','','','14000','CAEN',NULL,NULL,'2530115001001',27.000000000,'1981-03-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5740,'LEROND','BERNARD','1967-04-11','02.62.31.53.90','06.76.05.85.78',NULL,'3 RUE GANDHI','','','14000','CAEN',NULL,NULL,'1670414537001',631.000000000,'1993-10-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5741,'FOURMOND','noel','1963-08-28','02.40.32.59.05','06.90.03.70.40',NULL,'RESIDENCE GARVIN','','','14120','MONDEVILLE',NULL,NULL,'1630821460001',3.000000000,'1984-10-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5742,'MARIE','LOUISE','1938-02-09','02.38.24.79.65','06.55.89.59.89',NULL,'4 RUE HENRI 1ER BEAUCLAIR','','',NULL,NULL,NULL,NULL,'1380277395001',4088.000000000,'1959-07-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5743,'ANDRE','GENEVIEVE','1920-03-09','02.19.13.21.49','06.93.61.25.27',NULL,'11 alle emmanuel chabrier','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1200372225001',10.000000000,'1942-07-22','PREMIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5744,'BINET','VALERIE','1956-02-07','02.68.08.40.94','06.51.82.94.14',NULL,'N11 LE PLANITRE','','','66470','STE MARIE',NULL,NULL,'2560214118001',19.000000000,'1983-10-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5745,'SPECHT','SUZANNE',NULL,'02.84.21.95.65','06.35.31.65.51',NULL,'4 rue de romains','','','14111','LOUVIGNY',NULL,NULL,'1400922352001',123.000000000,'2013-01-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5746,'PESARD','SIMONE','1939-11-19','02.27.30.83.66','06.24.50.56.02',NULL,'5 RUE DU PETIT MARAIS','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'2391114668001',221.000000000,'1962-11-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5747,'LONGPRE','JEAN YVES','1928-10-26','02.66.36.94.97','06.63.35.46.78',NULL,'LE BEFFEUX','','','14000','CAEN',NULL,NULL,'1281014458001',746.000000000,'1950-09-26','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5748,'MARIE','MAURICE','1931-07-10','02.13.87.16.78','06.55.07.65.64',NULL,'RUE DE L4EGLISE','','','14460','COLOMBELLES',NULL,NULL,'2310714672001',106.000000000,'1953-06-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5749,'DANSE','YVONNE','1963-01-16','02.35.78.98.49','06.89.43.54.56',NULL,'26 rue g le conquerant','','','14680','GOUVIX',NULL,NULL,'2630135069001',30.000000000,'1991-10-14','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5750,'METTE','VALERIE',NULL,'02.10.55.75.81','06.34.15.02.78',NULL,'117 rue ernest manchon','','','14120','MONDEVILLE',NULL,NULL,'2650114338001',1297.000000000,'2011-09-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5751,'GANCEL','SERGE','1935-06-10','02.39.82.53.46','06.44.10.18.60',NULL,'rue de la fontaine','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2350650497001',199.000000000,'1965-12-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5752,'SAUVAGE','THERESE','1935-08-25','02.44.06.48.80','06.17.88.65.76',NULL,'19 RUE DES GRACILAIRES','','','14000','CAEN',NULL,NULL,'2350861227001',37.000000000,'1957-06-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5753,'CASSONNET','MARIANNE','1938-03-14','02.80.58.19.01','06.33.59.34.77',NULL,'1 RUE DE LA MINE','','','14630','CAGNY',NULL,NULL,'1380350109001',808.000000000,'1966-09-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5754,'RIOU','GENEVIEVE','1938-05-22','02.10.18.61.68','06.45.33.18.37',NULL,'RUE DE L4EGLISE','','','14123','IFS',NULL,NULL,'1380514076001',86.000000000,'1968-08-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5755,'LEROUVILLOIS','MADELEINE','1943-07-27','02.10.48.05.85','06.54.63.68.30',NULL,'20 rue jules vernes app 983','','','14000','CAEN',NULL,NULL,'1430750339001',427.000000000,'1966-09-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5756,'MARIE','JEAN','1931-05-30','02.50.45.45.68','06.60.23.74.31',NULL,'9 RUE DE LA GRACE DE DIEU','','','14120','MONDEVILLE',NULL,NULL,'1310514062001',35.000000000,'1952-04-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5757,'LORIOT','FERNAND',NULL,'02.24.03.34.36','06.66.51.33.51',NULL,'9 PLACE DE LA PREVOYANCE','','','14930','MALTOT',NULL,NULL,'2700114038001',355.000000000,'2010-02-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5758,'PERENCIN','SOLANGE','1941-01-14','02.60.98.75.60','06.34.03.53.31',NULL,'3 RUE DU 8 MAI','','','14000','CAEN',NULL,NULL,'2410149299001',44.000000000,'1964-07-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5759,'THOUVENIN','JEAN CLAUDE','1931-08-22','02.23.13.25.57','06.11.58.36.93',NULL,'15 RUE SALVADOR ALLIENDE','','','14000','CAEN',NULL,NULL,'2310814341001',762.000000000,'1961-11-29','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5760,'COQUEREL','GASTON','1981-08-21','02.46.01.17.35','06.30.08.46.22',NULL,'la grande rue','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'2810899317001',266.000000000,'2008-05-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5761,'MONTIGNY','BERNARD','1933-07-07','02.66.44.08.00','06.14.61.64.75',NULL,'87 RUE FRANCOIS BLACHE','','','14710','ECRAMMEVILLE',NULL,NULL,'1330714045001',564.000000000,'1963-10-02','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5762,'QUINTAINE','ANDREE','1964-02-16','02.44.86.38.90','06.58.27.95.03',NULL,'4 BIS RUE DU JEU DE PAUME','','','14000','CAEN',NULL,NULL,'1640261217001',72.000000000,'1993-02-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5763,'LECONTE','CHRISTIANE','1930-09-05','02.55.37.31.06','06.30.56.52.08',NULL,'17 impasse du chateau','','','14610','VILLONS LES BUISSONS',NULL,NULL,'1300914064001',1779.000000000,'1953-12-20','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5764,'ROZIER','Simone','1931-08-04','02.61.42.18.91','06.84.81.23.34',NULL,'FERME ST NICOLAS ROUTE DE GRAIN','VILLE S/ODON','','50550','ST VAAST LA HOUGUE',NULL,NULL,'2310814124001',460.000000000,'1956-03-02','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5765,'CHEMIN','JOEL','1945-02-23',NULL,NULL,NULL,'8 RUE JEAN DENIS','','','14980','ROTS',NULL,NULL,'2450250142001',269.000000000,'1975-05-02','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5766,'EURY','DANIEL','1933-11-22','02.10.86.48.20','06.93.46.65.99',NULL,'13 RUE BOULAY','','','14600','GENNEVILLE',NULL,NULL,'2331114550001',26.000000000,'1962-08-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5767,'PICOT','MARCEL','1931-08-13','02.23.82.34.54','06.17.30.91.84',NULL,'19 RUE DE SAINTONGE','','','14120','MONDEVILLE',NULL,NULL,'2310850160001',35.000000000,'1961-07-09','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5768,'NICOLLE','KATIA','1933-12-07','02.28.25.06.72','06.81.79.72.74',NULL,'24 RUE DES LILAS','','','14100','ST PIERRE DES IFS',NULL,NULL,'1331214220001',631.000000000,'1959-03-14','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5769,'DELAQUAIZE','MARCEL','1953-10-03','02.16.40.63.25','06.55.94.58.43',NULL,'','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2531076351001',109.000000000,'1974-09-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5770,'SAUVE','MONIQUE','1936-12-19','02.98.64.16.89','06.26.70.13.44',NULL,'9 quai de la londe','','','14123','IFS',NULL,NULL,'1361214531001',43.000000000,'1964-11-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5771,'BELLAMY','CHRISTINE','1934-01-15','02.39.98.21.01','06.44.24.51.59',NULL,'903 LA HAUTE FOLIE','','','14370','MERY CORBON',NULL,NULL,'1340177478001',1280.000000000,'1964-03-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5772,'BINET','SIMONE','1931-03-08','02.46.17.49.50','06.21.02.76.38',NULL,'4 alle saguenay','','','14000','CAEN',NULL,NULL,'2310314277001',752.000000000,'1952-07-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5773,'LALLEMAN','YVELINE','1940-07-22','02.51.16.80.02','06.86.67.52.20',NULL,'138 RUE D''AUGE  FOYER DE L''ENFAN','CE','','14230','LONGUEVILLE',NULL,NULL,'1400714309001',3038.000000000,'1970-07-30','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5774,'GODET','CHRISTIANE','1939-09-29','02.70.13.03.81','06.75.99.21.37',NULL,'65 RUE DE LA FONTAINE','','','14000','CAEN',NULL,NULL,'1390914566001',49.000000000,'1964-05-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5775,'HUE','HENRIETTE','1933-08-17','02.11.54.18.97','06.71.46.41.64',NULL,'73 route d harcourt','','','14250','JUAYE MONDAYE',NULL,NULL,'2330861026001',169.000000000,'1958-06-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5776,'WINDSOR','GILBERT','1929-04-11','02.89.59.64.05','06.17.26.80.25',NULL,'','','','14000','CAEN',NULL,NULL,'2290427107001',1206.000000000,'1954-02-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5777,'CHALES','PIERRE','1935-10-18','02.87.88.48.33','06.21.91.69.80',NULL,'15 RUE DE LA FONTAINE','','','14000','CAEN',NULL,NULL,'1351014167001',10.000000000,'1962-03-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5778,'LONGUET','MICHEL','1935-10-24','02.38.18.68.24','06.17.45.79.77',NULL,'hameau de benouville','','','14000','CAEN',NULL,NULL,'1351014167001',203.000000000,'1963-10-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5779,'DALIGAULT','MARIE LOUISE','1946-01-29','02.55.32.29.57','06.31.52.16.96',NULL,'Chez Madame Ranchy (fille) 9 ru','e Mozart','','14000','CAEN',NULL,NULL,'2460114387001',40.000000000,'1975-01-12','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5780,'CAMARA','JEANNINE','1930-07-10','02.11.26.60.67','06.97.71.62.33',NULL,'maison neuve','','','14000','CAEN',NULL,NULL,'1300714171001',299.000000000,'1953-09-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5781,'BROSSARD','GINETTE','1940-08-19','02.69.64.30.98','06.90.38.32.02',NULL,'20 RUE EUGENE BRUNEAU','','','14000','CAEN',NULL,NULL,'2400876165001',9.000000000,'1964-02-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5782,'LIAIGRE','MICHELINE','1941-01-18','02.50.11.41.96','06.43.66.71.65',NULL,'1 ROUTE DE CAEN','','','14700','FALAISE',NULL,NULL,'2410114622001',108.000000000,'1963-04-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5783,'COLOMES','JANINE','1939-06-11','02.44.32.67.17','06.47.03.77.53',NULL,'7 bis porte millet','','','50700','VALOGNES',NULL,NULL,'1390672186001',18.000000000,'1961-11-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5784,'DENIZE','RENE','1938-03-20','02.43.62.27.76','06.41.20.97.11',NULL,'6 rue alfred nobel','','','14840','CUVERVILLE',NULL,NULL,'2380314424001',69.000000000,'1960-05-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5785,'LEGAY','VERONIQUE','1928-01-10','02.58.27.08.73','06.26.82.49.28',NULL,'16 HAMEAU DE BITOT','','','61430','BERJOU',NULL,NULL,'2280122028001',791.000000000,'1952-11-18','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5786,'COTIGNY','ROGER','1933-11-20','02.45.96.58.71','06.93.01.16.52',NULL,'4 RUE DES BARENTINS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2331114614001',273.000000000,'1954-02-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5787,'CHIRAT','JEAN CLAUD','1930-05-21','02.53.51.58.52','06.83.19.33.18',NULL,'24 RUE DU BOIS DES TRENTAINES','','','14420','VILLERS CANIVET',NULL,NULL,'2300514450001',26.000000000,'1957-11-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5788,'BREARD','GUY-GILBERT','1933-08-19','02.74.23.27.64',NULL,NULL,'le hamel','','','14000','CAEN',NULL,NULL,'2330814739001',41.000000000,'1954-10-08','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5789,'LECORNE','ANNETTE','1951-07-03','02.12.18.88.27','06.11.03.62.66',NULL,'HAMEAU DE FAINS','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'2510714470001',347.000000000,'1980-06-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5790,'BULCKE','MARTINE',NULL,'02.50.26.76.33','06.77.37.76.97',NULL,'3 alle maurice rousseau','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2291214084001',41.000000000,'2009-07-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5791,'CARDINE','JANINE','1929-12-30','02.20.23.97.10','06.25.19.48.94',NULL,'6 C ROUTE DE SURTAINVILLE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2291214084001',4.000000000,'1958-08-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5792,'BOUVIER','BERNADETTE','1968-05-22','02.76.52.88.94','06.82.41.28.20',NULL,'10 RUE DU VALLON','','','14120','MONDEVILLE',NULL,NULL,'2680514241001',41.000000000,'1992-04-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5793,'LEFORT','MAURICE','1957-02-07','02.29.62.11.95','06.69.53.41.77',NULL,'CHEMIN DE LA PRADE','','','14000','CAEN',NULL,NULL,'1570214628001',144.000000000,'1981-09-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5794,'LUKIC','GISELE','1933-10-22','02.13.12.28.43','06.86.14.90.89',NULL,'LE TREMBLAY','','','14630','FRENOUVILLE',NULL,NULL,'1331014488001',87.000000000,'1955-08-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5795,'GROULT','GERARD','1936-12-08','02.10.44.27.99','06.49.30.10.91',NULL,'4 RUE DES VERTES PRAIRIES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2361257243001',910.000000000,'1965-11-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5796,'QUENAULT','BERNADETTE',NULL,'02.99.81.95.98','06.11.34.02.07',NULL,'2 rue des sales tinbanques','','','14120','MONDEVILLE',NULL,NULL,'1290959183001',2009.000000000,'2013-03-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5797,'LACOUR','GINETTE','1954-01-21','02.76.31.28.30','06.53.37.76.83',NULL,'64 RUE DU GENERAL DE GAULLE','','','14123','IFS',NULL,NULL,'1540114092001',1200.000000000,'1981-04-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5798,'BALONNIER','YVETTE','1954-03-28','02.18.41.77.53','06.27.66.03.70',NULL,'7 RUE GEORGES MAUDOUIT','','','14540','SOLIERS',NULL,NULL,'2540314266001',1007.000000000,'1977-04-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5799,'BOUILLARD','TAMARI','1933-10-19','02.42.64.71.46','06.12.28.30.52',NULL,'9 PLACE  AIN DT DANUBE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2331014562001',65.000000000,'1960-09-23','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5800,'ROSSIGNOL','GUY','1948-04-05','02.52.99.66.79','06.38.28.66.88',NULL,'3/1 rue des bleuets','','','14000','CAEN',NULL,NULL,'1480461179001',2877.000000000,'1971-07-08','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5801,'LIARD','PAULETTE','1928-11-19','02.67.95.02.02','06.44.38.56.40',NULL,'2 RUE DU CENTRE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2281150216001',11.000000000,'1950-09-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5802,'MAZUR','BERNARD','1931-08-24','02.11.35.54.88','06.80.11.37.35',NULL,'5 RUE DIVY BRIGE','','','14000','CAEN',NULL,NULL,'1310850526001',166.000000000,'1954-04-28','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5803,'JEANNE','jean','1937-08-05','02.72.37.09.31','06.35.56.56.72',NULL,'7 RUE EDOUARD VAILLANT','','','14710','FORMIGNY',NULL,NULL,'2370850142001',655.000000000,'1958-10-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5804,'ADAM','ODETTE',NULL,'02.91.19.23.16','06.18.88.33.83',NULL,'2 BIS RUE DES JARDINS','','','14840','DEMOUVILLE',NULL,NULL,'2700150582001',75.000000000,'2013-06-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5805,'','CHARLES','1934-05-15','02.81.32.82.15','06.38.33.28.78',NULL,'18 AVENUE MARECHAL GEOFFRE','','','14410','VIESSOIX',NULL,NULL,'2340514761001',25.000000000,'1962-11-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5806,'CHAMPAIN','DANIEL','1935-04-29','02.65.08.22.85','06.10.73.91.89',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'2350414629001',61.000000000,'1957-07-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5807,'BENIS','DANIEL','1936-04-24','02.59.15.72.59','06.28.51.50.53',NULL,'2 RUE FROIDE','','','14270','MEZIDON CANON',NULL,NULL,'1360457596001',29.000000000,'1958-07-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5808,'GUICHEUX','IRINE','1966-04-10','02.26.71.65.44','06.88.85.47.22',NULL,'3 AVENUE DU MESNIL','','','14610','EPRON',NULL,NULL,'2660441022001',820.000000000,'1993-07-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5809,'GERMAIN','ISABELLE','1955-03-08','02.20.89.27.83','06.51.26.17.46',NULL,'26 rue de la liberte','','','14610','EPRON',NULL,NULL,'1550314103001',3.000000000,'1982-03-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5810,'MAGUET','ANDREE','1957-03-20','02.59.90.88.26','06.79.42.54.21',NULL,'48 RUE JULES GUESDE','','','14940','SANNERVILLE',NULL,NULL,'1570314281001',360.000000000,'1981-02-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5811,'RUAULD','ANDRE','1930-11-04','02.20.41.82.84','06.38.44.64.68',NULL,'','','','14730','GIBERVILLE',NULL,NULL,'2301114160001',1352.000000000,'1952-12-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5812,'DUVAL','LOUIS','1929-06-26','02.27.38.15.42','06.93.97.82.17',NULL,'4 RUE GUY DE MAUPASSANT','','','14480','LE FRESNE CAMILLY',NULL,NULL,'2290614243001',10.000000000,'1958-04-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5813,'MONTAILLE','ANDREE','1939-09-21','02.74.21.87.67',NULL,NULL,'1 TER RUE DUSOIR','','','14123','FLEURY SUR ORNE',NULL,NULL,'2390914657001',12.000000000,'1962-05-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5814,'LEREVERS','JACQUES','1938-06-06','02.12.33.00.09','06.42.54.01.10',NULL,'24 RUE DU GENERAL LECLERC','','','14220','CROISILLES',NULL,NULL,'2380614191001',2548.000000000,'1963-06-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5815,'GASSON','MARIE LOUISE','1930-06-08','02.41.88.75.78','06.87.25.08.20',NULL,'3 PLACE CLAUDE DEBUSSY','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1300614712001',248.000000000,'1954-04-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5816,'RICHARD','BERNARD','1977-06-09','02.58.54.36.79','06.62.37.96.89',NULL,'6 RUE DES ACADIENS','','','14123','IFS',NULL,NULL,'2770699302001',1.000000000,'2007-02-08','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5817,'LECANU','BERNARD','1933-05-16','02.80.82.78.26','06.56.09.39.37',NULL,'12 RUE DES FOSSETTES 14123 CORM','ELLES LE ROYAL','','14120','MONDEVILLE',NULL,NULL,'1330514214001',610.000000000,'1960-06-09','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5818,'MENARD','YVONNE','1938-11-12','02.20.29.84.17','06.83.39.91.82',NULL,'22 RUE DE PICARDIE','','','14100','LISIEUX',NULL,NULL,'2381114118001',96.000000000,'1961-02-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5819,'HIELARD','HERVELINE','1933-08-25','02.46.53.73.75','06.11.19.39.21',NULL,'4 RUE DE L''ECUYER','','','14270','MEZIDON CANON',NULL,NULL,'2330850285001',1078.000000000,'1962-06-22','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5820,'BRAULT','PIERRETTE','1930-06-24','02.51.95.25.86','06.67.85.51.41',NULL,'17 HAMEAU DU FRESNE','','','14310','VILLERS BOCAGE',NULL,NULL,'1300661397001',76.000000000,'1952-07-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5821,'MIRIEL','JEAN CLAUDE','1938-09-16','02.10.25.33.83','06.12.16.58.69',NULL,'st blaise','','','14700','ST PIERRE CANIVET',NULL,NULL,'2380950639001',24.000000000,'1962-07-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5822,'VIVIEN','MARTINE','1935-03-02','02.24.07.29.07','06.18.33.96.16',NULL,'17 rue de la bienfaisance','','','14000','CAEN',NULL,NULL,'2350314088001',41.000000000,'1957-05-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5823,'CHEVALIER','JEAN PAUL','1930-08-10','02.11.09.12.99','06.81.91.54.34',NULL,'23 RUE PASTEUR','','','14280','AUTHIE',NULL,NULL,'2300814628001',58.000000000,'1954-04-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5824,'AMELINE','MIREILLE','1930-08-09','02.37.32.52.73','06.72.04.95.34',NULL,'4 RUE DU MOULIN','','','14000','CAEN',NULL,NULL,'1300850093001',1303.000000000,'1952-04-03','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5825,'GAIGNON','COLETTE','1945-01-29','02.96.63.35.44','06.79.46.74.05',NULL,'10 ROUTE DE PARIS','','','14150','OUISTREHAM',NULL,NULL,'1450114045001',400.000000000,'1974-02-15','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5826,'LE COGUIC','PAUL','1932-01-13','02.19.80.99.93','06.80.70.35.47',NULL,'le petit coucou','','','14540','GRENTHEVILLE',NULL,NULL,'2320150342001',6.000000000,'1954-05-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5827,'','odette','1936-12-14','02.11.21.13.96','06.50.83.87.95',NULL,'90 RUE BICOQUET','','','50250','ST JORES',NULL,NULL,'1361214531001',24.000000000,'1966-01-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5828,'BENOIT','MICHELE','1934-02-20','02.80.04.17.86','06.21.26.91.02',NULL,'','','','14850','HEROUVILLETTE',NULL,NULL,'1340261332001',15.000000000,'1961-08-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5829,'LARSON','JEAN MARIE',NULL,'02.12.30.32.96','06.10.68.48.98',NULL,'6 rue caumont','','','14630','FRENOUVILLE',NULL,NULL,'2520650212001',2148.000000000,'2010-09-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5830,'FAGOT','CECILE','1943-05-28','02.67.16.53.86','06.66.08.82.48',NULL,'23 AVENUE ALBERT PREMIER','','','14370','MOULT',NULL,NULL,'2430514181001',535.000000000,'1964-03-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5831,'CHENEL','MARIE ANTOINETTE','1928-06-04','02.26.75.19.54','06.33.04.47.45',NULL,'8 rue de la cavee','','',NULL,NULL,NULL,NULL,'2280662325001',538.000000000,'1956-10-28','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5832,'GASNIER','JEAN MAXIME','1928-05-07','02.58.63.96.64','06.15.98.70.81',NULL,'35 RUE ANDRE LEMAITRE','','','14190','FIERVILLE BRAY',NULL,NULL,'1280514271001',114.000000000,'1957-02-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5833,'DUPONT','MARIE THERESE','1955-04-25','02.38.13.78.72','06.33.46.06.32',NULL,'','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'1550450373001',719.000000000,'1979-07-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5834,'FERGANT','PHILOMAIN','1938-10-23','02.11.97.12.16','06.21.96.51.56',NULL,'37 rue st eloi','','','61200','ARGENTAN',NULL,NULL,'2381014056001',61.000000000,'1961-01-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5835,'BOUTRY','NICOLE','1929-12-05','02.31.59.93.40','06.32.40.92.90',NULL,'','','','14000','CAEN',NULL,NULL,'1291280581001',9.000000000,'1953-01-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5836,'MOTTE','CHARLOTTE',NULL,'02.43.96.03.53','06.70.79.12.09',NULL,'1 allee des promenades','','','14210','BARON SUR ODON',NULL,NULL,'2580214114001',10.000000000,'2009-06-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5837,'HALLEY','ANNICK','1943-01-24','02.48.95.36.57','06.97.18.67.21',NULL,'LES TERTRES','','','14630','CAGNY',NULL,NULL,'2430161301001',189.000000000,'1964-08-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5838,'LABBE','NOEL','1961-02-23','02.95.74.63.83',NULL,NULL,'1 RESIDENCE SAINT GERBOLD','','','50760','GATTEVILLE LE PHARE',NULL,NULL,'2610214287001',702.000000000,'1990-07-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5839,'LEROY','ELIANE','1966-07-28','02.89.49.69.15','06.68.97.83.29',NULL,'3 ALLE DES POETES','','','14210','BARON SUR ODON',NULL,NULL,'2660714034001',2.000000000,'1993-12-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5840,'FOSSE','JANINE','1937-10-03','02.10.90.36.79','06.10.49.60.59',NULL,'14 RUE DE LA POMMERAIE','','','14000','CAEN',NULL,NULL,'1371014590001',423.000000000,'1959-11-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5841,'BISSON','MADELEINE','1936-07-01','02.16.76.99.81','06.51.38.90.44',NULL,'20 bis rue de la residence','','','14000','CAEN',NULL,NULL,'1360750462001',958.000000000,'1959-05-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5842,'TAKOURNANT','RAYMONDE',NULL,'02.61.73.69.10','06.90.47.28.51',NULL,'125 bvd general vannier','','','14260','ROUCAMPS',NULL,NULL,'1420614029001',3353.000000000,'2009-03-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5843,'PASQUIER','FRANCOISE','1933-12-22',NULL,NULL,NULL,'2 RUE DU COMTE ROEDERER APPT 17','','','14000','CAEN',NULL,NULL,'1331214294001',14.000000000,'1960-05-21','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5844,'DREYFUS','HUBERT','1934-09-18','02.71.08.37.77','06.45.73.02.13',NULL,'LE PRE DE LA BIGNE','','','14930','ETERVILLE',NULL,NULL,'2340914690001',113.000000000,'1956-06-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5845,'COSTIL','GEORGETTE','1929-01-06','02.97.51.02.13','06.76.21.56.84',NULL,'11 RUE AUX PIERROTS','','','14540','GRENTHEVILLE',NULL,NULL,'2290114489001',255.000000000,'1952-01-04','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5846,'BESSON','MARIE','1940-12-03','02.65.40.97.88','06.10.33.11.01',NULL,'21 RUE DES MIMOSAS','','','14123','IFS',NULL,NULL,'2401214494001',63.000000000,'1962-01-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5847,'MOREL','ANDREE','1943-03-09','02.19.19.28.70','06.11.14.34.49',NULL,'5 rue du plein du roy','','','14320','FONTENAY LE MARMION',NULL,NULL,'1430314206001',135.000000000,'1969-06-24','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5848,'DESRUES','SYLVIE','1934-02-21','02.64.55.71.68','06.12.08.33.75',NULL,'GRANDE RUE','','','14670','TROARN',NULL,NULL,'2340250433001',1744.000000000,'1959-05-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5849,'BAUDAIN','GISELE','1933-02-02','02.64.24.71.80','00 33 6.80.60.89.52',NULL,'13 rue Reine Eddy','','','14860','AMFREVILLE',NULL,NULL,'2330214165001',16.000000000,'1956-05-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5850,'PIQUOIS','DIDIER','1946-11-29','02.42.18.10.49','06.17.80.50.12',NULL,'LA GUERROTERIE','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1461114479001',680.000000000,'1970-09-22','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5851,'LEBARBE','YVES','1929-12-26','02.80.25.16.64','06.82.95.92.58',NULL,'2 RUE DES LILAS','','','50800','VILLEDIEU LES POELES',NULL,NULL,'2291250129001',1.000000000,'1959-06-12','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5852,'GOUET','BERNARD',NULL,'02.50.54.68.27','06.52.51.26.70',NULL,'','','','14290','TORDOUET',NULL,NULL,'1390627469001',664.000000000,'2012-04-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5853,'SIMON','SUZANNE','1965-09-29','02.99.77.57.72','06.34.94.03.87',NULL,'21 RUE DU MANOIR','','','14700','FALAISE',NULL,NULL,'1650914215001',118.000000000,'1992-04-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5854,'LOHIER','SYLVIE','1934-05-13','02.73.90.32.17','06.53.87.89.19',NULL,'1 RUE DE VILLONS','','','14123','IFS',NULL,NULL,'2340561040001',60.000000000,'1960-01-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5855,'HEURTEVENT','ROSE','1934-09-14','02.29.98.93.04','06.61.42.84.39',NULL,'34 rue des tilleuls','','','50420','ST VIGOR DES MONTS',NULL,NULL,'1340914318001',16.000000000,'1955-07-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5856,'LONGUET','ROSE','1944-01-12','02.12.13.35.71','06.71.71.82.64',NULL,'5 bis rue du bel air','','','14000','CAEN',NULL,NULL,'2440114543001',134.000000000,'1974-08-07','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5857,'BIRON','SYLVIE','1937-07-09','02.77.55.43.41','06.26.11.71.17',NULL,'11 BIS RUE PASTEUR','','','14160','GRANGUES',NULL,NULL,'1370714074001',15.000000000,'1961-07-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5858,'BEQUET','ISABELLE','1930-02-12','02.46.16.61.29','06.11.68.30.81',NULL,'3 RUE DE LA CROIX CANTEE','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1300214040001',2992.000000000,'1953-11-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5859,'BERTIN','MICHELINE','1933-11-19','02.12.20.64.92','06.72.71.15.94',NULL,'5 RUE VIVIANNE','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2331161120001',445.000000000,'1963-07-30','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5860,'LEGARDIEN','HELENE','1960-01-04','02.26.21.23.41','06.47.06.42.23',NULL,'6 DOMAINE','','','14000','CAEN',NULL,NULL,'2600150394001',296.000000000,'1983-06-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5861,'FRANCOIS','FATIMA','1939-10-08','02.96.41.35.56','06.64.22.72.16',NULL,'5 RUE VICTOR HUGO','','','14250','FONTENAY LE PESNEL',NULL,NULL,'2391014579001',26.000000000,'1963-12-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5862,'BERNARD','GERARD','1944-03-01','02.96.77.73.34','06.73.23.07.90',NULL,'LA COUR','','','50440','GREVILLE HAGUE',NULL,NULL,'2440314635001',106.000000000,'1974-11-08','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5863,'AULNETTE','MICHEL','1953-03-22','02.26.68.18.37','00 33 6.34.85.45.42',NULL,'3 RESIDENCE FISSADAME','','','14370','AIRAN',NULL,NULL,'1530314283001',908.000000000,'1976-02-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5864,'AUVRAY','GEORGES','1933-07-09','02.53.57.23.37','06.31.23.99.68',NULL,'13 RUE DE LA DELLE DU RENARD','','','14610','CAIRON',NULL,NULL,'2330714121001',79.000000000,'1955-10-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5865,'FEUARDANT','GENEVIEVE','1962-04-16','02.90.13.33.70','06.86.86.31.75',NULL,'','','','50120','EQUEURDREVILLE HAINNEVILLE',NULL,NULL,'1620414080001',343.000000000,'1984-03-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5866,'BRIOUT','GERARD','1935-06-25','02.88.80.98.50','06.10.80.43.34',NULL,'7 ALLEE WINIPEG','','','14630','FRENOUVILLE',NULL,NULL,'1350650023001',454.000000000,'1964-10-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5867,'LAMI','MICHEL','1937-05-09','02.71.04.15.74',NULL,NULL,'302 la ramee','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1370514277001',34.000000000,'1963-07-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5868,'PIEDAGNIEL','ROGER','1958-05-15','02.18.04.74.82',NULL,NULL,'13 RUE EMILE HERBLINE','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'2580561451001',42.000000000,'1988-11-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5869,'','FERNAND','1949-01-04','02.81.66.51.96','06.17.85.82.29',NULL,'','','','14220','BARBERY',NULL,NULL,'1490114514001',11.000000000,'1971-04-04','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5870,'DESHAYES','JEAN PIERRE','1962-04-15','02.77.30.41.51','06.88.47.33.62',NULL,'18 RUE DE LA BIVELLERIE','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'2620414578001',163.000000000,'1987-07-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5871,'HEMARD','MARIE','1930-02-18','02.66.88.95.05','06.20.98.94.98',NULL,'3 RUE DES HAUTS VENTS','','','14123','IFS',NULL,NULL,'1300214328001',1202.000000000,'1953-02-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5872,'DUDOUET','MONIQUE','1943-02-12','02.11.91.17.26','06.11.25.52.38',NULL,'LA MABILIERE','','','14000','CAEN',NULL,NULL,'1430214717001',90.000000000,'1973-08-15','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5873,'GAILLARD','MONIQUE','1952-02-02','02.36.47.12.24','06.65.27.91.56',NULL,'15 route de la gueriniere app 14','','','14000','CAEN',NULL,NULL,'1520214005001',384.000000000,'1982-04-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5874,'GAILLARD','NOEL','1940-01-29','02.42.03.64.67','06.24.09.89.92',NULL,'10 IMPASSE DU VERT GALAND','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1400127135001',519.000000000,'1970-06-11','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5875,'ROULAND','CLAUDINE','1962-01-29','02.56.78.38.31','06.30.65.21.76',NULL,'20 RUE DES ROSIERS','','','14150','OUISTREHAM',NULL,NULL,'2620138507001',314.000000000,'1984-05-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5876,'VASSEUR','MONIQUE','1953-02-09','02.57.98.78.17','06.45.43.96.20',NULL,'16 RUE DE LA REFORME','','','14400','BAYEUX',NULL,NULL,'2530214700001',824.000000000,'1982-06-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5877,'GUESNON','CHRISTOPHE','1962-04-06','02.45.93.23.44','06.73.92.89.41',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1620478107001',165.000000000,'1983-03-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5878,'MARIE','EVELYNE','1931-12-25','02.87.86.23.98','06.15.30.03.37',NULL,'20 BIS RUE DU NORD','','','61100','FLERS',NULL,NULL,'1311214717001',73.000000000,'1956-08-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5879,'BISSON','MICHEL','1933-06-16','02.55.44.57.94','06.78.27.78.74',NULL,'7 RUE DE LA VERGEE','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1330614309001',21.000000000,'1958-05-19','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5880,'JARDIN','BRIGITTE','1957-02-03','02.58.53.20.42','06.37.11.67.83',NULL,'10 RUE CONSTANT FORGET  BAT/2 C','LOS   DU BOIS','','14680','FRESNEY LE PUCEUX',NULL,NULL,'2570250222001',577.000000000,'1986-03-30','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5881,'ADAM','SYLVIE','1935-05-05','02.97.10.16.80','06.10.30.73.44',NULL,'13 bis rue des bluets','','','14630','EMIEVILLE',NULL,NULL,'2350514235001',33.000000000,'1962-07-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5882,'CORBET','CLAUDE','1932-05-02','02.11.17.31.66','06.35.33.08.77',NULL,'LE MANOIR 4 RUE RENE ROLLAND','','','14000','CAEN',NULL,NULL,'2320514327001',1273.000000000,'1955-11-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5883,'PREVEL','EUGENE','1944-03-21','02.33.18.51.92','06.61.33.64.22',NULL,'22 rue de stockholm','','','14000','CAEN',NULL,NULL,'2440314331001',16.000000000,'1974-08-10','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5884,'DIGNE','GINETTE','1945-01-06','02.35.99.07.19','06.37.79.39.37',NULL,'RESIDENCE CATHERINE DE LONG PRE','','','14000','CAEN',NULL,NULL,'1450114473001',41.000000000,'1975-09-11','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5885,'VILLARD','ROGER','1936-02-15','02.18.94.73.60','06.62.28.03.56',NULL,'60 RUE CHRISTCHURCH','','','14980','ROTS',NULL,NULL,'1360250639001',17.000000000,'1964-06-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5886,'BUISARD','MONIQUE','1936-02-12','02.69.76.72.11','06.79.63.44.23',NULL,'LE BOURG','','','14860','AMFREVILLE',NULL,NULL,'1360250639001',118.000000000,'1957-01-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5887,'TILLAUT','BERNARD','1962-09-18','02.11.63.82.60','06.30.79.68.40',NULL,'27 rue jules valles','','','14850','HEROUVILLETTE',NULL,NULL,'1620914319001',3578.000000000,'1984-07-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5888,'BALLOIS','JEAN JACQUES','1936-03-08','02.27.75.31.71','06.85.41.55.30',NULL,'31 rue leon marcotte','','','14000','CAEN',NULL,NULL,'1360314123001',1361.000000000,'1963-04-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5889,'DURAND','ODILE','1931-07-19','02.53.19.55.38','06.51.68.47.21',NULL,'27 RUE DE L''ARQUETTE','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1310750354001',543.000000000,'1958-07-31','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5890,'BESNIARD','Jean','1934-06-01','02.70.23.85.42','06.32.75.42.49',NULL,'16 rue gujan mestras','','',NULL,NULL,NULL,NULL,'1340650131001',2728.000000000,'1956-04-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5891,'VIARD','HENRI','1929-05-12','02.46.51.86.28','06.39.52.66.56',NULL,'7 RUE DE L''ECUREUIL','','','14370','BELLENGREVILLE',NULL,NULL,'1290514349001',16.000000000,'1950-05-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5892,'LECOUILLARD','PAUL','1928-02-02','02.92.99.63.75','06.11.06.24.85',NULL,'8 RUE D''IFS','','','14120','MONDEVILLE',NULL,NULL,'1280214382001',69.000000000,'1950-02-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5893,'DUCHESNAY','HELIANE','1966-08-15','02.23.19.61.68','06.29.33.03.32',NULL,'220 QUARTIER DU GRAND PARC','','','14270','MEZIDON CANON',NULL,NULL,'1660875022001',24.000000000,'1992-11-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5894,'GROULT','MARIE CLAIRE','1940-04-19','02.63.76.51.34','06.11.83.34.16',NULL,'124 RUE D''ANGERVILLE','','','14730','GIBERVILLE',NULL,NULL,'2400450340001',465.000000000,'1966-01-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5895,'TUBOEUF','SIMONNE','1939-11-22','02.10.55.97.69','06.81.82.93.75',NULL,'RUE DE LA HAIE BRETON','','','14480','TIERCEVILLE',NULL,NULL,'2391114447001',256.000000000,'1963-10-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5896,'CARDONNEL','FLORENCE','1938-09-03','02.10.65.53.34','06.38.03.91.42',NULL,'23 RUE DES CHANOINES','','','50880','LA MEAUFFE',NULL,NULL,'2380950196001',258.000000000,'1968-09-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5897,'ROUSSEL','JEAN CLAUDE','1934-07-30','02.64.78.62.72','06.16.22.85.42',NULL,'33 RUE DES FRERES LUMIERE','','','14000','CAEN',NULL,NULL,'1340714111001',22.000000000,'1958-08-31','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5898,'ROGER','JEAN','1928-12-15','02.17.77.51.47','06.10.13.31.50',NULL,'5 AVENUE MADAME DE SEGUR','','','61160','TRUN',NULL,NULL,'1281214572001',174.000000000,'1952-10-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5899,'LECORNU','FRANCOIS','1928-05-18','02.61.94.85.15','06.29.98.71.28',NULL,'LA BRUYERE','','','14130','PONT L''EVEQUE',NULL,NULL,'2280514482001',339.000000000,'1952-08-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5900,'LETESSE','ANDREE','1939-05-06','02.63.01.42.45','06.21.34.88.30',NULL,'10 RUE DE QUILLY','','','14410','VASSY',NULL,NULL,'2390527679001',284.000000000,'1966-07-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5901,'ROULT','PATRICIA','1936-08-26','02.20.30.26.32','06.54.98.83.66',NULL,'6 RUE DES FRERES LUMIERES','','','14280','ST CONTEST',NULL,NULL,'1360814408001',186.000000000,'1960-08-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5902,'LEVALOT','EMILE','1939-10-26','02.21.54.33.32','06.78.58.98.98',NULL,'HAMEAU DE LA MARE','','','14440','PLUMETOT',NULL,NULL,'2391014324001',72.000000000,'1964-02-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5903,'LARDEAU','JEAN','1966-07-09','02.10.58.72.14','06.89.40.88.54',NULL,'4 TER ROUTE D''HARCOURT','','','14280','AUTHIE',NULL,NULL,'1660761490001',25.000000000,'1987-09-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5904,'VASTEL','ANNICK','1970-02-26','02.82.72.97.39','06.73.89.03.81',NULL,'502 LE VAL','','','14400','BAYEUX',NULL,NULL,'1700214121001',46.000000000,'1991-09-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5905,'DEMAN','jean pierre','1940-03-02','02.54.14.66.71','06.99.38.78.55',NULL,'62 BIS BD LYAUTEY','','','14210','CHEUX',NULL,NULL,'2400350265001',211.000000000,'1966-10-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5906,'LECOEUR','JEAN','1938-05-30','02.32.73.56.60','06.31.11.77.29',NULL,'LE THEIL','','','14370','MOULT',NULL,NULL,'2380514346001',48.000000000,'1963-06-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5907,'CANTELOUP','BERNARD','1945-02-17','02.50.99.17.94','06.11.52.75.93',NULL,'49 bis rue de la mer','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1450250402001',1004.000000000,'1967-01-01','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5908,'HUET','DOMINIQUE','1951-01-17','02.28.06.58.19','06.31.25.59.64',NULL,'2 LE HAUT HAMMEAU','','','14123','IFS',NULL,NULL,'2510114178001',392.000000000,'1972-04-27','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5909,'LOCARD','SIMONE','1958-04-13',NULL,NULL,NULL,'154 BD LEROY','','','14540','SOLIERS',NULL,NULL,'2580427046001',1243.000000000,'1988-10-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5910,'RICHARD','NICOLE','1933-03-25','02.12.24.11.74',NULL,NULL,'41 RUE DES CARRIERES DE VAUCELLE','S','','14000','CAEN',NULL,NULL,'1330314408001',61.000000000,'1957-03-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5911,'LECOIS','JEAN','1937-01-06','02.77.89.76.20','06.47.67.57.83',NULL,'6 RUE DES BLEUETS','','','14370','CROISSANVILLE',NULL,NULL,'2370157597001',3416.000000000,'1961-04-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5912,'MARIE','MICHEL','1938-11-11','02.75.92.56.14','06.26.46.59.26',NULL,'29 RUE GENERAL REVEL','','','14350','LE BENY BOCAGE',NULL,NULL,'1381114039001',70.000000000,'1961-04-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5913,'PELCOT','JACQUELINE','1935-01-04','02.31.33.03.79','06.81.25.60.93',NULL,'10 ALLEE DE LA GLACIERE','','','14840','DEMOUVILLE',NULL,NULL,'1350114288001',85.000000000,'1965-04-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5914,'FERON','MICHEL','1932-01-02',NULL,NULL,NULL,'54 RUE DE NORTHAM','','','14000','CAEN',NULL,NULL,'1320114355001',20.000000000,'1953-10-16','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5915,'LELOHANT','ELISABETH','1955-03-12','02.61.91.18.22','06.63.85.59.94',NULL,'91 AVENUE CHARLEMAGNE','','','14120','MONDEVILLE',NULL,NULL,'2550314470001',557.000000000,'1976-01-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5916,'MORIN','JEAN PIERRE','1959-11-01','02.63.84.55.47','06.18.12.00.33',NULL,'LE VIEUX SALLEN','','','14150','OUISTREHAM',NULL,NULL,'1591114118001',389.000000000,'1988-02-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5917,'DE BROU','YVETTE','1937-09-01','02.68.94.21.56','06.17.11.37.21',NULL,'68 RUE DES LUTHIERS','','','14190','ST SYLVAIN',NULL,NULL,'1370933458001',25.000000000,'1960-11-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5918,'LE ROY','MAURICETTE','1948-02-06','02.47.40.62.91','06.11.55.07.90',NULL,'18 RUE AUX BOUETS','','','14320','MAY SUR ORNE',NULL,NULL,'1480261039001',762.000000000,'1975-07-09','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5919,'DAIGNEAU','JEAN','1939-08-17','02.50.43.73.88','06.45.17.00.40',NULL,'22 RUE GEORGES BRASSENS','','','14320','MAY SUR ORNE',NULL,NULL,'1390814346001',79.000000000,'1964-11-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5920,'SPINGA','SIMONE','1928-03-31','02.49.89.10.72','06.10.77.51.39',NULL,'','','','14400','SOMMERVIEU',NULL,NULL,'1280314203001',68.000000000,'1949-05-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5921,'BILLARD','ANNICK','1936-09-05','02.57.91.13.20','06.61.09.20.53',NULL,'chemin de l eglise','','','14260','JURQUES',NULL,NULL,'2360914675001',17.000000000,'1958-10-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5922,'RUBLON','HUBERT','1937-11-23','02.11.37.04.09','06.71.07.95.61',NULL,'15 RUE EDITH','','','14250','AUDRIEU',NULL,NULL,'1371188163001',17.000000000,'1967-01-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5923,'WAHRENBERGER','DELPHINE','1934-09-08','02.10.92.41.68','06.89.39.81.74',NULL,'','','','14630','CAGNY',NULL,NULL,'2340914534001',37.000000000,'1956-07-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5924,'LEMONNIER','CLAUDE','1936-01-29','02.72.38.16.31','06.41.62.75.74',NULL,'146 rtede bretagne','','','14000','CAEN',NULL,NULL,'2360150220001',11.000000000,'1964-10-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5925,'NICOLLE','PIERRE','1934-05-18','02.41.55.25.90','06.32.49.47.15',NULL,'8 RUE COLLEVILLE MONTGOMERY','','','61700','DOMFRONT',NULL,NULL,'1340527289001',348.000000000,'1959-09-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5926,'MOUTON','BRIGITTE','1968-11-24','02.91.18.11.49','06.50.15.48.21',NULL,'26 ROUTE DES RENARDIERES  HAMEAU',' DE COUPIGNY','',NULL,NULL,NULL,NULL,'1681183032001',87.000000000,'1990-04-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5927,'HOLLER','REMY','1954-01-07','02.72.37.18.68','06.35.62.19.06',NULL,'1BIS RUE ROGER DECHAMBRE','','','14370','CROISSANVILLE',NULL,NULL,'2540114340001',9.000000000,'1984-02-05','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5928,'VIGNERON','NOELLE','1936-08-17','02.15.66.85.99','06.85.74.83.21',NULL,'2 CHEMIN DES HARNOTS','','','14790','VERSON',NULL,NULL,'1360814328001',2277.000000000,'1958-02-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5929,'CAILLEAU','REGINE','1931-09-19','02.28.31.44.91','06.10.00.94.06',NULL,'LE BOURG','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'2310914711001',13.000000000,'1952-10-10','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5930,'LEBEL','LOUIS','1936-01-15','02.86.86.34.99','06.41.01.56.58',NULL,'19 RUE CALMETTE','','','14380','ST SEVER CALVADOS',NULL,NULL,'1360176452001',23.000000000,'1963-07-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5931,'LAINEY','ERIC','1930-12-06','02.19.47.98.21','06.85.62.23.12',NULL,'7 rue porte millet','','','14123','IFS',NULL,NULL,'2301250644001',8.000000000,'1958-01-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5932,'RENARD','BERNARD','1936-11-17','02.71.75.58.60','06.87.13.20.13',NULL,'le haut de la rue','','','14123','IFS',NULL,NULL,'2361114046001',105.000000000,'1965-12-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5933,'BIDAULT','CLAUDE','1968-02-27','02.31.14.63.76','06.10.86.80.48',NULL,'les enclos','','','14220','PLACY',NULL,NULL,'2680214020001',927.000000000,'1997-02-11','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5934,'BEAUNIEUX','MARIE JEANNE','1929-08-19','02.14.44.74.92',NULL,NULL,'RUE ROCHEFORT','','','14850','ESCOVILLE',NULL,NULL,'2290814679001',906.000000000,'1951-03-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5935,'LEROY','ALINE','1937-06-29','02.60.02.01.57','06.41.63.33.22',NULL,'11 RUE DU MOULIN','','','14000','CAEN',NULL,NULL,'1370614429001',274.000000000,'1962-12-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5936,'VERNANT','PIERRE','1937-05-28','02.14.53.53.02','06.89.75.67.13',NULL,'74 RUE ST PATRICE','','',NULL,NULL,NULL,NULL,'1370514432001',383.000000000,'1960-01-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5937,'LEJEUNE','THERESE','1959-02-19','02.56.26.79.95','06.62.12.81.63',NULL,'','','','14000','CAEN',NULL,NULL,'2590214556001',11.000000000,'1981-03-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5938,'DELRIEUX','CHARLES','1936-04-25','02.68.32.34.71','06.38.81.17.52',NULL,'38 ROUTE DE BALLEROY','','','14370','CROISSANVILLE',NULL,NULL,'2360414137001',90.000000000,'1966-08-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5939,'LEPELTIER','RENE','1943-01-12','02.31.61.24.83','06.90.97.66.72',NULL,'7 RES DE LA VALLEE RUE DE LA POR','CELAINE','','14170','BERVILLE',NULL,NULL,'1430129279001',15.000000000,'1966-08-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5940,'SIMBAGOYE','SUZANNE','1939-02-23','02.38.03.94.69','06.46.35.54.66',NULL,'1 IMPASSE DE LA FONTAINE','','','14860','AMFREVILLE',NULL,NULL,'1390214554001',367.000000000,'1960-05-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5941,'LAFONTAINE','MARIE ANGE','1929-03-24','02.78.31.25.91','06.63.27.00.99',NULL,'17 RUE LOUIS ROBILLARD','','','50680','ST CLAIR SUR L''ELLE',NULL,NULL,'1290314349001',1081.000000000,'1951-09-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5942,'SOBOL','SUZANNE','1959-05-10','02.24.34.98.19','06.70.79.35.19',NULL,'9 RUE LOUIS BALLIERE','','',NULL,NULL,NULL,NULL,'1590578576001',86.000000000,'1982-03-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5943,'BUENO','ROLAND','1949-03-07','02.14.84.61.32','06.97.60.99.66',NULL,'21 RUE DE VILLONS','','','14460','COLOMBELLES',NULL,NULL,'2490361199001',84.000000000,'1974-05-24','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5944,'BASNEL','SIMONNE','1935-06-10','02.90.92.07.12','06.45.42.81.14',NULL,'24 RUE ARISTIDE BRIAND','','','14320','LAIZE LA VILLE',NULL,NULL,'1350614413001',58.000000000,'1964-11-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5945,'BLONDEL','ALBERT','1947-01-28','02.11.23.30.32','06.23.42.96.11',NULL,'90 quai vendeuvre','','','14230','ISIGNY SUR MER',NULL,NULL,'1470150092001',3174.000000000,'1968-07-19','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5946,'PETIT','FRANCOISE','1944-12-12','02.14.01.88.68','06.47.04.65.39',NULL,'','','','14940','SANNERVILLE',NULL,NULL,'2441214094001',116.000000000,'1965-02-07','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5947,'LEGRAND','DANIEL','1937-08-24','02.11.21.72.68','06.57.03.06.23',NULL,'LA CROIX DU HAMEL','','','14270','OUEZY',NULL,NULL,'2370850612001',1444.000000000,'1959-06-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5948,'BURNOUF','lucien','1934-06-13','02.70.57.87.93','06.31.16.78.60',NULL,'chemin du radier','','','14220','ST MARTIN DE SALLEN',NULL,NULL,'2340614090001',100.000000000,'1957-11-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5949,'LOIZEAU','MONIQUE','1932-04-19','02.64.93.19.92','06.11.55.99.51',NULL,'37 AVENUE SECRETAN','','','14480','BANVILLE',NULL,NULL,'2320450110001',93.000000000,'1961-11-05','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5950,'BUENOMERINO','YVETTE','1930-03-25','02.23.64.15.91','06.57.77.96.54',NULL,'35 rue del liberte','','','14840','DEMOUVILLE',NULL,NULL,'2300314273001',133.000000000,'1952-06-14','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5951,'SOBOL','GINETTE','1934-12-09','02.42.43.38.03','06.31.26.04.22',NULL,'LA SAGERE','','','14400','ETREHAM',NULL,NULL,'2341250509001',683.000000000,'1964-11-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5952,'PETIT','FRANCIS','1958-12-17','02.78.54.60.40','06.27.77.70.06',NULL,'','','','14460','COLOMBELLES',NULL,NULL,'2581214203001',53.000000000,'1979-10-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5953,'TOUZE','DANIEL','1963-02-02','02.11.35.73.89','06.46.58.40.06',NULL,'115 RUE D AUGE','','','14860','RANVILLE',NULL,NULL,'2630227244001',9.000000000,'1985-06-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5954,'BONNAL','DENISE','1935-06-27','02.60.73.88.11','06.17.35.96.75',NULL,'5, rue de la madeleine','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1350661444001',467.000000000,'1957-02-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5955,'HARDEL','JACQUES','1940-11-02','02.20.03.13.64','06.15.02.54.43',NULL,'3 impasse de la plaine','','','14000','CAEN',NULL,NULL,'1401114118001',195.000000000,'1965-10-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5956,'TALVAST','THERESE','1932-06-12','02.48.27.15.54','06.84.88.12.47',NULL,'14/2 rue du 6 juin','','','14670','ST SAMSON',NULL,NULL,'1320650225001',46.000000000,'1961-01-28','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5957,'PROFIT','GUY','1928-09-01','02.68.33.97.63','06.13.09.79.84',NULL,'29 rue du 4 juillet 1944','','','14210','EVRECY',NULL,NULL,'2280950268001',4142.000000000,'1958-12-11','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5958,'LEMARCHAND','DOMINIQUE','1950-01-02','02.57.45.16.52','06.55.43.38.42',NULL,'50  rue des brocs','','','14000','CAEN',NULL,NULL,'2500114266001',188.000000000,'1979-12-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5959,'LIENART','JACQUELINE','1938-08-31','02.61.88.01.61','06.40.08.56.65',NULL,'8 RUE DES AIRBORNES','','','14000','CAEN',NULL,NULL,'1380814173001',31.000000000,'1966-02-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5960,'THERESE DIT DUCHEMIN','ANDRE','1949-01-13','02.91.28.13.16','06.70.36.11.59',NULL,'10 rue du champ fleurie','','',NULL,NULL,NULL,NULL,'1490161354001',322.000000000,'1972-01-31','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5961,'FOSSE','DENISE','1958-01-13','02.10.75.44.48','06.16.11.22.13',NULL,'20 rue de la moinerie','','','14000','CAEN',NULL,NULL,'2580176390001',13.000000000,'1988-04-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5962,'','SERGE','1945-09-11','02.71.93.97.85','06.59.12.18.31',NULL,'LE PONT MULOT','','','14111','LOUVIGNY',NULL,NULL,'1450914749001',152.000000000,'1969-07-08','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5963,'DELAUNEY','ALAIN','1930-11-11','02.75.90.18.92','06.19.91.83.24',NULL,'7  RUE DES SOURCES','','','14000','CAEN',NULL,NULL,'1301161293001',37.000000000,'1955-12-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5964,'HELAINE','GENEVIEVE','1947-03-11','02.18.85.33.29','06.12.01.23.26',NULL,'10 RUE DE BIENVILLE LE CHALET','','','14370','BELLENGREVILLE',NULL,NULL,'2470314737001',337.000000000,'1968-04-06','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5965,'GEOFFROY','JOSEPH','1947-03-21','02.35.73.25.80','06.11.65.22.86',NULL,'13 RUE ALEXANDRE','','','14460','COLOMBELLES',NULL,NULL,'1470340139001',150.000000000,'1977-03-15','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5966,'LEFOULON','BERNARD','1940-06-13','02.69.46.78.04','06.65.80.55.32',NULL,'28 RUE DES CHASSES','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2400614411001',2789.000000000,'1970-05-15','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5967,'BISSON','LOUIS','1979-05-21','02.47.97.46.17','06.62.27.08.58',NULL,'rue de la justice','','','14120','MONDEVILLE',NULL,NULL,'2790529105001',1594.000000000,'2001-12-28','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5968,'HUREL','RENEE','1933-07-06','02.71.95.97.53','06.49.09.57.90',NULL,'CHEMIN DES BRUYERES','','','14540','BOURGUEBUS',NULL,NULL,'1330714381001',16.000000000,'1955-04-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5969,'FORTIN','JEAN','1932-11-25','02.92.78.52.65','06.45.70.10.54',NULL,'38 RUE DU ST GRAAL','','',NULL,NULL,NULL,NULL,'1321161089001',15.000000000,'1961-01-11','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5970,'BOUTELOUP','DENISE','1939-02-07','02.38.43.59.87','06.31.65.50.82',NULL,'LA CAVEE','','','14460','COLOMBELLES',NULL,NULL,'2390214441001',426.000000000,'1965-01-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5971,'MULLOIS','GUY','1948-01-19','02.68.87.15.81','06.28.61.65.41',NULL,'2 impasse du chron','','','14400','CROUAY',NULL,NULL,'1480150285001',716.000000000,'1973-06-24','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5972,'BINET','ROGER','1935-06-28','02.87.05.31.68','06.10.80.29.55',NULL,'5 RUE FRANCOIS MOISANT','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2350614735001',14.000000000,'1958-01-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5973,'JACQUES','','1936-02-27','02.69.76.10.67','06.26.79.28.36',NULL,'9 RUE DES CHEVREFEUILLES','','','14000','CAEN',NULL,NULL,'2360214348001',911.000000000,'1958-07-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5974,'DELISLE','SOLANGE MARIE','1956-01-24','02.11.36.88.82','06.71.48.81.78',NULL,'7 RUE DE L AVENIR','','','14120','MONDEVILLE',NULL,NULL,'2560114610001',808.000000000,'1979-06-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5975,'YAGOUNI','NICOLLE','1964-06-16','02.22.49.59.94','06.11.76.15.71',NULL,'12 AVENUE DE LA CONCORDE BAT 17',' PORTE 53','','14610','CAMBES EN PLAINE',NULL,NULL,'2640614288001',299.000000000,'1986-04-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5976,'LEBONNOIS','claude','1929-07-26','02.13.19.85.43','06.18.72.33.44',NULL,'le veau canut','','','14000','CAEN',NULL,NULL,'2290714659001',111.000000000,'1952-05-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5977,'MABIRE','GEORGETTE','1942-01-15','02.13.13.61.62','06.24.79.17.48',NULL,'LA MAISON BLANCHE','','','50160','GUILBERVILLE',NULL,NULL,'2420114145001',5.000000000,'1965-02-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5978,'D HAENE','CLAUDINE','1969-03-16','02.12.30.75.74',NULL,NULL,'19 RUE SAINT MARC','','','14120','MONDEVILLE',NULL,NULL,'2690361169001',457.000000000,'1999-10-31','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5979,'DU MESNIL DU BUISSON','ODILE','1936-01-05','02.49.83.09.62','06.21.00.65.50',NULL,'HAMEAU BOEUF','','','14690','TREPREL',NULL,NULL,'1360114410001',24.000000000,'1961-08-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5980,'QUEVAL','GEORGETTE','1950-03-13','02.49.18.29.09','06.44.79.21.62',NULL,'','','','50350','DONVILLE LES BAINS',NULL,NULL,'1500314436001',3754.000000000,'1980-02-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5981,'MAHIER','BEATRICE','1957-01-19','02.17.05.05.10','06.80.83.03.54',NULL,'LA VALLEE','','','14280','ST CONTEST',NULL,NULL,'1570114692001',4.000000000,'1985-12-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5982,'JAMES','BERNARD','1966-12-31','02.19.14.20.19','06.19.36.68.62',NULL,'24 rue des coteaux','','','14000','CAEN',NULL,NULL,'2661214114001',175.000000000,'1992-07-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5983,'VASSE','GILLES','1937-12-22','02.69.68.82.25','06.82.55.94.62',NULL,'2 CHEMIN AUX BOEUFS','','','14123','IFS',NULL,NULL,'2371214254001',18.000000000,'1966-06-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5984,'ROUSSEL','J FRANCOIS','1937-03-19','02.28.21.31.20','06.28.08.29.10',NULL,'9 ROUTE DE CAEN','','','14370','ARGENCES',NULL,NULL,'2370314309001',263.000000000,'1960-04-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5985,'THIRON','KLEBER','1935-01-28','02.85.31.31.91','06.85.17.99.68',NULL,'3 rue du languedoc','','','14000','CAEN',NULL,NULL,'1350150512001',366.000000000,'1957-07-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5986,'AUBREE','DANIEL','1959-09-23','02.79.85.02.97','06.34.25.62.66',NULL,'403 quartier duval','','','14480','CREULLY',NULL,NULL,'2590972034001',77.000000000,'1980-07-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5987,'LEFEVRE','gilbert','1940-04-24','02.86.25.51.08','06.67.52.14.15',NULL,'3 RUE DE BOURGOGNE','','','14670','ST PIERRE DU JONQUET',NULL,NULL,'2400450528001',30.000000000,'1964-01-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5988,'CHARDIN','JEAN MARIE','1933-05-14','02.11.29.29.73','06.55.30.35.18',NULL,'7 ALLEE DE VIENNE','','','14000','CAEN',NULL,NULL,'1330514211001',114.000000000,'1963-10-19','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5989,'FORGET','ANNE MARIE','1944-02-14','02.85.65.46.53','06.30.74.80.18',NULL,'4 IMPASSE DES PIVOINES','','','14000','CAEN',NULL,NULL,'1440214120001',6.000000000,'1968-10-17','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5990,'PORTIER','THIERRY','1965-05-22','02.92.51.32.04','06.39.73.06.07',NULL,'LIGNEROLLES','','','14940','SANNERVILLE',NULL,NULL,'1650514205001',63.000000000,'1995-06-11','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5991,'BERTRAND','MARTINE','1987-06-17','02.20.53.63.65','06.90.79.63.88',NULL,'16 TERRE ROUTE DE PARIS','','','14270','MEZIDON CANON',NULL,NULL,'1870699237001',2.000000000,'2012-12-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5992,'CHAUVEL','JANINE','1934-06-10','02.91.28.56.26','06.52.93.59.02',NULL,'','','','14000','CAEN',NULL,NULL,'1340650577001',217.000000000,'1961-12-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5993,'OSMONT','ERIC','1939-11-07','02.38.85.25.22','06.77.16.37.79',NULL,'le moutier','','','14480','BANVILLE',NULL,NULL,'1391114548001',26.000000000,'1962-05-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5994,'BARBE','BERNADETTE','1935-05-13','02.81.79.20.56','06.11.77.80.52',NULL,'27 RUE DU DEVON','','','14670','TROARN',NULL,NULL,'2350527099001',133.000000000,'1959-07-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5995,'LEVARD','NICOLE','1938-05-12','02.38.05.65.05','06.91.06.62.11',NULL,'4 ROUTE DES MARAIS st symphorien',' le vallois','','14370','ARGENCES',NULL,NULL,'1380553019001',681.000000000,'1965-01-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5996,'BRIARD','SOLANGE','1942-01-27','02.20.44.89.37','06.42.09.12.21',NULL,'4 RUE DU MOULIN','','','14000','CAEN',NULL,NULL,'2420161075001',61.000000000,'1971-02-28','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5997,'AMELINE','JEAN','1967-05-01','02.46.37.81.27','06.74.06.14.86',NULL,'64 RUE DE LA MARNE','','','14240','LIVRY',NULL,NULL,'2670514383001',165.000000000,'1989-06-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5998,'LEGARDIEN','MAURICE','1942-09-11','02.76.25.02.41','06.90.00.99.48',NULL,'','','','14500','VIRE',NULL,NULL,'2420927168001',13.000000000,'1964-11-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (5999,'','XAVIER','1929-12-01','02.74.89.40.24',NULL,NULL,'6 RUE PIQUET APPT 11','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'2291250029001',31.000000000,'1953-05-01','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6000,'ANJOU','','1946-01-09','02.10.65.14.46','06.83.81.26.17',NULL,'9 RUE BELLEVUE','','','14670','ST PIERRE DU JONQUET',NULL,NULL,'1460161119001',340.000000000,'1969-05-21','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6001,'CHATELAIN','ANDREE','1932-04-23','02.85.19.84.81','06.50.05.67.06',NULL,'18 RUE DES FRERES WILKIN','','','14370','AIRAN',NULL,NULL,'2320414387001',700.000000000,'1956-06-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6002,'DEVIC','JEANNE','1936-10-13','02.33.23.58.75','06.89.81.92.98',NULL,'10 cit jicquel','','',NULL,NULL,NULL,NULL,'2361014514001',92.000000000,'1960-02-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6003,'LARUE','JEANNINE','1931-05-16','02.94.10.97.89','06.81.68.40.40',NULL,'25 AVENUE DU DOCTEUR BRANLY','','','14190','FIERVILLE BRAY',NULL,NULL,'1310586193001',2955.000000000,'1960-07-15','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6004,'LORIOT','ELIANE','1982-10-11','02.31.46.62.44','06.51.28.18.58',NULL,'52 rue des cailloins','','','14730','GIBERVILLE',NULL,NULL,'2821099412001',1263.000000000,'2004-12-15','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6005,'HEBERT','ANTOINETTE','1954-05-22','02.74.76.06.02',NULL,NULL,'les hauts pallines','','','14123','IFS',NULL,NULL,'1540576483001',132.000000000,'1977-05-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6006,'COQUEREL','bernard','1955-06-13','02.80.55.51.37','06.78.02.81.64',NULL,'7 rue des auges','','','14270','MEZIDON CANON',NULL,NULL,'2550614322001',1022.000000000,'1985-07-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6007,'MARIE','MICHEL','1958-07-27','02.21.11.27.52','06.68.43.76.29',NULL,'1 RUE DENIS DIDEROT PORTE 4','','','14370','ARGENCES',NULL,NULL,'2580702088001',2.000000000,'1980-09-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6008,'DESAUNAY','DENIS','1945-04-23','02.38.06.69.37','06.18.13.12.07',NULL,'LA RUELLE','','','14790','VERSON',NULL,NULL,'1450475048001',39.000000000,'1974-02-15','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6009,'VALLEE','PIERRE',NULL,'02.14.25.66.51','06.34.68.09.27',NULL,'45 AVENUE DU 6 JUIN','','','14000','CAEN',NULL,NULL,'1361150639001',41.000000000,'2009-12-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6010,'LEMONNIER','RAYMOND','1955-06-03','02.57.79.56.66','06.10.94.88.56',NULL,'33 RUE DES FRERES LUMIERE','','','14730','GIBERVILLE',NULL,NULL,'2550614322001',196.000000000,'1976-02-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6011,'BOUTELOUP','PIERRE','1938-01-23','02.34.05.32.27','06.80.96.32.48',NULL,'1829 rue de bretteville','','','14123','FLEURY SUR ORNE',NULL,NULL,'1380114371001',15.000000000,'1960-07-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6012,'MOUCHEL','MICHEL','1938-02-02','02.79.45.16.51','06.10.84.11.71',NULL,'7 RUE DU DOCTEUR ROUX','','','14220','BARBERY',NULL,NULL,'1380227637001',73.000000000,'1961-05-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6013,'MAIGNAN','GILLES','1937-02-11','02.16.64.06.25','06.84.27.36.12',NULL,'VILLERS CANIVET','','','41600','LAMOTTE BEUVRON',NULL,NULL,'1370250498001',620.000000000,'1967-06-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6014,'BERTOLI','MICHELINE','1931-07-11','02.47.74.36.62',NULL,NULL,'8 RUE DE MARTAINVILLE','','','14460','COLOMBELLES',NULL,NULL,'2310714672001',33.000000000,'1953-08-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6015,'CABOURET','JEAN CLAUDE','1955-04-30','02.77.45.03.47','06.19.99.09.89',NULL,'29 RUE DAMOZANNE APPT/207','','','14730','GIBERVILLE',NULL,NULL,'2550414503001',229.000000000,'1976-02-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6016,'LEBRUN','ANDRE','1934-07-11','02.73.43.07.98','06.29.96.90.91',NULL,'6 RUE PIERRE SEMARD','','','14100','LISIEUX',NULL,NULL,'2340772044001',36.000000000,'1964-07-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6017,'PETIT','Rene','1931-06-12','02.36.00.27.87','06.80.73.33.14',NULL,'4 rue du Petit Bonheur','','','14610','EPRON',NULL,NULL,'1310676754001',579.000000000,'1954-01-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6018,'BAUCHER','GENEVIEVE','1928-12-05','02.44.56.60.44','06.36.74.55.46',NULL,'15 AVENUE DU GENERAL LECLERC','','','14370','MOULT',NULL,NULL,'1281214020001',601.000000000,'1953-11-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6019,'DUARTE DA ROSA','SUZANNE','1933-04-15','02.88.82.82.64','06.80.48.27.25',NULL,'18 RUE DE LA PILLARDIERE','','','14850','HEROUVILLETTE',NULL,NULL,'1330414691001',753.000000000,'1962-10-30','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6020,'BOUCHER','JEAN MARIE','1932-02-03','02.79.14.51.31','06.71.17.90.65',NULL,'36 rue jean paul marat','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1320214248001',113.000000000,'1953-03-31','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6021,'GOSSELIN','MONIQUE','1933-06-24','02.27.84.41.95','06.19.72.96.70',NULL,'7 RESIDENCE MARCEL PAUL','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2330650010001',126.000000000,'1961-05-24','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6022,'MALGRAIN','FRANCK','1949-01-20','02.30.38.71.19','06.83.22.89.64',NULL,'6 8 AVENUE GUYNEMER','','','14880','HERMANVILLE SUR MER',NULL,NULL,'2490150103001',93.000000000,'1972-03-08','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6023,'HENRY','MARTHE','1934-10-30','02.11.77.05.90','06.58.20.99.89',NULL,'10 RUE DE VALLEUIL','','','14150','OUISTREHAM',NULL,NULL,'2341014586001',2119.000000000,'1963-01-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6024,'PERRET','MADELEINE','1948-01-16','02.44.19.99.28','06.40.79.33.76',NULL,'21 RUE DU TUMULUS','','','14000','CAEN',NULL,NULL,'2480114221001',179.000000000,'1970-08-17','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6025,'DESRUES','GENEVIEVE','1943-04-30','02.40.26.67.08','06.63.12.64.40',NULL,'18 grande rue','','','14000','CAEN',NULL,NULL,'1430414037001',168.000000000,'1965-03-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6026,'GEFFROY','serge','1935-12-23','02.11.65.83.75','06.97.65.41.80',NULL,'322 LES BELLES PORTES','','','14000','CAEN',NULL,NULL,'1351214320001',1930.000000000,'1965-08-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6027,'FLORCHINGER','GILBERT','1957-06-19','02.51.34.81.24','06.53.50.92.89',NULL,'233 rue de falaise','','','14000','CAEN',NULL,NULL,'2570627512001',727.000000000,'1983-01-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6028,'ROLLAND','RENE','1957-01-10','02.35.15.58.58','06.86.22.39.24',NULL,'12 bvd boivin champeau','','','14260','AUNAY SUR ODON',NULL,NULL,'2570114747001',920.000000000,'1982-07-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6029,'TOSTAIN','MIREILLE','1958-02-08','02.98.76.82.49','06.98.79.39.15',NULL,'1 RUE COMMANDANT CHARCOT','','',NULL,NULL,NULL,NULL,'1580214611001',24.000000000,'1981-02-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6030,'CAPPELLO','SERGE','1947-10-02','02.55.99.97.99','06.10.59.51.42',NULL,'RUE DE BOULON','','','14123','IFS',NULL,NULL,'2471014223001',184.000000000,'1976-12-10','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6031,'DUCHEMIN','GENEVIEVE','1938-02-05','02.41.69.86.01','06.56.27.35.81',NULL,'34 rue georges clemenceau','','','14000','CAEN',NULL,NULL,'1380214433001',5.000000000,'1963-10-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6032,'AMET','CHRISTIAN','1945-01-06','02.86.26.82.88','06.42.82.63.10',NULL,'44 place des drakkars','','','14000','CAEN',NULL,NULL,'1450114406001',5071.000000000,'1975-08-10','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6033,'NOEL','DANIEL','1938-07-01','02.40.87.76.39','06.31.75.81.60',NULL,'11 RUE DE L''EGLISE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1380750570001',205.000000000,'1962-09-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6034,'HUET','jacques','1937-09-19','02.51.61.17.20','06.81.06.31.26',NULL,'LE BOIS DU PARC','','','14480','CREULLY',NULL,NULL,'1370961387001',72.000000000,'1964-03-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6035,'MALASSIGNE','MICHEL','1938-08-31','02.49.68.61.31','06.94.27.21.74',NULL,'5 rue traversiere','','','14000','CAEN',NULL,NULL,'2380814245001',1415.000000000,'1960-01-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6036,'RAPEAUD','YVONNE','1966-06-29','02.63.20.22.62','06.20.88.11.15',NULL,'7 SQUARE DES MESANGES ET DES ROU','GES GORGES','','14630','CAGNY',NULL,NULL,'2660675073001',46.000000000,'1991-01-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6037,'PONTAIS','CORINNE','1963-06-23','02.14.86.58.01','06.69.30.96.86',NULL,'42 RUE D''HARMONVILLE','','','14840','DEMOUVILLE',NULL,NULL,'1630661237001',15.000000000,'1990-07-31','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6038,'DELASALLE','JANINE','1942-01-27','02.32.90.35.53','06.62.21.17.30',NULL,'1 RESIDENCE DU PARC PLACE NICOL','AS POUSSIN','','14250','FONTENAY LE PESNEL',NULL,NULL,'2420161075001',14.000000000,'1965-10-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6039,'GODOY','MADELEINE','1963-02-20','02.50.51.15.62','06.10.79.17.78',NULL,'5. rue des aubepines','','','14170','BERVILLE',NULL,NULL,'1630214668001',610.000000000,'1990-12-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6040,'VIVIEN','MONIQUE','1938-08-16','02.81.41.87.91','06.35.58.32.26',NULL,'43 BD DE RETHEL','','','14740','ROSEL',NULL,NULL,'1380861025001',59.000000000,'1964-10-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6041,'CORBET','DANIEL','1932-04-27','02.20.02.88.28','06.16.84.29.63',NULL,'46 RUE ALBERT CAMUS','','','14123','IFS',NULL,NULL,'1320414565001',163.000000000,'1960-09-29','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6042,'CONFLANT','RAYMONDE','1969-11-18','02.76.80.45.23','06.55.88.88.52',NULL,'HAMEAU DE BOUGY','','','14320','FONTENAY LE MARMION',NULL,NULL,'2691114499001',1471.000000000,'1993-10-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6043,'IVON','PATRICK','1938-03-15','02.46.27.37.20','06.78.68.42.64',NULL,'LA COUTERIE','','','14520','COMMES',NULL,NULL,'1380314623001',26.000000000,'1961-11-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6044,'SONNET','GISELE','1945-07-28','02.34.39.16.44','06.14.27.35.38',NULL,'4 imp des giroflets','','','14000','CAEN',NULL,NULL,'2450714510001',35.000000000,'1973-08-14','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6045,'POTTIER','pierre','1952-10-08','02.10.91.23.72','06.79.62.72.23',NULL,'90 RUE BICOQUET','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2521014379001',1408.000000000,'1977-07-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6046,'DUMONT','THERESE','1940-07-30','02.56.71.57.95','06.87.63.41.87',NULL,'RESIDENCE BELLE VUE 4 CHEMIN ST','GERMAIN','','14123','IFS',NULL,NULL,'2400714689001',11.000000000,'1967-04-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6047,'PROFIT','FERNAND','1936-02-25','02.30.63.65.98','06.56.08.79.76',NULL,'21  rue de la butte','','','14000','CAEN',NULL,NULL,'2360214100001',12.000000000,'1964-06-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6048,'HEBERT','BLANDINE','1939-03-16','02.69.17.55.02','06.11.60.41.50',NULL,'8 ROUTE DE COURSEULLES','','','14530','LUC SUR MER',NULL,NULL,'2390314170001',591.000000000,'1966-12-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6049,'JEGOU','CHRISTIANE','1937-02-16','02.66.77.35.19','06.73.10.96.43',NULL,'1 RESIDENCE DE LA MORINIERE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2370214020001',399.000000000,'1960-01-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6050,'','SIMONNE','1940-12-28','02.68.89.51.30','06.51.18.51.66',NULL,'37 RUE DES TENNIS','','',NULL,NULL,NULL,NULL,'1401214290001',915.000000000,'1962-01-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6051,'DELACOUR','BERNARD','1933-03-29',NULL,NULL,NULL,'','','','14470','COURSEULLES SUR MER',NULL,NULL,'1330361123001',32.000000000,'1958-08-14','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6052,'DELVAL','GEORGES','1948-02-27','02.75.68.81.55','06.10.89.67.34',NULL,'56 rue pasteur','','','14370','MOULT',NULL,NULL,'1480214237001',1068.000000000,'1978-06-28','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6053,'MAZAN','ODILE','1932-07-22','02.29.44.53.35','06.10.96.60.46',NULL,'30 B RUE DES HAUTS VENTS','','','14120','MONDEVILLE',NULL,NULL,'2320750333001',17.000000000,'1954-12-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6054,'RESSENCOURT','PAULETTE','1936-07-06','02.51.82.35.93','06.75.73.33.18',NULL,'23. route de l aigle','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2360714133001',84.000000000,'1958-10-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6055,'FAUVEL','MARIE CLAIRE','1933-05-02','02.57.78.21.82','06.93.25.74.79',NULL,'10 route national','','','14123','IFS',NULL,NULL,'2330514532001',279.000000000,'1954-07-20','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6056,'BASNIER','CHRISTIANE','1931-05-14','02.30.34.87.75','06.22.10.36.95',NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2310514546001',64.000000000,'1952-07-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6057,'QUENOT','JEAN','1933-09-24','02.88.18.17.24','06.81.24.55.90',NULL,'ROUTE DE STE HONORINE DU FAY','','','14630','FRENOUVILLE',NULL,NULL,'1330961209001',142.000000000,'1957-05-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6058,'MARTIN','JEAN','1937-05-30','02.43.92.78.46','06.41.91.90.35',NULL,'14 RUE DE LA FRESNAYE','','','14000','CAEN',NULL,NULL,'2370514347001',174.000000000,'1958-04-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6059,'EUDINE','JACQUELINE','1935-01-27','02.15.11.14.44','06.25.27.45.65',NULL,'village le vieux vouet','','','14460','COLOMBELLES',NULL,NULL,'2350114271001',2.000000000,'1958-07-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6060,'HUE','NICOLE','1932-12-28','02.14.16.05.97','06.73.81.47.71',NULL,'3 RUE VICTOR HUGO','','','14540','SOLIERS',NULL,NULL,'2321250580001',385.000000000,'1958-10-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6061,'BOUSSELET','JACQUES','1937-01-05','02.33.96.84.00','06.69.31.13.58',NULL,'12. RUE SAINT GABRIEL','','','50270','BARNEVILLE CARTERET',NULL,NULL,'1370101357001',3787.000000000,'1967-12-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6062,'THIEBAUT','MARIE THERESE','1938-06-01','02.30.00.01.49','06.74.14.88.45',NULL,'8 RESIDENCE DES MAUVIS','','','14123','IFS',NULL,NULL,'1380614652001',364.000000000,'1962-10-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6063,'VANDEWIELE GIBOT','PATRICIA','1962-10-13','02.31.80.74.12',NULL,NULL,'5 rue joseph delente','','','14610','COLOMBY SUR THAON',NULL,NULL,'1621014211001',135.000000000,'1985-04-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6064,'HAIRY','MADELEINE','1956-04-14','02.63.37.55.66','06.81.17.94.13',NULL,'24 rue de l''ancienne gard','','','14000','CAEN',NULL,NULL,'2560414168001',48.000000000,'1978-06-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6065,'RONDEAU','PIERRE','1929-04-22',NULL,NULL,NULL,'hameau la croix carelle','','','14880','HERMANVILLE SUR MER',NULL,NULL,'1290450639001',25.000000000,'1952-03-31','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6066,'LELIEVRE','JEAN','1965-06-01','02.99.73.44.38','06.76.62.43.66',NULL,'3 RUE GENERAL REVEL','','','14000','CAEN',NULL,NULL,'2650614408001',211.000000000,'1990-02-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6067,'BIGOT','ROLAND','1928-06-14','02.63.26.74.98',NULL,NULL,'8 RUE DES FOLLIERES','','','14460','COLOMBELLES',NULL,NULL,'1280661153001',14.000000000,'1957-05-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6068,'MARESQ','GINETTE','1944-02-06','02.24.79.56.61','06.13.73.41.17',NULL,'19 av de normandie','','','14220','BARBERY',NULL,NULL,'2440214077001',81.000000000,'1966-01-15','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6069,'RAMSPACHER','ROSEMONDE','1935-01-26','02.61.75.97.92','06.47.70.08.77',NULL,'1547 RUE DE BRETTEVILLE','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1350114319001',656.000000000,'1962-10-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6070,'FASSIN','LUCIEN','1937-02-09','02.64.77.25.69','06.46.55.63.06',NULL,'20 RUE DE NORREY','','','14111','LOUVIGNY',NULL,NULL,'2370214109001',103.000000000,'1965-05-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6071,'RENAUD','PATRICIA','1939-04-17','02.54.13.61.03','06.42.23.28.03',NULL,'9 place des tourelles','','','14160','DIVES SUR MER',NULL,NULL,'2390414469001',600.000000000,'1967-05-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6072,'GAUCHARD','LOUIS','1937-05-18','02.25.92.58.93','06.80.84.76.53',NULL,'3 RUE DE LA MARJOLAINE','','','14920','MATHIEU',NULL,NULL,'1370514432001',1733.000000000,'1961-06-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6073,'LANNEHARD','CATHERINE','1954-01-27','02.11.30.42.13','06.26.88.92.43',NULL,'8 allee de laperouse','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'2540199255001',33.000000000,'1981-09-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6074,'LEFORESTIER','THERESE','1979-05-17','02.80.25.56.34','06.22.03.66.66',NULL,'','','','14840','DEMOUVILLE',NULL,NULL,'2790529105001',77.000000000,'2000-03-14','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6075,'ROBIAILLE','DESIRE','1933-07-21','02.87.24.17.09','06.81.61.83.72',NULL,'13 allee de copenahague','','','14460','COLOMBELLES',NULL,NULL,'2330714453001',331.000000000,'1960-07-07','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6076,'LEMOIGNE','HELENE','1948-01-23','02.64.95.36.83','06.10.94.52.65',NULL,'4 de la dive','','',NULL,NULL,NULL,NULL,'1480161062001',84.000000000,'1969-04-02','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6077,'CASTEL','THERESE','1935-03-03','02.42.99.36.13','06.82.85.46.43',NULL,'FOYER CLAIR SOLEIL RUE DU VALLE','UIL','','14000','CAEN',NULL,NULL,'1350350207001',13.000000000,'1958-02-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6078,'PIEDOUE','MARCEL','1939-07-31','02.64.56.19.72','06.69.50.17.34',NULL,'24 RUE DE L ANCIENNE GARE','','','14370','ARGENCES',NULL,NULL,'2390750520001',130.000000000,'1964-01-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6079,'VILLETTE','JEANINE','1952-04-07','02.50.82.68.81','06.68.28.13.81',NULL,'N8 RUE D''AUVERGNE','','','14120','MONDEVILLE',NULL,NULL,'1520414553001',33.000000000,'1973-06-24','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6080,'LECACHEUX','Sylvie','1930-07-20','02.77.55.90.76','06.64.55.53.68',NULL,'20 RUE DU POINT DU  JOUR','','','14123','IFS',NULL,NULL,'2300714217001',298.000000000,'1954-01-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6081,'LONGUET DES DIGUERES','FRANCIS','1949-05-02','02.11.42.24.53','06.83.56.08.68',NULL,'','','','14440','BENY SUR MER',NULL,NULL,'1490514432001',73.000000000,'1972-06-23','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6082,'CUSSY','GERARD','1936-07-28','02.54.12.24.12','06.11.40.59.64',NULL,'SILLY 147','','',NULL,NULL,NULL,NULL,'1360714506001',80.000000000,'1960-11-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6083,'CUSSY','ROLAND','1935-03-13','02.25.99.06.31','06.59.80.22.54',NULL,'55 rue ernest renan','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'2350350041001',174.000000000,'1958-11-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6084,'TESSARO','MAURICETTE','1935-10-07','02.62.47.44.44','06.37.35.61.92',NULL,'23 RUE DES PEUPLIERS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2351029079001',132.000000000,'1959-06-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6085,'GITTON','STANISLAS','1934-06-14','02.38.86.21.67','06.55.40.17.49',NULL,'LA BLOQUERE','','',NULL,NULL,NULL,NULL,'1340650394001',203.000000000,'1958-12-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6086,'DUBOIS','Guy','1944-02-26','02.87.04.41.89','06.48.16.23.93',NULL,'5 IMPASSE DU COSTIL','','','14123','FLEURY SUR ORNE',NULL,NULL,'1440227332001',1914.000000000,'1968-02-01','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6087,'MARIE DIT BROSSARD','MARIE FRANCOISE','1963-11-10','02.78.47.54.92','06.69.54.38.18',NULL,'19 RUE RAYMOND LEBARILLY','','',NULL,NULL,NULL,NULL,'2631114118001',190.000000000,'1985-01-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6088,'','IRENE','1963-11-23','02.10.46.77.19','06.32.56.98.69',NULL,'le mesnil','','','14490','CAHAGNOLLES',NULL,NULL,'2631114118001',22.000000000,'1991-10-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6089,'BARBIER','DOMINIQUE','1959-05-30','02.32.04.28.04','06.50.23.51.15',NULL,'68 RUE DES MUTES','','','27300','BERNAY',NULL,NULL,'1590578576001',19.000000000,'1980-11-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6090,'LESAGE','ROGER','1937-01-04','02.80.61.71.23','06.70.02.42.38',NULL,'12 ROUTE DE CAEN','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2370114451001',2309.000000000,'1958-01-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6091,'MARGERIE','MAURICETTE','1929-07-19','02.71.74.01.14',NULL,NULL,'25 rue du stade','','','14120','MONDEVILLE',NULL,NULL,'1290714372001',26.000000000,'1956-03-31','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6092,'AUSSANT','ADAM','1961-01-06','02.12.25.18.04','06.82.07.05.06',NULL,'rue alfred rossel residence du','port','','14190','FIERVILLE BRAY',NULL,NULL,'2610114221001',2.000000000,'1984-06-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6093,'LEGER','SIMONE','1929-06-16','02.80.99.51.68','06.12.03.30.17',NULL,'6 BIS CHEMIN DU CLOS JOLI','','','14400','BAYEUX',NULL,NULL,'1290650110001',44.000000000,'1953-11-10','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6094,'LAVILLE','MARC','1957-01-05','02.70.64.77.74',NULL,NULL,'18 RUE DES CHOMIERES','','','14490','VAUBADON',NULL,NULL,'1570150635001',1031.000000000,'1982-05-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6095,'MARIE','MADELEINE','1930-10-04','02.58.33.98.29','06.11.56.34.03',NULL,'8 RUE HENRI BEAUCLERC','','','14540','BOURGUEBUS',NULL,NULL,'1301050394001',411.000000000,'1954-02-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6096,'BESNIER','GILBERT','1936-09-26','02.72.43.05.03','06.14.16.22.96',NULL,'31 rue st Norbert','','',NULL,NULL,NULL,NULL,'1360951541001',126.000000000,'1964-11-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6097,'MICHEL','PIERRE','1938-06-26','02.81.82.12.38','06.22.33.88.88',NULL,'3 allee de chaumontel','','','14630','EMIEVILLE',NULL,NULL,'2380614645001',775.000000000,'1960-07-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6098,'RODRIGO','ANDRE','1965-08-09','02.97.36.05.63','06.61.23.16.47',NULL,'11 RUE DES ECOLES','','','14610','CAIRON',NULL,NULL,'2650814305001',66.000000000,'1993-01-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6099,'TROUILLARD','CHRISTIANE','1936-02-06','02.49.46.60.29','06.10.23.68.10',NULL,'4 RUE PIERRE ARTHUS','','','14850','ESCOVILLE',NULL,NULL,'2360214348001',2342.000000000,'1964-01-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6100,'BANCHET','MICHEL','1934-11-25','02.75.93.34.28','06.11.08.13.51',NULL,'3 rue saint gilles','','','61430','ATHIS DE L''ORNE',NULL,NULL,'2341114281001',307.000000000,'1964-08-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6101,'BRAD','PIERRE','1948-02-04','02.82.01.15.52','06.63.87.36.81',NULL,'26 route d ifs','','','61210','NEUVY AU HOULME',NULL,NULL,'2480261011001',35.000000000,'1971-03-24','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6102,'SAUSSET','GILBERTE','1938-12-28',NULL,NULL,NULL,'24 rue du saut de loup1','','','14000','CAEN',NULL,NULL,'1381250456001',187.000000000,'1961-06-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6103,'CORDIER','GERARD','1935-06-24','02.34.20.84.10','06.48.72.83.31',NULL,'9 RUE GANDHI','','','14120','MONDEVILLE',NULL,NULL,'2350660444001',1778.000000000,'1961-01-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6104,'GOUTIERE','JOEL','1931-03-25','02.54.23.13.25','06.82.07.67.60',NULL,'9 rue du parc','','','14740','LASSON',NULL,NULL,'2310314236001',761.000000000,'1955-07-31','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6105,'ERROT','CLAUDIE','1928-10-08','02.48.16.01.18','06.11.74.98.57',NULL,'36. rue eugene maes','','','14630','FRENOUVILLE',NULL,NULL,'2281061423001',654.000000000,'1951-03-20','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6106,'BEGUINOT','MARTINE','1930-07-11','02.96.70.48.73','06.37.40.65.39',NULL,'309 route d argences','','','14000','CAEN',NULL,NULL,'2300750321001',70.000000000,'1954-02-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6107,'ROUXEL','JOELLE','1948-02-17','02.36.03.59.37','06.16.02.62.15',NULL,'2 rue du stade','','','61000','ALENCON',NULL,NULL,'2480214137001',5.000000000,'1978-03-22','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6108,'PILON','HENRIETTE','1940-02-10','02.11.34.67.19','06.83.97.42.48',NULL,'1.les cretes perrete','','','61160','OMMOY',NULL,NULL,'1400214554001',22.000000000,'1970-09-12','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6109,'JOUANNE','JEANNINE','1935-11-26','02.75.61.71.74',NULL,NULL,'12 rue camille blaisot','','','14840','DEMOUVILLE',NULL,NULL,'2351114746001',39.000000000,'1961-08-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6110,'TISSIER','PAUL','1938-08-20','02.36.75.94.22','06.54.57.28.48',NULL,'13 rue du bois','','','14000','CAEN',NULL,NULL,'2380814309001',615.000000000,'1959-03-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6111,'LEMOINE','GUILLAUME','1932-01-29','02.36.11.11.74',NULL,NULL,'7 RUE DES CHAMPS','','','14860','BAVENT',NULL,NULL,'2320114470001',433.000000000,'1955-11-13','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6112,'LUET','YVAN','1936-03-27','02.18.31.54.13','06.72.68.14.95',NULL,'15 rue jacques cartier','','','14320','FONTENAY LE MARMION',NULL,NULL,'1360314472001',58.000000000,'1960-04-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6113,'MORICE','vadim','1964-05-28','02.12.31.45.23','06.15.08.46.49',NULL,'14 rue du dorset','','','14123','IFS',NULL,NULL,'1640550365001',1.000000000,'1989-02-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6114,'LECONTE','BERNARD',NULL,'02.55.81.38.55','06.89.94.71.02',NULL,'3 RUE MONT JACOB','','','14250','HOTTOT LES BAGUES',NULL,NULL,'1520227664001',155.000000000,'2008-05-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6115,'LESAGE','JEAN','1936-05-10','02.45.47.03.99','06.85.19.64.89',NULL,'611 LA HAUTE FOLIE','','','50750','ST SAMSON DE BONFOSSE',NULL,NULL,'2360514025001',199.000000000,'1959-10-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6116,'','BERNARD','1936-05-10','02.16.34.11.49','06.38.26.07.59',NULL,'7 route de mezidon','','','14000','CAEN',NULL,NULL,'2360514025001',440.000000000,'1960-12-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6117,'PIGEON','THERESE','1935-07-04','02.45.01.41.65','06.70.39.67.57',NULL,'72 rue du centre','','',NULL,NULL,NULL,NULL,'2350714089001',66.000000000,'1958-10-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6118,'JOUEN','LOUIS','1935-03-17','02.11.71.84.28','06.63.15.59.82',NULL,'1 RUE DU BOIS PERROTTE','','','14123','IFS',NULL,NULL,'1350314241001',4005.000000000,'1965-01-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6119,'LAURENT','LUCIENNE','1939-09-02','02.43.34.58.83','06.43.21.83.95',NULL,'12 RUE DU PARC','','','14670','JANVILLE',NULL,NULL,'1390927431001',1826.000000000,'1966-04-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6120,'SUPIZET','SIMONE','1929-01-07','02.10.02.63.30','06.72.64.50.62',NULL,'9 RUE DE L''EGALITE','','','14150','OUISTREHAM',NULL,NULL,'1290161490001',299.000000000,'1959-10-12','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6121,'LAIR','SOLANGE','1930-06-06','02.49.66.25.78','06.40.42.72.71',NULL,'6 RUE ALFRED CASSIGNEUL','','',NULL,NULL,NULL,NULL,'1300614602001',25.000000000,'1953-08-13','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6122,'DESDEVISES','GHISLAINE','1953-04-02','02.28.45.74.96',NULL,NULL,'1 ALLEE DES CHARMILLES','','','27500','MANNEVILLE SUR RISLE',NULL,NULL,'1530414482001',42.000000000,'1977-09-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6123,'HODIN','JEAN','1934-03-25','02.72.98.54.75','06.10.34.68.37',NULL,'ferme de l''ecarte','','','50180','AGNEAUX',NULL,NULL,'2340314135001',956.000000000,'1963-09-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6124,'BOREL','FRANCOISE','1934-12-11','02.21.58.33.96','06.16.40.75.55',NULL,'','','','14000','CAEN',NULL,NULL,'1341214091001',107.000000000,'1957-02-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6125,'FARCY','MARIE THERESE','1919-04-10','02.88.58.39.41','06.80.23.92.42',NULL,'18 grande rue','','','14700','FALAISE',NULL,NULL,'1190450502001',416.000000000,'1940-04-06','PREMIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6126,'FONTAINE','VERONIQUE','1928-09-27','02.10.94.50.98','06.12.88.55.93',NULL,'9 rue morin ruffier','','','14700','FALAISE',NULL,NULL,'2280950632001',208.000000000,'1949-04-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6127,'LEBRETON','PAULETTE','1936-12-10','02.12.20.94.60','06.75.90.49.17',NULL,'33 chemin des coteaux','','','14123','IFS',NULL,NULL,'2361214101001',279.000000000,'1962-12-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6128,'HAUPAIS','ODETTE','1967-01-30','02.11.63.40.04','06.28.64.46.73',NULL,'41 rue des carrieres de vaucelle','s','','14111','LOUVIGNY',NULL,NULL,'2670114020001',77.000000000,'1989-09-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6129,'ALVAREZ','MICHEL',NULL,'02.64.07.10.83','06.18.32.94.14',NULL,'824 BD DU GRAND PARC','','','14210','CHEUX',NULL,NULL,'2300214718001',55.000000000,'2009-01-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6130,'GABRIEL','ROGER','1931-10-15','02.11.30.32.03','06.95.14.64.22',NULL,'29 RUE DU REGIMENT ROYAL','','','14270','MEZIDON CANON',NULL,NULL,'2311014527001',327.000000000,'1960-03-24','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6131,'FENDEL','DELPHINE','1955-04-13','02.17.62.61.86','06.74.24.35.55',NULL,'LES MOULINS','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1550461022001',12.000000000,'1982-10-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6132,'VIGET','JEAN CLAUDE','1924-01-15','02.11.29.24.09','06.19.18.84.86',NULL,'68 BD MARECHAL LYAUTEY','','','14220','CROISILLES',NULL,NULL,'1240166090001',623.000000000,'1947-12-16','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6133,'SIGNORET','JACQUELINE','1930-05-26','02.61.67.42.48','06.88.68.41.51',NULL,'11 rue  de l esclosel','','','14540','BOURGUEBUS',NULL,NULL,'2300514045001',38.000000000,'1952-12-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6134,'LECOUTURIER','JEANNE','1967-01-14','02.36.56.17.98','06.10.41.56.96',NULL,'1 TER CHEMIN DU LONG BOIS','','','14000','CAEN',NULL,NULL,'2670114020001',91.000000000,'1992-09-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6135,'LEPAS','EVELYNE','1939-12-17','02.82.63.12.90','06.86.60.09.98',NULL,'9 RUE DES SOUCHETS','','','14370','VIMONT',NULL,NULL,'1391214535001',13.000000000,'1966-06-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6136,'FLEURY','NADINE','1940-04-30','02.10.00.76.84','06.86.71.24.68',NULL,'le bourg','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'2400450617001',324.000000000,'1963-03-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6137,'DUMONT','SIMONE','1960-04-14','02.14.80.14.64','06.27.87.78.00',NULL,'8 ALLEE BERENGERE','','','14320','MAY SUR ORNE',NULL,NULL,'2600478670001',2473.000000000,'1988-10-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6138,'LEBRUN','JEAN','1935-07-04','02.37.74.35.97',NULL,NULL,'3/1 RUE DES BLEUETS','','','14220','CROISILLES',NULL,NULL,'1350714566001',329.000000000,'1961-02-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6139,'BEEUWSAERT','ANDRE','1929-07-31','02.67.99.55.18','06.49.43.35.11',NULL,'727 rue de tour de ville','','','14000','CAEN',NULL,NULL,'1290714155001',857.000000000,'1955-06-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6140,'BEAUQUET','BERNARD','1934-02-09','02.85.94.86.44','06.32.20.02.65',NULL,'9 rue pasteur','','','14000','CAEN',NULL,NULL,'2340261073001',182.000000000,'1959-08-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6141,'BIDEL','ALAIN','1940-02-21','02.96.32.30.60','06.46.15.61.29',NULL,'928 BELLES PORTES','','','14320','FONTENAY LE MARMION',NULL,NULL,'1400276563001',3577.000000000,'1967-03-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6142,'MARGUERIE','NADINE','1934-05-16','02.25.02.36.41','06.97.27.38.23',NULL,'39 bis rue pasteur','','','14000','CAEN',NULL,NULL,'1340550458001',96.000000000,'1955-02-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6143,'GUIBERT','CLAUDE','1943-01-19','02.66.06.23.92','06.59.62.47.08',NULL,'28 AVENUE DU GENERAL LECLERC','','','14000','CAEN',NULL,NULL,'1430114626001',32.000000000,'1973-02-11','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6144,'CARABY','ANNICK','1929-03-16','02.11.32.38.07','06.19.43.19.10',NULL,'30 RUE DE L EPARGNE','','','14150','OUISTREHAM',NULL,NULL,'1290353080001',122.000000000,'1955-04-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6145,'GUILLOIS','MICHEL','1934-07-08','02.19.50.77.81','06.63.82.70.08',NULL,'le boscq benarsd','','','14000','CAEN',NULL,NULL,'2340714369001',383.000000000,'1961-07-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6146,'GIBERT','YOLANDE','1937-10-30','02.74.97.62.73',NULL,NULL,'LE BOURG','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1371027290001',128.000000000,'1964-09-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6147,'BOULA','JACQUELINE','1930-04-13','02.47.76.28.29','06.11.84.46.98',NULL,'route de la folie','','','14120','MONDEVILLE',NULL,NULL,'2300414554001',31.000000000,'1955-06-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6148,'ANNE','MICHELE','1960-01-24','02.11.07.08.09','06.87.03.64.61',NULL,'29 bd raymond poincar','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1600114488001',1179.000000000,'1983-10-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6149,'ALLAIS','PIERRE','1949-08-09','02.21.19.74.32',NULL,NULL,'1 rue des erables','','','14930','ETERVILLE',NULL,NULL,'1490814089001',539.000000000,'1973-12-24','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6150,'GOSSELIN','OLGA','1957-12-04','02.38.42.85.82','06.66.16.17.60',NULL,'L OISONNIERE','','','14230','NEUILLY LA FORET',NULL,NULL,'1571214223001',197.000000000,'1978-05-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6151,'MOUILLARD','CHRISTIAN','1936-09-24','02.67.27.71.20','06.12.09.64.19',NULL,'75 RUE DE LA MINE','','','14120','MONDEVILLE',NULL,NULL,'1360950103001',42.000000000,'1966-01-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6152,'ROMANO','SERGE','1929-05-17','02.12.05.38.73','06.12.14.44.17',NULL,'3 rue du languedoc','','','14280','AUTHIE',NULL,NULL,'2290514197001',91.000000000,'1950-11-01','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6153,'DUVAL','JACQUELINE','1970-01-03','02.67.11.64.32','06.20.01.13.89',NULL,'100 rue de belle vue','','','14170','HIEVILLE',NULL,NULL,'2700127642001',493.000000000,'1999-12-02','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6154,'ZERR','JACQUES','1928-01-06','02.65.37.62.59','06.55.05.67.29',NULL,'7 imp du chant de l alouette','','','14123','FLEURY SUR ORNE',NULL,NULL,'1280127309001',278.000000000,'1956-11-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6155,'TREHARD','JACQUES','1933-11-18','02.46.19.77.35','06.84.91.89.88',NULL,'3 rue jacques brel','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2331161278001',26.000000000,'1958-05-01','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6156,'PIOTROWSKI','MARIE','1961-03-29','02.32.96.99.95','06.19.31.26.22',NULL,'38 RUE ST JEAN','','','14000','CAEN',NULL,NULL,'1610361494001',651.000000000,'1987-01-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6157,'GUILBERT','YVETTE','1961-10-07','02.97.64.00.02','06.57.67.36.47',NULL,'','','','14490','CAHAGNOLLES',NULL,NULL,'1611053081001',40.000000000,'1987-11-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6158,'CHOUQUARD','CHARLES','1939-01-29','02.18.39.36.21','06.65.85.25.34',NULL,'13 RUE CAILLEMER','','','14830','LANGRUNE SUR MER',NULL,NULL,'1390114726001',54.000000000,'1966-10-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6159,'SAVORGNAN','MARGUERITE','1961-01-08','02.66.07.87.15','06.73.83.47.24',NULL,'63C RUE VICTOR HUGO','','','50270','LES MOITIERS D''ALLONNE',NULL,NULL,'1610150201001',172.000000000,'1982-10-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6160,'BAUMEL','YVES','1928-05-16','02.10.52.91.95','06.63.17.30.46',NULL,'7 LA CENSERIE','','','14000','CAEN',NULL,NULL,'2280514667001',79.000000000,'1949-10-21','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6161,'SERAFIN','MICHEL','1961-01-30','02.70.23.65.78','06.72.06.58.91',NULL,'10 RUE DES PRAIRIES','','','14000','CAEN',NULL,NULL,'2610150547001',29.000000000,'1984-05-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6162,'BULLERYAL','8','1968-01-10','02.60.81.75.91','06.33.89.21.56',NULL,'1 RUE JULES GUESDE','','','14700','LA HOGUETTE',NULL,NULL,'1680150218001',679.000000000,'1993-06-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6163,'LEFIOT','','1934-01-07','02.87.70.23.22','06.72.03.07.41',NULL,'34 RUE DU ROBILLARD','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2340114630001',17.000000000,'1962-05-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6164,'GUYOT','Jeannine','1962-01-11','02.45.08.10.95','06.66.76.62.27',NULL,'23 RUE DE 59 EME DIVISION ANGLAI','SE','','14730','GIBERVILLE',NULL,NULL,'2620114221001',740.000000000,'1992-10-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6165,'BARBE','COLETTE',NULL,'02.32.74.62.37',NULL,NULL,'2 ALLEE ST VIGOR','','','14140','CHEFFREVILLE TONNENCOURT',NULL,NULL,'1200250407001',282.000000000,'2007-12-23','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6166,'DAGORN','GILBERT','1942-03-08','02.75.88.85.80','06.62.90.16.13',NULL,'CHEMIN DE LA BRUYERE','','','14540','BOURGUEBUS',NULL,NULL,'2420314710001',58.000000000,'1966-03-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6167,'VERMEULEN','REMY','1936-11-08','02.11.62.27.49','06.24.93.39.49',NULL,'RUE DE LA JUSTICE','','','61700','PERROU',NULL,NULL,'2361161306001',85.000000000,'1959-01-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6168,'BOUDANT','MAURICE','1948-02-27','02.61.02.78.92','06.31.62.38.42',NULL,'','','','14270','MEZIDON CANON',NULL,NULL,'2480214141001',124.000000000,'1970-04-07','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6169,'GUERRY','DENISE','1940-10-04','02.58.57.43.60','06.48.45.80.38',NULL,'57 RUE SAINT ANDRE','','','14250','FONTENAY LE PESNEL',NULL,NULL,'2401027517001',37.000000000,'1961-06-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6170,'DAMEY','LEONE','1932-02-01','02.33.88.75.20','06.85.17.32.39',NULL,'15 RUE VICTOR HUGO','','','14000','CAEN',NULL,NULL,'2320261283001',241.000000000,'1961-03-04','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6171,'VERGOTE','ALAIN','1934-12-11','02.88.42.94.59','06.55.86.77.52',NULL,'12 BD GEORGES POMPIDOU','','','14000','CAEN',NULL,NULL,'1341214627001',1287.000000000,'1961-11-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6172,'BENCTEUX','ALAIN',NULL,'02.56.95.84.60','06.11.28.70.10',NULL,'','','','14280','ST CONTEST',NULL,NULL,'1350114319001',98.000000000,'2010-04-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6173,'BOIVERT','EMMANUEL','1933-10-29','02.65.33.46.87','06.59.21.36.88',NULL,'14 B RUE DES CAPUCINES','','','14840','DEMOUVILLE',NULL,NULL,'1331091134001',5.000000000,'1955-02-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6174,'HERVE','NICOLE','1949-02-08','02.25.42.79.27','06.48.96.10.24',NULL,'7 bis rue porte millet','','','14930','ETERVILLE',NULL,NULL,'1490250422001',237.000000000,'1973-09-14','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6175,'FERAY','CATHERINE','1945-01-15','02.58.34.38.84','06.69.87.25.47',NULL,'69 RUE DE LA BASSE RIVE','','','14220','COMBRAY',NULL,NULL,'1450114443001',1601.000000000,'1968-11-27','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6176,'DUCLOS','GENEVIEVE','1936-10-11','02.35.46.91.63','06.52.80.01.70',NULL,'RES LES POMMIERS LILLEBONNE','','','14310','VILLY BOCAGE',NULL,NULL,'2361028146001',35.000000000,'1961-02-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6177,'LESAUVAGE','PIERRE','1962-01-21','02.28.75.99.21','06.51.57.26.63',NULL,'11 RUE DE BRETAGNE','','','14540','ROCQUANCOURT',NULL,NULL,'2620114734001',5339.000000000,'1987-12-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6178,'BREANT','ROGER','1940-08-13','02.66.73.78.37','06.24.50.73.21',NULL,'11 RUE DE BRETAGNE','','','50260','BRICQUEBEC',NULL,NULL,'2400814745001',1.000000000,'1961-02-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6179,'DELIVET','MADELEINE','1929-08-08','02.46.01.55.18','06.68.60.59.39',NULL,'2 RUE DES MELIERES','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2290861454001',7.000000000,'1954-04-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6180,'AUGER','JOCELYNE','1932-11-21','02.39.83.26.11','06.53.84.96.68',NULL,'LE BOURG','','','30130','ST PAULET DE CAISSON',NULL,NULL,'1321150356001',272.000000000,'1953-10-01','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6181,'BELLEE','isabelle','1960-09-20','02.88.04.19.57','06.86.72.51.81',NULL,'45 rue de bouvines','','','14840','DEMOUVILLE',NULL,NULL,'2600961437001',405.000000000,'1984-01-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6182,'YGOUF','ALBERT','1934-07-17','02.11.70.79.40','00 33 6.64.99.70.72',NULL,'4 RUE DE LA CHAUSSEE FERREE','','','14730','GIBERVILLE',NULL,NULL,'1340714597001',212.000000000,'1959-09-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6183,'DRION','GEORGES','1932-02-09','02.36.73.03.74',NULL,NULL,'28 AVENUE SECRETAN','','',NULL,NULL,NULL,NULL,'2320261361001',15.000000000,'1962-07-29','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6184,'BON','FABIENNE','1946-02-27','02.19.85.95.78','06.45.98.45.00',NULL,'15 RUE DU FOUR','','','14540','CONTEVILLE',NULL,NULL,'2460214014001',66.000000000,'1970-12-10','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6185,'TISON','MICHEL','1939-04-29','02.54.31.91.48','06.87.23.90.75',NULL,'13 RUE GUSTAVE FLAUBERT','','','14400','BAYEUX',NULL,NULL,'1390414150001',406.000000000,'1961-03-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6186,'BOVE','DANIEL','1969-09-27','02.22.13.04.27','06.85.80.19.49',NULL,'4 RESIDENCE LA CROIX PICARD','','',NULL,NULL,NULL,NULL,'2690950502001',170.000000000,'1999-10-27','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6187,'DUPARD','JEAN','1928-10-08','02.46.68.32.29','06.19.99.82.16',NULL,'52 RUE DU VAL DE SAIRE','','','14790','MOUEN',NULL,NULL,'1281014715001',3885.000000000,'1951-08-03','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6188,'TASSERY','BLANCHE','1938-03-25','02.44.18.32.01','06.10.45.64.33',NULL,'LA TREHARDIERE','','','14280','ST CONTEST',NULL,NULL,'1380314514001',813.000000000,'1960-07-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6189,'LIGNOT','MADELEINE','1959-04-11','02.37.33.07.29','06.10.64.53.98',NULL,'65 ROUTE DES MONTS','','','14370','AIRAN',NULL,NULL,'2590414396001',24.000000000,'1982-02-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6190,'GALODE','CHRISTIANE','1940-06-23','02.84.26.74.91',NULL,NULL,'32 RUE ALEXIS DE TOCQUEVILLE','','','14000','CAEN',NULL,NULL,'1400614167001',418.000000000,'1963-09-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6191,'LESAULNIER','Georges','1934-12-22','02.68.48.20.42','06.39.47.32.42',NULL,'20/03 RUE DES BLEUETS','','','14860','BAVENT',NULL,NULL,'2341250642001',39.000000000,'1956-09-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6192,'LANGLOIS','MONIQUE','1932-01-21','02.97.01.70.72','06.29.01.77.19',NULL,'2 RUE DU PHOQUE','','','14350','DAMPIERRE',NULL,NULL,'2320178362001',136.000000000,'1956-04-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6193,'LECLERC','PAUL','1935-10-01',NULL,NULL,NULL,'17 rte de paris','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1351014138001',478.000000000,'1962-03-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6194,'VILLEROY','SUZANNE','1964-08-04','02.57.55.94.31','06.28.52.65.19',NULL,'8 rue des peupliers','','','14000','CAEN',NULL,NULL,'1640814080001',2579.000000000,'1990-02-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6195,'GAUGAIN','GUY','1931-03-10','02.36.70.90.33','06.36.47.33.66',NULL,'16 rte de trouville','','','61160','FONTAINE LES BASSETS',NULL,NULL,'1310314111001',85.000000000,'1954-04-28','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6196,'POTEL','PIERRETTE','1938-05-08','02.46.02.52.97','06.36.18.39.01',NULL,'18 RUE DES ECUYERS','','','14210','MAISONCELLES SUR AJON',NULL,NULL,'1380561040001',62.000000000,'1959-11-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6197,'TUBOEUF','THERESE','1945-10-08','02.57.81.20.64','06.70.23.79.73',NULL,'76 RUE DES DRAKKARS','','','14610','CAIRON',NULL,NULL,'1451049208001',8.000000000,'1969-05-21','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6198,'BALLON','GEORGES','1938-08-08','02.88.25.49.37','06.27.09.76.96',NULL,'VILLAGE LE CHATEAU','','','14270','MEZIDON CANON',NULL,NULL,'2380814158001',3.000000000,'1960-01-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6199,'DELAFONTAINE','BERNARD','1928-09-23','02.60.28.10.70','06.43.30.08.01',NULL,'6 RUE DE LA MARE','','','14000','CAEN',NULL,NULL,'1280914140001',36.000000000,'1949-09-10','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6200,'MERIEL','MICHELE','1944-01-09','02.53.54.78.70','06.25.15.38.32',NULL,'59 avenue jean jaures','','',NULL,NULL,NULL,NULL,'2440114629001',142.000000000,'1970-06-21','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6201,'LOYER','PATRICK','1939-06-01','02.40.46.90.57','06.89.98.67.77',NULL,'16 place letellier','','','50600','CHEVREVILLE',NULL,NULL,'1390614288001',839.000000000,'1962-08-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6202,'DUGUE','YVONNE','1936-08-22','02.12.43.28.57','06.11.77.99.08',NULL,'5 RUE PAUL MATHIEU','','','14430','HOTOT EN AUGE',NULL,NULL,'1360814990001',333.000000000,'1966-11-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6203,'DUVAL','MARC','1941-01-21','02.33.31.25.71','06.12.81.48.58',NULL,'25 RUE VICTOR LEPINE','','','14160','DIVES SUR MER',NULL,NULL,'2410114125001',2.000000000,'1966-05-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6204,'MABILLE','ROGER','1923-09-09','02.53.90.57.71','06.12.16.15.68',NULL,'16 RESIDENCE JEAN RACINE','','','14840','DEMOUVILLE',NULL,NULL,'2230965075001',981.000000000,'1950-02-14','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6205,'SAMSON','RENE',NULL,'02.96.87.68.67','06.77.91.98.62',NULL,'QUARTIER ST CLEMENT','','','14380','PLEINES OEUVRES',NULL,NULL,'2361257243001',1220.000000000,'2011-01-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6206,'LE HAIN','ALAIN','1939-12-29','02.28.55.17.96','06.36.16.19.27',NULL,'CHEMIN DE LA CROIX MARIE','','',NULL,NULL,NULL,NULL,'1391214570001',5093.000000000,'1963-05-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6207,'GALODE','CORINNE','1934-07-30','02.90.53.06.86','06.42.60.36.32',NULL,'9 RUE DU BOULHOULLAY','','','14120','MONDEVILLE',NULL,NULL,'2340714452001',161.000000000,'1957-04-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6208,'LESOUEF','Paul','1951-05-23','02.96.83.29.92','06.25.23.70.06',NULL,'2 RUE DES GLAIEULS','','','14320','MAY SUR ORNE',NULL,NULL,'2510599255001',57.000000000,'1974-11-26','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6209,'LEFEVRE','LOUISE','1930-11-08','02.78.78.90.60','06.10.23.69.92',NULL,'20 rue jules ferry','','','14730','GIBERVILLE',NULL,NULL,'1301161007001',147.000000000,'1960-08-15','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6210,'LEBOUCHER','PIERRE','1936-05-15','02.10.89.56.26','06.59.09.75.60',NULL,'LE BOURG','','','14730','GIBERVILLE',NULL,NULL,'2360514677001',3801.000000000,'1965-06-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6211,'DESSOLIERS','ALBERT','1929-04-17','02.79.20.80.29','06.42.68.11.29',NULL,'10 RUE LOUIS MICHEL','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1290414486001',25.000000000,'1950-05-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6212,'LEMASSON','JEAN PIERRE','1934-04-22','02.84.52.32.05','06.14.52.04.22',NULL,'38 rue du val es dunes','','','14230','MONFREVILLE',NULL,NULL,'2340414181001',37.000000000,'1960-06-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6213,'LE MARCHAND','GEORGETTE','1938-04-03','02.41.46.44.84','06.49.49.19.26',NULL,'AVENUE DES CHEMINS AUX BOEUFS','','','14330','LE MOLAY LITTRY',NULL,NULL,'1380414515001',2161.000000000,'1960-08-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6214,'GODIN','SIMONE','1944-01-15','02.21.16.53.93','06.68.79.80.80',NULL,'5 av de copenague','','','14230','ISIGNY SUR MER',NULL,NULL,'1440150194001',1340.000000000,'1971-03-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6215,'ANDRE','GEORGES','1929-05-24','02.20.86.29.19','06.23.13.85.01',NULL,'28 RUE DES QUENOTS','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'2290514543001',66.000000000,'1959-01-16','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6216,'GOHIER','MAURICE','1956-02-08','02.80.51.05.55','06.18.67.58.73',NULL,'RUE DU GRAND CHAMP','','','14000','CAEN',NULL,NULL,'2560250503001',729.000000000,'1984-08-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6217,'JEANNE','JEAN','1933-03-07','02.16.73.77.55','06.80.44.81.14',NULL,'8 rue de tageret','','','14840','CUVERVILLE',NULL,NULL,'2330314745001',31.000000000,'1963-05-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6218,'LEMOUTON','SERGE','1937-02-11','02.10.51.15.62','06.21.52.92.55',NULL,'5 RUE KALIGRENKO','','','14370','ARGENCES',NULL,NULL,'2370273008001',1.000000000,'1966-05-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6219,'MINES','JACQUELINE','1935-10-22','02.54.57.39.04','06.32.06.10.98',NULL,'7 RUE DE LARGERIE','','','14380','ST SEVER CALVADOS',NULL,NULL,'1351014118001',72.000000000,'1957-11-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6220,'PIERRE','THIERRY','1954-01-26','02.11.94.27.84','06.32.55.63.51',NULL,'LA GOUBINIERE','','','14000','CAEN',NULL,NULL,'2540161138001',287.000000000,'1975-04-16','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6221,'HUE','HELENE','1936-09-20','02.19.11.85.12','06.15.00.16.41',NULL,'LA BUTTE N/39','','','14940','SANNERVILLE',NULL,NULL,'1360914061001',6.000000000,'1957-11-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6222,'CHORIN','MICHEL','1939-06-13','02.55.16.18.45','06.60.24.81.12',NULL,'8 rue de la hague','','','14190','ROUVRES',NULL,NULL,'2390650444001',458.000000000,'1965-01-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6223,'CHATOJAN','VIVIANE','1940-02-01','02.12.53.68.21','06.59.42.46.34',NULL,'9 av pasteur','','','14630','CAGNY',NULL,NULL,'2400214112001',139.000000000,'1964-09-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6224,'SAVARIE','MARC','1932-08-23','02.26.00.71.21','06.86.47.03.21',NULL,'','','','14260','ST GEORGES D''AUNAY',NULL,NULL,'1320851098001',76.000000000,'1962-05-09','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6225,'COUBANT','WILFRID','1932-03-23','02.49.58.77.63','06.11.59.02.29',NULL,'4 IMPASSE DES GIROFLEES','','','14000','CAEN',NULL,NULL,'2320314201001',325.000000000,'1958-02-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6226,'LECHAUVE','AUGUSTE','1936-08-24','02.59.29.30.76','06.12.24.07.36',NULL,'6 rue mortemer','','',NULL,NULL,NULL,NULL,'2360814027001',1060.000000000,'1963-10-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6227,'PAISANT','PHILIPPE',NULL,'02.81.82.00.61','06.10.00.45.47',NULL,'LE PRESBYTERE','','','14510','HOULGATE',NULL,NULL,'1581061442001',1216.000000000,'2008-05-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6228,'PROU','MARLENE','1943-05-16','02.74.20.41.77',NULL,NULL,'20.5 GRANDE RUE','','','14000','CAEN',NULL,NULL,'2430514363001',11.000000000,'1968-01-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6229,'RENNES','YVETTE','1940-04-05','02.83.35.42.29','06.42.61.21.28',NULL,'14 rue du brle','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'2400414502001',1.000000000,'1970-08-09','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6230,'LESTAIN','FRANCOISE','1937-09-30','02.16.60.77.54','06.84.68.13.23',NULL,'4 imp du dan','','','14370','BILLY',NULL,NULL,'1370914434001',355.000000000,'1966-06-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6231,'NICOLLE','ROBERT',NULL,'02.97.13.33.65','06.81.41.65.44',NULL,'1 rue de la haute ecarde','','',NULL,NULL,NULL,NULL,'2390653116001',63.000000000,'2010-10-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6232,'NICOLLE','MARIE','1942-12-19','02.68.01.24.03','06.72.10.49.41',NULL,'138 RUE DE BAYEUX','','','14160','DIVES SUR MER',NULL,NULL,'1421297202001',805.000000000,'1963-10-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6233,'POUPPEVILLE','Helene','1940-12-04','02.17.35.43.32','06.64.26.45.03',NULL,'4 RUE DE LA ROSERAIE','','',NULL,NULL,NULL,NULL,'2401261413001',3510.000000000,'1961-04-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6234,'PENNETIER','CLAIRE','1942-11-30','02.79.28.28.56','06.89.43.11.74',NULL,'6 RUE LEOPOLD DE L''ISLE','','','14650','CARPIQUET',NULL,NULL,'1421114529001',197.000000000,'1966-10-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6235,'LEGLU','JACQUELINE','1968-01-05','02.41.19.37.87','06.20.19.34.07',NULL,'9 IMPASSE DES FOSSETTES','','','14160','DIVES SUR MER',NULL,NULL,'1680153166001',1812.000000000,'1996-09-16','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6236,'PELTIER','JEAN-PIERRE',NULL,'02.32.15.72.90','06.61.96.64.74',NULL,'HAMEAU DE IFS','','','14860','RANVILLE',NULL,NULL,'2690161007001',43.000000000,'2013-04-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6237,'TOURNAILLE','JACQUELINE','1939-01-28','02.11.25.56.03','06.19.52.22.55',NULL,'LEIU DIT ST CLEMENT','','','14210','ESQUAY NOTRE DAME',NULL,NULL,'1390153240001',296.000000000,'1969-04-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6238,'','JEAN CLAUDE','1928-09-30','02.55.35.59.11','06.40.57.35.26',NULL,'lieu le doigt','','','14190','URVILLE',NULL,NULL,'2280950200001',10.000000000,'1950-02-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6239,'DORNIOL','JEAN','1929-12-07','02.82.23.49.64','06.74.77.68.03',NULL,'11 RUE DU VAL QUESNEY','','','14240','LIVRY',NULL,NULL,'1291214715001',1052.000000000,'1953-02-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6240,'MARIE','BEATRICE','1956-05-19','02.28.30.07.09','06.58.04.06.01',NULL,'LE HOTEE','','','50410','PERCY',NULL,NULL,'1560561208001',1164.000000000,'1977-02-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6241,'','HELENE','1949-02-02','02.10.68.67.70','06.10.55.32.30',NULL,'RUE DES ECOLES','','','50630','OCTEVILLE L''AVENEL',NULL,NULL,'2490281032001',12.000000000,'1979-04-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6242,'MOUCHEL','MADELEINE','1931-06-21','02.72.31.24.09','06.51.63.81.58',NULL,'6 RESIDENCE D HARCOURT','','','14000','CAEN',NULL,NULL,'1310614109001',50.000000000,'1961-11-04','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6243,'DURAND','MARTINE','1945-01-28','02.46.70.11.34','06.88.64.76.14',NULL,'66 RUE ARISTIDE BRIAND','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1450114572001',170.000000000,'1966-02-20','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6244,'FRAVAL','PIERRETTE','1937-06-14','02.84.29.24.53','06.10.30.01.37',NULL,'11 rue de la republique','','','14220','BARBERY',NULL,NULL,'1370614711001',418.000000000,'1962-07-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6245,'AUPEE','MAURICETTE',NULL,'02.36.64.22.11','06.54.36.04.44',NULL,'3 rue des oiseaux','','','14210','VACOGNES NEUILLY',NULL,NULL,'2390116025001',146.000000000,'2010-10-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6246,'DELAFOSSE','YVETTE','1937-07-11','02.37.57.70.20','06.26.76.16.51',NULL,'24 RUE FERNAND LEGER','','','14000','CAEN',NULL,NULL,'1370714708001',41.000000000,'1961-03-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6247,'LEBOUCHER','IRENE','1942-10-14','02.22.35.39.42','06.86.00.78.46',NULL,'11 RUE DE DUBLIN','','','14700','FRESNE LA MERE',NULL,NULL,'2421012127001',12.000000000,'1963-05-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6248,'AUBINE','MARCEL','1940-06-11','02.11.83.64.12','06.87.90.66.09',NULL,'LE THIELLEY','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1400614162001',30.000000000,'1961-06-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6249,'KOUBA','MARCEL',NULL,'02.10.10.17.19','06.48.90.74.46',NULL,'','','','14250','AUDRIEU',NULL,NULL,'1320314631001',66.000000000,'2012-09-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6250,'LEBOUTEILLER','Merino','1930-06-12','02.12.01.28.76','06.59.26.29.68',NULL,'24 A ROUTE DU MESNIL AMEY','','','14123','IFS',NULL,NULL,'1300614145001',235.000000000,'1952-02-07','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6251,'SAULNIER','CLAUDE','1963-01-11','02.99.88.47.24','06.32.96.76.94',NULL,'2 ALLEE DU BREUIL','','','14730','GIBERVILLE',NULL,NULL,'1630114477001',2092.000000000,'1992-09-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6252,'SAINT JAMES','GASTON','1946-01-05','02.66.25.29.16','06.67.89.82.08',NULL,'1 rue des tilleuls','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'2460161462001',209.000000000,'1970-06-19','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6253,'DELAUNAY','STEPHANE','1944-01-25','02.19.17.68.16','06.37.18.07.22',NULL,'17 RUE DE L''EGLANTINE','','','14650','CARPIQUET',NULL,NULL,'2440114313001',543.000000000,'1970-01-05','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6254,'LA ROUTE','CLAUDE','1963-11-16','02.67.99.92.77','06.69.79.85.93',NULL,'LA VALLEE','','',NULL,NULL,NULL,NULL,'1631114446001',42.000000000,'1991-10-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6255,'MENANT','','1951-01-24','02.18.56.56.84','06.55.32.92.77',NULL,'15 RUE PARABOLE DU CLOS','','','14160','DIVES SUR MER',NULL,NULL,'2510114651001',234.000000000,'1973-06-30','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6256,'DEMEILLIER','ALAIN','1935-04-22','02.72.33.92.81','06.65.06.12.48',NULL,'26 rue g le conquerant','','','14740','ST MANVIEU NORREY',NULL,NULL,'1350414359001',3497.000000000,'1963-01-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6257,'PESNEL','JACQUELINE','1951-01-01','02.72.09.52.00','06.37.38.36.10',NULL,'13 ROUTE DES MARAIS','','','14000','CAEN',NULL,NULL,'2510114278001',33.000000000,'1980-11-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6258,'AUPEE','ARLETTE','1956-02-15','02.11.97.36.23','06.11.28.11.83',NULL,'4 RUE EDOUARD BOUBAT  APPT/R4','','','14730','GIBERVILLE',NULL,NULL,'2560250172001',770.000000000,'1978-03-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6259,'RIO','SERGE','1936-12-17','02.11.56.35.44','06.19.47.80.78',NULL,'3 RUE DE LA FONTAINE','','','14540','GRENTHEVILLE',NULL,NULL,'1361276678001',104.000000000,'1960-03-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6260,'MAUDUIT','CLAUDE','1932-12-23','02.54.19.84.62','06.22.66.62.82',NULL,'3 AVENUE  MADELAINE DE SEGUR','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1321214290001',122.000000000,'1954-09-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6261,'HUETTE','MARC','1945-04-15','02.30.75.22.91','06.59.10.64.06',NULL,'11 RUE DES MAZURETTES','','','50390','ST SAUVEUR LE VICOMTE',NULL,NULL,'2450446070001',53.000000000,'1967-11-26','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6262,'BODIN','STEPHANIE','1931-08-06','02.11.77.50.64','06.69.01.59.63',NULL,'','','','50000','ST LO',NULL,NULL,'1310809326001',42.000000000,'1955-08-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6263,'CHASLE','COLETTE','1928-02-16','02.43.46.23.95','06.31.51.38.13',NULL,'80 rue branville','','','14220','HAMARS',NULL,NULL,'2280214589001',23.000000000,'1954-05-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6264,'ASSELINE','GUY','1930-07-11','02.90.29.90.44','06.46.64.21.83',NULL,'6 RUE DES SABLONS','','','76610','LE HAVRE',NULL,NULL,'1300714483001',1779.000000000,'1955-01-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6265,'PHILIBERT','MARTINE','1964-05-27','02.13.36.80.98','06.25.17.06.39',NULL,'21 RUE DU MARECHAL LECLERC','','','61000','ALENCON',NULL,NULL,'1640514087001',803.000000000,'1988-06-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6266,'BISSON','christine','1956-05-31','02.70.89.77.99','06.50.68.57.53',NULL,'17 AVENUE DES TULIPES','','','14750','ST AUBIN SUR MER',NULL,NULL,'1560561208001',682.000000000,'1984-05-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6267,'BOULAY','ANNETTE','1932-12-31','02.28.02.02.41','06.10.96.24.10',NULL,'6 RUE DU FOYER RURAL','','','14460','COLOMBELLES',NULL,NULL,'2321214252001',83.000000000,'1959-07-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6268,'LEHERON','HERVE','1929-10-09','02.39.27.23.33','06.40.79.99.57',NULL,'le lieu fremont','','','50110','TOURLAVILLE',NULL,NULL,'2291014393001',81.000000000,'1956-06-27','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6269,'BIGOT','JEANINE','1930-03-07','02.26.46.85.58','06.10.36.92.16',NULL,'4 RUE DES VERTES PRAIRIES','','','14160','DIVES SUR MER',NULL,NULL,'2300350444001',22.000000000,'1952-05-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6270,'DAVID','','1939-09-05','02.37.03.61.67','06.84.47.83.27',NULL,'98 route d ifs','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2390914266001',1696.000000000,'1968-11-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6271,'BRIERE','JEAN','1970-01-11','02.64.95.05.53','06.41.58.98.33',NULL,'15 IMPASSE DES FONTAINES','','','14220','LES MOUTIERS EN CINGLAIS',NULL,NULL,'2700114327001',8.000000000,'1992-04-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6272,'GOUGET','CLAUDINE','1938-05-25','02.33.55.14.11','06.10.85.09.61',NULL,'23 les rives d''or','','','14490','BALLEROY',NULL,NULL,'1380514089001',440.000000000,'1964-11-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6273,'BALLAVENNE','FREDERIC','1940-09-04','02.10.97.61.35','06.36.53.53.53',NULL,'64 rue des bouchers','','','14460','COLOMBELLES',NULL,NULL,'1400922352001',1232.000000000,'1962-07-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6274,'GERBEAU','JEAN','1967-07-12','02.29.30.30.50','06.33.79.45.96',NULL,'55 ROUTE D IFS','','','14270','CONDE SUR IFS',NULL,NULL,'1670710196001',83.000000000,'1988-11-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6275,'LASTELLE','JACQUES','1933-09-16','02.50.92.91.71','06.64.76.34.70',NULL,'1 RUE DE LA PAIX','','','14000','CAEN',NULL,NULL,'1330914749001',178.000000000,'1955-11-29','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6276,'DEMEILLIERS','MARIE CLAIRE','1942-05-28','02.11.23.75.85','06.10.55.20.96',NULL,'23 les rives d''or','','','14000','CAEN',NULL,NULL,'1420514355001',148.000000000,'1967-09-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6277,'BARATTE','NOEL','1920-06-13','02.32.20.52.26','06.82.54.25.00',NULL,'30 RUE DU BERRY','','','14123','IFS',NULL,NULL,'1200628325001',10.000000000,'1941-02-19','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6278,'LECONTE','SYLVIE','1954-03-21','02.11.06.52.40','06.64.17.37.49',NULL,'HAMEAU ST RICHER','','','14000','CAEN',NULL,NULL,'1540314607001',52.000000000,'1978-05-26','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6279,'DUPONT','CLAUDE',NULL,'02.11.37.52.62','06.98.63.54.39',NULL,'17 ROUTE DE LA FRESNAIE','','','14420','POTIGNY',NULL,NULL,'1620114383001',2657.000000000,'2012-08-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6280,'JAMES','THERESE','1932-11-03','02.10.84.41.32','06.89.07.68.00',NULL,'68 BD MARECHAL LYAUTEY','','','14680','GOUVIX',NULL,NULL,'2321114049001',41.000000000,'1956-02-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6281,'CHAPRON','JEAN BAPTISTE','1932-02-05','02.95.14.64.86','06.93.25.70.52',NULL,'12 RUE HENRY DUNANT','','','14000','CAEN',NULL,NULL,'1320286087001',692.000000000,'1955-12-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6282,'SAINT JALMES','MURIELLE','1944-12-13','02.83.30.97.07','06.47.86.98.07',NULL,'le plessis','','','14100','LISIEUX',NULL,NULL,'2441214237001',163.000000000,'1971-05-31','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6283,'PAIN','DENISE','1936-10-16','02.11.16.12.74',NULL,NULL,'LE GARDAIS','','','14470','COURSEULLES SUR MER',NULL,NULL,'2361014075001',6.000000000,'1959-01-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6284,'SAULNIER','MARGUERITE','1938-08-13','02.13.20.45.92','06.16.94.15.43',NULL,'6 AV DE LA BAILLEE','','','14000','CAEN',NULL,NULL,'2380814271001',3.000000000,'1962-07-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6285,'YZABEL','DENISE','1949-03-26','02.67.30.97.33','06.18.57.95.53',NULL,'','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'1490314681001',139.000000000,'1978-09-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6286,'LANDEMAINE','ROBERT','1932-08-29','02.21.02.43.96','06.10.48.45.53',NULL,'1 rue leopold trebutien','','','14170','MITTOIS',NULL,NULL,'2320814578001',745.000000000,'1953-12-17','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6287,'MANCEL','JEAN CLAUDE','1967-05-02',NULL,NULL,NULL,'5 rue du temps perdu','','','27210','BEUZEVILLE',NULL,NULL,'1670538547001',37.000000000,'1990-09-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6288,'GOUBERT','DANIELE','1938-06-21','02.46.23.97.19','06.74.01.53.07',NULL,'6 GRANDE RUE','','','14123','IFS',NULL,NULL,'2380650189001',16.000000000,'1962-02-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6289,'CALBRIS','jean michel','1945-05-12','02.35.83.65.25','06.15.28.28.85',NULL,'14 rue du limousin','','','14000','CAEN',NULL,NULL,'1450514484001',680.000000000,'1973-07-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6290,'LEROYER','DOMINIQUE','1937-01-08','02.82.86.98.97','06.30.48.74.85',NULL,'48 rue de conde','','','14650','CARPIQUET',NULL,NULL,'2370114282001',116.000000000,'1961-08-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6291,'MOREL','MAURICE','1929-06-30','02.63.04.39.40','06.74.29.08.68',NULL,'rue des ecoles','','','14210','AMAYE SUR ORNE',NULL,NULL,'1290627055001',113.000000000,'1953-12-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6292,'CALENGE','SARAH','1932-11-22','02.62.83.70.07','06.19.54.61.89',NULL,'31 RUE HAMPSHIRE RESIDENCE DU M','ANOIR','','14280','ST CONTEST',NULL,NULL,'2321150470001',1411.000000000,'1955-06-12','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6293,'ACHARD','REGIS','1932-11-15','02.36.85.79.79','06.46.72.62.01',NULL,'29RUE DU CHATEAU D''EAU','','','61170','LE MELE SUR SARTHE',NULL,NULL,'2321114208001',958.000000000,'1954-10-13','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6294,'BABILOTTE','FABIENNE','1932-06-25','02.43.10.74.40',NULL,NULL,'RUE PRINCIPALE LE BOURG','','','14470','COURSEULLES SUR MER',NULL,NULL,'2320614490001',6.000000000,'1955-04-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6295,'FOESSEL','JULIENNE','1928-05-22','02.82.69.92.07','06.65.17.72.25',NULL,'22 rue des Frres Boutrois','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1280514609001',283.000000000,'1958-06-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6296,'JOUBERT','JEAN PAUL','1939-05-31','02.28.77.63.46','06.15.27.95.63',NULL,'LA GRANDE RUE BARBERY','','','14210','STE HONORINE DU FAY',NULL,NULL,'1390561407001',23.000000000,'1962-11-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6297,'GOUALARD','GISELE','1933-08-06','02.85.88.52.81','06.97.23.08.88',NULL,'9 RUE DU BERRY','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2330814167001',82.000000000,'1954-02-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6298,'GOUBERT','DENISE','1935-11-17','02.64.73.10.58','06.90.59.49.60',NULL,'13 RUE CAMILLE BLAISOT','','','14120','MONDEVILLE',NULL,NULL,'1351114103001',18.000000000,'1957-10-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6299,'GOUBERT','JACQUELINE','1951-01-19','02.25.12.30.04','06.11.53.48.83',NULL,'23 rue andre gide','','','14000','CAEN',NULL,NULL,'2510114467001',34.000000000,'1980-10-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6300,'LESAGE','THERESE','1961-03-27','02.46.92.91.83','06.87.94.74.25',NULL,'15 IMPASSE DES TILLEULS','','','14240','SALLEN',NULL,NULL,'1610361494001',419.000000000,'1989-09-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6301,'HAMELIN','nadine','1932-12-30','02.11.85.74.16',NULL,NULL,'4 RUE DU VIVIER','','','14000','CAEN',NULL,NULL,'2321214615001',30.000000000,'1957-03-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6302,'MARIAGE','','1932-12-26','02.67.44.77.43','06.26.32.63.11',NULL,'20 RUE DES ANEMONES','','',NULL,NULL,NULL,NULL,'1321214164001',1801.000000000,'1956-01-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6303,'DUPUY','MICHEL','1930-08-01','02.47.60.51.47','06.74.48.93.33',NULL,'12 RUE DU MANOIR','','','14120','MONDEVILLE',NULL,NULL,'1300814424001',469.000000000,'1958-08-28','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6304,'GUIHAIRE','MADELEINE','1938-05-25','02.87.02.10.36','06.12.28.92.52',NULL,'43 RUE DES ROCHES','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'2380514353001',29.000000000,'1963-08-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6305,'LUCAS','PAULETTE','1939-12-15','02.62.58.44.60','06.76.96.09.80',NULL,'13 rue jean joly','','','14290','ORBEC',NULL,NULL,'2391250059001',1191.000000000,'1961-10-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6306,'LEMENUEL','JEANNE','1946-10-20','02.58.16.70.92','06.82.80.27.42',NULL,'LE BOURG','','','14220','ST LAURENT DE CONDEL',NULL,NULL,'2461014087001',141.000000000,'1971-02-21','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6307,'SEBERT','VALERIE','1929-01-11','02.83.73.69.19','06.24.69.40.25',NULL,'94 RUE DE FALAISE','','',NULL,NULL,NULL,NULL,'2290161062001',1782.000000000,'1951-01-27','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6308,'SEIGNEURIE','BERNARD','1925-11-13','02.47.79.71.86','06.76.55.74.55',NULL,'10 RUE DU PERE SANSON','','','14210','AVENAY',NULL,NULL,'1251156121001',2826.000000000,'1953-05-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6309,'KETERS','NICOLE','1933-04-29','02.19.15.32.85','06.11.23.77.29',NULL,'9 RUE CHARLOTTE CORDAY','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1330414628001',125.000000000,'1958-11-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6310,'TAFFIN','MARCEL','1929-01-02','02.68.95.26.13','06.21.13.42.52',NULL,'54 RUE VICTOR LEPINE','','','14110','PROUSSY',NULL,NULL,'2290114489001',413.000000000,'1950-06-27','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6311,'GUESNON','MONIQUE','1954-01-05','02.12.02.84.40','06.10.32.53.73',NULL,'16 IMPASSE PASCAL','','','61570','MORTREE',NULL,NULL,'2540150370001',16.000000000,'1981-08-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6312,'PIGNIER','ALBERTE','1937-08-24','02.11.64.83.86','06.12.03.43.86',NULL,' 35 RUE DE BENAUVILLE','','','14480','VILLIERS LE SEC',NULL,NULL,'1370814201001',197.000000000,'1962-09-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6313,'ANDRISIK','CHRISTIANE','1937-03-24','02.76.08.54.93','06.55.44.41.43',NULL,'st pierre du mont','','','14000','CAEN',NULL,NULL,'2370361294001',40.000000000,'1958-08-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6314,'LEHERON','SYLVIE','1959-02-10','02.10.45.42.26','06.11.02.62.30',NULL,'le bourg','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2590214034001',320.000000000,'1984-09-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6315,'ADAM','JACQUELINE','1938-12-08','02.78.81.69.99','06.28.46.08.38',NULL,'22 RUE PIERRE CINGAL','','','14670','TROARN',NULL,NULL,'2381250077001',98.000000000,'1964-02-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6316,'LHERMENIER','MARIE THERESE','1928-09-26','02.48.79.37.85','00 33 6.71.48.03.92',NULL,'CHEMIN DE LA DOUCETIERE','','','14420','USSY',NULL,NULL,'1280914254001',72.000000000,'1951-03-12','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6317,'LEMONNIER','GASTON','1933-03-20','02.50.49.52.39','06.12.31.40.77',NULL,'8 rue des gres','','','14210','STE HONORINE DU FAY',NULL,NULL,'1330314200001',15.000000000,'1963-07-21','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6318,'LECONTE','PIERRE','1935-08-19','02.10.43.45.49','06.79.56.99.97',NULL,'11 rue bissonnet','','','50330','ST PIERRE EGLISE',NULL,NULL,'1350814413001',1204.000000000,'1959-05-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6319,'QUERREC','ROLAND','1933-04-29','02.49.02.90.27','06.80.66.12.17',NULL,'20 RUE MAURICE RAVEL','','','50150','SOURDEVAL',NULL,NULL,'2330414525001',31.000000000,'1955-09-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6320,'ROSSIGNOL','JACQUELINE','1936-04-27','02.11.06.95.27','06.71.08.49.60',NULL,'LA MERCERIE','','','14370','VIMONT',NULL,NULL,'2360461360001',166.000000000,'1966-07-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6321,'GUERRIER','YVES','1932-01-17','02.61.33.48.87','06.23.80.44.05',NULL,'','','','14400','BAYEUX',NULL,NULL,'1320114752001',132.000000000,'1962-07-20','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6322,'ZAJEWSKI','ANDREE','1930-07-20','02.14.87.16.39','06.51.77.30.15',NULL,'1 rue de la flagais','','','14670','TROARN',NULL,NULL,'1300714130001',4831.000000000,'1959-12-21','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6323,'ZAJEWSKI','JEAN PIERRE','1958-02-12','02.55.87.40.97','06.45.61.24.00',NULL,'37 av jean vilar','','','14000','CAEN',NULL,NULL,'2580214598001',41.000000000,'1980-03-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6324,'VAN DE CASTEELE','ANDRE','1946-01-06','02.11.21.39.71','06.70.98.05.82',NULL,'11 RUE DE LA REPUBLIQUE','','',NULL,NULL,NULL,NULL,'2460114434001',1674.000000000,'1973-01-24','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6325,'LESCAFFETTE','PASCAL','1933-12-30','02.66.83.42.77','06.16.57.71.66',NULL,'18 porte millet','','','14123','IFS',NULL,NULL,'1331250251001',886.000000000,'1956-08-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6326,'SIMON','PIERRETTE','1948-01-24','02.19.68.96.12','06.11.55.16.86',NULL,'ZONE ARTISANALE DES GOTHIERS','','','14000','CAEN',NULL,NULL,'2480150021001',23.000000000,'1970-10-20','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6327,'BRICET','BERNARD','1929-04-01','02.78.68.68.16','06.11.57.85.15',NULL,'6/2 av du rond point','','','14120','MONDEVILLE',NULL,NULL,'2290450202001',1411.000000000,'1953-11-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6328,'MARIE','ANNICK','1933-06-30','02.21.22.43.12','06.41.92.41.58',NULL,'39 AVENUE DU SIX JUIN','','','14670','TROARN',NULL,NULL,'1330650074001',506.000000000,'1957-05-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6329,'WIDEROWSKI','CHRISTIANE','1937-04-08','02.12.41.28.95','06.54.58.21.56',NULL,'7 BLD DU 13JUIN','','','14000','CAEN',NULL,NULL,'2370414756001',11.000000000,'1960-12-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6330,'DELAMORINIERE','JEAN PIERRE','1966-10-25','02.10.88.16.08','06.42.49.40.09',NULL,'27 rue du bout guesdon','','','14670','TROARN',NULL,NULL,'2661014073001',253.000000000,'1987-04-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6331,'CAPET','','1934-05-19','02.40.70.29.57','06.11.69.95.58',NULL,'coupigny','','',NULL,NULL,NULL,NULL,'1340527531001',1181.000000000,'1964-12-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6332,'LEVILLAIN','YVONNE','1933-05-16','02.62.18.85.92','06.93.45.41.92',NULL,'6 PLACE DU PARC','','','92100','BOULOGNE BILLANCOURT',NULL,NULL,'1330514187001',61.000000000,'1959-04-28','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6333,'LECHARTIER','PIERRE','1939-03-22','02.26.25.47.02','06.10.56.99.97',NULL,'5 rue albert frilley','','','14120','MONDEVILLE',NULL,NULL,'1390314745001',114.000000000,'1967-06-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6334,'FORTIER','JEAN PIERRE','1949-01-08','02.90.49.20.10','06.30.39.47.64',NULL,'38 BD LYAUTEY','','','14480','CULLY',NULL,NULL,'2490150196001',82.000000000,'1972-06-15','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6335,'LEPETIT','JACQUELINE','1964-06-06','02.11.13.13.16','06.12.26.97.27',NULL,'11 rue pre robert','','','14700','ST GERMAIN LANGOT',NULL,NULL,'1640675041001',666.000000000,'1990-11-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6336,'TANQUEREL','MARGUERITE','1930-12-04','02.28.21.01.54','06.75.95.65.38',NULL,'st blaise','','','14220','MUTRECY',NULL,NULL,'2301214436001',559.000000000,'1952-01-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6337,'GISZLER','EDOUARD','1967-02-10','02.49.07.21.03','06.33.56.16.30',NULL,'3 IMPASSE DE LA GARENNE','','','14000','CAEN',NULL,NULL,'1670214137001',33.000000000,'1989-11-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6338,'CHERI DIT LENAULT','ALAIN','1961-02-15','02.92.61.33.27','06.14.80.89.21',NULL,'43 QUAI DE JUILLET','','','14160','DIVES SUR MER',NULL,NULL,'2610214011001',62.000000000,'1990-04-14','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6339,'KORAL','CLAUDE MAURICE','1940-03-11','02.27.94.21.47','06.48.53.26.25',NULL,'18 rue des jouveaux','','','14000','CAEN',NULL,NULL,'1400314325001',120.000000000,'1961-03-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6340,'RENOUF','FRANCOISE','1934-07-28','02.12.27.22.76','06.14.33.37.11',NULL,'7 impasse de la vanoise','','','14120','MONDEVILLE',NULL,NULL,'2340727169001',319.000000000,'1956-04-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6341,'MARIE','ETIENNE','1946-04-25','02.33.41.54.69','06.12.28.65.79',NULL,'2 AVENUE DU PRESIDENT COTY','','','14730','GIBERVILLE',NULL,NULL,'1460477102001',427.000000000,'1970-12-11','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6342,'VASSE','NATHALIE','1931-11-22','02.76.84.04.04','06.23.36.59.57',NULL,'VILLAGE','','','14460','COLOMBELLES',NULL,NULL,'2311161342001',715.000000000,'1957-08-13','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6343,'GOUPIL','NADINE','1938-01-25','02.16.02.64.32','06.12.27.12.98',NULL,'6 rue auguste le chene','','','14120','MONDEVILLE',NULL,NULL,'1380114102001',12.000000000,'1960-03-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6344,'BEAUFILS','MICHEL','1936-08-13','02.82.88.78.94','06.62.13.61.02',NULL,'12 RUE DE LA CHARRIERE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2360814039001',17.000000000,'1966-10-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6345,'FLAMBARD','CHANTAL','1936-08-28','02.21.48.00.43','06.30.13.57.70',NULL,'5 chemin du commandant de touche','t','','14350','CARVILLE',NULL,NULL,'1360814327001',292.000000000,'1957-11-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6346,'MENARD','ANDRE','1938-09-23','02.90.08.60.57','06.21.45.10.22',NULL,'28 RUE DE PROVENCE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1380927253001',2425.000000000,'1960-10-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6347,'CEMON','MADELEINE','1943-02-12','02.59.77.32.91','06.94.05.45.80',NULL,'','','','14230','ISIGNY SUR MER',NULL,NULL,'2430214716001',662.000000000,'1970-09-19','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6348,'QUINETTE','MAURICE','1951-01-08','02.52.25.27.53','06.11.24.53.17',NULL,'','','','14210','MONTIGNY',NULL,NULL,'2510114209001',310.000000000,'1978-07-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6349,'LEVALLOIS','JACQUES','1953-01-23','02.12.22.37.08','06.50.20.98.22',NULL,'','','','14990','BERNIERES SUR MER',NULL,NULL,'1530114287001',148.000000000,'1981-03-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6350,'DEBLED','BRUNO','1910-09-23','02.35.02.80.86','06.91.02.38.29',NULL,'LA GRURIE','','','14240','CAUMONT L''EVENTE',NULL,NULL,'1100914118001',355.000000000,'1936-10-13','GOLD',24,1);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6351,'LEROUX','JACQUES','1928-04-30','02.87.16.34.37','06.32.53.21.88',NULL,'4 RUE DU PAVILLON','','','50810','ST JEAN DES BAISANTS',NULL,NULL,'2280489001001',732.000000000,'1956-07-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6352,'LEROUGE','GUY','1934-10-21','02.83.09.04.20','06.25.56.93.20',NULL,'3 RUE ROGER DECHAMBRE','','','50760','BARFLEUR',NULL,NULL,'1341014516001',38.000000000,'1956-08-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6353,'FAURIE','CASSIA','1936-02-21',NULL,NULL,NULL,'5 rue de la fosse  terre','','','14740','ROSEL',NULL,NULL,'2360214163001',32.000000000,'1958-09-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6354,'GAHERY','MARTINE','1931-11-15','02.48.31.71.69','06.11.10.11.32',NULL,'11 RUE SIRE CREULLY','','','14370','MERY CORBON',NULL,NULL,'1311114592001',10.000000000,'1952-01-31','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6355,'LEBOUCHER','SUZANNE','1930-03-18','02.10.47.73.16','06.33.99.80.18',NULL,'75 rue d ''auge','','','14400','BAYEUX',NULL,NULL,'2300353079001',177.000000000,'1953-09-21','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6356,'AIT ALDJET','MICHEL','1935-12-06','02.69.32.33.58','06.24.03.46.32',NULL,'1 rue jean de la bruyre','','','14000','CAEN',NULL,NULL,'1351260236001',842.000000000,'1956-01-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6357,'LEDENTU','JOSIANE',NULL,'02.70.42.04.17','06.47.06.27.94',NULL,'42 RUE DE L ESPERANCE','','','14860','BREVILLE LES MONTS',NULL,NULL,'1360114341001',1190.000000000,'2013-07-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6358,'LECHAT','ALFRED','1942-03-01','02.90.96.58.59','06.11.87.46.92',NULL,'4 RUE PAUL LANGEVIN','','','61430','ATHIS DE L''ORNE',NULL,NULL,'1420314505001',1672.000000000,'1970-02-07','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6359,'COLLET','MONIQUE','1955-03-21','02.89.52.92.15','06.39.16.29.03',NULL,'','','','14480','BAZENVILLE',NULL,NULL,'2550314054001',19.000000000,'1983-11-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6360,'CASTEL','THERESE','1969-11-07','02.40.62.95.73','06.14.82.52.48',NULL,'5 RUE MONGOLFIER','','','14123','IFS',NULL,NULL,'1691199256001',120.000000000,'1998-11-25','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6361,'LEBENOIT','SYLVIANE','1930-03-23','02.79.60.31.51','06.59.27.05.00',NULL,'16 RUE DE LA REFORME','','','14610','CAMBES EN PLAINE',NULL,NULL,'2300361209001',33.000000000,'1958-03-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6362,'BONNIN','XAVIER','1939-06-22','02.36.87.00.70','06.52.51.48.48',NULL,'2 RUE DU POINT DU JOUR','','','14000','CAEN',NULL,NULL,'2390614658001',13.000000000,'1964-03-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6363,'LECOINTRE','ROGER',NULL,'02.11.41.80.43','06.15.88.16.63',NULL,'25 RUE DES CANADIENS','','','14140','ST GERMAIN DE MONTGOMMERY',NULL,NULL,'1630927172001',12.000000000,'2009-10-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6364,'FAUVEL','NADINE','1933-12-17','02.41.95.39.14','06.89.96.65.33',NULL,'6 CHEMIN DE CAEN','','','50440','JOBOURG',NULL,NULL,'2331214158001',64.000000000,'1954-10-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6365,'LEFEVRE','FABIENNE','1956-02-27','02.11.42.62.00','06.21.09.65.41',NULL,'49 rue de messei','','','14260','AUNAY SUR ODON',NULL,NULL,'2560214118001',766.000000000,'1979-11-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6366,'SBRAIRE','BERNARD','1950-01-25','02.11.48.39.31','06.78.82.96.99',NULL,'22  BIS RUE ARISTIDE BRIAND','','','14690','PIERREFITTE EN CINGLAIS',NULL,NULL,'2500114017001',92.000000000,'1979-08-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6367,'CHARUEL','CAMILLE','1932-12-10','02.29.94.59.21','06.45.58.09.21',NULL,'RUE ETERNELLE','','',NULL,NULL,NULL,NULL,'2321261222001',28.000000000,'1955-11-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6368,'PESNEL','MARCEL','1960-02-12','02.18.90.86.18','06.63.24.50.42',NULL,'3 route de croissanville','','','14250','CHOUAIN',NULL,NULL,'2600214705001',90.000000000,'1985-05-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6369,'LAINE','ODETTE','1940-09-09','02.10.23.77.43','06.26.00.81.41',NULL,'14 rue du blanc','','','14680','GOUVIX',NULL,NULL,'2400914723001',357.000000000,'1963-05-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6370,'DALISSON','HELENE','1928-09-16','02.80.31.87.67','06.33.98.02.19',NULL,'LES TROENES','','','14930','ETERVILLE',NULL,NULL,'1280914743001',212.000000000,'1950-02-20','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6371,'PRIEUR','SOLANGE','1934-08-26','02.29.97.78.20','06.17.78.45.71',NULL,'9 RUE DE L''AMIRAL COURBET','','','14320','FONTENAY LE MARMION',NULL,NULL,'2340850200001',402.000000000,'1956-05-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6372,'MARIE','JEAN JACQUES','1929-05-05','02.34.69.19.94','06.78.31.25.36',NULL,'8-3 ALLEE DES CAMPANULES','','','14460','COLOMBELLES',NULL,NULL,'2290550417001',140.000000000,'1957-08-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6373,'BAZEILLE','Jean-jacques','1950-02-24','02.53.61.53.20','06.22.95.09.14',NULL,'25 rue leclerc','','','14840','DEMOUVILLE',NULL,NULL,'2500214590001',14.000000000,'1980-05-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6374,'GAIGNARD','MADELEINE','1929-07-03','02.75.43.90.06','06.10.70.99.80',NULL,'11 rue du marechal leclerc','','','14370','AIRAN',NULL,NULL,'1290714309001',68.000000000,'1952-09-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6375,'MAMEDOVA','ALIETTE','1937-12-17','02.73.72.91.58','06.10.69.35.17',NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1371222069001',1449.000000000,'1967-10-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6376,'GAUDIN','BERNARD','1929-12-17','02.17.91.04.68','06.52.31.94.26',NULL,'21 rue du clos des roses','','','14370','AIRAN',NULL,NULL,'1291214160001',42.000000000,'1957-03-27','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6377,'COUSIN','DANIEL','1939-08-27','02.23.35.43.49','06.32.20.34.12',NULL,'177 rue basse','','','14270','MEZIDON CANON',NULL,NULL,'1390814729001',682.000000000,'1965-06-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6378,'VAUGEOIS','NICOLE','1930-01-26','02.11.15.84.24','06.62.11.54.48',NULL,'30 AVENUE DU GENERAL DE GAULLE','','','14830','LANGRUNE SUR MER',NULL,NULL,'1300114408001',27.000000000,'1951-02-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6379,'KEMPERDICK','DAVID','1966-07-21',NULL,NULL,NULL,'LE BOISSEY','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1660714493001',9.000000000,'1994-12-28','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6380,'GALLET','ANDREE','1939-06-23','02.32.51.83.54','06.89.85.39.34',NULL,'impasse des bleuets','','','14570','CLECY',NULL,NULL,'1390614046001',4122.000000000,'1963-10-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6381,'MARTIN','ODETTE','1959-01-13','02.55.37.80.54','06.28.27.42.75',NULL,'10 rue des moulins','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1590114233001',171.000000000,'1987-01-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6382,'ACHARD','SYLVAIN','1959-01-29','02.39.25.60.05','06.12.09.96.85',NULL,'16 RUE DE LA POMME','','','14540','BOURGUEBUS',NULL,NULL,'1590114233001',27.000000000,'1984-08-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6383,'LONDES','ODETTE','1938-02-22','02.60.54.24.49','06.51.70.25.94',NULL,'14 allee gide','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1380250558001',1408.000000000,'1961-08-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6384,'TITON','FRANCOISE','1937-05-21','02.81.97.32.37','06.10.92.56.03',NULL,'8 RUE DES PETITS PAVES','','','14000','CAEN',NULL,NULL,'1370550092001',2609.000000000,'1966-12-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6385,'MAUVOISIN','MARCEL','1949-01-29','02.15.78.38.57','06.67.35.88.17',NULL,'5 impasse du clos charmant','','','14120','MONDEVILLE',NULL,NULL,'1490114505001',389.000000000,'1972-05-24','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6386,'POUCHIN','CHRISTIAN','1937-03-31','02.39.35.42.44','06.20.06.99.70',NULL,'LE MESNIL DE BENNEVILLE','','','14123','IFS',NULL,NULL,'2370350615001',35.000000000,'1961-10-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6387,'SIMON','LOUIS','1963-08-09','02.39.61.00.05','06.57.54.34.68',NULL,'1 RUE D4EVRECY','','','14210','TROIS MONTS',NULL,NULL,'1630821460001',193.000000000,'1992-03-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6388,'POULAIN','YVONNE CECILE M','1956-02-19','02.72.50.44.56','06.46.51.13.71',NULL,'37 RUE PIERRE DE COUBERTIN','','','14370','BELLENGREVILLE',NULL,NULL,'2560214046001',67.000000000,'1980-03-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6389,'TSIKLAURI','JACQUELINE',NULL,'02.56.54.54.53','06.13.46.69.97',NULL,'LE BOURG','','',NULL,NULL,NULL,NULL,'2340113042001',10.000000000,'2009-09-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6390,'JOURDAN','vadim','1966-03-22','02.52.45.51.12','06.37.87.45.25',NULL,'6 ROUTE DE CAEN','','','14220','DONNAY',NULL,NULL,'1660314453001',211.000000000,'1996-10-06','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6391,'POETTE','MARCEL','1939-02-04','02.57.08.65.35','06.45.42.66.02',NULL,'5 BIS RUE MARGUERITE DURAS','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'2390250507001',508.000000000,'1969-05-17','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6392,'DOIX','ANTOINETTE','1956-03-24','02.10.79.43.48','06.48.97.33.81',NULL,'LE BOURG','','','50250','LA HAYE DU PUITS',NULL,NULL,'2560314308001',1693.000000000,'1978-10-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6393,'TAUDU','MONIQUE','1951-01-02','02.89.89.18.56','00 33 6.78.20.94.62',NULL,'le plessis','','','14190','ROUVRES',NULL,NULL,'2510150548001',57.000000000,'1976-12-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6394,'BOISGONTIER','guy','1935-02-23','02.37.60.20.44','06.90.75.06.19',NULL,'14 RUE JULES MICHELET','','','14000','CAEN',NULL,NULL,'1350227629001',1296.000000000,'1965-02-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6395,'ROGUE','MADELEINE','1935-03-10','02.81.33.05.09','06.49.05.41.67',NULL,'RUE DE L''EGLISE','','','14420','BONS TASSILLY',NULL,NULL,'1350361282001',60.000000000,'1958-03-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6396,'RAOULT','LOUIS','1931-12-26','02.25.41.35.49','06.70.71.34.96',NULL,'HAMEAU DE GLATINY','','','14130','ST GATIEN DES BOIS',NULL,NULL,'2311261303001',1107.000000000,'1952-02-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6397,'MARIE','HUBERT','1930-08-20','02.91.64.89.59','06.11.92.06.27',NULL,'38 RUE VICTOR TESNIERES','','','14860','RANVILLE',NULL,NULL,'1300814761001',37.000000000,'1957-01-13','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6398,'ROUXEL','ROGER','1950-02-05','02.45.49.34.45','06.42.08.54.80',NULL,'33 RUE ERNEST MANCHON','','',NULL,NULL,NULL,NULL,'2500214498001',609.000000000,'1979-06-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6399,'','MARTHE','1952-01-15','02.25.88.04.23','06.52.58.82.55',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'2520150517001',31.000000000,'1982-01-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6400,'GROULT','',NULL,'02.10.67.84.24','06.80.83.81.06',NULL,'9 ALLEE ERNEST BLOT','','','14630','FRENOUVILLE',NULL,NULL,'2630614635001',188.000000000,'2013-03-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6401,'HETTIER','VALERIE','1928-08-03','02.18.08.75.94','06.68.58.98.07',NULL,'4 RUE DU MARAIS','','','14123','FLEURY SUR ORNE',NULL,NULL,'2280814695001',30.000000000,'1950-09-20','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6402,'ROSSIGNOL','JACKY','1934-04-05','02.12.15.46.51','06.63.20.13.98',NULL,'4 ROUTE DE VIMONT','','','14000','CAEN',NULL,NULL,'2340453064001',29.000000000,'1955-01-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6403,'MANSOURI','PIERRE','1935-05-17','02.48.46.24.06','06.11.59.91.72',NULL,'MAISON DE RETRAITE LES HAUTS VEN','TS 31 RUE DU DR MAUBERT','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1350514461001',954.000000000,'1963-04-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6404,'TANQUEREL','HENRI','1939-07-02','02.24.76.18.16','06.79.31.52.93',NULL,'7 RUE ROGER BASTION','','','14320','LAIZE LA VILLE',NULL,NULL,'1390750338001',65.000000000,'1962-08-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6405,'DAVID','MARIE JOSEPHE','1969-09-20','02.20.70.44.92','06.75.22.79.50',NULL,'55 BIS RUE D''AUTHIE','','','14220','PLACY',NULL,NULL,'2690950502001',551.000000000,'1991-01-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6406,'LENORMAND','ANDRE','1941-12-14','02.65.68.88.84','06.10.32.02.65',NULL,'108 RUE DE FALAISE','','','14000','CAEN',NULL,NULL,'1411275035001',5.000000000,'1966-12-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6407,'BAIGNEUX','GAETAN','1951-01-19','02.45.80.00.97','06.72.23.86.46',NULL,'22 RUE EMILE ZOLA','','','35410','CHATEAUGIRON',NULL,NULL,'2510150121001',15.000000000,'1977-08-22','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6408,'FOUQUEREL','MARIE THERESE',NULL,'02.89.36.74.94',NULL,NULL,'','','','14670','BURES SUR DIVES',NULL,NULL,'2330550240001',29.000000000,'2012-03-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6409,'BEURON','GERARD','1960-06-12','02.96.52.05.06','06.47.39.94.99',NULL,'9 RUE DES PAVILLONS','','','50500','CARENTAN',NULL,NULL,'2600614016001',2178.000000000,'1989-03-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6410,'SALLOT','MAURICETTE','1965-01-04','02.10.10.57.71','06.11.73.85.74',NULL,'57 RUE DU GENERAL LECLERC','','','61220','POINTEL',NULL,NULL,'2650114338001',179.000000000,'1986-11-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6411,'DESLANDES','JOCELYNE','1935-09-04','02.12.67.54.70','06.43.14.76.65',NULL,'19 rue paul claudel','','','14740','ROSEL',NULL,NULL,'2350950109001',93.000000000,'1957-08-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6412,'ZAJEWSKI','DROUIN','1934-12-04','02.41.88.66.76','06.71.99.86.74',NULL,'26. rue d arromanches','','','14730','GIBERVILLE',NULL,NULL,'1341214648001',112.000000000,'1958-11-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6413,'BASLY','MICHEL','1937-01-23','02.34.27.71.50','06.55.04.53.51',NULL,'68  ROUTE DE LA GUERINIERE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1370114340001',1059.000000000,'1961-01-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6414,'LABEY','COLETTE','1933-08-23','02.39.89.58.20','06.86.10.01.09',NULL,'33 chemin de l''arguilly','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1330814114001',8.000000000,'1954-05-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6415,'TOUQUET','LYDIE','1928-11-06','02.31.63.66.27','06.57.93.86.73',NULL,'45 AVENUE DU 6 JUIN','','','14390','CABOURG',NULL,NULL,'2281114453001',76.000000000,'1950-01-28','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6416,'GUILLOT','PHILIPPE','1945-01-19','02.11.57.40.39','06.70.97.52.00',NULL,'','','','14210','EVRECY',NULL,NULL,'2450150555001',96.000000000,'1972-12-29','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6417,'QUIDOR DIT PASQUET','ROGER','1934-08-13','02.63.32.72.55','06.84.43.29.10',NULL,'1 RUE DE LA VALLEE','','','14120','MONDEVILLE',NULL,NULL,'1340850164001',2897.000000000,'1964-09-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6418,'RAY','PIERRE','1947-02-20','02.55.31.60.16','06.93.19.56.34',NULL,'','','','14160','DIVES SUR MER',NULL,NULL,'2470227207001',22.000000000,'1975-12-08','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6419,'FLEURY','narcisse','1969-05-06','02.11.33.56.42','06.78.10.75.20',NULL,'18 BIS RUE RGT MAISONNEUVE','','','14150','OUISTREHAM',NULL,NULL,'1690514366001',618.000000000,'1995-09-01','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6420,'QUINETTE','DENISE','1939-07-02','02.19.24.80.56','06.19.25.29.91',NULL,'LA VIEILLE PLACE','','','14120','MONDEVILLE',NULL,NULL,'2390714437001',305.000000000,'1966-11-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6421,'LEGRAND','DENISE','1929-02-17','02.90.66.87.33','06.56.41.00.63',NULL,'15 rue charles gounod','','','14320','FONTENAY LE MARMION',NULL,NULL,'2290222374001',14.000000000,'1950-11-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6422,'LAMBERT','JACQUES','1935-06-26','02.10.54.06.86','06.11.93.42.67',NULL,'16 rue du 15 juin 44','','','14123','FLEURY SUR ORNE',NULL,NULL,'2350650581001',616.000000000,'1956-07-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6423,'','IRENE','1961-10-04','02.10.07.19.38','06.70.01.53.71',NULL,'RUE GEORGES LANDRY','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1611014353001',110.000000000,'1983-07-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6424,'GIBERT','ROBERT','1969-07-23','02.76.72.52.16','06.56.25.75.07',NULL,'10 rue de l hudson','','','14270','MEZIDON CANON',NULL,NULL,'1690714109001',831.000000000,'1993-10-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6425,'ANGOT','CHRISTIANE','1969-11-20','02.64.07.06.07','06.10.72.70.91',NULL,'10 PLACE DE LA JUSTICE','','','14170','BERVILLE',NULL,NULL,'1691199256001',50.000000000,'1993-05-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6426,'DUREL','ISABELLE','1938-02-18','02.59.70.22.22','06.75.97.66.03',NULL,'10 rue st vincent de paul','','','14220','THURY HARCOURT',NULL,NULL,'2380227361001',1355.000000000,'1959-01-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6427,'DUBOST','JACQUELINE','1931-07-09','02.10.55.34.10','00 33 6.46.95.05.72',NULL,'6 rue saint germain','','','14540','SOLIERS',NULL,NULL,'2310708107001',36.000000000,'1960-03-04','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6428,'AULNETTE','GINETTE','1935-09-02','02.78.79.00.36','06.18.05.51.01',NULL,'13 BD DE LA LIBERATION','','','14270','MAGNY LE FREULE',NULL,NULL,'1350950389001',19.000000000,'1959-10-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6429,'GRESSELIN','MAURICE','1934-06-18','02.84.10.50.26','06.10.73.22.37',NULL,'les epinettes','','','14220','BARBERY',NULL,NULL,'1340661487001',171.000000000,'1963-12-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6430,'LEMARINIER','JOSSELINE','1942-01-04','02.73.91.78.48','06.65.88.42.13',NULL,'12 RUE J MERMOZ','','','14170','ST MARTIN DE FRESNAY',NULL,NULL,'1420114543001',198.000000000,'1969-09-24','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6431,'MARIE','ARLETTE','1938-08-24','02.58.98.08.21','06.12.94.97.94',NULL,'3 RUE HUCHETTE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2380814243001',32.000000000,'1959-04-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6432,'GUERIN','EDITH','1916-04-23','02.62.50.36.57','06.11.58.71.31',NULL,'10 AVENUE DE CABOURG','','','14120','MONDEVILLE',NULL,NULL,'2160436173001',201.000000000,'1942-01-29','PREMIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6433,'MANET','gilbert','1953-01-02','02.55.12.87.45','06.60.89.71.41',NULL,'','','','14000','CAEN',NULL,NULL,'1530114106001',528.000000000,'1975-12-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6434,'LEGUEDOIS','ODETTE','1968-02-27','02.14.19.27.31','06.30.33.02.95',NULL,'','','',NULL,NULL,NULL,NULL,'1680214410001',64.000000000,'1991-09-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6435,'DELAHAYE','ARMELLE','1964-02-03','02.91.23.19.88','06.53.17.29.00',NULL,'8 RESIDENCE OLYMPIA','','','14000','CAEN',NULL,NULL,'1640261217001',382.000000000,'1987-12-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6436,'DESSEAUX','JEAN','1947-01-24','02.13.04.14.84','06.41.27.49.19',NULL,'LE CLOS SAINT LO','','','14000','CAEN',NULL,NULL,'2470114482001',42.000000000,'1977-09-21','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6437,'COLETTE','LUCIEN','1968-11-05','02.60.79.67.81','06.12.13.85.27',NULL,'10 rue de la verger','','','14990','BERNIERES SUR MER',NULL,NULL,'2681114119001',15.000000000,'1998-12-25','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6438,'PISLARD','YVELINE','1935-03-18','02.17.36.90.61','06.92.58.71.19',NULL,'4 RESIDENCE OLYMPIA','','','76170','LILLEBONNE',NULL,NULL,'2350314713001',1278.000000000,'1964-02-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6439,'COURTIN','MARIE LINE','1928-08-07','02.82.94.95.44','06.63.72.99.86',NULL,'8 RUE DE SOLOGNE','','','14123','IFS',NULL,NULL,'1280814462001',39.000000000,'1951-04-26','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6440,'CLAUS','RENEE','1928-01-16','02.32.06.88.55','06.68.01.77.44',NULL,'L''ANCIENNE NATIONALE','','','14123','IFS',NULL,NULL,'1280114142001',3255.000000000,'1952-11-05','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6441,'LETELLIER','HUBERT','1932-09-04','02.17.00.27.87','06.59.25.54.01',NULL,'LE VAL D''OR 18 RUE ROGER AINI','','','14480','RUCQUEVILLE',NULL,NULL,'2320945009001',564.000000000,'1954-05-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6442,'DUVAL','FERNANDE','1956-01-04','02.10.29.45.56','06.12.94.16.47',NULL,'18 PORTE MILLET','','','14220','ESSON',NULL,NULL,'2560114738001',86.000000000,'1979-06-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6443,'BEAUMOIS','FERNANDE','1952-03-12','02.50.00.97.51','06.24.95.27.67',NULL,'9 RUE ALBERT MOUSSET','','','14150','OUISTREHAM',NULL,NULL,'2520314034001',639.000000000,'1979-01-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6444,'ALLAIRE','SERGE','1932-01-02','02.79.13.22.84','06.39.59.15.86',NULL,'11 ROUTE DE CORMELLES','','','14123','IFS',NULL,NULL,'2320161457001',151.000000000,'1960-01-30','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6445,'ESCRIBANO','RENE','1931-03-18','02.11.92.44.07','06.69.30.74.15',NULL,'1 chemin clairon','','','14000','CAEN',NULL,NULL,'1310314626001',80.000000000,'1953-02-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6446,'JANKOWSKI','MONIQUE','1957-01-03','02.11.10.34.54','06.10.92.59.09',NULL,'11 RUE DE PROVENCE','','','14540','BOURGUEBUS',NULL,NULL,'2570114015001',788.000000000,'1984-03-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6447,'HEUZE','MARTINE','1966-05-13','02.20.35.80.65','06.80.63.23.80',NULL,'4 RUE ST JEAN','','','14630','FRENOUVILLE',NULL,NULL,'2660550153001',158.000000000,'1995-11-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6448,'DAUMESNIL','ROGER','1936-03-04','02.12.24.31.83','06.70.43.62.45',NULL,'chez mr. Badiradze Tino  2 rue d','e champagne porte 5','','14830','LANGRUNE SUR MER',NULL,NULL,'1360314160001',491.000000000,'1958-08-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6449,'GICQUEL','GEORGETTE','1932-09-22','02.14.82.84.22','06.10.76.66.00',NULL,'7 RUE PASTEUR','','','14123','FLEURY SUR ORNE',NULL,NULL,'2320914505001',17.000000000,'1953-12-14','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6450,'LEDARD','PHILIPPE','1939-11-04','02.47.20.73.02','06.27.54.20.51',NULL,'LE BOURG','','','14330','STE MARGUERITE D''ELLE',NULL,NULL,'1391114430001',76.000000000,'1968-04-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6451,'LEMEE','MARCEL','1933-11-27','02.12.88.13.21','06.85.26.30.93',NULL,'21 RUE DE L''ABBAYE','','','14120','MONDEVILLE',NULL,NULL,'1331114481001',19.000000000,'1957-06-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6452,'CHENNEVIERE','RAYMOND','1935-07-29','02.17.48.10.55','06.57.04.08.72',NULL,'24 RUE DE SULLY la gueriniere a','ppt 24','','14540','BOURGUEBUS',NULL,NULL,'1350714483001',36.000000000,'1963-01-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6453,'BIGEON','MARCELLE','1930-08-04','02.37.59.80.93','06.75.31.36.11',NULL,'31 RUE DE CREMEL RES DU NOUVEAU','MONDE','','14650','CARPIQUET',NULL,NULL,'2300814221001',98.000000000,'1954-08-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6454,'LERDU','ROLAND','1943-04-10','02.45.35.96.72','06.19.17.65.03',NULL,'26 RUE LE GRAND LARGE','','','14123','IFS',NULL,NULL,'2430414436001',613.000000000,'1966-07-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6455,'GARNIER','RENE','1939-05-08','02.10.84.62.55','06.87.14.41.31',NULL,'ROUTE NATIONALE','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1390580814001',28.000000000,'1964-08-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6456,'GOSSELIN','JACQUES','1931-09-19','02.29.29.15.16','06.62.78.95.78',NULL,'ROUTE DE COIGNY','','','14220','GRIMBOSQ',NULL,NULL,'1310914675001',76.000000000,'1956-08-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6457,'LOUET','DOMINIQUE','1936-11-16','02.93.38.15.42','06.12.41.33.42',NULL,'403 BVD DES BELLES PORTES','','','14540','SOLIERS',NULL,NULL,'1361150599001',487.000000000,'1961-10-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6458,'DRIEU','JEAN','1940-11-26','02.57.65.95.90','06.16.28.87.53',NULL,'10RUE ABBE BOULLIER','','','14000','CAEN',NULL,NULL,'1401150229001',71.000000000,'1965-07-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6459,'CRUCHON','Claude','1924-09-04','02.47.97.23.19','06.50.63.13.88',NULL,'22 RUE DU PARC','','','14370','ARGENCES',NULL,NULL,'2240937032001',65.000000000,'1945-02-03','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6460,'MARTINO','JOELLE','1929-03-11','02.11.99.34.62','06.10.84.89.14',NULL,'HARAS DE LA HARLIERE','','','14700','FALAISE',NULL,NULL,'2290350127001',61.000000000,'1956-09-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6461,'CARABY','JACQUES','1930-08-18','02.12.15.82.51','06.11.22.79.22',NULL,'2 rue marechal foch','','','14260','AUNAY SUR ODON',NULL,NULL,'1300862073001',1091.000000000,'1951-07-26','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6462,'FREMONT','FERNANDE','1940-10-12','02.70.47.66.06','06.48.89.84.10',NULL,'21 CHEMIN DE VILLENEUVE','','','14210','AVENAY',NULL,NULL,'1401050463001',24.000000000,'1964-12-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6463,'LEFEBVRE','ROGER','1959-01-15','02.85.31.49.51','06.95.90.88.63',NULL,'20 RUE ROUGEMONT','','','14270','MEZIDON CANON',NULL,NULL,'2590114057001',4114.000000000,'1989-12-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6464,'VILLEROY','CLAUDE','1953-05-05','02.40.46.87.53','06.41.42.73.00',NULL,'foyer residence  appt 28 rue des',' acacias','','14000','CAEN',NULL,NULL,'1530572030001',59.000000000,'1975-08-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6465,'GUIBLIN','GUY','1934-05-04','02.84.54.13.11','06.73.03.60.88',NULL,'12 rue de la rouvre','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2340554176001',54.000000000,'1960-04-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6466,'HAMEL','MIREILLE','1960-04-04','02.50.02.56.95','06.73.86.77.85',NULL,'10- 2 avenue du rond point','','','14000','CAEN',NULL,NULL,'1600414543001',59.000000000,'1984-01-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6467,'BISSON','COLETTE','1930-11-20','02.23.97.66.54','06.22.67.08.25',NULL,'68 RUE DE LA SEINE','','','14000','CAEN',NULL,NULL,'1301114152001',1875.000000000,'1951-12-20','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6468,'GRANDIN','JACQUELINE','1951-03-03','02.19.39.98.65','06.65.00.65.41',NULL,'1547 RUE DE BRETTEVILLE','','','14230','OSMANVILLE',NULL,NULL,'1510314705001',8.000000000,'1976-10-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6469,'BRIARD','SYLVIE','1964-07-15','02.65.26.72.48','06.10.64.32.83',NULL,'BP 11 LE NOUVEAU MONDE','','','14430','DOUVILLE EN AUGE',NULL,NULL,'1640714090001',4.000000000,'1993-01-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6470,'BOUTELOUP','jean claude','1931-10-22','02.22.02.33.30','06.89.44.34.10',NULL,'6 IMPASSE DE LA FERME','','','27310','ST OUEN DE THOUBERVILLE',NULL,NULL,'1311014515001',71.000000000,'1955-07-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6471,'CHEVIN','MARIE MADELEINE','1943-05-24','02.24.06.08.92','06.85.95.63.75',NULL,'4 ROUTE DE GRISY','','',NULL,NULL,NULL,NULL,'1430575072001',183.000000000,'1970-05-04','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6472,'FOURAY','JACQUES','1936-08-02','02.40.16.93.54','06.43.63.55.71',NULL,'place de l eglise','','','14123','IFS',NULL,NULL,'1360814346001',107.000000000,'1959-03-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6473,'LEVERRIER','MADELEINE','1937-08-03','02.87.02.55.39','06.85.85.17.43',NULL,'14 RUE DE QUILLY','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1370850194001',5.000000000,'1965-07-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6474,'HAMEL','HUBERT','1963-02-06','02.10.93.29.96','06.68.32.23.44',NULL,'2 rue cardinal lavigerie','','','50250','PRETOT STE SUZANNE',NULL,NULL,'1630214482001',1208.000000000,'1993-02-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6475,'HERVIEU','NELLY','1969-06-12','02.55.66.96.56','06.10.12.43.40',NULL,'32 RUE PICQUENOT','','','14120','MONDEVILLE',NULL,NULL,'2690692036001',12.000000000,'1993-03-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6476,'DE WILDE','LUCETTE','1929-04-01','03.57.03.90.70','06.99.54.24.24',NULL,'57 CLOS MICHEL','','','62380','WAVRANS SUR L''AA',NULL,NULL,'2290461306001',17.000000000,'1950-02-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6477,'DELAPIERRE','JACQUES','1965-09-15','02.35.01.23.77','06.61.87.72.88',NULL,'RUE LES ORMES','','','14120','MONDEVILLE',NULL,NULL,'2650914454001',1525.000000000,'1989-10-31','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6478,'MARIE','LOUISE','1929-04-08','02.12.27.75.34','06.25.49.95.84',NULL,'11 RUE LA CHAILLOIRE','','','14860','AMFREVILLE',NULL,NULL,'1290414623001',24.000000000,'1951-09-11','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6479,'MEUNIER','GUY','1938-02-13','02.66.97.69.57','00 33 6.36.12.42.72',NULL,'60 RUE DES ACACIAS','','','14000','CAEN',NULL,NULL,'2380214360001',96.000000000,'1964-03-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6480,'VAUVERT','CHRISTIAN','1963-02-21','02.79.80.46.75','06.73.50.24.82',NULL,'17 RUE EUGENE PAPIN','','','14000','CAEN',NULL,NULL,'2630214341001',264.000000000,'1990-07-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6481,'LEROUX','GILBERT','1940-07-12','02.76.09.73.00','06.43.13.36.81',NULL,'9 rue des pins','','','14670','TROARN',NULL,NULL,'1400714482001',5.000000000,'1967-10-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6482,'TREFEU','NADINE','1934-06-14','02.85.34.76.87','06.63.12.61.26',NULL,'LIEU DIT "LA CANNE"','','','14000','CAEN',NULL,NULL,'1340650031001',805.000000000,'1956-08-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6483,'FAFIN','JACQUES','1940-10-20','02.99.52.70.94','06.75.35.44.37',NULL,'20 RUE DES QUESNOTS','','','14630','CAGNY',NULL,NULL,'2401014542001',68.000000000,'1962-02-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6484,'DORIOT','RENE','1943-04-19','02.62.12.90.48','06.70.13.65.20',NULL,'38 RUE BOURG CAILLET','','','14000','CAEN',NULL,NULL,'1430414588001',29.000000000,'1973-08-08','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6485,'DELHOMME','MARCEL','1947-07-11','02.10.09.53.01','06.10.33.17.57',NULL,'6 PLACE PASTEUR','','','14540','SOLIERS',NULL,NULL,'1470714674001',172.000000000,'1969-09-20','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6486,'BRIERE','GHISLAINE','1952-01-05','02.10.89.93.79','06.10.70.81.60',NULL,'120 BOULEVARD DU MARECHAL LECLER','C','','14000','CAEN',NULL,NULL,'2520161022001',1910.000000000,'1982-08-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6487,'','CECILE','1960-07-11','02.35.13.07.30','06.72.24.45.54',NULL,'25 AVENUE LEON BLUM','','','14670','JANVILLE',NULL,NULL,'2600714297001',1131.000000000,'1983-12-23','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6488,'LECOUFLE','ROBERT','1950-08-19','02.45.19.90.86','06.76.63.72.28',NULL,'76 RUE DE LA REFORME','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2500814114001',21.000000000,'1977-10-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6489,'THOMASSE','MADELEINE','1933-08-28','02.97.37.43.73','06.37.63.55.47',NULL,'12 rue des fosettes','','','14970','BENOUVILLE',NULL,NULL,'2330814169001',209.000000000,'1954-02-20','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6490,'ORIN','HUBERT','1939-02-12','02.71.80.63.53','06.34.50.23.05',NULL,'7 RUE VINCENT MUSSELLI','','','14370','ARGENCES',NULL,NULL,'2390262264001',935.000000000,'1964-04-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6491,'LEGENDRE','CLAIRE','1928-03-24','02.26.31.68.18','06.70.80.24.07',NULL,'6 RUE ROND POINT DE L''EUROPE','','','14670','TROARN',NULL,NULL,'1280314046001',34.000000000,'1953-06-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6492,'DELANOUE','MADELEINE','1983-11-19','02.52.41.51.41','06.78.75.50.54',NULL,'8 rue du surrey','','','14540','GRENTHEVILLE',NULL,NULL,'1831199321001',150.000000000,'2007-09-04','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6493,'DESMOT','COLETTE','1921-01-27','02.12.21.60.94','06.28.92.30.91',NULL,'59 AVENUE DU 6 JUIN BAT C','','','14120','MONDEVILLE',NULL,NULL,'1210114554001',21.000000000,'1943-04-13','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6494,'JEANNE','CHRISTIAN','1969-11-16','02.11.47.17.99','06.60.36.50.56',NULL,'19 RUE DU PETIT RIOU','','','14930','MALTOT',NULL,NULL,'1691199256001',899.000000000,'1996-03-13','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6495,'ROUSSELLE','HUBERT',NULL,'02.80.99.70.30','06.27.94.62.07',NULL,'LA TRANQUERIE','','','14170','MITTOIS',NULL,NULL,'1291161102001',349.000000000,'2011-10-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6496,'YON','PIERRE','1931-12-28','02.47.20.99.94','06.41.93.55.21',NULL,'36 RUE MARTINVILLE','','','50570','MARIGNY',NULL,NULL,'2311214092001',5081.000000000,'1957-05-11','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6497,'TRIBOUILLARD','JULES','1935-03-08','02.77.85.40.53','06.18.34.40.02',NULL,'40 RUE LA GOSSELINERIE','','','14123','IFS',NULL,NULL,'2350350351001',18.000000000,'1965-03-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6498,'GRANGE','ETIENNE','1963-01-02','02.73.80.54.91','06.80.13.92.61',NULL,'25 rue guy de maupassant','','','50390','ST SAUVEUR LE VICOMTE',NULL,NULL,'2630180410001',2513.000000000,'1990-06-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6499,'LE BLOND','ROGER','1956-02-19','02.48.75.34.72','06.75.03.04.86',NULL,'21 rue de l avenir','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1560276636001',14.000000000,'1980-10-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6500,'BRUNET','Fernand',NULL,'02.67.02.39.02','06.41.62.42.97',NULL,'66 RUE Alfred . POUPART','','','14240','CAHAGNES',NULL,NULL,'1530414493001',1018.000000000,'2009-02-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6501,'TREMEREL','nadine','1934-06-22','02.10.32.39.05','06.66.96.26.39',NULL,'18 GRANDE RUE','','','14210','STE HONORINE DU FAY',NULL,NULL,'1340650268001',318.000000000,'1957-11-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6502,'MILON','MARCEL','1936-11-12','02.78.94.42.81','06.91.11.24.49',NULL,'9 rue du hameau de l eglise','','','14000','CAEN',NULL,NULL,'2361185063001',94.000000000,'1960-10-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6503,'HUBERDEAU','ANDREE','1931-12-23','02.22.32.80.12','06.24.74.00.33',NULL,'23 rue bertelot','','','50700','COLOMBY',NULL,NULL,'2311214092001',204.000000000,'1956-08-29','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6504,'MARESCOT','MIREILLE','1969-11-04','02.71.85.66.32','06.50.00.01.13',NULL,'7 ROUTE D''IFS','','','14480','LE FRESNE CAMILLY',NULL,NULL,'1691199256001',124.000000000,'1992-03-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6505,'COCHIN','COLETTE','1956-02-06','02.49.01.44.47','06.27.77.31.17',NULL,'50 RUE ARMAND MARIE','','','14370','MOULT',NULL,NULL,'1560276636001',315.000000000,'1978-05-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6506,'LECLERC','Martine','1938-03-08','02.11.67.78.24','06.39.27.45.13',NULL,'LE LIEU DES JARDINS','','','14700','VIGNATS',NULL,NULL,'2380314235001',63.000000000,'1959-12-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6507,'DUBOSCQ','LEON','1925-05-30','02.66.49.73.97','06.77.13.10.52',NULL,'30 RUE DU BOIS CRAQUET','','','61330','CEAUCE',NULL,NULL,'2250578132001',170.000000000,'1948-10-20','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6508,'MIKOLAJCZAK','MARYVONNE','1953-01-24','02.61.73.87.20','06.10.59.22.69',NULL,'19 RUE D''ALENCON','','','14111','LOUVIGNY',NULL,NULL,'1530114132001',7.000000000,'1978-12-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6509,'DELANNEE','EDMOND','1931-01-19','02.74.26.71.76',NULL,NULL,'RUE LA GRAUDAIS','','','14480','LE FRESNE CAMILLY',NULL,NULL,'2310114011001',329.000000000,'1953-12-10','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6510,'LETOREY','Claire','1960-05-27','02.77.24.57.34','06.11.67.12.48',NULL,'3 IMPASSE DU HOME','','','14120','MONDEVILLE',NULL,NULL,'2600514209001',426.000000000,'1981-07-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6511,'AUBRY','Claude','1956-07-13','02.12.31.27.26','06.61.85.81.85',NULL,'18 rue saint andre porte 27','','','14390','CABOURG',NULL,NULL,'2560714756001',1930.000000000,'1986-11-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6512,'LEGOFF','GUSTAVE','1939-02-22','02.65.56.83.31','06.73.06.43.26',NULL,'17 RUE DU VAL DE QUESNEY','','','14630','CAGNY',NULL,NULL,'2390214689001',853.000000000,'1960-12-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6513,'MELUN','OCTAVE','1959-01-11','02.12.75.82.39','06.25.37.06.51',NULL,'6 RUE YVERDON','','','14130','ST HYMER',NULL,NULL,'1590114277001',1246.000000000,'1989-03-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6514,'ROGUE','','1935-05-31','02.58.55.30.56','06.81.39.77.77',NULL,'98 RUE DE BRANVILLE','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2350550522001',23.000000000,'1962-09-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6515,'SUARD','JEANNE','1961-03-23','02.16.16.75.13','06.10.00.50.24',NULL,'19 RUE M LAFON','','','14000','GIBERVILLE',NULL,NULL,'1610361283001',140.000000000,'1988-12-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6516,'GUILBERT','ELISABETH','1939-09-29','02.15.66.46.28','00 33 6.59.14.88.92',NULL,'6 RUE JEAN MONNET','','','14610','FONTAINE HENRY',NULL,NULL,'2390976016001',126.000000000,'1961-07-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6517,'ETIENNE','CLAUDE','1938-01-03','02.50.67.59.25','06.81.85.68.72',NULL,'AVENUE DU BOIS DE LA COTARDIERE','RESIDENCE DES POIRIERS APPT/51','','14111','LOUVIGNY',NULL,NULL,'2380114512001',1629.000000000,'1966-08-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6518,'SAUVAGE','MARGUERITE','1932-07-15','02.64.33.28.49','06.90.33.22.72',NULL,'8 ALLEE BORIS VIAN','','','14000','CAEN',NULL,NULL,'1320714029001',71.000000000,'1959-09-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6519,'BRUNEAU','PAULE','1957-02-12','02.11.91.21.09','06.12.16.62.92',NULL,'3 rue du lieu vautier','','','14000','CAEN',NULL,NULL,'1570214628001',43.000000000,'1981-03-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6520,'OZANNE','JEAN CLAUDE','1937-11-01','02.76.81.13.82','06.32.83.89.56',NULL,'6 RUE DE PLUMETOT','','','14000','CAEN',NULL,NULL,'1371150364001',135.000000000,'1960-02-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6521,'MAGLOIRE','JEAN CLAUDE','1975-02-09','02.20.00.39.29','06.83.34.77.06',NULL,'14 rue maine','','',NULL,NULL,NULL,NULL,'2750250031001',42.000000000,'1996-07-21','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6522,'MARIE','HENRI','1937-07-04','02.10.95.57.83','06.51.47.94.40',NULL,'LE MESNIL TOUFFRAY','','','14000','CAEN',NULL,NULL,'2370714303001',213.000000000,'1967-12-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6523,'GOREL','GENEVIEVE','1948-02-05','02.55.62.45.40','06.59.20.89.86',NULL,'9 RUE MOLIERE','','','14370','BELLENGREVILLE',NULL,NULL,'1480214295001',597.000000000,'1978-10-05','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6524,'KRAWIEC','PIERRE',NULL,'02.27.22.44.52','06.43.71.76.69',NULL,'la fresnee clecy','','','14880','HERMANVILLE SUR MER',NULL,NULL,'1460314003001',436.000000000,'2010-03-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6525,'GOSSELIN','MARIE LOUISE','1941-01-27','02.64.82.38.89','06.20.73.47.83',NULL,'9 bis rue des biganos','','','14500','VIRE',NULL,NULL,'1410176674001',4697.000000000,'1963-02-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6526,'LAULIER','ROGER','1959-01-30','02.50.87.20.91','06.38.21.94.93',NULL,'8 RUE DU LAVOIR','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1590114233001',1407.000000000,'1980-07-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6527,'DAMECOURT','JANINE','1956-02-15','02.73.40.13.86','06.89.91.22.41',NULL,'38 BD LYAUTEY','','','14730','GIBERVILLE',NULL,NULL,'2560214106001',27.000000000,'1981-02-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6528,'CREPIN','CLAUDE','1947-05-25','02.86.55.04.38','06.65.96.05.81',NULL,'CHEMIN DU BOIS','','','14390','VARAVILLE',NULL,NULL,'1470514013001',1669.000000000,'1970-11-17','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6529,'LEGRAND','Fabienne','1958-02-12','02.62.22.10.75','06.89.03.28.05',NULL,'19 AVENUE DE PARIS RESIDENCE RA','VEL','','14000','CAEN',NULL,NULL,'2580214602001',38.000000000,'1983-04-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6530,'LEGIGAN','MARIE LOUISE','1936-08-03','02.92.70.70.32','06.69.43.04.50',NULL,'17 RUE ST GERBOLD','','','14380','ST MANVIEU BOCAGE',NULL,NULL,'1360837051001',355.000000000,'1965-01-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6531,'LECOMTE','MAURICE','1952-01-24','02.21.40.15.80','06.44.56.23.43',NULL,'36 RUE CHATEAU D''EAU','','','14700','NORON L''ABBAYE',NULL,NULL,'2520114305001',555.000000000,'1974-11-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6532,'MADELINE','ODETTE','1931-05-14','02.46.09.93.74',NULL,NULL,'5 RUE DES MARONNIERS','','','14220','MOULINES',NULL,NULL,'2310514739001',795.000000000,'1956-07-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6533,'LAURAIN','ALBERT','1937-04-08','02.79.50.39.76','06.63.78.10.91',NULL,'6 RUE DE LA HAIE BRETON','','','14000','CAEN',NULL,NULL,'2370414719001',28.000000000,'1958-01-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6534,'LAURAIN','GASTON','1937-10-06','02.46.81.00.16','06.47.56.60.98',NULL,'14 RUE FRED SCAMMARONI','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1371014405001',240.000000000,'1966-08-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6535,'DUBOSQ','MONIQUE','1937-09-16','02.10.99.00.05','06.97.17.93.89',NULL,'5 rue des noyers','','','61330','CEAUCE',NULL,NULL,'2370950144001',70.000000000,'1965-12-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6536,'MOMBRUN','LEONE','1937-08-07','02.10.37.37.20','06.87.47.51.60',NULL,'187 RUE DE BAYEUX','','','14680','GOUVIX',NULL,NULL,'1370814119001',559.000000000,'1963-11-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6537,'JARDIN','RACHID','1929-04-12','02.49.74.00.50',NULL,NULL,'20 GRANDE RUE','','','14000','CAEN',NULL,NULL,'2290450202001',35.000000000,'1953-06-18','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6538,'CLERC','JACQUELINE','1980-12-13','02.43.30.97.98','06.50.67.28.01',NULL,'10 RUE DU CLOS DUHAMEL','','','14000','CAEN',NULL,NULL,'1801299215001',835.000000000,'2005-08-23','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6539,'REYROLLE','BERNADETTE','1953-03-03','02.11.08.17.79','06.11.31.31.79',NULL,'21 RUE DU MANOIR','','','61330','CEAUCE',NULL,NULL,'2530314669001',431.000000000,'1981-06-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6540,'BREHIN','JACQUELINE','1934-04-18','02.71.98.60.38','06.80.91.03.10',NULL,'23 RUE ARISTIDE BRIANT','','','14330','SAONNET',NULL,NULL,'2340414057001',122.000000000,'1963-03-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6541,'LELIEVRE','Philippe','1930-10-15','02.10.22.28.86','06.30.20.87.66',NULL,'2 RUE DES FINLANDAISES','','','61140','BAGNOLES DE L''ORNE',NULL,NULL,'2301061070001',17.000000000,'1959-10-17','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6542,'PEZERIL','JACQUES','1930-11-30','02.23.26.30.56','06.40.25.79.48',NULL,'8 RUE ABBE LOUIS GUERIN','','',NULL,NULL,NULL,NULL,'2301161248001',67.000000000,'1957-03-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6543,'GARNIER','PIERRE','1936-05-13','02.34.83.81.34','06.91.32.24.87',NULL,'49 rue eustache','','','14121','SALLENELLES',NULL,NULL,'1360561170001',63.000000000,'1962-01-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6544,'FERET','CHRISTIANE','1948-01-21','02.37.50.01.07','06.36.18.10.33',NULL,'20 terr rue des mousseaux','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1480114060001',92.000000000,'1975-01-14','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6545,'GOURREAU','Merabi','1932-12-08','02.80.52.22.10','06.25.89.56.93',NULL,'7 IMPASSE DES MAISONS NEUVES','','','14610','COLOMBY SUR THAON',NULL,NULL,'2321250147001',1602.000000000,'1959-11-25','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6546,'LE HELLEY','Rene','1936-09-11','02.58.89.19.28','06.52.36.68.66',NULL,'6 rue Therese de la Varde','','','14123','IFS',NULL,NULL,'1360927700001',166.000000000,'1963-06-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6547,'LAMOUREUX','JEAN CLAUDE','1968-01-29','02.79.00.54.53','06.83.12.74.36',NULL,'6 PLACE DU PARC','','','14220','THURY HARCOURT',NULL,NULL,'1680153166001',38.000000000,'1996-02-02','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6548,'DOMINGO','NICOLE','1936-06-25','02.35.25.93.56','06.11.20.54.07',NULL,'17 ALLEE DU BREUIL','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1360614355001',30.000000000,'1960-04-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6549,'CHEVILLOT','MICHEL','1970-01-21','02.90.03.46.38','06.48.27.58.87',NULL,'16 LA LANDE','','','14610','ANISY',NULL,NULL,'2700114623001',109.000000000,'2000-10-26','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6550,'GIRARD','JEAN','1956-01-22','02.10.00.28.58','06.50.66.84.60',NULL,'52 LE FRESNE','','','14160','DIVES SUR MER',NULL,NULL,'1560114294001',46.000000000,'1978-06-26','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6551,'LIARD','GERARD','1966-06-30','02.39.35.13.48','06.49.84.67.44',NULL,'5 RUE DU PERE ROBERT','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'2660650502001',33.000000000,'1992-03-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6552,'MARESQ','SIMONE','1965-08-19','02.85.46.89.57','06.85.15.89.01',NULL,'29 rue du stade','','','14000','CAEN',NULL,NULL,'2650814305001',479.000000000,'1987-07-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6553,'LEMAIGAT','ROLAND','1940-06-06','02.10.99.24.81','06.99.11.48.84',NULL,'23 ROUTE DE CORMELLES','','','14630','EMIEVILLE',NULL,NULL,'1400614201001',6.000000000,'1964-02-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6554,'CACHARD','PATRICK','1929-06-12','02.78.48.43.99','06.40.06.50.09',NULL,'16 rue aux pierrots','','','14120','MONDEVILLE',NULL,NULL,'2290614480001',2509.000000000,'1957-08-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6555,'LOUVEL','Yvette','1930-01-25','02.93.90.96.90','06.71.17.42.37',NULL,'47 RUE DE LA 8EME ARMEE','','','61200','ARGENTAN',NULL,NULL,'2300114617001',1278.000000000,'1952-03-13','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6556,'RENE','BERNADETTE','1933-03-12','02.11.06.79.36','06.72.12.46.22',NULL,'','','','14260','JURQUES',NULL,NULL,'2330314649001',158.000000000,'1961-05-12','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6557,'DROULIN','SOLANGE','1966-07-05','02.84.21.63.91','06.88.92.94.56',NULL,'66 avenue de rouen','','','14000','CAEN',NULL,NULL,'2660714738001',6.000000000,'1990-12-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6558,'LEGRAS','ALAIN','1939-02-08','02.70.03.55.05','06.24.58.05.69',NULL,'31 bd raymond poincarre','','','14000','CAEN',NULL,NULL,'1390250558001',196.000000000,'1967-05-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6559,'SEBIRE','Lucienne','1940-12-20','02.23.15.35.54','06.89.50.50.56',NULL,'2 ALLEE ST VIGOR','','','14310','VILLERS BOCAGE',NULL,NULL,'2401214409001',778.000000000,'1961-12-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6560,'DONNE','MADELEINE','1938-02-24',NULL,NULL,NULL,'3 IMPASSE DES MESANGES','','','14123','IFS',NULL,NULL,'1380214483001',62.000000000,'1965-10-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6561,'MARCINKOWSKI','FRANCOISE','1937-01-01','02.16.81.69.29','06.10.75.51.27',NULL,'1 CENTRE DES ARGILLIER','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2370114738001',199.000000000,'1959-01-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6562,'LEMAINE','','1935-10-08','02.65.37.55.97','06.25.53.97.02',NULL,'19 RUE MALFILATRE maison de ret','raite st jean','','14123','IFS',NULL,NULL,'1351014491001',1380.000000000,'1957-01-01','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6563,'QUEUDEVILLE','serge','1935-10-09','02.39.08.30.50','06.10.97.25.23',NULL,'13 BD RICHEMOND','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1351014491001',3.000000000,'1963-08-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6564,'MAROT','ANDRE','1950-01-27','02.23.57.34.07','06.84.37.05.78',NULL,'3 rue du belvedere','','','50890','CONDE SUR VIRE',NULL,NULL,'2500150226001',41.000000000,'1980-12-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6565,'APARISI','SERGE','1929-09-16','02.54.48.90.84','06.24.06.05.39',NULL,'9 RUE DES CAILLOUINS','','','14400','RANCHY',NULL,NULL,'2290971044001',786.000000000,'1959-02-06','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6566,'CHAOUCHE','RAYMOND','1939-10-12','02.81.44.67.20','06.10.27.41.73',NULL,'MAISON DE RETRAITE 87 RUE ST MA','RTIN','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1391014277001',553.000000000,'1964-02-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6567,'CALBRIS','BERNARD','1928-11-08','02.10.15.45.24','06.38.76.59.03',NULL,'21 RUE J-CARTIER','','','14270','MEZIDON CANON',NULL,NULL,'2281114143001',711.000000000,'1958-05-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6568,'FRANCOIS','MONIQUE','1953-09-17','02.95.60.42.33','06.29.32.95.84',NULL,'route de rouen','','','27300','CAORCHES ST NICOLAS',NULL,NULL,'1530914180001',19.000000000,'1974-09-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6569,'BELLAIS','MAURICE','1944-06-11','02.26.03.12.41','06.82.87.77.66',NULL,'30 BIS RUE DU MILIEU','','','14470','COURSEULLES SUR MER',NULL,NULL,'1440614073001',27.000000000,'1965-02-01','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6570,'LESNIK','NOEL','1938-06-21','02.15.25.85.54','06.28.09.55.24',NULL,'LE CLOS BOUILLON','','','14000','CAEN',NULL,NULL,'2380650222001',126.000000000,'1962-02-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6571,'ANGUE','YVONNE','1968-08-09','02.30.63.79.11','06.76.28.45.16',NULL,'10 RUE LES MONTS','','','14220','THURY HARCOURT',NULL,NULL,'1680850129001',7.000000000,'1993-02-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6572,'CASSIGNEUL','MICHEL','1934-01-12','02.12.32.52.34','06.46.32.69.69',NULL,'8 RUE GUSTAVE FLAUBERT','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'2340114327001',56.000000000,'1958-04-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6573,'FEUGUERAY','EMILE','1937-08-03','02.52.84.95.59','06.21.89.92.99',NULL,'ROUTE DE LIVAROT','','','14120','MONDEVILLE',NULL,NULL,'2370850533001',477.000000000,'1965-09-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6574,'VAVASSEUR','DIDIER','1935-08-13','02.77.60.95.17','00 33 6.16.11.49.02',NULL,'1 AVENUE DE VERDUN','','','14730','GIBERVILLE',NULL,NULL,'2350814020001',2251.000000000,'1963-05-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6575,'HUARD','JEAN YVES','1929-01-25','02.45.35.94.18','06.88.37.83.84',NULL,'3 rue du belveder','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2290114408001',308.000000000,'1951-06-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6576,'LACROIX','SERGE','1955-01-03','02.46.22.56.55','06.12.20.70.46',NULL,'17 RUE DE LA BUTORERIE','','','14780','LION SUR MER',NULL,NULL,'2550114195001',191.000000000,'1978-11-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6577,'MARION','GUSTAVE','1962-04-22','02.52.80.40.39','06.74.70.03.30',NULL,'le grand tremblay','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2620450597001',9.000000000,'1984-11-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6578,'MOISSON','BERNARD','1931-10-07','02.63.40.46.81','06.86.28.25.00',NULL,'','','','14000','CAEN',NULL,NULL,'1311014596001',2089.000000000,'1959-01-23','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6579,'LEHERISSEY','DENISE','1932-05-04','02.43.36.55.26','06.20.84.06.77',NULL,'40 RUE DU CROISSANT','','','14160','DIVES SUR MER',NULL,NULL,'1320561383001',877.000000000,'1959-06-25','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6580,'OLIVIER','COLETTE','1961-06-16','02.63.14.58.29','06.46.40.34.29',NULL,'3 CHEMIN DU PETIT RUET','','','14540','SOLIERS',NULL,NULL,'2610614463001',737.000000000,'1991-02-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6581,'LECONTE','THERESE','1940-03-05','02.45.54.67.50','06.26.16.12.48',NULL,'215 RUE DE VERDUN','','','14370','ARGENCES',NULL,NULL,'1400314308001',7.000000000,'1964-10-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6582,'MAUDUIT','JEAN','1942-02-22','02.82.78.84.04','06.10.67.67.05',NULL,'13 RUE GEORGES BIZET','','','14210','NOYERS BOCAGE',NULL,NULL,'1420214038001',53.000000000,'1964-01-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6583,'LELEGARD','JACQUELINE','1931-01-30','02.99.24.26.70','06.86.72.59.58',NULL,'19 PLACE BELLE ISLE','','','50100','CHERBOURG',NULL,NULL,'1310114458001',1581.000000000,'1960-02-08','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6584,'ANDRE','MICHEL','1940-06-04','02.21.77.12.20','06.36.58.63.58',NULL,'','','','14290','ORBEC',NULL,NULL,'2400653127001',107.000000000,'1969-04-03','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6585,'HEUZE','BRICE','1936-03-04','02.42.17.91.68','06.82.98.00.05',NULL,'7 RUE DES ANCIEN D''AFN','','','50760','REVILLE',NULL,NULL,'2360350370001',245.000000000,'1959-10-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6586,'FOUCHER','PAUL','1933-11-11','02.96.66.98.38','06.92.83.43.93',NULL,'RUE DU VIEUX PAITIS','','','14400','BAYEUX',NULL,NULL,'2331114550001',8.000000000,'1960-04-11','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6587,'LEBON','GERARD','1933-02-26','02.90.00.68.79','06.95.55.53.61',NULL,'38 rue de la comedie','','','14730','GIBERVILLE',NULL,NULL,'1330214278001',802.000000000,'1956-04-18','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6588,'BETOURNE','SYLVAIN','1934-02-04','02.32.75.49.77','06.71.52.24.34',NULL,'LE LIEU POULAIN','','','50890','CONDE SUR VIRE',NULL,NULL,'2340263097001',212.000000000,'1964-12-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6589,'FOUBERT','YOLANDE','1933-01-19','02.79.23.56.97','06.11.97.87.37',NULL,'1 Frres des Vigouroux','','','14370','BELLENGREVILLE',NULL,NULL,'1330172111001',480.000000000,'1962-06-12','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6590,'GUILLAUME','Jeanne','1930-02-03','02.41.30.09.69','06.10.30.24.68',NULL,'','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2300269121001',274.000000000,'1954-05-09','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6591,'CORMERY','JEANINE','1931-11-03','02.10.36.04.66','06.24.85.81.54',NULL,'5 RUE ALEXANDER FLEMING','','','14000','CAEN',NULL,NULL,'1311150362001',1419.000000000,'1959-05-31','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6592,'DROST','COLETTE','1936-02-19','02.85.51.81.69','06.67.59.20.62',NULL,'LA FERRONNIERE','','',NULL,NULL,NULL,NULL,'2360214474001',68.000000000,'1961-08-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6593,'GARGARY','MICHEL','1928-09-24','02.38.62.76.24','06.66.50.91.64',NULL,'3252 route de faliase','','','14000','CAEN',NULL,NULL,'2280914212001',985.000000000,'1957-06-01','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6594,'TESTARD','ISABELLE','1935-05-28','02.11.95.17.88','06.99.78.90.11',NULL,'le petit st jean','','','14650','CARPIQUET',NULL,NULL,'2350551322001',573.000000000,'1964-10-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6595,'PITREL','MURIELLE','1964-05-20','02.76.07.18.43','06.75.42.01.00',NULL,'15 rue hector malot','','','14610','ANGUERNY',NULL,NULL,'1640514087001',362.000000000,'1994-09-26','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6596,'ENGEL','MURIELLE','1938-04-21','02.44.76.21.45','06.10.31.56.17',NULL,'5 rue du val iton','','','14190','ST SYLVAIN',NULL,NULL,'1380414431001',609.000000000,'1964-06-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6597,'LEMERRE SIBONI','JULIEN',NULL,'02.47.25.15.17','06.63.82.31.46',NULL,'1 RUE DU CHAMPS DU MOULIN','','','14190','CAUVICOURT',NULL,NULL,'2560214378001',82.000000000,'2012-06-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6598,'LUCA','MICHEL','1963-04-22','02.10.72.50.92','06.38.56.53.82',NULL,'41 RUE DES CARRIERES DE VAUCELLE','S','','61100','FLERS',NULL,NULL,'2630414501001',85.000000000,'1984-11-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6599,'LEMARIE','MARYSE','1953-01-08','02.56.14.65.77','06.57.80.07.89',NULL,'9 RUE GUILLAUME DE ROS','','','14270','MEZIDON CANON',NULL,NULL,'1530114377001',19.000000000,'1981-08-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6600,'HELENE','CLAUDIA','1935-09-05','02.34.07.45.32','06.25.47.37.44',NULL,'4 RUE DE LA BUTTE','','','14490','ST PAUL DU VERNAY',NULL,NULL,'2350950356001',1018.000000000,'1963-10-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6601,'DUCHEMIN','Denise','1933-11-29','02.31.80.66.34','06.10.82.26.42',NULL,'place marcel pagnol','','','14270','CESNY AUX VIGNES OUEZY',NULL,NULL,'1331114207001',1269.000000000,'1962-02-28','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6602,'PIROU','SUZANNE','1928-12-17','02.28.32.48.22','06.82.26.60.39',NULL,'6 RUE JULES GUESDES','','','14000','CAEN',NULL,NULL,'2281214271001',89.000000000,'1957-07-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6603,'MARTEL','PIERRE','1934-11-18',NULL,NULL,NULL,'9 IMPASSE DE L''ORANGERIE','','','14310','VILLERS BOCAGE',NULL,NULL,'2341150433001',100.000000000,'1956-10-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6604,'FOUCHARD','J CLAUDE','1954-01-31','02.78.60.63.12','06.46.66.66.14',NULL,'','','','14123','IFS',NULL,NULL,'2540114232001',73.000000000,'1976-01-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6605,'LIVRAIN','CONSTANT','1945-05-07','02.12.07.40.78','06.65.82.60.26',NULL,'163 RUE GRANDE','','','14000','CAEN',NULL,NULL,'1450556256001',59.000000000,'1973-03-16','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6606,'NOEL','MARCEL','1964-06-19','02.85.91.41.29','06.62.35.54.19',NULL,'la pilardiere','','','50650','LA HAYE BELLEFOND',NULL,NULL,'2640614079001',138.000000000,'1987-07-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6607,'BILLET','ROLAND','1932-03-23','02.96.83.43.43','06.14.80.23.79',NULL,'11 IMPASSE DE L''ORANGERAIE','','','50700','VALOGNES',NULL,NULL,'2320350441001',22.000000000,'1959-03-25','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6608,'DEZIER','GEORGES','1937-04-04','02.27.55.07.54','06.11.43.52.35',NULL,'75 RUE EUSTACHE RESTOUT','','','14370','BELLENGREVILLE',NULL,NULL,'2370427218001',578.000000000,'1961-08-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6609,'HEMERY','EDOUARD','1937-08-21','02.59.82.28.59','06.58.50.69.64',NULL,'RUE LES COURS','','','14270','CONDE SUR IFS',NULL,NULL,'1370814047001',204.000000000,'1963-10-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6610,'LECLERC','YVETTE','1931-05-31','02.77.25.52.07','06.10.11.10.85',NULL,'le manoir longvillers','','','61210','LES ROTOURS',NULL,NULL,'2310561436001',261.000000000,'1961-05-11','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6611,'AGNES','GERARD','1939-09-29','02.77.19.22.75','06.42.32.25.20',NULL,'64 AVENUE GUYNEMER','','','14270','MAGNY LE FREULE',NULL,NULL,'1390950394001',548.000000000,'1960-03-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6612,'ROGUELIN','SERGE','1930-03-20','02.53.43.16.68','06.22.59.66.03',NULL,'8 RUE DE LA MESANGE','','','14190','ESTREES LA CAMPAGNE',NULL,NULL,'1300301153001',566.000000000,'1960-03-14','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6613,'CATHERINE','Pierre','1965-11-23','02.23.53.27.25','06.48.22.80.05',NULL,'18 rue saint andre','','','14520','COMMES',NULL,NULL,'2651114380001',497.000000000,'1993-07-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6614,'ROULT','PHILIPPE','1930-04-08','02.78.63.50.01','06.59.44.97.26',NULL,'1 ALLEE DU BOIS','','','14700','VERSAINVILLE',NULL,NULL,'2300450356001',54.000000000,'1954-09-01','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6615,'HEUDE','LUCETTE','1931-04-02','02.80.56.73.68','06.53.80.03.04',NULL,'97 RUE DES ACACIAS','','','14123','FLEURY SUR ORNE',NULL,NULL,'2310414399001',501.000000000,'1955-03-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6616,'JOUANNE','RENE','1958-02-22','02.10.61.14.47','06.23.43.94.43',NULL,'RUE DES ROSIERS','','','61200','ARGENTAN',NULL,NULL,'2580214114001',91.000000000,'1981-01-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6617,'REMONDIERE','ALBERT','1955-03-10','02.12.08.94.67','06.27.20.94.91',NULL,'LE BOURG','','','14123','IFS',NULL,NULL,'2550314470001',135.000000000,'1983-11-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6618,'DEGRENNE','guy','1937-07-09','02.60.65.37.54','06.80.63.40.00',NULL,'8 RUE DES TROIS PRINCESSES','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2370714098001',39.000000000,'1966-06-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6619,'RENOUF','ROBERT','1934-10-30','02.62.65.21.39','06.86.10.72.75',NULL,'16 RUE AUX PIERROTS','','','61200','ARGENTAN',NULL,NULL,'2341014395001',4.000000000,'1959-01-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6620,'BRAULT','CECILE','1936-02-13','02.26.29.68.55','00 33 6.11.46.58.32',NULL,'4 CHEMIN AUX BOEUFS','','','14120','MONDEVILLE',NULL,NULL,'2360214068001',7.000000000,'1966-12-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6621,'MARIVINGT','ROGER','1938-05-31','02.13.88.02.62','06.10.32.81.01',NULL,'16 RUE ELISEE LOISELET','','','50260','MAGNEVILLE',NULL,NULL,'1380537091001',12.000000000,'1961-11-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6622,'PARIS','JACQUELINE','1935-03-14','02.20.59.36.87','06.60.46.44.29',NULL,'9 ALLEE DES PAINS GRIS','','','14320','MAY SUR ORNE',NULL,NULL,'1350314046001',238.000000000,'1957-03-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6623,'FONTAINE','YVONNE','1931-06-06','02.69.73.48.08','06.11.74.07.27',NULL,'RESIDENCE BELLEVUE','','','14000','CAEN',NULL,NULL,'1310614157001',34.000000000,'1952-03-24','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6624,'JEAN','ADRIEN','1934-05-08','02.74.26.87.49',NULL,NULL,'1 RUE DU VILLAGE','','','14400','BAYEUX',NULL,NULL,'1340514073001',4010.000000000,'1961-12-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6625,'JOUANNE','ANNICK','1932-10-15','02.95.98.35.64','06.50.45.16.91',NULL,'56 RUE CAMILLE BLAISOT','','','14290','FRIARDEL',NULL,NULL,'2321014556001',367.000000000,'1953-09-08','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6626,'TEYSSANDIER','LOUISE','1938-03-12','02.30.26.94.63','06.86.79.00.81',NULL,'CHEMIN DE LA CROIX THOY','','',NULL,NULL,NULL,NULL,'1380314719001',33.000000000,'1967-11-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6627,'BOUCEY','JACQUES','1929-02-05','02.27.43.66.08','06.38.85.47.28',NULL,'HAMEAU ST LAMBERT','','','14210','MISSY',NULL,NULL,'2290228267001',6.000000000,'1957-10-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6628,'HUREL','JEAN YVES','1944-03-06','02.35.67.21.85','06.63.30.92.47',NULL,'2 RUE DU MARAIS','','','14123','IFS',NULL,NULL,'1440314383001',52.000000000,'1971-03-04','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6629,'GROULT','MICHEL','1945-07-02','02.49.34.61.76','06.94.17.42.88',NULL,'1 RY+UE DE LA RESISTANCE','','','14123','IFS',NULL,NULL,'1450714610001',77.000000000,'1971-04-02','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6630,'JEANNE','SIMONE','1965-01-16','02.10.17.88.48','06.27.60.12.16',NULL,'56 RUE DE LA SEINE','','','14000','CAEN',NULL,NULL,'1650114543001',903.000000000,'1987-08-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6631,'RELLAND','MARCEL','1964-05-24','02.32.14.27.79','06.69.54.35.24',NULL,'14 RUE DES JEUNES','','','61160','NECY',NULL,NULL,'2640514099001',1226.000000000,'1994-04-21','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6632,'JARDIN','CHARLES','1939-10-28','02.17.47.53.89','06.78.03.63.93',NULL,'1 RUE BIENFAISANCE','','','14460','COLOMBELLES',NULL,NULL,'1391027129001',82.000000000,'1964-03-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6633,'DOUSSON','GEORGES','1946-01-23','02.25.88.24.46','06.10.56.41.60',NULL,'14 PLACE DE L''HOTEL DE VILLE','','','14000','CAEN',NULL,NULL,'2460114488001',627.000000000,'1974-07-26','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6634,'LEMOINE','LOUIS','1938-09-25','02.88.82.29.19','06.15.15.55.20',NULL,'SENTIER ST GILLES','','','14310','VILLERS BOCAGE',NULL,NULL,'2380914035001',83.000000000,'1968-12-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6635,'LEPETIT','GUY','1950-01-20','02.59.88.71.85','06.55.84.68.48',NULL,'RUE LE PARC VILLARD','','','14123','IFS',NULL,NULL,'1500176390001',335.000000000,'1978-05-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6636,'LEVAVASSEUR','BERNARD','1959-02-06','02.46.39.91.06','06.26.88.92.85',NULL,'1 RUE DU BOUT SOUVERAIN','','','14370','AIRAN',NULL,NULL,'2590214538001',735.000000000,'1982-11-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6637,'MARIE','COLETTE','1933-01-14','02.90.16.42.79','06.71.93.08.95',NULL,'GRANDE RUE','','','14370','BELLENGREVILLE',NULL,NULL,'2330114294001',6.000000000,'1956-03-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6638,'CAPELLO','ROGER','1962-02-19','02.83.65.66.63','06.15.63.65.41',NULL,'6 RUE DE LA GARE','','','14000','CAEN',NULL,NULL,'2620214554001',94.000000000,'1991-04-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6639,'DESVAUX','PHILIPPE','1934-11-15','02.10.61.05.25','06.38.18.68.30',NULL,'8 rue georges gallard','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1341114100001',76.000000000,'1958-03-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6640,'CHARTOL','LOIC','1955-08-29','02.85.88.81.12','06.29.84.39.81',NULL,'2 rue colbert','','','14210','BARON SUR ODON',NULL,NULL,'2550814582001',180.000000000,'1984-11-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6641,'MESLIN','GHISLAINE','1939-02-17','02.41.17.03.38','06.10.82.21.44',NULL,'9 RUE TAILLEFER','','','14123','IFS',NULL,NULL,'1390214667001',3605.000000000,'1960-06-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6642,'SAUTEUR','GERARD','1936-01-06','02.58.84.75.26','06.31.83.63.82',NULL,'46 RUE DE FALAISE','','',NULL,NULL,NULL,NULL,'2360114760001',80.000000000,'1966-12-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6643,'LEROY','MONIQUE','1938-11-07','02.78.97.33.67','06.40.68.69.78',NULL,'31 rue leon marcotte','','',NULL,NULL,NULL,NULL,'1381114039001',474.000000000,'1959-03-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6644,'SALAUN','christian','1939-10-07','02.88.89.93.96','06.14.15.68.99',NULL,'1 RUE DU LUCET','','',NULL,NULL,NULL,NULL,'1391061083001',12.000000000,'1963-12-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6645,'BIANCHINI','Andr','1959-09-20','02.78.32.63.25','06.61.73.23.55',NULL,'23 RUE BRANVILLE','','','14420','VILLERS CANIVET',NULL,NULL,'1590914075001',341.000000000,'1984-04-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6646,'CORDRAY','MICHELINE','1934-07-07','02.11.17.28.47','06.10.28.79.48',NULL,'12 AVENUE DE LA CONCORDE','','','14920','MATHIEU',NULL,NULL,'1340761472001',41.000000000,'1955-08-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6647,'LEMONNIER','PIERRE','1930-06-20','02.71.88.96.05','06.90.35.39.00',NULL,'11 RUE DE LA MOINERIE','','','14000','CAEN',NULL,NULL,'1300661154001',1706.000000000,'1951-05-02','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6648,'MEROUZE','ROGER','1981-09-26','02.13.29.90.64','06.75.04.49.78',NULL,'11 PLACE DE LA CROIX DE PIERRE','','','14730','GIBERVILLE',NULL,NULL,'2810999416001',179.000000000,'2008-10-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6649,'DESFAUDAIS','JACQUELINE','1935-12-14','02.66.96.91.88','06.22.35.48.16',NULL,'LE MAIZERET','','','50110','TOURLAVILLE',NULL,NULL,'1351214471001',20.000000000,'1957-12-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6650,'BOURREAU','','1954-08-12','02.44.86.05.59','06.69.31.69.80',NULL,'4 RUE DES RANDONNEES','','','14400','BAYEUX',NULL,NULL,'2540814483001',634.000000000,'1978-01-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6651,'GODEFROY','Isabelle','1955-12-11','02.87.80.49.94','06.46.91.48.79',NULL,'824 BD DU GRAND PARC','','','14400','BAYEUX',NULL,NULL,'1551275109001',51.000000000,'1976-12-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6652,'MARIE','JACQUELINE','1930-05-26','02.38.39.03.47','06.10.05.88.64',NULL,'BP 32','','','14000','CAEN',NULL,NULL,'1300514546001',39.000000000,'1954-05-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6653,'HOULETTE','MICHELLE','1966-07-18','02.76.59.53.48','06.28.52.27.77',NULL,'13 RUE BRIERE','','','14540','ROCQUANCOURT',NULL,NULL,'1660761490001',31.000000000,'1988-05-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6654,'MOTTIER','NOEL','1953-01-21','02.75.42.12.41','06.36.97.61.80',NULL,'60 RUE DU 20E SIECLE','','','14400','BAYEUX',NULL,NULL,'2530114001001',120.000000000,'1980-06-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6655,'JOSEPHINE','GEORGETTE','1938-12-12','02.63.18.17.73','06.60.93.98.06',NULL,'95 AVDE ROUEN','','','14123','IFS',NULL,NULL,'1381250456001',11.000000000,'1964-10-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6656,'BIDAULT','CECILE','1965-08-21','02.76.60.89.97','06.64.56.31.88',NULL,'la croix de veaux','','','14670','BASSENEVILLE',NULL,NULL,'2650814305001',694.000000000,'1992-11-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6657,'CHAMPION','CLAUDE','1931-03-18','02.59.21.85.04','06.16.18.24.69',NULL,'route de boulon','','','50700','ST JOSEPH',NULL,NULL,'1310314150001',715.000000000,'1957-07-12','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6658,'DANEL','PAUL','1940-02-07','02.57.83.91.63','06.75.26.50.84',NULL,'1 ter chemin du long bois','','','14790','VERSON',NULL,NULL,'2400210118001',35.000000000,'1962-07-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6659,'BOURGAULT','JEAN MARC','1954-01-17','02.69.66.39.42','06.28.26.46.86',NULL,'8 AV DU 43EME REGIMENT ARTILLERI','E','','14123','IFS',NULL,NULL,'2540114654001',29.000000000,'1979-12-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6660,'MAUGER','LILIANE','1928-09-04','02.82.19.59.52','06.30.13.20.00',NULL,'73 rue roger aini','','','14280','ST CONTEST',NULL,NULL,'1280989003001',374.000000000,'1952-12-28','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6661,'LEFEUVRE','Robert','1943-06-12','02.86.62.25.12','06.53.68.72.64',NULL,'56 rue de caen','','','14000','CAEN',NULL,NULL,'1430614112001',37.000000000,'1966-10-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6662,'LEMOINE','GISELE','1946-03-07','02.86.63.24.67','06.36.96.99.04',NULL,'','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2460350156001',36.000000000,'1967-09-07','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6663,'VOISIN','PAULETTE','1958-05-30','02.75.83.42.19','06.84.80.36.34',NULL,'12 RUE DE LA POMME D''OR','','','14000','CAEN',NULL,NULL,'2580514508001',107.000000000,'1982-01-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6664,'MARIE','MICHELE',NULL,'02.76.15.20.36','06.10.33.11.48',NULL,'7 bis rue de la vieille eglise','','',NULL,NULL,NULL,NULL,'1550314444001',1429.000000000,'2010-02-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6665,'HAREL','JACQUES','1947-04-05','02.24.95.14.27','06.48.99.46.19',NULL,'8 rue des platanes','','','14220','ESPINS',NULL,NULL,'1470414031001',205.000000000,'1977-10-02','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6666,'MARIE','JOSETTE','1934-10-25','02.42.35.24.07','06.53.83.07.64',NULL,'5 residence des pinsons','','',NULL,NULL,NULL,NULL,'1341054296001',1009.000000000,'1959-05-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6667,'MOREL','MARIE-CLAU','1933-10-16','02.11.88.72.51','06.10.63.65.64',NULL,'3 rue du bout roulant','','','14123','FLEURY SUR ORNE',NULL,NULL,'1331014294001',20.000000000,'1961-02-13','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6668,'HEMERY','ANDRE','1934-11-29','02.61.67.62.34','06.63.78.65.70',NULL,'10 IMPASSE DU 14 JUIN','','','14230','LA CAMBE',NULL,NULL,'2341150598001',20.000000000,'1961-09-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6669,'GILLET','JEANNE','1935-12-13','02.42.97.98.54','06.12.68.52.78',NULL,'ROUTE DE MALTOT','','','14120','MONDEVILLE',NULL,NULL,'2351214470001',2371.000000000,'1957-06-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6670,'LE THOREL','MARIE JEANNE','1930-10-26','02.21.40.12.79','06.63.62.47.68',NULL,'LA TOURELLE','','','14210','EVRECY',NULL,NULL,'1301014514001',2901.000000000,'1952-11-21','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6671,'AUGUSTIN','GUY','1932-03-17','02.35.27.87.48','06.15.40.55.83',NULL,'16 ter route de paris','','','14160','DIVES SUR MER',NULL,NULL,'2320314167001',665.000000000,'1955-07-06','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6672,'NUMA','NATHALIE','1932-08-11','02.66.88.76.23','06.53.20.48.60',NULL,'34 RUE VICTOR HUGO','','','14123','IFS',NULL,NULL,'1320836127001',96.000000000,'1962-09-21','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6673,'ZAGAR','RAYMOND','1933-05-20','02.43.33.80.09','06.42.77.33.61',NULL,'','','','14000','CAEN',NULL,NULL,'2330550161001',42.000000000,'1959-05-12','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6674,'DUVAL','JEAN CLAUDE','1966-01-03','02.23.87.46.57','06.11.71.37.05',NULL,'ROUTE DU FAULQ','','','14000','CAEN',NULL,NULL,'2660150402001',87.000000000,'1987-03-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6675,'HAUVEL','Marie louise','1937-12-18','02.10.47.42.19','06.74.93.57.89',NULL,'RUE GUILBERT','','','14310','VILLERS BOCAGE',NULL,NULL,'2371214067001',376.000000000,'1960-06-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6676,'GORDIEN','Marcel','1960-01-28','02.22.69.85.87','06.51.35.10.86',NULL,'1403 la grande delle','','','14700','FALAISE',NULL,NULL,'2600114714001',72.000000000,'1986-05-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6677,'ROCQUANCOURT','','1933-07-09','02.54.38.68.77','06.79.84.55.31',NULL,'LES PIERRETTES','','','61240','LE MERLERAULT',NULL,NULL,'1330714454001',826.000000000,'1958-05-09','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6678,'LOUVEL','MAURICE','1947-08-26','02.52.65.24.51','06.57.29.80.42',NULL,'RESIDENCE COLBERT','','','14940','SANNERVILLE',NULL,NULL,'2470814479001',75.000000000,'1971-06-02','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6679,'FEREC','GENEVIEVE','1937-03-05','02.10.36.26.48','06.32.50.23.20',NULL,'22 rue de stockholm','','','27600','ST PIERRE LA GARENNE',NULL,NULL,'2370308444001',24.000000000,'1959-01-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6680,'DAUGE','Jacqueline','1952-06-03','02.62.22.87.72','06.21.91.22.07',NULL,'3 AVENUE GEORGES CLEMENCEAU','','','14850','HEROUVILLETTE',NULL,NULL,'2520614113001',266.000000000,'1973-01-30','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6681,'GUINAUDEAU','Marie josephe','1953-03-15','02.90.61.57.35','06.99.53.71.80',NULL,'07 RUE D.A.F.N bat 3 porte 11','','','14420','BONS TASSILLY',NULL,NULL,'1530314283001',1313.000000000,'1981-03-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6682,'LECORNE','ANDRE','1933-08-15','02.98.64.91.54','06.72.06.03.07',NULL,'12 RUIE PIERRE CUURY','','',NULL,NULL,NULL,NULL,'2330814341001',1132.000000000,'1962-03-10','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6683,'AUMONT','CLAUDE','1962-02-27','02.60.69.35.82','06.51.43.58.01',NULL,'5 RUE DES COUURTILS','','','14000','CAEN',NULL,NULL,'2620214430001',34.000000000,'1990-06-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6684,'FOSSEY','SIMONE','1937-10-01','02.88.19.73.90','06.65.46.90.32',NULL,'17 RUE DES LIBERATEURS','','','50200','COURCY',NULL,NULL,'1371014562001',41.000000000,'1965-11-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6685,'ASSELINE','ROLAND','1945-01-18','02.39.40.15.80','06.62.57.65.93',NULL,'13 AV DU PARC','','','14740','ST MANVIEU NORREY',NULL,NULL,'1450118098001',512.000000000,'1966-06-17','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6686,'LAGRUE','MONIQUE','1936-02-21','02.16.08.50.01','06.23.00.78.77',NULL,'18 RUE DE QUILLY','','','14000','CAEN',NULL,NULL,'2360214100001',18.000000000,'1961-07-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6687,'LE CAMUS','GISELE','1969-09-24','02.11.05.65.03','06.63.55.01.35',NULL,'10 rue du temps perdu','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'2690914439001',172.000000000,'1991-12-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6688,'BOSSU','CAMILLE',NULL,'02.47.05.75.80','06.75.31.47.62',NULL,'30 RUE DE L''OMBREE','','','14230','LONGUEVILLE',NULL,NULL,'2290114375001',1907.000000000,'2013-03-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6689,'ROILLE','GILBERT','1937-03-13','02.49.12.10.54','06.20.97.67.04',NULL,'6 impasse des abeilles','','','50180','AGNEAUX',NULL,NULL,'1370314324001',6.000000000,'1966-06-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6690,'POTTIER','JEANNINE','1931-04-07','02.47.86.25.45','06.11.35.25.12',NULL,'7 rue du boulhoullay','','','14220','BARBERY',NULL,NULL,'1310427243001',366.000000000,'1955-04-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6691,'DAUDET','HENRI','1933-03-23','02.51.10.58.77','06.96.97.85.08',NULL,'37 allee des tronnes','','',NULL,NULL,NULL,NULL,'1330314658001',4.000000000,'1956-02-20','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6692,'JOLY','Henri',NULL,'02.44.69.52.62','00 33 6.76.85.54.32',NULL,'30 rue des Eperviers','','','61200','ARGENTAN',NULL,NULL,'2390214233001',263.000000000,'2011-10-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6693,'GORENFLOT','Leon','1938-02-20','02.64.40.07.85','06.69.93.79.52',NULL,'7 RUE SULLY','','','14610','ANGUERNY',NULL,NULL,'2380214692001',589.000000000,'1968-01-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6694,'BAUDIN','LOUISE','1933-02-27','02.10.31.15.48','06.63.88.31.19',NULL,'12 rue camille blaisot','','','14000','CAEN',NULL,NULL,'1330214364001',14.000000000,'1957-06-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6695,'PATTIER','AUGUSTE','1938-01-19','02.38.40.34.04','06.53.13.54.73',NULL,'700 RUE DU GABLE BLANC','','','14000','CAEN',NULL,NULL,'2380114327001',1095.000000000,'1959-07-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6696,'LAULIER','JOEL','1940-03-17','02.81.77.55.56','06.11.21.44.74',NULL,'19 RUE DU PRESSENCE','','','14370','CHICHEBOVILLE',NULL,NULL,'2400314659001',15.000000000,'1963-12-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6697,'LEMEE','NICOLE','1933-04-28','02.38.03.46.49','06.22.52.24.59',NULL,'7 rue de bir hakein','','','14450','ST PIERRE DU MONT',NULL,NULL,'2330414746001',15.000000000,'1958-09-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6698,'PERRIER','Jean','1965-08-11','02.41.46.83.86','06.28.68.09.89',NULL,'9 bld de la charite','','','14220','CULEY LE PATRY',NULL,NULL,'2650814305001',892.000000000,'1987-09-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6699,'DEROUET','MARIE THERESE','1938-01-27','02.46.64.67.26','06.71.16.95.88',NULL,'1102 QUARTIER DES BOIS','','','14370','MOULT',NULL,NULL,'2380150150001',1732.000000000,'1959-12-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6700,'PATRY','JULES',NULL,'02.34.13.88.25','06.69.74.73.03',NULL,'8 rue binet','','','50180','AGNEAUX',NULL,NULL,'2370653230001',232.000000000,'2007-12-26','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6701,'HARDEL','NICOLE','1948-03-21','02.50.71.60.19','06.33.47.47.79',NULL,'46 HAUTE VOIE','','','14100','LISIEUX',NULL,NULL,'1480314300001',7.000000000,'1970-05-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6702,'FERAY','MURIELLE','1955-01-15','02.81.73.08.87','06.15.05.25.55',NULL,'7 RUE PIERRE  HEBERT','','','14000','CAEN',NULL,NULL,'2550114089001',208.000000000,'1976-07-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6703,'DAUVERGNE','MARCEL','1955-01-11','02.50.15.41.66','06.56.17.33.89',NULL,'5 RUE DES CANADIENS','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2550114089001',13.000000000,'1982-05-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6704,'DUCHENNE','ROLANDE','1928-03-05','02.26.55.43.82','06.98.40.47.89',NULL,'ROUTE DE PARIS','','','14540','GRENTHEVILLE',NULL,NULL,'1280314010001',82.000000000,'1952-03-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6705,'JOUSSET','CLAUDIE','1941-05-18','02.14.11.39.07','06.72.14.95.74',NULL,'31 RUE DE LISIEUX','','','14250','TILLY SUR SEULLES',NULL,NULL,'1410514130001',2.000000000,'1964-08-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6706,'FOUCHARD','SIMONE','1954-01-29','02.42.44.57.49','06.47.16.86.31',NULL,'71 ROUTE DE BRETAGNE','','','14123','IFS',NULL,NULL,'2540150517001',667.000000000,'1984-12-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6707,'HUYGHE','Janine','1966-04-03','02.60.93.87.46','06.31.49.18.94',NULL,'HAMEAU CANFLAIS','','','14370','ARGENCES',NULL,NULL,'2660441022001',2244.000000000,'1990-07-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6708,'LEFOYE','Jeanine','1929-08-28','02.10.79.99.00','06.25.95.81.41',NULL,'50 rue du midi','','','14000','CAEN',NULL,NULL,'1290814352001',373.000000000,'1955-08-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6709,'BOSQUET','RENEE','1933-08-12','02.23.01.47.84','06.74.62.96.03',NULL,'2 RUE QUILLY','','','61600','LA FERTE MACE',NULL,NULL,'2330814340001',3.000000000,'1961-07-07','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6710,'LEMARIE','michel','1937-01-06',NULL,NULL,NULL,'22 RUE D''ARMOR','','','14700','SOULANGY',NULL,NULL,'1370114214001',135.000000000,'1959-12-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6711,'QUESNEL','Jacqueline','1933-10-12','02.85.95.15.79','06.82.68.90.23',NULL,'15 DE SCOTLCOM','','','14370','ARGENCES',NULL,NULL,'1331014452001',72.000000000,'1958-11-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6712,'LECHAUVE','ROLAND','1928-08-19','02.32.03.72.57','06.18.82.28.57',NULL,'7 rue amand bence','','','14000','CAEN',NULL,NULL,'1280814724001',45.000000000,'1950-06-06','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6713,'ROBINE','','1951-01-14','02.70.20.43.18','06.28.54.64.11',NULL,'22 RUE VOLTAIRE RES GUY TRAVER','S','','14400','BAYEUX',NULL,NULL,'2510114530001',80.000000000,'1978-04-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6714,'MARTY','JEANNINE','1933-07-04','02.42.70.37.64','06.11.76.40.78',NULL,'LIEU DIT"LE LIEU FOISON"','','','14960','ASNELLES',NULL,NULL,'1330708415001',128.000000000,'1961-08-05','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6715,'GROULT','MONIQUE','1936-04-03','02.10.70.10.24','06.20.94.68.79',NULL,'1 BIS RUE DE LA PAIX','','','14130','ST MARTIN AUX CHARTRAINS',NULL,NULL,'1360458079001',850.000000000,'1959-03-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6716,'LEPETIT','MICHELINE','1939-03-16','02.28.08.34.14','06.49.07.59.77',NULL,'9 RUE DE FOUR','','','50250','PRETOT STE SUZANNE',NULL,NULL,'1390361176001',1374.000000000,'1963-02-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6717,'BLANCHET','ANDRE',NULL,'02.34.99.96.09','06.16.07.74.09',NULL,'21 LE ROCHER','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1680153166001',121.000000000,'2008-05-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6718,'HEMERY','FRANCK','1933-07-21','02.12.10.92.66','06.12.06.72.93',NULL,'11 AV DU CALVADOS','','','14370','ARGENCES',NULL,NULL,'1330714383001',84.000000000,'1963-07-22','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6719,'LEFEVRE','JEAN',NULL,'02.19.92.89.29','06.11.32.84.59',NULL,'2 RUE DE LA NOUVELLE ECOSSE','','','14000','CAEN',NULL,NULL,'1430114703001',11.000000000,'2010-10-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6720,'AMY','FRANCOIS','1935-07-21','02.66.68.77.39','06.57.69.74.54',NULL,'14 RUE MARTHE GIBRAT','','','14000','CAEN',NULL,NULL,'2350714685001',243.000000000,'1962-07-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6721,'GASSERT','ALBERT','1929-09-09','02.14.82.91.63','06.87.16.93.54',NULL,'2.1 RUE DU CLOS NEUF','','','14380','ST SEVER CALVADOS',NULL,NULL,'2290914579001',1404.000000000,'1955-06-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6722,'JANKOWSKI','ROGER','1927-08-28','02.69.58.82.14','06.66.98.24.20',NULL,'37 avenue de rouen','','','14730','GIBERVILLE',NULL,NULL,'1270895401001',74.000000000,'1953-12-24','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6723,'DELHOMMEAU','THERESE','1937-02-27','02.85.91.29.28','06.66.99.20.69',NULL,'49 RUE ARISTIDE BRIANT','','','14000','CAEN',NULL,NULL,'1370250473001',114.000000000,'1959-01-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6724,'FEREY','PAULETTE','1935-11-05','02.32.17.77.31','06.98.33.72.45',NULL,'35 AVENUE DU 6 JUIN','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2351119040001',30.000000000,'1959-03-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6725,'BELLOT','GEORGES','1933-12-04','02.55.94.88.30','06.15.04.39.46',NULL,'ROUTE DE GRAINVILLE S/ODON','','','14270','BIEVILLE QUETIEVILLE',NULL,NULL,'1331214118001',281.000000000,'1955-08-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6726,'CHAGNY','gilbert','1935-04-01','02.85.84.17.49','06.70.41.51.28',NULL,'22 RUE DE LA GRANGE AUX DIMES','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2350414100001',1193.000000000,'1956-04-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6727,'DESCHATEAUX','J PIERRE','1965-02-19','02.10.43.03.23','06.40.02.24.07',NULL,'2 RUE AUGUSTE LEMONNIER','','','14000','CAEN',NULL,NULL,'1650214163001',170.000000000,'1992-12-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6728,'LEMOIGNE','Gaston','1937-02-21','02.51.71.97.02','06.11.09.23.28',NULL,'6 -003 allee du romarin','','','14000','CAEN',NULL,NULL,'2370214181001',974.000000000,'1964-10-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6729,'BOULAY','Jacqueline','1936-12-20','02.31.97.77.43','06.13.39.83.63',NULL,'1 ALLEE VERDIER','','','14420','POTIGNY',NULL,NULL,'2361285098001',168.000000000,'1965-11-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6730,'SAMSON','CLAUDE','1943-04-08','02.56.90.28.77','06.23.69.39.66',NULL,'1201 grande delle','','','14490','CAMPIGNY',NULL,NULL,'1430460516001',216.000000000,'1965-12-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6731,'POTTIER','JEAN','1928-11-20','02.29.54.42.66','06.12.87.86.52',NULL,'7 RUE FACTURE','','','61140','BAGNOLES DE L''ORNE',NULL,NULL,'2281114407001',23.000000000,'1949-02-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6732,'BADIER','Simone','1945-01-20','02.34.97.60.54','06.11.05.11.70',NULL,'12 RUE DE BARON','','','14730','GIBERVILLE',NULL,NULL,'1450150426001',1775.000000000,'1969-01-13','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6733,'RAULIN','JACQUES','1932-11-22','02.53.23.28.80','06.20.97.86.35',NULL,'29 rue de clinchamps','','','14000','CAEN',NULL,NULL,'1321114506001',27.000000000,'1958-02-12','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6734,'DRIQUERT','michel','1930-10-07','02.95.71.99.82','06.52.31.72.56',NULL,'16 CLOS LARIGAUDERIE','','','61430','BERJOU',NULL,NULL,'1301061101001',523.000000000,'1952-02-23','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6735,'DELPY','CLAUDE','1935-09-13','02.92.46.07.69','06.52.57.37.72',NULL,'','','','14310','LONGVILLERS',NULL,NULL,'2350914387001',343.000000000,'1957-12-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6736,'DUMONT','CHARLOTTE','1935-01-24','02.89.19.47.68','06.68.00.84.83',NULL,'6 allee des bouleaux','','','14000','CAEN',NULL,NULL,'1350114319001',1.000000000,'1965-12-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6737,'DUCAMP','MICHEL','1939-08-06','02.87.07.54.84','06.45.12.12.99',NULL,'35 ROUTE DES HAMEAUX','','','14800','TOUQUES',NULL,NULL,'1390814484001',14.000000000,'1964-10-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6738,'THOMINE','ANDRE','1934-06-07','02.74.16.74.69',NULL,NULL,'','','','14000','CAEN',NULL,NULL,'1340614340001',213.000000000,'1962-10-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6739,'CARPENTIER','JEAN CLAUDE','1928-08-22','02.10.78.15.24','06.71.40.72.13',NULL,'12 RUE DE LA QUERONIERE','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'2280836184001',3793.000000000,'1956-06-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6740,'PRALUS','ROGER','1949-03-13','02.99.52.15.05','06.70.47.88.69',NULL,'6 HAMEAU LA RUE','','','14730','GIBERVILLE',NULL,NULL,'1490314072001',202.000000000,'1979-03-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6741,'BRETAU','MARCEL','1949-03-22','02.10.38.59.71','06.29.85.24.68',NULL,'9 RUE DES CANADIENS','','','14120','MONDEVILLE',NULL,NULL,'1490314072001',542.000000000,'1977-07-22','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6742,'JAGU','ROBERT','1925-04-12','02.43.03.36.99','06.16.54.07.04',NULL,'19 RUE DE LA VIE COMTE','','','14270','CONDE SUR IFS',NULL,NULL,'1250439086001',17.000000000,'1946-06-03','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6743,'PAIN','Jean','1934-11-14','02.11.47.61.34','06.89.68.61.89',NULL,'RTE DEPARTEMENTALE 78','','','14990','BERNIERES SUR MER',NULL,NULL,'1341178201001',1025.000000000,'1955-08-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6744,'DILYS','JOEL','1956-02-05','02.82.52.29.10','06.11.62.24.60',NULL,'12 RUE DES JACYNTHES','','','14270','MEZIDON CANON',NULL,NULL,'1560214341001',71.000000000,'1980-05-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6745,'COSTE','HELENE','1955-05-21','02.78.04.70.49','06.98.80.44.73',NULL,'11 LES FONTAINES','','',NULL,NULL,NULL,NULL,'2550514045001',533.000000000,'1978-08-26','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6746,'BELLANGER','ALBERT','1962-02-27','02.11.70.99.98','06.10.36.91.57',NULL,'18 RUE VARIGNON','','','14000','CAEN',NULL,NULL,'2620214213001',91.000000000,'1985-03-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6747,'DESLOGES','Pierre','1969-07-03','02.38.86.62.73','06.47.17.59.62',NULL,'13 RUE LIVRY LEVREL','','','14740','LASSON',NULL,NULL,'2690780021001',1317.000000000,'1994-03-13','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6748,'BLANVILAIN','JACQUELINE','1965-05-10','02.68.62.30.42','06.44.78.43.01',NULL,'109 RUE DE LA CHAPELLE','','','14370','ARGENCES',NULL,NULL,'1650514205001',122.000000000,'1988-03-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6749,'SOSSON','MADELEINE','1933-03-14','02.35.08.67.89','06.44.08.77.85',NULL,'6 RUE DES IRIS','','','61100','FLERS',NULL,NULL,'1330361123001',817.000000000,'1962-03-04','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6750,'MOHSSINE','Christiane','1931-07-21','02.35.80.29.39','06.74.44.24.28',NULL,'LA PICHOTIERE','','','14000','CAEN',NULL,NULL,'1310714271001',330.000000000,'1960-09-10','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6751,'MADELAINE','JEAN YVES','1929-06-21','02.17.69.78.90','06.17.47.74.03',NULL,'13 RUE GEORGES BIZET','','','14000','CAEN',NULL,NULL,'2290614659001',35.000000000,'1954-12-09','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6752,'GUERIN','emile','1946-09-05','02.40.54.68.07','06.60.98.03.53',NULL,'95 RUE FONTENELLE','','','14000','CAEN',NULL,NULL,'1460907020001',70.000000000,'1974-08-17','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6753,'MALOISEL','JOSETTE','1965-06-10','02.10.81.89.35','06.26.35.84.34',NULL,'11 rue st clair','','','14270','MEZIDON CANON',NULL,NULL,'1650614319001',211.000000000,'1991-12-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6754,'RONARC H','LAURENT','1935-10-08','02.11.93.63.62','06.20.36.33.22',NULL,'19 rue du nord','','',NULL,NULL,NULL,NULL,'2351014266001',231.000000000,'1959-04-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6755,'BEAUDOIN','CLAUDE','1936-01-24','02.22.23.50.53','06.88.06.21.57',NULL,'11 rue des erables','','','14320','FONTENAY LE MARMION',NULL,NULL,'1360114410001',776.000000000,'1959-05-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6756,'BLANCHETIERE','DENISE','1941-02-04','02.91.19.89.02','06.63.78.59.79',NULL,'25 rue d''alencon','','','14220','BARBERY',NULL,NULL,'1410250421001',205.000000000,'1964-05-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6757,'TILLARD','BERNARD','1932-08-24','02.85.48.44.60','06.12.10.69.53',NULL,'HAMEAU DE LA PLACE','','','14000','CAEN',NULL,NULL,'2320861219001',3415.000000000,'1960-12-23','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6758,'BEAURUELLE','ROGER','1933-08-24','02.33.00.18.16','06.18.46.17.69',NULL,'20 CLOS ST MARTIN','','','14570','CLECY',NULL,NULL,'1330814058001',17.000000000,'1955-10-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6759,'TREFEU','ROGER','1929-01-07','02.20.45.38.36','06.66.62.29.86',NULL,'196 RUE DE FALAISE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2290114167001',126.000000000,'1953-08-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6760,'LESOMPTIER','FABIENNE','1930-05-20','02.39.16.92.28','06.10.79.90.63',NULL,'RUELLE DES PETITS MARAIS','','','14320','LAIZE LA VILLE',NULL,NULL,'1300572308001',1389.000000000,'1952-03-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6761,'LE BLOND','SUZANNE','1933-06-19','02.88.21.45.74',NULL,NULL,'LES GEMEAUX B2 190 AVENUE DE P','ESSICART','','14000','CAEN',NULL,NULL,'2330614257001',40.000000000,'1954-02-25','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6762,'LIBOIS','JOSEPH','1932-09-19','02.99.69.47.76','06.54.96.76.94',NULL,'5 rue des canadiens','','','14430','DOZULE',NULL,NULL,'2320950216001',1161.000000000,'1954-11-23','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6763,'LEMOIGNE','','1967-04-06','02.89.29.83.71','06.78.01.38.58',NULL,'4 RUE DE SUEDE','','','14000','CAEN',NULL,NULL,'2670452307001',4.000000000,'1989-08-16','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6764,'BAILLIEUL','Brunehilde','1929-03-16','02.81.85.28.42','06.11.70.02.43',NULL,'168 BOULEVARD DE FRANCE','','','14000','CAEN',NULL,NULL,'2290350356001',2378.000000000,'1952-10-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6765,'LEMARCHAND','GERARD','1964-09-02','02.50.60.99.34','06.43.11.14.54',NULL,'3 AV DE LA VALLEE','','','14160','DIVES SUR MER',NULL,NULL,'1640914364001',689.000000000,'1990-05-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6766,'MIREY','YVETTE','1933-06-14','02.35.32.68.15','06.23.62.78.97',NULL,'10 RUE DE BRETAGNE','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'2330614287001',274.000000000,'1962-09-19','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6767,'PAYEN','CLAUDE','1940-03-06',NULL,NULL,NULL,'2 IMPASSE MARLAUD','','','14150','OUISTREHAM',NULL,NULL,'1400361172001',25.000000000,'1966-05-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6768,'AUGUSTE','SUZANNE','1912-03-04','02.89.44.07.19','06.44.61.94.34',NULL,'3 RUE DE BERLIN','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1120314486001',72.000000000,'1934-06-22','PREMIUM',24,1);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6769,'LE GOFF','YVETTE','1937-05-10','02.74.97.06.73',NULL,NULL,'5 place du gal koenig','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2370514581001',460.000000000,'1966-01-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6770,'FOUCU','MAURICE','1936-02-13','02.58.22.82.33','06.17.03.65.96',NULL,'20 route du pont du coudray','','','14000','CAEN',NULL,NULL,'2360214737001',103.000000000,'1965-03-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6771,'CHANTEAU','Jean paul','1932-09-10','02.21.28.11.27','06.32.77.53.31',NULL,'33 RUE EMILE MAUGINS','','','14610','THAON',NULL,NULL,'2320914065001',3.000000000,'1953-10-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6772,'FAUDEMER','TUBO','1941-01-21','02.59.01.25.90','06.50.40.79.50',NULL,'3 CHEMIN DU ROCREUIL','','','27170','LE TILLEUL OTHON',NULL,NULL,'2410160684001',84.000000000,'1964-02-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6773,'MOREAU','JEANNE','1937-05-15','02.24.07.74.81',NULL,NULL,'2 PLACE SAINT GILLES','','','14000','CAEN',NULL,NULL,'1370550074001',261.000000000,'1965-05-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6774,'POISSON','michel','1928-06-30','02.24.04.35.36','06.64.45.09.18',NULL,'14 RUE DE LA MADELEINE','','','14000','CAEN',NULL,NULL,'1280614303001',34.000000000,'1950-06-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6775,'LANGUILLE','PIERRE','1938-10-22','02.26.05.05.83','06.73.72.18.85',NULL,'17 rue felix faure','','','14860','BREVILLE LES MONTS',NULL,NULL,'1381014747001',393.000000000,'1963-01-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6776,'FAUCON','SIMONE','1939-11-26','02.29.37.19.74',NULL,NULL,'50 RESIDENCE CHANPELIN','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1391114180001',709.000000000,'1960-05-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6777,'TUBOEUF','MICHEL',NULL,'02.40.42.34.65','06.10.78.07.66',NULL,'16 RUE DES RAMEES','','','14110','CONDE SUR NOIREAU',NULL,NULL,'1360350013001',144.000000000,'2012-10-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6778,'CHARPENTIER','JEAN','1935-03-21','02.14.05.08.67','06.46.79.25.54',NULL,'1874 ROUTE DE BRETTEVILLE','','','14280','AUTHIE',NULL,NULL,'1350314367001',51.000000000,'1964-03-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6779,'BERGERET','ROGER','1928-03-13','02.11.40.70.66','06.75.96.11.73',NULL,'LIEU DIT LA JALOUSIE','','','14430','GOUSTRANVILLE',NULL,NULL,'2280314008001',41.000000000,'1951-12-12','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6780,'MARESQ','NICOLAS','1932-02-14','02.89.68.32.68','00 33 6.46.11.20.32',NULL,'LA MONNERIE','','','14000','CAEN',NULL,NULL,'1320250519001',337.000000000,'1959-01-05','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6781,'JEAN','NICOLE','1928-03-03','02.66.60.35.53','06.48.41.02.63',NULL,'RESIDENCE TROTTEBECQ','','','14400','ST LOUP HORS',NULL,NULL,'1280314531001',23.000000000,'1954-12-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6782,'FONTAINE','JEAN CLAUDE','1928-04-15','02.74.96.13.07',NULL,NULL,'23 RUE DES COQUELICOTS','','','61100','LA LANDE PATRY',NULL,NULL,'2280414309001',75.000000000,'1951-12-27','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6783,'GARNIER','MICHEL','1955-02-14','02.70.58.38.29','06.69.55.17.18',NULL,'10 RUE DU PARC','','','14150','OUISTREHAM',NULL,NULL,'1550214254001',169.000000000,'1977-11-16','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6784,'ELIOT','Roger','1953-02-18','02.81.00.25.02','06.94.56.34.60',NULL,'16 mal leclerc','','','50680','ST CLAIR SUR L''ELLE',NULL,NULL,'2530280755001',13.000000000,'1978-03-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6785,'YONNET','Roch','1934-08-04','02.62.51.26.04','06.37.27.79.17',NULL,'lieu dit le mesnil gouffier','','','14000','CAEN',NULL,NULL,'2340814659001',114.000000000,'1960-11-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6786,'MARIE','ELIANE','1930-08-05','02.75.37.22.65','06.68.64.60.42',NULL,'9 rue du dauphin','','','14000','CAEN',NULL,NULL,'1300814600001',3564.000000000,'1953-12-12','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6787,'FOUCARD','HUGUETTE','1953-02-11','02.13.49.51.61','06.77.50.27.08',NULL,'3 RUE DU PEINTRE TOURNIERE','','','14320','FONTENAY LE MARMION',NULL,NULL,'2530261465001',128.000000000,'1976-02-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6788,'DECROCQ','SYLVAIN','1938-06-26','02.98.44.07.36','06.67.83.17.51',NULL,'LE BOURG NEUF','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1380614527001',101.000000000,'1960-06-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6789,'DECAMPS','HELENE','1963-01-13','02.88.25.63.58','06.45.06.83.72',NULL,'304 CHEMIN FLEURY','','','14750','ST AUBIN SUR MER',NULL,NULL,'1630114643001',89.000000000,'1984-12-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6790,'COCHEPAIN','chantal','1952-03-14','02.12.07.29.18','06.30.85.51.72',NULL,'','','','14860','RANVILLE',NULL,NULL,'1520314716001',143.000000000,'1979-11-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6791,'DUPLESSIS','NICOLE','1964-01-27','02.10.50.76.49','06.44.03.91.24',NULL,'10 RUE DE LA MINE','','','61100','MONTILLY SUR NOIREAU',NULL,NULL,'2640150613001',22.000000000,'1994-06-06','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6792,'MARIETTE','VACLAW','1945-08-18','02.79.67.45.76','06.52.15.36.20',NULL,'11 RUE DE NEUF MER','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1450814003001',119.000000000,'1967-03-22','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6793,'CORDEROCH','PIERRE','1936-04-06','02.56.12.39.74',NULL,NULL,'7 RUE DU STADE','','','61150','MONTGAROULT',NULL,NULL,'1360450040001',23.000000000,'1966-04-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6794,'MULLOIS','JACQUELINE','1947-05-06','02.20.27.25.63','06.85.76.61.57',NULL,'','','','14370','BELLENGREVILLE',NULL,NULL,'1470550192001',86.000000000,'1976-06-01','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6795,'BOUCLIER','MICHELINE','1958-03-12','02.27.22.15.95','06.12.06.54.25',NULL,'RUE DES PINSONS','','','14000','CAEN',NULL,NULL,'2580314181001',109.000000000,'1980-03-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6796,'GEORGET HAUGUEL','RAYMOND',NULL,'02.10.29.22.47','06.59.14.93.50',NULL,'10 RUE DE LA CABOTTIERE','','','14460','COLOMBELLES',NULL,NULL,'2590350363001',27.000000000,'2013-09-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6797,'LOUIS','GINETTE','1928-01-19','02.26.62.69.16','06.27.07.42.36',NULL,'25 RUE DU BOIS CLAQUET','','','14650','CARPIQUET',NULL,NULL,'1280114757001',101.000000000,'1949-10-08','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6798,'LECOINTRE','JULIETTE','1940-01-01','02.61.00.18.61','06.16.70.73.76',NULL,'8 rue st croix sur mer','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2400150110001',897.000000000,'1961-09-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6799,'VINETTE','GERARD','1936-12-29','02.67.23.03.86','06.98.13.00.34',NULL,'26 rue ste suzanne','','','61200','ARGENTAN',NULL,NULL,'1361214047001',1340.000000000,'1966-08-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6800,'BRIARD','JEAN YVES','1928-04-07','02.71.78.60.54','06.11.07.15.44',NULL,'29 RUE VICTOR LEPINE','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'2280414461001',146.000000000,'1952-02-16','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6801,'BACON','MARIE THERESE','1930-05-09','02.69.82.18.88','06.44.07.93.35',NULL,'68 RUE EUSTACHE RESTOUT','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2300514241001',27.000000000,'1960-08-15','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6802,'MONTALAND','ELISABETH','1954-04-06','02.43.22.28.84','06.19.67.05.89',NULL,'16 rue henri cheron','','','14100','LISIEUX',NULL,NULL,'2540414099001',2899.000000000,'1984-10-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6803,'RUEL','JEAN','1957-07-09','02.36.98.90.91','06.17.60.84.68',NULL,'325 rue de falaise','','','50480','STE MERE EGLISE',NULL,NULL,'1570714691001',6.000000000,'1980-05-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6804,'HERICY','ANDRE','1939-08-18','02.73.56.61.16','06.68.99.61.17',NULL,'1 BOULEVARD DES ALLIES','','','14940','SANNERVILLE',NULL,NULL,'2390814481001',776.000000000,'1968-08-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6805,'MICHON','CLAUDE','1929-02-20','02.80.45.18.87','06.72.45.96.69',NULL,'10 RUE DES TIEULS','','',NULL,NULL,NULL,NULL,'2290260632001',202.000000000,'1950-11-30','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6806,'LESAGE','ODETTE','1937-05-20','02.21.70.99.23','06.34.99.39.58',NULL,'6 2 RUE DES BALCONS','','','14000','CAEN',NULL,NULL,'1370522256001',93.000000000,'1961-06-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6807,'TUDOCE','ADRIEN','1936-05-12','02.72.94.00.45','06.52.01.23.26',NULL,'2 AVENUE JEAN VILAR','','','14000','CAEN',NULL,NULL,'1360514568001',35.000000000,'1957-02-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6808,'GUILLOU','LUCIEN','1957-09-04','02.47.24.73.87','06.79.22.62.40',NULL,'6 RUE DE LA LIBERATION','','','14650','CARPIQUET',NULL,NULL,'2570961216001',2667.000000000,'1982-05-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6809,'LAMY','CHRISTIANE','1980-12-27','02.17.98.58.06','06.70.77.62.76',NULL,'7 rue des bruyeres','','','14170','BOISSEY',NULL,NULL,'1801299255001',105.000000000,'2006-03-16','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6810,'DOUTRESOUL','MICHEL','1928-12-03','02.30.31.49.29','06.10.95.97.76',NULL,'13 route de bretagne','','','14210','AMAYE SUR ORNE',NULL,NULL,'2281214257001',377.000000000,'1953-05-13','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6811,'NOGENT','BERNADETTE','1940-03-29','02.67.36.51.88','06.57.47.15.25',NULL,'','','','14370','AIRAN',NULL,NULL,'2400314193001',638.000000000,'1968-05-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6812,'COLLIN','PASCALE','1966-01-30','02.11.42.80.41','06.69.68.50.75',NULL,'','','','14140','LIVAROT',NULL,NULL,'1660114246001',316.000000000,'1990-08-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6813,'BARATTE','Therese','1966-06-10','02.53.32.13.92','06.46.58.85.64',NULL,'2 RUE DU LONGRAIS','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2660614433001',10.000000000,'1988-08-30','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6814,'PAYEN','CHANTAL','1933-06-14','02.94.23.03.73','06.11.09.44.14',NULL,'11 BIS RUE PASTEUR','','','14400','BAYEUX',NULL,NULL,'1330614485001',92.000000000,'1957-01-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6815,'OTTENIN','JACQUELINE','1939-10-20','02.44.08.60.02','06.69.47.85.52',NULL,'','','','14123','IFS',NULL,NULL,'2391050592001',2711.000000000,'1968-07-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6816,'CRAMPON','COLETTE','1932-11-12','02.97.62.77.85','06.61.25.77.36',NULL,'LE BOURG','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2321175110001',4.000000000,'1962-10-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6817,'DROULIN','JEANNETTE','1940-07-09','02.78.85.04.88','06.32.90.48.63',NULL,'9 RUE DES ECOLES','','','14112','PERIERS SUR LE DAN',NULL,NULL,'1400714026001',1899.000000000,'1965-03-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6818,'LE PAGE','Marguerite','1940-07-14','02.99.39.88.25','06.92.41.02.37',NULL,'9 RUE CHEMIN AUX BOEUFS','','','61200','ARGENTAN',NULL,NULL,'1400714026001',479.000000000,'1966-08-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6819,'LAZARACHVILI','HERVE','1931-09-28','02.88.07.68.84','06.16.46.35.06',NULL,'15 rue constant forget','','','14000','CAEN',NULL,NULL,'1310914025001',182.000000000,'1953-01-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6820,'PARIS','JEAN MARIE','1934-03-14','02.40.29.97.87','06.51.90.92.93',NULL,'1 RUE MAZARIN','','','14190','ESTREES LA CAMPAGNE',NULL,NULL,'1340314156001',147.000000000,'1956-03-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6821,'LEBRETHON','NADINE','1943-01-30','02.11.88.19.68','06.37.08.24.33',NULL,'6 rue francois mitterant','','','14210','EVRECY',NULL,NULL,'1430150013001',1365.000000000,'1969-11-23','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6822,'GUILLOT','Philippe','1936-06-22','02.40.96.92.41','06.88.85.87.97',NULL,'1 RUE GENERAL MESLIN','','','14000','CAEN',NULL,NULL,'1360650149001',159.000000000,'1966-11-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6823,'LEBARBIER','MAURICE','1928-03-05','02.53.98.94.28','06.48.85.46.66',NULL,'22 Bis rue Joseph Levilly','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2280322164001',40.000000000,'1950-04-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6824,'DESLOGES','FERNAND','1930-12-31','02.47.06.93.99','06.28.07.05.25',NULL,'15 rue andre malraux','','','14940','SANNERVILLE',NULL,NULL,'2301250356001',17.000000000,'1958-09-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6825,'PRINTEMPS','JOCELYNE','1958-02-11','02.82.92.84.25','06.93.33.46.87',NULL,'LE BOURG  LE MESNIL OZOUF','','','14210','EVRECY',NULL,NULL,'2580214315001',502.000000000,'1988-11-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6826,'SACRISTE','MONIQUE','1960-02-07','02.11.12.15.43','06.45.79.20.84',NULL,'13 BOULEVARD MARITIME','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2600214245001',100.000000000,'1984-07-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6827,'FRAIZE','PIERRE','1934-09-06','02.26.33.99.39','06.54.36.66.62',NULL,'1 IMPASSE DU MUGUET','','','14320','MAY SUR ORNE',NULL,NULL,'2340914596001',33.000000000,'1961-10-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6828,'GODET','MARCELLE','1937-11-29','02.61.18.66.19','06.85.00.26.00',NULL,'la cour barette','','','14990','BERNIERES SUR MER',NULL,NULL,'2371114120001',68.000000000,'1965-09-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6829,'FILLET','Guy','1938-09-04','02.77.80.76.49','06.66.62.91.41',NULL,'3 chemin du beau site','','','14840','CUVERVILLE',NULL,NULL,'1380914090001',36.000000000,'1960-03-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6830,'BAYEUX','ANDRE','1937-10-21','02.13.19.85.19','06.22.16.06.45',NULL,'42 rue nationnal','','','50550','ST VAAST LA HOUGUE',NULL,NULL,'2371061256001',406.000000000,'1959-06-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6831,'CATHERINE','PAULETTE',NULL,'02.71.20.41.22','06.61.86.50.41',NULL,'48 boulevard raymond poincare','','',NULL,NULL,NULL,NULL,'1340277432001',3202.000000000,'2007-12-27','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6832,'PIARD','GISELE','1980-06-12','02.64.90.88.32','06.48.84.07.87',NULL,'131 avenue georges gynemer','','','14000','CAEN',NULL,NULL,'1800699324001',277.000000000,'2001-12-13','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6833,'LEMOINE','GEORGINA','1936-04-21','02.91.05.21.00','06.96.41.79.95',NULL,'43 BD DE RETHEL','','','14880','HERMANVILLE SUR MER',NULL,NULL,'1360414456001',19.000000000,'1960-03-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6834,'DUPONT','GEORGINA','1934-06-03','02.12.27.35.12','06.90.07.79.06',NULL,'3 RUE LOUIS ROBILLARD','','','50100','CHERBOURG',NULL,NULL,'1340614471001',897.000000000,'1957-09-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6835,'PREVEL','PAUL','1958-01-22','02.13.52.93.52','06.11.19.71.96',NULL,'2 RUE JEAN LE BARON','','','14400','NONANT',NULL,NULL,'1580114623001',76.000000000,'1988-05-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6836,'MARCHALOT','Madeleine','1950-05-21','02.75.31.32.81','06.11.62.94.98',NULL,'1 RUE DENIS DIDEROT','','','14190','OUILLY LE TESSON',NULL,NULL,'2500514340001',53.000000000,'1976-08-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6837,'DELAETER','pierre','1932-07-01','02.80.57.55.16','06.89.94.50.74',NULL,'RUE LA LANDE AU BARON','','','61100','MONTILLY SUR NOIREAU',NULL,NULL,'2320747167001',80.000000000,'1961-07-23','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6838,'BOUCHARD','JEAN','1932-04-09','02.43.24.76.15','06.11.14.26.76',NULL,'7 RUE DU CLOS  VERET','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1320476714001',5.000000000,'1956-02-16','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6839,'FAUCHOUX','PHILIPPE','1941-12-19','02.11.53.38.61','06.73.24.42.27',NULL,'325 ROUTE DE FALAISE','','','14320','FONTENAY LE MARMION',NULL,NULL,'2411278227001',850.000000000,'1968-04-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6840,'LONDES','GISELE','1963-01-29','02.11.28.47.86','06.73.99.42.15',NULL,'14 RUE PAUL DOUMER','','','61150','GOULET',NULL,NULL,'2630114009001',766.000000000,'1985-03-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6841,'LEPESQUEUX','JEAN MARIE','1957-04-02','02.18.56.19.64','06.19.57.25.15',NULL,'MAISON DU SACRECEOUR BP 5','','','14370','ARGENCES',NULL,NULL,'1570414589001',30.000000000,'1980-05-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6842,'TURQUETIL','Joseph','1929-06-24','02.81.73.70.07','06.82.18.84.94',NULL,'7 rue du marais','','','14980','ROTS',NULL,NULL,'2290614282001',803.000000000,'1957-07-28','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6843,'DUPONT','Magid','1931-12-07','02.11.04.58.66','06.28.40.94.34',NULL,'26 rue vaudieres','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1311214372001',156.000000000,'1955-04-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6844,'BEAUSSIEUX','DANIEL','1936-05-29','02.72.70.36.01','06.56.31.32.25',NULL,'15 SQUARE MARCEL PAGNOL','','','14670','TROARN',NULL,NULL,'1360553185001',1332.000000000,'1960-01-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6845,'DEVAUX','GISELE','1928-07-16','02.71.95.18.78','06.10.21.22.88',NULL,'la broquettiere','','','14000','CAEN',NULL,NULL,'1280714437001',105.000000000,'1955-01-24','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6846,'BURGEVIN','Leon','1970-03-18','02.58.86.97.46','06.56.20.54.27',NULL,'29 rue des mauvis','','','14460','COLOMBELLES',NULL,NULL,'2700314410001',73.000000000,'1993-01-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6847,'ONFROY','JEAN','1938-10-16','02.34.94.74.36',NULL,NULL,'','','','14000','CAEN',NULL,NULL,'2381067054001',16.000000000,'1961-05-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6848,'DUPLESSIS','PAUL','1936-05-01','02.29.29.95.94','06.51.34.03.44',NULL,'29 ROUTE DE ST LO','','','14123','IFS',NULL,NULL,'2360514635001',98.000000000,'1961-05-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6849,'POTIER DE COURCY','PIERRE','1957-03-25','02.66.78.42.37','06.88.39.80.28',NULL,'16 rue de beauvoir','','','14340','CAMBREMER',NULL,NULL,'2570361449001',53.000000000,'1980-12-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6850,'MARSSET','SYLVIE','1947-01-12',NULL,NULL,NULL,'18 RUE PILLET WILL','','','14780','LION SUR MER',NULL,NULL,'1470150153001',229.000000000,'1970-09-06','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6851,'BOUCEY','PIERRETTE','1947-01-16','02.97.01.05.49','06.23.39.98.96',NULL,'IMPASSE ANDRE GARNERIN','','',NULL,NULL,NULL,NULL,'1470150153001',1714.000000000,'1974-11-04','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6852,'LEPAREUR','ANDREE','1962-01-28','02.62.91.66.65','06.18.67.55.92',NULL,'8 route d ouville','','','77300','FONTAINEBLEAU',NULL,NULL,'1620114205001',98.000000000,'1992-08-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6853,'BERTRAND','CLAIRE','1932-02-07','02.98.18.37.41','06.50.85.78.28',NULL,'ROUTE DE LA TUILERIE LA COUR ST',' JEAN','','61270','LA CHAPELLE VIEL',NULL,NULL,'1320214191001',982.000000000,'1953-07-16','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6854,'BUREAU','Roger','1930-11-18','02.37.03.60.77','06.79.64.80.94',NULL,'16 rue des carriere','','','14130','LE BREUIL EN AUGE',NULL,NULL,'1301154339001',2108.000000000,'1958-12-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6855,'BUREAU','GERARD','1963-11-17','02.45.14.28.12','06.21.80.51.64',NULL,'6 IMPASSE DES FRERES ROBERGE','','','14000','CAEN',NULL,NULL,'1631114056001',256.000000000,'1991-08-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6856,'BALLET','JEAN','1979-06-29','02.30.59.72.52','06.12.06.22.16',NULL,'7 RUE JEAN ROGER','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1790629220001',37.000000000,'2002-05-04','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6857,'MICHEL','Marie','1950-03-01','02.21.74.19.51',NULL,NULL,'LIEU DIT"CHATEAU DE MAISON"','','','27300','BERNAY',NULL,NULL,'2500314364001',22.000000000,'1976-11-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6858,'FRILEY','Paul','1931-01-19','02.76.63.04.53','06.50.99.03.93',NULL,'"LA BONNE VIERGE"','','','14000','CAEN',NULL,NULL,'1310114739001',50.000000000,'1953-05-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6859,'JALLOH','BRIGITTE','1944-06-04','02.95.78.63.78','06.37.86.29.58',NULL,'LA GRANDE RUE BARBERY','','','14000','CAEN',NULL,NULL,'2440614075001',992.000000000,'1966-01-07','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6860,'BISSON','ANTOINETTE','1931-11-28','02.83.39.81.07','06.95.92.74.02',NULL,'route du vieux pain','','','14630','CAGNY',NULL,NULL,'1311159317001',596.000000000,'1952-07-03','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6861,'ROY','BERNARD','1930-10-26','02.37.38.43.48','06.37.40.92.84',NULL,'53 RUE JEAN VILAR','','','14000','CAEN',NULL,NULL,'1301014318001',141.000000000,'1951-10-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6862,'FRAICHOU','ANDREE','1941-06-09','02.10.06.31.92','06.10.86.29.18',NULL,'bourg de sevigny','','','14000','CAEN',NULL,NULL,'2410614097001',80.000000000,'1969-02-10','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6863,'THOUROUDE','YVONNE','1933-06-07','02.37.47.53.77','06.15.34.35.03',NULL,'16 RUE PLET BEAUGREY','','','14190','URVILLE',NULL,NULL,'1330614274001',26.000000000,'1954-03-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6864,'ROUSSEL','PIERRE','1929-01-13','02.35.09.31.83','00 33 6.97.85.56.02',NULL,'3 avenue de tourville','','','14670','TROARN',NULL,NULL,'1290161490001',831.000000000,'1950-10-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6865,'DEBAECKER','JEAN CLAUDE','1932-08-15','02.64.29.61.21','06.25.88.59.52',NULL,'21 RUE PAUL CLAUDEL','','','14120','MONDEVILLE',NULL,NULL,'1320814508001',199.000000000,'1959-06-15','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6866,'VASNIER','RAYMOND',NULL,'02.26.10.20.91','06.94.58.06.75',NULL,'LE RUYE','','','61350','PASSAIS LA CONCEPTION',NULL,NULL,'1360250383001',9.000000000,'2009-03-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6867,'CAUCHI','MARIUS','1933-05-19','02.91.61.94.72','06.35.01.13.17',NULL,'4 RUE DES FOSSETTES','','','14123','IFS',NULL,NULL,'2330514675001',330.000000000,'1954-07-07','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6868,'LETELLIER','JEAN','1944-01-18','02.24.87.25.17','06.51.72.95.62',NULL,'ROUVROU','','','14123','IFS',NULL,NULL,'2440114214001',110.000000000,'1966-10-09','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6869,'BELLIARD','ROGER','1929-09-23','02.35.54.55.02','06.83.29.43.46',NULL,'LIEU DIT"LECRUAU"','','','14790','VERSON',NULL,NULL,'2290961331001',22.000000000,'1951-12-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6870,'MARIE','ANITA','1947-12-27','02.25.20.79.40','06.53.78.41.67',NULL,'','','','14350','BEAULIEU',NULL,NULL,'2471214518001',302.000000000,'1973-03-25','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6871,'LIBOIS','CLAUDE','1951-04-17','02.60.24.27.76','06.14.20.13.03',NULL,'18 ALLEE DU BOSPHORE FOYER RES','IDENCE  APPT 105','','14020','CAEN CEDEX',NULL,NULL,'1510461186001',7.000000000,'1976-08-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6872,'PORQUET','JEANNINE','1963-02-24','02.61.51.88.98','06.31.48.06.11',NULL,'15 route de drsnay','','','61600','MAGNY LE DESERT',NULL,NULL,'2630214068001',91.000000000,'1984-08-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6873,'LEMONNIER','DENISE','1960-12-18','02.61.03.50.06','06.81.34.35.73',NULL,'51 ROUTE D OMAHA','','','14610','ANISY',NULL,NULL,'1601214537001',2211.000000000,'1989-04-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6874,'DEBART','CLAUDINE','1943-02-14','02.10.11.42.37','06.43.42.26.21',NULL,'6 rue du champ de foire','','','14123','IFS',NULL,NULL,'2430210016001',481.000000000,'1973-05-06','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6875,'JACQUELINE','ROLAND','1936-04-08','02.99.10.13.94','06.81.05.19.83',NULL,'3 rue saint gilles','','','14110','ST DENIS DE MERE',NULL,NULL,'1360450040001',289.000000000,'1966-01-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6876,'MIGNOTTE','denis','1938-12-08','02.37.68.48.04','06.68.88.79.87',NULL,'23 rue andre gide','','','14240','LA VACQUERIE',NULL,NULL,'1381250336001',160.000000000,'1960-04-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6877,'LE FRAPPER','GERARD','1961-03-02','02.94.08.26.37','06.10.07.47.17',NULL,'','','','50330','ST PIERRE EGLISE',NULL,NULL,'1610314435001',3962.000000000,'1989-12-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6878,'BLANDAMOUR','SIMONE','1930-11-09','02.31.34.95.82','06.29.94.10.67',NULL,'rue des cadrans','','','14840','DEMOUVILLE',NULL,NULL,'1301161468001',209.000000000,'1952-08-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6879,'ALMIN','michel','1934-06-02','02.74.44.54.15',NULL,NULL,'20 rue des fours a chaux','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2340614227001',186.000000000,'1956-08-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6880,'BONABAUD','BRIGITTE','1928-01-02','02.81.16.72.96','06.10.17.93.62',NULL,'15 RUE PAUL LANGEVIN','','','14110','CONDE SUR NOIREAU',NULL,NULL,'1280114076001',301.000000000,'1957-10-28','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6881,'HAY','EVELYNE','1933-10-11','02.15.91.34.72','06.29.55.75.83',NULL,'48 CLOS MICHEL','','','14500','ST GERMAIN DE TALLEVENDE',NULL,NULL,'1331061131001',298.000000000,'1957-08-28','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6882,'BOUDIN','FRANCOISE',NULL,'02.32.10.85.28','06.25.50.86.16',NULL,'1 rue leonard gilles','','','14680','GOUVIX',NULL,NULL,'1391114430001',161.000000000,'2010-08-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6883,'HOSTE','CLAUDE','1953-02-13','02.44.93.24.88','06.23.11.83.82',NULL,'31 bis rue larcher','','','50250','ST SYMPHORIEN LE VALOIS',NULL,NULL,'1530214297001',0.000000000,'1974-09-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6884,'LEVIEUX','MICHELLE','1920-03-01','02.25.64.69.73','06.79.32.98.19',NULL,'11 rue st baptiste','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1200314181001',36.000000000,'1946-09-23','PLATINIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6885,'MOULIN','MAURICE',NULL,'02.31.85.86.19','06.83.45.84.56',NULL,'2 RUE PAUL LANGEVIN','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1350750186001',478.000000000,'2008-05-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6886,'BOUFFAY','ELISABETH','1931-04-19','02.23.41.49.37','06.79.13.38.91',NULL,'7 RUE RENE VALOGNES','','','14220','BOULON',NULL,NULL,'1310450152001',53.000000000,'1952-02-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6887,'MICHEL','CHRISTIAN','1962-02-08','02.58.20.63.42','06.24.93.56.67',NULL,'LA DEVISE','','','14120','MONDEVILLE',NULL,NULL,'2620261377001',7.000000000,'1989-02-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6888,'LECOINTE','JEANNE','1930-06-19','02.83.92.75.29','06.52.09.83.26',NULL,'10 RUE MOLIERES PORTE 49','','','14860','ROBEHOMME',NULL,NULL,'1300661135001',90.000000000,'1956-04-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6889,'JOUSSET','GASTON','1934-01-24','02.29.41.79.59','06.53.82.44.75',NULL,'1rue leonard gilles','','','95110','SANNOIS',NULL,NULL,'2340114410001',33.000000000,'1963-06-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6890,'CLOUSIER','MICHEL','1938-10-10','02.15.32.58.94','06.36.24.13.10',NULL,'325 rte de falaise','','','14000','CAEN',NULL,NULL,'2381014294001',152.000000000,'1959-12-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6891,'MARTINEZ NAVARRO','JOSEPH','1941-01-22','02.72.10.47.93','06.32.40.57.82',NULL,'2 RUE PAUL LANGEVIN','','','14000','CAEN',NULL,NULL,'2410114246001',19.000000000,'1965-10-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6892,'LORY','sylvie','1953-01-27','02.53.48.19.09','06.80.18.46.21',NULL,'23 rue louis balliere','','','14430','BEUVRON EN AUGE',NULL,NULL,'2530114712001',34.000000000,'1976-10-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6893,'MARIE','MONIQUE','1935-08-23','02.78.17.86.52','06.64.97.02.78',NULL,'LA FEUILLERAIE   MAISON DE RETRA','ITE','','14120','MONDEVILLE',NULL,NULL,'1350814355001',8.000000000,'1957-07-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6894,'AMELINE','HUGUETTE','1951-01-25','02.36.95.38.32','06.66.92.12.96',NULL,'route de cond . lieu dit les pa','lieres','','14100','LISIEUX',NULL,NULL,'2510114062001',115.000000000,'1981-04-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6895,'LAIGUEDE','JACQUES','1919-09-09','02.90.10.14.30','06.16.05.21.59',NULL,'5 ave ste therese','','','61470','LE BOSC RENOULT',NULL,NULL,'1190914119001',382.000000000,'1948-12-12','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6896,'GAIGNARD','COLETTE','1930-10-16','02.55.04.92.37','06.24.16.10.77',NULL,'17 impasse du chateau','','','14123','IFS',NULL,NULL,'2301035347001',12.000000000,'1955-06-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6897,'LEVEQUE','ALEXIA','1928-04-11','02.25.85.96.62','06.49.73.21.19',NULL,'17 rue des mesanges','','','14540','SOLIERS',NULL,NULL,'1280461462001',2923.000000000,'1952-02-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6898,'FOUCHET','YANNICK','1935-10-05','02.21.14.72.18','06.52.99.89.24',NULL,'13 RUE ALBERT BAYET','','','61200','ARGENTAN',NULL,NULL,'1351014534001',49.000000000,'1964-09-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6899,'PESNEL','Pierrette','1934-08-12','02.60.79.07.90','06.30.67.95.59',NULL,'11 AVENUE DES CHEVALIERS','','','14670','ST PIERRE DU JONQUET',NULL,NULL,'1340814327001',12.000000000,'1955-12-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6900,'GUESNON','MAURICETTE','1958-01-10','02.71.07.27.54','06.21.51.43.48',NULL,'6 avenue du 19 mars 1962','','','14540','ROCQUANCOURT',NULL,NULL,'1580114672001',2695.000000000,'1981-09-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6901,'COQUET','CHANTAL','1933-10-01','02.45.68.19.55','06.21.24.77.03',NULL,'12 rue de lisbonne','','','50700','LIEUSAINT',NULL,NULL,'2331014133001',14.000000000,'1961-03-09','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6902,'FIANT','jean paul','1934-04-05','02.49.68.19.63','06.89.66.12.80',NULL,'','','','14000','CAEN',NULL,NULL,'1340450123001',301.000000000,'1955-11-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6903,'BUREAU','COLETTE','1937-11-20','02.11.08.11.69','06.10.13.67.09',NULL,'16 rue du puits Picard','','','14250','TILLY SUR SEULLES',NULL,NULL,'1371150433001',688.000000000,'1959-08-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6904,'LAIR','MICHELE','1940-11-13','02.81.72.26.49','06.10.35.45.43',NULL,'ROUTE DEPARTEMENTALE','','','14123','IFS',NULL,NULL,'2401114114001',98.000000000,'1966-03-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6905,'LENEVEU','VALERIE','1929-07-21','02.76.23.04.16','06.85.70.39.55',NULL,'20 RUE DES ANEMONES','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'2290714172001',134.000000000,'1954-10-12','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6906,'BRIARD','LEON','1929-01-05','02.60.67.15.82','06.92.62.44.19',NULL,'12 HENRI BARBUSSE','','','14380','MESNIL CLINCHAMPS',NULL,NULL,'2290161062001',161.000000000,'1957-10-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6907,'DEVILLE','ANNE MARIE','1945-01-12','02.27.19.74.97',NULL,NULL,'RUE DU XXE SIECLE','','','14840','CUVERVILLE',NULL,NULL,'1450114133001',20.000000000,'1966-11-11','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6908,'JAMES','SYLVIE','1940-04-03','02.78.80.88.66','06.46.83.44.86',NULL,'LA HAUTE BRUYERE','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1400414092001',369.000000000,'1962-02-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6909,'FLORO','patricia','1940-02-22','02.88.72.39.16','06.54.03.90.72',NULL,'57 rue luois aragon','','','14500','VIRE',NULL,NULL,'2400214689001',408.000000000,'1965-08-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6910,'HAYS','ROBERT','1964-06-26','02.10.16.52.51','06.70.42.18.35',NULL,'','','','14680','GOUVIX',NULL,NULL,'1640676451001',64.000000000,'1985-03-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6911,'','GEORGETTE','1930-11-14','02.42.77.09.32','06.43.06.51.05',NULL,'22  BIS RUE ARISTIDE BRIAND','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1301114181001',30.000000000,'1956-09-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6912,'VARON','DANIEL','1933-09-09','02.41.46.01.73','06.10.66.38.68',NULL,'10 residence de la prairie rue d','u blanc','','14670','BURES SUR DIVES',NULL,NULL,'1330953133001',139.000000000,'1960-05-20','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6913,'LELONG','SOLANGE','1959-01-25','02.10.60.12.94','06.20.91.21.44',NULL,'98 BIS  ROUTE DE FALAISE','','','14000','CAEN',NULL,NULL,'1590114090001',30.000000000,'1980-05-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6914,'OZOUF','NODAR',NULL,'02.75.41.78.08','06.80.85.55.30',NULL,'5 RUE JULES FERRY','','','14100','LISIEUX',NULL,NULL,'2300714566001',67.000000000,'2010-06-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6915,'POUCHIN','GUY','1965-05-27','02.42.72.08.52','06.26.33.68.05',NULL,'14 RUE DU CIVISME','','','14980','ROTS',NULL,NULL,'1650514556001',53.000000000,'1988-01-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6916,'BRUNET','THERESE','1932-01-24','02.73.35.15.22','06.14.21.74.50',NULL,'12 rue du muguet','','','14670','BURES SUR DIVES',NULL,NULL,'2320114393001',755.000000000,'1962-10-05','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6917,'LEBERRURIER','BERNARD','1940-03-14','02.43.73.81.54','06.32.00.86.08',NULL,'91 RUE DE CARENTAN','','','14100','ST MARTIN DE LA LIEUE',NULL,NULL,'1400361039001',29.000000000,'1965-09-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6918,'LEDENTU','ALAIN','1940-05-28','02.10.60.95.53','06.23.15.15.31',NULL,'36 rue des 13 acres','','','14700','FALAISE',NULL,NULL,'1400537008001',47.000000000,'1969-11-03','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6919,'GUILLOT','Monique','1955-07-20','02.86.76.53.33','06.87.29.62.36',NULL,'9 rue paul samson','','','14860','BREVILLE LES MONTS',NULL,NULL,'1550714118001',719.000000000,'1980-08-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6920,'COZIC','YVES','1929-01-04','02.13.53.04.16','06.82.67.29.39',NULL,'18 impasse de l''orangeraie','','','14540','GRENTHEVILLE',NULL,NULL,'1290114667001',121.000000000,'1958-07-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6921,'LECORNEC','CLAUDE','1959-11-29','02.11.97.91.46','06.68.34.61.44',NULL,'22 bd georges pompidou residence',' arena','','14840','DEMOUVILLE',NULL,NULL,'1591161256001',177.000000000,'1982-04-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6922,'CARABY','JEAN','1933-02-17','02.25.31.36.70','06.41.71.11.78',NULL,'rue nicolas copernic','','','14114','VER SUR MER',NULL,NULL,'2330214324001',70.000000000,'1956-07-26','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6923,'FOUREY','Marie therese','1940-03-29','02.76.18.77.25','06.28.67.50.19',NULL,'4 CITE DE CAUDET','','','14690','PIERREFITTE EN CINGLAIS',NULL,NULL,'2400350552001',3950.000000000,'1969-12-26','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6924,'DELETRE','GEORGES','1930-05-08','02.41.75.51.36','06.93.47.34.84',NULL,'1014 HAUTE FOLIE','','','14000','CAEN',NULL,NULL,'2300527538001',36.000000000,'1956-05-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6925,'MARTIN','JEAN','1954-04-18','02.39.57.10.08','06.34.94.33.50',NULL,'4 ROUTE DES MARAIS','','','14000','CAEN',NULL,NULL,'1540461009001',83.000000000,'1984-05-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6926,'PIERRE DE LA BRIERE','GINETTE','1940-01-12','02.94.73.73.39','06.74.08.96.84',NULL,'2.2 rue du delta','','','14540','SOLIERS',NULL,NULL,'2400114486001',35.000000000,'1966-10-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6927,'LEGREGEOIS','EDMOND','1932-07-28','02.90.36.86.67','06.41.43.77.59',NULL,'6-1 rue du ruisseau','','','14370','ARGENCES',NULL,NULL,'2320714990001',140.000000000,'1956-05-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6928,'','MARCELINE','1938-01-05','02.58.53.94.93','06.12.52.54.73',NULL,'21 RUE DE BRUXELLES','','','14220','BOULON',NULL,NULL,'1380114437001',81.000000000,'1968-06-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6929,'JEANNE','CLAUDE','1963-03-02','02.11.56.89.17','06.50.49.07.07',NULL,'6 RUE DE LA VIERGE','','','14270','MEZIDON CANON',NULL,NULL,'1630314535001',752.000000000,'1993-03-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6930,'MARIE','PIERRE','1951-07-25','02.29.83.00.14','06.23.06.61.61',NULL,'14 RUE DES BERGERONNETTES','','','61200','ARGENTAN',NULL,NULL,'2510714449001',813.000000000,'1972-09-22','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6931,'LEDRET','philamain','1938-01-14','02.30.09.10.48','06.11.27.03.98',NULL,'4 RUE PAUL LANGEVIN','','','14000','CAEN',NULL,NULL,'1380114738001',793.000000000,'1966-04-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6932,'BUNEL','Marcel','1939-08-25','02.14.04.61.62','06.84.80.39.69',NULL,'54 RUE LOUIS LECHATELLIER','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2390814597001',66.000000000,'1966-03-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6933,'BARETTE','NICOLE','1932-04-06','02.18.18.84.45','06.20.22.51.77',NULL,'8 RUE ST GERBOLD','','','14930','ETERVILLE',NULL,NULL,'1320450400001',149.000000000,'1956-01-16','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6934,'DESHAYES','GUY','1944-02-08','02.33.08.91.86','06.75.64.77.91',NULL,'19RUE DES FLEURS','','','14860','RANVILLE',NULL,NULL,'2440214011001',32.000000000,'1967-02-21','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6935,'DENEUVILLE','jacques','1931-11-20','02.13.87.80.52','06.51.52.67.89',NULL,'1148 RUE DU BOCAGE','','','14350','ST MARTIN DES BESACES',NULL,NULL,'2311114158001',845.000000000,'1952-08-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6936,'BERNET','JEAN','1934-10-04','02.11.50.18.83','06.66.98.22.35',NULL,'LE BOURG','','','14250','BROUAY',NULL,NULL,'1341022220001',1919.000000000,'1957-07-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6937,'DUVAL','JACQUES','1953-02-02','02.30.51.34.21','06.11.45.45.66',NULL,'25 RUE PIERRE DE RONSARD','','','14120','MONDEVILLE',NULL,NULL,'2530214364001',491.000000000,'1975-02-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6938,'','JEAN-LUC','1928-12-06','02.41.99.82.26','06.59.87.52.14',NULL,'12 AV DU 43 EME REGIMENT D''ARTIL','LERIE','','14400','BAYEUX',NULL,NULL,'2281214537001',74.000000000,'1955-11-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6939,'VIERSOU','patricia','1932-07-13','02.17.14.44.64','06.33.88.26.97',NULL,'RUE DE BALLEROY','','','14230','NEUILLY LA FORET',NULL,NULL,'1320750459001',112.000000000,'1954-01-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6940,'BOSANSKY','DENISE','1944-05-03','02.90.97.79.35','06.57.49.28.36',NULL,'19 RUE DES FRESNETS','','','14390','PETIVILLE',NULL,NULL,'1440561014001',195.000000000,'1965-08-20','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6941,'MARIE','BERNARD','1936-09-02','02.41.10.11.23','06.99.45.20.08',NULL,'25 RUE DE LA FONTAINE','','','14540','SOLIERS',NULL,NULL,'1360914701001',472.000000000,'1961-06-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6942,'THOMINE','MARYSE','1944-01-03','02.67.92.62.24','06.51.90.16.81',NULL,'52 av de rouen','','','14000','CAEN',NULL,NULL,'2440150127001',1100.000000000,'1968-02-22','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6943,'ROUSSELLE','ROGER','1928-01-18','02.62.22.30.79','06.10.39.72.56',NULL,'LE BOIS CHASSE VENT','','','14111','LOUVIGNY',NULL,NULL,'1280114319001',6.000000000,'1949-02-18','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6944,'QUESNOT','MAURICETTE','1928-06-04','02.55.20.78.11','06.68.08.46.50',NULL,'ROUTE DE MAIZIERES DANNEVILLE','','','14000','CAEN',NULL,NULL,'1280661462001',167.000000000,'1953-10-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6945,'LEBUGLE','ANDRE',NULL,'02.10.21.50.79','06.10.65.01.84',NULL,'15 RUE GEORGES GAILLARD','','','14460','COLOMBELLES',NULL,NULL,'1341150301001',7.000000000,'2011-07-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6946,'BACHRANI','JEAN LOUIS','1929-04-01','02.57.16.44.87','06.85.45.14.99',NULL,'LA GRANDE FERME','','','14370','CANTELOUP',NULL,NULL,'1290450093001',3011.000000000,'1953-07-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6947,'RENAUD','JACQUES','1939-09-26','02.81.62.41.66','06.94.26.09.05',NULL,'CHEMIN DU CLOS BAVENT','','','14260','JURQUES',NULL,NULL,'1390914133001',17.000000000,'1969-03-13','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6948,'MAILLET','PIERRE','1928-02-25','02.41.08.54.05','06.25.32.66.31',NULL,'4 rue daniel tison','','','14470','REVIERS',NULL,NULL,'1280260492001',131.000000000,'1951-12-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6949,'ABOUL','CHRISTIAN','1937-05-13','02.60.15.90.46','06.19.89.99.65',NULL,'6 RUE DU PARC','','','14190','FIERVILLE BRAY',NULL,NULL,'2370514623001',23.000000000,'1965-06-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6950,'FAVRIS','jacques','1952-01-29','02.43.31.15.86','06.15.00.30.63',NULL,'LA PERDRIERE','','','14540','SOLIERS',NULL,NULL,'2520150401001',349.000000000,'1976-04-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6951,'LE MOYNE','JACQUELINE','1937-11-21','02.73.10.56.38','06.97.79.18.69',NULL,'75 rue eustache restout','','','50820','TOLLEVAST',NULL,NULL,'1371114271001',279.000000000,'1960-11-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6952,'NADIRADZE','Joseph','1969-05-11','02.74.70.56.89',NULL,NULL,'11 rue des freres wilkin','','','14610','THAON',NULL,NULL,'1690514366001',660.000000000,'1999-04-15','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6953,'POULAIN','REMY','1936-09-25','02.43.68.79.02','06.89.70.58.88',NULL,'9 AVENUE DES FONTAINES','','','14280','AUTHIE',NULL,NULL,'1360914107001',1354.000000000,'1966-12-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6954,'ROUCAN','DENIS','1966-08-10','02.15.98.91.47','06.10.00.03.28',NULL,'8 RUE ALBERT BAILLET','','','14670','BURES SUR DIVES',NULL,NULL,'1660814119001',284.000000000,'1988-02-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6955,'MALLET','JEAN','1928-10-15','02.81.32.12.04','06.46.38.45.15',NULL,'27 RUE PIERRE CURIE','','','14730','GIBERVILLE',NULL,NULL,'1281014462001',956.000000000,'1949-08-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6956,'PARIS','Bernard','1931-01-19','02.48.06.41.82','06.60.26.48.19',NULL,'19 AVENUE DU 6 JUIN','','','14000','CAEN',NULL,NULL,'1310114076001',63.000000000,'1961-04-28','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6957,'LEMONNIER','Paul','1930-06-12','02.88.67.45.15','06.89.28.48.84',NULL,'149 RUE LE BOIS MARCEL','','','14270','MEZIDON CANON',NULL,NULL,'2300614438001',36.000000000,'1959-10-22','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6958,'VALOGNE','MARLENE','1940-05-21','02.11.81.69.84','06.34.76.02.66',NULL,'26 PLACE REINE MATHILDE','','','14000','CAEN',NULL,NULL,'2400550164001',857.000000000,'1962-01-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6959,'HAELEWYN','LUCIENNE','1937-04-28','02.91.34.25.78','06.33.61.89.24',NULL,'175 RUE D''AUGE','','','14250','FONTENAY LE PESNEL',NULL,NULL,'1370450559001',35.000000000,'1961-02-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6960,'RIBERT','Jean','1935-12-16','02.42.06.74.56',NULL,NULL,'rue chagford','','','61200','ARGENTAN',NULL,NULL,'1351260236001',4126.000000000,'1959-07-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6961,'GUILLAUME','MARGUERITE','1941-02-01','02.82.04.61.99','06.11.56.73.19',NULL,'3 RUE PAUL LANGEVIN','','','14270','OUEZY',NULL,NULL,'1410214254001',25.000000000,'1969-04-19','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6962,'DESGUET','Viviane','1938-03-14','02.54.09.54.63','06.42.53.87.64',NULL,'7 inpasse du champs de l''allouet','te','','14120','MONDEVILLE',NULL,NULL,'2380322225001',1.000000000,'1964-06-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6963,'TOUCHARD','LOUIS','1928-03-16','02.32.76.69.50','06.20.68.29.79',NULL,'34 DOMAINE DE LA COQUERAINE','','','14220','FRESNEY LE VIEUX',NULL,NULL,'1280314531001',199.000000000,'1950-06-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6964,'','BRUNO','1938-04-29','02.87.29.46.63','06.61.90.90.79',NULL,'20 RUE DES QUESNOTS','','','14000','CAEN',NULL,NULL,'2380414191001',24.000000000,'1966-09-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6965,'GOSSE','ODETTE','1959-03-03','02.27.23.87.60','06.86.24.35.89',NULL,'4 rue p langevin','','','14310','EPINAY SUR ODON',NULL,NULL,'2590350363001',844.000000000,'1983-01-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6966,'LAUNAY','MADELAINE','1945-03-30','02.42.91.94.35','06.98.99.02.17',NULL,'RUE DE LA VERDIERE','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1450361292001',150.000000000,'1971-09-20','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6967,'BANDRAC','GILLES',NULL,'02.11.23.46.18','06.87.11.83.98',NULL,'1 RUE BIENFAISANCE','','','14120','MONDEVILLE',NULL,NULL,'1520514118001',18.000000000,'2012-10-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6968,'FAGUAIS','JEAN','1938-09-13','02.24.16.95.80','06.56.76.74.48',NULL,'9 rue gilbert','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2380914506001',525.000000000,'1966-05-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6969,'LE GALL','PIERRE','1957-06-28','02.22.15.39.82','06.89.37.84.34',NULL,'47 RUE DU MANOIR','','','14630','EMIEVILLE',NULL,NULL,'2570614320001',2495.000000000,'1986-06-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6970,'LE GOFF','GINETTE','1929-08-07','02.51.80.39.83','06.56.21.36.63',NULL,'9 rue du val es dune','','','14270','MEZIDON CANON',NULL,NULL,'2290814408001',1894.000000000,'1955-06-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6971,'QUIGNETTE','ALAIN','1960-12-02','02.32.82.01.30','06.62.55.49.05',NULL,'12 rue trainerie','','','14320','FONTENAY LE MARMION',NULL,NULL,'1601214525001',29.000000000,'1986-11-05','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6972,'TROLET','GUY','1937-09-15','02.26.20.10.14','06.37.70.37.98',NULL,'le bourg','','','14710','TREVIERES',NULL,NULL,'1370961283001',481.000000000,'1958-11-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6973,'LEHUBY','MADELEINE','1935-09-15','02.83.61.50.98','06.10.69.02.44',NULL,'RUE AUNOU LE FAUCON','','','14000','CAEN',NULL,NULL,'1350950396001',2061.000000000,'1957-03-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6974,'MARTIN','CHRISTIANE','1939-05-09','02.16.76.09.57','06.84.38.38.50',NULL,'55 ROUTE D''HARCOURT','','','27700','BOUAFLES',NULL,NULL,'2390514228001',1009.000000000,'1969-11-21','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6975,'DESNOYER','MICHEL','1970-03-22','02.93.79.37.02','06.20.77.36.17',NULL,'30 rue robert bothereau','','','61700','DOMFRONT',NULL,NULL,'1700399255001',69.000000000,'1997-12-20','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6976,'LELIEVRE','PIERRE',NULL,'02.67.25.67.34','06.85.64.80.78',NULL,'8 RUE DES BOULEAUX','','','14370','BELLENGREVILLE',NULL,NULL,'2370750422001',39.000000000,'2012-05-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6977,'ROUSSEAU','jean claude','1944-08-02','02.12.14.43.54','06.91.08.30.00',NULL,'75 RUE EUSTACHE RESTOUT','','','14370','BELLENGREVILLE',NULL,NULL,'1440878268001',31.000000000,'1969-05-09','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6978,'VAULOUP','SYLVIE','1936-12-03','02.35.84.95.87','06.62.80.43.45',NULL,'10 RUE KALINIGRENKO','','','14270','MEZIDON CANON',NULL,NULL,'2361227292001',23.000000000,'1960-02-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6979,'MARIE','FRANCOISE','1948-01-28','02.17.23.07.44','06.38.93.78.70',NULL,'14 /2 rue du 6 juin','','','50500','ST ANDRE DE BOHON',NULL,NULL,'1480114670001',465.000000000,'1978-11-05','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6980,'VERRECKT','REGIS','1937-05-01','02.78.61.61.76','06.67.77.09.94',NULL,'10 rue des belles vues','','','14370','ARGENCES',NULL,NULL,'1370561462001',338.000000000,'1961-06-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6981,'LEBIGOT','JEANINE','1959-02-07','02.16.62.23.59','06.48.35.68.38',NULL,'42 rue des acadiens','','','14000','CAEN',NULL,NULL,'1590214544001',1411.000000000,'1987-12-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6982,'LESEINE','LAURENT','1934-06-14','02.25.52.23.55','06.51.97.57.04',NULL,'4 rue paul langevin','','','14540','SOLIERS',NULL,NULL,'2340614074001',15.000000000,'1959-04-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6983,'VALLY','ISABELLE','1930-11-28','02.12.80.86.75','06.73.40.02.56',NULL,'154 BOULEVARD LEROY','','',NULL,NULL,NULL,NULL,'1301127080001',8.000000000,'1959-11-13','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6984,'BECOURT','JEAN MARIE','1934-12-16','02.31.91.12.42','06.47.92.77.33',NULL,'4 rue des muguets','','','14590','LE PIN',NULL,NULL,'1341250546001',172.000000000,'1964-04-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6985,'VOISIN','JUSTINE','1938-05-01','02.10.38.72.83','06.10.71.38.53',NULL,'','','','14490','BALLEROY',NULL,NULL,'2380514106001',496.000000000,'1966-05-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6986,'CHALINE','CHRISTIANE','1936-08-24','02.38.71.88.88','06.37.95.01.21',NULL,'1010 BELLES PORTES','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1360850127001',210.000000000,'1962-11-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6987,'LORY','JACQUES','1929-08-21','02.79.85.20.18','06.56.43.03.38',NULL,'146 ROUTE DE BRETAGNE','','','61200','SAI',NULL,NULL,'1290883124001',203.000000000,'1954-11-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6988,'DALMONT','REGINE','1930-12-15','02.40.67.06.89','06.10.18.64.37',NULL,'5 RUE DU BAILLAGE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1301214171001',45.000000000,'1956-02-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6989,'DUL','jean','1931-08-16','02.69.95.04.64','06.58.23.17.23',NULL,'LE PAVEMENT','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2310814006001',4470.000000000,'1953-10-29','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6990,'PAQUIN','ERICK','1933-09-07','02.44.99.80.85','06.23.33.63.34',NULL,'5 RUE DES PAVILLONS','','','14000','CAEN',NULL,NULL,'2330914665001',120.000000000,'1958-09-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6991,'BENSSE','CHARLES','1938-11-12','02.61.18.45.31','06.15.42.72.57',NULL,'23 rue de la cle des champs','','','14000','CAEN',NULL,NULL,'2381114577001',32.000000000,'1960-12-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6992,'SAILLARD','MOHAMMED',NULL,'02.11.18.51.77','06.10.67.98.77',NULL,'386 RUE DU CHEMIN VERT','','','14270','MEZIDON CANON',NULL,NULL,'1301214040001',1745.000000000,'2012-11-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6993,'ALLAIS','Frdric','1934-09-25','02.53.16.56.11','06.75.68.92.47',NULL,'56 AVENUE RENE COTY','','','14370','ARGENCES',NULL,NULL,'1340972097001',280.000000000,'1956-05-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6994,'LAMBERT','Therese','1932-11-08','02.67.49.22.71','06.96.32.73.49',NULL,'2 RUE DE LA MULOISIERE','','','14540','TILLY LA CAMPAGNE',NULL,NULL,'2321150087001',1339.000000000,'1955-03-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6995,'BELLUAU','Jean jacques','1930-02-24','02.51.72.66.22','06.72.10.33.31',NULL,'27 rue du stade','','','14630','CAGNY',NULL,NULL,'1300236224001',54.000000000,'1953-09-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6996,'ENIE','RENE','1938-08-23','02.78.01.86.15','06.11.32.32.71',NULL,'rue des ecoles','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2380814271001',214.000000000,'1967-02-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6997,'GOBICHON','GENEVIEVE','1936-12-12','02.55.26.19.63','06.57.12.50.94',NULL,'14 rue jean paul marat','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2361261307001',32.000000000,'1963-03-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6998,'GUENE','MICHEL','1935-09-23','02.52.66.00.73','06.24.84.42.05',NULL,'22 rue du berry','','','50000','ST LO',NULL,NULL,'2350950356001',62.000000000,'1958-07-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (6999,'PELCERF','MARTHE','1956-06-05','02.19.47.25.49','06.20.46.17.90',NULL,'14 rue pasteur','','','14450','GRANDCAMP MAISY',NULL,NULL,'2560614404001',121.000000000,'1981-12-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7000,'DENIS','BLANCHE','1964-03-03','02.93.32.83.99','06.54.67.27.44',NULL,'','','','14790','VERSON',NULL,NULL,'2640314003001',727.000000000,'1986-12-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7001,'ROILLE','jacqueline','1928-02-22','02.11.69.16.68','06.81.97.99.14',NULL,'la hameliniere','','','14650','CARPIQUET',NULL,NULL,'1280214166001',40.000000000,'1950-02-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7002,'DESOUCHE','MICHEL','1932-02-19','02.79.04.95.19','06.93.73.76.31',NULL,'4 rue des haies vives','','','61310','SILLY EN GOUFFERN',NULL,NULL,'2320214218001',60.000000000,'1961-10-26','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7003,'OSSEDAT','MONIQUE','1958-10-15','02.88.18.67.64','06.11.61.03.08',NULL,'23 RUE ROBERT COURTEHEUSE','','','14140','LIVAROT',NULL,NULL,'2581051598001',12.000000000,'1985-10-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7004,'ISSAMBOURG','LUCIENNE','1939-06-02','02.27.93.14.98','06.14.32.30.76',NULL,'80 RUE DE FALAISE','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2390661031001',1024.000000000,'1961-01-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7005,'MAUGER','MICHEL','1941-03-27','02.88.17.65.80','06.40.28.86.45',NULL,'8 ALLEE LAPERUSE','','','14240','CAHAGNES',NULL,NULL,'2410314362001',67.000000000,'1966-04-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7006,'MARIE','Yvonne',NULL,'02.27.98.28.33','06.28.58.23.00',NULL,'3 IMPASSE DU HOME','','','14750','ST AUBIN SUR MER',NULL,NULL,'2640314003001',8.000000000,'2012-07-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7007,'CHOLET','DANIEL','1964-03-11','02.26.73.09.37','06.54.31.08.66',NULL,'CEVIGNY','','','27240','CORNEUIL',NULL,NULL,'2640314003001',1289.000000000,'1986-05-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7008,'HALUN','JACKY','1928-05-10','02.10.11.00.50','06.15.67.59.81',NULL,'19 RUE DU GENERAL LECLERC','','','14170','THIEVILLE',NULL,NULL,'1280514002001',111.000000000,'1956-08-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7009,'BOUET','MONIQUE','1940-12-03','02.67.55.40.02','06.12.41.65.79',NULL,'4/2 rue du bois','','','14000','CAEN',NULL,NULL,'1401214310001',31.000000000,'1964-11-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7010,'CHOLET','YVONNE','1937-09-12','02.56.41.82.98','06.64.23.58.75',NULL,'7 SQUARE DANIEL TISON','','','14980','ROTS',NULL,NULL,'2370957205001',136.000000000,'1962-08-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7011,'LEHAIN','MARIE AGNES','1968-01-15','02.41.34.82.03','06.45.35.26.21',NULL,'CHEMIN TUILE','','','14210','AMAYE SUR ORNE',NULL,NULL,'2680114327001',898.000000000,'1989-03-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7012,'JUNG','ALAIN','1949-04-04','02.76.08.21.75','06.13.91.22.08',NULL,'5 RUE DE LA RIVIERE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2490414163001',66.000000000,'1971-10-27','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7013,'GOUPIL','MICHELINE','1932-01-31','02.73.08.28.49','06.20.90.73.11',NULL,'282 RUE DU TOUR DE VILLE','','','14270','MEZIDON CANON',NULL,NULL,'2320127305001',39.000000000,'1961-11-05','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7014,'GENTIL','THIERRY','1931-10-16','02.90.04.41.82','06.73.10.70.40',NULL,'46 RUE GENERAL LECLERC','','','14730','GIBERVILLE',NULL,NULL,'1311014604001',580.000000000,'1961-02-15','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7015,'BISSONNET','ANDRE','1937-05-03','02.13.09.08.78','06.11.46.27.02',NULL,'LE BOURG','','','27800','CALLEVILLE',NULL,NULL,'1370514142001',2139.000000000,'1960-05-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7016,'ISABEL','MAURICE','1943-05-29','02.73.73.22.37','06.93.52.99.08',NULL,'17 rue des mesanges','','','50110','BRETTEVILLE',NULL,NULL,'1430514411001',85.000000000,'1968-07-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7017,'','YVETTE','1928-10-11','02.31.73.37.05','06.97.83.53.43',NULL,'4 RUE DU 8 MAI','','','14000','CAEN',NULL,NULL,'1281014183001',60.000000000,'1958-05-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7018,'GONFROY','PATRICIA','1931-03-22','02.58.02.61.59','06.11.23.21.51',NULL,'6 RUE DES GRANDE PATURES','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1310314443001',311.000000000,'1960-12-27','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7019,'PEUVREL','PIERRE','1933-07-22','02.82.88.01.18','06.45.32.26.89',NULL,'20 RUE BEAU SOLEIL','','','14123','IFS',NULL,NULL,'1330714185001',17.000000000,'1955-09-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7020,'BENOIST','AUGUSTE','1935-06-20','02.36.71.46.58','06.22.21.16.36',NULL,'VALLEE DE NEUILLY','','','14120','MONDEVILLE',NULL,NULL,'2350614275001',251.000000000,'1963-02-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7021,'MARTIN','ROBERT','1933-10-30','02.56.35.39.32','06.30.38.33.72',NULL,'23 RUE DU CIVISME','','','14123','IFS',NULL,NULL,'1331014212001',1125.000000000,'1957-08-20','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7022,'ROBERGE','DOMINIQUE','1936-08-15','02.33.07.01.78','06.32.71.00.25',NULL,'36 RUE DU MOULIN A VOIDE','','','14540','ROCQUANCOURT',NULL,NULL,'1360814990001',57.000000000,'1966-10-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7023,'LAMOTHE','CAROLINE','1940-02-23','02.97.66.18.31','06.72.49.90.47',NULL,'56 rue louis robillard','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'2400214277001',1.000000000,'1962-11-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7024,'LE COZ','Claude','1951-01-08','02.10.73.30.42','06.35.47.61.20',NULL,'3 ROUTE DE VILMONT','','','14220','FRESNEY LE VIEUX',NULL,NULL,'1510159651001',73.000000000,'1976-01-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7025,'LESAGE','GUSTAVE','1932-05-19','02.19.52.71.67','06.98.45.19.72',NULL,'7-1 JACQUES CONTE','','',NULL,NULL,NULL,NULL,'2320514592001',36.000000000,'1962-07-22','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7026,'REBOUL','GISELE','1967-02-19','02.87.17.18.08','06.86.75.52.82',NULL,'19 RUE DU DR LAENNEC','','',NULL,NULL,NULL,NULL,'2670214596001',166.000000000,'1988-10-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7027,'GUESNON','MARTINE','1935-12-04','02.57.24.10.20','06.89.51.59.79',NULL,'2 SQUARE ORDERIC VITAL','','','14930','MALTOT',NULL,NULL,'2351261206001',33.000000000,'1963-08-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7028,'LE BER','JACQUES','1952-01-11','02.62.07.21.83','06.31.92.25.95',NULL,'3 RUE DES BRETONS','','','14120','MONDEVILLE',NULL,NULL,'2520127207001',362.000000000,'1979-05-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7029,'DELAMAIRE','JACQUES','1943-05-30','02.10.94.92.41','06.46.11.54.00',NULL,'7 RUE PAUL GAUGAIN','','','61470','ST GERMAIN D''AUNAY',NULL,NULL,'2430514257001',846.000000000,'1968-07-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7030,'VERDUZIER','JACQUELINE','1937-04-20','02.10.79.71.18','06.89.95.25.22',NULL,'7 place danielle casanova','','','14220','ESSON',NULL,NULL,'2370453208001',1535.000000000,'1959-05-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7031,'AMELINE','EDITH','1940-08-20','02.13.74.97.99',NULL,NULL,'6 rue des charrons','','','14730','GIBERVILLE',NULL,NULL,'2400814301001',39.000000000,'1964-07-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7032,'BONNE','CLAUDINE','1929-12-08','02.63.78.92.92','06.78.96.09.21',NULL,'6 rue des charrons','','','14630','FRENOUVILLE',NULL,NULL,'2291250489001',194.000000000,'1954-06-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7033,'CHENEL','JACQUELINE','1928-03-02','02.15.48.06.86','06.18.41.73.31',NULL,'16 RUE DES LANDES','','','14100','LISIEUX',NULL,NULL,'2280350039001',650.000000000,'1957-08-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7034,'LEDUC','MARYLENE','1931-10-18','02.30.37.75.23','06.65.60.98.93',NULL,'4 RUE DU BLANC','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1311050175001',83.000000000,'1953-03-01','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7035,'SASSIER','JACQUES','1934-01-27','02.50.46.75.81','06.39.32.16.64',NULL,'21 Hameau Calais rd','','','14400','ST VIGOR LE GRAND',NULL,NULL,'1340114434001',324.000000000,'1957-04-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7036,'FOUCHER','MICHEL','1935-10-13','02.11.50.57.48','06.90.11.69.78',NULL,'15 RUE DE LA GUERINIERE','','','14000','CAEN',NULL,NULL,'1351050577001',92.000000000,'1957-05-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7037,'BLANCHAIS','JOSEPH','1966-09-12','02.28.10.31.00','06.45.21.04.68',NULL,'1 RUE DE LA VARENDE','','','14270','MEZIDON CANON',NULL,NULL,'2660914758001',26.000000000,'1992-01-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7038,'PONSARDIN','JEANNINE',NULL,'02.11.25.87.22','06.66.62.65.61',NULL,'19 AVENUE DU 19 JUIN','','','06100','NICE CEDEX',NULL,NULL,'2370936205001',2470.000000000,'2008-11-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7039,'DECLEE','OMER','1933-03-30','02.68.55.99.62','06.59.33.98.88',NULL,'3 RUE DU PERE ROBERT','','','14190','CAUVICOURT',NULL,NULL,'1330314628001',9.000000000,'1963-03-08','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7040,'FIERS','DANIELE','1959-12-02','02.70.41.85.19','06.78.26.33.37',NULL,'27 avenue de la Gare de Legey','','','14220','THURY HARCOURT',NULL,NULL,'1591214344001',734.000000000,'1987-05-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7041,'ALIAMUS','BERNARD','1945-01-02','02.61.38.07.47','06.74.53.78.25',NULL,'14 rue de la Rivire','','','14150','OUISTREHAM',NULL,NULL,'2450150502001',188.000000000,'1975-02-18','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7042,'LEGALLOIS','HERVE','1951-02-10','02.57.84.05.92','06.12.29.19.58',NULL,'47 rue de la liberte','','','14800','ST ARNOULT',NULL,NULL,'1510214072001',814.000000000,'1974-09-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7043,'HERVIEU','daniel','1933-06-19','02.41.21.57.99','06.25.55.52.91',NULL,'117 rue Mal Pas','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'2330614033001',6.000000000,'1963-04-26','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7044,'LANNIER','Martine','1936-12-29','02.93.77.93.42','06.80.50.57.78',NULL,'LA GOULAFRIERE','','','14120','MONDEVILLE',NULL,NULL,'1361276678001',138.000000000,'1959-04-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7045,'SAMSON','LILIANE',NULL,'02.95.62.36.01','06.27.12.25.56',NULL,'MAISON DE RETRAITE DU BEAU SITE','','','14120','MONDEVILLE',NULL,NULL,'2320214712001',5.000000000,'2011-03-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7046,'LEBEL','MARIE THERESE','1940-11-23','02.11.71.29.88','06.35.22.99.51',NULL,'LA POTERIE','','','14320','MAY SUR ORNE',NULL,NULL,'2401114309001',26.000000000,'1970-06-08','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7047,'CATUSCA','ANNICK','1933-06-17','02.76.66.99.86','06.69.61.43.11',NULL,'18 RUE DU VAL','','','14220','MUTRECY',NULL,NULL,'1330614566001',4561.000000000,'1960-04-25','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7048,'DUCHESNE','LAURENT','1939-04-02','02.57.26.92.31','06.27.33.77.08',NULL,'ld douillet','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2390414282001',68.000000000,'1960-08-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7049,'SEBIRE','JEANINE','1967-04-28','02.10.34.76.68','06.66.17.80.39',NULL,'38 rue de la pieere','','','14000','CAEN',NULL,NULL,'1670414537001',840.000000000,'1989-07-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7050,'BANIER','MADELEINE','1946-02-19','02.11.26.76.59','06.54.93.16.63',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'2460214287001',313.000000000,'1974-04-15','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7051,'FABRE','MARINETTE','1941-04-22','02.11.92.73.28','06.87.66.59.28',NULL,'11 RUE PIERRE TREBUTIEN','','','14123','FLEURY SUR ORNE',NULL,NULL,'2410414482001',46.000000000,'1962-12-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7052,'LECLAIR','ANDREE','1939-08-02','02.33.21.23.47','06.61.23.54.06',NULL,'LA GRANDE COUR','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1390814749001',32.000000000,'1969-10-02','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7053,'MARTIN','DANIEL','1932-09-14',NULL,NULL,NULL,'LE MANOIR','','','14000','CAEN',NULL,NULL,'2320963432001',164.000000000,'1954-05-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7054,'GARRIGUES','Cecile',NULL,'02.67.80.81.88','06.37.53.01.81',NULL,'3 rue de la paix','','','14940','TOUFFREVILLE',NULL,NULL,'2390750129001',100.000000000,'2009-08-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7055,'JARRY','DANIEL','1942-01-15','02.14.62.71.95','06.53.58.48.85',NULL,'133 RUE DU MOULIN GUIBERT','','','14270','MEZIDON CANON',NULL,NULL,'1420114686001',352.000000000,'1963-05-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7056,'AUSSANT','GERMAIN','1932-09-10','02.66.35.35.65','06.33.11.24.87',NULL,'18 RUE DES PRES','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2320914067001',632.000000000,'1954-10-24','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7057,'NEMTZOFF','Marcel','1938-07-14','02.33.01.92.85','06.59.88.27.24',NULL,'2 RUE DES MARCHES','','','14220','CURCY SUR ORNE',NULL,NULL,'2380714271001',32.000000000,'1966-03-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7058,'DUDOUIT','JACQUES','1930-01-02','02.33.57.94.44','06.61.69.23.99',NULL,'1 IMPASSE YVAN HENRI','','','14370','BELLENGREVILLE',NULL,NULL,'1300114301001',1.000000000,'1960-09-29','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7059,'MARIE','NICOLE','1961-02-09','02.44.71.61.02','06.84.29.82.76',NULL,'16 rue jeanne d''arc','','','14460','COLOMBELLES',NULL,NULL,'2610214530001',667.000000000,'1983-04-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7060,'FILLATRE','CHRISTIANE','1938-02-12','02.16.02.58.24','06.88.09.16.99',NULL,'7 RUE D''IFS','','','14460','COLOMBELLES',NULL,NULL,'1380214658001',142.000000000,'1961-12-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7061,'RUEL','christian','1982-01-30','02.12.39.60.31','06.70.10.51.57',NULL,'8 RUE DU  PIS AU FOUR','','','14790','VERSON',NULL,NULL,'2820199253001',67.000000000,'2006-02-24','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7062,'LE BRETON','PHILIPPE','1934-12-03','02.85.12.50.39','06.34.69.27.67',NULL,'','','','14000','CAEN',NULL,NULL,'2341250009001',751.000000000,'1957-09-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7063,'MKHITARIAN','Madeleine','1965-10-10','02.76.47.48.65','06.84.18.13.91',NULL,'6 RUE CAMILLE DRAPEAU','','','14120','MONDEVILLE',NULL,NULL,'1651050449001',727.000000000,'1987-12-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7064,'DENIS','MICHEL',NULL,'02.12.50.87.78','06.67.62.70.46',NULL,'RTE DE VIEUX','','','50120','EQUEURDREVILLE HAINNEVILLE',NULL,NULL,'1340114750001',84.000000000,'2013-09-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7065,'NIEL','DANIEL','1930-04-12','02.81.58.53.16','06.11.04.08.71',NULL,'vendeuvres','','','14000','CAEN',NULL,NULL,'2300414026001',381.000000000,'1956-04-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7066,'BROSSAUD','CHRISTIAN','1954-06-12','02.99.48.05.28','06.15.08.48.44',NULL,'12 RUE DONCANVILLE','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1540614424001',28.000000000,'1983-09-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7067,'DESLANDES','HUGUETTE','1928-05-02','02.11.42.61.52','06.64.65.09.95',NULL,'70 RUE DE BAYEUX','','','14123','IFS',NULL,NULL,'1280514159001',16.000000000,'1952-04-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7068,'LECOQ','Irene','1930-02-11','02.11.48.86.73','06.44.10.27.37',NULL,'6 RUE DES COMPAGNONS','','','14700','ST PIERRE CANIVET',NULL,NULL,'1300214654001',25.000000000,'1952-05-30','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7069,'CHEVALARIA','MARC','1965-03-08','02.63.78.16.46','06.65.11.39.30',NULL,'LE BOURG 35','','','14260','JURQUES',NULL,NULL,'1650314007001',19.000000000,'1987-02-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7070,'GRZESKOWIAK','BERNARD','1935-11-26','02.97.51.91.62','06.81.65.42.08',NULL,'2 cite des jardins','','','50110','TOURLAVILLE',NULL,NULL,'2351114430001',342.000000000,'1960-06-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7071,'LIARD','MAURICE','1940-12-06','02.39.48.88.31','06.19.66.71.96',NULL,'18 rue Martainville','','','50470','LA GLACERIE',NULL,NULL,'1401214367001',173.000000000,'1964-10-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7072,'GUILLOT','MIREILLE','1949-04-02','02.30.59.89.83','06.58.85.99.84',NULL,'2-4 rue de l''arbalete','','','14540','SOLIERS',NULL,NULL,'1490461427001',1464.000000000,'1978-11-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7073,'JAMET','ELIANE BERNADETTE','1943-02-11','02.17.13.24.40','06.44.75.63.96',NULL,'','','','50190','PERIERS',NULL,NULL,'1430214372001',256.000000000,'1967-04-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7074,'LEBARBEY','COLETTE','1950-01-29','02.26.00.45.66','06.46.44.81.53',NULL,'8 rue leonard gilles','','','14000','CAEN',NULL,NULL,'1500114456001',51.000000000,'1971-12-31','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7075,'LECONTE','NICOLE','1934-06-26','02.82.27.51.42','06.71.93.48.51',NULL,'8 PLACE DU COMMERCE','','','14320','MAY SUR ORNE',NULL,NULL,'2340614006001',239.000000000,'1963-09-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7076,'DEMORTREUX','GERMAINE','1940-03-01','02.40.29.75.75','06.78.11.00.16',NULL,'7 RUE DES ACACIAS','','','14630','CAGNY',NULL,NULL,'1400314283001',900.000000000,'1964-04-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7077,'BENARD','FRANCOISE','1937-03-29','02.10.94.63.04','06.24.92.98.33',NULL,'1 route de Paris','','','14630','FRENOUVILLE',NULL,NULL,'2370335315001',211.000000000,'1961-09-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7078,'NOEL','MARIE LOUISE','1938-07-24','02.70.92.83.76','06.30.67.67.55',NULL,'36 route de Caen','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1380714389001',90.000000000,'1961-06-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7079,'DESLOGES','HENRI','1945-01-02','02.82.73.02.14','06.56.67.20.52',NULL,'7 RUE DES ROSIERS','','','61200','ARGENTAN',NULL,NULL,'1450149342001',38.000000000,'1969-11-25','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7080,'CHARDIN','Jean Pierre','1937-10-22','02.99.02.39.24','06.27.22.85.25',NULL,'6 impasse des marronnies','','','14000','CAEN',NULL,NULL,'1371014372001',193.000000000,'1961-07-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7081,'RICHARD','MONIQUE',NULL,'02.65.58.74.89',NULL,NULL,'LIEU DIT AUBIGNY','','','14670','BASSENEVILLE',NULL,NULL,'2300614020001',27.000000000,'2011-12-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7082,'GUENIER','JEAN','1936-03-16','02.66.84.87.78','06.17.82.68.57',NULL,'RUE DES ECOLES','','','14000','CAEN',NULL,NULL,'1360314123001',44.000000000,'1966-06-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7083,'FAUTRAD','ISABELLE','1940-01-11','02.67.36.85.36','06.13.31.59.46',NULL,'39 rue de mauvaise ville','','','14220','ST LAURENT DE CONDEL',NULL,NULL,'1400150356001',171.000000000,'1961-09-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7084,'NOEL','JACQUELINE','1936-11-25','02.10.39.61.64','06.29.43.76.73',NULL,'24 RUE EUGENE  VARLIN','','','14000','CAEN',NULL,NULL,'2361114393001',1816.000000000,'1963-09-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7085,'LECERF','ANDRE','1931-05-25','02.13.95.67.68','06.12.98.55.70',NULL,'1801 LE BOIS','','','14000','CAEN',NULL,NULL,'2310514702001',671.000000000,'1960-02-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7086,'NERE','MICHEL','1939-10-22','02.28.34.58.60','06.90.14.75.38',NULL,'2 RUE DE LA MUANCE','','','14000','CAEN',NULL,NULL,'2391080732001',203.000000000,'1966-04-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7087,'MORICE','ROGER','1939-10-04','02.63.50.14.68','06.38.85.69.84',NULL,'9 rue de la charite','','','14000','CAEN',NULL,NULL,'2391080732001',1132.000000000,'1964-04-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7088,'FAUCHEUX','ERIC','1940-07-12','02.11.13.94.15','06.10.48.85.10',NULL,'11 RUE RENE BLANC','','','14310','VILLERS BOCAGE',NULL,NULL,'1400750523001',106.000000000,'1965-12-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7089,'HEUVELINE','ALICE','1930-05-12','02.25.03.67.42','06.35.08.93.66',NULL,'19 ROUTE DE LA GUERINIERE','','','14270','MEZIDON CANON',NULL,NULL,'2300550046001',11.000000000,'1953-03-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7090,'LOQUET','JACQUELINE','1934-08-31','02.27.09.28.92','06.44.39.69.29',NULL,'16 RUE LOUIS PASTEUR','','','14850','HEROUVILLETTE',NULL,NULL,'1340814592001',147.000000000,'1957-09-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7091,'GAUTIER','AGNES','1930-08-15',NULL,NULL,NULL,'25 rue  therese de la varde','','','14210','CHEUX',NULL,NULL,'1300814181001',251.000000000,'1952-11-18','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7092,'GUESNON','JEAN','1940-11-22','02.96.50.79.14','06.53.59.76.79',NULL,'20 rue de demouville','','','14260','ONDEFONTAINE',NULL,NULL,'1401114437001',115.000000000,'1967-12-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7093,'BLIN','JEAN','1933-07-11','02.14.15.86.37','06.18.43.07.27',NULL,'225 avenue francois mitterrand','','','14123','IFS',NULL,NULL,'1330714475001',2.000000000,'1959-03-12','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7094,'LE BIGOT','ANNICK','1933-02-15','02.63.50.15.61','06.65.21.02.89',NULL,'8 RUE AUX DIMES','','','14120','MONDEVILLE',NULL,NULL,'1330250211001',11.000000000,'1961-07-08','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7095,'HERGAULT','Lucien','1935-08-25','02.35.31.71.23','06.29.97.69.50',NULL,'29 RUE DES CANADIENS','','','61200','ARGENTAN',NULL,NULL,'2350861150001',375.000000000,'1957-12-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7096,'LEVEZIEL','NELLY','1944-01-28','02.12.21.58.71','06.11.29.64.21',NULL,'99 RUE DE LA DELIVRANDE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1440114309001',19.000000000,'1967-04-30','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7097,'POUCLEE','ANDREE SUZANNE','1930-01-16','02.40.97.64.89','06.58.63.96.60',NULL,'11 CHEMIN DE L''AVONDE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1300161222001',11.000000000,'1953-02-23','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7098,'BENARD','hubert','1964-05-18','02.15.00.22.45','06.31.94.48.72',NULL,'2 RUE ALEXANDRE LELANNIER','','','14620','MORTEAUX COULIBOEUF',NULL,NULL,'1640514193001',1322.000000000,'1988-01-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7099,'BRUNET','BERNARD','1930-02-21','02.25.92.21.85','06.43.22.91.78',NULL,'7 place des bleuets','','','14123','IFS',NULL,NULL,'2300261313001',42.000000000,'1952-11-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7100,'FAULIN','CLAUDE','1962-01-12','02.10.10.56.93','06.87.51.93.56',NULL,'19 CITE DU CALVAIRE','','','14270','OUEZY',NULL,NULL,'2620114030001',334.000000000,'1985-01-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7101,'BOULIN','MARYLINE','1951-02-14','02.47.00.38.25','06.53.13.45.29',NULL,'52 RUE  HAUTTEVILLE','','','14320','MAY SUR ORNE',NULL,NULL,'2510214001001',120.000000000,'1972-09-08','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7102,'GUIHENEUC','ROLAND','1932-03-09','02.10.92.87.85','06.89.30.88.73',NULL,'11 RUE DES CAPUCINES','','','14740','LASSON',NULL,NULL,'1320314310001',63.000000000,'1954-11-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7103,'THIBAULT','GEORGES','1936-05-25','02.11.22.00.71','06.56.52.91.43',NULL,'RUE DU CINGAL','','','14370','BELLENGREVILLE',NULL,NULL,'1360514323001',27.000000000,'1964-11-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7104,'MATHIEU','CHRISTIAN','1931-06-25','02.62.66.92.03','06.51.96.87.18',NULL,'76 RUE DE LA SEINE','','','14190','SOIGNOLLES',NULL,NULL,'2310614469001',6.000000000,'1960-10-10','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7105,'MOREL','CLAUDE','1931-10-30','02.78.22.30.30','06.99.73.75.41',NULL,'25D RUE  DE L EGLANTINE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2311076456001',1537.000000000,'1954-12-24','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7106,'BAURUELLE','VERONIQUE','1940-12-08','02.79.73.33.95','06.66.53.69.22',NULL,'','','','14210','EVRECY',NULL,NULL,'1401214603001',2784.000000000,'1962-02-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7107,'CHAPRON','ISABELLE','1938-09-18','02.61.12.05.51','06.42.35.11.65',NULL,'55 rue armand marie','','','14120','MONDEVILLE',NULL,NULL,'2380914407001',3347.000000000,'1965-01-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7108,'GUEROULT','SYLVAIN','1932-04-06','02.78.87.51.93','06.77.36.40.80',NULL,'28 RUE FONTAINE GAUTIER','','','14480','BANVILLE',NULL,NULL,'2320461354001',14.000000000,'1954-10-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7109,'BEVOLO','GILBERT','1949-02-16','02.51.55.72.37','06.47.14.79.25',NULL,'1 RUE DES CAPUCINES','','','14160','DIVES SUR MER',NULL,NULL,'1490261123001',23.000000000,'1979-12-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7110,'MOULINET','THERESE','1962-09-06','02.39.15.58.26','06.84.36.06.90',NULL,'20 RUE PRINCIPALE','','','14000','CAEN',NULL,NULL,'1620950453001',41.000000000,'1984-09-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7111,'','GILBERT','1938-01-03','02.11.16.85.14','06.45.96.42.53',NULL,'5 RUE ARMAND BENCE','','','14000','CAEN',NULL,NULL,'2380114132001',181.000000000,'1964-12-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7112,'PIVENT','JACQUELINE','1931-12-07','02.28.63.88.83','06.40.03.86.52',NULL,'10002 quartier du bois','','','14210','EVRECY',NULL,NULL,'2311214623001',548.000000000,'1953-04-21','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7113,'','J PIERRE','1959-03-05','02.37.24.68.42','06.55.18.94.82',NULL,'rue du poirier','','','14860','RANVILLE',NULL,NULL,'1590388524001',132.000000000,'1989-12-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7114,'LESACHEY','FRANCOISE','1951-01-30','02.44.41.98.94','06.92.98.27.62',NULL,'29 place des rosiers','','','14123','FLEURY SUR ORNE',NULL,NULL,'2510114278001',36.000000000,'1972-01-25','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7115,'DUPREY','JEAN','1964-03-19','02.61.55.46.42','06.10.12.94.81',NULL,'LIEU DIT"LA POIDEVINIERE"','','','14420','POTIGNY',NULL,NULL,'2640314134001',171.000000000,'1989-04-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7116,'BOULLEAUX','CECILE','1955-01-02','02.39.87.74.64',NULL,NULL,'22 RUE D''ARMOR','','','14540','BOURGUEBUS',NULL,NULL,'2550114431001',170.000000000,'1976-07-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7117,'BOULLEAUX','ISABELLE','1936-10-15','02.12.11.75.50','06.18.85.62.96',NULL,'10 AVENUE PERE CHARLES DE FOUCAU','LT','','14400','BAYEUX',NULL,NULL,'1361014090001',46.000000000,'1958-06-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7118,'MANCHION','JEAN-LUC','1943-03-15','02.36.25.27.38','06.25.72.58.96',NULL,'24 rue des marches','','','14370','CANTELOUP',NULL,NULL,'2430314205001',28.000000000,'1969-08-10','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7119,'AUBERT','DIDIER','1939-11-05','02.73.02.72.45','06.10.43.42.18',NULL,'','','','14000','CAEN',NULL,NULL,'1391127462001',97.000000000,'1962-12-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7120,'JOUAN','CORINNE','1948-02-17','02.60.55.07.93','06.50.99.40.09',NULL,'15RUE HAUT DU PAVE','','','14270','MEZIDON CANON',NULL,NULL,'2480250347001',356.000000000,'1972-01-07','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7121,'POUSSIN','NADINE','1953-01-06','02.83.16.45.20','06.67.84.54.10',NULL,'la haute deverre','','','50310','LESTRE',NULL,NULL,'1530128018001',26.000000000,'1975-04-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7122,'BOURDON','JOSEPH','1928-03-27','02.91.36.79.41','06.98.01.83.95',NULL,'14 rue du caprice','','','14000','CAEN',NULL,NULL,'2280350318001',119.000000000,'1955-06-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7123,'CHOCTEAU','DANIELLE','1937-01-18','02.86.70.80.36','06.22.41.07.73',NULL,'21 rue des mimosas','','','14540','BOURGUEBUS',NULL,NULL,'1370114005001',1050.000000000,'1963-06-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7124,'BEAUFILS','JACQUES','1935-02-08','02.33.48.91.88','06.60.01.23.27',NULL,'9 rue pasteur','','','14000','CAEN',NULL,NULL,'1350272154001',986.000000000,'1961-07-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7125,'CHEVILLARD','JACQUES','1929-03-12','02.54.40.64.39','06.12.20.84.17',NULL,'19 RUE DE LA MADELEINE','','','14000','CAEN',NULL,NULL,'1290350608001',2378.000000000,'1952-05-19','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7126,'DUDZAK','jean louis','1965-08-04','02.15.23.83.20','06.61.69.06.42',NULL,'11 rue du val richet','','','14840','CUVERVILLE',NULL,NULL,'2650814305001',357.000000000,'1989-07-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7127,'HUARD','ODETTE','1937-12-26','02.55.40.46.88','06.64.27.08.69',NULL,'2 RUE DES TILLEULS','','','14120','MONDEVILLE',NULL,NULL,'2371261101001',10.000000000,'1959-05-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7128,'GAUTIER','ALAIN','1934-03-10','02.74.83.43.03',NULL,NULL,'LE BOURG','','','14210','STE HONORINE DU FAY',NULL,NULL,'2340372124001',524.000000000,'1961-08-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7129,'DRAGAN','JOCELYNE','1939-06-03','02.45.76.14.48','06.58.59.68.19',NULL,'10 ROUTE DE PARIS','','','14000','CAEN',NULL,NULL,'1390614225001',29.000000000,'1962-03-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7130,'LELIEVRE','YVES','1939-10-30','02.13.61.13.19','06.12.36.39.96',NULL,'12 cite des castors','','','14730','GIBERVILLE',NULL,NULL,'2391014137001',2013.000000000,'1969-10-22','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7131,'SERRE','JACQUES','1958-10-21','02.19.58.60.59','06.15.53.70.91',NULL,'lieu dit le repos','','','14000','CAEN',NULL,NULL,'1581035238001',19.000000000,'1980-02-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7132,'DARSY','Bernard','1961-03-27','02.65.44.93.98','06.52.13.69.61',NULL,'2 AVENUE DES COURLIS','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1610314499001',12.000000000,'1988-07-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7133,'GRANDPERRET','CLAUDE','1961-11-07','02.41.03.67.92','06.42.38.25.67',NULL,'16 RUE DU ROI ARTHUS','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2611114206001',766.000000000,'1983-01-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7134,'YGOUF','ALICE','1960-01-01','02.90.47.33.40','06.98.63.84.39',NULL,'3 RUE DES PRIMEVERES','','','50260','BRICQUEBEC',NULL,NULL,'1600114373001',5327.000000000,'1986-02-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7135,'QUELLARD','MICHEL','1936-07-14','02.11.88.74.59',NULL,NULL,'10 RUE HELENE KELLER','','','14860','BAVENT',NULL,NULL,'1360750024001',288.000000000,'1961-01-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7136,'BUNEL','DOMINIQUE','1928-09-03','02.49.19.00.46','06.74.54.28.53',NULL,'24 RUE ALEXANDRE','','','14160','DIVES SUR MER',NULL,NULL,'1280914672001',51.000000000,'1949-08-12','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7137,'LEROUX','Madeleine','1938-04-07','02.59.71.55.34','06.32.65.61.70',NULL,'6 RUE CARDINAL LAVIGERIE','','','14260','AUNAY SUR ODON',NULL,NULL,'2380414675001',848.000000000,'1962-02-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7138,'','Janine','1934-03-27','02.72.59.73.57','06.15.12.07.55',NULL,'3 ALLEE DU DOUET','','','14680','GOUVIX',NULL,NULL,'2340350550001',99.000000000,'1959-08-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7139,'CATHERINE','Louis','1929-01-28','02.24.27.38.83','06.95.19.61.76',NULL,'LES ORMES','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2290114375001',228.000000000,'1950-12-31','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7140,'LE BRUN','GUY','1936-06-30','02.41.56.40.88','06.15.69.28.23',NULL,'FERME ST SYMPHORIEN','','','14000','CAEN',NULL,NULL,'1360614302001',243.000000000,'1959-07-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7141,'BOURGAULT','JEAN PIERRE','1940-02-26','02.11.21.29.06','06.67.73.17.81',NULL,'6 bis rue depressence','','','14460','COLOMBELLES',NULL,NULL,'2400214585001',27.000000000,'1962-07-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7142,'LE MOULEC','MICHEL','1931-06-02','02.53.31.07.32','06.98.36.61.78',NULL,'15 ROUTE DES SOURCES','','','14000','CAEN',NULL,NULL,'1310614753001',100.000000000,'1961-12-09','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7143,'BODIN','FRANCIS','1961-10-09','02.10.68.43.38','06.30.71.95.24',NULL,'59 RUE DES CYTISSES','','','14730','GIBERVILLE',NULL,NULL,'1611053081001',173.000000000,'1991-08-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7144,'GROSLIER','ANNETTE','1928-02-10','02.16.21.88.46','06.39.75.93.25',NULL,'2 IMPASSE DES BREOLES','','','14400','NONANT',NULL,NULL,'2280214301001',2218.000000000,'1952-08-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7145,'CAZALE','ANDRE','1931-04-01','02.44.92.29.36','06.37.25.23.35',NULL,'1410 QUARTIER GRANDE DELLE','','','14750','ST AUBIN SUR MER',NULL,NULL,'2310414556001',261.000000000,'1956-05-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7146,'MARTY','THERESE','1929-10-15','02.66.07.62.18','06.61.82.07.33',NULL,'4 impasse des marguerites','','','61600','LA FERTE MACE',NULL,NULL,'1291014245001',130.000000000,'1956-02-06','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7147,'MEZERETTE','JEAN','1933-05-07','02.84.97.64.69','06.12.08.30.99',NULL,'12 rue des pavillons','','','14840','DEMOUVILLE',NULL,NULL,'1330527630001',763.000000000,'1955-09-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7148,'HALOT','JEANNINE','1955-01-10','02.27.31.39.98','00 33 6.49.08.71.22',NULL,'45 BIS RUE ST LOUP','','','14000','CAEN',NULL,NULL,'1550114119001',47.000000000,'1978-11-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7149,'THEUNYNCK','IDA','1928-09-23','02.42.12.68.97','06.80.05.94.98',NULL,'30 LE PLAIN','','','50100','CHERBOURG',NULL,NULL,'2280950279001',170.000000000,'1955-07-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7150,'EDOUARD','SYLVIE','1958-10-13','02.12.32.58.94','06.56.63.30.95',NULL,'2 cite des clos','','','14540','GRENTHEVILLE',NULL,NULL,'1581061442001',396.000000000,'1986-03-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7151,'BLANCHARD','ROGER','1943-09-11','02.63.30.21.05','06.37.83.96.61',NULL,'LE BOURG','','','14630','FRENOUVILLE',NULL,NULL,'1430966008001',2.000000000,'1972-10-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7152,'DIVARET','JEAN LOUIS','1954-04-09','02.95.49.32.51','06.11.07.79.00',NULL,'48 rue victor lepine','','','14370','BELLENGREVILLE',NULL,NULL,'1540414400001',70.000000000,'1984-02-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7153,'NOVO','JACQUELINE','1935-05-10','02.54.50.25.95','06.40.38.63.83',NULL,'2 RUE LEONARD GILLES','','','14310','VILLERS BOCAGE',NULL,NULL,'1350514345001',1374.000000000,'1959-05-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7154,'NOVO','LEON','1957-02-22','02.65.28.08.51','06.39.80.01.20',NULL,'2 RUE ANDRE GIDE','','','14770','CAUVILLE',NULL,NULL,'2570250507001',51.000000000,'1984-03-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7155,'BOURDON','JEAN PIERRE','1928-07-03','02.11.37.09.42','06.35.43.85.16',NULL,'27 rue de la rennaissance','','','14000','CAEN',NULL,NULL,'1280750202001',134.000000000,'1957-02-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7156,'BOURDON','ALBERTE','1935-02-24','02.12.30.94.45','06.51.56.13.70',NULL,'13 rue de la grace de dieu','','','14490','TRUNGY',NULL,NULL,'1350214516001',21.000000000,'1964-05-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7157,'JEANNE','MONIQUE','1931-11-08','02.92.39.87.68','06.98.06.25.29',NULL,'19 rue de valeuil','','','14490','VAUBADON',NULL,NULL,'1311114174001',871.000000000,'1958-07-19','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7158,'DESBRUERES','GILBERT','1938-04-20','02.90.52.99.54','06.53.82.00.15',NULL,'LA PROVOTIERE','','','14220','THURY HARCOURT',NULL,NULL,'1380414221001',162.000000000,'1961-03-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7159,'BAZIN','PATRICIA','1961-01-16','02.54.39.01.65','06.37.32.70.58',NULL,'31 route de croissanville','','','14520','PORT EN BESSIN HUPPAIN',NULL,NULL,'2610114221001',11.000000000,'1990-12-08','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7160,'CLAVREUL','CATHERINE','1934-09-21','02.53.02.71.03','06.11.17.99.42',NULL,'31 route de croissanville','','','14400','ST MARTIN DES ENTREES',NULL,NULL,'2340916199001',396.000000000,'1957-02-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7161,'CHIEU','HENRI','1930-12-10','02.29.71.28.70','06.43.10.27.93',NULL,'1 place de la liberte','','','14270','PERCY EN AUGE',NULL,NULL,'2301214607001',899.000000000,'1958-05-06','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7162,'LORIN','RENE','1955-08-04','02.88.13.55.70','06.43.90.24.51',NULL,'42 rue du marais','','','14510','GONNEVILLE SUR MER',NULL,NULL,'2550814712001',64.000000000,'1976-10-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7163,'MORAUX','EDOUARD','1936-05-06','02.14.80.86.06','06.99.65.46.24',NULL,'3 RUE DU COTENTIN','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'2360514711001',3673.000000000,'1959-06-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7164,'NEEL','JEAN PIERRE','1932-08-29','02.28.30.29.45','06.91.83.09.10',NULL,'','','','14670','TROARN',NULL,NULL,'1320814288001',57.000000000,'1954-08-25','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7165,'LEPEIGNE','JACQUELINE','1932-11-03','02.24.26.45.07','06.30.91.48.63',NULL,'5 rue du 11 novembre','','','14510','HOULGATE',NULL,NULL,'1321114341001',211.000000000,'1956-03-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7166,'RAVENEL','JEANINE','1928-09-30','02.63.68.83.52','06.69.06.40.92',NULL,'3 rue camille drapeau','','',NULL,NULL,NULL,NULL,'1280914372001',7.000000000,'1950-01-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7167,'JEANNE','STEPHANE','1933-12-19','02.88.04.23.86','06.14.23.47.35',NULL,'11 ROUTE DE CORMELLES','','','14920','MATHIEU',NULL,NULL,'2331214191001',4.000000000,'1957-08-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7168,'FERAY','PIERRE','1955-02-16','02.80.29.25.78','06.86.06.70.25',NULL,'ROUTE DE VILLERS','','','14220','ST LAURENT DE CONDEL',NULL,NULL,'1550214254001',338.000000000,'1982-03-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7169,'LUSSEAU','ROBERT','1931-07-10','02.96.29.33.17','06.90.20.55.54',NULL,'3 rue de la plaine','','',NULL,NULL,NULL,NULL,'1310750307001',1.000000000,'1957-08-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7170,'LUSSEAU','MICHEL',NULL,'02.51.54.67.93','06.46.45.39.96',NULL,'16 RUE JULES VERNES','','','14520','STE HONORINE DES PERTES',NULL,NULL,'2380814243001',239.000000000,'2013-07-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7171,'DUBOIS','MARIE THERESE','1962-03-06','02.10.43.01.31','06.50.45.51.74',NULL,'10 rue du Bourg','','','14430','DOZULE',NULL,NULL,'2620314305001',2.000000000,'1983-01-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7172,'LEROUX','Guy','1939-06-03','02.33.46.49.42','06.63.76.51.95',NULL,'CINGAL','','','14670','TROARN',NULL,NULL,'1390614396001',779.000000000,'1965-07-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7173,'GANCEL','DOMINIQUE','1941-04-30','02.72.20.30.92','06.56.89.66.43',NULL,'25 rue henri cheron','','','14730','GIBERVILLE',NULL,NULL,'1410451221001',153.000000000,'1971-12-12','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7174,'JEANNE','PHILIPPE','1960-05-06','02.25.09.99.93','06.69.82.84.38',NULL,'27 rue montegu 2 etage','','',NULL,NULL,NULL,NULL,'1600514118001',660.000000000,'1983-11-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7175,'JEANNE','RAYMOND','1929-09-25','02.11.00.35.86','06.21.90.25.91',NULL,'le bourg','','','14190','BRETTEVILLE LE RABET',NULL,NULL,'2290950005001',227.000000000,'1952-02-08','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7176,'LEMONNIER','Micheline','1940-05-31','02.12.16.99.78','06.98.86.02.10',NULL,'19 BOULEVARD DE L''ESPERANCE','','','61430','MENIL HUBERT SUR ORNE',NULL,NULL,'1400514119001',3874.000000000,'1965-05-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7177,'PARIS','MICHEL','1938-05-25','02.67.82.42.39','06.95.19.08.87',NULL,'le pont friquet','','','50640','ST SYMPHORIEN DES MONTS',NULL,NULL,'1380514397001',20.000000000,'1962-11-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7178,'VAUTIER','JEAN-LUC','1963-02-26','02.14.79.86.47','06.67.39.48.17',NULL,'LE PETIT PONT','','','14220','PLACY',NULL,NULL,'2630214432001',84.000000000,'1988-12-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7179,'LESEIGNEUR','ISABELLE','1937-08-24','02.59.77.00.57','06.11.08.42.21',NULL,'11 RUE SAVIGNE L''EVEQUE','','','14000','CAEN',NULL,NULL,'1370814090001',211.000000000,'1958-02-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7180,'LEBRETON','','1935-03-30','03.13.79.83.81','06.20.68.83.66',NULL,'605 BD DES BELLES PORTES','','','51290','ST REMY EN BOUZEMONT ST GENES',NULL,NULL,'2350369243001',52.000000000,'1959-06-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7181,'PIERRE','VIVIANE','1930-11-12','02.90.51.53.23','06.47.00.08.17',NULL,'18 ALLEE DES POETES','','','14123','IFS',NULL,NULL,'2301114383001',16.000000000,'1955-09-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7182,'SALLARD','GEORGES','1931-10-19','02.12.27.27.65','06.20.85.14.58',NULL,'VILLAGE MONDANT','','','14000','CAEN',NULL,NULL,'1311014517001',1517.000000000,'1955-10-10','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7183,'LEGRAND','MARCEL','1930-04-01','02.90.51.37.39','06.60.52.33.29',NULL,'LE BOURG','','','14840','CUVERVILLE',NULL,NULL,'1300414271001',254.000000000,'1955-12-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7184,'MATHELIER','ODETTE','1932-09-05','02.81.98.99.76','06.37.66.34.15',NULL,'13 RUE DES PIERROTS','','','14370','BELLENGREVILLE',NULL,NULL,'2320914296001',100.000000000,'1960-08-20','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7185,'LECORNU','CHRISTINE','1966-09-24','02.63.10.33.83','06.20.58.13.94',NULL,'13 allees des fusilles mont roya','l','','14500','VAUDRY',NULL,NULL,'1660914074001',400.000000000,'1991-02-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7186,'LALLIER','PIERRE','1933-04-09','02.67.84.72.65','06.51.10.75.86',NULL,'villers','','','14170','BRETTEVILLE SUR DIVES',NULL,NULL,'1330414691001',92.000000000,'1956-09-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7187,'HERMEREL','GUY','1934-05-17','02.31.45.46.48','06.80.74.98.83',NULL,'18 AVENUE DE LA ROCHE BIARD','','','61200','ARGENTAN',NULL,NULL,'2340572258001',39.000000000,'1964-12-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7188,'LETHAN','BRUNO','1933-11-10','02.10.80.73.19','06.76.19.27.46',NULL,'9 RUE JEAN MERMOZ','','','14000','CAEN',NULL,NULL,'2331150117001',210.000000000,'1962-08-22','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7189,'LEJEUNE','ELISABETH','1932-11-02','02.39.11.09.69','06.28.26.95.66',NULL,'56 rue Louis Robillard','','','14460','COLOMBELLES',NULL,NULL,'1321172182001',146.000000000,'1962-03-14','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7190,'ANNE','BERNARD','1937-03-18','02.53.65.90.81','06.53.82.94.65',NULL,'LA CANTEPIE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1370314327001',217.000000000,'1959-05-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7191,'MARGUERITE','DIEGO','1949-02-27','02.10.71.94.92','06.95.55.86.40',NULL,'3 rue jean lehire','','','14000','CAEN',NULL,NULL,'1490272037001',1285.000000000,'1973-10-16','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7192,'BEAURUELLE','GEORGETTE','1967-05-27','02.49.42.20.81','06.77.63.95.47',NULL,'RUE DU TOURTOUT','','','14120','MONDEVILLE',NULL,NULL,'2670514383001',1640.000000000,'1991-01-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7193,'GHILIANI','ANNIE','1957-10-07','02.58.15.15.58','06.27.79.60.27',NULL,'17 RUE DE LA CAVEE','','','14460','COLOMBELLES',NULL,NULL,'2571050380001',21.000000000,'1983-08-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7194,'GRENOUILLEAU','REMI','1954-01-08','02.75.37.72.09','06.88.08.14.55',NULL,'LA PERELLE','','','14840','DEMOUVILLE',NULL,NULL,'1540114294001',597.000000000,'1981-04-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7195,'MAILLARD','RAYMOND','1934-06-29','02.60.57.95.45','06.23.65.32.77',NULL,'41 RUE PASTEUR','','','14000','CAEN',NULL,NULL,'2340614145001',308.000000000,'1958-06-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7196,'JOUSSET','RENE','1964-08-08','02.10.53.35.55','06.10.98.66.84',NULL,'LE MESNIL D''ARGENCES','','','14000','CAEN',NULL,NULL,'1640814542001',330.000000000,'1989-02-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7197,'LUCE','REVAZ','1930-11-04','02.91.04.35.38','06.84.31.65.94',NULL,'56 RUE ST PATRICE','','','14730','GIBERVILLE',NULL,NULL,'1301161292001',159.000000000,'1955-06-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7198,'DELYSLE','BERNARD','1940-06-22','02.20.64.26.69','06.49.92.71.47',NULL,'22 RUE DES EPERVIERS','','','14000','CAEN',NULL,NULL,'1400650129001',93.000000000,'1967-12-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7199,'LELANDAIS','GERARD','1933-09-01','02.60.58.73.39','06.16.41.41.00',NULL,'51 clos poteau rouge','','','14120','MONDEVILLE',NULL,NULL,'1330972030001',2370.000000000,'1955-10-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7200,'TRITT','YVES','1934-10-30','02.10.69.56.37','06.11.62.97.85',NULL,'2 rue louis savard','','','14700','FALAISE',NULL,NULL,'2341014508001',297.000000000,'1964-08-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7201,'BIDAULT','MAURICE','1930-08-29','02.30.64.24.18','06.72.83.70.19',NULL,'3 RUE GEORGES DUMESNIL','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1300814424001',869.000000000,'1953-05-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7202,'TCHACHIBAIA','JEAN PAUL','1935-07-23','02.90.85.59.24','06.81.22.41.78',NULL,'18 RUE PIERRE BEREGOVOY','','','50250','ST SYMPHORIEN LE VALOIS',NULL,NULL,'1350714744001',20.000000000,'1963-02-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7203,'JEANNE','JEAN','1930-09-16','02.68.30.03.37','06.27.38.62.75',NULL,'10 rue des sources','','','14120','MONDEVILLE',NULL,NULL,'2300914574001',410.000000000,'1958-03-28','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7204,'MARIE','PATRICIA','1948-02-20','02.57.00.41.09','06.30.18.92.49',NULL,'10 rue des champs st martin','','','14120','MONDEVILLE',NULL,NULL,'1480214667001',50.000000000,'1972-05-14','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7205,'MANGNAN','PATRICK','1932-11-09','02.48.55.03.83','06.10.07.34.52',NULL,'6 RUE DES PRIMEVERES','','','14120','MONDEVILLE',NULL,NULL,'2321114347001',175.000000000,'1960-11-22','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7206,'DEMEAUTIS','RENE','1928-08-31','02.57.05.01.65','06.12.31.62.73',NULL,'115 rue des accacias','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'1280814234001',172.000000000,'1952-09-22','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7207,'LECOIS','ANDRE',NULL,'02.39.08.65.31','06.25.36.89.25',NULL,'21 rue des tilleuls','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1391014162001',38.000000000,'2011-04-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7208,'CHAPRON','','1942-12-08','02.10.81.78.29','06.24.50.89.48',NULL,'route de fleury','','','14000','CAEN',NULL,NULL,'1421297202001',1079.000000000,'1972-09-07','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7209,'DEVAUX','marcel','1929-11-07',NULL,NULL,NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'1291161102001',58.000000000,'1952-12-14','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7210,'VANDENBERGHE','JACQUES','1961-01-25','02.35.44.32.68','06.56.21.04.12',NULL,'10 PLACE MARCEL CACHIN','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2610150547001',35.000000000,'1985-08-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7211,'QUATREBOEUFS','RENEE','1954-06-03','02.64.04.28.14','06.44.72.30.33',NULL,'6 RUE DES EGLANTIERS','','','14000','CAEN',NULL,NULL,'2540621208001',35.000000000,'1975-10-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7212,'LE ROUX','RAYMOND','1938-08-24','02.11.24.72.88','06.89.34.29.28',NULL,'53 RUE DE LA MARJOLAINE','','','14610','CAMBES EN PLAINE',NULL,NULL,'2380814278001',178.000000000,'1960-05-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7213,'ROULLAND','MARCEL','1965-02-02','02.79.74.58.20',NULL,NULL,'LA ROQUERIE','','','61160','TRUN',NULL,NULL,'1650214163001',39.000000000,'1988-02-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7214,'VORNIERES','RENE','1945-02-14','02.11.26.76.36','06.19.05.00.41',NULL,'8 rue de stokolm','','','14000','CAEN',NULL,NULL,'1450250402001',40.000000000,'1973-06-02','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7215,'TOUBALEM','RAYMONDE','1932-03-22','02.31.05.04.77','06.68.97.46.56',NULL,'3 rue jacques gueroult','','','14460','COLOMBELLES',NULL,NULL,'1320314407001',442.000000000,'1954-07-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7216,'LEMOINE','MICHELE','1966-12-03','02.19.49.73.08','06.48.69.64.26',NULL,'42 av georges guinemer','','','50270','SURTAINVILLE',NULL,NULL,'2661214294001',287.000000000,'1990-03-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7217,'BODIN','CHRISTIAN','1943-01-14','02.59.91.74.88',NULL,NULL,'4 RUE DES MINES','','','14000','CAEN',NULL,NULL,'1430114221001',731.000000000,'1970-11-24','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7218,'BRUNET','FLORENCE','1938-09-02','02.80.10.52.41','06.23.89.91.33',NULL,'3 IMPASSE FRANCOIS CASSARD','','','14190','ESTREES LA CAMPAGNE',NULL,NULL,'1380927217001',193.000000000,'1965-06-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7219,'LEMARS','','1959-02-25','02.52.44.57.68','06.74.65.46.55',NULL,'327 LES BELLES PORTES','','','14000','CAEN',NULL,NULL,'1590214438001',26.000000000,'1989-11-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7220,'ANGEL DIT HUGO','DENISE','1938-02-25','02.47.63.27.50','06.49.25.73.93',NULL,'3 RUE GANDHI','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1380250221001',2536.000000000,'1968-07-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7221,'ESTEVAN','GERARD','1966-04-28','02.37.29.06.72','06.30.99.69.55',NULL,'907 QUARTIER DU BOIS','','',NULL,NULL,NULL,NULL,'2660414752001',2012.000000000,'1990-07-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7222,'PERIER','BERNARD','1979-05-30','02.75.60.22.43','06.81.37.11.25',NULL,'CHEZ SIMON Brocardo 38 RUE GEOR','GES BRASSENS','','14000','CAEN',NULL,NULL,'2790529105001',2261.000000000,'2007-12-12','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7223,'PIEL','JOSETTE','1966-01-01','02.29.03.36.17','06.22.09.55.39',NULL,'39 RUE DES DRAKKARS','','','14670','TROARN',NULL,NULL,'1660114246001',5.000000000,'1996-12-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7224,'TURGIS','NATHALIE','1941-01-22','02.82.63.56.87','06.33.96.78.13',NULL,'LIEU DIT"LE HAUT LAURENT"','','','14370','MERY CORBON',NULL,NULL,'1410150252001',458.000000000,'1970-01-02','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7225,'LUCAS','CLAUDE','1929-12-07','02.64.33.37.92','06.63.30.15.23',NULL,'10 rue du clos carre','','','14220','MUTRECY',NULL,NULL,'2291214692001',687.000000000,'1959-07-04','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7226,'','ALAIN','1937-05-26','02.12.92.45.22','06.11.53.44.83',NULL,'64 RUE YVES BERNARD','','','14000','CAEN',NULL,NULL,'1370514090001',51.000000000,'1965-12-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7227,'JEANNE','JEANNINE','1954-04-27','02.58.71.10.58','06.55.87.15.80',NULL,'7 rue notre dame des champs','','','14000','CAEN',NULL,NULL,'1540414175001',893.000000000,'1979-07-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7228,'STEMPINSKI','JEANNINE','1959-02-22','02.40.80.14.92','06.52.17.27.35',NULL,'le bouillon ravenel','','','14330','LE MOLAY LITTRY',NULL,NULL,'2590214538001',376.000000000,'1982-02-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7229,'JEAN','HUGUETTE','1930-04-29','02.10.04.26.89','06.55.25.87.73',NULL,'TOURNAI SUR DIVES  LIEU DIT MIGU','ILLAUME','','14850','ESCOVILLE',NULL,NULL,'2300414068001',3.000000000,'1958-10-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7230,'PRIGENT','SOLANGE','1936-08-25','02.11.14.37.74',NULL,NULL,'50 RUE DE CUSSY','','','14220','ST LAURENT DE CONDEL',NULL,NULL,'1360861407001',158.000000000,'1962-03-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7231,'BOULE','MARIE LOUISE','1939-09-13','02.43.78.27.77','06.11.38.78.26',NULL,'19 ROUTE D''ISIGNY','','','14000','CAEN',NULL,NULL,'2390985292001',676.000000000,'1967-02-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7232,'PERES','Bruno','1947-01-25','02.44.57.23.17','06.10.36.58.48',NULL,'8 impasse des victimes civiles','','','61500','CHAILLOUE',NULL,NULL,'1470127335001',21.000000000,'1974-11-18','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7233,'METAIS','MONIQUE EUGENIE','1936-01-24','02.27.45.34.24','06.34.53.38.13',NULL,'','','','14190','FIERVILLE BRAY',NULL,NULL,'2360150568001',0.000000000,'1958-10-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7234,'ASTIC','GENEVIEVE','1934-06-14','02.72.95.47.66','06.45.92.23.49',NULL,'14 rue brillere','','','14000','CAEN',NULL,NULL,'1340661303001',95.000000000,'1958-10-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7235,'ROUILLE','MARCEL',NULL,'02.12.09.76.12','06.20.25.71.93',NULL,'50 RUE DES NOYERS','','','14480','CREPON',NULL,NULL,'1320470123001',224.000000000,'2007-12-28','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7236,'LEMARCHAND','HENRI','1933-12-03','02.37.67.67.13','06.30.75.98.27',NULL,'6 RUE DU VALET','','','14270','CESNY AUX VIGNES OUEZY',NULL,NULL,'1331214751001',14.000000000,'1957-09-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7237,'HEBERT','MARIE THERESE','1940-01-05','02.64.89.12.52','06.97.73.16.96',NULL,'5 RUE DU CLOS DUHAMEL','','','14540','GRENTHEVILLE',NULL,NULL,'1400114266001',17.000000000,'1970-11-26','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7238,'BERCHIO','SIMONE','1963-01-13','02.81.32.23.40','06.17.16.36.13',NULL,'916 RUE DU CHEMIN VERT','','','14540','SOLIERS',NULL,NULL,'1630114643001',214.000000000,'1984-03-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7239,'NIARD','DENISE','1938-02-11','02.33.68.54.78','06.26.32.82.76',NULL,'127 RUE RAYMOND POINCARE','','','14840','CUVERVILLE',NULL,NULL,'1380214083001',7.000000000,'1960-01-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7240,'GEUFFRARD','BERNADETTE','1938-10-01','02.16.67.48.66','06.86.55.88.72',NULL,'10 rue du marechal juin','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'1381014690001',388.000000000,'1962-11-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7241,'SCELLES','ROGER','1932-11-14','02.69.77.39.68','06.11.83.81.01',NULL,'72 rue martre','','','14730','GIBERVILLE',NULL,NULL,'1321161267001',537.000000000,'1953-01-19','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7242,'BENARD','Bernadette','1929-04-20','02.55.53.41.32','06.45.77.06.75',NULL,'28 avenue de normandie','','','14400','MAISONS',NULL,NULL,'1290414586001',98.000000000,'1951-04-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7243,'COURTOISE','FRANCISKA','1933-09-09','02.62.00.04.76','06.61.16.70.61',NULL,'5 rue de madeleine','','','14270','BIEVILLE QUETIEVILLE',NULL,NULL,'1330961307001',15.000000000,'1955-12-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7244,'COUTELLE','CHRISTIAN','1958-01-12','02.10.67.43.14','06.16.97.86.23',NULL,'14 CHEMIN DU ROUILLIS','','','14220','THURY HARCOURT',NULL,NULL,'2580114290001',1.000000000,'1982-06-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7245,'ALLAIN','XAVIER',NULL,'02.96.59.28.96','06.23.00.28.93',NULL,'8 rue de la gare','','','61310','LE BOURG ST LEONARD',NULL,NULL,'2281014720001',2117.000000000,'2009-06-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7246,'DEL PRETE','Jean','1929-05-14','02.91.03.10.00','06.29.71.09.15',NULL,'12 rue de l''Ecureuil','','','14730','GIBERVILLE',NULL,NULL,'1290514167001',104.000000000,'1951-11-02','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7247,'GROUAZEL','','1930-11-03','02.68.45.10.53','06.26.92.43.38',NULL,'RUE DE LA SENTE VERTE','','','61200','ARGENTAN',NULL,NULL,'2301153003001',26.000000000,'1953-12-02','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7248,'BOBIER','maurice','1936-11-01','02.32.88.22.16','06.11.92.83.87',NULL,'164 RUE LOUIS BOUILLARD','','','61500','SEES',NULL,NULL,'2361114277001',106.000000000,'1958-03-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7249,'MARECHAL','Nicole','1930-03-02','02.68.86.69.86','06.36.61.54.29',NULL,'8/3 ALLEE DES CAMPANULES','','','14000','CAEN',NULL,NULL,'1300361432001',1039.000000000,'1952-08-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7250,'EROMOSELE','REGINE','1939-03-21','02.61.21.21.65','06.94.64.86.79',NULL,'','','','14123','IFS',NULL,NULL,'1390314229001',5044.000000000,'1963-10-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7251,'DUCREUX','NORBERT','1937-04-16','02.25.86.41.93','06.97.44.28.47',NULL,'3 rue du 27 juillet 1944','','','14270','QUETIEVILLE',NULL,NULL,'1370461469001',56.000000000,'1967-06-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7252,'MARIE','REGIS','1919-10-28','02.10.09.71.84','06.10.85.90.17',NULL,'1 rue de la Libration','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1191014008001',251.000000000,'1944-01-15','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7253,'HUE','','1944-01-09','02.73.44.88.08','06.29.38.57.19',NULL,'77 rue des roches','','','14120','MONDEVILLE',NULL,NULL,'2440176691001',37.000000000,'1969-10-16','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7254,'HALLARD','THERESE','1933-09-12','02.56.84.26.92','06.11.85.73.43',NULL,'CHEMIN TUILE','','','14123','IFS',NULL,NULL,'1330960425001',1197.000000000,'1959-06-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7255,'JOSEPH','GILBERT','1945-06-26','02.28.58.05.66','06.49.41.99.99',NULL,'9 PLACE DE MARILLAC','','','14730','GIBERVILLE',NULL,NULL,'2450614386001',252.000000000,'1966-09-25','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7256,'LECONNETABLE','THERESE','1930-06-01','02.10.97.55.15','06.61.79.68.53',NULL,'18 allee des poetes','','',NULL,NULL,NULL,NULL,'2300661431001',63.000000000,'1953-04-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7257,'MORIN','DANIEL','1955-04-19','02.11.95.03.63','06.99.56.47.39',NULL,'25 rue armand marie','','','14350','MONT BERTRAND',NULL,NULL,'2550450054001',6.000000000,'1977-12-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7258,'THOMINES','MARC','1940-07-21','02.11.05.35.55','06.25.73.99.76',NULL,'CHEMIN DU MARAIS','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1400714137001',1600.000000000,'1961-07-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7259,'LOISEL','THERESE','1936-04-28','02.24.02.57.73','06.45.98.27.19',NULL,'10 chemin du val','','','14210','CHEUX',NULL,NULL,'2360414167001',1777.000000000,'1962-03-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7260,'FREMAUX','JANINE','1939-01-18','02.35.08.86.33','06.25.69.21.29',NULL,'11 RUE 104 EME REGIMENT D''INFANT','ERIE','','14000','CAEN',NULL,NULL,'2390114321001',415.000000000,'1967-06-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7261,'BARRAQUET','CHRISTIANE','1953-05-21','02.96.12.25.25','06.20.88.50.96',NULL,'le chateau','','','14000','CAEN',NULL,NULL,'1530514037001',21.000000000,'1974-03-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7262,'MOREL','MARCEL','1941-05-02','02.12.05.52.81','06.13.49.04.37',NULL,'7 rue du pot d''etain','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2410514702001',62.000000000,'1963-06-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7263,'ZAIANE','GUY','1929-12-30','02.47.54.20.37','06.21.91.39.91',NULL,'22 rue du berry','','','14490','CAMPIGNY',NULL,NULL,'1291214688001',201.000000000,'1957-08-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7264,'ABEGG','ROGER','1950-03-07','02.43.08.19.91','06.87.29.32.03',NULL,'10 rue du pont du coudray','','','14400','CUSSY',NULL,NULL,'1500314687001',32.000000000,'1973-02-20','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7265,'LEGRAND','FRANCOISE','1937-12-03','02.17.30.40.42','06.13.06.60.39',NULL,'38 allee des peupliers','','','14270','MEZIDON CANON',NULL,NULL,'1371272340001',242.000000000,'1964-04-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7266,'SAUVEGRAIN','MICHEL','1933-02-27','02.26.97.53.02','06.31.00.57.87',NULL,'4 RUES DES FONTAINES','','','14860','BAVENT',NULL,NULL,'1330214464001',801.000000000,'1961-05-16','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7267,'VOISIN','Philippe','1929-05-02','02.76.82.03.36','06.18.19.60.39',NULL,'','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1290535070001',1030.000000000,'1955-07-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7268,'CATHRIN','GILBERT','1941-09-07','02.68.55.78.12','06.14.85.43.38',NULL,'28 BIS RUE PASTEUR','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2410961064001',2441.000000000,'1969-03-26','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7269,'RITZ','CHRISTIANE',NULL,'02.26.81.80.53','06.46.05.10.81',NULL,'7 BIS RUE PORTE MILLET','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1370778331001',133.000000000,'2011-01-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7270,'LEHEDOIS','BRUNO','1945-05-28','02.60.71.64.95','06.47.03.79.47',NULL,'56 RUE JEAN FLEURY','','','61570','FRANCHEVILLE',NULL,NULL,'1450514587001',240.000000000,'1975-07-21','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7271,'MULET','THERESE','1938-12-10','02.71.01.85.72','06.11.33.35.43',NULL,'le bourg','','','14121','SALLENELLES',NULL,NULL,'2381214327001',939.000000000,'1964-02-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7272,'ALPHONSE','ROBERT','1929-10-27','02.30.04.47.86','06.14.74.56.21',NULL,'13 RUE MOLIERE','','','14370','ARGENCES',NULL,NULL,'1291061093001',199.000000000,'1953-02-06','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7273,'SIMONNE','PASCAL','1944-01-16','02.87.63.72.32','06.49.10.04.97',NULL,'7 RUE DE PROVENCE','','','14123','IFS',NULL,NULL,'2440150026001',101.000000000,'1968-07-04','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7274,'GUILLOUARD','GAEL','1928-03-08','02.23.84.53.32','06.19.82.61.09',NULL,'2 cite des jardins','','','14150','OUISTREHAM',NULL,NULL,'1280314412001',41.000000000,'1953-10-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7275,'AMELINE','Maurice','1969-02-16','02.18.55.32.73','06.75.16.16.48',NULL,'19 rue du petit parc','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1690214119001',206.000000000,'1992-01-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7276,'RAULIN','ANNICK','1930-09-21','02.91.80.45.69','06.10.88.52.61',NULL,'4 rue du soir','','','14000','CAEN',NULL,NULL,'2300978532001',708.000000000,'1956-08-11','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7277,'CATHERINE','COLETTE','1938-11-12','02.47.28.35.83','06.10.70.81.18',NULL,'23 RUE DES ERABLES','','','14270','MEZIDON CANON',NULL,NULL,'2381150513001',1372.000000000,'1960-12-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7278,'BEN SALAH','DANIEL','1954-04-07','02.10.14.35.54','06.84.71.29.10',NULL,'43 quai de juillet','','','14000','CAEN',NULL,NULL,'1540414365001',20.000000000,'1977-01-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7279,'LE PAGE','Joseph','1930-05-13','02.11.24.66.48','06.43.31.82.03',NULL,'8 rue de la cave','','','14000','CAEN',NULL,NULL,'2300576060001',51.000000000,'1955-01-11','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7280,'GUILBERT','OLIVIER',NULL,'02.79.41.52.84','06.87.97.43.99',NULL,'25 RUE DES FRERES BOUTROIS','','','14123','FLEURY SUR ORNE',NULL,NULL,'2790199255001',232.000000000,'2008-05-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7281,'PRENVEILLE','HENRI','1936-09-04','02.11.77.93.49','06.63.36.81.99',NULL,'4 rue  briere','','','14840','DEMOUVILLE',NULL,NULL,'1360914365001',51.000000000,'1962-07-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7282,'COISPEL','Yvette','1933-07-10','02.94.87.50.14','06.41.99.42.58',NULL,'3 RUE DU BISSONNET','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2330714003001',564.000000000,'1959-04-23','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7283,'LEBOUTEILLER','GILLES','1940-04-11','02.29.84.18.67','06.42.39.23.87',NULL,'49 PASSAGE DU GRAND TURC','','','14770','LE PLESSIS GRIMOULT',NULL,NULL,'2400450448001',13.000000000,'1968-02-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7284,'JANKOWSKI','LAURENCE','1936-01-08','02.67.23.37.59','06.80.11.94.84',NULL,'LE CALVAIRE','','','14270','MEZIDON CANON',NULL,NULL,'2360114689001',199.000000000,'1958-08-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7285,'RIBET','DENISE','1930-04-16','02.37.21.49.21','06.38.14.64.59',NULL,'RUE DES PERRELLES','','','14140','LES AUTHIEUX PAPION',NULL,NULL,'2300478146001',140.000000000,'1951-07-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7286,'ASSANTO','M MADELEINE','1962-02-18','02.12.01.16.84','06.82.42.50.22',NULL,'16 AVENUE COPERNIC','','','61160','TOURNAI SUR DIVE',NULL,NULL,'1620250486001',81.000000000,'1985-04-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7287,'LABBE','MONIQUE','1928-07-27','02.91.73.35.49','06.10.67.46.25',NULL,'13 RUE GIL DE MONTAIGU','','','14540','ROCQUANCOURT',NULL,NULL,'2280714576001',794.000000000,'1949-11-08','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7288,'DECOURVAL','JACQUELINE','1939-07-17','02.97.38.04.77','06.52.38.91.06',NULL,'24 RUE DU PUITS','','','50110','TOURLAVILLE',NULL,NULL,'1390714101001',8.000000000,'1962-03-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7289,'BERARD','bernard','1934-12-09','02.86.89.64.58','06.11.76.22.18',NULL,'6 IMPASSE JACQUARD','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1341227238001',27.000000000,'1963-11-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7290,'DUVAL','DANIEL','1950-01-30','02.10.89.52.75','06.41.73.93.98',NULL,'res palissis  rue monseigneur ad','am','','14123','CORMELLES LE ROYAL',NULL,NULL,'1500114746001',354.000000000,'1978-04-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7291,'GENET','FRANCOISE','1935-02-11','02.23.07.08.34','06.70.12.20.68',NULL,'10 rue de l avenir','','','14460','COLOMBELLES',NULL,NULL,'1350202536001',3642.000000000,'1965-10-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7292,'DUPREZ','PHILIPPE','1936-04-03','02.12.00.35.65','06.55.47.54.70',NULL,'1 rue du puit de rome','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2360414092001',1.000000000,'1958-08-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7293,'RIGOLET','NATHALIE','1967-07-18','02.54.47.20.55','06.10.95.84.63',NULL,'14 rue du DOMREMY','','','14000','CAEN',NULL,NULL,'2670714310001',608.000000000,'1989-06-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7294,'NEVEU','MICHEL','1932-01-06','02.10.85.20.57','06.11.60.11.48',NULL,'2 riue a lechesne','','','14000','CAEN',NULL,NULL,'1320114658001',45.000000000,'1953-10-29','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7295,'CORRETTE','HUGUETTE','1963-10-25','02.76.63.35.76','06.20.27.10.47',NULL,'10 RUE ABBE BOUDIER','','','14270','VIEUX FUME',NULL,NULL,'1631050001001',242.000000000,'1989-12-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7296,'ANCELIN','MICHEL','1937-11-08','02.67.22.48.94','06.61.81.68.13',NULL,'3 rue de la liberation','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2371114266001',2500.000000000,'1961-03-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7297,'BRIARD','GEORGETTE','1934-07-28','02.40.60.70.26','06.69.80.31.12',NULL,'','','','14790','MOUEN',NULL,NULL,'1340727561001',41.000000000,'1957-12-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7298,'BRODIN','ANDRE','1954-04-05','02.86.20.95.15','06.37.87.65.32',NULL,'2 RUE DE QUILLY','','','14000','CAEN',NULL,NULL,'2540414339001',73.000000000,'1978-10-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7299,'LAURENT','jean pierre','1932-12-24','02.88.66.58.91','06.42.95.39.52',NULL,'RUE ST LAMBERT','','','14700','CORDEY',NULL,NULL,'1321214075001',97.000000000,'1958-07-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7300,'LAURENT','MAURICE','1956-08-17','02.64.20.56.72','06.66.53.05.98',NULL,'residence st joseph','','','14320','FONTENAY LE MARMION',NULL,NULL,'1560814595001',40.000000000,'1981-10-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7301,'MUGNAINI','patrick',NULL,'02.57.24.16.14','06.60.43.53.43',NULL,'315 rue marechal montgomery','','','14540','SOLIERS',NULL,NULL,'1280814278001',70.000000000,'2010-08-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7302,'TOGNA','GEORGETTE','1956-08-05','02.40.33.79.16','06.64.06.27.32',NULL,'4 RUE ROLAND SPITZER','','','14123','IFS',NULL,NULL,'1560899381001',178.000000000,'1983-08-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7303,'HAY','RAYMOND','1968-09-02','02.45.85.14.02','06.67.41.70.94',NULL,'15 rue de l eglise','','','14390','VARAVILLE',NULL,NULL,'1680914390001',2.000000000,'1998-09-30','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7304,'JEANNE','ELISABETH','1946-01-27','02.33.38.87.45','06.24.13.99.39',NULL,'HAMEAU ES LONGS','','','14570','ST REMY',NULL,NULL,'2460114679001',515.000000000,'1969-08-25','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7305,'PELLETEY','FABRICE','1955-01-01','02.70.33.01.65','06.20.37.04.16',NULL,'VERNOT','','','14540','BOURGUEBUS',NULL,NULL,'1550150606001',267.000000000,'1976-03-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7306,'LEBOULANGER','bruno','1936-08-26','02.90.98.99.17','06.56.16.64.61',NULL,'2 RUE DES FINLANDAISES','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1360829072001',996.000000000,'1962-02-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7307,'CORDRAY','MONIQUE','1936-12-26','02.11.93.38.60','06.10.26.63.00',NULL,'13 RUE DES Acadiens','','','61570','LA BELLIERE',NULL,NULL,'2361261028002',20.000000000,'1958-11-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7308,'MOULIN','ANDRE','1953-10-29','02.29.88.42.30','06.86.66.68.03',NULL,'hameau de beneauville','','','14320','FONTENAY LE MARMION',NULL,NULL,'2531014051002',3186.000000000,'1975-05-26','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7309,'JUZIO','DANIEL','1953-08-25','02.65.81.18.28','06.20.04.34.42',NULL,'550 route de maltot','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2530814322002',7.000000000,'1981-11-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7310,'DUVELLEROY','ernest','1929-12-05','02.47.89.25.50','00 33 6.67.77.67.32',NULL,'12 RUE LAMBERT DES BUTTES','','','14940','SANNERVILLE',NULL,NULL,'2291214506002',585.000000000,'1958-03-06','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7311,'DUVELLEROY','PIERRE','1948-04-19','02.32.65.64.34','06.11.87.73.67',NULL,'3 avenue de l europe','','','14370','MOULT',NULL,NULL,'2480414100002',36.000000000,'1975-09-17','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7312,'BOURDAIS','DENIS','1933-02-10','02.28.65.05.21','06.70.83.88.75',NULL,'4 RUE DU CHANT DE L'' ALOUETTE','','','14380','PONT FARCY',NULL,NULL,'2330214434002',78.000000000,'1955-12-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7313,'LEREBOURG','MICHEL','1935-04-17','02.80.86.54.11','06.11.28.17.69',NULL,'2 RUE DE LA POUDRIERE','','','14000','CAEN',NULL,NULL,'1350414271002',0.000000000,'1961-06-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7314,'LE FRANCOIS','LILIANE','1937-12-26','02.75.48.46.66','06.40.10.52.48',NULL,'av de rouen','','','14123','IFS',NULL,NULL,'1371222146002',3150.000000000,'1961-11-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7315,'CAZALE','PIERRE','1932-02-08','02.88.44.32.70','06.74.78.59.37',NULL,'18 ALLEE DES POETES','','','61200','ARGENTAN',NULL,NULL,'1320214186001',5.000000000,'1953-04-21','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7316,'','MARCEL','1962-01-25','02.47.03.32.37','06.26.51.52.36',NULL,'rue de st hilaire','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1620114182001',57.000000000,'1983-10-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7317,'CAUCHEMEZ','ALBERTINE','1955-05-19','02.73.31.77.88','06.60.59.67.63',NULL,'19 RUE DE L''APFORD','','','14730','GIBERVILLE',NULL,NULL,'2550514707001',101.000000000,'1979-05-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7318,'ROUELLE','Laurence','1930-06-28','02.10.00.06.42','06.10.26.94.31',NULL,'1 RUE VAUQUELIN','','','14540','GRENTHEVILLE',NULL,NULL,'2300677162001',87.000000000,'1954-06-19','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7319,'JEZEQUEL','SYLVAINE','1952-01-26','02.28.91.36.09','06.11.15.34.82',NULL,'23 ALLE DES POETES','','','14570','ST LAMBERT',NULL,NULL,'2520114068001',470.000000000,'1976-09-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7320,'LEROY','NICOLE','1955-03-15','02.32.42.64.62','06.14.13.04.03',NULL,'12 avenue de paris','','','14390','PETIVILLE',NULL,NULL,'1550314482001',387.000000000,'1979-09-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7321,'HUBERDEAU','NOREDDINE','1939-08-29','02.35.86.66.11','06.14.23.66.13',NULL,'33 rue des Ecordires','','','14880','HERMANVILLE SUR MER',NULL,NULL,'2390814005001',42.000000000,'1965-11-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7322,'WNUK','YVETTE','1961-03-08','02.29.66.36.89','06.91.22.44.66',NULL,'18 rue edouard vaillant','','','50310','MONTEBOURG',NULL,NULL,'1610314529001',626.000000000,'1984-10-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7323,'COSAERT','MARIE CLAIRE','1930-03-08','02.24.22.46.46','06.77.02.71.75',NULL,'12 RUE DE LA GARE','','','61160','ST LAMBERT SUR DIVE',NULL,NULL,'1300314679001',192.000000000,'1960-07-02','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7324,'DUVAL','YVETTE','1919-10-22','02.46.50.17.59','06.42.06.07.55',NULL,'','','','14111','LOUVIGNY',NULL,NULL,'1191014579001',46.000000000,'1944-01-16','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7325,'SYLVESTRE','Jean Pierre','1961-03-20','02.16.93.53.15','06.32.95.33.46',NULL,'18 rue emile combes','','','14111','LOUVIGNY',NULL,NULL,'2610378419001',105.000000000,'1987-06-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7326,'ROUX','JEAN PIERRE','1943-01-08','02.12.11.69.59','06.64.24.05.74',NULL,'21 imp des fauvettes','','','14120','MONDEVILLE',NULL,NULL,'1430114530001',834.000000000,'1971-06-22','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7327,'GUELLE','alfred','1933-06-24','02.72.62.03.25','06.59.48.04.13',NULL,'10 rue a renoir','','','14000','CAEN',NULL,NULL,'2330614623001',43.000000000,'1954-03-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7328,'CRUCHON','JEAN-LUC','1932-09-09','02.85.42.47.79','06.19.01.22.67',NULL,'13 rue des jardins','','','14123','FLEURY SUR ORNE',NULL,NULL,'2320914209001',40.000000000,'1961-05-27','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7329,'BOURGET','Georges','1940-12-21','02.29.41.94.32','06.33.73.22.15',NULL,'rue 1814 rue rolland','','','14120','MONDEVILLE',NULL,NULL,'2401219129001',451.000000000,'1965-06-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7330,'BLIN','SAJ','1953-01-17','02.17.83.72.45','06.18.89.02.16',NULL,'3 RUE DES CHARMILLES','','',NULL,NULL,NULL,NULL,'1530114212001',369.000000000,'1975-10-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7331,'CHESNEL','Gerard','1935-08-09','02.28.15.41.03','06.56.16.87.83',NULL,'69 rue Marchal Foch','','','14000','CAEN',NULL,NULL,'2350814221001',2.000000000,'1957-09-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7332,'MAZINGUE','ROBERT','1946-01-15','02.10.14.75.38','06.30.34.56.05',NULL,'8 rue beau sejour','','','14190','FIERVILLE BRAY',NULL,NULL,'2460114167001',70.000000000,'1969-11-05','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7333,'WOJNICZ','michel','1968-11-01','02.27.33.41.71','06.82.52.74.25',NULL,'8 SQUARE LEON LE CIEUX','','','14000','CAEN',NULL,NULL,'2681114654001',34.000000000,'1995-10-20','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7334,'LORILLU','HELENE','1930-01-10','02.59.12.57.68','06.36.13.23.17',NULL,'66 avenue de rouen','','','14123','FLEURY SUR ORNE',NULL,NULL,'1300114140001',476.000000000,'1957-06-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7335,'VIGIER','maurice','1943-02-25','02.25.06.05.47','06.75.89.79.92',NULL,'250 av jean jaures','','','14220','FRESNEY LE VIEUX',NULL,NULL,'2430214569001',378.000000000,'1969-09-24','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7336,'RENEE','CHRISTELLE','1956-07-20','02.71.16.60.91','06.46.85.25.77',NULL,'','','','14310','AMAYE SUR SEULLES',NULL,NULL,'2560714122001',858.000000000,'1984-07-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7337,'MKHITARIAN','JEAN EMMANUEL','1959-02-23','02.11.01.48.30','06.82.37.98.74',NULL,'LA FERRIERE DU VAL','','','14460','COLOMBELLES',NULL,NULL,'2590214034001',381.000000000,'1981-05-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7338,'IRION','MARIE CLAUDE','1930-01-27','02.10.81.23.34','06.29.94.36.58',NULL,'5 bd de la charite','','',NULL,NULL,NULL,NULL,'1300161297001',101.000000000,'1953-12-24','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7339,'DESVAGES','ALAIN','1945-01-26','02.79.65.12.06','06.59.45.09.09',NULL,'11 QUAI DE LA LONDE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2450150273002',10.000000000,'1968-12-22','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7340,'','ANDRE','1929-05-29','02.10.94.23.98','06.43.26.98.37',NULL,'8 rue bruyere','','','14540','SOLIERS',NULL,NULL,'2290514654002',363.000000000,'1952-07-31','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7341,'COSSERON','NADINE','1944-01-25','02.25.28.07.51','06.10.92.20.44',NULL,'9 rue pierre brossolette','','','14540','SOLIERS',NULL,NULL,'2440159317002',41.000000000,'1965-09-30','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7342,'MABIRE','GERARD','1941-04-13','02.46.92.84.22','06.14.13.66.50',NULL,'502 LE VAL','','','50310','QUINEVILLE',NULL,NULL,'2410414556002',37.000000000,'1965-01-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7343,'BARBE','CLAUDE','1959-03-14','02.61.51.27.13','06.37.60.90.96',NULL,'ENTREPRISE RUFFOSSE','','','14000','CAEN',NULL,NULL,'2590314118002',319.000000000,'1982-03-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7344,'MARCHAND','SERGE','1954-09-17','02.31.80.73.68','06.97.19.57.79',NULL,'11 RUE ALBERT DE MUN','','','50690','ST MARTIN LE GREARD',NULL,NULL,'1540914218002',1609.000000000,'1979-07-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7345,'OLIVIER','CHRISTELLE','1947-05-17','02.44.30.51.59','06.10.67.09.79',NULL,'5 rue du moulin','','','14000','CAEN',NULL,NULL,'1470550521002',511.000000000,'1975-03-04','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7346,'ROILLE','DANIEL','1936-02-01','02.74.51.99.72',NULL,NULL,'15 RUE DE CAMBE','','','61200','ARGENTAN',NULL,NULL,'1360229234002',54.000000000,'1957-11-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7347,'ILLES','EDWIGE','1962-07-29','02.10.52.33.97','06.53.25.73.14',NULL,'38 rue jean paul sartre','','','14000','CAEN',NULL,NULL,'2620714026002',198.000000000,'1983-01-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7348,'RICHARDEAU','CHRISTINE',NULL,'02.77.16.66.40','06.47.46.96.20',NULL,'le maizeray','','','14000','CAEN',NULL,NULL,'1400634213002',397.000000000,'2009-10-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7349,'QUINCE','ELIE','1948-06-16','02.12.28.77.24','06.35.54.52.02',NULL,'','','','44200','NANTES',NULL,NULL,'2480614119002',11.000000000,'1978-02-15','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7350,'PIOGER','michel','1933-02-01','02.11.20.07.98','06.65.24.64.84',NULL,'286 RUE DES COSTILS','','','14390','PETIVILLE',NULL,NULL,'1330214074002',83.000000000,'1955-06-08','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7351,'DELAVAL','JACQUES','1945-02-02','02.33.97.90.95','06.33.01.91.84',NULL,'8 allee  du pres clair','','','14730','GIBERVILLE',NULL,NULL,'1450261158002',31.000000000,'1967-09-01','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7352,'SEHIER','GINETTE','1941-06-16','02.10.91.93.03','00 33 6.46.50.64.92',NULL,'RUE ST PIERRE','','','14220','BOULON',NULL,NULL,'1410628342002',18.000000000,'1962-12-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7353,'BROSSAUD','CLAUDE','1961-02-23','02.49.54.84.62','06.76.05.86.89',NULL,'8 alle boris vian','','','27390','LA GOULAFRIERE',NULL,NULL,'2610214666002',613.000000000,'1984-11-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7354,'VASNIER','','1935-02-22','02.62.68.48.25','06.74.55.57.47',NULL,'36 RUE MAURICE FOUQUES','','','14570','CLECY',NULL,NULL,'2350219148002',45.000000000,'1963-09-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7355,'LANGLINE','GERARD',NULL,'02.25.52.53.64','06.93.42.60.23',NULL,'1 rue des bassechaufter','','','14250','LONGRAYE',NULL,NULL,'2450414090002',280.000000000,'2012-03-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7356,'LESAGE','','1957-01-30','02.25.41.00.46','06.89.71.47.86',NULL,'27 rue madeleine renaud','','','14320','FONTENAY LE MARMION',NULL,NULL,'2570114396002',102.000000000,'1978-09-28','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7357,'PERRIN','CHRISTIANE','1947-09-20','02.10.47.55.72','06.53.51.40.21',NULL,'route de littry','','','14123','FLEURY SUR ORNE',NULL,NULL,'2470914144002',749.000000000,'1969-10-15','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7358,'GOMOND','JACQUELINE','1958-04-19','02.30.68.93.51','06.99.86.70.26',NULL,'6 RUE DU BESSIN','','','50550','ST VAAST LA HOUGUE',NULL,NULL,'1580414009002',98.000000000,'1982-01-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7359,'MANCHION','ANNICK','1946-01-31','02.10.91.17.93','06.85.32.65.08',NULL,'31 rue Pre Samson','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2460162040001',546.000000000,'1968-11-03','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7360,'DESLOGES','CHRISTIANE','1937-09-15','02.46.91.76.41','06.32.65.52.15',NULL,'4 RUE DE LA BROQUETTE','','','14540','ROCQUANCOURT',NULL,NULL,'2370950420001',2062.000000000,'1959-01-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7361,'DE LA HERONNIERE','NINO','1966-06-04','02.89.90.16.15','06.75.36.14.36',NULL,'LE BOURG','','','14840','DEMOUVILLE',NULL,NULL,'2660675073001',645.000000000,'1991-04-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7362,'BOISARD','NADINE',NULL,'02.97.17.08.48','06.11.56.48.84',NULL,'88 ROUTE DE CABOURG','','','14000','CAEN',NULL,NULL,'1290850417002',162.000000000,'2013-03-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7363,'FOUQUES','bernard','1940-05-21','02.51.14.50.43','06.46.87.94.90',NULL,'20 RUE DE QUILLY','','','27210','BEUZEVILLE',NULL,NULL,'1400550576002',10.000000000,'1961-05-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7364,'PAYSANT','Andre','1939-08-13','02.72.83.37.36','06.52.28.06.29',NULL,'6 IMPASSE DES BULLETIERES','','','14840','DEMOUVILLE',NULL,NULL,'1390854035002',664.000000000,'1960-01-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7365,'LEVEQUE','SUZANNE','1955-09-08','02.11.35.41.20','06.73.29.48.99',NULL,'12 RUE DE LA ROUVRE','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1550914719002',119.000000000,'1980-01-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7366,'POREE','HUGUETTE','1961-11-29','02.31.41.87.15','06.68.79.16.66',NULL,'LA BOISSAYE','','','14000','CAEN',NULL,NULL,'2611114118002',405.000000000,'1985-05-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7367,'MARETTE','PASCAL','1945-01-07','02.87.22.64.41','06.41.64.70.29',NULL,'54 RUE DES LUTHIERS','','','14370','ARGENCES',NULL,NULL,'1450114437002',10.000000000,'1969-09-03','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7368,'PLAISANCE','ALAIN','1936-11-28','02.30.68.65.56','06.71.34.47.71',NULL,'lieu dit l eglise','','','14100','LISIEUX',NULL,NULL,'1361150485002',153.000000000,'1960-07-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7369,'VASNIER','PAULE','1950-02-21','02.16.90.44.74',NULL,NULL,'19 rue d''athnes','','','14120','MONDEVILLE',NULL,NULL,'2500214121002',31.000000000,'1972-11-25','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7370,'POINCHEVAL','Daniel','1954-06-13','02.26.02.45.45','06.55.51.02.81',NULL,'212 rue de l''arbalete','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2540614215002',396.000000000,'1977-02-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7371,'ALLAIRE','CHRISTIAN','1932-03-05','02.12.34.11.99','06.98.72.75.08',NULL,'ROUGET DE LISLE N 1','','','14710','TREVIERES',NULL,NULL,'1320314301002',1277.000000000,'1954-09-17','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7372,'RESTOUT','PIERRE','1942-02-20','02.11.54.98.26','06.40.26.91.69',NULL,'FERME D''ALBRAY','','','14280','ST CONTEST',NULL,NULL,'1420250346002',2798.000000000,'1964-03-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7373,'JARDIN','PHILIPPE','1966-04-04','02.58.06.17.97','06.47.65.55.30',NULL,'31 RUE D''ORLEANS','','','14270','CESNY AUX VIGNES OUEZY',NULL,NULL,'2660414181002',1.000000000,'1987-01-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7374,'BAUCHET','MARTHE','1935-04-28','02.17.38.36.44','06.49.11.39.42',NULL,'LE COUDRAY','','','14000','CAEN',NULL,NULL,'1350414213002',157.000000000,'1957-04-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7375,'DEREAC','YVETTE','1928-11-18','02.11.06.22.65','06.24.21.59.61',NULL,'49 RUE L ANCIENNE GARE','','','14000','CAEN',NULL,NULL,'1281161251002',363.000000000,'1950-07-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7376,'TURROU','ANDRE','1939-02-26','02.17.66.55.46','06.82.32.31.17',NULL,'100 rue de dunkerque','','','14220','THURY HARCOURT',NULL,NULL,'1390261295002',50.000000000,'1963-04-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7377,'ZAMPIERO','MARYLINE','1949-05-18','02.68.20.90.13','06.11.69.26.44',NULL,'21 RUE BRUYERE','','','14490','PLANQUERY',NULL,NULL,'1490514118002',123.000000000,'1971-10-31','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7378,'CHATEL','ODILE','1928-07-02','02.64.18.84.72','06.10.71.37.70',NULL,'33 rue georges gaillard','','','14000','CAEN',NULL,NULL,'2280776495002',1054.000000000,'1954-12-22','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7379,'VIEL','MARCEL','1934-08-01','02.11.45.81.41','00 33 6.35.75.99.82',NULL,'22 BIS RUE ROBERT LEFEVRE','','','14270','MEZIDON CANON',NULL,NULL,'2340814675002',33.000000000,'1961-03-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7380,'CRUCHON','THERESE','1967-11-06','02.35.73.17.02','06.38.08.25.15',NULL,'33 RUE DE LA HAIE VIGNEE','','','14540','GRENTHEVILLE',NULL,NULL,'1671150502002',223.000000000,'1991-07-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7381,'TIRARD','THIERRY','1947-07-12','02.99.79.98.46','06.39.80.87.41',NULL,'2.4 RUE DE LARBALETTE','','','14100','COURTONNE LA MEURDRAC',NULL,NULL,'1470714677002',566.000000000,'1971-11-29','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7382,'LE BRETON','RAYMOND','1935-07-25','02.13.85.77.19','06.12.17.67.34',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1350714275002',79.000000000,'1959-09-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7383,'BOHERE','MARYLINE','1938-12-25','02.31.62.71.22','06.15.69.86.37',NULL,'22 rue de stockholm','','','14160','DIVES SUR MER',NULL,NULL,'1381214241002',2361.000000000,'1963-10-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7384,'BERARD','FRANCOISE','1930-06-23','03.93.79.60.71','06.17.81.46.27',NULL,'route de lisieux','','','10800','BUCHERES',NULL,NULL,'2300653132002',1161.000000000,'1955-03-23','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7385,'FAVRIS','ISABELLE','1934-10-01','02.50.31.48.09','06.70.00.15.76',NULL,'39 ru ernesy manchon','','','14190','ESTREES LA CAMPAGNE',NULL,NULL,'1341061199002',458.000000000,'1959-10-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7386,'RAOUL','JEAN FRANCOIS','1964-11-05','02.10.80.94.35','06.38.55.90.80',NULL,'chemin de courcelles','','','14210','EVRECY',NULL,NULL,'2641150195002',76.000000000,'1987-03-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7387,'REMOND','FABRICE','1960-05-25','02.36.83.89.57','06.62.60.81.85',NULL,'31 rue de l''aubepine','','','14000','CAEN',NULL,NULL,'1600514327002',16.000000000,'1990-10-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7388,'PANNEQUIN','GENEVIEVE','1940-04-25','02.46.16.06.74',NULL,NULL,'1547 ROUTE DE BRETTEVILLE','','','61150','GOULET',NULL,NULL,'1400429025002',66.000000000,'1970-08-03','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7389,'DUCHESNE','MICHELLE','1946-01-11','02.21.27.48.18','06.19.08.39.29',NULL,'8 rue belvedere','','','14540','SOLIERS',NULL,NULL,'1460114736002',8.000000000,'1969-12-13','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7390,'LELIEVRE','DENISE','1936-12-31','02.39.09.66.38','06.29.94.28.17',NULL,'6 RUE JEAN MONNET','','','14370','VIMONT',NULL,NULL,'2361260143002',72.000000000,'1958-02-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7391,'ASSELIN','andr','1936-03-07','02.66.03.70.51','06.50.41.29.46',NULL,'34 RUE DE LA MUANCE','','','61310','COURMENIL',NULL,NULL,'1360335184002',267.000000000,'1959-09-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7392,'HEUBERT','IRENA','1933-06-12','02.32.10.56.17','06.26.01.21.95',NULL,'11 RUE CAMILLE DRAPEAU','','','14000','CAEN',NULL,NULL,'2330614320002',919.000000000,'1956-02-13','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7393,'DARSY','ANDRE','1966-04-29','02.97.37.40.65','06.75.70.17.10',NULL,'4 ALLEE DES FLEURS','','','14000','CAEN',NULL,NULL,'2660414072002',33.000000000,'1989-04-08','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7394,'VASSELIN','LYDIE','1945-04-03','02.58.46.05.42','06.57.59.55.70',NULL,'6 RUE DE L''ILE DE FRANCE','','','14460','COLOMBELLES',NULL,NULL,'1450414118002',36.000000000,'1967-11-09','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7395,'MARTIN','YVONNE',NULL,'02.26.69.52.26','06.11.71.09.40',NULL,'LA HAUTE VILLE','','','14710','LA FOLIE',NULL,NULL,'1510314729002',5014.000000000,'2011-11-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7396,'GOURNAY','FABIEN','1962-08-14','02.20.24.88.48','06.71.90.48.94',NULL,'7 rue du quebec','','','14500','ST GERMAIN DE TALLEVENDE',NULL,NULL,'2620814017002',3.000000000,'1983-05-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7397,'HUNAULT','FABIEN','1955-09-09',NULL,NULL,NULL,'11 RUE DE L''EGLISE','','','61100','FLERS',NULL,NULL,'2550959122002',653.000000000,'1982-11-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7398,'ROBIEUX','GERARD','1932-03-06','02.32.18.26.73','06.72.60.62.72',NULL,'1 bis rue du marais','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1320349295002',195.000000000,'1962-10-14','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7399,'VINCENT','GERARD','1944-03-08','02.20.90.63.47','06.34.91.10.00',NULL,'RESIDENCE LES JARDINS D''IFS 1874',' RUE DE BRETTEVILLE','','14000','CAEN',NULL,NULL,'2440314738002',768.000000000,'1968-01-01','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7400,'MIREY','MARIE CLAIRE','1954-09-22','02.35.13.80.67','06.43.95.47.97',NULL,'29 RUE AUGUSTE LECHESNE','','','14540','ROCQUANCOURT',NULL,NULL,'1540914218002',1.000000000,'1975-12-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7401,'FOUQUES','CHRISTINE','1946-03-01','02.75.93.14.44','06.11.77.23.56',NULL,'1 ALLEE DU SOLEIL COUCHANT','','','14120','MONDEVILLE',NULL,NULL,'1460361474002',4.000000000,'1971-01-16','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7402,'LEBEL','MADELEINE','1933-09-19','02.47.38.91.74',NULL,NULL,'4 rue paul langevin','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1330971132002',61.000000000,'1959-01-01','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7403,'BISSONNET','GERARD',NULL,'02.53.58.91.54','06.51.69.84.68',NULL,'4 RUE DE LA FONTAINE','','','14000','CAEN',NULL,NULL,'2320214598001',488.000000000,'2013-05-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7404,'ISIDOR','HUGUETTE','1930-01-28','02.70.16.10.62','06.43.42.42.77',NULL,'3 rue du bout roulant','','','14460','COLOMBELLES',NULL,NULL,'1300114062001',156.000000000,'1960-05-31','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7405,'LEPERT','GUY','1945-01-07','02.10.34.23.60','06.12.17.29.08',NULL,'4 RUE CALMETTE','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'1450114349001',304.000000000,'1975-12-11','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7406,'JAMES','ANNIE','1933-05-16','02.44.40.79.23','06.32.40.89.92',NULL,'36 ret de paris','','','14120','MONDEVILLE',NULL,NULL,'1330561164001',2335.000000000,'1961-03-22','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7407,'CAHU','NADIA','1934-01-08','02.29.01.68.11','06.85.39.76.79',NULL,'9 RUE DE LA MER','','','14123','FLEURY SUR ORNE',NULL,NULL,'1340114067001',58.000000000,'1961-12-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7408,'LETERRIER','CLAUDINE','1933-01-07','02.11.29.01.02','06.12.30.12.01',NULL,'16 rue le marchand','','','14000','CAEN',NULL,NULL,'1330114140001',14.000000000,'1958-07-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7409,'LOUIS','BERNARD','1936-09-23','02.73.46.69.39','06.95.35.16.70',NULL,'1 B BOULEVARD CARNOT','','','50000','ST LO',NULL,NULL,'1360985227001',1.000000000,'1963-08-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7410,'BRAEM','CLAUDE','1969-06-21','02.81.43.22.49','06.10.55.06.55',NULL,'20 RUE LEONARD GILLES','','','14700','FALAISE',NULL,NULL,'2690692036001',313.000000000,'1997-11-16','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7411,'LE BELLER','CORINNE','1932-01-02','02.13.19.26.30','06.73.44.38.48',NULL,'53 RESIDENCE L''ENCLOS ROUTE D''H','ARCOURT','','14000','CAEN',NULL,NULL,'2320114651001',20.000000000,'1955-12-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7412,'GELMI','GUY','1932-01-09','02.21.91.45.70','06.53.61.14.03',NULL,'9 rue du dauphine','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1320114197001',1561.000000000,'1954-08-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7413,'TOQUET','GERARD','1940-08-19','02.92.95.11.19','06.54.09.86.09',NULL,'12 RUE HELENE BOUCHER','','','14120','MONDEVILLE',NULL,NULL,'2400814566001',454.000000000,'1970-12-13','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7414,'LE CALVEZ','SOLANGE','1939-12-03','02.25.26.00.70','06.16.99.51.64',NULL,'48 rue camille blaisot','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'2391261302001',689.000000000,'1964-12-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7415,'CHEREAU','ANDREE','1937-06-27','02.53.50.03.43','06.14.57.37.97',NULL,'4 rue mortemer','','','14540','SOLIERS',NULL,NULL,'1370614441001',157.000000000,'1963-12-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7416,'TAMARII','SIMONNE','1951-01-23','02.54.53.67.86','06.70.47.91.39',NULL,'110 RUE JULES JUESDE','','','14260','BONNEMAISON',NULL,NULL,'1510114730002',11.000000000,'1972-11-28','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7417,'LEFEUVRE','CHRISTIAN','1959-02-27','02.63.10.46.33','06.49.78.76.44',NULL,'24 ROUTE DE PARIS','','','14630','CAGNY',NULL,NULL,'2590214628002',42.000000000,'1982-02-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7418,'','CHRISTIAN','1963-05-09','02.38.53.15.36','06.59.33.69.69',NULL,'6 RUE TRAVERSIERE','','','14630','CAGNY',NULL,NULL,'1630550344002',84.000000000,'1990-09-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7419,'MARIE','FERNAND','1947-02-23','02.46.29.34.52','06.16.73.78.76',NULL,'CHEMIN DE L''HOPITAL','','','14700','AUBIGNY',NULL,NULL,'1470214554002',131.000000000,'1970-10-28','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7420,'LECOCQ','GENEVIEVE','1949-10-07','02.37.57.59.22','06.31.82.09.55',NULL,'15 RUE ARAGO','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'1491014002002',579.000000000,'1973-12-22','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7421,'LECHEVALIER','GENEVIEVE','1933-01-05','02.65.84.56.38','06.30.51.27.07',NULL,'SAINT CLAIR','','','14000','CAEN',NULL,NULL,'2330172154002',42.000000000,'1956-01-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7422,'LELODEY','MICHEL','1928-11-15','02.63.12.35.98','06.53.38.26.89',NULL,'LE LOCHEUR','','','14670','TROARN',NULL,NULL,'2281114699002',74.000000000,'1952-05-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7423,'AMESLANT','JEAN LUC','1939-10-20','02.24.06.73.96','06.83.97.77.22',NULL,'rue lemaitre','','','14000','CAEN',NULL,NULL,'1391008343002',1171.000000000,'1962-04-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7424,'COSTARD','BERNARD','1951-11-30','02.95.48.34.56','06.58.08.03.09',NULL,'8 RUE DU DAUPHINE','','','14000','CAEN',NULL,NULL,'1511114114002',4273.000000000,'1975-06-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7425,'MOULIN','BERNARD','1930-05-03','02.88.60.46.53','06.46.89.47.52',NULL,'13 RUE DU FOUR','','','14000','CAEN',NULL,NULL,'2300514162002',686.000000000,'1952-07-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7426,'EVANDRE','GILBERT','1947-06-03','02.87.65.42.65','06.10.07.88.38',NULL,'82 ALLLEE DES PEUPLIERS','','','14670','ST OUEN DU MESNIL OGER',NULL,NULL,'2470614760002',9.000000000,'1976-03-15','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7427,'RENOUF','BERNADETTE','1951-12-17','02.95.55.55.62','06.10.73.10.76',NULL,'LA FOUQUERIE','','','14000','CAEN',NULL,NULL,'1511214176002',16.000000000,'1981-05-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7428,'DAVID','THERESE','1959-01-07','02.42.45.18.02','06.59.99.91.95',NULL,'1 RUE PERE ROBERT','','','14123','IFS',NULL,NULL,'1590169168002',136.000000000,'1982-07-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7429,'SEGUY','MAURICE','1958-04-03','02.24.96.74.49',NULL,NULL,'','','','14540','GRENTHEVILLE',NULL,NULL,'2580414164002',2171.000000000,'1980-11-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7430,'BENOIST','MAURICE','1932-09-18','02.82.43.81.17','06.51.29.39.57',NULL,'31 RUE DE LA PIERRE','','','14470','COURSEULLES SUR MER',NULL,NULL,'1320950435002',134.000000000,'1956-06-06','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7431,'BARETTE','','1956-01-14','02.86.57.97.18','06.59.50.53.58',NULL,'325 rue de falaise','','','14370','ARGENCES',NULL,NULL,'2560161169002',98.000000000,'1986-09-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7432,'HUBERT','DANIEL','1965-08-30','02.84.16.49.87','06.10.60.07.02',NULL,'17 rue de la fosse  terre','','','61800','FRENES',NULL,NULL,'1650814158002',43.000000000,'1986-10-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7433,'DESPLANQUES','MICHELINE','1936-09-15','02.32.51.47.29','06.38.67.12.61',NULL,'57 RUE DU MANOIR','','','14650','CARPIQUET',NULL,NULL,'2360914120002',23.000000000,'1966-06-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7434,'LETOURNEL','pascal','1945-05-04','02.20.99.52.13','06.79.75.98.41',NULL,'POUSSY LA CAMPAGNE','','','14240','CAHAGNES',NULL,NULL,'1450514418002',244.000000000,'1971-02-17','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7435,'DUHAZE','pascal','1941-04-05','02.46.50.35.07','00 33 6.83.24.51.22',NULL,'14 RUE NOTRE DAME DES CHAMPS','','','14220','DONNAY',NULL,NULL,'1410414088002',70.000000000,'1968-10-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7436,'MOCQUAIS','PASCAL','1929-04-27','02.12.04.90.94','06.67.14.41.93',NULL,'23 ROUTE DE PARIS','','','14840','DEMOUVILLE',NULL,NULL,'2290414125002',754.000000000,'1958-06-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7437,'DESVAGES','MARCELLE','1957-12-24','02.66.98.68.26','06.57.36.43.25',NULL,'MAIRIE ESCURES SUR FAVIERES','','','14123','IFS',NULL,NULL,'2571214359002',100.000000000,'1986-10-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7438,'PAWLAK','GILBERT','1939-03-28','02.11.99.80.81','06.29.05.04.03',NULL,'13 RUE DES SEMAILLES','','','61160','MONTABARD',NULL,NULL,'1390314057002',97.000000000,'1965-10-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7439,'MOREL','MARCELLE','1930-06-13','02.10.23.39.64','06.31.91.01.29',NULL,'8 CLOS DU CHAPELET','','','50270','BARNEVILLE CARTERET',NULL,NULL,'1300614658002',28.000000000,'1952-03-10','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7440,'PRUD HOMME','JEANNINE','1960-02-14','02.11.99.38.70','06.47.68.52.80',NULL,'31 LE CLOS','','','14120','MONDEVILLE',NULL,NULL,'1600214088002',311.000000000,'1984-01-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7441,'ROULLAND','GHISLAINE','1936-02-26','02.94.68.84.59','06.61.81.63.15',NULL,'24 AVENUE GENERAL LYNE','','','14000','CAEN',NULL,NULL,'2360253211002',582.000000000,'1964-07-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7442,'DE BRUNVILLE','JEAN PIERRE',NULL,'02.10.02.01.30','06.99.52.24.52',NULL,'1 RUE DU PARC','','','50000','ST LO',NULL,NULL,'1350850102002',58.000000000,'2009-03-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7443,'','YVETTE','1951-10-18','02.82.28.17.72','06.63.09.18.13',NULL,'la valle','','','14000','CAEN',NULL,NULL,'1511099170002',207.000000000,'1975-06-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7444,'BOSSARD','JACQUES','1948-04-16','02.63.19.54.40','06.82.01.74.32',NULL,'2 longue vue du theatre','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'2480461339002',28.000000000,'1969-04-26','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7445,'BERTIN','GENEVIEVE','1956-04-09','02.90.01.56.74',NULL,NULL,'LA MORANDIERE','','','14190','CAUVICOURT',NULL,NULL,'2560450635002',262.000000000,'1980-02-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7446,'QUENET','CLAUDE','1930-09-29','02.10.67.46.14','06.22.51.21.70',NULL,'10 la bruyere','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2300961421002',1577.000000000,'1954-09-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7447,'BELLEMERE','HENRIETTE','1956-03-05','02.94.97.59.32','06.77.66.24.78',NULL,'16 rue des ecuillers','','','14240','CAHAGNES',NULL,NULL,'2560314383002',665.000000000,'1980-04-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7448,'BELLISSENT','ROLAND','1933-04-15','02.37.59.39.79','06.69.02.09.43',NULL,'727 rue de tour de ville','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1330414233002',2672.000000000,'1960-09-08','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7449,'MARTIN','MARIE LOU','1950-01-21','02.24.27.81.38','06.92.44.31.90',NULL,'39 AVENUE DE L''EUROPE','','','61200','ARGENTAN',NULL,NULL,'2500153253002',787.000000000,'1971-06-30','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7450,'MUNKHUU','MARIE THERESE','1938-03-31','02.46.68.45.16','06.13.59.64.88',NULL,'21 BOULEVARD DU 30 JUIN','','','14120','MONDEVILLE',NULL,NULL,'2380314554002',180.000000000,'1968-07-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7451,'LAVILLE','MARGUERITE','1917-11-19','02.53.49.50.00','06.78.73.69.69',NULL,'HAMEAU BEAUSSIEU','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1171127289002',10.000000000,'1938-09-16','PREMIUM',24,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7452,'RIGOT','CHRISTIAN','1953-03-25','02.11.10.51.33','06.36.52.54.35',NULL,'','','','14370','MOULT',NULL,NULL,'1530314246002',1446.000000000,'1978-02-21','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7453,'CHEVALIER','THERESE','1947-05-30','02.76.74.82.56',NULL,NULL,'75 rue bouteille','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1470550265002',1585.000000000,'1974-09-08','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7454,'COUDRAY','FRANCIS','1962-05-09','02.69.89.33.23','06.15.21.97.54',NULL,'31 RUE AUGUSTE LECHESNE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1620522313002',15.000000000,'1986-12-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7455,'ALLAIS','MARIANA','1941-03-09','02.97.71.88.55','06.66.88.30.52',NULL,'12 RUE TOURNIERES','','','14000','CAEN',NULL,NULL,'2410314391002',244.000000000,'1963-12-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7456,'MANCEL','ANDRE','1936-10-19','02.99.06.54.12','06.87.14.43.85',NULL,'17 RUE DE BENEAUVILLE','','','14510','HOULGATE',NULL,NULL,'2361014338002',16.000000000,'1959-05-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7457,'ANNE','ANNICK','1950-02-08','02.37.61.37.81','06.80.29.70.82',NULL,'5/3 ALLEE DES CHEVREFEUILLES','','','14320','FONTENAY LE MARMION',NULL,NULL,'1500250564002',22.000000000,'1971-02-15','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7458,'MATTARD','THERESE','1931-09-27','02.72.40.68.50','06.10.26.36.00',NULL,'15 RUE DU RUEL','','','14400','BAYEUX',NULL,NULL,'2310935132002',452.000000000,'1956-02-09','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7459,'MICHEL','LEVAN','1962-04-24','02.24.47.68.21','06.79.78.58.15',NULL,'15 RUE ST GERBOL','','','14860','AMFREVILLE',NULL,NULL,'2620414391002',16.000000000,'1983-05-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7460,'BRUNET','MARCELLE','1962-02-20','02.25.66.94.97','06.51.86.30.69',NULL,'2 rue cardinal lavigerie','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2620214209002',325.000000000,'1983-05-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7461,'BRAGANTI','MICHEL','1928-05-16','02.10.23.49.91','06.23.93.00.80',NULL,'15 rue frederic chopin','','','14240','CAHAGNES',NULL,NULL,'1280514253002',91.000000000,'1958-08-09','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7462,'BENARD','MICHEL','1937-09-29','02.12.22.35.92','06.24.87.29.25',NULL,'1 rue fouques','','','14000','CAEN',NULL,NULL,'1370914430002',0.000000000,'1959-09-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7463,'ANDRIEUX','CATHERINE','1928-09-23','02.55.68.08.87','06.66.44.77.49',NULL,'6 CHEMIN DU HOME','','','14320','FONTENAY LE MARMION',NULL,NULL,'2280950601002',1786.000000000,'1953-06-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7464,'LE CANU','PAULETTE','1927-04-29','02.89.41.05.63','06.76.39.90.66',NULL,'4 RUE DES CHAMPS','','','14730','GIBERVILLE',NULL,NULL,'1270474036002',116.000000000,'1954-01-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7465,'LEBRETON','AUGUSTE','1957-04-20','02.65.45.51.96','06.64.73.10.13',NULL,'noirville','','','14940','SANNERVILLE',NULL,NULL,'1570414643002',378.000000000,'1979-04-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7466,'LEBRETON','MARGUERITE','1949-02-24','02.38.01.71.78','06.76.62.68.30',NULL,'1 rue des marches','','','14610','EPRON',NULL,NULL,'2490214530002',21.000000000,'1975-07-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7467,'RAVRY','LOUIS','1962-05-11','02.18.05.85.22','06.77.96.74.62',NULL,'5 RUE DEMOLOMBE','','','14120','MONDEVILLE',NULL,NULL,'2620514663002',2453.000000000,'1992-09-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7468,'VAN DE CASTEELE','FERNAND','1947-02-04','02.89.73.22.10','06.61.56.02.94',NULL,'3 rue des freres lumieres','','','61320','ST MARTIN L''AIGUILLON',NULL,NULL,'1470214174002',96.000000000,'1968-02-08','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7469,'MARIE','JEAN ANDRE','1955-02-16','02.33.25.69.54','06.71.99.77.00',NULL,'3 RUE ROGER DECHAMBRE','','','14270','CESNY AUX VIGNES OUEZY',NULL,NULL,'2550214602002',618.000000000,'1976-08-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7470,'SAMIN','JEAN','1942-02-23','02.18.39.97.02','06.44.25.38.36',NULL,'8 Square Mirabeau','','','14220','MOULINES',NULL,NULL,'2420214579002',4.000000000,'1965-07-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7471,'SAMIN','JEAN MARC','1949-07-13','02.35.55.31.06','06.54.45.19.18',NULL,'48 boulevard raymond point carre','','','61160','FEL',NULL,NULL,'1490777439002',2.000000000,'1973-01-27','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7472,'CLEREMBEAUX','MIREILLE','1949-07-17','02.10.07.90.91','06.37.33.25.38',NULL,'15 rue des castors','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1490777439002',102.000000000,'1971-11-19','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7473,'LECERF','MARCEL','1961-05-12','02.91.90.35.15','06.25.79.51.09',NULL,'57 rue des potiers','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1610516189002',201.000000000,'1985-03-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7474,'HAUVEL','MAURICETTE','1951-02-16','02.84.93.99.07','06.26.97.96.93',NULL,'5 RUE FRANCOIS MOISANT','','','14680','GOUVIX',NULL,NULL,'1510214090002',57.000000000,'1976-01-26','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7475,'BOINEAU','GINETTE','1958-01-20','02.58.29.46.33','06.49.20.30.74',NULL,'10 BIS CHEMIN DU CLOS DE SALLES','','','14270','MEZIDON CANON',NULL,NULL,'1580114221002',2541.000000000,'1982-12-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7476,'MARCHAL','DANIEL','1988-12-08','02.12.28.96.55','06.77.08.86.08',NULL,'26 rue de lahaye','','','14370','ARGENCES',NULL,NULL,'1881299342002',615.000000000,'2012-12-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7477,'MATHURIN','ANNE MARIE','1932-07-08','02.16.58.78.57','06.76.54.80.67',NULL,'48 AVENUE LEON BLUM','','','50550','ST VAAST LA HOUGUE',NULL,NULL,'1320714517002',23.000000000,'1962-02-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7478,'LEMARQUIS','HELENA','1929-04-28','02.49.93.89.22','06.43.15.18.24',NULL,'559 rue de la mare','','','14670','TROARN',NULL,NULL,'1290477083002',27.000000000,'1952-09-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7479,'SLUZYNSKI','JEAN MARIE','1939-12-30','02.10.97.27.36','06.55.57.83.35',NULL,'ROUTE DE JORT','','','14400','BAYEUX',NULL,NULL,'1391237214002',155.000000000,'1964-05-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7480,'RENOUVIN','BENOIT','1930-02-10','02.25.27.31.69','06.37.47.80.58',NULL,'22 RUE W.KENNEDY FERGUSON','','','14000','CAEN',NULL,NULL,'2300214328002',1798.000000000,'1958-10-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7481,'MARIE','COLETTE','1929-03-22','02.49.38.86.33','06.39.33.98.00',NULL,'7 allee de l albertin','','','14270','MEZIDON CANON',NULL,NULL,'1290314452002',6.000000000,'1953-07-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7482,'BEN SALAH','LOVETH','1968-06-23','02.54.78.58.19','06.21.22.10.86',NULL,'21 rue emmanuel benard','','','14540','ROCQUANCOURT',NULL,NULL,'2680614092002',3728.000000000,'1997-04-09','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7483,'VIGOR','didier','1968-02-22','02.81.08.07.50','06.10.34.57.29',NULL,'9 boulevard de la charit','','','14770','DANVOU LA FERRIERE',NULL,NULL,'1680214338002',298.000000000,'1990-05-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7484,'DALYS','PASCAL','1948-02-26','02.81.48.18.24','06.41.55.64.56',NULL,'4 RUE DES BARENTINS','','','14000','CAEN',NULL,NULL,'2480214649002',9.000000000,'1969-02-02','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7485,'THEBAULT','HENRI','1937-12-30','02.14.09.61.93','06.86.50.22.05',NULL,'RUE ST HORTHAIRE','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2371278644002',371.000000000,'1960-07-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7486,'HUBERT','FERNANDE','1944-02-13','02.11.87.93.68','06.12.29.74.27',NULL,'4 rue guilbert','','','14000','CAEN',NULL,NULL,'1440214050002',2798.000000000,'1967-04-26','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7487,'BOURSIER','DIDIER','1930-02-04','02.51.17.75.88','06.10.17.99.59',NULL,'12 AVENUE DE LA CONCORDE','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1300214008002',33.000000000,'1960-04-14','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7488,'TERREE','JACQUES','1958-01-11','02.36.95.86.25','06.39.35.65.07',NULL,'4 ALLEE DES ROUGES GORGES','','','14000','CAEN',NULL,NULL,'1580114301002',94.000000000,'1981-01-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7489,'DAYES','ALAIN','1936-05-18','02.34.72.21.96','06.83.16.19.96',NULL,'38 RUE VICTOR TESNIERE','','','14120','MONDEVILLE',NULL,NULL,'1360527681002',16.000000000,'1960-07-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7490,'','GERARD','1947-04-17','02.24.58.67.36','06.27.19.05.52',NULL,'17 avenue georges clemenceau','','','14470','COURSEULLES SUR MER',NULL,NULL,'2470414264002',507.000000000,'1975-04-13','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7491,'VEREL','SUZANNE','1958-05-24',NULL,NULL,NULL,'19 RUE JACQUES LAROSE','','',NULL,NULL,NULL,NULL,'1580561473002',348.000000000,'1982-08-31','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7492,'PAYEN','GEORGES','1929-08-26','02.30.80.53.62','06.79.90.55.45',NULL,'7 rue d''argouges','','','14270','MEZIDON CANON',NULL,NULL,'2290814032002',78.000000000,'1959-06-14','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7493,'PICHARD','NICOLE','1961-05-12','02.82.96.26.63','06.51.97.38.03',NULL,'42 rue de la seine','','','14210','AVENAY',NULL,NULL,'1610514145002',2.000000000,'1982-07-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7494,'HEMERY','MARIE HELENE','1954-03-22','02.75.62.06.18','06.11.88.70.12',NULL,'PETITE SOEUR DES PAUVRES  7 PORT','E MILLET','','14170','VENDEUVRE',NULL,NULL,'1540314042002',122.000000000,'1983-04-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7495,'DESQUESNE','YVES','1959-07-21','02.58.85.25.90','06.89.16.96.57',NULL,'CHEMIN DU POIRIER','','','50760','VALCANVILLE',NULL,NULL,'1590714376002',132.000000000,'1981-01-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7496,'DEVAUX','PATRICK','1928-09-27','02.20.00.81.69','06.14.39.68.87',NULL,'40 avenue conseil','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'2280914409002',73.000000000,'1955-09-20','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7497,'GUILLAUME','FERNANDE','1952-01-13','02.70.38.17.72','06.31.14.57.03',NULL,'35 RU JULES GUESDE','','','14480','LE FRESNE CAMILLY',NULL,NULL,'2520114066002',186.000000000,'1982-06-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7498,'LEVITRE','SUZANNE','1939-04-30','02.16.02.51.41','06.58.54.79.84',NULL,'7 BIS RUE DE BRETAGNE','','','50690','ST MARTIN LE GREARD',NULL,NULL,'1390414004002',3006.000000000,'1960-11-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7499,'CAPELLO','NICOLE','1942-04-26','02.41.41.97.64','06.12.00.27.58',NULL,'11 RESIDENCE DE LA RIVIERE','','','14540','GRENTHEVILLE',NULL,NULL,'1420414294002',40.000000000,'1972-10-15','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7500,'POTIER DE COURCY','JACQUELINE','1936-03-19','02.28.61.88.69','06.20.11.61.96',NULL,'12 rue du reverand pere jules','','','14680','GOUVIX',NULL,NULL,'1360314645002',207.000000000,'1959-05-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7501,'POTIER DE COURCY','JOSETTE','1950-08-26','02.76.11.20.76','06.52.95.98.12',NULL,'41 rue st martin','','','14460','COLOMBELLES',NULL,NULL,'2500814319002',953.000000000,'1974-08-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7502,'MUSSO','DENISE','1961-01-30','02.78.27.33.17','06.14.91.02.77',NULL,'26 CHEMIN DE LA HAIE MORIN','','','61470','LE SAP',NULL,NULL,'1610114538002',724.000000000,'1985-02-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7503,'GUERIN','SIMONE','1929-05-03','02.11.15.94.21','06.73.36.68.50',NULL,'21 RUE DE LA GARE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1290550485002',80.000000000,'1959-06-06','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7504,'MARIE','BRUNO','1951-06-26','02.25.34.35.19','06.70.33.06.55',NULL,'CHEMIN DES COMMUNES','','','14370','ARGENCES',NULL,NULL,'1510661419002',566.000000000,'1972-06-11','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7505,'HARDY','JEAN MARIE','1982-07-31','02.11.87.48.66','06.59.96.53.91',NULL,'4 rue barbiche','','','14400','BAYEUX',NULL,NULL,'1820799155002',2086.000000000,'2007-03-03','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7506,'GROUT','GERARD','1939-03-08','02.86.95.94.78','06.29.42.93.88',NULL,'14 route des cascades','','','61200','ARGENTAN',NULL,NULL,'1390314506002',198.000000000,'1961-01-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7507,'TILLIER','JANINE','1930-07-01','02.80.44.60.91','00 33 6.68.75.95.62',NULL,'7 rue froide','','','14000','CAEN',NULL,NULL,'1300714310002',4.000000000,'1952-05-10','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7508,'AMAND','LUCIENNE','1943-02-04','02.32.70.88.84','06.64.16.26.78',NULL,'village mellier','','','14000','CAEN',NULL,NULL,'1430214623002',76.000000000,'1971-09-20','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7509,'DEBAUDRE','PIERRE','1929-12-24','02.57.65.83.11','06.74.77.08.55',NULL,'23 ROUTE DE CORMELLES','','','14360','TROUVILLE SUR MER',NULL,NULL,'1291214990002',36.000000000,'1952-07-14','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7510,'QUINTON','JOEL','1946-09-26','02.16.00.34.67','06.55.99.98.29',NULL,'31 RUE JEAN MOULIN','','','61200','ARGENTAN',NULL,NULL,'1460914537002',3.000000000,'1968-05-09','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7511,'DUBOIS','PASCAL','1936-05-09','02.73.23.69.32','06.85.94.78.51',NULL,'3 RUE ST MARTIN   VIEUX','','','14190','OUILLY LE TESSON',NULL,NULL,'1360514271002',719.000000000,'1960-05-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7512,'DOUBLET','ELIANE','1955-03-24','02.40.75.38.46','06.51.78.60.93',NULL,'28 RUE GUSTAVE FLAUBERT','','','14860','AMFREVILLE',NULL,NULL,'2550314629002',163.000000000,'1976-07-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7513,'RICHARD','JEAN PIERRE','1958-02-02','02.44.77.15.67','06.65.47.29.55',NULL,'24 RUE DU CREUX AU RENARD','','','14670','TROARN',NULL,NULL,'1580289024002',215.000000000,'1979-08-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7514,'MARIE','JEANNE','1928-07-13','02.61.60.82.87','00 33 6.89.69.52.62',NULL,'17 RUE DE LA REPUBLIQUE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1280714325002',1614.000000000,'1958-08-27','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7515,'CENEDESE','JACQUES','1965-03-31','02.45.93.16.98','06.65.70.73.20',NULL,'LE VEY','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'1650314666002',172.000000000,'1989-01-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7516,'MARIE','MONIQUE','1933-04-09','02.10.63.93.54','06.74.04.86.04',NULL,'60 rue des acassias','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1330450502002',53.000000000,'1959-10-20','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7517,'MARAIS','JACQUES','1944-02-28','02.34.41.71.28','06.24.33.46.59',NULL,'48 clos michel','','','14770','LE PLESSIS GRIMOULT',NULL,NULL,'1440214454002',4.000000000,'1972-07-03','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7518,'DENIEUL','ROGER','1938-08-10','02.73.02.46.71','06.62.95.33.13',NULL,'30 BIS  RUE DU MILIEU','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1380814387002',280.000000000,'1960-03-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7519,'ANNE','Colette','1939-05-01','02.44.68.29.12','06.62.76.17.93',NULL,'4 RUE MOITOIRET','','','14123','FLEURY SUR ORNE',NULL,NULL,'2390514990002',23.000000000,'1962-04-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7520,'GUILBERT','MADELEINE','1967-09-04','02.62.87.56.86','06.88.12.38.82',NULL,'36 avenue de paris','','','14370','BELLENGREVILLE',NULL,NULL,'2670950499002',74.000000000,'1991-06-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7521,'','LOUISE','1933-11-18','02.74.49.20.36',NULL,NULL,'4 BIS RUE DE MALTOT','','','14840','DEMOUVILLE',NULL,NULL,'1331122226002',654.000000000,'1959-03-23','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7522,'','JACQUELINE','1942-03-14','02.72.25.39.24','06.48.60.27.31',NULL,'','','','14780','LION SUR MER',NULL,NULL,'1420314277002',46.000000000,'1963-07-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7523,'MARIE','LOUIS','1932-01-05','02.18.03.08.41','06.41.29.58.80',NULL,'2 chemin de la haie de saules','','','14123','IFS',NULL,NULL,'2320114158002',11.000000000,'1962-05-20','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7524,'MARIE','VERONIQUE','1937-10-22','02.14.28.91.80','06.14.14.78.05',NULL,'4 rue daniel tison','','','50880','LA MEAUFFE',NULL,NULL,'2371053147002',1878.000000000,'1960-03-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7525,'GACOIN','SIMONE','1935-07-29','02.64.14.55.46','06.89.81.35.39',NULL,'55 RUE SALVATOR MAXIME','','','61160','TOURNAI SUR DIVE',NULL,NULL,'2350714027002',203.000000000,'1957-09-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7526,'','PASCAL','1930-01-09','02.30.92.41.22','06.59.14.03.07',NULL,'498 AV M. D''ORNANO','','','14000','CAEN',NULL,NULL,'2300114520002',103.000000000,'1959-02-20','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7527,'VINCE','DENIS','1930-03-20','02.60.05.78.38','06.78.48.33.47',NULL,'8 IMPASSE  THEODORE GERICAULT','','','14330','LE MOLAY LITTRY',NULL,NULL,'2300314724002',884.000000000,'1957-06-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7528,'BELLIARD','SUZANNE','1968-10-02','02.64.09.46.31','06.71.15.26.97',NULL,'9 RUE BERNARD ZAJEWSKI','','','14730','GIBERVILLE',NULL,NULL,'1681014410002',79.000000000,'1991-04-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7529,'MYAGMARJAV','IRENE','1934-06-28','02.51.62.46.34','06.51.95.28.29',NULL,'214 RUE D''AUGE','','','61200','AUNOU LE FAUCON',NULL,NULL,'2340614100002',43.000000000,'1958-02-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7530,'LECONTE','FRANCOISE','1942-08-17','02.77.45.43.80','06.77.22.98.04',NULL,'LE LIEU DIT MEHEUDIN','','','14120','MONDEVILLE',NULL,NULL,'2420861439002',220.000000000,'1970-03-30','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7531,'BELLIARD','JANINE','1947-05-05','02.41.58.86.59','06.27.59.26.29',NULL,'8 RUE JEAN  PHILIPPE RAMEAU','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1470514075002',978.000000000,'1972-06-30','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7532,'BAZIN','GINETTE','1944-08-05','02.52.58.33.66','06.44.80.00.97',NULL,'3 RUE CONSTANT FORGET RESIDENCE',' SAINT GERBOLD','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1440850601002',771.000000000,'1968-12-09','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7533,'VOISIN','GERARD','1968-02-07','02.68.94.04.00','06.46.74.74.32',NULL,'8 ALLEE DES  REBLOTS','','','50440','VASTEVILLE',NULL,NULL,'1680262270002',196.000000000,'1991-10-29','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7534,'MAUNOURY','LUCETTE','1947-03-10','02.47.99.94.26','06.32.30.38.94',NULL,'15 AVENUE LEON BLUM','','','14730','GIBERVILLE',NULL,NULL,'1470314150002',97.000000000,'1971-08-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7535,'JOURDAN','PIERRE','1929-02-19','02.43.08.88.09','06.85.61.52.84',NULL,'JULES FERRY','','','14540','SOLIERS',NULL,NULL,'2290214383002',246.000000000,'1951-03-22','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7536,'EHLING','MARIE THERESE','1968-05-17','02.67.15.66.97','06.76.15.47.63',NULL,'tupot','','','14000','CAEN',NULL,NULL,'2680550393002',139.000000000,'1991-04-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7537,'FREMOND','CHRISTINE','1942-02-09','02.77.78.27.87','06.65.69.39.83',NULL,'28 RUE D''ANJOU','','','14000','CAEN',NULL,NULL,'1420214617002',17.000000000,'1971-02-06','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7538,'CHAPRON','BERNADETTE','1949-11-11','02.57.09.14.76','06.83.84.11.93',NULL,'1 RUE LEO FERRE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2491150390002',86.000000000,'1973-05-06','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7539,'LABORIE','MARC','1955-10-30','02.28.08.76.70','06.33.46.55.21',NULL,'10 rue paul samson','','','50480','CHEF DU PONT',NULL,NULL,'1551014097002',411.000000000,'1980-08-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7540,'SCOLA','MICHEL','1939-12-16','02.77.49.32.76','06.66.37.56.41',NULL,'10 rue de la basse ecarde','','',NULL,NULL,NULL,NULL,'2391250564002',4295.000000000,'1962-04-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7541,'POUSSE','PHILIPPE','1929-08-30','02.77.73.00.50','06.10.18.96.38',NULL,'5 rue des charmilles','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1290814743002',6.000000000,'1952-02-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7542,'VICTOIRE','GILBERT','1949-07-31','02.48.91.53.16','06.10.42.32.09',NULL,'1 rue robert hamelin','','','14210','AMAYE SUR ORNE',NULL,NULL,'1490777439002',62.000000000,'1973-01-23','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7543,'BRETONNET','AUGUSTE','1933-07-03','02.14.67.64.17','06.11.79.43.28',NULL,'205 rue st jean chez mme Bequili','n Monique','','14390','VARAVILLE',NULL,NULL,'1330714490002',1438.000000000,'1956-02-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7544,'HAUSKNOST','CHANTAL','1959-06-21',NULL,NULL,NULL,'40 AV ALBERT 1ER','','','14990','BERNIERES SUR MER',NULL,NULL,'1590614039002',3567.000000000,'1981-06-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7545,'LEMARCHAND','PASCAL','1934-05-26','02.70.30.42.15','06.24.05.46.19',NULL,'','','','14630','FRENOUVILLE',NULL,NULL,'2340550348002',52.000000000,'1963-08-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7546,'CHANDELIER','EUGENIE','1929-01-06','02.45.50.93.45','06.65.36.36.29',NULL,'5 Impasse Albert Calmus','','','14500','ST GERMAIN DE TALLEVENDE',NULL,NULL,'1290114327002',178.000000000,'1951-03-23','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7547,'LECONTE','LEON','1962-12-29','02.76.44.12.37','06.16.92.15.18',NULL,'11 IMPASSE DES PRES','','','50820','BRIX',NULL,NULL,'2621214659002',26.000000000,'1987-07-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7548,'RICHIER','LEVAN','1956-01-30','03.14.58.87.60','06.11.89.94.05',NULL,'16 route esnil','','','21120','VERNOT',NULL,NULL,'1560161006002',151.000000000,'1979-09-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7549,'SAINT REQUIER','LYDIE','1964-06-30','02.90.13.95.25','06.10.89.65.29',NULL,'1 rue de l''ile de france','','','14320','FONTENAY LE MARMION',NULL,NULL,'1640614143002',28.000000000,'1993-03-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7550,'COTINEAU','ODILE','1960-02-21','02.70.88.42.37','06.73.53.42.37',NULL,'LA CORNICHE DU MONT CANISY RUE D','E LASSAY','','14120','MONDEVILLE',NULL,NULL,'2600278030002',136.000000000,'1981-04-23','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7551,'DANET','JEAN CLAUDE','1940-10-10','02.36.35.62.30','06.56.78.79.18',NULL,'4 RUE DE LA POSTE','','','14570','ST LAMBERT',NULL,NULL,'2401014119002',153.000000000,'1963-07-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7552,'ALEXANDRE','CLAUDINE','1941-01-28','02.34.23.11.53','06.63.99.36.10',NULL,'9 RUE ABBE LEROY','','','14000','CAEN',NULL,NULL,'1410150567002',20.000000000,'1965-02-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7553,'DURAND','JEAN PIERRE','1951-04-25','02.15.26.54.76','06.59.51.73.09',NULL,'57 RUE ARMAND MARIE','','','14120','MONDEVILLE',NULL,NULL,'2510414573002',620.000000000,'1979-07-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7554,'LEBRETON','REGINE','1934-09-11','02.46.29.70.70','06.64.83.37.53',NULL,'8 rue de la liberation','','','14000','CAEN',NULL,NULL,'1340961283002',47.000000000,'1958-08-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7555,'PHILIPPON','DANIEL','1965-05-30','02.96.18.07.43','06.11.83.56.63',NULL,'5 RUE DES BOULEAUX','','','14670','ST PIERRE DU JONQUET',NULL,NULL,'1650514118002',409.000000000,'1991-08-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7556,'LETOURNEL','MONIQUE','1932-05-24','02.70.18.01.42','06.65.60.06.04',NULL,'301 QUARTIER DE LA HAUTE FOLIE','','','14320','FONTENAY LE MARMION',NULL,NULL,'2320561408002',65.000000000,'1953-10-13','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7557,'DELAUNEY','SYLVIANE','1938-06-20','02.38.78.20.85','06.38.05.38.67',NULL,'RUE DE HIEVILLE','','','61200','ARGENTAN',NULL,NULL,'2380614327002',495.000000000,'1965-06-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7558,'MARIE','Marcel','1931-01-28','02.10.72.03.95','06.21.68.05.10',NULL,'LOTISSEMENT LES HAIES VIVES','','','14260','ST GEORGES D''AUNAY',NULL,NULL,'2310114114002',43.000000000,'1957-08-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7559,'','CHARLES','1938-12-24','02.38.06.02.41','06.92.19.25.60',NULL,'11 rue Urbain Lefrancois','','','14000','CAEN',NULL,NULL,'1381214479002',2.000000000,'1968-06-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7560,'DUREL','MARGUERITE','1939-10-17','02.25.12.10.12','06.99.40.29.22',NULL,'7 RUE D''IVRY BRIDGE','','','14123','IFS',NULL,NULL,'1391009167002',194.000000000,'1965-10-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7561,'DESMEULLES','MONIQUE','1931-12-10','02.67.83.63.19','06.77.09.17.88',NULL,'LES LEUDETS','','','14320','LAIZE LA VILLE',NULL,NULL,'1311235215002',34.000000000,'1954-07-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7562,'RENAULT','EVELYNE','1963-03-02','02.87.26.34.90','06.45.68.98.26',NULL,'32 RUE AMIRAL COURBET','','','14570','ST REMY',NULL,NULL,'2630314271002',1326.000000000,'1984-11-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7563,'GUESNON','THIERRY','1928-07-18',NULL,NULL,NULL,'3 PASSAGE DES JACOBINS','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'1280714167002',160.000000000,'1953-07-15','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7564,'GERARD','JEAN','1953-04-15','02.98.28.93.19','06.89.84.09.37',NULL,'7 RUE DU MESNIL','','',NULL,NULL,NULL,NULL,'1530478675002',18.000000000,'1976-09-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7565,'DECAEN','RAPHAELE','1950-03-21','02.53.58.25.99','06.76.34.97.73',NULL,'1 RUE HENRI VAILLANT','','','14730','GIBERVILLE',NULL,NULL,'1500314374002',732.000000000,'1971-05-24','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7566,'DIDIER','MARGUERITE','1935-10-22','02.56.11.71.84','06.49.10.72.94',NULL,'ALMENECHES','','','14000','CAEN',NULL,NULL,'2351014062002',740.000000000,'1963-04-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7567,'LEPROVOST','ISABELLE','1949-04-21','02.41.82.15.39','06.81.24.85.24',NULL,'189 ROUTE DE PARIS','','','14000','CAEN',NULL,NULL,'1490414148002',3270.000000000,'1978-05-22','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7568,'COCU','JACQUES','1961-09-21','02.38.65.12.88','06.23.27.34.13',NULL,'9/2 CITE DU CALVAIRE','','','14330','LE MOLAY LITTRY',NULL,NULL,'2610999151002',564.000000000,'1991-11-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7569,'LECORNEC','CHANTAL','1934-04-20','02.44.45.79.23','06.80.31.38.48',NULL,'28  RUE GEORGES BRUMMEL','','','14370','CHICHEBOVILLE',NULL,NULL,'1340414085002',1541.000000000,'1958-11-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7570,'PROD HOMME','CAMILLE','1957-01-17','02.85.05.41.22','06.33.63.11.00',NULL,'1 RUE DES ACACIAS','','','14120','MONDEVILLE',NULL,NULL,'2570114396002',67.000000000,'1985-02-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7571,'NIARD','CLAUDE','1944-06-05','02.53.46.39.93','06.52.34.56.89',NULL,'4 RUE DES PLATANES','','','14370','AIRAN',NULL,NULL,'2440618194002',15.000000000,'1969-12-09','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7572,'NIARD','ANDRE','1963-01-19','02.10.02.79.18','06.28.16.68.22',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'1630199255002',45.000000000,'1984-04-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7573,'ROUSSEAU','GINETTE','1931-07-09','02.54.14.08.40','06.91.00.69.03',NULL,'12 RUE DE LA CHENEVOTTE','','','14000','CAEN',NULL,NULL,'2310750183002',27.000000000,'1957-05-27','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7574,'NOEL','JACQUES','1951-01-11','02.93.90.07.39','06.30.08.48.98',NULL,'9 RUE DE L'' EPINE','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1510114102002',719.000000000,'1973-07-25','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7575,'HAYS','DENISE','1931-10-19','02.55.68.57.61','06.52.84.18.47',NULL,'','','','14400','ST VIGOR LE GRAND',NULL,NULL,'1311044197002',288.000000000,'1954-05-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7576,'ANDRE','MICHEL','1958-03-31','02.38.22.02.29','06.14.56.66.27',NULL,'10 RUE DU MUGUET','','','14860','RANVILLE',NULL,NULL,'2580361402002',72.000000000,'1988-10-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7577,'GALLOT','SIMONE','1931-01-20','02.50.10.39.79','06.76.45.45.29',NULL,'','','','14540','GRENTHEVILLE',NULL,NULL,'2310161451002',32.000000000,'1954-06-14','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7578,'LEPETIT','LUCIENNE','1933-04-28','02.58.11.71.80','06.64.47.69.35',NULL,'40 RUE DE  BONNEVILLE','','','61210','HABLOVILLE',NULL,NULL,'1330486293002',157.000000000,'1957-06-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7579,'COCHON','ELISABETH',NULL,'02.10.11.17.39','06.26.01.76.73',NULL,'5 place des bleuets','','','14123','IFS',NULL,NULL,'2350614504002',1376.000000000,'2013-08-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7580,'LEMIEUX','PHILIPPE','1942-10-28','02.91.50.82.62','06.51.63.31.43',NULL,'15 rue lucien bossoutrot','','','14000','CAEN',NULL,NULL,'2421014009002',373.000000000,'1964-05-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7581,'LECHEVALLIER','RENE','1959-01-02','02.16.38.04.14','06.21.36.72.46',NULL,'1 route de bayeux','','','14140','LIVAROT',NULL,NULL,'2590114685002',2452.000000000,'1987-06-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7582,'YVERT','JANINE','1929-08-26','02.96.46.25.21','06.55.30.76.10',NULL,'RUE DES FRERES CHAPPE','','','92110','CLICHY',NULL,NULL,'1290814342002',834.000000000,'1952-11-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7583,'RENAULT','RAYMONDE','1933-03-24','02.58.68.46.54','06.99.45.61.59',NULL,'1 chemin de la cavee','','','14123','IFS',NULL,NULL,'2330314656002',10.000000000,'1961-07-01','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7584,'VEYSSEIRE','MURIELLE','1935-01-31','02.86.97.12.52','06.30.02.64.03',NULL,'12 rue franklin','','','14850','ESCOVILLE',NULL,NULL,'2350114437002',148.000000000,'1957-05-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7585,'BRENNAN','LALI','1954-10-22','02.11.62.30.20','06.10.92.09.35',NULL,'HAMEAU DE JOUETTE','','','14270','MEZIDON CANON',NULL,NULL,'1541014491002',251.000000000,'1978-12-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7586,'HAVEL','SYLVIE','1953-05-12','02.83.63.32.10','06.12.25.30.73',NULL,'RUE DES CANADIENS','','','14370','ARGENCES',NULL,NULL,'1530514634002',70.000000000,'1976-01-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7587,'GROSSE','FABRICE','1942-05-26','02.66.32.61.76','06.95.29.04.32',NULL,'38 RUE DE LA SEINE','','','14000','CAEN',NULL,NULL,'1420514508002',112.000000000,'1966-01-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7588,'COUPPEY','HELENE','1936-05-15','02.31.91.91.71','00 33 6.26.76.10.32',NULL,'933 BD DES BELLES PORTES','','','14190','BRETTEVILLE LE RABET',NULL,NULL,'1360514594002',735.000000000,'1966-11-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7589,'HARDOUIN','RENE','1936-05-16','02.70.08.58.98','06.10.23.92.88',NULL,'10 RUE PASTEUR','','','14420','POTIGNY',NULL,NULL,'1360514594002',41.000000000,'1959-11-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7590,'DEJONGHE','PIERRE','1948-05-09','02.23.18.21.83','06.23.68.68.11',NULL,'120 ROUTE DE RUGLES','','','14730','GIBERVILLE',NULL,NULL,'2480514709002',4248.000000000,'1973-08-22','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7591,'HAIZE','GAETAN','1931-07-23','02.49.39.16.03','06.86.18.01.69',NULL,'CHEMIN DIT AUX MALADES','','','14770','LE PLESSIS GRIMOULT',NULL,NULL,'2310714020002',10.000000000,'1955-04-30','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7592,'AGNES','MICHEL','1954-08-26','02.33.45.91.73','06.17.76.85.43',NULL,'15 cote du val','','','50750','DANGY',NULL,NULL,'1540814520002',609.000000000,'1977-03-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7593,'BELLISSENT','ERIC','1959-05-05','02.86.33.17.21','06.72.30.02.69',NULL,'','','','14540','SOLIERS',NULL,NULL,'1590514673002',172.000000000,'1981-05-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7594,'FREMONT','LUCIENNE','1938-09-22','02.38.06.75.36','06.97.63.00.31',NULL,'10 rue de Goupy','','','14000','CAEN',NULL,NULL,'2380914397002',11.000000000,'1964-07-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7595,'BIDAULT','CHANTAL','1937-01-28','02.10.61.67.33','06.10.74.82.86',NULL,'7 RUE PASTEUR','','','61170','LE PLANTIS',NULL,NULL,'1370162217002',363.000000000,'1965-06-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7596,'VAN VLIERBERGHE','ROGER','1969-05-19','02.51.12.21.45','06.12.58.15.87',NULL,'LA JALOUSIE','','','14220','CULEY LE PATRY',NULL,NULL,'1690511114002',137.000000000,'1992-06-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7597,'THOMANN','martine','1966-02-22','02.60.69.17.02','06.59.21.68.95',NULL,'10 RUE DES SPORTS','','','14540','SOLIERS',NULL,NULL,'2660214366002',10.000000000,'1996-09-01','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7598,'BALSAC','MARIE CLAIRE','1932-08-17','02.29.89.30.76','06.88.30.29.20',NULL,'1 rue parsifal','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1320814409002',4035.000000000,'1955-12-12','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7599,'LEDOUX','joel','1954-09-10','02.40.18.03.63','06.72.95.38.34',NULL,'1 ALLEE DES ORMES','','','14120','MONDEVILLE',NULL,NULL,'2540914358002',709.000000000,'1982-02-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7600,'LANDRY','ERIC','1935-01-23','02.23.83.46.69','06.32.15.38.64',NULL,'31 RUE DU GENERAL LECLERC','','','14120','MONDEVILLE',NULL,NULL,'1350114366002',3060.000000000,'1964-09-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7601,'SANDRET','DAVID','1932-12-20','02.85.42.68.20','06.31.13.58.46',NULL,'LA MAIZERAIS','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'1321214705002',999.000000000,'1961-01-27','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7602,'SURIRAY','MARGUERITE','1934-01-14','02.93.64.02.31','06.24.04.49.36',NULL,'21 route de bretagne','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'2340114727002',641.000000000,'1957-07-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7603,'MOUTON','RENE','1965-12-02','02.76.39.27.32','06.85.45.18.14',NULL,'4 RUE DE L''ESPERANCE','','','14000','CAEN',NULL,NULL,'2651214537002',3.000000000,'1986-05-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7604,'BOSQUILLON DE JENLIS','MARIE-JEANNE','1940-09-19','02.60.96.44.95','06.51.13.40.01',NULL,'12 ALLEE DES POETES','','','14120','MONDEVILLE',NULL,NULL,'2400914133002',3.000000000,'1965-04-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7605,'PITOIS','Joseph','1941-08-19','02.74.21.36.90',NULL,NULL,'13 RUE EDOUARD VAILLANT','','','14000','CAEN',NULL,NULL,'2410814118002',1139.000000000,'1962-02-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7606,'PORET','JACQUES','1970-10-07','02.10.32.60.37','06.57.92.78.16',NULL,'27 rue de la cite liberee','','','14970','BENOUVILLE',NULL,NULL,'1701099380002',74.000000000,'2000-08-21','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7607,'PERETTI','JACQUELINE','1931-05-05','02.72.28.75.78','06.80.12.69.17',NULL,'app 12 13 rue st quentin','','','14270','MEZIDON CANON',NULL,NULL,'2310514290002',23.000000000,'1958-08-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7608,'','JEAN MARIE','1940-09-25','02.10.65.96.12','06.13.11.46.49',NULL,'46 rte d''ifs','','','14630','CAGNY',NULL,NULL,'2400914277002',28.000000000,'1964-12-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7609,'POTTIER','MADELEINE','1950-01-18','02.32.23.97.43','06.47.88.16.42',NULL,'58 ROUTE DE PARIS','','','14000','CAEN',NULL,NULL,'2500150282002',652.000000000,'1977-01-17','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7610,'POTTIER','FRANCOISE','1932-07-05','02.62.88.35.84','06.83.81.77.15',NULL,'91 rue jean jaurres','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'2320714689002',290.000000000,'1955-04-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7611,'HAMELIN','NICOLE','1971-05-04','02.94.21.48.44','06.57.84.78.81',NULL,'3 rue du languedoc','','','14770','CAUVILLE',NULL,NULL,'2710599255002',62.000000000,'1995-01-31','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7612,'TIREL','JEAN','1957-02-16','02.23.07.09.64','06.20.14.81.24',NULL,'LA FREGERE','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2570214670002',684.000000000,'1979-07-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7613,'HANGUEHARD','JEAN','1942-02-08','02.55.05.79.05','06.29.85.16.04',NULL,'8 RUE DU ROSEL','','','14680','GIBERVILLE',NULL,NULL,'1420250311002',1347.000000000,'1965-08-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7614,'TOPIC','MARIE THERESE','1922-12-21','02.70.84.79.71','06.28.90.71.13',NULL,'1D RUE PIERRE GRINGOIRE','','','14840','DEMOUVILLE',NULL,NULL,'1221214118002',211.000000000,'1947-08-05','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7615,'LORPHELIN','SYLVIANE','1928-08-01','02.12.10.27.63','06.10.10.19.88',NULL,'7 passage varin','','','14000','CAEN',NULL,NULL,'2280814157002',16.000000000,'1949-06-02','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7616,'FREMONT','GISELE','1936-01-01','02.80.56.15.52','06.24.37.70.12',NULL,'194 rue d''auge','','','14690','PIERREFITTE EN CINGLAIS',NULL,NULL,'2360114169002',448.000000000,'1963-11-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7617,'OLLIVIER','LAURENT',NULL,'02.47.41.53.58','06.22.91.04.30',NULL,'9 rue des Oiseaux','','','14000','CAEN',NULL,NULL,'1510350191002',191.000000000,'2013-06-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7618,'ISABEL','REGINE','1947-06-08','02.54.63.30.71','06.21.38.55.57',NULL,'18 RUE GUY DE MAUPASSANT','','','14490','ST PAUL DU VERNAY',NULL,NULL,'1470661018002',530.000000000,'1969-07-20','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7619,'DRIQUERT','LAURENCE','1931-05-11','02.74.48.43.17',NULL,NULL,'30 RUE DES BELLES VUES','','','14123','IFS',NULL,NULL,'2310522225002',2810.000000000,'1957-08-21','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7620,'OUSMAN','ODETTE','1951-01-24','02.98.79.45.53','06.26.54.86.44',NULL,'1 PLACE SCHOEFFER','','','14460','GIBERVILLE',NULL,NULL,'1510176495002',240.000000000,'1972-03-12','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7621,'TASSIN','COLETTE','1931-08-15','02.34.73.59.65','06.79.78.72.71',NULL,'20 RUE PIERROTS','','','27300','BERNAY',NULL,NULL,'1310814101002',41.000000000,'1961-10-17','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7622,'LEREBOURG','jean rene','1935-01-11','02.10.39.83.42','06.78.84.64.39',NULL,'SOUS LES JAUNETS','','','14210','EVRECY',NULL,NULL,'1350161486002',50.000000000,'1956-06-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7623,'BROCHET','ALAIN','1947-02-04','02.52.13.32.01','06.47.67.41.72',NULL,'29 RUE LOUVIERE','','','14000','CAEN',NULL,NULL,'1470214719002',343.000000000,'1977-03-03','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7624,'VEROLLE','','1967-08-22','02.81.88.97.78','06.23.99.04.76',NULL,'13 RUE ALEXANDRE','','','14620','CROCY',NULL,NULL,'2670861218002',94.000000000,'1991-05-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7625,'MEZIERES','LEONE','1946-04-14','02.37.73.20.32','06.28.12.50.61',NULL,'26 RUE DE L ANGANERIE','','','14270','VIEUX FUME',NULL,NULL,'2460414252002',161.000000000,'1976-02-09','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7626,'DESCAMPS','FREDERIC','1942-01-07','02.10.83.83.74',NULL,NULL,'1 RUE DU MABRET','','','14000','CAEN',NULL,NULL,'2420141101002',151.000000000,'1964-06-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7627,'PARIS','CELESTIN','1934-11-10','02.86.74.60.67',NULL,NULL,'27 rue aristide briand','','','14000','CAEN',NULL,NULL,'2341114654002',3601.000000000,'1960-02-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7628,'MAHIEU','ROBERT','1946-03-22','02.83.02.29.87','06.96.88.53.68',NULL,'29 RUE D''AMOZANNE','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'2460327214002',25.000000000,'1967-08-29','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7629,'SOVA','JACQUELINE','1930-12-22','02.91.10.22.14','06.62.23.86.20',NULL,'9 PLACE DE LA PREVOYANCE','','','14270','MEZIDON CANON',NULL,NULL,'1301214359002',43.000000000,'1952-07-07','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7630,'ROUX','MARIE EDITH','1928-09-02','02.64.80.55.96','06.75.94.68.33',NULL,'1 rue des Champs','','','14000','GIBERVILLE',NULL,NULL,'1280953185002',83.000000000,'1950-08-07','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7631,'DESMAISONS','ALAIN','1960-11-22',NULL,NULL,NULL,'8 rue jean bapt luly','','','14123','IFS',NULL,NULL,'2601114316002',602.000000000,'1987-05-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7632,'LEBISSONNAIS','DIDIER','1960-09-03','02.73.49.17.36','06.12.27.42.38',NULL,'4 RUE DU PRESIDENT COTY','','','14850','HEROUVILLETTE',NULL,NULL,'1600914640002',126.000000000,'1985-02-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7633,'BIZHAM','PASCAL','1938-03-20','02.43.03.01.69','06.78.51.31.30',NULL,'90 RUE DE LA CHAPELLE','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'1380314309002',1116.000000000,'1961-02-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7634,'GRIN','ODILE','1955-05-18','02.69.02.73.81','06.10.64.11.62',NULL,'10 rue sully','','','14150','OUISTREHAM',NULL,NULL,'1550514665002',47.000000000,'1983-09-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7635,'ALEXANDRE','DANIELLE','1946-04-12','02.25.75.15.71','06.20.90.02.20',NULL,'42 rue de l''eglise','','','14400','BAYEUX',NULL,NULL,'2460478590002',308.000000000,'1973-03-25','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7636,'ALEXANDRE','JEANNINE','1928-01-12','02.46.86.79.28','06.44.16.75.05',NULL,'11 rue elsa triolet','','','14000','GIBERVILLE',NULL,NULL,'2280114345002',1286.000000000,'1954-04-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7637,'DEROUET','JOSETTE','1930-12-09','02.58.59.97.60','06.34.10.73.65',NULL,'22 RUE JARDIN BARBEY','','','61200','ARGENTAN',NULL,NULL,'2301214133002',92.000000000,'1955-07-19','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7638,'FERRUT','FRANCIS','1935-10-26','02.41.35.46.40','06.45.30.85.74',NULL,'10 rue Constant Forget','','','14400','BAYEUX',NULL,NULL,'1351014379002',692.000000000,'1965-04-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7639,'GUILBERT','JACQUES','1950-06-29','02.58.83.71.51','06.72.20.67.98',NULL,'10 Alle Maurice Rousseau','','','14000','CAEN',NULL,NULL,'2500614636002',21.000000000,'1973-09-17','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7640,'LECLAIRE','JEAN CLAUDE','1969-11-11',NULL,NULL,NULL,'1 CHEMIN DES VICTOIRES','','','14000','CAEN',NULL,NULL,'2691194058002',175.000000000,'1995-08-22','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7641,'MARIE','SIMONE','1931-01-17','02.55.19.07.60','06.77.48.51.89',NULL,'6 rue des bons enfants','','','14220','HAMARS',NULL,NULL,'1310114191002',20.000000000,'1953-09-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7642,'','NICOLE','1953-02-06','02.85.39.24.25','06.73.70.42.65',NULL,'6 RUE DU CHATEAU','','','14400','BAYEUX',NULL,NULL,'1530214038002',20.000000000,'1976-02-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7643,'FONTENIT','JEAN-EMMANUEL','1933-05-03','02.59.25.93.24','06.58.23.89.25',NULL,'7.rue de l esperance','','','14270','MEZIDON CANON',NULL,NULL,'2330553003002',9.000000000,'1963-10-27','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7644,'BOULIN','RENE','1933-06-19','02.59.92.63.08','06.65.83.69.34',NULL,'16 RUE DU 18 JUILLET','','','14210','NOYERS BOCAGE',NULL,NULL,'2330614258002',268.000000000,'1959-12-23','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7645,'','ANDRE','1933-02-16','02.95.90.13.98','06.10.26.66.06',NULL,'40 RUE ANDRE LEMAITRE','','','14400','ST VIGOR LE GRAND',NULL,NULL,'2330241051002',586.000000000,'1959-02-10','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7646,'ENGUEHARD','JEAN','1940-01-14','02.57.19.69.82','06.41.64.78.94',NULL,'20 rue de bretagne','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2400114174002',38.000000000,'1963-05-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7647,'LEROY','bruno','1936-08-29','02.40.50.00.04','06.11.50.73.83',NULL,'14 RUE KALINIGRENKO','','','61200','ARGENTAN',NULL,NULL,'2360859368002',101.000000000,'1966-11-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7648,'LANGLOIS','','1955-03-22','02.83.90.81.36','06.82.74.62.92',NULL,'BEAU L''EVEQUE','','','14280','AUTHIE',NULL,NULL,'2550314396002',44.000000000,'1982-02-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7649,'GIFFARD','RENE','1955-07-05','02.19.87.92.66','06.59.41.46.67',NULL,'33 rue de bernieres','','','14370','MOULT',NULL,NULL,'1550714753002',39.000000000,'1976-08-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7650,'CARRILLO','PASCAL','1955-04-08','02.88.01.04.65','06.20.27.79.44',NULL,'Les Masses','','','14111','LOUVIGNY',NULL,NULL,'1550414545002',1475.000000000,'1976-07-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7651,'HEUDRON','MARGUERITE','1929-09-03','02.59.18.19.71','06.27.25.02.86',NULL,'LE FRESNE','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1290914481002',854.000000000,'1957-10-05','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7652,'BOUVIER','PATRICK','1936-03-13','02.12.48.58.61','06.29.74.48.81',NULL,'12 CITE DES CLOS','','','14120','MONDEVILLE',NULL,NULL,'1360314410002',101.000000000,'1961-12-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7653,'FANET','ANDRE','1949-01-19','02.58.01.43.00','06.72.81.85.35',NULL,'11 rue albert de mun','','','14123','FLEURY SUR ORNE',NULL,NULL,'1490114656002',27.000000000,'1979-11-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7654,'COLLET','RENE','1940-04-13','02.21.61.53.52','06.11.12.36.52',NULL,'29 rue de bouvines','','','14570','ST REMY',NULL,NULL,'1400435269002',8.000000000,'1967-10-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7655,'ALEXANDRE','RENE','1960-09-03','02.52.93.51.25','06.64.96.86.23',NULL,'17 rue de St Sulpice','','','14000','CAEN',NULL,NULL,'2600914536002',382.000000000,'1987-08-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7656,'ALEXANDRE','CATHERINE','1936-01-07','02.98.36.51.66','06.17.83.30.55',NULL,'4 rue d''audrieu','','','14370','ARGENCES',NULL,NULL,'2360112164002',2809.000000000,'1964-09-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7657,'BRETONNET','RENEE','1931-09-18','02.59.92.44.67','06.49.55.11.45',NULL,'4 BIS RUE MARCEL LEMERAY','','','14880','HERMANVILLE SUR MER',NULL,NULL,'1310927056002',2588.000000000,'1955-02-03','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7658,'FERAY','GISELE','1937-07-26','02.12.10.40.56','06.84.88.91.82',NULL,'6 RUE AUX DIMES','','','14120','MONDEVILLE',NULL,NULL,'2370714129002',565.000000000,'1962-11-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7659,'ENAULT','THERESE','1937-06-23','02.71.60.05.88','06.55.29.08.03',NULL,'29 rue gustade','','','14220','THURY HARCOURT',NULL,NULL,'2370650465002',3696.000000000,'1959-02-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7660,'SIBRAN','THERESE','1929-06-12','02.11.07.48.94','06.20.49.77.93',NULL,'3 RUE DU DCT AUVRAY','','','14260','ST GEORGES D''AUNAY',NULL,NULL,'2290614027002',301.000000000,'1953-08-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7661,'LETELLIER','MICHEL','1961-04-22','02.84.39.38.94','06.48.18.77.65',NULL,'LA GRANDE BRUYERE','','',NULL,NULL,NULL,NULL,'1610414167002',32.000000000,'1983-07-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7662,'PAPILLON','JEAN MICHEL','1937-08-28','03.51.99.24.33','06.79.90.90.63',NULL,'900 RUE DU BOCAGE','','','80430','BEAUCAMPS LE VIEUX',NULL,NULL,'2370850243002',132.000000000,'1964-12-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7663,'CLOUET','GIOVANNINA','1947-02-13','02.14.48.71.53','06.64.21.21.63',NULL,'avenue des cloustiers','','','14420','POTIGNY',NULL,NULL,'1470214554002',42.000000000,'1970-03-02','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7664,'ETOURMY','DENISE','1929-04-17','02.79.91.42.35','06.76.83.99.27',NULL,'ROUTE DE MAGNY LE FREULE','','','14000','CAEN',NULL,NULL,'1290477051002',4.000000000,'1952-06-11','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7665,'METIVIER','JACQUES','1928-11-18','02.78.25.67.78','06.10.78.15.01',NULL,'12 rue du port','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2281114260002',96.000000000,'1955-09-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7666,'DARAGONT','ANDREE','1928-02-12','02.77.37.17.74',NULL,NULL,'2 rue de la libertee','','','14000','CAEN',NULL,NULL,'2280261104002',98.000000000,'1951-03-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7667,'RIOU','HERVE','1934-04-20','02.10.78.28.34','06.11.58.66.40',NULL,'5 RUE DES FLEURS','','','14000','CAEN',NULL,NULL,'2340462588002',1203.000000000,'1957-11-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7668,'PERICHET','DIDIER','1958-07-11','02.48.63.88.84','06.13.15.27.23',NULL,'11 rue Jacques Cartier','','','14940','TOUFFREVILLE',NULL,NULL,'2580714394002',28.000000000,'1980-08-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7669,'SUZANNE','PAUL','1945-03-09','02.44.93.20.21','06.27.50.74.43',NULL,'11 ROUTE DE LAIZE','','','14730','GIBERVILLE',NULL,NULL,'1450361339002',18.000000000,'1973-01-13','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7670,'DEVILLE','BRIGITTE','1958-01-10','02.40.48.51.65','06.75.51.07.29',NULL,'LIEU DIT"GIBERVILLE"','','','14630','CAGNY',NULL,NULL,'2580114074002',118.000000000,'1987-02-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7671,'LECOSTEY','CHRISTIAN','1958-07-14','02.82.50.91.36','06.82.43.12.05',NULL,'14 rue r valognes','','','14520','STE HONORINE DES PERTES',NULL,NULL,'2580714294002',98.000000000,'1982-11-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7672,'CRESPIN','CHRISTIAN','1942-02-08','02.12.29.74.61',NULL,NULL,'HAMEAU LE LONDIN','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2420214254002',333.000000000,'1968-11-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7673,'BROUT','JEANINE','1929-08-24','02.11.14.85.66','06.50.34.74.84',NULL,'233 rue de Falaise','','','14100','LISIEUX',NULL,NULL,'1290860313002',32.000000000,'1953-01-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7674,'BISSONNET','CHRISTIAN','1953-06-11','02.67.43.25.84','06.36.41.61.29',NULL,'9 c rue chapron','','','14540','BOURGUEBUS',NULL,NULL,'1530661292002',147.000000000,'1983-07-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7675,'','JEANINE','1968-01-07','02.79.14.83.95','06.27.20.88.96',NULL,'LE LION D OR','','','14000','CAEN',NULL,NULL,'2680114623002',322.000000000,'1998-05-12','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7676,'DELAUNAY','MICHEL','1942-01-18','02.90.01.21.31','06.82.36.81.36',NULL,'21 rue Pierre Villey','','','14123','IFS',NULL,NULL,'1420114228002',1460.000000000,'1966-01-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7677,'LEBAILLY','REMI','1942-02-22','02.67.55.22.87','06.25.49.27.80',NULL,'6 RUE DU CLOS NEUF','','','14000','CAEN',NULL,NULL,'1420261319002',55.000000000,'1964-02-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7678,'LAMBIN','JOCELYNE','1930-09-29','02.36.27.87.76','06.36.86.12.56',NULL,'41 AVENUE DU 6 JUIN','','','14120','MONDEVILLE',NULL,NULL,'2300961177002',487.000000000,'1960-03-07','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7679,'MARSALLON','JEAN','1939-08-13','02.32.10.65.93','06.73.55.49.21',NULL,'LA POUSSINIERE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2390850500002',391.000000000,'1963-08-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7680,'LE PAIH','GILLES','1929-07-15','02.35.81.56.24','06.48.00.23.51',NULL,'50 AVENUE DE L''EUROPE','','','14730','GIBERVILLE',NULL,NULL,'2290753083002',328.000000000,'1957-06-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7681,'FEREY','NOEL','1933-05-24','02.10.14.58.68','06.34.18.11.35',NULL,'8 RUE DU PERON','','','14670','TROARN',NULL,NULL,'1330514655002',12.000000000,'1958-01-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7682,'LE BERRE','MARIE THERESE','1937-04-01','02.50.88.05.38','06.97.40.63.91',NULL,'3 rue paul langevin','','','14100','COURTONNE LA MEURDRAC',NULL,NULL,'1370461455002',3915.000000000,'1961-11-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7683,'VATTIER','GISELE','1928-11-05','02.10.84.09.41','06.12.15.23.09',NULL,'13 RUE CAILLEMER','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1281161251002',671.000000000,'1949-07-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7684,'FONNARD','CLAUDE','1931-05-09','02.37.79.67.92','06.11.66.17.72',NULL,'2 AVENUE DE LA MER','','','14540','SOLIERS',NULL,NULL,'2310514392002',1864.000000000,'1961-12-17','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7685,'BETTIN','MONIQUE','1937-04-01','02.19.79.17.95','06.64.26.79.82',NULL,'12 rue guillaume le conquerant','','','14000','CAEN',NULL,NULL,'2370414626002',3431.000000000,'1960-06-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7686,'GALLIER','JOSEPH','1940-09-19','02.33.14.95.61','06.97.04.43.30',NULL,'1 RESIDENCE DES POMMIERS','','','14680','GOUVIX',NULL,NULL,'1400914587002',845.000000000,'1969-03-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7687,'DUPONT','CLAUDE','1962-01-20','02.10.85.24.48','06.97.54.62.38',NULL,'18 RUE DE FALAISE','','','14630','FRENOUVILLE',NULL,NULL,'2620114020002',39.000000000,'1985-02-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7688,'SEGUY','CHRISTIAN','1965-04-13','02.68.76.24.75','06.86.71.54.68',NULL,'4 rue alfred richet','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2650414036002',49.000000000,'1986-01-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7689,'LEROY','FRANCOISE','1929-05-12','02.86.74.38.57',NULL,NULL,'5 rue paul alene','','','14000','CAEN',NULL,NULL,'2290550431002',993.000000000,'1954-07-14','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7690,'PIGEON','DOMINIQUE','1941-07-22','02.11.57.44.66','06.21.31.84.16',NULL,'14 rue des sabonnettes','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1410714250002',38.000000000,'1968-04-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7691,'BUSNEL','PHILIPPE','1935-02-05','02.51.59.90.15','06.22.04.12.23',NULL,'11 rue de la republique','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1350261103002',34.000000000,'1959-11-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7692,'COQUELLE','NATHALIE','1931-08-02','02.38.71.92.42','06.46.07.04.89',NULL,'1 rue hector berlioz','','','14700','FALAISE',NULL,NULL,'2310814338002',77.000000000,'1961-11-26','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7693,'PICARD','PAULETTE','1965-01-09','02.75.23.32.47','06.64.36.45.83',NULL,'6 route de soliers','','','14310','PARFOURU SUR ODON',NULL,NULL,'2650114167002',650.000000000,'1986-09-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7694,'GUELLE','COLETTE','1939-09-07','02.59.10.85.35','06.88.39.89.06',NULL,'21 RUE DES ECOLES','','','14370','CROISSANVILLE',NULL,NULL,'1390903235002',2.000000000,'1964-01-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7695,'GUILLOU','NICOLAS','1961-08-29','02.11.10.62.30','06.62.42.60.50',NULL,'66 rue du val distrait','','','14330','LE MOLAY LITTRY',NULL,NULL,'1610878326002',216.000000000,'1991-01-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7696,'ISABEL','CORINNE','1936-05-07','02.10.32.25.03','06.71.59.42.23',NULL,'7 rue jean de la varande','','','14123','IFS',NULL,NULL,'2360561199002',769.000000000,'1964-09-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7697,'PINTO','NADINE','1933-09-12','02.42.22.95.44','06.79.75.98.57',NULL,'17 RUE GEMARE','','','14000','CAEN',NULL,NULL,'2330914009002',34.000000000,'1956-08-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7698,'LEROY','JACQUES','1964-08-02','02.14.08.05.84','06.68.89.28.23',NULL,'8 RUE DE LA GRACE DE DIEU','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2640814637002',204.000000000,'1990-10-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7699,'LECOMTE','JEAN','1939-11-09','02.46.12.80.45','06.54.35.11.39',NULL,'24 RUE DES TILLEULS','','','14370','MOULT',NULL,NULL,'1391114407002',28.000000000,'1969-12-08','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7700,'HUYNH','GUY','1911-11-28','02.91.44.08.54','06.50.77.54.30',NULL,'HAMEAU DE BRIE','','','14270','MEZIDON CANON',NULL,NULL,'2111199731002',754.000000000,'1934-01-31','PREMIUM',24,1);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7701,'PATRY','PATRICK','1952-02-02','02.46.53.57.72','06.24.23.19.25',NULL,'7 RUE LIONEL BOCCARD','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1520214628002',700.000000000,'1979-10-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7702,'LEDENTU','ETIENNETTE','1948-01-09','02.66.65.44.42','06.50.42.91.77',NULL,'82 RUE EMILE NIVELET','','','14123','IFS',NULL,NULL,'2480150356002',49.000000000,'1978-08-18','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7703,'BANDRAC','NADINE',NULL,'02.16.21.99.64','06.16.27.91.27',NULL,'11 RUE DE LA POMME','','','61570','BOISSEI LA LANDE',NULL,NULL,'2400314258002',9.000000000,'2013-04-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7704,'THIBAULT','MICHEL','1960-04-03','02.75.82.56.36','06.72.58.99.59',NULL,'15 IMPASSE DU CHATEAU','','','14540','SOLIERS',NULL,NULL,'1600414119002',139.000000000,'1984-02-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7705,'TAMARII','CHRISTIANE','1960-04-07','02.10.49.43.13','06.82.34.99.37',NULL,'5 rue de l''avenir','','','14480','LE FRESNE CAMILLY',NULL,NULL,'1600414119002',1610.000000000,'1988-08-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7706,'ANNE','JULIETTE','1953-05-20','02.76.31.71.80','06.10.97.63.55',NULL,'17 rue  st lo','','','14000','CAEN',NULL,NULL,'1530514688002',16.000000000,'1983-08-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7707,'MARIE DIT HAREL','serge','1953-05-02','02.29.46.13.13','06.53.08.15.83',NULL,'7 RUE PIERRE MENDES FRANCE','','','14123','IFS',NULL,NULL,'1530514688002',591.000000000,'1983-02-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7708,'BOUTROIS','CLAUDINE','1947-06-05','02.84.05.48.84','06.81.37.61.48',NULL,'13 RUE DES GRES','','','14000','CAEN',NULL,NULL,'2470614130002',29.000000000,'1974-02-11','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7709,'JEANNE','BENOIT','1950-11-14','02.79.78.80.55','06.13.18.10.08',NULL,'17 allee des poetes','','','14190','CAUVICOURT',NULL,NULL,'2501114469002',718.000000000,'1976-07-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7710,'FARCY','PAUL','1929-02-25','02.58.08.43.57','06.55.56.25.63',NULL,'52 rue des coteaux','','','14000','CAEN',NULL,NULL,'2290227021002',299.000000000,'1952-08-19','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7711,'GOUSSET','ARNAUD','1937-07-12','02.35.30.03.39','06.11.27.75.54',NULL,'154 blve leroy','','','14270','MEZIDON CANON',NULL,NULL,'1370753151002',556.000000000,'1964-04-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7712,'HERVE','MARCEL PIERRE','1958-03-10','02.57.10.63.09','06.95.94.23.88',NULL,'10.11 BELLES PORTES','','','14000','CAEN',NULL,NULL,'1580350387002',4.000000000,'1982-04-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7713,'NEHOU','DIDIER','1934-06-18','02.39.24.69.04','06.13.31.31.37',NULL,'FERME DE THURIN','','','14120','MONDEVILLE',NULL,NULL,'1340614162002',6.000000000,'1955-08-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7714,'BESNARD','ALBERT','1957-06-26','02.23.37.90.34','06.83.49.33.55',NULL,'2 route de thury','','','14460','COLOMBELLES',NULL,NULL,'2570614034002',394.000000000,'1979-01-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7715,'COLINO','THIERRY','1950-04-02','02.48.47.84.99','06.88.64.08.02',NULL,'1 CHEMIN DE LA VALLEE APT 53','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1500461132002',87.000000000,'1980-07-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7716,'LECOUTEUR','CORINNE','1934-11-30','02.85.27.89.77','06.99.94.09.97',NULL,'18 ALLEE DE LA SAUSSAYE','','','50700','VALOGNES',NULL,NULL,'1341114101002',25.000000000,'1956-01-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7717,'LOCARD','JACQUELINE','1941-06-12','02.31.44.40.32','06.78.02.63.08',NULL,'13 RUE DES GRES','','','14000','CAEN',NULL,NULL,'1410686076002',7.000000000,'1962-07-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7718,'QUERNET','NATHALIE','1969-11-05','02.28.17.71.32','06.57.35.67.66',NULL,'6 ROUTE DE VERT','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'2691150502002',866.000000000,'1999-12-17','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7719,'DUVAL','GILBERT','1947-04-30','02.74.25.08.35',NULL,NULL,'12 rue des fleurs','','','14610','VILLONS LES BUISSONS',NULL,NULL,'1470414289002',179.000000000,'1977-07-21','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7720,'POREE','RENE','1951-01-28','02.12.30.26.17','06.81.57.70.08',NULL,'59 RUE DU QUEBEC','','','14120','MONDEVILLE',NULL,NULL,'2510150099002',214.000000000,'1980-01-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7721,'LEMAROIS','HENRIETTE','1958-11-02','02.44.68.98.19','06.11.34.69.82',NULL,'LA CONTREE','','','14220','ST MARTIN DE SALLEN',NULL,NULL,'2581114366002',342.000000000,'1980-12-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7722,'SAVOYE','MARYLINE','1937-11-22','02.75.43.26.81','06.32.55.67.44',NULL,'33 RUE DE LA GARE','','',NULL,NULL,NULL,NULL,'1371114364002',246.000000000,'1967-05-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7723,'LEROSIER','MICHELINE','1962-08-20','02.70.24.76.43','06.10.76.86.45',NULL,'7 impasse les hauts de ver','','','50000','ST LO',NULL,NULL,'1620814266002',5.000000000,'1988-10-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7724,'LESAULNIER','EVELYNE','1916-12-26','02.49.29.76.79','06.97.95.56.46',NULL,'RES INA  1205 HAUTE  FOLIE','','','14480','RUCQUEVILLE',NULL,NULL,'1161276540002',61.000000000,'1941-04-19','PREMIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7725,'BOURDON','ROLAND','1939-02-20','02.11.40.03.59','06.87.59.45.88',NULL,'LA CALIBOCHE','','','14340','BONNEBOSQ',NULL,NULL,'2390214221002',311.000000000,'1961-12-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7726,'PAUTREL','SOLANGE','1945-07-16','02.24.09.22.78','06.47.98.86.15',NULL,'2006 rue de la Valle','','','14123','IFS',NULL,NULL,'1450714414002',25.000000000,'1969-06-03','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7727,'BINIGUER','',NULL,'02.13.46.97.61','06.43.72.66.94',NULL,'42 rue andre lemaitre','','','14460','COLOMBELLES',NULL,NULL,'2541050229002',26.000000000,'2009-11-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7728,'ROUSSEL','MICHELE','1936-05-12','02.31.64.07.52','06.58.25.36.93',NULL,'107 rue des religieuses','','','14650','CARPIQUET',NULL,NULL,'1360514594002',1970.000000000,'1961-05-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7729,'','guy','1961-12-17','02.61.51.13.37','06.88.91.76.19',NULL,'56 RUE BASSE','','','14000','CAEN',NULL,NULL,'1611214118002',42.000000000,'1982-02-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7730,'OSOUF','FERNANDE','1950-08-25','02.10.83.14.48','06.10.16.69.28',NULL,'43 rue de benauville','','','14680','GOUVIX',NULL,NULL,'1500850191002',413.000000000,'1972-03-20','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7731,'GUELLE','JACQUES','1945-03-01','02.10.27.79.76','06.34.86.12.95',NULL,'18 rue du blanc','','','14840','CUVERVILLE',NULL,NULL,'2450314354002',69.000000000,'1970-05-24','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7732,'MADELAINE','PAULETTE','1955-08-02','02.36.48.04.52','06.21.61.95.96',NULL,'10 rue leon juohaux','','','14540','POUSSY LA CAMPAGNE',NULL,NULL,'1550814010002',55.000000000,'1984-09-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7733,'LESAGE','GERARD','1955-08-03','02.46.52.45.51','06.54.94.72.36',NULL,'22 RUE SAINT GERBOLD','','','14123','IFS',NULL,NULL,'1550814010002',3046.000000000,'1983-06-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7734,'BOURSIN','MARIE-FRANCOISE','1963-07-22','02.95.49.41.04','06.67.26.21.21',NULL,'50 rue de la marne','','','14630','CAGNY',NULL,NULL,'1630714432002',78.000000000,'1990-05-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7735,'SPENDER','RAYMOND','1932-03-05','02.11.54.74.01',NULL,NULL,'47 rue jules ferry','','','14170','ESCURES SUR FAVIERES',NULL,NULL,'2320361303002',600.000000000,'1960-02-06','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7736,'','JOSIANE','1948-06-26','02.13.10.33.48','06.53.74.06.34',NULL,'place pasteur','','','14540','TILLY LA CAMPAGNE',NULL,NULL,'1480614379002',60.000000000,'1972-10-24','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7737,'DUCHE','FRANCINE','1938-07-12','02.68.67.05.52','06.73.30.68.21',NULL,'24 RUE JEAN BOUCARD','','','61300','L''AIGLE',NULL,NULL,'2380750436002',181.000000000,'1961-08-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7738,'LEPETIT','PIERRE','1929-09-28','02.10.25.83.03','06.79.06.83.68',NULL,'6 av pere cg de foucault','','','14540','GRENTHEVILLE',NULL,NULL,'2290914162002',22.000000000,'1951-08-29','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7739,'SIBRAN','louis','1955-08-09','02.58.98.20.54','06.11.63.47.80',NULL,'12 rue albert bayet','','','14220','THURY HARCOURT',NULL,NULL,'2550814470002',12.000000000,'1980-01-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7740,'ONFROY','ANDRE','1956-06-25','02.45.30.20.28','06.11.95.54.40',NULL,'25 BD DU 11 NOVEMBRE','','','14540','HUBERT FOLIE',NULL,NULL,'1560614042002',196.000000000,'1986-09-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7741,'HUET','PATRICIA','1937-01-10','02.11.76.10.60','06.76.93.76.75',NULL,'la bazoque','','','14220','HAMARS',NULL,NULL,'2370153125002',29.000000000,'1962-08-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7742,'LOWE','JULIETTE','1955-02-19','02.65.71.32.96','06.21.46.16.96',NULL,'23 RUE DE LA FORGE','','','14111','LOUVIGNY',NULL,NULL,'1550214277002',81.000000000,'1976-07-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7743,'MARIE','GUY','1930-03-31','02.68.62.93.41','06.92.14.81.51',NULL,'17 RUE DE BRETAGNE','','','50860','LE MESNIL OPAC',NULL,NULL,'2300314708002',720.000000000,'1958-02-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7744,'LEFAUCONNIER','PATRICIA','1928-03-15','02.29.28.23.78','06.29.56.33.82',NULL,'38 AVENUE DU PARC','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2280314257002',578.000000000,'1951-06-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7745,'DOUBLET','MARIE ODILE','1934-12-11','02.37.06.58.93','06.17.61.58.87',NULL,'98 C RUE BRANVILLE','','','14680','GOUVIX',NULL,NULL,'2341260186002',128.000000000,'1962-03-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7746,'LEFRANCOIS','','1968-10-01','02.19.71.44.58','06.45.80.16.28',NULL,'40 RUE DU PATY','','','14700','ERAINES',NULL,NULL,'1681014410002',93.000000000,'1994-11-18','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7747,'ROUSSEL','THERESE','1923-06-29','02.45.56.34.90','06.86.24.60.51',NULL,'SONACOTRA  56 RUE LOUIS ROBILLAR','D','','14500','VIRE',NULL,NULL,'1230615176002',1.000000000,'1947-11-06','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7748,'DESMEULLES','EVELYNE','1957-02-10','02.12.23.55.47','06.45.06.07.69',NULL,'13 RUE PASTEUR','','','14500','VAUDRY',NULL,NULL,'1570214383002',153.000000000,'1982-09-23','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7749,'JANKOWSKI','ANDRE','1951-10-03','02.94.95.59.48','06.50.12.48.05',NULL,'8 RUE MARIVAUX','','','14400','RYES',NULL,NULL,'2511061028002',652.000000000,'1972-01-03','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7750,'BONABAUD','HENRIETTE','1938-03-25','02.30.16.06.56','06.24.90.58.47',NULL,'4 RUE AUX RENARDS','','','14220','CULEY LE PATRY',NULL,NULL,'2380314191002',108.000000000,'1966-08-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7751,'MADELAINE','JACQUELINE','1915-08-24','02.14.29.78.71','06.10.05.84.50',NULL,'9 rue Jules Ferry','','','14540','GRENTHEVILLE',NULL,NULL,'1150871380002',3267.000000000,'1939-12-08','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7752,'CUQUEMELLE','EUGENE','1949-11-18','02.74.29.04.99',NULL,NULL,'6 RUE DES SOURCES','','','14230','ISIGNY SUR MER',NULL,NULL,'1491114541002',2399.000000000,'1973-02-21','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7753,'FIQUET','JEAN','1962-03-14','02.36.42.98.08','06.34.93.76.71',NULL,'91 RUE DES ECOLES','','','14930','MALTOT',NULL,NULL,'1620314294002',3.000000000,'1984-10-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7754,'IMPOSTI','ALAIN','1937-04-21','02.12.31.52.42','06.11.12.92.76',NULL,'6 rue belvedere entree b','','','14370','ARGENCES',NULL,NULL,'2370414303002',92.000000000,'1960-11-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7755,'SURIRE','MARIE LOUISE','1940-10-10','02.85.75.55.15','06.68.92.94.73',NULL,'9 AVENUE GRAL LAPERRINE','','','14000','CAEN',NULL,NULL,'1401014432002',526.000000000,'1965-05-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7756,'BOURHIS','THERESE','1935-10-24','02.27.57.99.16','06.66.02.43.97',NULL,'16 RUE EDITH PIAF','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2351014235002',324.000000000,'1961-12-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7757,'MENGUY','BERNARD','1933-12-13','02.39.49.92.67','06.33.52.38.69',NULL,'6 bvd isaac rabine','','','14000','CAEN',NULL,NULL,'1331214145002',25.000000000,'1957-04-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7758,'LEBRETON','BERNARD','1933-07-10','02.19.85.26.58','06.54.35.86.31',NULL,'10 RUE RENE ROLAND','','','14730','GIBERVILLE',NULL,NULL,'1330714462002',148.000000000,'1956-10-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7759,'VIMOND','JEAN','1938-07-22','02.10.38.50.12','06.11.15.69.44',NULL,'32 RUE DES LONGS BOSQUETS','','','14000','CAEN',NULL,NULL,'1380761376002',20.000000000,'1968-11-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7760,'VAUSSY','MARIE THERESE','1952-03-09','02.42.01.50.76','06.78.91.20.75',NULL,'le bourg','','','14000','CAEN',NULL,NULL,'1520314078002',306.000000000,'1980-10-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7761,'DJIBO','JEAN','1935-06-27','02.31.10.67.86','06.99.88.69.09',NULL,'LIEU DIT NIDALO','','','14370','CROISSANVILLE',NULL,NULL,'2350650123002',1360.000000000,'1963-11-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7762,'DAUGE','BERNARD','1930-10-10','02.10.74.23.61',NULL,NULL,'7 rue de la liberation','','','14670','TROARN',NULL,NULL,'2301050404002',4.000000000,'1955-04-24','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7763,'BRICOTE','BERNARD','1935-01-28','02.59.35.63.39','06.61.34.94.03',NULL,'11 RUE VARIN','','','50000','ST LO',NULL,NULL,'1350114659002',693.000000000,'1957-03-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7764,'HUARD','GUY','1969-10-22','02.36.37.22.50','06.55.65.16.48',NULL,'692 CHEMIN DU VAL','','','14120','MONDEVILLE',NULL,NULL,'2691078311002',139.000000000,'1995-06-23','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7765,'VARIN','ANDRE','1958-06-07','02.70.95.59.27','06.18.30.52.33',NULL,'30 BIS RUE DU MILIEU','','','14000','CAEN',NULL,NULL,'2580614208002',321.000000000,'1984-08-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7766,'LECARDONNEL','JEAN','1930-12-12','02.88.09.22.73','06.66.25.72.68',NULL,'12 RUE DES BURES','','','14400','BAYEUX',NULL,NULL,'1301214762002',225.000000000,'1958-03-31','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7767,'NAHON','ODILE','1933-05-25','02.11.32.38.30','06.16.73.46.51',NULL,'2 route de bissieres','','','14000','CAEN',NULL,NULL,'2330514610002',198.000000000,'1961-03-03','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7768,'FARRET','MARCEL','1965-02-07','02.12.28.38.42','06.30.39.71.03',NULL,'LES HAUTES VALETTES','','','14460','COLOMBELLES',NULL,NULL,'1650214062002',57.000000000,'1989-09-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7769,'CHELLAL','OLIVIER','1933-07-17','02.22.93.26.01','06.59.00.99.73',NULL,'3 impasse valentin hauy','','','50800','LA LANDE D''AIROU',NULL,NULL,'1330750510002',257.000000000,'1961-11-25','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7770,'VIEILLARD','KHERLEN','1969-10-22','02.50.61.43.03','06.20.76.10.64',NULL,'18 RUE CARRIERE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2691078311002',166.000000000,'1990-02-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7771,'GUERARD','YVONNE','1947-04-04','02.49.66.73.76','06.59.99.02.86',NULL,'19 RUE DE SOLOGNE','','','14510','GONNEVILLE SUR MER',NULL,NULL,'2470414358002',1491.000000000,'1969-08-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7772,'FRILLEY','MICHEL','1962-01-05',NULL,NULL,NULL,'62 Bd Marchal Lyautey','','','14000','CAEN',NULL,NULL,'2620161153002',3956.000000000,'1992-06-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7773,'CHENET','yvon','1959-04-06','02.34.20.43.21','06.61.58.45.25',NULL,'4 RUE ALFRED DE MUSSET','','','14120','MONDEVILLE',NULL,NULL,'1590414386002',202.000000000,'1980-11-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7774,'','JACQUES','1968-09-28','02.10.18.36.32','06.80.72.83.99',NULL,'11 RUE PIERRE MENDES FRANCE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1680914747002',1715.000000000,'1993-01-31','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7775,'GAUDICHE','MADELEINE','1933-02-07','02.76.89.63.84','06.58.72.33.30',NULL,'3 RUE YVONNE DE REVIERS','','','14860','BAVENT',NULL,NULL,'1330214370002',241.000000000,'1957-09-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7776,'MARIE','ODILE','1962-10-23','02.68.03.27.22','06.10.74.52.83',NULL,'LE BOURG','','',NULL,NULL,NULL,NULL,'1621014248002',161.000000000,'1989-11-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7777,'DEHAIS','JACQUES','1961-02-18','02.10.08.26.06','06.18.49.42.03',NULL,'1 RESIDENCE ST GERBOLD 13 RUE CO','NSTANT FORGET','','14000','CAEN',NULL,NULL,'2610214277002',967.000000000,'1985-10-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7778,'PAYSANT','PHILIPPE','1952-02-20','02.42.90.17.67','06.29.07.14.33',NULL,'24 rue de verdun','','','14120','MONDEVILLE',NULL,NULL,'2520214663002',51.000000000,'1979-09-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7779,'TOUFFAIT','','1932-09-24','02.40.70.34.06','06.47.04.36.88',NULL,'10 LOT LOUVET','','','14700','ST PIERRE CANIVET',NULL,NULL,'1320950601002',14.000000000,'1962-02-08','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7780,'LE QUERE','','1954-03-04','02.67.89.44.45','06.61.34.95.26',NULL,'21 rue jean quedec','','','14460','COLOMBELLES',NULL,NULL,'2540314556002',165.000000000,'1984-12-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7781,'ROUSSEL','PHILIPPE','1947-06-21','02.64.53.88.18','06.70.06.50.88',NULL,'','','','14000','CAEN',NULL,NULL,'2470614130002',33.000000000,'1971-06-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7782,'CHAMPS','PHILIPPE','1950-01-07','02.11.15.23.63','06.35.38.46.31',NULL,'3 RUE DE PRESSENCE','','','14111','LOUVIGNY',NULL,NULL,'1500114020002',189.000000000,'1972-07-16','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7783,'PAYEN','LUCETTE','1969-06-12','02.27.75.62.49','06.27.05.79.34',NULL,'','','','14790','VERSON',NULL,NULL,'1690650502002',25.000000000,'1990-07-18','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7784,'MAHIA','','1968-01-02','02.10.18.60.00','06.45.37.25.87',NULL,'24 bis  yves bernard','','','14310','VILLY BOCAGE',NULL,NULL,'1680195582002',524.000000000,'1997-02-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7785,'ROUSSEL','YVETTE','1933-09-30','02.48.28.02.21','06.14.30.41.57',NULL,'12 bld louis barthou','','','14210','TOURVILLE SUR ODON',NULL,NULL,'2330914659002',428.000000000,'1954-03-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7786,'CHESNEL','ANDRE','1937-09-17','02.10.47.50.58','06.86.50.72.24',NULL,'39 rue de champagne','','','14630','EMIEVILLE',NULL,NULL,'1370999358002',91.000000000,'1963-01-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7787,'PAOLINI','AMARSANAA','1936-06-03','02.19.38.36.75','06.94.44.34.06',NULL,'9 RUE DES LILAS','','','14120','MONDEVILLE',NULL,NULL,'2360614699002',576.000000000,'1965-10-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7788,'GODET','COLETTE','1926-06-18','02.40.66.67.99','06.19.55.17.96',NULL,'ROUTE DU PETIT VILLAGE','','','14270','MEZIDON CANON',NULL,NULL,'1260663397002',283.000000000,'1948-05-18','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7789,'ROYDOR','FRANCINE','1934-09-08','02.12.72.76.60','06.99.31.60.47',NULL,'61 rue de falaise','','','14460','COLOMBELLES',NULL,NULL,'1340921425002',36.000000000,'1956-10-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7790,'ROBERT','THERESE','1938-03-20','02.10.75.40.66','06.87.87.04.90',NULL,'10 RESIDENCE DE LA RIVIERE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2380314554002',2257.000000000,'1959-10-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7791,'PELCHAT','ANDREE','1939-08-06','02.46.99.87.31','06.38.80.94.97',NULL,'32 RUE DE PROVENCE','','','14000','CAEN',NULL,NULL,'1390861260002',755.000000000,'1964-01-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7792,'VINDARD','ARLETTE','1941-07-10','02.12.13.18.75','06.86.72.93.61',NULL,'RESIDENCE COLBERT LES SAUGES','','','14310','VILLERS BOCAGE',NULL,NULL,'1410706088002',67.000000000,'1965-05-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7793,'MICHARD','LOUISETTE','1965-04-18','02.49.84.27.67','06.30.94.86.86',NULL,'8 rue de l''abbaye','','','14000','CAEN',NULL,NULL,'1650414294002',4.000000000,'1987-08-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7794,'DESLOGES','ROGER','1937-02-15','02.18.85.66.74',NULL,NULL,'8 RUE DE L4ABBAYE','','','14860','RANVILLE',NULL,NULL,'2370253036002',99.000000000,'1961-05-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7795,'MALGREY','SUZANNE','1937-05-19','02.50.16.61.43','06.70.63.90.44',NULL,'34 rue des jardins','','','14000','CAEN',NULL,NULL,'1370514347002',413.000000000,'1966-01-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7796,'LEBOUCHER','MARGUERITE','1949-02-04','02.42.62.51.10','06.93.39.15.55',NULL,'1050 rue de la republique','','','14250','AUDRIEU',NULL,NULL,'2490249052002',32.000000000,'1970-05-17','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7797,'GUERIN','NADIA','1941-04-21','02.31.17.08.95','06.45.77.58.61',NULL,'41 rue du petit vallon','','','14920','MATHIEU',NULL,NULL,'2410461110002',1768.000000000,'1963-05-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7798,'LEBAS','JACQUELINE','1934-04-29','02.26.68.02.01','06.31.86.75.20',NULL,'adda 14','','','14120','MONDEVILLE',NULL,NULL,'1340414164002',407.000000000,'1964-11-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7799,'VORNIERES','HENRI','1948-05-22','02.76.15.78.13','06.41.78.53.41',NULL,'rue des ecoles','','','14460','COLOMBELLES',NULL,NULL,'2480514587002',998.000000000,'1972-10-12','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7800,'LELOUP','LUCIEN','1937-03-01','02.24.28.70.82','06.31.05.60.99',NULL,'HARRAS HOTOVIC','','','14123','IFS',NULL,NULL,'2370314516002',875.000000000,'1965-05-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7801,'ECOLIVET','BERNADETTE','1945-02-09','02.67.73.58.19','06.17.78.64.78',NULL,'27 AVENUE HELIE DE BEAUMONT','','','14250','VENDES',NULL,NULL,'2450214264002',4054.000000000,'1969-05-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7802,'LEGUEDOIS','MARIE ANGE','1941-07-05','02.90.56.02.88','06.70.39.12.98',NULL,'18 rue du point du jour','','','14860','BAVENT',NULL,NULL,'1410714747002',57.000000000,'1967-01-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7803,'LAMBERT','GENEVIEVE','1969-02-07','02.11.35.25.90','06.52.49.45.43',NULL,'15 RUE DOMREMY','','','14540','GRENTHEVILLE',NULL,NULL,'2690214047002',661.000000000,'1999-12-23','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7804,'CRAMPON','Serge','1933-04-25','02.30.87.20.26','06.58.66.16.23',NULL,'14 RUE DES CHAMOINES','','','14150','OUISTREHAM',NULL,NULL,'2330414750002',98.000000000,'1959-11-08','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7805,'LAURIO','ROGER','1962-12-27','02.51.53.58.11','06.76.91.48.11',NULL,'15 RUE ST SUPPLICE','','','14390','CABOURG',NULL,NULL,'1621214042002',134.000000000,'1987-08-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7806,'GUIHENEUC','LUCIENNE','1965-01-10','02.25.59.33.03','06.55.89.97.83',NULL,'2 residence st gerbold','','','14123','IFS',NULL,NULL,'1650114623002',175.000000000,'1990-04-29','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7807,'HUET','ETIENNE','1929-10-03','02.45.76.54.30','06.10.91.90.40',NULL,'1 rue des Oppelias','','','14730','GIBERVILLE',NULL,NULL,'2291050476002',7.000000000,'1958-01-31','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7808,'FRAIZE','','1931-08-31','02.25.60.09.81','06.71.67.39.67',NULL,'12 RUE DE PASTEUR','','','14000','CAEN',NULL,NULL,'2310814257002',59.000000000,'1952-07-07','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7809,'VIVIEN','GENEVIEVE','1948-04-26','02.38.70.25.53','06.49.95.07.76',NULL,'27 RUE DU PERE SANSON','','','61150','ECOUCHE',NULL,NULL,'2480414100002',2621.000000000,'1970-08-28','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7810,'DUCHEMIN','SUZANNE MARIE','1928-11-15','02.31.19.49.63','06.47.99.64.18',NULL,'12 avenue de paris lion d''or','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'2281114654002',111.000000000,'1951-06-24','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7811,'DEFEVER','PHILIPPE','1943-02-04',NULL,NULL,NULL,'5 RUE GEORGES DE BREBEUF','','','14000','CAEN',NULL,NULL,'2430261494002',24.000000000,'1966-07-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7812,'LENEVEU','JEANNE','1943-03-06','02.36.24.90.59','06.79.01.41.19',NULL,'10 RUE AUGUSTE LECHESNE','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2430360029002',779.000000000,'1967-11-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7813,'BOULIERE','CHARLES','1936-02-10','02.90.95.77.02','06.10.36.50.22',NULL,'8 RUE PERNELLE','','','14610','THAON',NULL,NULL,'2360253211002',1208.000000000,'1959-05-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7814,'BIRON','ROGER',NULL,'02.14.59.70.79','06.10.75.49.20',NULL,'4 RUE TRAVERSIERE','','','14120','MONDEVILLE',NULL,NULL,'1460176699002',38.000000000,'2013-01-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7815,'LEFRANCOIS','JACQUELINE','1929-08-08','02.51.08.00.07','06.62.66.65.99',NULL,'18 rue georges bra','','','14480','TIERCEVILLE',NULL,NULL,'1290850147002',370.000000000,'1959-02-01','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7816,'RAMOND','GERARD','1932-03-27','02.49.43.38.34','06.40.03.39.59',NULL,'36 RUE DU GENERAL LECLERC','','','14540','GRENTHEVILLE',NULL,NULL,'2320314324002',77.000000000,'1961-03-21','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7817,'MONSION','PAULETTE','1933-10-11','02.83.88.75.91','06.74.87.57.20',NULL,'21 route de caen','','','14370','BILLY',NULL,NULL,'2331014177002',16.000000000,'1956-10-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7818,'HURELLE','YVETTE','1969-04-29','02.78.02.24.32','06.68.07.08.47',NULL,'13 BD MARITIME','','','14270','MEZIDON CANON',NULL,NULL,'2690461169002',37.000000000,'1991-01-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7819,'DAUDET','BERNARD','1958-12-23','02.75.78.22.11','06.73.15.09.17',NULL,'95 RUE DES ACACIAS','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'2581299255002',63.000000000,'1982-02-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7820,'ROUELLE','JEAN CLAUDE','1963-08-06','02.89.50.64.73','06.10.59.08.38',NULL,'RUE DU DOS DE LA POULE','','','14420','USSY',NULL,NULL,'2630814074002',3458.000000000,'1993-04-29','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7821,'VERIN','BRUNO','1966-01-15','02.57.46.97.25','06.45.95.36.12',NULL,'56 route d''harcourt','','','14000','CAEN',NULL,NULL,'1660114715002',94.000000000,'1993-07-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7822,'OKTAY','THERESE','1940-05-06','02.33.20.19.99','06.21.17.05.28',NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2400514186002',67.000000000,'1961-12-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7823,'MARIE','JEAN LUC','1929-07-20','02.73.70.83.94','06.75.38.13.08',NULL,'9 rue de la madelaine','','','14320','FONTENAY LE MARMION',NULL,NULL,'1290750324002',3.000000000,'1950-05-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7824,'','BRUNO','1932-08-04','02.48.05.96.31','06.51.19.15.88',NULL,'11 RUE LEONARD GILLES','','','61300','ST MARTIN D''ECUBLEI',NULL,NULL,'1320814152002',38.000000000,'1959-10-30','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7825,'LOOTEN','MICHEL','1939-08-05','02.76.69.60.32','06.57.53.54.97',NULL,'15 RUE LECHARPENTIER DESCHAMPS','','','14670','TROARN',NULL,NULL,'1390814266002',217.000000000,'1965-05-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7826,'JOUAN','JACQUES','1952-06-08','02.57.15.38.63','06.74.72.68.90',NULL,'1 RUE DE BELLENGREVILLE','','','61800','TINCHEBRAY',NULL,NULL,'1520614125002',683.000000000,'1979-08-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7827,'BOUILLE','patrice','1931-09-02','02.16.89.14.93','06.16.97.29.61',NULL,'12 rue des quesnots','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1310928298002',141.000000000,'1958-07-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7828,'KAMARA','DANIEL','1961-04-18','02.65.38.70.39','06.28.90.30.56',NULL,'STE FOY DE MONTGOMERRY','','','50700','LIEUSAINT',NULL,NULL,'1610414103002',28.000000000,'1985-11-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7829,'BRIARD','SIMONE','1933-04-28','02.37.91.28.11','06.10.42.14.23',NULL,'33 BOULEVARD RAYMOND POINCARE','','','14220','FRESNEY LE VIEUX',NULL,NULL,'1330450480002',5.000000000,'1957-06-12','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7830,'BRUEZIERE','MICHEL','1964-05-01','02.34.40.01.07','06.91.85.00.50',NULL,'hameau de caillouet','','','14700','FALAISE',NULL,NULL,'1640514157002',362.000000000,'1986-07-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7831,'MARIETTE','BRUNO','1968-01-28','02.23.86.74.83',NULL,NULL,'112 BD  RAYMOND POINCARE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2680114060002',9.000000000,'1989-04-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7832,'CARRE','WILLIAM','1936-06-11','02.10.18.92.42','06.33.88.33.72',NULL,'21 RUE DU CIVISME','','','14320','MAY SUR ORNE',NULL,NULL,'2360627117002',694.000000000,'1963-08-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7833,'MARIE','BERNARD','1965-01-16','02.28.22.42.08','06.65.09.70.60',NULL,'CARREFOUR DE LA BOTTE','','','14470','GRAYE SUR MER',NULL,NULL,'2650114167002',806.000000000,'1987-09-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7834,'LEHERISSEY','GERARD','1937-03-12','02.85.56.81.96','06.78.25.69.12',NULL,'3 IMPASSE SPIROU','','','14850','HEROUVILLETTE',NULL,NULL,'1370314596002',19.000000000,'1967-12-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7835,'LAUNAY','MARIE FRANCOISE',NULL,'02.47.04.05.37','06.51.41.50.71',NULL,'7 RUE DE LA VERDIERE','','','14123','IFS',NULL,NULL,'1340614200002',227.000000000,'2010-04-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7836,'LADUNE','YVES','1935-07-12','02.18.43.24.53','06.24.80.33.99',NULL,'8 RUE DU BENGALE','','','14140','VIEUX PONT',NULL,NULL,'2350714034002',159.000000000,'1965-11-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7837,'DORAPHE','GEORGES','1954-11-01','02.11.09.26.35','06.73.35.70.69',NULL,'5 RUE DU BOUT MESNIL','','','14630','CAGNY',NULL,NULL,'2541114530002',1265.000000000,'1979-10-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7838,'ROUSSEL','MONIQUE','1932-09-02','02.11.02.73.51','06.17.74.89.59',NULL,'4 ALLEE JEAN RACINE','','','14114','VER SUR MER',NULL,NULL,'2320914301002',41.000000000,'1962-09-11','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7839,'RADULPHE','BENOIT',NULL,'02.41.17.81.66','06.11.16.35.97',NULL,'9 RUE DE FORMIGNY','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2550361093002',527.000000000,'2013-01-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7840,'GOSSELIN','JEAN CLAUDE','1931-05-11','02.35.76.28.88','06.11.97.32.75',NULL,'19 ROUTE DE PARIS','','','61310','LE PIN AU HARAS',NULL,NULL,'1310514001002',629.000000000,'1958-05-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7841,'CHOISNARD','BERNADETTE','1952-01-30','02.89.43.94.93','06.44.14.83.61',NULL,'6 RUE DES ARTISTES','','','14840','DEMOUVILLE',NULL,NULL,'2520114327002',18.000000000,'1973-08-15','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7842,'MAUROUARD','MICHEL','1959-06-13','02.65.84.84.39','06.87.12.75.84',NULL,'','','','14370','BILLY',NULL,NULL,'1590614039002',96.000000000,'1989-04-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7843,'POSTEL','MARTINE','1963-07-06','02.97.19.62.97','06.25.81.48.41',NULL,'13 RUE DU 8 MAI','','','14220','BOULON',NULL,NULL,'1630714432002',1684.000000000,'1986-07-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7844,'FRANCOIS','MARTINE','1958-06-27','02.31.87.54.72','06.73.35.16.58',NULL,'','','','14000','CAEN',NULL,NULL,'2580614208002',49.000000000,'1982-11-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7845,'LANGUILLE','CLAUDE','1936-12-18','02.53.16.24.40','06.82.17.66.71',NULL,'12 rue du garcelle','','','14270','MEZIDON CANON',NULL,NULL,'2361214119002',130.000000000,'1961-02-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7846,'LETIRAND','YVONNE','1956-04-28','02.47.11.28.52','06.73.20.00.89',NULL,'LA VAUCELLE','','','14370','BELLENGREVILLE',NULL,NULL,'1560414750002',63.000000000,'1986-12-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7847,'HAELEWYN','JEAN PIERRE','1956-07-23','02.77.94.73.53','06.20.67.21.39',NULL,'36 rue du parc','','','14460','COLOMBELLES',NULL,NULL,'1560714178002',102.000000000,'1979-12-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7848,'VIMARE','JANINE','1932-07-22','02.45.15.56.72','06.32.74.68.49',NULL,'17 CITE SUCRERIE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1320714596002',33.000000000,'1957-09-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7849,'HUE','PAULETTE','1936-07-28','02.48.97.69.70','06.94.24.88.73',NULL,'46 rue du 20e siecle','','','14000','CAEN',NULL,NULL,'2360714623002',3.000000000,'1958-08-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7850,'CASTEL','STEPHANE','1942-04-19','02.60.30.44.04','06.81.57.84.81',NULL,'1 rue pierre gringoire','','','14700','LA HOGUETTE',NULL,NULL,'2420450207002',326.000000000,'1967-04-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7851,'JAUSSAUD','FRANCOISE-JEANN','1940-04-21','02.13.66.89.48','06.79.95.67.16',NULL,'70 AVENUE DE LA BRIGADE PIRON','','','14210','EVRECY',NULL,NULL,'1400414271002',15.000000000,'1963-12-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7852,'COQUELLE','MONIQUE','1960-05-30','02.25.81.18.72','06.97.29.38.14',NULL,'3 RUE ST JEAN DE MONT','','','14270','CESNY AUX VIGNES OUEZY',NULL,NULL,'1600514163002',1191.000000000,'1983-01-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7853,'LIOT','PIERRETTE','1946-07-10','02.12.26.07.44','06.14.24.58.29',NULL,'10 rue marthe givra','','','14123','IFS',NULL,NULL,'1460714118002',40.000000000,'1971-05-17','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7854,'GERVAISE','ANDRE','1946-07-02','02.38.38.37.50','06.80.50.73.67',NULL,'la vallee','','','14540','SOLIERS',NULL,NULL,'1460714118002',957.000000000,'1968-10-25','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7855,'OSMONT','MICHELINE','1950-01-25','02.46.36.81.08','06.71.43.26.56',NULL,'48 rue de la seine','','','14123','FLEURY SUR ORNE',NULL,NULL,'1500187142002',360.000000000,'1974-03-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7856,'','FABIENNE','1934-12-09','02.96.30.17.56','06.24.01.01.59',NULL,'65 av guynemer','','','61100','FLERS',NULL,NULL,'2341214347002',86.000000000,'1961-06-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7857,'GAULTIER','DIDIER','1932-07-09','02.11.16.26.12','06.62.70.58.63',NULL,'16 rue du sieur de bras','','','14000','CAEN',NULL,NULL,'2320714754002',91.000000000,'1956-06-29','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7858,'COQUELLE','MARIE JEANNE','1936-05-01','02.86.44.43.40','06.33.21.97.41',NULL,'14 rue st gerbold','','','14260','CAMPANDRE VALCONGRAIN',NULL,NULL,'1360514594002',71.000000000,'1966-04-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7859,'MICHON','MONIQUE','1958-09-02','02.84.82.78.70','06.79.63.85.54',NULL,'1 rue ledanois','','','14000','CAEN',NULL,NULL,'1580961030002',4416.000000000,'1982-07-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7860,'GASCOIN','MARCEL','1958-06-24','02.79.05.32.77','06.19.52.95.35',NULL,'17 RUE LE CLOS','','','14840','DEMOUVILLE',NULL,NULL,'1580614306002',273.000000000,'1983-02-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7861,'VOLKMER','DENISE','1938-09-13','02.74.15.47.83',NULL,NULL,'le moulin du fourneau','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1380914658002',704.000000000,'1965-05-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7862,'ROUSSEAUX','YVETTE','1929-06-13','02.77.39.46.55','06.78.99.59.86',NULL,'14 avnue des peintres','','','14000','CAEN',NULL,NULL,'2290614672002',95.000000000,'1953-03-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7863,'GABRIEL','JEANNINE','1954-03-11','02.56.50.64.62','06.59.32.34.83',NULL,'38 RUE DE LA LIBERTE','','','14000','CAEN',NULL,NULL,'1540361399002',168.000000000,'1982-08-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7864,'DELIVET','EDOUARD','1936-09-12','02.38.36.40.44','06.45.20.80.00',NULL,'5 rue de la fraternite','','','14000','CAEN',NULL,NULL,'1360927229002',81.000000000,'1957-08-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7865,'GELMI','JACQUELINE','1963-08-31','02.75.69.73.25','06.28.77.80.44',NULL,'2 rue des masanges','','','14990','BERNIERES SUR MER',NULL,NULL,'1630872122002',218.000000000,'1987-12-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7866,'CALVEZ','bernard','1936-05-28','02.43.85.29.92','06.76.09.26.39',NULL,'23 rue Pasteur','','','14400','BAYEUX',NULL,NULL,'1360514760002',2405.000000000,'1960-08-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7867,'QUAINTAINNE','ANNE MARIE','1961-08-21','02.67.92.80.48','06.58.08.84.61',NULL,'14 RUE DU GENERAL DE GAULLE','','','14400','BAYEUX',NULL,NULL,'1610878326002',1.000000000,'1990-07-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7868,'BEIGNEUX','BERNADETTE','1930-01-12','02.10.38.33.80','06.60.84.79.04',NULL,'09 rue des petites marettes','','','14000','CAEN',NULL,NULL,'1300153053002',638.000000000,'1951-11-10','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7869,'DELAUNAY','SIMONE','1936-10-10','02.21.71.23.89','06.37.81.25.30',NULL,'2 rue ste barbe','','','14000','CAEN',NULL,NULL,'2361056054002',119.000000000,'1960-06-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7870,'BOULIER','daniel','1968-09-04','02.54.27.50.82','06.24.36.03.41',NULL,'9 RUE MICHEL LASNE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1680914246002',393.000000000,'1991-04-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7871,'TOUBALEM','GHISLAIN','1930-07-18','02.16.27.97.91','06.51.66.93.10',NULL,'4 rue des Primevres','','','14270','MEZIDON CANON',NULL,NULL,'1300729212002',1333.000000000,'1953-01-26','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7872,'MARIE','SYLVIANE','1949-12-28','02.24.73.01.71','06.16.75.84.93',NULL,'13 JARDIN DE LA COTE FLEURY','','','14000','CAEN',NULL,NULL,'1491214329002',94.000000000,'1970-01-23','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7873,'MAFOUTA MONANGA','ANNICK',NULL,'02.67.60.46.44','06.83.95.66.85',NULL,'3 bis rue du docteur calmette','','','14370','MOULT',NULL,NULL,'2310514689002',43.000000000,'2012-08-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7874,'CASTEL','CATHERINE','1954-01-27','02.34.36.86.56','06.39.67.82.90',NULL,'6 RUE MARCEL CACHIN','','','14540','GRENTHEVILLE',NULL,NULL,'2540159574002',41.000000000,'1975-08-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7875,'SZUMIGAJ','','1948-02-20','02.73.19.50.15','06.66.64.46.84',NULL,'3 avenue charlotte corday','','','14123','IFS',NULL,NULL,'1480227251002',37.000000000,'1969-09-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7876,'','PIERRE','1965-12-05','02.65.63.32.54','06.90.42.17.37',NULL,'83 rue du village','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1651214118002',50.000000000,'1987-09-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7877,'MODZELEWSKI','PIERRE ETIENNE','1935-12-06','02.93.67.66.27','06.68.30.49.13',NULL,'11 RUE GENERAL DE GAULLE','','','14700','ST GERMAIN LANGOT',NULL,NULL,'2351203161002',25.000000000,'1957-12-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7878,'BURGEVIN','MICHEL','1952-07-01','02.90.64.51.81','06.11.94.11.16',NULL,'6 IMPASSE DU VERT GALANT','','','14123','IFS',NULL,NULL,'2520714186002',779.000000000,'1978-02-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7879,'ANGUET','HENRIETTE','1936-04-13','02.37.13.50.36','06.99.44.73.27',NULL,'1005 RUE DU VAL CANUS','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2360414167002',37.000000000,'1962-03-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7880,'BREMENSON','DANIEL','1953-05-20','02.39.28.73.36','06.75.46.90.10',NULL,'RUE DU CACHE COQUIN','','','14320','MAY SUR ORNE',NULL,NULL,'1530514009002',148.000000000,'1983-08-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7881,'TANQUEREL','JACQUELINE','1955-02-15','02.28.89.20.23','06.67.91.39.62',NULL,'2 RUE DES PHALENES','','','14860','AMFREVILLE',NULL,NULL,'1550250231002',45.000000000,'1982-04-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7882,'ANTUNES','HUGUETTE','1950-05-24','02.22.53.26.53','06.34.87.26.77',NULL,'ROUTE DE CANON','','','14540','HUBERT FOLIE',NULL,NULL,'1500514153002',813.000000000,'1973-11-28','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7883,'','VIVIANE','1947-06-06','02.10.27.50.29','06.66.84.57.03',NULL,'8 RUE DE L''ABBAYE','','','14370','MOULT',NULL,NULL,'1470614169002',9.000000000,'1969-07-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7884,'COTIGNY','JEAN','1930-01-07','02.40.51.68.31','06.48.06.28.72',NULL,'1 RUE DU MARAIS','','','14000','CAEN',NULL,NULL,'1300162734002',73.000000000,'1952-02-12','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7885,'TRITT','MIECZYSLAW','1952-04-21','02.10.98.53.58','06.46.78.40.89',NULL,'16 rue de madrid','','','14000','CAEN',NULL,NULL,'2520414152002',1676.000000000,'1981-02-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7886,'TRETON','GERARD','1958-04-18','02.61.92.15.90','06.95.94.70.95',NULL,'1 RUE DES FLEURS','','','14400','AGY',NULL,NULL,'1580414118002',31.000000000,'1983-02-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7887,'AUMONT','patrick',NULL,'02.46.47.39.59','06.90.77.11.29',NULL,'10 RUE FERNAND LEGER','','','14120','MONDEVILLE',NULL,NULL,'2290814140002',975.000000000,'2011-06-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7888,'VAUDEVIRE','JEAN CLAUDE','1929-06-01','02.98.95.60.85','06.20.72.30.66',NULL,'RUE DU DR PAUL ENOUF','','','14630','CAGNY',NULL,NULL,'1290614705002',4934.000000000,'1954-08-20','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7889,'LAMACHE','CHRISTIANE','1934-12-08','02.13.40.43.72','06.97.51.84.13',NULL,'21 RUE CLOS DU PAVILLON','','','61160','FEL',NULL,NULL,'2341250013002',2872.000000000,'1961-05-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7890,'DUFAY','MARIE-FRANCOIS','1952-04-13','02.66.76.93.20','06.10.04.87.93',NULL,'33 RUE DU 11 NOVEMBRE','','','14570','CLECY',NULL,NULL,'1520461290002',109.000000000,'1982-11-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7891,'VALLOIS','Raphael','1955-03-31','02.25.43.01.68','06.34.57.73.52',NULL,'','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2550314396002',80.000000000,'1979-11-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7892,'DJILALI','PIERRE','1963-01-25','02.59.45.08.40','06.96.06.39.31',NULL,'4 RUE DES CULTIVATEURS','','','50500','AUVERS',NULL,NULL,'1630199255002',56.000000000,'1986-12-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7893,'DROUILLET','FRANCIS','1937-04-06','02.78.04.37.71','06.77.13.56.82',NULL,'65 avenue de paris','','','14123','IFS',NULL,NULL,'2370461038002',205.000000000,'1961-05-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7894,'THOMASSIN','LAURENCE','1965-06-12','02.43.41.35.56','06.53.34.93.18',NULL,'6/2 GRANDE RUE','','','14910','BLONVILLE SUR MER',NULL,NULL,'2650614119002',94.000000000,'1988-08-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7895,'LAQUERIE','PIERRE LOUIS','1947-09-24','02.53.83.16.71','06.84.98.19.16',NULL,'2 RUE DES CHAUMIERES','','','14630','CAGNY',NULL,NULL,'1470914393002',197.000000000,'1976-11-30','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7896,'BOURSIN','ROSELYNE','1940-05-18','02.43.63.99.56','06.11.90.87.60',NULL,'132 RUE D''AUTHIE','','','14270','MEZIDON CANON',NULL,NULL,'2400556129002',360.000000000,'1968-04-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7897,'BANVILLE','YVES','1931-07-22','02.25.71.85.48','06.30.02.76.15',NULL,'8 PLACE MARIA CALLAS','','','14000','CAEN',NULL,NULL,'1310714318002',11.000000000,'1958-07-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7898,'COCHET','PAULETTE','1959-01-22','02.75.60.33.60','06.36.84.80.81',NULL,'MONTBOUGON','','','14220','THURY HARCOURT',NULL,NULL,'2590150399002',657.000000000,'1984-03-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7899,'LEDENTU','','1950-05-29','02.96.24.14.79','06.68.17.85.46',NULL,'1170 BD DE LA PAIX','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1500514251002',38.000000000,'1975-03-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7900,'SIMONIN','DIDIER','1960-09-08','02.85.95.24.24','06.13.43.27.95',NULL,'28 rue du puit','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2600914337002',69.000000000,'1988-06-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7901,'ROBERT','GERARD','1960-03-12','02.33.97.70.71','06.82.22.30.08',NULL,'5 RUE JEAN MOULIN','','','14170','BERVILLE',NULL,NULL,'2600314719002',22.000000000,'1983-01-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7902,'BURNEL','ODETTE','1931-01-19','02.74.60.01.33',NULL,NULL,'1 impasse de la cour aux au sel','','','14610','ANGUERNY',NULL,NULL,'1310150335002',101.000000000,'1954-09-29','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7903,'GARNIER','IRENEE','1942-06-28','02.64.77.99.60','06.49.13.99.62',NULL,'5 rue de la vire','','','14123','IFS',NULL,NULL,'1420691477002',512.000000000,'1963-01-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7904,'PHAMBA','JULES','1929-07-04','02.71.93.43.32','06.31.32.83.31',NULL,'20 RUE DE L''EGLISE','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2290753181002',2537.000000000,'1952-12-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7905,'PETITPAS','OLIVIER','1948-04-21','02.80.72.75.50','06.51.08.12.45',NULL,'2 chemin de la boulangerie','','','14130','BLANGY LE CHATEAU',NULL,NULL,'2480414111002',1518.000000000,'1972-10-18','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7906,'LAVACHE','GEORGETTE','1954-09-20','02.26.68.29.39','06.94.92.85.55',NULL,'606 chemin de la bruller','','','14700','FALAISE',NULL,NULL,'2540914183002',72.000000000,'1975-08-22','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7907,'RUCKL','christine','1964-06-17','02.10.75.06.35','06.32.48.70.91',NULL,'11 RUE DU 8 MAI 1945','','','14000','CAEN',NULL,NULL,'1640614517002',15.000000000,'1988-05-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7908,'CHERENCE','OLIVIER','1927-12-12','02.52.30.40.67','06.23.37.05.21',NULL,'3 place de l''etang','','','14000','CAEN',NULL,NULL,'1271219272002',63.000000000,'1952-02-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7909,'LABBE','MARIE','1928-08-28','02.23.84.15.01','06.86.61.78.56',NULL,'LE VIEUX SALLEN','','','61390','COURTOMER',NULL,NULL,'2280859328002',1067.000000000,'1952-01-19','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7910,'ROGER','RENEE','1936-03-15','02.78.75.47.54','06.66.19.98.76',NULL,'460 les bruyeres de calleville','','','61570','MORTREE',NULL,NULL,'2360314129002',482.000000000,'1966-09-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7911,'LEBIS','RENE','1951-07-20','02.87.88.44.48','06.26.87.18.83',NULL,'ROUTE DE BANNEVILLE   LE BOURG','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1510761187002',112.000000000,'1974-06-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7912,'GILOT','MICHEL','1938-01-02','02.65.39.60.82','06.34.50.05.19',NULL,'CHEMIN DU COUPE GORGE','','','14460','COLOMBELLES',NULL,NULL,'2380188451002',4051.000000000,'1964-09-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7913,'SURCOUF','NADEJDA','1958-05-29','02.11.06.65.02','06.82.23.24.53',NULL,'77 avenue de charlotte corday','','','14120','MONDEVILLE',NULL,NULL,'1580576420002',13.000000000,'1982-05-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7914,'LEFORESTIER','DENISE','1939-05-02','02.31.37.95.23','06.49.79.66.78',NULL,'ROUTE DE FALAISE','','','14320','FONTENAY LE MARMION',NULL,NULL,'1390514673002',76.000000000,'1963-12-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7915,'RABEC','RAYMONDE','1957-07-05','02.84.11.62.41','06.41.19.02.48',NULL,'15 RUE DENIS DIDEROT','','','61500','SEES',NULL,NULL,'2570714322002',421.000000000,'1984-06-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7916,'LEMARCHAND','MICHEL','1962-11-14','02.58.09.12.62','06.92.56.23.45',NULL,'2 RUE D''ANDERNOS','','','14270','MEZIDON CANON',NULL,NULL,'1621114490002',55.000000000,'1983-01-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7917,'LEFRANCOIS','JEAN PIERRE','1962-11-11','02.98.47.77.09','06.71.87.87.16',NULL,'12 RUE DU JARDIN BARBET','','','14400','NONANT',NULL,NULL,'1621114490002',4265.000000000,'1986-06-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7918,'SEBIRE','MONIQUE','1937-10-14','02.35.82.32.28','06.11.62.39.13',NULL,'rue de l eglise','','','14000','CAEN',NULL,NULL,'2371014102002',72.000000000,'1958-04-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7919,'LECALLO','MARIE LOUISE','1943-07-31','02.66.75.81.38','06.96.13.68.99',NULL,'LA PETITE RAMEE','','','14120','MONDEVILLE',NULL,NULL,'1430750098002',23.000000000,'1967-03-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7920,'VOISIN','LOUIS','1936-09-05','02.60.67.31.40','06.11.40.67.76',NULL,'1 rue de la fontaine','','','14370','MERY CORBON',NULL,NULL,'2360914120002',940.000000000,'1963-12-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7921,'LEFETEY','YVAN','1940-04-27','02.11.65.03.38','06.41.80.82.02',NULL,'1 RUE SAINT SULPICE','','','14470','COURSEULLES SUR MER',NULL,NULL,'1400414271002',16.000000000,'1961-10-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7922,'SAUTON','LEONE','1932-05-16','02.11.76.50.91','06.58.96.08.60',NULL,'1RUE AMBROISE PARE','','','14540','SOLIERS',NULL,NULL,'1320514376002',1800.000000000,'1959-06-18','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7923,'PHELIPPOT','BERNADETTE','1940-08-02','02.31.22.73.90','06.11.51.57.71',NULL,'25 AVENUE DE VERDUN','','','14540','GRENTHEVILLE',NULL,NULL,'1400861464002',505.000000000,'1968-05-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7924,'PICAN','MARIE-NOELLE','1946-06-08','02.86.64.99.85','06.49.56.50.27',NULL,'LE BOURG','','','14220','ESPINS',NULL,NULL,'1460614657002',229.000000000,'1969-02-26','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7925,'BATAILLE','ALAIN','1932-10-19','02.91.16.66.65','06.34.77.76.99',NULL,'56 ROUTE DE BALLEROY','','','14220','COMBRAY',NULL,NULL,'2321061096002',401.000000000,'1956-11-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7926,'PIGEON','GUILLERMO','1940-05-13','02.80.81.82.55','06.14.43.90.81',NULL,'6 RUE MICHEL JEAN','','','14260','COURVAUDON',NULL,NULL,'1400514327002',202.000000000,'1970-11-14','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7927,'FREMONT','JEANINE','1940-03-19','02.81.82.28.74',NULL,NULL,'3 CHEMON DES ECOLIERS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1400314006002',38.000000000,'1965-07-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7928,'JENVRIN','PAULE','1940-03-07','02.82.30.16.04','06.12.22.97.96',NULL,'5 RUE DE QUILLY','','','14120','MONDEVILLE',NULL,NULL,'1400314006002',75.000000000,'1961-04-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7929,'','FRANCOISE','1930-10-16','02.80.95.62.15','06.31.36.43.39',NULL,'38 rue du quebec','','','14123','IFS',NULL,NULL,'1301061007002',162.000000000,'1954-04-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7930,'OSMONT','ANNICK','1936-06-18','02.59.54.11.85','06.92.39.03.74',NULL,'','','','14000','CAEN',NULL,NULL,'1360614722002',948.000000000,'1957-03-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7931,'MARIE','YVETTE','1931-10-11','02.44.58.71.10','06.46.28.97.70',NULL,'12 rue trainerie','','','14670','TROARN',NULL,NULL,'1311014020002',532.000000000,'1955-06-27','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7932,'PIOLINE','YVETTE','1936-03-04','02.20.36.86.94','06.68.65.67.09',NULL,'34 ROUTE D''IFS','','','14370','CROISSANVILLE',NULL,NULL,'2360314437002',60.000000000,'1957-01-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7933,'FOUQUES','PIERRE','1931-06-25','02.55.68.24.09','06.51.66.06.54',NULL,'220 quartier du grand parc','','','14170','LIEURY',NULL,NULL,'1310635021002',43.000000000,'1953-10-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7934,'GUIHENEUC','JEAN  PIERRE','1982-02-20','02.54.89.67.12','06.42.54.61.99',NULL,'3 rue du coursin','','','14400','ST MARTIN DES ENTREES',NULL,NULL,'1820299231002',7.000000000,'2005-07-13','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7935,'COUDREAU','MARTINE','1939-01-24','02.17.01.44.36','06.26.63.51.28',NULL,'4 rue eugene leriteau','','','14123','IFS',NULL,NULL,'2390151358002',2378.000000000,'1961-06-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7936,'','BERNARD','1987-03-18','02.22.57.48.06','06.90.99.46.60',NULL,'20 rue orasio smith','','','14000','CAEN',NULL,NULL,'2870399338002',40.000000000,'2011-07-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7937,'TABESSE','CLAUDE-HEL','1941-02-14','02.20.26.51.97','06.13.97.89.08',NULL,'11 Bd Louis Barthout','','','14000','CAEN',NULL,NULL,'2410214167002',41.000000000,'1962-07-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7938,'LECONTE','RENEE','1929-01-17','02.10.62.04.42','06.65.82.42.55',NULL,'13 Impasse de la Hetraie','','','14350','MONT BERTRAND',NULL,NULL,'1290114689002',482.000000000,'1957-12-28','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7939,'ARTHUR','JOSEPHINE','1954-02-10','02.11.01.68.36','06.85.44.48.27',NULL,'13 RUE DE LA GROTTE','','','14120','MONDEVILLE',NULL,NULL,'1540214186002',113.000000000,'1982-09-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7940,'REBUFFONI','RAYMONDE','1942-02-21','02.88.93.95.73','06.90.72.86.22',NULL,'4 RUE AUGUSTE LECHESNE','','','14740','ST MANVIEU NORREY',NULL,NULL,'1420250158002',272.000000000,'1964-01-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7941,'DECEUNINCK','JEAN YVES','1938-01-20','02.21.34.53.49','06.48.18.55.30',NULL,'11 RUE PAUL LANGEVIN','','','14120','MONDEVILLE',NULL,NULL,'2380153127002',32.000000000,'1966-02-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7942,'MALHERBE','SERGE','1955-12-21','02.50.60.74.30',NULL,NULL,'7 RUE DE LA LIBERATION','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2551261143002',69.000000000,'1982-09-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7943,'THOMASSE','PIERRE','1932-01-29','02.87.47.44.32','06.67.15.59.68',NULL,'12 AVENUE DU VAL PRES','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2320114515002',1276.000000000,'1962-06-27','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7944,'VIVIEN','COLETTE','1939-04-28','02.44.25.72.12','06.72.05.72.71',NULL,'5 PLACE DE LA MAIRIE','','','14540','BOURGUEBUS',NULL,NULL,'2390478146002',62.000000000,'1960-05-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7945,'GEFFROY','COLETTE','1943-01-06','02.45.73.27.24','06.54.44.56.50',NULL,'3 RUE DES HAUTS MARQUETS','','','14840','DEMOUVILLE',NULL,NULL,'1430150558002',435.000000000,'1970-09-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7946,'LEGAIGNEUR','JOCELYNE','1935-07-30','02.86.68.94.11','06.32.56.20.60',NULL,'','','','14190','ROUVRES',NULL,NULL,'1350714628002',3195.000000000,'1958-05-28','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7947,'WALLECAN','',NULL,'02.97.70.10.68','06.63.51.01.35',NULL,'8 PLACE DE ROTTENDORF','','','14840','CUVERVILLE',NULL,NULL,'1320750224002',92.000000000,'2008-09-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7948,'LABORIE','BERNARD','1949-03-03','02.57.37.70.15','06.65.38.93.49',NULL,'5 rue de la bienfaisance','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2490314506002',59.000000000,'1971-06-18','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7949,'LE GAL','GINETTE','1955-07-18','02.44.82.83.22','06.16.32.70.05',NULL,'RUE DE VIENNE','','','14123','IFS',NULL,NULL,'2550714678002',9.000000000,'1980-01-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7950,'LEROY','MICHEL','1951-09-06','02.13.54.43.95','06.78.53.08.00',NULL,'2 rue president coty','','','14123','IFS',NULL,NULL,'1510928085002',130.000000000,'1976-01-28','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7951,'LEMARIE','ROGER','1964-02-08','02.11.70.05.94','06.71.07.08.05',NULL,'28 AVENUE A. DELAVERGNE','','','14860','BAVENT',NULL,NULL,'2640214454002',4.000000000,'1986-08-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7952,'LEPLAT','EDITH','1934-08-01','02.59.12.94.55','06.83.41.17.43',NULL,'6 rue des jacinthes','','','14540','GRENTHEVILLE',NULL,NULL,'2340850463002',55.000000000,'1960-09-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7953,'FLAGEUL','CHANTAL','1936-06-28','02.10.90.64.86','06.93.02.34.41',NULL,'1803 QUARTIER DU BOIS','','','14340','CREVECOEUR EN AUGE',NULL,NULL,'2360614556002',194.000000000,'1963-10-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7954,'FOUCHER','JACQUES','1921-02-14','02.37.94.50.19','06.37.64.18.12',NULL,'37 RUE DE LA LIBERTE','','','14220','BOULON',NULL,NULL,'1210257322002',45.000000000,'1951-03-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7955,'RAULIN','LUCIENNE','1934-02-13','02.73.21.25.53','06.23.15.93.15',NULL,'42 RUE DE L EGLISE','','','14370','MOULT',NULL,NULL,'2340214134002',5.000000000,'1963-01-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7956,'AUBEY','FRANCOISE','1960-11-04','02.11.79.46.40','06.39.55.57.05',NULL,'7 BLD DU 11 NOVEMBRE','','','14120','MONDEVILLE',NULL,NULL,'2601114316002',1202.000000000,'1988-11-05','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7957,'ADOLPHE','REMI','1951-07-17','02.52.86.63.07','06.80.54.24.23',NULL,'2 RUE DE CHAMPAGNE','','','14123','IFS',NULL,NULL,'2510714274002',10.000000000,'1976-05-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7958,'CHANU','ANDRE','1928-06-12','02.43.46.62.55','06.11.33.50.28',NULL,'PLACE DU COLLEGE RUE CAMILLE BLA','IZOT','','50630','QUETTEHOU',NULL,NULL,'1280614488002',1961.000000000,'1953-01-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7959,'LERIQUIER','RAYMOND','1935-10-21','02.80.78.99.43','06.41.23.90.46',NULL,'47 BVD LEROY','','','50340','LES PIEUX',NULL,NULL,'1351014657002',812.000000000,'1965-10-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7960,'NEELZ','HELENE','1942-04-10','02.10.95.98.50','06.82.94.80.48',NULL,'29 RUE GENERAL GIRAUD','','','14000','CAEN',NULL,NULL,'2420414102002',130.000000000,'1967-08-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7961,'BLANDIN','YVETTE','1941-12-11',NULL,NULL,NULL,'CHEMIN DES HAUTES VALLETTES','','','14120','MONDEVILLE',NULL,NULL,'2411250645002',1238.000000000,'1964-01-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7962,'VANLEYNSEELE','SOLANGE','1931-09-19','02.43.06.14.27','06.35.45.61.82',NULL,'10 RUE KALINICRENKO','','','14000','CAEN',NULL,NULL,'2310950404002',163.000000000,'1954-07-25','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7963,'BOULY','FRANCOISE','1962-07-22','02.57.76.64.46','06.68.64.16.83',NULL,'6.2 AVENUE DES 2 EGLISES','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'1620714118002',17.000000000,'1985-07-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7964,'BOUET','',NULL,'02.69.47.41.15','06.75.58.99.33',NULL,'09 PLACE NELSON MANDELA','','','14730','GIBERVILLE',NULL,NULL,'2361014462002',94.000000000,'2010-10-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7965,'CHARLES','CLAUDE','1965-07-24','02.74.60.16.69',NULL,NULL,'6 allee des tieulles','','','14840','DEMOUVILLE',NULL,NULL,'2650714118002',52.000000000,'1992-09-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7966,'DRAGAN','CHRISTOPHE','1930-02-13','02.80.07.68.63','06.59.81.52.20',NULL,'53 avenue guynemer','','','14840','CUVERVILLE',NULL,NULL,'2300261083002',615.000000000,'1951-05-04','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7967,'SKUPSKI','NICOLE','1934-03-29','02.45.14.67.41','06.10.04.28.86',NULL,'64 AVENUE DE LA REDOUTE','','','14840','DEMOUVILLE',NULL,NULL,'2340314437002',17.000000000,'1964-09-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7968,'LAHAYE','DENIS','1934-02-19','02.51.05.72.67','06.78.07.37.37',NULL,'14 RUE DE LA MARE','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1340214712002',202.000000000,'1964-07-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7969,'DARSY','YVETTE','1965-03-22','02.43.71.99.62','06.82.18.73.38',NULL,'4 RUE DE LA PECHERIE','','','14000','CAEN',NULL,NULL,'1650314212002',937.000000000,'1995-03-19','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7970,'MENDE','NADIA','1944-04-18','02.35.36.87.73','06.88.11.95.34',NULL,'30 RUE DE L''ECUREUIL','','','14970','BENOUVILLE',NULL,NULL,'1440461479002',396.000000000,'1972-05-10','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7971,'MOYA','THIERRY','1933-08-09','02.42.64.49.01','06.31.61.85.42',NULL,'lotissement les 5 ormes','','','14220','ST MARTIN DE SALLEN',NULL,NULL,'2330814672002',84.000000000,'1954-12-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7972,'GUILLOT','ISABELLE','1959-07-21','02.12.17.58.64','06.81.85.67.71',NULL,'34 RUE DE L''ECUREUIL','','','14930','ETERVILLE',NULL,NULL,'1590750395002',3.000000000,'1984-02-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7973,'LEMONNIER','ANDRE','1930-04-16','02.29.78.79.71','06.66.18.56.34',NULL,'6 RESIDENCE DU 8 MAI','','','14630','CAGNY',NULL,NULL,'2300414191002',1625.000000000,'1955-08-18','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7974,'AUBERT','MARCEL','1928-05-30','02.38.02.23.12','06.82.99.00.87',NULL,'CHEMIN PERDU LA VIEILLE EGLISE','','','14220','FRESNEY LE VIEUX',NULL,NULL,'2280514545002',65.000000000,'1950-09-25','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7975,'FOUCHARD','SOLANGE','1964-05-02','02.14.19.97.73','06.45.20.97.22',NULL,'4 BIS RUE CHAPRON','','','14000','CAEN',NULL,NULL,'1640514406002',4040.000000000,'1992-10-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7976,'MAILLET','YVETTE','1930-10-25','02.68.12.11.21','06.93.43.41.53',NULL,'20 RUE DE LA VIEILLE EGLISE','','','14640','VILLERS SUR MER',NULL,NULL,'2301014743002',72.000000000,'1960-01-13','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7977,'PITARD','MARIE MARGUERITE','1960-03-26','02.63.69.18.84','06.51.42.95.65',NULL,'rue du 19 mars 1962','','','14120','MONDEVILLE',NULL,NULL,'1600314232002',101.000000000,'1983-07-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7978,'CADOT','BERNARD','1961-03-27','02.78.32.19.48','06.39.76.42.15',NULL,'4 rue jean jacques rousseau','','','61120','CANAPVILLE',NULL,NULL,'1610314257002',86.000000000,'1985-02-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7979,'BLANCHEMAIN','REGINE','1948-10-07','02.51.49.32.14','06.55.25.91.59',NULL,'VILLERS CANIVET','','','14000','CAEN',NULL,NULL,'1481014697002',16.000000000,'1972-08-15','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7980,'WOYTEAU','SYLVAIN','1958-06-21','02.10.49.88.84','06.53.32.25.87',NULL,'28 RUE FENITON','','','14400','ARGANCHY',NULL,NULL,'1580614444002',1594.000000000,'1979-07-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7981,'TACCHI','MARIE-THERESE','1937-05-08','02.11.63.01.21','06.88.76.85.94',NULL,'27 rue de la paix','','','14210','MAISONCELLES SUR AJON',NULL,NULL,'2370561135002',1655.000000000,'1958-10-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7982,'','JACQUES','1960-06-22','02.41.91.48.85','06.86.11.88.43',NULL,'21 RUE DE L'' ANCIENNE GARE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1600614099002',261.000000000,'1982-02-23','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7983,'PICHON','jean marie','1942-01-02','02.11.09.11.44','06.31.87.44.90',NULL,'26 AVENUE JEAN VILLARD','','','14000','CAEN',NULL,NULL,'1420114536002',98.000000000,'1971-05-08','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7984,'HAMANT','SYLVIE','1928-11-11','02.78.43.72.19','06.75.29.55.75',NULL,'13 route de caen','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1281161251002',16.000000000,'1957-11-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7985,'MICHARD','EMILIENNE','1942-01-31','02.10.08.65.03','06.77.26.41.30',NULL,' 2rue p langevin','','','14400','ST VIGOR LE GRAND',NULL,NULL,'1420166179002',401.000000000,'1971-05-29','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7986,'TRINCART','DANIEL','1956-03-21','02.29.11.46.50','06.56.19.66.69',NULL,'3 RUE DIEUDONNE','','','14250','BROUAY',NULL,NULL,'2560314356002',1026.000000000,'1978-09-21','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7987,'LE BIHAN','BERNARD','1932-02-06','02.21.17.82.80','06.10.89.59.20',NULL,'4 ROUTE DE TROARN','','','14270','MEZIDON CANON',NULL,NULL,'2320261189002',30.000000000,'1953-01-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7988,'RUAUX','ANNICK','1950-01-21','02.91.23.85.93','06.46.72.31.78',NULL,'4 RUE P SEMARD','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'2500150625002',13.000000000,'1978-05-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7989,'PRUNIER','JEANNINE',NULL,'02.98.63.17.50','06.53.33.43.95',NULL,'53 RUE DE VILLEDIEU','','','14540','SOLIERS',NULL,NULL,'2450350158002',38.000000000,'2012-07-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7990,'PRUNIER','PASCAL','1943-02-26','02.85.43.87.22','06.17.22.65.16',NULL,'10 PASSAGE DES JACOBINS','','','14000','CAEN',NULL,NULL,'2430250271002',1013.000000000,'1964-09-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7991,'GONFROY','CLAUDE','1931-10-10','02.35.87.28.51','06.56.55.57.80',NULL,'10 RUE CLAUDE DEBUSSY','','','14940','TOUFFREVILLE',NULL,NULL,'1311044197002',21.000000000,'1953-01-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7992,'POSTIL','THERESE','1961-02-08','02.69.54.18.42','06.11.65.42.51',NULL,'26 RUE ALEXANDRE','','','14210','CHEUX',NULL,NULL,'1610214221002',97.000000000,'1983-08-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7993,'GUERIN','VITALIY','1964-08-18','02.96.11.47.39','06.10.91.02.21',NULL,'6 ROUTE DE TROUVILLE','','','14370','BELLENGREVILLE',NULL,NULL,'2640814411002',12.000000000,'1987-11-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7994,'GEPHINE','MICHEL','1938-07-03','02.68.02.09.04','06.42.68.69.47',NULL,'7 RUE DU DR ROUX','','','14460','COLOMBELLES',NULL,NULL,'1380714038002',25.000000000,'1959-04-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7995,'LESAUVAGE','YVETTE','1955-02-21','02.48.72.03.40','06.41.19.62.19',NULL,'','','','14000','CAEN',NULL,NULL,'2550261237002',538.000000000,'1976-09-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7996,'CAPELLE','YVETTE','1929-10-10','02.61.19.08.00','06.48.49.69.57',NULL,'10 RUE SULLY','','','14370','MOULT',NULL,NULL,'2291082112002',72.000000000,'1953-08-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7997,'HENWOOD','JEAN','1941-05-05','02.79.61.24.87','06.80.00.40.55',NULL,'24 RUE DU BOUT RENARD','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'1410514720002',475.000000000,'1967-09-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7998,'BASTARD','FRANCIS','1930-12-02','02.29.72.20.11','06.17.22.52.36',NULL,'56 RUE LOUIS ROBILLARD','','','14250','DUCY STE MARGUERITE',NULL,NULL,'1301214246002',29.000000000,'1960-08-02','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (7999,'OSOUF','PASCAL','1939-05-10','02.74.95.61.21',NULL,NULL,'7 ALLEE DES CHARMES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2390550639002',281.000000000,'1961-11-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8000,'LECLERC','NATHALIE','1935-02-03','02.73.69.18.90','06.95.11.92.31',NULL,'RN 13 le lion d or','','','14630','EMIEVILLE',NULL,NULL,'1350214536002',145.000000000,'1965-07-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8001,'GRAND','YVONNE','1935-10-12','02.45.90.20.01','06.44.41.68.54',NULL,'206 RUE DE BAYEUX','','','14960','MEUVAINES',NULL,NULL,'2351050507002',586.000000000,'1961-09-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8002,'GRAND','','1933-02-01','02.84.63.76.60','06.69.97.27.49',NULL,'RUE  LA CHAPELLE','','','14670','TROARN',NULL,NULL,'1330214370002',54.000000000,'1956-10-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8003,'BASSAQUE','ETIENNE','1936-12-30','02.67.23.10.09','06.26.27.58.74',NULL,'LA BUTTE','','',NULL,NULL,NULL,NULL,'2361235308002',10.000000000,'1958-04-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8004,'LE DIOURON','SERGE','1932-03-31','02.91.35.62.14','06.42.36.29.60',NULL,'3 ALLEE DU COLONEL DE LA GIRAUDI','ERE','','14370','CHICHEBOVILLE',NULL,NULL,'2320350523002',5177.000000000,'1959-12-09','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8005,'MONSALLIER','','1938-01-11','02.48.73.00.84','06.57.84.16.87',NULL,'26 ROUTE D''HARCOURT','','','14370','ARGENCES',NULL,NULL,'2380102290002',1.000000000,'1961-07-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8006,'PESNELLE','JOELLE','1940-08-13','02.23.20.51.92','06.10.61.92.53',NULL,'11 RUE JEAN PAUL MARAT','','','14123','IFS',NULL,NULL,'1400861464002',55.000000000,'1961-11-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8007,'LEGROS','ALBERT',NULL,'02.42.67.88.28','06.64.31.63.79',NULL,'13 rue albert frilley','','','14370','MERY CORBON',NULL,NULL,'2390461150002',1567.000000000,'2011-09-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8008,'LAMBIOTTE','PIERRE','1960-02-21','02.88.43.00.20','06.69.83.43.21',NULL,'24 IMPASSE TISON','','','50160','TORIGNI SUR VIRE',NULL,NULL,'1600214167002',67.000000000,'1989-12-29','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8009,'TAPIN','ANNIE','1928-02-24','02.37.62.97.61','06.89.69.60.48',NULL,'6 CLOS LE PRIEURE LEBISEY','','','14000','CAEN',NULL,NULL,'2280214543002',16.000000000,'1952-12-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8010,'FRANCHEQUIN','Yvette','1934-11-26','02.28.90.97.47','06.61.72.59.57',NULL,'12 rue albert bayet','','','61120','VIMOUTIERS',NULL,NULL,'1341114100002',418.000000000,'1958-08-02','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8011,'SAVERYS','BEATRICE','1921-12-12','02.45.30.90.00','06.64.26.96.16',NULL,'3 RUE ABBE ALLIX','','','14460','COLOMBELLES',NULL,NULL,'1211202691002',22.000000000,'1948-07-31','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8012,'GERNIGON','GINETTE',NULL,'02.41.67.74.08',NULL,NULL,'10 RUE DES 29E ET 35E DIVISIONS','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2560261260002',6.000000000,'2013-02-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8013,'DAN','DOMINIQUE','1941-08-21','02.27.96.03.00','06.78.72.91.57',NULL,'RUE DE BOULON','','','14790','VERSON',NULL,NULL,'1410876157002',76.000000000,'1962-12-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8014,'ANTONOVA','LAURENT','1935-01-08','02.23.90.23.83','06.10.20.63.35',NULL,'4 RUE DU COLOMBIER','','','14570','ST REMY',NULL,NULL,'2350150216002',80.000000000,'1963-08-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8015,'PAIN','LOUIS','1933-05-02','02.14.60.60.49','06.66.38.01.82',NULL,'14-5 RUE DU BOIS','','','14750','ST AUBIN SUR MER',NULL,NULL,'2330514378002',410.000000000,'1955-04-12','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8016,'MAUGER','LOUISE','1931-10-17','02.99.55.75.97','06.94.56.77.34',NULL,'212 RUE D4AUGE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1311050565002',186.000000000,'1956-07-03','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8017,'VALLEE','JEANNINE','1943-12-23','02.77.51.86.21','06.77.57.85.59',NULL,'14 RUE MARGUERITE DURAS','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1431214568002',17.000000000,'1969-01-29','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8018,'RICHARD','ROGER','1955-11-24','02.19.69.77.49','06.97.82.21.04',NULL,'3 RUE DEES AUBEPINES','','','14260','AUNAY SUR ODON',NULL,NULL,'1551114118002',1438.000000000,'1976-04-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8019,'GAILLARD','SIMONNE','1933-05-12','02.11.42.05.63','06.96.77.42.06',NULL,'7 CITE BELLE VUE','','',NULL,NULL,NULL,NULL,'2330514610002',226.000000000,'1954-02-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8020,'RICHARD','Stephanie','1951-05-15','02.96.14.23.77','06.69.22.52.68',NULL,'10 ALLEE DES POMMIERS','','','14120','MONDEVILLE',NULL,NULL,'1510514364002',216.000000000,'1972-02-10','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8021,'VEYSSEIRE','FRANCOISE','1930-12-16','02.21.52.68.98','06.19.11.37.52',NULL,'147 chemin de la vertiniere','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2301214236002',251.000000000,'1957-06-09','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8022,'RAMARD','EVELYNE','1939-06-10','02.41.70.06.72','06.70.02.63.47',NULL,'1/1 ALLEE DU BASILIC','','','14730','GIBERVILLE',NULL,NULL,'2390614431002',485.000000000,'1969-05-26','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8023,'BAGLIN','MONIQUE','1934-07-27','02.88.78.33.27','06.11.89.82.91',NULL,'7 RUE DES LILAS','','','14930','ETERVILLE',NULL,NULL,'2340753185002',37.000000000,'1955-07-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8024,'LEBOEUF','MICHEL','1965-10-30','02.45.70.40.68','06.74.44.28.96',NULL,'L''OISONNERIE','','','14000','CAEN',NULL,NULL,'1651014319002',2.000000000,'1989-11-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8025,'BUCHART','ARLETTE','1929-06-25','02.67.56.27.68','06.85.73.28.29',NULL,'24 PLACE DES DRAKKARS','','','14540','ROCQUANCOURT',NULL,NULL,'1290614101002',275.000000000,'1952-11-01','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8026,'MARIE','SIMONE',NULL,'02.59.23.50.09','06.16.44.55.00',NULL,'18 RUE LOUISE MICHEL','','','14210','BARON SUR ODON',NULL,NULL,'1420250363002',98.000000000,'2013-03-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8027,'SALLE','ELIANE','1939-08-22','02.58.08.89.14','06.64.29.55.63',NULL,'10 RUE DES TENNIS','','','14000','CAEN',NULL,NULL,'2390814654002',3599.000000000,'1963-08-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8028,'HUGGHE','PHILIPPE','1954-02-18','02.68.92.20.34','06.11.01.04.50',NULL,'4 rue de la garre','','','14190','OUILLY LE TESSON',NULL,NULL,'2540214393002',20.000000000,'1975-06-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8029,'JAMAULT','JEAN JACQUES','1968-02-05','02.98.09.36.15','06.39.40.86.09',NULL,'6 RUE PASTEUR','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1680214338002',325.000000000,'1993-09-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8030,'LEROUX','AZIZA','1933-11-20','02.89.65.01.96','06.21.21.03.92',NULL,'LE MONT JOLY','','','14190','ST SYLVAIN',NULL,NULL,'1331150071002',280.000000000,'1959-05-11','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8031,'LEPAGE','DANIELLE','1941-08-15','02.11.91.02.77','06.11.43.53.41',NULL,'447 ROUTE DE THURY HARCOURT','','','14370','BILLY',NULL,NULL,'1410850227002',207.000000000,'1966-07-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8032,'ENAULT','MAURICE','1934-02-17','02.44.60.59.20','06.39.66.80.93',NULL,'15 RUE DE GRENTHEVILLE','','','14160','DIVES SUR MER',NULL,NULL,'1340214616002',48.000000000,'1955-12-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8033,'MESSIDOR','MONIQUE','1931-11-04','02.11.01.34.78','06.82.97.96.99',NULL,'58 RUE DE NORTHAM','','','61200','ARGENTAN',NULL,NULL,'2311114704002',3741.000000000,'1960-04-25','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8034,'DESVIGNE','GERARD','1919-08-28','02.28.81.13.70','06.91.40.15.09',NULL,'2 AVENUE GENERAL LAPERRINE','','','14000','CAEN',NULL,NULL,'1190850348002',558.000000000,'1942-10-04','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8035,'MARION','SYLVIE','1986-02-01','02.88.00.14.86','06.97.25.75.31',NULL,'8 rue des tilleuls','','','14630','CAGNY',NULL,NULL,'2860298747002',234.000000000,'2009-01-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8036,'MARIE','GUY','1956-05-24','02.80.65.24.61','06.12.55.50.96',NULL,'6 RUE ETIENNE VERVISCH','','','14000','CAEN',NULL,NULL,'2560514150002',158.000000000,'1980-01-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8037,'NARDY','ALAIN','1936-04-15','02.83.44.13.23','06.38.52.44.80',NULL,'chemin de blamont','','','61200','ARGENTAN',NULL,NULL,'1360414357002',568.000000000,'1958-05-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8038,'DESVIGNE','JEAN-PIERRE','1933-04-17','02.83.06.35.38','06.85.14.97.44',NULL,'4 RUE ST JEAN BAPTISTE','','','14000','CAEN',NULL,NULL,'2330450456002',19.000000000,'1956-06-17','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8039,'DOUTRESOUL','GINETTE-BLANCHE','1955-05-15','02.25.06.15.83','06.99.79.01.91',NULL,'61 RUE ERNEST  MANCHON','','','14120','MONDEVILLE',NULL,NULL,'2550514224002',33.000000000,'1976-08-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8040,'CORDIER','THERESE','1943-06-12','02.37.47.68.18','06.32.34.67.36',NULL,'L HERBEY','','','14123','IFS',NULL,NULL,'1430614282002',70.000000000,'1967-06-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8041,'LE MAITRE','NOEL','1938-11-29','02.64.00.63.52','06.27.40.05.87',NULL,'LE BOURG','','','14540','HUBERT FOLIE',NULL,NULL,'2381114730002',840.000000000,'1968-01-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8042,'LAINEY','Benoit','1945-01-21','02.67.72.31.14','06.61.59.92.77',NULL,'24 RUE ALEXANDRE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2450150130002',21.000000000,'1975-11-08','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8043,'AUBE','EDOUARD','1929-07-12','02.53.48.33.87','06.46.97.36.02',NULL,'421 LA BRUYERE DE CALEVILLE','','','14860','ROBEHOMME',NULL,NULL,'1290735084002',838.000000000,'1950-04-20','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8044,'MAGNIER','ODETTE','1941-04-13','02.17.91.56.83','06.10.58.38.19',NULL,'LE BEFFEUX','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1410414357002',17.000000000,'1963-02-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8045,'PICHARD','CLAUDE','1948-08-01','02.11.79.49.78','06.34.32.44.51',NULL,'123 BD DU GENERAL VANIER','','','14000','CAEN',NULL,NULL,'1480814554002',313.000000000,'1969-11-11','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8046,'LEBOUTEILLER','','1930-04-28','02.63.62.43.77','06.10.90.18.22',NULL,'LE LOCHEUR','','','14000','CAEN',NULL,NULL,'2300450586002',28.000000000,'1953-07-03','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8047,'MARTIN','RENEE','1934-09-05','02.97.96.35.84','06.86.77.14.02',NULL,'42 CLOS JOLI','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2340914114002',755.000000000,'1964-05-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8048,'FAUCON','BENOIT','1943-03-22','02.72.52.82.79','06.85.35.68.96',NULL,'3 RUE DE SAVOIE','','','14630','FRENOUVILLE',NULL,NULL,'2430359124002',48.000000000,'1971-12-24','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8049,'COLEAUX','christian','1979-07-09','02.65.92.74.88',NULL,NULL,'4 rue jean jacques rousseau','','',NULL,NULL,NULL,NULL,'1790775111002',134.000000000,'2004-06-07','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8050,'DUVAL PITEL','','1940-01-21','02.50.90.75.13','06.78.75.98.10',NULL,'10 RUE LUCIEN ROPARS','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'2400196111002',733.000000000,'1963-10-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8051,'GARNIER','RAYMONDE','1930-10-26','02.73.95.95.75','06.10.46.67.65',NULL,'7 RUE JOLLIOT .CURRY','','','14270','MEZIDON CANON',NULL,NULL,'2301014628002',9.000000000,'1958-05-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8052,'LEVANNIER','MICHEL','1947-07-29','02.80.96.65.00','06.18.64.97.43',NULL,'26 rue st michel','','','14160','DIVES SUR MER',NULL,NULL,'1470714340002',563.000000000,'1973-08-22','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8053,'JULIENNE','THERESE','1931-12-07','02.83.74.97.60',NULL,NULL,'3 RUE DU LIEUTENANT LOUIS RENOUF','','','14840','DEMOUVILLE',NULL,NULL,'2311214653002',20.000000000,'1953-05-15','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8054,'BARBANCHON','PATRICK','1967-02-11',NULL,NULL,NULL,'25 BIS ROUTE D''HARCOURT','','','14850','HEROUVILLETTE',NULL,NULL,'1670227151002',42.000000000,'1991-05-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8055,'BOTTET','LAURENCE','1938-09-28','02.11.77.50.30','06.23.82.24.44',NULL,'VILLAGE DES HAISES','','','14150','OUISTREHAM',NULL,NULL,'2380914124002',418.000000000,'1968-10-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8056,'MAINCENT','YVES','1964-03-13','02.86.96.46.27','06.69.54.62.68',NULL,'15 ROUTE DE LA GUERINIERE','','','14670','TROARN',NULL,NULL,'2640314118002',452.000000000,'1991-01-09','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8057,'LEGRIX','','1939-09-27','02.39.87.98.94','06.83.33.70.86',NULL,'123 ALLEE DE LA CLAIRIERE','','','14000','CAEN',NULL,NULL,'2390914167002',484.000000000,'1961-02-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8058,'GRATALOUP','GUY','1948-02-01','02.87.84.44.20','06.46.76.09.58',NULL,'6 RESIDENCE ST EXUPERE','','','14000','CAEN',NULL,NULL,'1480251416002',1337.000000000,'1977-10-13','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8059,'MEUNIER','DENISE','1943-07-06','02.57.82.28.37','06.47.74.59.94',NULL,'6 rue du pere joseph','','','14400','ST VIGOR LE GRAND',NULL,NULL,'1430755501002',36.000000000,'1964-07-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8060,'CEBULA','PASCAL','1929-08-27','02.53.63.09.31','06.69.79.97.69',NULL,'7 PLACE DES TOURELLES','','','14000','CAEN',NULL,NULL,'2290850050002',1014.000000000,'1957-05-02','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8061,'FEROUELLE','JEAN PIERRE','1957-04-03',NULL,NULL,NULL,'1 IMPASSE  CHIRONNE','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1570414661002',65.000000000,'1987-04-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8062,'LEMENAND','LEONTINE',NULL,'02.10.42.60.95','06.89.29.92.23',NULL,'14 RUE DE MILLEHARTS','','','14540','ROCQUANCOURT',NULL,NULL,'1560814553002',1976.000000000,'2010-02-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8063,'VALLICCIONI','JOSEPH','1931-07-31','02.15.27.87.80','00 33 6.34.36.98.52',NULL,'12 CITE DES CLOS','','','14000','CAEN',NULL,NULL,'2310714367002',153.000000000,'1958-05-09','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8064,'ESSANAA','JEANNE','1952-07-15','02.17.14.46.13','06.65.76.07.57',NULL,'le bourg','','','14190','CAUVICOURT',NULL,NULL,'2520714186002',486.000000000,'1978-03-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8065,'ENAULT','GERARD','1931-10-20','02.81.41.78.34','06.31.68.15.93',NULL,'13 rue de breteville','','','14630','EMIEVILLE',NULL,NULL,'1311014413002',322.000000000,'1961-11-26','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8066,'BOISSEAU','JEAN PIERR','1941-09-30','02.11.22.79.62','06.65.75.61.07',NULL,'2 rue pierre mendes france','','','14270','CONDE SUR IFS',NULL,NULL,'1410914096002',2.000000000,'1962-06-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8067,'VOISIN','JEAN LUC','1969-01-11','02.11.06.61.49','06.49.16.90.35',NULL,'11 rue de dublin','','','14000','CAEN',NULL,NULL,'1690179049002',99.000000000,'1992-03-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8068,'GIGON','CATHERINE','1982-10-08','02.72.38.12.08','06.47.54.00.02',NULL,'38 rue du quebec','','','14860','RANVILLE',NULL,NULL,'2821099242002',62.000000000,'2010-07-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8069,'GROULT','PASCAL','1929-10-10','02.73.86.04.63','06.53.06.31.18',NULL,'5 RUE CAMILLE BLAIZOT','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'2291014589002',18.000000000,'1954-05-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8070,'BRUNET','MICHEL','1945-08-25','02.64.01.03.10','06.11.73.00.48',NULL,'57 rue calmette','','','14000','GIBERVILLE',NULL,NULL,'1450850482002',373.000000000,'1968-07-24','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8071,'CENEDESE','ANNICK','1957-04-13','02.54.77.70.49','06.96.38.82.22',NULL,'29 RUE DES ECOLES','','','14000','CAEN',NULL,NULL,'1570461124002',462.000000000,'1981-01-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8072,'VAULTIER','ROLANDE','1955-04-24','02.14.59.31.28','06.39.08.73.35',NULL,'','','','14540','SOLIERS',NULL,NULL,'1550461207002',74.000000000,'1978-07-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8073,'DELIVET','MONIQUE','1968-01-02','02.92.44.75.81','06.60.90.45.00',NULL,'37 BOULEVARD DETOLLE','','','14370','ARGENCES',NULL,NULL,'2680114623002',4038.000000000,'1995-08-16','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8074,'LESERVOISIER','bernadette','1964-10-12','02.41.01.88.97','06.45.95.93.31',NULL,'8 RESIDENCE LES VERGERS','','','14000','CAEN',NULL,NULL,'2641050617002',330.000000000,'1990-06-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8075,'THOMAS','BERNARD','1942-05-22','02.15.93.25.99','06.55.93.96.05',NULL,'14 alle des poetes','','','14123','FLEURY SUR ORNE',NULL,NULL,'1420514616002',2647.000000000,'1964-11-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8076,'PICQUE','ANTHONY','1941-01-24','02.69.91.45.39','06.35.06.24.08',NULL,'70 rue des acacias','','','14850','ESCOVILLE',NULL,NULL,'1410127050002',93.000000000,'1963-04-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8077,'BARON','jean marc','1930-06-10','02.51.18.49.00','06.36.73.75.28',NULL,'16 rte de benouville','','','14220','LES MOUTIERS EN CINGLAIS',NULL,NULL,'1300614658002',29.000000000,'1955-02-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8078,'CHAVENTRE','MONIQUE-EUGENI','1960-11-29','02.49.95.82.83','00 33 6.50.37.43.32',NULL,'11 ALLEE DES MARGUERITES','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1601114323002',145.000000000,'1989-07-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8079,'GAREL','MARYLINE','1928-05-20','03.26.33.02.64','06.22.39.10.08',NULL,'21 ROUTE DE BOUGY','','','08000','CHARLEVILLE MEZIERES',NULL,NULL,'2280559247002',39.000000000,'1958-04-23','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8080,'TROUILLOT','BRUNO','1957-06-26','02.51.45.98.73','06.10.98.99.35',NULL,'ROUTE DE LA VALLEE','','','14140','LIVAROT',NULL,NULL,'2570614034002',257.000000000,'1979-11-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8081,'LAINE','ERIC','1937-06-17','02.14.26.89.95','06.40.61.00.93',NULL,'46 bd georges pompidou','','','14730','GIBERVILLE',NULL,NULL,'1370644069002',40.000000000,'1961-02-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8082,'LOHIER','CHRISTOPHE','1939-09-28','02.44.84.19.10','06.40.28.60.06',NULL,'8 rue romain roland','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2390914204002',27.000000000,'1961-10-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8083,'LABROUQUERE','claude','1931-04-09','02.53.38.03.36','06.10.64.13.96',NULL,'','','','50420','TESSY SUR VIRE',NULL,NULL,'1310414258002',34.000000000,'1959-03-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8084,'DOZIERE','ISABELLE','1931-04-06','02.16.82.73.26','06.61.68.29.48',NULL,'CHATEAU ST GILES','','','14540','SOLIERS',NULL,NULL,'1310414258002',49.000000000,'1955-02-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8085,'OLIVIER','MICHELINE','1944-12-29','02.31.55.96.11','00 33 6.33.46.97.52',NULL,'hameaux de bernire','','','14320','MAY SUR ORNE',NULL,NULL,'2441275009002',428.000000000,'1967-12-27','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8086,'BOULAY','SERGE','1956-07-20','02.43.43.83.66','06.18.71.93.36',NULL,'9 RUE GUSTAVE FLAUBERT','','','14120','MONDEVILLE',NULL,NULL,'1560714226002',664.000000000,'1982-11-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8087,'CHATEL','MICHELINE','1939-11-17','02.25.92.65.33','06.66.21.99.07',NULL,'27 rue de broceliande','','','14000','CAEN',NULL,NULL,'2391114191002',30.000000000,'1964-05-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8088,'CHAUVIN','JULIETTE','1953-01-09','02.41.69.34.30','06.49.01.70.62',NULL,'29 rue gustade','','','14400','ST VIGOR LE GRAND',NULL,NULL,'2530114407002',88.000000000,'1983-04-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8089,'DADURE','NELLY','1936-04-25','02.62.23.11.52','06.37.48.11.24',NULL,'6 RUE JEAN CATHERINE','','','14123','IFS',NULL,NULL,'2360440201002',20.000000000,'1959-10-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8090,'LEBAS','JOSEPH','1930-11-07','02.47.26.05.41','06.19.55.14.01',NULL,'23 RUE FROIDE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2301178268002',347.000000000,'1956-05-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8091,'BERARD','PIERRE','1940-02-26','02.62.74.90.44',NULL,NULL,'','','','14370','ARGENCES',NULL,NULL,'2400214209002',4729.000000000,'1961-08-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8092,'HUET','ALAIN','1935-01-27','02.62.30.86.02','06.70.67.51.07',NULL,'9 RUE BERTHAULD','','','14370','ARGENCES',NULL,NULL,'1350150546002',1622.000000000,'1964-08-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8093,'HAREL','GENEVIEVE','1948-09-18','02.40.36.81.99','06.89.47.54.31',NULL,'LE BOURG','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2480914681002',16.000000000,'1969-05-16','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8094,'ANDOUARD','MARTINE','1952-04-22','02.20.51.27.80','06.42.77.14.68',NULL,'31 ALLEE DE LA FERME','','','14220','BOULON',NULL,NULL,'2520414695002',1773.000000000,'1975-02-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8095,'HOUELBEC','JEAN','1963-10-09','02.83.89.47.94','06.62.77.18.20',NULL,'21 RUE D''ENFER','','','14840','DEMOUVILLE',NULL,NULL,'2631014467002',45.000000000,'1984-02-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8096,'FERRAND','JEAN PIERRE','1937-10-02','02.19.40.09.52','06.68.26.72.98',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'2371014310002',939.000000000,'1959-08-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8097,'VARDON','frederic','1941-03-15','02.58.04.36.47','06.78.81.68.60',NULL,'10 RUE DES MESANGES','','','14540','POUSSY LA CAMPAGNE',NULL,NULL,'1410314730002',160.000000000,'1964-05-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8098,'LEJEUNE','MONIQUE','1936-10-24','02.51.80.95.24','06.99.50.74.50',NULL,'4 RUE DES AIRBORNES','','','14430','HOTOT EN AUGE',NULL,NULL,'1361061232002',98.000000000,'1963-02-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8099,'GALLIOT','LEONE',NULL,'02.58.10.64.56','06.52.38.12.50',NULL,'84 RUE GEORGES CLEMENCEAU','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1360950222002',1274.000000000,'2012-12-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8100,'LARDOUX','HENRIETTE','1942-10-27','02.16.70.15.34','06.15.72.96.24',NULL,'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX','XXXXXXXXXXXXXXXXXXXXXXXXXXXXX','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1421061314002',241.000000000,'1972-09-14','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8101,'DELANGHE','','1955-01-06','02.23.34.41.74',NULL,NULL,'74 BIS RUE GAMBETTA','','','14270','MEZIDON CANON',NULL,NULL,'2550162827002',5.000000000,'1976-12-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8102,'LEBAILLY','CLAUDINE','1933-03-29','02.35.05.17.80','06.20.53.80.23',NULL,'2 rue de la pomme d''or','','','14000','CAEN',NULL,NULL,'1330314078002',99.000000000,'1956-04-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8103,'GRANDSIRE','YVETTE','1946-08-30','02.69.00.84.55','06.78.36.18.02',NULL,'21 rue des regrets lotissement d','es tilleuls','','14510','HOULGATE',NULL,NULL,'2460814751002',184.000000000,'1969-07-06','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8104,'TAOUJI','PIERRE','1941-09-08','02.53.07.23.81','06.83.43.46.98',NULL,'11 RUE DES BASSES TERRES','','','14540','GRENTHEVILLE',NULL,NULL,'1410914096002',105.000000000,'1971-03-18','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8105,'DAVID','VERONIQUE','1944-06-09','02.50.12.86.19','06.18.75.17.04',NULL,'14 RUE DE LA MAIRIE','','','61120','ORVILLE',NULL,NULL,'2440661069002',206.000000000,'1972-10-06','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8106,'MARGUERITE','DOMINIQUE','1949-10-26','02.90.57.09.28','06.67.76.66.37',NULL,'21 RUE DES 13 ACRES','','','61200','ARGENTAN',NULL,NULL,'2491014681002',167.000000000,'1975-06-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8107,'REBUFFONI','CHRISTIAN','1936-03-29','02.75.73.21.73','06.56.11.33.95',NULL,'22 BD RAYMOND POINCARE','','','14840','DEMOUVILLE',NULL,NULL,'2360314585002',848.000000000,'1959-08-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8108,'HARDOUIN','ROGER','1941-11-30','02.33.81.71.61','06.19.70.02.30',NULL,'18 RUE DE LA MER','','','14730','GIBERVILLE',NULL,NULL,'1411162510002',72.000000000,'1966-12-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8109,'CHAUVET','EDITH','1946-06-08','02.27.73.52.17','06.12.96.69.28',NULL,'l aiguillee','','','14111','LOUVIGNY',NULL,NULL,'2460614577002',1684.000000000,'1968-09-14','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8110,'MESLET','FRANCIS','1941-04-02','03.41.83.53.44','06.10.98.16.91',NULL,'24 rue des cerisiers','','','08110','CARIGNAN',NULL,NULL,'2410414447002',378.000000000,'1962-11-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8111,'TOUBALEM','FARID','1938-12-23','02.44.16.04.24','06.43.05.67.34',NULL,'3 BASSE RUE','','','14670','BURES SUR DIVES',NULL,NULL,'2381214115002',6.000000000,'1966-06-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8112,'VERLY','BERNARD','1933-04-23','02.39.54.30.29','06.73.24.66.94',NULL,'3 BASSE RUE','','','14570','ST REMY',NULL,NULL,'1330414752002',1148.000000000,'1959-01-12','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8113,'LUCET','OLIVIER','1935-08-24','02.93.11.48.07','06.40.02.80.45',NULL,'9 impasse de l egalite','','','14000','CAEN',NULL,NULL,'2350814327002',1922.000000000,'1965-12-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8114,'FAVRIS','GUY','1970-01-21','02.14.56.46.29','06.38.46.67.28',NULL,'19 rue de suede','','','14000','CAEN',NULL,NULL,'2700161145002',105.000000000,'1994-08-21','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8115,'GAREL','Marie-louise','1960-07-20','02.80.26.36.22','06.10.58.85.23',NULL,'10 RUE DU TEMPS PERDU','','','14123','IFS',NULL,NULL,'1600714566002',231.000000000,'1990-11-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8116,'LEPARMENTIER','','1930-07-08','02.39.86.36.82','06.10.99.33.73',NULL,'','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'2300707324002',42.000000000,'1951-10-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8117,'DUBUCS','FERNANDE','1958-10-18','02.10.03.79.00','06.82.94.84.77',NULL,'9 RUE DE LA MADELEINE RENAUD','','','50700','VALOGNES',NULL,NULL,'2581014708002',17.000000000,'1980-12-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8118,'PICARD','CHRISTINA','1952-06-02','02.10.87.43.52','06.65.65.87.08',NULL,'','','','14000','CAEN',NULL,NULL,'1520661132002',616.000000000,'1973-01-29','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8119,'HUE','MICHELLE','1939-06-23','02.50.21.61.60','06.64.20.15.77',NULL,'27 RUE CHAGFORD','','','14370','CHICHEBOVILLE',NULL,NULL,'2390614364002',1913.000000000,'1962-01-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8120,'SIMON','NADINE','1954-12-02','02.16.37.69.92','06.74.67.19.68',NULL,'LE TESSON','','','14000','CAEN',NULL,NULL,'1541214017002',988.000000000,'1983-10-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8121,'LOUVEL','SYLVIE','1939-05-18','02.88.10.59.67','06.90.54.20.59',NULL,'201 bvd du grand parc','','','14460','COLOMBELLES',NULL,NULL,'2390514070002',77.000000000,'1968-03-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8122,'HUE','NADINE','1957-02-11','02.46.30.27.24','06.38.56.38.30',NULL,'201 bvd du grand parc','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1570214383002',74.000000000,'1981-10-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8123,'MARANGER','CATHERINE','1954-03-23','02.87.13.25.14','06.54.00.84.78',NULL,'11 rue paul langevin','','','14000','CAEN',NULL,NULL,'2540350005002',11.000000000,'1975-05-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8124,'MANCHION','JEAN PIERRE','1936-08-23','02.11.55.02.54','06.44.53.09.67',NULL,'22 AV DE LA CONCORDE','','','14120','MONDEVILLE',NULL,NULL,'1360850414002',66.000000000,'1958-10-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8125,'BRIOSNE','daniel','1936-03-29','02.51.77.87.71','06.63.59.72.72',NULL,'LE BOURG','','','14370','BELLENGREVILLE',NULL,NULL,'2360314643002',909.000000000,'1963-05-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8126,'LETELLIER','PATRICIA','1928-01-06','02.97.90.51.34','06.11.27.60.50',NULL,'14 RUE DES 2 SICILES','','','50000','ST LO',NULL,NULL,'2280102552002',1594.000000000,'1953-11-15','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8127,'HERICHER','MARIE THERESE',NULL,'02.55.09.80.91','06.37.21.16.40',NULL,'80 RUE DE FALAISE','','','14000','CAEN',NULL,NULL,'1300153053002',152.000000000,'2011-10-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8128,'LEVINDRE','MARIE','1936-04-29','02.75.68.37.18','06.93.87.94.00',NULL,'32 AVENUE FOCH','','','14120','MONDEVILLE',NULL,NULL,'1360414357002',86.000000000,'1959-12-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8129,'FOLDRIN','AGNES','1917-11-16','02.17.69.39.88','06.31.77.22.94',NULL,'ROUTE DE L''EGLISE','','','14110','CONDE SUR NOIREAU',NULL,NULL,'1171127289002',790.000000000,'1940-02-04','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8130,'LECOEUR','STEPHANIE','1962-06-25','02.70.86.31.32','06.33.13.11.44',NULL,'11 RUE DES BOULEAUX','','','14490','LA BAZOQUE',NULL,NULL,'2620614719002',70.000000000,'1984-05-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8131,'CLEMENT','JEAN',NULL,'02.13.34.62.78','06.14.98.16.64',NULL,'LE MAREE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2650714431002',16.000000000,'2008-07-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8132,'SABINE','LILIANE','1936-03-16','02.99.68.23.12','06.10.67.66.54',NULL,'RUE PIAU','','','14000','CAEN',NULL,NULL,'1360314306002',740.000000000,'1966-06-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8133,'GILLETTE','LEON','1956-06-09','02.57.95.57.63','06.88.69.08.66',NULL,'1 4 allee des capucines','','','14670','ST PAIR',NULL,NULL,'1560661071002',65.000000000,'1982-11-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8134,'FARCY','GILLES','1956-06-28','02.59.47.71.18','06.17.36.61.22',NULL,'11 RUE DES FOSSETTES','','','50410','PERCY',NULL,NULL,'1560661071002',186.000000000,'1978-06-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8135,'POISSON','JEAN-LUC','1968-09-09','02.13.08.34.16','06.10.48.91.60',NULL,'12 AVENUE DOCTEUR MAURICE COLLIN','','','14730','GIBERVILLE',NULL,NULL,'1680914118002',49.000000000,'1991-10-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8136,'ROUSSEL','MARCELLE','1932-02-03','02.54.39.21.92','06.40.85.34.06',NULL,'14 rue de la rouvre','','','50110','TOURLAVILLE',NULL,NULL,'2320214100002',25.000000000,'1958-04-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8137,'MEZIERES','BERNARD','1939-09-26','02.58.14.01.98','06.11.46.11.02',NULL,'16 RTE DU PONT DU COUDRAY','','','14190','BRETTEVILLE LE RABET',NULL,NULL,'1390914715002',1.000000000,'1960-01-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8138,'JANUSKIEWICZ','RENEE','1930-07-12','02.11.17.74.25',NULL,NULL,'10 ALLEE PAUL HELUARD','','','14540','SOLIERS',NULL,NULL,'2300714530002',1140.000000000,'1959-01-25','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8139,'SERVAIN','GEORGETTE','1928-02-12','02.37.92.39.06','06.49.42.15.17',NULL,'2 lotissement la bagotiere','','','14370','BISSIERES',NULL,NULL,'2280214166002',54.000000000,'1958-03-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8140,'DUQUESNEY','THIERRY','1954-12-24','02.92.84.96.99','06.69.54.28.08',NULL,'15 ROUTE DE LA GUERINIERE','','','14370','ARGENCES',NULL,NULL,'2541222140002',777.000000000,'1979-08-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8141,'EUGENE','RAPHAEL','1932-04-18','02.88.15.33.95','06.85.27.30.72',NULL,'14 rue d angletaire','','','14630','FRENOUVILLE',NULL,NULL,'1320450631002',839.000000000,'1955-07-20','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8142,'CATHERINE','FRANCINE','1940-07-21','02.91.00.00.93','06.17.83.12.11',NULL,'LA BRUYERE','','','14120','MONDEVILLE',NULL,NULL,'1400714437002',2121.000000000,'1964-02-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8143,'VETILLARD','CHRISTELLE','1933-10-12','02.92.50.07.29','06.86.09.38.63',NULL,'','','','50500','ST HILAIRE PETITVILLE',NULL,NULL,'1331027470002',271.000000000,'1954-06-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8144,'HUET','MAURICETTE','1959-04-18','02.50.89.43.23','06.69.88.51.87',NULL,'39 rue de vaucelles','','','14730','GIBERVILLE',NULL,NULL,'1590414378002',62.000000000,'1989-11-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8145,'DUCHESNE','','1947-09-23','02.98.21.74.70',NULL,NULL,'LE BOURG TOURNIERES','','','14190','ST SYLVAIN',NULL,NULL,'1470914393002',151.000000000,'1974-04-13','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8146,'ROUYER','MARIANNICK','1935-06-21','02.17.06.77.61','06.81.31.03.39',NULL,'56 rue robillard','','','14840','CUVERVILLE',NULL,NULL,'1350661486002',18.000000000,'1956-09-06','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8147,'LEMEUNIER','JEAN MICHEL','1958-05-17','02.23.18.24.85','06.12.20.95.38',NULL,'13 RUE DE L''HOTEL DE VILLE','','','14630','CAGNY',NULL,NULL,'1580514432002',10.000000000,'1980-03-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8148,'BAYEUX','COLETTE','1964-12-23','02.70.79.40.02','06.76.41.33.55',NULL,'9 imp des pres','','','14120','MONDEVILLE',NULL,NULL,'2641250474002',766.000000000,'1988-07-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8149,'DUBOIS','RAYMOND','1939-08-04','02.90.65.34.76','06.76.96.07.56',NULL,'26 AVENUE LEON BLUM','','','14370','MERY CORBON',NULL,NULL,'1390814628002',2777.000000000,'1964-11-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8150,'DUPONT','DANIEL','1953-02-27','02.69.10.77.87','06.10.35.83.35',NULL,'2 CHEMIN DU LAIZON','','','14000','CAEN',NULL,NULL,'2530280268002',323.000000000,'1981-09-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8151,'DUFFOURG','JOCELYNE','1946-10-04','02.81.59.77.35','06.87.90.76.96',NULL,'6 RUE DE LA DEMELEE','','','14111','LOUVIGNY',NULL,NULL,'1461014254002',1812.000000000,'1967-09-04','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8152,'ALLAIN','laurence','1928-03-02','02.49.60.21.92','06.80.95.92.21',NULL,'3 RUE DE L HOTEL DE VILLE','','','61310','ST PIERRE LA RIVIERE',NULL,NULL,'2280314290002',91.000000000,'1952-10-24','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8153,'DUTHE','ARLETTE','1963-07-23','02.80.42.27.16','06.35.30.14.96',NULL,'2 TER RUE ALBERDI','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1630714432002',15.000000000,'1988-12-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8154,'DUHAMEL','JOSEPH','1963-02-24','02.73.99.74.66',NULL,NULL,'8 BIS AV CH DE GAULLES','','','14320','FONTENAY LE MARMION',NULL,NULL,'1630214221002',199.000000000,'1987-12-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8155,'GOUVILLE','MICHEL','1937-04-01','02.70.29.38.15','06.86.03.38.83',NULL,'2 TER LA BRUYERE','','','14370','ARGENCES',NULL,NULL,'1370414076002',255.000000000,'1967-08-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8156,'PEREZ','JEANNINE','1935-05-14','02.27.67.15.06','06.31.19.69.16',NULL,'74 IMPASSE DU HAMEL','','','14270','CESNY AUX VIGNES OUEZY',NULL,NULL,'2350553033002',98.000000000,'1956-01-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8157,'LECLEROT','JACKY','1932-05-22','02.86.81.61.48','06.39.90.08.52',NULL,'3 ALBERT VIELLE','','','14240','SERMENTOT',NULL,NULL,'2320514069002',64.000000000,'1953-01-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8158,'MONNIETTE','MARIUS','1942-05-23','02.57.82.99.48','06.32.34.67.82',NULL,'7 BVD DES ALLIES','','','14000','CAEN',NULL,NULL,'1420514616002',32.000000000,'1966-06-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8159,'AMAND','YVETTE','1961-11-29','02.58.22.79.80','06.11.92.04.92',NULL,'9 RUE FRANZ','','','14370','MOULT',NULL,NULL,'1611114007002',34.000000000,'1991-12-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8160,'BASLY','MARIE HELENE','1934-09-14','02.39.90.69.69','06.34.16.68.48',NULL,'5 RUE DE SUEDE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1340921425002',785.000000000,'1963-08-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8161,'TALBOT','PIERRE','1930-07-09','02.14.13.55.63','06.38.23.56.72',NULL,'9 SQUARE DU CENTRE','','','14270','MEZIDON CANON',NULL,NULL,'1300714310002',6.000000000,'1952-06-24','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8162,'CATILLON','ANDRE','1959-10-25','02.10.09.14.00','06.13.68.19.09',NULL,'HAMEAUX  DE BERNIERES','','',NULL,NULL,NULL,NULL,'1591014094002',195.000000000,'1981-11-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8163,'BELLANGER','SIMONNE','1959-10-23','02.10.21.79.88','06.54.83.68.44',NULL,'8 route de vimont','','','14270','MEZIDON CANON',NULL,NULL,'1591014094002',120.000000000,'1981-05-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8164,'','MIREILLE',NULL,'02.15.86.79.50','06.34.59.81.51',NULL,'12 avenue duy 43 rgt d'' artiller','ie','','61310','VILLEBADIN',NULL,NULL,'2360150272002',981.000000000,'2010-01-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8165,'LEFETEY','GUY','1949-04-20','02.21.28.05.87','06.40.65.89.89',NULL,'1 rue de vaudieres','','','14330','LE MOLAY LITTRY',NULL,NULL,'1490414252002',937.000000000,'1970-03-19','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8166,'LAUNAY','CHRISTELLE','1930-03-21','02.99.94.56.08','06.28.21.48.08',NULL,'15 RUE DU 18 JUILLET','','','14000','CAEN',NULL,NULL,'2300377240002',83.000000000,'1957-12-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8167,'DUMONT','MAURICETTE','1931-07-10','02.11.34.54.96','06.91.15.45.64',NULL,'RAGNY','','','14000','CAEN',NULL,NULL,'1310714707002',15.000000000,'1952-08-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8168,'LEMIEUX','JACQUELINE','1987-12-30','02.62.67.06.36','06.97.99.41.15',NULL,'27 RUE DU BLANC','','','14270','MEZIDON CANON',NULL,NULL,'1871299242002',103.000000000,'2012-12-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8169,'LEMOUSSU','FRANCOIS','1935-01-27','02.11.41.97.17','06.12.13.21.46',NULL,'64 route de lyon','','','14310','TOURNAY SUR ODON',NULL,NULL,'2350176421002',439.000000000,'1959-05-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8170,'CHOLET','GERARD','1932-09-27','02.22.08.09.78','06.48.29.26.24',NULL,'30 RUE DES CANADIENS','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'1320950601002',58.000000000,'1957-10-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8171,'ANDRE','ALAIN','1931-10-22','02.20.87.05.32','06.97.02.18.88',NULL,'2 RUE SAINT GABRIEL','','','14540','ROCQUANCOURT',NULL,NULL,'2311014454002',9.000000000,'1961-10-24','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8172,'MAZZOCKI','MARGUERITE','1955-02-05','02.12.32.35.62','06.10.37.98.50',NULL,'4 RUE ST ANDRE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2550214597002',210.000000000,'1979-04-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8173,'PHILIPPE','THERESE','1945-10-20','02.83.36.14.91','06.19.57.49.43',NULL,'20 rue richard 1er','','','14730','GIBERVILLE',NULL,NULL,'1451088236002',634.000000000,'1974-08-01','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8174,'LAMY','MIREILLE','1933-02-01','02.45.35.34.84','06.50.53.63.56',NULL,'35 av albert 1er','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2330250563002',101.000000000,'1957-11-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8175,'CARON','JEAN','1955-11-12','02.45.11.07.24','06.18.99.49.87',NULL,'3 avenue charlotte corday','','','14110','CONDE SUR NOIREAU',NULL,NULL,'2551114703002',263.000000000,'1976-03-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8176,'LAFONTAINE','REMY','1952-03-13','02.88.82.07.20','06.28.31.87.94',NULL,'15 ALLEE JACQUES PREVERT','','','14000','CAEN',NULL,NULL,'1520353262002',517.000000000,'1982-09-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8177,'CAILLY','CHRISTINE','1929-09-26','02.70.10.99.40','06.79.95.14.58',NULL,'8 ROUTE DE OUISTREHAM','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1290914752002',1254.000000000,'1950-08-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8178,'VITCHEN','JEAN CLAUDE',NULL,'02.68.50.96.84','06.43.96.83.34',NULL,'4 RUE DES PLEINS CHAMPS','','','14000','CAEN',NULL,NULL,'1290114327002',5357.000000000,'2011-01-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8179,'RENAUD','JACQUELINE','1938-04-05','02.54.26.19.06','06.11.48.59.37',NULL,'4 IMPASSE  DES ALPES','','','14000','CAEN',NULL,NULL,'2380450576002',18.000000000,'1962-08-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8180,'DEMOTA','ANNA','1947-02-15','02.18.88.47.20','06.54.80.46.31',NULL,'HAMEAU DE RENOUVILLE','','','14270','CONDE SUR IFS',NULL,NULL,'2470253002002',391.000000000,'1977-03-14','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8181,'GONANO','GILBERT','1938-04-17','02.36.68.42.98','06.33.88.85.94',NULL,'ROUTE DE LA VARINIERE','','','14120','MONDEVILLE',NULL,NULL,'2380457542002',11.000000000,'1959-11-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8182,'CAIGNARD','ANNE MARIE','1960-11-09','02.15.53.84.12','06.61.58.07.79',NULL,'12 RUE SEIGLE','','','14120','MONDEVILLE',NULL,NULL,'2601114316002',99.000000000,'1981-01-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8183,'BOUQUEREL','DIDIER','1939-11-21','02.56.23.45.18','06.60.94.27.04',NULL,'3 allee de vienne','','','14123','FLEURY SUR ORNE',NULL,NULL,'1391114407002',139.000000000,'1962-10-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8184,'DULONG','VIVIANE','1934-06-03','02.83.45.38.11','06.91.54.00.89',NULL,'22 rue aux renards','','','14860','AMFREVILLE',NULL,NULL,'1340614383002',942.000000000,'1958-03-13','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8185,'LE HENAFF','REGINE','1964-01-08','02.71.62.90.18','06.87.91.77.38',NULL,'1 IMPASSE CROIZAT','','','14000','CAEN',NULL,NULL,'1640161044002',189.000000000,'1987-08-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8186,'DORADOUX','RENEE','1931-07-07','02.13.45.61.89','06.41.36.35.55',NULL,'85 rue d hasting','','','14150','OUISTREHAM',NULL,NULL,'2310759656002',73.000000000,'1955-03-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8187,'GUILLET','GUY','1930-08-16','02.74.15.99.85',NULL,NULL,'4 rue paul langevin','','','14370','CHICHEBOVILLE',NULL,NULL,'1300878190002',103.000000000,'1953-02-12','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8188,'GUESNON','JOELLE','1958-06-21','02.24.46.68.62','06.43.03.69.71',NULL,'9 PLACE DE LA MAIRIE','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1580614125002',3209.000000000,'1987-11-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8189,'GUESNON','PATRICE','1939-02-13','02.54.34.44.90','06.37.44.95.56',NULL,'34 VILLAGE SAINT EXPERE','','','14570','CLECY',NULL,NULL,'1390250265002',189.000000000,'1961-05-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8190,'TREBOUILLARD','MARIE','1934-03-10','02.99.11.56.03','06.51.03.27.43',NULL,'5 BIS RUE PIERRE GUEROULT','','','14000','CAEN',NULL,NULL,'2340314431002',1316.000000000,'1960-01-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8191,'PAN','CHANTAL','1936-12-27','02.13.61.51.97','06.57.12.80.43',NULL,'5 rue du gros pommier','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1361214101002',2.000000000,'1957-08-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8192,'POUSSARD','RAYMOND','1967-10-01','02.15.58.23.93','06.85.32.40.41',NULL,'29 blvd de rethel','','','14000','CAEN',NULL,NULL,'1671014271002',68.000000000,'1988-09-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8193,'CLIQUET','FRANCOIS','1963-06-06','02.54.88.31.49','06.84.94.51.21',NULL,'15 CHEMIN DU BOIS D''ALENCON','','','14840','DEMOUVILLE',NULL,NULL,'1630614118002',102.000000000,'1991-09-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8194,'AUVRAY','EMMANUEL','1931-10-05','02.40.63.35.27','06.56.86.33.95',NULL,'6 rue des jacinthes','','','14130','BONNEVILLE LA LOUVET',NULL,NULL,'1311014718002',586.000000000,'1957-12-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8195,'FERAY','MARIE','1938-02-18','02.32.36.81.45','06.14.70.44.18',NULL,'16 rue jules ferry','','','14370','BELLENGREVILLE',NULL,NULL,'1380214174002',791.000000000,'1961-10-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8196,'MOULIN','MIREILLE','1943-03-01','02.11.34.95.86','06.34.40.78.37',NULL,'10 RUE GENERAL LECLERC','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2430359124002',97.000000000,'1971-10-11','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8197,'DUPLESSIS','NADEJDA','1929-10-15','02.74.93.86.69',NULL,NULL,'54 ROUTE D''IFS','','','14000','CAEN',NULL,NULL,'1291053083002',326.000000000,'1951-03-14','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8198,'SALVETAT','','1934-12-09','02.27.87.60.78','06.31.00.00.41',NULL,'7 RUE D''ARDENNES','','','14240','CAUMONT L''EVENTE',NULL,NULL,'2341214516002',38.000000000,'1959-08-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8199,'ALLEAUME','STEPHANE','1928-05-10','02.65.15.84.38','06.73.88.61.22',NULL,'163 rue e zola','','','14670','JANVILLE',NULL,NULL,'2280550418002',57.000000000,'1952-05-12','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8200,'BEAUMOIS','JOSEPH','1931-03-01','02.10.48.98.69','06.18.49.11.76',NULL,'MAISON DE RETRAITE BRIERE LEMPER','IERE','','14310','LANDES SUR AJON',NULL,NULL,'1310350202002',420.000000000,'1959-09-05','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8201,'COUTURE','JEAN PHILIPPE','1962-08-04','02.27.70.97.38','06.86.15.24.73',NULL,'6 RUE BONNISSENT','','','14220','MUTRECY',NULL,NULL,'1620814266002',32.000000000,'1990-11-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8202,'BRAEM','MONIQUE',NULL,'02.34.97.34.02','06.82.66.00.88',NULL,'102 ROUTE D HARCOURT','','','14000','CAEN',NULL,NULL,'2770499107002',27.000000000,'2013-05-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8203,'HAMEAU','LOUIS','1931-08-27','02.11.47.80.86','06.90.86.36.77',NULL,'14/2 rue du 6 juin','','','61210','PUTANGES PONT ECREPIN',NULL,NULL,'2310814027002',388.000000000,'1960-06-23','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8204,'FAVRIS','CLAUDE','1939-09-25','02.70.64.92.13','06.90.69.27.46',NULL,'4 impasse du perret','','','14270','MEZIDON CANON',NULL,NULL,'2390950082002',127.000000000,'1963-12-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8205,'CAUCHARD','','1942-03-04','02.22.12.58.57','06.96.35.22.64',NULL,'15 rue des rosiers','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'1420314159002',311.000000000,'1972-02-07','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8206,'HUNEL','EWING','1957-08-03','02.85.27.93.57','06.60.20.76.60',NULL,'RUE ETERNELLE','','','14930','ETERVILLE',NULL,NULL,'1570814206002',907.000000000,'1982-03-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8207,'CLAIREL','RAYMONDE','1938-10-24','02.11.96.74.69',NULL,NULL,'5 RUE DU MAJOR MARTIN','','','14220','CROISILLES',NULL,NULL,'2381050012002',586.000000000,'1968-08-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8208,'BANVILLE','JOEL','1943-01-16','02.37.23.42.97','06.58.50.61.61',NULL,'77 RUE D''HASTINGS','','','14710','TREVIERES',NULL,NULL,'2430161378002',947.000000000,'1965-05-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8209,'FLAUSS','THERESE','1945-02-24','02.41.46.12.75','06.46.26.40.00',NULL,'18 RUE DU BLANC','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1450276702002',38.000000000,'1975-03-01','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8210,'SIMON','FERNAND','1955-09-30','02.57.71.78.30','06.70.47.48.56',NULL,'20 RUE DE LA VIELLE EGLISE','','','14400','SOMMERVIEU',NULL,NULL,'1550950350002',113.000000000,'1979-10-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8211,'','MALIKA','1931-01-26','02.53.75.69.74',NULL,NULL,'75 ROUTE DE COLLEVILLE','','','14500','VIRE',NULL,NULL,'2310149218002',855.000000000,'1955-01-07','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8212,'PIGEON','GILBERT','1934-09-15','02.58.67.47.87','06.28.28.82.72',NULL,'15 RUE DE LA ROSERAIE','','','14000','CAEN',NULL,NULL,'2340928287002',15.000000000,'1956-03-09','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8213,'LARSONNEUR','CHRISTIAN','1933-02-01','02.27.93.33.09','00 33 6.86.06.70.52',NULL,'7 rue de la 59e division','','','14120','MONDEVILLE',NULL,NULL,'2330272158002',8.000000000,'1955-07-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8214,'FOUQUES','REMI','1937-04-07','02.20.67.07.89','06.19.79.95.69',NULL,'22 RUE DE LA FRESNAYE','','','53250','MADRE',NULL,NULL,'2370414488002',117.000000000,'1967-07-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8215,'DAVID','LAURENCE','1930-10-03','02.66.24.29.24','06.55.19.13.36',NULL,'LE PLATEAU','','','14000','CAEN',NULL,NULL,'2301061454002',250.000000000,'1960-03-31','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8216,'RENOUF','ANNICK','1952-03-26','02.22.82.91.91','06.56.51.10.41',NULL,'20 RUE DU SIEUR DU BRAS','','','14123','FLEURY SUR ORNE',NULL,NULL,'1520350185002',743.000000000,'1976-03-17','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8217,'JUHEL','ARNAUD','1931-04-19','02.29.44.16.98','06.64.78.62.49',NULL,'le pre de l eglise','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1310414258002',232.000000000,'1961-02-11','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8218,'HUET','CATHERINE',NULL,'02.61.90.48.82','06.79.02.24.58',NULL,'8 RUE DU PHARE','','','14150','OUISTREHAM',NULL,NULL,'1390961342002',515.000000000,'2008-07-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8219,'DEVILLE','ALAIN','1937-05-09','02.40.63.25.87','06.70.03.94.71',NULL,'60 avenue flandres dunkerque','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2370514268002',36.000000000,'1960-01-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8220,'DUVAL','jannick','1936-07-29','02.42.66.19.10','06.80.09.84.16',NULL,'LA LANDE LES CAMELIAS','','','14610','VILLONS LES BUISSONS',NULL,NULL,'2360714312002',98.000000000,'1964-06-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8221,'DAVID','ANNIE','1957-01-23','02.77.60.06.95','06.34.37.69.95',NULL,'28 rue de l''glise','','',NULL,NULL,NULL,NULL,'2570114631002',41.000000000,'1980-10-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8222,'HAMEL','THIERRY','1949-07-24','02.76.33.16.04','06.11.23.78.95',NULL,'le mont attelin','','','14670','TROARN',NULL,NULL,'1490777439002',85.000000000,'1975-07-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8223,'LEROYER','MICHEL','1934-07-27','02.49.43.77.28','06.62.39.01.67',NULL,'4 AVENUE DE LA REPUBLIQUE','','','14000','CAEN',NULL,NULL,'1340750172002',127.000000000,'1956-08-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8224,'CAPELLE','COLETTE','1938-05-18','02.88.64.21.50','06.45.08.70.67',NULL,'LES HAUTES RIVIERES','','','14400','LE MANOIR',NULL,NULL,'2380514050002',57.000000000,'1964-12-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8225,'QUENET','SYLVIE','1934-01-29','02.44.80.13.01','06.46.61.80.70',NULL,'512 BD DE LA GRANDE DELLE','','','61120','VIMOUTIERS',NULL,NULL,'1340114562002',22.000000000,'1962-08-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8226,'GILLETTE','PHILIPPE','1957-02-13','02.54.71.88.24','06.24.99.26.99',NULL,'2 av des cloustiers','','','14530','LUC SUR MER',NULL,NULL,'1570214698002',194.000000000,'1978-04-17','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8227,'BEN SALAH','JOCELYNE','1928-02-20','02.56.98.11.23','06.10.78.40.85',NULL,'VILLAGE LA CROIX','','','14120','MONDEVILLE',NULL,NULL,'1280214158002',1378.000000000,'1951-03-20','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8228,'HRUSKA','JEANNINE','1941-08-02','02.28.47.32.69','06.38.07.52.37',NULL,'3 rue raoul tesson','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'2410850039002',1534.000000000,'1970-08-01','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8229,'DERRIEN','MAURICETTE','1935-03-17','02.91.02.47.56','06.98.53.50.08',NULL,'121 rue du vieux manoir','','',NULL,NULL,NULL,NULL,'2350350088002',829.000000000,'1956-04-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8230,'CHIEU','GERARD','1950-02-23','02.10.98.24.70','06.48.04.51.75',NULL,'','','','14000','CAEN',NULL,NULL,'2500214266002',128.000000000,'1971-08-30','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8231,'DUCHEMIN','PAULETTE','1959-01-16','02.38.21.62.18','06.41.96.02.18',NULL,'RUE DE LA POSTE','','','14860','AMFREVILLE',NULL,NULL,'2590114685002',2.000000000,'1983-08-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8232,'LOUATRON','THEODORE','1933-05-24','02.37.49.68.38','06.52.92.16.39',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1330514220002',785.000000000,'1963-02-20','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8233,'LEPOULTIER','IRENA','1965-04-19','02.52.31.83.27','06.87.52.28.69',NULL,'168 RUE DE LA LUZERNE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1650414294002',40.000000000,'1987-05-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8234,'ORAIN','PHILIPPE','1965-04-26','02.78.29.73.36','06.39.29.31.30',NULL,'24 RUE JEAN BOUCARD','','','14370','CHICHEBOVILLE',NULL,NULL,'1650414294002',733.000000000,'1995-11-28','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8235,'ROUILLARD','JEAN MARIE','1934-06-15','02.83.62.24.94','06.81.11.77.68',NULL,'lieu dit guillerville','','','14260','AUNAY SUR ODON',NULL,NULL,'2340614100002',43.000000000,'1959-12-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8236,'AUVRAY','JOCELYNE','1969-10-20','02.80.37.74.63',NULL,NULL,'3 rsidence st pre','','','14210','MISSY',NULL,NULL,'2691078311002',2801.000000000,'1998-06-12','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8237,'RENAUD','MONIQUE','1964-06-02','02.87.54.74.30',NULL,NULL,'33 BOULEVARD RAYMOND POINCARE','','','14700','ERAINES',NULL,NULL,'1640614143002',16.000000000,'1989-01-08','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8238,'MARCELLE','MONIQUE','1955-08-04','02.81.63.19.66','06.52.55.84.96',NULL,'30 rue des jardins','','','14000','CAEN',NULL,NULL,'1550850490002',43.000000000,'1979-11-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8239,'DAGORT','ANDREE','1968-10-21','02.85.77.02.50','06.36.60.13.28',NULL,'DU DOUET','','','14270','MEZIDON CANON',NULL,NULL,'1681014197002',1066.000000000,'1992-09-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8240,'CATHERINE','MARCELLE','1936-12-21','02.34.56.88.07','06.52.66.16.09',NULL,'','','',NULL,NULL,NULL,NULL,'1361214197002',225.000000000,'1963-11-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8241,'GLINEL','claude','1960-01-04','02.68.05.97.43','06.85.66.98.26',NULL,'50 rue du paty','','','14370','ARGENCES',NULL,NULL,'2600114618002',141.000000000,'1983-03-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8242,'BAPTISTE','CLAUDINE','1929-04-20','02.52.98.67.69','06.77.84.79.94',NULL,'62 rue armand  marie','','','14250','JUAYE MONDAYE',NULL,NULL,'2290427485002',598.000000000,'1952-08-31','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8243,'DAVY','FRANCINE','1936-10-01','02.28.99.07.87','06.88.52.87.60',NULL,'17 RUE DE MARTIN VILLE','','','14940','SANNERVILLE',NULL,NULL,'1361014383002',34.000000000,'1959-10-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8244,'MESNIL','BERNARD','1954-01-19','02.10.12.19.71','06.84.86.11.02',NULL,'37 RUE DE LA LIBERTE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2540114027002',66.000000000,'1981-10-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8245,'COLLETTE','RENE','1929-04-28','02.36.23.83.17','06.89.54.43.25',NULL,'8 RUE DES TILLEULS','','','14270','MAGNY LA CAMPAGNE',NULL,NULL,'2290414541002',194.000000000,'1954-03-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8246,'PLANQUETTE','DENISE','1938-05-03','02.48.30.44.66','06.73.24.39.33',NULL,'49 rue michel anne','','','14190','URVILLE',NULL,NULL,'2380514465002',2472.000000000,'1966-04-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8247,'LECOZ','FERNANDE','1947-06-04','02.52.15.47.16','06.29.73.94.57',NULL,'17 rue de bonn','','','14000','CAEN',NULL,NULL,'1470650387002',73.000000000,'1977-10-11','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8248,'DEQUAINDRY','JOCELYNE','1927-03-12','02.90.09.96.18','06.14.04.82.39',NULL,'12 RUE DU DAUPHINE','','','14670','TROARN',NULL,NULL,'1270362160002',16.000000000,'1950-11-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8249,'LEPETIT','STEPHANE',NULL,'02.31.09.98.17','06.92.92.53.47',NULL,'1 BIS ROGER SALENGRO','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2330527179002',36.000000000,'2012-07-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8250,'SCANCAR','GINETTE','1949-02-07','02.31.23.27.79','06.45.17.01.01',NULL,'22 AV DU GENERAL LAVERYNE','','','14000','CAEN',NULL,NULL,'2490214137002',183.000000000,'1978-07-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8251,'BLAIS','JACQUES','1953-05-01','02.13.10.77.41','06.10.40.77.83',NULL,'18 RUE ARISTIDE BRIAND','','','14000','CAEN',NULL,NULL,'1530504008002',10.000000000,'1974-08-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8252,'BELOIN','MARIE LAURE','1937-06-10','02.25.81.41.49','06.24.89.16.98',NULL,'835 HAUTE FOLIE','','','14630','CAGNY',NULL,NULL,'1370614258002',2.000000000,'1963-02-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8253,'LEGUEDOIS','CHRISTIANE','1936-04-30','02.90.64.81.38','06.87.44.06.25',NULL,'7 rue jean jacques rousseau gue','riniere','','14210','CHEUX',NULL,NULL,'2360414167002',374.000000000,'1963-02-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8254,'MARIE','REMY','1961-05-26','02.72.62.96.46','06.18.75.26.46',NULL,'16 RUE DE MA DRID','','',NULL,NULL,NULL,NULL,'1610514145002',15.000000000,'1988-09-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8255,'VALLICCIONI','JACQUES','1955-01-30','02.79.08.34.22','06.59.41.24.13',NULL,'11 rue paul langevin','','','14680','GOUVIX',NULL,NULL,'2550114499002',983.000000000,'1982-05-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8256,'PIERRE','DANIEL','1955-01-22','02.89.94.77.59','06.57.37.09.97',NULL,'','','',NULL,NULL,NULL,NULL,'2550114499002',122.000000000,'1980-05-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8257,'RUFFIN','HUGUETTE','1954-06-03','02.12.26.90.82','06.24.91.69.84',NULL,'HARAS D''ELLON','','','14370','CLEVILLE',NULL,NULL,'2540627009002',9.000000000,'1982-08-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8258,'FOUCHET','JEANINE','1943-09-02','02.79.02.69.68','06.10.87.30.91',NULL,'9 IMPASSE DES POMMIERS','','','14120','MONDEVILLE',NULL,NULL,'2430978322002',26.000000000,'1969-03-08','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8259,'LEREBOURS','YVETTE','1944-05-11','02.43.91.04.43','06.84.91.61.41',NULL,'3 PLACE LOUISE DE MARILLAC','','','14270','MEZIDON CANON',NULL,NULL,'2440514527002',73.000000000,'1968-02-13','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8260,'DENIS','GEORGES','1937-03-29',NULL,NULL,NULL,'13 rue des premontres','','','14310','LONGVILLERS',NULL,NULL,'1370314301002',28.000000000,'1962-03-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8261,'LEGENDRE','LOUIS','1934-12-02','02.73.74.84.02',NULL,NULL,'3 RUE DU COMMANDANT LECOUTOUR','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2341227398002',462.000000000,'1964-12-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8262,'GONDOUIN','CATHERINE','1929-09-10','02.43.16.49.70','06.45.11.91.20',NULL,'13 impasse des vosges','','','14160','DIVES SUR MER',NULL,NULL,'2290914151002',1769.000000000,'1959-08-01','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8263,'CHIRVANIAN','GEORGES','1935-02-15','02.10.54.86.93','06.50.98.91.05',NULL,'RUE ALBERT LEPEE','','','14470','COURSEULLES SUR MER',NULL,NULL,'2350214119002',32.000000000,'1957-03-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8264,'GOSSELIN','ANGELE','1960-09-15','02.24.83.54.74',NULL,NULL,'2 ALLEE DE LA FOSSETTE','','','14630','CAGNY',NULL,NULL,'1600914640002',75.000000000,'1988-09-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8265,'DUVEY','EVELINE','1955-03-12','02.65.81.26.47','06.79.28.91.52',NULL,'1 rue ledanois','','','14270','MEZIDON CANON',NULL,NULL,'1550314002002',2665.000000000,'1978-12-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8266,'SOYER','SIMONE',NULL,'02.54.29.62.80','06.26.63.12.95',NULL,'11 RUE DE L ODON','','','14420','SOUMONT ST QUENTIN',NULL,NULL,'2702099344002',87.000000000,'2009-04-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8267,'BAUDET','BRIGITTE','1947-10-09','02.84.05.18.65','06.90.34.90.76',NULL,'5 PLACE RHIN ET DANUBE','','','14111','LOUVIGNY',NULL,NULL,'2471061256002',549.000000000,'1970-07-03','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8268,'AUZOU','GILBERT','1937-05-30','02.77.70.32.22','06.90.73.89.63',NULL,'63 rue voltaire','','','14000','CAEN',NULL,NULL,'1370561391002',597.000000000,'1967-12-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8269,'ADAM','YVON','1933-05-18','02.88.93.65.93','06.41.13.99.25',NULL,'HAMEAU DE BUSSY','','','14370','ARGENCES',NULL,NULL,'2330556080002',5.000000000,'1956-06-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8270,'ROBIEUX','OSMAN','1958-05-10','02.74.70.68.14',NULL,NULL,'','','','14000','CAEN',NULL,NULL,'1580514015002',178.000000000,'1988-09-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8271,'SURIREY','ANNICK','1950-12-21','02.49.96.26.26','06.70.95.22.79',NULL,'18 rte du robillard','','','14420','VILLERS CANIVET',NULL,NULL,'2501214118002',119.000000000,'1975-04-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8272,'BERCEAU','JACQUELINE','1968-01-23','02.16.87.97.29','06.94.35.29.90',NULL,'60 RUE CHARLES NODIER','','','14111','LOUVIGNY',NULL,NULL,'1680125057002',932.000000000,'1997-01-13','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8273,'BOYER','LILIANE','1930-11-27','02.18.17.88.49','06.60.11.83.11',NULL,'19 rue du 6juin','','','14123','FLEURY SUR ORNE',NULL,NULL,'2301114090002',30.000000000,'1953-04-01','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8274,'HOUEL','CLAUDE','1945-08-22','02.67.40.05.53','06.68.85.40.82',NULL,'12 rue l bossoutrot','','','14370','MERY CORBON',NULL,NULL,'1450814458002',724.000000000,'1970-08-10','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8275,'LEMOIGNE','ALAIN','1956-08-28','02.85.22.50.02','06.55.37.36.33',NULL,'10 RUE DES AUGES','','','14123','IFS',NULL,NULL,'1560814553002',31.000000000,'1983-09-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8276,'FIANT','ANNICK','1959-02-05','02.77.53.86.11','06.11.89.88.15',NULL,'','','','14121','SALLENELLES',NULL,NULL,'2590214309002',88.000000000,'1980-04-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8277,'','SYLVETTE',NULL,'02.76.70.98.34','06.79.62.53.37',NULL,'LA CHAUMIERE','','','14000','CAEN',NULL,NULL,'2390350414002',88.000000000,'2009-02-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8278,'LAINEY','DANIEL','1942-02-07','02.16.97.96.04','06.58.50.30.83',NULL,'14 rue jacques brel','','','14160','DIVES SUR MER',NULL,NULL,'1420214643002',38.000000000,'1963-07-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8279,'BESNARD','DENISE','1930-10-08','02.24.00.96.43','06.47.18.59.69',NULL,'9 ROUTE DE FALAISE','','','14630','CAGNY',NULL,NULL,'1301080167002',65.000000000,'1951-01-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8280,'ERY','MICHELLE',NULL,'02.74.69.25.79',NULL,NULL,'2 RUE FRANCOIS MAURIAC','','','14270','MEZIDON CANON',NULL,NULL,'2330114342002',697.000000000,'2009-12-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8281,'VAUMOUSSE','EMMANUEL','1933-04-18','02.11.76.98.32','06.36.73.57.12',NULL,'8 RUE A.FRILEY','','','50000','ST LO',NULL,NULL,'2330450173002',233.000000000,'1957-06-22','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8282,'LEBORGNE','Louis','1930-02-12','02.11.82.15.55','06.12.19.12.88',NULL,'2 RUE DES FRESNES','','','14000','CAEN',NULL,NULL,'2300214009002',40.000000000,'1951-09-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8283,'MARIE','PIERRE','1953-05-13','02.93.44.41.02','06.30.96.44.90',NULL,'8 IMPASSE DES MONTS','','','14123','IFS',NULL,NULL,'1530504008002',709.000000000,'1974-07-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8284,'SOREL','PIERRE','1968-09-01','02.49.40.08.49','06.10.68.39.66',NULL,'7 rue damozanne','','','14000','CAEN',NULL,NULL,'1680914181002',867.000000000,'1994-04-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8285,'LIEGARD','GILLES','1952-09-25','02.20.88.64.82','06.58.75.49.08',NULL,'63 RUE DU CHEMIN VERT','','','14630','CAGNY',NULL,NULL,'2520914324002',424.000000000,'1973-01-02','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8286,'CONOS','JANIQUE','1931-06-15','02.68.96.09.39','06.77.55.49.15',NULL,'','','','14860','RANVILLE',NULL,NULL,'2310614341002',175.000000000,'1955-01-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8287,'LEFRANC','GUY','1940-10-19','02.89.48.82.28','06.67.15.22.96',NULL,'11 RUE YVONNE DE REVIERS','','','14000','CAEN',NULL,NULL,'1401014118002',33.000000000,'1968-06-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8288,'AUBERT','CHRISTINE','1967-06-20','02.81.39.69.45','06.62.82.08.77',NULL,'ROUTE DE LISIEUX','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'1670614126002',369.000000000,'1996-05-28','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8289,'CHENET','CARMEN','1950-09-05','02.72.57.00.37','06.31.54.51.03',NULL,'8 chemin des tinards','','','14460','COLOMBELLES',NULL,NULL,'1500914499002',148.000000000,'1977-07-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8290,'BONNIFAIT','MONIQUE','1928-12-08','02.83.26.88.16','06.48.00.22.98',NULL,'19 rue de la croix odin','','','14670','BURES SUR DIVES',NULL,NULL,'2281214631002',170.000000000,'1951-12-30','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8291,'BONNIFAIT','PIERRE','1931-06-12','02.14.35.22.46','06.26.61.95.19',NULL,'6 RUE VALES DUNES','','','14000','CAEN',NULL,NULL,'1310675066002',18.000000000,'1961-03-07','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8292,'DELABY','CORINNE','1937-03-13','02.20.67.87.71','06.58.94.47.11',NULL,'19 place du champs foire','','','14730','GIBERVILLE',NULL,NULL,'1370314118002',150.000000000,'1961-06-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8293,'CLERC','NICOLE','1967-05-30','02.58.45.95.54','06.44.93.78.93',NULL,'7 RUE DES BONS ENFANTS','','','61200','ARGENTAN',NULL,NULL,'1670551108002',6.000000000,'1990-01-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8294,'MAIGNAN','PEA','1936-01-30','02.22.57.77.64','06.10.94.29.38',NULL,'28 AVENUE DE ROUEN','','','14370','ARGENCES',NULL,NULL,'2360114364002',494.000000000,'1959-06-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8295,'PACILLY','HUBERT',NULL,'02.33.59.67.46','06.51.94.70.07',NULL,'1 RUE DE LA MOINERIE','','','14000','CAEN',NULL,NULL,'1580814529002',817.000000000,'2008-01-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8296,'GODET','PHILIPPE','1935-10-19','02.10.48.89.82','06.37.42.60.22',NULL,'206 RUE DE BAYEUX','','','14460','COLOMBELLES',NULL,NULL,'1351014431002',496.000000000,'1965-03-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8297,'PRADON','JEANNINE','1937-02-08','02.26.89.58.81','00 33 6.57.63.00.82',NULL,'12 rue du mont','','','14000','CAEN',NULL,NULL,'2370250004002',41.000000000,'1965-04-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8298,'BOUET','CHRISTINE','1979-07-28','02.11.17.26.02','06.33.36.62.11',NULL,'LE HAMEL','','','14270','MEZIDON CANON',NULL,NULL,'1790799155002',100.000000000,'2009-01-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8299,'LEGOFF','VICTORINE','1936-04-27','02.20.67.58.84','06.24.66.27.67',NULL,'3 RUE DU CLOS JOLI','','','14000','CAEN',NULL,NULL,'1360489024002',11.000000000,'1960-09-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8300,'BESNOUIN','nadia','1934-11-03','02.39.68.69.52','06.76.67.96.40',NULL,'','','','14130','BONNEVILLE LA LOUVET',NULL,NULL,'2341114372002',203.000000000,'1958-07-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8301,'TURPIN','FRANCOISE','1934-11-21','02.21.58.91.53','06.35.78.78.26',NULL,'1 RUE DES ANCIENS LAVOIRS','','','14000','CAEN',NULL,NULL,'2341114372002',53.000000000,'1961-04-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8302,'ONFROY','IRENE',NULL,'02.42.54.69.47','06.90.66.02.82',NULL,'15 rue du bois protte','','','14480','LE FRESNE CAMILLY',NULL,NULL,'1580450263002',521.000000000,'2012-10-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8303,'PAQUIER','CHRISTINE','1941-04-09','02.18.40.69.12','06.99.40.21.30',NULL,'13 rue des tilleuls','','','14000','CAEN',NULL,NULL,'1410414679002',1328.000000000,'1962-05-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8304,'HAUDEBAULT','PATRICIA','1961-11-28','02.78.30.22.47','06.67.12.33.14',NULL,'RESIDENCE DU VAL 504 bvd du val','','','14120','MONDEVILLE',NULL,NULL,'1611114007002',46.000000000,'1990-11-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8305,'BROCHARD','COLETTE','1964-11-27','02.76.52.15.09','06.54.80.66.85',NULL,'1 rue des accacias','','','14370','MERY CORBON',NULL,NULL,'2641150502002',333.000000000,'1985-11-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8306,'LEGUAY','ANNE-MARIE','1941-03-25','02.70.29.85.55','06.23.92.30.42',NULL,'129 BD RAYMOND POINCARE RESIDEN','CE LE PARIS','','14000','CAEN',NULL,NULL,'2410314291002',105.000000000,'1969-11-28','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8307,'DEROIN','JOCELYNE','1940-03-22','02.86.81.38.95','06.23.76.11.59',NULL,'74 IMPASSE DUHAMEL','','','14700','VERSAINVILLE',NULL,NULL,'1400350579002',130.000000000,'1961-12-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8308,'BERCHIO','CECILE','1939-07-25','02.77.40.13.81','06.10.03.87.31',NULL,'1202 GRANDE DELLE','','','14500','VIRE',NULL,NULL,'1390785165002',80.000000000,'1963-02-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8309,'TRANCHAND','CLAUDE','1941-06-08','02.78.16.55.28','06.89.92.16.51',NULL,'RESIDENCE DES COTEAUX','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'1410686076002',222.000000000,'1964-07-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8310,'DAUVERGNE','JEAN PIERRE','1954-07-25','02.66.12.52.27','06.62.54.71.38',NULL,'3 rue roger dechambre','','','14123','FLEURY SUR ORNE',NULL,NULL,'2540714298002',46.000000000,'1980-04-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8311,'RAVALET','GILLES','1954-07-27','02.27.29.55.91','06.60.57.06.96',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'2540714714002',21.000000000,'1978-08-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8312,'LEPRINCE','DANIEL','1934-05-13','02.88.56.07.68','06.72.64.96.92',NULL,'50 RUE D''AUTHIE','','','14000','CAEN',NULL,NULL,'2340514431002',12.000000000,'1964-05-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8313,'AUBERT','PIERRE','1964-01-28','02.39.65.28.97','06.29.39.63.74',NULL,'FOYER RESIDENCE RUE DES ACACIA','S','','61490','ST CLAIR DE HALOUZE',NULL,NULL,'2640114673002',1179.000000000,'1986-12-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8314,'AUBERT','BIENAIME','1951-06-14','02.72.33.63.24','06.27.75.03.47',NULL,'51 rue de bagnoles de l''orne','','','14330','LE MOLAY LITTRY',NULL,NULL,'1510614703002',86.000000000,'1976-05-22','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8315,'CHARLES','MARIE THERESE','1931-05-13','02.75.75.99.02','06.86.53.26.70',NULL,'4/2 CITE DES ROCHES','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'1310550030002',105.000000000,'1953-05-14','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8316,'CHEVAL','LUCIENNE','1937-10-29','02.28.11.94.29','06.55.46.20.12',NULL,'2 rue des boulots','','','14350','ST MARTIN DES BESACES',NULL,NULL,'2371050425002',33.000000000,'1965-10-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8317,'LEFORT','','1936-09-25','02.12.11.16.67','06.70.67.36.99',NULL,'2 rue des boulots','','','14680','GIBERVILLE',NULL,NULL,'2360972265002',12.000000000,'1957-12-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8318,'VASNIER','FRANCOISE','1967-09-09','02.80.93.83.87','06.34.22.59.03',NULL,'28 place de la mairie','','','14123','IFS',NULL,NULL,'2670914712002',65.000000000,'1993-10-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8319,'TOUBALEM','GINETTE','1953-08-01','02.41.70.21.78','06.30.23.34.91',NULL,'6 rue henri cochet','','','14670','ST OUEN DU MESNIL OGER',NULL,NULL,'1530814114002',63.000000000,'1977-05-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8320,'MAITRE','GILLES','1935-09-22','02.44.15.69.64','06.63.10.36.79',NULL,'15 RUE HAUTE','','','14500','VAUDRY',NULL,NULL,'2350978513002',406.000000000,'1958-01-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8321,'BUHOT','genevieve','1935-09-25','02.11.75.66.39','06.88.60.63.14',NULL,'3/4 RUE DES SPORTS','','','14000','CAEN',NULL,NULL,'2350978513002',26.000000000,'1958-12-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8322,'LEPY','CLAIRE','1957-08-26','02.11.75.91.36','06.23.96.02.02',NULL,'28 RUE HENRI CHERON VENOIX','','','14540','SOLIERS',NULL,NULL,'1570814206002',108.000000000,'1986-01-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8323,'MARTIN','AUGUSTE','1960-05-30','02.41.69.21.67','06.56.71.25.12',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1600514163002',3723.000000000,'1985-04-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8324,'COHIER','PHILIPPE','1965-05-28','02.81.86.56.61','06.12.25.43.93',NULL,'135 BOULEVARD GENERAL VASNIER','','','14123','IFS',NULL,NULL,'2650514589002',81.000000000,'1987-09-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8325,'LECUYER','NELLY','1969-11-25','02.54.08.36.47','06.60.73.59.35',NULL,'8 RUE JACQUES BREVAIRE','','','14320','LAIZE LA VILLE',NULL,NULL,'2691177288002',2.000000000,'1990-02-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8326,'VIEILLARD','PIERRETTE','1949-06-19','02.39.94.35.03','06.97.20.53.95',NULL,'13 rue Jacques Brel','','','14410','VASSY',NULL,NULL,'1490614146002',2688.000000000,'1974-11-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8327,'DALYS','Rene','1934-07-04','02.17.20.21.89','06.20.08.44.71',NULL,'4 2 rue de la renaissance','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1340761389002',903.000000000,'1957-07-26','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8328,'MURY','COLETTE','1934-06-17','02.50.11.84.29','06.91.42.07.15',NULL,'19 RUE ROBERT DESNOST','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2340614662002',84.000000000,'1963-06-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8329,'GUIHENEUC','Rene','1945-01-09','02.44.66.01.14','06.46.99.76.56',NULL,'6 AVENUE MADAME DE SEGUR','','','14120','MONDEVILLE',NULL,NULL,'1450172061002',20.000000000,'1972-05-24','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8330,'BIGOIN','Ren','1937-03-28','02.54.80.04.56','06.14.51.78.25',NULL,'43 CHEMIN DE L''INFIRMERIE','','','14000','CAEN',NULL,NULL,'1370361150002',1773.000000000,'1967-05-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8331,'TRIFONOVA','THERESE','1937-02-22','02.11.10.51.84','06.71.62.30.67',NULL,'84 RUE DE LA SEINE','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'2370214174002',114.000000000,'1959-04-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8332,'AUBERT','JOSEPH','1933-07-22','02.89.14.54.75','06.71.24.12.50',NULL,'8 RUE DU CHATEAU D''EAU','','','14930','ETERVILLE',NULL,NULL,'1330750484002',7.000000000,'1957-12-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8333,'MARIE','ANDRE','1944-02-02','02.40.20.15.65','06.77.43.53.09',NULL,'15 RUE DE LA LIBERATION','','','14123','IFS',NULL,NULL,'2440214100002',605.000000000,'1967-07-18','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8334,'CERISEL','PATRICK','1938-03-11','02.86.83.76.94','06.72.52.03.67',NULL,'13 alle de l''alberta  APP 11','','','14460','COLOMBELLES',NULL,NULL,'1380314663002',127.000000000,'1961-08-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8335,'LEBLOND','BRUNO','1927-10-22','02.93.59.25.45','06.10.87.78.41',NULL,'8 rue du val','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2271087095002',132.000000000,'1952-04-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8336,'VIGAN','Alain','1953-01-20','02.97.47.83.31','06.79.70.93.29',NULL,'10 RUE DES LILAS','','',NULL,NULL,NULL,NULL,'1530114633002',99.000000000,'1979-01-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8337,'RENAUDEAU','EMILE','1939-02-19','02.75.83.46.68','06.12.23.92.16',NULL,'21 rue theodore gericault','','','14120','MONDEVILLE',NULL,NULL,'2390214225002',202.000000000,'1969-09-12','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8338,'HAMELIN','MARIE THERESE','1969-06-25','02.45.31.55.61','06.87.20.48.61',NULL,'6 rue des anciens combatants d''a','lgerie','',NULL,NULL,NULL,NULL,'2690683023002',152.000000000,'1999-07-15','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8339,'LE BIHAN','MONIQUE','1953-02-01','02.40.90.11.05','06.23.94.58.61',NULL,'9 rue des cormorrants','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2530214335002',14.000000000,'1981-02-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8340,'GREFFE','SIMONE','1954-01-30','02.12.22.35.68','06.50.92.60.93',NULL,'place des tilleuls','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2540114313002',189.000000000,'1982-05-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8341,'FERIANI','BRIGITTE','1942-01-11','02.52.80.79.81','06.33.29.48.05',NULL,'11 RUE L AIGUILLON','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2420150270002',2793.000000000,'1965-12-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8342,'HARDY','CARMEN','1958-03-28','02.57.89.08.57','06.34.01.59.81',NULL,'61 RUE ERNEST  MANCHON','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2580314038002',81.000000000,'1979-07-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8343,'PALATRE','LOUIS','1966-04-30',NULL,NULL,NULL,'CHEZ MME BEBERT MARTINE 2 RUE LO','UIS BRAILLE','','14120','MONDEVILLE',NULL,NULL,'2660414181002',60.000000000,'1989-09-08','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8344,'BUHOT','THIERRY','1936-07-10','02.85.20.74.35',NULL,NULL,'6 RUE DES ARDENNES','','','14000','CAEN',NULL,NULL,'1360714407002',647.000000000,'1964-10-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8345,'OSMONT','MICHELE','1947-04-15','02.20.36.49.08','06.76.95.59.77',NULL,'5 RUE DU MARAIS','','','14240','CAHAGNES',NULL,NULL,'1470414289002',406.000000000,'1977-04-21','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8346,'MOISSON','MARTINE','1986-02-17','02.11.21.12.74',NULL,NULL,'8 RUE PAUL ALLENE','','','14000','CAEN',NULL,NULL,'2860298747002',819.000000000,'2010-04-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8347,'JEANNE','ANNIE','1932-11-11','02.29.31.74.43',NULL,NULL,'8 AVENUE DES TILLEULS','','','14000','CAEN',NULL,NULL,'2321114692002',953.000000000,'1956-05-04','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8348,'HAMEL','LUCETTE','1930-07-02','02.26.81.33.77','06.43.42.13.73',NULL,'26 rue de villers','','','14390','CABOURG',NULL,NULL,'2300714483002',70.000000000,'1959-05-28','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8349,'CHARLES','DIDIER','1956-06-24','02.17.58.81.84','06.15.70.39.94',NULL,'6 RUE MONTCALM FOYER PERSONNES','AGEES PIERRE HEUZE','','14210','BARON SUR ODON',NULL,NULL,'2560614361002',1497.000000000,'1982-03-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8350,'LAFORGE','HUBERT','1969-08-15','02.11.08.34.63','06.56.69.51.48',NULL,'57 RUE BLANCHE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2690814383002',180.000000000,'1993-03-16','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8351,'LAURENT','ISABELLE','1950-08-21','02.30.73.50.28','06.70.08.16.90',NULL,'9 rue du chateau d''eau','','','14120','MONDEVILLE',NULL,NULL,'2500814592002',704.000000000,'1973-06-05','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8352,'BAILLEUL','GERARD','1932-10-20','02.14.16.93.56','06.91.32.92.71',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'1321050139002',3066.000000000,'1953-05-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8353,'HAVEL','HUGUETTE','1962-02-20','02.27.80.17.74',NULL,NULL,'5 BD BELLEVUE BAT G APPT 12','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2620214209002',1.000000000,'1989-07-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8354,'HOUARD','JEAN','1936-03-30','02.24.36.33.19','06.95.85.45.28',NULL,'39 RUE DU GENERAL DE GAULLE','','','14840','CUVERVILLE',NULL,NULL,'1360314659002',101.000000000,'1958-01-23','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8355,'CHEREAU','MAGALIE','1947-06-10','02.10.82.37.48','06.18.17.43.15',NULL,'','','','14370','ARGENCES',NULL,NULL,'1470661018002',136.000000000,'1970-03-11','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8356,'LANGUILLE','JEAN MARC','1949-01-03','02.98.78.48.06','06.73.25.87.30',NULL,'1549 ROUTE DE BRETTEVILLE','','','14370','ARGENCES',NULL,NULL,'1490161063002',4.000000000,'1977-11-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8357,'DESGRANGES','DIDIER','1938-03-22','02.74.89.22.01',NULL,NULL,'RESIDENCE LES BORDS DU CHENAL BA','T /A  APPT/11','','14000','CAEN',NULL,NULL,'2380314292002',33.000000000,'1959-08-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8358,'CHAPPERON','MICHEL','1944-02-10','02.84.69.08.59','06.80.46.19.11',NULL,'39 residence du 8 mai','','','61160','MERRI',NULL,NULL,'2440250041002',530.000000000,'1974-06-14','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8359,'LETOUZE','MICHEL','1940-01-30','02.47.43.54.50','06.63.48.56.05',NULL,'19 RUE DANIEL DANJON','','','14220','DONNAY',NULL,NULL,'1400118083002',803.000000000,'1963-08-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8360,'LIBERGE','BERNARD','1953-05-29','02.96.39.72.41','06.93.40.17.22',NULL,'12 RUE FREMINGTON','','','14000','CAEN',NULL,NULL,'1530504008002',2058.000000000,'1976-07-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8361,'ROMAGNE','CORINNE','1935-07-29','02.56.88.97.84','06.76.51.27.68',NULL,'15 ROUTE DE LA GUERINIERE','','','14670','JANVILLE',NULL,NULL,'1350750387002',35.000000000,'1963-01-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8362,'MAZINGUE','GISELE','1935-11-01','02.92.63.71.74',NULL,NULL,'9 rue du village','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2351150540002',47.000000000,'1958-07-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8363,'PLANTE','PIERRE','1931-10-13','02.92.89.94.99','06.71.76.05.53',NULL,'11 hameau de caullet','','','14000','CAEN',NULL,NULL,'1311050510002',36.000000000,'1956-10-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8364,'GOARDON','FABIENNE','1950-01-31','02.96.71.71.10','06.91.17.64.46',NULL,'2 PLACE DE L''EGLISE','','','14210','EVRECY',NULL,NULL,'1500114020002',244.000000000,'1972-01-18','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8365,'LANGLOIS','JOEL','1966-04-03','02.71.42.65.68','06.18.79.76.51',NULL,'26 AVENUE LEON BLUM','','','14330','LE MOLAY LITTRY',NULL,NULL,'2660414181002',488.000000000,'1994-10-14','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8366,'CRESTEY','RENE','1969-06-28','02.76.17.48.84','06.66.51.63.62',NULL,'les fermes','','','14000','CAEN',NULL,NULL,'2690614301002',27.000000000,'1991-12-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8367,'GALOPIN','SYLVIE','1949-04-07','02.97.30.19.43','06.98.51.03.60',NULL,'8. RUE DES SOURCES','','','14160','DIVES SUR MER',NULL,NULL,'1490414252002',137.000000000,'1974-12-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8368,'PONSARDIN','JACKY','1951-02-05','02.28.73.07.78','06.35.99.51.67',NULL,'11 RUE DE L''EGLISE','','','14630','CAGNY',NULL,NULL,'2510214627002',29.000000000,'1980-03-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8369,'DEDEYAN','ROGER','1930-05-19','02.45.12.98.10','06.12.23.59.98',NULL,'8 RUE HOMMET','','','14460','COLOMBELLES',NULL,NULL,'1300514167002',32.000000000,'1960-12-10','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8370,'PELLETIER','PATRICE','1940-11-26','02.65.88.91.50','06.10.89.20.07',NULL,'15 RUE DES  CANADIENS ROCUANCOUR','T','','14190','MAIZIERES',NULL,NULL,'1401150110002',355.000000000,'1970-12-19','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8371,'CLERAUX','MICHEL',NULL,'02.70.64.03.10','06.10.24.01.49',NULL,'8 rue du village','','','14470','GRAYE SUR MER',NULL,NULL,'2530214020002',268.000000000,'2007-11-16','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8372,'HERSANT','JEAN','1965-07-19','02.55.99.40.68','06.79.23.00.80',NULL,'67 RUE DE FORMIGNY','','','50370','BRECEY',NULL,NULL,'2650714118002',1423.000000000,'1995-04-05','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8373,'CATEL','Roland','1931-05-17','02.35.69.64.42','06.47.80.09.93',NULL,'11 rue paul langevin','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2310514712002',116.000000000,'1961-05-31','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8374,'HELLOCO','GILLES','1953-03-09','02.41.02.53.32','06.47.42.93.00',NULL,'BEAU MESNIL','','','14430','ANNEBAULT',NULL,NULL,'2530333136002',100.000000000,'1980-09-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8375,'RIVIERE','SIMONE','1942-05-02','02.15.22.85.48','06.13.01.07.47',NULL,'21 RUE D''ORIENT','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'2420561269002',89.000000000,'1968-03-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8376,'LAINEY','JEAN','1943-05-27','02.48.53.59.35','06.83.63.37.03',NULL,'1 RUE DU CALVAIRE','','','50760','MONTFARVILLE',NULL,NULL,'2430514736002',43.000000000,'1964-02-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8377,'BASLEY','MARIE JOSEPHE','1931-04-14','02.10.70.35.81','06.62.31.14.36',NULL,'11 rue de provence','','','14370','ARGENCES',NULL,NULL,'1310414258002',11.000000000,'1952-08-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8378,'LAMY','BERNARD','1950-03-14','02.28.71.17.74',NULL,NULL,'6 rue de la paternite','','','14210','AVENAY',NULL,NULL,'1500350028002',24.000000000,'1977-09-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8379,'COLLET','SERGE','1931-10-09','02.33.35.37.95','06.24.26.04.86',NULL,'21 rue du luxembourg','','','14370','ARGENCES',NULL,NULL,'2311014282002',2273.000000000,'1957-12-21','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8380,'MAUGER','JEAN LOUIS','1980-04-07','02.11.22.93.64','06.51.11.86.84',NULL,'MENGNE','','','14000','CAEN',NULL,NULL,'2800499337002',361.000000000,'2006-08-01','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8381,'MENARD','JEAN PAUL','1966-07-06','02.12.28.90.62','06.43.81.94.34',NULL,'3 RUE DE VIRE','','','14270','VIEUX FUME',NULL,NULL,'1660714372002',2762.000000000,'1990-10-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8382,'HEDOU','LIONEL','1961-11-26','02.29.51.28.39','06.14.97.01.27',NULL,'VILLAGE DE BRECOURT','','','14000','CAEN',NULL,NULL,'1611114007002',732.000000000,'1983-09-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8383,'COCU','','1940-04-12','02.68.32.82.38','06.57.18.97.16',NULL,'87 rue de falaise','','','14240','CAUMONT L''EVENTE',NULL,NULL,'1400414449002',41.000000000,'1967-05-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8384,'LEJEUNE','LILIANE','1931-06-15','02.41.39.39.88','06.90.42.12.12',NULL,'LE BOURG','','','14123','FLEURY SUR ORNE',NULL,NULL,'1310614475002',98.000000000,'1955-03-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8385,'COLOMES','MAURICETTE','1935-07-29','02.26.58.37.99','06.27.27.26.53',NULL,'10 RUE DES SOURCES','','','14120','MONDEVILLE',NULL,NULL,'2350714249002',15.000000000,'1959-04-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8386,'HAUSERMANN','JEAN LUC','1930-02-19','02.89.10.69.35','06.64.53.61.22',NULL,'17 res les pommier rue malasier','','','14123','FLEURY SUR ORNE',NULL,NULL,'2300214689002',391.000000000,'1951-06-05','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8387,'DUDOUIT','JOCELYNE','1959-01-13','02.33.41.39.62','06.10.61.95.38',NULL,'11 RUE ALAIN CHARTIER','','','14370','MERY CORBON',NULL,NULL,'1590114225002',24.000000000,'1989-11-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8388,'MILOCHE','ANTOINETTE','1979-08-19','02.25.68.60.50','06.62.65.41.59',NULL,'13 RUE VERTE','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1790899353002',95.000000000,'2001-06-01','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8389,'LECLERC','JANINE','1930-06-14','02.71.09.27.11','06.30.58.15.54',NULL,'11 rue d aulnay','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1300614659002',33.000000000,'1956-04-06','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8390,'LECLERC','MIREILLE','1966-02-15','02.40.45.41.89','06.34.26.85.44',NULL,'38 RUE CALMETTE','','','14840','DEMOUVILLE',NULL,NULL,'1660214437002',190.000000000,'1988-03-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8391,'QUITIN','FRANCIS','1965-04-16','02.67.79.01.36','06.48.49.21.69',NULL,'6 RUE SAVIGNE L EVEQUE','','','14150','OUISTREHAM',NULL,NULL,'2650414036002',150.000000000,'1986-08-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8392,'SEGUIN','JACQUELINE','1943-03-04','02.32.81.10.08','06.85.33.00.76',NULL,'5 RUE DES BELGES','','','14000','CAEN',NULL,NULL,'2430359356002',43.000000000,'1968-07-29','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8393,'LEPETIT','DENIS','1942-02-13','02.28.95.23.48','06.37.66.70.08',NULL,'CHEZ MR ET MME TAGNE 8 RUE LEBE','ILLYL','','14840','DEMOUVILLE',NULL,NULL,'2420214603002',313.000000000,'1971-10-23','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8394,'BESLIN','Andr','1960-02-04','02.50.79.43.94','06.46.03.10.05',NULL,'28 RUE HENRI CHERON   VENOIX','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'1600214712002',102.000000000,'1983-04-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8395,'JOUVIN','MARC','1968-10-31','02.68.20.34.69','06.72.46.36.67',NULL,'6 rue du monastere','','','14610','CAIRON',NULL,NULL,'2681061389002',3097.000000000,'1997-11-06','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8396,'L HOPITAL BURDIN','PAULETTE','1958-03-20','02.46.82.93.45','06.40.94.36.85',NULL,'19 AVENUE DE THIES','','','14000','CAEN',NULL,NULL,'1580314319002',90.000000000,'1982-12-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8397,'BIDOT','MARIE LAURE','1966-03-21','02.41.71.10.24','06.51.49.16.85',NULL,'71 rue andre albout','','','14000','CAEN',NULL,NULL,'1660375045002',86.000000000,'1989-02-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8398,'BELLISSENT','Thrse','1943-01-26','02.70.14.71.56','06.10.10.27.25',NULL,'10 rue des jacobins','','','14470','COURSEULLES SUR MER',NULL,NULL,'1430122228002',674.000000000,'1965-05-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8399,'MOREE','Michel','1957-05-25','02.60.38.69.29','06.76.24.17.77',NULL,'74 ALLEE GABRIEL JAMES','','','72160','DUNEAU',NULL,NULL,'2570516267002',17.000000000,'1983-11-06','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8400,'PERRELLE','MONIQUE',NULL,'02.12.23.59.95','06.75.20.10.47',NULL,'10 rue jules ferry','','','14680','GOUVIX',NULL,NULL,'2290314675002',422.000000000,'2009-08-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8401,'BOUET','','1942-04-04','02.94.34.47.09','06.66.38.15.03',NULL,'46 blvd alsace loraine','','','14730','GIBERVILLE',NULL,NULL,'1420414294002',31.000000000,'1964-06-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8402,'ANGELIQUE','ROSE MARIE','1936-10-20','02.59.40.52.68','06.22.57.91.20',NULL,'51 bvd belle vue','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1361014163002',54.000000000,'1958-04-14','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8403,'DELASALLE','JACKY','1939-05-19','02.14.52.19.15','06.93.98.43.46',NULL,'39 rue de demouville','','','14000','CAEN',NULL,NULL,'2390561447002',212.000000000,'1961-01-23','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8404,'NICOLLE','HELENE','1932-02-13','02.84.10.82.01','06.17.37.22.58',NULL,'9 ALLEE LE PRE CLAIR','','','14123','IFS',NULL,NULL,'2320214257002',1024.000000000,'1956-06-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8405,'PICARD','JANINE','1953-04-20','02.77.96.23.28','06.72.92.15.71',NULL,'9 RUE DU DEBARQUEMENT','','','14123','IFS',NULL,NULL,'2530414747002',398.000000000,'1974-05-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8406,'LELIEVRE','MARYLENE','1967-11-20','02.53.58.39.01','06.94.80.17.99',NULL,'6 rue m curie','','','14270','MEZIDON CANON',NULL,NULL,'1671150502002',49.000000000,'1992-02-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8407,'DOCAGNE','CAROLINE','1935-09-07','02.49.05.93.64','06.62.85.47.63',NULL,'5 RUE DES ANCIENS D''AFN','','','14220','THURY HARCOURT',NULL,NULL,'2350914174002',482.000000000,'1958-12-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8408,'DEROBERT','BERNARD','1932-11-23','02.54.88.64.14','06.40.82.35.21',NULL,'2 RUE DES ECOURTILS','','','14620','FOURCHES',NULL,NULL,'1321161153002',47.000000000,'1961-01-08','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8409,'BESNARD','JACQUES','1942-01-01','02.11.88.15.09','06.58.39.50.57',NULL,'26  RUE DES TILLEULS','','','27470','SERQUIGNY',NULL,NULL,'2420161181002',83.000000000,'1968-07-21','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8410,'PROFICHET','JEAN','1928-02-20','02.65.91.56.40','06.38.68.27.83',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1280250224002',1982.000000000,'1953-02-14','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8411,'LAFOSSE','YVETTE','1957-05-02','02.95.39.52.51','06.44.10.82.22',NULL,'LE SAUCE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1570514712002',362.000000000,'1979-10-19','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8412,'HUAUT','DIDIER','1959-08-03','02.20.26.38.10','06.53.81.44.93',NULL,'le bourg','','','14000','CAEN',NULL,NULL,'1590814537002',81.000000000,'1989-05-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8413,'TOLLEMER','Jean pierre','1936-07-26','02.94.41.00.58','06.12.15.69.41',NULL,'10 BD DELEAN','','','14000','CAEN',NULL,NULL,'2360714576002',11.000000000,'1957-09-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8414,'LEBAILLY','ELIA','1951-05-27','02.73.50.90.20','06.76.59.19.71',NULL,'31 rue des freres boutroies','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1510514183002',460.000000000,'1975-09-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8415,'DAVID','PHILIPPE','1937-02-21','02.47.07.14.75','06.25.48.73.75',NULL,'5 RUE DE L''ORNE','','','14270','MEZIDON CANON',NULL,NULL,'2370214749002',1910.000000000,'1964-09-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8416,'LELIEVRE','THERESE','1948-05-17','02.53.18.79.20','06.25.04.08.76',NULL,'9 RUE LUCIEN MANGEMATIN','','','14170','BRETTEVILLE SUR DIVES',NULL,NULL,'2480514006002',34.000000000,'1972-10-28','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8417,'','ANDRE','1964-05-06','02.57.77.01.56','06.45.50.55.61',NULL,'2 RUE DU PARC DE L''ABBAYE','','','14000','CAEN',NULL,NULL,'1640514157002',1135.000000000,'1994-06-20','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8418,'TOUTAIN','DENIS','1966-05-16','02.61.69.51.46','06.95.29.85.07',NULL,'2 RUE DE LA FONTAINE','','','14220','THURY HARCOURT',NULL,NULL,'1660514057002',3642.000000000,'1993-07-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8419,'PESNELLE','YVES','1935-08-04','02.31.48.68.71','06.39.60.98.22',NULL,'24 rue jean jaures','','','14310','TOURNAY SUR ODON',NULL,NULL,'2350814046002',28.000000000,'1957-09-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8420,'CARDIA','BERTRAND','1969-11-17','02.59.93.90.76','06.47.97.42.42',NULL,'21 RUE REGIMENT DE MAISONNEUVE','','',NULL,NULL,NULL,NULL,'2691150502002',306.000000000,'1994-03-20','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8421,'DOUVILLE','HELENE','1944-05-30','02.11.58.03.74',NULL,NULL,'5 RUE HARDY','','','14000','CAEN',NULL,NULL,'2440514128002',20.000000000,'1967-02-12','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8422,'DUFAIT','JANIQUE','1953-02-01','02.84.41.02.50','06.30.35.15.98',NULL,'4 RUE AMPERE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1530214038002',77.000000000,'1981-06-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8423,'CEREUIL','Bernadette','1969-01-29','02.83.03.15.81','06.50.66.47.50',NULL,'56 RUE SAINT LAURENT','','','14350','LE BENY BOCAGE',NULL,NULL,'2690127375002',33.000000000,'1991-01-31','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8424,'LETONDOT','PASCAL','1939-07-13','02.18.50.93.48','06.13.64.35.23',NULL,'15 rue de bonn','','','14000','CAEN',NULL,NULL,'1390750488002',473.000000000,'1968-04-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8425,'MASSELOT','GENEVIEVE','1958-04-07','02.16.93.40.80','06.23.04.05.71',NULL,'8 RUE TRAVERSIERE','','','76160','ST MARTIN DU VIVIER',NULL,NULL,'1580414009002',127.000000000,'1988-07-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8426,'DURAND','COLETTE','1958-01-05',NULL,NULL,NULL,'5 rue livry level','','','14400','ST VIGOR LE GRAND',NULL,NULL,'1580114271002',331.000000000,'1988-09-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8427,'HUET','COLETTE','1928-02-01','02.39.20.28.34','06.45.05.91.43',NULL,'6 BVD WEYGAND','','','14000','CAEN',NULL,NULL,'2280250539002',34.000000000,'1957-05-07','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8428,'ZIMMERMANN','Marie ange','1957-02-16','02.18.45.09.99','06.54.51.69.01',NULL,'CHEMIN DU BOSQUAIN','','','14540','BOURGUEBUS',NULL,NULL,'1570214698002',585.000000000,'1980-06-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8429,'CHAUVIN','FRANCOIS','1940-05-19','02.21.28.41.60','06.32.53.76.37',NULL,'LA BUTTE DU CHENE','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1400514747002',13.000000000,'1962-04-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8430,'MATHIEU','ANNICK','1945-03-11','02.90.95.30.72','06.73.50.51.68',NULL,'','','','14220','THURY HARCOURT',NULL,NULL,'2450314714002',133.000000000,'1975-02-04','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8431,'RENARD','COLETTE','1931-04-16','02.70.53.52.67','06.43.00.28.72',NULL,'20 RUE JULES FERY','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1310479001002',39.000000000,'1957-11-27','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8432,'ZIMMERMAN','LOUISE','1930-06-30','02.89.44.98.94','06.44.01.45.84',NULL,'LA CROIX','','','14370','ARGENCES',NULL,NULL,'1300614695002',1931.000000000,'1955-12-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8433,'THERESSE','JEAN','1929-01-23','02.61.18.43.33','06.40.29.44.72',NULL,'7 bvd p cornielle','','','14360','TROUVILLE SUR MER',NULL,NULL,'1290114488002',166.000000000,'1955-11-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8434,'VEREL','Michel','1957-02-03','02.27.24.46.66','06.10.09.23.19',NULL,'10 RUE MAURICE LAFON','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2570214118002',98.000000000,'1981-06-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8435,'SAILLEY','MARCEL','1936-10-31','02.75.56.35.69','06.29.25.24.81',NULL,'23 AV LEON BLUM','','','14120','MONDEVILLE',NULL,NULL,'2361014738002',824.000000000,'1965-07-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8436,'MICHEL','LOUISE','1955-08-06','02.27.40.45.99','06.73.33.33.09',NULL,'la grande vienne','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'2550877306002',2318.000000000,'1982-09-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8437,'JEANNE','christian','1938-05-04','02.10.52.99.32','06.73.95.68.72',NULL,'LES MONTYS','','','50000','ST LO',NULL,NULL,'2380514050002',1052.000000000,'1961-06-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8438,'HAMELIN','JANINE','1955-09-08','02.91.15.03.53','06.10.43.55.86',NULL,'18 RUE DE DERRIERE LES PORTES','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'1550914719002',30.000000000,'1976-07-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8439,'JENDREL','ANDREE','1965-08-20','02.75.62.08.20','06.85.06.96.35',NULL,'25 des freres boutrois','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1650814158002',616.000000000,'1993-05-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8440,'KERNEC','RAYMOND','1940-03-17','02.59.05.99.53','06.79.33.57.29',NULL,'42 BOULEVARD LEROY','','','14730','GIBERVILLE',NULL,NULL,'1400314384002',283.000000000,'1962-08-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8441,'LALLOUET','CLAUDE','1933-12-31','02.18.21.09.61','06.91.17.48.85',NULL,'18 RUE DU CHANOINE TRECHE','','','14000','CAEN',NULL,NULL,'2331250579002',3730.000000000,'1960-03-03','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8442,'MARAIS','PIERRE YVES','1933-05-11','02.32.73.51.67','06.26.27.17.95',NULL,'23 RUE D''AUDRIEU','','','14370','MOULT',NULL,NULL,'2330514100002',257.000000000,'1956-04-14','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8443,'CRUCHON','PATRICK','1936-06-15','02.56.37.57.07','06.11.62.69.33',NULL,'24 IMP GRANDE COUR','','','14630','CAGNY',NULL,NULL,'1360614437002',25.000000000,'1962-01-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8444,'CHORIN','MARCEL',NULL,'02.37.05.97.31','06.23.04.46.53',NULL,'34 ROUTE D''IFS','','','14650','CARPIQUET',NULL,NULL,'2291050484002',93.000000000,'2011-08-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8445,'LOUAIL','CHRISTINE','1968-12-27','02.20.56.87.70','06.62.22.75.25',NULL,'25 RUE DU PONT CREON','','','14150','OUISTREHAM',NULL,NULL,'2681214118002',408.000000000,'1994-07-19','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8446,'LETELLIER','GERARD','1937-07-17','02.49.87.93.01','06.11.71.43.77',NULL,'26 BD KIEFFER','','','14120','MONDEVILLE',NULL,NULL,'1370789035002',80.000000000,'1959-12-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8447,'HEBERT','THIERRY','1950-02-02','02.14.26.26.96','06.25.56.04.50',NULL,'7 RUE D''ETREHAM','','','14220','THURY HARCOURT',NULL,NULL,'1500235072002',25.000000000,'1978-08-31','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8448,'LACROIX','NORBERT','1939-11-12','02.84.73.19.76','06.11.32.68.77',NULL,'78 RUE GAMBETTA','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1391172034002',253.000000000,'1963-06-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8449,'LAFORGE','ANDREE','1969-01-09','02.72.38.47.54','06.68.29.76.94',NULL,'PLACE DES CANADIENS','','','14430','BRANVILLE',NULL,NULL,'2690127375002',876.000000000,'1993-09-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8450,'LECORNEC','MICHEL','1939-10-23','02.40.74.43.10',NULL,NULL,'LA RUERIE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2391050562002',494.000000000,'1969-04-19','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8451,'GERMAIN','OLIVIER','1959-07-10','02.74.88.87.24',NULL,NULL,'50 RUE DU PATI','','','14690','LA POMMERAYE',NULL,NULL,'1590722050002',48.000000000,'1981-12-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8452,'GOUPIL','Huguette','1966-04-13','02.87.04.22.31','06.31.90.12.71',NULL,'48 RUE ROBERT BOTHEREAU','','','14520','PORT EN BESSIN HUPPAIN',NULL,NULL,'2660414181002',44.000000000,'1996-05-31','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8453,'MARIE','PIERRE','1954-04-04','02.94.40.79.70','06.43.00.20.38',NULL,'19 RUE DES ERABLES','','','14880','HERMANVILLE SUR MER',NULL,NULL,'1540450376002',27.000000000,'1977-10-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8454,'BOUET','OLIVIER','1963-04-30','02.24.35.71.14','06.24.44.61.35',NULL,'RUE DU HOMMET','','','50250','LITHAIRE',NULL,NULL,'1630414038002',87.000000000,'1990-12-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8455,'NORMAND','christine','1951-02-13','02.44.27.90.12','06.88.38.56.54',NULL,'2 CHEMIN DU DOUET','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2510261391002',2666.000000000,'1975-07-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8456,'DESHAYES','christine','1958-03-20','02.64.92.69.47','06.69.64.57.75',NULL,'','','','14710','LA FOLIE',NULL,NULL,'1580314030002',548.000000000,'1981-03-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8457,'MARIE','jean baptiste','1937-10-25','02.59.46.57.71','06.15.94.13.20',NULL,'27 L''EGLISE','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1371078201002',168.000000000,'1959-08-06','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8458,'MANCHION','MICHEL','1935-07-21','02.93.02.42.09','06.29.30.39.99',NULL,'3/2 RUE DES PRES','','','14700','SOULANGY',NULL,NULL,'2350745068002',51.000000000,'1956-11-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8459,'TOQUET','ANDRE','1959-08-30','02.37.94.43.62','06.26.86.71.57',NULL,'16 RUE DES CHAMPS','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2590814150002',378.000000000,'1988-03-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8460,'MARTIN','RENEE','1951-05-02','02.82.45.38.25','06.38.80.91.71',NULL,'5 RUE DE SUEDE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1510561194002',292.000000000,'1972-07-13','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8461,'GERMAIN','DANIEL','1953-02-15','02.99.13.53.08','06.16.48.91.09',NULL,'5 RESIDENCE MADAME DE SEGUR','','','14000','CAEN',NULL,NULL,'1530214151002',0.000000000,'1976-11-12','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8462,'VANDEN DURPEL','GEORGES','1929-07-28','02.38.55.82.33','06.59.76.80.38',NULL,'27 rue du blanc','','','14123','FLEURY SUR ORNE',NULL,NULL,'2290753181002',32.000000000,'1959-04-17','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8463,'TOUZE','RENE','1932-12-19','02.81.98.03.09','06.79.43.50.70',NULL,'CHEMIN DU BOIS DE LA VALLEE','','','14370','ARGENCES',NULL,NULL,'2321261410002',937.000000000,'1955-09-13','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8464,'VARDON','JOEL','1949-06-02','02.88.71.38.60','06.10.25.02.54',NULL,'','','','14000','CAEN',NULL,NULL,'2490614443002',3891.000000000,'1972-02-12','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8465,'FIANT','MARIE FRANCE','1949-02-03','02.15.48.58.44','06.47.16.11.77',NULL,'27 rue de broceliande','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2490214371002',187.000000000,'1979-01-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8466,'PAVIE','GENEVIEVE','1928-12-03','02.85.30.70.98','06.50.75.37.64',NULL,'','','','14540','GRENTHEVILLE',NULL,NULL,'1281214493002',390.000000000,'1952-02-14','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8467,'DUFOUR','Solange','1938-01-05','02.27.49.68.07','06.20.22.56.61',NULL,'','','','14250','JUAYE MONDAYE',NULL,NULL,'1380150159002',5.000000000,'1962-07-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8468,'DUMAS','Colette','1936-10-22','02.91.00.81.02','06.82.44.44.55',NULL,'27 BIS ROUTE DE ROUEN','','','14370','ARGENCES',NULL,NULL,'2361050281002',95.000000000,'1960-07-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8469,'MAUDUIT','francois','1950-08-10','02.26.64.37.33','06.40.67.90.88',NULL,'2 av de la concorde','','','14000','CAEN',NULL,NULL,'2500814319002',101.000000000,'1979-02-23','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8470,'QUESNEL','ODETTE','1931-06-19','02.45.21.92.31','06.88.83.85.23',NULL,'','','','14370','BELLENGREVILLE',NULL,NULL,'1310614431002',929.000000000,'1957-05-08','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8471,'CRUCHON','SYLVIE',NULL,'02.74.75.19.78',NULL,NULL,'7 RUE DU DOCTEUR ROUX','','','14190','ST SYLVAIN',NULL,NULL,'2691150502002',26.000000000,'2011-09-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8472,'PANEL','MARC','1945-02-20','02.86.40.10.18','06.23.07.90.97',NULL,'12 rue du professeur gombeaux','','','14310','TOURNAY SUR ODON',NULL,NULL,'2450259159002',114.000000000,'1967-12-10','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8473,'VILLETTE','ROBERT','1934-08-18','02.89.80.75.71','06.43.09.59.37',NULL,'47 route de falaise','','','14000','CAEN',NULL,NULL,'2340814333002',14.000000000,'1957-06-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8474,'MARIE','PADOUE','1959-02-26','02.54.24.19.04','06.21.88.41.28',NULL,'41 RUE DES PRAIRIES','','','63430','PONT DU CHATEAU',NULL,NULL,'1590214327002',2626.000000000,'1982-08-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8475,'LAGALLE','THERESE','1929-12-27','02.51.23.69.40','06.15.31.61.61',NULL,'10 RUE DE LA HAGUE','','','14000','CAEN',NULL,NULL,'2291214707002',159.000000000,'1950-11-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8476,'','Philippe','1969-05-01','02.49.86.25.97','06.77.10.14.34',NULL,'8 RUE DU SAUT DE LOUP','','','14540','SOLIERS',NULL,NULL,'2690514437002',545.000000000,'1993-09-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8477,'DESHAYES','Louis','1962-09-27','02.95.57.99.04','06.48.43.10.67',NULL,'8 RUE DE HOGUE','','','14390','CABOURG',NULL,NULL,'2620961329002',698.000000000,'1984-10-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8478,'CENEDESE','Yvette','1937-07-03','02.69.97.20.45','06.11.30.03.56',NULL,'11 PERE CHARLES DE FOUCAULT','','','14980','ROTS',NULL,NULL,'1370753079002',55.000000000,'1967-11-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8479,'FOUCHER','JEAN','1949-01-14','02.42.45.37.46','06.81.73.12.28',NULL,'RUE DES SABLES','','',NULL,NULL,NULL,NULL,'1490114372002',40.000000000,'1973-12-07','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8480,'TARGAT','MARIE CLAIRE','1954-07-01','02.97.13.65.01','06.58.42.21.56',NULL,'5 RUE ROGER BASTION','','','14790','VERSON',NULL,NULL,'1540750519002',217.000000000,'1983-11-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8481,'PREVEL','Hubert','1935-11-08','02.65.45.56.11','06.49.37.70.76',NULL,'8 rue de la lisiere','','','14310','EPINAY SUR ODON',NULL,NULL,'2351102302002',504.000000000,'1960-08-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8482,'PARIS','ALINA','1952-01-20','02.43.44.67.34','00 33 6.61.78.93.52',NULL,'10 RUE DES ANCIENNES CANTINES','','','14780','LION SUR MER',NULL,NULL,'2520114065002',104.000000000,'1976-05-26','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8483,'MATHON','CLAUDE','1931-05-08','02.38.87.56.67','06.25.19.43.61',NULL,'8 avenue pere charles foucault','','','61200','ARGENTAN',NULL,NULL,'1310514701002',291.000000000,'1953-10-30','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8484,'KALCZUGA','thierry','1949-05-10','02.87.08.20.76','06.12.59.17.94',NULL,'2 ROUTE DE LA CROIX DE LABRILLET','TE','','14220','MOULINES',NULL,NULL,'1490514118002',28.000000000,'1972-03-19','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8485,'TREHET','Carole','1968-09-06','02.74.65.45.70',NULL,NULL,'2 rue de la marne','','','14610','EPRON',NULL,NULL,'1680914246002',401.000000000,'1993-07-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8486,'LETHAN','THERESE','1950-03-15','02.29.42.27.86','06.10.61.26.94',NULL,'26 RUE JULES FERRY','','','14850','HEROUVILLETTE',NULL,NULL,'2500359474002',51.000000000,'1972-04-12','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8487,'LAVILLE','HENRY','1959-04-25','02.24.82.54.22','06.14.96.42.15',NULL,'14 RUE DU PONT D''AIZY','','','14310','VILLERS BOCAGE',NULL,NULL,'2590414383002',2145.000000000,'1982-11-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8488,'QUINTIN','Jacques','1935-12-15','02.10.10.81.53','06.13.23.37.31',NULL,'6 ALLEE BOBBY LAPOINTE','','','14000','CAEN',NULL,NULL,'2351250139002',17.000000000,'1959-03-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8489,'HOUEL','JEAN LOUIS','1930-03-27','02.92.45.65.93','06.28.95.42.42',NULL,'1 rue madame viont','','','14000','CAEN',NULL,NULL,'2300361222002',778.000000000,'1954-06-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8490,'PAIN','BERNADETTE','1937-09-13','02.66.75.40.05','06.12.09.75.29',NULL,'39 BOULEVARD KIEFFER','','','14000','CAEN',NULL,NULL,'1370914357002',100.000000000,'1959-01-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8491,'SANSON','GERARD','1952-07-15','02.91.29.73.11','06.15.09.99.88',NULL,'5 rue du mont notre dame','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2520750379002',236.000000000,'1974-12-24','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8492,'POUCLEE','JACKY','1958-09-26','02.87.53.27.84','06.43.94.69.24',NULL,'24 RUE DES SOURCES','','','14400','ST VIGOR LE GRAND',NULL,NULL,'1580957137002',474.000000000,'1979-07-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8493,'GUILLOUET','FRANCIS','1928-12-20','02.65.97.94.83','06.18.52.03.32',NULL,'25 ROUTE DE PERCY','','','50360','PICAUVILLE',NULL,NULL,'2281250289002',2367.000000000,'1949-03-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8494,'NOUVEL','MONIQUE','1966-05-08','02.87.37.50.32','06.78.45.13.35',NULL,'11 ROND POINT DE L''ORNE','','','14860','BAVENT',NULL,NULL,'2660514364002',59.000000000,'1990-07-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8495,'LEFORT','ROLAND','1940-12-01','02.22.58.85.26','06.15.30.88.67',NULL,'2BIS RUE NEUVE','','','14000','CAEN',NULL,NULL,'1401214098002',158.000000000,'1964-11-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8496,'DAUGE','YVONNE','1959-02-12','02.17.54.10.12','06.60.77.61.48',NULL,'10 RUE RENE BLANC','','','27300','BERNAY',NULL,NULL,'1590214327002',113.000000000,'1986-11-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8497,'GUILTAT','REMY','1969-11-01','02.10.32.60.36','06.59.53.06.73',NULL,'19 RUE HELENE BOUCHER','','','14540','ROCQUANCOURT',NULL,NULL,'1691114257002',5277.000000000,'1993-10-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8498,'MANCHION','CECILE','1929-09-10','02.10.95.78.55','06.15.02.75.94',NULL,'8 RUE DE LA CROIX THOY','','','14123','FLEURY SUR ORNE',NULL,NULL,'2290950503002',166.000000000,'1959-08-30','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8499,'DUGUE','MARCEL','1948-08-21','02.46.54.16.19','06.49.41.15.05',NULL,'8 IMPASSE DES MONTS','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'2480814476002',42.000000000,'1977-11-29','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8500,'BOURDON','Guy','1977-04-18','02.77.62.42.53','06.25.80.97.75',NULL,'39 RUE DE LA MISERICORDE','','','14000','CAEN',NULL,NULL,'2770499107002',1529.000000000,'2004-08-26','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8501,'LEROUVILLOIS','EVELYNE','1935-09-08','02.88.11.13.69','06.12.32.92.28',NULL,'933 BD BELLES PORTES','','','14540','ROCQUANCOURT',NULL,NULL,'1350956242002',2.000000000,'1965-10-04','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8502,'PIGNE','ANDREE','1939-04-09','02.21.48.53.15','06.10.09.84.35',NULL,'1 RUE DU REVEREND PERE JULES','','','14940','SANNERVILLE',NULL,NULL,'1390414746002',1239.000000000,'1962-04-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8503,'SEREE','MARIE MADELEINE','1937-06-27','02.75.16.28.75','06.52.04.12.38',NULL,'4 RUE DES BERETS VERTS','','','14530','LUC SUR MER',NULL,NULL,'1370614689002',117.000000000,'1960-10-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8504,'VERITE','PAULETTE','1957-07-12','02.71.42.92.57','06.71.21.61.91',NULL,'59 RUE DE BAYEUX','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2570761283002',92.000000000,'1984-10-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8505,'PERIER','ANTOINE','1938-04-29','02.55.27.80.73','06.63.81.27.30',NULL,'maison de retraite sacre coeur ','GRENTHEVILLE','','14000','CAEN',NULL,NULL,'2380450488002',480.000000000,'1959-10-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8506,'ASTIC','CHRISTIAN','1952-01-13','02.12.25.16.54','06.21.23.94.74',NULL,'10 alle maurice rousseau','','','14120','MONDEVILLE',NULL,NULL,'1520114703002',18.000000000,'1979-02-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8507,'NOEL','andre','1947-02-11','02.66.94.69.19','06.15.13.24.91',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1470214554002',40.000000000,'1974-08-09','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8508,'TANGUY','EDDY','1950-01-21','02.17.03.91.79','06.46.34.73.11',NULL,'residence colbert batiment N','','','14670','ST OUEN DU MESNIL OGER',NULL,NULL,'1500114654002',87.000000000,'1973-06-30','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8509,'BROWN','GEORGETTE','1929-05-02','02.62.08.75.68','06.10.92.40.52',NULL,'5 rue pierre girard','','','14250','ELLON',NULL,NULL,'2290561176002',1.000000000,'1957-05-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8510,'LANGLOIS','AUGUSTINE','1929-04-17','02.11.77.30.65','06.30.04.35.07',NULL,'residence les edelweiss 1 rue p',' gringoire','','14700','FALAISE',NULL,NULL,'1290461153002',1410.000000000,'1950-02-28','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8511,'MARIE','JEANNE','1968-01-16','02.53.53.28.75','06.87.60.84.01',NULL,'3 RUE BASSE','','','14500','VIRE',NULL,NULL,'2680114060002',124.000000000,'1992-12-30','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8512,'VIVET','DENISE','1942-05-14','02.61.18.93.36','06.24.87.89.96',NULL,'77 TER AVENUE DE COURSEULLES','','','14000','CAEN',NULL,NULL,'2420514391002',2388.000000000,'1966-02-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8513,'ABEGG','EDITH','1983-01-20','02.77.89.48.69','06.79.63.16.46',NULL,'17 CLOS GUILLAUME','','','14000','CAEN',NULL,NULL,'2830199324002',26.000000000,'2007-07-21','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8514,'JOUSSELIN','serge','1930-09-04','02.78.41.57.69','06.50.25.27.59',NULL,'','','','14540','POUSSY LA CAMPAGNE',NULL,NULL,'2300914664002',496.000000000,'1951-02-10','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8515,'VAL','LOUIS','1937-04-12','02.10.05.08.98','06.11.01.16.52',NULL,'16 RUE DES MARETTES','','','14000','CAEN',NULL,NULL,'1370477333002',57.000000000,'1967-05-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8516,'MORISSET','NELLY','1967-01-27','02.30.03.68.05','06.24.55.63.84',NULL,'20 AV DU 20 EME CORPS CANADIEN','','','14000','CAEN',NULL,NULL,'2670114118002',26.000000000,'1988-08-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8517,'THOMASSET','LAURENT','1945-03-03','02.13.55.56.15','06.10.50.89.77',NULL,'RESIDENCE DE LA POLLE CHERBOURG','','','14120','MONDEVILLE',NULL,NULL,'1450361081002',808.000000000,'1966-02-11','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8518,'FIERS','IDA','1932-03-09','02.68.97.36.35','06.12.08.93.16',NULL,'LA HURE DU LOUP','','','61370','ECHAUFFOUR',NULL,NULL,'1320349295002',90.000000000,'1962-03-14','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8519,'BARETTE','FLAVIEN','1932-03-29','02.49.69.74.28',NULL,NULL,'4 ALLEE JEAN RACINE','','','50120','EQUEURDREVILLE HAINNEVILLE',NULL,NULL,'1320314376002',372.000000000,'1956-03-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8520,'THOMINE','Anne marie','1937-12-22','02.20.76.80.76','06.71.03.93.72',NULL,'23 RUE BRANVILLE','','','14123','FLEURY SUR ORNE',NULL,NULL,'2371214158002',134.000000000,'1960-02-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8521,'DESMONTS','JEAN','1932-07-16','02.46.47.13.67','00 33 6.91.65.34.52',NULL,'15 rue st marc','','','14460','COLOMBELLES',NULL,NULL,'1320714692002',25.000000000,'1961-09-14','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8522,'ROBILLARD','MADELEINE','1939-11-28','02.11.27.34.89','06.20.19.22.12',NULL,'40 ROUTE DE LA FORET DE BRIX','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'1391150567002',36.000000000,'1963-05-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8523,'PRESTAVOINE','FRANCIS','1949-07-25','02.49.57.17.60','06.76.00.58.71',NULL,'LE BOURG','','','14123','IFS',NULL,NULL,'1490777439002',22.000000000,'1972-05-05','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8524,'PAPILLON','jean pierre','1990-10-23','02.30.55.91.91','06.99.79.71.60',NULL,'','','','14490','ST PAUL DU VERNAY',NULL,NULL,'1901098714002',90.000000000,'2012-12-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8525,'MOSENGO BONU','GUY','1933-10-01','02.35.81.46.37','06.94.67.96.94',NULL,'8 rue des hirondelles','','','14960','ASNELLES',NULL,NULL,'2331014177002',432.000000000,'1954-04-25','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8526,'KIOMA','LEON','1955-01-15','02.76.56.00.15','06.76.46.92.93',NULL,'3 alle de dublin','','','14000','CAEN',NULL,NULL,'1550161419002',4600.000000000,'1978-07-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8527,'LECARDONNEL','JOSIANE','1930-05-14','02.81.43.75.47','06.59.42.37.05',NULL,'150 RUE ANATOLE DUVAL','','','14000','CAEN',NULL,NULL,'2300575027002',12.000000000,'1958-01-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8528,'CHOCTEAU','GENEVIEVE','1931-11-09','02.60.58.23.68','06.34.65.50.84',NULL,'7 IMPASSE DES MARRONNIERS','','','14123','FLEURY SUR ORNE',NULL,NULL,'1311114171002',895.000000000,'1952-03-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8529,'MAHIER','GERARD','1952-01-02','02.30.12.49.12','06.81.25.13.21',NULL,'8 rue du val d''or','','',NULL,NULL,NULL,NULL,'1520114117002',146.000000000,'1975-04-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8530,'LE GOARANT','LOUISE','1943-06-08','02.52.35.90.40','06.31.43.91.70',NULL,'7 alle des roseaux','','','14000','CAEN',NULL,NULL,'1430614232002',335.000000000,'1971-02-01','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8531,'DESSEAUX','PIERRE','1935-12-30','02.15.40.72.91','06.27.34.97.31',NULL,'13 RUE DU MAINE','','','14670','TROARN',NULL,NULL,'1351214274002',2017.000000000,'1958-10-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8532,'HRUSKA','GINETTE','1940-08-12','02.78.07.17.34','06.51.75.07.21',NULL,'LE BOURG','','','61140','LA CHAPELLE D''ANDAINE',NULL,NULL,'1400850127002',93.000000000,'1961-01-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8533,'DAIGREMONT','Michelle','1938-04-02','02.85.32.17.30','06.20.19.64.30',NULL,'6 RUE DE LA CHARMILLE','','','14120','MONDEVILLE',NULL,NULL,'2380459449002',1142.000000000,'1966-02-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8534,'LEPONT','JACQUELINE','1941-04-27','02.52.88.14.28','06.19.44.91.71',NULL,'37 RUE DU CLOS DU PAVILLON','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2410414049002',927.000000000,'1964-01-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8535,'LANDEAU','IRENE','1949-05-17','02.89.66.88.50','06.17.36.61.30',NULL,'15 rue des longs champs','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1490514118002',159.000000000,'1971-08-28','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8536,'FORTIN','MARGUERITE','1960-06-13','02.14.72.89.01','06.61.11.64.74',NULL,'10 RUE RAYMOND COSSON','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2600614320002',614.000000000,'1983-03-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8537,'BRUNET','ANDRE','1930-06-28','02.86.28.98.34','00 33 6.45.85.22.52',NULL,'6 chemin du long bois','','','14630','FRENOUVILLE',NULL,NULL,'2300614387002',29.000000000,'1951-06-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8538,'VILPREUX','','1957-05-24','02.60.38.24.61','06.93.44.68.00',NULL,'','','','14370','ARGENCES',NULL,NULL,'1570514712002',25.000000000,'1978-11-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8539,'','LEONE','1965-05-20','02.10.56.40.73','06.64.51.98.56',NULL,'47 RUE DU PORT','','','14460','COLOMBELLES',NULL,NULL,'2650514754002',32.000000000,'1989-03-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8540,'LEMARCHAND','FRANCOIS','1956-04-26','02.71.52.19.54','06.94.27.51.82',NULL,'LA VALETTE 14210 PREAUX BOCAGE','','','14000','CAEN',NULL,NULL,'2560414461002',66.000000000,'1978-08-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8541,'TROCHON','LIONEL','1939-01-26','02.38.48.40.25','06.51.36.27.29',NULL,'24 rue des cerisiers','','',NULL,NULL,NULL,NULL,'1390150129002',317.000000000,'1965-09-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8542,'TOLLEMER','MARIE SIMONE','1957-05-15','02.77.08.15.64','06.51.74.78.57',NULL,'3 rue du muguets','','','14000','CAEN',NULL,NULL,'1570514447002',50.000000000,'1986-07-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8543,'PIERRE','rene','1957-05-14','02.90.86.10.68','06.89.40.77.03',NULL,'8 ALLEE DES POETES','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'1570514447002',27.000000000,'1985-07-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8544,'MEZERETTE','STEPHANE','1950-03-03','02.89.49.92.53','06.45.51.46.83',NULL,'ROUTE DE LISIEUX','','','14310','TOURNAY SUR ODON',NULL,NULL,'2500314057002',39.000000000,'1977-05-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8545,'GROUT','MICHEL','1940-12-20','02.68.25.78.44','06.27.86.11.37',NULL,'2 RUE DE LA MER','','','14220','THURY HARCOURT',NULL,NULL,'2401214754002',415.000000000,'1964-03-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8546,'COLLEVILLE','ANGELE','1939-04-05','02.30.14.13.89','06.38.24.03.79',NULL,'3 RUE ALFRED MESRAIZE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2390414101002',8.000000000,'1961-03-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8547,'CLAVREUL','JEAN','1957-09-19','02.38.70.85.04','06.73.50.30.55',NULL,'MANOIR DES COURS D''ORMES','','',NULL,NULL,NULL,NULL,'1570914606002',347.000000000,'1986-05-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8548,'PAYSANT','JEAN','1931-06-09','02.52.56.11.63','06.95.44.62.62',NULL,'8 av pere charles de foucault 4e','me etage porte 10','','14210','STE HONORINE DU FAY',NULL,NULL,'2310614462002',41.000000000,'1954-11-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8549,'MARTEL','JEAN','1950-03-11','02.46.48.65.61','06.72.80.30.39',NULL,'3 alle des bernelles','','',NULL,NULL,NULL,NULL,'1500350580002',15.000000000,'1972-12-24','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8550,'BOURHIS','CHRISTOPHE','1938-11-07','02.11.12.56.58','06.12.24.76.28',NULL,'','','','14990','BERNIERES SUR MER',NULL,NULL,'2381102385002',451.000000000,'1959-04-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8551,'BARATTE','GUY','1958-05-19','02.10.97.54.51','06.10.30.45.38',NULL,'','','','50000','ST LO',NULL,NULL,'1580514697002',921.000000000,'1982-12-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8552,'FONTAINE','JEAN',NULL,'02.11.75.59.35','06.28.27.00.22',NULL,'12 RUE DE PASTEUR','','','14940','BANNEVILLE LA CAMPAGNE',NULL,NULL,'1530250418002',99.000000000,'2012-05-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8553,'GRANDIN','Jacqueline','1957-12-17','02.16.52.01.62','06.37.91.88.21',NULL,'38 rue du quebec','','','14500','VAUDRY',NULL,NULL,'2571250181002',76.000000000,'1980-01-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8554,'MAUGAIN','DAVID','1930-10-02','02.87.51.82.26','06.46.08.80.34',NULL,'la bocquetterie','','','14000','CAEN',NULL,NULL,'2301037261002',482.000000000,'1958-11-18','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8555,'DAUDETEAU','JEAN','1940-01-03','02.81.10.20.93','06.46.97.31.58',NULL,'17 IMPASSE ALSACE LORRAINE','','','14320','MAY SUR ORNE',NULL,NULL,'2400114117002',2963.000000000,'1961-04-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8556,'VOCANT','ANDRE','1948-06-16','02.81.23.33.75','06.50.26.98.31',NULL,'54 RUE BLANCHE ROSE','','','14120','MONDEVILLE',NULL,NULL,'1480614379002',903.000000000,'1977-04-02','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8557,'ALVAREZ','MARCELLE','1945-01-14','02.68.19.64.61','06.60.32.88.90',NULL,'323 RUE DE FALAISE','','','14400','ST MARTIN DES ENTREES',NULL,NULL,'1450186244002',12.000000000,'1966-10-28','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8558,'LANGLOIS','MARCELLE',NULL,'02.14.05.39.49','06.61.83.42.24',NULL,'41  CHEMIN AUX BOEUFS','','',NULL,NULL,NULL,NULL,'1861299342002',748.000000000,'2011-08-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8559,'RENAULT','philippe','1950-05-16','02.16.54.42.13','06.89.74.76.65',NULL,'23 bld raymond poincar','','','14170','BERVILLE',NULL,NULL,'2500514188002',103.000000000,'1980-05-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8560,'LECOURT','Georges','1936-06-11','02.81.83.96.96','06.79.97.41.91',NULL,'17 rue des godets','','','93500','PANTIN',NULL,NULL,'2360614027002',34.000000000,'1960-11-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8561,'MOTTIN','Charles','1950-04-16','02.57.06.04.02','06.20.60.16.44',NULL,'','','','61200','ARGENTAN',NULL,NULL,'2500488271002',81.000000000,'1976-05-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8562,'TRIGER','PATRICK','1940-02-16','02.58.65.76.92','06.76.52.90.43',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'1400214383002',120.000000000,'1964-09-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8563,'BIDAULT','claude','1936-01-15','02.37.64.16.81','06.99.12.87.53',NULL,'1 allee de bernt','','','14490','BALLEROY',NULL,NULL,'1360114488002',30.000000000,'1957-04-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8564,'HAREL','AGNES',NULL,'02.54.25.55.13','06.36.04.65.01',NULL,'1 sur 1 alle des serpentine','','',NULL,NULL,NULL,NULL,'2510250197002',64.000000000,'2009-09-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8565,'DUPRE','CHRISTINE','1965-03-20','02.82.46.57.71','06.11.47.66.54',NULL,'LA POSTE','','','14240','STE HONORINE DE DUCY',NULL,NULL,'2650314624002',148.000000000,'1995-04-22','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8566,'CERE','JACQUES','1934-12-31','02.60.23.89.66','06.53.02.36.68',NULL,'ROUTE DE VIERVILLE','','','14210','EVRECY',NULL,NULL,'1341214470002',16.000000000,'1955-05-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8567,'MARIE','JOSETTE','1935-10-29','02.11.27.68.89','06.67.14.63.57',NULL,'303 allee des serpelets','','','61210','PUTANGES PONT ECREPIN',NULL,NULL,'2351050340002',2.000000000,'1960-05-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8568,'MARIE','PASCAL','1940-03-13','02.16.64.02.60','06.25.60.99.32',NULL,'','','','14500','VIRE',NULL,NULL,'2400314301002',1164.000000000,'1961-06-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8569,'DELALANDE','ANDREE','1963-02-11','02.81.00.13.57','06.51.48.85.49',NULL,'LE BOURG','','','14370','ARGENCES',NULL,NULL,'1630214020002',2979.000000000,'1985-06-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8570,'PAYSANT','MARIE THERESE','1939-09-28','02.79.73.32.27','06.98.96.06.44',NULL,'bat B 1549 route de bretteville','','','14400','TOUR EN BESSIN',NULL,NULL,'1390950257002',355.000000000,'1967-03-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8571,'TOLLEMER','ANDRE','1960-05-28','02.39.82.68.40','06.20.79.47.31',NULL,'54 RUE JULES GUESDES','','','14000','CAEN',NULL,NULL,'1600514019002',185.000000000,'1982-08-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8572,'FEREY','Daniel','1931-07-05','02.89.50.64.15','06.14.70.89.79',NULL,'19 RUE DE L EGLISE','','','14840','DEMOUVILLE',NULL,NULL,'2310750369002',19.000000000,'1955-05-29','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8573,'LEPRINCE','PADOUE','1960-04-25','02.20.67.90.23','06.51.76.46.71',NULL,'23 rue  ambroise croisade','','','14700','SOULANGY',NULL,NULL,'2600414100002',36.000000000,'1990-08-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8574,'DELANGHE','Valentine','1924-10-28','02.42.32.17.51','06.83.87.42.34',NULL,'2 alle des quatre vents','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2241062063002',130.000000000,'1949-10-29','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8575,'QUERUEL','CLAUDINE','1963-10-03','02.26.64.29.10','06.63.83.96.74',NULL,'','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2631014467002',204.000000000,'1987-09-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8576,'LEHERON','JEANNINE','1962-10-22','02.14.36.38.71','06.49.97.95.09',NULL,'ROUTE DE BRETAGNE','','','61200','ARGENTAN',NULL,NULL,'2621014475002',23.000000000,'1987-02-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8577,'DELAUNAY','THERESE','1935-03-26','02.63.10.43.48','06.18.42.66.43',NULL,'4 LE CLOS FLEURIE','','','14930','ETERVILLE',NULL,NULL,'2350361145002',88.000000000,'1959-10-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8578,'GROSSE','Roger','1957-03-05','02.87.17.29.54','06.75.96.81.69',NULL,'16 avenue de l''hypodrome','','','14850','ESCOVILLE',NULL,NULL,'2570361040002',102.000000000,'1980-02-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8579,'CAILLEBOTTE','GILBERT','1961-10-05','02.80.43.19.75','06.93.67.68.92',NULL,'84 rue de la seine','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2611014030002',427.000000000,'1989-10-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8580,'LEGRAND','JEAN','1942-06-30','02.15.31.28.36','06.13.81.90.41',NULL,'','','','14940','SANNERVILLE',NULL,NULL,'2420614376002',961.000000000,'1971-04-09','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8581,'SIMON','vartanoush','1935-05-15','02.14.54.57.84','06.39.01.38.43',NULL,'LA FORGE CAMBRO','','','14000','CAEN',NULL,NULL,'2350514092002',39.000000000,'1962-05-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8582,'TARDIF','GISELE','1969-09-20','02.90.66.68.73','06.88.25.07.89',NULL,'37 av de rouen  bat i','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2690914038002',87.000000000,'1997-04-25','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8583,'MAIGNAN','MONIQUE','1953-03-23','02.56.67.99.02','06.63.50.54.78',NULL,'RUE LES CHAMPS','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2530361362002',129.000000000,'1980-03-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8584,'NICOLAS','THERESE','1938-06-24','02.15.14.43.14','06.17.28.97.06',NULL,'21 RUE DU CIVISME','','','14117','ARROMANCHES LES BAINS',NULL,NULL,'1380614594002',1561.000000000,'1962-05-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8585,'LE MOIGNE GUILBERT','SIMONE','1945-06-29','02.46.75.60.54','06.42.32.30.10',NULL,'4 RUE Alfred NOBEL','','','14000','CAEN',NULL,NULL,'1450650603002',1800.000000000,'1966-03-16','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8586,'HERBINIERE','Isabelle','1930-08-11','02.66.63.55.01','06.52.42.57.97',NULL,'RUE DES MOUTIERS','','','14700','MARTIGNY SUR L''ANTE',NULL,NULL,'2300814308002',94.000000000,'1951-04-24','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8587,'AUVRAY','Henri','1930-04-12','02.90.52.13.08','06.99.96.18.96',NULL,'16 RUE SAINT URSIN','','','14123','IFS',NULL,NULL,'1300414068002',18.000000000,'1958-12-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8588,'THOMAS','MARIE MADELEINE','1946-02-27','02.44.31.72.99','06.99.21.64.69',NULL,'8 RESIDENCE OREE D''HASTINGS','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1460214530002',2411.000000000,'1972-08-26','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8589,'LE GOARANT','Jean','1956-08-15','02.39.42.99.06','06.34.98.12.30',NULL,'7 route de formigny','','','14460','COLOMBELLES',NULL,NULL,'1560850247002',815.000000000,'1982-06-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8590,'LAIR','Claudine','1930-08-30','02.91.40.14.89','06.96.02.39.60',NULL,'le bourg st vogor','','','61210','PUTANGES PONT ECREPIN',NULL,NULL,'2300814308002',79.000000000,'1954-11-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8591,'BOSCHAT','SUZANNE','1959-07-25','02.45.91.02.35','06.34.23.89.04',NULL,'3/2 RUE DES PRES','','','14700','ST PIERRE DU BU',NULL,NULL,'1590714376002',659.000000000,'1983-11-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8592,'THEBAULT','JEANINE','1934-03-07','02.80.78.76.61','06.69.94.61.79',NULL,'7 passage varin','','','14370','ARGENCES',NULL,NULL,'2340314085002',188.000000000,'1960-08-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8593,'MEHENNAOUI','Yvette','1928-06-01','02.92.59.40.67','06.62.91.05.69',NULL,'chicheboville','','','14000','CAEN',NULL,NULL,'2280661446002',263.000000000,'1951-07-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8594,'DUHAZE','RAYMOND','1932-07-31','02.79.40.10.16','06.72.43.53.34',NULL,'4 rue abel lemarchand','','','14000','CAEN',NULL,NULL,'1320714370002',94.000000000,'1953-09-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8595,'MULLOIS','ALAIN','1935-02-12','02.23.24.35.03','06.57.79.63.84',NULL,'34 rue des castors','','','14500','VIRE',NULL,NULL,'1350227385002',242.000000000,'1965-03-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8596,'LEHERON','AUGUSTE','1967-05-03','02.27.95.53.97','06.11.21.17.19',NULL,'73 AVENUE CLEMENCEAU','','','14250','TILLY SUR SEULLES',NULL,NULL,'1670580279002',412.000000000,'1993-02-21','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8597,'COUSIN','GISELE','1958-08-07','02.85.55.97.74',NULL,NULL,'14 rsidence du parc','','','14470','COURSEULLES SUR MER',NULL,NULL,'1580814557002',19.000000000,'1981-06-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8598,'LESNARD','PIERRE','1941-09-16','02.48.56.67.64','06.71.55.22.01',NULL,'2 RUE DES LILAS','','','14000','CAEN',NULL,NULL,'1410914289002',0.000000000,'1966-05-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8599,'GENTIL','MARCELLE','1953-02-24','02.24.85.32.82','06.79.40.72.73',NULL,'37 RUE SAINT MARTIN','','','14790','VERSON',NULL,NULL,'1530250046002',1.000000000,'1977-09-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8600,'GENTIL','GABRIEL','1961-05-27','02.12.55.63.61','06.61.52.60.00',NULL,'6 rue de la grace de dieu','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'2610514039002',409.000000000,'1984-12-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8601,'COLLEU','FABIENNE','1949-01-22','02.78.64.49.98','06.39.92.20.40',NULL,'10 RUE FERNAND LEGER','','','14670','TROARN',NULL,NULL,'1490150446002',57.000000000,'1972-04-01','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8602,'PAYEN','MONIQUE','1938-03-23','02.11.33.52.75','06.10.46.13.05',NULL,'35 Les Taillis','','','14123','IFS',NULL,NULL,'2380314554002',3233.000000000,'1962-10-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8603,'CHANU','LILIANE','1953-11-03','02.75.68.70.59','06.91.03.54.50',NULL,'13, rue du Gros Orme','','','50330','COSQUEVILLE',NULL,NULL,'2531176451002',502.000000000,'1976-12-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8604,'BEZARD','NADINE','1955-01-17','02.85.64.94.01','06.63.84.94.16',NULL,'122 chemin de l''eglise','','','14350','ST MARTIN DES BESACES',NULL,NULL,'1550114264002',112.000000000,'1978-12-28','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8605,'LEMONNIER','ANNICK',NULL,NULL,NULL,NULL,'3 avenue charlotte corday','','','14540','BOURGUEBUS',NULL,NULL,'2331244010002',225.000000000,'2011-09-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8606,'DECLOMESNIL','MARCEL','1951-11-07','02.76.10.41.42','06.85.08.82.43',NULL,'70 RUE DES ACACIAS','','','14120','MONDEVILLE',NULL,NULL,'1511114112002',148.000000000,'1978-05-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8607,'BERTHELOT','SYLVIE','1959-06-16','02.58.45.32.67','06.48.35.58.22',NULL,'85 rue de falaise','','','14540','HUBERT FOLIE',NULL,NULL,'2590650388002',2737.000000000,'1980-01-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8608,'PELTIER','','1947-04-17','02.11.91.75.65','06.32.71.08.66',NULL,'23 BIS AV CROIX GUERIN','','','14123','FLEURY SUR ORNE',NULL,NULL,'2470414546002',100.000000000,'1977-07-01','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8609,'LE BELLER','JEAN','1946-05-13','02.76.01.89.90','06.73.84.59.45',NULL,'50 RUE DU PATY','','','14220','THURY HARCOURT',NULL,NULL,'2460514623002',25.000000000,'1974-10-10','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8610,'GROSSET','DIDIER','1930-01-21','02.10.70.15.27','06.30.63.89.00',NULL,'11 ALLEE DES POETES','','','14840','DEMOUVILLE',NULL,NULL,'1300150052002',21.000000000,'1952-03-13','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8611,'SOURDIN','DIDIER','1945-01-23','02.54.12.73.54','06.53.29.04.04',NULL,'VILLAGE CARTILLY','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1450161494002',43.000000000,'1975-04-25','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8612,'BETTIN','FRANCOISE','1957-06-16','02.37.31.67.95','06.52.80.65.04',NULL,'','','','61150','TANQUES',NULL,NULL,'1570614505002',76.000000000,'1987-04-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8613,'BERGUE','MARIE PAULE','1960-06-20','02.33.62.94.31','06.83.85.98.35',NULL,'50 RUE DES ACASIAS','','','14240','CAUMONT L''EVENTE',NULL,NULL,'1600614509002',4521.000000000,'1987-05-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8614,'DEFEVER','Jacques','1965-03-29','02.70.11.29.48','06.10.37.32.05',NULL,'','','','50120','EQUEURDREVILLE HAINNEVILLE',NULL,NULL,'1650314675002',11.000000000,'1991-09-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8615,'MERINO','PATRICE','1961-08-28','02.30.29.92.81','06.11.22.31.11',NULL,'VILLAGE LES SAPINS','','','14000','CAEN',NULL,NULL,'1610814139002',255.000000000,'1991-12-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8616,'LENEVEU','CORINNE','1932-05-27','02.49.20.28.53','06.56.21.00.69',NULL,'10 RUE DU BOURG','','','14220','CROISILLES',NULL,NULL,'2320550602002',98.000000000,'1960-10-01','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8617,'BOUILLARD','janny','1934-01-13','02.11.89.15.52','00 33 6.72.73.89.52',NULL,'3 HAMEAU MONCEL','','','14740','MARTRAGNY',NULL,NULL,'2340127233002',793.000000000,'1955-07-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8618,'LEBAS','LOUIS','1957-03-09','02.92.59.95.78','06.88.99.51.40',NULL,'16 RUE DE PROVENCE','','','14840','DEMOUVILLE',NULL,NULL,'1570314327002',52.000000000,'1978-10-13','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8619,'BINET','MARTHE','1944-05-25','02.49.38.70.64','06.63.66.91.89',NULL,'CHEMIN DU LIEU MEZERAY','','','14150','OUISTREHAM',NULL,NULL,'2440514740002',1322.000000000,'1974-11-16','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8620,'SIBRAN','PIERRE',NULL,'02.65.53.78.00','06.44.25.93.32',NULL,'5 rue de l''egalite','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2400614309002',355.000000000,'2010-05-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8621,'PANEL','GUY','1931-09-12','02.67.85.33.25','06.86.48.39.53',NULL,'8 rue des iris','','','14310','VILLERS BOCAGE',NULL,NULL,'2310914288002',10.000000000,'1954-04-20','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8622,'GOURIOU','Annie','1934-12-07','02.61.16.00.35','06.66.19.76.71',NULL,'69 RUE EMILE ZOLA','','','14120','MONDEVILLE',NULL,NULL,'2341214164002',186.000000000,'1963-04-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8623,'LECHEMINANT','J CLAUDE','1960-11-06','02.17.04.02.60','06.88.92.70.93',NULL,'12 RUE URBAIN LEFRANCOIS','','','14123','IFS',NULL,NULL,'1601114323002',20.000000000,'1986-04-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8624,'GROSINI','PIERRE','1963-02-19','02.14.71.72.72','06.13.75.03.09',NULL,'29 rue des primeveres','','','14320','FONTENAY LE MARMION',NULL,NULL,'1630214221002',45.000000000,'1985-08-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8625,'VOCANT','THERESE','1953-03-02','02.64.43.11.35','06.16.09.55.74',NULL,'','','','14270','MEZIDON CANON',NULL,NULL,'1530350248002',3304.000000000,'1976-05-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8626,'HUCHET','MARCEL','1940-01-16','02.79.05.45.25','06.58.29.17.36',NULL,'8 RUE OCTAVE DODEMAN','','','14840','CUVERVILLE',NULL,NULL,'1400114572002',2922.000000000,'1961-10-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8627,'PITARD','CLAUDE',NULL,'02.40.28.83.04','06.47.96.73.06',NULL,'28 rue montcalm','','','14460','COLOMBELLES',NULL,NULL,'2310850597002',36.000000000,'2008-07-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8628,'LECARPENTIER','MICHELE','1952-03-26','02.75.49.25.61','06.25.59.76.42',NULL,'la saunerie le bateau est','','','14000','CAEN',NULL,NULL,'2520361511002',196.000000000,'1973-10-26','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8629,'LAIGNEAU','BERNADETTE','1931-06-06','02.45.14.10.27','06.31.92.36.12',NULL,'4 rue richard 1 er','','','14370','ARGENCES',NULL,NULL,'2310650371002',21.000000000,'1959-10-08','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8630,'BOREL','MARIE-CLAIRE','1957-03-14','02.79.37.56.70','06.10.05.66.35',NULL,'10 CHEMIN DU VAL ES FLEURS','','','14850','HEROUVILLETTE',NULL,NULL,'2570380720002',326.000000000,'1982-03-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8631,'RIDEAU','Marcel','1955-03-30','02.11.49.63.55','06.26.22.54.18',NULL,'VILLAGE LES LANDES','','','14000','CAEN',NULL,NULL,'2550314365002',230.000000000,'1976-06-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8632,'PROFICHET','FRANCOISE','1935-06-27','02.71.56.26.18','06.93.10.46.81',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'1350629211002',98.000000000,'1959-03-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8633,'GREGOIRE','MYRIAM','1955-07-25','02.65.51.85.58','06.87.92.44.75',NULL,'32 RUE DES ECOLES','','','50180','AGNEAUX',NULL,NULL,'1550761228002',5.000000000,'1984-11-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8634,'PRESTAVOINE','GISELE','1931-07-12','02.14.59.66.87','06.12.16.74.14',NULL,'3 impasse spirou','','','14630','FRENOUVILLE',NULL,NULL,'2310750237002',10.000000000,'1955-09-06','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8635,'BELLIARD','JEANNINE','1966-04-17','02.31.98.82.28','06.99.10.89.42',NULL,'5 BD BELLEVUE BAT G APPT 12','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2660414108002',468.000000000,'1987-09-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8636,'PHELIPPOT','ELISABETH','1935-08-16','02.78.69.98.69','06.74.28.94.04',NULL,'2 RUE GUY DE MAUPASSANT','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2350865304002',1608.000000000,'1958-04-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8637,'LEBAILLY','Isabelle','1936-06-06','02.50.24.69.95','06.51.90.13.89',NULL,'21 bvd du 30 juin','','','14260','AUNAY SUR ODON',NULL,NULL,'2360627591002',103.000000000,'1964-10-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8638,'MAUNOURY','RENE','1947-07-22','02.10.90.29.64','06.56.97.02.53',NULL,'le bourg','','','14000','CAEN',NULL,NULL,'1470714455002',165.000000000,'1970-03-22','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8639,'BOZO','DANIEL','1945-11-04','02.69.03.21.92','06.87.93.38.14',NULL,'110 rue du general leclerc','','','14680','GOUVIX',NULL,NULL,'1451114467002',28.000000000,'1974-07-06','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8640,'MOREL','','1942-10-02','02.10.14.60.83','06.38.65.35.76',NULL,'9 RUE DES CASTORS','','','14370','BILLY',NULL,NULL,'1421014622002',392.000000000,'1963-10-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8641,'TREILHES','MICHELINE','1949-01-02','02.39.45.86.10','06.81.34.20.27',NULL,'5 RUE DES ROITELETS','','','14850','ESCOVILLE',NULL,NULL,'1490114378002',25.000000000,'1973-12-23','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8642,'HOORELBECKE','DANIEL','1930-08-11','02.84.66.73.52','06.31.54.14.29',NULL,'97 B RUE D''HEROUVILLE','','','14470','COURSEULLES SUR MER',NULL,NULL,'2300861044002',5255.000000000,'1953-10-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8643,'','Marie france','1934-06-20','02.26.35.61.94','06.71.87.71.96',NULL,'14 RUE MARCEL LEMERAY','','','14000','CAEN',NULL,NULL,'2340614514002',78.000000000,'1957-03-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8644,'GAUTIER','MYRIAM','1936-03-04','02.44.73.27.07','06.23.22.11.55',NULL,'2 IMPASSE DE LA GARENNE','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'1360350567002',80.000000000,'1959-12-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8645,'COURGENOULT','THIERRY','1940-03-21','02.15.79.61.89','06.68.20.95.50',NULL,'20 ROUTE DE CAEN','','','14000','CAEN',NULL,NULL,'1400350579002',2940.000000000,'1962-09-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8646,'GERAULT','Valerie','1959-03-25','02.48.41.53.49','06.20.23.70.29',NULL,'4 RUE ARISTIDE BRIAND','','','14123','IFS',NULL,NULL,'2590314124002',656.000000000,'1981-01-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8647,'FAUTRAT','CATHERINE','1949-05-24','02.34.30.83.60','06.37.51.58.23',NULL,'12/2 CITEE DU CALVAIRE','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1490562526002',7.000000000,'1972-12-26','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8648,'GOUYE','GUY','1928-06-08','02.72.20.96.79','06.22.27.08.37',NULL,'83 rue du village','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2280614092002',1997.000000000,'1958-08-24','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8649,'SAUVAN','THERESE','1959-02-07','02.89.57.82.12','06.39.30.38.12',NULL,'51 RUE DU GENERAL LECLERC','','','14510','HOULGATE',NULL,NULL,'2590214257002',133.000000000,'1984-04-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8650,'FICHET','JEAN','1934-12-24','02.37.49.18.17','06.72.35.52.47',NULL,'21 BIS RUE PERE CHARLES DE FOUCA','ULT','','14260','AUNAY SUR ODON',NULL,NULL,'2341260186002',362.000000000,'1960-04-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8651,'ASSELOT','JEAN CLAUDE','1965-06-24','02.62.46.82.63','06.36.60.38.18',NULL,'10 RUE DE LA BRUYERE','','','14000','CAEN',NULL,NULL,'2650614163002',23.000000000,'1993-03-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8652,'AUBREE','JACKIE','1957-02-15','02.10.12.87.65','06.15.55.52.30',NULL,'8 RUE DU CLOS ST JACQUES','','','50420','DOMJEAN',NULL,NULL,'1570214383002',667.000000000,'1979-03-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8653,'JAMET','PIERRE','1939-01-27','02.39.41.27.19','06.67.17.13.56',NULL,'12 rue de la chenedotte','','','14260','AUNAY SUR ODON',NULL,NULL,'2390114301002',565.000000000,'1969-09-28','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8654,'GOURDAIN','ALAIN','1937-06-14','02.52.30.58.50','06.18.87.82.42',NULL,'4 RUE DE LA PETITE JUSTICE','','','14370','VIMONT',NULL,NULL,'1370614649002',94.000000000,'1964-02-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8655,'PATRY','MATHILDE','1969-06-27','02.75.00.98.98','06.30.01.30.73',NULL,'09 PLACE NELSON MANDELA','','',NULL,NULL,NULL,NULL,'2690614008002',341.000000000,'1992-01-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8656,'GRAINDORGE','MONIQUE','1936-06-26','02.18.91.00.23','06.69.88.19.55',NULL,'LE PORTAIL','','','14123','IFS',NULL,NULL,'1360614738002',4.000000000,'1957-11-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8657,'BROUARD','denis','1965-06-09','02.29.91.56.21','06.34.40.11.28',NULL,'LIEU DIT"LA BRUYERE"','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1650678200002',1054.000000000,'1986-03-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8658,'COZIC','Laurent','1959-01-12','02.68.78.20.78','06.30.12.30.99',NULL,'19 HAMEAU AUX FEVRES','','','14240','CAUMONT L''EVENTE',NULL,NULL,'1590114663002',784.000000000,'1983-09-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8659,'THERESE DIT DUCHEMIN','JEAN PAUL','1939-07-19','02.16.34.41.67','06.10.77.47.42',NULL,'15 RUE DE LA FONTAINE','','','14000','CAEN',NULL,NULL,'1390744036002',780.000000000,'1964-03-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8660,'ANNE','NICOLE','1932-04-12','02.32.17.23.66','06.15.97.95.09',NULL,'4 RUE DES BERETS VERTS','','','14460','COLOMBELLES',NULL,NULL,'1320450579002',181.000000000,'1954-07-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8661,'HOUSSIN','ALAIN','1968-01-11','02.13.61.57.82','06.76.52.88.04',NULL,'17 BEAUVAIS','','','14000','CAEN',NULL,NULL,'2680114060002',170.000000000,'1989-08-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8662,'MARIE','PIERRE','1958-03-31','02.11.41.23.79','06.52.32.83.13',NULL,'60 route d harcourt','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'2580314515002',82.000000000,'1979-02-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8663,'MARIE','PIERRE','1929-10-10','02.72.94.65.08','06.27.89.05.33',NULL,'LA GAUDINE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1291050341002',33.000000000,'1950-09-01','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8664,'MARIE','MIREILLE','1970-01-13','02.40.87.77.68','06.72.49.55.63',NULL,'8 route de vimont','','','14860','BAVENT',NULL,NULL,'2700161145002',871.000000000,'2000-12-27','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8665,'BELLOU','PASCAL','1935-06-05','02.38.58.39.73','06.89.07.56.09',NULL,'908 BD GRANDE DELLE','','','14840','DEMOUVILLE',NULL,NULL,'1350629211002',111.000000000,'1956-07-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8666,'ISABELLE','JEANNINE','1936-07-27','02.13.64.59.18','06.12.32.52.34',NULL,'4 rue des berets verts','','','14830','LANGRUNE SUR MER',NULL,NULL,'1360750343002',303.000000000,'1959-07-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8667,'LE FERON DE LONGCAMP','MICHEL','1934-08-11','02.48.05.41.72','06.31.04.66.75',NULL,'2 allee de l''alberta','','','14000','CAEN',NULL,NULL,'1340827129002',37.000000000,'1959-01-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8668,'LELIEVRE','ANNIE','1963-02-18','02.81.57.71.53','06.39.32.91.36',NULL,'','','','14000','CAEN',NULL,NULL,'1630214228002',335.000000000,'1984-11-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8669,'DURAND','CLAIRE','1963-06-12','02.36.14.15.07','06.22.79.10.26',NULL,'7 RUE DE L''EGLISE','','','14220','LES MOUTIERS EN CINGLAIS',NULL,NULL,'2630614635002',16.000000000,'1989-01-04','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8670,'BAPTISTE','MICHEL','1943-03-13','02.75.60.67.52','06.12.04.06.42',NULL,'3 RUE DE LA MER','','','14270','CESNY AUX VIGNES OUEZY',NULL,NULL,'1430314036002',1924.000000000,'1967-07-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8671,'ALFRED','NATHALIE','1929-04-04','02.71.67.07.69','06.86.53.01.25',NULL,'18 rue de stocklom','','','14570','CLECY',NULL,NULL,'2290414489002',1544.000000000,'1953-08-22','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8672,'LENEVEU','FLORENCE','1963-06-03','02.58.00.05.42','06.24.84.44.79',NULL,'4 rue de la garre','','','14000','CAEN',NULL,NULL,'2630614635002',77.000000000,'1990-11-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8673,'BOTATA','ANTOINETTE','1958-10-19','02.98.69.00.12','06.66.36.84.97',NULL,'17 RUE ROBERT LETELLIER','','','14400','BAYEUX',NULL,NULL,'2581027105002',662.000000000,'1983-02-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8674,'LEDEMNEY','LOUIS','1963-07-29','02.74.93.61.53',NULL,NULL,'12 allee des aubepines','','','14123','IFS',NULL,NULL,'1630714432002',32.000000000,'1984-05-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8675,'CANTEL','CLAUDE','1939-02-14','02.88.07.27.71','06.82.42.75.79',NULL,'11 rue elsa trioller','','','14730','GIBERVILLE',NULL,NULL,'2390250431002',425.000000000,'1967-07-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8676,'SEBIRE','CECILE','1944-01-17','02.58.69.51.30','06.84.73.16.86',NULL,'43 avenue jean villard','','','14250','TILLY SUR SEULLES',NULL,NULL,'2440114354002',204.000000000,'1966-03-02','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8677,'HOUDANT','SERGE','1934-01-16','02.45.66.09.32','06.53.50.47.72',NULL,'13 ALLEE DE VARSOVIE','','','14000','CAEN',NULL,NULL,'2340114578002',31.000000000,'1963-07-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8678,'TILLARD','JEANNE','1935-08-15','02.90.95.08.87','06.10.80.70.38',NULL,'8 allee des poetes','','','14740','CARCAGNY',NULL,NULL,'2350835011002',103.000000000,'1962-10-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8679,'COLARD','EVELYNE','1968-10-24','02.39.09.48.24','06.11.78.43.19',NULL,'18 RUE ARTHUR RAIMBAUD','','','14310','MONTS EN BESSIN',NULL,NULL,'1681014319002',963.000000000,'1992-10-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8680,'BOTATA','MICHEL','1952-01-01','02.58.69.90.73','06.24.98.05.00',NULL,'8 rue du puits de rome','','',NULL,NULL,NULL,NULL,'2520114245002',333.000000000,'1977-07-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8681,'NOEL','ARMELLE','1945-07-25','02.88.99.68.98','06.59.56.28.80',NULL,'4 RUE DES OISEAUX','','','14120','MONDEVILLE',NULL,NULL,'2450714438002',19.000000000,'1966-02-08','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8682,'LEVANNIER','DIDIER','1939-05-26','02.42.18.28.17','06.22.34.97.97',NULL,'21 AVENUE KENNEDY','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1390514207002',156.000000000,'1966-10-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8683,'VAUDRY','DIDIER',NULL,'02.44.98.14.84','06.40.74.62.83',NULL,'3 rue paul verlene','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'2460114290002',1342.000000000,'2012-08-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8684,'DUVALLEROY','JEAN','1954-08-08','02.22.10.42.80','06.26.67.70.79',NULL,'23 ALLEE DES PEPINIERES','','','50130','OCTEVILLE',NULL,NULL,'1540861143002',490.000000000,'1980-12-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8685,'GOULET','JACQUELINE','1962-04-08','02.15.70.50.68','06.82.83.43.70',NULL,'17 RUE SAINT LO','','','50750','STE SUZANNE SUR VIRE',NULL,NULL,'2620414391002',12.000000000,'1985-02-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8686,'SALMON','FRANCOISE','1939-05-18','02.82.05.06.54','06.87.19.04.70',NULL,'','','','14000','CAEN',NULL,NULL,'2390517058002',55.000000000,'1964-06-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8687,'BAYEUX','GENEVIEVE','1939-05-20','02.57.99.40.84','06.75.46.06.22',NULL,'21 RUE DU DEVON','','','14000','CAEN',NULL,NULL,'2390517058002',1423.000000000,'1960-06-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8688,'FAVRIS','LILIANE','1937-02-19','02.52.51.10.53','06.10.87.86.83',NULL,'14 impasse de la hetraie','','','14230','MONFREVILLE',NULL,NULL,'2370214990002',28.000000000,'1959-02-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8689,'GAUTIER','JACQUES','1930-03-04','02.73.95.24.04','06.76.88.55.48',NULL,'4 RUE   CLOS BARON','','',NULL,NULL,NULL,NULL,'2300359592002',26.000000000,'1956-08-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8690,'TROUVE','JACQUELINE','1935-11-22','02.56.08.07.29','06.66.44.63.05',NULL,'7 IMPASSE DU CHAPEAU','','','61200','ARGENTAN',NULL,NULL,'1351161025002',1042.000000000,'1957-10-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8691,'LABORDE','SERGE','1940-01-20','02.11.80.89.53','06.58.75.56.63',NULL,'26 avenue jacques chastellain','','','14000','CAEN',NULL,NULL,'2400114076002',169.000000000,'1965-11-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8692,'LEGRAND','GUY','1932-02-26','02.72.72.97.95','06.69.58.29.17',NULL,'5 BOULEVARD GENERAL VANNIER','','','14000','CAEN',NULL,NULL,'2320214489002',95.000000000,'1959-11-27','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8693,'ROQUET','CLAUDETTE','1940-10-08','02.38.45.98.65','06.11.93.81.35',NULL,'8 rue du marais','','','14630','CAGNY',NULL,NULL,'1401061456002',36.000000000,'1967-04-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8694,'TURPIN','JACQUES','1938-03-10','02.18.88.81.96','06.42.49.28.57',NULL,'la pice margot','','','14860','BAVENT',NULL,NULL,'1380350552002',3466.000000000,'1962-07-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8695,'HEUZE','GISELE','1932-04-20','02.12.03.71.08','06.76.64.13.91',NULL,'LA FORETERIE','','','14000','CAEN',NULL,NULL,'2320450601002',416.000000000,'1959-01-21','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8696,'ANCELIN','REGINE','1937-10-09','02.11.86.12.89','06.18.75.12.27',NULL,'4 rue des hirondelles','','','14400','CROUAY',NULL,NULL,'1371059017002',32.000000000,'1960-01-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8697,'GUILBERT','SYLVIE','1951-01-19','02.56.48.05.49','06.60.09.91.58',NULL,'23 LOTISSEMENT DU BEL HAMELIN','','','14000','CAEN',NULL,NULL,'2510114020002',620.000000000,'1972-07-07','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8698,'NEMTZOFF','LOUIS','1932-06-25','02.50.61.27.55','06.10.82.70.21',NULL,'26 rue du village','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1320614554002',40.000000000,'1953-10-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8699,'ISSAKHA','Michel','1987-01-13','02.84.48.78.06','06.11.78.88.59',NULL,'6 RUE DU MAINE','','','14420','SOUMONT ST QUENTIN',NULL,NULL,'2870199151002',5.000000000,'2008-03-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8700,'COUDREAU','JEAN','1959-07-16','02.39.41.52.73','06.12.20.29.05',NULL,'44 av st therese','','','14000','CAEN',NULL,NULL,'1590750187002',3474.000000000,'1988-10-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8701,'LANGLOIS','MARIE THERESE','1967-05-26','02.83.66.27.68','06.14.71.78.23',NULL,'692 CHEMIN DU VAL','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'1670514535002',255.000000000,'1994-03-12','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8702,'ZENE HELOU','Huguette','1969-11-19','02.55.25.43.72','06.34.31.63.21',NULL,'17 rue de bonne','','','14000','CAEN',NULL,NULL,'2691176231002',220.000000000,'1998-10-02','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8703,'CHAPRON','FRANCOISE JEANNE','1950-05-30','02.78.79.45.70','06.79.16.79.59',NULL,'33 RUE DU CLOS DES ROSES','','','14120','MONDEVILLE',NULL,NULL,'2500550552002',151.000000000,'1973-10-26','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8704,'ANDOUARD','DANIEL','1928-05-28','02.87.17.79.29','06.47.27.00.45',NULL,'5 RUE JULES FERRY','','','50260','BRICQUEBEC',NULL,NULL,'1280514266002',1361.000000000,'1958-06-25','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8705,'ZENE HELOU','RENEE','1960-06-24','02.24.18.70.20','06.10.35.04.85',NULL,'1 RUE DU STADE','','','14700','FALAISE',NULL,NULL,'1600614319002',378.000000000,'1983-07-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8706,'SCELLES','BERNARD','1935-09-01','02.16.66.13.34','06.38.91.41.38',NULL,'8 PLACE DE ROTTENDORF','','','14540','SOLIERS',NULL,NULL,'1350950123002',52.000000000,'1957-03-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8707,'HULINE','FRANCIS','1929-07-20','02.19.07.15.66','06.80.51.82.44',NULL,'21 rue albert de mun','','','14150','OUISTREHAM',NULL,NULL,'2290714098002',29.000000000,'1955-02-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8708,'BLAISE','JACQUELINE','1942-10-28','02.14.15.35.84','06.67.80.43.59',NULL,'95 RUE DE LA FONTAINE','','','14700','FALAISE',NULL,NULL,'1421078585002',93.000000000,'1966-06-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8709,'VIVIER','CHRISTELLE','1930-05-30','02.72.34.37.80','06.23.36.00.76',NULL,'2 RUE LIEUTENANT LOUIS RENOUF','','','14000','CAEN',NULL,NULL,'1300550394002',143.000000000,'1951-05-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8710,'POUTEAU','HELENE','1932-08-05','02.48.12.04.30','06.32.73.85.04',NULL,'2 rue des charrons','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1320814409002',607.000000000,'1956-01-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8711,'LAURENT','ANELIYA','1935-01-18','02.68.71.85.38','06.37.84.80.49',NULL,'15 RUE LE CLOS','','','14000','CAEN',NULL,NULL,'2350150216002',29.000000000,'1959-08-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8712,'LEMAIRE','GERARD','1966-08-24','02.74.20.74.04',NULL,NULL,'60 BD DU MARECHAL LYAUTEY','','','14500','VIRE',NULL,NULL,'2660814014002',358.000000000,'1994-01-11','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8713,'SOCHA','HENRIETTE','1929-02-25','02.12.73.93.50','06.16.69.45.94',NULL,'15 rue des vaudes','','','14000','CAEN',NULL,NULL,'2290214671002',36.000000000,'1953-10-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8714,'GIRARD','RENE','1952-12-09','02.40.92.28.14','06.36.23.23.79',NULL,'6 impasse du clos perel','','','14480','CREULLY',NULL,NULL,'1521214097002',100.000000000,'1975-06-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8715,'DUBUS','NICOLE','1951-01-23','02.11.21.25.52','06.82.81.55.18',NULL,'9 rue henri crochet','','','14320','MAY SUR ORNE',NULL,NULL,'2510114341002',647.000000000,'1974-10-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8716,'CARBONNEL','MICHEL','1928-07-27','02.66.13.73.52','06.10.83.58.65',NULL,'40 RUE ANDRE LEMAITRE','','','14123','IFS',NULL,NULL,'1280714167002',61.000000000,'1956-04-17','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8717,'ERRAGNE','ALAIN','1936-09-25','02.57.99.95.74',NULL,NULL,'119 chemin de l''eglise','','','14260','AUNAY SUR ODON',NULL,NULL,'2360914436002',3650.000000000,'1959-02-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8718,'RICHARD','MARGUERITE','1957-04-12','02.67.25.10.90','06.68.90.17.11',NULL,'24 RUE DE BAYEUX','','','14840','CUVERVILLE',NULL,NULL,'1570461324002',82.000000000,'1980-09-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8719,'DESFAUDAIS','EUGENE','1949-04-12','02.24.82.56.41','06.78.70.27.16',NULL,'1 chemin des coteaux','','','14480','RUCQUEVILLE',NULL,NULL,'2490414207002',33.000000000,'1972-04-25','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8720,'AUVRAY','JOSETTE DENISE','1934-12-28','02.78.46.03.63','06.92.46.25.53',NULL,'27 IMPASSE DE L''ORANGERAIE','','','14960','ASNELLES',NULL,NULL,'2341214046002',374.000000000,'1956-08-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8721,'ROGER','PHILIPPE','1960-03-12','02.54.98.65.95','00 33 6.14.55.89.42',NULL,'2 route de bissiers','','','14730','GIBERVILLE',NULL,NULL,'2600314050002',1489.000000000,'1984-09-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8722,'KOWAL','MARIE THERESE','1971-11-19','02.86.35.54.70','06.47.71.96.22',NULL,'154 bvd leroy','','','14000','CAEN',NULL,NULL,'2711114118002',456.000000000,'1996-04-03','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8723,'LEVASSEUR','FRANCOISE','1936-08-13','02.35.99.06.21','06.89.98.15.36',NULL,'noron la baye','','','14540','ROCQUANCOURT',NULL,NULL,'1360850203002',1397.000000000,'1960-05-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8724,'MARCELLE','MICHEL','1939-03-08','02.63.98.39.35','06.39.74.86.52',NULL,'10 RUE LUCIEN ROPARS','','',NULL,NULL,NULL,NULL,'1390314719002',106.000000000,'1962-05-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8725,'HARDOUIN','ALAIN','1969-10-06','02.79.52.81.43','06.47.19.33.78',NULL,'44 RUE DU BOSQ','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1691027681002',122.000000000,'1995-10-17','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8726,'CHAILLOUX','PAULETTE','1935-07-08','02.56.15.89.36','06.31.57.50.68',NULL,'21 rue Pierre Jaquot','','','14000','CAEN',NULL,NULL,'2350772367002',51.000000000,'1959-10-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8727,'BERNIER','PAULETTE','1932-07-07','02.63.68.66.74',NULL,NULL,'2 ALLEE DES PROMENADES','','','14000','CAEN',NULL,NULL,'1320714545002',181.000000000,'1960-08-15','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8728,'DORTEE','JOSETTE','1947-09-09','02.55.01.91.89','06.11.56.81.44',NULL,'41 RUE DU PORT','','','14270','MEZIDON CANON',NULL,NULL,'2470976522002',32.000000000,'1971-06-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8729,'VETILLARD','HENRI','1967-01-12','02.40.72.86.21','06.49.66.09.32',NULL,'21 rue du tumulus','','','14730','GIBERVILLE',NULL,NULL,'2670114076002',1987.000000000,'1994-02-28','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8730,'LABROUQUERE','PIERRE','1955-04-21','02.61.36.39.20','06.59.94.36.58',NULL,'37 av de rouen bat i','','','14780','LION SUR MER',NULL,NULL,'1550414118002',232.000000000,'1980-08-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8731,'REVERT','CLAUDE','1946-03-01','02.20.03.61.54','06.30.83.13.29',NULL,'44 RUE DE LA TESTE','','','14000','CAEN',NULL,NULL,'1460350350002',12.000000000,'1971-01-01','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8732,'VAULTIER','Marie therese','1957-04-14','02.75.59.05.60','06.66.96.23.20',NULL,'36 avenue de paris','','','14540','ROCQUANCOURT',NULL,NULL,'2570414394002',84.000000000,'1983-04-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8733,'HAMEL','MICHEL','1948-07-07','02.23.11.47.63','06.11.17.61.47',NULL,'LA LANDE','','','14840','DEMOUVILLE',NULL,NULL,'2480714747002',83.000000000,'1973-01-09','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8734,'LANDEAU','MONIQUE','1938-04-11','02.52.31.50.53','06.73.67.40.41',NULL,'5 RUE DU LONG BOUET','','','14460','COLOMBELLES',NULL,NULL,'1380414589002',763.000000000,'1966-03-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8735,'BRION','PIERRE',NULL,'02.10.19.92.68','06.93.29.91.49',NULL,'3 place des sorbiers','','','50880','PONT HEBERT',NULL,NULL,'2390214478002',6.000000000,'2011-09-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8736,'FOUCHER','RENE','1938-09-13','02.60.21.50.39','06.64.31.84.51',NULL,'46 rue de lisbonne','','','14000','CAEN',NULL,NULL,'2380914371002',874.000000000,'1965-11-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8737,'BONNESOEUR','CECILE','1936-06-25','02.14.78.31.02','06.54.11.50.28',NULL,'75 RUE DE LA REPUBLIQUE','','','14670','ST PAIR',NULL,NULL,'1360650484002',23.000000000,'1960-06-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8738,'KAMALI','JOCELYNE','1930-06-19','02.71.61.68.99','06.36.12.93.39',NULL,'5 ALLEE DES THUYAS','','','14000','CAEN',NULL,NULL,'2300614464002',1465.000000000,'1955-01-28','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8739,'LAUNAY','FRANCOISE','1951-02-03','02.61.63.74.64',NULL,NULL,'14 LE PRE DU VILLAGE','','','14000','CAEN',NULL,NULL,'2510214318002',162.000000000,'1973-01-31','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8740,'DURAND','MICHEL','1934-03-14','02.72.72.31.43','06.74.32.50.90',NULL,'7 TER RUE DU JANVILLE','','',NULL,NULL,NULL,NULL,'2340314743002',4289.000000000,'1964-06-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8741,'BERTOUT','DOMINIQUE','1929-11-26','02.31.81.60.92','06.58.14.05.39',NULL,'20 RUE LEONARD GILLES','','',NULL,NULL,NULL,NULL,'2291150597002',18.000000000,'1957-03-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8742,'POISSON','BERNADETTE','1951-01-20','02.11.15.03.88','06.11.62.13.41',NULL,'7 impasse de rocroi','','','14730','GIBERVILLE',NULL,NULL,'2510114762002',192.000000000,'1974-06-17','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8743,'SAMSON','GERALDINE','1933-04-03','02.24.38.90.48','06.49.51.75.54',NULL,'14 RUE KALINIGRENKO','','','14000','CAEN',NULL,NULL,'1330414516002',130.000000000,'1959-08-28','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8744,'BATTAGION','JEAN CLAUDE','1930-04-08','02.10.12.44.55','06.89.10.22.59',NULL,'10 RUE MAURICE FOUQUES','','',NULL,NULL,NULL,NULL,'2300477441002',101.000000000,'1951-12-06','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8745,'GOSSET','NICOLLE','1958-08-14','02.90.37.47.00','06.60.34.07.30',NULL,'CARREFOUR DE LA BOTTE','','','14730','GIBERVILLE',NULL,NULL,'2580814081002',665.000000000,'1979-07-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8746,'LACOTTE','JEANINE','1939-08-10','02.31.99.47.81','06.22.34.33.86',NULL,'9 RUE DE L''AVENIR','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1390861073002',66.000000000,'1961-10-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8747,'BUREAU','GEORGETTE','1940-11-08','02.11.04.80.23','06.42.42.65.75',NULL,'22 avenue de la concorde','','','14000','CAEN',NULL,NULL,'1401150240002',4.000000000,'1962-08-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8748,'HANOY','THERESE','1932-01-17','02.27.47.83.63','06.66.12.66.79',NULL,'121 RUE DE LA GARENNE','','','14160','DIVES SUR MER',NULL,NULL,'2320120246002',168.000000000,'1961-06-29','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8749,'BINARD','MARIE THERESE','1942-02-14','02.67.82.14.47','06.20.10.57.38',NULL,'19 place du champs foire','','','14000','CAEN',NULL,NULL,'1420224301002',709.000000000,'1971-03-24','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8750,'LESCOT','OLIVIER','1929-11-26','02.29.14.29.18','06.88.43.14.52',NULL,'7 RUE DES CARRIERES DE VAUCELLES','','','14500','COULONCES',NULL,NULL,'1291127527002',226.000000000,'1958-10-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8751,'OUZOUF','roland','1955-01-23','02.11.56.79.89','06.73.64.72.12',NULL,'le haut mesnil','','',NULL,NULL,NULL,NULL,'1550114163002',188.000000000,'1981-09-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8752,'BOUCHARD','Rene','1928-09-14','02.64.97.97.25','06.62.99.99.71',NULL,'RUE DES PRES','','','14700','FALAISE',NULL,NULL,'1280945348002',84.000000000,'1950-07-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8753,'','BERNADETTE','1933-09-02','02.59.54.49.12','06.33.62.55.62',NULL,'21 RUE DU BOIS DE CLOQUET','','','14240','CAUMONT L''EVENTE',NULL,NULL,'2330914290002',36.000000000,'1957-08-09','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8754,'NOEL','GILBERT','1934-02-06','02.78.39.72.77','06.51.11.97.85',NULL,'10 rue de la pomme d''or','','','14123','FLEURY SUR ORNE',NULL,NULL,'1340253155002',91.000000000,'1958-04-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8755,'DESMEULLES','FRANCOIS','1970-01-14','02.14.27.15.61','06.80.65.13.25',NULL,'11 rue du manoir','','','14730','GIBERVILLE',NULL,NULL,'2700161145002',1278.000000000,'2000-02-11','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8756,'SALLE','COLETTE','1950-08-06','02.98.69.76.42','06.82.16.50.75',NULL,'29 rue gustade','','','50690','VIRANDEVILLE',NULL,NULL,'2500814160002',808.000000000,'1972-09-09','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8757,'MEUROU','CATHERINE','1948-05-01','02.29.84.85.45','06.84.30.20.80',NULL,'19 RUE NICOLAS ORESME','','','14000','CAEN',NULL,NULL,'2480514075002',247.000000000,'1976-04-11','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8758,'TRIFONOVA','Emmanuel','1954-03-04','02.71.35.52.18','06.40.03.16.12',NULL,'13 rue du major eg steyffe','','','14370','CLEVILLE',NULL,NULL,'2540314205002',2765.000000000,'1984-04-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8759,'YGOUF','VENANCIO JORGE','1939-10-21','02.19.39.95.00','06.72.41.14.08',NULL,'181 RESIDENCE VALMY','','','14000','CAEN',NULL,NULL,'2391050562002',1193.000000000,'1962-08-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8760,'PROU','SOLANGE','1942-04-21','02.87.35.43.76','06.28.15.95.97',NULL,'2 CHEMIN DES BOIS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1420414197002',149.000000000,'1971-03-06','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8761,'RADIC','GHISLAINE','1959-04-26','02.58.11.90.76','06.31.65.52.35',NULL,'','','','14000','CAEN',NULL,NULL,'2590414589002',6.000000000,'1982-09-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8762,'BRIARD','MONIQUE','1961-12-23','02.44.10.51.38','06.90.42.69.81',NULL,'3 RUE DES PETITES CHASSES','','','14000','CAEN',NULL,NULL,'1611214118002',1133.000000000,'1984-07-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8763,'DENIAUX','JEAN','1957-06-12','02.50.23.41.02','06.71.92.70.53',NULL,'7 rue du paty','','','14970','BENOUVILLE',NULL,NULL,'1570614505002',1680.000000000,'1987-11-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8764,'BOSSARD','JACQUELINE','1930-01-06','02.22.31.74.32',NULL,NULL,'la grande bruyere','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'2300150468002',815.000000000,'1959-09-17','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8765,'THOMAS','PIERRE','1934-09-01','02.12.14.53.29','06.56.90.74.11',NULL,'LA BADERIE','','','14530','LUC SUR MER',NULL,NULL,'1340914569002',295.000000000,'1958-07-04','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8766,'LAMARE','SIMONE','1956-01-11','02.22.36.73.99','06.63.73.66.76',NULL,'4 rue du capitaine foucher','','','50700','VALOGNES',NULL,NULL,'1560114278002',142.000000000,'1979-10-31','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8767,'HUREL','BERNADETTE','1949-01-25','02.60.06.60.64','06.11.04.47.97',NULL,'5 ROUTE D''AUNAY LE MESNIL','','','14270','MEZIDON CANON',NULL,NULL,'1490150528002',677.000000000,'1979-01-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8768,'FOSSARD','PAULETTE','1931-08-24','02.52.56.69.77','06.12.33.21.97',NULL,'306 quartier de la grande delle','','','14000','CAEN',NULL,NULL,'2310822054002',32.000000000,'1955-04-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8769,'LANGEVIN','NICOLE','1938-04-28','02.41.75.18.02','06.25.62.20.44',NULL,'4 BD DES DENTELLIERES','','','14123','FLEURY SUR ORNE',NULL,NULL,'1380414617002',105.000000000,'1968-01-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8770,'HOTTIN','BERNARD','1933-08-31','02.55.08.58.02','06.41.87.38.46',NULL,'121 RUE DE LA GARENNE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2330850268002',400.000000000,'1956-04-13','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8771,'PIERRE','CHANTAL','1957-03-09','02.10.32.94.34','06.94.39.56.76',NULL,'18 RUE DU BOURG','','','14000','CAEN',NULL,NULL,'1570350111002',516.000000000,'1987-03-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8772,'DEKIEN','HERVE','1965-07-01','02.33.87.85.24','06.38.07.50.60',NULL,'2 RUE DES ACACIAS','','','14400','BAYEUX',NULL,NULL,'2650714121002',1254.000000000,'1987-08-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8773,'LUCET','MICHELINE','1930-03-31','02.10.14.53.45','06.23.13.93.75',NULL,'78 RUE ST MARTIN','','','14830','LANGRUNE SUR MER',NULL,NULL,'1300350037002',40.000000000,'1952-07-29','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8774,'LECOQ','PIERRETTE','1933-12-30','02.34.57.09.31','06.87.70.48.57',NULL,'23 RUE BRANVILLE','','','14000','CAEN',NULL,NULL,'1331214712002',43.000000000,'1954-07-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8775,'BEAU','PASCAL','1956-01-23','02.38.25.31.47','06.69.67.68.61',NULL,'5 rue des acacias','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2560114408002',794.000000000,'1984-10-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8776,'EDMOND','BRUNO','1935-08-03','02.31.03.13.30','06.62.31.41.01',NULL,'72. rue st clair','','',NULL,NULL,NULL,NULL,'1350814566002',104.000000000,'1961-12-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8777,'BESSELIEVRE','RAYMOND','1933-04-01','02.27.82.06.88','06.56.20.09.12',NULL,'664 route de canteloup','','','14140','LISORES',NULL,NULL,'2330414071002',8.000000000,'1960-08-13','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8778,'DAVID','LOUIS','1952-04-05','02.41.95.87.72','06.23.62.58.95',NULL,'207 chemin du mar','','','14190','SOIGNOLLES',NULL,NULL,'1520414118002',2977.000000000,'1981-03-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8779,'MAITRE','BERNARD','1954-06-04','02.55.82.73.96','06.11.25.51.23',NULL,'1 rue raguet','','','14370','ARGENCES',NULL,NULL,'1540614037002',6.000000000,'1982-08-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8780,'MARIE','MARIE HELENE','1958-01-27','02.42.44.87.35','06.31.86.71.32',NULL,'33 rue du petit valon','','','14000','CAEN',NULL,NULL,'2580114046002',269.000000000,'1982-04-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8781,'RADULPHE','MARTINE','1956-06-07','02.70.86.36.86','06.81.82.33.95',NULL,'24 rue du 8 mai 45','','','14460','COLOMBELLES',NULL,NULL,'1560614705002',15.000000000,'1985-11-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8782,'BARAN','FRANCE','1932-09-01','02.19.67.59.54','06.16.28.34.74',NULL,'3 RUE DES SCHISTES','','','14460','COLOMBELLES',NULL,NULL,'2320914048002',32.000000000,'1960-11-23','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8783,'BLAIZOT','jacques','1930-06-29','02.78.96.74.07',NULL,NULL,'5 rue du gros pommier','','','14980','ROTS',NULL,NULL,'1300614045002',28.000000000,'1951-09-04','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8784,'TOUBALEM','GERARD','1965-01-03','02.55.14.24.54','06.85.09.65.79',NULL,'17 PLACE ST CLAIR','','','50500','LES VEYS',NULL,NULL,'1650114623002',178.000000000,'1995-05-15','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8785,'LECOMTE','ALBERTINE','1936-05-08','02.47.30.03.26','06.64.81.64.48',NULL,'42 AVENUE DE L''HIPPODROME','','','14120','MONDEVILLE',NULL,NULL,'1360514714002',15.000000000,'1958-05-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8786,'GEORGES','VIOLETTE','1919-09-11','02.88.32.85.61','06.72.11.10.48',NULL,'CARREFOUR DE LA BOTTE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1190935352002',2671.000000000,'1944-05-15','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8787,'BUNEL','VIOLETTE','1967-11-20','02.95.10.88.99','06.38.06.70.98',NULL,'2 RUE PABLO PICASSO','','','14220','HAMARS',NULL,NULL,'1671114695002',1042.000000000,'1993-12-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8788,'FOUCHER','MARYLENE','1950-06-01','02.16.70.71.74',NULL,NULL,'','','','14460','COLOMBELLES',NULL,NULL,'1500614710002',1074.000000000,'1979-07-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8789,'FEREY','JEAN CLAUDE','1950-06-28','02.95.15.25.12','06.27.01.14.78',NULL,'11 elsa triolet','','','61200','FONTENAI SUR ORNE',NULL,NULL,'1500627149002',1942.000000000,'1972-08-21','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8790,'HOREL','BERNARD','1961-02-22','02.89.89.19.60','06.78.78.10.91',NULL,'40 rue de hautsvents','','','14150','OUISTREHAM',NULL,NULL,'2610261233002',55.000000000,'1988-04-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8791,'LESAGE','CLAUDINE','1956-01-16','02.11.48.60.25','06.54.53.25.48',NULL,'LES CROIX','','','14740','ST MANVIEU NORREY',NULL,NULL,'1560114278002',30.000000000,'1978-03-17','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8792,'LECONTE','JEAN','1931-07-01','02.65.51.03.47','06.10.43.99.02',NULL,'71 BD CHARLES POULLAIN','','','14260','AUNAY SUR ODON',NULL,NULL,'1310714597002',856.000000000,'1955-07-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8793,'BRIARD','OLIVIER','1958-09-17','02.92.57.00.87','06.76.58.27.43',NULL,'8 PLACE DES PEUPLIERS','','','14540','ROCQUANCOURT',NULL,NULL,'1580957137002',43.000000000,'1982-09-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8794,'MARIE','MARCEL','1956-10-11','02.11.19.14.58','06.63.55.49.70',NULL,'2 impasse du moulin de la fontai','ne','','14930','ETERVILLE',NULL,NULL,'1561061002002',1.000000000,'1978-08-17','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8795,'MOREL','JEAN CLAUDE','1939-05-02','02.83.42.62.09','06.66.99.63.09',NULL,'22 rue aux renards','','','14000','CAEN',NULL,NULL,'1390514150002',222.000000000,'1963-06-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8796,'LECARPENTIER','CLAIRE','1931-04-16','02.15.81.64.32','06.38.96.13.10',NULL,'20 RUE CHARLES GOUNOD','','','14120','MONDEVILLE',NULL,NULL,'1310414688002',134.000000000,'1955-01-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8797,'PERICOI','EMILIENNE','1948-10-12','02.72.71.79.95','06.68.37.17.09',NULL,'55 MOULIN DE   AVOIDE','','','14380','ST SEVER CALVADOS',NULL,NULL,'1481014180002',2291.000000000,'1978-05-26','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8798,'FORNENGO','REGINE','1931-11-19','02.91.60.81.66','06.46.92.29.35',NULL,'LE BAS HAMEL','','','14840','DEMOUVILLE',NULL,NULL,'2311114177002',96.000000000,'1956-03-06','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8799,'JEAN','PASCAL','1940-07-28',NULL,NULL,NULL,'3 RUE DU BOULHOULLAY','','','14250','FONTENAY LE PESNEL',NULL,NULL,'1400714584002',174.000000000,'1964-04-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8800,'GAULTIER','JEAN','1934-05-10','02.40.20.05.59','06.69.70.60.12',NULL,'14 RUE GAL VARAWOIT','','','14000','CAEN',NULL,NULL,'2340550151002',174.000000000,'1958-04-12','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8801,'NIASS','PAUL','1953-02-04','02.13.77.48.71','06.67.71.65.54',NULL,'29 BLVD DE REUTEL','','','50160','TORIGNI SUR VIRE',NULL,NULL,'2530214118002',520.000000000,'1979-06-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8802,'RADULPHE','michel','1928-02-20','02.60.89.83.06','06.11.73.26.50',NULL,'16 RUE CAMILLE BLAISOT','','','14000','CAEN',NULL,NULL,'2280250539002',162.000000000,'1958-06-19','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8803,'DUCREUX','MAURICE','1950-03-31','02.45.37.20.59','06.43.50.67.55',NULL,'19 rue saint constet','','','14150','OUISTREHAM',NULL,NULL,'2500353033002',32.000000000,'1980-08-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8804,'LAGARDE','LUCIE','1961-12-29',NULL,NULL,NULL,'37 rue michel lanes','','',NULL,NULL,NULL,NULL,'1611214118002',97.000000000,'1982-05-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8805,'VAUQUELIN','MARYLINE','1932-01-12','02.77.15.95.77','06.39.19.28.44',NULL,'28 rue camille blaizot','','','14120','MONDEVILLE',NULL,NULL,'2320120246002',158.000000000,'1953-12-12','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8806,'RICHARD','MICHEL','1932-07-12','02.73.54.16.25','06.54.82.74.00',NULL,'12 rue des surets','','','14940','SANNERVILLE',NULL,NULL,'2320714341002',803.000000000,'1959-07-19','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8807,'VIGOR','FERGUSON','1947-07-05','02.78.76.90.61','06.57.15.26.71',NULL,'8 avenue Pre Charles de Foucaul','t','',NULL,NULL,NULL,NULL,'2470714467002',4.000000000,'1969-03-23','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8808,'CHENU','SIMONE','1932-07-17','02.72.67.04.38','06.41.22.67.44',NULL,'VILLAGE MITRECAMP','','','14790','MOUEN',NULL,NULL,'2320714118002',142.000000000,'1956-10-02','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8809,'THURET','','1929-05-19','02.42.22.42.40','06.48.56.23.16',NULL,'4 IMPASSE GLORIEL','','','14500','ST GERMAIN DE TALLEVENDE',NULL,NULL,'2290514724002',1600.000000000,'1951-08-11','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8810,'COUESPEL','JEAN YVES','1929-04-26','02.20.20.63.32','06.13.58.96.92',NULL,'LA BRUYERE','','','14000','CAEN',NULL,NULL,'1290472058002',340.000000000,'1956-12-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8811,'MADELAINE','REGINE','1930-08-16','02.45.07.83.96','06.14.65.45.08',NULL,'1 rue de la mine','','','14000','CAEN',NULL,NULL,'1300814126002',932.000000000,'1951-04-23','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8812,'MOREL','Bernard','1937-10-17','02.24.79.29.26','06.82.87.95.77',NULL,'7 RUE DES PEUPLIERS LA VALLETTE','','',NULL,NULL,NULL,NULL,'1371014330002',10.000000000,'1958-12-21','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8813,'LUCET','CLAUDE','1971-08-08','02.11.07.78.44','06.69.70.29.49',NULL,'les cinq fermes','','','14220','CROISILLES',NULL,NULL,'2710899253002',305.000000000,'1992-08-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8814,'COSSON','JEANNINE','1930-04-06','02.81.24.41.38','06.82.02.22.72',NULL,'23, rue de la Grange Guesnon','','','14000','CAEN',NULL,NULL,'2300461146002',102.000000000,'1952-06-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8815,'HUET','NICOLE','1952-01-22','02.66.59.24.35','06.46.80.62.27',NULL,'1 TER RUE DE LA CROIX BOISSEE','','','61100','LA SELLE LA FORGE',NULL,NULL,'2520114301002',156.000000000,'1982-12-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8816,'CHABLAIN','BERNARD','1951-07-29','02.23.70.09.82','06.60.20.29.80',NULL,'10 rue de casino','','','14840','DEMOUVILLE',NULL,NULL,'2510714721002',4813.000000000,'1980-08-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8817,'HANIN','ISABELLE','1929-12-17','02.23.67.45.35','06.63.22.21.95',NULL,'RUE DES ECOLES 1533 ROUTE DE BA','LLEROY','','14000','CAEN',NULL,NULL,'2291250077002',200.000000000,'1951-03-20','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8818,'GUINE','MARCEL','1947-05-23','02.46.29.98.81','06.87.81.78.26',NULL,'12 CHEMIN DES LONGS FOULINS','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1470561287002',14.000000000,'1977-12-19','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8819,'L HOPITAL BURDIN','Gisele','1939-02-22','02.69.62.70.94','06.90.29.01.45',NULL,'','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'2390250639002',26.000000000,'1961-04-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8820,'','MYRIAM','1930-01-30','02.48.95.12.04','06.43.60.43.68',NULL,'9 RUE DE L''EGLISE','','','14220','THURY HARCOURT',NULL,NULL,'1300153053002',67.000000000,'1953-08-30','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8821,'BALACKI','MARTINE','1959-10-09','02.17.46.04.15','06.10.73.53.48',NULL,'9 rue de balleroy','','','14123','IFS',NULL,NULL,'1591061334002',34.000000000,'1987-07-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8822,'FOUQUES','PIERRE','1958-01-02','02.33.03.10.56','06.45.86.78.63',NULL,'14 rue de la liberation','','','14000','CAEN',NULL,NULL,'2580114277002',249.000000000,'1985-03-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8823,'CHEREAU','JACKY','1938-03-10','02.84.35.18.96','06.17.11.76.60',NULL,'5 SQUARE ROBERT DE MORTAIN','','','14260','AUNAY SUR ODON',NULL,NULL,'1380314167002',20.000000000,'1959-06-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8824,'LEROY','BRUNO','1936-05-08','02.10.77.07.92','06.71.07.69.01',NULL,'7 RUE PAUL ELUARD','','','50700','BRIX',NULL,NULL,'2360514251002',93.000000000,'1958-09-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8825,'BRIARD','','1937-03-07','02.21.47.05.63','06.32.99.14.01',NULL,'','','','14240','CAHAGNES',NULL,NULL,'1370350464002',407.000000000,'1963-04-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8826,'FOURREY','Serge','1930-06-06','02.38.62.35.29','06.53.37.87.85',NULL,'l institut camille blaisot 6 ru','e vaux de la folie','',NULL,NULL,NULL,NULL,'1300614271002',66.000000000,'1954-12-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8827,'DUMELON','Claudine','1929-06-11','02.71.08.00.98','06.93.50.39.89',NULL,'4 RUE DU COLOMBIER','','','14540','BOURGUEBUS',NULL,NULL,'1290614489002',226.000000000,'1953-10-22','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8828,'PIMOR','JACQUES','1931-09-14','02.82.91.48.65','06.88.78.03.41',NULL,'9 RUE DU PETIT SEMILLON','','','14123','IFS',NULL,NULL,'1310914328002',33.000000000,'1961-04-15','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8829,'BOUVIER','PAULETTE','1942-11-30','02.36.27.84.79','06.15.87.40.75',NULL,'3 RUE AMBROISE CROIZAT','','','14990','BERNIERES SUR MER',NULL,NULL,'2421178362002',73.000000000,'1964-04-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8830,'CATHERINE','MARIE NOELLE','1940-03-09','02.16.46.87.61','06.31.95.58.10',NULL,'','','','14123','IFS',NULL,NULL,'2400314309002',38.000000000,'1970-03-17','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8831,'GUENIER','AUGUSTE','1961-04-11','02.56.05.01.38','06.10.47.26.22',NULL,'17 RUE NICOLAS ORESME','','','14000','CAEN',NULL,NULL,'2610461513002',9.000000000,'1987-05-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8832,'LEMASSON','GILBERTE','1930-05-22','02.70.53.86.83','06.87.65.69.25',NULL,'3 AVENUE DU GENERAL LECLERC','','','14150','OUISTREHAM',NULL,NULL,'1300514338002',741.000000000,'1953-02-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8833,'LEDENTU','LILIANE','1969-11-06','02.23.49.63.64','06.81.41.50.73',NULL,'73 RUE DU GENERAL MOULIN','','','14520','STE HONORINE DES PERTES',NULL,NULL,'1691114685002',834.000000000,'1993-10-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8834,'DESLOGES','SIMONE','1956-01-23','02.25.64.10.00','06.69.70.75.75',NULL,'12 RUE D''URVILLE','','','14150','OUISTREHAM',NULL,NULL,'1560114431002',604.000000000,'1979-04-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8835,'MATUSIAK','CHANTAL','1930-09-11','02.57.35.32.52','06.26.27.59.24',NULL,'17 rue robert letellier','','','14740','LE MESNIL PATRY',NULL,NULL,'2300914039002',2754.000000000,'1954-06-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8836,'LAURENT','CHRISTIANE','1944-02-22','02.93.16.34.57','06.78.37.04.04',NULL,'9 RUE GUY DE MAUPASSANT','','','50800','FLEURY',NULL,NULL,'1440273067002',88.000000000,'1970-12-18','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8837,'VARIN','LUCIENNE','1969-05-02',NULL,NULL,NULL,'106 RUE EMMANUEL LIAIS','','','61200','ARGENTAN',NULL,NULL,'1690514111002',2.000000000,'1996-09-19','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8838,'GAUTHIER','GHISLAINE','1946-02-27','02.84.55.26.40','06.68.16.00.77',NULL,'LE BOURG','','','14460','COLOMBELLES',NULL,NULL,'2460214288002',19.000000000,'1973-03-22','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8839,'PERTEQUIN','ESTELLE','1951-03-10','02.81.80.65.91','06.66.99.26.84',NULL,'8 LES BIBEAUX','','','14470','COURSEULLES SUR MER',NULL,NULL,'1510314158002',23.000000000,'1979-09-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8840,'HOUEL','DANIEL','1955-05-29','02.11.58.74.96',NULL,NULL,'zone industrielle des martray','','','14450','GRANDCAMP MAISY',NULL,NULL,'1550541255002',737.000000000,'1982-05-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8841,'GLEYZES','LEONE','1959-04-26','02.45.53.39.59','06.98.83.68.37',NULL,'RUE LA COMMANDERIE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2590450527002',300.000000000,'1981-07-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8842,'BRENAC','MARIE NOELLE','1959-04-26','02.10.86.62.28','06.11.91.90.32',NULL,'13 RUE DE L EGLISE','','',NULL,NULL,NULL,NULL,'2590450527002',15.000000000,'1982-11-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8843,'OZANNE','MICHEL','1935-04-24','02.83.88.53.76','06.61.71.71.11',NULL,'6 ROUTE PONT ROGER','','','50310','EMONDEVILLE',NULL,NULL,'1350450129002',28.000000000,'1958-07-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8844,'LEBLANC','CLAUDE','1933-08-16','02.39.89.89.88','06.11.74.52.80',NULL,'1 rue de mortemer','','','14120','MONDEVILLE',NULL,NULL,'1330888165002',1063.000000000,'1957-09-09','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8845,'CARDINE','HUGUETTE','1930-02-22','02.63.44.65.91','06.31.50.99.00',NULL,'34 rue de  l''eglise','','','14750','ST AUBIN SUR MER',NULL,NULL,'1300214277002',604.000000000,'1959-03-07','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8846,'DESSOLIERS','ROGER','1943-11-20','02.69.74.47.99',NULL,NULL,'LA COUR VALLIER','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2431114587002',8.000000000,'1966-05-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8847,'JARDIN','CLAUDE','1955-06-25','02.11.84.56.24','06.76.55.02.14',NULL,'30 RUE ANDRE HALBOUT','','','14000','CAEN',NULL,NULL,'1550614042002',61.000000000,'1977-11-16','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8848,'HERBINIERE','MAURICETTE','1928-06-23','02.32.33.44.36','06.73.35.12.68',NULL,'91 avenue charlemagne','','','14500','VIRE',NULL,NULL,'2280614092002',706.000000000,'1950-06-17','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8849,'DELACOUR','DAVID','1942-03-15','02.62.44.84.99','06.11.03.37.16',NULL,'LE CALVAIRE','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1420314277002',10.000000000,'1971-12-21','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8850,'DOINARD','MICHEL','1929-07-13','02.81.61.29.31','06.58.54.57.15',NULL,'156 rue branville','','','14000','CAEN',NULL,NULL,'1290761504002',58.000000000,'1950-03-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8851,'','THERESE','1942-05-31','02.53.68.23.39','06.59.65.02.05',NULL,'18 ROUTE DE LA FORGETTE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1420514409002',17.000000000,'1971-08-09','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8852,'WUILLOT','JACQUES','1968-04-25','02.78.67.14.37','06.86.20.86.17',NULL,'rue de Bretagne','','',NULL,NULL,NULL,NULL,'1680414431002',12.000000000,'1994-11-27','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8853,'CERQUANT','JANINE','1956-01-06','02.96.27.96.33','06.32.09.19.35',NULL,'le champ manoury','','',NULL,NULL,NULL,NULL,'1560114715002',885.000000000,'1984-10-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8854,'TIRADR','MONIQUE','1933-12-17','02.10.18.62.25','06.24.87.87.56',NULL,'2 rue de le pomme d''or','','','14540','ROCQUANCOURT',NULL,NULL,'1331278197002',1338.000000000,'1957-01-24','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8855,'DUBOIS','ANDRE',NULL,'02.53.68.02.68','06.81.86.63.66',NULL,'32 rte de caen','','','14123','IFS',NULL,NULL,'2331150137002',393.000000000,'2011-03-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8856,'MORICE','PASCAL','1938-08-15','02.90.10.89.84','06.68.36.11.70',NULL,'','','',NULL,NULL,NULL,NULL,'2380814366002',169.000000000,'1966-05-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8857,'FRITSCHE','SYLVIE','1965-03-05','02.10.86.66.34','06.46.55.25.29',NULL,'2 allee dardenne','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'2650361063002',225.000000000,'1995-10-12','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8858,'ISSAMBOURG','PIERRE','1941-12-04','02.75.39.91.85','06.89.79.16.50',NULL,'12 rue du marechal leclerc','','','14120','MONDEVILLE',NULL,NULL,'2411214118002',60.000000000,'1965-10-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8859,'SOYER','THIERRY','1932-03-12','02.60.23.23.35','06.58.78.61.31',NULL,'3 AVENUE SAINT MICHEL','','','14780','LION SUR MER',NULL,NULL,'1320361153002',174.000000000,'1954-10-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8860,'MARAIS','ROXANNE','1938-01-06',NULL,NULL,NULL,'','','','14210','CHEUX',NULL,NULL,'2380178227002',132.000000000,'1968-07-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8861,'ANGELIQUE','JACQUELINE','1958-10-31','02.34.86.19.13','06.50.58.40.11',NULL,'11 RUE DU BAC DU PORT','','','76000','ROUEN',NULL,NULL,'1581050119002',19.000000000,'1987-10-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8862,'BIRON','GERARD','1934-08-30','02.60.59.39.11','06.31.35.04.70',NULL,'153 RUE DE BEAULIEU','','','61200','ARGENTAN',NULL,NULL,'1340814753002',649.000000000,'1961-08-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8863,'LEGOFF','CHRISTINE','1964-09-11','02.34.27.48.01','06.23.76.24.68',NULL,'45 rue de la bastille','','','14120','MONDEVILLE',NULL,NULL,'1640914158002',30.000000000,'1988-02-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8864,'LAMY','PIERRE','1964-09-08','02.68.22.36.83','06.75.46.35.53',NULL,'route de la chapelle les forges',' de clermont','','50680','CERISY LA FORET',NULL,NULL,'1640914158002',50.000000000,'1986-01-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8865,'ROBINE','MADELAINE','1963-04-29','02.94.46.82.98','06.52.23.05.18',NULL,'9 la delle du grand champ','','',NULL,NULL,NULL,NULL,'2630414057002',127.000000000,'1987-08-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8866,'LEFLOCH','ODETTE','1965-02-11','02.19.01.81.78','06.86.26.97.33',NULL,'99 rue des acacias','','','14270','MEZIDON CANON',NULL,NULL,'2650236044002',1405.000000000,'1988-03-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8867,'LEPIOUFFE','J PIERRE','1965-03-01','02.95.95.47.45','06.11.99.37.76',NULL,'141 boulevard carnot','','','14460','COLOMBELLES',NULL,NULL,'2650376179002',40.000000000,'1987-05-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8868,'BONHEM','ROBERT','1962-06-14','02.50.26.37.54','06.19.22.84.52',NULL,'11.1 rue des champs fleuris','','','14670','ST PAIR',NULL,NULL,'1620614458002',32.000000000,'1984-01-21','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8869,'GASCOIN','ANNIE','1929-05-18','02.76.21.15.84','06.75.10.30.02',NULL,'LE CAMP DE PIE 109 RUE DES BUCAR','DE','','14790','VERSON',NULL,NULL,'2290527207002',585.000000000,'1952-02-07','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8870,'SCHIER','GISELE','1939-12-17','02.85.68.92.12','06.55.73.78.36',NULL,'6 RUE ETIENNE VERVISCH','','','14000','CAEN',NULL,NULL,'1391250407002',310.000000000,'1963-06-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8871,'PAIN','ALAIN','1932-02-13','02.28.32.85.05','06.46.27.31.82',NULL,'35 avenue pasteur','','','61200','ARGENTAN',NULL,NULL,'1320235308002',160.000000000,'1953-03-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8872,'L''EQUILBECQ','CLAUDE','1934-07-03','02.10.47.39.43','06.80.89.18.29',NULL,'LE BOURG','','','14880','HERMANVILLE SUR MER',NULL,NULL,'1340750044002',72.000000000,'1958-07-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8873,'BIDARD','GUY',NULL,'02.10.94.35.58','06.28.79.44.29',NULL,'notre dame de fresnay','','','14000','CAEN',NULL,NULL,'2300950202002',1600.000000000,'2008-09-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8874,'BAUDRY','PIERRE','1930-09-14','02.12.01.83.19','06.90.68.82.35',NULL,'18 PLACE DES ANCIENNES BOUCHERIE','S','','14000','CAEN',NULL,NULL,'2300950202002',2949.000000000,'1951-07-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8875,'GONTIER','MARIE THERESE','1956-02-25','02.43.92.55.04','06.17.65.79.34',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'1560214341002',117.000000000,'1985-05-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8876,'MAUDUIT','Bernadette','1935-09-27','02.16.90.16.93','06.76.20.64.72',NULL,'124 BIS RUE DE FALAISE','','','14210','AMAYE SUR ORNE',NULL,NULL,'1350914431002',608.000000000,'1957-01-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8877,'PRIGENT','PHILIPPE','1938-07-31','02.18.69.77.98','06.59.12.68.73',NULL,'FLAUGNY','','',NULL,NULL,NULL,NULL,'1380750400002',839.000000000,'1967-05-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8878,'AUBREE','MARIE LOUISE','1956-11-11','02.48.70.00.24','06.26.75.78.83',NULL,'1 RUE DES PINSONS','','',NULL,NULL,NULL,NULL,'1561114118002',2302.000000000,'1977-01-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8879,'DEBEAUPTE','AURELIA','1948-01-04','02.47.93.05.42','06.73.07.64.99',NULL,'13 RUE DES 6 ACRES','','','14120','MONDEVILLE',NULL,NULL,'1480114090002',356.000000000,'1969-04-21','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8880,'LE MER','PASCAL','1968-02-08','02.46.00.15.96','06.45.37.62.04',NULL,'3 rue fresnel','','','14120','MONDEVILLE',NULL,NULL,'2680214123002',399.000000000,'1992-03-03','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8881,'FOUCHER','ANNICK','1957-12-27','02.14.00.58.72','06.76.94.34.28',NULL,'','','','14310','MAISONCELLES PELVEY',NULL,NULL,'2571214359002',19.000000000,'1987-08-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8882,'LEMUTRECY','GERARD','1954-09-26','02.10.66.33.06','06.11.00.37.37',NULL,'19 RUE DES PRES','','','14450','GRANDCAMP MAISY',NULL,NULL,'1540914218002',102.000000000,'1980-08-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8883,'BOSQUET','CLAIRE','1959-01-05','02.50.73.00.34','06.20.03.29.21',NULL,'27 RUE DE COIGNY','','','14120','MONDEVILLE',NULL,NULL,'2590114637002',437.000000000,'1983-01-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8884,'LAURENT','laurent','1958-06-06','02.18.56.72.63','06.94.25.38.57',NULL,'7 IMPASSE ALBERT CAMUS','','',NULL,NULL,NULL,NULL,'1580614306002',78.000000000,'1982-05-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8885,'TORCHY','REMY','1938-04-12','02.10.71.85.85','06.51.14.57.46',NULL,'','','','50500','MEAUTIS',NULL,NULL,'2380461233002',370.000000000,'1965-03-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8886,'CATHERINE','GINETTE','1943-08-17','02.45.26.12.38','06.26.15.28.27',NULL,'4 RUE DES FONTAINES "HAMEAU SAM','SON"','','14123','IFS',NULL,NULL,'2430814319002',129.000000000,'1967-03-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8887,'LEGUAY','DANIEL','1938-01-08','02.14.95.37.24','06.37.35.06.05',NULL,'rue du 20eme sicle','','','14270','MEZIDON CANON',NULL,NULL,'1380150159002',10.000000000,'1965-10-03','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8888,'GUILLAUME','JOSEPH','1945-03-09','02.95.47.84.90','06.75.11.07.68',NULL,'12 ROUTE DE BARBERY','','','50680','AIREL',NULL,NULL,'1450314509002',570.000000000,'1966-10-11','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8889,'LAUNAY','GISELE','1937-12-04','02.51.60.40.80','06.77.31.64.63',NULL,'810 PONT DE CALIX','','',NULL,NULL,NULL,NULL,'2371227037002',194.000000000,'1959-05-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8890,'MADELAINE','MARTINE','1956-04-02','02.87.80.30.30','06.79.06.72.35',NULL,'2 RUE EMILE MAUGUIN','','','14123','IFS',NULL,NULL,'2560414461002',36.000000000,'1978-12-31','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8891,'LELOUEY','ROSY',NULL,'02.16.69.39.24','06.36.75.76.11',NULL,'24 AVENUE PIERRE 1ER DE SERBIE','','','14520','STE HONORINE DES PERTES',NULL,NULL,'1511061210002',548.000000000,'2008-10-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8892,'KOKINOS','MARTINE','1959-03-19','02.20.70.95.20','06.43.76.70.32',NULL,'15 CITE JARDIN','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2590327616002',627.000000000,'1982-05-23','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8893,'LEROY','JEAN','1964-11-18','02.39.02.71.97','06.11.42.95.20',NULL,'2 RUE EMILE MAUGUIN','','','14630','CAGNY',NULL,NULL,'2641175005002',38.000000000,'1991-02-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8894,'LOUTREUIL','DIDIER','1950-01-09','02.56.77.97.15','06.33.87.85.75',NULL,'14 rue de saintonge','','','14000','CAEN',NULL,NULL,'2500127285002',11.000000000,'1978-08-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8895,'PICHARD','DANIEL','1937-05-19','02.57.98.08.49','06.11.86.29.38',NULL,'11 rue paul langevin','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1370550083002',99.000000000,'1962-04-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8896,'ENGUERRAND','MIREILLE','1931-10-20','02.17.67.28.56','06.30.75.59.42',NULL,'22 RUE DU QUEBEC','','','14730','GIBERVILLE',NULL,NULL,'1311050510002',91.000000000,'1955-01-16','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8897,'PEILLEX','MICHEL','1934-02-06','02.14.21.73.15','06.22.23.89.61',NULL,'27 ALLEE DES POETES','','','14123','IFS',NULL,NULL,'2340214635002',363.000000000,'1958-06-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8898,'BERDU','MARIE-JOSEPHE','1949-07-05','02.14.22.74.33',NULL,NULL,'12 RUE DE SUEDE','','','14120','MONDEVILLE',NULL,NULL,'1490714648002',190.000000000,'1975-08-09','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8899,'POULEN','JEAN LOUIS','1939-04-07','02.59.76.66.22','06.58.66.21.74',NULL,'1 av marechal joffre','','','14120','MONDEVILLE',NULL,NULL,'2390414370002',563.000000000,'1960-06-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8900,'BAZIN','VERONIQUE','1959-02-25','02.44.73.42.44','06.10.38.17.38',NULL,'2 RUE DU 20 SIECLE','','','14540','BOURGUEBUS',NULL,NULL,'2590214257002',298.000000000,'1986-08-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8901,'JAMONT','ODETTE','1947-03-02','02.56.39.44.65','06.72.43.12.30',NULL,'66 RUE ARMAND MARIE','','','14850','HEROUVILLETTE',NULL,NULL,'1470314140002',1364.000000000,'1977-01-29','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8902,'REIGNER','GEORGES','1965-04-15','02.82.18.39.89','06.36.97.59.32',NULL,' 845 rue mac farlane mouen','','','61500','SEES',NULL,NULL,'2650414036002',19.000000000,'1987-05-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8903,'HEBERT','JEAN CLAUDE','1950-01-24','02.54.84.26.51','06.66.25.89.03',NULL,'6 RUE DU DOMAINE','','','14240','ANCTOVILLE',NULL,NULL,'2500153253002',3210.000000000,'1972-04-14','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8904,'CROIX','JEAN ANDRE','1941-03-24','02.10.75.55.18','06.23.42.14.76',NULL,'33 RUE HAUTE','','','14610','EPRON',NULL,NULL,'1410314730002',180.000000000,'1962-12-24','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8905,'ROY','ERICK','1935-01-08','02.56.11.36.51','06.40.01.87.59',NULL,'6 rue sallengro','','','14000','CAEN',NULL,NULL,'2350114711002',409.000000000,'1960-01-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8906,'CHALLIOT','LOUISE','1952-06-05','02.58.22.38.17','06.93.78.97.53',NULL,'4 RUE DE WESENDORF','','','14710','TREVIERES',NULL,NULL,'1520614125002',61.000000000,'1973-01-14','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8907,'DAVE','RAYMONDE','1948-05-06','02.52.49.26.51','06.72.27.63.82',NULL,'6 rue du domaine','','','14310','AMAYE SUR SEULLES',NULL,NULL,'2480522341002',26.000000000,'1969-11-03','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8908,'BERNIER','PATRICE','1932-04-24','02.35.62.80.56','06.11.28.94.88',NULL,'2 rue du puplier','','','14120','MONDEVILLE',NULL,NULL,'2320461156002',1503.000000000,'1956-02-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8909,'VILLEROY','HENRI','1944-08-25','02.29.57.63.11','06.74.30.96.11',NULL,'7 RUE DU PLAIN DU ROY','','','14120','MONDEVILLE',NULL,NULL,'2440814199002',36.000000000,'1967-05-14','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8910,'GOUPIL','BERNARD','1938-07-28','02.69.27.41.47','06.79.66.51.06',NULL,'4 RUE MICHEL CABIEU','','','14370','CHICHEBOVILLE',NULL,NULL,'2380714669002',222.000000000,'1962-12-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8911,'TRANSON','ROGER','1936-04-29','02.46.32.85.19','06.89.00.15.94',NULL,'8 rue mac mahon','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2360440201002',1880.000000000,'1958-12-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8912,'FAUCHON','MARCEL','1942-01-11','02.80.75.87.13','06.40.14.32.34',NULL,'23 BASSE RUE','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'2420141101002',81.000000000,'1968-06-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8913,'CORMIER','alfred','1939-12-23','02.42.93.08.50','06.90.05.04.39',NULL,'LA TOUCHE','','','14000','CAEN',NULL,NULL,'2391250198002',83.000000000,'1961-09-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8914,'QUESNEL','PATRICIA','1937-02-17','02.11.50.94.41','06.11.61.04.03',NULL,'50 RUE DU NEUBOURG','','','14540','GRENTHEVILLE',NULL,NULL,'1370214515002',100.000000000,'1960-10-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8915,'PERONNE','pierre','1937-04-28','02.22.54.09.55','06.12.09.26.87',NULL,'8 RUE VICTOR HUGO','','','14160','DIVES SUR MER',NULL,NULL,'1370450639002',163.000000000,'1964-10-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8916,'TIREL','FRANCIS','1951-03-22','02.43.12.00.35','06.66.68.22.63',NULL,'18 CHAUSSEE ROMAINE','','','14000','CAEN',NULL,NULL,'1510314352002',130.000000000,'1979-06-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8917,'FOULON','MARCEL','1935-12-20','02.25.63.09.14','06.86.53.29.25',NULL,'RUE PAUL CLAUDEL','','','61430','MENIL HUBERT SUR ORNE',NULL,NULL,'2351209194002',9.000000000,'1959-12-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8918,'LOHBRUNNER','PASCAL','1954-07-23','02.79.97.52.48','06.64.59.00.87',NULL,'5 RUE DU ROCHER','','','14370','ARGENCES',NULL,NULL,'2540714125002',355.000000000,'1983-09-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8919,'LEROUVILLOIS','YVONNE','1958-03-26','02.47.48.44.43','06.52.02.10.36',NULL,'10 RUE LUCIEN ROPARS','','','50400','GRANVILLE',NULL,NULL,'2580350260002',204.000000000,'1979-02-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8920,'LECANNELIE','MONIQUE','1941-07-01','02.29.90.35.70','06.92.26.62.41',NULL,'5 ALLEE DE LA MER','','','14220','HAMARS',NULL,NULL,'1410728181002',44.000000000,'1962-09-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8921,'HOLLEY','JEAN','1957-03-27','02.41.79.92.12','06.27.41.87.24',NULL,'23 RUE DE L''AUBEPINE','','','14220','COMBRAY',NULL,NULL,'2570314666002',529.000000000,'1981-11-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8922,'ZENIER','GERARD','1967-01-29','02.52.87.86.14','06.20.91.44.94',NULL,'MEHEUDIN','','','14610','ANISY',NULL,NULL,'2670114076002',152.000000000,'1991-03-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8923,'LECONTE','THIERRY','1944-05-20','02.11.73.52.33','06.53.28.61.10',NULL,'10 RUE VAL HUBERT','','','14370','BELLENGREVILLE',NULL,NULL,'2440514383002',42.000000000,'1968-01-12','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8924,'GOSSELIN','FABIENNE','1937-02-03','02.62.61.93.81','06.15.37.25.80',NULL,'1 BIS CHEMIN DU LONG BOIS','','','14260','AUNAY SUR ODON',NULL,NULL,'2370235256002',1324.000000000,'1959-04-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8925,'PRAT','JEAN BERNA','1962-01-19','02.13.07.80.93','06.12.30.88.69',NULL,'Rsidence Normandie 2 Be rue Em','ilie Zola','','14250','TILLY SUR SEULLES',NULL,NULL,'2620129019002',486.000000000,'1986-04-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8926,'LEGRANDOIS','ALAIN','1966-07-01','02.87.14.47.86','06.13.72.31.91',NULL,'2 RUE DE CAEN','','','14220','THURY HARCOURT',NULL,NULL,'2660714254002',27.000000000,'1994-05-07','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8927,'MARIE','JEAN CLAUDE','1932-06-13','02.10.52.14.92','06.22.31.57.57',NULL,'1 RUE DU VAL CLAIR','','','14570','ST LAMBERT',NULL,NULL,'1320614009002',42.000000000,'1957-03-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8928,'BOUVILLE','REGINE','1955-03-28','02.47.41.91.66','06.63.59.02.68',NULL,'30 CHEMIN DE LA MULOTIERE','','','14990','BERNIERES SUR MER',NULL,NULL,'1550314164002',112.000000000,'1977-02-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8929,'','JOSETTE','1944-02-19','02.66.89.78.83','06.94.47.84.27',NULL,'RES LE PARC ST CLAIR 12.03 GRAN','DE DELLE','','14790','MOUEN',NULL,NULL,'1440261349002',19.000000000,'1965-03-09','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8930,'GUERIN','HELENE','1953-11-23','02.39.04.33.59','06.17.83.14.32',NULL,'61 RUE ERNEST  MANCHON','','','50500','ST HILAIRE PETITVILLE',NULL,NULL,'1531114450002',2859.000000000,'1979-09-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8931,'DANGLEHANT','WILLIAM','1930-05-14','02.30.88.06.77','06.10.96.83.84',NULL,'1 RUE A CAMUS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1300514225002',1059.000000000,'1954-06-14','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8932,'PREVEL','MONIQUE','1961-05-20','02.75.10.77.61','06.10.56.29.69',NULL,'14 ROGER DUPONT','','','14860','BAVENT',NULL,NULL,'1610514278002',1766.000000000,'1986-01-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8933,'LALAISON','JULIETTE','1949-02-06','02.63.79.08.90','06.40.91.22.21',NULL,'154 BOULEVARD LEROY','','','14123','FLEURY SUR ORNE',NULL,NULL,'2490250632002',40.000000000,'1971-02-19','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8934,'','LAURA','1950-02-13','02.41.07.67.97','06.87.99.37.16',NULL,'1 RUE DU LOUP PENDU','','','61440','ST ANDRE DE MESSEI',NULL,NULL,'2500214266002',93.000000000,'1973-04-25','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8935,'GUERIN','PATRICK','1965-01-20','02.25.83.27.58','06.46.45.25.35',NULL,'15 RTE DE PARIS','','','14370','BISSIERES',NULL,NULL,'1650114623002',383.000000000,'1995-07-07','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8936,'GUERIN','ELISABETH','1969-10-31','02.51.15.52.30','06.72.71.84.86',NULL,'8 RUE ALFRED NOBEL','','','50440','GREVILLE HAGUE',NULL,NULL,'1691014137002',105.000000000,'1996-03-06','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8937,'LEMONNIER','FRANCOISE','1930-03-11','02.97.22.61.51','06.10.63.62.92',NULL,'','','','14470','COURSEULLES SUR MER',NULL,NULL,'1300333544002',5.000000000,'1956-08-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8938,'VAL','FERNAND','1932-05-13','02.35.21.97.59','06.32.47.91.35',NULL,'11 rue maurice lafont','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'2320550497002',9.000000000,'1954-07-09','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8939,'BISSON','PASCAL','1941-05-13','02.10.86.00.46','06.62.63.24.93',NULL,'29 bvd de rethel','','','50390','ORGLANDES',NULL,NULL,'1410514164002',851.000000000,'1963-11-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8940,'RICHARD','EUGENE','1937-07-05','02.76.27.72.79','06.37.54.90.38',NULL,'25 RUE EDMOND MICHELET','','','14123','IFS',NULL,NULL,'1370714158002',316.000000000,'1967-10-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8941,'ROSE','FRANCIS','1937-07-18','02.52.77.24.92','00 33 6.57.33.11.22',NULL,'51 bis rue caponniere','','','14260','ONDEFONTAINE',NULL,NULL,'1370714158002',33.000000000,'1960-10-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8942,'BATTEUR','ROGER','1956-08-09','02.11.12.18.95','06.59.47.94.88',NULL,'13 allee de l''alberta appt 11','','','14370','ARGENCES',NULL,NULL,'2560850284002',1749.000000000,'1985-09-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8943,'FOUCHER','CLAUDETTE','1960-03-26','02.10.51.85.26','06.36.92.61.20',NULL,'23 RUE DE L''AUBEPINE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1600314074002',717.000000000,'1986-02-01','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8944,'BESNARD','MARCEL','1937-09-17','02.10.15.27.70','06.76.37.66.45',NULL,'village tot','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'2370961479002',454.000000000,'1963-08-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8945,'PELCERF','NICOLE','1936-08-18','02.76.45.73.97','06.71.38.89.57',NULL,'LE CLOS JOUAN','','','14123','IFS',NULL,NULL,'1360814266002',277.000000000,'1959-05-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8946,'TOUDIC','Janine','1947-01-14','02.77.66.06.08','06.82.13.32.11',NULL,'26 RUE THERESE DE LA VARDE','','','61160','NECY',NULL,NULL,'2470114712002',778.000000000,'1974-06-26','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8947,'BOUCEY','Leon','1950-07-02','02.39.58.08.51','06.82.30.45.48',NULL,'LA VALDIELE','','','14150','OUISTREHAM',NULL,NULL,'1500714006002',1250.000000000,'1974-11-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8948,'BLONDIN','GERARD','1966-11-21','02.10.93.54.53','06.67.84.07.62',NULL,'341 chemin du val','','','14540','BOURGUEBUS',NULL,NULL,'1661114431002',59.000000000,'1990-08-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8949,'MICHON','THERESE','1941-09-25','02.75.41.85.88','06.41.66.72.14',NULL,'24 RUE DU PONT ROSSIGNOL','','','14370','ARGENCES',NULL,NULL,'1410914096002',1649.000000000,'1970-10-24','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8950,'DUCREUX','DANIELE','1938-03-07','02.46.60.03.46','06.19.18.77.86',NULL,'4 ROUTE DE ST CLAIR','','','14540','HUBERT FOLIE',NULL,NULL,'1380341269002',78.000000000,'1965-11-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8951,'LECORNU','GUY',NULL,'02.51.07.61.12','06.26.50.30.89',NULL,'6 RUE ROGER SALENGRO','','','14280','ST CONTEST',NULL,NULL,'2520114228002',32.000000000,'2012-08-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8952,'MARIE','JACQUELINE','1932-02-17','02.89.81.21.75','06.43.06.74.70',NULL,'32 RUE PASTEUR','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2320214039002',187.000000000,'1959-11-20','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8953,'QUINONES','GILBERT','1960-06-30','02.70.69.21.47','06.57.29.35.58',NULL,'4 rue coubet','','','61430','BERJOU',NULL,NULL,'2600680572002',629.000000000,'1990-10-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8954,'TALVAST','VIVIANE','1958-03-29','02.45.95.04.24','06.35.45.70.69',NULL,'8 RUE DE CHAMPAGNE','','','14630','FRENOUVILLE',NULL,NULL,'1580314195002',126.000000000,'1981-04-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8955,'MARIE','MICHEL','1936-05-19','02.42.16.96.51','06.52.67.41.89',NULL,'5 IMPASSE DES CHAMPS','','','14220','TOURNEBU',NULL,NULL,'2360514117002',112.000000000,'1963-03-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8956,'COLLIN','RENEE','1960-02-15','02.43.64.91.54','06.20.08.91.44',NULL,'10 RUE DE VILLIERS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2600214026002',4.000000000,'1982-05-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8957,'POUCHIN','LILIANE','1934-03-05','02.69.82.93.18','06.95.72.94.16',NULL,'10 rue chemin du fort','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2340361168002',508.000000000,'1958-11-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8958,'COLLIN','GILBERT','1964-08-04','02.72.79.43.20','06.47.33.12.97',NULL,'','','','14470','COURSEULLES SUR MER',NULL,NULL,'2640814319002',212.000000000,'1994-05-22','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8959,'ANDRE','MURIELLE','1933-03-03','02.71.83.57.61','06.37.48.90.09',NULL,'1 ALLEE DE LA BICHOTTE','','','14460','COLOMBELLES',NULL,NULL,'2330314233002',1244.000000000,'1963-07-10','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8960,'EYRAUD','JEAN PIERRE','1929-08-07','02.14.10.52.71','06.85.50.75.47',NULL,'6 PLACE DE LA BASILIQUE BP29','','','14670','TROARN',NULL,NULL,'1290814743002',335.000000000,'1953-03-04','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8961,'MEKSHI','MARIE ROSE','1949-07-31','02.80.21.76.08','06.11.19.94.59',NULL,'664 route de canteloup','','',NULL,NULL,NULL,NULL,'1490777439002',292.000000000,'1978-08-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8962,'ROULT','JEAN PHILIPPE','1940-05-13','02.67.36.28.05','06.52.44.49.36',NULL,'8 bis rue du pont de pierre','','','14160','DIVES SUR MER',NULL,NULL,'2400514275002',105.000000000,'1970-07-10','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8963,'DEMARET','MARIE CLAIRE','1964-09-08','02.31.10.60.11','06.48.09.38.32',NULL,'3 BIS RUE EMILE ZOLA','','',NULL,NULL,NULL,NULL,'1640914107002',26.000000000,'1986-04-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8964,'EUDELINE','MARIE CLAIRE','1958-02-27','02.83.77.51.02','06.11.73.03.20',NULL,'9 LE CLOS DE BULLY','','','14370','MERY CORBON',NULL,NULL,'1580214410002',191.000000000,'1980-12-31','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8965,'PIERRE','MAURICE','1931-12-01','02.74.78.16.43',NULL,NULL,'','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2311256182002',889.000000000,'1957-02-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8966,'QUIESSE','CLAUDE',NULL,'02.63.77.92.24','06.45.54.12.32',NULL,'4 impasse mal couronne','','','14120','MONDEVILLE',NULL,NULL,'1390650436002',9.000000000,'2010-04-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8967,'HOUEIX','MARTINE','1967-11-23','02.62.39.83.87','06.35.09.07.27',NULL,'6 AVENUE JOEL MINICI','','','14640','AUBERVILLE',NULL,NULL,'1671150502002',28.000000000,'1996-07-23','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8968,'LIBERGE','PAUL','1931-09-26','02.11.80.60.44','06.26.39.55.94',NULL,'22 BIS RUE DU MARECHAL LECLERC','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1310926064002',2290.000000000,'1961-12-09','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8969,'RIBOT','JOEL','1932-06-11','02.31.74.03.02',NULL,NULL,'4 rue Madame Bouffare','','','14120','MONDEVILLE',NULL,NULL,'1320661346002',39.000000000,'1957-08-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8970,'PACHOUD','JEANNINE','1936-06-08','02.26.98.62.76','06.30.07.87.44',NULL,'les avenages','','','61200','ARGENTAN',NULL,NULL,'2360650464002',3903.000000000,'1964-11-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8971,'VANDEN DURPEL','MARIE ANGE','1953-02-10','02.51.96.61.80','06.99.62.72.62',NULL,'10 PLACE PALBRE','','','14000','CAEN',NULL,NULL,'2530214524002',18.000000000,'1975-04-06','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8972,'ROSAIS','CHRISTIAN','1937-07-01','02.28.54.20.39','06.54.25.41.25',NULL,'54 RUE DE LA LIBERATION','','','14130','COQUAINVILLIERS',NULL,NULL,'2370714437002',31.000000000,'1963-06-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8973,'JARRY','BELLY','1946-01-11','02.45.03.14.06','06.21.42.73.03',NULL,'27 rue d''ifs','','','14670','TROARN',NULL,NULL,'1460161464002',76.000000000,'1975-07-04','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8974,'BELLIARD','ALAIN','1931-07-15','02.75.48.56.87','06.16.63.79.72',NULL,'5 rue Maurice Fouques','','','14540','BOURGUEBUS',NULL,NULL,'1310714431002',718.000000000,'1952-09-26','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8975,'EDENNE','JEAN FRANCOIS','1933-11-21','02.61.60.71.04','06.53.51.33.32',NULL,'45 route d''Harcourt','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2331159168002',83.000000000,'1956-07-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8976,'PANUS','COLETTE','1965-05-23','02.28.42.42.87','06.78.51.37.66',NULL,'chemin de la butte','','','14120','MONDEVILLE',NULL,NULL,'2650514277002',1368.000000000,'1989-09-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8977,'CUQUEMELLE','EVELYNE','1945-07-07','02.26.79.03.08','06.69.88.08.93',NULL,'8 AVENUE PLEIN CIEL','','','14460','COLOMBELLES',NULL,NULL,'1450761351002',22.000000000,'1972-03-29','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8978,'BERRY','PIERRE','1940-03-18','02.34.64.75.19','06.12.08.20.34',NULL,'LES 4 ROUTES','','','14130','BONNEVILLE LA LOUVET',NULL,NULL,'1400327438002',36.000000000,'1965-08-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8979,'VAUCHER','GHISLAINE','1934-08-21','02.84.13.63.86','06.95.37.69.42',NULL,'16 RUE DE L''EGLISE','','','14550','GIBERVILLE',NULL,NULL,'2340833203002',182.000000000,'1955-06-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8980,'LEMEE','BELLY',NULL,'02.29.19.89.22','06.44.33.13.64',NULL,'1 HAMEAU DIGARD','','','14000','CAEN',NULL,NULL,'2301214333002',217.000000000,'2008-02-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8981,'BELLOU','MARYLINE','1945-07-14','02.41.22.02.29','06.83.45.02.82',NULL,'21 RUE DE CORMELLES','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2450761009002',439.000000000,'1966-11-18','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8982,'DELAUNAY','PHILIPPE','1940-03-11','02.56.32.76.88','06.11.52.48.25',NULL,'19 RUE SOUS LIAU','','','14000','CAEN',NULL,NULL,'1400327438002',112.000000000,'1970-01-17','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8983,'MAHE','MAURICETTE','1946-02-03','02.49.62.43.77','06.68.03.31.41',NULL,'3 rue Thiers','','','14000','CAEN',NULL,NULL,'2460214157002',638.000000000,'1967-02-12','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8984,'LE BUAN','LILIANE','1936-10-30','02.89.92.95.63','06.49.02.11.38',NULL,'9 RUE DES BOULEAUX','','','14430','BRANVILLE',NULL,NULL,'1361014309002',34.000000000,'1962-07-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8985,'VERES','GERARD','1931-10-03','02.77.13.61.73','06.83.77.64.13',NULL,'La Valle du Bas','','','61150','RANES',NULL,NULL,'2311014752002',410.000000000,'1957-01-05','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8986,'TOUCHARD','ODETTE','1935-01-06','02.12.09.16.12','06.42.76.05.92',NULL,'480 RUE DE LA MARE','','','14540','BOURGUEBUS',NULL,NULL,'2350150405002',96.000000000,'1957-02-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8987,'LEROUX','JANINE','1963-08-15','02.10.85.00.76','06.78.23.47.32',NULL,'15 RUE DU MARAIS','','','50690','NOUAINVILLE',NULL,NULL,'2630814074002',1064.000000000,'1984-03-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8988,'DELAHAYE','RENE','1937-04-26','02.79.49.07.13','06.11.29.40.09',NULL,'32 rue des Hauts Vents','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1370450222002',25.000000000,'1967-09-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8989,'BEAUFILS','fatima',NULL,'02.55.37.57.46','06.17.95.82.99',NULL,'adda 14 bp  50204 7 rue du dr r','oux','','14123','IFS',NULL,NULL,'1520214516002',14.000000000,'2008-03-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8990,'CASTEL','HERVE','1929-11-27','02.96.52.97.40','06.95.04.42.83',NULL,'3 Impasse de Rocroi','','','14000','CAEN',NULL,NULL,'1291129136002',4158.000000000,'1950-07-16','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8991,'ANGER','JEANNINE','1933-09-28','02.11.48.58.45','06.63.26.06.06',NULL,'24 rue de crevecoeur','','','14123','IFS',NULL,NULL,'2330961145002',89.000000000,'1956-09-23','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8992,'QUEUDRUE','YVETTE','1951-05-30','02.99.94.10.33','06.96.12.07.94',NULL,'2 rue Yvonne Talbot','','','14123','IFS',NULL,NULL,'2510550490002',14.000000000,'1974-04-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8993,'GRAFFIN','RENEE','1930-10-27','02.18.45.53.97','06.60.69.14.85',NULL,'1 CITE DES ROCHES','','','14000','CAEN',NULL,NULL,'2301014743002',3730.000000000,'1953-08-07','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8994,'SELLE','FRANCOIS','1948-01-26','02.61.86.15.13','06.82.73.98.92',NULL,'3 route de caen','','','14123','FLEURY SUR ORNE',NULL,NULL,'1480161344002',206.000000000,'1969-02-03','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8995,'DJIBO','GEORGES','1933-10-29','02.39.12.25.08','06.10.74.45.45',NULL,'10 rue Marivaux','','','50890','CONDE SUR VIRE',NULL,NULL,'2331050261002',700.000000000,'1958-12-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8996,'LEGENDRE','MICHEL','1930-06-19','02.74.02.57.47',NULL,NULL,'23 RUE DE TROARN','','','14670','TROARN',NULL,NULL,'1300614659002',628.000000000,'1953-05-10','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8997,'LEFEVRE','CHRISTIAN','1958-05-05','02.96.16.44.51','06.52.62.46.14',NULL,'38 AV DE LA REINE MATHILDE','','','14000','CAEN',NULL,NULL,'1580514432002',52.000000000,'1981-05-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8998,'VIMONT','ELIANE','1929-02-23',NULL,NULL,NULL,'9 RUE PASTEUR','','','14220','ST LAURENT DE CONDEL',NULL,NULL,'2290214137002',685.000000000,'1953-03-19','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (8999,'GASNIER','MARIE',NULL,'02.10.53.98.21','06.11.81.11.80',NULL,'12 place de l hotel de ville','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2530414530002',19.000000000,'2010-07-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9000,'VERGOTE','CHRISTIAN','1935-02-24','02.10.55.80.34','06.62.75.71.74',NULL,'18 rue albert de mun','','',NULL,NULL,NULL,NULL,'1350261346002',253.000000000,'1960-07-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9001,'COLLIN','JACQUES','1953-06-22','02.19.10.80.60','06.11.39.10.29',NULL,'','','','14310','MONTS EN BESSIN',NULL,NULL,'1530614221002',24.000000000,'1975-02-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9002,'LE JEAN','ANDRE','1968-01-09','02.68.28.87.80','06.20.89.86.12',NULL,'','','','14680','GOUVIX',NULL,NULL,'2680114060002',461.000000000,'1998-04-08','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9003,'CAZALE','RAYMOND','1939-02-19','02.15.57.00.75','06.21.37.21.29',NULL,'4 rue jean jacques rousseau','','','50250','ST JORES',NULL,NULL,'1390210376002',104.000000000,'1961-02-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9004,'GOUYA','','1937-05-17','02.12.83.45.89','06.42.43.41.57',NULL,'2 rue de la nuance','','','14220','THURY HARCOURT',NULL,NULL,'1370550083002',91.000000000,'1960-10-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9005,'BAYET','ODILE','1964-02-01','02.41.64.54.63','06.83.78.28.43',NULL,'les ilots','','','14160','GRANGUES',NULL,NULL,'2640214191002',392.000000000,'1985-01-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9006,'MARIE','BERNARD','1932-10-30','02.96.88.14.95','06.24.23.67.69',NULL,'4 rue des primeverts','','','14000','GIBERVILLE',NULL,NULL,'1321014486002',1098.000000000,'1953-01-20','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9007,'MOULIN','DIDIER','1954-04-19','02.11.74.43.95',NULL,NULL,'12 HAMEAU DE BITOT','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1540450628002',41.000000000,'1978-03-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9008,'CHAUVIN','SUZANNE','1951-06-10','02.45.53.64.15','06.61.43.88.49',NULL,'61 AV DE L''EUROPE APP 53','','','14120','MONDEVILLE',NULL,NULL,'2510659350002',80.000000000,'1978-01-26','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9009,'BLANCHEMAIN','DENISE','1947-09-26','02.55.37.33.90','06.56.10.80.50',NULL,'lieu dit guillerville','','','14123','IFS',NULL,NULL,'1470914393002',1117.000000000,'1971-06-25','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9010,'PETIT','SYLVAIN',NULL,'02.53.79.80.20','06.33.20.12.09',NULL,'13 rue jacques brel','','','14000','CAEN',NULL,NULL,'1330161464002',1664.000000000,'2012-01-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9011,'MOREL','JACQUES','1951-09-28','02.40.67.46.72','06.38.77.83.26',NULL,'2 route de bretteville','','',NULL,NULL,NULL,NULL,'2510950633002',26.000000000,'1981-11-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9012,'JANKOWSKI','MICHEL','1969-11-21','02.49.02.42.67','06.16.13.37.48',NULL,'21 rue monseigneur Adam','','','14000','CAEN',NULL,NULL,'2691150502002',68.000000000,'1990-01-26','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9013,'GOYEZ','GUY','1939-01-23','02.73.81.94.69','06.19.54.49.03',NULL,'67 RUE ST MARGUERITE','','','14540','GIBERVILLE',NULL,NULL,'2390114167002',10.000000000,'1962-10-07','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9014,'HUET','GOGA','1984-01-22','02.41.10.93.22','06.62.10.80.51',NULL,'25 des freres boutrois','','','14540','GRENTHEVILLE',NULL,NULL,'2840199111002',15.000000000,'2007-05-22','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9015,'LEBOULANGER','JACKY','1937-02-03',NULL,NULL,NULL,'9 rue des brises','','','14000','CAEN',NULL,NULL,'1370214410002',257.000000000,'1961-11-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9016,'JARDIN','GERALDINE','1946-05-07','02.98.51.64.61','06.65.88.86.08',NULL,'54 rue Girard','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2460514150002',1570.000000000,'1972-06-14','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9017,'NIEPCERON','Guy','1920-08-14','02.89.36.61.94','06.21.60.01.31',NULL,'37 rue l bouillard','','','14123','IFS',NULL,NULL,'1200850119002',21.000000000,'1946-04-06','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9018,'OZANNE','CHARLES','1933-01-23','02.28.46.65.92','06.17.08.53.55',NULL,'12 RUE DE L EGLISE','','','14630','FRENOUVILLE',NULL,NULL,'2330114271002',9.000000000,'1963-05-11','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9019,'POULAIN','RAYMONDE','1944-04-07','02.24.23.52.32','06.35.96.95.43',NULL,'','','','14370','BILLY',NULL,NULL,'1440450521002',2255.000000000,'1969-12-14','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9020,'PIGNOL','FRANCOIS','1948-07-11','02.10.28.25.87','06.44.22.29.73',NULL,'8 RUE DE DOMFRONT','','','14370','CLEVILLE',NULL,NULL,'1480714294002',962.000000000,'1969-09-10','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9021,'LEROUX','MARTINE','1930-07-09','02.69.53.00.33','06.15.47.92.94',NULL,'20 RUE DES L EGLISE','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'2300750570002',37.000000000,'1951-01-18','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9022,'MICHEL','ALAIN','1960-03-06','02.62.29.95.77','06.49.09.09.08',NULL,'17 RUE DU BICENTENAIRE','','','14000','CAEN',NULL,NULL,'1600314173002',814.000000000,'1984-02-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9023,'SONNET','BERNARD','1941-05-24','02.12.14.40.45','06.43.87.40.51',NULL,'LA PETITE BRUYERE','','','14730','GIBERVILLE',NULL,NULL,'2410561411002',44.000000000,'1970-06-18','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9024,'LANCHAS CRUCES','MADELEINE','1955-05-01','02.12.04.88.17','06.16.94.48.32',NULL,'2 RUE DU LIEUTENANT','','','14370','CROISSANVILLE',NULL,NULL,'1550514665002',48.000000000,'1985-07-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9025,'BOULEAU','THERESE','1936-05-12','02.79.62.47.40','06.32.82.75.68',NULL,'3 ALLEE DU SAGUENAY','','','14000','CAEN',NULL,NULL,'2360550539002',1451.000000000,'1965-12-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9026,'YON','ISABELLE','1950-06-02','02.17.74.14.46',NULL,NULL,'13 ALLEE DES REBLOTS','','','14860','RANVILLE',NULL,NULL,'1500614710002',61.000000000,'1974-04-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9027,'HOMBOURGER','Huguette','1938-09-24','02.22.32.96.43','06.66.96.03.04',NULL,'51 RUE LOUIS ROBILLARD','','','61200','ARGENTAN',NULL,NULL,'2380914397002',615.000000000,'1965-01-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9028,'LEBAS','ALBERT','1963-02-24','02.98.98.62.77','06.10.52.59.23',NULL,'9 RUE D''ARROMANCHES','','','14500','VIRE',NULL,NULL,'1630214221002',93.000000000,'1989-01-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9029,'CLEMENT','didier','1957-06-19','02.21.37.93.93','06.30.69.46.53',NULL,'88 RUE CHAPRON','','','14370','ARGENCES',NULL,NULL,'1570614039002',38.000000000,'1984-12-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9030,'ROUELLE','ALAIN','1934-09-17','02.82.45.11.52','06.53.91.04.54',NULL,'706 RUE DU 23 eme HUSSARD','','','14670','JANVILLE',NULL,NULL,'1340914699002',98.000000000,'1963-04-10','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9031,'','MICHEL','1942-10-13','02.87.51.78.19','06.12.33.57.07',NULL,'90 ROUTE D''HARCOURT','','','14000','CAEN',NULL,NULL,'1421014031002',823.000000000,'1969-09-03','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9032,'FRANCOISE','DJIDDI','1930-01-10','02.86.67.55.09','06.59.52.59.15',NULL,'12 RUE HECTOR BERLIOZ','','','14840','DEMOUVILLE',NULL,NULL,'2300150402002',24.000000000,'1958-01-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9033,'DEREAC','MAURICETTE','1955-02-19','02.80.20.73.20','06.10.57.00.25',NULL,'9 alle rsidence d''harcourt','','','14190','CAUVICOURT',NULL,NULL,'2550214207002',155.000000000,'1976-08-25','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9034,'MANCHION','ALBERT','1935-08-05','02.41.60.21.35','06.40.54.65.18',NULL,'TOURNIERES','','','14320','MAY SUR ORNE',NULL,NULL,'2350814035002',30.000000000,'1963-07-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9035,'BERNARDIN','AZIZA','1929-04-17','02.49.64.74.46',NULL,NULL,'16 ROUTE DE ROUEN','','','14860','BAVENT',NULL,NULL,'1290414020002',852.000000000,'1954-02-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9036,'DAHYOT','GAETAN','1961-12-09','02.35.63.29.92','06.73.01.41.45',NULL,'7 PLACE DES TOURELLES','','','14370','BELLENGREVILLE',NULL,NULL,'1611214042002',49.000000000,'1984-04-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9037,'MORIN','elia','1928-09-21','02.32.88.12.80','06.10.49.89.40',NULL,'11 RUE DU DR YVONNET','','','14000','CAEN',NULL,NULL,'2280950563002',526.000000000,'1951-06-12','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9038,'BOISMARE','AZIZA',NULL,'02.80.06.94.75','06.78.78.88.90',NULL,'69 BD DE ROTHEL','','','14130','BONNEVILLE LA LOUVET',NULL,NULL,'2550414287002',24.000000000,'2013-07-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9039,'LECHEVALIER','MARCEL','1955-04-10','02.40.47.61.79','06.99.36.37.98',NULL,'3 RUE DU CINGAL','','','14320','MAY SUR ORNE',NULL,NULL,'2550414287002',3937.000000000,'1979-04-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9040,'MAUTALENT','GERARD','1958-02-08','02.32.63.61.48','06.62.07.27.69',NULL,'11 RUE DES GRANDES MURAILLES','','',NULL,NULL,NULL,NULL,'2580250043002',355.000000000,'1979-01-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9041,'EUGENE','MICHEL','1953-04-26','02.10.56.32.19','06.11.67.42.28',NULL,'20 avenue jean JAURES','','','14730','GIBERVILLE',NULL,NULL,'1530414666002',42.000000000,'1977-12-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9042,'FAICT','guy','1939-11-30','02.51.07.50.14','06.81.98.85.56',NULL,'27 RUE SAINT EXUPERY','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1391153271002',336.000000000,'1969-12-15','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9043,'SAMOURA','Nicole','1940-12-16','02.73.46.52.85','06.19.79.98.23',NULL,'8 rue des freres lumieres','','','14000','CAEN',NULL,NULL,'1401214640002',28.000000000,'1965-01-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9044,'KOPER','jacques','1932-02-25','02.29.47.20.72','06.10.02.89.28',NULL,'20 RUE DU FOUR A CHAUX','','','14530','LUC SUR MER',NULL,NULL,'1320261144002',160.000000000,'1955-12-31','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9045,'SEIGNEUR','MARIE LAURE','1951-02-15','02.90.61.48.16','06.60.37.59.64',NULL,'207 CHEMIN DE LA ROCHE','','','14320','FONTENAY LE MARMION',NULL,NULL,'1510253164002',158.000000000,'1976-07-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9046,'OFOUNGUINY MAISSA','GERARD',NULL,'02.28.70.90.42','06.26.31.50.14',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'1300162734002',20.000000000,'2010-08-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9047,'LAMBERGER','MAURICETTE','1933-05-28','02.45.68.82.76','06.52.56.22.43',NULL,'CHEMIN DE VAUSSERY','','','14120','MONDEVILLE',NULL,NULL,'2330514578002',39.000000000,'1959-01-03','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9048,'AUVRAY','maurice','1949-02-13','02.12.52.24.88','06.95.06.75.94',NULL,'25 RUE CHARLES  PEGUY','','','14320','MAY SUR ORNE',NULL,NULL,'1490275120002',1738.000000000,'1974-07-01','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9049,'RIEL','ROLAND','1950-05-27','02.53.12.65.24','06.36.31.52.79',NULL,'1C RUE DES FRESNETS','','','14000','CAEN',NULL,NULL,'2500514555002',2.000000000,'1972-07-05','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9050,'HENRY','MONIQUE','1940-01-24','02.20.51.19.93','06.93.78.68.69',NULL,'58 AVENUE DE PARIS','','','14570','CLECY',NULL,NULL,'1400114427002',137.000000000,'1963-09-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9051,'DERAUCROIX','DANIEL','1948-02-17','02.12.11.12.74',NULL,NULL,'2 rue du parc','','','14000','CAEN',NULL,NULL,'2480214675002',223.000000000,'1976-07-21','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9052,'DEMAZEAU','YVETTE','1930-12-05','02.97.39.51.79','06.23.98.70.00',NULL,'19 RUE CHATEAUBRIAND','','','14540','BOURGUEBUS',NULL,NULL,'1301214174002',29.000000000,'1960-01-13','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9053,'CAPELLO','PHILIPPE','1960-09-05','02.48.75.56.08','06.60.42.47.59',NULL,'13 rue pasteur','','','14000','CAEN',NULL,NULL,'2600914536002',786.000000000,'1987-01-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9054,'LE MOYNE','ALBERT','1935-11-09','02.53.27.49.72','06.25.83.31.50',NULL,'4 RUE DE GENEVE','','','14680','GOUVIX',NULL,NULL,'2351114086002',105.000000000,'1958-06-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9055,'EUDE','PAUL','1960-05-09','02.47.23.25.86','06.91.27.64.90',NULL,'34 GRANDE RUE','','','14000','CAEN',NULL,NULL,'2600561081002',373.000000000,'1983-04-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9056,'ALEXANDRE','M-FRANCE','1939-02-14','02.19.36.00.75','06.82.45.77.84',NULL,'8 IMPASSE ANDRE AMPRERE','','','14730','GIBERVILLE',NULL,NULL,'2390214670002',96.000000000,'1967-02-05','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9057,'MAUGER','DANIEL','1932-07-01','02.24.34.49.57','06.88.46.08.44',NULL,'12 RUE DU MUGUET','','','50100','CHERBOURG',NULL,NULL,'2320714126002',21.000000000,'1956-02-23','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9058,'FLOHIC','ROSANNA','1930-09-16','02.25.52.17.21','06.81.59.30.77',NULL,'le gros houx','','','14220','COMBRAY',NULL,NULL,'2300914516002',833.000000000,'1956-07-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9059,'PINCELOUP','BERNARD','1934-10-05','02.79.92.20.64','06.92.86.26.86',NULL,'HAMEAU DE L''EGLISE','','','50160','ST SYMPHORIEN LES BUTTES',NULL,NULL,'2341022055002',13.000000000,'1964-10-06','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9060,'LE BLOND','MICHELINE','1956-08-28','02.52.70.47.77','06.46.25.85.19',NULL,'6 rue saint patrice','','','14530','LUC SUR MER',NULL,NULL,'1560814645002',344.000000000,'1985-05-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9061,'GARNIER','ERIC','1940-05-31','02.94.35.54.07','06.91.06.96.75',NULL,'la cour bourdon st crespin','','','14170','THIEVILLE',NULL,NULL,'2400514275002',232.000000000,'1968-05-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9062,'RICHARD','AUGUSTE','1964-01-17','02.90.90.22.04','06.75.73.15.87',NULL,'la cour bourdon st crespin','','','14670','ST SAMSON',NULL,NULL,'2640114673002',1858.000000000,'1993-12-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9063,'VARIN','ABOU','1940-01-27','02.64.39.40.65','06.83.51.70.80',NULL,'6 rue du discobole','','','50690','SIDEVILLE',NULL,NULL,'1400114427002',1430.000000000,'1961-08-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9064,'HANGUEHARD','FRANCOIS','1935-07-05','02.42.52.54.19','06.51.04.86.00',NULL,'13 RUE CLAUDE DEBUSSY','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1350776134002',989.000000000,'1959-02-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9065,'GROUT','DIDIER','1932-09-02','02.38.67.62.02','06.10.82.49.28',NULL,'6 RUE DE L EGLISE','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2320914088002',715.000000000,'1961-05-21','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9066,'VOISIN','RAYMOND','1935-12-31','02.87.96.57.45','06.43.87.19.49',NULL,'86 RTE D''IFS','','','61150','SEVRAI',NULL,NULL,'1351214349002',58.000000000,'1963-11-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9067,'LETELLIER','rene','1934-02-23','02.20.26.30.02','06.74.93.32.74',NULL,'20 rue louise michel','','','14500','VIRE',NULL,NULL,'1340214090002',3.000000000,'1962-05-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9068,'ROUSSEAU','michel','1960-03-26','02.87.43.64.60','06.57.11.80.77',NULL,'21 RUE DU VAL ES DUNES','','','14500','VIRE',NULL,NULL,'2600314657002',2.000000000,'1982-01-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9069,'LAMY','MARCEL','1931-09-27','02.92.72.10.85','06.75.69.58.51',NULL,'5 CHEMIN DE BETEVILLE','','','14000','CAEN',NULL,NULL,'1310914449002',197.000000000,'1952-07-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9070,'KILATCHIKOFF','JEANNINE','1931-09-04','02.89.08.22.61','06.67.45.45.13',NULL,'CHEMIN DE LA RIVIERE','','','14350','CARVILLE',NULL,NULL,'1310927056002',12.000000000,'1960-07-27','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9071,'LE BRAY','FRANCOIS','1940-02-06','02.11.94.33.91','06.50.07.66.95',NULL,'','','','14700','AUBIGNY',NULL,NULL,'1400214137002',25.000000000,'1963-03-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9072,'MARIE','JOSETTE','1944-05-31','02.27.52.32.68','06.55.16.33.84',NULL,'152 BD LEROY','','','14120','MONDEVILLE',NULL,NULL,'2440550643002',811.000000000,'1966-11-22','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9073,'WERDA','JEAN','1937-06-07','02.93.22.37.52','06.17.40.04.70',NULL,'30 rue des forges','','','14000','CAEN',NULL,NULL,'1370661073002',33.000000000,'1960-12-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9074,'LOUET','PATRICIA','1952-01-31','02.58.92.63.82','06.96.91.30.30',NULL,'13 alle de l''alberta','','','14940','SANNERVILLE',NULL,NULL,'1520114191002',761.000000000,'1980-11-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9075,'DELAUNAY','MARTINE','1935-03-12','02.65.68.32.79','06.73.26.88.96',NULL,'6 RUE DU PRIEURE','','','14540','SOLIERS',NULL,NULL,'2350314365002',836.000000000,'1958-04-30','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9076,'DANCEL','PIERRE','1961-03-15','02.78.59.90.69','06.10.96.38.13',NULL,'LE PARMENTIER RUE LOUIS ARMOR','','','14000','CAEN',NULL,NULL,'2610350228002',18.000000000,'1991-05-01','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9077,'CHATELAIS','ALFRED','1987-04-27','02.38.56.09.99','06.47.77.94.82',NULL,'9 RUE GUY DE MAUPASSANT','','','14000','CAEN',NULL,NULL,'1870499395002',3151.000000000,'2012-12-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9078,'LECLERC','GEORGES','1935-07-02','02.97.10.44.04','06.62.92.91.66',NULL,'64 rue louis le chatellier','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2350714249002',1013.000000000,'1956-04-22','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9079,'PAILLE','ODILE','1955-08-30','02.11.07.88.61','06.17.26.74.41',NULL,'1 RUE SALVADOR ALLENDE','','','14310','COULVAIN',NULL,NULL,'2550814470002',58.000000000,'1978-04-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9080,'AUBRY','thierry','1948-05-19','02.91.20.89.24','06.87.46.48.84',NULL,'','','','14190','ROUVRES',NULL,NULL,'2480514118002',56.000000000,'1971-09-25','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9081,'MONNET','ANNE MARIE','1932-12-16','02.98.91.28.59','06.12.11.26.92',NULL,'9 la delle du grand champ','','','61200','ARGENTAN',NULL,NULL,'1321214044002',167.000000000,'1955-03-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9082,'GRANDJEAN','CATHERINE','1934-03-01','02.51.22.50.36','06.10.74.29.47',NULL,'E.H. P A.D FONDATION LETAVERNIER',' PITROU   17 LE FRESNE','','14940','TOUFFREVILLE',NULL,NULL,'2340314271002',493.000000000,'1958-10-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9083,'MOREL','bernard','1933-01-21','02.99.43.34.53','06.77.55.48.28',NULL,'28 rue de l''glise','','','14430','BEUVRON EN AUGE',NULL,NULL,'1330161464002',37.000000000,'1957-03-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9084,'PETITHOMME','ida','1936-06-04','02.11.41.82.95','06.21.01.39.18',NULL,'12 rue Louis Aragon','','','14111','LOUVIGNY',NULL,NULL,'2360614543002',121.000000000,'1964-02-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9085,'CAILLY','MARGUERITE','1935-09-05','02.54.14.32.23','06.59.75.85.83',NULL,'10 RUE DES ERABLES','','','14460','COLOMBELLES',NULL,NULL,'2350961369002',4275.000000000,'1959-07-04','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9086,'ANDRE','Simone','1954-01-04','02.52.15.83.80','06.44.90.48.72',NULL,'le bourg neuf','','','14000','CAEN',NULL,NULL,'1540187161002',965.000000000,'1976-06-28','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9087,'YONNET','PIERRE','1933-11-09','02.77.50.71.68','06.70.42.89.37',NULL,'14 rue hautbois','','',NULL,NULL,NULL,NULL,'1331114252002',377.000000000,'1963-03-01','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9088,'FOLLIOT','yolande','1937-08-16','02.59.86.36.77','06.43.04.45.47',NULL,'29 Bd de Rethel','','',NULL,NULL,NULL,NULL,'1370814485002',105.000000000,'1966-01-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9089,'DEQUILBECQ','ANNE MARIE','1941-04-20','02.65.45.14.94','06.57.85.11.27',NULL,'13 10 rue du bois','','','61150','ECOUCHE',NULL,NULL,'1410414150002',19.000000000,'1963-12-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9090,'JOURDAN','MAURICETTE','1947-05-12','02.36.83.94.46','06.80.05.74.02',NULL,'27 rue marechal foch','','','14000','CAEN',NULL,NULL,'1470561468002',156.000000000,'1968-04-13','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9091,'DUHAZE','LOUIS','1950-06-23','02.31.02.33.91','06.90.60.52.77',NULL,'14 RUE KALINIKRENKO','','','14370','VIMONT',NULL,NULL,'1500614190002',34.000000000,'1973-02-07','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9092,'HARDY','ROBERT',NULL,'02.14.20.26.10','06.10.31.47.47',NULL,'22 rue des tilleuls','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'1440514158002',52.000000000,'2010-12-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9093,'','ALAIN','1932-05-17','02.48.69.22.97','06.26.13.70.36',NULL,'14 rue loius pasteur','','','14000','CAEN',NULL,NULL,'2320514140002',296.000000000,'1958-11-12','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9094,'','CHARLOTTE','1956-05-11','02.62.73.12.45','06.10.52.64.10',NULL,'','','','14360','TROUVILLE SUR MER',NULL,NULL,'1560514568002',85.000000000,'1980-08-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9095,'AUMOND','NELLY','1955-05-11','02.10.28.92.38','06.28.35.13.54',NULL,'62 RUE DES ACACIAS','','','14111','LOUVIGNY',NULL,NULL,'1550514177002',1513.000000000,'1980-10-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9096,'GOHON','EUGENE',NULL,'02.88.75.06.61','06.34.50.86.64',NULL,'28 place des drakkars','','','14000','CAEN',NULL,NULL,'1530250202002',210.000000000,'2012-07-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9097,'LEROUVILLOIS','MARIA','1928-10-12','02.99.35.28.69','06.77.23.61.69',NULL,'LE BOURG','','','50420','TESSY SUR VIRE',NULL,NULL,'2281014200002',945.000000000,'1955-04-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9098,'BESNIER','JANNY','1966-08-04','02.10.95.20.55','06.17.06.62.88',NULL,'21 basse ecarde','','','14250','TILLY SUR SEULLES',NULL,NULL,'2660814287002',60.000000000,'1989-03-16','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9099,'REBUFFONI','JEAN','1932-06-17','02.63.97.52.72','06.60.16.43.71',NULL,'10 impasse des acacias','','','14630','FRENOUVILLE',NULL,NULL,'1320661044002',115.000000000,'1958-04-18','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9100,'PIERRE','CATHERINE','1956-01-14','02.24.35.69.92','06.86.12.79.54',NULL,'11 rue du bois','','','14400','BAYEUX',NULL,NULL,'1560114278002',1379.000000000,'1977-07-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9101,'LEDEMNEY','STEPHAN',NULL,'02.89.77.84.06','06.13.46.71.86',NULL,'9 rue du regret','','','14730','GIBERVILLE',NULL,NULL,'1681014410002',2299.000000000,'2010-12-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9102,'GRUENAIS','LUCIENNE','1956-08-09','02.11.35.76.86','06.46.94.52.66',NULL,'34 QUAI CHARCOT','','',NULL,NULL,NULL,NULL,'1560814553002',91.000000000,'1979-05-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9103,'TOULLIER','CORINNE','1937-04-18','02.10.23.26.18','06.94.73.22.66',NULL,'27 RUE D''iFS','','','14000','CAEN',NULL,NULL,'1370450200002',5.000000000,'1967-09-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9104,'','ANDREE','1940-01-19','02.67.76.35.83','06.57.08.22.80',NULL,'46 RUE ARISTIDE BRIAND','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'2400114076002',8.000000000,'1962-07-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9105,'RAVENEAU','MIREILLE','1937-06-30','02.55.46.95.32','06.88.59.02.71',NULL,'2 RUE PAUL ALLENE','','','14630','CAGNY',NULL,NULL,'1370676659002',274.000000000,'1964-06-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9106,'LEROUGE','GASTON','1929-09-02','02.46.02.97.26','06.76.08.75.80',NULL,'23 rue savard','','','14123','FLEURY SUR ORNE',NULL,NULL,'2290914341002',267.000000000,'1958-03-14','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9107,'CATEL','Clemence','1964-01-07','02.77.48.55.35','06.96.06.50.41',NULL,'4 sente des jardins','','','61430','MENIL HUBERT SUR ORNE',NULL,NULL,'2640114673002',745.000000000,'1992-08-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9108,'LECOQ','CLAUDE','1944-03-12','02.45.36.41.93','06.73.02.09.05',NULL,'la senaudiere','','','14000','CAEN',NULL,NULL,'1440350358002',748.000000000,'1966-05-29','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9109,'ESNAULT','SERGE','1940-11-19','02.48.55.47.01','06.45.01.43.08',NULL,'23 AVENUE ALBERT 1ER   FOYER ALB','ERT 1 ER','','14910','BENERVILLE SUR MER',NULL,NULL,'2401150031002',34.000000000,'1961-04-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9110,'BREMONT','Patrick','1932-07-19','02.42.81.45.02','06.43.93.16.24',NULL,'11 RUE DU COMMERCE','','','50480','RAVENOVILLE',NULL,NULL,'1320761006002',68.000000000,'1956-02-14','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9111,'ENEE','LUCIENNE','1930-09-01','02.77.14.02.54','06.57.84.84.90',NULL,'11 bis rue de cormelles','','','14520','PORT EN BESSIN HUPPAIN',NULL,NULL,'2300914597002',209.000000000,'1954-09-22','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9112,'PRUNEAU','Annick','1958-05-04','02.82.98.88.16','06.78.87.38.51',NULL,'38 rue louis leblanc','','','14470','COURSEULLES SUR MER',NULL,NULL,'2580514662002',564.000000000,'1986-03-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9113,'DESGUET','JEAN LUC','1950-06-22','02.76.08.03.82','06.85.95.22.83',NULL,'11 rue du stade','','',NULL,NULL,NULL,NULL,'1500614580002',774.000000000,'1974-01-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9114,'LESAUVAGE','Monique','1969-04-18','02.10.91.76.13','06.16.83.02.98',NULL,'4 bis rue marcel lemereay','','','14220','ST LAURENT DE CONDEL',NULL,NULL,'2690461169002',25.000000000,'1996-08-28','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9115,'BUNEL','ludmila','1954-06-20','02.62.80.23.34','06.30.72.78.68',NULL,'ROUTE DE CANON','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1540614037002',344.000000000,'1978-10-28','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9116,'MACHOU','RAYMOND','1933-04-29','02.22.91.46.73','06.11.99.64.65',NULL,'','','','14370','ARGENCES',NULL,NULL,'2330414191002',84.000000000,'1963-06-23','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9117,'LERENARD','Aime','1965-05-06','02.62.96.03.61','06.51.88.86.41',NULL,'29 rue chargford','','','14390','CABOURG',NULL,NULL,'1650514123002',185.000000000,'1989-07-13','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9118,'LETANNEUR','Maurice','1954-08-22','02.15.66.62.37','06.11.71.58.77',NULL,'4 RUE CHARLES MULLER','','','14120','MONDEVILLE',NULL,NULL,'2540814004002',3.000000000,'1978-08-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9119,'BOULANGER','Julien','1954-08-01','02.10.74.55.37',NULL,NULL,'18 rue le clos','','','14370','MOULT',NULL,NULL,'2540814004002',997.000000000,'1979-12-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9120,'FONTENELLE','Paulette','1935-10-08','02.74.95.71.56',NULL,NULL,'4 RUE DES MARCHES','','',NULL,NULL,NULL,NULL,'1351014357002',2391.000000000,'1957-01-24','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9121,'HUET','DENISE','1937-11-20','02.59.32.09.67','06.10.74.01.98',NULL,'le doitigier','','','14370','BELLENGREVILLE',NULL,NULL,'1371161328002',324.000000000,'1964-07-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9122,'CHEVALIER','christian','1966-08-25','02.71.74.17.77',NULL,NULL,'2 ROUTE DE BISSIERES','','','14370','BELLENGREVILLE',NULL,NULL,'2660814287002',93.000000000,'1988-10-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9123,'POMAR-FORTEZA','Gilbert','1939-01-15','02.60.40.85.99','06.31.96.16.54',NULL,'6 square edouard le confesseur','','','14640','VILLERS SUR MER',NULL,NULL,'1390114162002',90.000000000,'1964-11-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9124,'MERIOTTE','GEORGES','1940-02-15','02.56.96.35.48','06.34.56.99.67',NULL,'11.1 rue des champs fleuris','','','14000','CAEN',NULL,NULL,'2400261116002',36.000000000,'1967-04-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9125,'FERNANDEZ DA COSTA','Thrse','1967-11-10','02.18.30.27.88','06.10.72.58.16',NULL,'27 AVENUE ELI DE BEAUMONT','','','14340','ST AUBIN LEBIZAY',NULL,NULL,'1671114695002',386.000000000,'1992-04-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9126,'GENET','pierre','1940-03-05','02.15.65.12.55','06.43.67.42.38',NULL,'LIEU DIT"LE CHENET"','','','14000','CAEN',NULL,NULL,'1400361157002',1007.000000000,'1969-07-10','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9127,'TOURY','THERESE','1940-05-15','02.51.89.85.79','06.64.10.15.58',NULL,'3 BIS MAJOR GENERAL MOULTON','','','50340','LES PIEUX',NULL,NULL,'2400550224002',21.000000000,'1966-03-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9128,'LEVAL','Marcel','1932-08-21','02.26.32.40.00','06.29.89.21.26',NULL,'74 rue des epivas','','','14690','PONT D''OUILLY',NULL,NULL,'1320814736002',434.000000000,'1957-04-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9129,'VINCENT','Corinne','1941-01-06','02.18.55.97.26','06.63.38.87.18',NULL,'3 ALLEE MARC LACOUR','','','14430','DOZULE',NULL,NULL,'2410150131002',1879.000000000,'1964-10-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9130,'JULIEN','JEAN MICHEL','1955-05-05','02.80.97.60.67','06.93.18.91.73',NULL,'LE GRAND VILLAGE','','','14000','CAEN',NULL,NULL,'2550514007002',684.000000000,'1976-05-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9131,'VINCENT','RAYMOND','1929-07-14','02.74.20.21.37',NULL,NULL,'5 rue basse','','','14650','CARPIQUET',NULL,NULL,'1290714444002',2638.000000000,'1955-12-11','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9132,'THEBAULT','Frederique',NULL,'02.11.57.44.80','06.96.10.52.26',NULL,'4 RUE DES HORTENSIAS','','',NULL,NULL,NULL,NULL,'1541014106002',126.000000000,'2009-03-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9133,'SENAY','PIERRE','1929-02-04','02.37.30.91.99','06.43.22.70.29',NULL,'MAISON DE RETRAITE ST FERDINAND ','19/21 RUE MALFILATRE','','50800','ROUFFIGNY',NULL,NULL,'1290214290002',36.000000000,'1957-06-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9134,'HARIKENCHIKH','HENRI','1955-01-06','02.75.95.15.06','06.94.70.96.49',NULL,'26 RUE THERESE DE LA VARDE','','','14000','CAEN',NULL,NULL,'2550150491002',62.000000000,'1978-09-17','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9135,'LEFRANCOIS','REGIS','1959-01-19','02.89.53.08.32','06.59.93.61.48',NULL,'19 rue marechal joffre','','','14111','LOUVIGNY',NULL,NULL,'2590114685002',3329.000000000,'1984-02-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9136,'FOLLIOT','MICHEL','1930-05-19','02.43.26.10.45','06.52.26.04.35',NULL,'6 BOULEVARD DE LA REPUBLIQUE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2300514371002',78.000000000,'1951-07-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9137,'BENZOHRA','THERESE','1947-01-16','02.46.92.83.16','06.18.58.69.53',NULL,'5 RUE DU 6 JUIN','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'2470114133002',6.000000000,'1975-08-29','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9138,'TREHET','VERONIQUE','1964-10-02','02.78.21.79.95','06.15.13.53.98',NULL,'10 RUE FERNAND LEGER','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1641014364002',194.000000000,'1986-05-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9139,'BLANCHET','ANDRE','1954-10-09','02.90.03.12.27','06.95.26.00.13',NULL,'9 RUE DE LA CHESNAIE','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2541002016002',1116.000000000,'1977-11-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9140,'CHENEVARIN','PIERRE','1958-06-05','02.59.38.21.67','06.55.52.04.06',NULL,'LA FELIERE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1580650129002',128.000000000,'1979-01-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9141,'ADAM','YVETTE','1938-09-27','02.92.96.09.52','06.72.26.85.82',NULL,'la monneraie','','','14000','CAEN',NULL,NULL,'2380914397002',126.000000000,'1967-09-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9142,'LAURENT','MARYSE','1952-09-06','02.10.79.76.38','06.12.12.08.89',NULL,'2 RUE PAUL THOMASSE','','','14000','CAEN',NULL,NULL,'2520914324002',770.000000000,'1976-10-17','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9143,'LE MARCHAND','HUBERT','1963-07-18','02.86.94.64.03','06.70.69.28.51',NULL,'32 RUE DU CLOS DU MANOIR','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1630714432002',0.000000000,'1984-10-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9144,'BLOT','VIVIANE','1929-09-30','02.46.06.69.11','06.74.00.29.66',NULL,'8 RUE DE HOGUE','','','14610','CAIRON',NULL,NULL,'1290914271002',124.000000000,'1954-12-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9145,'MACHOU','Baptiste','1938-12-06','02.11.09.44.63','06.46.29.38.37',NULL,'9 RUE MICHEL LASNE','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1381214479002',133.000000000,'1961-03-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9146,'MARTINET','RENEE','1945-02-05','02.50.79.93.02','06.17.46.99.33',NULL,'32 RUE DES 3 BUTTES','','','61160','MONTABARD',NULL,NULL,'1450214142002',884.000000000,'1966-05-13','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9147,'MARTINET','CLAUDE','1964-06-12','02.98.14.92.87','06.72.33.71.67',NULL,'40 bis rue nationale','','','50000','ST LO',NULL,NULL,'2640614221002',76.000000000,'1991-01-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9148,'DAJOUX','Daniel','1958-05-04','02.96.62.78.68','06.49.66.37.67',NULL,'50 ROUTE DU FORT','','','14700','FALAISE',NULL,NULL,'2580514537002',83.000000000,'1982-05-07','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9149,'BAUMY','PHILIPPE','1932-08-31','02.58.86.61.59','06.60.16.91.84',NULL,'la moinerie','','','14630','CAGNY',NULL,NULL,'1320814663002',702.000000000,'1953-07-15','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9150,'HILL','Franoise','1951-04-08','02.87.88.81.98','06.70.98.19.38',NULL,'3 rue des jardins rouges','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'1510414319002',8.000000000,'1981-10-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9151,'BRISARD','','1932-11-15','02.10.55.77.63','06.19.41.33.86',NULL,'5 rte de gonneville','','','61200','ARGENTAN',NULL,NULL,'2321161091002',9.000000000,'1956-06-11','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9152,'MARTIN','JEAN-MICHEL','1932-11-29',NULL,NULL,NULL,'13 RUE CHAUSSEE','','','61430','ATHIS DE L''ORNE',NULL,NULL,'2321161091002',984.000000000,'1954-11-11','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9153,'PUYRAVEAU','Ginette','1943-05-06','02.34.05.03.40','06.24.01.19.64',NULL,'2 rue du cahot','','','14160','DIVES SUR MER',NULL,NULL,'2430561320002',196.000000000,'1971-11-18','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9154,'CHAUVEAU','Anne Marie','1933-05-24','02.27.67.66.74',NULL,NULL,'9 RUE DU RUET','','','14320','FONTENAY LE MARMION',NULL,NULL,'1330514515002',965.000000000,'1955-12-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9155,'OTHON','JACQUES','1941-05-07','02.81.35.58.02','06.54.43.90.06',NULL,'14 rue de stockstadt','','','14000','CAEN',NULL,NULL,'1410514549002',285.000000000,'1965-04-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9156,'PESQUEREL','ANELIA','1934-08-17','02.79.66.73.19','06.11.46.48.99',NULL,'111 RUE D''AUGE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2340814600002',147.000000000,'1963-05-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9157,'DE BERRANGER','LUCIENNE','1958-02-08','03.62.73.77.17','06.53.66.69.57',NULL,'17 rue du dr roux','','','62480','LE PORTEL',NULL,NULL,'1580214257002',17.000000000,'1981-04-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9158,'DELAPORTE','ANDRE','1951-04-15','02.54.85.45.59','06.63.80.51.09',NULL,'3 rue la perquette','','','14730','GIBERVILLE',NULL,NULL,'1510414245002',1093.000000000,'1976-05-21','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9159,'VINCENT','MICHELINE','1958-12-22','02.11.83.11.97','06.52.71.45.51',NULL,'57 RUE DU CHANOINE POREE','','','14990','BERNIERES SUR MER',NULL,NULL,'2581262747002',122.000000000,'1988-08-27','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9160,'TRIGOUST','Jacqueline','1928-05-07','02.53.75.66.74',NULL,NULL,'24 RUE DE BOUVINES','','','14840','CUVERVILLE',NULL,NULL,'2280514258002',281.000000000,'1951-12-21','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9161,'VARANGUE','Marie Paulette','1965-04-01','02.18.73.93.09','06.11.87.03.32',NULL,'160 RUE GAL MOULIN','','','14390','CABOURG',NULL,NULL,'1650461276002',14.000000000,'1988-02-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9162,'VARANGUE','Dominique','1959-07-28','02.16.86.13.16','06.10.89.78.87',NULL,'','','','14240','CAHAGNES',NULL,NULL,'1590750187002',105.000000000,'1989-09-08','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9163,'COLOMBIER','Marie Claude','1956-03-08','02.53.15.84.43','06.10.53.57.89',NULL,'','','','14170','L''OUDON',NULL,NULL,'1560350480002',373.000000000,'1978-02-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9164,'CLEMENT','Annick','1963-06-07','02.40.61.54.43','06.32.86.99.52',NULL,'22 RUE DE LA DEMI LUNE','','','14730','GIBERVILLE',NULL,NULL,'1630614118002',4293.000000000,'1985-04-07','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9165,'AVELINE','MARCEL','1930-06-02','02.20.39.28.56','06.64.33.88.46',NULL,'30 rue de la liberte','','','14630','FRENOUVILLE',NULL,NULL,'2300661023002',120.000000000,'1951-11-09','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9166,'GOSSET','JOEL','1969-05-05','02.74.82.76.09',NULL,NULL,'RESIDENCE LE PRE  1,AVENUE DE FO','UCAULT','','14000','CAEN',NULL,NULL,'2690514437002',60.000000000,'1997-06-05','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9167,'HEURTEBISE','JOSETTE','1954-09-06','02.28.08.56.74',NULL,NULL,'MANOIR DES COURS D''ORMES','','','14790','VERSON',NULL,NULL,'2540927364002',42.000000000,'1982-04-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9168,'BOUSSET','MAURICE','1959-06-23','02.57.79.98.60','06.16.47.02.53',NULL,'7 place des tourelles','','','14370','VIMONT',NULL,NULL,'1590614039002',186.000000000,'1980-10-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9169,'FONTAINE','ALAIN','1958-07-25','02.36.97.55.23','06.67.34.15.95',NULL,'3 place louise de marillac','','','14000','CAEN',NULL,NULL,'2580714674002',13.000000000,'1979-08-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9170,'BENARD','MICHEL','1953-02-14','02.10.33.09.90','06.20.39.49.74',NULL,'route de grancamp','','','14100','COURTONNE LA MEURDRAC',NULL,NULL,'2530250297002',637.000000000,'1977-03-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9171,'LIOULT','THERESE','1961-04-16','02.91.66.19.70','06.31.01.27.06',NULL,'9 RUE DES ORMES','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1610461157002',156.000000000,'1991-08-23','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9172,'GUILLAUME','DANIEL','1957-02-18','02.49.87.36.89','06.83.29.22.46',NULL,'42 rue du village','','','14000','CAEN',NULL,NULL,'1570214698002',62.000000000,'1987-02-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9173,'NEHOU','JACQUELINE','1960-03-12','02.40.92.45.14','06.77.32.42.46',NULL,'27 rue albert camus','','','14400','BAYEUX',NULL,NULL,'1600314173002',13.000000000,'1988-09-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9174,'BAREA','ODILE','1959-11-09','02.11.30.75.21','06.21.28.51.29',NULL,'hameau de la gare','','','14000','CAEN',NULL,NULL,'1591114635002',603.000000000,'1984-06-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9175,'GENISSON','CLAUDE','1934-03-08','02.11.62.12.14','06.32.36.57.03',NULL,'34 RUE BARBEUX','','','14123','IFS',NULL,NULL,'1340314456002',164.000000000,'1960-02-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9176,'DE THIBOUT','RAYMOND','1931-06-23','02.58.57.55.83','06.10.37.20.26',NULL,'41 RUE DES ECUYERS','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2310642287002',4.000000000,'1957-02-14','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9177,'CHARBONNIER','Anne Marie','1936-02-03','02.19.37.08.10','06.46.70.20.71',NULL,'33 rue de l esperance','','','14240','SERMENTOT',NULL,NULL,'2360250563002',207.000000000,'1964-03-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9178,'MARIE','Ccile','1939-02-08','02.91.20.69.53','06.95.38.84.99',NULL,'13 boulevard de l''esperance','','','14000','CAEN',NULL,NULL,'2390253079002',175.000000000,'1968-05-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9179,'MAQUEREL','ROLANDE','1951-01-12','02.27.64.70.07','06.59.68.65.23',NULL,'5 rue du loup pendu','','','61570','MARCEI',NULL,NULL,'1510102039002',30.000000000,'1972-03-13','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9180,'MELECK','MARIE ANNE','1930-11-05','02.85.32.94.19','06.18.13.22.76',NULL,'25 rue de l haye','','','14111','LOUVIGNY',NULL,NULL,'2301114347002',657.000000000,'1952-11-03','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9181,'LE NOEL','ANNIC','1931-09-11','02.47.58.15.13','06.47.38.14.85',NULL,'route de boulon','','','14610','CAMBES EN PLAINE',NULL,NULL,'2310914452002',1.000000000,'1952-09-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9182,'BEN CHELH','EMILE','1963-07-27','02.79.43.92.96','06.16.24.82.90',NULL,'2 bis rue des jardins','','','14000','CAEN',NULL,NULL,'1630714432002',85.000000000,'1989-07-22','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9183,'LARMOIRE','PIERRE','1950-02-08','02.57.54.72.42','06.59.68.60.10',NULL,'47 rue jules ferry','','',NULL,NULL,NULL,NULL,'2500214456002',130.000000000,'1978-02-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9184,'COQUEREL','MICHELLE','1953-05-31','02.26.46.99.56','06.56.98.52.37',NULL,'13 RUE DES GRES','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'1530514688002',551.000000000,'1978-10-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9185,'LEPAULOUX','Ren','1944-01-01','02.12.72.56.20','06.73.16.56.31',NULL,'chemin du rouillis n12','','','14400','ST VIGOR LE GRAND',NULL,NULL,'2440114257002',609.000000000,'1966-12-19','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9186,'BROCQ','Simone','1965-04-11','02.10.20.29.92','06.21.45.55.17',NULL,'11 RUE DES BASSES TERRES','','','14120','MONDEVILLE',NULL,NULL,'1650427487002',143.000000000,'1992-04-08','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9187,'MARIE','ODILE','1959-04-24','02.30.96.53.72','06.35.63.13.34',NULL,'4 LE CHEMIN VERT','','',NULL,NULL,NULL,NULL,'1590414456002',25.000000000,'1988-01-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9188,'DEVAUX','MONIQUE','1937-03-07','02.24.37.21.94','06.51.58.10.28',NULL,'6 RUE ST JEAN DES BOIS','','','50440','JOBOURG',NULL,NULL,'2370314092002',29.000000000,'1961-12-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9189,'CAILLE','FABIENNE','1954-01-25','02.24.09.05.00','06.97.98.78.41',NULL,'20 RUE LEONARD GILLES','','','14730','GIBERVILLE',NULL,NULL,'1540114090002',7.000000000,'1977-02-07','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9190,'CHATELAIS','MONIQUE','1926-06-29','02.44.19.50.30','06.80.15.57.09',NULL,'14 rue st andre bat 5','','','14190','URVILLE',NULL,NULL,'1260663397002',15.000000000,'1953-06-16','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9191,'LOMAZZI','NADEGE','1969-10-23','02.61.58.61.95','06.61.66.19.51',NULL,'21 rue de cormelles','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'2691078311002',390.000000000,'1999-11-26','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9192,'DUBOIS','JEAN PIERRE','1941-04-13','02.57.54.74.51',NULL,NULL,'26 rue S. villard','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1410414294002',46.000000000,'1969-05-01','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9193,'DE FREITAS MENDES','GISELE','1978-04-08','02.57.38.11.85','06.70.82.61.89',NULL,'4 PLACE DE L''HOTEL DE VILLE','','','14000','CAEN',NULL,NULL,'1780499302002',4732.000000000,'1999-09-11','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9194,'WISNIEWSKI','Maurice','1934-04-18','02.28.27.71.26','06.57.98.59.56',NULL,'31 RUE DE CALIX','','','14240','LIVRY',NULL,NULL,'2340414073002',27.000000000,'1957-07-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9195,'LEVREL','Odette',NULL,'02.65.62.26.26','06.17.78.45.26',NULL,'7 rue des pommiers','','','61200','ARGENTAN',NULL,NULL,'1290914481002',71.000000000,'2008-09-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9196,'LEMESLE','Lon','1940-03-19','02.49.29.29.33','06.36.20.50.24',NULL,'9 rue branly','','','14700','ST PIERRE DU BU',NULL,NULL,'1400314763002',1603.000000000,'1964-11-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9197,'AVENEL','Annie','1933-03-06','02.84.61.59.18','06.24.02.07.70',NULL,'14 rue du 6 juin','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2330314295002',1017.000000000,'1959-07-20','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9198,'DUDOUIT','BERNARD','1931-03-31','02.37.50.21.49','06.16.19.86.93',NULL,'30 rue gustave flaubert','','','14470','GRAYE SUR MER',NULL,NULL,'1310361199002',590.000000000,'1957-03-04','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9199,'GERVAIS','Roland','1949-09-13','02.11.83.99.93','06.94.10.13.63',NULL,'325 rue de falaise cada bp1254','','','14320','FONTENAY LE MARMION',NULL,NULL,'1490950264002',18.000000000,'1975-12-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9200,'ROUSSEAU','YVES','1947-06-26','02.83.92.25.97','06.35.11.09.61',NULL,'29 RUE DAMOZANE','','','14480','BANVILLE',NULL,NULL,'2470614349002',643.000000000,'1975-02-07','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9201,'PECH','JEAN MICHEL','1941-07-23','02.52.43.63.59','06.70.28.13.74',NULL,'5 RUE DES CHARDONNERETTES','','','61440','MESSEI',NULL,NULL,'2410798818002',180.000000000,'1965-04-18','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9202,'NARDY','Henri',NULL,'02.86.87.78.35','06.37.65.84.08',NULL,'5 RUE DU MAINE','','','14700','FALAISE',NULL,NULL,'1360363338002',49.000000000,'2013-03-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9203,'LOYAN','Suzanne','1934-09-22','02.80.15.50.53','06.66.16.73.33',NULL,'190  RUE PIERRE CORNEILLE','','','14330','LE MOLAY LITTRY',NULL,NULL,'2340976414002',5.000000000,'1960-01-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9204,'LABONNE','Marcel','1944-03-06','02.72.18.26.14','06.10.22.20.11',NULL,'LA GAILLARDIERE','','','14320','MAY SUR ORNE',NULL,NULL,'1440314114002',1122.000000000,'1966-10-08','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9205,'MORIN','Philippe','1952-05-18','02.89.16.41.45','06.98.79.00.68',NULL,'70 av de rouen','','','14400','CONDE SUR SEULLES',NULL,NULL,'2520514619002',332.000000000,'1974-04-16','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9206,'ALEXANDRE','Claire','1947-03-19','02.82.89.34.94','06.85.91.62.91',NULL,'8 RUE DES TILLEULS','','','14210','BARON SUR ODON',NULL,NULL,'2470314221002',8.000000000,'1974-10-20','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9207,'MORTIER','ANNIE','1961-10-23','02.84.57.84.15','06.65.08.98.83',NULL,'7 RUE D''OLENDON','','','14460','COLOMBELLES',NULL,NULL,'1611027298002',943.000000000,'1989-08-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9208,'DEMONIE','NICOLE','1930-05-06','02.88.60.29.52','06.78.92.92.65',NULL,'4 rue du capitaine foucher','','','14840','DEMOUVILLE',NULL,NULL,'2300514538002',20.000000000,'1956-08-26','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9209,'SEYFARTH','','1930-07-18','02.72.61.41.55','06.10.05.54.45',NULL,'10 rue de beaulieu','','','14670','ST SAMSON',NULL,NULL,'2300714100002',27.000000000,'1952-04-15','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9210,'MANCEAU','CATHERINE','1937-08-24','02.79.75.09.55','06.67.51.64.36',NULL,'15 QUAI DE LA LONDE','','','14370','ARGENCES',NULL,NULL,'1370814066002',35.000000000,'1963-12-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9211,'GOSSET','CATHERINE','1940-06-10','02.18.35.41.00','06.20.23.78.60',NULL,'LA MAISON BLANCHE','','','14860','BAVENT',NULL,NULL,'1400614167002',12.000000000,'1967-04-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9212,'BRUNET','YVES','1929-10-25','02.66.72.92.16','06.21.54.14.91',NULL,'4 rue de l''eglise','','','14000','CAEN',NULL,NULL,'1291014150002',557.000000000,'1954-02-17','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9213,'LESQUEY','DANIEL','1942-05-06','02.49.86.06.65','06.93.15.38.79',NULL,'LE MARQUENTIN','','','14860','RANVILLE',NULL,NULL,'1420514616002',191.000000000,'1963-06-27','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9214,'SCELLES','MARIE THERESE','1950-08-13','02.88.28.72.59','06.37.08.55.59',NULL,'LA CHESNAIE','','','27500','CORNEVILLE SUR RISLE',NULL,NULL,'2500814015002',914.000000000,'1971-05-03','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9215,'ROUSSEAU','Monique','1948-07-28','02.15.72.99.02','06.11.91.44.82',NULL,'14 rue d angletaire','','','14770','ST PIERRE LA VIEILLE',NULL,NULL,'1480714307002',1723.000000000,'1976-01-21','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9216,'ROYNARD','GUY','1938-02-14','02.60.01.77.18','06.86.55.84.10',NULL,'LES SARRASINS','','','14430','BRANVILLE',NULL,NULL,'2380214530002',83.000000000,'1964-07-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9217,'VASSEUR','JOSETTE','1938-12-27','02.10.46.02.53','06.17.77.91.02',NULL,'7 rue du commerce','','','14000','CAEN',NULL,NULL,'1381214198002',766.000000000,'1960-12-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9218,'ROYER','MICHEL','1930-04-11','02.11.23.11.92','06.19.70.79.60',NULL,'7 rue de la republique','','','14850','ESCOVILLE',NULL,NULL,'1300414119002',463.000000000,'1959-09-04','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9219,'BARRIERE','GEORGES','1931-10-22','02.21.14.61.61','06.44.52.64.91',NULL,'MESNIL VILLEMENT','','','14000','CAEN',NULL,NULL,'2311014015002',852.000000000,'1960-10-27','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9220,'LECHANGEUR','THERESE','1938-04-25','02.73.61.98.70','06.18.46.09.59',NULL,'11 RUE HAMEAU DE FOUR','','','14320','FONTENAY LE MARMION',NULL,NULL,'1380499227002',158.000000000,'1966-06-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9221,'TRICOT','ARIOST','1927-09-10','02.11.23.99.55','06.11.60.70.19',NULL,'13 cote du val','','','14150','OUISTREHAM',NULL,NULL,'1270903003002',6.000000000,'1951-11-24','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9222,'NDOME KWA','CHANTAL','1964-01-24','02.85.73.63.56','06.10.74.47.50',NULL,'3 RUE DU 6 JUIN','','','14370','BILLY',NULL,NULL,'2640114514002',4182.000000000,'1993-04-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9223,'CHEVREAU','CHRISTIANE','1964-01-24','02.33.31.88.82','06.24.76.08.05',NULL,'LE HAMEL','','','14430','DANESTAL',NULL,NULL,'2640114514002',1651.000000000,'1994-11-29','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9224,'SIMEON','daniel','1932-04-23','02.86.05.07.71','06.20.85.76.20',NULL,'4 rue c foucher','','','14000','CAEN',NULL,NULL,'1320450543002',52.000000000,'1953-05-19','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9225,'MASSON','NICOLE','1952-02-23','02.76.70.21.54','06.10.78.82.87',NULL,'1202 quartier grande delle','','','14280','ST CONTEST',NULL,NULL,'1520214119002',11.000000000,'1978-12-02','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9226,'LEMOYNE','MONIQUE','1960-01-07','02.50.86.96.22','06.23.67.15.76',NULL,'chemin videe','','','14120','MONDEVILLE',NULL,NULL,'2600114587002',784.000000000,'1987-03-25','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9227,'BERLAND','JOSEPH','1964-08-27','02.84.24.79.51','06.13.44.68.43',NULL,'26 avenue lon bloom','','','14940','BANNEVILLE LA CAMPAGNE',NULL,NULL,'2640814637002',21.000000000,'1993-05-25','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9228,'BERLAND','MARIE MADELEINE','1946-05-22','02.25.99.55.47','06.67.65.72.19',NULL,'la vallee','','','14840','DEMOUVILLE',NULL,NULL,'1460561233002',126.000000000,'1967-11-22','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9229,'BOUDJIDIR','PHILIPPE','1930-01-10','02.88.65.45.73','06.51.18.19.43',NULL,'3 rue du marche','','','14650','CARPIQUET',NULL,NULL,'1300114133002',971.000000000,'1957-04-20','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9230,'DUCASSE','SERGE','1937-07-31','02.11.13.11.74',NULL,NULL,'30 RUE DES ECUREUILS','','','61790','ST PIERRE DU REGARD',NULL,NULL,'1370753151002',1111.000000000,'1965-12-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9231,'MARET','ROGER','1965-10-23','02.29.45.92.08','06.93.75.89.71',NULL,'gournay','','','50300','AVRANCHES',NULL,NULL,'1651014319002',779.000000000,'1995-03-02','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9232,'VOGT','','1951-02-21','02.10.84.80.38','06.55.49.74.90',NULL,'LIEU DIT"LA PORTE"','','','14123','IFS',NULL,NULL,'1510214232002',29.000000000,'1980-03-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9233,'CABART','DIDIER','1956-12-04','02.34.83.10.42','00 33 6.95.48.43.62',NULL,'7 rue jean jaures','','','50140','MORTAIN',NULL,NULL,'1561214118002',27.000000000,'1981-01-17','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9234,'VOISIN','DOMINIQUE','1930-03-17','02.53.02.75.29','06.35.01.22.88',NULL,'9 rue notre dame des champs','','','14630','CAGNY',NULL,NULL,'2300314145002',2360.000000000,'1959-05-05','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9235,'ROUSSEL','guy','1962-05-19','02.39.40.17.60','06.73.42.95.01',NULL,'La Siaule','','','14780','LION SUR MER',NULL,NULL,'2620514663002',248.000000000,'1983-01-31','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9236,'PIGNOL','PAULETTE','1948-05-18','02.58.53.46.17','06.22.45.65.67',NULL,'19 rue du 6 juin','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1480514444002',52.000000000,'1971-10-17','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9237,'GILLETTE','christian','1943-06-21','02.53.47.71.75','06.77.93.00.81',NULL,'9 RUE DU RUET','','','61150','ECOUCHE',NULL,NULL,'1430661110002',37.000000000,'1972-06-16','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9238,'DOMBROVSKI','Michel','1969-11-22','02.10.69.20.87','06.89.99.65.45',NULL,'24 ALLEE DES POETES','','','50300','AVRANCHES',NULL,NULL,'1691114685002',4.000000000,'1992-11-12','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9239,'FROEHLY','Christian','1970-01-19','02.29.49.36.93','06.77.20.57.45',NULL,'72 RUE ERNEST MANCHON','','','14670','BURES SUR DIVES',NULL,NULL,'2700161145002',36.000000000,'1993-09-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9240,'MARTIE PEYTAVIT','ANDREE','1952-09-16','02.54.18.97.86','06.59.54.28.77',NULL,'20 RUE HAUTE BONNY','','','14120','MONDEVILLE',NULL,NULL,'1520914693002',42.000000000,'1973-04-11','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9241,'TRICARD','MADELEINE','1968-12-07','02.71.97.72.31','06.10.64.70.13',NULL,'LE HAUT DE CALIGNY','','','14540','BOURGUEBUS',NULL,NULL,'1681291105002',43.000000000,'1990-08-15','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9242,'VILLEROY','AGNES','1937-01-11','02.26.19.25.39','06.29.84.55.90',NULL,'41 RUE ERNEST MANCHON','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1370114167002',42.000000000,'1966-04-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9243,'MAUREY','PIERRE','1936-10-30','02.12.26.52.79','06.79.53.70.31',NULL,'20 rue leonard gilles','','','14700','FALAISE',NULL,NULL,'2361014462002',576.000000000,'1961-11-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9244,'QUERUEL','Eric','1935-08-18','02.74.02.50.85',NULL,NULL,'15 BOULEVARD CARNOT','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2350827218002',102.000000000,'1958-06-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9245,'LABBE','DOMINIQUE','1943-01-13','02.64.20.86.42','06.42.58.06.82',NULL,'29 RUE ARISTIDE BRIAND','','','14000','CAEN',NULL,NULL,'2430135253002',235.000000000,'1965-03-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9246,'DEQUAINDRY','CHRISTIAN','1932-04-18','02.85.11.94.60','06.20.31.57.30',NULL,'1 RESIDENCE ST GERBOLD 13 RUE CO','NSTANT FORGET','','14000','CAEN',NULL,NULL,'2320427229002',2988.000000000,'1957-08-01','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9247,'VALLANCE','georgette','1928-04-04','02.10.80.25.44','06.11.78.15.62',NULL,'13 rue jacques brel','','','14280','ST CONTEST',NULL,NULL,'1280414301002',112.000000000,'1955-08-10','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9248,'LEFEBVRE','Andr','1958-05-18','02.50.37.90.27','06.10.60.68.85',NULL,'11 allee des fusilliers montroya','l','','14120','MONDEVILLE',NULL,NULL,'1580576420002',1532.000000000,'1986-04-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9249,'OZDAMAR','SIMONE','1954-01-22','02.23.50.98.30','06.32.38.48.65',NULL,'LA CROIX SONNET','','','14790','MOUEN',NULL,NULL,'1540150371002',38.000000000,'1982-02-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9250,'CLEMENCEAU','ARLETTE','1928-07-24','02.56.91.67.62','06.33.91.02.35',NULL,'LE LIEU ST MARC','','','14123','FLEURY SUR ORNE',NULL,NULL,'1280714167002',395.000000000,'1951-09-11','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9251,'VAN BRABANT','JEAN PIERRE','1985-01-19','02.79.68.22.46','06.58.77.31.96',NULL,'25 RUE DU LONG BOUET','','','14860','BAVENT',NULL,NULL,'1850199344002',407.000000000,'2010-12-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9252,'MAUGER','ARTHUR','1930-10-03','02.21.83.31.60','06.89.56.11.78',NULL,'2 hameau de la guinguette','','','14123','FLEURY SUR ORNE',NULL,NULL,'2301037261002',85.000000000,'1959-02-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9253,'CHRETIEN','YVETTE','1919-11-26','02.41.66.72.07','06.12.05.33.72',NULL,'8 rue henry dunand','','','14330','LE MOLAY LITTRY',NULL,NULL,'1191114135002',2420.000000000,'1943-08-29','PREMIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9254,'HEUZEY','NORBERT',NULL,'02.53.42.30.20','06.10.98.34.86',NULL,'3 impasse des bleuets','','','14670','ST SAMSON',NULL,NULL,'2702099344002',218.000000000,'2008-01-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9255,'LEBRETON','ROBERT','1939-08-19','02.32.99.54.21','06.62.40.27.71',NULL,'6 rue du capitaine kalligny grek','o','','14540','BOURGUEBUS',NULL,NULL,'1390814266002',9.000000000,'1961-10-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9256,'JIBLADZE','AIME','1958-01-01','02.85.38.37.77','06.12.59.35.68',NULL,'73 rue anatole france','','','14860','BAVENT',NULL,NULL,'2580114046002',1324.000000000,'1986-07-02','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9257,'GUIBERT','NADIA',NULL,'02.69.94.62.19','06.76.94.81.03',NULL,'33 RUE CAILLEMER','','','14000','CAEN',NULL,NULL,'2702099344002',5.000000000,'2008-07-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9258,'GUIBERT','CHRISTIANE','1937-05-29','02.84.14.82.63','06.11.80.27.64',NULL,'33 rue caillemer','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1370514347002',57.000000000,'1960-04-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9259,'KORMILITCHEVA','ROGER','1943-04-26','02.26.38.96.76','06.26.85.46.05',NULL,'ruelle de la redetiere','','','14840','DEMOUVILLE',NULL,NULL,'1430414432002',28.000000000,'1965-02-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9260,'ROUSSELET','JEAN','1958-11-23','02.23.63.67.21','06.63.87.08.77',NULL,'15 rue du 6 juin','','','14270','MEZIDON CANON',NULL,NULL,'1581175104002',9.000000000,'1983-01-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9261,'WALLE','SYLVIANE','1952-02-16','02.60.66.90.93','06.45.48.65.63',NULL,'1 rue des canadiens','','','14123','IFS',NULL,NULL,'1520214305002',807.000000000,'1974-01-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9262,'KILINC','MARIE THERESE','1935-12-11','02.62.47.08.45','06.75.02.18.06',NULL,'12 AVENUE  DES CAPELLES','','','14370','BELLENGREVILLE',NULL,NULL,'2351250197002',1020.000000000,'1964-07-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9263,'SAFFRE','laurent','1940-02-10','02.10.74.68.52',NULL,NULL,'5 RUE DES COURLIS','','','14570','ST LAMBERT',NULL,NULL,'1400288011002',24.000000000,'1965-08-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9264,'LEBOURGEOIS','JEANNINE','1942-10-07','02.62.26.16.27','06.18.44.70.71',NULL,'1 bis rue du soir','','','14123','IFS',NULL,NULL,'1421062518002',128.000000000,'1963-12-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9265,'GALODET','JOEL','1962-05-21','03.81.31.03.61','06.11.73.90.33',NULL,'25 rue des merisiers','','','51100','REIMS',NULL,NULL,'2620514046002',1071.000000000,'1985-11-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9266,'COIFFIER','Ginette','1954-01-16','02.85.81.30.36','06.51.03.44.88',NULL,'23 rue froide','','','14120','MONDEVILLE',NULL,NULL,'1540150356002',22.000000000,'1976-09-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9267,'NEEL','CLAUDETTE','1966-11-21','02.21.10.04.67','06.11.13.24.26',NULL,'24 avenue du Gnral Leclerc','','','14390','CABOURG',NULL,NULL,'1661114069002',37.000000000,'1987-09-12','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9268,'PAWLOWSKI','Yvette',NULL,'02.63.13.66.44','06.30.07.77.20',NULL,'2 RUE DES MONTS RENOUF','','','61330','CEAUCE',NULL,NULL,'2661150129002',722.000000000,'2010-07-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9269,'ALLEYNE','Liliane','1930-05-24','02.90.69.80.20','06.12.35.81.05',NULL,'VILLAGE SENECAL','','','14610','BASLY',NULL,NULL,'2300553161002',1244.000000000,'1958-04-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9270,'FREROT','JEAN','1942-10-26','02.13.71.61.67','06.71.62.57.62',NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1421014665002',156.000000000,'1967-10-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9271,'MONGREVILLE','','1957-07-08','02.17.62.07.00','06.51.43.66.92',NULL,'','','','50360','BEUZEVILLE LA BASTILLE',NULL,NULL,'2570780132002',10.000000000,'1979-06-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9272,'MARTIAL','JEAN CLAUDE','1938-10-04','02.12.87.92.55','06.10.63.26.60',NULL,'6 RUE DES LILAS','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2381014437002',2775.000000000,'1965-12-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9273,'TUYTTEN','DANIEL','1942-10-14','02.62.76.83.21','06.12.31.19.32',NULL,'22 AVENUE DE LA CONCORDE  APPT 6','9','','14240','SEPT VENTS',NULL,NULL,'1421014665002',126.000000000,'1965-12-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9274,'CHIRON','CHRISTIANE','1930-03-21','02.47.52.39.64','06.36.86.37.06',NULL,'22 BIS rue aristide briand','','','14123','IFS',NULL,NULL,'2300314157002',87.000000000,'1960-10-19','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9275,'ROMAIN','GISELE','1931-03-14','02.56.44.09.23','06.10.37.35.44',NULL,'14 RUE MARGUERITE DURAS','','','14370','ARGENCES',NULL,NULL,'2310322262002',672.000000000,'1956-06-10','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9276,'SUREST','YVES',NULL,'02.76.54.31.65','06.96.49.82.24',NULL,'LE PETIT  BOEL','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1360645145002',76.000000000,'2012-07-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9277,'FOUCHER','GEORGETTE','1967-01-24','02.29.56.24.18','06.41.57.33.68',NULL,'33 rue st norbert','','','14012',NULL,NULL,NULL,'2670114118002',36.000000000,'1990-06-02','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9278,'PERCHEY','JOSEPH','1967-02-18','02.84.74.84.12',NULL,NULL,'35 RUE DES CAILLOUINS','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1670227151002',50.000000000,'1994-06-17','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9279,'CHATELAIS','JEAN CLAUDE','1962-07-01','02.94.36.42.97','06.46.55.11.29',NULL,'14 ALLEE DES ARTS','','','14123','FLEURY SUR ORNE',NULL,NULL,'2620714026002',115.000000000,'1985-03-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9280,'BIENDINE','Jobline','1933-04-22','02.89.76.83.24','06.51.87.66.07',NULL,'12 impasse de la gronde','','','14500','VIRE',NULL,NULL,'2330414497002',865.000000000,'1956-03-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9281,'GATELET','ROSE MARIE','1928-07-13','02.93.34.98.32','06.12.22.09.42',NULL,'17 RESIDENCE DES POMMIERS','','','14120','MONDEVILLE',NULL,NULL,'2280714456002',18.000000000,'1951-11-16','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9282,'HODIERNE','CLAUDE','1950-07-18','02.98.85.39.79','06.49.29.42.98',NULL,'44 RUE DU BOIS DE CLAQUET','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1500714086002',1799.000000000,'1972-08-02','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9283,'DUVAL','FABRICE','1957-11-05','02.89.07.73.50','06.36.95.25.12',NULL,'12 ALLEE DES AUBEPINES','','','14123','IFS',NULL,NULL,'1571114249002',27.000000000,'1981-12-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9284,'VARNIERE','GERARD','1962-05-29','02.11.81.17.97','06.30.03.79.97',NULL,'8 RUE DES IRIS','','','14370','ARGENCES',NULL,NULL,'1620514237002',206.000000000,'1983-08-28','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9285,'REBEYROL','MAUDE','1954-01-08','02.91.42.00.48','06.96.66.97.19',NULL,'8 RUE DES SOURCES','','','14400','BAYEUX',NULL,NULL,'1540187161002',204.000000000,'1980-07-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9286,'BOURDIN','veronique','1951-04-06','02.11.14.91.29','06.16.03.19.96',NULL,'7 RUE DU CHEMINET','','','95200','SARCELLES',NULL,NULL,'2510414184002',88.000000000,'1981-04-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9287,'JAMES','Louis','1962-03-08','02.33.29.25.44','06.78.20.79.28',NULL,'CARREFOUR DE LA BOTTE','','','14000','CAEN',NULL,NULL,'1620314310002',16.000000000,'1983-08-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9288,'GERMAIN','GABRIELLE','1934-09-17','02.62.62.83.14','06.17.30.50.01',NULL,'11 RUE DE COPENAGHE','','','14160','DIVES SUR MER',NULL,NULL,'1340914717002',51.000000000,'1960-05-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9289,'CHEREAU','PATRICIA','1982-11-16','02.37.57.37.00','06.22.00.73.03',NULL,'4 rue de la pomme d''or','','','14000','CAEN',NULL,NULL,'1821199255002',238.000000000,'2012-01-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9290,'DUVAL','JEANINE','1957-04-30','02.12.28.77.27','06.93.92.43.45',NULL,'4 IMPASSE FRANCOIS CASSARD','','','14530','LUC SUR MER',NULL,NULL,'1570461324002',48.000000000,'1983-11-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9291,'GREGOIRE','FRANCOIS','1965-05-17','02.82.87.99.78','06.20.63.95.39',NULL,'7 rue de la valle','','','14500','VIRE',NULL,NULL,'2650514277002',1657.000000000,'1994-07-20','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9292,'CHELY','ANDRE','1960-10-29','02.93.15.27.53','06.11.25.54.57',NULL,'village le poussiard','','','14420','POTIGNY',NULL,NULL,'1601014447002',3891.000000000,'1981-05-23','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9293,'LAVERGNE','JACQUELINE','1937-05-04','02.78.49.45.17','06.69.88.40.66',NULL,'3 rue jules fleury','','','14540','HUBERT FOLIE',NULL,NULL,'1370550289002',18.000000000,'1966-08-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9294,'ALEXANDRE','IVAN','1934-04-02','02.11.94.96.10','06.14.36.25.33',NULL,'15 RUE DU REGIMENT DE LA CHAUDIE','RE','',NULL,NULL,NULL,NULL,'2340427542002',112.000000000,'1957-03-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9295,'DEJA','JOCELYNE','1939-01-22','02.64.36.33.38','06.12.34.51.51',NULL,'7 RUE DE LA CITE MINIERE','','','61220','BRIOUZE',NULL,NULL,'1390103100002',1081.000000000,'1968-07-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9296,'BOURGOIN','MICHELINE','1962-07-03','02.18.29.43.17','06.69.90.05.86',NULL,'78 ROUTE DE PARIS','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2620750473002',598.000000000,'1985-11-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9297,'SONNET','FRANCE','1966-04-06','02.29.68.71.93','06.98.61.45.23',NULL,'4 rue alfred nobel','','','14570','ST REMY',NULL,NULL,'1660478066002',180.000000000,'1988-03-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9298,'VILPREUX','MARIE CLAIRE','1945-01-07','02.83.45.84.53','06.59.30.53.88',NULL,'40 RUE 13 AOUT 1944','','','14860','BAVENT',NULL,NULL,'1450108198002',80.000000000,'1969-09-01','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9299,'DEGUETTE','ROLAND','1933-07-01','02.11.00.49.50','06.89.43.13.12',NULL,'64 b avenue guynemer','','','14000','CAEN',NULL,NULL,'2330727597002',1496.000000000,'1960-06-04','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9300,'ROBERT','MARIE','1929-11-02','02.82.29.19.79','06.58.06.28.70',NULL,'38 PL DE LA BAIE ST PIERRE','','','14123','IFS',NULL,NULL,'2291162447002',19.000000000,'1958-04-16','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9301,'AALLIOUX','GISELE','1960-05-29','02.11.52.11.64','06.42.19.25.79',NULL,'11 RUE DES GRANDES MURAILLES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2600514367002',39.000000000,'1990-08-05','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9302,'LEMARCHAND','andre','1948-05-25','02.12.26.57.66','06.81.97.32.28',NULL,'5 RUE SALVADOR ALLENDE','','','50110','BRETTEVILLE',NULL,NULL,'1480550545002',82.000000000,'1970-11-17','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9303,'NADEAU','SERGE','1944-02-11','02.10.92.25.91','06.80.17.92.65',NULL,'6 TER RUE DE LA CROIX ROUGE','','','14190','URVILLE',NULL,NULL,'1440214316002',103.000000000,'1967-04-06','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9304,'NADEAU','THERESE','1936-12-31','02.98.17.57.20','06.11.04.49.91',NULL,'11 pl fr bernard','','','14111','LOUVIGNY',NULL,NULL,'2361260143002',71.000000000,'1957-09-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9305,'GERMAIN DIT PINABEL','ANDRE','1949-08-16','02.75.56.28.75','06.70.72.14.39',NULL,'','','','14860','BREVILLE LES MONTS',NULL,NULL,'2490814042002',69.000000000,'1977-09-18','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9306,'CHENU','ROSELYNE','1938-11-08','02.54.76.20.55','06.21.23.86.40',NULL,'6 RUE MARCEL CACHIN','','','14500','VIRE',NULL,NULL,'1381177288002',938.000000000,'1965-11-26','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9307,'MARIE','GERARD','1938-05-20','02.73.42.91.49','06.43.95.46.59',NULL,'74 RUE DU MILIEU','','','14370','MOULT',NULL,NULL,'2380514050002',8.000000000,'1966-12-09','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9308,'LEBAS','catherine','1935-05-18','02.53.77.24.34','06.18.00.34.73',NULL,'104 RUE DE LA HEVE','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'2350514092002',1022.000000000,'1964-11-08','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9309,'LIENARD','ROGER','1944-03-24','02.49.84.43.66','06.27.62.56.39',NULL,'CHEMIN DE LA DELLE','','','50250','MONTGARDON',NULL,NULL,'1440314114002',2189.000000000,'1966-01-22','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9310,'SALLES','JULIEN','1945-11-03','02.52.33.01.25','06.45.74.40.90',NULL,'7 RUE DE STOCKOLM','','','27300','CAORCHES ST NICOLAS',NULL,NULL,'2451114760002',2509.000000000,'1969-07-19','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9311,'BLACHET','BERNADETTE','1941-01-02','02.90.27.61.72','06.57.69.91.61',NULL,'','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2410114035002',37.000000000,'1970-05-12','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9312,'HOUSSINI','Renee','1955-04-27','02.44.10.35.71','06.41.93.28.22',NULL,'3 BIS RUE EMILE ZOLA','','','14190','ST SYLVAIN',NULL,NULL,'2550427585002',59.000000000,'1981-07-21','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9313,'BABET','Marguerite','1955-02-16','02.46.58.29.50','06.52.30.82.09',NULL,'3 RUE BORIS VIAND','','','14390','CABOURG',NULL,NULL,'2550253013002',16.000000000,'1980-03-29','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9314,'TROCHERIE','YVETTE','1958-08-06','02.29.43.89.73','06.18.72.43.32',NULL,'80 rue de falaise','','','14270','LE MESNIL MAUGER',NULL,NULL,'2580814539002',56.000000000,'1980-03-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9315,'MERIENNE','ALINE','1935-03-20','02.84.35.79.59','06.26.10.00.91',NULL,'7 IMP DES COLVERTS','','','14190','ST SYLVAIN',NULL,NULL,'1350314030002',2128.000000000,'1957-04-18','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9316,'TARDIF','MONIQUE','1955-05-16','02.84.50.14.90','06.61.38.66.14',NULL,'27 RUE DU CLOS ST PIERRE','','','14123','IFS',NULL,NULL,'1550514177002',1498.000000000,'1979-09-14','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9317,'LEMIERE','FRANCINE','1939-05-31','02.43.36.73.39','06.21.96.11.14',NULL,'3 RUE DU 6 JUIN','','','14120','MONDEVILLE',NULL,NULL,'1390514408002',783.000000000,'1963-08-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9318,'DELOFFE','MONIQUE','1938-04-07','02.15.05.96.93','06.96.77.56.08',NULL,'LA GAUDINE','','','14540','SOLIERS',NULL,NULL,'2380414039002',126.000000000,'1961-08-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9319,'GUILLOU','YOLAND','1931-06-18','02.27.43.92.34','06.68.84.68.89',NULL,'1 albert camus','','','14120','MONDEVILLE',NULL,NULL,'1310614712002',2.000000000,'1952-03-30','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9320,'BLOT','MAURICE','1946-05-29','02.27.30.95.38','06.12.06.81.89',NULL,'hameau st richer','','','14220','THURY HARCOURT',NULL,NULL,'2460514623002',1.000000000,'1976-10-17','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9321,'CORDONNIER','PAUL','1942-05-27','02.79.03.74.90',NULL,NULL,'18 RUE REINE EDITH','','','61200','ARGENTAN',NULL,NULL,'1420514753002',439.000000000,'1963-05-19','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9322,'BOUQUEREL','JEAN BAPTISTE','1964-12-07','02.64.33.95.20','06.32.66.50.57',NULL,'LE CAMP DE PIE 109 RUE DES BUCAR','DE','','14730','GIBERVILLE',NULL,NULL,'2641214628002',78.000000000,'1994-11-06','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9323,'PAGNY','HELENE','1933-07-28','02.99.81.31.23','06.66.38.14.05',NULL,'30 rue h berlioz','','','14000','CAEN',NULL,NULL,'2330761002002',3.000000000,'1959-08-25','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9324,'STOURBE','','1938-02-17','02.64.47.84.80','06.52.60.72.21',NULL,'8 PLACE DE ROTTENDORFF','','','14790','VERSON',NULL,NULL,'1380214689002',216.000000000,'1968-04-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9325,'FRILEY','NORBERT','1948-05-25','02.55.44.67.01','06.50.86.93.93',NULL,'6 rue aux dimes','','','14670','ST SAMSON',NULL,NULL,'1480514546002',376.000000000,'1977-07-19','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9326,'BASNIER','J JACQUES','1938-07-15','02.75.52.24.85','06.12.30.56.94',NULL,'2 rue de la marne','','','14112','BIEVILLE BEUVILLE',NULL,NULL,'1380761376002',101.000000000,'1968-03-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9327,'LE PORS','JACQUELINE','1934-05-22','02.85.14.44.37','06.10.41.34.90',NULL,'18 rue du professeur gombeaux','','','14220','CROISILLES',NULL,NULL,'2340514296002',103.000000000,'1961-10-05','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9328,'HENOT','GEORGETTE','1960-05-21','02.70.52.47.91','06.40.37.70.82',NULL,'16 RUE JACK BREL','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2600514432002',916.000000000,'1990-06-28','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9329,'GHERTIL','ANDRE','1949-05-18','02.58.64.04.05','06.17.38.11.58',NULL,'9 RUE CAPITAINE GAUTIER','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1490550169002',2048.000000000,'1973-04-05','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9330,'BOUVIER','RAYMONDE','1933-02-10','02.24.19.24.87','06.33.77.08.83',NULL,'21 RUE HENRI DEGABEL','','','14250','DUCY STE MARGUERITE',NULL,NULL,'2330214437002',331.000000000,'1960-07-08','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9331,'JEANNE','','1939-02-10','02.12.31.08.79','06.27.78.86.58',NULL,'26 RUE DE LA TOURELLE','','','14860','AMFREVILLE',NULL,NULL,'1390210376002',323.000000000,'1960-01-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9332,'KRAAN','GUY','1933-04-10','02.78.03.69.94','06.22.78.45.02',NULL,'9 PLACE DES FRANCAIS LIBRES','','','14320','FONTENAY LE MARMION',NULL,NULL,'1330414666002',11.000000000,'1954-09-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9333,'CHATELIER','YVONNE','1956-06-23','02.64.10.38.12','06.39.70.62.00',NULL,'26 RUE TH POTTIER','','','14670','TROARN',NULL,NULL,'2560678542002',490.000000000,'1979-05-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9334,'BROCHUS','PASCAL','1933-01-15','02.14.42.81.04','06.35.01.56.19',NULL,'1 rue des Oppelias','','','14840','DEMOUVILLE',NULL,NULL,'1330114167002',1043.000000000,'1958-06-28','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9335,'BARBIER','JEAN PIERRE',NULL,'02.98.15.29.26','06.33.64.91.93',NULL,'','','','14150','OUISTREHAM',NULL,NULL,'2340150402002',309.000000000,'2013-07-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9336,'GROULT','GEORGETTE','1968-01-07','02.11.28.24.49','06.20.58.92.10',NULL,'20 avenue du six juin','','','14123','FLEURY SUR ORNE',NULL,NULL,'2680114060002',73.000000000,'1993-08-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9337,'VAUPRE','MICHEL','1928-06-28','02.11.11.08.45','06.16.67.93.62',NULL,'11 RUE DU BAC DU PORT','','','14270','MEZIDON CANON',NULL,NULL,'2280614579002',21.000000000,'1952-08-21','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9338,'RIDEAU','JACQUELINE','1958-07-05','02.24.70.21.71','06.93.89.33.94',NULL,'22 rue du val','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2580750557002',2779.000000000,'1982-04-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9339,'BOULAY','CHRISTIAN','1940-08-12','02.95.24.87.61','06.97.78.71.18',NULL,'7 RUE PORTE MILLET','','','14000','CAEN',NULL,NULL,'1400814241002',1038.000000000,'1962-06-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9340,'PHILIPPERON','Jacqueline',NULL,'02.28.39.44.43','06.42.56.33.01',NULL,'13 rue du maine','','','14680','GOUVIX',NULL,NULL,'2380414719002',52.000000000,'2011-01-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9341,'KHENTOUS','JEAN PIERRE','1945-01-18','02.76.91.12.65','06.44.51.43.73',NULL,'19 RUE DU QUARTIER','','','14250','LINGEVRES',NULL,NULL,'1450114437002',41.000000000,'1974-05-21','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9342,'PELCOT','MARIE LOUISE','1953-03-30','02.11.61.40.85','06.80.52.24.86',NULL,'2 impasse du herisson','','','14000','CAEN',NULL,NULL,'1530314623002',187.000000000,'1977-11-03','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9343,'PRUDENT','Anne marie','1958-05-14','02.28.98.28.06','06.14.88.08.81',NULL,'2 rue paul langevin','','','14120','MONDEVILLE',NULL,NULL,'1580561473002',4.000000000,'1987-07-24','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9344,'HEBERT','THERESE','1947-01-22','02.58.13.48.39','06.16.67.87.79',NULL,'17 COURS MIOQUE','','','14000','CAEN',NULL,NULL,'1470114543002',107.000000000,'1968-02-07','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9345,'GALLAIS','YVETTE','1939-05-31','02.19.82.54.36','06.91.95.74.38',NULL,'9 RUE DE L''ARMUCHE','','','61570','MORTREE',NULL,NULL,'1390514673002',449.000000000,'1961-05-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9346,'CATHERINE','CHRISTIAN','1942-03-28','02.75.83.43.97','00 33 6.69.14.86.62',NULL,'61 H  ROUTE DE BRETAGNE','','','14610','EPRON',NULL,NULL,'2420314454002',65.000000000,'1972-11-26','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9347,'LE ROUX','DIDIER','1949-01-26','02.88.08.71.29','06.19.31.39.01',NULL,'45 RUE LOUIS ROBILLARD','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1490150121002',969.000000000,'1979-11-04','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9348,'LEGENDRE','DANIELLE','1939-10-19','02.48.10.51.23','06.74.74.77.33',NULL,'163 rue d auge','','','14310','LONGVILLERS',NULL,NULL,'2391014277002',834.000000000,'1969-08-12','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9349,'GAUTIER','philippe','1925-02-23','02.11.92.46.45','06.21.33.89.60',NULL,'38 RUE DU BEL AIR','','','14430','CRICQUEVILLE EN AUGE',NULL,NULL,'1250275109002',15.000000000,'1955-12-10','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9350,'MENANT','Alain','1931-01-18','02.32.94.14.78','06.33.20.90.22',NULL,'LA VIGNE','','','14370','ARGENCES',NULL,NULL,'2310114271002',1934.000000000,'1958-03-13','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9351,'CAILLAUD','Alphonse','1969-06-12','02.48.64.67.59','06.14.31.61.77',NULL,'29 rue chagford','','','14270','LE MESNIL MAUGER',NULL,NULL,'1690650502002',156.000000000,'1991-11-24','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9352,'CULOT','MARTINE','1928-02-20','02.57.69.30.21','06.51.29.84.31',NULL,'13 rue du maine','','','14270','LE MESNIL MAUGER',NULL,NULL,'1280253084002',274.000000000,'1953-02-07','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9353,'LARCHER','annick','1937-01-10','02.90.46.10.34','06.29.75.12.28',NULL,'1 bld de reteul','','','14000','CAEN',NULL,NULL,'2370176161002',30.000000000,'1967-12-15','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9354,'LEMARCHAND','MARYANICK','1943-07-09','02.77.61.89.14','06.67.23.35.26',NULL,' la croix blanche l''oudon','','','14100','ST MARTIN DE LA LIEUE',NULL,NULL,'1430714103002',157.000000000,'1972-05-28','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9355,'FEIGNA','REMY','1935-05-28','02.11.29.61.55','06.17.92.09.32',NULL,'127 av jean jaures','','','61430','ATHIS DE L''ORNE',NULL,NULL,'2350514695002',409.000000000,'1964-08-13','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9356,'COLLET','JACKY','1966-08-25','02.82.43.93.79','06.10.23.11.30',NULL,'CHEMIN DE LA ROUTIERE','','','14790','VERSON',NULL,NULL,'2660814543002',76.000000000,'1996-02-20','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9357,'NOUAS','SOLANGE','1945-02-19','02.11.62.53.54','06.59.07.60.59',NULL,'22 rue voltaire','','','14114','VER SUR MER',NULL,NULL,'1450214719002',32.000000000,'1967-09-06','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9358,'TANGUY','JEAN CLAUDE','1978-06-23','02.81.30.95.61','06.32.45.05.70',NULL,'21 rue lucien bossoutrot','','','14123','IFS',NULL,NULL,'2780699324002',61.000000000,'2000-12-18','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9359,'FREMONT','GINETTE',NULL,'02.65.66.90.70','06.96.11.79.81',NULL,'havetot','','','14120','MONDEVILLE',NULL,NULL,'1620414525002',742.000000000,'2012-02-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9360,'BESLIN','DIDIER','1957-04-02','02.94.25.72.13','06.35.78.32.54',NULL,'10 RUE DU XXI EME SIECLE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'1570414579002',129.000000000,'1987-05-13','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9361,'DE MOURA','Michel','1928-11-19','02.90.49.34.63','06.13.78.72.40',NULL,'3 impasse des accacias','','','14190','FIERVILLE BRAY',NULL,NULL,'2281114260002',158.000000000,'1953-01-20','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9362,'BAZIRE','JACQUELINE','1950-03-18','02.14.93.40.08','06.12.33.55.45',NULL,'12 rue des lilas','','','14111','LOUVIGNY',NULL,NULL,'2500314525002',18.000000000,'1975-02-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9363,'COUSTIC','CATHERINE','1950-01-03','02.52.60.78.49','06.76.96.01.56',NULL,'LE MOULIN','','','14270','ECAJEUL',NULL,NULL,'1500114027002',132.000000000,'1980-06-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9364,'BERTI','THERESE','1954-02-24','02.68.84.16.50','06.98.22.99.25',NULL,'2-I AVENUE HENRY CHERON','','','14740','ST MANVIEU NORREY',NULL,NULL,'2540214287002',52.000000000,'1980-05-08','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9365,'LEMARIE','DANIEL','1978-06-16','02.12.26.32.27','06.10.67.32.12',NULL,'7 RUE HENRI CROCHET','','','50130','OCTEVILLE',NULL,NULL,'2780699324002',81.000000000,'2004-05-21','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9366,'DEVERNOIS','RAYMONDE','1969-10-12','02.63.18.34.20','06.44.39.70.49',NULL,'24 RUE PAUL BUCQUET','','','14000','CAEN',NULL,NULL,'2691078311002',717.000000000,'1994-05-12','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9367,'FERGANT','CLAUDINE','1934-08-29','02.79.66.50.96','06.28.26.82.92',NULL,'LE MOULIN','','','14570','ST REMY',NULL,NULL,'1340861310002',3034.000000000,'1955-05-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9368,'SIMEON','MAURICE','1935-03-13','02.46.93.08.88','06.39.13.92.84',NULL,'4 IMPASSE A LA FOSSE AUX LOUPS','','','61300','L''AIGLE',NULL,NULL,'2350377232002',69.000000000,'1963-05-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9369,'GAUTIER','SIMONE','1936-09-30','02.76.65.25.16','06.18.00.19.37',NULL,'3 cite des jardin','','','14370','BELLENGREVILLE',NULL,NULL,'1360914129002',129.000000000,'1960-12-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9370,'VERMONT','ALAIN','1935-07-13','02.68.75.62.35','06.11.91.15.75',NULL,'ARRY','','','14130','PONT L''EVEQUE',NULL,NULL,'1350714005002',231.000000000,'1957-04-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9371,'BAUDRY','MARIE JEANNE','1928-07-20','02.65.52.87.10','06.18.26.27.49',NULL,'4 route  de troarn','','','14270','CESNY AUX VIGNES OUEZY',NULL,NULL,'2280714101002',23.000000000,'1955-08-08','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9372,'MONGARDIEN','THERESE','1933-04-30','02.82.87.52.16','06.88.69.57.75',NULL,'137 RUE HAUTE','','',NULL,NULL,NULL,NULL,'1330477243002',322.000000000,'1956-02-11','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9373,'CARNET','patrice','1934-07-01','02.11.54.55.75','06.37.97.98.50',NULL,'24 RUE CAILLOUET','','','14000','CAEN',NULL,NULL,'2340753185002',776.000000000,'1958-11-03','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9374,'FERRANT','ANNICK','1952-06-17','02.25.79.83.39','06.73.27.59.31',NULL,'48 RUE DE DOMFRONT','','','14490','BALLEROY',NULL,NULL,'1520614125002',98.000000000,'1980-08-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9375,'SAMSON','ALAIN','1965-12-13','02.91.19.31.81','06.80.26.99.03',NULL,'1002 haute folie','','','14123','IFS',NULL,NULL,'2651214271002',254.000000000,'1987-11-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9376,'KARAKATSAN','alain','1961-02-26','02.98.32.33.63','06.59.55.10.14',NULL,'9 PLACE DES HAUTES COUTURES','','','14680','CINTHEAUX',NULL,NULL,'2610214666002',63.000000000,'1982-04-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9377,'HENRY','ISABELLE','1939-10-20','02.11.96.56.05','06.30.85.64.40',NULL,'1 place de la mairie','','','14270','MEZIDON CANON',NULL,NULL,'1391014628002',35.000000000,'1967-01-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9378,'PYPE','','1930-10-19','02.11.63.12.82','06.11.13.76.03',NULL,'cada foyer sonacotra 56 rue robi','llard','','14123','CORMELLES LE ROYAL',NULL,NULL,'2301050499002',136.000000000,'1955-06-04','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9379,'BRAY','JACKY','1934-04-08','02.41.13.33.85','06.80.68.63.13',NULL,'4 passage du grand turc','','','14730','GIBERVILLE',NULL,NULL,'1340450002002',21.000000000,'1958-06-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9380,'GUERNY','CHARLES','1930-05-17','02.77.47.03.22','06.10.98.76.60',NULL,'3 HAMEAU MONCEL','','','14000','CAEN',NULL,NULL,'1300514488002',625.000000000,'1953-05-30','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9381,'MARGUERITTE','GHISLAINE','1965-06-03','02.46.04.97.88','06.98.83.51.57',NULL,'32 AVENUE FOCH','','','14460','COLOMBELLES',NULL,NULL,'2650614119002',59.000000000,'1987-03-09','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9382,'LEPROVOST','robert','1965-02-02','02.14.23.44.67','06.61.09.40.27',NULL,'6 1 rue centrale','','',NULL,NULL,NULL,NULL,'1650214062002',6.000000000,'1993-07-11','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9383,'CASTEL','JULIEN',NULL,'02.93.37.80.45','06.76.15.19.55',NULL,'10 rue des champs st martin','','','14111','LOUVIGNY',NULL,NULL,'2470550321002',280.000000000,'2011-07-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9384,'GUILBERT','THERESE','1966-04-16',NULL,NULL,NULL,'15 BD DU GENERAL VANIER','','','14370','ARGENCES',NULL,NULL,'2660414181002',2797.000000000,'1990-05-10','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9385,'GEFFROY','CHRISTIANE','1935-10-21','02.17.85.63.71','06.80.80.16.54',NULL,'624 le thuit','','','14000','CAEN',NULL,NULL,'1351014075002',361.000000000,'1960-11-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9386,'TOUTAIN','HELENE','1939-05-13','02.30.50.34.88','06.36.45.37.80',NULL,'CHEMIN DES ECOLES','','','14370','BELLENGREVILLE',NULL,NULL,'1390514225002',868.000000000,'1966-10-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9387,'LAINE','SIMONNE','1955-04-28','02.10.44.33.49','06.54.16.27.18',NULL,'18 rue georges brassens','','','14370','ARGENCES',NULL,NULL,'1550450150002',367.000000000,'1981-09-09','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9388,'LEGOUX','THIERRY','1952-01-20','02.73.62.59.50','06.42.54.00.56',NULL,'6 ALLEE DU BREUIL','','','14530','LUC SUR MER',NULL,NULL,'1520114394002',46.000000000,'1979-12-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9389,'DEQUAINDRY','JEAN CLAUDE','1932-06-06','02.57.26.96.79','06.27.83.55.66',NULL,'9 rue des jardins','','','14170','ST PIERRE SUR DIVES',NULL,NULL,'2320650215002',12.000000000,'1955-03-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9390,'RIVOLA','CLAUDE','1958-06-07','02.31.67.86.14','06.44.89.03.34',NULL,'15 RUE PIERRE DE COUBERTIN','','','14730','GIBERVILLE',NULL,NULL,'2580614287002',344.000000000,'1979-02-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9391,'PARAVISINI','J PIERRE','1933-04-12','02.27.65.17.99','06.44.42.78.31',NULL,'1 RUE DE L''avenir','','','14790','MOUEN',NULL,NULL,'1330414456002',6.000000000,'1959-04-20','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9392,'CORTES','LUDOVIC','1933-04-11','02.83.74.45.31',NULL,NULL,'LE BOIS DE MILLEHRTS','','','14210','MISSY',NULL,NULL,'1330411106002',83.000000000,'1960-04-24','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9393,'ETASSE','CHARLOTTE','1940-07-16','02.63.45.09.24','06.10.67.68.27',NULL,'1 RESIDENCE ST GERBOLD 13 RUE CO','NSTANT FORGET','','50140','FONTENAY',NULL,NULL,'2400714431002',33.000000000,'1961-01-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9394,'FEVRE','MICHEL','1948-03-02','02.10.92.69.04','06.23.75.21.94',NULL,'LA VALLEE"LIEU DIT"','','','14840','CUVERVILLE',NULL,NULL,'2480350262002',227.000000000,'1972-08-22','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9395,'HAY','MICHEL','1953-04-27','02.44.40.83.05','06.95.76.60.58',NULL,'11 rue paul langevin','','','14280','ST CONTEST',NULL,NULL,'1530450494002',311.000000000,'1974-11-29','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9396,'COZANNET','JEAN-PIERRE','1961-03-30','02.27.73.70.75','06.78.37.73.96',NULL,'1 IMPASSE CROIZAT','','','14860','BAVENT',NULL,NULL,'2610388270002',2027.000000000,'1990-10-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9397,'GIGON','FRANCK','1938-08-30','02.32.00.42.72','06.30.67.34.94',NULL,'28 RUE HENRI CHERON   VENOIX','','','61350','PASSAIS LA CONCEPTION',NULL,NULL,'2380814158002',11.000000000,'1967-03-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9398,'FOSSE','RENE','1936-09-17','02.97.12.57.37','06.74.79.60.36',NULL,'23 RUE DE L''UNION','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'2360975101002',104.000000000,'1958-08-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9399,'THOMAS','JACQUES','1929-02-09','02.11.47.35.50','06.10.59.46.04',NULL,'8 RUE DU PRESBYTERE','','','14270','MEZIDON CANON',NULL,NULL,'1290276108002',171.000000000,'1950-05-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9400,'SELLOM AYA','NADINE','1946-03-18','02.57.42.89.44','06.51.05.27.06',NULL,'1 Rue Marcel Cachin','','','14120','MONDEVILLE',NULL,NULL,'2460314327002',364.000000000,'1976-12-21','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9401,'SANSON','LAURENT','1921-08-06','02.14.24.51.26','06.60.87.91.45',NULL,'2 route d ifs','','','14140','LIVAROT',NULL,NULL,'1210863316002',412.000000000,'1943-10-04','PREMIUM',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9402,'RAMDANI','YVETTE','1954-10-25','02.17.58.30.16','06.11.10.25.62',NULL,'HAMEAU DE LONGCHAMPS','','','14000','CAEN',NULL,NULL,'2541050229002',121.000000000,'1977-05-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9403,'HOROZ','MARGUERITE','1961-07-12','02.51.15.89.10','06.68.44.66.09',NULL,'16 route de cabourg','','','14730','GIBERVILLE',NULL,NULL,'2610714554002',15.000000000,'1988-02-17','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9404,'DANJOU','GINETTE','1935-03-10','02.32.08.56.05','06.41.57.35.80',NULL,'5 rue du bois claquet','','','14630','FRENOUVILLE',NULL,NULL,'2350377232002',35.000000000,'1963-12-08','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9405,'LE BLOND','LUCIENNE','1933-05-11','02.14.72.72.18','06.91.84.88.20',NULL,'la rue auger','','','14120','MONDEVILLE',NULL,NULL,'1330514700002',1996.000000000,'1963-09-05','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9406,'PANNETIER','ALPHONSE','1951-11-08','02.71.31.99.22','06.71.91.15.54',NULL,'20 RUE PASTEUR','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1511114118002',97.000000000,'1972-06-26','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9407,'BENOIT','FRANCOISE','1960-03-02','02.92.92.62.88','06.58.19.38.10',NULL,'LES PLANQUETTES','','','14123','FLEURY SUR ORNE',NULL,NULL,'1600350214002',196.000000000,'1983-09-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9408,'DORTEE','kathleen','1935-01-24','02.34.68.62.40','06.13.12.00.62',NULL,'64 route de lyon','','','14000','CAEN',NULL,NULL,'2350114268002',91.000000000,'1961-07-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9409,'AVENEL','ANGELIQUE','1968-10-16','02.12.12.31.60','06.12.26.09.46',NULL,'38 rue du quebec','','','14000','CAEN',NULL,NULL,'2681014383002',24.000000000,'1991-02-27','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9410,'RENIER','MARIE','1942-10-12','02.44.16.55.52','06.80.11.93.39',NULL,'8 RUE GEORGES BIZET','','','14123','IFS',NULL,NULL,'1421061314002',152.000000000,'1963-07-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9411,'GEAI','Christiane','1947-07-25','02.27.53.01.59','06.53.10.39.01',NULL,'6rue cardinal la vigerie','','','14730','GIBERVILLE',NULL,NULL,'2470714044002',20.000000000,'1968-07-20','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9412,'RIBAY','SOPHIE','1933-12-02','02.10.97.72.61','06.93.69.90.10',NULL,'13 RUE CAMILLE BLAISOT','','','14000','CAEN',NULL,NULL,'1331214710002',542.000000000,'1957-12-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9413,'BASSET','ANGELIQUE','1952-01-12','02.84.95.81.91','06.26.25.58.89',NULL,'27 rue de la paix','','','14850','HEROUVILLETTE',NULL,NULL,'2520114287002',20.000000000,'1974-06-20','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9414,'VALLE','LYDIA','1931-09-06','02.14.49.05.88','06.87.27.55.43',NULL,'1876 RUE DE BRETTEVILLE','','','14000','CAEN',NULL,NULL,'1310914328002',204.000000000,'1960-12-03','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9415,'DELAHAYE','PEGGY','1935-08-25','02.95.46.00.39','06.11.63.75.01',NULL,'35 RU EDE LA POTERIE','','','14940','SANNERVILLE',NULL,NULL,'2350865304002',187.000000000,'1956-05-20','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9416,'BOURGES','JEAN PIERRE','1937-04-27','02.10.80.94.53','06.83.84.73.46',NULL,'35 rue du camps ferm','','','14370','ARGENCES',NULL,NULL,'1370414053002',684.000000000,'1966-10-27','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9417,'PUYRAVEAU','Veronique','1932-05-14','02.68.26.70.77','06.78.31.66.00',NULL,'2 rue du 8 mai 1945','','','14020','CAEN CEDEX',NULL,NULL,'1320527527002',138.000000000,'1953-06-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9418,'LECUYER','GUY','1948-01-16','02.10.56.45.69','06.69.07.90.63',NULL,'','','','14000','CAEN',NULL,NULL,'1480162350002',5.000000000,'1970-11-06','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9419,'GROULT','ANTOINE','1949-04-06','02.64.77.99.68','06.62.16.57.57',NULL,'24 RUE DE CHEUX','','','14860','RANVILLE',NULL,NULL,'1490414252002',5.000000000,'1974-11-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9420,'MOCQUES','REGINE','1937-07-30','02.11.41.10.04','06.54.53.54.97',NULL,'LA BARANTELLE CHEMIN DE LA TREU','LETTE','','14220','THURY HARCOURT',NULL,NULL,'1370714516002',359.000000000,'1961-09-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9421,'LEFEVRE','MARIE FRANCE','1947-05-08','02.10.92.90.74',NULL,NULL,'ALLEE JEAN JACQUES ROUSSEAU','','','50110','TOURLAVILLE',NULL,NULL,'2470550432002',23.000000000,'1976-12-01','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9422,'MADELEINE','MARIE FRANCE','1934-12-21','02.12.85.10.96','06.16.70.65.87',NULL,'20 ROUTE DE CAMBRAI','','','50250','SURVILLE',NULL,NULL,'1341214387002',723.000000000,'1955-01-25','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9423,'LAURENT','ANNE GAELLE','1958-08-19','02.10.58.82.45','06.20.25.18.44',NULL,'23 rue de la clef des champs','','','14000','CAEN',NULL,NULL,'1580814222002',108.000000000,'1982-06-05','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9424,'REBHI','YOUSSEF','1954-10-24','02.38.46.96.22','06.24.96.95.97',NULL,'5 RUE DE LA FORGE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2541014118002',2344.000000000,'1977-06-16','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9425,'LEMONNIER','ARLETTE','1954-09-28','02.50.97.78.08','06.85.71.42.92',NULL,'13 RUE DE LA VICOMTE','','','14390','CABOURG',NULL,NULL,'1540914160002',4460.000000000,'1984-06-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9426,'BISSON','LAETITIA','1936-03-29','02.68.31.70.89','06.64.34.80.94',NULL,'4 RUE DE LA LIBERTE','','','14000','CAEN',NULL,NULL,'2360350400002',114.000000000,'1965-03-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9427,'CAMBRAYE','VALERIE','1938-12-30','02.71.08.88.78','06.94.58.40.64',NULL,'1610 QUARTIER GRANDE DELLE','','','75010','PARIS 10',NULL,NULL,'2381250060002',1020.000000000,'1959-12-20','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9428,'CAMEDESCASSE','THIBALD','1952-04-11','02.10.61.49.57','06.84.52.65.11',NULL,'HAMEAU DE GLATIGNY','','','14540','SOLIERS',NULL,NULL,'1520414546002',104.000000000,'1975-09-10','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9429,'FERNANDEZ','ELISE','1940-02-05','02.26.80.53.26','06.65.07.55.50',NULL,'14-5 RUE DU BOIS','','','14270','MEZIDON CANON',NULL,NULL,'2400250639002',776.000000000,'1970-11-13','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9430,'BAUDE','FANNY','1976-03-19','02.56.00.07.43','06.88.00.87.83',NULL,'4 RUE DU VERCORS','','','14370','BISSIERES',NULL,NULL,'2760399148002',3624.000000000,'2001-07-06','PREMIUM',11,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9431,'LUSSIEZ','Eric','1957-06-07','02.37.43.18.17','06.56.14.79.51',NULL,'15 RUE DES CORMORANS','','',NULL,NULL,NULL,NULL,'1570614039002',32.000000000,'1985-08-26','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9432,'LORPHELIN','Edwige','1932-10-24','02.63.34.01.66','06.17.71.49.99',NULL,'3 RUE DES ARTISTES','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1321014513002',101.000000000,'1957-05-08','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9433,'LALLEMAND','KARINE','1935-03-21','02.43.53.34.90','06.87.41.59.76',NULL,'RESIDENCE COLBERT BAT H APPT 1','','','14460','COLOMBELLES',NULL,NULL,'1350314098002',19.000000000,'1957-01-17','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9434,'HEUDIER','sophie','1928-08-26','02.55.94.91.17','06.10.21.37.43',NULL,'RESIDENCE COLBERT BAT H APPT 1','','','14540','GRENTHEVILLE',NULL,NULL,'1280814370002',46.000000000,'1958-09-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9435,'ABDOU','Karine','1935-06-13','02.22.86.93.21','06.16.14.69.51',NULL,'LE LIEU DIT LEMANOIR','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2350614582002',636.000000000,'1958-02-15','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9436,'ABDOU','NATACHA','1929-05-08','02.61.67.62.17','06.18.99.86.63',NULL,'LA CHENEVIERE','','','50140','ROMAGNY',NULL,NULL,'2290550431002',581.000000000,'1955-08-28','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9437,'LE BOURGEOIS','SANDRINE','1928-10-31','02.83.02.84.21','06.26.93.89.71',NULL,'26 RUE DE LA TOURELLE','','','14370','CROISSANVILLE',NULL,NULL,'1281080540002',36.000000000,'1958-07-15','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9438,'AVELINE','EMILIE','1929-12-22','02.75.62.20.17','06.98.44.06.53',NULL,'SUROSNE','','','14400','BAYEUX',NULL,NULL,'1291277350002',718.000000000,'1953-10-08','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9439,'COIRRE','MAUD','1956-01-18','02.57.35.15.12','06.12.72.96.16',NULL,'18 RUE RENE SUZANNE','','','14000','CAEN',NULL,NULL,'2560161307002',25.000000000,'1986-10-16','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9440,'GERARD','MUSTAPHA','1961-04-04','02.51.13.95.40','06.79.36.10.31',NULL,'3 CHEMIN DU CLOS FOURNIER','','','14170','GRANDMESNIL',NULL,NULL,'2610414410002',273.000000000,'1984-03-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9441,'CUTRUPIA','FRANCOISE','1950-01-26','02.69.87.11.91','06.11.20.51.34',NULL,'10 RUE DU REVERAN PERE JULES','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1500114618002',23.000000000,'1979-05-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9442,'GEFFROY','SERGE','1984-01-23','02.50.97.93.71','06.60.14.76.74',NULL,'8 RUE DES CULTURES','','','14000','CAEN',NULL,NULL,'2840199111002',69.000000000,'2012-08-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9443,'LEMIERE','EMILIE','1938-03-17','02.98.70.83.27','06.29.11.41.69',NULL,'6 RUE DE LA DIVE','','','14000','CAEN',NULL,NULL,'2380314191002',1163.000000000,'1962-06-29','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9444,'LEROY','JULIE','1928-03-22','02.88.97.13.63','06.17.75.08.47',NULL,'10 RUE FRANKLIN','','','14370','BELLENGREVILLE',NULL,NULL,'1280314485002',152.000000000,'1952-03-10','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9445,'GUELLE','CHRISTELLE','1940-03-25','02.10.64.18.16','06.13.57.60.84',NULL,'50 ALLEE DE LA TROURELLE','','','27300','BERNAY',NULL,NULL,'2400375059002',419.000000000,'1961-07-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9446,'LOPES','BERNARD','1929-12-15','02.49.77.53.11','06.23.90.90.80',NULL,'6 ROUTE DE CABOURG','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2291227467002',37.000000000,'1953-03-29','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9447,'LEROY','ISABELLE','1936-12-16','02.56.49.86.49','06.11.81.36.31',NULL,'39 RUE ALBERT  PREMIER','','','14000','CAEN',NULL,NULL,'2361214047002',180.000000000,'1957-06-19','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9448,'DEPINCE','SABRINA','1963-02-19','02.81.81.47.74',NULL,NULL,'3 IMPASSE DE ROCROI','','',NULL,NULL,NULL,NULL,'1630214629002',42.000000000,'1986-08-20','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9449,'BESNARD','sedat','1934-09-18','02.61.07.94.29','06.56.30.28.21',NULL,'51 rue de la gare','','',NULL,NULL,NULL,NULL,'2340950266002',1058.000000000,'1958-11-11','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9450,'NEEL','natacha','1952-05-12','02.54.49.11.77','06.90.83.69.10',NULL,'9 RUE BEAUSEJOUR','','','14000','CAEN',NULL,NULL,'2520514675002',187.000000000,'1974-07-04','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9451,'MARTEL','STEPHANIE',NULL,'02.85.07.80.19','06.11.33.18.28',NULL,'LES BINETTES','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2521214262002',304.000000000,'2008-12-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9452,'LE DORNER','ovide','1946-07-21','02.43.05.93.51','06.19.11.70.42',NULL,'8,rue de la croix cante','','','14000','CAEN',NULL,NULL,'2460714458002',1344.000000000,'1975-04-16','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9453,'AVENEL','MEHDI','1931-04-26','02.87.63.62.11','06.55.23.56.54',NULL,'87 RUE DE BAYEUX','','','14790','VERSON',NULL,NULL,'2310414296002',19.000000000,'1954-12-31','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9454,'HARRAT','richard','1937-03-15','02.15.83.91.81','06.44.95.81.61',NULL,'BOURG LE LIVRY','','','14120','MONDEVILLE',NULL,NULL,'2370314225002',705.000000000,'1966-08-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9455,'PAVEE','FREDERIC','1937-08-20','02.58.07.62.81','06.26.48.37.07',NULL,'14 RUE EUGENE BOUDIN','','','14680','FRESNEY LE PUCEUX',NULL,NULL,'2370822143002',37.000000000,'1958-10-16','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9456,'MAUPAS','samuel','1932-07-24','02.65.46.66.94','06.10.75.72.64',NULL,'11 rue paul langevin','','','14650','CARPIQUET',NULL,NULL,'1320761161002',59.000000000,'1959-09-01','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9457,'SADER','KATIA','1929-10-27','02.68.40.44.76','06.75.95.34.79',NULL,'1 imp patry','','','14120','MONDEVILLE',NULL,NULL,'1291050341002',282.000000000,'1957-10-31','PLATINIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9458,'JANEZ','RAUX','1946-03-22','02.91.77.76.96','06.61.23.46.38',NULL,'CHATEAU ST GILES','','','14320','MAY SUR ORNE',NULL,NULL,'2460314637002',82.000000000,'1974-08-27','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9459,'BISSON','Rudy','1919-06-10','02.11.68.33.37','06.82.07.00.38',NULL,'6 RUE DES ROCQUIERS','','','14270','MEZIDON CANON',NULL,NULL,'1190624586002',170.000000000,'1940-06-22','GOLD',23,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9460,'LEBRETON','DELPHINE','1928-02-02','02.70.55.16.91','06.21.05.22.26',NULL,'100 rue du haut magny','','','14810','MERVILLE FRANCEVILLE PLAGE',NULL,NULL,'2280214365002',42.000000000,'1955-07-28','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9461,'MOULEC','CINDY','1945-07-13','02.41.15.64.49','06.45.53.72.22',NULL,'29 ROUTE DU CIMETIERE','','','61220','BRIOUZE',NULL,NULL,'2450750493002',9.000000000,'1975-03-29','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9462,'DELAPORTE','Yannick','1960-03-02','02.29.50.01.96','06.41.48.58.45',NULL,'3 rue de verriere','','','61800','TINCHEBRAY',NULL,NULL,'2600364381002',891.000000000,'1981-06-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9463,'BERNIER','Yannick','1963-05-01','02.64.94.23.88','06.11.81.23.60',NULL,'19 ROUTE COOPERATIVE','','','14540','BOURGUEBUS',NULL,NULL,'2630514659002',24.000000000,'1986-05-05','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9464,'BANVILLE','RACHEL','1950-03-31','02.10.61.21.13','06.62.13.81.37',NULL,'','','',NULL,NULL,NULL,NULL,'2500350160002',1270.000000000,'1973-08-04','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9465,'GAUTIER','ANGELINA','1936-10-15','02.74.96.36.63',NULL,NULL,'LE MONT LES MARRES','','','14120','MONDEVILLE',NULL,NULL,'2361014221002',247.000000000,'1958-04-05','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9466,'GUICHETEAU','DAVID',NULL,'02.66.83.20.66','06.24.54.32.80',NULL,'6 RUE AUGUSTE CHENE','','','14370','ARGENCES',NULL,NULL,'2300514623002',83.000000000,'2010-12-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9467,'ROCHEREAU','LYDIE','1932-06-01','02.13.96.01.49','06.31.01.03.19',NULL,'21 RUE INGENIEUR BERTIN','','','14000','CAEN',NULL,NULL,'2320614271002',15.000000000,'1960-06-04','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9468,'COSNARD','THOMAS','1933-10-16','02.22.95.23.99','06.54.51.46.53',NULL,'3 IMPASSE DES GENETS','','','14670','TROARN',NULL,NULL,'2331050604002',14.000000000,'1955-12-30','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9469,'CASTEL','DOMINIQUE','1934-05-17','02.29.87.46.69','06.79.41.20.30',NULL,'16 RUE JACques BREL','','','14610','ANISY',NULL,NULL,'2340514118002',1944.000000000,'1963-08-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9470,'LAIR','HENRY','1938-02-03','02.35.37.44.62','06.76.69.98.61',NULL,'36 RUE D ANGLETERRE','','','14630','FRENOUVILLE',NULL,NULL,'2380254273002',324.000000000,'1960-12-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9471,'FISCHER','STEPHANIE','1945-06-17','02.20.88.38.64','06.68.67.08.09',NULL,'1/2 RUE DU RUISSEAU','','','14260','ONDEFONTAINE',NULL,NULL,'2450661283002',384.000000000,'1972-10-08','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9472,'PINCHON','AURELIE','1956-11-19','02.65.09.09.95','06.75.05.09.51',NULL,'17 RUE PIERRE GIRARD','','','14123','IFS',NULL,NULL,'1561114227002',6.000000000,'1980-03-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9473,'OUDIN','ANNE','1920-05-18','02.78.21.42.23','06.82.30.50.53',NULL,'153 RUE DE BEAULUE','','','14670','BASSENEVILLE',NULL,NULL,'1200564416002',9.000000000,'1947-04-18','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9474,'BUSNEL','FLORENCE','1928-12-02','02.38.59.65.60','06.35.84.66.42',NULL,'12 CLOS DES 9 VERGEES','','','14400','BAYEUX',NULL,NULL,'1281250002002',106.000000000,'1952-04-23','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9475,'LAFOSSE','JEAN FRANCOIS','1936-03-02','02.48.89.92.99','06.26.71.65.68',NULL,'la cour d appel de caen place ga','mbetta','','14990','BERNIERES SUR MER',NULL,NULL,'1360314306002',102.000000000,'1966-11-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9476,'PIQUOT','NADEGE','1935-11-16','02.85.33.18.77','06.89.35.25.83',NULL,'LIEU DIT MONTRON','','','14120','MONDEVILLE',NULL,NULL,'2351114287002',1488.000000000,'1965-11-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9477,'LECAUDEY','STEPHANIE','1967-11-19','02.49.60.73.94','06.32.65.46.33',NULL,'8 PETIT HAMEL','','','14670','TROARN',NULL,NULL,'1671150502002',890.000000000,'1991-07-20','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9478,'LE GALL','VIRGINIE','1938-10-10','02.10.10.88.93','06.79.90.47.27',NULL,'43 allee st germain','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'1381050090002',338.000000000,'1959-01-26','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9479,'LEMIERE','MAXIME','1943-06-17','02.77.36.30.84','00 33 6.12.21.40.62',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'1430664233002',36.000000000,'1968-11-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9480,'FARCY','julien','1955-01-12','02.13.60.84.56','06.86.22.26.43',NULL,'6 IMP DES TILLEULS','','','14420','BONS TASSILLY',NULL,NULL,'2550114762002',142.000000000,'1977-04-21','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9481,'ORANGE','odile','1944-01-26','02.72.30.56.75','06.33.61.90.67',NULL,'194 rue d auge','','','14000','CAEN',NULL,NULL,'2440114612002',2343.000000000,'1974-04-04','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9482,'VIBET','elisabeth','1946-01-24','02.94.36.67.59','06.72.11.41.28',NULL,'6 RUE DE SUEDE','','','22400','LAMBALLE',NULL,NULL,'1460176699002',577.000000000,'1967-06-10','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9483,'SERAFIN','VIRGINIE','1954-03-11','02.93.03.31.76','06.71.22.57.53',NULL,'45 RUE GUYNEMER','','','14000','CAEN',NULL,NULL,'2540350076002',749.000000000,'1976-03-26','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9484,'LE GOUPILLOT','ANGELIQUE','1954-03-30','02.92.35.97.48','06.55.15.60.11',NULL,'27 RUE PIERRE BROSSOLETTE','','','14270','MAGNY LE FREULE',NULL,NULL,'2540350076002',19.000000000,'1976-10-24','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9485,'ELISABETH','SABRINA','1959-07-28','02.72.81.08.87','06.10.83.74.70',NULL,'14 RUE DES CASTORS','','','14190','MAIZIERES',NULL,NULL,'1590714281002',36.000000000,'1985-10-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9486,'LIEGARD','Pascal','1977-02-21','02.11.36.11.87','06.82.36.66.59',NULL,'MESNIL VILLEMENT','','','14000','CAEN',NULL,NULL,'1770299336002',1706.000000000,'2006-05-25','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9487,'GAZEL','HERVE','1931-11-08','02.58.58.58.83','06.81.03.35.77',NULL,'96 RUE DU CENTRE','','','50130','OCTEVILLE',NULL,NULL,'1311114637002',32.000000000,'1955-11-07','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9488,'ILY','FLORENCE','1958-09-27','02.45.72.54.09','00 33 6.67.25.46.12',NULL,'11 RUE VICTOR HUGO','','','14540','BOURGUEBUS',NULL,NULL,'1580961030002',79.000000000,'1984-06-18','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9489,'LE BLOND','','1930-04-18','02.49.22.42.92','06.85.39.72.65',NULL,'2 RUE JEAN MERMOZ','','','14000','CAEN',NULL,NULL,'1300432285002',20.000000000,'1953-05-17','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9490,'BUQUET','','1936-06-26','02.96.03.32.64','06.72.07.67.11',NULL,'49 AVENUE DE THIES','','','14123','FLEURY SUR ORNE',NULL,NULL,'1360650484002',227.000000000,'1957-05-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9491,'CAMBIEN','AURELIE','1937-02-19','02.53.16.87.34','06.97.01.02.54',NULL,'548 RUE DU CHEMIN VERT','','','14730','GIBERVILLE',NULL,NULL,'1370214271002',4.000000000,'1960-07-31','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9492,'COCARD','ISABELLE','1950-05-12','02.72.01.11.32','06.95.09.88.97',NULL,'3 RUE DU CINGAL','','','14150','OUISTREHAM',NULL,NULL,'2500550552002',3.000000000,'1971-02-24','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9493,'AUROY','JOAO PAULE','1935-06-27','02.52.18.80.00','06.52.35.53.56',NULL,'34 RUE DE LA REPUBLIQUE','','','61310','VILLEBADIN',NULL,NULL,'1350661486002',1032.000000000,'1959-09-13','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9494,'HODIESNE','BEATRICE','1937-03-14','02.60.25.79.41','06.74.49.22.72',NULL,'MARTINBEAU','','','14750','ST AUBIN SUR MER',NULL,NULL,'2370372124002',50.000000000,'1966-08-23','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9495,'HERVO','GWENDOLINE','1934-03-06','02.10.66.30.86','06.88.64.18.84',NULL,'1202 GRANDE DELLE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1340314225002',68.000000000,'1961-09-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9496,'MERIOTTE','RENE','1961-11-02','02.67.01.20.09','06.19.92.78.26',NULL,'50 RUE DU MILIEU','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2611114262002',79.000000000,'1985-08-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9497,'FLAMBARD','PIERRE','1962-03-18','02.79.85.25.56','06.50.17.76.35',NULL,'9 RUE DES GODETS','','','61120','TICHEVILLE',NULL,NULL,'1620314208002',25.000000000,'1984-05-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9498,'LECONTE','NOEL','1948-02-16','02.26.03.49.69','06.56.58.44.92',NULL,'61 RUE DE CONDE','','','14000','CAEN',NULL,NULL,'1480214405002',153.000000000,'1972-04-24','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9499,'BOUVACHON','CHARLENE','1956-06-13','02.42.80.00.51','06.97.77.29.51',NULL,'1 SALVADORE ALLENDE','','','14100','OUILLY LE VICOMTE',NULL,NULL,'2560675068002',3707.000000000,'1982-11-18','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9500,'BESNON','MARIE-EMILIE','1942-01-03','02.36.41.71.02','06.11.09.02.90',NULL,'3 RUE HAYE','','','14120','MONDEVILLE',NULL,NULL,'1420172077002',2636.000000000,'1965-10-22','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9501,'DIDIER','AMANDINE','1928-10-31','02.16.51.99.26','06.79.87.17.42',NULL,'3 PLACE DU TOURELLES','','','14980','ROTS',NULL,NULL,'2281072220002',213.000000000,'1953-11-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9502,'MARAIS','ANGELIQUE','1944-04-15','02.59.84.31.76','06.66.36.79.06',NULL,'LA VALLEE','','','61150','ECOUCHE',NULL,NULL,'2440434157002',37.000000000,'1965-05-27','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9503,'VORNIERE','SYLVAINE','1946-05-01','02.42.06.94.92','06.19.02.80.20',NULL,'FERME DU VIVIER','','','14220','THURY HARCOURT',NULL,NULL,'2460527571002',1626.000000000,'1967-10-17','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9504,'BAH','BEATRICE','1934-04-19','02.36.27.45.53','06.24.90.21.48',NULL,'3 RUE MAURICE FOUQUES','','','50620','LES CHAMPS DE LOSQUE',NULL,NULL,'2340444132002',148.000000000,'1958-12-27','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9505,'MORAINE','BRIGITTE','1932-06-17','02.20.13.90.62','06.30.01.60.31',NULL,'4 ALLEE DES CAPUCINES','','','14420','VILLERS CANIVET',NULL,NULL,'1320614327002',115.000000000,'1957-04-16','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9506,'DUPUIS','ANGELIQUE',NULL,'02.69.74.81.78',NULL,NULL,'17 rue du petit semillon','','',NULL,NULL,NULL,NULL,'1400414342002',742.000000000,'2008-01-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9507,'DESLOGES','DELPHINE','1940-04-12','02.58.17.81.15','06.50.48.17.83',NULL,'la vallee','','','14370','CHICHEBOVILLE',NULL,NULL,'1400414342002',154.000000000,'1962-05-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9508,'DORGUEILLE','DENIS','1963-03-01','02.18.31.18.30','06.31.81.91.39',NULL,'18 RUE DU BLANC RESIDENCE ROYAL','E 18','','14460','COLOMBELLES',NULL,NULL,'2630314386002',37.000000000,'1987-03-22','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9509,'DEVAUX','JEAN','1929-11-03','02.82.85.24.47','06.57.81.04.68',NULL,'LE MESNIL AU GRAINS','','','14850','HEROUVILLETTE',NULL,NULL,'2291135300002',26.000000000,'1950-05-17','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9510,'BARRE','NICOLAS','1931-11-19','02.68.33.22.70','06.11.56.52.40',NULL,'27 AVENUE DU PARC','','','14620','MORTEAUX COULIBOEUF',NULL,NULL,'2311150341002',372.000000000,'1955-04-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9511,'LEROY','NAJAT','1929-01-28','02.55.87.98.11','06.15.55.39.81',NULL,'12 IMPASSE DU MANOIR LE HAUT ME','SNIL','','14840','DEMOUVILLE',NULL,NULL,'1290149103002',6.000000000,'1958-06-27','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9512,'COQUOIN','MONIQUE','1929-11-23','02.85.49.05.65','06.69.57.71.78',NULL,'LE HAM','','','14000','CAEN',NULL,NULL,'2291157556002',5018.000000000,'1951-02-25','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9513,'LEPOULTIER','CINDY','1977-01-22','02.28.08.26.35','06.99.76.55.90',NULL,'32 RUE EUGENE MAES','','','14860','BAVENT',NULL,NULL,'1770199125002',851.000000000,'2004-04-22','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9514,'GAMBIER','ELODIE','1955-08-01','02.36.66.90.34','06.92.83.95.64',NULL,'','','','14630','FRENOUVILLE',NULL,NULL,'2550814675002',23.000000000,'1978-06-14','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9515,'LAMBART','JULIEN','1937-09-29','02.46.28.18.20','06.37.77.43.66',NULL,'2 RUE DES PARACHUTISTES','','','14220','COMBRAY',NULL,NULL,'2370914328002',294.000000000,'1966-06-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9516,'BAUMEL','FABIEN','1952-05-01','02.18.13.76.95','06.60.41.88.22',NULL,'11 rue des carrieres de vaucelle','','','14000','CAEN',NULL,NULL,'1520514422002',916.000000000,'1976-04-08','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9517,'HAY','DAVID','1933-10-19','02.17.30.04.13','06.11.99.14.31',NULL,'19 RUE LE BOULHOULLAY','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'2331089055002',6.000000000,'1960-09-06','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9518,'PENNETIER','BRANDON','1936-11-10','02.81.03.07.70','06.84.45.75.83',NULL,'27 rue de la gare','','','14130','ST GATIEN DES BOIS',NULL,NULL,'2361127549002',103.000000000,'1957-02-10','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9519,'FREMY','BLANDINE','1956-02-27','02.10.21.16.71','06.51.47.34.49',NULL,'14 alle des poetes','','','14460','COLOMBELLES',NULL,NULL,'1560256191002',2076.000000000,'1983-09-01','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9520,'DEGUIN','isabelle','1937-07-15','02.40.18.87.25','06.77.67.00.45',NULL,'37 RUE DES CALOUINS','','','14220','HAMARS',NULL,NULL,'2370714730002',139.000000000,'1962-02-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9521,'LAMARRE','LAURE','1934-08-30','02.70.98.12.36','06.19.96.95.95',NULL,'4 RUE PIERRE TREBUTIEN','','','14480','BANVILLE',NULL,NULL,'1340861310002',27.000000000,'1961-02-09','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9522,'BOUQUET','ALINE','1931-04-22','02.88.89.40.30','06.98.32.04.46',NULL,'7 rue gaumesnil','','','14130','BONNEVILLE LA LOUVET',NULL,NULL,'1310461165002',2314.000000000,'1960-05-14','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9523,'LESELLIER','FLORIAN','1928-12-02','02.72.84.48.93','06.75.52.27.09',NULL,'46 rue du milieu','','','14120','MONDEVILLE',NULL,NULL,'2281214026002',18.000000000,'1952-10-01','PLATINIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9524,'GAUTHIER','CINDY','1964-06-26','02.89.32.33.01','06.96.61.43.37',NULL,'2 chemin de caen','','','14000','CAEN',NULL,NULL,'2640614221002',44.000000000,'1988-10-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9525,'LEFAUCONNIER','EL GHALIA',NULL,'02.15.03.10.87','06.86.00.60.87',NULL,'20 RUE E L4EGLISE','','','14630','FRENOUVILLE',NULL,NULL,'2310322339002',42.000000000,'2011-01-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9526,'DESVAUX','JEAN','1937-11-12','02.11.16.28.57','06.18.22.73.67',NULL,'3 impasse des accacias','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'1371161145002',862.000000000,'1963-09-01','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9527,'BARBIER','BRICE','1931-07-06','02.68.10.47.55','06.44.84.79.96',NULL,'1 RUE DE LA MOTTE','','','14400','MONCEAUX EN BESSIN',NULL,NULL,'1310714707002',136.000000000,'1960-05-15','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9528,'TREBUTIEN','FATOUM','1949-06-13','02.34.24.24.84','06.11.00.72.99',NULL,'12 RUE DES COURTILS','','','14123','FLEURY SUR ORNE',NULL,NULL,'2490614723002',16.000000000,'1971-12-31','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9529,'PENNETIER','MORGANE','1949-07-07','02.82.05.46.61','06.36.19.79.32',NULL,'2 rue de l''auvraye','','','14610','ANGUERNY',NULL,NULL,'1490799151002',266.000000000,'1970-07-24','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9530,'LELIEVRE','PATRICE','1929-11-02','02.67.77.54.14','06.34.34.46.96',NULL,'5 rue de la vire','','','14000','CAEN',NULL,NULL,'1291114312002',357.000000000,'1950-08-28','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9531,'LE-BOHEC','COLETTE','1949-08-13','02.48.23.85.69','06.93.27.64.07',NULL,'8 2 alle des marguerites','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'2490814344002',41.000000000,'1972-04-06','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9532,'MADELAINE','JOSIANE','1936-10-22','02.87.94.20.46','06.11.86.38.70',NULL,'22 rue du petit valon','','','14520','PORT EN BESSIN HUPPAIN',NULL,NULL,'1361061501002',35.000000000,'1960-04-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9533,'GAUCHER','CARLOS','1943-01-02','02.68.70.76.86','06.11.89.33.45',NULL,'4 rue de la pecherie','','','14000','CAEN',NULL,NULL,'1430114258002',8.000000000,'1973-06-26','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9534,'ALVAREZ','SEVERINE','1933-08-01','02.33.84.07.17','06.98.32.76.72',NULL,'13 RUE DES PREMONTRES','','','14260','BANNEVILLE SUR AJON',NULL,NULL,'1330814011002',379.000000000,'1962-09-04','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9535,'LYE','ANNE SOPHIE','1962-07-22','02.56.39.93.33','06.37.31.44.32',NULL,'6 RESIDENCE LA PETITE CAMPAGNE','','','61160','TRUN',NULL,NULL,'2620750473002',119.000000000,'1985-09-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9536,'VILLEDIEU','CORALIE','1952-01-29','02.30.93.00.01','06.93.22.15.00',NULL,'7 IMPASSE DU CHAPEAU','','','14000','CAEN',NULL,NULL,'1520159221002',64.000000000,'1982-10-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9537,'DENIS','NATHALIE','1960-09-03','02.93.31.45.51','06.27.36.83.27',NULL,'10 rue 8 mai 1945','','','14123','IFS',NULL,NULL,'2600914139002',824.000000000,'1984-09-08','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9538,'FAROLDI','kevin','1933-10-31','02.43.19.33.94','06.11.04.42.78',NULL,'6 bvd isaac rabine','','','61230','ST EVROULT DE MONTFORT',NULL,NULL,'1331014298002',141.000000000,'1956-02-19','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9539,'HAYS','MATHIEU','1932-01-07','02.78.77.28.79','06.37.90.27.48',NULL,'63 RUE DE BAYEUX','','','14940','SANNERVILLE',NULL,NULL,'2320161070002',12.000000000,'1962-12-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9540,'LAVILLE','VALRIE','1958-08-11','02.10.52.68.78','06.21.70.42.88',NULL,'2 AVE GENERAL LYNE','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'1580850067002',27.000000000,'1985-08-11','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9541,'PISMONT','Aurlie','1938-08-14','02.91.43.24.63','06.87.12.89.49',NULL,'111 RUE D AUGE','','','14120','MONDEVILLE',NULL,NULL,'1380814556002',3855.000000000,'1968-09-16','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9542,'DAVID','Josiane','1940-09-01','02.11.09.32.65','06.38.51.56.88',NULL,'13 allee de l''alberta appt 11','','','14000','CAEN',NULL,NULL,'1400914587002',1017.000000000,'1964-08-17','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9543,'MAHE','EMILIE','1931-07-25','02.87.55.35.44','06.39.89.59.66',NULL,'37 rue de la procession','','','14980','ROTS',NULL,NULL,'2310714688002',4.000000000,'1955-11-26','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9544,'MARAIS','NADEGE','1935-05-22','02.72.02.57.89','06.28.57.18.27',NULL,'14 RUE DU DR SCHWEITZER','','','14210','CHEUX',NULL,NULL,'2350553033002',39.000000000,'1958-11-07','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9545,'SAMSON','Annne Marie','1963-03-18','02.44.74.46.79',NULL,NULL,'82 RUE DE FALAISE','','','14000','CAEN',NULL,NULL,'2630314096002',2730.000000000,'1985-01-31','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9546,'CORRE','JULIE','1949-01-14','02.70.77.48.17','06.74.25.44.85',NULL,'3 ALLEE DE VIENNE LA VALLEY BAR','REY','','14370','BELLENGREVILLE',NULL,NULL,'1490114372002',98.000000000,'1971-03-31','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9547,'BARRIER','LOUIS','1962-05-11','02.30.71.17.12','06.14.55.98.35',NULL,'4 IMPASSE DE L''HERISSON','','','61200','ARGENTAN',NULL,NULL,'1620522313002',3.000000000,'1983-11-24','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9548,'LEMONNIER','RODOLPHE','1953-04-23','02.14.66.87.45','06.24.36.05.41',NULL,'38 RUE DU MOULIN','','','14270','MEZIDON CANON',NULL,NULL,'2530461494002',198.000000000,'1974-05-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9549,'DELLA SANTA','Marie-line','1952-04-30','02.41.93.45.58','06.68.72.99.74',NULL,'10 rue rene blanc','','','14370','ARGENCES',NULL,NULL,'2520461127002',166.000000000,'1981-07-11','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9550,'CARROUE','Fabienne','1919-08-16','02.93.89.72.33','06.11.11.96.88',NULL,'BORCHET','','','14730','GIBERVILLE',NULL,NULL,'1190861182002',27.000000000,'1946-08-30','GOLD',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9551,'GOSSELIN','JULIE','1957-06-09','02.87.19.34.80','06.28.42.21.75',NULL,'31 RTE DE CAEN','','','14000','CAEN',NULL,NULL,'1570650473002',38.000000000,'1981-11-20','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9552,'GRIEUX','RENE','1933-10-14','02.79.26.82.69','06.46.41.31.73',NULL,'30 rue du bingale','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'2331053154002',169.000000000,'1959-09-16','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9553,'MERIENNE','sarah','1940-02-01','02.94.01.60.82','06.26.17.50.91',NULL,'16 RUE DE MADRID','','','14540','BOURGUEBUS',NULL,NULL,'1400222225002',17.000000000,'1964-04-02','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9554,'VAUSSY','patrick','1961-08-09','02.22.98.06.15','06.82.06.70.02',NULL,'1874 RUE DE BRETTEVILLE','','','14000','CAEN',NULL,NULL,'1610878326002',281.000000000,'1988-08-06','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9555,'ADAM','LOUISE','1944-01-22','02.45.45.15.26','06.17.85.48.58',NULL,'16 RUE PIERRE AUDIGE','','','14710','VIERVILLE SUR MER',NULL,NULL,'1440122175002',14.000000000,'1972-09-04','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9556,'CAPELLE','JOANNA','1933-10-27',NULL,NULL,NULL,'LA HANE','','','50180','AGNEAUX',NULL,NULL,'2331014628002',105.000000000,'1962-05-04','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9557,'MENARD','ANDRE','1950-06-24','02.46.42.42.70','06.10.82.03.91',NULL,'8 ALLEE DES POETES','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'1500614208002',1547.000000000,'1973-12-29','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9558,'LAURENT','arnaud','1930-04-11','02.65.03.45.42','06.35.80.82.03',NULL,'4 rue alfred nobel','','','14123','IFS',NULL,NULL,'2300414732002',32.000000000,'1951-02-12','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9559,'GARNIER','CHRISTIANE','1941-07-03','02.18.78.07.98','06.32.95.72.16',NULL,'19 RN','','','14370','MOULT',NULL,NULL,'2410714235002',813.000000000,'1969-12-19','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9560,'DELAUNAY','JEANNE','1934-03-22','02.69.01.98.93','06.13.73.07.27',NULL,'21 RUE MARIE CURIE','','','14000','CAEN',NULL,NULL,'1340350079002',209.000000000,'1960-12-12','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9561,'LELOUP','JEANNE','1921-02-15','02.11.09.31.85','06.90.35.42.84',NULL,'75 RUE BRANVILLE','','','14370','ARGENCES',NULL,NULL,'1210250203002',186.000000000,'1946-10-05','PLATINIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9562,'HUBERT','SAMIA','1939-01-26','02.84.12.18.00','06.52.19.49.37',NULL,'20 ROUTE DE CAMBRAI','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'1390114153002',133.000000000,'1969-02-14','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9563,'LARUE','MARIE JAC','1934-06-27','02.84.35.20.90','06.10.85.21.02',NULL,'1 RUE DE LA PRAIRE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'1340614347002',5.000000000,'1960-05-22','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9564,'LEBOSQUAIN','MATTHIAS','1960-03-24','02.74.52.27.33',NULL,NULL,'chemin du lavoir','','','14170','SASSY',NULL,NULL,'2600314719002',161.000000000,'1984-04-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9565,'MARSAULT','Elodie','1947-04-02','02.11.72.65.15','06.10.25.47.57',NULL,'17 allee des merisiers','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'2470461035002',392.000000000,'1977-08-10','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9566,'GIRARD','FANNY','1961-03-16','02.79.70.36.81','06.31.63.60.54',NULL,'11 RUE LEON MARCOTTE','','','14780','LION SUR MER',NULL,NULL,'1610314015002',19.000000000,'1988-09-10','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9567,'GOUET','pascal','1930-05-05','02.84.03.88.47','06.79.00.86.20',NULL,'15 reu des dentelieres','','','14370','ARGENCES',NULL,NULL,'2300527218002',31.000000000,'1954-04-17','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9568,'BANDRAC','STEPHANIE','1968-11-07','02.11.10.70.49','06.64.48.41.79',NULL,'5 ALLEE DES SERPENTINES','','','14000','CAEN',NULL,NULL,'1681114347002',229.000000000,'1991-07-07','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9569,'AUBERT','MELANIE','1928-05-18','02.53.47.71.73','06.71.63.09.60',NULL,'43 RUE REMI DUMONCEL','','','14000','CAEN',NULL,NULL,'1280514060002',325.000000000,'1952-02-08','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9570,'PERRETTE','sebastien','1943-06-14','02.55.38.14.51','06.12.28.43.32',NULL,'2 IMPASSE JARDIN BOULARD','','','14440','DOUVRES LA DELIVRANDE',NULL,NULL,'1430614257002',3954.000000000,'1967-02-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9571,'PETIT','ANTHONY','1957-02-26','02.25.30.56.97','00 33 6.53.31.82.62',NULL,'la boissonniere','','','14123','FLEURY SUR ORNE',NULL,NULL,'2570214670002',908.000000000,'1978-11-11','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9572,'LETELLIER','LAETITIA','1967-06-03','02.27.72.85.12','06.10.21.11.09',NULL,'1 RUE DU MAGASIN APOUDRE','','','14000','CAEN',NULL,NULL,'1670650370002',80.000000000,'1991-07-19','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9573,'OSSEMONT','CELINE','1936-02-03','02.79.67.97.39','06.22.12.58.79',NULL,'69 AV D HARCOURT RED GD PRES','','','14210','STE HONORINE DU FAY',NULL,NULL,'2360250356002',168.000000000,'1966-08-20','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9574,'COLOMES','Jacqueline','1957-05-24','02.10.46.95.17','06.11.26.96.14',NULL,'CIDEX 51','','','14270','MEZIDON CANON',NULL,NULL,'1570514090002',17.000000000,'1987-02-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9575,'GALLEAZZI','CELINE','1952-01-06','02.34.84.89.20','06.80.29.23.48',NULL,'38 rue du nouveau monde','','','14310','TRACY BOCAGE',NULL,NULL,'1520114654002',29.000000000,'1978-01-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9576,'VERITE','EMILIE','1930-07-16','02.83.14.96.34','06.44.52.68.70',NULL,'5 PLACE PABLO PICASSO','','','14120','MONDEVILLE',NULL,NULL,'2300714002002',93.000000000,'1955-09-05','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9577,'GERVAISE','valentin','1945-07-28','02.25.74.31.44',NULL,NULL,'14 RUE DE LA DELIVRANDE','','','14120','MONDEVILLE',NULL,NULL,'1450714605002',13.000000000,'1967-07-03','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9578,'FOUCHER','VALERIE','1939-05-11','02.44.41.44.91','06.10.02.52.74',NULL,'5 RUE MONTCALM ou ATC carpiquet','','','14240','ANCTOVILLE',NULL,NULL,'2390550639002',75.000000000,'1962-12-16','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9579,'MACAULT','MELANIE','1951-04-04','02.20.48.06.46','06.24.12.26.59',NULL,'5 RUE ROGER DECHAMBRE','','','14670','TROARN',NULL,NULL,'1510414022002',134.000000000,'1975-09-27','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9580,'GUILMONT','nelly','1935-05-20','02.73.71.15.51','06.46.69.68.18',NULL,'26 rue st michel','','','14320','FONTENAY LE MARMION',NULL,NULL,'1350514701002',11.000000000,'1961-11-21','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9581,'TROHEL','CAROLINE','1943-03-29','02.11.94.05.57','06.69.41.11.84',NULL,'21 AV PERE CHARLES DE FOUCAULT','','','14111','LOUVIGNY',NULL,NULL,'2430314716002',682.000000000,'1964-09-01','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9582,'DJIHIL','AURELIE','1933-12-24','02.55.57.14.27','06.24.55.35.46',NULL,'18 RUE DE BENAUVILLE','','','61200','AUNOU LE FAUCON',NULL,NULL,'2331222166002',186.000000000,'1955-06-28','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9583,'DELAUNAY','CINDY','1953-01-06','02.20.18.73.17','06.71.28.55.84',NULL,'14 rue bis de la resistance','','','14000','CAEN',NULL,NULL,'2530114407002',429.000000000,'1983-10-16','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9584,'HOUEL','ELODIE','1952-04-24','02.90.51.48.33','06.11.73.78.48',NULL,'14 RUE DE LA DELIVRANDE','','','14630','FRENOUVILLE',NULL,NULL,'1520414158002',100.000000000,'1978-12-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9585,'LELIEVRE','PASCALE','1945-03-10','02.13.07.95.69','06.29.03.42.58',NULL,'38 rue du quebec','','','61160','CHAMBOIS',NULL,NULL,'2450314074002',56.000000000,'1968-02-15','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9586,'JOSEPH','NADEGE','1938-03-01','02.85.79.31.09','06.14.72.25.09',NULL,'PLACE DE L''EGLISE','','','61200','AUNOU LE FAUCON',NULL,NULL,'2380376287002',32.000000000,'1961-02-17','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9587,'EUDINE','SOPHIE','1928-02-11','02.84.56.77.83','06.62.81.07.13',NULL,'14 rue de fraternite','','','14123','IFS',NULL,NULL,'1280251230002',17.000000000,'1952-03-05','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9588,'LEROUVILLOIS','AURELIE','1935-08-27','02.58.03.68.76','06.77.61.92.09',NULL,'8 ALLEE DES POETES','','','14123','IFS',NULL,NULL,'1350837261002',1034.000000000,'1958-08-08','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9589,'LEBLANC','JEROME','1939-07-28','02.55.88.63.77','06.63.79.80.03',NULL,'4 ALLEE DES CAPUCINES','','','14000','CAEN',NULL,NULL,'1390777280002',18.000000000,'1962-10-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9590,'LEMONNIER','MARLENE','1951-01-24','02.46.70.48.33','06.10.44.13.23',NULL,'2 RUE JUGAN','','','14270','MEZIDON CANON',NULL,NULL,'2510102409002',663.000000000,'1972-12-17','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9591,'LAHAYE','CAROLE','1945-01-06','02.61.59.87.98','06.95.96.20.95',NULL,'22 PLACE BOUCHARD','','','14370','MOULT',NULL,NULL,'2450114516002',1503.000000000,'1967-12-05','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9592,'DUBOSCQ','CAROLINE','1954-01-15','02.89.86.35.07','06.49.88.08.09',NULL,'le bourg','','','50340','GROSVILLE',NULL,NULL,'1540161287002',551.000000000,'1982-05-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9593,'BENMERZOUG','SANDRA','1932-05-10','02.10.94.34.95','06.28.03.19.35',NULL,'3 rue paul verlaine','','','14000','CAEN',NULL,NULL,'2320514629002',18.000000000,'1955-08-14','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9594,'CHAUVEL','NATACHA','1938-11-17','02.31.52.53.08','06.19.36.60.04',NULL,'4 RUE AMPERE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'1381114437002',1310.000000000,'1964-04-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9595,'ENAULT','SYLVAINE','1942-03-18','02.89.64.10.00','06.27.77.22.42',NULL,'59 RUE DU QUEBEC','','','14000','CAEN',NULL,NULL,'1420327547002',325.000000000,'1968-05-19','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9596,'GUERARD','MARIE-EMILIE',NULL,'02.65.83.83.88','06.10.24.04.75',NULL,'LE BUSSON','','','14120','MONDEVILLE',NULL,NULL,'8076360161002',94.000000000,'2010-10-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9597,'GASNIER','LAURE','1931-12-18','02.15.95.49.00','06.58.65.80.96',NULL,'3 rue albert bayet','','','14840','DEMOUVILLE',NULL,NULL,'2311233069002',83.000000000,'1954-04-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9598,'AKOPIAN','AURELIE','1948-01-01','02.10.15.39.58','06.11.61.23.55',NULL,'6 RUE VARIN','','','14120','MONDEVILLE',NULL,NULL,'1480114090002',54.000000000,'1978-07-19','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9599,'LANGEVIN','FLORENCE','1963-04-18','02.71.61.13.28','06.87.91.52.74',NULL,'23 cite libere','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1630461072002',3376.000000000,'1985-10-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9600,'GODARD','SANDRINE','1937-07-14','02.76.72.96.23','06.56.20.89.62',NULL,'LE MARAIS','','','14540','ST AIGNAN DE CRAMESNIL',NULL,NULL,'1370714422002',302.000000000,'1967-07-31','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9601,'HAMON','ELODIE','1955-05-13','02.34.61.80.51','06.86.85.30.39',NULL,'27 av du parc','','','14150','OUISTREHAM',NULL,NULL,'2550514409002',28.000000000,'1985-08-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9602,'VASTEL','ELODIE','1961-05-25','02.14.21.70.25','06.25.67.77.77',NULL,'10 ROUTE DE CREULLY','','','14000','CAEN',NULL,NULL,'2610514383002',13.000000000,'1983-05-27','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9603,'METTE','CHRISTINE','1937-02-21','02.28.89.74.55',NULL,NULL,'38 AVENUE DU CALVADOS','','','14860','AMFREVILLE',NULL,NULL,'1370214753002',473.000000000,'1966-10-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9604,'DODIER','NATHALIE','1938-01-05','02.16.04.30.01','06.39.67.71.27',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'2380102290002',838.000000000,'1960-12-18','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9605,'MARIE','NADIA','1932-07-27','02.92.84.25.06','06.30.07.08.43',NULL,'','','','14220','BOULON',NULL,NULL,'2320714689002',334.000000000,'1960-12-07','GOLD',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9606,'LEMEUR','CAROLINE','1933-09-06','02.54.62.34.78','06.43.69.80.07',NULL,'AVENUE DE LA BRECHE BUHOT RESID','ENCE CABOURG 2000','','14230','VOUILLY',NULL,NULL,'2330914760002',5.000000000,'1955-10-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9607,'PROVOOST','ARMELLE','1933-02-12','02.56.55.77.19','06.10.64.86.34',NULL,'5 LEVAL VACLIER','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2330214039002',1098.000000000,'1963-04-09','PLATINIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9608,'LECOUTEY','EMMANUELLE','1967-05-16','02.15.43.19.25','06.38.75.48.19',NULL,'47 rue louis robien','','','14270','MEZIDON CANON',NULL,NULL,'1670514535002',56.000000000,'1993-12-06','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9609,'SERVAGER','DENISE','1940-12-10','02.57.97.85.95','06.76.03.32.74',NULL,'9 RUE DES PRIMEVERES','','','14840','DEMOUVILLE',NULL,NULL,'1401222345002',204.000000000,'1969-08-06','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9610,'VLIEGEN','GUILLAUME','1940-02-14','02.43.98.65.54','06.61.55.22.37',NULL,'5 RUE DE LA PAIX','','','14840','DEMOUVILLE',NULL,NULL,'1400228280002',26.000000000,'1965-05-10','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9611,'ROUSSELLE','CLAIRE','1937-12-03','02.70.31.32.90','06.61.69.30.93',NULL,'11 RUE DE LA VALLEE','','','14210','AVENAY',NULL,NULL,'1371222146002',435.000000000,'1963-02-03','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9612,'AUVRAY','DELPHINE','1968-04-11','02.49.76.57.44','06.44.00.95.22',NULL,'23 rue camille blaisot','','','14220','ESSON',NULL,NULL,'1680414118002',167.000000000,'1997-05-08','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9613,'HERVO','NATHALIE','1939-06-05','02.55.20.55.88','06.11.44.73.23',NULL,'1 RUE DES MESANGES','','','14000','CAEN',NULL,NULL,'2390614663002',22.000000000,'1966-04-25','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9614,'MATHIEU','CLEMENTINE','1937-08-27','02.43.16.21.33','06.99.95.40.10',NULL,'DE LA VALLEE','','','14220','CROISILLES',NULL,NULL,'1370814530002',3228.000000000,'1960-01-25','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9615,'LECORDIER','JEROME','1942-07-03','02.65.90.27.72','06.64.09.78.60',NULL,'48 rue de northam','','','14120','MONDEVILLE',NULL,NULL,'1420714489002',54.000000000,'1966-07-07','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9616,'DALLET','VERONIQUE','1946-03-12','02.61.93.17.59','06.11.68.08.26',NULL,'LA RUE','','','14123','FLEURY SUR ORNE',NULL,NULL,'1460376689002',51.000000000,'1969-03-22','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9617,'MARIN','LEONA','1954-07-21','02.22.49.13.31','06.82.41.44.78',NULL,'28 RUE GAMBETTA','','','14000','CAEN',NULL,NULL,'1540737070002',30.000000000,'1977-07-15','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9618,'MOREL','Sebastien','1964-02-13','02.11.42.36.64','06.85.39.27.94',NULL,'43 chemin de l infirmerie','','','61310','COURMENIL',NULL,NULL,'1640214290002',313.000000000,'1987-03-14','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9619,'LEVEQUE','ALICE','1931-09-10','02.35.70.20.66','06.11.07.80.24',NULL,'13 RUE DES FAUVETTES','','','61100','AUBUSSON',NULL,NULL,'2310950621002',25.000000000,'1952-02-03','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9620,'MOUFLE','ALEXANDRA','1949-08-05','02.34.72.01.71','06.65.68.05.59',NULL,'67 rue voltair','','','14220','THURY HARCOURT',NULL,NULL,'2490889329002',763.000000000,'1975-09-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9621,'GELINAUD','VIRGINIE','1951-07-02','02.90.00.11.96','06.75.71.56.81',NULL,'9 RUE MANGE MATIN','','','14600','EQUEMAUVILLE',NULL,NULL,'1510714118002',158.000000000,'1973-03-12','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9622,'PINCON','JEFFRY','1926-11-12','02.11.56.96.43','06.30.92.80.59',NULL,'23 RUE D''ARGENCES','','','14270','ERNES',NULL,NULL,'2261167437002',1121.000000000,'1951-05-26','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9623,'LHOMME','ISABELLE','1962-03-27','02.89.51.05.81','06.80.06.54.55',NULL,'LE BOURG','','','14600','HONFLEUR',NULL,NULL,'1620314310002',5.000000000,'1983-08-26','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9624,'CHAPRON','CELINE','1928-10-01','02.97.09.51.15','06.18.92.27.18',NULL,'30 RUE DU REGIMENT DE LA CHAUDIE','RE','','14690','PONT D''OUILLY',NULL,NULL,'1281050343002',50.000000000,'1955-04-19','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9625,'BOURDAIS','ELODIE',NULL,'02.13.39.81.37','06.40.64.52.31',NULL,'47 RUE DE VERDUN','','','14540','SOLIERS',NULL,NULL,'2410614581002',566.000000000,'2011-11-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9626,'HAMEL','DAMIEN',NULL,'02.73.42.88.17','06.38.52.65.14',NULL,'30 rue des jardins','','','14670','TROARN',NULL,NULL,'2300927669002',56.000000000,'2011-02-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9627,'THIBAULT','FERAN','1958-10-08','02.59.39.90.95','06.21.86.70.44',NULL,'22, rue Jardin Barbet','','','14000','CAEN',NULL,NULL,'2581014233002',86.000000000,'1982-12-02','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9628,'BEUNARD','LUDWIG','1931-10-02','02.61.44.13.81','06.52.52.91.15',NULL,'18 AVENUE DU PRESIDENT COTY','','','14800','TOUQUES',NULL,NULL,'2311014559002',2648.000000000,'1952-04-27','PREMIUM',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9629,'EDENNE','SANDRINE','1932-09-22','02.10.02.48.88','06.14.99.29.78',NULL,'14/2 rue du 6juin','','','14790','VERSON',NULL,NULL,'2320950391002',26.000000000,'1958-03-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9630,'BERTHELOT','GUILLAUME','1958-04-12','02.86.12.26.58','06.11.48.32.59',NULL,'4 le bout de godets','','','14760','BRETTEVILLE SUR ODON',NULL,NULL,'1580414009002',207.000000000,'1982-08-12','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9631,'PIRON','AGNES','1958-09-01','02.30.41.37.66','06.56.58.33.90',NULL,'PLACE DE L4EGLISE','','','14000','CAEN',NULL,NULL,'1580961030002',19.000000000,'1979-05-10','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9632,'FOUBERT','CATHERINE','1960-01-10','02.78.28.32.80','06.20.00.49.58',NULL,'16 RUE DE VERRIERES','','','14000','CAEN',NULL,NULL,'2600114341002',349.000000000,'1989-04-17','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9633,'CRUCHON','BENEDICTE','1955-05-19','02.89.92.18.91','06.53.56.06.28',NULL,'LES MANOIR LES POIRIER','','','14000','CAEN',NULL,NULL,'1550514665002',1876.000000000,'1976-08-05','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9634,'DESHAYES','SONIA','1948-01-21','02.18.62.36.21','06.18.74.58.72',NULL,'4 RUE DE LA MAIRIE','','','14220','CULEY LE PATRY',NULL,NULL,'1480114305002',83.000000000,'1969-08-03','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9635,'LEVALLOIS','SAMIA','1928-06-24','02.10.40.94.66','06.61.73.53.28',NULL,'RUE  REGIMENT D ARTILLERIE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1280614281002',371.000000000,'1955-01-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9636,'LECOURTOIS','SELDA','1958-02-12','02.55.18.47.50','06.44.22.49.54',NULL,'908 BD DE LA GRANDE DELLE','','','14220','THURY HARCOURT',NULL,NULL,'2580250086002',651.000000000,'1981-12-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9637,'LEMAITRE','MARCEL','1958-09-21','02.62.36.95.93','06.88.05.11.20',NULL,'28 bvd pierre corneille','','','14690','PONT D''OUILLY',NULL,NULL,'1580975009002',40.000000000,'1982-07-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9638,'FLAMBARD','AURORE','1967-02-24','02.35.89.39.47','06.18.15.97.51',NULL,'le frene d argences','','','14840','DEMOUVILLE',NULL,NULL,'1670227151002',18.000000000,'1997-09-20','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9639,'ROCHE','BETTY','1964-11-08','02.11.79.00.09','06.95.14.73.54',NULL,'21 RUE DU REGRET       LOT LES T','ILLEUL','','14700','FALAISE',NULL,NULL,'2641175005002',282.000000000,'1992-08-14','PREMIUM',13,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9640,'BERTIN','ALEXANDRA',NULL,'02.37.93.87.81','06.69.18.14.52',NULL,'22 RUE DU COMMANDANT CHARCOT','','','14540','ROCQUANCOURT',NULL,NULL,'2641175005002',321.000000000,'2011-01-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9641,'VANDERMERSCH','FRANCOISE','1958-05-02','02.25.86.48.94','06.58.42.75.96',NULL,'les avenages','','','14000','CAEN',NULL,NULL,'1580576420002',12.000000000,'1986-06-04','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9642,'BOURGUAIS','LAURENT','1931-02-12','02.62.77.93.46','06.71.28.25.51',NULL,'9 bd sainte anne','','','14940','SANNERVILLE',NULL,NULL,'2310214288002',205.000000000,'1954-01-18','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9643,'FERGANT','Djelloul','1952-08-29','02.31.65.22.21','06.16.28.31.01',NULL,'4 RUE CAPITAINE FOUCHER','','','14210','LE LOCHEUR',NULL,NULL,'1520875044002',1.000000000,'1973-05-11','PREMIUM',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9644,'SZYMANSKI','Celia','1932-07-04','02.57.75.46.41','06.46.67.21.49',NULL,'7 ompasse de la madeleine','','','14630','CAGNY',NULL,NULL,'2320750480002',91.000000000,'1953-03-11','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9645,'HOLLER','LAURENCIA','1934-06-13','02.15.33.20.14','06.80.62.02.04',NULL,'','','','14670','JANVILLE',NULL,NULL,'2340614751002',229.000000000,'1959-01-30','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9646,'EUDINE','INGE','1958-09-19','02.80.50.03.16','06.49.09.17.68',NULL,'3 PLACE LOUISE DE MARILLAC','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'1580957137002',1118.000000000,'1982-02-15','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9647,'GESTIN','MIREILLE','1946-02-25','02.25.16.91.21','06.27.97.68.99',NULL,'4 RUE DU CAPITAINE FOUCHER','','','61100','FLERS',NULL,NULL,'2460214675002',776.000000000,'1970-11-06','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9648,'GREGOIRE','NATHALIE','1962-04-04','02.80.66.17.41','06.63.90.83.72',NULL,'Le Bourg Cursey sur Orne','','','14000','CAEN',NULL,NULL,'1620414525002',37.000000000,'1983-08-30','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9649,'LECERF','JEAN-PAUL',NULL,'02.11.43.46.27','06.12.21.02.48',NULL,'2006 RUE DE LA VALLEE','','','14000','CAEN',NULL,NULL,'1480414101002',22.000000000,'2011-02-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9650,'ANDRE','pierre','1966-07-21','02.39.12.35.93','06.65.25.11.29',NULL,'LE BOURG','','','14840','DEMOUVILLE',NULL,NULL,'2660761177002',130.000000000,'1996-08-18','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9651,'LEROY','amandine','1958-09-30','02.32.52.42.67','06.37.98.25.51',NULL,'28 RUE ANDRE LEMAITRE','','','14000','CAEN',NULL,NULL,'1580957137002',76.000000000,'1982-12-13','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9652,'TALVAST','PATRICE','1940-04-12','02.65.49.56.38','06.33.41.39.94',NULL,'7 PLACE DE L''EGLISE','','','14000','CAEN',NULL,NULL,'1400472022002',821.000000000,'1967-08-28','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9653,'ENAULT','DANIEL','1944-07-21','02.17.46.02.43','06.64.03.77.32',NULL,'4 AVENUE PASTEUR MARTIN LUTHER K','ING','','50250','ST JORES',NULL,NULL,'1440750223002',472.000000000,'1970-03-17','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9654,'BOUILLON','ALEXANDRA','1930-09-17','02.39.51.20.34','06.55.47.55.97',NULL,'9 imp des pres','','','14390','CABOURG',NULL,NULL,'2300914516002',80.000000000,'1957-02-14','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9655,'BARBEY','FARID','1949-12-05','02.12.16.57.09','06.59.46.16.76',NULL,'2 RUE PIERRE MENDES FRANCE','','','14460','COLOMBELLES',NULL,NULL,'1491214329002',243.000000000,'1978-05-23','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9656,'LECUIROT','ODETTE',NULL,'02.69.84.76.87','06.71.38.58.35',NULL,'30 rue le clos du pavillon','','','14120','MONDEVILLE',NULL,NULL,'',1643.000000000,'2009-10-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9657,'LEMIEUX','stephane',NULL,'02.41.47.71.80','06.24.44.69.05',NULL,'1 RUE DES GLENGARRIENS','','','14120','MONDEVILLE',NULL,NULL,'',4184.000000000,'2008-10-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9658,'BUFFARD','EL HABI',NULL,'02.47.22.49.35','06.12.00.46.46',NULL,'','','','14630','CAGNY',NULL,NULL,'',695.000000000,'2012-12-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9659,'ALEXANDRE','genevive',NULL,'02.91.41.24.47','06.89.83.83.49',NULL,'93 route de caumont','','','14220','HAMARS',NULL,NULL,'',1142.000000000,'2008-07-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9660,'GOUGET','ALINE',NULL,'02.93.66.39.47','06.96.89.17.39',NULL,'16 rue des brulleres','','','14000','CAEN',NULL,NULL,'',2941.000000000,'2008-06-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9661,'CHERIE','MATHILDE',NULL,'02.55.30.43.85','06.60.24.00.39',NULL,'13 rue du parc','','','14260','LE MESNIL AU GRAIN',NULL,NULL,'',4.000000000,'2011-06-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9662,'HUREL','SANDRA',NULL,'02.20.58.60.93','06.81.81.37.47',NULL,'12 rue fresnel','','','14630','CAGNY',NULL,NULL,'',56.000000000,'2012-11-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9663,'CARON','EMILIE','1948-07-17','02.22.47.70.22','00 33 6.91.93.14.32',NULL,'la folie','','','14190','ST GERMAIN LE VASSON',NULL,NULL,'2480714249002',198.000000000,'1975-10-23','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9664,'GILLARD','SEVERINE','1935-06-15','02.74.79.16.60',NULL,NULL,'3 rue des coudraies','','','14370','MOULT',NULL,NULL,'2350614225002',50.000000000,'1959-12-28','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9665,'DUMAIL','madeleine','1928-05-16','02.57.85.04.25','06.79.21.97.03',NULL,'12 residence du parc','','','14000','CAEN',NULL,NULL,'2280522183002',281.000000000,'1956-06-25','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9666,'AILLET','sylvain','1947-03-07','02.95.83.64.94','06.88.92.64.67',NULL,'LES BORDEAUX','','','61190','TOUROUVRE',NULL,NULL,'2470314713002',88.000000000,'1975-08-19','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9667,'DROULON','emilie','1930-04-12','02.91.24.09.88','06.10.64.32.16',NULL,'8 CHEMIN DE SAINT MARDS','','','14000','CAEN',NULL,NULL,'1300414119002',204.000000000,'1957-07-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9668,'MALABOEUF CARRE','maryline','1931-10-06','02.70.55.59.19','06.80.53.72.81',NULL,'30 BIS RUE MALFILATRE','','','50330','ST PIERRE EGLISE',NULL,NULL,'2311014467002',66.000000000,'1958-06-09','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9669,'THOMAS','sabrina','1931-03-05','02.93.43.46.42','06.35.16.99.88',NULL,'1 RUE HENRI DAGORN','','','14840','DEMOUVILLE',NULL,NULL,'2310314543002',261.000000000,'1955-09-24','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9670,'LECOLLEY','annick','1953-01-17','02.20.26.18.65','06.77.39.94.80',NULL,'hameau de longchamp','','','14000','CAEN',NULL,NULL,'1530114685002',408.000000000,'1980-11-03','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9671,'MACAULT','julie','1948-11-23','02.19.29.55.95','06.48.02.27.88',NULL,'13 RUE DES CLEMATITES','','','14840','DEMOUVILLE',NULL,NULL,'2481114537002',2592.000000000,'1977-06-14','GOLD',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9672,'VASSEUR','JEROME','1965-03-27','02.91.25.83.91','06.16.59.29.70',NULL,'102 rte d''harcourt','','','14123','IFS',NULL,NULL,'1650314666002',315.000000000,'1994-03-26','PREMIUM',12,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9673,'PEIGNEY','ARNAUD','1932-08-16','02.22.48.68.21','06.12.20.47.42',NULL,'20 rue D HELSINSKI','','','14360','TROUVILLE SUR MER',NULL,NULL,'2320814720002',1412.000000000,'1959-10-31','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9674,'BOUSSUGUE','VICKY','1939-08-30','02.12.16.53.54','06.28.08.40.63',NULL,'11 RUE DU 8 MAI 1945','','','14100','LE MESNIL EUDES',NULL,NULL,'2390814027002',738.000000000,'1966-10-14','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9675,'LABEY','CINDY','1956-06-16','02.11.66.70.86','06.11.51.49.38',NULL,'7 rue docteur roux','','','14000','CAEN',NULL,NULL,'1560614042002',156.000000000,'1985-09-03','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9676,'LETELLIER','LUCIENNE','1928-09-07','02.45.89.00.25','06.76.33.07.73',NULL,'2 RUE PABLO PICASSO','','','14540','HUBERT FOLIE',NULL,NULL,'1280914118002',96.000000000,'1957-10-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9677,'GOSSELIN','EMILIE','1932-02-16','02.14.48.61.49','06.60.23.46.54',NULL,'GRANDE RUE','','','14000','CAEN',NULL,NULL,'2320261426002',4.000000000,'1958-04-15','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9678,'PIET','DELPHINE','1940-01-11','02.28.63.62.82','06.24.08.29.61',NULL,'4 RUE STE CECILE','','','14123','IFS',NULL,NULL,'1400114437002',47.000000000,'1963-06-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9679,'LAVIE','gislaine',NULL,'02.66.37.81.85','06.10.95.77.13',NULL,'2 terre la bruyere','','','14120','MONDEVILLE',NULL,NULL,'1291053262002',6.000000000,'2012-03-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9680,'FOURREAU','Fabien','1933-01-08','02.10.12.99.28','06.67.92.00.84',NULL,'12 rue  hertor berlioz','','','14120','MONDEVILLE',NULL,NULL,'1330114157002',931.000000000,'1954-03-03','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9681,'DANJOIE','christian','1980-04-10','02.57.22.70.53','06.71.60.82.01',NULL,'4 RUE STE CECILE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2800499337002',232.000000000,'2008-11-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9682,'CAPELLO','ARLETTE','1940-09-18','02.36.41.14.41','06.80.41.73.70',NULL,'LA VALLEE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2400956041002',17.000000000,'1967-12-24','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9683,'BRETEL','NATHALIE','1928-06-19','02.13.59.90.33','06.11.81.19.08',NULL,'25 RUE DE LA CROIX PICARD','','','14500','VIRE',NULL,NULL,'1280614119002',2138.000000000,'1953-06-13','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9684,'BEUVE','Eric','1933-08-30','02.50.40.06.68','06.45.66.09.54',NULL,'RUE DU BAS DE CONDE','','','14940','SANNERVILLE',NULL,NULL,'1330814100002',63.000000000,'1955-07-22','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9685,'CAMBYSE','JESSY',NULL,'02.84.30.77.90','06.18.18.10.80',NULL,'La Croix aux Houx','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'',373.000000000,'2011-11-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9686,'LELIEVRE','SEVERINE',NULL,'02.73.53.76.13','06.24.43.40.23',NULL,'2 rue du Bel Air','','','14000','CAEN',NULL,NULL,'',3590.000000000,'2009-05-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9687,'PORCON','GAELLE',NULL,'02.41.24.20.50','06.75.65.95.51',NULL,'2 rue Pierre Mends France','','','14940','SANNERVILLE',NULL,NULL,'',134.000000000,'2013-01-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9688,'BOURHIS','Sandrine',NULL,'02.46.47.93.72','06.20.44.97.91',NULL,'3 rue des Carelles','','','14570','LA VILLETTE',NULL,NULL,'',212.000000000,'2010-11-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9689,'HOUTTEVILLE','VINCENT',NULL,'02.89.52.55.05','06.34.87.86.84',NULL,'Rsidence les Cteaux 58 route d','''Harcourt','','14610','CAMBES EN PLAINE',NULL,NULL,'',14.000000000,'2008-03-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9690,'BLANDIN','ALEXANDRA',NULL,'02.59.12.84.68','06.43.06.55.67',NULL,'2 RUE JEAN MOULIN RESIDENCE FRA','NCOIS MITERRAND','','14000','CAEN',NULL,NULL,'',2420.000000000,'2010-07-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9691,'JARDIN','MARIE',NULL,'02.94.35.97.36','06.11.99.44.39',NULL,'8 CHEMIN DES LONGS FOULINS','','','14240','CAUMONT L''EVENTE',NULL,NULL,'',1073.000000000,'2011-02-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9692,'ISSAMBOURG','LAETITIA',NULL,'02.37.28.47.32','06.40.41.83.85',NULL,'13 RUE DE VERDUN','','','14000','CAEN',NULL,NULL,'',15.000000000,'2012-02-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9693,'JOIMEL','ALAIN',NULL,'02.44.83.85.73','06.10.86.08.52',NULL,'33 RUE DE LA FONTAINE','','','14120','MONDEVILLE',NULL,NULL,'',58.000000000,'2011-08-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9694,'MOTTIER','jean marie',NULL,'02.69.85.66.84','06.28.03.39.12',NULL,'51 BIS RUE CAPONIERE','','','14270','OUEZY',NULL,NULL,'',12.000000000,'2011-09-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9695,'AHMED','NATHALIE',NULL,'02.76.15.13.54','06.12.90.73.97',NULL,'2 RUE ERICK SATIE','','','14370','ARGENCES',NULL,NULL,'',857.000000000,'2011-03-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9696,'GLINEL','MARIE CHRISTINE',NULL,'02.12.26.78.02','06.89.10.63.17',NULL,'35 rue des Carreux','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'',116.000000000,'2011-12-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9697,'RONDEAU','MICHEL',NULL,'02.58.12.21.77','06.86.25.77.72',NULL,'7 rue du Qubec','','','14670','GIBERVILLE',NULL,NULL,'',28.000000000,'2013-07-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9698,'FESTE','SYLVIE',NULL,'02.99.97.45.44','06.10.66.67.86',NULL,'8 RUE DU PARC','','','14370','CROISSANVILLE',NULL,NULL,'',1100.000000000,'2011-05-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9699,'HUYTS','lise',NULL,'02.31.94.29.96','06.58.66.53.68',NULL,'LES 5 AUTELS CHEMIN DE LA TANNE','RIE','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'',113.000000000,'2009-04-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9700,'BEAUVOIS','JANINE',NULL,'02.21.63.90.95','06.95.24.39.98',NULL,'194 RUE DE FALAISE','','','14460','COLOMBELLES',NULL,NULL,'',242.000000000,'2008-06-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9701,'JACQ','JESSICA',NULL,'02.11.09.56.66','06.57.87.14.09',NULL,'6 IMPASSE DE LA HETRAIE','','','63430','PONT DU CHATEAU',NULL,NULL,'',23.000000000,'2011-11-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9702,'LEROY','MAXIME',NULL,'02.22.59.18.18','06.69.52.74.98',NULL,'2 RUE DU TEMPS PERDU','','','14123','IFS',NULL,NULL,'',968.000000000,'2012-01-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9703,'LEPETIT','MAXIME',NULL,'02.18.09.20.46','06.16.60.68.32',NULL,'RUE DE BOURGEAUVILLE','','','14120','MONDEVILLE',NULL,NULL,'',5.000000000,'2010-03-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9704,'GODEFROY','LYDIE',NULL,'02.88.47.53.15','06.28.34.71.35',NULL,'HAMEAU DE SAUTELS','','','14000','CAEN',NULL,NULL,'',64.000000000,'2011-01-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9705,'MILOUX','FLORENCE',NULL,'02.13.08.56.27','06.12.13.90.49',NULL,'Le Dtroit','','','14370','GIBERVILLE',NULL,NULL,'',220.000000000,'2010-09-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9706,'AUXEPAULES','CHRISTINE',NULL,'02.29.50.59.23','06.65.86.36.76',NULL,'21 rue de l''Avenir','','','14123','FLEURY SUR ORNE',NULL,NULL,'',1132.000000000,'2010-01-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9707,'MAISERET','CHRISTELLE',NULL,'02.68.56.55.37','06.28.42.06.26',NULL,'2 rue Paul Allene','','','14123','CORMELLES LE ROYAL',NULL,NULL,'',390.000000000,'2012-01-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9708,'ENEE','joseph',NULL,'02.96.94.30.25','06.78.12.55.00',NULL,'Rsidence Normandie 2 Be rue Em','ilie Zola','','61200','ARGENTAN',NULL,NULL,'',98.000000000,'2011-01-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9709,'SALLIOT','CHRISTOPHE','1923-02-24','02.21.87.72.77','06.75.86.64.89',NULL,'RUE JOSEPH DELENTE','','','14860','AMFREVILLE',NULL,NULL,'2230203147002',876.000000000,'1944-01-30','PREMIUM',22,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9710,'ISABEL','RAYMOND','1957-01-25','02.32.39.03.86','06.81.68.66.69',NULL,'14 rue de fraternite','','','14120','MONDEVILLE',NULL,NULL,'2570161508002',76.000000000,'1987-09-29','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9711,'LEVEILLE','ALAIN','1931-12-03','02.71.37.01.05','06.62.64.43.57',NULL,'3 RUE PIERRE TREBUSSIEN','','','61160','BAILLEUL',NULL,NULL,'2311214005002',76.000000000,'1953-05-27','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9712,'LENOBLE','JEAN LOUIS','1928-07-21','02.16.67.78.57','06.18.53.70.13',NULL,'2 bis rue de la grace de dieu','','','14270','MEZIDON CANON',NULL,NULL,'1280753202002',61.000000000,'1956-05-17','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9713,'LEPLANQUOIS','yannick','1935-03-04','02.13.58.32.03','06.90.42.70.49',NULL,'6 RUE DE MADRID','','','14330','LE MOLAY LITTRY',NULL,NULL,'2350314113002',796.000000000,'1963-08-11','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9714,'DONGE','florence','1936-11-24','02.11.05.13.09','06.88.08.97.13',NULL,'4 RESIDENCE OLYMPIA','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'2361178596002',91.000000000,'1959-11-15','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9715,'MAUDUIT','COLETTE','1948-05-14','02.62.87.43.40','06.15.35.80.71',NULL,'6 AVENUE PRESIDENT COTY','','','14840','DEMOUVILLE',NULL,NULL,'2480514006002',3686.000000000,'1970-11-02','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9716,'GRANDIN','JOCELYNE','1933-01-31','02.12.02.31.06','06.93.32.56.62',NULL,'7 rue de l''orne','','','14790','VERSON',NULL,NULL,'1330114206002',89.000000000,'1959-12-08','PREMIUM',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9717,'PIGNET','ANGELIQUE','1935-05-17','02.79.60.93.85','06.74.93.53.81',NULL,'10 RUE DES CAPUCINES','','','14120','MONDEVILLE',NULL,NULL,'2350514106002',165.000000000,'1957-05-29','SILVER',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9718,'FOUQUES','KARINE','1965-01-20','02.91.98.37.40','06.89.03.66.35',NULL,'13 COTE DU VAL','','','14630','FRENOUVILLE',NULL,NULL,'1650114623002',100.000000000,'1988-10-28','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9719,'GILLARD','CHARLENE','1937-10-13','02.80.83.69.88','06.61.37.51.54',NULL,'7 RUE DU POINT DU JOUR','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1371014277002',21.000000000,'1960-12-02','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9720,'AUVRAY','CATHERINE','1933-08-10','02.68.03.07.64','06.80.25.02.55',NULL,'15 RUE ANDRE LEMAITRE','','','14370','BELLENGREVILLE',NULL,NULL,'2330814672002',168.000000000,'1958-06-12','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9721,'BOUZAT','MELANIE','1963-07-26','02.76.18.64.34','06.56.05.81.13',NULL,'5/4 avenue du point du jour','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'1630714432002',20.000000000,'1988-01-19','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9722,'LE PRESLE','AURELIE','1957-02-19','02.42.57.30.31','06.71.86.29.84',NULL,'18 ROUTE DE PIERPONT','','',NULL,NULL,NULL,NULL,'1570214092002',22.000000000,'1978-08-30','PREMIUM',16,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9723,'FOUQUES','Peter','1937-11-13','02.20.42.28.55','06.43.36.81.08',NULL,'29 BVD RAYMOND POINCARE','','','14000','CAEN',NULL,NULL,'2371150297002',721.000000000,'1965-01-30','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9724,'MARIE','IRMA','1932-12-19','02.40.22.74.33',NULL,NULL,'VILLAGE QUEVRU','','','14610','BASLY',NULL,NULL,'1321261494002',1627.000000000,'1956-02-18','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9725,'DEGOURNAY','GEOFFREY','1942-06-04','02.92.30.62.52','06.30.74.33.07',NULL,'13 RUE DES PRINCES','','','14123','CORMELLES LE ROYAL',NULL,NULL,'2420627129002',394.000000000,'1967-01-11','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9726,'DENIS','GEOFFREY','1937-08-17','02.12.88.62.89','06.93.67.31.87',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'1370814117002',173.000000000,'1961-01-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9727,'PLESSIS','LARISSA','1935-02-20','02.11.88.76.86','06.52.29.10.80',NULL,'1 croix de a brulette','','','14220','THURY HARCOURT',NULL,NULL,'2350214431002',38.000000000,'1965-10-12','SILVER',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9728,'COQUIERE','Remy','1930-06-30','02.44.63.25.20','06.39.53.80.11',NULL,'9 RUE DES OISEAUX','','','50630','QUETTEHOU',NULL,NULL,'1300614271002',1636.000000000,'1957-01-21','GOLD',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9729,'REGNIER','christine',NULL,'02.41.34.87.35','06.52.09.71.70',NULL,'25 rue de la Fontaine','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'',1133.000000000,'2009-12-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9730,'PAIN','VIRGINIE',NULL,'02.10.63.27.33','06.11.82.82.47',NULL,'La Titelire','','','14540','SOLIERS',NULL,NULL,'',137.000000000,'2009-06-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9731,'PROFFIT','LAURIE',NULL,'02.22.27.32.09','06.41.74.63.69',NULL,'46 rue du Hamel','','','14940','GIBERVILLE',NULL,NULL,'',22.000000000,'2008-03-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9732,'TRIGER','SOPHIE',NULL,NULL,NULL,NULL,'29 rue de la Plaine','','','61200','ARGENTAN',NULL,NULL,'',26.000000000,'2008-01-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9733,'QUIEDVILLE','JACQUELINE',NULL,'02.56.96.60.32','06.35.61.65.18',NULL,'50 RUE DE NORTHAM','','','14730','GIBERVILLE',NULL,NULL,'',38.000000000,'2009-02-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9734,'GIRARD','LEONE HENRIETTE',NULL,'02.45.95.40.14','06.13.52.54.55',NULL,'1511 Quartier du bois','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'',81.000000000,'2013-07-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9735,'FRILLEY','YAMINA',NULL,'02.57.46.59.37','06.85.84.95.60',NULL,'10 rue du val','','','14270','CONDE SUR IFS',NULL,NULL,'',701.000000000,'2010-10-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9736,'ROUVRES','MAGDELENA',NULL,'02.89.06.28.90','06.75.21.58.02',NULL,'8 rue de la Mare','','','14730','GIBERVILLE',NULL,NULL,'',10.000000000,'2010-09-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9737,'TAUPIN','CARMEN',NULL,'02.78.18.46.92','06.10.07.15.49',NULL,'3 rue jean marot','','','14123','IFS',NULL,NULL,'',1264.000000000,'2008-06-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9738,'JEAN','NADIM',NULL,'02.75.81.95.55','06.35.07.95.95',NULL,'11 ALLEE DES FUSILLES','','','14000','CAEN',NULL,NULL,'',59.000000000,'2012-03-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9739,'LE MALICOTTE','Blandine',NULL,'02.52.27.26.83','06.86.88.54.28',NULL,'9 Impasse de la Garenne','','','14210','CHEUX',NULL,NULL,'',13.000000000,'2008-09-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9740,'GUERRIER','GUY',NULL,'02.22.12.95.14','06.76.94.45.11',NULL,'La Bruyre','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'',319.000000000,'2013-06-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9741,'LEPLEUX','DANIELLE',NULL,'02.52.86.20.12','06.14.73.64.43',NULL,'99 Bd Raymond Poincar','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'',636.000000000,'2012-05-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9742,'COSME','VANESSA',NULL,'02.92.30.26.75','06.84.90.54.74',NULL,'33 rue de l''Edienne','','','14310','LONGVILLERS',NULL,NULL,'',13.000000000,'2013-04-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9743,'OZENNE','GUY',NULL,'02.77.50.52.40','06.72.25.59.75',NULL,'5 RUE DE LA BIENFAISANCE','','','14220','ESSON',NULL,NULL,'',39.000000000,'2010-05-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9744,'DALLET','SOPHIE',NULL,NULL,NULL,NULL,'33 rue de l''ancienne gare','','','14630','FRENOUVILLE',NULL,NULL,'',4387.000000000,'2013-04-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9745,'LAULIER','ISABELLE',NULL,'02.43.38.68.97','06.87.29.10.14',NULL,'route de bayeux','','','14570','CLECY',NULL,NULL,'',266.000000000,'2012-12-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9746,'LEGOVIC','VIRGINIA',NULL,'02.85.77.80.19','06.44.96.60.45',NULL,'3 ROUTE DE FLEURY SUR ORNE','','','14123','IFS',NULL,NULL,'',694.000000000,'2012-09-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9747,'LEBOUCHER','Marcel',NULL,'02.18.38.06.85','06.11.71.19.94',NULL,'1-1 Cit des Roches','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'',2178.000000000,'2009-11-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9748,'ROGER','Jacques',NULL,'02.99.63.60.45','06.11.01.39.40',NULL,'les fermes','','','61160','FEL',NULL,NULL,'',30.000000000,'2007-12-19','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9749,'VASNIER','MURIELLE',NULL,'02.41.13.85.55','06.31.90.97.69',NULL,'12 avenue de la concorde','','','14220','CURCY SUR ORNE',NULL,NULL,'',38.000000000,'2010-05-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9750,'HENIN','NATHALIE',NULL,'02.19.10.30.88','06.16.78.00.52',NULL,'23 rue du Commerce','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'',932.000000000,'2011-09-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9751,'PHILIPPE','MATHILDE',NULL,'02.14.79.55.85','06.23.15.04.55',NULL,'Village Durdos','','','14000','CAEN',NULL,NULL,'',642.000000000,'2013-09-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9752,'BARBIER','VIRGINIE',NULL,'02.86.12.39.41','06.74.68.45.66',NULL,'37 RUE MICHEL LASNE','','','14210','AMAYE SUR ORNE',NULL,NULL,'',2522.000000000,'2011-01-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9753,'VIMARD','CELINE',NULL,'02.10.06.34.41','06.36.38.17.09',NULL,'1 RUE DU DEFFEND','','','14220','THURY HARCOURT',NULL,NULL,'',83.000000000,'2011-03-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9754,'YONNET','ANGELIQUE',NULL,'02.55.22.70.21','06.10.58.69.09',NULL,'20 av de la 3e division d''infant','erie britanique','','14460','COLOMBELLES',NULL,NULL,'',29.000000000,'2008-03-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9755,'COTTEREAU','MICHEL','1930-03-01','02.55.08.95.65','06.11.27.99.55',NULL,'3 rue du mont hry','','','14730','GIBERVILLE',NULL,NULL,'2300314288002',14.000000000,'1951-07-31','GOLD',21,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9756,'COEURET','WILLY','1948-03-25','02.75.69.54.98','06.12.68.46.69',NULL,'75 RUE JEAN JAURES','','','14840','DEMOUVILLE',NULL,NULL,'2480353265002',189.000000000,'1969-11-27','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9757,'LAURENT','FLORENCE','1939-03-20','02.32.90.55.46','06.14.12.79.99',NULL,'1 rue daniel tison','','','14123','FLEURY SUR ORNE',NULL,NULL,'1390314719002',282.000000000,'1969-03-23','SILVER',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9758,'MARIE','SABRINE','1953-01-31','02.35.36.16.95','06.94.82.84.48',NULL,'PLACE DE L''EGLISE','','','14400','ST VIGOR LE GRAND',NULL,NULL,'1530114437002',1811.000000000,'1980-02-25','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9759,'AOUSTIN','RENEE','1937-07-07','02.19.17.84.36','06.52.32.78.74',NULL,'8 rue de la Grce de Dieu','','','14610','EPRON',NULL,NULL,'2370714034002',155.000000000,'1962-10-14','SILVER',19,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9760,'LEBRET','FRANOIS','1946-01-21','02.61.37.58.08','06.42.96.92.97',NULL,'22 bd raymond poincare','','',NULL,NULL,NULL,NULL,'1460114045002',157.000000000,'1967-11-24','GOLD',18,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9761,'LEFEVRE','OPHELIE','1957-01-30','02.61.92.78.15','06.63.18.25.70',NULL,'32 av des drakkars','','','14123','FLEURY SUR ORNE',NULL,NULL,'2570114294002',31.000000000,'1985-02-15','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9762,'HELAINE','CLARA','1953-01-01','02.30.48.59.79','06.22.37.98.07',NULL,'3/2 rue des prs','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'1530114633002',51.000000000,'1983-07-22','PREMIUM',15,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9763,'LAMOTTE','elodie','1963-07-05','02.82.40.93.27','06.68.84.84.03',NULL,'Les 5 Fermes','','','14150','OUISTREHAM',NULL,NULL,'2630750154002',49.000000000,'1986-11-23','PREMIUM',14,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9764,'HEBERT','LAETITIA','1947-08-29','02.23.66.85.21','06.10.88.84.11',NULL,'91 RUE DES ACACIAS','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'2470850101002',17.000000000,'1973-03-28','GOLD',17,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9765,'HUET','VERONIQUE','1928-05-05','02.78.22.38.95','06.75.69.64.60',NULL,'4 rue de la pomme d''or','','','14000','CAEN',NULL,NULL,'1280514299002',851.000000000,'1954-09-23','PREMIUM',20,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9766,'NOVO','DANY',NULL,'02.11.40.94.41','06.84.09.87.85',NULL,'LE BOURG','','','14210','EVRECY',NULL,NULL,'',1121.000000000,'2008-01-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9767,'CHARLET','VIRGINIE',NULL,'02.40.39.05.34','06.29.21.39.41',NULL,'27 PARABOLE DU CLOS','','','14270','MEZIDON CANON',NULL,NULL,'',17.000000000,'2008-06-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9768,'YBERT','SEVERINE',NULL,'02.53.14.87.13','06.88.28.57.64',NULL,'15 rue des prairies st gilles','','','14630','FRENOUVILLE',NULL,NULL,'',293.000000000,'2008-02-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9769,'MARIE','MAGALIE',NULL,'02.73.55.66.05','06.44.33.39.40',NULL,'18 rue Maurices Fouques','','','14860','AMFREVILLE',NULL,NULL,'',4.000000000,'2013-06-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9770,'JARDIN','Delphine',NULL,'02.44.77.00.35','06.82.50.58.26',NULL,'1 rue Rene Duchez PORTE 17 RESID','ENCE PORSMOUTH','','14000','CAEN',NULL,NULL,'',110.000000000,'2012-05-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9771,'LANDRU','DAVID',NULL,'02.66.53.34.87','06.20.29.64.78',NULL,'4 rue des hirondelles','','','14120','MONDEVILLE',NULL,NULL,'',178.000000000,'2011-08-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9772,'PELCOT','LUDOVIC',NULL,'02.64.75.30.27','06.56.16.96.91',NULL,'19 route de paris','','','14670','TROARN',NULL,NULL,'',76.000000000,'2008-10-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9773,'DELAPORTE LUCAS','LINA',NULL,'02.21.73.88.62','06.42.22.30.39',NULL,'19 RUE DES CLOS','','','14114','VER SUR MER',NULL,NULL,'',1100.000000000,'2011-02-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9774,'BRICET','roland',NULL,'02.10.05.96.86','06.80.48.12.34',NULL,'17 impasse valentin hauy','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'',173.000000000,'2011-03-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9775,'LAIDET','Monique',NULL,'02.56.19.20.66','06.75.02.81.16',NULL,'13 AVENUE DE LA CONCORDE','','','61160','BAILLEUL',NULL,NULL,'',857.000000000,'2010-04-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9776,'SCELLES','guy',NULL,'02.88.88.55.08','06.91.97.73.28',NULL,'21 RUE ROBERT LEBIS','','','14380','PONT FARCY',NULL,NULL,'',693.000000000,'2008-03-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9777,'GALLIS','ALAIN',NULL,'02.85.57.35.01','06.28.73.21.81',NULL,'1 RUE BASSE','','','14000','CAEN',NULL,NULL,'',43.000000000,'2013-02-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9778,'COQUELIN','DENISE',NULL,'02.56.68.37.40','06.26.28.11.43',NULL,'60 AVENUE LEON BLUM','','','14120','MONDEVILLE',NULL,NULL,'',45.000000000,'2009-08-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9779,'LELIEVRE','CLAUDE',NULL,'02.69.20.83.14','06.92.25.15.66',NULL,'37 rue de la libert','','','14123','IFS',NULL,NULL,'',80.000000000,'2008-01-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9780,'LAUMONDAIS','SIMONNE',NULL,'02.74.55.02.14',NULL,NULL,'58 rue de bayeux','','','14000','CAEN',NULL,NULL,'',72.000000000,'2009-06-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9781,'BOUTELOUP','DENISE',NULL,NULL,NULL,NULL,'','','','61310','EXMES',NULL,NULL,'',1.000000000,'2009-07-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9782,'LEFEVRE','GUY',NULL,'02.16.52.53.11','06.60.26.69.44',NULL,'16 Leon Blum','','','14120','MONDEVILLE',NULL,NULL,'',19.000000000,'2012-09-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9783,'MILLET','MICHEL',NULL,'02.42.45.30.42','06.42.23.96.82',NULL,'62 RUE LOUIS LECHATELLIER','','','14000','CAEN',NULL,NULL,'',159.000000000,'2010-02-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9784,'LEMIERE','henri',NULL,'02.77.93.40.88','06.21.75.27.73',NULL,'13 alle des Reblots','','','14570','ST REMY',NULL,NULL,'',70.000000000,'2008-05-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9785,'LEPREVOST','Yvonne',NULL,'02.74.00.70.03',NULL,NULL,'RUE DU HARAS','','','14730','GIBERVILLE',NULL,NULL,'',2234.000000000,'2010-03-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9786,'BERLAND','THERESE',NULL,'02.77.67.70.42','06.77.87.69.45',NULL,'RESIDENCE LES MATINES AVENUE D''O','RNANO','','14000','CAEN',NULL,NULL,'',581.000000000,'2011-06-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9787,'JEHENNE','Bernadette',NULL,'02.11.45.14.56','06.55.21.05.14',NULL,'12 reage des clairs','','','14550','BLAINVILLE SUR ORNE',NULL,NULL,'',29.000000000,'2009-01-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9788,'GROSSET','RENE',NULL,'02.89.63.91.67','06.81.63.27.98',NULL,'16 RUE DES PRES','','','14740','BRETTEVILLE L''ORGUEILLEUSE',NULL,NULL,'',55.000000000,'2009-08-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9789,'BRICE','JACQUELINE',NULL,'02.41.86.29.24','06.18.30.49.63',NULL,'31 rue des ecorbieres','','','14400','CONDE SUR SEULLES',NULL,NULL,'',307.000000000,'2008-06-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9790,'BRUNET','THERESE',NULL,'02.99.40.16.50','06.71.07.75.80',NULL,'28 RUE ALFRED CASSIGNEUL','','','27500','ST GERMAIN VILLAGE',NULL,NULL,'',208.000000000,'2013-07-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9791,'LEHERISSEY','MARIE CLAIRE',NULL,'02.13.73.76.10','06.65.82.49.35',NULL,'51 route d''harcourt','','','14000','CAEN',NULL,NULL,'',29.000000000,'2013-08-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9792,'DESLOGES','SERGE',NULL,'02.11.20.13.68','00 33 6.93.96.24.62',NULL,'17 RUE DU CLOS CHARMANT','','','50470','LA GLACERIE',NULL,NULL,'',570.000000000,'2013-04-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9793,'SANS REFUS','MICHEL',NULL,'02.41.76.37.63','06.16.66.02.19',NULL,'8 RUE DES BLONDS EPIS','','','14111','LOUVIGNY',NULL,NULL,'',737.000000000,'2013-03-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9794,'CLEMENT','Edith',NULL,'02.94.49.17.70','06.15.41.12.70',NULL,'20 IMPASSE MES DELICES','','','14840','DEMOUVILLE',NULL,NULL,'',80.000000000,'2009-07-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9795,'BINARD','PASCAL',NULL,'02.66.85.40.89','06.86.31.20.09',NULL,'16 BIS RUE COLONEL FABIER','','','14220','THURY HARCOURT',NULL,NULL,'',73.000000000,'2009-07-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9796,'DUTEIL','Madeleine',NULL,'02.12.60.60.10','06.95.95.06.08',NULL,'route du bu sur rouvres','','','14120','MONDEVILLE',NULL,NULL,'',69.000000000,'2011-09-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9797,'FIANT','BERNARD',NULL,'02.44.85.02.63','06.89.60.62.06',NULL,'918 route de canteloup','','','14000','CAEN',NULL,NULL,'',34.000000000,'2011-07-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9798,'DEZIER','Michel',NULL,'02.56.21.41.91','06.40.31.55.35',NULL,'25 RUE DE L''ETRIER','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'',1214.000000000,'2009-03-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9799,'JAMES','Yves',NULL,'02.54.18.43.42','06.45.54.91.96',NULL,'9 CITE BELLEVUE','','','14350','LA GRAVERIE',NULL,NULL,'',4.000000000,'2012-12-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9800,'ROUX','CLAUDE',NULL,'02.34.09.45.94','06.19.94.59.14',NULL,'26  RUE DES TILLEULS','','','14000','CAEN',NULL,NULL,'',523.000000000,'2010-08-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9801,'JEGOU','MICHEL',NULL,'02.14.63.29.40','06.60.80.83.02',NULL,'43 av g guynemer','','','61500','NEUVILLE PRES SEES',NULL,NULL,'',339.000000000,'2011-03-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9802,'BARBIER','LAETITIA',NULL,'02.87.49.53.34','06.42.40.96.40',NULL,'13 impasse pascal','','','14190','CAUVICOURT',NULL,NULL,'',1517.000000000,'2011-10-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9803,'LEMASSON','JUSTINE',NULL,'02.18.63.17.33','06.35.77.85.63',NULL,'15 RUE MALFILATRE','','','14430','DOZULE',NULL,NULL,'',4.000000000,'2012-11-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9804,'SONNET','AURELIE',NULL,'02.83.97.64.08','06.73.22.83.06',NULL,'90 RUE BASSE','','','14000','CAEN',NULL,NULL,'',1777.000000000,'2010-06-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9805,'DALERT','ARLETTE',NULL,'02.23.81.09.91','06.88.09.28.03',NULL,'9 RUE PIERRE MENDEZ FRANCE','','',NULL,NULL,NULL,NULL,'',182.000000000,'2010-04-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9806,'JOSEPH','ARMELLE',NULL,'02.95.68.27.23','06.11.67.35.05',NULL,'17 allee des poetes','','','14850','ESCOVILLE',NULL,NULL,'',71.000000000,'2008-05-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9807,'DELAPLANQUE','CANDYLENE',NULL,'02.74.82.73.48',NULL,NULL,'13 rue caponiniere','','','14000','CAEN',NULL,NULL,'',186.000000000,'2012-06-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9808,'PATRY','Zainaba',NULL,'02.83.99.52.18','06.24.59.40.19',NULL,'231 rue de falaise','','','14630','FRENOUVILLE',NULL,NULL,'',79.000000000,'2008-01-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9809,'ROUX','Zainaba',NULL,'02.29.09.19.41','06.27.24.79.82',NULL,'22 RUE DE LA HEVE','','','14730','GIBERVILLE',NULL,NULL,'',1580.000000000,'2012-05-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9810,'DENISE','SARAH',NULL,'02.12.23.22.65','06.11.76.03.06',NULL,'7 ALLEE WINNIPEG','','','14120','MONDEVILLE',NULL,NULL,'',329.000000000,'2010-06-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9811,'ALEXANDRE','julien',NULL,'02.10.89.26.63','06.16.76.25.39',NULL,'44 RUE VOLTAIRE','','','14123','CORMELLES LE ROYAL',NULL,NULL,'',21.000000000,'2009-01-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9812,'FLAUSS','estelle',NULL,'02.88.82.44.20','06.47.85.76.50',NULL,'PLACE DE L''EGLISE','','','14270','MEZIDON CANON',NULL,NULL,'',21.000000000,'2013-02-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9813,'HUYGHE','PASCAL',NULL,'02.73.36.77.90','06.90.65.39.31',NULL,'7 IMPASSE DES MARONNIERS','','','14370','ARGENCES',NULL,NULL,'',188.000000000,'2008-06-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9814,'MUNEREL','TOMY',NULL,'02.37.66.30.31','06.89.48.12.69',NULL,'1 RUE D''AUNAY','','','14280','ST GERMAIN LA BLANCHE HERBE',NULL,NULL,'',684.000000000,'2009-09-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9815,'LAURENT','CHARLENE',NULL,'02.25.62.48.86','06.10.02.63.02',NULL,'3 rue des coudraies','','','14400','MONCEAUX EN BESSIN',NULL,NULL,'',296.000000000,'2012-06-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9816,'DUBREUIL','sophie',NULL,'02.26.15.30.31','06.60.35.74.30',NULL,'6 rue des schistes','','','14210','CHEUX',NULL,NULL,'',75.000000000,'2010-05-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9817,'LELANDAIS','anais',NULL,'02.10.54.96.37','06.47.26.43.05',NULL,'17 bis rue sadi carnot','','','14190','CAUVICOURT',NULL,NULL,'',23.000000000,'2011-07-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9818,'MARIE','ELIANE',NULL,'02.31.08.18.26','06.17.05.26.92',NULL,'37 avenue robert shuman','','','14123','IFS',NULL,NULL,'',88.000000000,'2010-11-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9819,'DEVILLIERS','angelina',NULL,'02.36.75.37.56','06.10.20.95.88',NULL,'LE VAL','','','14000','CAEN',NULL,NULL,'',11.000000000,'2013-02-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9820,'VERGNE','LAURENCE',NULL,'02.96.70.45.61','06.98.30.84.53',NULL,'roche comun','','','14220','THURY HARCOURT',NULL,NULL,'',301.000000000,'2009-12-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9821,'HEBERT','lisa',NULL,'02.81.70.86.00','06.73.81.30.40',NULL,'6 rue des moulins','','','14000','CAEN',NULL,NULL,'',233.000000000,'2012-10-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9822,'SUARD','rudy',NULL,'02.20.18.79.05','06.29.88.94.11',NULL,'3 rue du haut marquet','','','14123','IFS',NULL,NULL,'',139.000000000,'2009-02-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9823,'CRESPIN','francois',NULL,'02.10.64.70.63','06.18.41.98.54',NULL,'9 RUE ROMAIN  ROLAND','','','75015','PARIS 15',NULL,NULL,'',2231.000000000,'2011-01-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9824,'LEDRU','MELANIE',NULL,'02.97.47.24.16','06.68.03.83.02',NULL,'19 RUE ROBERT DESNOS','','','14150','OUISTREHAM',NULL,NULL,'',98.000000000,'2012-10-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9825,'SALAUN','THIERNO',NULL,'02.14.50.00.83','06.71.81.82.67',NULL,'LE VIEUX CHATEAU','','','14000','CAEN',NULL,NULL,'',109.000000000,'2009-04-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9826,'MARIE','claude',NULL,'02.94.42.08.30','06.51.43.63.26',NULL,'','','','14000','CAEN',NULL,NULL,'',353.000000000,'2008-06-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9827,'JOLIVET','MADELEINE',NULL,'02.12.13.04.97','06.66.96.07.91',NULL,'36 ROUTE DE BRETAGNE','','','14790','FONTAINE ETOUPEFOUR',NULL,NULL,'',5.000000000,'2009-12-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9828,'BARTHE','MICHELINE',NULL,'02.22.77.98.12','06.38.00.89.68',NULL,'10 RUE DES PUITS DE ROME','','','14210','STE HONORINE DU FAY',NULL,NULL,'',12.000000000,'2009-09-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9829,'CLOUS','Jacqueline',NULL,'02.66.77.09.74',NULL,NULL,'1 rue rouget dechambre','','','14940','SANNERVILLE',NULL,NULL,'',30.000000000,'2008-12-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9830,'THOBIE','JEAN PIERRE',NULL,'02.12.28.37.76','06.12.10.72.73',NULL,'33 rue du 11 Novembre','','','14123','FLEURY SUR ORNE',NULL,NULL,'',171.000000000,'2008-01-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9831,'PETIT','GEORGETTE',NULL,'02.52.95.08.60','06.11.42.61.83',NULL,'14 AVENUE CHARLOTTE CORDAY','','','14120','MONDEVILLE',NULL,NULL,'',4479.000000000,'2012-12-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9832,'GUELLE','JACKY',NULL,'02.79.98.74.34',NULL,NULL,'RESIDENCE LEONARD GILLES LES B','OULEAUX APP.170','','14190','CAUVICOURT',NULL,NULL,'',1.000000000,'2013-09-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9833,'BRACHET','JOELLE',NULL,'02.12.08.16.35','06.31.39.36.45',NULL,'ROUTE DE L''EGLISE','','','14000','CAEN',NULL,NULL,'',7.000000000,'2008-05-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9834,'BRICON','DIDIER',NULL,'02.57.46.40.25','06.10.58.28.03',NULL,'1 RUE DE L''EGLISE','','','14320','MAY SUR ORNE',NULL,NULL,'',479.000000000,'2012-08-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9835,'LORENCE','SIMONE',NULL,'02.13.96.32.21','06.37.37.18.47',NULL,'63 RUE CAMILLE BLAISOT','','','14740','CARCAGNY',NULL,NULL,'',653.000000000,'2011-06-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9836,'LEREBOURG','GEORGES',NULL,'02.11.14.60.63','06.11.25.98.41',NULL,'2-3 ALLEE DES CLEMATITES','','','14000','CAEN',NULL,NULL,'',46.000000000,'2008-09-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9837,'TOULLIER','CLAUDE',NULL,'02.46.44.24.59','06.51.49.03.56',NULL,'37 rue chapron','','','14320','FEUGUEROLLES BULLY',NULL,NULL,'',204.000000000,'2011-08-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9838,'LEROUVILLOIS','ROBERT',NULL,'02.30.72.86.67','06.88.70.38.92',NULL,'6 rue des bourriliers','','','14860','BAVENT',NULL,NULL,'',88.000000000,'2008-01-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9839,'LEMARINEL','MONIQUE',NULL,'02.68.44.60.19','06.12.04.31.78',NULL,'7 rue d''etavaux','','','14000','CAEN',NULL,NULL,'',25.000000000,'2012-04-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9840,'BERTRAND','CLAUDE',NULL,'02.34.25.08.34','06.31.45.74.02',NULL,'5 rue des peupliers','','','14310','EPINAY SUR ODON',NULL,NULL,'',155.000000000,'2011-06-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9841,'HAMON','LUCIEN',NULL,'02.36.93.82.83','06.62.56.96.73',NULL,'9 RUE VAL ES DUNES','','','14210','NOYERS BOCAGE',NULL,NULL,'',1155.000000000,'2012-01-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9842,'THOMASSE','Rene',NULL,'02.11.30.09.50','06.78.55.25.80',NULL,'1 rue jules ferry','','','14270','CONDE SUR IFS',NULL,NULL,'',286.000000000,'2009-12-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9843,'MONTAGNE','BRIGITTE',NULL,'02.22.06.06.32','06.74.11.57.07',NULL,'8 chemin des tinards','','','14970','BENOUVILLE',NULL,NULL,'',414.000000000,'2009-12-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9844,'MALAS','CLAUDE',NULL,'02.10.42.60.49','06.12.20.60.40',NULL,'31 RUE MICHEL LASNE','','','14000','CAEN',NULL,NULL,'',4287.000000000,'2009-02-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9845,'ROZIER','GISELE',NULL,'02.57.14.65.24','06.15.36.49.21',NULL,'94 rue basse','','','14000','CAEN',NULL,NULL,'',1073.000000000,'2008-07-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9846,'ROGER','GUY',NULL,'02.37.71.83.95','06.57.07.76.76',NULL,'3 ALLEE DES POETES','','','14540','SOLIERS',NULL,NULL,'',32.000000000,'2007-11-13','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9847,'ANDRE','LOIC',NULL,'02.95.00.69.37','06.11.72.35.98',NULL,'CAHAGNES','','','14120','MONDEVILLE',NULL,NULL,'',13.000000000,'2011-05-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9848,'BRAUD','NICOLE',NULL,'02.58.33.61.02','06.31.85.00.55',NULL,'6 RUE GUSTAVE FLAUBERT','','','75014','PARIS 14',NULL,NULL,'',65.000000000,'2013-04-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9849,'TREGUILLY','DANIEL',NULL,'02.33.90.19.74',NULL,NULL,'90 RUE DES ACACIAS','','','14210','GRAINVILLE SUR ODON',NULL,NULL,'',119.000000000,'2012-01-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9850,'JEANNE','BEATRICE',NULL,'02.42.13.35.57','06.44.56.87.15',NULL,'6 CITE DU PILIER VERT','','','14700','FALAISE',NULL,NULL,'',230.000000000,'2011-11-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9851,'MARETTE','ANNE DOROTHEE',NULL,'02.50.46.92.98','06.31.98.48.45',NULL,'12 rue du Blanc','','','14190','CAUVICOURT',NULL,NULL,'',4.000000000,'2011-01-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9852,'PEZERIL','BENOIT',NULL,'02.10.12.29.31','06.31.70.27.48',NULL,'301 LE VAL','','','14220','GRIMBOSQ',NULL,NULL,'',157.000000000,'2010-03-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9853,'RENAULT','DAMIEN',NULL,'02.50.78.36.86','06.96.72.90.27',NULL,'40 RUE DES HAUTS VENTS','','','14000','CAEN',NULL,NULL,'',35.000000000,'2012-07-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9854,'MESLEM','ANGELIQUE',NULL,'02.89.30.74.55',NULL,NULL,'9 rue Georges Lacour','','','83320','CARQUEIRANNE',NULL,NULL,'',245.000000000,'2009-12-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9855,'DETEY','Andre',NULL,'02.18.23.95.49','06.72.24.93.03',NULL,'13 RUE  DU FINISTERE','','','14123','IFS',NULL,NULL,'',320.000000000,'2009-01-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9856,'RADUFE','MARCEL',NULL,'02.73.91.21.43','06.52.82.43.42',NULL,'2 ROUTE DE BISSIERES','','','14260','AUNAY SUR ODON',NULL,NULL,'',818.000000000,'2011-07-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9857,'MESLAY','MADELEINE',NULL,'02.43.68.47.64','06.53.68.66.98',NULL,'88 rue victor lepine','','','14630','CAGNY',NULL,NULL,'',40.000000000,'2008-02-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9858,'LETOUZEY','Janine',NULL,'02.12.16.36.34','06.37.94.85.68',NULL,'303 quartier haute folie','','','61490','ST CLAIR DE HALOUZE',NULL,NULL,'',41.000000000,'2011-01-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9859,'CLANET','FRANCOISE',NULL,'02.85.42.95.42','06.10.56.67.05',NULL,'27 RUE DU BEAU SITE','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'',22.000000000,'2012-03-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9860,'SYRYN','MICHEL',NULL,'02.10.22.95.65','06.75.13.35.64',NULL,'31 rue jules ferry','','','14000','CAEN',NULL,NULL,'',5191.000000000,'2010-11-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9861,'DUBOURG','JEANNE',NULL,'02.10.94.75.51','06.33.99.06.53',NULL,'3 RUE ABBE ALLIX','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'',2657.000000000,'2009-11-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9862,'TETI','JANINE',NULL,'02.23.77.93.83','06.16.83.90.57',NULL,'5 RUE DU CAPITAINE POINLANE','','','14530','LUC SUR MER',NULL,NULL,'',5.000000000,'2010-07-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9863,'PASSAYS','BERNARD',NULL,'02.16.27.87.21','06.47.14.71.55',NULL,'5 RUE DU CAPITAINE POINLANE','','','14460','COLOMBELLES',NULL,NULL,'',173.000000000,'2009-05-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9864,'COURTIN','CECILE',NULL,'02.55.17.57.78','06.89.23.00.89',NULL,'1 SQUARE DES POMMIERS','','','14320','FONTENAY LE MARMION',NULL,NULL,'',49.000000000,'2013-07-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9865,'GOUENARD','Therese',NULL,'02.19.11.22.38','06.12.08.73.54',NULL,'LA GRANDE RUE','','','14670','TROARN',NULL,NULL,'',221.000000000,'2010-10-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9866,'MARIE','GILBERT',NULL,'02.49.90.12.03','06.11.83.71.78',NULL,'56 RUE ST PATRICE','','','14880','COLLEVILLE MONTGOMERY',NULL,NULL,'',16.000000000,'2008-03-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9867,'RIBET','Maurice',NULL,'02.12.00.76.95','06.49.44.51.22',NULL,'5 allee des primeveres','','','14120','MONDEVILLE',NULL,NULL,'',54.000000000,'2009-03-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9868,'GARNIER','Jacqueline',NULL,'02.26.85.57.98','06.70.29.84.65',NULL,'12bis des terres noires','','','14460','COLOMBELLES',NULL,NULL,'',14.000000000,'2008-12-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9869,'LEVALLOIS','Michel',NULL,'02.17.36.75.41','06.22.39.22.07',NULL,'41 IMPASSE ECUYERE','','','14670','TROARN',NULL,NULL,'',39.000000000,'2008-02-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9870,'HARE','CHANTAL',NULL,'02.27.19.73.27','06.24.27.35.57',NULL,'7 RUE GAUMESNIL','','','14210','AVENAY',NULL,NULL,'',544.000000000,'2012-04-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9871,'BOURGUAIS','rene',NULL,'02.62.33.46.54','06.64.04.00.22',NULL,'26 rue porte millet esc 6','','','14610','ANGUERNY',NULL,NULL,'',6.000000000,'2011-05-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9872,'PERON','LEON',NULL,'02.49.81.04.72','06.57.84.47.64',NULL,'LA CHEVRETIERE VILLAGE CANDON','','','14850','HEROUVILLETTE',NULL,NULL,'',19.000000000,'2009-11-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9873,'LANGLAIS','Janine',NULL,'02.78.86.47.33','06.34.55.39.00',NULL,'26 rue de la prevoyance','','','14360','TROUVILLE SUR MER',NULL,NULL,'',199.000000000,'2012-08-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9874,'BOSSUYT','Roger',NULL,'02.10.05.91.10','06.43.32.50.49',NULL,'20 RUE DES ACADIAS','','','14710','TREVIERES',NULL,NULL,'',27.000000000,'2013-08-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9875,'LESAGE','PIERRE',NULL,'02.15.22.37.81','06.11.63.86.55',NULL,'6 RUE MAURICE LAFON','','','14250','LINGEVRES',NULL,NULL,'',303.000000000,'2010-07-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9876,'LAINE','YVONNE',NULL,'02.97.00.77.63','06.38.10.60.70',NULL,'RUE DE L''EGLISE','','','14370','CROISSANVILLE',NULL,NULL,'',208.000000000,'2012-12-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9877,'BLIER','francois',NULL,'02.42.01.68.13','06.94.41.73.85',NULL,'17 RUE DE ROUGEMONT','','','14123','FLEURY SUR ORNE',NULL,NULL,'',337.000000000,'2010-10-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9878,'TUBOEUF','ODETTE',NULL,'02.12.01.07.61','06.65.28.44.44',NULL,'2 IMPASSE BERTIN','','','14000','CAEN',NULL,NULL,'',1009.000000000,'2008-11-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9879,'BIBAUT','ALBERT',NULL,'02.49.17.26.44','06.93.94.00.00',NULL,'RESIDENCE DU VAL','','','14000','CAEN',NULL,NULL,'',168.000000000,'2012-11-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9880,'LIGRON','NATHALIE',NULL,'02.87.94.47.59','06.75.62.03.62',NULL,'4 rue de la guerande','','','14000','CAEN',NULL,NULL,'',1992.000000000,'2011-10-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9881,'MARGUERIE','HENRI',NULL,'02.90.40.43.17','06.79.81.24.52',NULL,'LA HAUTE RUE','','','14000','CAEN',NULL,NULL,'',0.000000000,'2008-06-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9882,'SOUPPLET','FRANCOIS',NULL,'02.11.25.75.07','06.74.61.79.45',NULL,'8 6 CITE DES ROCHES','','','14000','CAEN',NULL,NULL,'',104.000000000,'2009-11-18','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9883,'BARBEY','SIMONE',NULL,'02.86.75.50.30','06.25.20.07.17',NULL,'2 residence st gerbold rue cons','tant forget','','14370','CHICHEBOVILLE',NULL,NULL,'',7.000000000,'2012-06-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9884,'MICHEL','ALBERT',NULL,'02.90.67.70.82','06.29.57.00.59',NULL,'8 RUE DU SAUT DE LOUP','','','14630','FRENOUVILLE',NULL,NULL,'',737.000000000,'2013-07-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9885,'NOEL','CORINNE',NULL,'02.89.76.64.58','06.88.84.69.97',NULL,'LA BONDE','','','14000','CAEN',NULL,NULL,'',212.000000000,'2010-05-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9886,'PORET','MICHEL',NULL,'02.38.38.08.15','06.93.42.02.38',NULL,'billy','','','14123','IFS',NULL,NULL,'',60.000000000,'2011-12-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9887,'FROEHLICHER','DANIEL',NULL,'02.35.56.64.79','06.13.84.70.94',NULL,'102 rte d''harcourt','','','61430','ATHIS DE L''ORNE',NULL,NULL,'',6.000000000,'2008-09-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9888,'GILET','michel',NULL,'02.49.68.05.00','06.11.18.71.52',NULL,'HAMEAU COUVERT','','','14100','LISIEUX',NULL,NULL,'',150.000000000,'2008-08-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9889,'GEORGES','YVES',NULL,'02.70.84.60.77','06.72.37.95.76',NULL,'18 RUE PONT MORTAIN','','','14000','CAEN',NULL,NULL,'',1011.000000000,'2013-08-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9890,'HAMON','CLAUDINE',NULL,'02.66.13.98.69','06.67.69.04.85',NULL,'51 RUE SADI CARNOT','','','14000','CAEN',NULL,NULL,'',3710.000000000,'2011-02-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9891,'CHATOJAN','GUY',NULL,'02.34.17.49.73','06.10.07.30.35',NULL,'12 rue alexandre dumas','','','14250','DUCY STE MARGUERITE',NULL,NULL,'',615.000000000,'2010-01-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9892,'JOUANNEAULT','YVES',NULL,'02.80.07.56.40','06.78.67.07.79',NULL,'341 chemin du val','','','14000','CAEN',NULL,NULL,'',62.000000000,'2011-06-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9893,'TROUILLARD','MARTHE',NULL,'02.57.77.33.67','06.17.46.06.40',NULL,'6 AVENUE JULES FERRY','','','14000','CAEN',NULL,NULL,'',1105.000000000,'2013-01-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9894,'DOMINGO','MICHEL',NULL,'02.20.60.60.28','06.10.29.33.79',NULL,'5 RUE MONTCALM ou ATC carpiquet','','','14220','THURY HARCOURT',NULL,NULL,'',201.000000000,'2013-08-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9895,'PREVELLE','MICHEL',NULL,'02.36.06.23.41','00 33 6.52.31.27.52',NULL,'9 rue de provence','','','14840','DEMOUVILLE',NULL,NULL,'',132.000000000,'2008-12-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9896,'LE MEUR','FRANCOISE',NULL,'02.26.93.79.02','06.14.53.36.54',NULL,'1 RUE PAUL LANGEVIN','','','14770','LE PLESSIS GRIMOULT',NULL,NULL,'',101.000000000,'2013-09-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9897,'VILLETTE','CLAUDE',NULL,'02.18.03.04.03','06.17.32.83.79',NULL,'341 chemin du val','','','14370','BILLY',NULL,NULL,'',203.000000000,'2010-04-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9898,'SIMON','ANDRE',NULL,'02.87.27.30.33','06.57.86.52.20',NULL,'PLACE DU COLLEGE','','','61120','NEUVILLE SUR TOUQUES',NULL,NULL,'',175.000000000,'2010-02-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9899,'DESHAYES','JEANNE-MARIE',NULL,'02.34.12.95.74',NULL,NULL,'86 RUE EMMANUEL LIAIS','','','14000','CAEN',NULL,NULL,'',2062.000000000,'2013-04-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9900,'TEISSEDRE','YVES',NULL,'02.47.21.76.75','06.12.28.48.11',NULL,'7 RUE DU MOULIN','','','14000','CAEN',NULL,NULL,'',879.000000000,'2008-11-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9901,'MORIEL','michel',NULL,'02.10.79.37.19','06.66.56.08.88',NULL,'4 ALLEE DE L ALBERTA','','','14540','GARCELLES SECQUEVILLE',NULL,NULL,'',7.000000000,'2007-11-21','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9902,'JOUENNE','RENE',NULL,'02.55.04.04.69','06.19.92.77.52',NULL,'6 avenue du 19 mars 1962 bat E a','ppt 70','','14730','GIBERVILLE',NULL,NULL,'',71.000000000,'2011-09-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9903,'DEBUF','JEAN',NULL,'02.10.09.88.00','06.27.88.55.52',NULL,'15 RUE DE L''EGLISE','','','14400','BAYEUX',NULL,NULL,'',3.000000000,'2013-09-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9904,'LOURY','THERESE',NULL,'02.20.58.71.83','06.31.93.11.71',NULL,'4 rue maurice fouilloux','','','14123','FLEURY SUR ORNE',NULL,NULL,'',103.000000000,'2008-05-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9905,'MARIE','MARC',NULL,'02.69.17.82.45','06.89.45.43.62',NULL,'98 BIS RUE DE L''EGLISE','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'',25.000000000,'2008-12-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9906,'POUCHIN','TONY',NULL,'02.30.74.40.20',NULL,NULL,'11 bis rue gustave flaubert','','','14540','BOURGUEBUS',NULL,NULL,'',1279.000000000,'2011-11-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9907,'LEGALLOIS','VALERIE',NULL,'02.17.50.48.77','06.18.39.61.89',NULL,'2 IMPASSE DES MARETTES','','','14220','HAMARS',NULL,NULL,'',2.000000000,'2013-01-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9908,'LEFEVRE','isabelle',NULL,'02.53.53.16.75','06.41.62.52.88',NULL,'12 rue chapron','','','14250','LINGEVRES',NULL,NULL,'',45.000000000,'2009-05-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9909,'COCOUAL','THERESE',NULL,'02.42.77.51.51','06.10.52.98.68',NULL,'5 RUE NICOLAS COPERNIC LE CLOS','DES MESANGES','','61320','LALACELLE',NULL,NULL,'',18.000000000,'2012-11-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9910,'DORENLOT','FRANCOISE',NULL,'02.37.68.73.95','06.85.23.80.61',NULL,'21 avenue pasteur','','','14730','GIBERVILLE',NULL,NULL,'',217.000000000,'2009-02-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9911,'CORSET','JOSIANE',NULL,'02.26.69.56.54','06.44.49.44.28',NULL,'12 chemin des bois','','','14120','MONDEVILLE',NULL,NULL,'',1838.000000000,'2008-05-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9912,'DJIBRINE IDRISS','JENNIFER',NULL,'02.11.97.66.58','06.74.27.76.72',NULL,'ROUTE DE BRANVILLE','','','14120','MONDEVILLE',NULL,NULL,'',458.000000000,'2010-06-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9913,'LEMANISSIER','SIMONNE',NULL,'02.97.96.29.57','06.65.84.01.60',NULL,'3 TER ROUTE D''EMIEVILLE','','','14250','AUDRIEU',NULL,NULL,'',4036.000000000,'2013-02-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9914,'DUBOURGUAIS','ZENON',NULL,'02.58.46.72.69','06.66.52.47.20',NULL,'ROUTE DE COUVRIGNY','','','14000','CAEN',NULL,NULL,'',93.000000000,'2013-04-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9915,'MENAL','ELIANE',NULL,'02.31.84.98.46','06.43.74.61.04',NULL,'174 rue de falaise','','','14260','BONNEMAISON',NULL,NULL,'',265.000000000,'2008-08-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9916,'LE GORGEU','JEAN',NULL,'02.42.95.95.16','06.11.46.97.10',NULL,'7 rue Harry Hawkins','','','14111','LOUVIGNY',NULL,NULL,'',51.000000000,'2012-10-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9917,'FRANCOISE','ALINE',NULL,'02.76.88.53.35','06.10.05.58.27',NULL,'8 RUE DE COLOMBELLES','','','14000','CAEN',NULL,NULL,'',39.000000000,'2011-08-21','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9918,'BEZARD','GILBERT',NULL,'02.88.79.93.24','06.11.69.74.04',NULL,'7 RUE DE L''ECOLE','','','14123','IFS',NULL,NULL,'',576.000000000,'2010-08-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9919,'DAUFRESNE','ROGER',NULL,'02.79.51.22.47','06.10.01.51.04',NULL,'38 rue demidoff','','','14220','MESLAY',NULL,NULL,'',1030.000000000,'2013-06-04','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9920,'THOMASSE','JEAN FRANCOIS',NULL,'02.12.51.60.27','06.52.48.93.63',NULL,'Bd Raymond Poincar','','','14120','MONDEVILLE',NULL,NULL,'',271.000000000,'2010-05-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9921,'EVE','CHARLOTTE',NULL,'02.86.24.64.12','06.66.14.08.60',NULL,'Le Hamelet','','','14120','MONDEVILLE',NULL,NULL,'',19.000000000,'2008-11-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9922,'HODEMOND','MARIE CLAIRE',NULL,'02.11.51.01.46','06.63.79.93.78',NULL,'4 Lotissement des Erables','','','14460','COLOMBELLES',NULL,NULL,'',34.000000000,'2009-05-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9923,'LE PLEUX','CHRISTIAN',NULL,'02.54.04.27.41','06.60.93.88.97',NULL,'7 CHEMIN DU LAIZON','','','14250','TESSEL',NULL,NULL,'',22.000000000,'2010-11-27','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9924,'LAGOUDE','CLAUDE',NULL,'02.59.37.02.88','06.13.99.02.61',NULL,'69 Bd Raymond Poincar','','','14630','CAGNY',NULL,NULL,'',51.000000000,'2013-05-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9925,'BONABAUD','CLAUDE',NULL,'02.16.42.83.80','06.71.58.98.70',NULL,'27 bld general vasnier','','','14400','VAUX SUR SEULLES',NULL,NULL,'',138.000000000,'2010-10-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9926,'MELINOU','CLAUDINE',NULL,'02.21.86.62.24','06.84.38.90.47',NULL,'hameau de carbec','','','14680','CINTHEAUX',NULL,NULL,'',51.000000000,'2008-05-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9927,'BOMPAIN','MICHEL',NULL,'02.69.35.07.95','06.35.84.84.26',NULL,'18 RUE DES PEUPLIERS','','','14000','CAEN',NULL,NULL,'',3.000000000,'2012-12-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9928,'LEFOL','LORENZO',NULL,'02.44.15.84.11','06.46.33.65.60',NULL,'22 rue du petit valon','','','14320','CLINCHAMPS SUR ORNE',NULL,NULL,'',319.000000000,'2012-01-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9929,'GUERIN','SOLANGE',NULL,'02.10.11.50.73','06.12.22.36.70',NULL,'4 IMPASSE DE ROUEN','','','14320','ST ANDRE SUR ORNE',NULL,NULL,'',30.000000000,'2013-03-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9930,'GAUCHARD','ROLAND',NULL,'02.86.72.85.60','06.81.82.74.34',NULL,'100 RUE DE FALAISE','','','14320','FONTENAY LE MARMION',NULL,NULL,'',343.000000000,'2008-11-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9931,'POIRIER','GERARD',NULL,'02.57.57.74.37',NULL,NULL,'12 rue du professeur gombeaux','','','14000','CAEN',NULL,NULL,'',37.000000000,'2008-01-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9932,'','CAROLE',NULL,'02.66.31.44.07','06.13.69.90.79',NULL,'ROUTE DE LISIEUX','','','50000','ST LO',NULL,NULL,'',65.000000000,'2008-07-08','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9933,'LE FRAPPER','ALAIN',NULL,'02.27.25.18.79','06.58.32.11.42',NULL,'325 RUE DE FALAISE','','','14630','EMIEVILLE',NULL,NULL,'',631.000000000,'2008-12-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9934,'PERROTTE','CHARLES',NULL,'02.17.61.76.60','06.21.18.51.50',NULL,'15 RUE DE L''AUBEPINE','','','14220','MOULINES',NULL,NULL,'',20.000000000,'2013-09-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9935,'MARIE','VERONIQUE',NULL,'02.10.35.48.25','06.24.80.58.32',NULL,'42 RUE DE NORMANDIE','','','14680','BRETTEVILLE SUR LAIZE',NULL,NULL,'',310.000000000,'2011-08-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9936,'NICOLLE','BERNADETTE',NULL,'02.10.43.91.08','06.10.12.91.11',NULL,'13 RUE DE LA VALLEE','','','14120','MONDEVILLE',NULL,NULL,'',3436.000000000,'2009-07-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9937,'DUDOUIT','LOUIS',NULL,'02.15.03.75.99','06.97.62.17.54',NULL,'LE POIRIER','','','61200','SAI',NULL,NULL,'',2868.000000000,'2012-10-16','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9938,'BOUFFAY','GEORGES',NULL,'02.97.65.00.67','06.26.91.48.08',NULL,'LE BOURG','','','27500','PONT AUDEMER',NULL,NULL,'',63.000000000,'2011-02-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9939,'BOUILLAULT','RENEE',NULL,'02.75.76.85.83','06.53.38.14.49',NULL,'22 RUE DES CALLOUINS','','','14120','MONDEVILLE',NULL,NULL,'',150.000000000,'2013-08-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9940,'TERRIER','STEPHANIE',NULL,'02.28.54.25.48','06.11.39.07.74',NULL,'17 la moinnerie','','','14540','GRENTHEVILLE',NULL,NULL,'',296.000000000,'2012-04-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9941,'WATHLET','ALEXANDRE',NULL,'02.27.78.73.57','06.10.01.85.65',NULL,'33 rue briere','','','14130','SURVILLE',NULL,NULL,'',2.000000000,'2012-07-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9942,'PROVOST','MARTINE',NULL,'02.10.45.48.19','06.63.42.12.09',NULL,'','','','14123','FLEURY SUR ORNE',NULL,NULL,'',194.000000000,'2012-04-07','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9943,'BOREL','BRUNO',NULL,'02.67.46.83.00','06.89.05.11.40',NULL,'1 ROUTE DE ROUEN','','','14000','CAEN',NULL,NULL,'',30.000000000,'2009-06-30','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9944,'DESHAYES','JEAN CLAUDE',NULL,'02.60.88.82.58','06.65.39.03.85',NULL,'lotissement les maronniers','','','14390','CABOURG',NULL,NULL,'',190.000000000,'2008-03-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9945,'CHAMPION','LUCIENNE',NULL,'02.65.49.44.58','06.18.21.59.35',NULL,'5 allee de bertea','','','14120','MONDEVILLE',NULL,NULL,'',539.000000000,'2010-03-09','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9946,'LECHAUVE','HELENE',NULL,'02.84.60.82.90','06.44.87.30.11',NULL,'1 bis rue du marais','','','14320','FONTENAY LE MARMION',NULL,NULL,'',22.000000000,'2009-10-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9947,'MORIN','JOSIANE',NULL,'02.75.95.48.88','06.98.98.39.76',NULL,'4 RUE DE CHAUSEY','','','14123','CORMELLES LE ROYAL',NULL,NULL,'',3178.000000000,'2013-04-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9948,'LEBIGRE','ALAIN',NULL,'02.95.41.55.10','06.63.83.00.29',NULL,'25 RUE LOUIS ARMAND','','','14000','CAEN',NULL,NULL,'',50.000000000,'2008-12-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9949,'LEMORE','YOLANDE',NULL,'02.11.71.42.56','06.15.30.15.96',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'',0.000000000,'2011-04-15','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9950,'PANEL','PAULETTE',NULL,'02.56.28.45.71','06.14.89.87.71',NULL,'RUE DES PERRUCHES','','','14000','CAEN',NULL,NULL,'',405.000000000,'2012-06-29','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9951,'BELLAUNAY','PASCAL',NULL,'02.82.11.76.05','06.76.77.56.23',NULL,'3 RUE DES SCHISTES','','','14000','CAEN',NULL,NULL,'',75.000000000,'2009-01-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9952,'CASTEL','GUY',NULL,'02.63.57.16.06','06.10.83.91.79',NULL,'','','','14460','COLOMBELLES',NULL,NULL,'',48.000000000,'2011-11-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9953,'CHANCEREL','MARIE CLAUDE',NULL,'02.57.64.52.20','06.62.47.95.72',NULL,'72 RUE PASTEUR','','','14123','CORMELLES LE ROYAL',NULL,NULL,'',0.000000000,'2007-12-24','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9954,'REMOND','GENEVIEVE',NULL,'02.34.01.57.98','06.12.63.48.33',NULL,'','','','14860','BAVENT',NULL,NULL,'',572.000000000,'2013-09-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9955,'LETOURNEUR','MICHEL',NULL,'02.92.38.51.86','06.96.57.55.55',NULL,'11 RUE DE LA PREVOYANCE','','','14670','TROARN',NULL,NULL,'',783.000000000,'2012-12-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9956,'PREE','GISELE',NULL,'02.48.12.41.91','06.10.80.72.72',NULL,'3 RUE DE VIRE','','','14270','CESNY AUX VIGNES OUEZY',NULL,NULL,'',325.000000000,'2008-12-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9957,'SIMONNEAU','PATRICIA',NULL,'02.29.88.63.93','06.43.63.71.16',NULL,'11 rue paul langevin','','','14730','GIBERVILLE',NULL,NULL,'',109.000000000,'2011-05-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9958,'EIGLE','MADELEINE',NULL,'02.11.29.14.77','06.97.54.37.01',NULL,'28 rue de l''eglise de vaucelles','','','50550','ST VAAST LA HOUGUE',NULL,NULL,'',1338.000000000,'2010-06-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9959,'MARIE','Albert',NULL,'02.43.99.03.65','06.76.53.54.50',NULL,'26 RUE DE LA 30 EME DIVISION US','','','14000','CAEN',NULL,NULL,'',323.000000000,'2008-04-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9960,'DAUXAIS','PIERRE',NULL,'02.26.13.58.95','06.25.68.19.99',NULL,'L''AUNAY','','','14260','ST GEORGES D''AUNAY',NULL,NULL,'',184.000000000,'2013-03-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9961,'LE CORDIER','RAYMOND',NULL,'02.57.22.21.27','06.11.18.61.74',NULL,'2 RUE NICOLAS COPERNIC','','','92100','BOULOGNE BILLANCOURT',NULL,NULL,'',383.000000000,'2011-12-23','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9962,'GUIRADO','BLANCHE',NULL,'02.45.98.72.95','06.15.83.44.88',NULL,'14 ROUTE DE VIMONT','','','14260','AUNAY SUR ODON',NULL,NULL,'',870.000000000,'2010-07-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9963,'LAVILLE','JEAN',NULL,'02.66.71.48.55','06.60.99.56.08',NULL,'430 rue du becquet','','','14190','GRAINVILLE LANGANNERIE',NULL,NULL,'',21.000000000,'2008-10-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9964,'MAS','MICHEL',NULL,'02.87.77.57.63','06.45.69.58.63',NULL,'27 RUE D''IFS','','','14220','CESNY BOIS HALBOUT',NULL,NULL,'',84.000000000,'2009-11-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9965,'LECLERC','Yves',NULL,'02.10.53.30.95','06.10.54.32.00',NULL,'31 RUE AUGUSTE LECHESNE','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'',295.000000000,'2013-08-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9966,'JULIEN','MICHEL',NULL,'02.29.37.88.72','06.20.38.41.10',NULL,'23 rue albert de mun','','','14930','ETERVILLE',NULL,NULL,'',728.000000000,'2010-11-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9967,'DOUBLET','YVETTE',NULL,'02.89.85.58.66','06.28.56.99.49',NULL,'18 RUE ALBERT CAMUS','','','14000','CAEN',NULL,NULL,'',41.000000000,'2007-12-20','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9968,'ROBBE','CHRISTIANE',NULL,'02.12.68.83.88','06.54.69.90.78',NULL,'7 RUE DES ANEMONES','','','14460','COLOMBELLES',NULL,NULL,'',632.000000000,'2009-04-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9969,'CROIZER','GILBERTE',NULL,'02.27.75.40.46','06.86.97.24.68',NULL,'11 RUE ELSA TRILLOLET','','','14210','AMAYE SUR ORNE',NULL,NULL,'',208.000000000,'2009-08-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9970,'DUVAL','FABRICE',NULL,'02.31.65.37.18','06.86.01.07.98',NULL,'21 RUE DU REGRET','','','14220','GRIMBOSQ',NULL,NULL,'',351.000000000,'2007-11-15','PREMIUM',10,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9971,'LETOURNEUR','EUGENE',NULL,'02.11.97.52.86','06.43.89.59.72',NULL,'2 bvd itzak rabin','','','14320','ST MARTIN DE FONTENAY',NULL,NULL,'',1165.000000000,'2010-01-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9972,'MANSON','Roger',NULL,'02.47.75.94.87','06.40.84.29.12',NULL,'64 b avenue guynemer','','','14800','TOURGEVILLE',NULL,NULL,'',152.000000000,'2011-05-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9973,'LEVEE','JEAN',NULL,'02.71.24.72.68','06.81.90.67.03',NULL,'15 rue du general leclerc','','','14320','FONTENAY LE MARMION',NULL,NULL,'',17.000000000,'2009-06-05','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9974,'DELAUNE','GERMAIN',NULL,'02.60.72.06.49','06.78.00.91.61',NULL,'12 route de tilly','','','14000','CAEN',NULL,NULL,'',22.000000000,'2011-09-25','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9975,'MAURICE','GERARD',NULL,'02.63.38.29.51','06.95.62.12.07',NULL,'12 rue de la forge','','','14200','HEROUVILLE ST CLAIR',NULL,NULL,'',670.000000000,'2011-11-12','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9976,'BASTARD','LAURETTE',NULL,'02.17.40.43.87','06.66.55.89.72',NULL,'3 RUE ABBE LUCAS','','','14123','IFS',NULL,NULL,'',1703.000000000,'2012-12-22','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9977,'HERVOT','MAURICE',NULL,'02.33.02.15.97','06.15.37.12.16',NULL,'4 rue ampere','','','14370','ARGENCES',NULL,NULL,'',903.000000000,'2012-07-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9978,'LEREVEREND','SIMONE',NULL,'02.32.80.71.75','06.31.50.70.15',NULL,'7 IMP DES COLVERTS','','','14840','DEMOUVILLE',NULL,NULL,'',35.000000000,'2011-09-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9979,'TOUTAIN','CHRISTINE',NULL,'02.88.30.54.58','06.89.45.28.42',NULL,'','','','14120','MONDEVILLE',NULL,NULL,'',244.000000000,'2009-11-01','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9980,'RENAULT','LEGER',NULL,'02.10.81.56.02','06.44.75.27.49',NULL,'ROUTE DE LA MAIRIE RD 176','','','14260','AUNAY SUR ODON',NULL,NULL,'',272.000000000,'2012-05-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9981,'LUNEL','GEORGETTE',NULL,'02.55.49.57.36','06.58.41.20.35',NULL,'3 RUE DE L ESPACE','','','14150','OUISTREHAM',NULL,NULL,'',111.000000000,'2013-02-28','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9982,'BIHEL','GERARD',NULL,'02.12.17.20.82','06.11.78.80.96',NULL,'163 rue d''auge','','','14630','CAGNY',NULL,NULL,'',2837.000000000,'2010-02-20','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9983,'LETIEN','PASCAL',NULL,'02.29.64.50.90','06.51.32.18.79',NULL,'1 bis place du monument','','','14540','SOLIERS',NULL,NULL,'',20.000000000,'2013-04-14','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9984,'MORA','BRIGITTE',NULL,'02.29.00.24.03','06.50.63.56.56',NULL,'LE BOURG','','','14000','CAEN',NULL,NULL,'',1408.000000000,'2009-04-11','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9985,'BELLERY','GEORGES',NULL,'02.66.25.85.25','06.82.57.25.66',NULL,'chez mme Floquet Patricia 277 im','p du village','','14220','COMBRAY',NULL,NULL,'',314.000000000,'2012-09-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9986,'BRUYERE','THIERRY',NULL,'02.29.63.45.27','06.20.85.75.06',NULL,'7 BD DU 11 NOVEMBRE','','','14370','BISSIERES',NULL,NULL,'',64.000000000,'2012-03-24','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9987,'LECOQ','HENRI',NULL,'02.14.69.04.47','06.78.76.14.38',NULL,'3 rue de la crete','','','14390','CABOURG',NULL,NULL,'',199.000000000,'2008-09-03','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9988,'DESVALLEES','MICHEL',NULL,'02.99.62.75.47','06.70.06.53.95',NULL,'10 impasse germaine','','','50630','QUETTEHOU',NULL,NULL,'',744.000000000,'2010-07-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9989,'JULES','JEAN MARIE',NULL,'02.71.72.19.23','06.99.75.34.79',NULL,'24 RUE DE CREVECOEUR','','','14000','CAEN',NULL,NULL,'',800.000000000,'2012-08-13','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9990,'ROCANCOURT','BERNARD',NULL,'02.11.59.34.73','06.27.26.07.21',NULL,'114 RUE DU REGIMENT DE LA CHAUDI','ERE','','14000','CAEN',NULL,NULL,'',320.000000000,'2008-01-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9991,'KAMALI','JONATHAN',NULL,'02.87.78.20.78','06.53.90.01.05',NULL,'66 RUE PASTEUR','','','14370','MOULT',NULL,NULL,'',36.000000000,'2010-02-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9992,'PAISANT','Irene',NULL,'02.28.91.11.98','06.10.68.26.04',NULL,'17 rue de st supplice','','','14123','CORMELLES LE ROYAL',NULL,NULL,'',24.000000000,'2008-05-02','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9993,'LEFEVRE','ROGER',NULL,'02.63.35.62.61','06.11.35.09.12',NULL,'22 RUE ROBERT CASTEL','','','14120','MONDEVILLE',NULL,NULL,'',206.000000000,'2009-05-10','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9994,'HAMON','ALAIN',NULL,'02.25.99.01.00','06.63.60.68.93',NULL,'28 RUE EMMANUEL','','','14000','CAEN',NULL,NULL,'',20.000000000,'2010-04-26','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9995,'','ALAIN',NULL,'02.67.78.33.52','06.50.45.66.87',NULL,'14 RUE DU CHEMINOT','','','14480','GIBERVILLE',NULL,NULL,'',409.000000000,'2008-11-19','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9996,'LEJEUNE','JULES',NULL,'02.98.85.71.46','06.22.24.56.68',NULL,'14 RUE MARCEL LEMERAY','','','14120','MONDEVILLE',NULL,NULL,'',1949.000000000,'2008-06-17','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9997,'FRILLEY','SANDRINE',NULL,'02.12.05.51.19','06.30.26.86.41',NULL,'route de treviere','','','14700','ST GERMAIN LANGOT',NULL,NULL,'',1198.000000000,'2010-03-06','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9998,'JOUANNE','BERNADETTE',NULL,'02.51.85.23.20','06.48.64.98.36',NULL,'GENDARMERIE NATIONALE  87 RUE DE',' L''EGLISE','','14150','OUISTREHAM',NULL,NULL,'',87.000000000,'2012-01-31','PREMIUM',NULL,0);
INSERT INTO dbo.T_ADHERENT_ADR (ADR_ID,ADR_NOM,ADR_PRENOM,ADR_DATE_NAISSANCE,ADR_TEL_FIX,ADR_TEL_MOBILE,ADR_MAIL,ADR_ADRESSE1,ADR_ADRESSE2,ADR_ADRESSE3,ADR_CP,ADR_VILLE,ADR_LOGIN,ADR_PASS,ADR_NUMSECU,ADR_POINTS,ADR_DATE_ADHESION,ADR_CATEGORIE,ADR_REDUCTION_PC,ADR_FONDATEUR) VALUES (9999,'LEROY','THERESE',NULL,'02.76.72.02.25','06.14.91.74.61',NULL,'12  RUE FITZ HAIMON','','','14670','TROARN',NULL,NULL,'',849.000000000,'2012-04-21','PREMIUM',NULL,0);
SET IDENTITY_INSERT dbo.T_ADHERENT_ADR OFF;


CHECKPOINT;
GO

INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9,18);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (12,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (15,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (18,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (18,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (19,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (26,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (27,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (31,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (32,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (33,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (38,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (40,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (42,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (42,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (43,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (44,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (46,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (51,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (51,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (56,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (64,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (64,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (65,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (69,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (71,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (72,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (76,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (77,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (77,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (83,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (85,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (94,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (97,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (99,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (100,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (100,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (101,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (106,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (107,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (110,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (111,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (113,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (113,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (116,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (117,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (120,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (125,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (125,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (126,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (126,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (127,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (131,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (131,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (134,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (135,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (140,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (140,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (142,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (144,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (144,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (147,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (147,50);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (148,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (149,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (150,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (150,77);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (151,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (152,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (155,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (155,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (155,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (158,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (160,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (161,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (164,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (166,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (167,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (170,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (175,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (176,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (180,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (182,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (182,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (183,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (186,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (187,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (188,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (190,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (192,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (192,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (193,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (196,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (199,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (200,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (200,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (202,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (203,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (203,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (206,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (207,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (210,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (210,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (212,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (213,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (217,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (222,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (224,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (226,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (228,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (229,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (231,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (232,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (233,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (235,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (235,50);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (235,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (240,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (245,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (247,86);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (248,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (250,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (250,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (253,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (254,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (255,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (259,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (260,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (260,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (263,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (266,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (269,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (270,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (272,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (273,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (277,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (277,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (277,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (283,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (284,50);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (292,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (294,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (298,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (303,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (304,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (305,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (306,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (311,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (311,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (311,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (317,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (322,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (324,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (326,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (328,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (328,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (328,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (329,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (331,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (331,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (333,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (333,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (341,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (341,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (350,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (353,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (357,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (358,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (360,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (362,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (363,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (364,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (366,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (367,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (372,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (376,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (379,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (381,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (384,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (386,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (387,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (388,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (388,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (390,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (391,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (392,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (395,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (396,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (398,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (400,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (401,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (406,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (408,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (412,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (414,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (414,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (418,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (421,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (421,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (422,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (424,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (425,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (427,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (429,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (431,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (431,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (434,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (436,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (440,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (442,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (446,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (448,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (448,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (449,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (453,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (455,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (455,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (458,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (459,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (459,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (463,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (463,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (465,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (467,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (470,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (472,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (477,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (478,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (481,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (487,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (488,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (488,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (489,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (494,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (495,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (496,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (498,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (499,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (499,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (502,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (503,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (504,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (504,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (507,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (508,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (513,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (518,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (519,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (520,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (521,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (522,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (522,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (523,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (523,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (524,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (529,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (530,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (530,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (531,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (531,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (531,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (533,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (533,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (537,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (537,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (540,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (542,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (542,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (548,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (551,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (551,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (552,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (553,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (557,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (558,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (562,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (563,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (563,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (565,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (565,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (565,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (588,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (588,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (590,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (591,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (591,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (597,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (602,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (602,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (605,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (606,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (625,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (626,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (626,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (630,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (632,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (637,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (638,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (640,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (642,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (642,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (642,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (642,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (644,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (647,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (650,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (652,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (655,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (656,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (658,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (660,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (661,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (663,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (665,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (670,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (677,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (677,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (677,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (681,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (681,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (681,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (682,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (683,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (687,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (694,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (695,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (698,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (699,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (702,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (702,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (705,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (706,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (706,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (711,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (712,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (719,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (725,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (728,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (730,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (732,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (732,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (733,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (734,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (736,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (739,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (743,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (746,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (746,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (747,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (748,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (753,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (754,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (755,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (756,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (760,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (760,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (760,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (761,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (761,50);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (762,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (762,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (764,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (766,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (767,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (772,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (773,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (773,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (774,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (778,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (780,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (781,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (783,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (786,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (788,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (791,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (793,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (796,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (800,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (801,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (805,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (806,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (811,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (811,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (812,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (814,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (815,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (815,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (828,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (830,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (830,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (834,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (834,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (838,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (839,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (841,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (842,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (845,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (846,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (847,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (851,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (851,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (853,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (854,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (855,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (865,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (868,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (872,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (875,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (875,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (878,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (879,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (882,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (884,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (884,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (886,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (890,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (893,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (894,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (895,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (896,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (897,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (898,95);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (899,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (900,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (904,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (906,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (907,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (916,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (921,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (921,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (924,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (924,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (927,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (929,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (930,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (930,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (931,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (934,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (936,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (936,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (942,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (943,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (944,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (946,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (948,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (950,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (954,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (955,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (957,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (958,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (965,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (966,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (967,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (968,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (973,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (975,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (975,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (976,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (978,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (984,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (986,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (987,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (987,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (989,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (989,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (992,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (992,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (996,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (997,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (997,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (998,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1006,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1006,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1009,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1013,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1013,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1019,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1021,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1026,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1027,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1032,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1034,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1035,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1043,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1053,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1054,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1054,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1058,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1061,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1062,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1062,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1063,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1063,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1064,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1066,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1067,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1069,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1070,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1075,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1075,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1076,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1079,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1080,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1085,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1085,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1093,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1095,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1095,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1096,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1098,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1102,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1103,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1107,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1108,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1108,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1110,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1113,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1115,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1115,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1117,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1118,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1121,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1122,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1124,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1125,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1127,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1127,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1129,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1133,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1133,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1134,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1135,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1140,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1142,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1142,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1144,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1145,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1150,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1153,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1155,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1158,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1160,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1161,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1163,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1164,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1169,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1169,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1170,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1171,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1172,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1177,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1178,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1183,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1186,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1186,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1189,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1190,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1197,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1197,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1198,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1199,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1199,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1200,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1201,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1204,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1205,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1207,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1213,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1215,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1217,63);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1217,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1219,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1219,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1220,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1222,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1223,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1225,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1230,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1231,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1231,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1231,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1232,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1232,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1233,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1234,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1235,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1237,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1238,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1241,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1244,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1245,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1245,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1245,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1247,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1247,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1249,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1254,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1255,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1255,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1257,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1259,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1263,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1267,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1272,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1272,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1272,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1279,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1287,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1288,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1290,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1290,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1292,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1293,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1294,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1295,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1295,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1298,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1300,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1306,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1307,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1312,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1321,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1323,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1324,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1328,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1329,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1330,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1332,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1336,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1338,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1339,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1341,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1341,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1344,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1344,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1345,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1347,5);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1348,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1349,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1351,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1351,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1353,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1358,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1359,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1366,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1370,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1372,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1377,7);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1378,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1379,86);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1383,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1384,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1385,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1389,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1394,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1403,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1403,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1405,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1406,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1406,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1409,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1410,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1410,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1411,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1412,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1413,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1414,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1417,95);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1420,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1420,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1421,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1422,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1426,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1431,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1432,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1432,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1433,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1435,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1435,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1436,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1438,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1439,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1440,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1441,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1443,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1445,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1445,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1446,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1450,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1451,50);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1453,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1454,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1457,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1462,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1465,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1468,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1469,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1469,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1470,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1482,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1489,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1496,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1498,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1500,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1502,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1504,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1506,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1507,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1509,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1509,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1509,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1510,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1514,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1517,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1521,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1521,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1522,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1525,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1527,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1527,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1529,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1529,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1531,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1533,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1534,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1535,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1539,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1540,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1542,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1548,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1551,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1559,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1560,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1564,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1565,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1565,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1566,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1567,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1572,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1572,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1573,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1573,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1582,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1582,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1583,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1585,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1586,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1588,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1589,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1591,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1596,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1601,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1605,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1605,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1607,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1607,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1610,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1611,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1615,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1617,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1622,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1623,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1626,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1628,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1628,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1629,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1632,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1632,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1633,18);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1638,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1640,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1641,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1641,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1642,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1646,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1647,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1649,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1656,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1659,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1663,50);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1665,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1668,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1671,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1674,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1674,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1677,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1677,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1683,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1687,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1693,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1694,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1696,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1696,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1696,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1700,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1701,5);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1705,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1710,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1721,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1721,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1723,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1723,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1724,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1725,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1727,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1728,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1730,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1738,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1738,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1739,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1740,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1741,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1743,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1746,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1748,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1749,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1750,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1752,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1756,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1757,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1767,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1770,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1771,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1773,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1774,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1777,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1782,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1783,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1788,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1789,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1792,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1795,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1796,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1798,5);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1801,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1803,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1806,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1806,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1811,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1812,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1813,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1816,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1817,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1823,23);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1824,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1828,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1832,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1838,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1839,63);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1839,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1841,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1841,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1841,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1842,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1844,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1845,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1845,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1846,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1852,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1852,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1855,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1857,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1859,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1860,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1861,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1864,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1865,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1867,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1869,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1870,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1872,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1873,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1876,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1876,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1876,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1877,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1886,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1889,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1889,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1890,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1897,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1898,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1902,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1904,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1905,33);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1907,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1909,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1909,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1911,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1913,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1918,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1921,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1922,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1923,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1923,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1928,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1928,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1937,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1940,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1941,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1950,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1956,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1966,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1967,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1967,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1968,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1969,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1971,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1975,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1979,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1984,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1987,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1987,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1988,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1989,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1990,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1990,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1992,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1993,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1994,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1995,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (1996,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2000,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2000,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2000,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2011,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2017,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2021,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2021,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2024,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2025,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2037,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2039,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2040,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2042,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2042,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2042,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2044,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2044,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2045,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2047,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2052,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2054,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2054,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2055,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2063,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2069,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2074,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2075,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2080,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2083,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2085,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2087,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2087,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2091,23);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2092,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2094,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2094,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2095,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2096,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2097,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2099,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2099,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2102,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2106,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2113,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2115,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2115,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2117,5);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2117,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2126,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2128,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2130,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2132,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2134,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2136,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2138,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2141,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2141,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2142,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2144,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2145,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2145,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2145,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2148,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2148,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2149,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2151,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2153,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2158,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2164,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2165,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2166,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2167,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2169,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2170,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2173,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2174,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2175,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2179,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2184,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2188,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2188,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2189,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2191,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2193,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2193,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2200,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2200,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2208,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2208,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2208,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2213,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2218,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2218,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2219,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2221,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2221,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2225,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2232,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2235,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2235,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2236,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2237,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2238,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2243,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2247,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2248,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2248,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2249,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2250,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2250,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2251,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2253,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2255,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2261,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2261,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2268,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2269,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2270,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2278,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2279,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2283,2);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2284,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2285,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2286,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2286,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2287,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2288,7);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2288,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2290,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2290,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2291,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2293,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2293,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2295,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2297,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2298,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2299,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2301,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2302,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2308,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2312,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2318,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2319,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2322,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2331,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2331,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2331,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2338,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2339,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2343,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2349,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2350,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2351,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2357,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2357,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2357,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2359,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2360,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2362,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2370,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2370,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2370,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2372,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2374,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2374,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2378,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2384,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2385,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2388,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2390,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2390,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2394,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2394,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2396,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2399,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2401,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2406,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2407,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2408,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2409,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2410,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2412,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2413,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2414,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2418,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2423,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2430,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2432,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2437,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2438,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2440,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2440,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2447,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2448,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2448,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2448,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2449,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2449,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2449,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2450,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2452,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2453,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2454,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2458,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2459,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2462,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2462,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2467,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2473,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2474,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2477,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2479,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2483,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2483,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2485,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2487,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2487,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2487,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2489,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2489,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2495,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2495,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2496,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2497,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2498,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2499,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2500,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2504,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2505,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2506,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2507,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2509,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2510,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2517,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2522,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2522,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2526,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2528,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2530,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2534,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2535,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2536,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2537,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2537,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2545,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2548,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2548,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2549,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2550,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2550,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2552,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2552,50);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2553,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2553,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2554,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2556,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2561,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2562,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2569,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2571,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2573,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2577,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2578,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2581,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2586,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2587,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2589,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2594,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2595,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2596,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2601,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2601,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2602,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2603,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2604,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2606,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2608,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2612,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2614,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2616,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2618,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2621,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2622,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2623,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2624,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2625,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2626,18);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2629,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2630,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2632,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2633,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2634,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2641,18);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2644,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2650,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2651,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2652,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2656,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2662,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2666,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2670,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2670,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2671,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2675,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2686,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2689,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2690,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2690,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2692,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2696,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2696,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2700,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2701,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2702,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2702,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2702,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2703,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2703,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2703,86);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2703,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2705,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2705,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2705,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2707,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2709,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2710,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2712,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2713,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2715,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2717,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2717,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2718,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2720,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2721,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2722,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2723,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2726,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2730,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2731,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2735,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2735,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2741,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2744,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2750,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2752,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2753,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2761,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2762,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2762,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2762,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2764,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2767,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2767,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2768,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2771,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2776,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2778,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2780,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2780,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2782,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2785,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2787,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2787,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2787,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2789,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2791,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2792,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2793,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2794,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2795,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2796,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2796,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2800,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2801,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2801,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2803,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2807,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2813,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2813,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2814,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2819,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2820,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2825,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2827,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2827,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2833,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2839,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2844,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2845,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2846,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2846,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2847,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2849,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2850,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2855,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2856,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2867,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2874,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2875,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2878,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2878,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2882,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2884,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2886,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2886,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2887,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2889,33);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2895,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2896,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2898,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2898,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2905,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2906,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2906,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2910,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2910,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2919,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2922,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2925,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2929,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2933,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2933,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2933,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2934,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2953,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2955,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2957,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2960,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2962,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2963,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2964,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2973,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2975,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2975,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2976,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2976,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2977,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2978,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2982,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2985,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2985,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2987,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2987,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2988,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2990,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2992,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2992,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2994,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (2996,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3002,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3009,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3010,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3011,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3012,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3013,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3013,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3016,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3017,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3021,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3024,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3029,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3030,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3031,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3033,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3033,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3035,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3041,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3047,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3047,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3053,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3059,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3060,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3060,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3061,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3061,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3064,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3064,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3071,86);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3079,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3080,77);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3080,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3083,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3083,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3085,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3086,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3091,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3093,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3097,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3100,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3103,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3104,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3105,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3108,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3109,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3111,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3115,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3119,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3120,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3126,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3128,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3130,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3130,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3131,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3133,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3140,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3142,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3147,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3149,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3153,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3158,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3159,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3166,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3167,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3167,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3176,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3176,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3179,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3180,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3180,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3185,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3186,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3190,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3191,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3201,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3201,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3205,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3206,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3207,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3215,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3225,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3226,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3228,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3231,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3233,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3234,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3235,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3236,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3236,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3238,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3240,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3243,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3243,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3245,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3247,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3251,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3252,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3258,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3259,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3259,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3261,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3264,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3266,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3266,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3267,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3269,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3271,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3272,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3272,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3273,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3278,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3280,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3284,95);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3292,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3293,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3295,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3301,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3313,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3313,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3313,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3315,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3315,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3321,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3323,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3327,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3328,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3328,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3330,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3332,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3335,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3338,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3338,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3340,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3340,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3340,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3343,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3350,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3353,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3355,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3355,77);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3359,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3360,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3362,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3363,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3369,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3369,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3370,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3371,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3373,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3374,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3375,5);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3379,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3384,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3384,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3393,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3398,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3398,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3399,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3400,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3402,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3406,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3409,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3411,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3415,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3415,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3417,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3418,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3418,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3419,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3420,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3424,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3424,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3426,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3430,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3434,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3436,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3436,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3438,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3439,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3440,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3440,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3442,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3450,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3451,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3453,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3456,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3456,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3457,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3457,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3458,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3460,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3462,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3463,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3464,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3467,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3470,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3471,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3472,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3474,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3475,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3479,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3479,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3480,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3485,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3488,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3490,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3490,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3491,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3493,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3494,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3496,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3500,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3502,2);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3502,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3504,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3504,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3507,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3509,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3512,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3517,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3523,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3525,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3529,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3531,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3531,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3533,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3536,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3540,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3545,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3546,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3546,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3548,95);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3551,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3553,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3554,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3555,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3569,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3570,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3570,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3576,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3580,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3581,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3588,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3588,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3590,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3595,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3595,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3599,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3601,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3601,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3601,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3601,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3601,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3602,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3605,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3606,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3609,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3613,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3616,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3617,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3618,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3620,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3626,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3626,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3638,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3639,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3641,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3642,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3643,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3644,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3645,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3646,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3649,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3657,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3661,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3662,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3664,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3666,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3667,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3668,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3670,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3672,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3672,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3674,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3679,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3681,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3687,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3697,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3699,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3702,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3702,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3702,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3703,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3704,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3711,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3711,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3712,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3715,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3717,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3720,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3721,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3722,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3724,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3726,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3729,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3731,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3735,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3736,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3737,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3742,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3742,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3743,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3751,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3752,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3754,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3754,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3757,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3761,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3762,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3765,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3766,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3767,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3769,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3769,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3774,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3777,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3780,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3782,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3782,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3785,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3785,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3786,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3790,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3790,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3799,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3799,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3802,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3804,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3807,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3808,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3811,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3812,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3813,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3816,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3816,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3821,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3823,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3825,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3826,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3832,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3832,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3832,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3837,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3838,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3839,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3843,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3844,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3845,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3847,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3848,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3850,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3851,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3858,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3858,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3859,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3859,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3859,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3864,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3867,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3868,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3869,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3871,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3871,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3874,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3880,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3881,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3882,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3884,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3885,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3889,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3890,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3893,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3896,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3897,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3897,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3899,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3899,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3900,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3900,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3902,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3905,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3907,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3908,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3908,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3928,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3931,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3932,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3936,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3938,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3938,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3948,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3948,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3953,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3955,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3956,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3962,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3965,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3965,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3965,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3966,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3967,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3970,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3970,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3972,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3973,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3973,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3978,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3982,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3982,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3985,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3986,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3986,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3986,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3994,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3995,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (3999,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4000,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4002,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4004,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4008,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4008,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4011,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4012,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4016,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4016,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4018,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4019,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4020,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4028,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4030,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4033,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4035,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4036,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4041,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4043,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4044,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4049,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4051,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4064,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4068,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4068,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4071,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4075,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4075,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4076,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4077,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4079,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4081,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4083,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4085,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4090,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4092,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4093,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4094,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4096,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4106,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4108,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4108,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4112,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4113,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4113,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4115,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4115,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4116,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4120,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4120,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4121,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4125,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4126,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4127,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4129,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4129,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4138,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4140,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4143,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4144,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4145,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4149,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4153,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4160,86);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4161,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4161,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4161,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4169,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4170,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4171,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4174,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4175,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4177,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4182,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4183,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4184,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4184,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4185,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4188,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4190,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4190,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4190,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4195,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4198,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4201,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4208,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4209,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4212,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4216,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4221,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4221,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4231,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4233,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4237,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4238,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4240,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4240,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4241,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4241,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4242,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4243,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4246,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4250,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4250,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4251,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4251,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4253,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4256,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4257,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4262,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4267,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4267,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4268,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4269,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4271,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4275,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4278,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4278,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4279,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4282,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4286,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4290,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4291,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4297,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4297,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4302,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4303,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4304,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4307,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4310,2);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4310,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4312,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4312,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4314,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4315,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4319,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4320,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4322,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4323,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4323,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4323,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4324,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4325,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4332,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4336,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4339,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4340,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4340,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4344,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4345,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4345,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4348,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4349,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4350,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4351,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4357,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4364,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4365,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4366,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4368,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4369,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4377,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4378,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4379,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4380,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4382,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4382,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4389,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4391,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4394,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4394,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4396,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4406,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4407,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4411,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4411,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4412,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4412,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4412,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4412,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4413,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4415,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4417,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4418,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4418,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4425,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4426,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4429,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4431,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4431,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4431,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4431,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4432,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4433,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4433,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4433,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4434,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4439,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4448,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4451,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4455,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4456,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4461,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4462,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4462,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4466,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4466,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4468,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4468,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4474,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4476,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4478,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4478,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4479,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4479,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4480,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4480,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4480,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4480,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4480,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4489,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4491,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4492,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4492,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4494,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4494,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4496,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4496,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4497,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4498,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4509,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4517,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4517,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4519,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4522,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4523,63);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4525,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4528,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4528,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4529,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4531,50);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4531,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4531,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4533,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4535,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4539,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4540,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4542,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4542,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4546,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4549,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4554,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4555,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4557,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4561,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4565,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4566,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4568,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4571,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4577,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4578,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4578,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4579,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4582,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4585,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4586,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4587,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4589,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4592,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4593,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4595,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4595,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4598,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4603,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4605,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4609,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4620,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4622,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4625,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4625,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4625,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4626,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4627,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4633,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4634,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4643,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4645,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4646,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4647,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4649,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4650,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4651,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4652,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4654,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4657,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4658,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4659,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4660,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4662,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4669,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4670,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4679,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4681,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4682,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4684,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4685,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4686,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4686,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4688,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4690,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4691,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4692,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4697,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4698,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4698,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4698,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4702,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4702,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4705,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4706,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4706,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4706,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4708,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4709,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4709,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4710,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4712,3);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4712,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4715,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4716,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4721,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4722,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4722,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4724,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4724,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4725,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4725,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4726,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4726,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4727,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4727,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4728,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4729,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4730,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4732,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4732,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4732,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4733,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4736,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4737,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4739,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4741,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4745,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4745,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4746,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4748,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4750,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4752,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4752,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4756,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4757,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4759,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4760,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4761,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4763,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4768,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4775,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4776,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4778,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4778,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4780,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4785,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4787,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4798,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4801,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4805,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4805,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4807,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4811,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4814,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4817,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4819,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4820,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4826,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4827,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4829,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4832,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4833,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4833,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4837,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4844,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4844,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4848,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4848,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4850,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4851,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4858,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4858,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4859,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4859,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4860,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4860,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4863,7);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4864,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4868,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4873,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4874,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4877,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4880,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4882,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4886,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4887,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4889,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4890,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4890,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4892,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4893,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4894,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4895,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4897,86);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4901,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4904,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4904,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4910,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4912,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4914,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4920,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4924,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4928,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4930,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4932,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4933,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4939,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4940,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4945,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4946,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4947,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4947,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4949,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4955,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4956,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4960,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4960,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4963,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4964,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4964,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4965,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4972,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4976,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4976,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4976,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4977,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4979,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4980,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4981,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4981,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4982,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4984,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4988,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4991,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4991,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4991,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4992,23);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4992,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4993,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4993,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (4997,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5010,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5013,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5014,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5015,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5016,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5017,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5021,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5021,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5025,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5028,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5031,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5033,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5033,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5033,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5035,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5042,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5045,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5060,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5062,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5062,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5065,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5066,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5066,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5068,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5069,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5070,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5071,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5077,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5093,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5094,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5097,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5098,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5100,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5102,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5103,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5104,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5105,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5114,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5114,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5114,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5114,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5117,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5117,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5119,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5120,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5120,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5121,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5122,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5129,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5129,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5130,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5133,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5140,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5140,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5142,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5149,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5155,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5155,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5156,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5158,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5159,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5161,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5162,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5168,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5170,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5171,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5172,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5174,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5177,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5183,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5185,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5186,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5190,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5191,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5192,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5192,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5192,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5196,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5196,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5197,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5202,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5202,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5202,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5203,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5207,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5209,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5212,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5213,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5229,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5232,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5233,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5237,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5240,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5242,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5245,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5250,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5251,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5254,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5256,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5258,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5262,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5264,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5268,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5271,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5277,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5277,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5279,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5279,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5283,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5286,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5289,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5290,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5292,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5298,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5300,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5301,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5301,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5317,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5317,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5320,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5320,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5325,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5326,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5332,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5334,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5338,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5338,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5341,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5344,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5345,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5351,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5352,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5352,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5353,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5353,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5353,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5354,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5354,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5370,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5370,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5373,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5378,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5380,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5381,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5383,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5392,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5393,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5396,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5398,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5404,86);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5414,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5417,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5418,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5420,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5422,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5423,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5425,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5428,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5431,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5431,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5436,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5437,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5439,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5439,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5441,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5442,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5448,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5449,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5453,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5455,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5457,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5457,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5461,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5468,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5468,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5469,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5472,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5475,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5476,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5478,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5479,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5480,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5481,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5483,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5484,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5485,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5487,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5488,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5490,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5490,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5498,5);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5498,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5499,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5502,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5505,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5510,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5510,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5513,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5514,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5516,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5518,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5521,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5530,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5533,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5535,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5535,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5536,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5538,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5539,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5539,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5540,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5543,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5543,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5544,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5544,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5546,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5549,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5550,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5553,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5554,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5554,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5554,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5565,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5570,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5570,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5571,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5572,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5578,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5580,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5581,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5582,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5582,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5586,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5588,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5588,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5590,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5594,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5594,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5595,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5595,7);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5599,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5600,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5601,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5604,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5608,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5609,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5609,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5610,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5610,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5613,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5614,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5614,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5616,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5622,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5626,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5627,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5628,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5628,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5629,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5630,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5631,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5632,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5634,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5637,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5642,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5643,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5644,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5644,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5645,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5646,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5646,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5648,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5649,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5649,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5654,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5656,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5658,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5660,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5661,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5661,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5671,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5683,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5684,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5686,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5687,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5692,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5692,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5694,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5695,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5698,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5699,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5701,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5701,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5703,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5704,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5710,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5711,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5712,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5715,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5715,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5716,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5717,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5724,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5726,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5726,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5730,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5733,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5735,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5736,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5738,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5738,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5740,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5741,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5743,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5744,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5746,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5746,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5746,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5747,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5750,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5751,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5752,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5755,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5756,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5759,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5762,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5762,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5765,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5768,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5768,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5768,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5769,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5770,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5772,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5772,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5773,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5774,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5775,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5788,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5789,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5796,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5797,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5798,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5799,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5802,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5803,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5804,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5804,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5809,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5818,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5818,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5819,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5823,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5827,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5829,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5831,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5832,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5833,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5838,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5841,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5845,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5850,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5852,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5857,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5861,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5863,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5864,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5865,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5868,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5871,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5871,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5874,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5877,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5877,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5883,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5884,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5887,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5887,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5891,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5892,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5893,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5895,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5898,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5902,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5903,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5906,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5908,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5908,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5909,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5913,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5913,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5917,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5917,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5918,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5918,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5918,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5923,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5929,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5930,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5930,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5936,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5938,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5942,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5942,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5944,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5946,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5946,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5947,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5956,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5957,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5962,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5963,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5969,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5971,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5973,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5977,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5979,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5980,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5980,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5981,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5982,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5987,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5988,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5989,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5989,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5990,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5994,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5994,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5996,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (5996,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6007,95);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6008,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6010,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6010,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6011,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6016,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6016,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6021,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6024,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6027,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6029,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6034,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6036,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6042,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6051,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6053,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6053,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6055,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6058,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6060,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6061,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6061,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6061,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6062,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6064,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6064,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6067,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6067,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6068,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6072,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6075,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6076,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6076,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6078,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6084,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6089,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6092,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6093,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6098,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6101,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6101,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6104,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6105,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6112,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6114,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6116,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6116,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6118,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6120,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6122,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6124,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6125,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6127,7);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6129,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6133,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6133,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6134,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6136,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6136,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6140,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6143,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6149,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6149,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6150,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6151,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6152,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6153,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6156,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6157,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6162,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6164,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6165,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6165,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6169,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6170,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6173,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6173,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6173,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6180,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6187,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6189,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6195,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6197,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6197,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6197,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6204,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6206,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6210,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6210,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6211,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6213,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6220,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6223,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6226,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6227,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6227,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6232,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6232,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6232,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6235,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6238,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6239,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6240,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6241,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6244,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6244,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6245,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6246,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6247,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6248,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6249,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6252,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6255,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6256,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6258,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6260,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6261,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6261,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6264,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6269,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6270,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6273,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6274,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6275,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6275,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6275,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6279,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6279,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6283,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6284,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6284,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6284,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6285,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6297,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6299,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6301,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6302,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6307,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6308,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6308,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6311,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6314,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6314,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6314,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6319,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6320,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6322,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6328,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6328,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6328,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6329,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6329,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6339,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6340,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6345,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6348,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6348,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6354,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6362,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6365,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6365,77);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6374,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6374,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6375,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6379,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6379,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6379,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6392,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6392,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6396,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6396,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6402,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6402,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6405,90);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6407,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6412,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6416,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6419,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6426,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6427,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6428,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6430,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6431,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6434,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6435,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6438,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6439,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6440,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6442,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6443,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6444,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6447,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6453,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6455,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6456,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6458,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6461,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6462,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6463,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6465,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6465,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6467,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6469,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6471,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6472,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6472,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6474,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6475,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6477,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6478,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6479,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6482,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6486,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6486,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6493,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6494,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6497,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6499,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6503,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6503,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6504,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6505,95);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6506,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6507,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6510,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6511,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6514,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6520,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6524,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6524,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6526,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6531,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6534,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6535,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6535,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6539,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6542,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6543,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6546,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6549,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6549,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6557,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6557,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6558,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6561,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6561,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6563,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6566,7);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6568,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6568,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6569,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6569,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6575,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6577,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6579,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6580,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6581,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6585,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6585,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6585,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6586,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6587,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6589,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6589,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6590,5);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6592,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6594,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6598,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6600,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6603,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6608,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6612,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6614,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6617,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6620,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6626,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6627,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6627,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6628,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6630,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6634,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6636,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6638,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6639,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6640,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6643,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6643,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6648,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6648,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6649,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6652,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6656,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6657,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6657,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6659,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6660,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6661,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6662,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6662,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6662,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6664,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6666,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6667,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6669,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6670,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6673,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6674,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6681,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6681,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6683,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6684,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6687,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6688,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6692,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6693,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6694,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6695,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6699,2);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6704,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6704,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6706,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6709,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6710,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6716,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6717,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6722,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6723,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6725,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6727,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6729,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6730,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6732,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6732,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6733,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6733,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6735,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6738,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6738,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6740,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6744,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6746,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6747,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6748,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6749,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6749,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6750,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6753,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6754,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6755,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6755,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6756,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6756,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6761,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6764,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6766,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6766,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6769,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6769,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6771,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6772,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6775,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6781,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6787,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6789,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6794,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6796,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6797,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6801,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6801,90);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6802,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6802,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6803,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6803,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6805,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6806,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6807,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6807,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6807,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6807,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6807,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6816,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6817,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6819,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6821,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6822,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6828,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6829,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6832,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6832,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6834,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6835,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6837,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6837,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6841,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6841,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6843,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6847,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6847,90);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6849,77);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6856,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6856,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6857,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6858,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6859,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6860,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6862,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6864,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6864,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6867,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6869,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6871,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6871,63);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6873,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6875,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6876,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6877,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6878,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6880,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6881,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6882,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6882,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6884,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6884,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6884,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6886,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6890,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6893,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6899,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6902,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6905,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6905,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6905,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6909,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6910,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6911,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6911,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6912,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6915,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6916,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6923,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6924,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6925,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6928,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6929,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6931,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6931,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6935,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6936,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6937,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6942,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6944,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6944,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6947,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6948,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6950,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6951,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6958,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6963,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6967,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6971,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6973,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6974,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6974,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6977,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6979,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6980,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6981,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6982,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6983,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6989,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6991,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6993,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6993,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6996,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (6996,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7004,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7004,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7005,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7005,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7005,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7007,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7008,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7009,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7010,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7010,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7016,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7021,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7021,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7022,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7023,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7028,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7029,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7030,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7030,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7034,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7039,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7040,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7046,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7047,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7047,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7047,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7054,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7054,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7058,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7059,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7060,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7061,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7062,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7063,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7065,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7065,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7068,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7070,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7071,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7071,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7073,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7074,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7075,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7078,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7082,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7083,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7089,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7094,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7095,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7096,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7096,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7102,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7106,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7107,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7111,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7113,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7114,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7115,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7115,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7116,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7116,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7117,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7117,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7118,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7118,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7121,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7122,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7123,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7128,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7129,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7132,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7133,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7133,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7134,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7135,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7142,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7146,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7146,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7147,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7154,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7155,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7156,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7158,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7158,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7165,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7168,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7172,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7174,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7177,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7182,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7182,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7190,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7191,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7196,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7201,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7203,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7210,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7210,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7215,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7217,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7217,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7218,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7224,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7224,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7225,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7225,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7229,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7231,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7233,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7236,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7240,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7241,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7242,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7248,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7249,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7250,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7251,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7255,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7255,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7257,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7259,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7261,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7262,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7263,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7264,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7270,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7271,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7271,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7271,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7272,95);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7276,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7277,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7278,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7279,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7279,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7280,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7281,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7286,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7286,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7290,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7291,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7294,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7295,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7299,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7303,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7305,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7305,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7305,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7306,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7306,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7308,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7316,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7319,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7322,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7323,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7324,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7325,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7326,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7328,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7328,68);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7328,69);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7328,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7329,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7331,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7335,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7336,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7337,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7341,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7344,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7347,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7347,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7347,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7349,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7351,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7353,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7355,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7356,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7357,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7359,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7361,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7364,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7368,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7369,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7373,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7375,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7377,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7378,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7383,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7384,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7386,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7386,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7386,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7388,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7390,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7392,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7393,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7393,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7394,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7397,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7398,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7398,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7399,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7408,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7411,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7412,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7412,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7414,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7414,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7414,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7415,3);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7419,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7422,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7424,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7427,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7434,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7442,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7452,95);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7453,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7454,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7454,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7455,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7455,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7456,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7456,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7457,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7458,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7458,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7461,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7472,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7474,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7474,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7475,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7475,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7476,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7476,50);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7478,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7479,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7479,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7481,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7482,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7487,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7489,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7489,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7490,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7491,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7494,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7501,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7502,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7507,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7507,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7510,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7512,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7513,50);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7518,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7518,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7519,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7520,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7521,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7522,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7523,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7529,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7531,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7532,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7532,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7535,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7536,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7536,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7539,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7539,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7547,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7550,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7554,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7560,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7563,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7567,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7567,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7570,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7571,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7572,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7572,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7576,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7576,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7579,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7582,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7591,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7592,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7594,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7595,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7596,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7598,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7599,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7599,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7616,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7618,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7619,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7622,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7623,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7628,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7636,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7636,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7638,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7638,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7639,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7641,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7647,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7648,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7649,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7652,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7653,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7653,95);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7657,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7665,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7666,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7669,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7679,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7680,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7683,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7684,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7685,50);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7687,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7689,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7696,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7701,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7702,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7705,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7707,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7709,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7713,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7714,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7715,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7716,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7718,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7729,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7733,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7736,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7742,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7743,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7743,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7744,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7745,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7747,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7747,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7750,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7751,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7751,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7752,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7753,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7756,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7758,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7760,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7761,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7762,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7763,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7764,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7764,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7770,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7771,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7772,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7772,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7772,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7776,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7778,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7778,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7780,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7780,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7781,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7781,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7784,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7785,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7787,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7787,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7788,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7793,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7796,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7798,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7799,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7803,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7803,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7804,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7809,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7809,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7810,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7816,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7817,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7818,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7820,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7823,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7825,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7827,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7828,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7828,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7829,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7829,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7832,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7834,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7836,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7837,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7847,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7847,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7853,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7859,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7859,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7860,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7861,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7862,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7864,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7866,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7867,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7869,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7872,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7873,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7874,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7876,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7877,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7879,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7880,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7882,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7883,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7883,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7884,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7884,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7889,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7891,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7892,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7899,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7902,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7902,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7903,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7908,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7910,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7911,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7912,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7915,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7916,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7917,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7924,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7925,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7930,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7932,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7933,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7938,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7938,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7938,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7940,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7943,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7944,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7945,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7953,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7958,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7958,50);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7958,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7960,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7973,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7975,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7977,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7977,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7984,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7985,86);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7988,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7991,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7992,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (7995,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8006,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8006,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8007,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8008,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8008,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8012,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8014,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8019,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8020,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8021,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8022,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8024,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8024,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8028,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8029,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8032,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8032,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8037,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8037,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8038,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8039,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8040,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8040,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8042,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8043,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8045,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8046,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8046,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8049,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8054,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8058,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8060,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8061,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8062,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8064,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8065,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8068,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8068,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8068,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8069,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8072,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8076,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8076,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8077,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8079,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8081,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8082,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8083,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8087,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8090,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8095,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8097,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8098,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8103,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8105,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8106,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8113,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8115,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8120,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8120,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8121,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8121,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8121,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8123,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8124,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8130,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8131,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8133,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8133,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8135,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8139,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8139,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8140,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8140,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8141,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8145,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8152,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8159,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8159,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8161,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8162,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8168,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8170,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8170,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8173,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8174,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8177,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8178,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8179,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8181,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8184,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8184,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8185,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8185,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8187,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8188,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8196,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8197,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8199,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8199,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8200,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8201,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8202,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8204,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8205,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8207,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8221,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8221,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8224,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8224,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8225,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8230,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8233,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8235,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8236,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8238,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8238,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8239,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8244,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8246,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8252,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8253,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8253,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8260,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8260,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8263,63);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8265,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8268,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8272,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8272,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8278,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8278,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8279,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8279,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8279,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8281,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8282,23);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8283,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8286,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8293,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8293,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8294,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8296,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8298,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8299,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8299,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8299,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8302,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8306,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8308,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8313,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8314,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8314,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8315,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8320,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8320,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8331,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8332,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8333,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8333,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8334,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8334,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8336,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8337,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8341,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8343,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8345,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8345,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8346,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8346,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8347,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8348,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8353,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8357,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8361,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8362,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8362,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8367,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8368,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8368,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8369,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8370,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8371,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8372,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8375,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8375,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8375,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8377,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8378,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8380,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8382,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8382,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8383,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8384,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8385,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8387,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8393,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8396,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8396,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8396,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8397,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8397,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8403,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8407,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8409,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8413,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8415,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8417,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8419,63);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8421,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8421,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8422,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8423,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8423,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8428,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8429,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8430,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8431,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8432,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8436,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8439,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8439,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8441,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8442,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8442,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8447,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8447,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8449,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8449,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8451,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8453,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8454,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8455,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8455,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8458,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8459,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8462,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8464,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8469,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8471,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8471,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8472,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8473,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8473,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8473,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8475,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8476,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8476,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8485,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8486,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8486,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8486,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8489,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8493,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8494,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8494,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8494,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8497,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8499,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8502,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8503,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8510,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8516,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8517,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8518,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8520,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8523,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8523,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8523,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8525,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8530,23);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8534,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8535,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8540,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8540,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8545,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8545,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8548,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8548,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8549,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8549,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8556,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8558,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8559,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8567,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8568,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8574,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8579,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8580,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8580,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8580,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8586,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8586,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8586,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8587,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8589,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8589,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8592,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8594,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8594,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8597,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8597,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8598,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8602,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8606,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8610,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8611,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8613,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8620,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8623,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8624,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8629,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8630,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8633,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8633,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8639,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8639,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8640,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8641,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8642,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8642,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8644,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8644,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8646,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8647,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8648,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8649,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8652,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8653,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8654,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8657,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8661,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8663,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8663,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8666,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8669,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8673,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8678,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8680,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8680,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8687,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8690,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8691,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8691,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8693,90);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8696,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8696,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8697,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8700,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8700,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8704,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8710,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8710,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8713,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8721,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8723,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8724,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8724,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8725,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8727,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8729,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8734,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8738,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8743,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8745,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8747,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8752,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8753,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8753,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8754,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8755,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8756,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8759,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8764,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8765,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8767,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8767,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8768,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8774,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8776,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8777,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8778,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8779,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8781,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8786,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8787,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8788,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8792,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8792,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8794,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8798,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8799,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8802,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8804,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8805,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8808,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8809,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8812,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8813,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8813,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8815,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8817,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8817,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8818,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8820,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8821,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8822,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8831,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8832,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8835,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8836,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8836,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8838,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8839,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8841,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8841,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8842,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8846,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8851,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8852,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8853,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8855,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8857,83);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8860,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8867,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8867,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8869,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8875,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8878,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8882,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8883,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8886,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8887,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8889,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8891,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8893,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8896,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8900,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8907,63);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8908,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8910,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8911,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8911,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8911,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8912,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8912,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8912,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8914,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8916,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8917,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8919,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8922,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8924,35);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8927,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8927,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8929,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8931,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8932,33);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8934,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8936,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8940,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8945,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8946,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8946,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8948,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8950,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8951,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8952,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8953,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8953,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8954,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8957,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8959,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8961,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8967,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8968,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8971,23);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8974,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8975,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8979,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8980,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8982,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8984,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8988,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8994,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8996,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (8999,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9001,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9001,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9002,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9006,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9006,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9008,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9009,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9009,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9012,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9013,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9019,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9020,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9022,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9022,98);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9026,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9027,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9030,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9032,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9033,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9038,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9039,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9042,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9045,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9048,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9056,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9061,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9062,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9066,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9066,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9068,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9074,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9075,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9078,23);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9078,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9079,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9081,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9083,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9085,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9087,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9089,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9090,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9092,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9095,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9097,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9099,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9100,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9105,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9107,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9109,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9114,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9115,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9115,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9116,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9119,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9120,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9123,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9124,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9125,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9126,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9126,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9129,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9129,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9130,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9131,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9131,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9132,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9136,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9139,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9141,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9141,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9143,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9144,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9145,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9148,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9151,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9156,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9157,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9159,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9162,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9162,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9166,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9168,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9171,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9174,3);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9177,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9177,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9177,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9180,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9188,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9194,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9199,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9199,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9199,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9203,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9205,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9206,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9209,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9211,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9212,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9219,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9225,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9227,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9230,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9232,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9232,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9235,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9238,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9244,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9247,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9249,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9254,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9256,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9257,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9258,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9260,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9263,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9266,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9270,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9271,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9274,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9276,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9285,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9285,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9289,44);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9291,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9298,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9299,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9299,90);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9300,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9302,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9304,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9304,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9305,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9309,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9313,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9316,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9317,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9318,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9318,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9319,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9320,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9323,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9326,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9328,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9330,66);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9335,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9342,31);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9344,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9348,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9349,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9350,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9352,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9355,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9357,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9358,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9362,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9369,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9370,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9372,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9373,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9379,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9384,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9392,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9394,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9396,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9399,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9399,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9406,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9408,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9410,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9411,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9411,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9412,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9416,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9418,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9418,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9423,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9424,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9424,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9424,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9427,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9428,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9433,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9435,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9440,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9442,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9442,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9443,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9444,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9445,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9446,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9449,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9454,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9455,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9456,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9457,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9460,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9467,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9471,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9474,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9478,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9480,54);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9480,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9481,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9481,72);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9481,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9482,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9483,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9484,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9487,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9489,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9491,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9497,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9499,95);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9500,87);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9501,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9501,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9502,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9503,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9504,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9504,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9505,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9506,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9507,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9507,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9512,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9516,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9517,17);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9523,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9526,75);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9530,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9530,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9531,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9535,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9537,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9541,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9541,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9547,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9551,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9553,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9557,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9558,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9559,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9560,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9563,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9563,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9564,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9569,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9570,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9571,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9572,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9572,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9574,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9581,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9586,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9586,74);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9586,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9587,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9588,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9589,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9594,9);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9597,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9599,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9602,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9603,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9607,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9607,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9611,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9611,63);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9612,14);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9615,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9620,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9621,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9627,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9627,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9628,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9630,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9634,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9638,55);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9639,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9639,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9641,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9644,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9647,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9648,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9649,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9650,96);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9652,43);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9655,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9661,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9661,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9661,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9663,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9664,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9670,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9670,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9672,84);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9676,57);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9677,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9677,70);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9679,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9680,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9681,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9681,91);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9682,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9683,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9683,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9686,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9686,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9686,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9686,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9688,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9690,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9695,10);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9695,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9695,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9700,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9701,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9705,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9708,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9708,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9709,86);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9713,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9713,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9716,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9716,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9723,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9728,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9728,85);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9728,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9733,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9736,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9739,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9740,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9741,4);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9744,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9749,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9750,5);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9751,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9752,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9754,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9755,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9755,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9757,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9759,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9762,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9773,15);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9774,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9775,51);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9776,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9779,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9781,11);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9783,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9792,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9794,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9798,1);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9799,6);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9799,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9801,71);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9804,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9807,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9812,37);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9813,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9815,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9816,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9818,29);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9824,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9825,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9826,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9827,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9827,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9827,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9831,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9832,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9833,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9833,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9835,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9837,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9838,73);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9839,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9839,99);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9841,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9843,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9848,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9849,24);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9849,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9849,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9850,20);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9857,28);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9859,62);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9861,67);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9866,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9867,45);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9872,68);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9879,36);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9879,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9880,56);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9883,82);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9883,93);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9886,38);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9887,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9887,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9890,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9892,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9900,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9900,60);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9906,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9907,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9908,13);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9910,27);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9913,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9914,40);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9926,52);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9928,42);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9929,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9929,30);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9930,48);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9930,76);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9931,16);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9934,58);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9936,26);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9939,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9944,25);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9944,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9947,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9948,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9949,94);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9952,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9954,39);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9956,32);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9957,79);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9959,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9963,78);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9966,22);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9967,8);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9968,34);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9968,64);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9968,81);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9969,21);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9976,61);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9977,65);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9979,53);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9982,46);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9986,80);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9986,88);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9986,92);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9986,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9988,49);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9990,89);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9994,12);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9995,97);
INSERT INTO dbo.T_PRATIQUE_PTQ (ADR_ID,SPT_ID) VALUES (9999,28);
GO

CHECKPOINT;
GO

UPDATE dbo.T_ADHERENT_ADR
SET ADR_ADRESSE2 = NULL
WHERE ADR_ADRESSE2 = '';
GO
UPDATE dbo.T_ADHERENT_ADR
SET ADR_ADRESSE3 = NULL
WHERE ADR_ADRESSE3 = '';
GO

CHECKPOINT;
GO

--> mise  jour LOGIN / MOT DE PASSE
WITH 
T0 AS
(
SELECT ADR_ID, RIGHT(CAST(ABS(CHECKSUM(*)) AS VARCHAR(32)), 6) AS MP, 
       LEFT(REPLACE(RTRIM(ADR_NOM) + ADR_PRENOM, ' ', ''), 4) AS LG1,
       LEFT(COALESCE(REPLACE(RTRIM(ADR_TEL_FIX) + RTRIM(ADR_TEL_MOBILE), '.', ''), ''), 4) AS LG2
FROM   T_ADHERENT_ADR
),
T1 AS 
(
SELECT ADR_ID, CASE LG1 WHEN '' THEN 'AAAA' ELSE LG1 END AS LG1, LG2, MP,
       ROW_NUMBER() OVER(PARTITION BY LG1, LG2 ORDER BY MP) AS RN
FROM   T0
),
T2 AS
(
SELECT ADR_ID, LG1 + CASE LG2 WHEN '' THEN '000' + CAST(RN AS VARCHAR(4)) ELSE LG2 END AS LG, MP
FROM   T1
)
UPDATE T
SET    ADR_LOGIN = LG,
       ADR_PASS = MP
FROM   T_ADHERENT_ADR AS T
       INNER JOIN T2
	         ON T.ADR_ID = T2.ADR_ID;
GO

CHECKPOINT;
GO

-- mise  jour email
WITH 
T0 AS
(
SELECT ADR_ID, LOWER(REPLACE(COALESCE(NULLIF(RTRIM(ADR_NOM), '') + '.', '') + ADR_PRENOM, ' ', '')) AS USR
FROM   T_ADHERENT_ADR
),
T1 AS
(
SELECT ADR_ID, USR, ROW_NUMBER() OVER(PARTITION BY USR ORDER BY ADR_ID) AS RN
FROM   T0
),
T2 AS 
(
SELECT ADR_ID, USR + CASE RN WHEN 1 THEN '' ELSE CAST(RN AS VARCHAR(32)) END AS USR
FROM   T1
)
UPDATE T
SET    ADR_MAIL = NULLIF(USR, '') +'@mysportclub.fr'
FROM   T_ADHERENT_ADR AS T
       INNER JOIN T2 
	         ON T.ADR_ID = T2.ADR_ID;
GO

CHECKPOINT;
GO

-- rajustement noms 
UPDATE [dbo].[T_ADHERENT_ADR]
SET    ADR_NOM = 'VAJEWSKI'
WHERE  ADR_NOM = 'ZAJEWSKI';
GO

UPDATE [dbo].[T_ADHERENT_ADR]
SET    ADR_NOM = 'LIBBERMANN'
WHERE  ADR_NOM = 'ZIMMERMANN';
GO

CHECKPOINT;
GO